/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/glob","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function($e){for(var e=[],I=0,F=$e.length;I<F;I++)e[I]=Se[$e[I]];return e};define(Se[158],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const f=new Map,L=new Map,R=new Map,p=new Map;function E(y,D){y.has(D.detail)||y.set(D.detail,-D.timestamp)}function m(y,D){const w=y.get(D.detail);w&&(w>=0||y.set(D.detail,w+D.timestamp))}let A=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(A=$e.getStats().slice(0).sort((y,D)=>y.timestamp-D.timestamp));for(const y of A)switch(y.type){case 10:E(f,y);break;case 11:case 12:m(f,y);break;case 21:E(L,y);break;case 22:m(L,y);break;case 33:E(R,y);break;case 34:m(R,y);break;case 31:E(p,y);break;case 32:m(p,y);break}let P=0;R.forEach(y=>P+=y);function g(y){const D=[];return y.forEach((w,u)=>D.push([u,w])),D}return{amdLoad:g(f),amdInvoke:g(L),nodeRequire:g(R),nodeEval:g(p),nodeRequireTotal:P}}static toMarkdownTable(f,L){let R="";const p=[];return f.forEach((E,m)=>{p[m]=E.length}),L.forEach(E=>{E.forEach((m,A)=>{typeof m>"u"&&(m=E[A]="-");const P=m.toString().length;p[A]=Math.max(P,p[A])})}),f.forEach((E,m)=>{R+=`| ${E+" ".repeat(p[m]-E.toString().length)} `}),R+=`|
`,f.forEach((E,m)=>{R+=`| ${"-".repeat(p[m])} `}),R+=`|
`,L.forEach(E=>{E.forEach((m,A)=>{typeof m<"u"&&(R+=`| ${m+" ".repeat(p[A]-m.toString().length)} `)}),R+=`|
`}),R}}e.$T=I}),define(Se[120],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(w,u,c){const i=F(w,u);if(i!==-1)return w[i]}e.$eb=I;function F(w,u,c=w.length-1){for(let i=c;i>=0;i--){const s=w[i];if(u(s))return i}return-1}e.$fb=F;function f(w,u){const c=L(w,u);return c===-1?void 0:w[c]}e.$gb=f;function L(w,u,c=0,i=w.length){let s=c,r=i;for(;s<r;){const o=Math.floor((s+r)/2);u(w[o])?s=o+1:r=o}return s-1}e.$hb=L;function R(w,u){const c=p(w,u);return c===w.length?void 0:w[c]}e.$ib=R;function p(w,u,c=0,i=w.length){let s=c,r=i;for(;s<r;){const o=Math.floor((s+r)/2);u(w[o])?r=o:s=o+1}return s}e.$jb=p;function E(w,u,c=0,i=w.length){const s=p(w,u,c,i);return s===w.length?-1:s}e.$kb=E;class m{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(m.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!u(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const c=L(this.e,u,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$lb=m;function A(w,u){if(w.length===0)return;let c=w[0];for(let i=1;i<w.length;i++){const s=w[i];u(s,c)>0&&(c=s)}return c}e.$mb=A;function P(w,u){if(w.length===0)return;let c=w[0];for(let i=1;i<w.length;i++){const s=w[i];u(s,c)>=0&&(c=s)}return c}e.$nb=P;function g(w,u){return A(w,(c,i)=>-u(c,i))}e.$ob=g;function y(w,u){if(w.length===0)return-1;let c=0;for(let i=1;i<w.length;i++){const s=w[i];u(s,w[c])>0&&(c=i)}return c}e.$pb=y;function D(w,u){for(const c of w){const i=u(c);if(i!==void 0)return i}}e.$qb=D}),define(Se[74],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(R,p){const E=Object.create(null);for(const m of R){const A=p(m);let P=E[A];P||(P=E[A]=[]),P.push(m)}return E}e.$J=I;function F(R,p){const E=[],m=[];for(const A of R)p.has(A)||E.push(A);for(const A of p)R.has(A)||m.push(A);return{removed:E,added:m}}e.$K=F;function f(R,p){const E=[],m=[];for(const[A,P]of R)p.has(A)||E.push(P);for(const[A,P]of p)R.has(A)||m.push(P);return{removed:E,added:m}}e.$L=f;function L(R,p){const E=new Set;for(const m of p)R.has(m)&&E.add(m);return E}e.$M=L}),define(Se[59],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function I(R){return(p,E,m)=>{let A=null,P=null;if(typeof m.value=="function"?(A="value",P=m.value):typeof m.get=="function"&&(A="get",P=m.get),!P)throw new Error("not supported");m[A]=R(P,E)}}function F(R,p,E){let m=null,A=null;if(typeof E.value=="function"?(m="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(m="get",A=E.get),!A)throw new Error("not supported");const P=`$memoize$${p}`;E[m]=function(...g){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,g)}),this[P]}}e.$hh=F;function f(R,p,E){return I((m,A)=>{const P=`$debounce$${A}`,g=`$debounce$result$${A}`;return function(...y){this[g]||(this[g]=E?E():void 0),clearTimeout(this[P]),p&&(this[g]=p(this[g],...y),y=[this[g]]),this[P]=setTimeout(()=>{m.apply(this,y),this[g]=E?E():void 0},R)}})}e.$ih=f;function L(R,p,E){return I((m,A)=>{const P=`$throttle$timer$${A}`,g=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,D=`$throttle$pending$${A}`;return function(...w){if(this[g]||(this[g]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),p&&(this[g]=p(this[g],...w)),this[D])return;const u=this[y]+R;u<=Date.now()?(this[y]=Date.now(),m.apply(this,[this[g]]),this[g]=E?E():void 0):(this[D]=!0,this[P]=setTimeout(()=>{this[D]=!1,this[y]=Date.now(),m.apply(this,[this[g]]),this[g]=E?E():void 0},u-Date.now()))}})}e.$jh=L}),define(Se[9],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?s.isErrorNoTelemetry(t)?new s(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=I,e.$W=new I;function F(o){e.$W.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=F;function f(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=f;function L(o){m(o)||e.$W.onUnexpectedError(o)}e.$Z=L;function R(o){m(o)||e.$W.onUnexpectedExternalError(o)}e.$1=R;function p(o){if(o instanceof Error){const{name:t,message:n}=o,d=o.stacktrace||o.stack;return{$isError:!0,name:t,message:n,stack:d,noTelemetry:s.isErrorNoTelemetry(o)}}return o}e.$2=p;const E="Canceled";function m(o){return o instanceof A?!0:o instanceof Error&&o.name===E&&o.message===E}e.$3=m;class A extends Error{constructor(){super(E),this.name=this.message}}e.$4=A;function P(){const o=new Error(E);return o.name=o.message,o}e.$5=P;function g(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.$6=g;function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.$7=y;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=D;function w(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.$9=w;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=u;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=c;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class s extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof s)return t;const n=new s;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=s;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$bb=r}),define(Se[19],De([1,0,9,120]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function f(Z,ee=0){return Z[Z.length-(1+ee)]}e.$rb=f;function L(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.$sb=L;function R(Z,ee,_=(we,ue)=>we===ue){if(Z===ee)return!0;if(!Z||!ee||Z.length!==ee.length)return!1;for(let we=0,ue=Z.length;we<ue;we++)if(!_(Z[we],ee[we]))return!1;return!0}e.$tb=R;function p(Z,ee){const _=Z.length-1;ee<_&&(Z[ee]=Z[_]),Z.pop()}e.$ub=p;function E(Z,ee,_){return m(Z.length,we=>_(Z[we],ee))}e.$vb=E;function m(Z,ee){let _=0,we=Z-1;for(;_<=we;){const ue=(_+we)/2|0,ge=ee(ue);if(ge<0)_=ue+1;else if(ge>0)we=ue-1;else return ue}return-(_+1)}e.$wb=m;function A(Z,ee,_){if(Z=Z|0,Z>=ee.length)throw new TypeError("invalid index");const we=ee[Math.floor(ee.length*Math.random())],ue=[],ge=[],te=[];for(const fe of ee){const be=_(fe,we);be<0?ue.push(fe):be>0?ge.push(fe):te.push(fe)}return Z<ue.length?A(Z,ue,_):Z<ue.length+te.length?te[0]:A(Z-(ue.length+te.length),ge,_)}e.$xb=A;function P(Z,ee){const _=[];let we;for(const ue of Z.slice(0).sort(ee))!we||ee(we[0],ue)!==0?(we=[ue],_.push(we)):we.push(ue);return _}e.$yb=P;function*g(Z,ee){let _,we;for(const ue of Z)we!==void 0&&ee(we,ue)?_.push(ue):(_&&(yield _),_=[ue]),we=ue;_&&(yield _)}e.$zb=g;function y(Z,ee){for(let _=0;_<=Z.length;_++)ee(_===0?void 0:Z[_-1],_===Z.length?void 0:Z[_])}e.$Ab=y;function D(Z,ee){for(let _=0;_<Z.length;_++)ee(_===0?void 0:Z[_-1],Z[_],_+1===Z.length?void 0:Z[_+1])}e.$Bb=D;function w(Z,ee,_){const we=[];function ue(fe,be,Pe){if(be===0&&Pe.length===0)return;const B=we[we.length-1];B&&B.start+B.deleteCount===fe?(B.deleteCount+=be,B.toInsert.push(...Pe)):we.push({start:fe,deleteCount:be,toInsert:Pe})}let ge=0,te=0;for(;;){if(ge===Z.length){ue(ge,0,ee.slice(te));break}if(te===ee.length){ue(ge,Z.length-ge,[]);break}const fe=Z[ge],be=ee[te],Pe=_(fe,be);Pe===0?(ge+=1,te+=1):Pe<0?(ue(ge,1,[]),ge+=1):Pe>0&&(ue(ge,0,[be]),te+=1)}return we}e.$Cb=w;function u(Z,ee,_){const we=w(Z,ee,_),ue=[],ge=[];for(const te of we)ue.push(...Z.slice(te.start,te.start+te.deleteCount)),ge.push(...te.toInsert);return{removed:ue,added:ge}}e.$Db=u;function c(Z,ee,_){if(_===0)return[];const we=Z.slice(0,_).sort(ee);return s(Z,ee,we,_,Z.length),we}e.top=c;function i(Z,ee,_,we,ue){return _===0?Promise.resolve([]):new Promise((ge,te)=>{(async()=>{const fe=Z.length,be=Z.slice(0,_).sort(ee);for(let Pe=_,B=Math.min(_+we,fe);Pe<fe;Pe=B,B=Math.min(B+we,fe)){if(Pe>_&&await new Promise(J=>setTimeout(J)),ue&&ue.isCancellationRequested)throw new I.$4;s(Z,ee,be,Pe,B)}return be})().then(ge,te)})}e.$Fb=i;function s(Z,ee,_,we,ue){for(const ge=_.length;we<ue;we++){const te=Z[we];if(ee(te,_[ge-1])<0){_.pop();const fe=(0,F.$jb)(_,be=>ee(te,be)<0);_.splice(fe,0,te)}}}function r(Z){return Z.filter(ee=>!!ee)}e.$Gb=r;function o(Z){let ee=0;for(let _=0;_<Z.length;_++)Z[_]&&(Z[ee]=Z[_],ee+=1);Z.length=ee}e.$Hb=o;function t(Z,ee,_){Z.splice(_,0,Z.splice(ee,1)[0])}e.$Ib=t;function n(Z){return!Array.isArray(Z)||Z.length===0}e.$Jb=n;function d(Z){return Array.isArray(Z)&&Z.length>0}e.$Kb=d;function l(Z,ee=_=>_){const _=new Set;return Z.filter(we=>{const ue=ee(we);return _.has(ue)?!1:(_.add(ue),!0)})}e.$Lb=l;function a(Z){const ee=new Set;return _=>{const we=Z(_);return ee.has(we)?!1:(ee.add(we),!0)}}e.$Mb=a;function h(Z,ee){return Z.length>0?Z[0]:ee}e.$Nb=h;function S(Z,ee){return Z.length>0?Z[Z.length-1]:ee}e.$Ob=S;function k(Z,ee,_=(we,ue)=>we===ue){let we=0;for(let ue=0,ge=Math.min(Z.length,ee.length);ue<ge&&_(Z[ue],ee[ue]);ue++)we++;return we}e.$Pb=k;function $(Z){return[].concat(...Z)}e.$Qb=$;function b(Z,ee){let _=typeof ee=="number"?Z:0;typeof ee=="number"?_=Z:(_=0,ee=Z);const we=[];if(_<=ee)for(let ue=_;ue<ee;ue++)we.push(ue);else for(let ue=_;ue>ee;ue--)we.push(ue);return we}e.$Rb=b;function v(Z,ee,_){return Z.reduce((we,ue)=>(we[ee(ue)]=_?_(ue):ue,we),Object.create(null))}e.$Sb=v;function C(Z,ee){return Z.push(ee),()=>N(Z,ee)}e.$Tb=C;function N(Z,ee){const _=Z.indexOf(ee);if(_>-1)return Z.splice(_,1),ee}e.$Ub=N;function T(Z,ee,_){const we=Z.slice(0,ee),ue=Z.slice(ee);return we.concat(_,ue)}e.$Vb=T;function M(Z,ee){let _;if(typeof ee=="number"){let we=ee;_=()=>{const ue=Math.sin(we++)*179426549;return ue-Math.floor(ue)}}else _=Math.random;for(let we=Z.length-1;we>0;we-=1){const ue=Math.floor(_()*(we+1)),ge=Z[we];Z[we]=Z[ue],Z[ue]=ge}}e.$Wb=M;function U(Z,ee){const _=Z.indexOf(ee);_>-1&&(Z.splice(_,1),Z.unshift(ee))}e.$Xb=U;function j(Z,ee){const _=Z.indexOf(ee);_>-1&&(Z.splice(_,1),Z.push(ee))}e.$Yb=j;function O(Z,ee){for(const _ of ee)Z.push(_)}e.$Zb=O;function V(Z,ee){return Array.isArray(Z)?Z.map(ee):ee(Z)}e.$1b=V;function q(Z){return Array.isArray(Z)?Z:[Z]}e.$2b=q;function de(Z){return Z[Math.floor(Math.random()*Z.length)]}e.$3b=de;function x(Z,ee,_){const we=G(Z,ee),ue=Z.length,ge=_.length;Z.length=ue+ge;for(let te=ue-1;te>=we;te--)Z[te+ge]=Z[te];for(let te=0;te<ge;te++)Z[te+we]=_[te]}e.$4b=x;function Q(Z,ee,_,we){const ue=G(Z,ee);let ge=Z.splice(ue,_);return ge===void 0&&(ge=[]),x(Z,ue,we),ge}e.$5b=Q;function G(Z,ee){return ee<0?Math.max(ee+Z.length,0):Math.min(ee,Z.length)}var ce;(function(Z){function ee(ge){return ge<0}Z.isLessThan=ee;function _(ge){return ge<=0}Z.isLessThanOrEqual=_;function we(ge){return ge>0}Z.isGreaterThan=we;function ue(ge){return ge===0}Z.isNeitherLessOrGreaterThan=ue,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ie(Z,ee){return(_,we)=>ee(Z(_),Z(we))}e.$6b=ie;function ae(...Z){return(ee,_)=>{for(const we of Z){const ue=we(ee,_);if(!ce.isNeitherLessOrGreaterThan(ue))return ue}return ce.neitherLessOrGreaterThan}}e.$7b=ae;const ye=(Z,ee)=>Z-ee;e.$8b=ye;const H=(Z,ee)=>(0,e.$8b)(Z?1:0,ee?1:0);e.$9b=H;function z(Z){return(ee,_)=>-Z(ee,_)}e.$0b=z;class X{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const we=_===this.c?null:this.g.slice(this.c,_);return this.c=_,we}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const we=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,we}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$$b=X;class re{static{this.empty=new re(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new re(_=>this.iterate(we=>ee(we)?_(we):!0))}map(ee){return new re(_=>this.iterate(we=>_(ee(we))))}some(ee){let _=!1;return this.iterate(we=>(_=ee(we),!_)),_}findFirst(ee){let _;return this.iterate(we=>ee(we)?(_=we,!1):!0),_}findLast(ee){let _;return this.iterate(we=>(ee(we)&&(_=we),!0)),_}findLastMaxBy(ee){let _,we=!0;return this.iterate(ue=>((we||ce.isGreaterThan(ee(ue,_)))&&(we=!1,_=ue),!0)),_}}e.$_b=re}),define(Se[60],De([1,0,9]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function F(E,m){if(!E)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=F;function f(E,m="Unreachable"){throw new Error(m)}e.$3c=f;function L(E){if(!E)throw new I.$bb("Assertion Failed")}e.$4c=L;function R(E){if(!E()){debugger;E(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$5c=R;function p(E,m){let A=0;for(;A<E.length-1;){const P=E[A],g=E[A+1];if(!m(P,g))return!1;A++}return!0}e.$6c=p}),define(Se[75],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(F){const f=this;let L=!1,R;return function(){return L||(L=!0,R=F.apply(f,arguments)),R}}e.$cb=I}),define(Se[121],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0;class I{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$zM=I,e.$AM=new I("id#")}),define(Se[51],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function f(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}F.is=f;const L=Object.freeze([]);function R(){return L}F.empty=R;function*p(o){yield o}F.single=p;function E(o){return f(o)?o:p(o)}F.wrap=E;function m(o){return o||L}F.from=m;function*A(o){for(let t=o.length-1;t>=0;t--)yield o[t]}F.reverse=A;function P(o){return!o||o[Symbol.iterator]().next().done===!0}F.isEmpty=P;function g(o){return o[Symbol.iterator]().next().value}F.first=g;function y(o,t){for(const n of o)if(t(n))return!0;return!1}F.some=y;function D(o,t){for(const n of o)if(t(n))return n}F.find=D;function*w(o,t){for(const n of o)t(n)&&(yield n)}F.filter=w;function*u(o,t){let n=0;for(const d of o)yield t(d,n++)}F.map=u;function*c(...o){for(const t of o)for(const n of t)yield n}F.concat=c;function i(o,t,n){let d=n;for(const l of o)d=t(d,l);return d}F.reduce=i;function*s(o,t,n=o.length){for(t<0&&(t+=o.length),n<0?n+=o.length:n>o.length&&(n=o.length);t<n;t++)yield o[t]}F.slice=s;function r(o,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,o];const d=o[Symbol.iterator]();for(let l=0;l<t;l++){const a=d.next();if(a.done)return[n,F.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return d}}]}F.consume=r})(I||(e.Iterable=I={}))}),define(Se[159],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,n=!1){let d=0;const l=t.length;let a="",h=0,S=16,k=0;function $(U){let j=0,O=0;for(;j<U;){const V=t.charCodeAt(d);if(V>=48&&V<=57)O=O*16+V-48;else if(V>=65&&V<=70)O=O*16+V-65+10;else if(V>=97&&V<=102)O=O*16+V-97+10;else break;d++,j++}return j<U&&(O=-1),O}function b(U){d=U,a="",h=0,S=16,k=0}function v(){const U=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&m(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&m(t.charCodeAt(d)))for(d++;d<t.length&&m(t.charCodeAt(d));)d++;else return k=3,t.substring(U,d);let j=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&m(t.charCodeAt(d))){for(d++;d<t.length&&m(t.charCodeAt(d));)d++;j=d}else k=3;return t.substring(U,j)}function C(){let U="",j=d;for(;;){if(d>=l){U+=t.substring(j,d),k=2;break}const O=t.charCodeAt(d);if(O===34){U+=t.substring(j,d),d++;break}if(O===92){if(U+=t.substring(j,d),d++,d>=l){k=2;break}switch(t.charCodeAt(d++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const q=$(4);q>=0?U+=String.fromCharCode(q):k=4;break}default:k=5}j=d;continue}if(O>=0&&O<=31)if(E(O)){U+=t.substring(j,d),k=2;break}else k=6;d++}return U}function N(){if(a="",k=0,h=d,d>=l)return h=l,S=17;let U=t.charCodeAt(d);if(p(U)){do d++,a+=String.fromCharCode(U),U=t.charCodeAt(d);while(p(U));return S=15}if(E(U))return d++,a+=String.fromCharCode(U),U===13&&t.charCodeAt(d)===10&&(d++,a+=`
`),S=14;switch(U){case 123:return d++,S=1;case 125:return d++,S=2;case 91:return d++,S=3;case 93:return d++,S=4;case 58:return d++,S=6;case 44:return d++,S=5;case 34:return d++,a=C(),S=10;case 47:{const j=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!E(t.charCodeAt(d));)d++;return a=t.substring(j,d),S=12}if(t.charCodeAt(d+1)===42){d+=2;const O=l-1;let V=!1;for(;d<O;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,V=!0;break}d++}return V||(d++,k=1),a=t.substring(j,d),S=13}return a+=String.fromCharCode(U),d++,S=16}case 45:if(a+=String.fromCharCode(U),d++,d===l||!m(t.charCodeAt(d)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=v(),S=11;default:for(;d<l&&T(U);)d++,U=t.charCodeAt(d);if(h!==d){switch(a=t.substring(h,d),a){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return a+=String.fromCharCode(U),d++,S=16}}function T(U){if(p(U)||E(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:b,getPosition:()=>d,scan:n?M:N,getToken:()=>S,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>k}}e.$Um=R;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,n){const d=[],l=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k($,b,v,C){h.value=$,h.offset=b,h.length=v,h.type=C,h.colonOffset=void 0,a=h}try{s(t,{onObjectBegin:($,b)=>{if(n<=$)throw l;a=void 0,S=n>$,d.push("")},onObjectProperty:($,b,v)=>{if(n<b||(k($,b,v,"property"),d[d.length-1]=$,n<=b+v))throw l},onObjectEnd:($,b)=>{if(n<=$)throw l;a=void 0,d.pop()},onArrayBegin:($,b)=>{if(n<=$)throw l;a=void 0,d.push(0)},onArrayEnd:($,b)=>{if(n<=$)throw l;a=void 0,d.pop()},onLiteralValue:($,b,v)=>{if(n<b||(k($,b,v,o($)),n<=b+v))throw l},onSeparator:($,b,v)=>{if(n<=b)throw l;if($===":"&&a&&a.type==="property")a.colonOffset=b,S=!1,a=void 0;else if($===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(S=!0,d[d.length-1]=""),a=void 0}}})}catch($){if($!==l)throw $}return{path:d,previousNode:a,isAtPropertyKey:S,matches:$=>{let b=0;for(let v=0;b<$.length&&v<d.length;v++)if($[b]===d[v]||$[b]==="*")b++;else if($[b]!=="**")return!1;return b===$.length}}}e.$Vm=P;function g(t,n=[],d=L.DEFAULT){let l=null,a=[];const h=[];function S($){Array.isArray(a)?a.push($):l!==null&&(a[l]=$)}return s(t,{onObjectBegin:()=>{const $={};S($),h.push(a),a=$,l=null},onObjectProperty:$=>{l=$},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const $=[];S($),h.push(a),a=$,l=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:S,onError:($,b,v)=>{n.push({error:$,offset:b,length:v})}},d),a[0]}e.$Wm=g;function y(t,n=[],d=L.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a($){l.type==="property"&&(l.length=$-l.offset,l=l.parent)}function h($){return l.children.push($),$}s(t,{onObjectBegin:$=>{l=h({type:"object",offset:$,length:-1,parent:l,children:[]})},onObjectProperty:($,b,v)=>{l=h({type:"property",offset:b,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:$,offset:b,length:v,parent:l})},onObjectEnd:($,b)=>{l.length=$+b-l.offset,l=l.parent,a($+b)},onArrayBegin:($,b)=>{l=h({type:"array",offset:$,length:-1,parent:l,children:[]})},onArrayEnd:($,b)=>{l.length=$+b-l.offset,l=l.parent,a($+b)},onLiteralValue:($,b,v)=>{h({type:o($),offset:b,length:v,parent:l,value:$}),a(b+v)},onSeparator:($,b,v)=>{l.type==="property"&&($===":"?l.colonOffset=b:$===","&&a(b))},onError:($,b,v)=>{n.push({error:$,offset:b,length:v})}},d);const k=l.children[0];return k&&delete k.parent,k}e.$Xm=y;function D(t,n){if(!t)return;let d=t;for(const l of n)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let a=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],a=!0;break}if(!a)return}else{const a=l;if(d.type!=="array"||a<0||!Array.isArray(d.children)||a>=d.children.length)return;d=d.children[a]}return d}e.$Ym=D;function w(t){if(!t.parent||!t.parent.children)return[];const n=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;n.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&n.push(d)}return n}e.$Zm=w;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const n=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(n[d.children[0].value]=u(l))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$1m=u;function c(t,n,d=!1){return n>=t.offset&&n<t.offset+t.length||d&&n===t.offset+t.length}e.$2m=c;function i(t,n,d=!1){if(c(t,n,d)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=n;a++){const h=i(l[a],n,d);if(h)return h}return t}}e.$3m=i;function s(t,n,d=L.DEFAULT){const l=R(t,!1);function a(ie){return ie?()=>ie(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(ie){return ie?ae=>ie(ae,l.getTokenOffset(),l.getTokenLength()):()=>!0}const S=a(n.onObjectBegin),k=h(n.onObjectProperty),$=a(n.onObjectEnd),b=a(n.onArrayBegin),v=a(n.onArrayEnd),C=h(n.onLiteralValue),N=h(n.onSeparator),T=a(n.onComment),M=h(n.onError),U=d&&d.disallowComments,j=d&&d.allowTrailingComma;function O(){for(;;){const ie=l.scan();switch(l.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:U||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(ie){case 12:case 13:U?V(10):T();break;case 16:V(1);break;case 15:case 14:break;default:return ie}}}function V(ie,ae=[],ye=[]){if(M(ie),ae.length+ye.length>0){let H=l.getToken();for(;H!==17;){if(ae.indexOf(H)!==-1){O();break}else if(ye.indexOf(H)!==-1)break;H=O()}}}function q(ie){const ae=l.getTokenValue();return ie?C(ae):k(ae),O(),!0}function de(){switch(l.getToken()){case 11:{let ie=0;try{ie=JSON.parse(l.getTokenValue()),typeof ie!="number"&&(V(2),ie=0)}catch{V(2)}C(ie);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return O(),!0}function x(){return l.getToken()!==10?(V(3,[],[2,5]),!1):(q(!1),l.getToken()===6?(N(":"),O(),ce()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Q(){S(),O();let ie=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ie||V(4,[],[]),N(","),O(),l.getToken()===2&&j)break}else ie&&V(6,[],[]);x()||V(4,[],[2,5]),ie=!0}return $(),l.getToken()!==2?V(7,[2],[]):O(),!0}function G(){b(),O();let ie=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ie||V(4,[],[]),N(","),O(),l.getToken()===4&&j)break}else ie&&V(6,[],[]);ce()||V(4,[],[4,5]),ie=!0}return v(),l.getToken()!==4?V(8,[4],[]):O(),!0}function ce(){switch(l.getToken()){case 3:return G();case 1:return Q();case 10:return q(!0);default:return de()}}return O(),l.getToken()===17?d.allowEmptyContent?!0:(V(4,[],[]),!1):ce()?(l.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$4m=s;function r(t,n){const d=R(t),l=[];let a,h=0,S;do switch(S=d.getPosition(),a=d.scan(),a){case 12:case 13:case 17:h!==S&&l.push(t.substring(h,S)),n!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,n)),h=d.getPosition();break}while(a!==17);return l.join("")}e.$5m=r;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=o}),define(Se[47],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(Se[76],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const R=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=R}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const p=new I(L);if(this.a===I.Undefined)this.a=p,this.b=p;else if(R){const m=this.b;this.b=p,p.prev=m,m.next=p}else{const m=this.a;this.a=p,p.next=m,m.prev=p}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(p))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$1c=F}),define(Se[28],De([1,0]),function($e,e){"use strict";var I,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(i,s,r){let o=i.get(s);return o===void 0&&(o=r,i.set(s,o)),o}e.$wc=L;function R(i){const s=[];return i.forEach((r,o)=>{s.push(`${o} => ${r}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.$xc=R;function p(i){const s=[];return i.forEach(r=>{s.push(r)}),`Set(${i.size}) {${s.join(", ")}}`}e.$yc=p;class E{constructor(s,r){this.uri=s,this.value=r}}function m(i){return Array.isArray(i)}class A{static{this.a=s=>s.toString()}constructor(s,r){if(this[I]="ResourceMap",s instanceof A)this.b=new Map(s.b),this.c=r??A.a;else if(m(s)){this.b=new Map,this.c=r??A.a;for(const[o,t]of s)this.set(o,t)}else this.b=new Map,this.c=s??A.a}set(s,r){return this.b.set(this.c(s),new E(s,r)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,r){typeof r<"u"&&(s=s.bind(r));for(const[o,t]of this.b)s(t.value,t.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.$zc=A;class P{constructor(s,r){this[F]="ResourceSet",!s||typeof s=="function"?this.a=new A(s):(this.a=new A(r),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,r){this.a.forEach((o,t)=>s.call(r,t,t,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=P;var g;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class y{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,r=0){const o=this.a.get(s);if(o)return r!==0&&this.j(o,r),o.value}set(s,r,o=0){let t=this.a.get(s);if(t)t.value=r,o!==0&&this.j(t,o);else{switch(t={key:s,value:r,next:void 0,previous:void 0},o){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(s,t),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this.a.get(s);if(r)return this.a.delete(s),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,r){const o=this.e;let t=this.b;for(;t;){if(r?s.bind(r)(t.value,t.key,this):s(t.value,t.key,this),this.e!==o)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const s=this,r=this.e;let o=this.b;const t={[Symbol.iterator](){return t},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:o.key,done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return t}values(){const s=this,r=this.e;let o=this.b;const t={[Symbol.iterator](){return t},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:o.value,done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return t}entries(){const s=this,r=this.e;let o=this.b;const t={[Symbol.iterator](){return t},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const n={value:[o.key,o.value],done:!1};return o=o.next,n}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this.b,o=this.size;for(;r&&o>s;)this.a.delete(r.key),r=r.next,o--;this.b=r,this.d=o,r&&(r.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const r=s.next,o=s.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}s.next=void 0,s.previous=void 0,this.e++}j(s,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this.b)return;const o=s.next,t=s.previous;s===this.c?(t.next=void 0,this.c=t):(o.previous=t,t.next=o),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(r===2){if(s===this.c)return;const o=s.next,t=s.previous;s===this.b?(o.previous=void 0,this.b=o):(o.previous=t,t.next=o),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((r,o)=>{s.push([o,r])}),s}fromJSON(s){this.clear();for(const[r,o]of s)this.set(r,o)}}e.$Bc=y;class D extends y{constructor(s,r=1){super(),this.k=s,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=D;class w{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let r=this.a.get(s)||0;return r===0?!1:(r--,r===0?this.a.delete(s):this.a.set(s,r),!0)}has(s){return this.a.has(s)}}e.$Dc=w;class u{constructor(s){if(this.a=new Map,this.b=new Map,s)for(const[r,o]of s)this.set(r,o)}clear(){this.a.clear(),this.b.clear()}set(s,r){this.a.set(s,r),this.b.set(r,s)}get(s){return this.a.get(s)}getKey(s){return this.b.get(s)}delete(s){const r=this.a.get(s);return r===void 0?!1:(this.a.delete(s),this.b.delete(r),!0)}forEach(s,r){this.a.forEach((o,t)=>{s.call(r,o,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=u;class c{constructor(){this.a=new Map}add(s,r){let o=this.a.get(s);o||(o=new Set,this.a.set(s,o)),o.add(r)}delete(s,r){const o=this.a.get(s);o&&(o.delete(r),o.size===0&&this.a.delete(s))}forEach(s,r){const o=this.a.get(s);o&&o.forEach(r)}get(s){const r=this.a.get(s);return r||new Set}}e.$Fc=c}),define(Se[3],De([1,0,19,74,28,75,51]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const p=!1;let E=null;class m{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:m.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const N=this.c(v);N.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const N=C.get(v);if(N)return N;const T=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,T),T}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,C){let N;if(C)N=C;else{const O=new Map,V=[...this.b.values()].filter(de=>de.source!==null&&!this.f(de,O).isSingleton);if(V.length===0)return;const q=new Set(V.map(de=>de.value));if(N=V.filter(de=>!(de.parent&&q.has(de.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function T(O){function V(de,x){for(;de.length>0&&x.some(Q=>typeof Q=="string"?Q===de[0]:de[0].match(Q));)de.shift()}const q=O.source.split(`
`).map(de=>de.trim().replace("at ","")).filter(de=>de!=="");return V(q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),q.reverse()}const M=new f.$Fc;for(const O of N){const V=T(O);for(let q=0;q<=V.length;q++)M.add(V.slice(0,q).join(`
`),O)}N.sort((0,I.$6b)(O=>O.idx,I.$8b));let U="",j=0;for(const O of N.slice(0,v)){j++;const V=T(O),q=[];for(let de=0;de<V.length;de++){let x=V[de];x=`(shared with ${M.get(V.slice(0,de+1).join(`
`)).size}/${N.length} leaks) at ${x}`;const G=M.get(V.slice(0,de).join(`
`)),ce=(0,F.$J)([...G].map(ie=>T(ie)[de]),ie=>ie);delete ce[V[de]];for(const[ie,ae]of Object.entries(ce))q.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${ie}`);q.unshift(x)}U+=`


==================== Leaking disposable ${j}/${N.length}: ${O.value.constructor.name} ====================
${q.join(`
`)}
============================================================

`}return N.length>v&&(U+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:U}}}e.$Gc=m;function A(b){E=b}if(e.$Hc=A,p){const b="__is_disposable_tracked__";A(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function P(b){return E?.trackDisposable(b),b}e.$Ic=P;function g(b){E?.markAsDisposed(b)}e.$Jc=g;function y(b,v){E?.setParent(b,v)}function D(b,v){if(E)for(const C of b)E.setParent(C,v)}function w(b){return E?.markAsSingleton(b),b}e.$Kc=w;function u(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Lc=u;function c(b){if(R.Iterable.is(b)){const v=[];for(const C of b)if(C)try{C.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Mc=c;function i(b){for(const v of b)u(v)&&v.dispose();return[]}e.$Nc=i;function s(...b){const v=r(()=>c(b));return D(b,v),v}e.$Oc=s;function r(b){const v=P({dispose:(0,L.$cb)(()=>{g(v),b()})});return v}e.$Pc=r;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return y(v,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),y(v,null))}}e.$Qc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,P(this),y(this.q,this)}dispose(){g(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Rc=t;class n{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&y(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&y(v,null),v}}e.$Sc=n;class d{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,g(this))},this}}e.$Uc=l;class a{constructor(){this.a=new Map}acquire(v,...C){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...C)},this.a.set(v,N));const{object:T}=N,M=(0,L.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:T,dispose:M}}}e.$Vc=a;class h{constructor(v){this.a=v}async acquire(v,...C){const N=this.a.acquire(v,...C);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(T){throw N.dispose(),T}}}e.$Wc=h;class S{constructor(v){this.object=v}dispose(){}}e.$Xc=S;function k(b){const v=new o;try{b(v)}finally{v.dispose()}}e.$Yc=k;class ${constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function($e,e){typeof define=="function"&&define.amd?define(Se[160],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ee,_){for(var we=0;we<_.length;we++){var ue=_[we];ue.enumerable=ue.enumerable||!1,ue.configurable=!0,"value"in ue&&(ue.writable=!0),Object.defineProperty(ee,ue.key,ue)}}function I(ee,_,we){return _&&e(ee.prototype,_),we&&e(ee,we),Object.defineProperty(ee,"prototype",{writable:!1}),ee}function F(ee,_){if(ee){if(typeof ee=="string")return f(ee,_);var we=Object.prototype.toString.call(ee).slice(8,-1);if(we==="Object"&&ee.constructor&&(we=ee.constructor.name),we==="Map"||we==="Set")return Array.from(ee);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return f(ee,_)}}function f(ee,_){(_==null||_>ee.length)&&(_=ee.length);for(var we=0,ue=new Array(_);we<_;we++)ue[we]=ee[we];return ue}function L(ee,_){var we=typeof Symbol<"u"&&ee[Symbol.iterator]||ee["@@iterator"];if(we)return(we=we.call(ee)).next.bind(we);if(Array.isArray(ee)||(we=F(ee))||_&&ee&&typeof ee.length=="number"){we&&(ee=we);var ue=0;return function(){return ue>=ee.length?{done:!0}:{done:!1,value:ee[ue++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=R();function p(ee){$e.defaults=ee}var E=/[&<>"']/,m=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(_){return g[_]};function D(ee,_){if(_){if(E.test(ee))return ee.replace(m,y)}else if(A.test(ee))return ee.replace(P,y);return ee}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ee){return ee.replace(w,function(_,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var c=/(^|[^\[])\^/g;function i(ee,_){ee=typeof ee=="string"?ee:ee.source,_=_||"";var we={replace:function(ge,te){return te=te.source||te,te=te.replace(c,"$1"),ee=ee.replace(ge,te),we},getRegex:function(){return new RegExp(ee,_)}};return we}var s=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(ee,_,we){if(ee){var ue;try{ue=decodeURIComponent(u(we)).replace(s,"").toLowerCase()}catch{return null}if(ue.indexOf("javascript:")===0||ue.indexOf("vbscript:")===0||ue.indexOf("data:")===0)return null}_&&!r.test(we)&&(we=a(_,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var t={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ee,_){t[" "+ee]||(n.test(ee)?t[" "+ee]=ee+"/":t[" "+ee]=$(ee,"/",!0)),ee=t[" "+ee];var we=ee.indexOf(":")===-1;return _.substring(0,2)==="//"?we?_:ee.replace(d,"$1")+_:_.charAt(0)==="/"?we?_:ee.replace(l,"$1")+_:ee+_}var h={exec:function(){}};function S(ee){for(var _=1,we,ue;_<arguments.length;_++){we=arguments[_];for(ue in we)Object.prototype.hasOwnProperty.call(we,ue)&&(ee[ue]=we[ue])}return ee}function k(ee,_){var we=ee.replace(/\|/g,function(te,fe,be){for(var Pe=!1,B=fe;--B>=0&&be[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ue=we.split(/ \|/),ge=0;if(ue[0].trim()||ue.shift(),ue.length>0&&!ue[ue.length-1].trim()&&ue.pop(),ue.length>_)ue.splice(_);else for(;ue.length<_;)ue.push("");for(;ge<ue.length;ge++)ue[ge]=ue[ge].trim().replace(/\\\|/g,"|");return ue}function $(ee,_,we){var ue=ee.length;if(ue===0)return"";for(var ge=0;ge<ue;){var te=ee.charAt(ue-ge-1);if(te===_&&!we)ge++;else if(te!==_&&we)ge++;else break}return ee.slice(0,ue-ge)}function b(ee,_){if(ee.indexOf(_[1])===-1)return-1;for(var we=ee.length,ue=0,ge=0;ge<we;ge++)if(ee[ge]==="\\")ge++;else if(ee[ge]===_[0])ue++;else if(ee[ge]===_[1]&&(ue--,ue<0))return ge;return-1}function v(ee){ee&&ee.sanitize&&!ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ee,_){if(_<1)return"";for(var we="";_>1;)_&1&&(we+=ee),_>>=1,ee+=ee;return we+ee}function N(ee,_,we,ue){var ge=_.href,te=_.title?D(_.title):null,fe=ee[1].replace(/\\([\[\]])/g,"$1");if(ee[0].charAt(0)!=="!"){ue.state.inLink=!0;var be={type:"link",raw:we,href:ge,title:te,text:fe,tokens:ue.inlineTokens(fe)};return ue.state.inLink=!1,be}return{type:"image",raw:we,href:ge,title:te,text:D(fe)}}function T(ee,_){var we=ee.match(/^(\s+)(?:```)/);if(we===null)return _;var ue=we[1];return _.split(`
`).map(function(ge){var te=ge.match(/^\s+/);if(te===null)return ge;var fe=te[0];return fe.length>=ue.length?ge.slice(ue.length):ge}).join(`
`)}var M=function(){function ee(we){this.options=we||$e.defaults}var _=ee.prototype;return _.space=function(ue){var ge=this.rules.block.newline.exec(ue);if(ge&&ge[0].length>0)return{type:"space",raw:ge[0]}},_.code=function(ue){var ge=this.rules.block.code.exec(ue);if(ge){var te=ge[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ge[0],codeBlockStyle:"indented",text:this.options.pedantic?te:$(te,`
`)}}},_.fences=function(ue){var ge=this.rules.block.fences.exec(ue);if(ge){var te=ge[0],fe=T(te,ge[3]||"");return{type:"code",raw:te,lang:ge[2]?ge[2].trim():ge[2],text:fe}}},_.heading=function(ue){var ge=this.rules.block.heading.exec(ue);if(ge){var te=ge[2].trim();if(/#$/.test(te)){var fe=$(te,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(te=fe.trim())}return{type:"heading",raw:ge[0],depth:ge[1].length,text:te,tokens:this.lexer.inline(te)}}},_.hr=function(ue){var ge=this.rules.block.hr.exec(ue);if(ge)return{type:"hr",raw:ge[0]}},_.blockquote=function(ue){var ge=this.rules.block.blockquote.exec(ue);if(ge){var te=ge[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ge[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},_.list=function(ue){var ge=this.rules.block.list.exec(ue);if(ge){var te,fe,be,Pe,B,J,se,oe,Y,me,Ee,je,We=ge[1].trim(),_e=We.length>1,Xe={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ue&&(je=!1,!(!(ge=it.exec(ue))||this.rules.block.hr.test(ue)));){if(te=ge[0],ue=ue.substring(te.length),oe=ge[2].split(`
`,1)[0],Y=ue.split(`
`,1)[0],this.options.pedantic?(Pe=2,Ee=oe.trimLeft()):(Pe=ge[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Ee=oe.slice(Pe),Pe+=ge[1].length),J=!1,!oe&&/^ *$/.test(Y)&&(te+=Y+`
`,ue=ue.substring(Y.length+1),je=!0),!je)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ue&&(me=ue.split(`
`,1)[0],oe=me,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(oe)||qe.test(oe)||tt.test(oe)||Ae.test(ue)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())Ee+=`
`+oe.slice(Pe);else if(!J)Ee+=`
`+oe;else break;!J&&!oe.trim()&&(J=!0),te+=me+`
`,ue=ue.substring(me.length+1)}Xe.loose||(se?Xe.loose=!0:/\n *\n *$/.test(te)&&(se=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(Ee),fe&&(be=fe[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:te,task:!!fe,checked:be,loose:!1,text:Ee}),Xe.raw+=te}Xe.items[Xe.items.length-1].raw=te.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Re=Xe.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Xe.items[B].tokens=this.lexer.blockTokens(Xe.items[B].text,[]);var Ze=Xe.items[B].tokens.filter(function(le){return le.type==="space"}),he=Ze.every(function(le){for(var Ie=le.raw.split(""),Ke=0,ze=L(Ie),Ye;!(Ye=ze()).done;){var nt=Ye.value;if(nt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Xe.loose&&Ze.length&&he&&(Xe.loose=!0,Xe.items[B].loose=!0)}return Xe}},_.html=function(ue){var ge=this.rules.block.html.exec(ue);if(ge){var te={type:"html",raw:ge[0],pre:!this.options.sanitizer&&(ge[1]==="pre"||ge[1]==="script"||ge[1]==="style"),text:ge[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]);te.type="paragraph",te.text=fe,te.tokens=this.lexer.inline(fe)}return te}},_.def=function(ue){var ge=this.rules.block.def.exec(ue);if(ge){ge[3]&&(ge[3]=ge[3].substring(1,ge[3].length-1));var te=ge[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:ge[0],href:ge[2],title:ge[3]}}},_.table=function(ue){var ge=this.rules.block.table.exec(ue);if(ge){var te={type:"table",header:k(ge[1]).map(function(se){return{text:se}}),align:ge[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ge[3]&&ge[3].trim()?ge[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=ge[0];var fe=te.align.length,be,Pe,B,J;for(be=0;be<fe;be++)/^ *-+: *$/.test(te.align[be])?te.align[be]="right":/^ *:-+: *$/.test(te.align[be])?te.align[be]="center":/^ *:-+ *$/.test(te.align[be])?te.align[be]="left":te.align[be]=null;for(fe=te.rows.length,be=0;be<fe;be++)te.rows[be]=k(te.rows[be],te.header.length).map(function(se){return{text:se}});for(fe=te.header.length,Pe=0;Pe<fe;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(fe=te.rows.length,Pe=0;Pe<fe;Pe++)for(J=te.rows[Pe],B=0;B<J.length;B++)J[B].tokens=this.lexer.inline(J[B].text);return te}}},_.lheading=function(ue){var ge=this.rules.block.lheading.exec(ue);if(ge)return{type:"heading",raw:ge[0],depth:ge[2].charAt(0)==="="?1:2,text:ge[1],tokens:this.lexer.inline(ge[1])}},_.paragraph=function(ue){var ge=this.rules.block.paragraph.exec(ue);if(ge){var te=ge[1].charAt(ge[1].length-1)===`
`?ge[1].slice(0,-1):ge[1];return{type:"paragraph",raw:ge[0],text:te,tokens:this.lexer.inline(te)}}},_.text=function(ue){var ge=this.rules.block.text.exec(ue);if(ge)return{type:"text",raw:ge[0],text:ge[0],tokens:this.lexer.inline(ge[0])}},_.escape=function(ue){var ge=this.rules.inline.escape.exec(ue);if(ge)return{type:"escape",raw:ge[0],text:D(ge[1])}},_.tag=function(ue){var ge=this.rules.inline.tag.exec(ue);if(ge)return!this.lexer.state.inLink&&/^<a /i.test(ge[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ge[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]):ge[0]}},_.link=function(ue){var ge=this.rules.inline.link.exec(ue);if(ge){var te=ge[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var fe=$(te.slice(0,-1),"\\");if((te.length-fe.length)%2===0)return}else{var be=b(ge[2],"()");if(be>-1){var Pe=ge[0].indexOf("!")===0?5:4,B=Pe+ge[1].length+be;ge[2]=ge[2].substring(0,be),ge[0]=ge[0].substring(0,B).trim(),ge[3]=""}}var J=ge[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);oe&&(J=oe[1],se=oe[3])}else se=ge[3]?ge[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(te)?J=J.slice(1):J=J.slice(1,-1)),N(ge,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ge[0],this.lexer)}},_.reflink=function(ue,ge){var te;if((te=this.rules.inline.reflink.exec(ue))||(te=this.rules.inline.nolink.exec(ue))){var fe=(te[2]||te[1]).replace(/\s+/g," ");if(fe=ge[fe.toLowerCase()],!fe||!fe.href){var be=te[0].charAt(0);return{type:"text",raw:be,text:be}}return N(te,fe,te[0],this.lexer)}},_.emStrong=function(ue,ge,te){te===void 0&&(te="");var fe=this.rules.inline.emStrong.lDelim.exec(ue);if(fe&&!(fe[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=fe[1]||fe[2]||"";if(!be||be&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=fe[0].length-1,B,J,se=Pe,oe=0,Y=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ge=ge.slice(-1*ue.length+Pe);(fe=Y.exec(ge))!=null;)if(B=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!B){if(J=B.length,fe[3]||fe[4]){se+=J;continue}else if((fe[5]||fe[6])&&Pe%3&&!((Pe+J)%3)){oe+=J;continue}if(se-=J,!(se>0)){if(J=Math.min(J,J+se+oe),Math.min(Pe,J)%2){var me=ue.slice(1,Pe+fe.index+J);return{type:"em",raw:ue.slice(0,Pe+fe.index+J+1),text:me,tokens:this.lexer.inlineTokens(me)}}var Ee=ue.slice(2,Pe+fe.index+J-1);return{type:"strong",raw:ue.slice(0,Pe+fe.index+J+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},_.codespan=function(ue){var ge=this.rules.inline.code.exec(ue);if(ge){var te=ge[2].replace(/\n/g," "),fe=/[^ ]/.test(te),be=/^ /.test(te)&&/ $/.test(te);return fe&&be&&(te=te.substring(1,te.length-1)),te=D(te,!0),{type:"codespan",raw:ge[0],text:te}}},_.br=function(ue){var ge=this.rules.inline.br.exec(ue);if(ge)return{type:"br",raw:ge[0]}},_.del=function(ue){var ge=this.rules.inline.del.exec(ue);if(ge)return{type:"del",raw:ge[0],text:ge[2],tokens:this.lexer.inlineTokens(ge[2])}},_.autolink=function(ue,ge){var te=this.rules.inline.autolink.exec(ue);if(te){var fe,be;return te[2]==="@"?(fe=D(this.options.mangle?ge(te[1]):te[1]),be="mailto:"+fe):(fe=D(te[1]),be=fe),{type:"link",raw:te[0],text:fe,href:be,tokens:[{type:"text",raw:fe,text:fe}]}}},_.url=function(ue,ge){var te;if(te=this.rules.inline.url.exec(ue)){var fe,be;if(te[2]==="@")fe=D(this.options.mangle?ge(te[0]):te[0]),be="mailto:"+fe;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);fe=D(te[0]),te[1]==="www."?be="http://"+fe:be=fe}return{type:"link",raw:te[0],text:fe,href:be,tokens:[{type:"text",raw:fe,text:fe}]}}},_.inlineText=function(ue,ge){var te=this.rules.inline.text.exec(ue);if(te){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):D(te[0]):te[0]:fe=D(this.options.smartypants?ge(te[0]):te[0]),{type:"text",raw:te[0],text:fe}}},ee}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=S({},U),U.gfm=S({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=S({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=i(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=i(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=i(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=i(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=i(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=i(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=i(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=i(j.reflink).replace("label",j._label).replace("ref",U._label).getRegex(),j.nolink=i(j.nolink).replace("ref",U._label).getRegex(),j.reflinkSearch=i(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=S({},j),j.pedantic=S({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=S({},j.normal,{escape:i(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=i(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=S({},j.gfm,{br:i(j.br).replace("{2,}","*").getRegex(),text:i(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ee){return ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ee){var _="",we,ue,ge=ee.length;for(we=0;we<ge;we++)ue=ee.charCodeAt(we),Math.random()>.5&&(ue="x"+ue.toString(16)),_+="&#"+ue+";";return _}var q=function(){function ee(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ue={block:U.normal,inline:j.normal};this.options.pedantic?(ue.block=U.pedantic,ue.inline=j.pedantic):this.options.gfm&&(ue.block=U.gfm,this.options.breaks?ue.inline=j.breaks:ue.inline=j.gfm),this.tokenizer.rules=ue}ee.lex=function(ue,ge){var te=new ee(ge);return te.lex(ue)},ee.lexInline=function(ue,ge){var te=new ee(ge);return te.inlineTokens(ue)};var _=ee.prototype;return _.lex=function(ue){ue=ue.replace(/\r\n|\r/g,`
`),this.blockTokens(ue,this.tokens);for(var ge;ge=this.inlineQueue.shift();)this.inlineTokens(ge.src,ge.tokens);return this.tokens},_.blockTokens=function(ue,ge){var te=this;ge===void 0&&(ge=[]),this.options.pedantic?ue=ue.replace(/\t/g,"    ").replace(/^ +$/gm,""):ue=ue.replace(/^( *)(\t+)/gm,function(se,oe,Y){return oe+"    ".repeat(Y.length)});for(var fe,be,Pe,B;ue;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(fe=se.call({lexer:te},ue,ge))?(ue=ue.substring(fe.raw.length),ge.push(fe),!0):!1}))){if(fe=this.tokenizer.space(ue)){ue=ue.substring(fe.raw.length),fe.raw.length===1&&ge.length>0?ge[ge.length-1].raw+=`
`:ge.push(fe);continue}if(fe=this.tokenizer.code(ue)){ue=ue.substring(fe.raw.length),be=ge[ge.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):ge.push(fe);continue}if(fe=this.tokenizer.fences(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.heading(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.hr(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.blockquote(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.list(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.html(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.def(ue)){ue=ue.substring(fe.raw.length),be=ge[ge.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.lheading(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(Pe=ue,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=ue.slice(1),Y=void 0;te.options.extensions.startBlock.forEach(function(me){Y=me.call({lexer:this},oe),typeof Y=="number"&&Y>=0&&(se=Math.min(se,Y))}),se<1/0&&se>=0&&(Pe=ue.substring(0,se+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Pe))){be=ge[ge.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):ge.push(fe),B=Pe.length!==ue.length,ue=ue.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(ue)){ue=ue.substring(fe.raw.length),be=ge[ge.length-1],be&&be.type==="text"?(be.raw+=`
`+fe.raw,be.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):ge.push(fe);continue}if(ue){var J="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,ge},_.inline=function(ue,ge){return ge===void 0&&(ge=[]),this.inlineQueue.push({src:ue,tokens:ge}),ge},_.inlineTokens=function(ue,ge){var te=this;ge===void 0&&(ge=[]);var fe,be,Pe,B=ue,J,se,oe;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,J.index)+"["+C("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,J.index)+"["+C("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,J.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ue;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(fe=Ee.call({lexer:te},ue,ge))?(ue=ue.substring(fe.raw.length),ge.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.tag(ue)){ue=ue.substring(fe.raw.length),be=ge[ge.length-1],be&&fe.type==="text"&&be.type==="text"?(be.raw+=fe.raw,be.text+=fe.text):ge.push(fe);continue}if(fe=this.tokenizer.link(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.reflink(ue,this.tokens.links)){ue=ue.substring(fe.raw.length),be=ge[ge.length-1],be&&fe.type==="text"&&be.type==="text"?(be.raw+=fe.raw,be.text+=fe.text):ge.push(fe);continue}if(fe=this.tokenizer.emStrong(ue,B,oe)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.codespan(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.br(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.del(ue)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(fe=this.tokenizer.autolink(ue,V)){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(ue,V))){ue=ue.substring(fe.raw.length),ge.push(fe);continue}if(Pe=ue,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,je=ue.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(Pe=ue.substring(0,Ee+1))}(),fe=this.tokenizer.inlineText(Pe,O)){ue=ue.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(oe=fe.raw.slice(-1)),se=!0,be=ge[ge.length-1],be&&be.type==="text"?(be.raw+=fe.raw,be.text+=fe.text):ge.push(fe);continue}if(ue){var me="Infinite loop on byte: "+ue.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return ge},I(ee,null,[{key:"rules",get:function(){return{block:U,inline:j}}}]),ee}(),de=function(){function ee(we){this.options=we||$e.defaults}var _=ee.prototype;return _.code=function(ue,ge,te){var fe=(ge||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ue,fe);be!=null&&be!==ue&&(te=!0,ue=be)}return ue=ue.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+D(fe,!0)+'">'+(te?ue:D(ue,!0))+`</code></pre>
`:"<pre><code>"+(te?ue:D(ue,!0))+`</code></pre>
`},_.blockquote=function(ue){return`<blockquote>
`+ue+`</blockquote>
`},_.html=function(ue){return ue},_.heading=function(ue,ge,te,fe){if(this.options.headerIds){var be=this.options.headerPrefix+fe.slug(te);return"<h"+ge+' id="'+be+'">'+ue+"</h"+ge+`>
`}return"<h"+ge+">"+ue+"</h"+ge+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(ue,ge,te){var fe=ge?"ol":"ul",be=ge&&te!==1?' start="'+te+'"':"";return"<"+fe+be+`>
`+ue+"</"+fe+`>
`},_.listitem=function(ue){return"<li>"+ue+`</li>
`},_.checkbox=function(ue){return"<input "+(ue?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(ue){return"<p>"+ue+`</p>
`},_.table=function(ue,ge){return ge&&(ge="<tbody>"+ge+"</tbody>"),`<table>
<thead>
`+ue+`</thead>
`+ge+`</table>
`},_.tablerow=function(ue){return`<tr>
`+ue+`</tr>
`},_.tablecell=function(ue,ge){var te=ge.header?"th":"td",fe=ge.align?"<"+te+' align="'+ge.align+'">':"<"+te+">";return fe+ue+("</"+te+`>
`)},_.strong=function(ue){return"<strong>"+ue+"</strong>"},_.em=function(ue){return"<em>"+ue+"</em>"},_.codespan=function(ue){return"<code>"+ue+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(ue){return"<del>"+ue+"</del>"},_.link=function(ue,ge,te){if(ue=o(this.options.sanitize,this.options.baseUrl,ue),ue===null)return te;var fe='<a href="'+D(ue)+'"';return ge&&(fe+=' title="'+ge+'"'),fe+=">"+te+"</a>",fe},_.image=function(ue,ge,te){if(ue=o(this.options.sanitize,this.options.baseUrl,ue),ue===null)return te;var fe='<img src="'+ue+'" alt="'+te+'"';return ge&&(fe+=' title="'+ge+'"'),fe+=this.options.xhtml?"/>":">",fe},_.text=function(ue){return ue},ee}(),x=function(){function ee(){}var _=ee.prototype;return _.strong=function(ue){return ue},_.em=function(ue){return ue},_.codespan=function(ue){return ue},_.del=function(ue){return ue},_.html=function(ue){return ue},_.text=function(ue){return ue},_.link=function(ue,ge,te){return""+te},_.image=function(ue,ge,te){return""+te},_.br=function(){return""},ee}(),Q=function(){function ee(){this.seen={}}var _=ee.prototype;return _.serialize=function(ue){return ue.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(ue,ge){var te=ue,fe=0;if(this.seen.hasOwnProperty(te)){fe=this.seen[ue];do fe++,te=ue+"-"+fe;while(this.seen.hasOwnProperty(te))}return ge||(this.seen[ue]=fe,this.seen[te]=0),te},_.slug=function(ue,ge){ge===void 0&&(ge={});var te=this.serialize(ue);return this.getNextSafeSlug(te,ge.dryrun)},ee}(),G=function(){function ee(we){this.options=we||$e.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Q}ee.parse=function(ue,ge){var te=new ee(ge);return te.parse(ue)},ee.parseInline=function(ue,ge){var te=new ee(ge);return te.parseInline(ue)};var _=ee.prototype;return _.parse=function(ue,ge){ge===void 0&&(ge=!0);var te="",fe,be,Pe,B,J,se,oe,Y,me,Ee,je,We,_e,Xe,it,tt,Ae,Ne,qe,Re=ue.length;for(fe=0;fe<Re;fe++){if(Ee=ue[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(qe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){te+=qe||"";continue}switch(Ee.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,u(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(Y="",oe="",B=Ee.header.length,be=0;be<B;be++)oe+=this.renderer.tablecell(this.parseInline(Ee.header[be].tokens),{header:!0,align:Ee.align[be]});for(Y+=this.renderer.tablerow(oe),me="",B=Ee.rows.length,be=0;be<B;be++){for(se=Ee.rows[be],oe="",J=se.length,Pe=0;Pe<J;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:Ee.align[Pe]});me+=this.renderer.tablerow(oe)}te+=this.renderer.table(Y,me);continue}case"blockquote":{me=this.parse(Ee.tokens),te+=this.renderer.blockquote(me);continue}case"list":{for(je=Ee.ordered,We=Ee.start,_e=Ee.loose,B=Ee.items.length,me="",be=0;be<B;be++)it=Ee.items[be],tt=it.checked,Ae=it.task,Xe="",it.task&&(Ne=this.renderer.checkbox(tt),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Xe+=Ne),Xe+=this.parse(it.tokens,_e),me+=this.renderer.listitem(Xe,Ae,tt);te+=this.renderer.list(me,je,We);continue}case"html":{te+=this.renderer.html(Ee.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(me=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;fe+1<Re&&ue[fe+1].type==="text";)Ee=ue[++fe],me+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);te+=ge?this.renderer.paragraph(me):me;continue}default:{var Ze='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return te},_.parseInline=function(ue,ge){ge=ge||this.renderer;var te="",fe,be,Pe,B=ue.length;for(fe=0;fe<B;fe++){if(be=ue[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){te+=Pe||"";continue}switch(be.type){case"escape":{te+=ge.text(be.text);break}case"html":{te+=ge.html(be.text);break}case"link":{te+=ge.link(be.href,be.title,this.parseInline(be.tokens,ge));break}case"image":{te+=ge.image(be.href,be.title,be.text);break}case"strong":{te+=ge.strong(this.parseInline(be.tokens,ge));break}case"em":{te+=ge.em(this.parseInline(be.tokens,ge));break}case"codespan":{te+=ge.codespan(be.text);break}case"br":{te+=ge.br();break}case"del":{te+=ge.del(this.parseInline(be.tokens,ge));break}case"text":{te+=ge.text(be.text);break}default:{var J='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return te},ee}();function ce(ee,_,we){if(typeof ee>"u"||ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");if(typeof _=="function"&&(we=_,_=null),_=S({},ce.defaults,_||{}),v(_),we){var ue=_.highlight,ge;try{ge=q.lex(ee,_)}catch(B){return we(B)}var te=function(J){var se;if(!J)try{_.walkTokens&&ce.walkTokens(ge,_.walkTokens),se=G.parse(ge,_)}catch(oe){J=oe}return _.highlight=ue,J?we(J):we(null,se)};if(!ue||ue.length<3||(delete _.highlight,!ge.length))return te();var fe=0;ce.walkTokens(ge,function(B){B.type==="code"&&(fe++,setTimeout(function(){ue(B.text,B.lang,function(J,se){if(J)return te(J);se!=null&&se!==B.text&&(B.text=se,B.escaped=!0),fe--,fe===0&&te()})},0))}),fe===0&&te();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Pe=q.lex(ee,_);if(_.walkTokens){if(_.async)return Promise.all(ce.walkTokens(Pe,_.walkTokens)).then(function(){return G.parse(Pe,_)}).catch(be);ce.walkTokens(Pe,_.walkTokens)}return G.parse(Pe,_)}catch(B){be(B)}}ce.options=ce.setOptions=function(ee){return S(ce.defaults,ee),p(ce.defaults),ce},ce.getDefaults=R,ce.defaults=$e.defaults,ce.use=function(){for(var ee=arguments.length,_=new Array(ee),we=0;we<ee;we++)_[we]=arguments[we];var ue=S.apply(void 0,[{}].concat(_)),ge=ce.defaults.extensions||{renderers:{},childTokens:{}},te;_.forEach(function(fe){if(fe.extensions&&(te=!0,fe.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=ge.renderers?ge.renderers[Pe.name]:null;B?ge.renderers[Pe.name]=function(){for(var J=arguments.length,se=new Array(J),oe=0;oe<J;oe++)se[oe]=arguments[oe];var Y=Pe.renderer.apply(this,se);return Y===!1&&(Y=B.apply(this,se)),Y}:ge.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Pe.level]?ge[Pe.level].unshift(Pe.tokenizer):ge[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?ge.startBlock?ge.startBlock.push(Pe.start):ge.startBlock=[Pe.start]:Pe.level==="inline"&&(ge.startInline?ge.startInline.push(Pe.start):ge.startInline=[Pe.start]))}Pe.childTokens&&(ge.childTokens[Pe.name]=Pe.childTokens)})),fe.renderer&&function(){var Pe=ce.defaults.renderer||new de,B=function(oe){var Y=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,Ee=new Array(me),je=0;je<me;je++)Ee[je]=arguments[je];var We=fe.renderer[oe].apply(Pe,Ee);return We===!1&&(We=Y.apply(Pe,Ee)),We}};for(var J in fe.renderer)B(J);ue.renderer=Pe}(),fe.tokenizer&&function(){var Pe=ce.defaults.tokenizer||new M,B=function(oe){var Y=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,Ee=new Array(me),je=0;je<me;je++)Ee[je]=arguments[je];var We=fe.tokenizer[oe].apply(Pe,Ee);return We===!1&&(We=Y.apply(Pe,Ee)),We}};for(var J in fe.tokenizer)B(J);ue.tokenizer=Pe}(),fe.walkTokens){var be=ce.defaults.walkTokens;ue.walkTokens=function(Pe){var B=[];return B.push(fe.walkTokens.call(this,Pe)),be&&(B=B.concat(be.call(this,Pe))),B}}te&&(ue.extensions=ge),ce.setOptions(ue)})},ce.walkTokens=function(ee,_){for(var we=[],ue=function(){var be=te.value;switch(we=we.concat(_.call(ce,be)),be.type){case"table":{for(var Pe=L(be.header),B;!(B=Pe()).done;){var J=B.value;we=we.concat(ce.walkTokens(J.tokens,_))}for(var se=L(be.rows),oe;!(oe=se()).done;)for(var Y=oe.value,me=L(Y),Ee;!(Ee=me()).done;){var je=Ee.value;we=we.concat(ce.walkTokens(je.tokens,_))}break}case"list":{we=we.concat(ce.walkTokens(be.items,_));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[be.type]?ce.defaults.extensions.childTokens[be.type].forEach(function(We){we=we.concat(ce.walkTokens(be[We],_))}):be.tokens&&(we=we.concat(ce.walkTokens(be.tokens,_)))}},ge=L(ee),te;!(te=ge()).done;)ue();return we},ce.parseInline=function(ee,_){if(typeof ee>"u"||ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");_=S({},ce.defaults,_||{}),v(_);try{var we=q.lexInline(ee,_);return _.walkTokens&&ce.walkTokens(we,_.walkTokens),G.parseInline(we,_)}catch(ue){if(ue.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+D(ue.message+"",!0)+"</pre>";throw ue}},ce.Parser=G,ce.parser=G.parse,ce.Renderer=de,ce.TextRenderer=x,ce.Lexer=q,ce.lexer=q.lex,ce.Tokenizer=M,ce.Slugger=Q,ce.parse=ce;var ie=ce.options,ae=ce.setOptions,ye=ce.use,H=ce.walkTokens,z=ce.parseInline,X=ce,re=G.parse,Z=q.lex;$e.Lexer=q,$e.Parser=G,$e.Renderer=de,$e.Slugger=Q,$e.TextRenderer=x,$e.Tokenizer=M,$e.getDefaults=R,$e.lexer=Z,$e.marked=ce,$e.options=ie,$e.parse=X,$e.parseInline=z,$e.parser=re,$e.setOptions=ae,$e.use=ye,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(Se[77],De([1,0,28]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const F=new I.$Cc(1e4);function f(m){return E(m,"NFC",F)}e.$ol=f;const L=new I.$Cc(1e4);function R(m){return E(m,"NFD",L)}e.$pl=R;const p=/[^\u0000-\u0080]/;function E(m,A,P){if(!m)return m;const g=P.get(m);if(g)return g;let y;return p.test(m)?y=m.normalize(A):y=m,P.set(m,y),y}e.$ql=function(){const m=/[\u0300-\u036f]/g;return function(A){return R(A).replace(m,"")}}()}),define(Se[122],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function I(p,E,m){return Math.min(Math.max(p,E),m)}e.$Ol=I;function F(p,E){return(E+p%E)%E}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=f;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=L;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const m=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=R}),function(){function $e(f){const L=[];typeof f=="number"&&L.push("code/timeOrigin",f);function R(E){L.push(E,Date.now())}function p(){const E=[];for(let m=0;m<L.length;m+=2)E.push({name:L[m],startTime:L[m+1]});return E}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(f+R.startTime)});return L}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function I(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:$e)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function I(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return $e[F].call(f.exports,f,f.exports,I),f.l=!0,f.exports}return I.m=$e,I.c=e,I.d=function(F,f,L){I.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:L})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,f){if(1&f&&(F=I(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var R in F)I.d(L,R,function(p){return F[p]}.bind(null,R));return L},I.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(f,"a",f),f},I.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},I.p="",I(I.s=0)}([function($e,e,I){(function(F){var f;e=$e.exports=ye,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],E=e.src=[],m=0,A=m++;E[A]="0|[1-9]\\d*";var P=m++;E[P]="[0-9]+";var g=m++;E[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=m++;E[y]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var D=m++;E[D]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var w=m++;E[w]="(?:"+E[A]+"|"+E[g]+")";var u=m++;E[u]="(?:"+E[P]+"|"+E[g]+")";var c=m++;E[c]="(?:-("+E[w]+"(?:\\."+E[w]+")*))";var i=m++;E[i]="(?:-?("+E[u]+"(?:\\."+E[u]+")*))";var s=m++;E[s]="[0-9A-Za-z-]+";var r=m++;E[r]="(?:\\+("+E[s]+"(?:\\."+E[s]+")*))";var o=m++,t="v?"+E[y]+E[c]+"?"+E[r]+"?";E[o]="^"+t+"$";var n="[v=\\s]*"+E[D]+E[i]+"?"+E[r]+"?",d=m++;E[d]="^"+n+"$";var l=m++;E[l]="((?:<|>)?=?)";var a=m++;E[a]=E[P]+"|x|X|\\*";var h=m++;E[h]=E[A]+"|x|X|\\*";var S=m++;E[S]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[c]+")?"+E[r]+"?)?)?";var k=m++;E[k]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[i]+")?"+E[r]+"?)?)?";var $=m++;E[$]="^"+E[l]+"\\s*"+E[S]+"$";var b=m++;E[b]="^"+E[l]+"\\s*"+E[k]+"$";var v=m++;E[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=m++;E[C]="(?:~>?)";var N=m++;E[N]="(\\s*)"+E[C]+"\\s+",p[N]=new RegExp(E[N],"g");var T=m++;E[T]="^"+E[C]+E[S]+"$";var M=m++;E[M]="^"+E[C]+E[k]+"$";var U=m++;E[U]="(?:\\^)";var j=m++;E[j]="(\\s*)"+E[U]+"\\s+",p[j]=new RegExp(E[j],"g");var O=m++;E[O]="^"+E[U]+E[S]+"$";var V=m++;E[V]="^"+E[U]+E[k]+"$";var q=m++;E[q]="^"+E[l]+"\\s*("+n+")$|^$";var de=m++;E[de]="^"+E[l]+"\\s*("+t+")$|^$";var x=m++;E[x]="(\\s*)"+E[l]+"\\s*("+n+"|"+E[S]+")",p[x]=new RegExp(E[x],"g");var Q=m++;E[Q]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var G=m++;E[G]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var ce=m++;E[ce]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)f(ie,E[ie]),p[ie]||(p[ie]=new RegExp(E[ie]));function ae(Y,me){if(Y instanceof ye)return Y;if(typeof Y!="string"||Y.length>L||!(me?p[d]:p[o]).test(Y))return null;try{return new ye(Y,me)}catch{return null}}function ye(Y,me){if(Y instanceof ye){if(Y.loose===me)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ye))return new ye(Y,me);f("SemVer",Y,me),this.loose=me;var Ee=Y.trim().match(me?p[d]:p[o]);if(!Ee)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<R)return We}return je}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Y,me){var Ee=ae(Y,me);return Ee?Ee.version:null},e.clean=function(Y,me){var Ee=ae(Y.trim().replace(/^[=v]+/,""),me);return Ee?Ee.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(Y){return f("SemVer.compare",this.version,this.loose,Y),Y instanceof ye||(Y=new ye(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ye.prototype.compareMain=function(Y){return Y instanceof ye||(Y=new ye(Y,this.loose)),z(this.major,Y.major)||z(this.minor,Y.minor)||z(this.patch,Y.patch)},ye.prototype.comparePre=function(Y){if(Y instanceof ye||(Y=new ye(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var me=0;do{var Ee=this.prerelease[me],je=Y.prerelease[me];if(f("prerelease compare",me,Ee,je),Ee===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==je)return z(Ee,je)}while(++me)},ye.prototype.inc=function(Y,me){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,me,Ee,je){typeof Ee=="string"&&(je=Ee,Ee=void 0);try{return new ye(Y,Ee).inc(me,je).version}catch{return null}},e.diff=function(Y,me){if(ee(Y,me))return null;var Ee=ae(Y),je=ae(me);if(Ee.prerelease.length||je.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return We},e.compareIdentifiers=z;var H=/^[0-9]+$/;function z(Y,me){var Ee=H.test(Y),je=H.test(me);return Ee&&je&&(Y=+Y,me=+me),Ee&&!je?-1:je&&!Ee?1:Y<me?-1:Y>me?1:0}function X(Y,me,Ee){return new ye(Y,Ee).compare(new ye(me,Ee))}function re(Y,me,Ee){return X(Y,me,Ee)>0}function Z(Y,me,Ee){return X(Y,me,Ee)<0}function ee(Y,me,Ee){return X(Y,me,Ee)===0}function _(Y,me,Ee){return X(Y,me,Ee)!==0}function we(Y,me,Ee){return X(Y,me,Ee)>=0}function ue(Y,me,Ee){return X(Y,me,Ee)<=0}function ge(Y,me,Ee,je){var We;switch(me){case"===":typeof Y=="object"&&(Y=Y.version),typeof Ee=="object"&&(Ee=Ee.version),We=Y===Ee;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof Ee=="object"&&(Ee=Ee.version),We=Y!==Ee;break;case"":case"=":case"==":We=ee(Y,Ee,je);break;case"!=":We=_(Y,Ee,je);break;case">":We=re(Y,Ee,je);break;case">=":We=we(Y,Ee,je);break;case"<":We=Z(Y,Ee,je);break;case"<=":We=ue(Y,Ee,je);break;default:throw new TypeError("Invalid operator: "+me)}return We}function te(Y,me){if(Y instanceof te){if(Y.loose===me)return Y;Y=Y.value}if(!(this instanceof te))return new te(Y,me);f("comparator",Y,me),this.loose=me,this.parse(Y),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Y,me){return z(me,Y)},e.major=function(Y,me){return new ye(Y,me).major},e.minor=function(Y,me){return new ye(Y,me).minor},e.patch=function(Y,me){return new ye(Y,me).patch},e.compare=X,e.compareLoose=function(Y,me){return X(Y,me,!0)},e.rcompare=function(Y,me,Ee){return X(me,Y,Ee)},e.sort=function(Y,me){return Y.sort(function(Ee,je){return e.compare(Ee,je,me)})},e.rsort=function(Y,me){return Y.sort(function(Ee,je){return e.rcompare(Ee,je,me)})},e.gt=re,e.lt=Z,e.eq=ee,e.neq=_,e.gte=we,e.lte=ue,e.cmp=ge,e.Comparator=te;var fe={};function be(Y,me){if(Y instanceof be)return Y.loose===me?Y:new be(Y.raw,me);if(Y instanceof te)return new be(Y.value,me);if(!(this instanceof be))return new be(Y,me);if(this.loose=me,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,me,Ee,je,We,_e,Xe,it,tt,Ae,Ne,qe,Re){return((me=Pe(Ee)?"":Pe(je)?">="+Ee+".0.0":Pe(We)?">="+Ee+"."+je+".0":">="+me)+" "+(it=Pe(tt)?"":Pe(Ae)?"<"+(+tt+1)+".0.0":Pe(Ne)?"<"+tt+"."+(+Ae+1)+".0":qe?"<="+tt+"."+Ae+"."+Ne+"-"+qe:"<="+it)).trim()}function J(Y,me){for(var Ee=0;Ee<Y.length;Ee++)if(!Y[Ee].test(me))return!1;if(me.prerelease.length){for(Ee=0;Ee<Y.length;Ee++)if(f(Y[Ee].semver),Y[Ee].semver!==fe&&Y[Ee].semver.prerelease.length>0){var je=Y[Ee].semver;if(je.major===me.major&&je.minor===me.minor&&je.patch===me.patch)return!0}return!1}return!0}function se(Y,me,Ee){try{me=new be(me,Ee)}catch{return!1}return me.test(Y)}function oe(Y,me,Ee,je){var We,_e,Xe,it,tt;switch(Y=new ye(Y,je),me=new be(me,je),Ee){case">":We=re,_e=ue,Xe=Z,it=">",tt=">=";break;case"<":We=Z,_e=we,Xe=re,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Y,me,je))return!1;for(var Ae=0;Ae<me.set.length;++Ae){var Ne=me.set[Ae],qe=null,Re=null;if(Ne.forEach(function(Ze){Ze.semver===fe&&(Ze=new te(">=0.0.0")),qe=qe||Ze,Re=Re||Ze,We(Ze.semver,qe.semver,je)?qe=Ze:Xe(Ze.semver,Re.semver,je)&&(Re=Ze)}),qe.operator===it||qe.operator===tt||(!Re.operator||Re.operator===it)&&_e(Y,Re.semver)||Re.operator===tt&&Xe(Y,Re.semver))return!1}return!0}te.prototype.parse=function(Y){var me=this.loose?p[q]:p[de],Ee=Y.match(me);if(!Ee)throw new TypeError("Invalid comparator: "+Y);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new ye(Ee[2],this.loose):this.semver=fe},te.prototype.toString=function(){return this.value},te.prototype.test=function(Y){return f("Comparator.test",Y,this.loose),this.semver===fe||(typeof Y=="string"&&(Y=new ye(Y,this.loose)),ge(Y,this.operator,this.semver,this.loose))},te.prototype.intersects=function(Y,me){if(!(Y instanceof te))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new be(Y.value,me),se(this.value,Ee,me);if(Y.operator==="")return Ee=new be(this.value,me),se(Y.semver,Ee,me);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),_e=this.semver.version===Y.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=ge(this.semver,"<",Y.semver,me)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),tt=ge(this.semver,">",Y.semver,me)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||We||_e&&Xe||it||tt},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var me=this.loose;Y=Y.trim(),f("range",Y,me);var Ee=me?p[G]:p[Q];Y=Y.replace(Ee,B),f("hyphen replace",Y),Y=Y.replace(p[x],"$1$2$3"),f("comparator trim",Y,p[x]),Y=(Y=(Y=Y.replace(p[N],"$1~")).replace(p[j],"$1^")).split(/\s+/).join(" ");var je=me?p[q]:p[de],We=Y.split(" ").map(function(_e){return function(Xe,it){return f("comp",Xe),Xe=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Ne){return function(qe,Re){f("caret",qe,Re);var Ze=Re?p[V]:p[O];return qe.replace(Ze,function(he,le,Ie,Ke,ze){var Ye;return f("caret",qe,he,le,Ie,Ke,ze),Pe(le)?Ye="":Pe(Ie)?Ye=">="+le+".0.0 <"+(+le+1)+".0.0":Pe(Ke)?Ye=le==="0"?">="+le+"."+Ie+".0 <"+le+"."+(+Ie+1)+".0":">="+le+"."+Ie+".0 <"+(+le+1)+".0.0":ze?(f("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=le==="0"?Ie==="0"?">="+le+"."+Ie+"."+Ke+ze+" <"+le+"."+Ie+"."+(+Ke+1):">="+le+"."+Ie+"."+Ke+ze+" <"+le+"."+(+Ie+1)+".0":">="+le+"."+Ie+"."+Ke+ze+" <"+(+le+1)+".0.0"):(f("no pr"),Ye=le==="0"?Ie==="0"?">="+le+"."+Ie+"."+Ke+" <"+le+"."+Ie+"."+(+Ke+1):">="+le+"."+Ie+"."+Ke+" <"+le+"."+(+Ie+1)+".0":">="+le+"."+Ie+"."+Ke+" <"+(+le+1)+".0.0"),f("caret return",Ye),Ye})}(Ne,Ae)}).join(" ")}(Xe,it),f("caret",Xe),Xe=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Ne){return function(qe,Re){var Ze=Re?p[M]:p[T];return qe.replace(Ze,function(he,le,Ie,Ke,ze){var Ye;return f("tilde",qe,he,le,Ie,Ke,ze),Pe(le)?Ye="":Pe(Ie)?Ye=">="+le+".0.0 <"+(+le+1)+".0.0":Pe(Ke)?Ye=">="+le+"."+Ie+".0 <"+le+"."+(+Ie+1)+".0":ze?(f("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=">="+le+"."+Ie+"."+Ke+ze+" <"+le+"."+(+Ie+1)+".0"):Ye=">="+le+"."+Ie+"."+Ke+" <"+le+"."+(+Ie+1)+".0",f("tilde return",Ye),Ye})}(Ne,Ae)}).join(" ")}(Xe,it),f("tildes",Xe),Xe=function(tt,Ae){return f("replaceXRanges",tt,Ae),tt.split(/\s+/).map(function(Ne){return function(qe,Re){qe=qe.trim();var Ze=Re?p[b]:p[$];return qe.replace(Ze,function(he,le,Ie,Ke,ze,Ye){f("xRange",qe,he,le,Ie,Ke,ze,Ye);var nt=Pe(Ie),ct=nt||Pe(Ke),bt=ct||Pe(ze);return le==="="&&bt&&(le=""),nt?he=le===">"||le==="<"?"<0.0.0":"*":le&&bt?(ct&&(Ke=0),bt&&(ze=0),le===">"?(le=">=",ct?(Ie=+Ie+1,Ke=0,ze=0):bt&&(Ke=+Ke+1,ze=0)):le==="<="&&(le="<",ct?Ie=+Ie+1:Ke=+Ke+1),he=le+Ie+"."+Ke+"."+ze):ct?he=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(he=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),f("xRange return",he),he})}(Ne,Ae)}).join(" ")}(Xe,it),f("xrange",Xe),Xe=function(tt,Ae){return f("replaceStars",tt,Ae),tt.trim().replace(p[ce],"")}(Xe,it),f("stars",Xe),Xe}(_e,me)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new te(_e,me)})},be.prototype.intersects=function(Y,me){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(je){return Y.set.some(function(We){return We.every(function(_e){return je.intersects(_e,me)})})})})},e.toComparators=function(Y,me){return new be(Y,me).set.map(function(Ee){return Ee.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ye(Y,this.loose));for(var me=0;me<this.set.length;me++)if(J(this.set[me],Y))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Y,me,Ee){var je=null,We=null;try{var _e=new be(me,Ee)}catch{return null}return Y.forEach(function(Xe){_e.test(Xe)&&(je&&We.compare(Xe)!==-1||(We=new ye(je=Xe,Ee)))}),je},e.minSatisfying=function(Y,me,Ee){var je=null,We=null;try{var _e=new be(me,Ee)}catch{return null}return Y.forEach(function(Xe){_e.test(Xe)&&(je&&We.compare(Xe)!==1||(We=new ye(je=Xe,Ee)))}),je},e.validRange=function(Y,me){try{return new be(Y,me).range||"*"}catch{return null}},e.ltr=function(Y,me,Ee){return oe(Y,me,"<",Ee)},e.gtr=function(Y,me,Ee){return oe(Y,me,">",Ee)},e.outside=oe,e.prerelease=function(Y,me){var Ee=ae(Y,me);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(Y,me,Ee){return Y=new be(Y,Ee),me=new be(me,Ee),Y.intersects(me)},e.coerce=function(Y){if(Y instanceof ye)return Y;if(typeof Y!="string")return null;var me=Y.match(p[v]);return me==null?null:ae((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,I(1))},function($e,e){var I,F,f=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(u){if(I===setTimeout)return setTimeout(u,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(u,0);try{return I(u,0)}catch{try{return I.call(null,u,0)}catch{return I.call(this,u,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var E,m=[],A=!1,P=-1;function g(){A&&E&&(A=!1,E.length?m=E.concat(m):P=-1,m.length&&y())}function y(){if(!A){var u=p(g);A=!0;for(var c=m.length;c;){for(E=m,m=[];++P<c;)E&&E[P].run();P=-1,c=m.length}E=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(u)}}function D(u,c){this.fun=u,this.array=c}function w(){}f.nextTick=function(u){var c=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)c[i-1]=arguments[i];m.push(new D(u,c)),m.length!==1||A||p(y)},D.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=w,f.addListener=w,f.once=w,f.off=w,f.removeListener=w,f.removeAllListeners=w,f.emit=w,f.prependListener=w,f.prependOnceListener=w,f.listeners=function(u){return[]},f.binding=function(u){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(u){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(Se[36],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=F}),define(Se[4],De([1,0,9,75,3,76,36]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const p=!1,E=!1;var m;(function($){$.None=()=>f.$Rc.None;function b(ge){if(E){const{onDidAddListener:te}=ge,fe=D.create();let be=0;ge.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),te?.()}}}function v(ge,te){return de(ge,()=>{},0,void 0,!0,void 0,te)}$.defer=v;function C(ge){return(te,fe=null,be)=>{let Pe=!1,B;return B=ge(J=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(fe,J)},null,be),Pe&&B.dispose(),B}}$.once=C;function N(ge,te,fe){return V((be,Pe=null,B)=>ge(J=>be.call(Pe,te(J)),null,B),fe)}$.map=N;function T(ge,te,fe){return V((be,Pe=null,B)=>ge(J=>{te(J),be.call(Pe,J)},null,B),fe)}$.forEach=T;function M(ge,te,fe){return V((be,Pe=null,B)=>ge(J=>te(J)&&be.call(Pe,J),null,B),fe)}$.filter=M;function U(ge){return ge}$.signal=U;function j(...ge){return(te,fe=null,be)=>{const Pe=(0,f.$Oc)(...ge.map(B=>B(J=>te.call(fe,J))));return q(Pe,be)}}$.any=j;function O(ge,te,fe,be){let Pe=fe;return N(ge,B=>(Pe=te(Pe,B),Pe),be)}$.reduce=O;function V(ge,te){let fe;const be={onWillAddFirstListener(){fe=ge(Pe.fire,Pe)},onDidRemoveLastListener(){fe?.dispose()}};te||b(be);const Pe=new s(be);return te?.add(Pe),Pe.event}function q(ge,te){return te instanceof Array?te.push(ge):te&&te.add(ge),ge}function de(ge,te,fe=100,be=!1,Pe=!1,B,J){let se,oe,Y,me=0,Ee;const je={leakWarningThreshold:B,onWillAddFirstListener(){se=ge(_e=>{me++,oe=te(oe,_e),be&&!Y&&(We.fire(oe),oe=void 0),Ee=()=>{const Xe=oe;oe=void 0,Y=void 0,(!be||me>1)&&We.fire(Xe),me=0},typeof fe=="number"?(clearTimeout(Y),Y=setTimeout(Ee,fe)):Y===void 0&&(Y=0,queueMicrotask(Ee))})},onWillRemoveListener(){Pe&&me>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,se.dispose()}};J||b(je);const We=new s(je);return J?.add(We),We.event}$.debounce=de;function x(ge,te=0,fe){return $.debounce(ge,(be,Pe)=>be?(be.push(Pe),be):[Pe],te,void 0,!0,void 0,fe)}$.accumulate=x;function Q(ge,te=(be,Pe)=>be===Pe,fe){let be=!0,Pe;return M(ge,B=>{const J=be||!te(B,Pe);return be=!1,Pe=B,J},fe)}$.latch=Q;function G(ge,te,fe){return[$.filter(ge,te,fe),$.filter(ge,be=>!te(be),fe)]}$.split=G;function ce(ge,te=!1,fe=[],be){let Pe=fe.slice(),B=ge(oe=>{Pe?Pe.push(oe):se.fire(oe)});be&&be.add(B);const J=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new s({onWillAddFirstListener(){B||(B=ge(oe=>se.fire(oe)),be&&be.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(J):J())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(se),se.event}$.buffer=ce;function ie(ge,te){return(be,Pe,B)=>{const J=te(new ye);return ge(function(se){const oe=J.evaluate(se);oe!==ae&&be.call(Pe,oe)},void 0,B)}}$.chain=ie;const ae=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(fe=>(te(fe),fe)),this}filter(te){return this.f.push(fe=>te(fe)?fe:ae),this}reduce(te,fe){let be=fe;return this.f.push(Pe=>(be=te(be,Pe),be)),this}latch(te=(fe,be)=>fe===be){let fe=!0,be;return this.f.push(Pe=>{const B=fe||!te(Pe,be);return fe=!1,be=Pe,B?Pe:ae}),this}evaluate(te){for(const fe of this.f)if(te=fe(te),te===ae)break;return te}}function H(ge,te,fe=be=>be){const be=(...se)=>J.fire(fe(...se)),Pe=()=>ge.on(te,be),B=()=>ge.removeListener(te,be),J=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}$.fromNodeEventEmitter=H;function z(ge,te,fe=be=>be){const be=(...se)=>J.fire(fe(...se)),Pe=()=>ge.addEventListener(te,be),B=()=>ge.removeEventListener(te,be),J=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}$.fromDOMEventEmitter=z;function X(ge){return new Promise(te=>C(ge)(te))}$.toPromise=X;function re(ge){const te=new s;return ge.then(fe=>{te.fire(fe)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}$.fromPromise=re;function Z(ge,te,fe){return te(fe),ge(be=>te(be))}$.runAndSubscribe=Z;function ee(ge,te){let fe=null;function be(B){fe?.dispose(),fe=new f.$Qc,te(B,fe)}be(void 0);const Pe=ge(B=>be(B));return(0,f.$Pc)(()=>{Pe.dispose(),fe?.dispose()})}$.runAndSubscribeWithStore=ee;class _{constructor(te,fe){this._observable=te,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};fe||b(be),this.emitter=new s(be),fe&&fe.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,fe){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(ge,te){return new _(ge,te).emitter.event}$.fromObservable=we;function ue(ge){return te=>{let fe=0,be=!1;const Pe={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(ge.reportChanges(),be&&(be=!1,te()))},handlePossibleChange(){},handleChange(){be=!0}};return ge.addObserver(Pe),ge.reportChanges(),{dispose(){ge.removeObserver(Pe)}}}}$.fromObservableLight=ue})(m||(e.Event=m={}));class A{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${A.f++}`,A.all.add(this)}start(b){this.g=new R.$Jd,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$Ld=A;let P=-1;function g($){const b=P;return P=$,{dispose(){P=b}}}e.$Md=g;class y{constructor(b,v=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=v,this.g=0}dispose(){this.f?.clear()}check(b,v){const C=this.threshold;if(C<=0||v<C)return;this.f||(this.f=new Map);const N=this.f.get(b.value)||0;if(this.f.set(b.value,N+1),this.g-=1,this.g<=0){this.g=C*.5;let T,M=0;for(const[U,j]of this.f)(!T||M<j)&&(T=U,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${M}):`),console.warn(T)}return()=>{const T=this.f.get(b.value)||0;this.f.set(b.value,T-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(b){this.value=b,this.id=w++}}const c=2,i=($,b)=>{if($ instanceof u)b($);else for(let v=0;v<$.length;v++){const C=$[v];C&&b(C)}};class s{constructor(b){this.w=0,this.f=b,this.g=P>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const b=this.t;queueMicrotask(()=>{i(b,v=>v.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,v,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Rc.None;if(this.m)return f.$Rc.None;v&&(b=b.bind(v));const N=new u(b);let T,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=D.create(),T=this.g.check(N.stack,this.w+1)),p&&(N.stack=M??D.create()),this.t?this.t instanceof u?(this.u??=new o,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,f.$Pc)(()=>{T?.(),this.x(N)});return C instanceof f.$Qc?C.add(U):Array.isArray(C)&&C.push(U),U},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const v=this.t,C=v.indexOf(b);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,v[C]=void 0;const N=this.u.current===this;if(this.w*c<=v.length){let T=0;for(let M=0;M<v.length;M++)v[M]?v[T++]=v[M]:N&&(this.u.end--,T<this.u.i&&this.u.i--);v.length=T}}y(b,v){if(!b)return;const C=this.f?.onListenerError||I.$Z;if(!C){b.value(v);return}try{b.value(v)}catch(N){C(N)}}z(b){const v=b.current.t;for(;b.i<b.end;)this.y(v[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,b);else{const v=this.u;v.enqueue(this,b,this.t.length),this.z(v)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=s;const r=()=>new o;e.$Od=r;class o{constructor(){this.i=-1,this.end=0}enqueue(b,v,C){this.i=0,this.end=C,this.current=b,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends s{async fireAsync(b,v,C){if(this.t)for(this.h||(this.h=new L.$1c),i(this.t,N=>this.h.push([N.value,b]));this.h.size>0&&!v.isCancellationRequested;){const[N,T]=this.h.shift(),M=[],U={...T,token:v,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");C&&(j=C(j,N)),M.push(j)}};try{N(U)}catch(j){(0,I.$Z)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const O of j)O.status==="rejected"&&(0,I.$Z)(O.reason)})}}}e.$Pd=t;class n extends s{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new L.$1c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$Qd=n;class d extends n{constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$Rd=d;class l extends s{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$Sd=l;class a{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const v={event:b,listener:null};this.h.push(v),this.g&&this.m(v);const C=()=>{this.g&&this.o(v);const N=this.h.indexOf(v);this.h.splice(N,1)};return(0,f.$Pc)((0,F.$cb)(C))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(v=>this.f.fire(v))}o(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.f.dispose()}}e.$Td=a;class h{constructor(b,v,C,N){this.f=new f.$Qc;const T=this.f.add(new a),M=this.f.add(new f.$Zc);function U(j){M.set(j,T.add(N(j)))}for(const j of b)U(j);this.f.add(v(j=>{U(j)})),this.f.add(C(j=>{M.deleteAndDispose(j)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Ud=h;class S{constructor(){this.f=[]}wrapEvent(b){return(v,C,N)=>b(T=>{const M=this.f[this.f.length-1];M?M.push(()=>v.call(C,T)):v.call(C,T)},void 0,N)}bufferEvents(b){const v=[];this.f.push(v);const C=b();return this.f.pop(),v.forEach(N=>N()),C}}e.$Vd=S;class k{constructor(){this.f=!1,this.g=m.None,this.h=f.$Rc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=k}),define(Se[21],De([1,0,4]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const F=Object.freeze(function(p,E){const m=setTimeout(p.bind(E),0);return{dispose(){clearTimeout(m)}}});var f;(function(p){function E(m){return m===p.None||m===p.Cancelled||m instanceof L?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}p.isCancellationToken=E,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new I.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=f.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=f.None}}e.$Xd=R}),define(Se[161],De([1,0,21]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class F{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new I.$Xd,E=this.b(p.token);return this.a={promise:E,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$we=F;class f{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const E=JSON.stringify(p);return this.b!==E&&(this.b=E,this.a=this.c(p)),this.a}}e.$xe=f;class L{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const E=this.b(p);return this.a.set(p,E),E}}e.$ye=L}),define(Se[97],De([1,0,9,3]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function f(r){const o=r;return o?typeof o.read=="function":!1}e.$Yd=f;function L(r){const o=r;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}e.$Zd=L;function R(r){const o=r;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.$1d=R;function p(r,o){return new E(r,o)}e.$2d=p;class E{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,I.$Z)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let n;switch(o){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(t);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(r,o){const t=[];let n;for(;(n=r.read())!==null;)t.push(n);return o(t)}e.$3d=m;function A(r,o,t){const n=[];let d;for(;(d=r.read())!==null&&n.length<t;)n.push(d);return d===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}e.$4d=A;function P(r,o){return new Promise((t,n)=>{const d=[];g(r,{onData:l=>{o&&d.push(l)},onError:l=>{o?n(l):t(void 0)},onEnd:()=>{t(o?o(d):void 0)}})})}e.$5d=P;function g(r,o,t){r.on("error",n=>{t?.isCancellationRequested||o.onError(n)}),r.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),r.on("data",n=>{t?.isCancellationRequested||o.onData(n)})}e.$6d=g;function y(r,o){return new Promise((t,n)=>{const d=new F.$Qc,l=[],a=k=>{if(l.push(k),l.length>o)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=k=>(d.dispose(),n(k)),S=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,F.$Pc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,F.$Pc)(()=>r.removeListener("end",S))),r.on("end",S),d.add((0,F.$Pc)(()=>r.removeListener("data",a))),r.on("data",a)})}e.$7d=y;function D(r,o){const t=p(o);return t.end(r),t}e.$8d=D;function w(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}e.$9d=w;function u(r){let o=!1;return{read:()=>o?null:(o=!0,r)}}e.$0d=u;function c(r,o,t){const n=p(t);return g(r,{onData:d=>n.write(o.data(d)),onError:d=>n.error(o.error?o.error(d):d),onEnd:()=>n.end()}),n}e.$$d=c;function i(r,o,t){let n=!1;return{read:()=>{const d=o.read();return n?d:(n=!0,d!==null?t([r,d]):r)}}}e.$_d=i;function s(r,o,t){let n=!1;const d=p(t);return g(o,{onData:l=>n?d.write(l):(n=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(r)),d.end()}}),d}e.$ae=s}),define(Se[22],De([1,0,47,97]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const f=typeof Buffer<"u",L=new I.$U(()=>new Uint8Array(256));let R,p;class E{static alloc(v){return f?new E(Buffer.allocUnsafe(v)):new E(new Uint8Array(v))}static wrap(v){return f&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new E(v)}static fromString(v,C){return!(C?.dontUseNodeBuffer||!1)&&f?new E(Buffer.from(v)):(R||(R=new TextEncoder),new E(R.encode(v)))}static fromByteArray(v){const C=E.alloc(v.length);for(let N=0,T=v.length;N<T;N++)C.buffer[N]=v[N];return C}static concat(v,C){if(typeof C>"u"){C=0;for(let M=0,U=v.length;M<U;M++)C+=v[M].byteLength}const N=E.alloc(C);let T=0;for(let M=0,U=v.length;M<U;M++){const j=v[M];N.set(j,T),T+=j.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=E.alloc(this.byteLength);return v.set(this),v}toString(){return f?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(v,C){return new E(this.buffer.subarray(v,C))}set(v,C){if(v instanceof E)this.buffer.set(v.buffer,C);else if(v instanceof Uint8Array)this.buffer.set(v,C);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),C);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return g(this.buffer,v)}writeUInt32BE(v,C){y(this.buffer,v,C)}readUInt32LE(v){return D(this.buffer,v)}writeUInt32LE(v,C){w(this.buffer,v,C)}readUInt8(v){return u(this.buffer,v)}writeUInt8(v,C){c(this.buffer,v,C)}indexOf(v,C=0){return m(this.buffer,v instanceof E?v.buffer:v,C)}}e.$be=E;function m(b,v,C=0){const N=v.byteLength,T=b.byteLength;if(N===0)return 0;if(N===1)return b.indexOf(v[0]);if(N>T-C)return-1;const M=L.value;M.fill(v.length);for(let V=0;V<v.length;V++)M[v[V]]=v.length-V-1;let U=C+v.length-1,j=U,O=-1;for(;U<T;)if(b[U]===v[j]){if(j===0){O=U;break}U--,j--}else U+=Math.max(v.length-j,M[b[U]]),j=v.length-1;return O}e.$ce=m;function A(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0}e.$de=A;function P(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255}e.$ee=P;function g(b,v){return b[v]*2**24+b[v+1]*2**16+b[v+2]*2**8+b[v+3]}e.$fe=g;function y(b,v,C){b[C+3]=v,v=v>>>8,b[C+2]=v,v=v>>>8,b[C+1]=v,v=v>>>8,b[C]=v}e.$ge=y;function D(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0|b[v+2]<<16>>>0|b[v+3]<<24>>>0}e.$he=D;function w(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255,v=v>>>8,b[C+2]=v&255,v=v>>>8,b[C+3]=v&255}e.$ie=w;function u(b,v){return b[v]}e.$je=u;function c(b,v,C){b[C]=v}e.$ke=c;function i(b){return F.$3d(b,v=>E.concat(v))}e.$le=i;function s(b){return F.$0d(b)}e.$me=s;function r(b){return F.$5d(b,v=>E.concat(v))}e.$ne=r;async function o(b){return b.ended?E.concat(b.buffer):E.concat([...b.buffer,await r(b.stream)])}e.$oe=o;function t(b){return F.$8d(b,v=>E.concat(v))}e.$pe=t;function n(b){return F.$$d(b,{data:v=>typeof v=="string"?E.fromString(v):E.wrap(v)},v=>E.concat(v))}e.$qe=n;function d(b){return F.$2d(v=>E.concat(v),b)}e.$re=d;function l(b,v){return F.$_d(b,v,C=>E.concat(C))}e.$se=l;function a(b,v){return F.$ae(b,v,C=>E.concat(C))}e.$te=a;function h(b){let v=0,C=0,N=0;const T=new Uint8Array(Math.floor(b.length/4*3)),M=j=>{switch(C){case 3:T[N++]=v|j,C=0;break;case 2:T[N++]=v|j>>>2,v=j<<6,C=3;break;case 1:T[N++]=v|j>>>4,v=j<<4,C=2;break;default:v=j<<2,C=1}};for(let j=0;j<b.length;j++){const O=b.charCodeAt(j);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${b[j]}`)}}const U=N;for(;C>0;)M(0);return E.wrap(T).slice(0,U)}e.$ue=h;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:b},v=!0,C=!1){const N=C?k:S;let T="";const M=b.byteLength%3;let U=0;for(;U<b.byteLength-M;U+=3){const j=b[U+0],O=b[U+1],V=b[U+2];T+=N[j>>>2],T+=N[(j<<4|O>>>4)&63],T+=N[(O<<2|V>>>6)&63],T+=N[V&63]}if(M===1){const j=b[U+0];T+=N[j>>>2],T+=N[j<<4&63],v&&(T+="==")}else if(M===2){const j=b[U+0],O=b[U+1];T+=N[j>>>2],T+=N[(j<<4|O>>>4)&63],T+=N[O<<2&63],v&&(T+="=")}return T}e.$ve=$}),define(Se[13],De([1,0,161,47]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Be=f;const L=/{(\d+)}/g;function R(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(L,function(qe,Re){const Ze=parseInt(Re,10);return isNaN(Ze)||Ze<0||Ze>=Ne.length?qe:Ne[Ze]})}e.$Ce=R;const p=/{([^}]+)}/g;function E(Ae,Ne){return Object.keys(Ne).length===0?Ae:Ae.replace(p,(qe,Re)=>Ne[Re]??qe)}e.$De=E;function m(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ee=m;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=A;function P(Ae,Ne){let qe=0;const Re=Ne.charCodeAt(0);for(let Ze=Ae.length-1;Ze>=0;Ze--)Ae.charCodeAt(Ze)===Re&&qe++;return qe}e.$Ge=P;function g(Ae,Ne,qe="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${qe}`}e.$He=g;function y(Ae,Ne=" "){const qe=D(Ae,Ne);return w(qe,Ne)}e.$Ie=y;function D(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length;if(qe===0||Ae.length===0)return Ae;let Re=0;for(;Ae.indexOf(Ne,Re)===Re;)Re=Re+qe;return Ae.substring(Re)}e.$Je=D;function w(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length,Re=Ae.length;if(qe===0||Re===0)return Ae;let Ze=Re,he=-1;for(;he=Ae.lastIndexOf(Ne,Ze-1),!(he===-1||he+qe!==Ze);){if(he===0)return"";Ze=he}return Ae.substring(0,Ze)}e.$Ke=w;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=u;function c(Ae){return Ae.replace(/\*/g,"")}e.$Me=c;function i(Ae,Ne,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=A(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Re="";return qe.global&&(Re+="g"),qe.matchCase||(Re+="i"),qe.multiline&&(Re+="m"),qe.unicode&&(Re+="u"),new RegExp(Ae,Re)}e.$Ne=i;function s(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Oe=s;function r(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Pe=r;function o(Ae){for(let Ne=0,qe=Ae.length;Ne<qe;Ne++){const Re=Ae.charCodeAt(Ne);if(Re!==32&&Re!==9)return Ne}return-1}e.$Qe=o;function t(Ae,Ne=0,qe=Ae.length){for(let Re=Ne;Re<qe;Re++){const Ze=Ae.charCodeAt(Re);if(Ze!==32&&Ze!==9)return Ae.substring(Ne,Re)}return Ae.substring(Ne,qe)}e.$Re=t;function n(Ae,Ne=Ae.length-1){for(let qe=Ne;qe>=0;qe--){const Re=Ae.charCodeAt(qe);if(Re!==32&&Re!==9)return qe}return-1}e.$Se=n;function d(Ae,Ne,qe){const Re=[];let Ze=0;for(const he of Ae.matchAll(Ne)){if(Re.push(Ae.slice(Ze,he.index)),he.index===void 0)throw new Error("match.index should be defined");Ze=he.index+he[0].length,Re.push(qe(he[0],...he.slice(1),he.index,Ae,he.groups))}return Re.push(Ae.slice(Ze)),Promise.all(Re).then(he=>he.join(""))}e.$Te=d;function l(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ue=l;function a(Ae,Ne,qe=0,Re=Ae.length,Ze=0,he=Ne.length){for(;qe<Re&&Ze<he;qe++,Ze++){const Ke=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Ze);if(Ke<ze)return-1;if(Ke>ze)return 1}const le=Re-qe,Ie=he-Ze;return le<Ie?-1:le>Ie?1:0}e.$Ve=a;function h(Ae,Ne){return S(Ae,Ne,0,Ae.length,0,Ne.length)}e.$We=h;function S(Ae,Ne,qe=0,Re=Ae.length,Ze=0,he=Ne.length){for(;qe<Re&&Ze<he;qe++,Ze++){let Ke=Ae.charCodeAt(qe),ze=Ne.charCodeAt(Ze);if(Ke===ze)continue;if(Ke>=128||ze>=128)return a(Ae.toLowerCase(),Ne.toLowerCase(),qe,Re,Ze,he);$(Ke)&&(Ke-=32),$(ze)&&(ze-=32);const Ye=Ke-ze;if(Ye!==0)return Ye}const le=Re-qe,Ie=he-Ze;return le<Ie?-1:le>Ie?1:0}e.$Xe=S;function k(Ae){return Ae>=48&&Ae<=57}e.$Ye=k;function $(Ae){return Ae>=97&&Ae<=122}e.$Ze=$;function b(Ae){return Ae>=65&&Ae<=90}e.$1e=b;function v(Ae,Ne){return Ae.length===Ne.length&&S(Ae,Ne)===0}e.$2e=v;function C(Ae,Ne){const qe=Ne.length;return Ne.length>Ae.length?!1:S(Ae,Ne,0,qe)===0}e.$3e=C;function N(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Re;for(Re=0;Re<qe;Re++)if(Ae.charCodeAt(Re)!==Ne.charCodeAt(Re))return Re;return qe}e.$4e=N;function T(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Re;const Ze=Ae.length-1,he=Ne.length-1;for(Re=0;Re<qe;Re++)if(Ae.charCodeAt(Ze-Re)!==Ne.charCodeAt(he-Re))return Re;return qe}e.$5e=T;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$6e=M;function U(Ae){return 56320<=Ae&&Ae<=57343}e.$7e=U;function j(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$8e=j;function O(Ae,Ne,qe){const Re=Ae.charCodeAt(qe);if(M(Re)&&qe+1<Ne){const Ze=Ae.charCodeAt(qe+1);if(U(Ze))return j(Re,Ze)}return Re}e.$9e=O;function V(Ae,Ne){const qe=Ae.charCodeAt(Ne-1);if(U(qe)&&Ne>1){const Re=Ae.charCodeAt(Ne-2);if(M(Re))return j(Re,qe)}return qe}class q{get offset(){return this.e}constructor(Ne,qe=0){this.c=Ne,this.d=Ne.length,this.e=qe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=V(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=O(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$0e=q;class de{get offset(){return this.c.offset}constructor(Ne,qe=0){this.c=new q(Ne,qe)}nextGraphemeLength(){const Ne=me.getInstance(),qe=this.c,Re=qe.offset;let Ze=Ne.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,le=Ne.getGraphemeBreakType(qe.nextCodePoint());if(oe(Ze,le)){qe.setOffset(he);break}Ze=le}return qe.offset-Re}prevGraphemeLength(){const Ne=me.getInstance(),qe=this.c,Re=qe.offset;let Ze=Ne.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,le=Ne.getGraphemeBreakType(qe.prevCodePoint());if(oe(le,Ze)){qe.setOffset(he);break}Ze=le}return Re-qe.offset}eol(){return this.c.eol()}}e.$$e=de;function x(Ae,Ne){return new de(Ae,Ne).nextGraphemeLength()}e.$_e=x;function Q(Ae,Ne){return new de(Ae,Ne).prevGraphemeLength()}e.$af=Q;function G(Ae,Ne){Ne>0&&U(Ae.charCodeAt(Ne))&&Ne--;const qe=Ne+x(Ae,Ne);return[qe-Q(Ae,qe),qe]}e.$bf=G;function ce(Ae){const Ne=new de(Ae);let qe=0;for(;!Ne.eol();)qe++,Ne.nextGraphemeLength();return qe}e.$cf=ce;let ie;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(Ae){return ie||(ie=ae()),ie.test(Ae)}e.$df=ye;const H=/^[\t\n\r\x20-\x7E]*$/;function z(Ae){return H.test(Ae)}e.$ef=z,e.$ff=/[\u2028\u2029]/;function X(Ae){return e.$ff.test(Ae)}e.$gf=X;function re(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$hf=re;function Z(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$if=Z;function ee(Ae,Ne){if(Ae.length<Ne)return Ae;const qe=/\b/g;let Re=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Ne);)Re=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Re).replace(/^\s/,"")}e.$jf=ee;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,we=/\x1b\].*?\x07/g;function ue(Ae){return Ae&&(Ae=Ae.replace(_,"").replace(we,"")),Ae}e.$kf=ue,e.$lf=String.fromCharCode(65279);function ge(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$mf=ge;function te(Ae){return ge(Ae)?Ae.substr(1):Ae}e.$nf=te;function fe(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const qe=Ne.length,Re=Ae.toLowerCase();let Ze=0,he=-1;for(;Ze<qe;){const le=Re.indexOf(Ne[Ze],he+1);if(le<0)return!1;he=le,Ze++}return!0}e.$of=fe;function be(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$pf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$qf=Pe;function B(Ae,Ne=1){if(Ne===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Ne--;while(Ne>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$rf=B;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$sf=J;function se(Ae){return me.getInstance().getGraphemeBreakType(Ae)}e.$tf=se;function oe(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class me{static{this.c=null}static getInstance(){return me.c||(me.c=new me),me.c}constructor(){this.d=Ee()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const qe=this.d,Re=qe.length/3;let Ze=1;for(;Ze<=Re;)if(Ne<qe[3*Ze])Ze=2*Ze;else if(Ne>qe[3*Ze+1])Ze=2*Ze+1;else return qe[3*Ze+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const qe=We(Ae,Ne);if(qe!==void 0)return qe;const Re=new q(Ne,Ae);return Re.prevCodePoint(),Re.offset}e.$uf=je;function We(Ae,Ne){const qe=new q(Ne,Ae);let Re=qe.prevCodePoint();for(;_e(Re)||Re===65039||Re===8419;){if(qe.offset===0)return;Re=qe.prevCodePoint()}if(!Z(Re))return;let Ze=qe.offset;return Ze>0&&qe.prevCodePoint()===8205&&(Ze=qe.offset),Ze}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Xe;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$vf="\xA0";class it{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$xe(Ne=>{function qe(Ye){const nt=new Map;for(let ct=0;ct<Ye.length;ct+=2)nt.set(Ye[ct],Ye[ct+1]);return nt}function Re(Ye,nt){const ct=new Map(Ye);for(const[bt,Et]of nt)ct.set(bt,Et);return ct}function Ze(Ye,nt){if(!Ye)return nt;const ct=new Map;for(const[bt,Et]of Ye)nt.has(bt)&&ct.set(bt,Et);return ct}const he=this.c.value;let le=Ne.filter(Ye=>!Ye.startsWith("_")&&Ye in he);le.length===0&&(le=["_default"]);let Ie;for(const Ye of le){const nt=qe(he[Ye]);Ie=Ze(Ie,nt)}const Ke=qe(he._common),ze=Re(Ke,Ie);return new it(ze)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new F.$U(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=it;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Ne){return tt.e().has(Ne)}static get codePoints(){return tt.e()}}e.$xf=tt}),define(Se[123],De([1,0,28,13]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function f(...te){return function(fe,be){for(let Pe=0,B=te.length;Pe<B;Pe++){const J=te[Pe](fe,be);if(J)return J}return null}}e.or=f,e.$Cj=L.bind(void 0,!1),e.$Dj=L.bind(void 0,!0);function L(te,fe,be){if(!be||be.length<fe.length)return null;let Pe;return te?Pe=F.$3e(be,fe):Pe=be.indexOf(fe)===0,Pe?fe.length>0?[{start:0,end:fe.length}]:[]:null}function R(te,fe){const be=fe.toLowerCase().indexOf(te.toLowerCase());return be===-1?null:[{start:be,end:be+te.length}]}e.$Ej=R;function p(te,fe){return E(te.toLowerCase(),fe.toLowerCase(),0,0)}e.$Fj=p;function E(te,fe,be,Pe){if(be===te.length)return[];if(Pe===fe.length)return null;if(te[be]===fe[Pe]){let B=null;return(B=E(te,fe,be+1,Pe+1))?c({start:Pe,end:Pe+1},B):null}return E(te,fe,be,Pe+1)}function m(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Gj=A;function P(te){return 48<=te&&te<=57}function g(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function D(te){return g(te)||y.has(te)}function w(te,fe){return te===fe||D(te)&&D(fe)}function u(te){return m(te)||A(te)||P(te)}function c(te,fe){return fe.length===0?fe=[te]:te.end===fe[0].start?fe[0].start=te.start:fe.unshift(te),fe}function i(te,fe){for(let be=fe;be<te.length;be++){const Pe=te.charCodeAt(be);if(A(Pe)||P(Pe)||be>0&&!u(te.charCodeAt(be-1)))return be}return te.length}function s(te,fe,be,Pe){if(be===te.length)return[];if(Pe===fe.length)return null;if(te[be]!==fe[Pe].toLowerCase())return null;{let B=null,J=Pe+1;for(B=s(te,fe,be+1,Pe+1);!B&&(J=i(fe,J))<fe.length;)B=s(te,fe,be+1,J),J++;return B===null?null:c({start:Pe,end:Pe+1},B)}}function r(te){let fe=0,be=0,Pe=0,B=0,J=0;for(let Ee=0;Ee<te.length;Ee++)J=te.charCodeAt(Ee),A(J)&&fe++,m(J)&&be++,u(J)&&Pe++,P(J)&&B++;const se=fe/te.length,oe=be/te.length,Y=Pe/te.length,me=B/te.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:Y,numericPercent:me}}function o(te){const{upperPercent:fe,lowerPercent:be}=te;return be===0&&fe>.6}function t(te){const{upperPercent:fe,lowerPercent:be,alphaPercent:Pe,numericPercent:B}=te;return be>.2&&fe<.8&&Pe>.6&&B<.2}function n(te){let fe=0,be=0,Pe=0,B=0;for(let J=0;J<te.length;J++)Pe=te.charCodeAt(J),A(Pe)&&fe++,m(Pe)&&be++,g(Pe)&&B++;return(fe===0||be===0)&&B===0?te.length<=30:fe<=5}function d(te,fe){if(!fe||(fe=fe.trim(),fe.length===0)||!n(te)||fe.length>60)return null;const be=r(fe);if(!t(be)){if(!o(be))return null;fe=fe.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<fe.length&&(Pe=s(te,fe,0,B))===null;)B=i(fe,B+1);return Pe}e.$Hj=d;function l(te,fe,be=!1){if(!fe||fe.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),fe=fe.toLowerCase();B<fe.length&&(Pe=a(te,fe,0,B,be))===null;)B=h(fe,B+1);return Pe}e.$Ij=l;function a(te,fe,be,Pe,B){if(be===te.length)return[];if(Pe===fe.length)return null;if(w(te.charCodeAt(be),fe.charCodeAt(Pe))){let J=null,se=Pe+1;if(J=a(te,fe,be+1,Pe+1,B),!B)for(;!J&&(se=h(fe,se))<fe.length;)J=a(te,fe,be+1,se,B),se++;return J?te.charCodeAt(be)!==fe.charCodeAt(Pe)?J:c({start:Pe,end:Pe+1},J):null}else return null}function h(te,fe){for(let be=fe;be<te.length;be++)if(D(te.charCodeAt(be))||be>0&&D(te.charCodeAt(be-1)))return be;return te.length}const S=f(e.$Dj,d,R),k=f(e.$Dj,d,p),$=new I.$Cc(1e4);function b(te,fe,be=!1){if(typeof te!="string"||typeof fe!="string")return null;let Pe=$.get(te);Pe||(Pe=new RegExp(F.$Le(te),"i"),$.set(te,Pe));const B=Pe.exec(fe);return B?[{start:B.index,end:B.index+B[0].length}]:be?k(te,fe):S(te,fe)}e.$Jj=b;function v(te,fe){const be=re(te,te.toLowerCase(),0,fe,fe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Kj=v;function C(te,fe,be,Pe,B,J){const se=Math.min(13,te.length);for(;be<se;be++){const oe=re(te,fe,be,Pe,B,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,J]}e.$Lj=C;function N(te){if(typeof te>"u")return[];const fe=[],be=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+be,J=fe[fe.length-1];J&&J.end===B?J.end=B+1:fe.push({start:B,end:B+1})}return fe}e.$Mj=N;const T=128;function M(){const te=[],fe=[];for(let be=0;be<=T;be++)fe[be]=0;for(let be=0;be<=T;be++)te.push(fe.slice(0));return te}function U(te){const fe=[];for(let be=0;be<=te;be++)fe[be]=0;return fe}const j=U(2*T),O=U(2*T),V=M(),q=M(),de=M(),x=!1;function Q(te,fe,be,Pe,B){function J(oe,Y,me=" "){for(;oe.length<Y;)oe=me+oe;return oe}let se=` |   |${Pe.split("").map(oe=>J(oe,3)).join("|")}
`;for(let oe=0;oe<=be;oe++)oe===0?se+=" |":se+=`${fe[oe-1]}|`,se+=te[oe].slice(0,B+1).map(Y=>J(Y.toString(),3)).join("|")+`
`;return se}function G(te,fe,be,Pe){te=te.substr(fe),be=be.substr(Pe),console.log(Q(q,te,te.length,be,be.length)),console.log(Q(de,te,te.length,be,be.length)),console.log(Q(V,te,te.length,be,be.length))}function ce(te,fe){if(fe<0||fe>=te.length)return!1;const be=te.codePointAt(fe);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$if(be)}}function ie(te,fe){if(fe<0||fe>=te.length)return!1;switch(te.charCodeAt(fe)){case 32:case 9:return!0;default:return!1}}function ae(te,fe,be){return fe[te]!==be[te]}function ye(te,fe,be,Pe,B,J,se=!1){for(;fe<be&&B<J;)te[fe]===Pe[B]&&(se&&(j[fe]=B),fe+=1),B+=1;return fe===be}e.$Nj=ye;var H;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(H||(H={}));var z;(function(te){te.Default=[-100,0];function fe(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}te.isDefault=fe})(z||(e.FuzzyScore=z={}));class X{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(fe,be){this.firstMatchCanBeWeak=fe,this.boostFullMatch=be}}e.$Oj=X;function re(te,fe,be,Pe,B,J,se=X.default){const oe=te.length>T?T:te.length,Y=Pe.length>T?T:Pe.length;if(be>=oe||J>=Y||oe-be>Y-J||!ye(fe,be,oe,B,J,Y,!0))return;Z(oe,Y,be,J,fe,B);let me=1,Ee=1,je=be,We=J;const _e=[!1];for(me=1,je=be;je<oe;me++,je++){const Ne=j[je],qe=O[je],Re=je+1<oe?O[je+1]:Y;for(Ee=Ne-J+1,We=Ne;We<Re;Ee++,We++){let Ze=Number.MIN_SAFE_INTEGER,he=!1;We<=qe&&(Ze=ee(te,fe,je,be,Pe,B,We,Y,J,V[me-1][Ee-1]===0,_e));let le=0;Ze!==Number.MAX_SAFE_INTEGER&&(he=!0,le=Ze+q[me-1][Ee-1]);const Ie=We>Ne,Ke=Ie?q[me][Ee-1]+(V[me][Ee-1]>0?-5:0):0,ze=We>Ne+1&&V[me][Ee-1]>0,Ye=ze?q[me][Ee-2]+(V[me][Ee-2]>0?-5:0):0;if(ze&&(!Ie||Ye>=Ke)&&(!he||Ye>=le))q[me][Ee]=Ye,de[me][Ee]=3,V[me][Ee]=0;else if(Ie&&(!he||Ke>=le))q[me][Ee]=Ke,de[me][Ee]=2,V[me][Ee]=0;else if(he)q[me][Ee]=le,de[me][Ee]=1,V[me][Ee]=V[me-1][Ee-1]+1;else throw new Error("not possible")}}if(x&&G(te,be,Pe,J),!_e[0]&&!se.firstMatchCanBeWeak)return;me--,Ee--;const Xe=[q[me][Ee],J];let it=0,tt=0;for(;me>=1;){let Ne=Ee;do{const qe=de[me][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&fe[be+me-1]===B[J+Ee-1]&&!ae(Ne+J-1,Pe,B)&&it+1>V[me][Ne]&&(Ne=Ee),Ne===Ee?it++:it=1,tt||(tt=Ne),me--,Ee=Ne-1,Xe.push(Ee)}Y===oe&&se.boostFullMatch&&(Xe[0]+=2);const Ae=tt-oe;return Xe[0]-=Ae,Xe}e.$Pj=re;function Z(te,fe,be,Pe,B,J){let se=te-1,oe=fe-1;for(;se>=be&&oe>=Pe;)B[se]===J[oe]&&(O[se]=oe,se--),oe--}function ee(te,fe,be,Pe,B,J,se,oe,Y,me,Ee){if(fe[be]!==J[se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return se===be-Pe?je=te[be]===B[se]?7:5:ae(se,B,J)&&(se===0||!ae(se-1,B,J))?(je=te[be]===B[se]?7:5,We=!0):ce(J,se)&&(se===0||!ce(J,se-1))?je=5:(ce(J,se-1)||ie(J,se-1))&&(je=5,We=!0),je>1&&be===Pe&&(Ee[0]=!0),We||(We=ae(se,B,J)||ce(J,se-1)||ie(J,se-1)),be===Pe?se>Y&&(je-=We?3:5):me?je+=We?2:0:je+=We?0:1,se+1===oe&&(je-=We?3:5),je}function _(te,fe,be,Pe,B,J,se){return ue(te,fe,be,Pe,B,J,!0,se)}e.$Qj=_;function we(te,fe,be,Pe,B,J,se){return ue(te,fe,be,Pe,B,J,!1,se)}e.$Rj=we;function ue(te,fe,be,Pe,B,J,se,oe){let Y=re(te,fe,be,Pe,B,J,oe);if(Y&&!se)return Y;if(te.length>=3){const me=Math.min(7,te.length-1);for(let Ee=be+1;Ee<me;Ee++){const je=ge(te,Ee);if(je){const We=re(je,je.toLowerCase(),be,Pe,B,J,oe);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function ge(te,fe){if(fe+1>=te.length)return;const be=te[fe],Pe=te[fe+1];if(be!==Pe)return te.slice(0,fe)+Pe+be+te.slice(fe+2)}}),define(Se[52],De([1,0,13]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function F(c){return f(c,0)}e.$Di=F;function f(c,i){switch(typeof c){case"object":return c===null?L(349,i):Array.isArray(c)?E(c,i):m(c,i);case"string":return p(c,i);case"boolean":return R(c,i);case"number":return L(c,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Ei=f;function L(c,i){return(i<<5)-i+c|0}e.$Fi=L;function R(c,i){return L(c?433:863,i)}function p(c,i){i=L(149417,i);for(let s=0,r=c.length;s<r;s++)i=L(c.charCodeAt(s),i);return i}e.$Gi=p;function E(c,i){return i=L(104579,i),c.reduce((s,r)=>f(r,s),i)}function m(c,i){return i=L(181387,i),Object.keys(c).sort().reduce((s,r)=>(s=p(r,s),f(c[r],s)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Hi=A;var P;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function g(c,i,s=32){const r=s-i,o=~((1<<r)-1);return(c<<i|(o&c)>>>r)>>>0}function y(c,i=0,s=c.byteLength,r=0){for(let o=0;o<s;o++)c[i+o]=r}function D(c,i,s="0"){for(;c.length<i;)c=s+c;return c}function w(c,i=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(s=>s.toString(16).padStart(2,"0")).join(""):D((c>>>0).toString(16),i/4)}e.$Ii=w;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const s=i.length;if(s===0)return;const r=this.p;let o=this.r,t=this.u,n,d;for(t!==0?(n=t,d=-1,t=0):(n=i.charCodeAt(0),d=0);;){let l=n;if(I.$6e(n))if(d+1<s){const a=i.charCodeAt(d+1);I.$7e(a)?(d++,l=I.$8e(n,a)):l=65533}else{t=n;break}else I.$7e(n)&&(l=65533);if(o=this.w(r,o,l),d++,d<s)n=i.charCodeAt(d);else break}this.r=o,this.u=t}w(i,s,r){return r<128?i[s++]=r:r<2048?(i[s++]=192|(r&1984)>>>6,i[s++]=128|(r&63)>>>0):r<65536?(i[s++]=224|(r&61440)>>>12,i[s++]=128|(r&4032)>>>6,i[s++]=128|(r&63)>>>0):(i[s++]=240|(r&1835008)>>>18,i[s++]=128|(r&258048)>>>12,i[s++]=128|(r&4032)>>>6,i[s++]=128|(r&63)>>>0),s>=64&&(this.y(),s-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),s}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=u.g,s=this.q;for(let S=0;S<64;S+=4)i.setUint32(S,s.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)i.setUint32(S,g(i.getUint32(S-12,!1)^i.getUint32(S-32,!1)^i.getUint32(S-56,!1)^i.getUint32(S-64,!1),1),!1);let r=this.h,o=this.l,t=this.m,n=this.n,d=this.o,l,a,h;for(let S=0;S<80;S++)S<20?(l=o&t|~o&n,a=1518500249):S<40?(l=o^t^n,a=1859775393):S<60?(l=o&t|o&n|t&n,a=2400959708):(l=o^t^n,a=3395469782),h=g(r,5)+l+d+a+i.getUint32(S*4,!1)&4294967295,d=n,n=t,t=g(o,30),o=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$Ji=u}),define(Se[38],De([1,0,13]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const L="error",R="warning",p="warn",E="info",m="ignore";function A(g){return g?I.$2e(L,g)?f.Error:I.$2e(R,g)||I.$2e(p,g)?f.Warning:I.$2e(E,g)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function P(g){switch(g){case f.Error:return L;case f.Warning:return R;case f.Info:return E;default:return m}}f.toString=P}(F||(F={})),e.default=F}),define(Se[162],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,13]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class f{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const D=y.charCodeAt(0),w=this.b.charCodeAt(this.c);return D-w}value(){return this.b[this.c]}}e.$Rh=f;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$Ve)(y,this.b,0,y.length,this.c,this.d):(0,F.$Xe)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=L;class R{constructor(y=!0,D=!0){this.f=y,this.g=D}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let D=y.length-1;D>=0;D--,this.c--){const w=this.b.charCodeAt(D);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$Ve)(y,this.b,0,y.length,this.d,this.e):(0,F.$Xe)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=R;var p;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(p||(p={}));class E{constructor(y,D){this.f=y,this.g=D,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$We)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$We)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Ue)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Ue)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=E;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(A||(A={}));class P{static forUris(y=()=>!1,D=()=>!1){return new P(new E(y,D))}static forPaths(y=!1){return new P(new R(void 0,!y))}static forStrings(){return new P(new f)}static forConfigKeys(){return new P(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,D){if(D){const w=D.slice(0);(0,I.$Wb)(w);for(const u of w)this.set(u,y)}else{const w=y.slice(0);(0,I.$Wb)(w);for(const u of w)this.set(u[0],u[1])}}set(y,D){const w=this.b.reset(y);let u;this.c||(this.c=new m,this.c.segment=w.value());const c=[];for(u=this.c;;){const s=w.cmp(u.segment);if(s>0)u.left||(u.left=new m,u.left.segment=w.value()),c.push([-1,u]),u=u.left;else if(s<0)u.right||(u.right=new m,u.right.segment=w.value()),c.push([1,u]),u=u.right;else if(w.hasNext())w.next(),u.mid||(u.mid=new m,u.mid.segment=w.value()),c.push([0,u]),u=u.mid;else break}const i=u.value;u.value=D,u.key=y;for(let s=c.length-1;s>=0;s--){const r=c[s][1];r.updateHeight();const o=r.balanceFactor();if(o<-1||o>1){const t=c[s][0],n=c[s+1][0];if(t===1&&n===1)c[s][1]=r.rotateLeft();else if(t===-1&&n===-1)c[s][1]=r.rotateRight();else if(t===1&&n===-1)r.right=c[s+1][1]=c[s+1][1].rotateRight(),c[s][1]=r.rotateLeft();else if(t===-1&&n===1)r.left=c[s+1][1]=c[s+1][1].rotateLeft(),c[s][1]=r.rotateRight();else throw new Error;if(s>0)switch(c[s-1][0]){case-1:c[s-1][1].left=c[s][1];break;case 1:c[s-1][1].right=c[s][1];break;case 0:c[s-1][1].mid=c[s][1];break}else this.c=c[0][1]}}return i}get(y){return this.d(y)?.value}d(y){const D=this.b.reset(y);let w=this.c;for(;w;){const u=D.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(D.hasNext())D.next(),w=w.mid;else break}return w}has(y){const D=this.d(y);return!(D?.value===void 0&&D?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,D){const w=this.b.reset(y),u=[];let c=this.c;for(;c;){const i=w.cmp(c.segment);if(i>0)u.push([-1,c]),c=c.left;else if(i<0)u.push([1,c]),c=c.right;else if(w.hasNext())w.next(),u.push([0,c]),c=c.mid;else break}if(c){if(D?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const i=this.f(c.right);if(i.key){const{key:s,value:r,segment:o}=i;this.e(i.key,!1),c.key=s,c.value=r,c.segment=o}}else{const i=c.left??c.right;if(u.length>0){const[s,r]=u[u.length-1];switch(s){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=u.length-1;i>=0;i--){const s=u[i][1];s.updateHeight();const r=s.balanceFactor();if(r>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),u[i][1]=s.rotateLeft()):r<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),u[i][1]=s.rotateRight()),i>0)switch(u[i-1][0]){case-1:u[i-1][1].left=u[i][1];break;case 1:u[i-1][1].right=u[i][1];break;case 0:u[i-1][1].mid=u[i][1];break}else this.c=u[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const D=this.b.reset(y);let w=this.c,u;for(;w;){const c=D.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(D.hasNext())D.next(),u=w.value||u,w=w.mid;else break}return w&&w.value||u}findSuperstr(y){return this.g(y,!1)}g(y,D){const w=this.b.reset(y);let u=this.c;for(;u;){const c=w.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(w.hasNext())w.next(),u=u.mid;else return u.mid?this.h(u.mid):D?u.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[D,w]of this)y(w,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const D=[];return this.j(y,D),D[Symbol.iterator]()}j(y,D){y&&(y.left&&this.j(y.left,D),y.value&&D.push([y.key,y.value]),y.mid&&this.j(y.mid,D),y.right&&this.j(y.right,D))}_isBalanced(){const y=D=>{if(!D)return!0;const w=D.balanceFactor();return w<-1||w>1?!1:y(D.left)&&y(D.right)};return y(this.c)}}e.$Vh=P}),define(Se[17],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function I(o){return typeof o=="string"}e.$yf=I;function F(o){return Array.isArray(o)&&o.every(t=>I(t))}e.$zf=F;function f(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$Af=f;function L(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.$Bf=L;function R(o){return typeof o=="number"&&!isNaN(o)}e.$Cf=R;function p(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$Df=p;function E(o){return o===!0||o===!1}e.$Ef=E;function m(o){return typeof o>"u"}e.$Ff=m;function A(o){return!P(o)}e.$Gf=A;function P(o){return m(o)||o===null}e.$Hf=P;function g(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$If=g;function y(o){if(P(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$Jf=y;function D(...o){const t=[];for(let n=0;n<o.length;n++){const d=o[n];if(P(d))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(d)}return t}e.$Kf=D;const w=Object.prototype.hasOwnProperty;function u(o){if(!f(o))return!1;for(const t in o)if(w.call(o,t))return!1;return!0}e.$Lf=u;function c(o){return typeof o=="function"}e.$Mf=c;function i(...o){return o.length>0&&o.every(c)}e.$Nf=i;function s(o,t){const n=Math.min(o.length,t.length);for(let d=0;d<n;d++)r(o[d],t[d])}e.$Of=s;function r(o,t){if(I(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(o instanceof t)return}catch{}if(!P(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=r}),define(Se[79],De([1,0,17]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const F=Object.create(null);function f(p,E){if((0,I.$yf)(E)){const m=F[E];if(m===void 0)throw new Error(`${p} references an unknown codicon: ${E}`);E=m}return F[p]=E,{id:p}}function L(){return F}e.$Sj=L;function R(){return Object.values(e.$Uj)}e.$Tj=R,e.$Uj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(Se[24],De([1,0,17]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function F(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const o=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([t,n])=>{o[t]=n&&typeof n=="object"?F(n):n}),o}e.$7m=F;function f(r){if(!r||typeof r!="object")return r;const o=[r];for(;o.length>0;){const t=o.shift();Object.freeze(t);for(const n in t)if(L.call(t,n)){const d=t[n];typeof d=="object"&&!Object.isFrozen(d)&&!(0,I.$Bf)(d)&&o.push(d)}}return r}e.$8m=f;const L=Object.prototype.hasOwnProperty;function R(r,o){return p(r,o,new Set)}e.$9m=R;function p(r,o,t){if((0,I.$Hf)(r))return r;const n=o(r);if(typeof n<"u")return n;if(Array.isArray(r)){const d=[];for(const l of r)d.push(p(l,o,t));return d}if((0,I.$Af)(r)){if(t.has(r))throw new Error("Cannot clone recursive data-structure");t.add(r);const d={};for(const l in r)L.call(r,l)&&(d[l]=p(r[l],o,t));return t.delete(r),d}return r}function E(r,o,t=!0){return(0,I.$Af)(r)?((0,I.$Af)(o)&&Object.keys(o).forEach(n=>{n in r?t&&((0,I.$Af)(r[n])&&(0,I.$Af)(o[n])?E(r[n],o[n],t):r[n]=o[n]):r[n]=o[n]}),r):o}e.$0m=E;function m(r,o){if(r===o)return!0;if(r==null||o===null||o===void 0||typeof r!=typeof o||typeof r!="object"||Array.isArray(r)!==Array.isArray(o))return!1;let t,n;if(Array.isArray(r)){if(r.length!==o.length)return!1;for(t=0;t<r.length;t++)if(!m(r[t],o[t]))return!1}else{const d=[];for(n in r)d.push(n);d.sort();const l=[];for(n in o)l.push(n);if(l.sort(),!m(d,l))return!1;for(t=0;t<d.length;t++)if(!m(r[d[t]],o[d[t]]))return!1}return!0}e.$$m=m;function A(r){const o=new Set;return JSON.stringify(r,(t,n)=>{if((0,I.$Af)(n)||Array.isArray(n)){if(o.has(n))return"[Circular]";o.add(n)}return n})}e.$_m=A;function P(r,o){const t=Object.create(null);return!r||!o||Object.keys(o).forEach(d=>{const l=r[d],a=o[d];m(l,a)||(t[d]=a)}),t}e.$an=P;function g(r,o){const t=o.toLowerCase(),n=Object.keys(r).find(d=>d.toLowerCase()===t);return n?r[n]:r[o]}e.$bn=g;function y(r,o){const t=Object.create(null);for(const[n,d]of Object.entries(r))o(n,d)&&(t[n]=d);return t}e.$cn=y;function D(r){let o=[];for(;Object.prototype!==r;)o=o.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return o}e.$dn=D;function w(r){const o=[];for(const t of D(r))typeof r[t]=="function"&&o.push(t);return o}e.$en=w;function u(r,o){const t=d=>function(){const l=Array.prototype.slice.call(arguments,0);return o(d,l)},n={};for(const d of r)n[d]=t(d);return n}e.$fn=u;function c(r,o,t){typeof o=="string"&&r[o]!==void 0&&typeof r[o]!="boolean"&&(r[o]=t)}e.$gn=c;function i(r,o,t){typeof o=="string"&&r[o]!==void 0&&typeof r[o]!="number"&&(r[o]=t)}e.$hn=i;function s(r,o,t,n){if(typeof o!="string")return;const d=r[o];d!==void 0&&(typeof d!="string"||!t.includes(d))&&(r[o]=n)}e.$in=s}),define(Se[61],De([1,0,79]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var F;(function(R){function p(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=p})(F||(e.ThemeColor=F={}));function f(R){return{id:R}}e.$Vj=f;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(i){const s=p.exec(i.id);if(!s)return E(I.$Uj.error);const[,r,o]=s,t=["codicon","codicon-"+r];return o&&t.push("codicon-modifier-"+o.substring(1)),t}R.asClassNameArray=E;function m(i){return E(i).join(" ")}R.asClassName=m;function A(i){return"."+E(i).join(".")}R.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}R.isThemeIcon=P;const g=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function y(i){const s=g.exec(i);if(!s)return;const[,r]=s;return{id:r}}R.fromString=y;function D(i){return{id:i}}R.fromId=D;function w(i,s){let r=i.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),s&&(r=`${r}~${s}`),{id:r}}R.modify=w;function u(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}R.getModifier=u;function c(i,s){return i.id===s.id&&i.color?.id===s.color?.id}R.isEqual=c})(L||(e.ThemeIcon=L={}))}),define(Se[163],De([1,0,123,13,61]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const L="$(",R=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function E(c){return c.replace(p,(i,s)=>s?i:`\\${i}`)}e.$Wj=E;const m=new RegExp(`\\\\${R.source}`,"g");function A(c){return c.replace(m,i=>`\\${i}`)}e.$Xj=A;const P=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function g(c){return c.indexOf(L)===-1?c:c.replace(P,(i,s,r,o)=>r?i:s||o||"")}e.$Yj=g;function y(c){return c?c.replace(/\$\((.*?)\)/g,(i,s)=>` ${s} `).trim():""}e.$Zj=y;const D=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(c){D.lastIndex=0;let i="";const s=[];let r=0;for(;;){const o=D.lastIndex,t=D.exec(c),n=c.substring(o,t?.index);if(n.length>0){i+=n;for(let d=0;d<n.length;d++)s.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:s}}e.$1j=w;function u(c,i,s=!1){const{text:r,iconOffsets:o}=i;if(!o||o.length===0)return(0,I.$Jj)(c,r,s);const t=(0,F.$Je)(r," "),n=r.length-t.length,d=(0,I.$Jj)(c,t,s);if(d)for(const l of d){const a=o[l.start+n]+n;l.start+=a,l.end+=a}return d}e.$2j=u}),define(Se[124],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.Constants=void 0;var I;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(L){return L<0?0:L>255?255:L|0}e.$ze=F;function f(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Ae=f}),define(Se[32],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return I.test(f)}e.$dg=F,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(p){for(let E=0;E<p.length;E++)p[E]=Math.floor(Math.random()*256);return p};const L=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){f(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,m="";return m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m}}()}),define(Se[164],De([1,0,19,51,32]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=e.$4s=e.$3s=e.$2s=void 0;function L(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$2s=L;function R(P,g,y){const D={id:(0,f.$eg)(),name:P,uri:g,data:y};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$3s=R;class p{constructor(){this.a=new Map}get size(){let g=0;for(const y of this.a)g++;return g}has(g){return this.a.has(this.b(g))}matches(g){const y=[...this.a.keys()];return F.Iterable.some(this,([D,w])=>w.asFile())&&y.push("files"),A(E(g),y)}get(g){return this.a.get(this.b(g))?.[0]}append(g,y){const D=this.a.get(g);D?D.push(y):this.a.set(this.b(g),[y])}replace(g,y){this.a.set(this.b(g),[y])}delete(g){this.a.delete(this.b(g))}*[Symbol.iterator](){for(const[g,y]of this.a)for(const D of y)yield[g,D]}b(g){return E(g)}}e.$4s=p;function E(P){return P.toLowerCase()}function m(P,g){return A(E(P),g.map(E))}e.$5s=m;function A(P,g){if(P==="*/*")return g.length>0;if(g.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[D,w,u]=y;return u==="*"?g.some(c=>c.startsWith(w+"/")):!1}e.$6s=Object.freeze({create:P=>(0,I.$Lb)(P.map(g=>g.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$6s.split(P).filter(g=>!g.startsWith("#"))})}),define(Se[165],De([1,0,62]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function F(p,E,m,A=1){let P=!1;return new Promise(g=>{const y=setTimeout(()=>{if(!P)return P=!0,g(0)},m);f(p,E,A,D=>{if(!P)return P=!0,clearTimeout(y),g(D)})})}e.$gg=F;function f(p,E,m,A){if(E===0)return A(0);const P=new I.Socket;P.once("connect",()=>(R(P),f(p+m,E-1,m,A))),P.once("data",()=>{}),P.once("error",g=>(R(P),g.code!=="ECONNREFUSED"?f(p+m,E-1,m,A):A(p))),P.connect(p,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(p,E,m,A="127.0.0.1"){let P=!1,g,y=1;const D=I.createServer({pauseOnConnect:!0});function w(u,c){P||(P=!0,D.removeAllListeners(),D.close(),g&&clearTimeout(g),c(u))}return new Promise(u=>{g=setTimeout(()=>{w(0,u)},m),D.on("listening",()=>{w(p,u)}),D.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&y<E?(p++,y++,D.listen(p,A)):w(0,u)}),D.on("close",()=>{w(0,u)}),D.listen(p,A)})}e.$ig=L;function R(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(E){console.error(E)}}}),define(Se[125],De([1,0,124]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=void 0;class F{constructor(p){const E=(0,I.$ze)(p);this.c=E,this.a=F.d(E),this.b=new Map}static d(p){const E=new Uint8Array(256);return E.fill(p),E}set(p,E){const m=(0,I.$ze)(E);p>=0&&p<256?this.a[p]=m:this.b.set(p,m)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ts=F;var f;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(f||(f={}));class L{constructor(){this.a=new F(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$Us=L}),define(Se[166],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.StringEOL=void 0;var I;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(f){let L=0,R=0,p=0,E=0;for(let m=0,A=f.length;m<A;m++){const P=f.charCodeAt(m);P===13?(L===0&&(R=m),L++,m+1<A&&f.charCodeAt(m+1)===10?(E|=2,m++):E|=3,p=m+1):P===10&&(E|=1,L===0&&(R=m),L++,p=m+1)}return L===0&&(R=f.length),[L,R,f.length-p,E]}e.$9s=F}),define(Se[53],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;class I{constructor(f,L){this.lineNumber=f,this.column=L}with(f=this.lineNumber,L=this.column){return f===this.lineNumber&&L===this.column?this:new I(f,L)}delta(f=0,L=0){return this.with(this.lineNumber+f,this.column+L)}equals(f){return I.equals(this,f)}static equals(f,L){return!f&&!L?!0:!!f&&!!L&&f.lineNumber===L.lineNumber&&f.column===L.column}isBefore(f){return I.isBefore(this,f)}static isBefore(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<L.column}isBeforeOrEqual(f){return I.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<=L.column}static compare(f,L){const R=f.lineNumber|0,p=L.lineNumber|0;if(R===p){const E=f.column|0,m=L.column|0;return E-m}return R-p}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new I(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$vs=I}),define(Se[29],De([1,0,53]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class F{constructor(L,R,p,E){L>p||L===p&&R>E?(this.startLineNumber=p,this.startColumn=E,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=p,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,R){let p,E,m,A;return R.startLineNumber<L.startLineNumber?(p=R.startLineNumber,E=R.startColumn):R.startLineNumber===L.startLineNumber?(p=R.startLineNumber,E=Math.min(R.startColumn,L.startColumn)):(p=L.startLineNumber,E=L.startColumn),R.endLineNumber>L.endLineNumber?(m=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(m=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(m=L.endLineNumber,A=L.endColumn),new F(p,E,m,A)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,R){let p=L.startLineNumber,E=L.startColumn,m=L.endLineNumber,A=L.endColumn;const P=R.startLineNumber,g=R.startColumn,y=R.endLineNumber,D=R.endColumn;return p<P?(p=P,E=g):p===P&&(E=Math.max(E,g)),m>y?(m=y,A=D):m===y&&(A=Math.min(A,D)),p>m||p===m&&E>A?null:new F(p,E,m,A)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new I.$vs(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new I.$vs(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new F(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new F(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new F(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const m=L.startLineNumber|0,A=R.startLineNumber|0;if(m===A){const P=L.startColumn|0,g=R.startColumn|0;if(P===g){const y=L.endLineNumber|0,D=R.endLineNumber|0;if(y===D){const w=L.endColumn|0,u=R.endColumn|0;return w-u}return y-D}return P-g}return m-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ws=F}),define(Se[167],De([1,0,29]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class F{static insert(L,R){return{range:new I.$ws(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$xs=F}),define(Se[168],De([1,0,53,29]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.SelectionDirection=void 0;var f;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class L extends F.$ws{constructor(p,E,m,A){super(p,E,m,A),this.selectionStartLineNumber=p,this.selectionStartColumn=E,this.positionLineNumber=m,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return L.selectionsEqual(this,p)}static selectionsEqual(p,E){return p.selectionStartLineNumber===E.selectionStartLineNumber&&p.selectionStartColumn===E.selectionStartColumn&&p.positionLineNumber===E.positionLineNumber&&p.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,p,E):new L(p,E,this.startLineNumber,this.startColumn)}getPosition(){return new I.$vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,E){return this.getDirection()===0?new L(p,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,p,E)}static fromPositions(p,E=p){return new L(p.lineNumber,p.column,E.lineNumber,E.column)}static fromRange(p,E){return E===0?new L(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new L(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new L(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,E){if(p&&!E||!p&&E)return!1;if(!p&&!E)return!0;if(p.length!==E.length)return!1;for(let m=0,A=p.length;m<A;m++)if(!this.selectionsEqual(p[m],E[m]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,E,m,A,P){return P===0?new L(p,E,m,A):new L(m,A,p,E)}}e.$ys=L}),define(Se[169],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0,e.$6r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[170],De([1,0,125]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends I.$Ts{constructor(p){super(0);for(let E=0,m=p.length;E<m;E++)this.set(p.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Vs=f;function L(R){const p={};return E=>(p.hasOwnProperty(E)||(p[E]=R(E)),p[E])}e.$Ws=L(R=>new f(R))}),define(Se[126],De([1,0,51,3,76]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=e.$7r=void 0,e.$7r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(P=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$7r)P.indexOf(y)>=0||(g+="\\"+y);return g+="\\s]+)",new RegExp(g,"g")}e.$8r=L();function R(P){let g=e.$8r;if(P&&P instanceof RegExp)if(P.global)g=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),g=new RegExp(P.source,y)}return g.lastIndex=0,g}e.$9r=R;const p=new f.$1c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(P){const g=p.unshift(P);return(0,F.$Pc)(g)}e.$0r=E;function m(P,g,y,D,w){if(w||(w=I.Iterable.first(p)),y.length>w.maxLen){let r=P-w.maxLen/2;return r<0?r=0:D+=r,y=y.substring(r,P+w.maxLen/2),m(P,g,y,D,w)}const u=Date.now(),c=P-1-D;let i=-1,s=null;for(let r=1;!(Date.now()-u>=w.timeBudget);r++){const o=c-w.windowSize*r;g.lastIndex=Math.max(0,o);const t=A(g,y,c,i);if(!t&&s||(s=t,o<=0))break;i=o}if(s){const r={word:s[0],startColumn:D+1+s.index,endColumn:D+1+s.index+s[0].length};return g.lastIndex=0,r}return null}e.$$r=m;function A(P,g,y,D){let w;for(;w=P.exec(g);){const u=w.index||0;if(u<=y&&P.lastIndex>=y)return w;if(D>0&&u>D)return null}return null}}),define(Se[171],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let E=0,m=p.notIn.length;E<m;E++)switch(p.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,E){if(p.getTokenCount()===0)return!0;const m=p.findTokenIndexAtOffset(E-2),A=p.getStandardTokenType(m);return this.isOK(A)}g(p,E){for(let m=p;m<=E;m++){const A=String.fromCharCode(m);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$st=F;class f{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of p)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$tt=f;function L(R,p,E){R.has(p)?R.get(p).push(E):R.set(p,[E])}}),define(Se[172],De([1,0,125]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hZ=e.$gZ=e.$fZ=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(D,w,u){const c=new Uint8Array(D*w);for(let i=0,s=D*w;i<s;i++)c[i]=u;this.a=c,this.rows=D,this.cols=w}get(D,w){return this.a[D*this.cols+w]}set(D,w,u){this.a[D*this.cols+w]=u}}class L{constructor(D){let w=0,u=0;for(let i=0,s=D.length;i<s;i++){const[r,o,t]=D[i];o>w&&(w=o),r>u&&(u=r),t>u&&(u=t)}w++,u++;const c=new f(u,w,0);for(let i=0,s=D.length;i<s;i++){const[r,o,t]=D[i];c.set(r,o,t)}this.a=c,this.b=w}nextState(D,w){return w<0||w>=this.b?0:this.a.get(D,w)}}e.$fZ=L;let R=null;function p(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let m=null;function A(){if(m===null){m=new I.$Ts(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<y.length;w++)m.set(y.charCodeAt(w),1);const D=".,;:";for(let w=0;w<D.length;w++)m.set(D.charCodeAt(w),2)}return m}class P{static a(D,w,u,c,i){let s=i-1;do{const r=w.charCodeAt(s);if(D.get(r)!==2)break;s--}while(s>c);if(c>0){const r=w.charCodeAt(c-1),o=w.charCodeAt(s);(r===40&&o===41||r===91&&o===93||r===123&&o===125)&&s--}return{range:{startLineNumber:u,startColumn:c+1,endLineNumber:u,endColumn:s+2},url:w.substring(c,s+1)}}static computeLinks(D,w=p()){const u=A(),c=[];for(let i=1,s=D.getLineCount();i<=s;i++){const r=D.getLineContent(i),o=r.length;let t=0,n=0,d=0,l=1,a=!1,h=!1,S=!1,k=!1;for(;t<o;){let $=!1;const b=r.charCodeAt(t);if(l===13){let v;switch(b){case 40:a=!0,v=0;break;case 41:v=a?0:1;break;case 91:S=!0,h=!0,v=0;break;case 93:S=!1,v=h?0:1;break;case 123:k=!0,v=0;break;case 125:v=k?0:1;break;case 39:case 34:case 96:d===b?v=1:d===39||d===34||d===96?v=0:v=1;break;case 42:v=d===42?1:0;break;case 124:v=d===124?1:0;break;case 32:v=S?0:1;break;default:v=u.get(b)}v===1&&(c.push(P.a(u,r,i,n,t)),$=!0)}else if(l===12){let v;b===91?(h=!0,v=0):v=u.get(b),v===1?$=!0:l=13}else l=w.nextState(l,b),l===0&&($=!0);$&&(l=1,a=!1,h=!1,k=!1,n=t+1,d=b),t++}l===13&&c.push(P.a(u,r,i,n,o))}return c}}e.$gZ=P;function g(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.$hZ=g}),define(Se[80],De([1,0,24]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=e.$Qu=e.$Pu=e.ModelConstants=e.PositionAffinity=e.$Ou=e.TrackedRangeStickiness=e.$Nu=e.$Mu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var L;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var E;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(e.EndOfLineSequence=m={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,I.$$m)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$Mu=A;class P{constructor(o,t){this._findMatchBrand=void 0,this.range=o,this.matches=t}}e.$Nu=P;var g;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(e.TrackedRangeStickiness=g={}));function y(r){return r&&typeof r.read=="function"}e.$Ou=y;var D;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var w;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class u{constructor(o,t,n,d,l,a){this.identifier=o,this.range=t,this.text=n,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=l,this._isTracked=a}}e.$Pu=u;class c{constructor(o,t,n){this.regex=o,this.wordSeparators=t,this.simpleSearch=n}}e.$Qu=c;class i{constructor(o,t,n){this.reverseEdits=o,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Ru=i;function s(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$Su=s}),define(Se[173],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=e.NodeColor=e.$nB=void 0;class I{constructor(u,c){this.piece=u,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oB)return f(this.right);let u=this;for(;u.parent!==e.$oB&&u.parent.left!==u;)u=u.parent;return u.parent===e.$oB?e.$oB:u.parent}prev(){if(this.left!==e.$oB)return L(this.left);let u=this;for(;u.parent!==e.$oB&&u.parent.right!==u;)u=u.parent;return u.parent===e.$oB?e.$oB:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nB=I;var F;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$oB=new I(null,0),e.$oB.parent=e.$oB,e.$oB.left=e.$oB,e.$oB.right=e.$oB,e.$oB.color=0;function f(w){for(;w.left!==e.$oB;)w=w.left;return w}e.$pB=f;function L(w){for(;w.right!==e.$oB;)w=w.right;return w}e.$qB=L;function R(w){return w===e.$oB?0:w.size_left+w.piece.length+R(w.right)}function p(w){return w===e.$oB?0:w.lf_left+w.piece.lineFeedCnt+p(w.right)}function E(){e.$oB.parent=e.$oB}function m(w,u){const c=u.right;c.size_left+=u.size_left+(u.piece?u.piece.length:0),c.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=c.left,c.left!==e.$oB&&(c.left.parent=u),c.parent=u.parent,u.parent===e.$oB?w.root=c:u.parent.left===u?u.parent.left=c:u.parent.right=c,c.left=u,u.parent=c}e.$rB=m;function A(w,u){const c=u.left;u.left=c.right,c.right!==e.$oB&&(c.right.parent=u),c.parent=u.parent,u.size_left-=c.size_left+(c.piece?c.piece.length:0),u.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),u.parent===e.$oB?w.root=c:u===u.parent.right?u.parent.right=c:u.parent.left=c,c.right=u,u.parent=c}e.$sB=A;function P(w,u){let c,i;if(u.left===e.$oB?(i=u,c=i.right):u.right===e.$oB?(i=u,c=i.left):(i=f(u.right),c=i.right),i===w.root){w.root=c,c.color=0,u.detach(),E(),w.root.parent=e.$oB;return}const s=i.color===1;if(i===i.parent.left?i.parent.left=c:i.parent.right=c,i===u?(c.parent=i.parent,D(w,c)):(i.parent===u?c.parent=i:c.parent=i.parent,D(w,c),i.left=u.left,i.right=u.right,i.parent=u.parent,i.color=u.color,u===w.root?w.root=i:u===u.parent.left?u.parent.left=i:u.parent.right=i,i.left!==e.$oB&&(i.left.parent=i),i.right!==e.$oB&&(i.right.parent=i),i.size_left=u.size_left,i.lf_left=u.lf_left,D(w,i)),u.detach(),c.parent.left===c){const o=R(c),t=p(c);if(o!==c.parent.size_left||t!==c.parent.lf_left){const n=o-c.parent.size_left,d=t-c.parent.lf_left;c.parent.size_left=o,c.parent.lf_left=t,y(w,c.parent,n,d)}}if(D(w,c.parent),s){E();return}let r;for(;c!==w.root&&c.color===0;)c===c.parent.left?(r=c.parent.right,r.color===1&&(r.color=0,c.parent.color=1,m(w,c.parent),r=c.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,c=c.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(w,r),r=c.parent.right),r.color=c.parent.color,c.parent.color=0,r.right.color=0,m(w,c.parent),c=w.root)):(r=c.parent.left,r.color===1&&(r.color=0,c.parent.color=1,A(w,c.parent),r=c.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,c=c.parent):(r.left.color===0&&(r.right.color=0,r.color=1,m(w,r),r=c.parent.left),r.color=c.parent.color,c.parent.color=0,r.left.color=0,A(w,c.parent),c=w.root));c.color=0,E()}e.$tB=P;function g(w,u){for(D(w,u);u!==w.root&&u.parent.color===1;)if(u.parent===u.parent.parent.left){const c=u.parent.parent.right;c.color===1?(u.parent.color=0,c.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,m(w,u)),u.parent.color=0,u.parent.parent.color=1,A(w,u.parent.parent))}else{const c=u.parent.parent.left;c.color===1?(u.parent.color=0,c.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,A(w,u)),u.parent.color=0,u.parent.parent.color=1,m(w,u.parent.parent))}w.root.color=0}e.$uB=g;function y(w,u,c,i){for(;u!==w.root&&u!==e.$oB;)u.parent.left===u&&(u.parent.size_left+=c,u.parent.lf_left+=i),u=u.parent}e.$vB=y;function D(w,u){let c=0,i=0;if(u!==w.root){for(;u!==w.root&&u===u.parent.right;)u=u.parent;if(u!==w.root)for(u=u.parent,c=R(u.left)-u.size_left,i=p(u.left)-u.lf_left,u.size_left+=c,u.lf_left+=i;u!==w.root&&(c!==0||i!==0);)u.parent.left===u&&(u.parent.size_left+=c,u.parent.lf_left+=i),u=u.parent}}e.$wB=D}),define(Se[174],De([1,0,19,124]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.$Vu=void 0;class f{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,m){E=(0,F.$Ae)(E);const A=this.a,P=this.b,g=m.length;return g===0?!1:(this.a=new Uint32Array(A.length+g),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E),E+g),this.a.set(m,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(E,m){return E=(0,F.$Ae)(E),m=(0,F.$Ae)(m),this.a[E]===m?!1:(this.a[E]=m,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,m){E=(0,F.$Ae)(E),m=(0,F.$Ae)(m);const A=this.a,P=this.b;if(E>=A.length)return!1;const g=A.length-E;return m>=g&&(m=g),m===0?!1:(this.a=new Uint32Array(A.length-m),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E+m),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$Ae)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let m=this.c[0]+1;m===0&&(this.b[0]=this.a[0],m++),E>=this.a.length&&(E=this.a.length-1);for(let A=m;A<=E;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let m=0,A=this.a.length-1,P=0,g=0,y=0;for(;m<=A;)if(P=m+(A-m)/2|0,g=this.b[P],y=g-this.a[P],E<y)A=P-1;else if(E>=g)m=P+1;else break;return new R(P,E-y)}}e.$Vu=f;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const m=this.e[E],A=m>0?this.d[m-1]:0;return new R(m,E-A)}removeValues(E,m){this.a.splice(E,m),this.f(E)}insertValues(E,m){this.a=(0,I.$Vb)(this.a,E,m),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,m=this.a.length;E<m;E++){const A=this.a[E],P=E>0?this.d[E-1]:0;this.d[E]=P+A;for(let g=0;g<A;g++)this.e[P+g]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,m){this.a[E]!==m&&(this.a[E]=m,this.f(E))}}e.$Wu=L;class R{constructor(E,m){this.index=E,this.remainder=m,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=m}}e.$Xu=R}),define(Se[175],De([1,0,13,53,174]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=void 0;class L{constructor(p,E,m,A){this.d=p,this.f=E,this.g=m,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const E=p.changes;for(const m of E)this.o(m.range),this.p(new F.$vs(m.range.startLineNumber,m.range.startColumn),m.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,E=this.f.length,m=new Uint32Array(E);for(let A=0;A<E;A++)m[A]=this.f[A].length+p;this.j=new f.$Vu(m)}}n(p,E){this.f[p]=E,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,E){if(E.length===0)return;const m=(0,I.$Pe)(E);if(m.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+m[0]+this.f[p.lineNumber-1].substring(p.column-1));return}m[m.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+m[0]);const A=new Uint32Array(m.length-1);for(let P=1;P<m.length;P++)this.f.splice(p.lineNumber+P-1,0,m[P]),A[P-1]=m[P].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$Yu=L}),define(Se[98],De([1,0,13,170,53,29,80]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=void 0;const p=999;class E{constructor(i,s,r,o){this.searchString=i,this.isRegex=s,this.matchCase=r,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=m(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=I.$Ne(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new R.$Qu(s,this.wordSeparators?(0,F.$Ws)(this.wordSeparators):null,r?this.searchString:null)}}e.$xB=E;function m(c){if(!c||c.length===0)return!1;for(let i=0,s=c.length;i<s;i++){const r=c.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=s)break;const o=c.charCodeAt(i);if(o===110||o===114||o===87)return!0}}return!1}e.$yB=m;function A(c,i,s){if(!s)return new R.$Nu(c,null);const r=[];for(let o=0,t=i.length;o<t;o++)r[o]=i[o];return new R.$Nu(c,r)}e.$zB=A;class P{constructor(i){const s=[];let r=0;for(let o=0,t=i.length;o<t;o++)i.charCodeAt(o)===10&&(s[r++]=o);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let r=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;r<o;){const t=r+((o-r)/2>>0);s[t]>=i?o=t-1:s[t+1]>=i?(r=t,o=t):r=t+1}return r+1}}class g{static findMatches(i,s,r,o,t){const n=s.parseSearchRequest();return n?n.regex.multiline?this.b(i,r,new u(n.wordSeparators,n.regex),o,t):this.c(i,r,n,o,t):[]}static a(i,s,r,o,t,n){let d,l=0;o?(l=o.findLineFeedCountBeforeOffset(t),d=s+t+l):d=s+t;let a;if(o){const $=o.findLineFeedCountBeforeOffset(t+n.length)-l;a=d+n.length+$}else a=d+n.length;const h=i.getPositionAt(d),S=i.getPositionAt(a);return new L.$ws(h.lineNumber,h.column,S.lineNumber,S.column)}static b(i,s,r,o,t){const n=i.getOffsetAt(s.getStartPosition()),d=i.getValueInRange(s,1),l=i.getEOL()===`\r
`?new P(d):null,a=[];let h=0,S;for(r.reset(0);S=r.next(d);)if(a[h++]=A(this.a(i,n,d,l,S.index,S[0]),S,o),h>=t)return a;return a}static c(i,s,r,o,t){const n=[];let d=0;if(s.startLineNumber===s.endLineNumber){const a=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return d=this.d(r,a,s.startLineNumber,s.startColumn-1,d,n,o,t),n}const l=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);d=this.d(r,l,s.startLineNumber,s.startColumn-1,d,n,o,t);for(let a=s.startLineNumber+1;a<s.endLineNumber&&d<t;a++)d=this.d(r,i.getLineContent(a),a,0,d,n,o,t);if(d<t){const a=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);d=this.d(r,a,s.endLineNumber,0,d,n,o,t)}return n}static d(i,s,r,o,t,n,d,l){const a=i.wordSeparators;if(!d&&i.simpleSearch){const k=i.simpleSearch,$=k.length,b=s.length;let v=-$;for(;(v=s.indexOf(k,v+$))!==-1;)if((!a||w(a,s,b,v,$))&&(n[t++]=new R.$Nu(new L.$ws(r,v+1+o,r,v+1+$+o),null),t>=l))return t;return t}const h=new u(i.wordSeparators,i.regex);let S;h.reset(0);do if(S=h.next(s),S&&(n[t++]=A(new L.$ws(r,S.index+1+o,r,S.index+1+S[0].length+o),S,d),t>=l))return t;while(S);return t}static findNextMatch(i,s,r,o){const t=s.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,n,o):this.f(i,r,n,o)}static e(i,s,r,o){const t=new f.$vs(s.lineNumber,1),n=i.getOffsetAt(t),d=i.getLineCount(),l=i.getValueInRange(new L.$ws(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),a=i.getEOL()===`\r
`?new P(l):null;r.reset(s.column-1);const h=r.next(l);return h?A(this.a(i,n,l,a,h.index,h[0]),h,o):s.lineNumber!==1||s.column!==1?this.e(i,new f.$vs(1,1),r,o):null}static f(i,s,r,o){const t=i.getLineCount(),n=s.lineNumber,d=i.getLineContent(n),l=this.g(r,d,n,s.column,o);if(l)return l;for(let a=1;a<=t;a++){const h=(n+a-1)%t,S=i.getLineContent(h+1),k=this.g(r,S,h+1,1,o);if(k)return k}return null}static g(i,s,r,o,t){i.reset(o-1);const n=i.next(s);return n?A(new L.$ws(r,n.index+1,r,n.index+1+n[0].length),n,t):null}static findPreviousMatch(i,s,r,o){const t=s.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,n,o):this.j(i,r,n,o)}static h(i,s,r,o){const t=this.b(i,new L.$ws(1,1,s.lineNumber,s.column),r,o,10*p);if(t.length>0)return t[t.length-1];const n=i.getLineCount();return s.lineNumber!==n||s.column!==i.getLineMaxColumn(n)?this.h(i,new f.$vs(n,i.getLineMaxColumn(n)),r,o):null}static j(i,s,r,o){const t=i.getLineCount(),n=s.lineNumber,d=i.getLineContent(n).substring(0,s.column-1),l=this.k(r,d,n,o);if(l)return l;for(let a=1;a<=t;a++){const h=(t+n-a-1)%t,S=i.getLineContent(h+1),k=this.k(r,S,h+1,o);if(k)return k}return null}static k(i,s,r,o){let t=null,n;for(i.reset(0);n=i.next(s);)t=A(new L.$ws(r,n.index+1,r,n.index+1+n[0].length),n,o);return t}}e.$AB=g;function y(c,i,s,r,o){if(r===0)return!0;const t=i.charCodeAt(r-1);if(c.get(t)!==0||t===13||t===10)return!0;if(o>0){const n=i.charCodeAt(r);if(c.get(n)!==0)return!0}return!1}function D(c,i,s,r,o){if(r+o===s)return!0;const t=i.charCodeAt(r+o);if(c.get(t)!==0||t===13||t===10)return!0;if(o>0){const n=i.charCodeAt(r+o-1);if(c.get(n)!==0)return!0}return!1}function w(c,i,s,r,o){return y(c,i,s,r,o)&&D(c,i,s,r,o)}e.$BB=w;class u{constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let r;do{if(this.b+this.c===s||(r=this.a.exec(i),!r))return null;const o=r.index,t=r[0].length;if(o===this.b&&t===this.c){if(t===0){I.$9e(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,s,o,t))return r}while(r);return null}}e.$CB=u}),define(Se[127],De([1,0,53,29,80,173,98]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=void 0;const p=65535;function E(c){let i;return c[c.length-1]<65536?i=new Uint16Array(c.length):i=new Uint32Array(c.length),i.set(c,0),i}class m{constructor(i,s,r,o,t){this.lineStarts=i,this.cr=s,this.lf=r,this.crlf=o,this.isBasicASCII=t}}function A(c,i=!0){const s=[0];let r=1;for(let o=0,t=c.length;o<t;o++){const n=c.charCodeAt(o);n===13?o+1<t&&c.charCodeAt(o+1)===10?(s[r++]=o+2,o++):s[r++]=o+1:n===10&&(s[r++]=o+1)}return i?E(s):s}e.$DB=A;function P(c,i){c.length=0,c[0]=0;let s=1,r=0,o=0,t=0,n=!0;for(let l=0,a=i.length;l<a;l++){const h=i.charCodeAt(l);h===13?l+1<a&&i.charCodeAt(l+1)===10?(t++,c[s++]=l+2,l++):(r++,c[s++]=l+1):h===10?(o++,c[s++]=l+1):n&&h!==9&&(h<32||h>126)&&(n=!1)}const d=new m(E(c),r,o,t,n);return c.length=0,d}e.$EB=P;class g{constructor(i,s,r,o,t){this.bufferIndex=i,this.start=s,this.end=r,this.lineFeedCnt=o,this.length=t}}e.$FB=g;class y{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$GB=y;class D{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==L.$oB&&i.iterate(i.root,r=>(r!==L.$oB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const r=this.b[s];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const r=this.b[s];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const r=this.b;for(let o=0;o<r.length;o++){const t=r[o];if(t.node.parent===null||t.nodeStartOffset>=i){r[o]=null,s=!0;continue}}if(s){const o=[];for(const t of r)t!==null&&o.push(t);this.b=o}}}class u{constructor(i,s,r){this.create(i,s,r)}create(i,s,r){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=L.$oB,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=r;let o=null;for(let t=0,n=i.length;t<n;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new g(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),o=this.S(o,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=p,r=s-Math.floor(s/3),o=r*2;let t="",n=0;const d=[];if(this.iterate(this.root,l=>{const a=this.R(l),h=a.length;if(n<=r||n+h<o)return t+=a,n+=h,!0;const S=t.replace(/\r\n|\r|\n/g,i);return d.push(new y(S,A(S))),t=a,n=h,!0}),n>0){const l=t.replace(/\r\n|\r|\n/g,i);d.push(new y(l,A(l)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new D(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===L.$oB)return!0;const t=this.R(o),n=t.length,d=i.G(s),l=i.G(s+n),a=i.getValueInRange2(d,l);return s+=n,t===a})}getOffsetAt(i,s){let r=0,o=this.root;for(;o!==L.$oB;)if(o.left!==L.$oB&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){r+=o.size_left;const t=this.B(o,i-o.lf_left-2);return r+=t+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,r=0;const o=i;for(;s!==L.$oB;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const t=this.A(s,i-s.size_left);if(r+=s.lf_left+t.index,t.index===0){const n=this.getOffsetAt(r+1,1),d=o-n;return new I.$vs(r+1,d+1)}return new I.$vs(r+1,t.remainder+1)}else if(i-=s.size_left+s.piece.length,r+=s.lf_left+s.piece.lineFeedCnt,s.right===L.$oB){const t=this.getOffsetAt(r+1,1),n=o-i-t;return new I.$vs(r+1,n+1)}else s=s.right;return new I.$vs(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,o);return s?s!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,s):t}getValueInRange2(i,s){if(i.node===s.node){const d=i.node,l=this.a[d.piece.bufferIndex].buffer,a=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(a+i.remainder,a+s.remainder)}let r=i.node;const o=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let n=o.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==L.$oB;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===s.node){n+=d.substring(l,l+s.remainder);break}else n+=d.substr(l,r.piece.length);r=r.next()}return n}getLinesContent(){const i=[];let s=0,r="",o=!1;return this.iterate(this.root,t=>{if(t===L.$oB)return!0;const n=t.piece;let d=n.length;if(d===0)return!0;const l=this.a[n.bufferIndex].buffer,a=this.a[n.bufferIndex].lineStarts,h=n.start.line,S=n.end.line;let k=a[h]+n.start.column;if(o&&(l.charCodeAt(k)===10&&(k++,d--),i[s++]=r,r="",o=!1,d===0))return!0;if(h===S)return!this.f&&l.charCodeAt(k+d-1)===13?(o=!0,r+=l.substr(k,d-1)):r+=l.substr(k,d),!0;r+=this.f?l.substring(k,Math.max(k,a[h+1]-this.e)):l.substring(k,a[h+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=r;for(let $=h+1;$<S;$++)r=this.f?l.substring(a[$],a[$+1]-this.e):l.substring(a[$],a[$+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=r;return!this.f&&l.charCodeAt(a[S]+n.end.column-1)===13?(o=!0,n.end.column===0?s--:r=l.substr(a[S],n.end.column-1)):r=l.substr(a[S],n.end.column),!0}),o&&(i[s++]=r,r=""),i[s++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const r=this.a[s.piece.bufferIndex],o=this.u(s.piece.bufferIndex,s.piece.start);return r.buffer.charCodeAt(o)}else{const s=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const r=this.H(i,s+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}findMatchesInNode(i,s,r,o,t,n,d,l,a,h,S){const k=this.a[i.piece.bufferIndex],$=this.u(i.piece.bufferIndex,i.piece.start),b=this.u(i.piece.bufferIndex,t),v=this.u(i.piece.bufferIndex,n);let C;const N={line:0,column:0};let T,M;s._wordSeparators?(T=k.buffer.substring(b,v),M=U=>U+b,s.reset(0)):(T=k.buffer,M=U=>U,s.reset(b));do if(C=s.next(T),C){if(M(C.index)>=v)return h;this.s(i,M(C.index)-$,N);const U=this.t(i.piece.bufferIndex,t,N),j=N.line===t.line?N.column-t.column+o:N.column+1,O=j+C[0].length;if(S[h++]=(0,R.$zB)(new F.$ws(r+U,j,r+U,O),C,l),M(C.index)+C[0].length>=v||h>=a)return h}while(C);return h}findMatchesLineByLine(i,s,r,o){const t=[];let n=0;const d=new R.$CB(s.wordSeparators,s.regex);let l=this.H(i.startLineNumber,i.startColumn);if(l===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let h=this.s(l.node,l.remainder);const S=this.s(a.node,a.remainder);if(l.node===a.node)return this.findMatchesInNode(l.node,d,i.startLineNumber,i.startColumn,h,S,s,r,o,n,t),t;let k=i.startLineNumber,$=l.node;for(;$!==a.node;){const v=this.t($.piece.bufferIndex,h,$.piece.end);if(v>=1){const N=this.a[$.piece.bufferIndex].lineStarts,T=this.u($.piece.bufferIndex,$.piece.start),M=N[h.line+v],U=k===i.startLineNumber?i.startColumn:1;if(n=this.findMatchesInNode($,d,k,U,h,this.s($,M-T),s,r,o,n,t),n>=o)return t;k+=v}const C=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(C,i.endColumn-1);return n=this.n(s,d,N,i.endLineNumber,C,n,t,r,o),t}if(n=this.n(s,d,this.getLineContent(k).substr(C),k,C,n,t,r,o),n>=o)return t;k++,l=this.H(k,1),$=l.node,h=this.s(l.node,l.remainder)}if(k===i.endLineNumber){const v=k===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(k).substring(v,i.endColumn-1);return n=this.n(s,d,C,i.endLineNumber,v,n,t,r,o),t}const b=k===i.startLineNumber?i.startColumn:1;return n=this.findMatchesInNode(a.node,d,k,b,h,S,s,r,o,n,t),t}n(i,s,r,o,t,n,d,l,a){const h=i.wordSeparators;if(!l&&i.simpleSearch){const k=i.simpleSearch,$=k.length,b=r.length;let v=-$;for(;(v=r.indexOf(k,v+$))!==-1;)if((!h||(0,R.$BB)(h,r,b,v,$))&&(d[n++]=new f.$Nu(new F.$ws(o,v+1+t,o,v+1+$+t),null),n>=a))return n;return n}let S;s.reset(0);do if(S=s.next(r),S&&(d[n++]=(0,R.$zB)(new F.$ws(o,S.index+1+t,o,S.index+1+S[0].length+t),S,l),n>=a))return n;while(S);return n}insert(i,s,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==L.$oB){const{node:o,remainder:t,nodeStartOffset:n}=this.G(i),d=o.piece,l=d.bufferIndex,a=this.s(o,t);if(o.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&n+d.length===i&&s.length<p){this.F(o,s),this.y();return}if(n===i)this.o(s,o),this.h.validate(i);else if(n+o.piece.length>i){const h=[];let S=new g(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),this.u(l,d.end)-this.u(l,a));if(this.K()&&this.M(s)&&this.I(o,t)===10){const v={line:S.start.line+1,column:0};S=new g(S.bufferIndex,v,S.end,this.t(S.bufferIndex,v,S.end),S.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(o,t-1)===13){const v=this.s(o,t-1);this.C(o,v),s="\r"+s,o.piece.length===0&&h.push(o)}else this.C(o,a);else this.C(o,a);const k=this.w(s);S.length>0&&this.S(o,S);let $=o;for(let b=0;b<k.length;b++)$=this.S($,k[b]);this.v(h)}else this.q(s,o)}else{const o=this.w(s);let t=this.T(null,o[0]);for(let n=1;n<o.length;n++)t=this.S(t,o[n])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===L.$oB)return;const r=this.G(i),o=this.G(i+s),t=r.node,n=o.node;if(t===n){const k=this.s(t,r.remainder),$=this.s(t,o.remainder);if(r.nodeStartOffset===i){if(s===t.piece.length){const b=t.next();(0,L.$tB)(this,t),this.N(b),this.y();return}this.D(t,$),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+s){this.C(t,k),this.O(t),this.y();return}this.E(t,k,$),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(i),t.piece.length===0&&d.push(t);const a=this.s(n,o.remainder);this.D(n,a),n.piece.length===0&&d.push(n);const h=t.next();for(let k=h;k!==L.$oB&&k!==n;k=k.next())d.push(k);const S=t.piece.length===0?t.prev():t;this.v(d),this.O(S),this.y()}o(i,s){const r=[];if(this.K()&&this.M(i)&&this.L(s)){const n=s.piece,d={line:n.start.line+1,column:0},l=new g(n.bufferIndex,d,n.end,this.t(n.bufferIndex,d,n.end),n.length-1);s.piece=l,i+=`
`,(0,L.$vB)(this,s,-1,-1),s.piece.length===0&&r.push(s)}const o=this.w(i);let t=this.T(s,o[o.length-1]);for(let n=o.length-2;n>=0;n--)t=this.T(t,o[n]);this.N(t),this.v(r)}q(i,s){this.Q(i,s)&&(i+=`
`);const r=this.w(i),o=this.S(s,r[0]);let t=o;for(let n=1;n<r.length;n++)t=this.S(t,r[n]);this.N(o)}s(i,s,r){const o=i.piece,t=i.piece.bufferIndex,n=this.a[t].lineStarts,l=n[o.start.line]+o.start.column+s;let a=o.start.line,h=o.end.line,S=0,k=0,$=0;for(;a<=h&&(S=a+(h-a)/2|0,$=n[S],S!==h);)if(k=n[S+1],l<$)h=S-1;else if(l>=k)a=S+1;else break;return r?(r.line=S,r.column=l-$,null):{line:S,column:l-$}}t(i,s,r){if(r.column===0)return r.line-s.line;const o=this.a[i].lineStarts;if(r.line===o.length-1)return r.line-s.line;const t=o[r.line+1],n=o[r.line]+r.column;if(t>n+1)return r.line-s.line;const d=n-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-s.line+1:r.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,L.$tB)(this,i[s])}w(i){if(i.length>p){const h=[];for(;i.length>p;){const k=i.charCodeAt(p-1);let $;k===13||k>=55296&&k<=56319?($=i.substring(0,p-1),i=i.substring(p-1)):($=i.substring(0,p),i=i.substring(p));const b=A($);h.push(new g(this.a.length,{line:0,column:0},{line:b.length-1,column:$.length-b[b.length-1]},b.length-1,$.length)),this.a.push(new y($,b))}const S=A(i);return h.push(new g(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new y(i,S)),h}let s=this.a[0].buffer.length;const r=A(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let h=0;h<r.length;h++)r[h]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let h=0;h<r.length;h++)r[h]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,n=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[n],l={line:n,column:d},a=new g(0,o,l,this.t(0,o,l),t-s);return this.g=l,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let r=this.root,o="";const t=this.h.get2(i);if(t){r=t.node;const n=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)o=d.substring(l+n,l+r.piece.length);else{const a=this.B(r,i-t.nodeStartLineNumber);return d.substring(l+n,l+a-s)}}else{let n=0;const d=i;for(;r!==L.$oB;)if(r.left!==L.$oB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const l=this.B(r,i-r.lf_left-2),a=this.B(r,i-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,S=this.u(r.piece.bufferIndex,r.piece.start);return n+=r.size_left,this.h.set({node:r,nodeStartOffset:n,nodeStartLineNumber:d-(i-1-r.lf_left)}),h.substring(S+l,S+a-s)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const l=this.B(r,i-r.lf_left-2),a=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);o=a.substring(h+l,h+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,n+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==L.$oB;){const n=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return o+=n.substring(l,l+d-s),o}else{const d=this.u(r.piece.bufferIndex,r.piece.start);o+=n.substr(d,r.piece.length)}r=r.next()}return o}y(){let i=this.root,s=1,r=0;for(;i!==L.$oB;)s+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=r,this.h.validate(this.c)}A(i,s){const r=i.piece,o=this.s(i,s),t=o.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===s){const n=this.t(i.piece.bufferIndex,r.start,o);if(n!==t)return{index:n,remainder:0}}return{index:t,remainder:o.column}}B(i,s){if(s<0)return 0;const r=i.piece,o=this.a[r.bufferIndex].lineStarts,t=r.start.line+s+1;return t>r.end.line?o[r.end.line]+r.end.column-o[r.start.line]-r.start.column:o[t]-o[r.start.line]-r.start.column}C(i,s){const r=i.piece,o=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),n=s,d=this.u(r.bufferIndex,n),l=this.t(r.bufferIndex,r.start,n),a=l-o,h=d-t,S=r.length+h;i.piece=new g(r.bufferIndex,r.start,n,l,S),(0,L.$vB)(this,i,h,a)}D(i,s){const r=i.piece,o=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),n=s,d=this.t(r.bufferIndex,n,r.end),l=this.u(r.bufferIndex,n),a=d-o,h=t-l,S=r.length+h;i.piece=new g(r.bufferIndex,n,r.end,d,S),(0,L.$vB)(this,i,h,a)}E(i,s,r){const o=i.piece,t=o.start,n=o.end,d=o.length,l=o.lineFeedCnt,a=s,h=this.t(o.bufferIndex,o.start,a),S=this.u(o.bufferIndex,s)-this.u(o.bufferIndex,t);i.piece=new g(o.bufferIndex,o.start,a,h,S),(0,L.$vB)(this,i,S-d,h-l);const k=new g(o.bufferIndex,r,n,this.t(o.bufferIndex,r,n),this.u(o.bufferIndex,n)-this.u(o.bufferIndex,r)),$=this.S(i,k);this.N($)}F(i,s){this.Q(s,i)&&(s+=`
`);const r=this.K()&&this.L(s)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=s;const t=A(s,!1);for(let $=0;$<t.length;$++)t[$]+=o;if(r){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const n=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[n],l={line:n,column:d},a=i.piece.length+s.length,h=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,l),k=S-h;i.piece=new g(i.piece.bufferIndex,i.piece.start,l,S,a),this.g=l,(0,L.$vB)(this,i,s.length,k)}G(i){let s=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let o=0;for(;s!==L.$oB;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const t={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this.h.set(t),t}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let r=this.root,o=0;for(;r!==L.$oB;)if(r.left!==L.$oB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),n=this.B(r,i-r.lf_left-1);return o+=r.size_left,{node:r,remainder:Math.min(t+s-1,n),nodeStartOffset:o}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+s-1<=r.piece.length)return{node:r,remainder:t+s-1,nodeStartOffset:o};s-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==L.$oB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),n=this.J(r);return{node:r,remainder:Math.min(s-1,t),nodeStartOffset:n}}else if(r.piece.length>=s-1){const t=this.J(r);return{node:r,remainder:s-1,nodeStartOffset:t}}else s-=r.piece.length;r=r.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+s;return r.buffer.charCodeAt(o)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$oB||i.piece.lineFeedCnt===0)return!1;const s=i.piece,r=this.a[s.bufferIndex].lineStarts,o=s.start.line,t=r[o]+s.start.column;return o===r.length-1||r[o+1]>t+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$oB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const r=[],o=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const n=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new g(i.piece.bufferIndex,i.piece.start,t,d,n),(0,L.$vB)(this,i,-1,-1),i.piece.length===0&&r.push(i);const l={line:s.piece.start.line+1,column:0},a=s.piece.length-1,h=this.t(s.piece.bufferIndex,l,s.piece.end);s.piece=new g(s.piece.bufferIndex,l,s.piece.end,h,a),(0,L.$vB)(this,s,-1,-1),s.piece.length===0&&r.push(s);const S=this.w(`\r
`);this.S(i,S[0]);for(let k=0;k<r.length;k++)(0,L.$tB)(this,r[k])}Q(i,s){if(this.K()&&this.M(i)){const r=s.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,L.$tB)(this,r);else{const o=r.piece,t={line:o.start.line+1,column:0},n=o.length-1,d=this.t(o.bufferIndex,t,o.end);r.piece=new g(o.bufferIndex,t,o.end,d,n),(0,L.$vB)(this,r,-1,-1)}return!0}}return!1}iterate(i,s){if(i===L.$oB)return s(L.$oB);const r=this.iterate(i.left,s);return r&&s(i)&&this.iterate(i.right,s)}R(i){if(i===L.$oB)return"";const s=this.a[i.piece.bufferIndex],r=i.piece,o=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return s.buffer.substring(o,t)}getPieceContent(i){const s=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return s.buffer.substring(r,o)}S(i,s){const r=new L.$nB(s,1);if(r.left=L.$oB,r.right=L.$oB,r.parent=L.$oB,r.size_left=0,r.lf_left=0,this.root===L.$oB)this.root=r,r.color=0;else if(i.right===L.$oB)i.right=r,r.parent=i;else{const t=(0,L.$pB)(i.right);t.left=r,r.parent=t}return(0,L.$uB)(this,r),r}T(i,s){const r=new L.$nB(s,1);if(r.left=L.$oB,r.right=L.$oB,r.parent=L.$oB,r.size_left=0,r.lf_left=0,this.root===L.$oB)this.root=r,r.color=0;else if(i.left===L.$oB)i.left=r,r.parent=i;else{const o=(0,L.$qB)(i.left);o.right=r,r.parent=o}return(0,L.$uB)(this,r),r}U(i){let s="";return this.iterate(i,r=>(s+=this.R(r),!0)),s}}e.$HB=u}),define(Se[176],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67=e.$57=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$57=I;class F{constructor(L){this.identifier=L}}e.$67=F}),define(Se[177],De([1,0,4,3]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new I.$Nd,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,E){return this.a.set(p,E),this.handleChange([p]),(0,F.$Pc)(()=>{this.a.get(p)===E&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,E){this.b.get(p)?.dispose();const m=new L(this,p,E);return this.b.set(p,m),(0,F.$Pc)(()=>{const A=this.b.get(p);!A||A!==m||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const E=this.get(p);if(E)return E;const m=this.b.get(p);return!m||m.isResolved?null:(await m.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const m=this.b.get(p);return!!(!m||m.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$8s=f;class L extends F.$Rc{get isResolved(){return this.c}constructor(p,E,m){super(),this.f=p,this.g=E,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Se[178],De([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Se[179],De([1,0,4,3,178]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class L extends F.$Rc{constructor(g,y="",D="",w=!0,u){super(),this.h=this.B(new I.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=g,this.m=y,this.u=D,this.w=w,this.C=u}get id(){return this.j}get label(){return this.m}set label(g){this.D(g)}D(g){this.m!==g&&(this.m=g,this.h.fire({label:g}))}get tooltip(){return this.n||""}set tooltip(g){this.F(g)}F(g){this.n!==g&&(this.n=g,this.h.fire({tooltip:g}))}get class(){return this.u}set class(g){this.G(g)}G(g){this.u!==g&&(this.u=g,this.h.fire({class:g}))}get enabled(){return this.w}set enabled(g){this.H(g)}H(g){this.w!==g&&(this.w=g,this.h.fire({enabled:g}))}get checked(){return this.z}set checked(g){this.I(g)}I(g){this.z!==g&&(this.z=g,this.h.fire({checked:g}))}async run(g,y){this.C&&await this.C(g)}}e.$ui=L;class R extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new I.$Nd),this.onWillRun=this.f.event,this.m=this.B(new I.$Nd),this.onDidRun=this.m.event}async run(g,y){if(!g.enabled)return;this.f.fire({action:g});let D;try{await this.u(g,y)}catch(w){D=w}this.m.fire({action:g,error:D})}async u(g,y){await g.run(y)}}e.$vi=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let y=[];for(const D of g)D.length&&(y.length?y=[...y,new p,...D]:y=D);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=p;class E{get actions(){return this.a}constructor(g,y,D,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=y,this.class=w,this.a=D}async run(){}}e.$xi=E;class m extends L{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,f.localize(0,null),void 0,!1)}}e.$yi=m;function A(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...g)=>P.run(...g),tooltip:P.label}}e.$zi=A}),define(Se[180],De([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Se[181],De([1,0,180]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const F=60,f=F*60,L=f*24,R=L*7,p=L*30,E=L*365;function m(P,g,y,D){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!D&&w<30)return(0,I.localize)(1,null);let u;return w<F?(u=w,g?u===1?y?(0,I.localize)(2,null,u):(0,I.localize)(3,null,u):y?(0,I.localize)(4,null,u):(0,I.localize)(5,null,u):u===1?y?(0,I.localize)(6,null,u):(0,I.localize)(7,null,u):y?(0,I.localize)(8,null,u):(0,I.localize)(9,null,u)):w<f?(u=Math.floor(w/F),g?u===1?y?(0,I.localize)(10,null,u):(0,I.localize)(11,null,u):y?(0,I.localize)(12,null,u):(0,I.localize)(13,null,u):u===1?y?(0,I.localize)(14,null,u):(0,I.localize)(15,null,u):y?(0,I.localize)(16,null,u):(0,I.localize)(17,null,u)):w<L?(u=Math.floor(w/f),g?u===1?y?(0,I.localize)(18,null,u):(0,I.localize)(19,null,u):y?(0,I.localize)(20,null,u):(0,I.localize)(21,null,u):u===1?y?(0,I.localize)(22,null,u):(0,I.localize)(23,null,u):y?(0,I.localize)(24,null,u):(0,I.localize)(25,null,u)):w<R?(u=Math.floor(w/L),g?u===1?(0,I.localize)(26,null,u):(0,I.localize)(27,null,u):u===1?(0,I.localize)(28,null,u):(0,I.localize)(29,null,u)):w<p?(u=Math.floor(w/R),g?u===1?y?(0,I.localize)(30,null,u):(0,I.localize)(31,null,u):y?(0,I.localize)(32,null,u):(0,I.localize)(33,null,u):u===1?y?(0,I.localize)(34,null,u):(0,I.localize)(35,null,u):y?(0,I.localize)(36,null,u):(0,I.localize)(37,null,u)):w<E?(u=Math.floor(w/p),g?u===1?y?(0,I.localize)(38,null,u):(0,I.localize)(39,null,u):y?(0,I.localize)(40,null,u):(0,I.localize)(41,null,u):u===1?y?(0,I.localize)(42,null,u):(0,I.localize)(43,null,u):y?(0,I.localize)(44,null,u):(0,I.localize)(45,null,u)):(u=Math.floor(w/E),g?u===1?y?(0,I.localize)(46,null,u):(0,I.localize)(47,null,u):y?(0,I.localize)(48,null,u):(0,I.localize)(49,null,u):u===1?y?(0,I.localize)(50,null,u):(0,I.localize)(51,null,u):y?(0,I.localize)(52,null,u):(0,I.localize)(53,null,u))}e.$dm=m;function A(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=A}),define(Se[182],De([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Se[41],De([1,0,19,17,182]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function L(P,g){return g&&(P.stack||P.stacktrace)?f.localize(0,null,p(P),R(P.stack)||R(P.stacktrace)):p(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?f.localize(1,null,P.message):P.message||f.localize(2,null)}function E(P=null,g=!1){if(!P)return f.localize(3,null);if(Array.isArray(P)){const y=I.$Gb(P),D=E(y[0],g);return y.length>1?f.localize(4,null,D,y.length):D}if(F.$yf(P))return P;if(P.detail){const y=P.detail;if(y.error)return L(y.error,g);if(y.exception)return L(y.exception,g)}return P.stack?L(P,g):P.message?P.message:f.localize(5,null)}e.$Ai=E;function m(P){const g=P;return g instanceof Error&&Array.isArray(g.actions)}e.$Bi=m;function A(P,g){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=g,y}e.$Ci=A}),define(Se[183],De([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,183]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let F=!1,f=!1,L=!1,R=!1,p=!1,E=!1,m=!1,A=!1,P=!1,g=!1,y,D=e.$g,w=e.$g,u,c;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let i;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?i=e.$h.vscode.process:typeof process<"u"&&(i=process);const s=typeof i?.versions?.electron=="string",r=s&&i?.type==="renderer";if(typeof navigator=="object"&&!r)c=navigator.userAgent,F=c.indexOf("Windows")>=0,f=c.indexOf("Macintosh")>=0,A=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=c.indexOf("Linux")>=0,g=c?.indexOf("Mobi")>=0,E=!0,y=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,D=y,w=navigator.language;else if(typeof i=="object"){F=i.platform==="win32",f=i.platform==="darwin",L=i.platform==="linux",R=L&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,m=s,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,D=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const $=JSON.parse(k),b=$.availableLanguages["*"];y=$.locale,w=$.osLocale,D=b||e.$g,u=$._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var o;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(o||(e.Platform=o={}));function t(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;f?n=1:F?n=3:L&&(n=2),e.$j=F,e.$k=f,e.$l=L,e.$m=R,e.$n=p,e.$o=m,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=A,e.$s=g,e.$t=P,e.$u=n,e.$v=c,e.$w=D;var d;(function(k){function $(){return e.$w}k.value=$;function b(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=b;function v(){return e.$w==="en"}k.isDefault=v})(d||(e.Language=d={})),e.$x=y,e.$y=w,e.$z=u,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const k=[];e.$h.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let v=0,C=k.length;v<C;v++){const N=k[v];if(N.id===b.data.vscodeScheduleAsyncWork){k.splice(v,1),N.callback();return}}});let $=0;return b=>{const v=++$;k.push({id:v,callback:b}),e.$h.postMessage({vscodeScheduleAsyncWork:v},"*")}}return k=>setTimeout(k)})();var l;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=f||A?2:F?1:3;let a=!0,h=!1;function S(){if(!h){h=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,a=new Uint16Array(k.buffer)[0]===(2<<8)+1}return a}e.$D=S,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(Se[48],De([1,0,12]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.process<"u"){const f=I.$h.vscode.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(Se[16],De([1,0,48]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,f=97,L=90,R=122,p=46,E=47,m=92,A=58,P=63;class g extends Error{constructor(n,d,l){let a;typeof d=="string"&&d.indexOf("not ")===0?(a="must not be",d=d.replace(/^not /,"")):a="must be";const h=n.indexOf(".")!==-1?"property":"argument";let S=`The "${n}" ${h} ${a} of type ${d}`;S+=`. Received type ${typeof l}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new g(n,"Object",t)}function D(t,n){if(typeof t!="string")throw new g(n,"string",t)}const w=I.$cc==="win32";function u(t){return t===E||t===m}function c(t){return t===E}function i(t){return t>=F&&t<=L||t>=f&&t<=R}function s(t,n,d,l){let a="",h=0,S=-1,k=0,$=0;for(let b=0;b<=t.length;++b){if(b<t.length)$=t.charCodeAt(b);else{if(l($))break;$=E}if(l($)){if(!(S===b-1||k===1))if(k===2){if(a.length<2||h!==2||a.charCodeAt(a.length-1)!==p||a.charCodeAt(a.length-2)!==p){if(a.length>2){const v=a.lastIndexOf(d);v===-1?(a="",h=0):(a=a.slice(0,v),h=a.length-1-a.lastIndexOf(d)),S=b,k=0;continue}else if(a.length!==0){a="",h=0,S=b,k=0;continue}}n&&(a+=a.length>0?`${d}..`:"..",h=2)}else a.length>0?a+=`${d}${t.slice(S+1,b)}`:a=t.slice(S+1,b),h=b-S-1;S=b,k=0}else $===p&&k!==-1?++k:k=-1}return a}function r(t,n){y(n,"pathObject");const d=n.dir||n.root,l=n.base||`${n.name||""}${n.ext||""}`;return d?d===n.root?`${d}${l}`:`${d}${t}${l}`:l}e.$ec={resolve(...t){let n="",d="",l=!1;for(let a=t.length-1;a>=-1;a--){let h;if(a>=0){if(h=t[a],D(h,"path"),h.length===0)continue}else n.length===0?h=I.cwd():(h=I.env[`=${n}`]||I.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==n.toLowerCase()&&h.charCodeAt(2)===m)&&(h=`${n}\\`));const S=h.length;let k=0,$="",b=!1;const v=h.charCodeAt(0);if(S===1)u(v)&&(k=1,b=!0);else if(u(v))if(b=!0,u(h.charCodeAt(1))){let C=2,N=C;for(;C<S&&!u(h.charCodeAt(C));)C++;if(C<S&&C!==N){const T=h.slice(N,C);for(N=C;C<S&&u(h.charCodeAt(C));)C++;if(C<S&&C!==N){for(N=C;C<S&&!u(h.charCodeAt(C));)C++;(C===S||C!==N)&&($=`\\\\${T}\\${h.slice(N,C)}`,k=C)}}}else k=1;else i(v)&&h.charCodeAt(1)===A&&($=h.slice(0,2),k=2,S>2&&u(h.charCodeAt(2))&&(b=!0,k=3));if($.length>0)if(n.length>0){if($.toLowerCase()!==n.toLowerCase())continue}else n=$;if(l){if(n.length>0)break}else if(d=`${h.slice(k)}\\${d}`,l=b,b&&n.length>0)break}return d=s(d,!l,"\\",u),l?`${n}\\${d}`:`${n}${d}`||"."},normalize(t){D(t,"path");const n=t.length;if(n===0)return".";let d=0,l,a=!1;const h=t.charCodeAt(0);if(n===1)return c(h)?"\\":t;if(u(h))if(a=!0,u(t.charCodeAt(1))){let k=2,$=k;for(;k<n&&!u(t.charCodeAt(k));)k++;if(k<n&&k!==$){const b=t.slice($,k);for($=k;k<n&&u(t.charCodeAt(k));)k++;if(k<n&&k!==$){for($=k;k<n&&!u(t.charCodeAt(k));)k++;if(k===n)return`\\\\${b}\\${t.slice($)}\\`;k!==$&&(l=`\\\\${b}\\${t.slice($,k)}`,d=k)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,n>2&&u(t.charCodeAt(2))&&(a=!0,d=3));let S=d<n?s(t.slice(d),!a,"\\",u):"";return S.length===0&&!a&&(S="."),S.length>0&&u(t.charCodeAt(n-1))&&(S+="\\"),l===void 0?a?`\\${S}`:S:a?`${l}\\${S}`:`${l}${S}`},isAbsolute(t){D(t,"path");const n=t.length;if(n===0)return!1;const d=t.charCodeAt(0);return u(d)||n>2&&i(d)&&t.charCodeAt(1)===A&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,d;for(let h=0;h<t.length;++h){const S=t[h];D(S,"path"),S.length>0&&(n===void 0?n=d=S:n+=`\\${S}`)}if(n===void 0)return".";let l=!0,a=0;if(typeof d=="string"&&u(d.charCodeAt(0))){++a;const h=d.length;h>1&&u(d.charCodeAt(1))&&(++a,h>2&&(u(d.charCodeAt(2))?++a:l=!1))}if(l){for(;a<n.length&&u(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.$ec.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n)return"";const d=e.$ec.resolve(t),l=e.$ec.resolve(n);if(d===l||(t=d.toLowerCase(),n=l.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===m;)a++;let h=t.length;for(;h-1>a&&t.charCodeAt(h-1)===m;)h--;const S=h-a;let k=0;for(;k<n.length&&n.charCodeAt(k)===m;)k++;let $=n.length;for(;$-1>k&&n.charCodeAt($-1)===m;)$--;const b=$-k,v=S<b?S:b;let C=-1,N=0;for(;N<v;N++){const M=t.charCodeAt(a+N);if(M!==n.charCodeAt(k+N))break;M===m&&(C=N)}if(N!==v){if(C===-1)return l}else{if(b>v){if(n.charCodeAt(k+N)===m)return l.slice(k+N+1);if(N===2)return l.slice(k+N)}S>v&&(t.charCodeAt(a+N)===m?C=N:N===2&&(C=3)),C===-1&&(C=0)}let T="";for(N=a+C+1;N<=h;++N)(N===h||t.charCodeAt(N)===m)&&(T+=T.length===0?"..":"\\..");return k+=C,T.length>0?`${T}${l.slice(k,$)}`:(l.charCodeAt(k)===m&&++k,l.slice(k,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$ec.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===m){if(n.charCodeAt(1)===m){const d=n.charCodeAt(2);if(d!==P&&d!==p)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(i(n.charCodeAt(0))&&n.charCodeAt(1)===A&&n.charCodeAt(2)===m)return`\\\\?\\${n}`;return t},dirname(t){D(t,"path");const n=t.length;if(n===0)return".";let d=-1,l=0;const a=t.charCodeAt(0);if(n===1)return u(a)?t:".";if(u(a)){if(d=l=1,u(t.charCodeAt(1))){let k=2,$=k;for(;k<n&&!u(t.charCodeAt(k));)k++;if(k<n&&k!==$){for($=k;k<n&&u(t.charCodeAt(k));)k++;if(k<n&&k!==$){for($=k;k<n&&!u(t.charCodeAt(k));)k++;if(k===n)return t;k!==$&&(d=l=k+1)}}}}else i(a)&&t.charCodeAt(1)===A&&(d=n>2&&u(t.charCodeAt(2))?3:2,l=d);let h=-1,S=!0;for(let k=n-1;k>=l;--k)if(u(t.charCodeAt(k))){if(!S){h=k;break}}else S=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let d=0,l=-1,a=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let S=n.length-1,k=-1;for(h=t.length-1;h>=d;--h){const $=t.charCodeAt(h);if(u($)){if(!a){d=h+1;break}}else k===-1&&(a=!1,k=h+1),S>=0&&($===n.charCodeAt(S)?--S===-1&&(l=h):(S=-1,l=k))}return d===l?l=k:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(u(t.charCodeAt(h))){if(!a){d=h+1;break}}else l===-1&&(a=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){D(t,"path");let n=0,d=-1,l=0,a=-1,h=!0,S=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(n=l=2);for(let k=t.length-1;k>=n;--k){const $=t.charCodeAt(k);if(u($)){if(!h){l=k+1;break}continue}a===-1&&(h=!1,a=k+1),$===p?d===-1?d=k:S!==1&&(S=1):d!==-1&&(S=-1)}return d===-1||a===-1||S===0||S===1&&d===a-1&&d===l+1?"":t.slice(d,a)},format:r.bind(null,"\\"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const d=t.length;let l=0,a=t.charCodeAt(0);if(d===1)return u(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(u(a)){if(l=1,u(t.charCodeAt(1))){let C=2,N=C;for(;C<d&&!u(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&u(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&!u(t.charCodeAt(C));)C++;C===d?l=C:C!==N&&(l=C+1)}}}}else if(i(a)&&t.charCodeAt(1)===A){if(d<=2)return n.root=n.dir=t,n;if(l=2,u(t.charCodeAt(2))){if(d===3)return n.root=n.dir=t,n;l=3}}l>0&&(n.root=t.slice(0,l));let h=-1,S=l,k=-1,$=!0,b=t.length-1,v=0;for(;b>=l;--b){if(a=t.charCodeAt(b),u(a)){if(!$){S=b+1;break}continue}k===-1&&($=!1,k=b+1),a===p?h===-1?h=b:v!==1&&(v=1):h!==-1&&(v=-1)}return k!==-1&&(h===-1||v===0||v===1&&h===k-1&&h===S+1?n.base=n.name=t.slice(S,k):(n.name=t.slice(S,h),n.base=t.slice(S,k),n.ext=t.slice(h,k))),S>0&&S!==l?n.dir=t.slice(0,S-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(w){const t=/\\/g;return()=>{const n=I.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...t){let n="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const a=l>=0?t[l]:o();D(a,"path"),a.length!==0&&(n=`${a}/${n}`,d=a.charCodeAt(0)===E)}return n=s(n,!d,"/",c),d?`/${n}`:n.length>0?n:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,d=t.charCodeAt(t.length-1)===E;return t=s(t,!n,"/",c),t.length===0?n?"/":d?"./":".":(d&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let d=0;d<t.length;++d){const l=t[d];D(l,"path"),l.length>0&&(n===void 0?n=l:n+=`/${l}`)}return n===void 0?".":e.$fc.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n||(t=e.$fc.resolve(t),n=e.$fc.resolve(n),t===n))return"";const d=1,l=t.length,a=l-d,h=1,S=n.length-h,k=a<S?a:S;let $=-1,b=0;for(;b<k;b++){const C=t.charCodeAt(d+b);if(C!==n.charCodeAt(h+b))break;C===E&&($=b)}if(b===k)if(S>k){if(n.charCodeAt(h+b)===E)return n.slice(h+b+1);if(b===0)return n.slice(h+b)}else a>k&&(t.charCodeAt(d+b)===E?$=b:b===0&&($=0));let v="";for(b=d+$+1;b<=l;++b)(b===l||t.charCodeAt(b)===E)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(h+$)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let d=-1,l=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===E){if(!l){d=a;break}}else l=!1;return d===-1?n?"/":".":n&&d===1?"//":t.slice(0,d)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let d=0,l=-1,a=!0,h;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let S=n.length-1,k=-1;for(h=t.length-1;h>=0;--h){const $=t.charCodeAt(h);if($===E){if(!a){d=h+1;break}}else k===-1&&(a=!1,k=h+1),S>=0&&($===n.charCodeAt(S)?--S===-1&&(l=h):(S=-1,l=k))}return d===l?l=k:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===E){if(!a){d=h+1;break}}else l===-1&&(a=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){D(t,"path");let n=-1,d=0,l=-1,a=!0,h=0;for(let S=t.length-1;S>=0;--S){const k=t.charCodeAt(S);if(k===E){if(!a){d=S+1;break}continue}l===-1&&(a=!1,l=S+1),k===p?n===-1?n=S:h!==1&&(h=1):n!==-1&&(h=-1)}return n===-1||l===-1||h===0||h===1&&n===l-1&&n===d+1?"":t.slice(n,l)},format:r.bind(null,"/"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const d=t.charCodeAt(0)===E;let l;d?(n.root="/",l=1):l=0;let a=-1,h=0,S=-1,k=!0,$=t.length-1,b=0;for(;$>=l;--$){const v=t.charCodeAt($);if(v===E){if(!k){h=$+1;break}continue}S===-1&&(k=!1,S=$+1),v===p?a===-1?a=$:b!==1&&(b=1):a!==-1&&(b=-1)}if(S!==-1){const v=h===0&&d?1:h;a===-1||b===0||b===1&&a===S-1&&a===h+1?n.base=n.name=t.slice(v,S):(n.name=t.slice(v,a),n.base=t.slice(v,S),n.ext=t.slice(a,S))}return h>0?n.dir=t.slice(0,h-1):d&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(Se[128],De([1,0,47,16]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=void 0;const f=new I.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),L=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(k,$,b=!1){const v=k||"",C=$||"",N=f.value.collator.compare(v,C);return f.value.collatorIsNumeric&&N===0&&v!==C?v<C?-1:1:N}e.$kq=p;function E(k,$){const b=L.value.collator;return k=k||"",$=$||"",r(b,k,$)}e.$lq=E;function m(k,$){const b=L.value.collator;return k=k||"",$=$||"",d(k,$)||r(b,k,$)}e.$mq=m;function A(k,$){const b=L.value.collator;return k=k||"",$=$||"",n(k,$)||r(b,k,$)}e.$nq=A;function P(k,$){return k=k||"",$=$||"",k===$?0:k<$?-1:1}e.$oq=P;function g(k,$){const[b,v]=i(k),[C,N]=i($);let T=f.value.collator.compare(v,N);if(T===0){if(f.value.collatorIsNumeric&&v!==N)return v<N?-1:1;if(T=f.value.collator.compare(b,C),f.value.collatorIsNumeric&&T===0&&b!==C)return b<C?-1:1}return T}e.$pq=g;function y(k,$){k=k||"",$=$||"";const b=s(k),v=s($),C=L.value.collator,N=R.value.collator;return r(N,b,v)||r(C,k,$)}e.$qq=y;function D(k,$){k=k||"",$=$||"";const b=s(k),v=s($),C=L.value.collator,N=R.value.collator;return r(N,b,v)||d(k,$)||r(C,k,$)}e.$rq=D;function w(k,$){k=k||"",$=$||"";const b=s(k),v=s($),C=L.value.collator,N=R.value.collator;return r(N,b,v)||n(k,$)||r(C,k,$)}e.$sq=w;function u(k,$){k=k||"",$=$||"";const b=s(k).toLowerCase(),v=s($).toLowerCase();return b!==v?b<v?-1:1:k!==$?k<$?-1:1:0}e.$tq=u;const c=/^(.*?)(\.([^.]*))?$/;function i(k,$=!1){const b=k?c.exec(k):[];let v=[b&&b[1]||"",b&&b[3]||""];return $&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function s(k){const $=k?c.exec(k):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function r(k,$,b){const v=k.compare($,b);return v!==0?v:$.length!==b.length?$.length<b.length?-1:1:0}function o(k){const $=k.charAt(0);return $.toLocaleUpperCase()!==$}function t(k){const $=k.charAt(0);return $.toLocaleLowerCase()!==$}function n(k,$){return o(k)&&t($)?-1:t(k)&&o($)?1:0}function d(k,$){return t(k)&&o($)?-1:o(k)&&t($)?1:0}function l(k,$,b=!1){return b||(k=k&&k.toLowerCase(),$=$&&$.toLowerCase()),k===$?0:k<$?-1:1}function a(k,$,b=!1){const v=k.split(F.sep),C=$.split(F.sep),N=v.length-1,T=C.length-1;let M,U;for(let j=0;;j++){if(M=N===j,U=T===j,M&&U)return p(v[j],C[j],b);if(M)return-1;if(U)return 1;const O=l(v[j],C[j],b);if(O!==0)return O}}e.$uq=a;function h(k,$,b){const v=k.toLowerCase(),C=$.toLowerCase(),N=S(k,$,b);if(N)return N;const T=v.endsWith(b),M=C.endsWith(b);if(T!==M)return T?-1:1;const U=p(v,C);return U!==0?U:v.localeCompare(C)}e.$vq=h;function S(k,$,b){const v=k.toLowerCase(),C=$.toLowerCase(),N=v.startsWith(b),T=C.startsWith(b);if(N!==T)return N?-1:1;if(N&&T){if(v.length<C.length)return-1;if(v.length>C.length)return 1}return 0}e.$wq=S}),define(Se[33],De([1,0,16,12,13,17]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function R(h){return h===47||h===92}e.$Qf=R;function p(h){return h.replace(/[\\/]/g,I.$fc.sep)}e.$Rf=p;function E(h){return h.indexOf("/")===-1&&(h=p(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Sf=E;function m(h,S=I.$fc.sep){if(!h)return"";const k=h.length,$=h.charCodeAt(0);if(R($)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let v=3;const C=v;for(;v<k&&!R(h.charCodeAt(v));v++);if(C!==v&&!R(h.charCodeAt(v+1))){for(v+=1;v<k;v++)if(R(h.charCodeAt(v)))return h.slice(0,v+1).replace(/[\\/]/g,S)}}return S}else if(c($)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+S:h.slice(0,2);let b=h.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(R(h.charCodeAt(b)))return h.slice(0,b+1)}return""}e.$Tf=m;function A(h){if(!F.$j||!h||h.length<5)return!1;let S=h.charCodeAt(0);if(S!==92||(S=h.charCodeAt(1),S!==92))return!1;let k=2;const $=k;for(;k<h.length&&(S=h.charCodeAt(k),S!==92);k++);return!($===k||(S=h.charCodeAt(k+1),isNaN(S)||S===92))}e.$Uf=A;const P=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(h,S=F.$j){const k=S?P:g;return!(!h||h.length===0||/^\s+$/.test(h)||(k.lastIndex=0,k.test(h))||S&&y.test(h)||h==="."||h===".."||S&&h[h.length-1]==="."||S&&h.length!==h.trim().length||h.length>255)}e.$Vf=D;function w(h,S,k){const $=h===S;return!k||$?$:!h||!S?!1:(0,f.$2e)(h,S)}e.$Wf=w;function u(h,S,k,$=I.sep){if(h===S)return!0;if(!h||!S||S.length>h.length)return!1;if(k){if(!(0,f.$3e)(h,S))return!1;if(S.length===h.length)return!0;let v=S.length;return S.charAt(S.length-1)===$&&v--,h.charAt(v)===$}return S.charAt(S.length-1)!==$&&(S+=$),h.indexOf(S)===0}e.$Xf=u;function c(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Yf=c;function i(h,S){return F.$j&&h.endsWith(":")&&(h+=I.sep),(0,I.$hc)(h)||(h=(0,I.$ic)(S,h)),h=(0,I.$gc)(h),F.$j?(h=(0,f.$Ke)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,f.$Ke)(h,I.sep),h||(h=I.sep)),h}e.$Zf=i;function s(h){const S=(0,I.$gc)(h);return F.$j?h.length>3?!1:r(S)&&(h.length===2||S.charCodeAt(2)===92):S===I.$fc.sep}e.$1f=s;function r(h,S=F.$j){return S?c(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$2f=r;function o(h,S=F.$j){return r(h,S)?h[0]:void 0}e.$3f=o;function t(h,S,k){return S.length>h.length?-1:h===S?0:(k&&(h=h.toLowerCase(),S=S.toLowerCase()),h.indexOf(S))}e.$4f=t;function n(h){const S=h.split(":");let k,$,b;for(const v of S){const C=Number(v);(0,L.$Cf)(C)?$===void 0?$=C:b===void 0&&(b=C):k=k?[k,v].join(":"):v}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:$!==void 0?$:void 0,column:b!==void 0?b:$!==void 0?1:void 0}}e.$5f=n;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,S,k=8){let $="";for(let v=0;v<k;v++){let C;v===0&&F.$j&&!S&&(k===3||k===4)?C=l:C=d,$+=C.charAt(Math.floor(Math.random()*C.length))}let b;return S?b=`${S}-${$}`:b=$,h?(0,I.$ic)(h,b):b}e.$6f=a}),define(Se[129],De([1,0,128,123,52,16,12,13]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=void 0;const E=0,m=[E,[]];function A(V,q,de,x){if(!V||!q)return m;const Q=V.length,G=q.length;if(Q<G)return m;const ce=V.toLowerCase();return P(q,de,G,V,ce,Q,x)}e.$xq=A;function P(V,q,de,x,Q,G,ce){const ie=[],ae=[];for(let X=0;X<de;X++){const re=X*G,Z=re-G,ee=X>0,_=V[X],we=q[X];for(let ue=0;ue<G;ue++){const ge=ue>0,te=re+ue,fe=te-1,be=Z+ue-1,Pe=ge?ie[fe]:0,B=ee&&ge?ie[be]:0,J=ee&&ge?ae[be]:0;let se;!B&&ee?se=0:se=g(_,we,x,Q,ue,J),se&&B+se>=Pe&&(ce||ee||Q.startsWith(q,ue))?(ae[te]=J+1,ie[te]=B+se):(ae[te]=E,ie[te]=Pe)}}const ye=[];let H=de-1,z=G-1;for(;H>=0&&z>=0;){const X=H*G+z;ae[X]===E||(ye.push(z),H--),z--}return[ie[de*G-1],ye.reverse()]}function g(V,q,de,x,Q,G){let ce=0;if(!y(q,x[Q]))return ce;if(ce+=1,G>0&&(ce+=G*5),V===de[Q]&&(ce+=1),Q===0)ce+=8;else{const ie=D(de.charCodeAt(Q-1));ie?ce+=ie:(0,F.$Gj)(de.charCodeAt(Q))&&G===0&&(ce+=2)}return ce}function y(V,q){return V===q?!0:V==="/"||V==="\\"?q==="/"||q==="\\":!1}function D(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function u(V,q,de=0,x=0){const Q=q;return Q.values&&Q.values.length>1?c(V,Q.values,de,x):i(V,q,de,x)}e.$yq=u;function c(V,q,de,x){let Q=0;const G=[];for(const ce of q){const[ie,ae]=i(V,ce,de,x);if(typeof ie!="number")return w;Q+=ie,G.push(...ae)}return[Q,k(G)]}function i(V,q,de,x){const Q=(0,F.$Pj)(q.original,q.originalLowercase,de,V,V.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$Mj)(Q)]:w}const s=Object.freeze({score:0}),r=1<<18,o=1<<17,t=1<<16;function n(V,q,de,x){const Q=x.values?x.values:[x];return(0,f.$Di)({[x.normalized]:{values:Q.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:V,description:q,allowNonContiguousMatches:de}})}function d(V,q,de,x,Q){if(!V||!q.normalized)return s;const G=x.getItemLabel(V);if(!G)return s;const ce=x.getItemDescription(V),ie=n(G,ce,de,q),ae=Q[ie];if(ae)return ae;const ye=l(G,ce,x.getItemPath(V),q,de);return Q[ie]=ye,ye}e.$zq=d;function l(V,q,de,x,Q){const G=!de||!x.containsPathSeparator;return de&&(R.$l?x.pathNormalized===de:(0,p.$2e)(x.pathNormalized,de))?{score:r,labelMatch:[{start:0,end:V.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:x.values&&x.values.length>1?a(V,q,de,x.values,G,Q):h(V,q,de,x,G,Q)}function a(V,q,de,x,Q,G){let ce=0;const ie=[],ae=[];for(const ye of x){const{score:H,labelMatch:z,descriptionMatch:X}=h(V,q,de,ye,Q,G);if(H===E)return s;ce+=H,z&&ie.push(...z),X&&ae.push(...X)}return{score:ce,labelMatch:k(ie),descriptionMatch:k(ae)}}function h(V,q,de,x,Q,G){if(Q||!q){const[ce,ie]=A(V,x.normalized,x.normalizedLowercase,G&&!x.expectContiguousMatch);if(ce){const ae=(0,F.$Dj)(x.normalized,V);let ye;if(ae){ye=o;const H=Math.round(x.normalized.length/V.length*100);ye+=H}else ye=t;return{score:ye+ce,labelMatch:ae||S(ie)}}}if(q){let ce=q;de&&(ce=`${q}${L.sep}`);const ie=ce.length,ae=`${ce}${V}`,[ye,H]=A(ae,x.normalized,x.normalizedLowercase,G&&!x.expectContiguousMatch);if(ye){const z=S(H),X=[],re=[];return z.forEach(Z=>{Z.start<ie&&Z.end>ie?(X.push({start:0,end:Z.end-ie}),re.push({start:Z.start,end:ie})):Z.start>=ie?X.push({start:Z.start-ie,end:Z.end-ie}):re.push(Z)}),{score:ye,labelMatch:X,descriptionMatch:re}}}return s}function S(V){const q=[];if(!V)return q;let de;for(const x of V)de&&de.end===x?de.end+=1:(de={start:x,end:x+1},q.push(de));return q}function k(V){const q=V.sort((Q,G)=>Q.start-G.start),de=[];let x;for(const Q of q)!x||!$(x,Q)?(x=Q,de.push(Q)):(x.start=Math.min(x.start,Q.start),x.end=Math.max(x.end,Q.end));return de}function $(V,q){return!(V.end<q.start||q.end<V.start)}function b(V,q,de,x,Q,G){const ce=d(V,de,x,Q,G),ie=d(q,de,x,Q,G),ae=ce.score,ye=ie.score;if((ae===r||ye===r)&&ae!==ye)return ae===r?-1:1;if(ae>t||ye>t){if(ae!==ye)return ae>ye?-1:1;if(ae<o&&ye<o){const _=C(ce.labelMatch,ie.labelMatch);if(_!==0)return _}const Z=Q.getItemLabel(V)||"",ee=Q.getItemLabel(q)||"";if(Z.length!==ee.length)return Z.length-ee.length}if(ae!==ye)return ae>ye?-1:1;const H=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,z=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(H&&!z)return-1;if(z&&!H)return 1;const X=v(V,ce,Q),re=v(q,ie,Q);return X&&re&&X!==re?re>X?-1:1:N(V,q,de,Q)}e.$Aq=b;function v(V,q,de){let x=-1,Q=-1;if(q.descriptionMatch&&q.descriptionMatch.length?x=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(x=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(Q=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const G=de.getItemDescription(V);G&&(Q+=G.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(Q=q.descriptionMatch[q.descriptionMatch.length-1].end);return Q-x}function C(V,q){if(!V&&!q||(!V||!V.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!V||!V.length)return 1;const de=V[0].start,Q=V[V.length-1].end-de,G=q[0].start,ie=q[q.length-1].end-G;return Q===ie?0:ie<Q?1:-1}function N(V,q,de,x){const Q=x.getItemLabel(V)||"",G=x.getItemLabel(q)||"",ce=x.getItemDescription(V),ie=x.getItemDescription(q),ae=Q.length+(ce?ce.length:0),ye=G.length+(ie?ie.length:0);if(ae!==ye)return ae-ye;const H=x.getItemPath(V),z=x.getItemPath(q);return H&&z&&H.length!==z.length?H.length-z.length:Q!==G?(0,I.$vq)(Q,G,de.normalized):ce&&ie&&ce!==ie?(0,I.$vq)(ce,ie,de.normalized):H&&z&&H!==z?(0,I.$vq)(H,z,de.normalized):0}function T(V){return V.startsWith('"')&&V.endsWith('"')}const M=" ";function U(V){typeof V!="string"&&(V="");const q=V.toLowerCase(),{pathNormalized:de,normalized:x,normalizedLowercase:Q}=j(V),G=de.indexOf(L.sep)>=0,ce=T(V);let ie;const ae=V.split(M);if(ae.length>1)for(const ye of ae){const H=T(ye),{pathNormalized:z,normalized:X,normalizedLowercase:re}=j(ye);X&&(ie||(ie=[]),ie.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:z,normalized:X,normalizedLowercase:re,expectContiguousMatch:H}))}return{original:V,originalLowercase:q,pathNormalized:de,normalized:x,normalizedLowercase:Q,values:ie,containsPathSeparator:G,expectContiguousMatch:ce}}e.$Bq=U;function j(V){let q;R.$j?q=V.replace(/\//g,L.sep):q=V.replace(/\\/g,L.sep);const de=(0,p.$Me)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:de,normalizedLowercase:de.toLowerCase()}}function O(V){return Array.isArray(V)?U(V.map(q=>q.original).join(M)):U(V.original)}e.$Cq=O}),define(Se[99],De([1,0,16]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const P=(0,I.$nc)(A),g=F[P.toLowerCase()];return g!==void 0?g:R(A)}e.$Tr=L;function R(A){const P=(0,I.$nc)(A);return f[P.toLowerCase()]}e.$Ur=R;function p(A){for(const P in f)if(f[P]===A)return P}e.$Vr=p;const E=/^(.+)\/(.+?)(;.+)?$/;function m(A,P){const g=E.exec(A);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:P?void 0:A}e.$Wr=m}),define(Se[100],De([1,0,12]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var F;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function L(p,...E){const m=E.reduce((g,y)=>(g[y]=!0,g),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(g=>!m[g]).forEach(g=>{for(let y=0;y<A.length;y++)if(g.search(A[y])!==-1){delete p[g];break}})}e.$zl=L;function R(p){p&&(delete p.DEBUG,I.$k&&delete p.DYLD_LIBRARY_PATH,I.$l&&delete p.LD_PRELOAD)}e.$Al=R}),define(Se[2],De([1,0,16,12]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function p(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!f.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!L.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(l,a){return!l&&!a?"file":l}function m(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const A="",P="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,S,k,$,b=!1){typeof a=="object"?(this.scheme=a.scheme||A,this.authority=a.authority||A,this.path=a.path||A,this.query=a.query||A,this.fragment=a.fragment||A):(this.scheme=E(a,b),this.authority=h||A,this.path=m(this.scheme,S||A),this.query=k||A,this.fragment=$||A,p(this,b))}get fsPath(){return r(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:S,path:k,query:$,fragment:b}=a;return h===void 0?h=this.scheme:h===null&&(h=A),S===void 0?S=this.authority:S===null&&(S=A),k===void 0?k=this.path:k===null&&(k=A),$===void 0?$=this.query:$===null&&($=A),b===void 0?b=this.fragment:b===null&&(b=A),h===this.scheme&&S===this.authority&&k===this.path&&$===this.query&&b===this.fragment?this:new u(h,S,k,$,b)}static parse(a,h=!1){const S=g.exec(a);return S?new u(S[2]||A,d(S[4]||A),d(S[5]||A),d(S[7]||A),d(S[9]||A),h):new u(A,A,A,A,A)}static file(a){let h=A;if(F.$j&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const S=a.indexOf(P,2);S===-1?(h=a.substring(2),a=P):(h=a.substring(2,S),a=a.substring(S)||P)}return new u("file",h,a,A,A)}static from(a,h){return new u(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return F.$j&&a.scheme==="file"?S=y.file(I.$ec.join(r(a,!0),...h)).path:S=I.$fc.join(a.path,...h),a.with({path:S})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const h=new u(a);return h._formatted=a.external??null,h._fsPath=a._sep===w?a.fsPath??null:null,h}}else return a}}e.URI=y;function D(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}e.$uc=D;const w=F.$j?1:void 0;class u extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=w),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(l,a,h){let S,k=-1;for(let $=0;$<l.length;$++){const b=l.charCodeAt($);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||a&&b===47||h&&b===91||h&&b===93||h&&b===58)k!==-1&&(S+=encodeURIComponent(l.substring(k,$)),k=-1),S!==void 0&&(S+=l.charAt($));else{S===void 0&&(S=l.substr(0,$));const v=c[b];v!==void 0?(k!==-1&&(S+=encodeURIComponent(l.substring(k,$)),k=-1),S+=v):k===-1&&(k=$)}}return k!==-1&&(S+=encodeURIComponent(l.substring(k))),S!==void 0?S:l}function s(l){let a;for(let h=0;h<l.length;h++){const S=l.charCodeAt(h);S===35||S===63?(a===void 0&&(a=l.substr(0,h)),a+=c[S]):a!==void 0&&(a+=l[h])}return a!==void 0?a:l}function r(l,a){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,F.$j&&(h=h.replace(/\//g,"\\")),h}e.$vc=r;function o(l,a){const h=a?s:i;let S="",{scheme:k,authority:$,path:b,query:v,fragment:C}=l;if(k&&(S+=k,S+=":"),($||k==="file")&&(S+=P,S+=P),$){let N=$.indexOf("@");if(N!==-1){const T=$.substr(0,N);$=$.substr(N+1),N=T.lastIndexOf(":"),N===-1?S+=h(T,!1,!1):(S+=h(T.substr(0,N),!1,!1),S+=":",S+=h(T.substr(N+1),!1,!0)),S+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?S+=h($,!1,!0):(S+=h($.substr(0,N),!1,!0),S+=$.substr(N))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const N=b.charCodeAt(1);N>=65&&N<=90&&(b=`/${String.fromCharCode(N+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const N=b.charCodeAt(0);N>=65&&N<=90&&(b=`${String.fromCharCode(N+32)}:${b.substr(2)}`)}S+=h(b,!0,!1)}return v&&(S+="?",S+=h(v,!1,!1)),C&&(S+="#",S+=a?C:i(C,!1,!1)),S}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(n)?l.replace(n,a=>t(a)):l}}),define(Se[184],De([1,0,2]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$3p=e.$2p=e.$1p=void 0;function F(m){const A=m;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$1p=F;function f(m){const A=[];let P;try{const g=JSON.parse(m.arguments),y=g[g.length-1];y&&y.__$stack&&(g.pop(),P=y.__$stack),A.push(...g)}catch{A.push("Unable to log remote console arguments",m.arguments)}return{args:A,stack:P}}e.$2p=f;function L(m){if(typeof m!="string")return L(f(m).stack);const A=m;if(A){const P=R(A),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(g&&g.length===4)return{uri:I.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$3p=L;function R(m){if(!m)return m;const A=m.indexOf(`
`);return A===-1?m:m.substring(0,A)}function p(m,A){const{args:P,stack:g}=f(m),y=typeof P[0]=="string"&&P.length===1;let D=R(g);D&&(D=`(${D.trim()})`);let w=[];if(typeof P[0]=="string"?D&&y?w=[`%c[${A}] %c${P[0]} %c${D}`,E("blue"),E(""),E("grey")]:w=[`%c[${A}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:w=[`%c[${A}]%`,E("blue"),...P],D&&!y&&w.push(D),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=p;function E(m){return`color: ${m}`}}),define(Se[54],De([1,0,22,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function f(E){return JSON.stringify(E,R)}e.$kh=f;function L(E){let m=JSON.parse(E);return m=p(m),m}e.$lh=L;function R(E,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function p(E,m=0){if(!E||m>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof I.$be||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=p(E[A],m+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=p(E[A],m+1))}return E}e.$mh=p}),define(Se[18],De([1,0,9,12,2]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$7f="vscode-tkn",e.$8f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,P,g){this.a[A]=P,this.b[A]=g}setConnectionToken(A,P){this.c[A]=P}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(u){return I.$Z(u),A}const P=A.authority;let g=this.a[P];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const y=this.b[P],D=this.c[P];let w=`path=${encodeURIComponent(A.path)}`;return typeof D=="string"&&(w+=`&${e.$8f}=${encodeURIComponent(D)}`),f.URI.from({scheme:F.$p?this.d:L.vscodeRemoteResource,authority:`${g}:${y}`,path:this.f,query:w})}}e.$9f=new R,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class p{static{this.a=e.$bg}asBrowserUri(A){const P=this.b(A,$e);return this.uriToBrowserUri(P)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$9f.rewrite(A):A.scheme===L.file&&(F.$n||F.$q&&F.$h.origin===`${L.vscodeFileResource}://${p.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||p.a,query:null,fragment:null}):A}asFileUri(A){const P=this.b(A,$e);return this.uriToFileUri(P)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==p.a?A.authority:null,query:null,fragment:null}):A}b(A,P){return f.URI.isUri(A)?A:f.URI.parse(P.toUrl(A))}}e.$cg=new p;var E;(function(m){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(A.get("3"));const P="vscode-coi";function g(D){let w;typeof D=="string"?w=new URL(D).searchParams:D instanceof URL?w=D.searchParams:f.URI.isUri(D)&&(w=new URL(D.toString(!0)).searchParams);const u=w?.get(P);if(u)return A.get(u)}m.getHeadersFromQuery=g;function y(D,w,u){if(!globalThis.crossOriginIsolated)return;const c=w&&u?"3":u?"2":"1";D instanceof URLSearchParams?D.set(P,c):D[P]=c}m.addSearchParam=y})(E||(e.COI=E={}))}),define(Se[185],De([1,0,158,18,12,2]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class R{constructor(g,y,D){this.id=g,this.dependencies=y,this.callback=D}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,y,D)=>{typeof g!="string"&&(D=y,y=g,g=null),(typeof y!="object"||!Array.isArray(y))&&(D=y,y=null),this.c.push(new R(g,y,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const y=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!y)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(g){return new Promise((y,D)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const u=()=>{w.removeEventListener("load",c),w.removeEventListener("error",i)},c=s=>{u(),y(this.c.pop())},i=s=>{u(),D(s)};w.addEventListener("load",c),w.addEventListener("error",i),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((y,D)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),y(this.c.pop())}catch(w){D(w)}})}async j(g){try{const y=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,u=L.URI.parse(g).fsPath,c=y.readFileSync(u).toString(),i=w.wrap(c.replace(/^#!.*/,""));return new D.Script(i).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function A(P,g,y){if(I.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[P]&&(P=m[P]);const D=`${P}/${g}`;if(E.has(D))return E.get(D);let w;if(/^\w[\w\d+.-]*:\/\//.test(D))w=D;else{const s=`${y&&!f.$p?F.$_f:F.$$f}/${D}`;w=F.$cg.asBrowserUri(s).toString(!0)}const u=p.INSTANCE.load(w);return E.set(D,u),u}else return await new Promise((D,w)=>{$e([P],D,w)})}e.$zC=A}),define(Se[23],De([1,0,33,18,16,12,13,2]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function E(y){return(0,p.$vc)(y,!0)}e.$jg=E;class m{constructor(D){this.a=D}compare(D,w,u=!1){return D===w?0:(0,R.$Ue)(this.getComparisonKey(D,u),this.getComparisonKey(w,u))}isEqual(D,w,u=!1){return D===w?!0:!D||!w?!1:this.getComparisonKey(D,u)===this.getComparisonKey(w,u)}getComparisonKey(D,w=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,w,u=!1){if(D.scheme===w.scheme){if(D.scheme===F.Schemas.file)return I.$Xf(E(D),E(w),this.a(D))&&D.query===w.query&&(u||D.fragment===w.fragment);if((0,e.$Ag)(D.authority,w.authority))return I.$Xf(D.path,w.path,this.a(D),"/")&&D.query===w.query&&(u||D.fragment===w.fragment)}return!1}joinPath(D,...w){return p.URI.joinPath(D,...w)}basenameOrAuthority(D){return(0,e.$sg)(D)||D.authority}basename(D){return f.$fc.basename(D.path)}extname(D){return f.$fc.extname(D.path)}dirname(D){if(D.path.length===0)return D;let w;return D.scheme===F.Schemas.file?w=p.URI.file(f.$lc(E(D))).path:(w=f.$fc.dirname(D.path),D.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),w="/")),D.with({path:w})}normalizePath(D){if(!D.path.length)return D;let w;return D.scheme===F.Schemas.file?w=p.URI.file(f.$gc(E(D))).path:w=f.$fc.normalize(D.path),D.with({path:w})}relativePath(D,w){if(D.scheme!==w.scheme||!(0,e.$Ag)(D.authority,w.authority))return;if(D.scheme===F.Schemas.file){const i=f.$kc(E(D),E(w));return L.$j?I.$Rf(i):i}let u=D.path||"/";const c=w.path||"/";if(this.a(D)){let i=0;for(const s=Math.min(u.length,c.length);i<s&&!(u.charCodeAt(i)!==c.charCodeAt(i)&&u.charAt(i).toLowerCase()!==c.charAt(i).toLowerCase());i++);u=c.substr(0,i)+u.substr(i)}return f.$fc.relative(u,c)}resolvePath(D,w){if(D.scheme===F.Schemas.file){const u=p.URI.file(f.$jc(E(D),w));return D.with({authority:u.authority,path:u.path})}return w=I.$Sf(w),D.with({path:f.$fc.resolve(D.path,w)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,w){return D===w||D!==void 0&&w!==void 0&&(0,R.$2e)(D,w)}hasTrailingPathSeparator(D,w=f.sep){if(D.scheme===F.Schemas.file){const u=E(D);return u.length>I.$Tf(u).length&&u[u.length-1]===w}else{const u=D.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,w=f.sep){return(0,e.$Bg)(D,w)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,w=f.sep){let u=!1;if(D.scheme===F.Schemas.file){const c=E(D);u=c!==void 0&&c.length===I.$Tf(c).length&&c[c.length-1]===w}else{w="/";const c=D.path;u=c.length===1&&c.charCodeAt(c.length-1)===47}return!u&&!(0,e.$Bg)(D,w)?D.with({path:D.path+"/"}):D}}e.$kg=m,e.$lg=new m(()=>!1),e.$mg=new m(y=>y.scheme===F.Schemas.file?!L.$l:!0),e.$ng=new m(y=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function A(y,D){const w=[];for(let u=0;u<y.length;u++){const c=D(y[u]);y.some((i,s)=>s===u?!1:(0,e.$pg)(c,D(i)))||w.push(y[u])}return w}e.$Eg=A;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function D(w){const u=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(s=>{const[r,o]=s.split(":");r&&o&&u.set(r,o)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&u.set(y.META_DATA_MIME,i),u}y.parseMetaData=D})(P||(e.DataUri=P={}));function g(y,D,w){if(D){let u=y.path;return u&&u[0]!==f.$fc.sep&&(u=f.$fc.sep+u),y.with({scheme:w,authority:D,path:u})}return y.with({scheme:w})}e.$Fg=g}),define(Se[8],De([1,0,21,9,4,3,23,12,162]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function m(X){return!!X&&typeof X.then=="function"}e.$Gg=m;function A(X){const re=new I.$Xd,Z=X(re.token),ee=new Promise((_,we)=>{const ue=re.token.onCancellationRequested(()=>{ue.dispose(),re.dispose(),we(new F.$4)});Promise.resolve(Z).then(ge=>{ue.dispose(),re.dispose(),_(ge)},ge=>{ue.dispose(),re.dispose(),we(ge)})});return new class{cancel(){re.cancel()}then(_,we){return ee.then(_,we)}catch(_){return this.then(void 0,_)}finally(_){return ee.finally(_)}}}e.$Hg=A;function P(X,re,Z){return new Promise((ee,_)=>{const we=re.onCancellationRequested(()=>{we.dispose(),ee(Z)});X.then(ee,_).finally(()=>we.dispose())})}e.$Ig=P;function g(X,re){return new Promise((Z,ee)=>{const _=re.onCancellationRequested(()=>{_.dispose(),ee(new F.$4)});X.then(Z,ee).finally(()=>_.dispose())})}e.$Jg=g;async function y(X){let re=-1;const Z=X.map((ee,_)=>ee.then(we=>(re=_,we)));try{return await Promise.race(Z)}finally{X.forEach((ee,_)=>{_!==re&&ee.cancel()})}}e.$Kg=y;function D(X,re,Z){let ee;const _=setTimeout(()=>{ee?.(void 0),Z?.()},re);return Promise.race([X.finally(()=>clearTimeout(_)),new Promise(we=>ee=we)])}e.$Lg=D;function w(X){return new Promise((re,Z)=>{const ee=X();m(ee)?ee.then(re,Z):re(ee)})}e.$Mg=w;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const Z=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Z,Z).then(ee)})}return new Promise((Z,ee)=>{this.b.then(Z,ee)})}return this.a=re(),new Promise((Z,ee)=>{this.a.then(_=>{this.a=null,Z(_)},_=>{this.a=null,ee(_)})})}dispose(){this.f=!0}}e.$Ng=u;class c{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Og=c;class i{constructor(){this.a=new Map}queue(re,Z){const _=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(re)===_&&this.a.delete(re)});return this.a.set(re,_),_}}e.$Pg=i;const s=(X,re)=>{let Z=!0;const ee=setTimeout(()=>{Z=!1,re()},X);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(ee),Z=!1}}},r=X=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,X())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class o{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,Z=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((_,we)=>{this.d=_,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const _=this.g;return this.g=null,_()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Z===E.$Kd?r(ee):s(Z,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=o;class t{constructor(re){this.a=new o(re),this.b=new u}trigger(re,Z){return this.a.trigger(()=>this.b.queue(re),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=t;class n{constructor(){this.a=!1,this.b=new Promise((re,Z)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=n;class d extends n{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Tg=d;function l(X,re){return re?new Promise((Z,ee)=>{const _=setTimeout(()=>{we.dispose(),Z()},X),we=re.onCancellationRequested(()=>{clearTimeout(_),we.dispose(),ee(new F.$4)})}):A(Z=>l(X,Z))}e.$Ug=l;function a(X,re=0,Z){const ee=setTimeout(()=>{X(),Z&&_.dispose()},re),_=(0,L.$Pc)(()=>{clearTimeout(ee),Z?.deleteAndLeak(_)});return Z?.add(_),_}e.$Vg=a;function h(X){const re=[];let Z=0;const ee=X.length;function _(){return Z<ee?X[Z++]():null}function we(ue){ue!=null&&re.push(ue);const ge=_();return ge?ge.then(we):Promise.resolve(re)}return Promise.resolve(null).then(we)}e.$Wg=h;function S(X,re=ee=>!!ee,Z=null){let ee=0;const _=X.length,we=()=>{if(ee>=_)return Promise.resolve(Z);const ue=X[ee++];return Promise.resolve(ue()).then(te=>re(te)?Promise.resolve(te):we())};return we()}e.$Xg=S;function k(X,re=ee=>!!ee,Z=null){if(X.length===0)return Promise.resolve(Z);let ee=X.length;const _=()=>{ee=-1;for(const we of X)we.cancel?.()};return new Promise((we,ue)=>{for(const ge of X)ge.then(te=>{--ee>=0&&re(te)?(_(),we(te)):ee===0&&we(Z)}).catch(te=>{--ee>=0&&(_(),ue(te))})})}e.$Yg=k;class ${constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new f.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((Z,ee)=>{this.f.push({factory:re,c:Z,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const Z=re.factory();Z.then(re.c,re.e),Z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=$;class b extends ${constructor(){super(1)}}e.$1g=b;class v{constructor(){this.a=new de,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$2g=v;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new G;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,Z=R.$lg){const ee=Z.getComparisonKey(re);let _=this.a.get(ee);if(!_){_=new b;const we=this.f++,ue=f.Event.once(_.onDrained)(()=>{_?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(we,ue),this.a.set(ee,_)}return _}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=C;class N{constructor(re,Z){this.a=-1,typeof re=="function"&&typeof Z=="number"&&this.setIfNotSet(re,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},Z)}setIfNotSet(re,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},Z))}}e.$4g=N;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(re,Z){this.cancel(),this.a=setInterval(()=>{re()},Z)}}e.$5g=T;class M{constructor(re,Z){this.b=-1,this.a=re,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=M;class U{constructor(re,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=re,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=U;class j extends M{constructor(re,Z){super(re,Z),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$8g=j;class O extends L.$Rc{constructor(re,Z){super(),this.g=re,this.h=Z,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of re)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=X=>{(0,p.$B)(()=>{if(re)return;const Z=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$0g=(X,re)=>{const Z=requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback(Z))}}}}();class V{constructor(re){this.d=!1,this.a=()=>{try{this.f=re()}catch(Z){this.g=Z}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=V;async function q(X,re,Z){let ee;for(let _=0;_<Z;_++)try{return await X()}catch(we){ee=we,await l(re)}throw ee}e.$_g=q;class de{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,Z,ee){return this.a={taskId:re,cancel:()=>ee?.(),promise:Z},Z.then(()=>this.d(re),()=>this.d(re)),Z}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let Z,ee;const _=new Promise((we,ue)=>{Z=we,ee=ue});this.b={run:re,promise:_,promiseResolve:Z,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=de;class x{constructor(re,Z=()=>Date.now()){this.d=re,this.f=Z,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$bh=x;var Q;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(Q||(Q={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,Z)=>{this.a=re,this.b=Z})}complete(re){return new Promise(Z=>{this.a(re),this.d={outcome:0,value:re},Z()})}error(re){return new Promise(Z=>{this.b(re),this.d={outcome:1,value:re},Z()})}cancel(){return this.error(new F.$4)}}e.$ch=G;var ce;(function(X){async function re(ee){let _;const we=await Promise.all(ee.map(ue=>ue.then(ge=>ge,ge=>{_||(_=ge)})));if(typeof _<"u")throw _;return we}X.settled=re;function Z(ee){return new Promise(async(_,we)=>{try{await ee(_,we)}catch(ue){we(ue)}})}X.withAsyncBody=Z})(ce||(e.Promises=ce={}));var ie;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(ie||(ie={}));class ae{static fromArray(re){return new ae(Z=>{Z.emitMany(re)})}static fromPromise(re){return new ae(async Z=>{Z.emitMany(await re)})}static fromPromises(re){return new ae(async Z=>{await Promise.all(re.map(async ee=>Z.emitOne(await ee)))})}static merge(re){return new ae(async Z=>{await Promise.all(re.map(async ee=>{for await(const _ of ee)Z.emitOne(_)}))})}static{this.EMPTY=ae.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new f.$Nd,queueMicrotask(async()=>{const Z={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(re(Z)),this.j()}catch(ee){this.k(ee)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(re,Z){return new ae(async ee=>{for await(const _ of re)ee.emitOne(Z(_))})}map(re){return ae.map(this,re)}static filter(re,Z){return new ae(async ee=>{for await(const _ of re)Z(_)&&ee.emitOne(_)})}filter(re){return ae.filter(this,re)}static coalesce(re){return ae.filter(re,Z=>!!Z)}coalesce(){return ae.coalesce(this)}static async toPromise(re){const Z=[];for await(const ee of re)Z.push(ee);return Z}toPromise(){return ae.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$dh=ae;class ye extends ae{constructor(re,Z){super(Z),this.l=re}cancel(){this.l.cancel()}}e.$eh=ye;function H(X){const re=new I.$Xd,Z=X(re.token);return new ye(re,async ee=>{const _=re.token.onCancellationRequested(()=>{_.dispose(),re.dispose(),ee.reject(new F.$4)});try{for await(const we of Z){if(re.token.isCancellationRequested)return;ee.emitOne(we)}_.dispose(),re.dispose()}catch(we){_.dispose(),re.dispose(),ee.reject(we)}})}e.$fh=H;class z{constructor(){this.a=new G,this.b=new ae(ee=>{if(re){ee.reject(re);return}return Z&&ee.emitMany(Z),this.d=_=>ee.reject(_),this.f=_=>ee.emitOne(_),this.a.p});let re,Z;this.f=ee=>{Z||(Z=[]),Z.push(ee)},this.d=ee=>{re||(re=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$gh=z}),define(Se[37],De([1,0,19,8,33,28,16,12,13]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function m(){return Object.create(null)}e.$rj=m,e.$sj="**",e.$tj="/";const A="[/\\\\]",P="[^/\\\\]",g=/\//g;function y(de,x){switch(de){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${x?`|${A}${P}+`:""})*?`}}function D(de,x){if(!de)return[];const Q=[];let G=!1,ce=!1,ie="";for(const ae of de){switch(ae){case x:if(!G&&!ce){Q.push(ie),ie="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ie+=ae}return ie&&Q.push(ie),Q}e.$uj=D;function w(de){if(!de)return"";let x="";const Q=D(de,e.$tj);if(Q.every(G=>G===e.$sj))x=".*";else{let G=!1;Q.forEach((ce,ie)=>{if(ce===e.$sj){if(G)return;x+=y(2,ie===Q.length-1)}else{let ae=!1,ye="",H=!1,z="";for(const X of ce){if(X!=="}"&&ae){ye+=X;continue}if(H&&(X!=="]"||!z)){let re;X==="-"?re=X:(X==="^"||X==="!")&&!z?re="^":X===e.$tj?re="":re=(0,E.$Fe)(X),z+=re;continue}switch(X){case"{":ae=!0;continue;case"[":H=!0;continue;case"}":{const Z=`(?:${D(ye,",").map(ee=>w(ee)).join("|")})`;x+=Z,ae=!1,ye="";break}case"]":{x+="["+z+"]",H=!1,z="";break}case"?":x+=P;continue;case"*":x+=y(1);continue;default:x+=(0,E.$Fe)(X)}}ie<Q.length-1&&(Q[ie+1]!==e.$sj||ie+2<Q.length)&&(x+=A)}G=ce===e.$sj})}return x}const u=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),n=function(){return!1},d=function(){return null};function l(de,x){if(!de)return d;let Q;typeof de!="string"?Q=de.pattern:Q=de,Q=Q.trim();const G=`${Q}_${!!x.trimForExclusions}`;let ce=t.get(G);if(ce)return a(ce,de);let ie;return u.test(Q)?ce=S(Q.substr(4),Q):(ie=c.exec(h(Q,x)))?ce=k(ie[1],Q):(x.trimForExclusions?s:i).test(Q)?ce=$(Q,x):(ie=r.exec(h(Q,x)))?ce=b(ie[1].substr(1),Q,!0):(ie=o.exec(h(Q,x)))?ce=b(ie[1],Q,!1):ce=v(Q),t.set(G,ce),a(ce,de)}function a(de,x){if(typeof x=="string")return de;const Q=function(G,ce){return(0,f.$Xf)(G,x.base,!p.$l)?de((0,E.$Je)(G.substr(x.base.length),R.sep),ce):null};return Q.allBasenames=de.allBasenames,Q.allPaths=de.allPaths,Q.basenames=de.basenames,Q.patterns=de.patterns,Q}function h(de,x){return x.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function S(de,x){return function(Q,G){return typeof Q=="string"&&Q.endsWith(de)?x:null}}function k(de,x){const Q=`/${de}`,G=`\\${de}`,ce=function(ae,ye){return typeof ae!="string"?null:ye?ye===de?x:null:ae===de||ae.endsWith(Q)||ae.endsWith(G)?x:null},ie=[de];return ce.basenames=ie,ce.patterns=[x],ce.allBasenames=ie,ce}function $(de,x){const Q=V(de.slice(1,-1).split(",").map(ye=>l(ye,x)).filter(ye=>ye!==d),de),G=Q.length;if(!G)return d;if(G===1)return Q[0];const ce=function(ye,H){for(let z=0,X=Q.length;z<X;z++)if(Q[z](ye,H))return de;return null},ie=Q.find(ye=>!!ye.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const ae=Q.reduce((ye,H)=>H.allPaths?ye.concat(H.allPaths):ye,[]);return ae.length&&(ce.allPaths=ae),ce}function b(de,x,Q){const G=R.sep===R.$fc.sep,ce=G?de:de.replace(g,R.sep),ie=R.sep+ce,ae=R.$fc.sep+de;let ye;return Q?ye=function(H,z){return typeof H=="string"&&(H===ce||H.endsWith(ie)||!G&&(H===de||H.endsWith(ae)))?x:null}:ye=function(H,z){return typeof H=="string"&&(H===ce||!G&&H===de)?x:null},ye.allPaths=[(Q?"*/":"./")+de],ye}function v(de){try{const x=new RegExp(`^${w(de)}$`);return function(Q){return x.lastIndex=0,typeof Q=="string"&&x.test(Q)?de:null}}catch{return d}}function C(de,x,Q){return!de||typeof x!="string"?!1:N(de)(x,void 0,Q)}e.$vj=C;function N(de,x={}){if(!de)return n;if(typeof de=="string"||T(de)){const Q=l(de,x);if(Q===d)return n;const G=function(ce,ie){return!!Q(ce,ie)};return Q.allBasenames&&(G.allBasenames=Q.allBasenames),Q.allPaths&&(G.allPaths=Q.allPaths),G}return j(de,x)}e.$wj=N;function T(de){const x=de;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$xj=T;function M(de){return de.allBasenames||[]}e.$yj=M;function U(de){return de.allPaths||[]}e.$zj=U;function j(de,x){const Q=V(Object.getOwnPropertyNames(de).map(ye=>O(ye,de[ye],x)).filter(ye=>ye!==d)),G=Q.length;if(!G)return d;if(!Q.some(ye=>!!ye.requiresSiblings)){if(G===1)return Q[0];const ye=function(X,re){let Z;for(let ee=0,_=Q.length;ee<_;ee++){const we=Q[ee](X,re);if(typeof we=="string")return we;(0,F.$Gg)(we)&&(Z||(Z=[]),Z.push(we))}return Z?(async()=>{for(const ee of Z){const _=await ee;if(typeof _=="string")return _}return null})():null},H=Q.find(X=>!!X.allBasenames);H&&(ye.allBasenames=H.allBasenames);const z=Q.reduce((X,re)=>re.allPaths?X.concat(re.allPaths):X,[]);return z.length&&(ye.allPaths=z),ye}const ce=function(ye,H,z){let X,re;for(let Z=0,ee=Q.length;Z<ee;Z++){const _=Q[Z];_.requiresSiblings&&z&&(H||(H=(0,R.$mc)(ye)),X||(X=H.substr(0,H.length-(0,R.$nc)(ye).length)));const we=_(ye,H,X,z);if(typeof we=="string")return we;(0,F.$Gg)(we)&&(re||(re=[]),re.push(we))}return re?(async()=>{for(const Z of re){const ee=await Z;if(typeof ee=="string")return ee}return null})():null},ie=Q.find(ye=>!!ye.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const ae=Q.reduce((ye,H)=>H.allPaths?ye.concat(H.allPaths):ye,[]);return ae.length&&(ce.allPaths=ae),ce}function O(de,x,Q){if(x===!1)return d;const G=l(de,Q);if(G===d)return d;if(typeof x=="boolean")return G;if(x){const ce=x.when;if(typeof ce=="string"){const ie=(ae,ye,H,z)=>{if(!z||!G(ae,ye))return null;const X=ce.replace("$(basename)",()=>H),re=z(X);return(0,F.$Gg)(re)?re.then(Z=>Z?de:null):re?de:null};return ie.requiresSiblings=!0,ie}}return G}function V(de,x){const Q=de.filter(ye=>!!ye.basenames);if(Q.length<2)return de;const G=Q.reduce((ye,H)=>{const z=H.basenames;return z?ye.concat(z):ye},[]);let ce;if(x){ce=[];for(let ye=0,H=G.length;ye<H;ye++)ce.push(x)}else ce=Q.reduce((ye,H)=>{const z=H.patterns;return z?ye.concat(z):ye},[]);const ie=function(ye,H){if(typeof ye!="string")return null;if(!H){let X;for(X=ye.length;X>0;X--){const re=ye.charCodeAt(X-1);if(re===47||re===92)break}H=ye.substr(X)}const z=G.indexOf(H);return z!==-1?ce[z]:null};ie.basenames=G,ie.patterns=ce,ie.allBasenames=G;const ae=de.filter(ye=>!ye.basenames);return ae.push(ie),ae}function q(de,x){return(0,I.$tb)(de,x,(Q,G)=>typeof Q=="string"&&typeof G=="string"?Q===G:typeof Q!="string"&&typeof G!="string"?Q.base===G.base&&Q.pattern===G.pattern:!1)}e.$Aj=q}),define(Se[81],De([1,0,9,163,23,13,2]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class E{constructor(c="",i=!1){if(this.value=c,typeof this.value!="string")throw(0,I.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(c,i=0){return this.value+=g(this.supportThemeIcons?(0,F.$Wj)(c):c).replace(/([ \t]+)/g,(s,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,i){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(c,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(c),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(c,i){const s=new RegExp((0,L.$Fe)(i),"g");return c.replace(s,(r,o)=>c.charAt(o-1)!=="\\"?`\\${r}`:r)}}e.$3j=E;function m(u){return A(u)?!u.value:Array.isArray(u)?u.every(m):!0}e.$4j=m;function A(u){return u instanceof E?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$5j=A;function P(u,c){return u===c?!0:!u||!c?!1:u.value===c.value&&u.isTrusted===c.isTrusted&&u.supportThemeIcons===c.supportThemeIcons&&u.supportHtml===c.supportHtml&&(u.baseUri===c.baseUri||!!u.baseUri&&!!c.baseUri&&(0,f.$og)(R.URI.from(u.baseUri),R.URI.from(c.baseUri)))}e.$6j=P;function g(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=g;function y(u){return u.replace(/"/g,"&quot;")}e.$8j=y;function D(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=D;function w(u){const c=[],i=u.split("|").map(r=>r.trim());u=i[0];const s=i[1];if(s){const r=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),t=r?r[1]:"",n=o?o[1]:"",d=isFinite(parseInt(n)),l=isFinite(parseInt(t));d&&c.push(`width="${n}"`),l&&c.push(`height="${t}"`)}return{href:u,dimensions:c}}e.$0j=w}),define(Se[101],De([1,0,19,33,16,12,23,13]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=void 0;function E(l,a){const{os:h,tildify:S,relative:k}=a;if(k){const v=m(l,k,h);if(typeof v=="string")return v}let $=l.fsPath;if(h===1&&!L.$j?$=$.replace(/\//g,"\\"):h!==1&&L.$j&&($=$.replace(/\\/g,"/")),h!==1&&S?.userHome){const v=S.userHome.fsPath;let C;l.scheme!==S.userHome.scheme&&l.path.startsWith(f.$fc.sep)?C=S.userHome.with({path:l.path}).fsPath:C=l.fsPath,$=g(C,v,h)}return(h===1?f.$ec:f.$fc).normalize(A($,h===1))}e.$uv=E;function m(l,a,h){const S=h===1?f.$ec:f.$fc,k=h===3?R.$lg:R.$ng,$=a.getWorkspace(),b=(0,I.$Nb)($.folders);if(!b)return;l.scheme!==b.uri.scheme&&l.path.startsWith(f.$fc.sep)&&(l=b.uri.with({path:l.path}));const v=a.getWorkspaceFolder(l);if(!v)return;let C;if(k.isEqual(v.uri,l)?C="":C=k.relativePath(v.uri,l)??"",C&&(C=S.normalize(C)),$.folders.length>1&&!a.noPrefix){const N=v.name?v.name:k.basenameOrAuthority(v.uri);C=C?`${N} \u2022 ${C}`:N}return C}function A(l,a=L.$j){return(0,F.$2f)(l,a)?l.charAt(0).toUpperCase()+l.slice(1):l}e.$vv=A;let P=Object.create(null);function g(l,a,h=L.OS){if(h===1||!l||!a)return l;let S=P.original===a?P.normalized:void 0;S||(S=a,L.$j&&(S=(0,F.$Rf)(S)),S=`${(0,p.$Ke)(S,f.$fc.sep)}${f.$fc.sep}`,P={original:a,normalized:S});let k=l;return L.$j&&(k=(0,F.$Rf)(k)),(h===3?k.startsWith(S):(0,p.$3e)(k,S))?`~/${k.substr(S.length)}`:l}e.$wv=g;function y(l,a){return l.replace(/^~($|\/|\\)/,`${a}$1`)}e.$xv=y;const D="\u2026",w="\\\\",u="~";function c(l,a=f.sep){const h=new Array(l.length);let S=!1;for(let k=0;k<l.length;k++){const $=l[k];if($===""){h[k]=`.${a}`;continue}if(!$){h[k]=$;continue}S=!0;let b="",v=$;v.indexOf(w)===0?(b=v.substr(0,v.indexOf(w)+w.length),v=v.substr(v.indexOf(w)+w.length)):v.indexOf(a)===0?(b=v.substr(0,v.indexOf(a)+a.length),v=v.substr(v.indexOf(a)+a.length)):v.indexOf(u)===0&&(b=v.substr(0,v.indexOf(u)+u.length),v=v.substr(v.indexOf(u)+u.length));const C=v.split(a);for(let N=1;S&&N<=C.length;N++)for(let T=C.length-N;S&&T>=0;T--){S=!1;let M=C.slice(T,T+N).join(a);for(let U=0;!S&&U<l.length;U++)if(U!==k&&l[U]&&l[U].indexOf(M)>-1){const j=T+N===C.length,O=T>0&&l[U].indexOf(a)>-1?a+M:M,V=l[U].endsWith(O);S=!j||V}if(!S){let U="";(C[0].endsWith(":")||b!=="")&&(T===1&&(T=0,N++,M=C[0]+a+M),T>0&&(U=C[0]+a),U=b+U),T>0&&(U=U+D+a),U=U+M,T+N<C.length&&(U=U+a+D),h[k]=U}}S&&(h[k]=$)}return h}e.$yv=c;var i;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function s(l,a=Object.create(null)){const h=[];let S=!1,k="";for(const $ of l)if($==="$"||S&&$==="{")k&&h.push({value:k,type:i.TEXT}),k="",S=!0;else if($==="}"&&S){const b=a[k];if(typeof b=="string")b.length&&h.push({value:b,type:i.VARIABLE});else if(b){const v=h[h.length-1];(!v||v.type!==i.SEPARATOR)&&h.push({value:b.label,type:i.SEPARATOR})}k="",S=!1}else k+=$;return k&&!S&&h.push({value:k,type:i.TEXT}),h.filter(($,b)=>{if($.type===i.SEPARATOR){const v=h[b-1],C=h[b+1];return[v,C].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$zv=s;function r(l,a){return L.$k||a?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Av=r;function o(l,a){return L.$k||a?l.replace(/\(&&\w\)|&&/g,""):L.$j?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.$Bv=o;function t(l){return l.replace(/&/g,"&&")}e.$Cv=t;function n(l){if(l.endsWith("]")){const a=l.lastIndexOf(" [",l.length-2);if(a!==-1){const h=d(l.substring(0,a));return{name:h.name,parentPath:h.parentPath+l.substring(a)}}}return d(l)}e.$Dv=n;function d(l){const a=l.indexOf("/")!==-1?f.$fc:f.$ec,h=a.basename(l),S=a.dirname(l);return h.length?{name:h,parentPath:S}:{name:S,parentPath:""}}}),define(Se[130],De([1,0,22,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function f(P){return P.toJSON()}class L{constructor(g){this.a=g}transformIncoming(g){const y=this.a.transformIncoming(g);return y===g?g:f(F.URI.from(y))}transformOutgoing(g){const y=this.a.transformOutgoing(g);return y===g?g:f(F.URI.from(y))}transformOutgoingURI(g){const y=this.a.transformOutgoing(g);return y===g?g:F.URI.from(y)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Lm=L,e.$Mm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,g,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof F.URI)return g.transformOutgoing(P);for(const D in P)if(Object.hasOwnProperty.call(P,D)){const w=R(P[D],g,y+1);w!==null&&(P[D]=w)}}return null}function p(P,g){const y=R(P,g,0);return y===null?P:y}e.$Nm=p;function E(P,g,y,D){if(!P||D>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?F.URI.revive(g.transformIncoming(P)):g.transformIncoming(P);if(P instanceof I.$be)return null;for(const w in P)if(Object.hasOwnProperty.call(P,w)){const u=E(P[w],g,y,D+1);u!==null&&(P[w]=u)}}return null}function m(P,g){const y=E(P,g,!1,0);return y===null?P:y}e.$Om=m;function A(P,g){const y=E(P,g,!0,0);return y===null?P:y}e.$Pm=A}),define(Se[30],De([1,0,55,63,383,8,33,77,16,12,23,2]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function y(O,V=g.UNLINK,q){if((0,R.$1f)(O))throw new Error("rimraf - will refuse to recursively delete root");return V===g.UNLINK?w(O):D(O,q)}async function D(O,V=(0,R.$6f)((0,F.tmpdir)())){try{try{await I.promises.rename(O,V)}catch(q){return q.code==="ENOENT"?void 0:w(O)}w(V).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function w(O){return(0,f.promisify)(I.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function u(O){if((0,R.$1f)(O))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function c(O,V){return r(await(V?i(O):(0,f.promisify)(I.readdir)(O)))}async function i(O){try{return await(0,f.promisify)(I.readdir)(O,{withFileTypes:!0})}catch(de){console.warn("[node.js fs] readdir with filetypes failed with error: ",de)}const V=[],q=await c(O);for(const de of q){let x=!1,Q=!1,G=!1;try{const ce=await e.Promises.lstat((0,E.$ic)(O,de));x=ce.isFile(),Q=ce.isDirectory(),G=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}V.push({name:de,isFile:()=>x,isDirectory:()=>Q,isSymbolicLink:()=>G})}return V}function s(O){return r(I.readdirSync(O))}e.readdirSync=s;function r(O){return O.map(V=>typeof V=="string"?m.$k?(0,p.$ol)(V):V:(V.name=m.$k?(0,p.$ol)(V.name):V.name,V))}async function o(O){const V=await c(O),q=[];for(const de of V)await n.existsDirectory((0,E.$ic)(O,de))&&q.push(de);return q}function t(O,V=1e3){return new Promise(q=>{let de=!1;const x=setInterval(()=>{de||(de=!0,I.access(O,Q=>{de=!1,Q&&(clearInterval(x),q(void 0))}))},V)})}e.whenDeleted=t;var n;(function(O){async function V(x){let Q;try{if(Q=await e.Promises.lstat(x),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(m.$j&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ce}throw G}}O.stat=V;async function q(x){try{const{stat:Q,symbolicLink:G}=await O.stat(x);return Q.isFile()&&G?.dangling!==!0}catch{}return!1}O.existsFile=q;async function de(x){try{const{stat:Q,symbolicLink:G}=await O.stat(x);return Q.isDirectory()&&G?.dangling!==!0}catch{}return!1}O.existsDirectory=de})(n||(e.SymlinkSupport=n={}));const d=new L.$3g;function l(O,V,q){return d.queueFor(P.URI.file(O),A.$mg).queue(()=>{const de=$(q);return new Promise((x,Q)=>S(O,V,de,G=>G?Q(G):x()))})}let a=!0;function h(O){a=O}e.configureFlushOnWrite=h;function S(O,V,q,de){if(!a)return I.writeFile(O,V,{mode:q.mode,flag:q.flag},de);I.open(O,q.flag,q.mode,(x,Q)=>{if(x)return de(x);I.writeFile(Q,V,G=>{if(G)return I.close(Q,()=>de(G));I.fdatasync(Q,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),h(!1)),I.close(Q,ie=>de(ie))))})})}function k(O,V,q){const de=$(q);if(!a)return I.writeFileSync(O,V,{mode:de.mode,flag:de.flag});const x=I.openSync(O,de.flag,de.mode);try{I.writeFileSync(x,V);try{I.fdatasyncSync(x)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{I.closeSync(x)}}e.writeFileSync=k;function $(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function b(O,V,q=6e4){if(O!==V)try{m.$j&&typeof q=="number"?await v(O,V,Date.now(),q):await(0,f.promisify)(I.rename)(O,V)}catch(de){if(O.toLowerCase()!==V.toLowerCase()&&de.code==="EXDEV"||O.endsWith("."))await C(O,V,{preserveSymlinks:!1}),await y(O,g.MOVE);else throw de}}async function v(O,V,q,de,x=0){try{return await(0,f.promisify)(I.rename)(O,V)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-q>=de)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Q}`),Q;if(x===0){let G=!1;try{const{stat:ce}=await n.stat(V);ce.isFile()||(G=!0)}catch{}if(G)throw Q}return await(0,L.$Ug)(Math.min(100,x*10)),v(O,V,q,de,x+1)}}async function C(O,V,q){return T(O,V,{root:{source:O,target:V},options:q,handledSourcePaths:new Set})}const N=511;async function T(O,V,q){if(q.handledSourcePaths.has(O))return;q.handledSourcePaths.add(O);const{stat:de,symbolicLink:x}=await n.stat(O);if(x){if(q.options.preserveSymlinks)try{return await j(O,V,q)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(x.dangling)return}return de.isDirectory()?M(O,V,de.mode&N,q):U(O,V,de.mode&N)}async function M(O,V,q,de){await e.Promises.mkdir(V,{recursive:!0,mode:q});const x=await c(O);for(const Q of x)await T((0,E.$ic)(O,Q),(0,E.$ic)(V,Q),de)}async function U(O,V,q){await e.Promises.copyFile(O,V),await e.Promises.chmod(V,q)}async function j(O,V,q){let de=await e.Promises.readlink(O);(0,R.$Xf)(de,q.root.source,!m.$l)&&(de=(0,E.$ic)(q.root.target,de.substr(q.root.source.length+1))),await e.Promises.symlink(de,V)}e.Promises=new class{get access(){return(0,f.promisify)(I.access)}get stat(){return(0,f.promisify)(I.stat)}get lstat(){return(0,f.promisify)(I.lstat)}get utimes(){return(0,f.promisify)(I.utimes)}get read(){return(O,V,q,de,x)=>new Promise((Q,G)=>{I.read(O,V,q,de,x,(ce,ie,ae)=>ce?G(ce):Q({bytesRead:ie,buffer:ae}))})}get readFile(){return(0,f.promisify)(I.readFile)}get write(){return(O,V,q,de,x)=>new Promise((Q,G)=>{I.write(O,V,q,de,x,(ce,ie,ae)=>ce?G(ce):Q({bytesWritten:ie,buffer:ae}))})}get appendFile(){return(0,f.promisify)(I.appendFile)}get fdatasync(){return(0,f.promisify)(I.fdatasync)}get truncate(){return(0,f.promisify)(I.truncate)}get copyFile(){return(0,f.promisify)(I.copyFile)}get open(){return(0,f.promisify)(I.open)}get close(){return(0,f.promisify)(I.close)}get symlink(){return(0,f.promisify)(I.symlink)}get readlink(){return(0,f.promisify)(I.readlink)}get chmod(){return(0,f.promisify)(I.chmod)}get mkdir(){return(0,f.promisify)(I.mkdir)}get unlink(){return(0,f.promisify)(I.unlink)}get rmdir(){return(0,f.promisify)(I.rmdir)}get realpath(){return(0,f.promisify)(I.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return o}get writeFile(){return l}get rm(){return y}get rename(){return b}get copy(){return C}}}),define(Se[102],De([1,0,55,16,12,13,30]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=void 0;function p(g){if(f.$l)return g;const y=(0,F.$lc)(g);if(g===y)return g;const D=((0,F.$mc)(g)||g).toLowerCase();try{const u=(0,R.readdirSync)(y).filter(c=>c.toLowerCase()===D);if(u.length===1){const c=p(y);if(c)return(0,F.$ic)(c,u[0])}else if(u.length>1){const c=u.indexOf(D);if(c>=0){const i=p(y);if(i)return(0,F.$ic)(i,u[c])}}}catch{}return null}e.$8p=p;async function E(g){if(f.$l)return g;const y=(0,F.$lc)(g);if(g===y)return g;const D=((0,F.$mc)(g)||g).toLowerCase();try{const u=(await R.Promises.readdir(y)).filter(c=>c.toLowerCase()===D);if(u.length===1){const c=await E(y);if(c)return(0,F.$ic)(c,u[0])}else if(u.length>1){const c=u.indexOf(D);if(c>=0){const i=await E(y);if(i)return(0,F.$ic)(i,u[c])}}}catch{}return null}e.$9p=E;async function m(g){try{return await R.Promises.realpath(g)}catch{const D=P(g);return await R.Promises.access(D,I.constants.R_OK),D}}e.$0p=m;function A(g){try{return I.realpathSync(g)}catch{const D=P(g);return I.accessSync(D,I.constants.R_OK),D}}e.$$p=A;function P(g){return(0,L.$Ke)((0,F.$gc)(g),F.sep)}}),define(Se[103],De([1,0,16,12,48,100,17,30]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(P=f.env){return P.comspec||"cmd.exe"}e.$Bl=E;function m(P){let g=[],y=!1;const D=function(w){if(y){g.push(w);return}(!P.send(w,c=>{if(c&&console.error(c),y=!1,g.length>0){const i=g.slice(0);g=[],i.forEach(s=>D(s))}})||F.$j)&&(y=!0)};return{send:D}}e.$Cl=m;var A;(function(P){async function g(y,D,w){if(I.$hc(y))return y;if(D===void 0&&(D=f.cwd()),I.$lc(y)!=="."||(w===void 0&&R.$yf(f.env.PATH)&&(w=f.env.PATH.split(I.$sc)),w===void 0||w.length===0))return I.$ic(D,y);async function c(i){if(await p.Promises.exists(i)){let s;try{s=await p.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(s=await p.Promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of w){let s;if(I.$hc(i)?s=I.$ic(i,y):s=I.$ic(D,i,y),await c(s))return s;let r=s+".com";if(await c(r)||(r=s+".exe",await c(r)))return r}return I.$ic(D,y)}P.findExecutable=g})(A||(e.win32=A={}))});var He=this&&this.__decorate||function($e,e,I,F){var f=arguments.length,L=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,I,F);else for(var p=$e.length-1;p>=0;p--)(R=$e[p])&&(L=(f<3?R(L):f>3?R(e,I,L):R(e,I))||L);return f>3&&L&&Object.defineProperty(e,I,L),L};define(Se[82],De([1,0,19,8,22,21,59,9,4,3,54,13,17]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y||(y={}));function D(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(w||(w={}));function u(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(c||(c={}));function i(x){let Q=0;for(let G=0;;G+=7){const ce=x.read(1);if(Q|=(ce.buffer[0]&127)<<G,!(ce.buffer[0]&128))return Q}}const s=d(0);function r(x,Q){if(Q===0){x.write(s);return}let G=0;for(let ie=Q;ie!==0;ie=ie>>>7)G++;const ce=f.$be.alloc(G);for(let ie=0;Q!==0;ie++)ce.buffer[ie]=Q&127,Q=Q>>>7,Q>0&&(ce.buffer[ie]|=128);x.write(ce)}class o{constructor(Q){this.b=Q,this.a=0}read(Q){const G=this.b.slice(this.a,this.a+Q);return this.a+=G.byteLength,G}}e.$nh=o;class t{constructor(){this.a=[]}get buffer(){return f.$be.concat(this.a)}write(Q){this.a.push(Q)}}e.$oh=t;var n;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(n||(n={}));function d(x){const Q=f.$be.alloc(1);return Q.writeUInt8(x,0),Q}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},a=typeof Buffer<"u";function h(x,Q){if(typeof Q>"u")x.write(l.Undefined);else if(typeof Q=="string"){const G=f.$be.fromString(Q);x.write(l.String),r(x,G.byteLength),x.write(G)}else if(a&&Buffer.isBuffer(Q)){const G=f.$be.wrap(Q);x.write(l.Buffer),r(x,G.byteLength),x.write(G)}else if(Q instanceof f.$be)x.write(l.VSBuffer),r(x,Q.byteLength),x.write(Q);else if(Array.isArray(Q)){x.write(l.Array),r(x,Q.length);for(const G of Q)h(x,G)}else if(typeof Q=="number"&&(Q|0)===Q)x.write(l.Uint),r(x,Q);else{const G=f.$be.fromString(JSON.stringify(Q));x.write(l.Object),r(x,G.byteLength),x.write(G)}}e.$ph=h;function S(x){switch(x.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return x.read(i(x)).toString();case n.Buffer:return x.read(i(x)).buffer;case n.VSBuffer:return x.read(i(x));case n.Array:{const G=i(x),ce=[];for(let ie=0;ie<G;ie++)ce.push(S(x));return ce}case n.Object:return JSON.parse(x.read(i(x)).toString());case n.Int:return i(x)}}e.$qh=S;class k{constructor(Q,G,ce=null,ie=1e3){this.h=Q,this.j=G,this.k=ce,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(Q,G){this.b.set(Q,G),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const G=this.o([Q.type]);this.k?.logOutgoing(G,0,1,u(Q.type));return}case 201:case 202:case 204:case 203:{const G=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(G,Q.id,1,u(Q.type),Q.data);return}}}o(Q,G=void 0){const ce=new t;return h(ce,Q),h(ce,G),this.p(ce.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const G=new o(Q),ce=S(G),ie=S(G),ae=ce[0];switch(ae){case 100:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${D(ae)}: ${ce[2]}.${ce[3]}`,ie),this.s({type:ae,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 102:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${D(ae)}: ${ce[2]}.${ce[3]}`,ie),this.t({type:ae,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 101:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${D(ae)}`),this.u({type:ae,id:ce[1]});case 103:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${D(ae)}`),this.u({type:ae,id:ce[1]})}}s(Q){const G=this.b.get(Q.channelName);if(!G){this.v(Q);return}const ce=new L.$Xd;let ie;try{ie=G.call(this.j,Q.name,Q.arg,ce.token)}catch(H){ie=Promise.reject(H)}const ae=Q.id;ie.then(H=>{this.m({id:ae,data:H,type:201})},H=>{H instanceof Error?this.m({id:ae,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ae,data:H,type:203})}).finally(()=>{ye.dispose(),this.d.delete(Q.id)});const ye=(0,m.$Pc)(()=>ce.cancel());this.d.set(Q.id,ye)}t(Q){const G=this.b.get(Q.channelName);if(!G){this.v(Q);return}const ce=Q.id,ae=G.listen(this.j,Q.name,Q.arg)(ye=>this.m({id:ce,data:ye,type:204}));this.d.set(Q.id,ae)}u(Q){const G=this.d.get(Q.id);G&&(G.dispose(),this.d.delete(Q.id))}v(Q){let G=this.g.get(Q.channelName);G||(G=[],this.g.set(Q.channelName,G));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:Q,timeoutTimer:ce})}w(Q){const G=this.g.get(Q);if(G){for(const ce of G)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$Mc)(this.d.values()),this.d.clear()}}e.$rh=k;var $;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class b{constructor(Q,G=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=G}getChannel(Q){const G=this;return{call(ce,ie,ae){return G.a?Promise.reject(new p.$4):G.m(Q,ce,ie,ae)},listen(ce,ie){return G.a?E.Event.None:G.o(Q,ce,ie)}}}m(Q,G,ce,ie=L.CancellationToken.None){const ae=this.g++,H={id:ae,type:100,channelName:Q,name:G,arg:ce};if(ie.isCancellationRequested)return Promise.reject(new p.$4);let z;return new Promise((re,Z)=>{if(ie.isCancellationRequested)return Z(new p.$4);const ee=()=>{const ge=te=>{switch(te.type){case 201:this.f.delete(ae),re(te.data);break;case 202:{this.f.delete(ae);const fe=new Error(te.data.message);fe.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,fe.name=te.data.name,Z(fe);break}case 203:this.f.delete(ae),Z(te.data);break}};this.f.set(ae,ge),this.p(H)};let _=null;this.b===c.Idle?ee():(_=(0,F.$Hg)(ge=>this.u()),_.then(()=>{_=null,ee()}));const we=()=>{_?(_.cancel(),_=null):this.p({id:ae,type:101}),Z(new p.$4)},ue=ie.onCancellationRequested(we);z=(0,m.$Oc)((0,m.$Pc)(we),ue),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(Q,G,ce){const ie=this.g++,ye={id:ie,type:102,channelName:Q,name:G,arg:ce};let H=null;const z=new E.$Nd({onWillAddFirstListener:()=>{H=(0,F.$Hg)(re=>this.u()),H.then(()=>{H=null,this.d.add(z),this.p(ye)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(z),this.p({id:ie,type:103}))}}),X=re=>z.fire(re.data);return this.f.set(ie,X),z.event}p(Q){switch(Q.type){case 100:case 102:{const G=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(G,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const G=this.q([Q.type,Q.id]);this.j?.logOutgoing(G,Q.id,0,D(Q.type));return}}}q(Q,G=void 0){const ce=new t;return h(ce,Q),h(ce,G),this.r(ce.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const G=new o(Q),ce=S(G),ie=S(G),ae=ce[0];switch(ae){case 200:return this.j?.logIncoming(Q.byteLength,0,0,u(ae)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ce[1],0,u(ae),ie),this.t({type:ce[0],id:ce[1],data:ie})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$Mc)(this.d.values()),this.d.clear()}}e.$sh=b,He([R.$hh],b.prototype,"onDidInitializePromise",null);class v{get connections(){const Q=[];return this.f.forEach(G=>Q.push(G)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new E.$Nd,this.onDidAddConnection=this.g.event,this.h=new E.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new m.$Qc,this.j.add(Q(({protocol:G,onDidClientDisconnect:ce})=>{const ie=E.Event.once(G.onMessage);this.j.add(ie(ae=>{const ye=new o(ae),H=S(ye),z=new k(G,H),X=new b(G);this.a.forEach((Z,ee)=>z.registerChannel(ee,Z));const re={channelServer:z,channelClient:X,ctx:H};this.f.add(re),this.g.fire(re),this.j.add(ce(()=>{z.dispose(),X.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(Q,G){const ce=this;return{call(ie,ae,ye){let H;if((0,g.$Mf)(G)){const X=(0,I.$3b)(ce.connections.filter(G));H=X?Promise.resolve(X):E.Event.toPromise(E.Event.filter(ce.onDidAddConnection,G))}else H=G.routeCall(ce,ie,ae);const z=H.then(X=>X.channelClient.getChannel(Q));return N(z).call(ie,ae,ye)},listen(ie,ae){if((0,g.$Mf)(G))return ce.k(Q,G,ie,ae);const ye=G.routeEvent(ce,ie,ae).then(H=>H.channelClient.getChannel(Q));return N(ye).listen(ie,ae)}}}k(Q,G,ce,ie){const ae=this;let ye;const H=new E.$Nd({onWillAddFirstListener:()=>{ye=new m.$Qc;const z=new E.$Td,X=new Map,re=ee=>{const we=ee.channelClient.getChannel(Q).listen(ce,ie),ue=z.add(we);X.set(ee,ue)},Z=ee=>{const _=X.get(ee);_&&(_.dispose(),X.delete(ee))};ae.connections.filter(G).forEach(re),E.Event.filter(ae.onDidAddConnection,G)(re,void 0,ye),ae.onDidRemoveConnection(Z,void 0,ye),z.event(H.fire,H,ye),ye.add(z)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return H.event}registerChannel(Q,G){this.a.set(Q,G);for(const ce of this.f)ce.channelServer.registerChannel(Q,G)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=v;class C{constructor(Q,G,ce=null){const ie=new t;h(ie,G),Q.send(ie.buffer),this.a=new b(Q,ce),this.d=new k(Q,G,ce)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,G){this.d.registerChannel(Q,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=C;function N(x){return{call(Q,G,ce){return x.then(ie=>ie.call(Q,G,ce))},listen(Q,G){const ce=new E.$Wd;return x.then(ie=>ce.input=ie.listen(Q,G)),ce.event}}}e.$vh=N;function T(x){let Q=!1;return{call(G,ce,ie){return Q?x.call(G,ce,ie):(0,F.$Ug)(0).then(()=>Q=!0).then(()=>x.call(G,ce,ie))},listen(G,ce){if(Q)return x.listen(G,ce);const ie=new E.$Wd;return(0,F.$Ug)(0).then(()=>Q=!0).then(()=>ie.input=x.listen(G,ce)),ie.event}}}e.$wh=T;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const G of Q.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await E.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$xh=M;var U;(function(x){function Q(ae,ye,H){const z=ae,X=H&&H.disableMarshalling,re=new Map;for(const Z in z)ce(Z)&&re.set(Z,E.Event.buffer(z[Z],!0,void 0,ye));return new class{listen(Z,ee,_){const we=re.get(ee);if(we)return we;if(ie(ee)){const ue=z[ee];if(typeof ue=="function")return ue.call(z,_)}throw new p.$ab(`Event not found: ${ee}`)}call(Z,ee,_){const we=z[ee];if(typeof we=="function"){if(!X&&Array.isArray(_))for(let ge=0;ge<_.length;ge++)_[ge]=(0,A.$mh)(_[ge]);let ue=we.apply(z,_);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new p.$ab(`Method not found: ${ee}`)}}}x.fromService=Q;function G(ae,ye){const H=ye&&ye.disableMarshalling;return new Proxy({},{get(z,X){if(typeof X=="string")return ye?.properties?.has(X)?ye.properties.get(X):ie(X)?function(re){return ae.listen(X,re)}:ce(X)?ae.listen(X):async function(...re){let Z;ye&&!(0,g.$Hf)(ye.context)?Z=[ye.context,...re]:Z=re;const ee=await ae.call(X,Z);return H?ee:(0,A.$mh)(ee)};throw new p.$ab(`Property not found: ${String(X)}`)}})}x.toService=G;function ce(ae){return ae[0]==="o"&&ae[1]==="n"&&P.$1e(ae.charCodeAt(2))}function ie(ae){return/^onDynamic/.test(ae)&&P.$1e(ae.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Q=x.toString();if(Q!=="[object Object]")return Q}return x}function V(x){return Array.isArray(x)?x.map(O):O(x)}function q(x,Q,G,ce,ie,ae,ye){ye=V(ye);const H=j[ie],z=H[ce%H.length];let X=[`%c[${x}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(ae)?(X=X.concat(ye),X.push(")")):X.push(ye),console.log.apply(console,X)}class de{constructor(Q,G){this.d=Q,this.f=G,this.a=0,this.b=0}logOutgoing(Q,G,ce,ie,ae){this.b+=Q,q(this.d,this.b,Q,G,ce,ie,ae)}logIncoming(Q,G,ce,ie,ae){this.a+=Q,q(this.f,this.a,Q,G,ce,ie,ae)}}e.$yh=de}),define(Se[83],De([1,0,22,4,3,82]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var p;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let h=0;function S($,b){if(!a.has($)){const v=String(++h);a.set($,v)}return a.get($)}function k($,b,v,C){if(!l.enableDiagnostics)return;const N=S($,b);if(C instanceof I.$be||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const T=I.$be.alloc(C.byteLength);T.set(C),l.records.push({timestamp:Date.now(),id:N,label:b,type:v,buff:T})}else l.records.push({timestamp:Date.now(),id:N,label:b,type:v,data:C})}l.traceSocketEvent=k})(p||(e.SocketDiagnostics=p={}));var E;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let m=null;function A(){return m||(m=I.$be.alloc(0)),m}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,h){if(a===0)return A();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const b=this.a[0];return h&&(this.a.shift(),this.b-=a),b}if(this.a[0].byteLength>a){const b=this.a[0].slice(0,a);return h&&(this.a[0]=this.a[0].slice(a),this.b-=a),b}const S=I.$be.alloc(a);let k=0,$=0;for(;a>0;){const b=this.a[$];if(b.byteLength>a){const v=b.slice(0,a);S.set(v,k),k+=a,h&&(this.a[$]=b.slice(a),this.b-=a),a-=a}else S.set(b,k),k+=b.byteLength,h?(this.a.shift(),this.b-=b.byteLength):$++,a-=b.byteLength}return S}}e.$zh=P;var g;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(g||(g={}));function y(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class w{constructor(a,h,S,k){this.type=a,this.id=h,this.ack=S,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends f.$Rc{constructor(a){super(),this.f=this.B(new F.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,k=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(S,k,$,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=I.$be.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(h,a.data)}g(a,h){const S=this.f===0;return this.d.push(a,h),this.f+=a.byteLength+h.byteLength,S}h(){const a=I.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,h){this.g(a,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends f.$Rc{constructor(a){super(),this.f=new F.$Nd,this.onMessage=this.f.event,this.g=new F.$Nd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new c(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new w(1,0,0,a))}}e.$Ah=i;class s extends L.$uh{static fromSocket(a,h){return new s(new i(a),h)}get onDidDispose(){return this.b.onDidDispose}constructor(a,h,S=null){super(a,h,S),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Bh=s;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Ch=r;class o{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,h=this.a;for(;h;)h=h.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let h=0,S=this.a;for(;S;)a[h++]=S.data,S=S.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const h=new o(a);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let h=0;h<n.a;h++)this.c[h]=a-1e3*h;setInterval(()=>{for(let h=n.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),h=(1+n.a)*1e3;let S=0;for(let k=0;k<n.a;k++)a-this.c[k]<=h&&S++;return 1-S/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??n.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Qc,this.o=a.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new w(5,0,0,A());this.p.write(a),this.p.flush()}sendPause(){const a=new w(7,0,0,A());this.p.write(a)}sendResume(){const a=new w(8,0,0,A());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,h){this.a=!0,this.r.dispose(),this.r=new f.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new w(3,0,this.h,A());this.p.write(a);const h=this.b.toArray();for(let S=0,k=h.length;S<k;S++)this.p.write(h[S]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const h=this.b.peek();if(h&&h.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let S=0,k=h.length;S<k;S++)this.p.write(h[S]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const h=++this.c;this.h=this.g;const S=new w(1,h,this.h,a);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(a){const h=new w(2,0,0,a);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),h=Date.now()-a.writtenTime,S=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(h>=2e4&&S>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:S});return}const $=Math.max(2e4-h,2e4-S,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new w(3,0,this.h,A());this.p.write(a)}D(){this.h=this.g;const a=new w(9,0,this.h,A());this.p.write(a)}}e.$Dh=d}),define(Se[186],De([1,0,49,8,22,21,184,9,4,3,24,103,100,82]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class D extends y.$rh{constructor(c){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",i=>f.$be.wrap(Buffer.from(i,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$5p=D;class w{constructor(c,i){this.i=c,this.j=i,this.c=new Set,this.g=new Map,this.h=new E.$Nd,this.onDidProcessExit=this.h.event;const s=i&&i.timeout?i.timeout:6e4;this.b=new F.$Qg(s),this.d=null,this.f=null}getChannel(c){const i=this;return{call(s,r,o){return i.k(c,s,r,o)},listen(s,r){return i.l(c,s,r)}}}k(c,i,s,r=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$5());this.b.cancel();const o=this.n(c),t=(0,F.$Hg)(l=>o.call(i,s,l)),n=r.onCancellationRequested(()=>t.cancel()),d=(0,m.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,i,s){if(!this.b)return E.Event.None;this.b.cancel();let r;const o=new E.$Nd({onWillAddFirstListener:()=>{r=this.n(c).listen(i,s)(o.fire,o),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,g.$Al)(i.env),this.d=(0,I.fork)(this.i,c,i);const s=new E.$Nd;E.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,R.$1p)(a)){(0,R.log)(a,`IPC Library: ${this.j.serverName}`);return}s.fire(f.$be.wrap(Buffer.from(a,"base64")))});const o=this.j.useQueue?(0,P.$Cl)(this.d):this.d,t=a=>this.d&&this.d.connected&&o.send(a.buffer.toString("base64")),n=s.event,d={send:t,onMessage:n};this.f=new y.$sh(d);const l=()=>this.o();process.once("exit",l),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,h)=>{process.removeListener("exit",l),this.c.forEach(S=>(0,m.$Mc)(S)),this.c.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:h})})}return this.f}n(c){let i=this.g.get(c);return i||(i=this.m.getChannel(c),this.g.set(c,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6p=w}),define(Se[187],De([1,0,8,4,3,54,17]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.StorageState=e.$4o=e.StorageHint=void 0;var p;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function E(g){const y=g;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$4o=E;var m;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(m||(e.StorageState=m={}));class A extends f.$Rc{static{this.a=100}constructor(y,D=Object.create(null)){super(),this.r=y,this.s=D,this.b=this.B(new F.$Qd),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new I.$Rg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((D,w)=>this.w(w,D)),y.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(y,D){if(this.c===m.Closed)return;let w=!1;(0,R.$Hf)(D)?w=this.f.delete(y):this.f.get(y)!==D&&(this.f.set(y,D),w=!0),w&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,D){const w=this.f.get(y);return(0,R.$Hf)(w)?D:w}getBoolean(y,D){const w=this.get(y);return(0,R.$Hf)(w)?D:w==="true"}getNumber(y,D){const w=this.get(y);return(0,R.$Hf)(w)?D:parseInt(w,10)}getObject(y,D){const w=this.get(y);return(0,R.$Hf)(w)?D:(0,L.$lh)(w)}async set(y,D,w=!1){if(this.c===m.Closed)return;if((0,R.$Hf)(D))return this.delete(y,w);const u=(0,R.$Af)(D)||Array.isArray(D)?(0,L.$kh)(D):String(D);if(this.f.get(y)!==u)return this.f.set(y,u),this.j.set(y,u),this.h.delete(y),this.b.fire({key:y,external:w}),this.D()}async delete(y,D=!1){if(!(this.c===m.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:D}),this.D()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=m.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$5o=A;class P{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((D,w)=>this.a.set(w,D)),y.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$6o=P}),define(Se[188],De([1,0,13,12,22]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let p;function E(){return p||(p=new TextDecoder("UTF-16BE")),p}let m;function A(){return m||(m=F.$D()?R():E()),m}e.$Os=A;function P(D,w,u){const c=new Uint16Array(D.buffer,w,u);return u>0&&(c[0]===65279||c[0]===65534)?g(D,w,u):R().decode(c)}e.$Ps=P;function g(D,w,u){const c=[];let i=0;for(let s=0;s<u;s++){const r=f.$de(D,w);w+=2,c[i++]=String.fromCharCode(r)}return c.join("")}class y{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const u=this.a-this.d;u<=1&&(u===0||I.$6e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const u=w.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=w;return}for(let c=0;c<u;c++)this.b[this.d++]=w.charCodeAt(c)}}e.$Qs=y}),define(Se[189],De([1,0,22,188]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;function f(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(m,A,P,g){this.oldPosition=m,this.oldText=A,this.newPosition=P,this.newText=g}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(m){return 4+2*m.length}static c(m,A,P){const g=A.length;I.$ge(m,g,P),P+=4;for(let y=0;y<g;y++)I.$ee(m,A.charCodeAt(y),P),P+=2;return P}static d(m,A){const P=I.$fe(m,A);return A+=4,(0,F.$Ps)(m,A,P)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(m,A){return I.$ge(m,this.oldPosition,A),A+=4,I.$ge(m,this.newPosition,A),A+=4,A=L.c(m,this.oldText,A),A=L.c(m,this.newText,A),A}static read(m,A,P){const g=I.$fe(m,A);A+=4;const y=I.$fe(m,A);A+=4;const D=L.d(m,A);A+=L.a(D);const w=L.d(m,A);return A+=L.a(w),P.push(new L(g,D,y,w)),A}}e.$Rs=L;function R(E,m){return E===null||E.length===0?m:new p(E,m).compress()}e.$Ss=R;class p{constructor(m,A){this.a=m,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let m=0,A=0,P=this.n(m),g=this.l(A);for(;m<this.f||A<this.h;){if(P===null){this.k(g),g=this.l(++A);continue}if(g===null){this.m(P),P=this.n(++m);continue}if(g.oldEnd<=P.newPosition){this.k(g),g=this.l(++A);continue}if(P.newEnd<=g.oldPosition){this.m(P),P=this.n(++m);continue}if(g.oldPosition<P.newPosition){const[c,i]=p.r(g,P.newPosition-g.oldPosition);this.k(c),g=i;continue}if(P.newPosition<g.oldPosition){const[c,i]=p.q(P,g.oldPosition-P.newPosition);this.m(c),P=i;continue}let w,u;if(g.oldEnd===P.newEnd)w=P,u=g,P=this.n(++m),g=this.l(++A);else if(g.oldEnd<P.newEnd){const[c,i]=p.q(P,g.oldLength);w=c,u=g,P=i,g=this.l(++A)}else{const[c,i]=p.r(g,P.newLength);w=P,u=c,P=this.n(++m),g=i}this.d[this.e++]=new L(w.oldPosition,w.oldText,u.newPosition,u.newText),this.g+=w.newLength-w.oldLength,this.j+=u.newLength-u.oldLength}const y=p.s(this.d);return p.t(y)}k(m){this.d[this.e++]=p.o(this.g,m),this.j+=m.newLength-m.oldLength}l(m){return m<this.h?this.c[m]:null}m(m){this.d[this.e++]=p.p(this.j,m),this.g+=m.newLength-m.oldLength}n(m){return m<this.f?this.a[m]:null}static o(m,A){return new L(A.oldPosition-m,A.oldText,A.newPosition,A.newText)}static p(m,A){return new L(A.oldPosition,A.oldText,A.newPosition+m,A.newText)}static q(m,A){const P=m.newText.substr(0,A),g=m.newText.substr(A);return[new L(m.oldPosition,m.oldText,m.newPosition,P),new L(m.oldEnd,"",m.newPosition+A,g)]}static r(m,A){const P=m.oldText.substr(0,A),g=m.oldText.substr(A);return[new L(m.oldPosition,P,m.newPosition,m.newText),new L(m.oldPosition+A,g,m.newEnd,"")]}static s(m){if(m.length===0)return m;const A=[];let P=0,g=m[0];for(let y=1;y<m.length;y++){const D=m[y];g.oldEnd===D.oldPosition?g=new L(g.oldPosition,g.oldText+D.oldText,g.newPosition,g.newText+D.newText):(A[P++]=g,g=D)}return A[P++]=g,A}static t(m){if(m.length===0)return m;const A=[];let P=0;for(let g=0;g<m.length;g++){const y=m[g];y.oldText!==y.newText&&(A[P++]=y)}return A}}}),define(Se[190],De([1,0,37,16]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=void 0;function f(L,R,p,E,m,A){if(Array.isArray(L)){let P=0;for(const g of L){const y=f(g,R,p,E,m,A);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof L=="string")return E?L==="*"?5:L===p?10:0:0;if(L){const{language:P,pattern:g,scheme:y,hasAccessToAllModels:D,notebookType:w}=L;if(!E&&!D)return 0;w&&m&&(R=m);let u=0;if(y)if(y===R.scheme)u=10;else if(y==="*")u=5;else return 0;if(P)if(P===p)u=10;else if(P==="*")u=Math.max(u,5);else return 0;if(w)if(w===A)u=10;else if(w==="*"&&A!==void 0)u=Math.max(u,5);else return 0;if(g){let c;if(typeof g=="string"?c=g:c={...g,base:(0,F.$gc)(g.base)},c===R.fsPath||(0,I.$vj)(c,R.fsPath))u=10;else return 0}return u}else return 0}}e.$xE=f}),define(Se[191],De([1,0,4,13,29,80,127,166,189,3]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IB=void 0;class A extends m.$Rc{constructor(g,y,D,w,u,c,i){super(),this.m=this.B(new I.$Nd),this.onDidChangeContent=this.m.event,this.f=y,this.j=!c,this.g=w,this.h=u,this.c=new R.$HB(g,D,i)}equals(g){return!(g instanceof A)||this.f!==g.f||this.getEOL()!==g.getEOL()?!1:this.c.equal(g.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(g){return this.c.createSnapshot(g?this.f:"")}getOffsetAt(g,y){return this.c.getOffsetAt(g,y)}getPositionAt(g){return this.c.getPositionAt(g)}getRangeAt(g,y){const D=g+y,w=this.getPositionAt(g),u=this.getPositionAt(D);return new f.$ws(w.lineNumber,w.column,u.lineNumber,u.column)}getValueInRange(g,y=0){if(g.isEmpty())return"";const D=this.n(y);return this.c.getValueInRange(g,D)}getValueLengthInRange(g,y=0){if(g.isEmpty())return 0;if(g.startLineNumber===g.endLineNumber)return g.endColumn-g.startColumn;const D=this.getOffsetAt(g.startLineNumber,g.startColumn),w=this.getOffsetAt(g.endLineNumber,g.endColumn);let u=0;const c=this.n(y),i=this.getEOL();if(c.length!==i.length){const s=c.length-i.length,r=g.endLineNumber-g.startLineNumber;u=s*r}return w-D+u}getCharacterCountInRange(g,y=0){if(this.j){let D=0;const w=g.startLineNumber,u=g.endLineNumber;for(let c=w;c<=u;c++){const i=this.getLineContent(c),s=c===w?g.startColumn-1:0,r=c===u?g.endColumn-1:i.length;for(let o=s;o<r;o++)F.$6e(i.charCodeAt(o))?(D=D+1,o=o+1):D=D+1}return D+=this.n(y).length*(u-w),D}return this.getValueLengthInRange(g,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(g){return this.c.getLineContent(g)}getLineCharCode(g,y){return this.c.getLineCharCode(g,y)}getCharCode(g){return this.c.getCharCode(g)}getLineLength(g){return this.c.getLineLength(g)}getLineMinColumn(g){return 1}getLineMaxColumn(g){return this.getLineLength(g)+1}getLineFirstNonWhitespaceColumn(g){const y=F.$Qe(this.getLineContent(g));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(g){const y=F.$Se(this.getLineContent(g));return y===-1?0:y+2}n(g){switch(g){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(g){this.c.setEOL(g)}applyEdits(g,y,D){let w=this.g,u=this.h,c=this.j,i=!0,s=[];for(let a=0;a<g.length;a++){const h=g[a];i&&h._isTracked&&(i=!1);const S=h.range;if(h.text){let C=!0;c||(C=!F.$ef(h.text),c=C),!w&&C&&(w=F.$df(h.text)),!u&&C&&(u=F.$gf(h.text))}let k="",$=0,b=0,v=0;if(h.text){let C;[$,b,v,C]=(0,p.$9s)(h.text);const N=this.getEOL();C===0||C===(N===`\r
`?2:1)?k=h.text:k=h.text.replace(/\r\n|\r|\n/g,N)}s[a]={sortIndex:a,identifier:h.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:k,eolCount:$,firstLineLength:b,lastLineLength:v,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}s.sort(A.u);let r=!1;for(let a=0,h=s.length-1;a<h;a++){const S=s[a].range.getEndPosition(),k=s[a+1].range.getStartPosition();if(k.isBeforeOrEqual(S)){if(k.isBefore(S))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(s=this.s(s));const o=D||y?A._getInverseEditRanges(s):[],t=[];if(y)for(let a=0;a<s.length;a++){const h=s[a],S=o[a];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let k=S.startLineNumber;k<=S.endLineNumber;k++){let $="";k===S.startLineNumber&&($=this.getLineContent(h.range.startLineNumber),F.$Qe($)!==-1)||t.push({lineNumber:k,oldContent:$})}}let n=null;if(D){let a=0;n=[];for(let h=0;h<s.length;h++){const S=s[h],k=o[h],$=this.getValueInRange(S.range),b=S.rangeOffset+a;a+=S.text.length-$.length,n[h]={sortIndex:S.sortIndex,identifier:S.identifier,range:k,text:$,textChange:new E.$Rs(S.rangeOffset,$,b,S.text)}}r||n.sort((h,S)=>h.sortIndex-S.sortIndex)}this.g=w,this.h=u,this.j=c;const d=this.t(s);let l=null;if(y&&t.length>0){t.sort((a,h)=>h.lineNumber-a.lineNumber),l=[];for(let a=0,h=t.length;a<h;a++){const S=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===S)continue;const k=t[a].oldContent,$=this.getLineContent(S);$.length===0||$===k||F.$Qe($)!==-1||l.push(S)}}return this.m.fire(),new L.$Ru(n,d,l)}s(g){return g.length<1e3?g:[this._toSingleEditOperation(g)]}_toSingleEditOperation(g){let y=!1;const D=g[0].range,w=g[g.length-1].range,u=new f.$ws(D.startLineNumber,D.startColumn,w.endLineNumber,w.endColumn);let c=D.startLineNumber,i=D.startColumn;const s=[];for(let d=0,l=g.length;d<l;d++){const a=g[d],h=a.range;y=y||a.forceMoveMarkers,s.push(this.getValueInRange(new f.$ws(c,i,h.startLineNumber,h.startColumn))),a.text.length>0&&s.push(a.text),c=h.endLineNumber,i=h.endColumn}const r=s.join(""),[o,t,n]=(0,p.$9s)(r);return{sortIndex:0,identifier:g[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,0),text:r,eolCount:o,firstLineLength:t,lastLineLength:n,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(g){g.sort(A.w);const y=[];for(let D=0;D<g.length;D++){const w=g[D],u=w.range.startLineNumber,c=w.range.startColumn,i=w.range.endLineNumber,s=w.range.endColumn;if(u===i&&c===s&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const r=new f.$ws(u,c,i,s);y.push({range:r,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return y}findMatchesLineByLine(g,y,D,w){return this.c.findMatchesLineByLine(g,y,D,w)}getPieceTree(){return this.c}static _getInverseEditRange(g,y){const D=g.startLineNumber,w=g.startColumn,[u,c,i]=(0,p.$9s)(y);let s;if(y.length>0){const r=u+1;r===1?s=new f.$ws(D,w,D,w+c):s=new f.$ws(D,w,D+r-1,i+1)}else s=new f.$ws(D,w,D,w);return s}static _getInverseEditRanges(g){const y=[];let D=0,w=0,u=null;for(let c=0,i=g.length;c<i;c++){const s=g[c];let r,o;u?u.range.endLineNumber===s.range.startLineNumber?(r=D,o=w+(s.range.startColumn-u.range.endColumn)):(r=D+(s.range.startLineNumber-u.range.endLineNumber),o=s.range.startColumn):(r=s.range.startLineNumber,o=s.range.startColumn);let t;if(s.text.length>0){const n=s.eolCount+1;n===1?t=new f.$ws(r,o,r,o+s.firstLineLength):t=new f.$ws(r,o,r+n-1,s.lastLineLength+1)}else t=new f.$ws(r,o,r,o);D=t.endLineNumber,w=t.endColumn,y.push(t),u=s}return y}static u(g,y){const D=f.$ws.compareRangesUsingEnds(g.range,y.range);return D===0?g.sortIndex-y.sortIndex:D}static w(g,y){const D=f.$ws.compareRangesUsingEnds(g.range,y.range);return D===0?y.sortIndex-g.sortIndex:-D}}e.$IB=A}),define(Se[192],De([1,0,13,127,191]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=void 0;class L{constructor(E,m,A,P,g,y,D,w,u){this.a=E,this.b=m,this.c=A,this.d=P,this.e=g,this.f=y,this.g=D,this.h=w,this.j=u}k(E){const m=this.c+this.d+this.e,A=this.c+this.e;return m===0?E===1?`
`:`\r
`:A>m/2?`\r
`:`
`}create(E){const m=this.k(E),A=this.a;if(this.j&&(m===`\r
`&&(this.c>0||this.d>0)||m===`
`&&(this.c>0||this.e>0)))for(let g=0,y=A.length;g<y;g++){const D=A[g].buffer.replace(/\r\n|\r|\n/g,m),w=(0,F.$DB)(D);A[g]=new F.$GB(D,w)}const P=new f.$IB(A,this.b,m,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&I.$mf(E)&&(this.b=I.$lf,E=E.substr(1));const m=E.charCodeAt(E.length-1);m===13||m>=55296&&m<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=m):(this.m(E,!1),this.c=!1,this.d=m)}m(E,m){!m&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const m=(0,F.$EB)(this.e,E);this.a.push(new F.$GB(E,m.lineStarts)),this.f+=m.cr,this.g+=m.lf,this.h+=m.crlf,m.isBasicASCII||(this.l=!1,this.j||(this.j=I.$df(E)),this.k||(this.k=I.$gf(E)))}finish(E=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const m=(0,F.$DB)(E.buffer);E.lineStarts=m,this.d===13&&this.f++}}}e.$JB=R}),define(Se[131],De([1,0,22,12]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$=e.$b$=void 0;var f;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(f||(f={}));function L(P){for(let g=0,y=P.length;g<y;g+=4){const D=P[g+0],w=P[g+1],u=P[g+2],c=P[g+3];P[g+0]=c,P[g+1]=u,P[g+2]=w,P[g+3]=D}}function R(P){const g=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return F.$D()||L(g),I.$be.wrap(g)}function p(P){const g=P.buffer;if(F.$D()||L(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const y=new Uint8Array(g.byteLength);return y.set(g),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(P){const g=new Uint32Array(m(P));let y=0;if(g[y++]=P.id,P.type==="full")g[y++]=1,g[y++]=P.data.length,g.set(P.data,y),y+=P.data.length;else{g[y++]=2,g[y++]=P.deltas.length;for(const D of P.deltas)g[y++]=D.start,g[y++]=D.deleteCount,D.data?(g[y++]=D.data.length,g.set(D.data,y),y+=D.data.length):g[y++]=0}return R(g)}e.$b$=E;function m(P){let g=0;if(g+=1+1,P.type==="full")g+=1+P.data.length;else{g+=1,g+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(g+=y.data.length)}return g}function A(P){const g=p(P);let y=0;const D=g[y++];if(g[y++]===1){const i=g[y++],s=g.subarray(y,y+i);return y+=i,{id:D,type:"full",data:s}}const u=g[y++],c=[];for(let i=0;i<u;i++){const s=g[y++],r=g[y++],o=g[y++];let t;o>0&&(t=g.subarray(y,y+o),y+=o),c[i]={start:s,deleteCount:r,data:t}}return{id:D,type:"delta",deltas:c}}e.$c$=A}),define(Se[193],De([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Se[132],De([1,0,19,24,12,169,126,193]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(le){this.c=le}hasChanged(le){return this.c[le]}}e.ConfigurationChangedEvent=m;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(le,Ie,Ke,ze){this.id=le,this.name=Ie,this.defaultValue=Ke,this.schema=ze}applyUpdate(le,Ie){return y(le,Ie)}compute(le,Ie,Ke){return Ke}}class g{constructor(le,Ie){this.newValue=le,this.didChange=Ie}}e.ApplyUpdateResult=g;function y(he,le){if(typeof he!="object"||typeof le!="object"||!he||!le)return new g(le,he!==le);if(Array.isArray(he)||Array.isArray(le)){const Ke=Array.isArray(he)&&Array.isArray(le)&&I.$tb(he,le);return new g(le,!Ke)}let Ie=!1;for(const Ke in le)if(le.hasOwnProperty(Ke)){const ze=y(he[Ke],le[Ke]);ze.didChange&&(he[Ke]=ze.newValue,Ie=!0)}return new g(he,Ie)}class D{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,Ie){return y(le,Ie)}validate(le){return this.defaultValue}}class w{constructor(le,Ie,Ke,ze){this.id=le,this.name=Ie,this.defaultValue=Ke,this.schema=ze}applyUpdate(le,Ie){return y(le,Ie)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,Ie,Ke){return Ke}}function u(he,le){return typeof he>"u"?le:he==="false"?!1:!!he}e.boolean=u;class c extends w{constructor(le,Ie,Ke,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Ke),super(le,Ie,Ke,ze)}validate(le){return u(le,this.defaultValue)}}function i(he,le,Ie,Ke){if(typeof he>"u")return le;let ze=parseInt(he,10);return isNaN(ze)?le:(ze=Math.max(Ie,ze),ze=Math.min(Ke,ze),ze|0)}e.clampedInt=i;class s extends w{static clampedInt(le,Ie,Ke,ze){return i(le,Ie,Ke,ze)}constructor(le,Ie,Ke,ze,Ye,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ke,nt.minimum=ze,nt.maximum=Ye),super(le,Ie,Ke,nt),this.minimum=ze,this.maximum=Ye}validate(le){return s.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function r(he,le,Ie,Ke){if(typeof he>"u")return le;const ze=o.float(he,le);return o.clamp(ze,Ie,Ke)}e.clampedFloat=r;class o extends w{static clamp(le,Ie,Ke){return le<Ie?Ie:le>Ke?Ke:le}static float(le,Ie){if(typeof le=="number")return le;if(typeof le>"u")return Ie;const Ke=parseFloat(le);return isNaN(Ke)?Ie:Ke}constructor(le,Ie,Ke,ze,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Ke),super(le,Ie,Ke,Ye),this.validationFn=ze}validate(le){return this.validationFn(o.float(le,this.defaultValue))}}class t extends w{static string(le,Ie){return typeof le!="string"?Ie:le}constructor(le,Ie,Ke,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Ke),super(le,Ie,Ke,ze)}validate(le){return t.string(le,this.defaultValue)}}function n(he,le,Ie,Ke){return typeof he!="string"?le:Ke&&he in Ke?Ke[he]:Ie.indexOf(he)===-1?le:he}e.stringSet=n;class d extends w{constructor(le,Ie,Ke,ze,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=ze,Ye.default=Ke),super(le,Ie,Ke,Ye),this.c=ze}validate(le){return n(le,this.defaultValue,this.c)}}class l extends P{constructor(le,Ie,Ke,ze,Ye,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ye,ct.default=ze),super(le,Ie,Ke,ct),this.c=Ye,this.d=nt}validate(le){return typeof le!="string"?this.defaultValue:this.c.indexOf(le)===-1?this.defaultValue:this.d(le)}}function a(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,Ie,Ke){return Ke===0?le.accessibilitySupport:Ke}}class S extends P{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:p.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function $(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function v(he){switch(he){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function C(he){switch(he){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class N extends D{constructor(){super(141)}compute(le,Ie,Ke){const ze=["monaco-editor"];return Ie.get(39)&&ze.push(Ie.get(39)),le.extraEditorClassName&&ze.push(le.extraEditorClassName),Ie.get(73)==="default"?ze.push("mouse-default"):Ie.get(73)==="copy"&&ze.push("mouse-copy"),Ie.get(111)&&ze.push("showUnused"),Ie.get(139)&&ze.push("showDeprecated"),ze.join(" ")}}class T extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(le,Ie,Ke){return Ke&&le.emptySelectionClipboard}}class M extends P{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:p.localize(16,null),included:f.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:p.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class U extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?U.OFF:le==="true"?U.ON:le:le?U.ON:U.OFF}}e.EditorFontLigatures=U;class j extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?j.OFF:le==="true"?j.TRANSLATE:le:le?j.TRANSLATE:j.OFF}compute(le,Ie,Ke){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class O extends D{constructor(){super(50)}compute(le,Ie,Ke){return le.fontInfo}}class V extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(le){const Ie=o.float(le,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ie,6,100)}compute(le,Ie,Ke){return le.fontInfo.fontSize}}class q extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(s.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class de extends P{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:Ke,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:Ke,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:Ke,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:Ke,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:Ke,description:p.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:p.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:s.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:s.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var Q;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class G extends D{constructor(){super(144)}compute(le,Ie,Ke){return G.computeLayout(Ie,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const Ie=le.height/le.lineHeight,Ke=Math.floor(le.paddingTop/le.lineHeight);let ze=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(ze=Math.max(ze,Ie-1));const Ye=(Ke+le.viewLineCount+ze)/(le.pixelRatio*le.height),nt=Math.floor(le.viewLineCount/Ye);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:ze,desiredRatio:Ye,minimapLineCount:nt}}static c(le,Ie){const Ke=le.outerWidth,ze=le.outerHeight,Ye=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const nt=Ie.stableMinimapLayoutInput,ct=nt&&le.outerHeight===nt.outerHeight&&le.lineHeight===nt.lineHeight&&le.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&le.pixelRatio===nt.pixelRatio&&le.scrollBeyondLastLine===nt.scrollBeyondLastLine&&le.paddingTop===nt.paddingTop&&le.paddingBottom===nt.paddingBottom&&le.minimap.enabled===nt.minimap.enabled&&le.minimap.side===nt.minimap.side&&le.minimap.size===nt.minimap.size&&le.minimap.showSlider===nt.minimap.showSlider&&le.minimap.renderCharacters===nt.minimap.renderCharacters&&le.minimap.maxColumn===nt.minimap.maxColumn&&le.minimap.scale===nt.minimap.scale&&le.verticalScrollbarWidth===nt.verticalScrollbarWidth&&le.isViewportWrapping===nt.isViewportWrapping,bt=le.lineHeight,Et=le.typicalHalfwidthCharacterWidth,Kt=le.scrollBeyondLastLine,Ht=le.minimap.renderCharacters;let wt=Ye>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const jt=le.minimap.maxColumn,Nt=le.minimap.size,Gt=le.minimap.side,zt=le.verticalScrollbarWidth,Dt=le.viewLineCount,Ft=le.remainingWidth,Bt=le.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Ye*ze);const qt=Wt/Ye;let Ot=!1,ut=!1,ft=Jt*wt,At=wt/Ye,Vt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Te,desiredRatio:Ce,minimapLineCount:ne}=G.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:ze,lineHeight:bt,pixelRatio:Ye});if(Dt/ne>1)Ot=!0,ut=!0,wt=1,ft=1,At=wt/Ye;else{let Ve=!1,xe=wt+1;if(Nt==="fit"){const Je=Math.ceil((Me+Dt+Te)*ft);Bt&&ct&&Ft<=Ie.stableFitRemainingWidth?(Ve=!0,xe=Ie.stableFitMaxMinimapScale):Ve=Je>Wt}if(Nt==="fill"||Ve){Ot=!0;const Je=wt;ft=Math.min(bt*Ye,Math.max(1,Math.floor(1/Ce))),Bt&&ct&&Ft<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(ft/Jt))),wt>Je&&(Vt=Math.min(2,wt/Je)),At=wt/Ye/Vt,Wt=Math.ceil(Math.max(Qt,Me+Dt+Te)*ft),Bt?(Ie.stableMinimapLayoutInput=le,Ie.stableFitRemainingWidth=Ft,Ie.stableFitMaxMinimapScale=wt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Lt=Math.floor(jt*At),at=Math.min(Lt,Math.max(0,Math.floor((Ft-zt-2)*At/(Et+At)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Ye*at);const Tt=vt/Ye;vt=Math.floor(vt*Vt);const Pt=Ht?1:2,Ge=Gt==="left"?0:Ke-at-zt;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:at,minimapHeightIsEditorHeight:Ot,minimapIsSampling:ut,minimapScale:wt,minimapLineHeight:ft,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:qt}}static computeLayout(le,Ie){const Ke=Ie.outerWidth|0,ze=Ie.outerHeight|0,Ye=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ct=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=le.get(136),wt=Ht==="inherit"?le.get(135):Ht,jt=wt==="inherit"?le.get(131):wt,Nt=le.get(134),Gt=Ie.isDominatedByLongLines,zt=le.get(57),Dt=le.get(67).renderType!==0,Ft=le.get(68),Bt=le.get(105),Jt=le.get(84),Wt=le.get(72),qt=le.get(103),Ot=qt.verticalScrollbarSize,ut=qt.verticalHasArrows,ft=qt.arrowSize,At=qt.horizontalScrollbarSize,Vt=le.get(43),Lt=le.get(110)!=="never";let at=le.get(65);Vt&&Lt&&(at+=16);let vt=0;if(Dt){const kt=Math.max(nt,Ft);vt=Math.round(kt*bt)}let Tt=0;zt&&(Tt=Ye*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Tt,Qt=Ge+vt,Me=Qt+at;const Te=Ke-Tt-vt-at;let Ce=!1,ne=!1,Fe=-1;wt==="inherit"&&Gt?(Ce=!0,ne=!0):jt==="on"||jt==="bounded"?ne=!0:jt==="wordWrapColumn"&&(Fe=Nt);const Ve=G.c({outerWidth:Ke,outerHeight:ze,lineHeight:Ye,typicalHalfwidthCharacterWidth:ct,pixelRatio:Et,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Ot,viewLineCount:Kt,remainingWidth:Te,isViewportWrapping:ne},Ie.memory||new A);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Pt+=Ve.minimapWidth,Ge+=Ve.minimapWidth,Qt+=Ve.minimapWidth,Me+=Ve.minimapWidth);const xe=Te-Ve.minimapWidth,Je=Math.max(1,Math.floor((xe-Ot-2)/ct)),rt=ut?ft:0;return ne&&(Fe=Math.max(1,Je),jt==="bounded"&&(Fe=Math.min(Fe,Nt))),{width:Ke,height:ze,glyphMarginLeft:Pt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:vt,decorationsLeft:Qt,decorationsWidth:at,contentLeft:Me,contentWidth:xe,minimap:Ve,viewportColumn:Je,isWordWrapMinified:Ce,isViewportWrapping:ne,wrappingColumn:Fe,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:At,overviewRuler:{top:rt,width:Ot,height:ze-2*rt,right:0}}}}e.EditorLayoutInfoComputer=G;class ce extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(le){return n(le,"simple",["simple","advanced"])}compute(le,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class ie extends P{constructor(){const le={enabled:!0};super(64,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:p.localize(50,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:u(le.enabled,this.defaultValue.enabled)}}}class ae extends P{constructor(){const le={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:p.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:10,description:p.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:p.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:p.localize(54,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:s.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends P{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:p.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(56,null),p.localize(57,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),p.localize(58,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),p.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:p.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:p.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:p.localize(62,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:s.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class H extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):s.clampedInt(le,this.defaultValue,0,1e3)}compute(le,Ie,Ke){return Ke<0?s.clampedInt(-Ke*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class z extends o{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>o.clamp(le,0,150),{markdownDescription:p.localize(63,null)})}compute(le,Ie,Ke){return le.fontInfo.lineHeight}}class X extends P{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:p.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:p.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(66,null),p.localize(67,null),p.localize(68,null)],default:le.size,description:p.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:p.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:p.localize(71,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:p.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:p.localize(74,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(Ie.scale,1,1,3),maxColumn:s.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(he){return he==="ctrlCmd"?f.$k?"metaKey":"ctrlKey":"altKey"}class Z extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(76,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{top:s.clampedInt(Ie.top,0,0,1e3),bottom:s.clampedInt(Ie.bottom,0,0,1e3)}}}class ee extends P{constructor(){const le={enabled:!0,cycle:!0};super(86,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:p.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:p.localize(78,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class _ extends D{constructor(){super(142)}compute(le,Ie,Ke){return le.pixelRatio}}class we extends P{constructor(){const le={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(79,null),p.localize(80,null),p.localize(81,null)]}];super(89,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:le.strings,description:p.localize(82,null)},comments:{anyOf:Ie,default:le.comments,description:p.localize(83,null)},other:{anyOf:Ie,default:le.other,description:p.localize(84,null)}},default:le,markdownDescription:p.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const Et=le?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!le||typeof le!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:ze}=le,Ye=["on","inline","off"];let nt,ct,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=n(Ie,this.defaultValue.other,Ye),typeof Ke=="boolean"?ct=Ke?"on":"off":ct=n(Ke,this.defaultValue.comments,Ye),typeof ze=="boolean"?bt=ze?"on":"off":bt=n(ze,this.defaultValue.strings,Ye),{other:nt,comments:ct,strings:bt}}}var ue;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(ue||(e.RenderLineNumbersType=ue={}));class ge extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(86,null),p.localize(87,null),p.localize(88,null),p.localize(89,null)],default:"on",description:p.localize(90,null)})}validate(le){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(Ie=4,Ke=le):le==="interval"?Ie=3:le==="relative"?Ie=2:le==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(he){const le=he.get(98);return le==="editable"?he.get(91):le!=="on"}e.filterValidationDecorations=te;class fe extends P{constructor(){const le=[],Ie={type:"number",description:p.localize(91,null)};super(102,"rulers",le,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:p.localize(92,null),format:"color-hex"}}}]},default:le,description:p.localize(93,null)})}validate(le){if(Array.isArray(le)){const Ie=[];for(const Ke of le)if(typeof Ke=="number")Ie.push({column:s.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const ze=Ke;Ie.push({column:s.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ie.sort((Ke,ze)=>Ke.column-ze.column),Ie}return this.defaultValue}}class be extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function Pe(he,le){if(typeof he!="string")return le;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(94,null),p.localize(95,null),p.localize(96,null)],default:"auto",description:p.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(98,null),p.localize(99,null),p.localize(100,null)],default:"auto",description:p.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:p.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:p.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:p.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:le.ignoreHorizontalScrollbarInContentHeight,description:p.localize(105,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le,Ke=s.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=s.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:s.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:s.clampedInt(Ie.verticalSliderSize,ze,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:u(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends P{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:p.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:p.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:p.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:p.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:p.localize(112,null)}})}applyUpdate(le,Ie){let Ke=!1;Ie.allowedCharacters&&le&&(F.$$m(le.allowedCharacters,Ie.allowedCharacters)||(le={...le,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&le&&(F.$$m(le.allowedLocales,Ie.allowedLocales)||(le={...le,allowedLocales:Ie.allowedLocales},Ke=!0));const ze=super.applyUpdate(le,Ie);return Ke?new g(ze.newValue,!0):ze}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{nonBasicASCII:me(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(le.allowedLocales,this.defaultValue.allowedLocales)}}c(le,Ie){if(typeof le!="object"||!le)return Ie;const Ke={};for(const[ze,Ye]of Object.entries(le))Ye===!0&&(Ke[ze]=!0);return Ke}}class se extends P{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:p.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover"],enumDescriptions:[p.localize(114,null),p.localize(115,null)],description:p.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:p.localize(117,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const le={enabled:L.$6r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$6r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:p.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:p.localize(119,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends P{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],default:le.bracketPairs,description:p.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(124,null),p.localize(125,null),p.localize(126,null)],default:le.bracketPairsHorizontal,description:p.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:p.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:p.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(130,null),p.localize(131,null),p.localize(132,null)],default:le.highlightActiveIndentation,description:p.localize(133,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{bracketPairs:me(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(he,le,Ie){const Ke=Ie.indexOf(he);return Ke===-1?le:Ie[Ke]}class Ee extends P{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(134,null),p.localize(135,null)],default:le.insertMode,description:p.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:p.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:p.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:p.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(140,null),p.localize(141,null),p.localize(142,null),p.localize(143,null)],default:le.selectionMode,markdownDescription:p.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:p.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:p.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:p.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:p.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:p.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(183,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(le.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(184,null),p.localize(185,null),p.localize(186,null),p.localize(187,null)],description:p.localize(188,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Xe extends D{constructor(){super(145)}compute(le,Ie,Ke){const ze=Ie.get(144);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends P{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:p.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(191,null),p.localize(192,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:p.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(195,null),p.localize(196,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ie=le;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$k?Ne:f.$l?qe:Ae,fontWeight:"normal",fontSize:f.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(he){return e.editorOptionsRegistry[he.id]=he,he}var Ze;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",he[he.quickSuggestions=89]="quickSuggestions",he[he.quickSuggestionsDelay=90]="quickSuggestionsDelay",he[he.readOnly=91]="readOnly",he[he.readOnlyMessage=92]="readOnlyMessage",he[he.renameOnType=93]="renameOnType",he[he.renderControlCharacters=94]="renderControlCharacters",he[he.renderFinalNewline=95]="renderFinalNewline",he[he.renderLineHighlight=96]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=98]="renderValidationDecorations",he[he.renderWhitespace=99]="renderWhitespace",he[he.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",he[he.roundedSelection=101]="roundedSelection",he[he.rulers=102]="rulers",he[he.scrollbar=103]="scrollbar",he[he.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=105]="scrollBeyondLastLine",he[he.scrollPredominantAxis=106]="scrollPredominantAxis",he[he.selectionClipboard=107]="selectionClipboard",he[he.selectionHighlight=108]="selectionHighlight",he[he.selectOnLineNumbers=109]="selectOnLineNumbers",he[he.showFoldingControls=110]="showFoldingControls",he[he.showUnused=111]="showUnused",he[he.snippetSuggestions=112]="snippetSuggestions",he[he.smartSelect=113]="smartSelect",he[he.smoothScrolling=114]="smoothScrolling",he[he.stickyScroll=115]="stickyScroll",he[he.stickyTabStops=116]="stickyTabStops",he[he.stopRenderingLineAfter=117]="stopRenderingLineAfter",he[he.suggest=118]="suggest",he[he.suggestFontSize=119]="suggestFontSize",he[he.suggestLineHeight=120]="suggestLineHeight",he[he.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",he[he.suggestSelection=122]="suggestSelection",he[he.tabCompletion=123]="tabCompletion",he[he.tabIndex=124]="tabIndex",he[he.unicodeHighlighting=125]="unicodeHighlighting",he[he.unusualLineTerminators=126]="unusualLineTerminators",he[he.useShadowDOM=127]="useShadowDOM",he[he.useTabStops=128]="useTabStops",he[he.wordBreak=129]="wordBreak",he[he.wordSeparators=130]="wordSeparators",he[he.wordWrap=131]="wordWrap",he[he.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=134]="wordWrapColumn",he[he.wordWrapOverride1=135]="wordWrapOverride1",he[he.wordWrapOverride2=136]="wordWrapOverride2",he[he.wrappingIndent=137]="wrappingIndent",he[he.wrappingStrategy=138]="wrappingStrategy",he[he.showDeprecated=139]="showDeprecated",he[he.inlayHints=140]="inlayHints",he[he.editorClassName=141]="editorClassName",he[he.pixelRatio=142]="pixelRatio",he[he.tabFocusMode=143]="tabFocusMode",he[he.layoutInfo=144]="layoutInfo",he[he.wrappingInfo=145]="wrappingInfo",he[he.defaultColorDecorators=146]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(197,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(198,null),""],markdownDescription:p.localize(199,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new s(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(200,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",p.localize(201,null))),ariaRequired:Re(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(203,null),p.localize(204,null),""],description:p.localize(205,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(206,null),p.localize(207,null),""],description:p.localize(208,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(209,null),""],description:p.localize(210,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(211,null),""],description:p.localize(212,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(213,null),p.localize(214,null),""],description:p.localize(215,null)})),autoIndent:Re(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[p.localize(216,null),p.localize(217,null),p.localize(218,null),p.localize(219,null),p.localize(220,null)],description:p.localize(221,null)})),automaticLayout:Re(new c(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(222,null),p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new Y),stickyTabStops:Re(new c(116,"stickyTabStops",!1,{description:p.localize(226,null)})),codeLens:Re(new c(17,"codeLens",!0,{description:p.localize(227,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:p.localize(228,null)})),codeLensFontSize:Re(new s(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(229,null)})),colorDecorators:Re(new c(20,"colorDecorators",!0,{description:p.localize(230,null)})),colorDecoratorActivatedOn:Re(new d(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),colorDecoratorsLimit:Re(new s(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(235,null)})),columnSelection:Re(new c(22,"columnSelection",!1,{description:p.localize(236,null)})),comments:Re(new S),contextmenu:Re(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new c(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(237,null)})),cursorBlinking:Re(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:p.localize(238,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null)],description:p.localize(242,null)})),cursorStyle:Re(new l(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(243,null)})),cursorSurroundingLines:Re(new s(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(244,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(245,null),p.localize(246,null)],markdownDescription:p.localize(247,null)})),cursorWidth:Re(new s(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(248,null)})),disableLayerHinting:Re(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new c(34,"domReadOnly",!1)),dragAndDrop:Re(new c(35,"dragAndDrop",!0,{description:p.localize(249,null)})),emptySelectionClipboard:Re(new T),dropIntoEditor:Re(new it),stickyScroll:Re(new ae),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(250,null),p.localize(251,null),p.localize(252,null)],description:p.localize(253,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new o(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:p.localize(254,null)})),find:Re(new M),fixedOverflowWidgets:Re(new c(42,"fixedOverflowWidgets",!1)),folding:Re(new c(43,"folding",!0,{description:p.localize(255,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(256,null),p.localize(257,null)],description:p.localize(258,null)})),foldingHighlight:Re(new c(45,"foldingHighlight",!0,{description:p.localize(259,null)})),foldingImportsByDefault:Re(new c(46,"foldingImportsByDefault",!1,{description:p.localize(260,null)})),foldingMaximumRegions:Re(new s(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(261,null)})),unfoldOnClickAfterEndOfLine:Re(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(262,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(263,null)})),fontInfo:Re(new O),fontLigatures2:Re(new U),fontSize:Re(new V),fontWeight:Re(new q),fontVariations:Re(new j),formatOnPaste:Re(new c(55,"formatOnPaste",!1,{description:p.localize(264,null)})),formatOnType:Re(new c(56,"formatOnType",!1,{description:p.localize(265,null)})),glyphMargin:Re(new c(57,"glyphMargin",!0,{description:p.localize(266,null)})),gotoLocation:Re(new de),hideCursorInOverviewRuler:Re(new c(59,"hideCursorInOverviewRuler",!1,{description:p.localize(267,null)})),hover:Re(new x),inDiffEditor:Re(new c(61,"inDiffEditor",!1)),letterSpacing:Re(new o(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>o.clamp(he,-5,20),{description:p.localize(268,null)})),lightbulb:Re(new ie),lineDecorationsWidth:Re(new H),lineHeight:Re(new z),lineNumbers:Re(new ge),lineNumbersMinChars:Re(new s(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new c(69,"linkedEditing",!1,{description:p.localize(269,null)})),links:Re(new c(70,"links",!0,{description:p.localize(270,null)})),matchBrackets:Re(new d(71,"matchBrackets","always",["always","near","never"],{description:p.localize(271,null)})),minimap:Re(new X),mouseStyle:Re(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new o(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:p.localize(272,null)})),mouseWheelZoom:Re(new c(75,"mouseWheelZoom",!1,{markdownDescription:p.localize(273,null)})),multiCursorMergeOverlapping:Re(new c(76,"multiCursorMergeOverlapping",!0,{description:p.localize(274,null)})),multiCursorModifier:Re(new l(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[p.localize(275,null),p.localize(276,null)],markdownDescription:p.localize(277,null)})),multiCursorPaste:Re(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(278,null),p.localize(279,null)],markdownDescription:p.localize(280,null)})),multiCursorLimit:Re(new s(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(281,null)})),occurrencesHighlight:Re(new c(81,"occurrencesHighlight",!0,{description:p.localize(282,null)})),multiDocumentOccurrencesHighlight:Re(new c(80,"multiDocumentOccurrencesHighlight",!1,{description:p.localize(283,null)})),overviewRulerBorder:Re(new c(82,"overviewRulerBorder",!0,{description:p.localize(284,null)})),overviewRulerLanes:Re(new s(83,"overviewRulerLanes",3,0,3)),padding:Re(new Z),pasteAs:Re(new tt),parameterHints:Re(new ee),peekWidgetDefaultFocus:Re(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(285,null),p.localize(286,null)],description:p.localize(287,null)})),definitionLinkOpensInPeek:Re(new c(88,"definitionLinkOpensInPeek",!1,{description:p.localize(288,null)})),quickSuggestions:Re(new we),quickSuggestionsDelay:Re(new s(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(289,null)})),readOnly:Re(new c(91,"readOnly",!1)),readOnlyMessage:Re(new be),renameOnType:Re(new c(93,"renameOnType",!1,{description:p.localize(290,null),markdownDeprecationMessage:p.localize(291,null)})),renderControlCharacters:Re(new c(94,"renderControlCharacters",!0,{description:p.localize(292,null),restricted:!0})),renderFinalNewline:Re(new d(95,"renderFinalNewline",f.$l?"dimmed":"on",["off","on","dimmed"],{description:p.localize(293,null)})),renderLineHighlight:Re(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(294,null)],description:p.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Re(new c(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(296,null)})),renderValidationDecorations:Re(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(297,null),p.localize(298,null),p.localize(299,null),""],description:p.localize(300,null)})),revealHorizontalRightPadding:Re(new s(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new c(101,"roundedSelection",!0,{description:p.localize(301,null)})),rulers:Re(new fe),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new s(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(302,null)})),scrollBeyondLastLine:Re(new c(105,"scrollBeyondLastLine",!0,{description:p.localize(303,null)})),scrollPredominantAxis:Re(new c(106,"scrollPredominantAxis",!0,{description:p.localize(304,null)})),selectionClipboard:Re(new c(107,"selectionClipboard",!0,{description:p.localize(305,null),included:f.$l})),selectionHighlight:Re(new c(108,"selectionHighlight",!0,{description:p.localize(306,null)})),selectOnLineNumbers:Re(new c(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(307,null),p.localize(308,null),p.localize(309,null)],description:p.localize(310,null)})),showUnused:Re(new c(111,"showUnused",!0,{description:p.localize(311,null)})),showDeprecated:Re(new c(139,"showDeprecated",!0,{description:p.localize(312,null)})),inlayHints:Re(new ye),snippetSuggestions:Re(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(313,null),p.localize(314,null),p.localize(315,null),p.localize(316,null)],description:p.localize(317,null)})),smartSelect:Re(new je),smoothScrolling:Re(new c(114,"smoothScrolling",!1,{description:p.localize(318,null)})),stopRenderingLineAfter:Re(new s(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Ee),inlineSuggest:Re(new se),inlineCompletionsAccessibilityVerbose:Re(new c(148,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(319,null)})),suggestFontSize:Re(new s(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new s(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new c(121,"suggestOnTriggerCharacters",!0,{description:p.localize(322,null)})),suggestSelection:Re(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(323,null),p.localize(324,null),p.localize(325,null)],description:p.localize(326,null)})),tabCompletion:Re(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),tabIndex:Re(new s(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new J),unusualLineTerminators:Re(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(331,null),p.localize(332,null),p.localize(333,null)],description:p.localize(334,null)})),useShadowDOM:Re(new c(127,"useShadowDOM",!0)),useTabStops:Re(new c(128,"useTabStops",!0,{description:p.localize(335,null)})),wordBreak:Re(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(336,null),p.localize(337,null)],description:p.localize(338,null)})),wordSeparators:Re(new t(130,"wordSeparators",R.$7r,{description:p.localize(339,null)})),wordWrap:Re(new d(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(340,null),p.localize(341,null),p.localize(342,null),p.localize(343,null)],description:p.localize(344,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new s(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(345,null)})),wordWrapOverride1:Re(new d(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new N),defaultColorDecorators:Re(new c(146,"defaultColorDecorators",!1,{markdownDescription:p.localize(346,null)})),pixelRatio:Re(new _),tabFocusMode:Re(new c(143,"tabFocusMode",!1,{markdownDescription:p.localize(347,null)})),layoutInfo:Re(new G),wrappingInfo:Re(new Xe),wrappingIndent:Re(new _e),wrappingStrategy:Re(new ce)}}),define(Se[194],De([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(Se[84],De([1,0,79,2,167,29,177,194]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$nt=e.$mt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$lt=e.$kt=e.SymbolKinds=e.SymbolTag=e.$jt=e.$it=e.SymbolKind=e.$ht=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$gt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ft=e.$et=e.$dt=void 0;class E{constructor(U,j,O){this.offset=U,this.type=j,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$dt=E;class m{constructor(U,j){this.tokens=U,this.endState=j,this._tokenizationResultBrand=void 0}}e.$et=m;class A{constructor(U,j){this.tokens=U,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$ft=A;var P;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var g;(function(M){const U=new Map;U.set(0,I.$Uj.symbolMethod),U.set(1,I.$Uj.symbolFunction),U.set(2,I.$Uj.symbolConstructor),U.set(3,I.$Uj.symbolField),U.set(4,I.$Uj.symbolVariable),U.set(5,I.$Uj.symbolClass),U.set(6,I.$Uj.symbolStruct),U.set(7,I.$Uj.symbolInterface),U.set(8,I.$Uj.symbolModule),U.set(9,I.$Uj.symbolProperty),U.set(10,I.$Uj.symbolEvent),U.set(11,I.$Uj.symbolOperator),U.set(12,I.$Uj.symbolUnit),U.set(13,I.$Uj.symbolValue),U.set(15,I.$Uj.symbolEnum),U.set(14,I.$Uj.symbolConstant),U.set(15,I.$Uj.symbolEnum),U.set(16,I.$Uj.symbolEnumMember),U.set(17,I.$Uj.symbolKeyword),U.set(27,I.$Uj.symbolSnippet),U.set(18,I.$Uj.symbolText),U.set(19,I.$Uj.symbolColor),U.set(20,I.$Uj.symbolFile),U.set(21,I.$Uj.symbolReference),U.set(22,I.$Uj.symbolCustomColor),U.set(23,I.$Uj.symbolFolder),U.set(24,I.$Uj.symbolTypeParameter),U.set(25,I.$Uj.account),U.set(26,I.$Uj.issues);function j(q){let de=U.get(q);return de||(console.info("No codicon found for CompletionItemKind "+q),de=I.$Uj.symbolProperty),de}M.toIcon=j;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function V(q,de){let x=O.get(q);return typeof x>"u"&&!de&&(x=9),x}M.fromString=V})(g||(e.CompletionItemKinds=g={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var D;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var w;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var u;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class c{constructor(U,j,O,V){this.range=U,this.text=j,this.completionKind=O,this.isSnippetText=V}equals(U){return L.$ws.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$gt=c;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var s;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var r;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function o(M){return M&&F.URI.isUri(M.uri)&&L.$ws.isIRange(M.range)&&(L.$ws.isIRange(M.originSelectionRange)||L.$ws.isIRange(M.targetSelectionRange))}e.$ht=o;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$it={[17]:(0,p.localize)(0,null),[16]:(0,p.localize)(1,null),[4]:(0,p.localize)(2,null),[13]:(0,p.localize)(3,null),[8]:(0,p.localize)(4,null),[9]:(0,p.localize)(5,null),[21]:(0,p.localize)(6,null),[23]:(0,p.localize)(7,null),[7]:(0,p.localize)(8,null),[0]:(0,p.localize)(9,null),[11]:(0,p.localize)(10,null),[10]:(0,p.localize)(11,null),[19]:(0,p.localize)(12,null),[5]:(0,p.localize)(13,null),[1]:(0,p.localize)(14,null),[2]:(0,p.localize)(15,null),[20]:(0,p.localize)(16,null),[15]:(0,p.localize)(17,null),[18]:(0,p.localize)(18,null),[24]:(0,p.localize)(19,null),[3]:(0,p.localize)(20,null),[6]:(0,p.localize)(21,null),[14]:(0,p.localize)(22,null),[22]:(0,p.localize)(23,null),[25]:(0,p.localize)(24,null),[12]:(0,p.localize)(25,null)};function n(M,U){return(0,p.localize)(26,null,M,e.$it[U])}e.$jt=n;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var l;(function(M){const U=new Map;U.set(0,I.$Uj.symbolFile),U.set(1,I.$Uj.symbolModule),U.set(2,I.$Uj.symbolNamespace),U.set(3,I.$Uj.symbolPackage),U.set(4,I.$Uj.symbolClass),U.set(5,I.$Uj.symbolMethod),U.set(6,I.$Uj.symbolProperty),U.set(7,I.$Uj.symbolField),U.set(8,I.$Uj.symbolConstructor),U.set(9,I.$Uj.symbolEnum),U.set(10,I.$Uj.symbolInterface),U.set(11,I.$Uj.symbolFunction),U.set(12,I.$Uj.symbolVariable),U.set(13,I.$Uj.symbolConstant),U.set(14,I.$Uj.symbolString),U.set(15,I.$Uj.symbolNumber),U.set(16,I.$Uj.symbolBoolean),U.set(17,I.$Uj.symbolArray),U.set(18,I.$Uj.symbolObject),U.set(19,I.$Uj.symbolKey),U.set(20,I.$Uj.symbolNull),U.set(21,I.$Uj.symbolEnumMember),U.set(22,I.$Uj.symbolStruct),U.set(23,I.$Uj.symbolEvent),U.set(24,I.$Uj.symbolOperator),U.set(25,I.$Uj.symbolTypeParameter);function j(O){let V=U.get(O);return V||(console.info("No codicon found for SymbolKind "+O),V=I.$Uj.symbolProperty),V}M.toIcon=j})(l||(e.SymbolKinds=l={}));class a{static asEditOperation(U){return f.$xs.replace(L.$ws.lift(U.range),U.text)}}e.$kt=a;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(U){switch(U){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(U)}constructor(U){this.value=U}}e.$lt=h;var S;(function(M){function U(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}M.is=U})(S||(e.Command=S={}));var k;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var $;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var b;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var v;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(v||(e.CommentState=v={}));var C;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class N{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$mt=N,e.$nt=new R.$8s;var T;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}))}),define(Se[195],De([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[196],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[197],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Se[198],De([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[199],De([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[200],De([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[201],De([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[202],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Se[203],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(Se[204],De([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[205],De([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Se[206],De([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[207],De([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[208],De([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Se[209],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(Se[210],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[211],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[212],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[213],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[214],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[215],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[216],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[217],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[218],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[219],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[220],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[221],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[222],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[223],De([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[224],De([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Se[225],De([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Se[226],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[227],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[228],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[229],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[230],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[231],De([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[232],De([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[233],De([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[234],De([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[235],De([1,0,9,197]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var f;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(f||(e.TokenType=f={}));function L(...m){switch(m.length){case 1:return(0,F.localize)(0,null,m[0]);case 2:return(0,F.localize)(1,null,m[0],m[1]);case 3:return(0,F.localize)(2,null,m[0],m[1],m[2]);default:return}}const R=(0,F.localize)(3,null),p=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,g=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:g};this.g.push({offset:P,lexeme:g,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),g=E.b.get(P);g?this.k(g):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,g=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const D=this.c.charCodeAt(A);if(P)P=!1;else if(D===47&&!g){A++;break}else D===91?g=!0:D===92?P=!0:D===93&&(g=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=E}),define(Se[236],De([1,0,23,38,200,384]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function E(c){return c=c.trim(),c==="*"||R.test(c)}e.$Oo=E;function m(c){if(!E(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=c.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Po=m;function A(c){if(!c)return null;const i=c.majorBase,s=c.majorMustEqual,r=c.minorBase;let o=c.minorMustEqual;const t=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(i===0||(o=!1),n=!1);let d=0;if(c.preRelease){const l=p.exec(c.preRelease);if(l){const[,a,h,S]=l;d=Date.UTC(Number(a),Number(h)-1,Number(S))}}return{majorBase:i,majorMustEqual:s,minorBase:r,minorMustEqual:o,patchBase:t,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:d}}e.$Qo=A;function P(c,i,s){let r;typeof c=="string"?r=A(m(c)):r=c;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let t;if(typeof s=="string"?t=A(m(s)):t=s,!r||!t)return!1;const n=r.majorBase,d=r.minorBase,l=r.patchBase;let a=t.majorBase,h=t.minorBase,S=t.patchBase;const k=t.notBefore;let $=t.majorMustEqual,b=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:d>h?!0:d<h||o&&o<k?!1:l>=S:(n===1&&a===0&&(!$||!b||!v)&&(a=1,h=0,S=0,$=!0,b=!1,v=!1),n<a?!1:n>a?!$:d<h?!1:d>h?!b:l<S?!1:l>S?!v:!(o&&o<k))}e.$Ro=P;function g(c,i,s,r,o){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof r.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!r.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!u(r.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!u(r.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const l=(0,I.$vg)(s,r.main);(0,I.$pg)(l,s)||t.push([F.default.Warning,f.localize(10,null,l.path,s.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const l=(0,I.$vg)(s,r.browser);(0,I.$pg)(l,s)||t.push([F.default.Warning,f.localize(12,null,l.path,s.path)])}}if(!L.valid(r.version))return t.push([F.default.Error,f.localize(13,null)]),t;const n=[];if(!y(c,i,r,o,n))for(const l of n)t.push([F.default.Error,l]);return t}e.$So=g;function y(c,i,s,r,o){return r||typeof s.main>"u"&&typeof s.browser>"u"?!0:w(c,i,s.engines.vscode,o)}e.$To=y;function D(c,i,s){return c==="*"||w(i,s,c)}e.$Uo=D;function w(c,i,s,r=[]){const o=A(m(s));if(!o)return r.push(f.localize(14,null,s)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return r.push(f.localize(15,null,s)),!1}else if(!o.majorMustEqual)return r.push(f.localize(16,null,s)),!1;return P(c,i,o)?!0:(r.push(f.localize(17,null,c,s)),!1)}function u(c){if(!Array.isArray(c))return!1;for(let i=0,s=c.length;i<s;i++)if(typeof c[i]!="string")return!1;return!0}}),define(Se[104],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class I{constructor(f,L=[],R=!1){this.ctor=f,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Mh=I}),define(Se[105],De([1,0,104]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const F=[];var f;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function L(p,E,m){E instanceof I.$Mh||(E=new I.$Mh(E,[],!!m)),F.push([p,E])}e.$zr=L;function R(){return F}e.$Ar=R}),define(Se[237],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class I{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$eq=I;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const p=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);p.outgoing.set(E.key,E),E.incoming.set(p.key,p)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let p=this.a.get(R);return p||(p=new I(R,L),this.a.set(R,p)),p}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,p]of this.a)L.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const p=new Set([L]),E=this.c(R,p);if(E)return E}}c(L,R){for(const[p,E]of L.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const m=this.c(E,R);if(m)return m;R.delete(p)}}}e.$fq=F}),define(Se[5],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(I||(e._util=I={})),e.$Oh=f("instantiationService");function F(R,p,E){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:R,index:E}):(p[I.DI_DEPENDENCIES]=[{id:R,index:E}],p[I.DI_TARGET]=p)}function f(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const p=function(E,m,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(p,E,A)};return p.toString=()=>R,I.serviceIds.set(R,p),p}e.$Ph=f;function L(R){return R}e.$Qh=L}),define(Se[50],De([1,0,17,2,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,f.$Ph)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof F.URI)}e.$ki=L;function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof F.URI)}e.$li=R;var p;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function E(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=E;function m(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$ni=m;function A(c,i){const s=Object.create(null);for(const r in c)P(s,r,c[r],i);return s}e.$oi=A;function P(c,i,s,r){const o=i.split("."),t=o.pop();let n=c;for(let d=0;d<o.length;d++){const l=o[d];let a=n[l];switch(typeof a){case"undefined":a=n[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${o.slice(0,d+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[t]=s}catch{r(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(n)}`)}else r(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(n)}`)}e.$pi=P;function g(c,i){const s=i.split(".");y(c,s)}e.$qi=g;function y(c,i){const s=i.shift();if(i.length===0){delete c[s];return}if(Object.keys(c).indexOf(s)!==-1){const r=c[s];typeof r=="object"&&!Array.isArray(r)&&(y(r,i),Object.keys(r).length===0&&delete c[s])}}function D(c,i,s){function r(n,d){let l=n;for(const a of d){if(typeof l!="object"||l===null)return;l=l[a]}return l}const o=i.split("."),t=r(c,o);return typeof t>"u"?s:t}e.$ri=D;function w(c,i,s){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in c?I.$Af(c[r])&&I.$Af(i[r])?w(c[r],i[r],s):s&&(c[r]=i[r]):c[r]=i[r])})}e.$si=w;function u(c){return c.replace(/[\[\]]/g,"")}e.$ti=u}),define(Se[42],De([1,0,12,13,235,5,196,9]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",I.$k),E.set("isLinux",I.$l),E.set("isWindows",I.$j),E.set("isWeb",I.$p),E.set("isMacNative",I.$k&&!I.$p),E.set("isEdge",I.$H),E.set("isFirefox",I.$F),E.set("isChrome",I.$E),E.set("isSafari",I.$G);function m(H,z){if(E.get(H)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(H,z)}e.$Li=m;const A=Object.prototype.hasOwnProperty;var P;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const g={regexParsingWithErrorRecovery:!0},y=(0,R.localize)(0,null),D=(0,R.localize)(1,null),w=(0,R.localize)(2,null),u=(0,R.localize)(3,null),c=(0,R.localize)(4,null),i=(0,R.localize)(5,null),s=(0,R.localize)(6,null),r=(0,R.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=g){this.k=z,this.d=new f.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const re=this.D(),Z=re.type===17?i:void 0;throw this.h.push({message:c,offset:re.offset,lexeme:f.$Ki.getLexeme(re),additionalInfo:Z}),o.c}return X}catch(X){if(X!==o.c)throw X;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const X=this.o();z.push(X)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const X=this.s();z.push(X)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const X=this.l();return this.A(1,u),X?.negate()}case 17:return this.z(),C.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const X=this.l();return this.A(1,u),X}case 17:{const X=z.lexeme;if(this.z(),this.y(9)){const Z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Z.type!==10)throw this.B("REGEX",Z);const ee=Z.lexeme,_=ee.lastIndexOf("/"),we=_===ee.length-1?void 0:this.w(ee.substring(_+1));let ue;try{ue=new RegExp(ee.substring(1,_),we)}catch{throw this.B("REGEX",Z)}return O.create(X,ue)}switch(Z.type){case 10:case 19:{const ee=[Z.lexeme];this.z();let _=this.D(),we=0;for(let be=0;be<Z.lexeme.length;be++)Z.lexeme.charCodeAt(be)===40?we++:Z.lexeme.charCodeAt(be)===41&&we--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:we++;break;case 1:we--;break;case 10:case 18:for(let be=0;be<_.lexeme.length;be++)_.lexeme.charCodeAt(be)===40?we++:Z.lexeme.charCodeAt(be)===41&&we--}if(we<0)break;ee.push(f.$Ki.getLexeme(_)),this.z(),_=this.D()}const ue=ee.join(""),ge=ue.lastIndexOf("/"),te=ge===ue.length-1?void 0:this.w(ue.substring(ge+1));let fe;try{fe=new RegExp(ue.substring(1,ge),te)}catch{throw this.B("REGEX",Z)}return t.regex(X,fe)}case 18:{const ee=Z.lexeme;this.z();let _=null;if(!(0,F.$Be)(ee)){const we=ee.indexOf("/"),ue=ee.lastIndexOf("/");if(we!==ue&&we>=0){const ge=ee.slice(we+1,ue),te=ee[ue+1]==="i"?"i":"";try{_=new RegExp(ge,te)}catch{throw this.B("REGEX",Z)}}}if(_===null)throw this.B("REGEX",Z);return O.create(X,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const Z=this.u();return t.notIn(X,Z)}switch(this.D().type){case 3:{this.z();const Z=this.u();if(this.x().type===18)return t.equals(X,Z);switch(Z){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,Z)}}case 4:{this.z();const Z=this.u();if(this.x().type===18)return t.notEquals(X,Z);switch(Z){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,Z)}}case 5:return this.z(),U.create(X,this.u());case 6:return this.z(),j.create(X,this.u());case 7:return this.z(),T.create(X,this.u());case 8:return this.z(),M.create(X,this.u());case 13:return this.z(),t.in(X,this.u());default:return t.has(X)}}case 20:throw this.h.push({message:s,offset:z.offset,lexeme:"",additionalInfo:r}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,X){if(this.C(z))return this.z();throw this.B(X,this.D())}B(z,X,re){const Z=(0,R.localize)(8,null,z,f.$Ki.getLexeme(X)),ee=X.offset,_=f.$Ki.getLexeme(X);return this.h.push({message:Z,offset:ee,lexeme:_,additionalInfo:re}),o.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=o;class t{static false(){return a.INSTANCE}static true(){return h.INSTANCE}static has(z){return S.create(z)}static equals(z,X){return k.create(z,X)}static notEquals(z,X){return v.create(z,X)}static regex(z,X){return O.create(z,X)}static in(z,X){return $.create(z,X)}static notIn(z,X){return b.create(z,X)}static not(z){return C.create(z)}static and(...z){return de.create(z,null,!0)}static or(...z){return x.create(z,null,!0)}static greater(z,X){return T.create(z,X)}static greaterEquals(z,X){return M.create(z,X)}static smaller(z,X){return U.create(z,X)}static smallerEquals(z,X){return j.create(z,X)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Ni=t;function n(H){const z=new o({regexParsingWithErrorRecovery:!1});return H.map(X=>(z.parse(X),z.lexingErrors.length>0?z.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,R.localize)(9,null,re.additionalInfo):(0,R.localize)(10,null),offset:re.offset,length:re.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$Oi=n;function d(H,z){const X=H?H.substituteConstants():void 0,re=z?z.substituteConstants():void 0;return!X&&!re?!0:!X||!re?!1:X.equals(re)}e.$Pi=d;function l(H,z){return H.cmp(z)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return h.INSTANCE}}e.$Qi=a;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return a.INSTANCE}}e.$Ri=h;class S{static create(z,X=null){const re=E.get(z);return typeof re=="boolean"?re?h.INSTANCE:a.INSTANCE:new S(z,X)}constructor(z,X){this.key=z,this.c=X,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:G(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=E.get(this.key);return typeof z=="boolean"?z?h.INSTANCE:a.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Si=S;class k{static create(z,X,re=null){if(typeof X=="boolean")return X?S.create(z,re):C.create(z,re);const Z=E.get(z);return typeof Z=="boolean"?X===(Z?"true":"false")?h.INSTANCE:a.INSTANCE:new k(z,X,re)}constructor(z,X,re){this.c=z,this.d=X,this.f=re,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const X=z?"true":"false";return this.d===X?h.INSTANCE:a.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ti=k;class ${static create(z,X){return new $(z,X)}constructor(z,X){this.d=z,this.f=X,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const X=z.getValue(this.f),re=z.getValue(this.d);return Array.isArray(X)?X.includes(re):typeof re=="string"&&typeof X=="object"&&X!==null?A.call(X,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Ui=$;class b{static create(z,X){return new b(z,X)}constructor(z,X){this.d=z,this.f=X,this.type=11,this.c=$.create(z,X)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=b;class v{static create(z,X,re=null){if(typeof X=="boolean")return X?C.create(z,re):S.create(z,re);const Z=E.get(z);return typeof Z=="boolean"?X===(Z?"true":"false")?a.INSTANCE:h.INSTANCE:new v(z,X,re)}constructor(z,X,re){this.c=z,this.d=X,this.f=re,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const X=z?"true":"false";return this.d===X?a.INSTANCE:h.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Wi=v;class C{static create(z,X=null){const re=E.get(z);return typeof re=="boolean"?re?a.INSTANCE:h.INSTANCE:new C(z,X)}constructor(z,X){this.c=z,this.d=X,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:G(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=E.get(this.c);return typeof z=="boolean"?z?a.INSTANCE:h.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Xi=C;function N(H,z){if(typeof H=="string"){const X=parseFloat(H);isNaN(X)||(H=X)}return typeof H=="string"||typeof H=="number"?z(H):a.INSTANCE}class T{static create(z,X,re=null){return N(X,Z=>new T(z,Z,re))}constructor(z,X,re){this.c=z,this.d=X,this.f=re,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Yi=T;class M{static create(z,X,re=null){return N(X,Z=>new M(z,Z,re))}constructor(z,X,re){this.c=z,this.d=X,this.f=re,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Zi=M;class U{static create(z,X,re=null){return N(X,Z=>new U(z,Z,re))}constructor(z,X,re){this.c=z,this.d=X,this.f=re,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$1i=U;class j{static create(z,X,re=null){return N(X,Z=>new j(z,Z,re))}constructor(z,X,re){this.c=z,this.d=X,this.f=re,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ce(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$2i=j;class O{static create(z,X){return new O(z,X)}constructor(z,X){this.d=z,this.f=X,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const X=this.f?this.f.source:"",re=z.f?z.f.source:"";return X<re?-1:X>re?1:0}equals(z){if(z.type===this.type){const X=this.f?this.f.source:"",re=z.f?z.f.source:"";return this.d===z.d&&X===re}return!1}substituteConstants(){return this}evaluate(z){const X=z.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$3i=O;class V{static create(z){return new V(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new V(this.c.map(z))}negate(){return this.c}}e.$4i=V;function q(H){let z=null;for(let X=0,re=H.length;X<re;X++){const Z=H[X].substituteConstants();if(H[X]!==Z&&z===null){z=[];for(let ee=0;ee<X;ee++)z[ee]=H[ee]}z!==null&&(z[X]=Z)}return z===null?H:z}class de{static create(z,X,re){return de.d(z,X,re)}constructor(z,X){this.expr=z,this.c=X,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Z=l(this.expr[X],z.expr[X]);if(Z!==0)return Z}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals(z.expr[X]))return!1;return!0}return!1}substituteConstants(){const z=q(this.expr);return z===this.expr?this:de.create(z,this.c,!1)}evaluate(z){for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].evaluate(z))return!1;return!0}static d(z,X,re){const Z=[];let ee=!1;for(const _ of z)if(_){if(_.type===1){ee=!0;continue}if(_.type===0)return a.INSTANCE;if(_.type===6){Z.push(..._.expr);continue}Z.push(_)}if(Z.length===0&&ee)return h.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(l);for(let _=1;_<Z.length;_++)Z[_-1].equals(Z[_])&&(Z.splice(_,1),_--);if(Z.length===1)return Z[0];for(;Z.length>1;){const _=Z[Z.length-1];if(_.type!==9)break;Z.pop();const we=Z.pop(),ue=Z.length===0,ge=x.create(_.expr.map(te=>de.create([te,we],null,re)),null,ue);ge&&(Z.push(ge),Z.sort(l))}if(Z.length===1)return Z[0];if(re){for(let _=0;_<Z.length;_++)for(let we=_+1;we<Z.length;we++)if(Z[_].negate().equals(Z[we]))return a.INSTANCE;if(Z.length===1)return Z[0]}return new de(Z,X)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const X of this.expr)z.push(...X.keys());return z}map(z){return new de(this.expr.map(X=>X.map(z)),null)}negate(){if(!this.c){const z=[];for(const X of this.expr)z.push(X.negate());this.c=x.create(z,this,!0)}return this.c}}e.$5i=de;class x{static create(z,X,re){return x.d(z,X,re)}constructor(z,X){this.expr=z,this.c=X,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Z=l(this.expr[X],z.expr[X]);if(Z!==0)return Z}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals(z.expr[X]))return!1;return!0}return!1}substituteConstants(){const z=q(this.expr);return z===this.expr?this:x.create(z,this.c,!1)}evaluate(z){for(let X=0,re=this.expr.length;X<re;X++)if(this.expr[X].evaluate(z))return!0;return!1}static d(z,X,re){let Z=[],ee=!1;if(z){for(let _=0,we=z.length;_<we;_++){const ue=z[_];if(ue){if(ue.type===0){ee=!0;continue}if(ue.type===1)return h.INSTANCE;if(ue.type===9){Z=Z.concat(ue.expr);continue}Z.push(ue)}}if(Z.length===0&&ee)return a.INSTANCE;Z.sort(l)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let _=1;_<Z.length;_++)Z[_-1].equals(Z[_])&&(Z.splice(_,1),_--);if(Z.length===1)return Z[0];if(re){for(let _=0;_<Z.length;_++)for(let we=_+1;we<Z.length;we++)if(Z[_].negate().equals(Z[we]))return h.INSTANCE;if(Z.length===1)return Z[0]}return new x(Z,X)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const X of this.expr)z.push(...X.keys());return z}map(z){return new x(this.expr.map(X=>X.map(z)),null)}negate(){if(!this.c){const z=[];for(const X of this.expr)z.push(X.negate());for(;z.length>1;){const X=z.shift(),re=z.shift(),Z=[];for(const ee of ye(X))for(const _ of ye(re))Z.push(de.create([ee,_],null,!1));z.unshift(x.create(Z,null,!1))}this.c=x.create(z,this,!0)}return this.c}}e.$6i=x;class Q extends S{static{this.d=[]}static all(){return Q.d.values()}constructor(z,X,re){super(z,null),this.f=X,typeof re=="object"?Q.d.push({...re,key:z}):re!==!0&&Q.d.push({key:z,description:re,type:X!=null?typeof X:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return k.create(this.key,z)}notEqualsTo(z){return v.create(this.key,z)}}e.$7i=Q,e.$8i=(0,L.$Ph)("contextKeyService");function G(H,z){return H<z?-1:H>z?1:0}function ce(H,z,X,re){return H<X?-1:H>X?1:z<re?-1:z>re?1:0}function ie(H,z){if(H.type===0||z.type===1)return!0;if(H.type===9)return z.type===9?ae(H.expr,z.expr):!1;if(z.type===9){for(const X of z.expr)if(ie(H,X))return!0;return!1}if(H.type===6){if(z.type===6)return ae(z.expr,H.expr);for(const X of H.expr)if(ie(X,z))return!0;return!1}return H.equals(z)}e.$9i=ie;function ae(H,z){let X=0,re=0;for(;X<H.length&&re<z.length;){const Z=H[X].cmp(z[re]);if(Z<0)return!1;Z===0&&X++,re++}return X===H.length}function ye(H){return H.type===9?H.expr:[H]}}),define(Se[238],De([1,0,23,38,198,5,101,12,24]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.ConfirmResult=e.$Gv=e.$Fv=e.$Ev=void 0,e.$Ev=(0,L.$Ph)("dialogService");var m;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(m||(m={}));class A{a(u){return this.d(u,m.Confirmation)}b(u){return this.d(u,m.Prompt)}c(u){return this.d(u,m.Input)}d(u,c){const i=[];switch(c){case m.Confirmation:{const s=u;s.primaryButton?i.push(s.primaryButton):i.push((0,f.localize)(0,null)),s.cancelButton?i.push(s.cancelButton):i.push((0,f.localize)(1,null));break}case m.Prompt:{const s=u;Array.isArray(s.buttons)&&s.buttons.length>0&&i.push(...s.buttons.map(r=>r.label)),s.cancelButton&&(s.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof s.cancelButton=="string"?i.push(s.cancelButton):s.cancelButton.label?i.push(s.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case m.Input:{const s=u;s.primaryButton?i.push(s.primaryButton):i.push((0,f.localize)(5,null)),s.cancelButton?i.push(s.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===F.default.Info?"info":u===F.default.Error?"error":u===F.default.Warning?"warning":"none"}f(u,c,i){const s=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&s.push(u.cancelButton);let r=s[c]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$Fv=A,e.$Gv=(0,L.$Ph)("fileDialogService");var P;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const g=10;function y(w){const u=[];return u.push(...w.slice(0,g).map(c=>typeof c=="string"?c:(0,I.$sg)(c))),w.length>g&&(w.length-g===1?u.push((0,f.localize)(7,null)):u.push((0,f.localize)(8,null,w.length-g))),u.push(""),u.join(`
`)}e.$Hv=y;function D(w,u){const c=(0,E.$7m)(w);let i=(c.buttons??[]).map(t=>(0,R.$Bv)(t)),s=(w.buttons||[]).map((t,n)=>n),r=0,o=c.cancelId??i.length-1;if(i.length>1){const t=typeof o=="number"?i[o]:void 0;if(p.$l||p.$k){if(typeof t=="string"&&i.length>1&&o!==1){i.splice(o,1),i.splice(1,0,t);const n=s[o];s.splice(o,1),s.splice(1,0,n),o=1}p.$l&&i.length>1&&(i=i.reverse(),s=s.reverse(),r=i.length-1,typeof t=="string"&&(o=r-1))}else if(p.$j&&typeof t=="string"&&i.length>1&&o!==i.length-1){i.splice(o,1),i.push(t);const n=s[o];s.splice(o,1),s.push(n),o=i.length-1}}return c.buttons=i,c.defaultId=r,c.cancelId=o,c.noLink=!0,c.title=c.title||u.nameLong,{options:c,buttonIndeces:s}}e.$Iv=D}),define(Se[133],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,I.$Ph)("environmentService"),e.$Xh=(0,I.$Qh)(e.$Wh)}),define(Se[134],De([1,0,199,5]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function f(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=f;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=L;function R(c,i){switch(c){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=R;function p(c,i){return i==="web"&&!c.includes("web")}e.$0n=p;function E(c,i,s){return p(i,s)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===s}e.$$n=E;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$_n=m;var A;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var y;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$ao=(0,F.$Ph)("extensionGalleryService");var D;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(D||(e.ExtensionManagementErrorCode=D={}));var w;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class u extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$bo=u,e.$co=(0,F.$Ph)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,F.$Ph)("IGlobalExtensionEnablementService"),e.$go=(0,F.$Ph)("IExtensionTipsService"),e.$ho=(0,I.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,I.localize)(1,null),original:"Preferences"}}),define(Se[239],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KYb=e.$JYb=void 0,e.$JYb=(0,I.$Ph)("externalTerminal"),e.$KYb="Terminal.app"}),define(Se[240],De([1,0,49,18,16,12,100,30,103,201,239]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=e.$F7b=e.$E7b=void 0;const P=m.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends g{static{this.b="cmd.exe"}openTerminal(r,o){return this.spawnTerminal(I,r,E.$Bl(),o)}spawnTerminal(r,o,t,n){const d=o.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const l=f.$mc(d,".exe").toLowerCase();if(l==="cmder")return r.spawn(d,n?[n]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return d.indexOf(" ")>=0&&a.push('""'),a.push(d),l==="wt"&&a.push("-d ."),new Promise((h,S)=>{const k=u(process),$=r.spawn(t,a,{cwd:n,env:k});$.on("error",S),$.on("exit",()=>h())})}runInTerminal(r,o,t,n,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:y.getDefaultTerminalWindows();return new Promise((a,h)=>{const S=`"${o} - ${P}"`,k=`""${t.join('" "')}" & pause"`,$=Object.assign({},u(process),n);Object.keys($).filter(T=>$[T]===null).forEach(T=>delete $[T]);const b={cwd:o,env:$,windowsVerbatimArguments:!0};let v,C;f.$mc(l,".exe")==="wt"?(v=l,C=["-d",".",y.b,"/c",k]):(v=y.b,C=["/c","start",S,"/wait",l,"/c",k]),I.spawn(v,C,b).on("error",T=>{h(c(T))}),a(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$E7b=y;class D extends g{static{this.b="/usr/bin/osascript"}openTerminal(r,o){return this.spawnTerminal(I,r,o)}runInTerminal(r,o,t,n,d){const l=d.osxExec||A.$KYb;return new Promise((a,h)=>{if(l===A.$KYb||l==="iTerm.app"){const S=l===A.$KYb?"TerminalHelper":"iTermHelper",$=[F.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",r||P,"-w",o];for(const C of t)$.push("-a"),$.push(C);if(n){const C=Object.assign({},u(process),n);for(const N in C){const T=C[N];T===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${T}`))}}let b="";const v=I.spawn(D.b,$);v.on("error",C=>{h(c(C))}),v.stderr.on("data",C=>{b+=C.toString()}),v.on("exit",C=>{if(C===0)a(void 0);else if(b){const N=b.split(`
`,1);h(new Error(N[0]))}else h(new Error(m.localize(1,null,S,C)))})}else h(new Error(m.localize(2,null,l)))})}spawnTerminal(r,o,t){const n=o.osxExec||A.$KYb;return new Promise((d,l)=>{const a=["-a",n];t&&a.push(t);const h=u(process),S=r.spawn("/usr/bin/open",a,{cwd:t,env:h});S.on("error",l),S.on("exit",()=>d())})}}e.$F7b=D;class w extends g{static{this.b=m.localize(3,null)}openTerminal(r,o){return this.spawnTerminal(I,r,o)}runInTerminal(r,o,t,n,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((a,h)=>{const S=[];l.then(k=>{k.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const $=`${i(t)}; echo; read -p "${w.b}" -n1;`;S.push(`''${$}''`);const b=Object.assign({},u(process),n);Object.keys(b).filter(T=>b[T]===null).forEach(T=>delete b[T]);const v={cwd:o,env:b};let C="";const N=I.spawn(k,S,v);N.on("error",T=>{h(c(T))}),N.stderr.on("data",T=>{C+=T.toString()}),N.on("exit",T=>{if(T===0)a(void 0);else if(C){const M=C.split(`
`,1);h(new Error(M[0]))}else h(new Error(m.localize(4,null,k,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!L.$l)w.d=Promise.resolve("xterm");else{const r=await p.Promises.exists("/etc/debian_version");w.d=new Promise(o=>{r?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return w.d}spawnTerminal(r,o,t){const n=o.linuxExec?Promise.resolve(o.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{n.then(a=>{const h=u(process),S=r.spawn(a,[],{cwd:t,env:h});S.on("error",l),S.on("exit",()=>d())})})}}e.$G7b=w;function u(s){const r={...s.env};return(0,R.$zl)(r),r}function c(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(m.localize(5,null,s.path)):s}function i(s){let r="";for(const o of s)o.indexOf(" ")>=0?r+='"'+o+'"':r+=o,r+=" ";return r}}),define(Se[31],De([1,0,78,16,13,17,2,202,5,12,18,47]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,E.$Ph)("fileService");function g(ie){return ie.create===!0}e.$_j=g;var y;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var D;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(D||(e.FilePermission=D={}));function w(ie){const ae=ie;return!!ae&&typeof ae.onDidChange=="function"}e.$ak=w;var u;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function c(ie){return!!(ie.capabilities&2)}e.$bk=c;function i(ie){return!!(ie.capabilities&8)}e.$ck=i;function s(ie){return!!(ie.capabilities&131072)}e.$dk=s;function r(ie){return!!(ie.capabilities&4)}e.$ek=r;function o(ie){return!!(ie.capabilities&16)}e.$fk=o;function t(ie){return c(ie)?!!(ie.capabilities&16384):!1}e.$gk=t;function n(ie){return c(ie)?!!(ie.capabilities&32768):!1}e.$hk=n;function d(ie){return!!(ie.capabilities&65536)}e.$ik=d;function l(ie){return!!(ie.capabilities&2048)}e.$jk=l;var a;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class h extends Error{static create(ae,ye){const H=new h(ae.toString(),ye);return $(H,ye),H}constructor(ae,ye){super(ae),this.code=ye}}e.$kk=h;function S(ie,ae){return h.create(ie,ae)}e.$lk=S;function k(ie){return ie||S((0,p.localize)(0,null),a.Unknown)}e.$mk=k;function $(ie,ae){return ie.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ie}e.$nk=$;function b(ie){if(!ie)return a.Unknown;if(ie instanceof h)return ie.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ae)return a.Unknown;switch(ae[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$ok=b;function v(ie){if(ie instanceof j)return ie.fileOperationResult;switch(b(ie)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$pk=v;var C;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class N{constructor(ae,ye,H){this.resource=ae,this.operation=ye,this.target=H}isOperation(ae){return this.operation===ae}}e.$qk=N;var T;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class M{static{this.a=null}constructor(ae,ye){this.c=ye,this.b=void 0,this.d=new P.$U(()=>{const H=I.$Vh.forUris(()=>this.c);return H.fill(this.rawAdded.map(z=>[z,!0])),H}),this.f=new P.$U(()=>{const H=I.$Vh.forUris(()=>this.c);return H.fill(this.rawUpdated.map(z=>[z,!0])),H}),this.g=new P.$U(()=>{const H=I.$Vh.forUris(()=>this.c);return H.fill(this.rawDeleted.map(z=>[z,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ae){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...ye){return this.h(ae,{includeChildren:!1},...ye)}affects(ae,...ye){return this.h(ae,{includeChildren:!0},...ye)}h(ae,ye,...H){if(!ae)return!1;const z=H.length>0;return!!((!z||H.includes(1))&&(this.d.value.get(ae)||ye.includeChildren&&this.d.value.findSuperstr(ae))||(!z||H.includes(0))&&(this.f.value.get(ae)||ye.includeChildren&&this.f.value.findSuperstr(ae))||(!z||H.includes(2))&&(this.g.value.findSubstr(ae)||ye.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$rk=M;function U(ie,ae,ye){return!ie||!ae||ie===ae||ae.length>ie.length?!1:(ae.charAt(ae.length-1)!==F.sep&&(ae+=F.sep),ye?(0,f.$3e)(ie,ae):ie.indexOf(ae)===0)}e.$sk=U;class j extends Error{constructor(ae,ye,H){super(ae),this.fileOperationResult=ye,this.options=H}}e.$tk=j;class O extends j{constructor(ae,ye,H,z){super(ae,ye,z),this.fileOperationResult=ye,this.size=H}}e.$uk=O;class V extends j{constructor(ae,ye,H){super(ae,2,H),this.stat=ye}}e.$vk=V;var q;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var de;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Dk="";function x(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Ek=x;async function Q(ie,ae){if(!ae.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(ye=>{const H=ae.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===ie.scheme&&z.added&&(H.dispose(),ye())})})}e.$Fk=Q;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(ae){return(0,L.$Cf)(ae)||(ae=0),ae<G.KB?(0,p.localize)(1,null,ae.toFixed(0)):ae<G.MB?(0,p.localize)(2,null,(ae/G.KB).toFixed(2)):ae<G.GB?(0,p.localize)(3,null,(ae/G.MB).toFixed(2)):ae<G.TB?(0,p.localize)(4,null,(ae/G.GB).toFixed(2)):(0,p.localize)(5,null,(ae/G.TB).toFixed(2))}}e.$Gk=G;function ce(ie){const ae=typeof ie=="string"||ie?.scheme===A.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===A.Schemas.file?1024*G.MB:ae?10*G.MB:m.$p?50*G.MB:1024*G.MB}e.$Hk=ce}),define(Se[241],De([1,0,22,9,203,31]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function R(A,P,g,y,D,w){let u;try{await p(A,P,g,y,D,w)}catch(c){u=c}finally{u&&D.errorTransformer&&(u=D.errorTransformer(u)),typeof u<"u"&&g.error(u),g.end()}}e.$Pp=R;async function p(A,P,g,y,D,w){E(w);const u=await A.open(P,{create:!1});try{E(w);let c=0,i=0,s=D&&typeof D.length=="number"?D.length:void 0,r=I.$be.alloc(Math.min(D.bufferSize,typeof s=="number"?s:D.bufferSize)),o=D&&typeof D.position=="number"?D.position:0,t=0;do i=await A.read(u,o,r.buffer,t,r.byteLength-t),o+=i,t+=i,c+=i,typeof s=="number"&&(s-=i),t===r.byteLength&&(await g.write(y(r)),r=I.$be.alloc(Math.min(D.bufferSize,typeof s=="number"?s:D.bufferSize)),t=0);while(i>0&&(typeof s!="number"||s>0)&&E(w)&&m(c,D));if(t>0){let n=t;typeof s=="number"&&(n=Math.min(t,s)),g.write(y(r.slice(0,n)))}}catch(c){throw(0,L.$mk)(c)}finally{await A.close(u)}}function E(A){if(A.isCancellationRequested)throw(0,F.$5)();return!0}function m(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,L.$lk)((0,f.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[85],De([1,0,37,3,16,12,2,31]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function E(c){return c.recursive===!0}e.$Rp=E;class m extends F.$Rc{static{this.a=5}constructor(i,s,r,o){super(),this.h=i,this.j=s,this.m=r,this.n=o,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const i=new F.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(s=>this.h(s))),i.add(this.b.onDidLogMessage(s=>this.j(s))),i.add(this.b.onDidError(s=>this.t(s)))}t(i){this.n.restartOnError?this.g<m.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Sp=m;class A extends m{constructor(i,s,r){super(i,s,r,{type:"node.js",restartOnError:!1})}}e.$Tp=A;class P extends m{constructor(i,s,r){super(i,s,r,{type:"universal",restartOnError:!0})}}e.$Up=P;function g(c){return c.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$Vp=g;function y(c){const i=new u;for(const s of c)i.processEvent(s);return i.coalesce()}e.$Wp=y;function D(c,i){return typeof i=="string"&&!i.startsWith(I.$sj)&&!(0,f.$hc)(i)?{base:c,pattern:i}:i}e.$Xp=D;function w(c,i){const s=[];for(const r of i)s.push((0,I.$wj)(D(c,r)));return s}e.$Yp=w;class u{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$l?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const s=this.b.get(this.c(i));let r=!1;if(s){const o=s.type,t=i.type;s.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:o===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(s)):o===2&&t===1?s.type=0:o===1&&t===0||(s.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],s=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,o)=>r.resource.fsPath.length-o.resource.fsPath.length).filter(r=>s.some(o=>(0,p.$sk)(r.resource.fsPath,o,!L.$l))?!1:(s.push(r.resource.fsPath),!0)).concat(i)}}}),define(Se[242],De([1,0,55,8,21,33,3,77,16,12,23,2,102,30,85]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class w extends R.$Rc{static{this.a=100}static{this.b=75}constructor(i,s,r,o){super(),this.m=i,this.n=s,this.r=r,this.s=o,this.c=this.B(new F.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$8g(t=>this.z(t),w.b)),this.g=(0,D.$Yp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,D.$Yp)(this.m.path,this.m.includes):void 0,this.j=new f.$Xd,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const s=await y.Promises.stat(i);this.B(await this.w(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let s=i.path;try{s=await y.Promises.realpath(i.path),i.path===s&&(s=await(0,g.$9p)(i.path)??i.path),i.path!==s&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async w(i,s){if(m.$k&&(0,L.$Xf)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Rc.None;const r=new f.$Xd(this.j.token),o=new R.$Qc;try{const t=P.URI.file(this.m.path),n=(0,E.$mc)(i),d=(0,I.watch)(i);o.add((0,R.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const l=new Set;if(s)try{for(const h of await y.Promises.readdir(i))l.add(h)}catch(h){this.D(h)}const a=new Map;o.add((0,R.$Pc)(()=>{for(const[,h]of a)h.dispose();a.clear()})),d.on("error",(h,S)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${S})`),this.dispose()}),d.on("change",(h,S)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${S}`);let k="";if(S&&(k=S.toString(),m.$k&&(k=(0,p.$ol)(k))),!(!k||h!=="change"&&h!=="rename"))if(s)if(h==="rename"){a.get(k)?.dispose();const $=setTimeout(async()=>{if(a.delete(k),k===n&&!await y.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.C((0,E.$ic)(i,k));if(r.token.isCancellationRequested)return;let v;b?l.has(k)?v=0:(v=1,l.add(k)):(l.delete(k),v=2),this.y({resource:(0,A.$vg)(t,k),type:v,cId:this.m.correlationId})},w.a);a.set(k,(0,R.$Pc)(()=>clearTimeout($)))}else{let $;l.has(k)?$=0:($=1,l.add(k)),this.y({resource:(0,A.$vg)(t,k),type:$,cId:this.m.correlationId})}else if(h==="rename"||k!==n){const $=setTimeout(async()=>{const b=await y.Promises.exists(i);r.token.isCancellationRequested||(b?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),o.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);o.clear(),o.add((0,R.$Pc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Pc)(()=>{r.dispose(!0),o.dispose()})}y(i,s=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const s=(0,D.$Wp)(i);if(s.length>0){if(this.s)for(const o of s)this.G(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(m.$l)return y.Promises.exists(i);try{const s=(0,E.$mc)(i);return(await y.Promises.readdir((0,E.$lc)(i))).some(o=>o===s)}catch(s){return this.G(s),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$_p=w;async function u(c,i,s,r,o=512){const t=await y.Promises.open(c,"r"),n=Buffer.allocUnsafe(o),d=new f.$Xd(r);let l,a=!1;const h={path:c,excludes:[],recursive:!1},S=new w(h,k=>{(async()=>{for(const{type:$}of k)if($===0){if(a)return;a=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:b}=await y.Promises.read(t,n,0,o,null);if(!b||d.token.isCancellationRequested)break;i(n.slice(0,b))}}catch(b){l=new Error(b),d.dispose(!0)}finally{a=!1}}})()});return await S.ready,s(),new Promise((k,$)=>{d.token.onCancellationRequested(async()=>{S.dispose();try{await y.Promises.close(t)}catch(b){l=new Error(b)}l?$(l):k()})})}e.$aq=u}),define(Se[243],De([1,0,4,37,3,12,242]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class p extends f.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(m){const A=this.j(m),P=A.filter(y=>{const D=this.c.get(y.path);return D?!(0,F.$Aj)(D.request.excludes,y.excludes)||!(0,F.$Aj)(D.request.includes,y.includes):!0}),g=Array.from(this.c.values()).filter(({request:y})=>!A.find(D=>D.path===y.path&&(0,F.$Aj)(D.excludes,y.excludes)&&(0,F.$Aj)(D.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.m(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const y of g)this.h(y);for(const y of P)this.g(y)}g(m){const A=new R.$_p(m,g=>this.a.fire(g),g=>this.b.fire(g),this.f),P={request:m,instance:A};this.c.set(m.path,P)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const A=this.c.get(m);A&&(this.c.delete(m),A.instance.dispose())}j(m){const A=new Map;for(const P of m){const g=L.$l?P.path:P.path.toLowerCase();let y=A.get(P.correlationId);y||(y=new Map,A.set(P.correlationId,y)),y.set(g,P)}return Array.from(A.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(m){this.f=m;for(const[,A]of this.c)A.instance.setVerboseLogging(m)}m(m){this.f&&this.b.fire({type:"trace",message:this.n(m)})}n(m,A){return A?`[File Watcher (node.js)] ${m} (path: ${A.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$bq=p}),define(Se[244],De([1,0,85,243]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class f extends I.$Tp{constructor(R,p,E){super(R,p,E),this.s()}r(R){return R.add(new F.$bq)}}e.$cq=f}),define(Se[245],De([1,0,18,82,186,85]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class R extends L.$Up{constructor(E,m,A){super(E,m,A),this.s()}r(E){const m=E.add(new f.$6p(I.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(m.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),F.ProxyChannel.toService((0,F.$wh)(m.getChannel("watcher")))}}e.$7p=R}),define(Se[106],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class I{constructor(...f){this.a=new Map;for(const[L,R]of f)this.set(L,R)}set(f,L){const R=this.a.get(f);return this.a.set(f,L),R}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Nh=I}),define(Se[246],De([1,0,8,9,3,104,237,5,106,76]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const A=!1;class P extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class g{constructor(u=new E.$Nh,c=!1,i,s=A){this.f=u,this.g=c,this.h=i,this.i=s,this.o=new Set,this.f.set(p.$Oh,this),this._globalGraph=s?i?._globalGraph??new R.$fq(r=>r):void 0}createChild(u){return new g(u,this.g,this,this.i)}invokeFunction(u,...c){const i=D.traceInvocation(this.i,u);let s=!1;try{return u({get:o=>{if(s)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(o,i);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...c)}finally{s=!0,i.stop()}}createInstance(u,...c){let i,s;return u instanceof L.$Mh?(i=D.traceCreation(this.i,u.ctor),s=this.j(u.ctor,u.staticArguments.concat(c),i)):(i=D.traceCreation(this.i,u),s=this.j(u,c,i)),i.stop(),s}j(u,c=[],i){const s=p._util.getServiceDependencies(u).sort((t,n)=>t.index-n.index),r=[];for(const t of s){const n=this.m(t.id,i);n||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(n)}const o=s.length>0?s[0].index:c.length;if(c.length!==o){console.trace(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${c.length} static arguments`);const t=o-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,o)}return Reflect.construct(u,c.concat(r))}k(u,c){if(this.f.get(u)instanceof L.$Mh)this.f.set(u,c);else if(this.h)this.h.k(u,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const c=this.f.get(u);return!c&&this.h?this.h.l(u):c}m(u,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const i=this.l(u);return i instanceof L.$Mh?this.q(u,i,c.branch(u,!0)):(c.branch(u,!1),i)}q(u,c,i){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,c,i)}finally{this.o.delete(u)}}r(u,c,i){const s=new R.$fq(t=>t.id.toString());let r=0;const o=[{id:u,desc:c,_trace:i}];for(;o.length;){const t=o.pop();if(s.lookupOrInsertNode(t),r++>1e3)throw new P(s);for(const n of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(n.id);if(d||this.u(`[createInstance] ${u} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),d instanceof L.$Mh){const l={id:n.id,desc:d,_trace:t._trace.branch(n.id,!0)};s.insertEdge(t,l),o.push(l)}}}for(;;){const t=s.roots();if(t.length===0){if(!s.isEmpty())throw new P(s);break}for(const{data:n}of t){if(this.l(n.id)instanceof L.$Mh){const l=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,l)}s.removeNode(n)}}return this.l(u)}s(u,c,i=[],s,r){if(this.f.get(u)instanceof L.$Mh)return this.t(u,c,i,s,r);if(this.h)return this.h.s(u,c,i,s,r);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(u,c,i=[],s,r){if(s){const o=new g(void 0,this.g,this,this.i);o.c=String(u);const t=new Map,n=new I.$$g(()=>{const d=o.j(c,i,r);for(const[l,a]of t){const h=d[l];if(typeof h=="function")for(const S of a)h.apply(d,S)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!n.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let S=t.get(l);return S||(S=new m.$1c,t.set(l,S)),($,b,v)=>{const C=S.push([$,b,v]);return(0,f.$Pc)(C)}}if(l in d)return d[l];const a=n.value;let h=a[l];return typeof h!="function"||(h=h.bind(a),d[l]=h),h},set(d,l,a){return n.value[l]=a,!0},getPrototypeOf(d){return c.prototype}})}else return this.j(c,i,r)}u(u,c){if(c&&console.warn(u),this.g)throw new Error(u)}}e.$gq=g;var y;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(y||(y={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,c){return u?new D(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(u,c){return u?new D(1,c.name):D.c}static{this.f=0}constructor(u,c){this.type=u,this.name=c,this.g=Date.now(),this.h=[]}branch(u,c){const i=new D(3,u.toString());return this.h.push([u,c,i]),i}stop(){const u=Date.now()-this.g;D.f+=u;let c=!1;function i(r,o){const t=[],n=new Array(r+1).join("	");for(const[d,l,a]of o.h)if(l&&a){c=!0,t.push(`${n}CREATES -> ${d}`);const h=i(r+1,a);h&&t.push(h)}else t.push(`${n}uses -> ${d}`);return t.join(`
`)}const s=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(u>2||c)&&D.all.add(s.join(`
`))}}e.$hq=D}),define(Se[15],De([1,0,41,4,52,3,28,12,23,17,2,42,5]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,g.$Ph)("logService"),e.$$i=(0,g.$Ph)("loggerService");function y(){return new Date().toISOString()}function D($){return(0,m.$Cf)($)}e.$_i=D;var w;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$aj=w.Info;function u($,b,v){switch(b){case w.Trace:$.trace(v);break;case w.Debug:$.debug(v);break;case w.Info:$.info(v);break;case w.Warning:$.warn(v);break;case w.Error:$.error(v);break;case w.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=u;function c($,b=!1){let v="";for(let C=0;C<$.length;C++){let N=$[C];if(N instanceof Error&&(N=(0,I.$Ai)(N,b)),typeof N=="object")try{N=JSON.stringify(N)}catch{}v+=(C>0?" ":"")+N}return v}class i extends L.$Rc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new F.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==w.Off&&this.b<=b}}e.$cj=i;class s extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...v){this.f(w.Trace)&&this.g(w.Trace,c([b,...v],!0))}debug(b,...v){this.f(w.Debug)&&this.g(w.Debug,c([b,...v]))}info(b,...v){this.f(w.Info)&&this.g(w.Info,c([b,...v]))}warn(b,...v){this.f(w.Warning)&&this.g(w.Warning,c([b,...v]))}error(b,...v){if(this.f(w.Error))if(b instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=b.stack,this.g(w.Error,c(C))}else this.g(w.Error,c([b,...v]))}flush(){}}e.$dj=s;class r extends i{constructor(b=e.$aj){super(),this.setLevel(b),this.g=!p.$j}trace(b,...v){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}debug(b,...v){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}info(b,...v){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}warn(b,...v){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,b,...v):console.warn(`[main ${y()}]`,b,...v))}error(b,...v){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,b,...v):console.error(`[main ${y()}]`,b,...v))}dispose(){}flush(){}}e.$ej=r;class o extends i{constructor(b=e.$aj,v=!0){super(),this.g=v,this.setLevel(b)}trace(b,...v){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...v):console.log(b,...v))}debug(b,...v){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...v):console.log(b,...v))}info(b,...v){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...v):console.log(b,...v))}warn(b,...v){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...v):console.log(b,...v))}error(b,...v){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...v):console.error(b,...v))}dispose(){}flush(){}}e.$fj=o;class t extends i{constructor(b,v=e.$aj){super(),this.g=b,this.setLevel(v)}trace(b,...v){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(b),...v])}debug(b,...v){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(b),...v])}info(b,...v){this.f(w.Info)&&this.g.log(w.Info,[this.h(b),...v])}warn(b,...v){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(b),...v])}error(b,...v){this.f(w.Error)&&this.g.log(w.Error,[this.h(b),...v])}h(b){return typeof b=="string"?b:(0,I.$Ai)(b,this.f(w.Trace))}dispose(){}flush(){}}e.$gj=t;class n extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const v of this.g)v.setLevel(b);super.setLevel(b)}trace(b,...v){for(const C of this.g)C.trace(b,...v)}debug(b,...v){for(const C of this.g)C.debug(b,...v)}info(b,...v){for(const C of this.g)C.info(b,...v)}warn(b,...v){for(const C of this.g)C.warn(b,...v)}error(b,...v){for(const C of this.g)C.error(b,...v)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$hj=n;class d extends L.$Rc{constructor(b,v,C){if(super(),this.h=b,this.j=v,this.b=new R.$zc,this.c=this.B(new F.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Nd),this.onDidChangeVisibility=this.g.event,C)for(const N of C)this.b.set(N.resource,{logger:void 0,info:N})}m(b){return(0,m.$yf)(b)?[...this.b.values()].find(v=>v.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,v){const C=this.n(b),N=(0,m.$yf)(b)?b:v?.id??(0,f.$Di)(C.toString()).toString(16);let T=this.b.get(C)?.logger;const M=v?.logLevel==="always"?w.Trace:v?.logLevel;T||(T=this.s(C,M??this.getLogLevel(C)??this.h,{...v,id:N}));const U={logger:T,info:{resource:C,id:N,logLevel:M,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(U.info),this.b.set(C,U),T}n(b){return(0,m.$yf)(b)?(0,E.$vg)(this.j,`${b}.log`):b}setLogLevel(b,v){if(A.URI.isUri(b)){const C=b,N=v,T=this.b.get(C);T&&N!==T.info.logLevel&&(T.info.logLevel=N===this.h?void 0:N,T.logger?.setLevel(N),this.b.set(T.info.resource,T),this.f.fire([C,N]))}else{this.h=b;for(const[C,N]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,v){const C=this.m(b);C&&v!==!C.info.hidden&&(C.info.hidden=!v,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,v]))}getLogLevel(b){let v;return b&&(v=this.b.get(b)?.info.logLevel),v??this.h}registerLogger(b){const v=this.b.get(b.resource);v?v.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const v=this.b.get(b);v&&(v.logger&&v.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=d;class l{constructor(){this.onDidChangeLogLevel=new F.$Nd().event}setLevel(b){}getLevel(){return w.Info}trace(b,...v){}debug(b,...v){}info(b,...v){}warn(b,...v){}error(b,...v){}critical(b,...v){}dispose(){}flush(){}}e.$jj=l;class a extends l{}e.$kj=a;function h($){if($.verbose)return w.Trace;if(typeof $.logLevel=="string"){const b=k($.logLevel.toLowerCase());if(b!==void 0)return b}return e.$aj}e.$lj=h;function S($){switch($){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$mj=S;function k($){switch($){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$nj=k,e.$oj=new P.$7i("logLevel",S(w.Info))}),define(Se[247],De([1,0,19,8,9,4,3,16,85,15]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class A extends R.$Rc{constructor(g,y){super(),this.a=g,this.b=y,this.c=this.B(new L.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Rg(0)),this.w=[],this.y=this.B(new F.$Rg(0))}watch(g,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(g,y):this.z(g,y)}n(g,y){const D={path:this.H(g),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},w=(0,I.$Tb)(this.j,D);return this.r(),(0,R.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,f.$Z)(g))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Vp)(y)),y=>this.G(y),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const y of this.j)(0,E.$Rp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const y of this.j)(0,E.$Rp)(y)&&g.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,y){const D={path:this.H(g),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},w=(0,I.$Tb)(this.w,D);return this.C(),(0,R.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,f.$Z)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,E.$Vp)(g)),g=>this.G(g),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,p.$gc)(g.fsPath)}}e.$Zp=A}),define(Se[248],De([1,0,55,385,8,28,22,4,33,3,16,12,23,97,30,204,31,241,247,41,245,244]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(n){console.error(`Error enabling graceful-fs: ${(0,s.$Ai)(n)}`)}})();class t extends i.$Zp{static{this.I=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=p.Event.None,this.N=new L.$zc(a=>g.$mg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$l&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:a}=await D.SymlinkSupport.stat(this.H(d));return{type:this.M(l,a),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:u.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await D.Promises.readdir(this.H(d),{withFileTypes:!0}),a=[];return await Promise.all(l.map(async h=>{try{let S;h.isSymbolicLink()?S=(await this.stat((0,g.$vg)(d,h.name))).type:S=this.M(h),a.push([h.name,S])}catch(S){this.a.trace(S)}})),a}catch(l){throw this.fb(l)}}M(d,l){let a;return l?.dangling?a=u.FileType.Unknown:d.isFile()?a=u.FileType.File:d.isDirectory()?a=u.FileType.Directory:a=u.FileType.Unknown,l&&(a|=u.FileType.SymbolicLink),a}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let a;for(;a=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await a.wait();const h=new f.$Sg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,m.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let a;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),a=await this.O(d));const h=this.H(d);return await D.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{a?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,a){const h=(0,y.$2d)(S=>R.$be.concat(S.map(k=>R.$be.wrap(k))).buffer);return(0,c.$Pp)(this,d,h,S=>S.buffer,{...l,bufferSize:256*1024},a),h}async writeFile(d,l,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,g.$vg)((0,g.$ug)(d),`${(0,g.$sg)(d)}${a.atomic.postfix}`),l,a):this.S(d,l,a)}async Q(d){try{const l=this.H(d),{symbolicLink:a}=await D.SymlinkSupport.stat(l);if(a)return!1}catch{}return!0}async R(d,l,a,h){const S=new m.$Qc;try{S.add(await this.O(d)),S.add(await this.O(l)),await this.S(l,a,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(k){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{S.dispose()}}async S(d,l,a,h){let S;try{const k=this.H(d);if(!a.create||!a.overwrite){if(await D.Promises.exists(k)){if(!a.overwrite)throw(0,u.$lk)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,u.$lk)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(d,{create:!0,unlock:a.unlock},h),await this.write(S,0,l,0,l.byteLength)}catch(k){throw await this.gb(d,k)}finally{typeof S=="number"&&await this.close(S)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,l,a){const h=this.H(d);let S;(0,u.$_j)(l)&&!a&&(S=await this.O(d));let k;try{if((0,u.$_j)(l)&&l.unlock)try{const{stat:b}=await D.SymlinkSupport.stat(h);b.mode&128||await D.Promises.chmod(h,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let $;if((0,u.$_j)(l)){if(P.$j)try{await D.Promises.truncate(h,0),$="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}$||($="w")}else $="r";k=await D.Promises.open(h,$)}catch($){throw S?.dispose(),(0,u.$_j)(l)?await this.gb(d,$):this.fb($)}if(this.U.set(k,0),(0,u.$_j)(l)&&this.X.set(k,d),S){const $=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${h})`),this.W.set(k,S),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${h})`),$.dispose())}return k}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await D.Promises.fdatasync(d)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await D.Promises.close(d)}catch(a){throw this.fb(a)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,a,h,S){const k=this.Z(d,l);let $=null;try{$=(await D.Promises.read(d,a,h,S,k)).bytesRead}catch(b){throw this.fb(b)}finally{this.$(d,k,$)}return $}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,a){const h=this.U.get(d);typeof h=="number"&&(typeof l=="number"||(typeof a=="number"?this.U.set(d,h+a):this.U.delete(d)))}async write(d,l,a,h,S){return(0,f.$_g)(()=>this.ab(d,l,a,h,S),100,3)}async ab(d,l,a,h,S){const k=this.Z(d,l);let $=null;try{$=(await D.Promises.write(d,a,h,S,k)).bytesWritten}catch(b){throw await this.gb(this.X.get(d),b)}finally{this.$(d,k,$)}return $}async mkdir(d){try{await D.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const a=this.H(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(a),`${(0,A.$mc)(a)}${l.atomic.postfix}`)),await D.Promises.rm(a,D.RimRafMode.MOVE,h)}else try{await D.Promises.unlink(a)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let S=!1;try{const{stat:k,symbolicLink:$}=await D.SymlinkSupport.stat(a);S=k.isDirectory()&&!$}catch{}if(S)await D.Promises.rmdir(a);else throw h}else throw h}}catch(a){throw this.fb(a)}}async rename(d,l,a){const h=this.H(d),S=this.H(l);if(h!==S)try{await this.bb(d,l,"move",a.overwrite),await D.Promises.rename(h,S)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(S)),k.toString()))),this.fb(k)}}async copy(d,l,a){const h=this.H(d),S=this.H(l);if(h!==S)try{await this.bb(d,l,"copy",a.overwrite),await D.Promises.copy(h,S,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(S)),k.toString()))),this.fb(k)}}async bb(d,l,a,h){const S=this.H(d),k=this.H(l);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Wf)(S,k,!0)),$){if(a==="copy")throw(0,u.$lk)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const v=await this.L(d);if(!v)throw(0,u.$lk)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(l);if(C){if(!h)throw(0,u.$lk)((0,w.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);v.type&u.FileType.File&&C.type&u.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,a){const h=this.H(d),S=this.H(l),k=!!(this.capabilities&1024);if((0,E.$Wf)(h,S,!k))return;const $=new m.$Qc;try{$.add(await this.O(d)),$.add(await this.O(l)),a&&await D.Promises.mkdir((0,A.$lc)(S),{recursive:!0}),await D.Promises.copyFile(h,S)}catch(b){if(b.code==="ENOENT"&&!a)return this.cb(d,l,!0);throw this.fb(b)}finally{$.dispose()}}t(d,l,a){return new r.$7p(h=>d(h),h=>l(h),a)}F(d,l,a){return new o.$cq(h=>d(h),h=>l(h),a)}fb(d){if(d instanceof u.$kk)return d;let l=d,a;switch(d.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=u.FileSystemProviderErrorCode.Unknown;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.$lk)(l,a)}async gb(d,l){let a=this.fb(l);if(d&&a.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await D.SymlinkSupport.stat(this.H(d));h.mode&128||(a=(0,u.$lk)(l,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return a}}e.$dq=t}),define(Se[249],De([1,0,3,15]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class f extends I.$Rc{constructor(R,p=[]){super(),this.a=new F.$hj([R,...p]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$RN=f}),define(Se[250],De([1,0,31,15]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0;var f;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(f||(f={}));async function L(m,A,P,g,y){try{const D=await new Promise((u,c)=>{$e(["@vscode/spdlog"],u,c)});D.setFlushOn(f.Trace);const w=await D.createAsyncRotatingLogger(m,A,P,g);return y?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(D){console.error(D)}return null}function R(m,A,P){switch(A){case F.LogLevel.Trace:m.trace(P);break;case F.LogLevel.Debug:m.debug(P);break;case F.LogLevel.Info:m.info(P);break;case F.LogLevel.Warning:m.warn(P);break;case F.LogLevel.Error:m.error(P);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(m,A){switch(A){case F.LogLevel.Trace:m.setLevel(f.Trace);break;case F.LogLevel.Debug:m.setLevel(f.Debug);break;case F.LogLevel.Info:m.setLevel(f.Info);break;case F.LogLevel.Warning:m.setLevel(f.Warning);break;case F.LogLevel.Error:m.setLevel(f.Error);break;case F.LogLevel.Off:m.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class E extends F.$dj{constructor(A,P,g,y,D){super(),this.m=[],this.setLevel(D),this.n=this.s(A,P,g,y),this.B(this.onDidChangeLogLevel(w=>{this.r&&p(this.r,w)}))}async s(A,P,g,y){const D=g?6:1,w=30/D*I.$Gk.MB,u=await L(A,P,w,D,y);if(u){this.r=u,p(this.r,this.getLevel());for(const{level:c,message:i}of this.m)R(this.r,c,i);this.m=[]}}g(A,P){this.r?R(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$GN=E}),define(Se[135],De([1,0,38,205,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function m(D,w){return w-D}E.compare=m;const A=Object.create(null);A[E.Error]=(0,F.localize)(0,null),A[E.Warning]=(0,F.localize)(1,null),A[E.Info]=(0,F.localize)(2,null);function P(D){return A[D]||""}E.toString=P;function g(D){switch(D){case I.default.Error:return E.Error;case I.default.Warning:return E.Warning;case I.default.Info:return E.Info;case I.default.Ignore:return E.Hint}}E.fromSeverity=g;function y(D){switch(D){case E.Error:return I.default.Error;case E.Warning:return I.default.Warning;case E.Info:return I.default.Info;case E.Hint:return I.default.Ignore}}E.toSeverity=y}(R||(e.MarkerSeverity=R={}));var p;(function(E){const m="";function A(g){return P(g,!0)}E.makeKey=A;function P(g,y){const D=[m];return g.source?D.push(g.source.replace("\xA6","\\\xA6")):D.push(m),g.code?typeof g.code=="string"?D.push(g.code.replace("\xA6","\\\xA6")):D.push(g.code.value.replace("\xA6","\\\xA6")):D.push(m),g.severity!==void 0&&g.severity!==null?D.push(R.toString(g.severity)):D.push(m),g.message&&y?D.push(g.message.replace("\xA6","\\\xA6")):D.push(m),g.startLineNumber!==void 0&&g.startLineNumber!==null?D.push(g.startLineNumber.toString()):D.push(m),g.startColumn!==void 0&&g.startColumn!==null?D.push(g.startColumn.toString()):D.push(m),g.endLineNumber!==void 0&&g.endLineNumber!==null?D.push(g.endLineNumber.toString()):D.push(m),g.endColumn!==void 0&&g.endColumn!==null?D.push(g.endColumn.toString()):D.push(m),D.push(m),D.join("\xA6")}E.makeKeyOptionalMessage=P})(p||(e.IMarkerData=p={})),e.$ct=(0,f.$Ph)("markerService")}),define(Se[251],De([1,0,4,38,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3u=e.Severity=void 0,e.Severity=F.default,e.$3u=(0,f.$Ph)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var p;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new m,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$4u=E;class m{infinite(){}done(){}total(P){}worked(P){}}e.$5u=m}),define(Se[136],De([1,0,13,2,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=e.$xU=e.$wU=e.$vU=void 0,e.$vU=(0,f.$Ph)("openerService");function L(m,A){return F.URI.isUri(m)?(0,I.$2e)(m.scheme,A):(0,I.$3e)(m,A+":")}e.$wU=L;function R(m,...A){return A.some(P=>L(m,P))}e.$xU=R;function p(m,A){return m.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$yU=p;function E(m){let A;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return P&&(A={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},m=m.with({fragment:""})),{selection:A,uri:m}}e.$zU=E}),define(Se[252],De([1,0,12,48]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.context<"u"){const L=I.$h.vscode.context.configuration();if(L)f=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:L.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(Se[137],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,I.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(I,F){e(I,F,$e)}};define(Se[64],De([1,0,8,21,3,5]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProgressLocation=e.$6u=void 0,e.$6u=(0,L.$Ph)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$7u=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(g){this.b=g}report(g){this.a=g,this.b(this.a)}}e.$8u=p;class E{get value(){return this.a}constructor(g){this.e=g}report(g){this.b?this.b.push(g):this.b=[g],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const g=this.b.shift();this.a=g,await this.e(this.a)}}finally{this.c=!1;const g=this.d;this.d=void 0,g?.()}}drain(){return this.c?new Promise(g=>{const y=this.d;this.d=()=>{y?.(),g()}}):Promise.resolve()}}e.$9u=E;let m=class extends f.$Rc{constructor(g,y){super(),this.a=new I.$ch,y.withProgress(g,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,f.$Pc)(()=>this.a.complete()))}report(g){this.b?this.b.report(g):this.c=g}};e.$0u=m,e.$0u=m=He([Be(1,e.$6u)],m);class A extends f.$Rc{constructor(g){super(),this.g=g,this.a=0,this.b=this.B(new f.$Qc)}start(g){this.stop();const y=++this.a,D=new F.$Xd;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},g),this.b.add((0,f.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Pc)(()=>D.cancel())),this.b.add((0,f.$Pc)(()=>this.c?this.c.done():void 0)),{id:y,token:D.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(g){this.a===g&&this.b.clear()}}e.$$u=A,e.$_u=(0,L.$Ph)("editorProgressService")}),define(Se[43],De([1,0,60,17]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class f{constructor(){this.a=new Map}add(R,p){I.ok(F.$yf(R)),I.ok(F.$Af(p)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$jn=new f}),define(Se[107],De([1,0,4,43]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function f(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class L{constructor(){this.b=new I.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,m){this.a[f(E)]=m,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$jn.add(e.$kn.JSONContribution,R)}),define(Se[138],De([1,0,19,4,17,195,50,107,43]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var m;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$on={Configuration:"base.contributions.configuration"};var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const P=E.$jn.as(p.$kn.JSONContribution);class g{constructor(){this.h=new Set,this.i=new F.$Nd,this.onDidSchemaChange=this.i.event,this.j=new F.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const d=new Set;this.n(t,n,d),P.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const n=new Set;this.o(t,n),P.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const d=new Set;this.o(n,d),this.n(t,!1,d),P.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const d=[];for(const{overrides:l,source:a}of t)for(const h in l)if(n.add(h),e.$yn.test(h)){const S=this.a.get(h),k=S?.valuesSources??new Map;if(a)for(const C of Object.keys(l[h]))k.set(C,a);const $={...S?.value||{},...l[h]};this.a.set(h,{source:a,value:$,valuesSources:k});const b=(0,R.$ti)(h),v={type:"object",default:$,description:L.localize(1,null,b),$ref:e.$vn,defaultDefaultValue:$,source:f.$yf(a)?void 0:a,defaultValueSource:a};d.push(...w(h)),this.d[h]=v,this.b.properties[h]=v}else{this.a.set(h,{value:l[h],source:a});const S=this.d[h];S&&(this.w(h,S),this.r(h,S))}this.m(d)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:d,source:l}of t)for(const a in d){const h=this.a.get(a),S=f.$yf(l)?l:l?.id,k=f.$yf(h?.source)?h?.source:h?.source?.id;if(S===k)if(n.add(a),this.a.delete(a),e.$yn.test(a))delete this.d[a],delete this.b.properties[a];else{const $=this.d[a];$&&(this.w(a,$),this.r(a,$))}}this.u()}deltaConfiguration(t){let n=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,d){t.forEach(l=>{this.p(l,n,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,n){const d=l=>{if(l.properties)for(const a in l.properties){n.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,l.properties[a])}l.allOf?.forEach(a=>d(a))};for(const l of t){d(l);const a=this.c.indexOf(l);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,d,l,a=3,h){a=f.$Hf(t.scope)?a:t.scope;const S=t.properties;if(S)for(const $ in S){const b=S[$];if(n&&s($,b)){delete S[$];continue}if(b.source=d,b.defaultDefaultValue=S[$].default,this.w($,b),e.$yn.test($)?b.scope=void 0:(b.scope=f.$Hf(b.scope)?a:b.scope,b.restricted=f.$Hf(b.restricted)?!!l?.includes($):b.restricted),S[$].hasOwnProperty("included")&&!S[$].included){this.f[$]=S[$],delete S[$];continue}else this.d[$]=S[$],S[$].policy?.name&&this.e.set(S[$].policy.name,$);!S[$].deprecationMessage&&S[$].markdownDeprecationMessage&&(S[$].deprecationMessage=S[$].markdownDeprecationMessage),h.add($)}const k=t.allOf;if(k)for(const $ of k)this.p($,n,d,l,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$pn.properties[t]=n,n.scope){case 1:e.$qn.properties[t]=n;break;case 2:e.$rn.properties[t]=n;break;case 6:e.$sn.properties[t]=n;break;case 3:e.$tn.properties[t]=n;break;case 4:e.$un.properties[t]=n;break;case 5:e.$un.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$pn.properties[t],n.scope){case 1:delete e.$qn.properties[t];break;case 2:delete e.$rn.properties[t];break;case 6:delete e.$sn.properties[t];break;case 3:delete e.$tn.properties[t];break;case 4:case 5:delete e.$un.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,d={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$vn};this.w(n,d),e.$pn.properties[n]=d,e.$qn.properties[n]=d,e.$rn.properties[n]=d,e.$sn.properties[n]=d,e.$tn.properties[n]=d,e.$un.properties[n]=d}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=t,e.$qn.patternProperties[e.$xn]=t,e.$rn.patternProperties[e.$xn]=t,e.$sn.patternProperties[e.$xn]=t,e.$tn.patternProperties[e.$xn]=t,e.$un.patternProperties[e.$xn]=t,this.i.fire()}w(t,n){const d=this.a.get(t);let l=d?.value,a=d?.source;f.$Ff(l)&&(l=n.defaultDefaultValue,a=void 0),f.$Ff(l)&&(l=c(n.type)),n.default=l,n.defaultValueSource=a}}const y="\\[([^\\]]+)\\]",D=new RegExp(y,"g");e.$xn=`^(${y})+$`,e.$yn=new RegExp(e.$xn);function w(o){const t=[];if(e.$yn.test(o)){let n=D.exec(o);for(;n?.length;){const d=n[1].trim();d&&t.push(d),n=D.exec(o)}}return(0,I.$Lb)(t)}e.$zn=w;function u(o){return o.reduce((t,n)=>`${t}[${n}]`,"")}e.$An=u;function c(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=c;const i=new g;E.$jn.add(e.$on.Configuration,i);function s(o,t){return o.trim()?e.$yn.test(o)?L.localize(7,null,o):i.getConfigurationProperties()[o]!==void 0?L.localize(8,null,o):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,o,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$Cn=s;function r(){const o=[],t=i.getConfigurationProperties();for(const n of Object.keys(t))o.push([n,t[n].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.$Dn=r}),define(Se[253],De([1,0,19,4,159,3,28,24,17,2,50,138,43]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function y(n){return Object.isFrozen(n)?n:p.$8m(n)}class D{constructor(d={},l=[],a=[],h){this.b=d,this.c=l,this.d=a,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof D)return l;const a=new w("");return a.parseRaw(l),a.configurationModel});this.f=d.reduce((l,a)=>a===l?a:l.merge(a),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$ri)(this.contents,d):this.contents}inspect(d,l){const a=this.rawConfiguration.getValue(d),h=l?this.rawConfiguration.getOverrideValue(d,l):void 0,S=l?this.rawConfiguration.override(l).getValue(d):a;return{value:a,override:h,merged:S}}getOverrideValue(d,l){const a=this.i(l);return a?d?(0,A.$ri)(a,d):a:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const a of this.overrides)a.identifiers.includes(d)&&l.push(...a.keys);return I.$Lb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return I.$Lb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=p.$7m(this.contents),a=p.$7m(this.overrides),h=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const k of d)if(S.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(l,k.contents);for(const $ of k.overrides){const[b]=a.filter(v=>I.$tb(v.identifiers,$.identifiers));b?(this.h(b.contents,$.contents),b.keys.push(...$.keys),b.keys=I.$Lb(b.keys)):a.push(p.$7m($))}for(const $ of k.keys)h.indexOf($)===-1&&h.push($)}return new D(l,h,a,S.every(k=>k instanceof D)?void 0:S)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const a={};for(const h of I.$Lb([...Object.keys(this.contents),...Object.keys(l)])){let S=this.contents[h];const k=l[h];k&&(typeof S=="object"&&typeof k=="object"?(S=p.$7m(S),this.h(S,k)):S=k),a[h]=S}return new D(a,this.keys,this.overrides)}h(d,l){for(const a of Object.keys(l)){if(a in d&&E.$Af(d[a])&&E.$Af(l[a])){this.h(d[a],l[a]);continue}d[a]=p.$7m(l[a])}}i(d){let l=null,a=null;const h=S=>{S&&(a?this.h(a,S):a=p.$7m(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===d?l=S.contents:S.identifiers.includes(d)&&h(S.contents);return h(l),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$qi)(this.contents,d),P.$yn.test(d)&&this.overrides.splice(this.overrides.findIndex(a=>I.$tb(a.identifiers,(0,P.$zn)(d))),1))}j(d,l,a){(0,A.$pi)(this.contents,d,l,h=>console.error(h)),a=a||this.keys.indexOf(d)===-1,a&&this.keys.push(d),P.$yn.test(d)&&this.overrides.push({identifiers:(0,P.$zn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$oi)(this.contents[d],h=>console.error(h))})}}e.$En=D;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!E.$Hf(d)){const a=this.g(d);this.parseRaw(a,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:a,keys:h,overrides:S,restricted:k,hasExcludedProperties:$}=this.h(d,l);this.b=new D(a,h,S,$?[d]:void 0),this.c=k||[]}g(d){let l={},a=null,h=[];const S=[],k=[];function $(v){Array.isArray(h)?h.push(v):a!==null&&(h[a]=v)}const b={onObjectBegin:()=>{const v={};$(v),S.push(h),h=v,a=null},onObjectProperty:v=>{a=v},onObjectEnd:()=>{h=S.pop()},onArrayBegin:()=>{const v=[];$(v),S.push(h),h=v,a=null},onArrayEnd:()=>{h=S.pop()},onLiteralValue:$,onError:(v,C,N)=>{k.push({error:v,offset:C,length:N})}};if(d)try{f.$4m(d,b),l=h[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return l}h(d,l){const a=g.$jn.as(P.$on.Configuration).getConfigurationProperties(),h=this.i(d,a,!0,l);d=h.raw;const S=(0,A.$oi)(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),k=Object.keys(d),$=this.j(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:S,keys:k,overrides:$,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,a,h){let S=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:S};const k={},$=[];for(const b in d)if(P.$yn.test(b)&&a){const v=this.i(d[b],l,!1,h);k[b]=v.raw,S=S||v.hasExcludedProperties,$.push(...v.restricted)}else{const v=l[b],C=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&$.push(b),!h.exclude?.includes(b)&&(h.include?.includes(b)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&v?.restricted))?k[b]=d[b]:S=!0}return{raw:k,restricted:$,hasExcludedProperties:S}}j(d,l){const a=[];for(const h of Object.keys(d))if(P.$yn.test(h)){const S={};for(const k in d[h])S[k]=d[h][k];a.push({identifiers:(0,P.$zn)(h),keys:Object.keys(S),contents:(0,A.$oi)(S,l)})}return a}}e.$Fn=w;class u extends L.$Rc{constructor(d,l,a,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new F.$Nd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&a.isEqual(S.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=u;class c{constructor(d,l,a,h,S,k,$,b,v,C,N,T,M){this.a=d,this.b=l,this.c=a,this.overrideIdentifiers=h,this.d=S,this.f=k,this.g=$,this.h=b,this.i=v,this.j=C,this.k=N,this.l=T,this.m=M}get value(){return y(this.c)}n(d,l,a){const h=d.inspect(l,a);return{get value(){return y(h.value)},get override(){return y(h.override)},get merged(){return y(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,l,a,h,S=new D,k=new D,$=new R.$zc,b=new D,v=new R.$zc){this.c=d,this.d=l,this.f=a,this.g=h,this.h=S,this.i=k,this.j=$,this.l=b,this.m=v,this.a=null,this.b=new R.$zc,this.n=null}getValue(d,l,a){return this.q(d,l,a).getValue(d)}updateValue(d,l,a={}){let h;a.resource?(h=this.m.get(a.resource),h||(h=new D,this.m.set(a.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),a.resource||(this.a=null)}inspect(d,l,a){const h=this.q(d,l,a),S=this.u(l.resource,a),k=l.resource?this.m.get(l.resource)||this.l:this.l,$=new Set;for(const b of h.overrides)for(const v of b.identifiers)h.getOverrideValue(d,v)!==void 0&&$.add(v);return new c(d,l,h.getValue(d),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,S||void 0,k)}keys(d){const l=this.u(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.p.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const a=[];if(!l){const{added:h,updated:S,removed:k}=o(this.c,d);l=[...h,...S,...k]}for(const h of l)for(const S of(0,P.$zn)(h)){const k=this.c.getKeysForOverrideIdentifier(S),$=d.getKeysForOverrideIdentifier(S),b=[...$.filter(v=>k.indexOf(v)===-1),...k.filter(v=>$.indexOf(v)===-1),...k.filter(v=>!p.$$m(this.c.override(S).getValue(v),d.override(S).getValue(v)))];a.push([S,b])}return this.updateDefaultConfiguration(d),{keys:l,overrides:a}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:a,removed:h}=o(this.d,d),S=[...l,...a,...h];return S.length&&this.updatePolicyConfiguration(d),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:a,removed:h,overrides:S}=o(this.applicationConfiguration,d),k=[...l,...a,...h];return k.length&&this.updateApplicationConfiguration(d),{keys:k,overrides:S}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:a,removed:h,overrides:S}=o(this.localUserConfiguration,d),k=[...l,...a,...h];return k.length&&this.updateLocalUserConfiguration(d),{keys:k,overrides:S}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:a,removed:h,overrides:S}=o(this.remoteUserConfiguration,d),k=[...l,...a,...h];return k.length&&this.updateRemoteUserConfiguration(d),{keys:k,overrides:S}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:a,removed:h,overrides:S}=o(this.workspaceConfiguration,d),k=[...l,...a,...h];return k.length&&this.updateWorkspaceConfiguration(d),{keys:k,overrides:S}}compareAndUpdateFolderConfiguration(d,l){const a=this.p.get(d),{added:h,updated:S,removed:k,overrides:$}=o(a,l),b=[...h,...S,...k];return(b.length||!a)&&this.updateFolderConfiguration(d,l),{keys:b,overrides:$}}compareAndDeleteFolderConfiguration(d){const l=this.p.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:a,updated:h,removed:S,overrides:k}=o(l,void 0);return{keys:[...a,...h,...S],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(d,l,a){let h=this.r(l,a);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}r({resource:d},l){let a=this.s();if(l&&d){const h=l.getFolder(d);h&&(a=this.t(h.uri)||a);const S=this.m.get(d);S&&(a=a.merge(S))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(d){let l=this.b.get(d);if(!l){const a=this.s(),h=this.j.get(d);h?(l=a.merge(h),this.b.set(d,l)):l=a}return l}u(d,l){if(l&&d){const a=l.getFolder(d);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:a,overrides:h,keys:S}=this.j.get(l);return d.push([l,{contents:a,overrides:h,keys:S}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(a=>d.add(a))),[...d.values()]}v(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(a=>d.add(a))),[...d.values()]}w(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.i.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.x(d.defaults),a=this.x(d.policy),h=this.x(d.application),S=this.x(d.user),k=this.x(d.workspace),$=d.folders.reduce((b,v)=>(b.set(m.URI.revive(v[0]),this.x(v[1])),b),new R.$zc);return new i(l,a,h,S,new D,k,$,new D,new R.$zc)}static x(d){return new D(d.contents,d.keys,d.overrides)}}e.$Hn=i;function s(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const d=new Set,l=new Map;for(const h of n)h.keys.forEach(S=>d.add(S)),h.overrides.forEach(([S,k])=>{const $=(0,R.$wc)(l,S,new Set);k.forEach(b=>$.add(b))});const a=[];return l.forEach((h,S)=>a.push([S,[...h.values()]])),{keys:[...d.values()],overrides:a}}e.$In=s;class r{constructor(d,l,a,h){this.change=d,this.f=l,this.g=a,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of d.keys)this.affectedKeys.add(S);for(const[,S]of d.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,l){const a=this.a+d,h=this.d.indexOf(a);if(h<0)return!1;const S=h+a.length;if(S>=this.d.length)return!1;const k=this.d.charCodeAt(S);if(k!==this.b&&k!==this.c)return!1;if(l){const $=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,b=this.g.getValue(d,l,this.h);return!p.$$m($,b)}return!0}}e.$Jn=r;function o(n,d){const{added:l,removed:a,updated:h}=t(d?.rawConfiguration,n?.rawConfiguration),S=[],k=n?.getAllOverrideIdentifiers()||[],$=d?.getAllOverrideIdentifiers()||[];if(d){const b=$.filter(v=>!k.includes(v));for(const v of b)S.push([v,d.getKeysForOverrideIdentifier(v)])}if(n){const b=k.filter(v=>!$.includes(v));for(const v of b)S.push([v,n.getKeysForOverrideIdentifier(v)])}if(d&&n){for(const b of k)if($.includes(b)){const v=t({contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)},{contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)});S.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:l,removed:a,updated:h,overrides:S}}function t(n,d){const l=n?d?n.keys.filter(S=>d.keys.indexOf(S)===-1):[...n.keys]:[],a=d?n?d.keys.filter(S=>n.keys.indexOf(S)===-1):[...d.keys]:[],h=[];if(n&&d){for(const S of d.keys)if(n.keys.indexOf(S)!==-1){const k=(0,A.$ri)(d.contents,S),$=(0,A.$ri)(n.contents,S);p.$$m(k,$)||h.push(S)}}return{added:l,removed:a,updated:h}}}),define(Se[254],De([1,0,22,4,3,83]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkb=e.$Ykb=e.$Xkb=e.$Wkb=void 0;const R=(m,A,P)=>{const g=new Uint8Array(16);for(let w=0;w<16;w++)g[w]=Math.round(Math.random()*256);const y=(0,I.$ve)(I.$be.wrap(g));return[`GET ws://localhost${m}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Wkb=R,e.$Xkb=I.$be.fromString(`\r
\r
`);async function p(m,A,P,g,y){m.write(I.$be.fromString((0,e.$Wkb)(A,P,g)));const D=new f.$Qc;try{return await new Promise((w,u)=>{let c;D.add(m.onData(i=>{c?c=I.$be.concat([c,i],c.byteLength+i.byteLength):c=i;const s=c.indexOf(e.$Xkb);if(s===-1)return;w(m),m.pauseData();const r=c.slice(s+e.$Xkb.byteLength);r.byteLength&&y.onData.fire(r)})),D.add(m.onClose(i=>u(i??new Error("socket closed")))),D.add(m.onEnd(()=>u(new Error("socket ended"))))})}catch(w){throw m.dispose(),w}finally{D.dispose()}}e.$Ykb=p;class E extends f.$Rc{constructor(A,P){super(),this.g=A,this.a=this.B(new F.$Qd),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new F.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(g=>this.a.fire(g))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Zkb=E}),define(Se[65],De([1,0,9,5]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,F.$Ph)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class L{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=L;class R{constructor(P,g){this.host=P,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=R;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class E extends I.$ab{static isNotAvailable(P){return P instanceof E&&P._code===p.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof E&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof E&&P._code===p.NoResolverFound}static isInvalidAuthority(P){return P instanceof E&&P._code===p.InvalidAuthority}static isHandled(P){return P instanceof E&&P.isHandled}constructor(P,g=p.Unknown,y){super(P),this._message=P,this._code=g,this._detail=y,this.isHandled=g===p.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Sk=E;function m(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}e.$Tk=m}),define(Se[66],De([1,0,18]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function F(m){return m.scheme===I.Schemas.vscodeRemote?m.authority:void 0}e.$Uk=F;function f(m){if(!m)return;const A=m.indexOf("+");return A<0?m:m.substr(0,A)}e.$Vk=f;function L(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$Wk=L;function R(m){const{host:A,port:P}=E(m);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:P}}e.$Xk=R;function p(m,A){let{host:P,port:g}=E(m);return typeof g>"u"&&(g=A),{host:P,port:g}}e.$Yk=p;function E(m){const A=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const P=m.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const g=m.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:m,port:void 0}}}),define(Se[25],De([1,0,13,5,66]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$4l=L,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class E{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,c){if(typeof u>"u"||u===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof u=="string"||typeof c=="string"){const i=typeof u=="string"?u:u.value,s=typeof c=="string"?c:c.value;return I.$2e(i,s)}return u._lower===c._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$6l=E;class m{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const c of u)this.add(c)}add(u){this.c.add(E.toKey(u))}delete(u){return this.c.delete(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}}e.$7l=m;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(E.toKey(u))}get(u){return this.c.get(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}set(u,c){this.c.set(E.toKey(u),c)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=A;function P(w){return g(w)}e.$9l=P;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$0l=g;function y(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$$l=y;function D(w,u){if(u){const c=`onResolveRemoteAuthority:${(0,f.$Vk)(u)}`;return!!w.activationEvents?.includes(c)}return!1}e.$_l=D,e.$am=(0,F.$Ph)("IBuiltinExtensionsScannerService")}),define(Se[139],De([1,0,9,25]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const E of R){const m=this.readActivationEvents(E);m.length>0&&(p[F.$6l.toKey(E.identifier)]=m)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return p;for(const E in R.contributes){const m=this.a.get(E);if(!m)continue;const A=R.contributes[E],P=Array.isArray(A)?A:[A];try{m(P,p)}catch(g){(0,I.$Z)(g)}}return p}}e.$2E=f,e.$3E=new f}),define(Se[255],De([1,0,8,22,21,9,4,3,56,36,32,83,65,66]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const D=30*1e3;var w;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function u(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(H){const z=new f.$Xd;return setTimeout(()=>z.cancel(),H),z.token}function i(H,z){if(H.isCancellationRequested||z.isCancellationRequested)return f.CancellationToken.Cancelled;const X=new f.$Xd;return H.onCancellationRequested(()=>X.cancel()),z.onCancellationRequested(()=>X.cancel()),X.token}class s{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new p.$Qc,this.promise=new Promise((X,re)=>{this.f=X,this.g=re}),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function r(H,z){const X=new s(z);return X.registerDisposable(H.onControlMessage(re=>{const Z=JSON.parse(re.toString()),ee=Q(Z);ee?X.reject(ee):X.resolve(Z)})),X.promise}function o(H,z,X,re,Z,ee,_,we){const ue=new s(we),ge=m.$Jd.create(!1);return H.info(`Creating a socket (${_})...`),E.mark(`code/willCreateSocket/${ee}`),z.connect(X,re,Z,_).then(te=>{ue.didTimeout?(E.mark(`code/didCreateSocketError/${ee}`),H.info(`Creating a socket (${_}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(E.mark(`code/didCreateSocketOK/${ee}`),H.info(`Creating a socket (${_}) was successful after ${ge.elapsed()} ms.`),ue.resolve(te))},te=>{E.mark(`code/didCreateSocketError/${ee}`),H.info(`Creating a socket (${_}) returned an error after ${ge.elapsed()} ms.`),H.error(te),ue.reject(te)}),ue.promise}function t(H,z){const X=new s(z);return H.then(re=>{X.didTimeout||X.resolve(re)},re=>{X.didTimeout||X.reject(re)}),X.promise}async function n(H,z,X,re){const Z=ae(H,z);H.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await o(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,y.$Wk)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,u(z),`renderer-${u(z)}-${H.reconnectionToken}`,re)}catch(te){throw H.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),H.logService.error(te),te}H.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let _,we;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(ee,null),_=H.reconnectionProtocol,we=!1):(_=new P.$Dh({socket:ee}),we=!0),H.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ue=await t(H.signService.createNewMessage((0,A.$eg)()),re),ge={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ue.data};_.sendControl(F.$be.fromString(JSON.stringify(ge)));try{const te=await r(_,i(re,c(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(H.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await t(H.signService.validate(ue,te.signedData),re)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(H.signService.sign(te.data),re),Pe={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:z};return X&&(Pe.args=X),H.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(F.$be.fromString(JSON.stringify(Pe))),{protocol:_,ownsProtocol:we}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(H.logService.error(`${Z} the handshake timed out. Error:`),H.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${Z} received error control message when negotiating connection. Error:`),H.logService.error(te)),we&&x(_),te}}async function d(H,z,X,re){const Z=Date.now(),ee=ae(H,z),{protocol:_,ownsProtocol:we}=await n(H,z,X,re),ue=new s(re);return ue.registerDisposable(_.onControlMessage(ge=>{const te=JSON.parse(ge.toString()),fe=Q(te);fe?(H.logService.error(`${ee} received error control message when negotiating connection. Error:`),H.logService.error(fe),we&&x(_),ue.reject(fe)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${ye(Z)}!`),ue.resolve({protocol:_,firstMessage:te}))})),ue.promise}async function l(H,z){const{protocol:X}=await d(H,1,void 0,z);return{protocol:X}}async function a(H,z,X){const{protocol:re,firstMessage:Z}=await d(H,2,z,X),ee=Z&&Z.debugPort;return{protocol:re,debugPort:ee}}async function h(H,z,X){const re=Date.now(),Z=ae(H,3),{protocol:ee}=await n(H,3,z,X);return H.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${ye(re)}!`),ee}async function S(H,z,X){const{connectTo:re,connectionToken:Z}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:re,connectionToken:Z,reconnectionToken:z,reconnectionProtocol:X,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function k(H,z,X){return b(H,async re=>{const{protocol:Z}=await l(re,f.CancellationToken.None);return new q(H,z,X,re.reconnectionToken,Z)})}e.$4k=k;async function $(H,z){return b(H,async X=>{const{protocol:re,debugPort:Z}=await a(X,z,f.CancellationToken.None);return new de(H,z,X.reconnectionToken,re,Z)})}e.$5k=$;async function b(H,z){for(let re=1;;re++)try{const Z=(0,A.$eg)(),ee=await S(H,Z,null);return await z(ee)}catch(Z){if(re<5)H.logService.error(`[remote-connection][attempt ${re}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(Z);else throw H.logService.error(`[remote-connection][attempt ${re}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(Z),V.triggerPermanentFailure(0,0,g.$Sk.isHandled(Z)),Z}}async function v(H,z,X){const re=await S(H,(0,A.$eg)(),null);return await h(re,{host:z,port:X},f.CancellationToken.None)}e.$6k=v;function C(H){return(0,I.$Hg)(z=>new Promise((X,re)=>{const Z=setTimeout(X,H*1e3);z.onCancellationRequested(()=>{clearTimeout(Z),X()})}))}var N;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class T{constructor(z,X){this.reconnectionToken=z,this.millisSinceLastIncomingData=X,this.type=0}}e.$7k=T;class M{constructor(z,X,re,Z){this.reconnectionToken=z,this.millisSinceLastIncomingData=X,this.durationSeconds=re,this.c=Z,this.type=1}skipWait(){this.c.cancel()}}e.$8k=M;class U{constructor(z,X,re){this.reconnectionToken=z,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=2}}e.$9k=U;class j{constructor(z,X,re){this.reconnectionToken=z,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=4}}e.$0k=j;class O{constructor(z,X,re,Z){this.reconnectionToken=z,this.millisSinceLastIncomingData=X,this.attempt=re,this.handled=Z,this.type=3}}e.$$k=O;class V extends p.$Rc{static triggerPermanentFailure(z,X,re){this._permanentFailure=!0,this.f=z,this.g=X,this.h=re,this.j.forEach(Z=>Z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(z=>z.y())}static debugPauseSocketWriting(){this.j.forEach(z=>z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||V._permanentFailure}constructor(z,X,re,Z,ee){super(),this.t=z,this.u=X,this.reconnectionToken=re,this.protocol=Z,this.w=ee,this.m=this.B(new R.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(Z.onSocketClose(_=>{const we=ie(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${we} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${we} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${we} received socket close event.`),this.y()})),this.B(Z.onSocketTimeout(_=>{const we=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${we} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),V.j.push(this),this.B((0,p.$Pc)(()=>{const _=V.j.indexOf(this);_>=0&&V.j.splice(_,1)})),this.n&&this.D(V.f,V.g,V.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const z=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const X=[0,5,5,10,10,10,10,10,30];let re=-1;do{re++;const Z=re<X.length?X[re]:X[X.length-1];try{if(Z>0){const _=C(Z);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,_)),this.u.logService.info(`${z} waiting for ${Z} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1)),this.u.logService.info(`${z} resolving connection...`);const ee=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${z} connecting to ${ee.connectTo}...`),await this.G(ee,c(D)),this.u.logService.info(`${z} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(re>360){this.u.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(g.$Sk.isTemporarilyNotAvailable(ee)){this.u.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.u.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((0,L.$3)(ee)){this.u.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if(ee instanceof g.$Sk){this.u.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,g.$Sk.isHandled(ee));break}this.u.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}}while(!this.n&&!this.s)}C(z,X,re){this.w?V.triggerPermanentFailure(z,X,re):this.D(z,X,re)}D(z,X,re){this.m.fire(new O(this.reconnectionToken,z,X,re)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=V;class q extends V{constructor(z,X,re,Z,ee){super(1,z,Z,ee,!0),this.client=this.B(new P.$Bh(ee,{remoteAuthority:X,clientId:re},z.ipcLogger))}async G(z,X){await l(z,X)}}e.$al=q;class de extends V{constructor(z,X,re,Z,ee){super(2,z,re,Z,!1),this.H=X,this.debugPort=ee}async G(z,X){await a(z,this.H,X)}}e.$bl=de;function x(H){try{H.acceptDisconnect();const z=H.getSocket();H.dispose(),z.dispose()}catch(z){(0,L.$Z)(z)}}function Q(H){if(H&&H.type==="error"){const z=new Error(`Connection error: ${H.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function G(H,z){for(;H.length<z;)H+=" ";return H}function ce(H,z){return`[remote-connection][${G(u(H),13)}][${z.substr(0,5)}\u2026]`}function ie(H,z,X){return`${ce(H,z)}[${X?"reconnect":"initial"}]`}function ae(H,z){return`${ie(z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function ye(H){return`${Date.now()-H} ms`}}),define(Se[256],De([1,0,3,5]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,F.$Ph)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(R,p){return this.a[R]??=[],this.a[R].push(p),(0,I.$Pc)(()=>{const E=this.a[R]?.indexOf(p);typeof E=="number"&&E>=0&&this.a[R]?.splice(E,1)})}b(R){return(this.a[R.type]||[]).find(E=>E.supports(R))}connect(R,p,E,m){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,p,E,m)}}e.$1k=f}),define(Se[257],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y3b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const L=await this.c();if(L){const R=String(I.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,L){if(!f.id)return!0;const R=this.b.get(f.id);if(!R)return!1;this.b.delete(f.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$Y3b=I}),define(Se[108],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,I.$Ph)(e.$2k)}),define(Se[140],De([1,0,257]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S8b=void 0;class F extends I.$Y3b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>$e(["vsda"],L,R))}}e.$S8b=F}),define(Se[258],De([1,0,12,48,32]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function L(E){if(I.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,m,A,P,g,y,D,w,u){const c=Object.create(null);c["common.machineId"]=y,c["common.sqmId"]=D,c.sessionID=(0,f.$eg)()+Date.now(),c.commitHash=P,c.version=g,c["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,I.$i)(I.$u),c["common.nodePlatform"]=F.$cc,c["common.nodeArch"]=A,c["common.product"]=u||"desktop",w&&(c["common.msftInternal"]=w);let i=0;const s=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$m&&(c["common.snap"]="true");const r=L(m);return r&&(c["common.platformDetail"]=r),c}e.$ko=R;function p(E){const m=F.env.USERDNSDOMAIN;if(!m)return!1;const A=m.toLowerCase();return E.some(P=>A===P)}e.$lo=p}),define(Se[259],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,I.$Ph)("telemetryService"),e.$dl=(0,I.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(Se[86],De([1,0,24,17,4,50,66,258,259]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class m{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$mo=m;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=A,e.$oo=new A;class P{async publicLog(a,h,S){}async publicLogError(a,h,S){}}e.$po=P,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function g(l,a){return f.Event.debounce(a.onDidChangeConfiguration,(S,k)=>{const $=S?new Set([...S.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:$}},1e3,!0)(S=>{S.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,L.$mi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$to=g;function y(l,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!l.enableTelemetry)}e.$uo=y;function D(l,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.$vo=D;function w(l){const a=l.getValue(E.$kl),h=l.getValue(E.$ll);if(l.getValue(E.$ml)===!1||h===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=w;function u(l){const a={},h={},S={};s(l,S);for(let k in S){k=k.length>150?k.substr(k.length-149):k;const $=S[k];typeof $=="number"?h[k]=$:typeof $=="boolean"?h[k]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${$.length}`),a[k]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(a[k]=$)}return{properties:a,measurements:h}}e.$xo=u;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(l){if(!l)return"none";const a=(0,R.$Vk)(l);return c.has(a)?a:"other"}e.$yo=i;function s(l,a,h=0,S){if(l)for(const k of Object.getOwnPropertyNames(l)){const $=l[k],b=S?S+k:k;Array.isArray($)?a[b]=(0,I.$_m)($):$ instanceof Date?a[b]=$.toISOString():(0,F.$Af)($)?h<2?s($,a,h+1,b+"."):a[b]=(0,I.$_m)($):a[b]=$}}function r(l,a){const h=l.msftInternalDomains||[],S=a.getValue("telemetry.internalTesting");return(0,p.$lo)(h)||S}e.$zo=r;function o(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.$Ao=o;function t(l,a){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let h=l;const S=[];for(const v of a)for(;;){const C=v.exec(l);if(!C)break;S.push([C.index,v.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(h="";;){const v=$.exec(l);if(!v)break;const C=S.some(([N,T])=>v.index<T&&N<$.lastIndex);!k.test(v[0])&&!C&&(h+=l.substring(b,v.index)+"<REDACTED: user-file-path>",b=$.lastIndex)}return b<l.length&&(h+=l.substr(b)),h}function n(l){if(!l)return l;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(l))return`<REDACTED: ${h.label}>`;return l}function d(l,a){return(0,I.$9m)(l,h=>{if(h instanceof m||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let S=h.replaceAll("%20"," ");S=t(S,a);for(const k of a)S=S.replace(k,"");return S=n(S),S}})}e.$Bo=d}),define(Se[260],De([1,0,13,134,25,12,2,9,48,86]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,I.$We)(d.id,l.id)===0}e.$Co=A;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(l){const a=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new g(l.identifier,a,h)}static parse(l){const a=P.exec(l);return a&&a[1]&&a[2]?new g({id:a[1]},a[2],a[4]||void 0):null}constructor(l,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof g?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Do=g;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(d){const l=y.exec(d);return l&&l[1]?[u(l[1]),l[2]]:[u(d),void 0]}e.$Eo=D;function w(d,l){return`${d}.${l}`}e.$Fo=w;function u(d){return d.toLowerCase()}e.$Go=u;function c(d,l){return u(w(d??f.$2l,l))}e.$Ho=c;function i(d,l){const a=[],h=S=>{for(const k of a)if(k.some($=>A(l($),l(S))))return k;return null};for(const S of d){const k=h(S);k?k.push(S):a.push([S])}return a}e.$Io=i;function s(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Jo=s;function r(d){return{id:new m.$mo(d.identifier.id),name:new m.$mo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Ko=r,e.$Lo=new f.$6l("pprice.better-merge");function o(d,l){const a=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const S=h.shift();if(S&&a.every(k=>!A(k.identifier,{id:S}))){const k=d.filter($=>A($.identifier,{id:S}));k.length===1&&(a.push(k[0]),h.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Mo=o;async function t(d,l){if(!L.$l)return!1;let a;try{a=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,p.$9)(S))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const a=await t(d,l),h=(0,F.$9n)(a?"alpine":L.$u,E.$dc);return l.debug("ComputeTargetPlatform:",h),h}e.$No=n}),define(Se[261],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=e.$qr=e.$pr=e.$or=e.$nr=void 0;function I(E){return[...E.entries()]}e.$nr=I;function F(E){return E?[...E.entries()]:[]}e.$or=F;function f(E){return new Map(E)}e.$pr=f;function L(E){return new Map(E??[])}e.$qr=L;function R(E){return Array.from(E.entries()).map(m=>[m[0],I(m[1].map),F(m[1].descriptionMap)])}e.$rr=R;function p(E){return new Map(E.map(m=>[m[0],{map:f(m[1]),descriptionMap:L(m[2])}]))}e.$sr=p}),define(Se[262],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elb=void 0;class I{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,L,R=5){const p=L(E=>{const m=typeof E=="string"?E:E.data;let A=this.a.get(f);if(A){A.data.push(m);return}const P=setTimeout(()=>this.flushBuffer(f),R);A={data:[m],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(f),p.dispose()}},this.a.set(f,A)});return p}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const L=this.a.get(f);L&&(this.a.delete(f),this.b(f,L.data.join("")))}}e.$elb=I}),define(Se[263],De([1,0,8,79,61,4,17,2,206,107,43]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.IconFontDefinition=e.IconContribution=e.$8v=void 0,e.$8v={IconContribution:"base.contributions.icons"};var P;(function(r){function o(t,n){let d=t.defaults;for(;f.ThemeIcon.isThemeIcon(d);){const l=D.getIcon(d.id);if(!l)return;d=l.defaults}return d}r.getDefinition=o})(P||(e.IconContribution=P={}));var g;(function(r){function o(n){return{weight:n.weight,style:n.style,src:n.src.map(d=>({format:d.format,location:d.location.toString()}))}}r.toJSONObject=o;function t(n){const d=l=>(0,R.$yf)(l)?l:void 0;if(n&&Array.isArray(n.src)&&n.src.every(l=>(0,R.$yf)(l.format)&&(0,R.$yf)(l.location)))return{weight:d(n.weight),style:d(n.style),src:n.src.map(l=>({format:l.format,location:p.URI.parse(l.location)}))}}r.fromJSONObject=t})(g||(e.IconFontDefinition=g={}));class y{constructor(){this.a=new L.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,t,n,d){const l=this.b[o];if(l){if(n&&!l.description){l.description=n,this.d.properties[o].markdownDescription=`${n} $(${o})`;const S=this.e.enum.indexOf(o);S!==-1&&(this.e.enumDescriptions[S]=n),this.a.fire()}return l}const a={id:o,description:n,defaults:t,deprecationMessage:d};this.b[o]=a;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),n&&(h.markdownDescription=`${n}: $(${o})`),this.d.properties[o]=h,this.e.enum.push(o),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const t=this.e.enum.indexOf(o);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,t){const n=this.f[o];return n||(this.f[o]=t,this.a.fire(),t)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(l,a)=>l.id.localeCompare(a.id),t=l=>{for(;f.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(l=>this.b[l]);for(const l of d.filter(a=>!!a.description).sort(o))n.push(`|<i class="${t(l)}"></i>|${l.id}|${f.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const l of d.filter(a=>!f.ThemeIcon.isThemeIcon(a.defaults)).sort(o))n.push(`|<i class="${t(l)}"></i>|${l.id}|`);return n.join(`
`)}}const D=new y;A.$jn.add(e.$8v.IconContribution,D);function w(r,o,t,n){return D.registerIcon(r,o,t,n)}e.$9v=w;function u(){return D}e.$0v=u;function c(){const r=(0,F.$Sj)();for(const o in r){const t="\\"+r[o].toString(16);D.registerIcon(o,{fontCharacter:t})}}c(),e.$$v="vscode://schemas/icons";const i=A.$jn.as(m.$kn.JSONContribution);i.registerSchema(e.$$v,D.getIconSchema());const s=new I.$6g(()=>i.notifySchemaChanged(e.$$v),200);D.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$_v=w("widget-close",F.$Uj.close,(0,E.localize)(2,null)),e.$aw=w("goto-previous-location",F.$Uj.arrowUp,(0,E.localize)(3,null)),e.$bw=w("goto-next-location",F.$Uj.arrowDown,(0,E.localize)(4,null)),e.$cw=f.ThemeIcon.modify(F.$Uj.sync,"spin"),e.$dw=f.ThemeIcon.modify(F.$Uj.loading,"spin")}),define(Se[87],De([1,0,4,50,5,15]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,f.$Ph)("tunnelService"),e.$bv=(0,f.$Ph)("sharedTunnelsService");var R;(function(u){u.Http="http",u.Https="https"})(R||(e.TunnelProtocol=R={}));var p;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(u){return!!u.forwardPort}e.$cv=E;var m;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function A(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(c)return{address:c[1],port:+c[2]}}e.$dv=A,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(u){return e.$ev.indexOf(u)>=0}e.$fv=P,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(u){return e.$gv.indexOf(u)>=0}e.$hv=g;function y(u,c,i,s){if(i===1)return!1;if(i===2&&g(c)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(r?.length===4&&parseInt(r[1])>=18)return!1}return u<1024}e.$iv=y;class D{constructor(c,i,s){this.remoteAddress=c,this.localAddress=i,this.b=s,this.a=new I.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=D;let w=class{constructor(c,i){this.j=c,this.k=i,this.a=new I.$Nd,this.onTunnelOpened=this.a.event,this.b=new I.$Nd,this.onTunnelClosed=this.b.event,this.c=new I.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],i=Array.from(this.e.values());for(const s of i){const r=Array.from(s.values());for(const o of r){const t=await o.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:i}of c.values())await i.then(s=>typeof s!="string"?s?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,i,s,r,o){this.p(c,i,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:i,localAddress:s,privacy:r,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,i){(g(c)||P(c))&&(c=e.$ev[0]);const s=this.r(c,i);if(s)return++s.refcount,s.value}openTunnel(c,i,s,r,o,t=!1,n,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${s} on local port ${o}.`);const l=this.f??c;if(!l)return;if(i||(i="localhost"),r||(r=this.l),this.f&&this.i.has(s)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(l,i,s,r,o,t,n,d);return a?a.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,s),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,s);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==s)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&h.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const i=this.e.get(c.tunnelRemoteHost);if(i){const s=i.get(c.tunnelRemotePort);s&&(s.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,s))}}}}async o(c,i,s){if(s.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${i}.`);const r=s.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(i),r}}async closeTunnel(c,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${i} `);const s=this.e.get(c);if(s&&s.has(i)){const r=s.get(i);r.refcount=0,await this.o(c,i,r)}}p(c,i,s){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(i,{refcount:1,value:s})}async q(c,i){const s=this.e.get(c);if(s){const r=s.get(i),o=r?await r.value:void 0;(!o||typeof o=="string")&&s.delete(i),s.size===0&&this.e.delete(c)}}r(c,i){const s=[c];P(c)?(s.push(...e.$ev),s.push(...e.$gv)):g(c)&&s.push(...e.$gv);const r=s.map(o=>this.e.get(o));for(const o of r){const t=o?.get(i);if(t)return t}}canTunnel(c){return!!A(c)}t(c,i,s,r,o,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${s} on local port ${r}.`);const d=s;this.i.add(d);const l=r===void 0?s:r,a={elevationRequired:o?this.isPortPrivileged(l):!1},h={remoteAddress:{host:i,port:s},localAddressPort:r,privacy:t,public:t?t!==p.Private:void 0,protocol:n},S=c.forwardPort(h,a);return S?(this.p(i,s,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),S}};e.$kv=w,e.$kv=w=He([Be(0,L.$0i),Be(1,F.$ji)],w)}),define(Se[264],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,I.$Ph)("IUriIdentityService")}),define(Se[265],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$lv=void 0,e.$lv=(0,I.$Ph)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Se[266],De([1,0,18]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0;function F(E){return E.scheme!==I.Schemas.file&&E.scheme!==I.Schemas.vscodeRemote}e.$ZJ=F;function f(E){if(E.folders.length)return E.folders.every(m=>F(m.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$1J=f;function L(E){return f(E)?.scheme}e.$2J=L;function R(E){return f(E)?.authority}e.$3J=R;function p(E){return f(E)!==void 0}e.$4J=p}),define(Se[44],De([1,0,208,16,78,23,2,5,18]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,p.$Ph)("contextService");function m(l){const a=l;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}e.$Zh=m;function A(l){return typeof l?.id=="string"&&!m(l)&&!g(l)}e.$1h=A,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function P(l,a){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,F.$mc)(l)}:a?e.$2h:e.$3h;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$4h=P;function g(l){const a=l;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}e.$5h=g;function y(l){const a=l;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}e.$6h=y;var D;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function w(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$7h=w;function u(l){const a=l;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$8h=u;class c{constructor(a,h,S,k,$){this.h=a,this.j=S,this.k=k,this.l=$,this.c=f.$Vh.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=f.$Vh.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=c;class i{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,L.$vg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=i;function s(l){return new i({uri:l,index:0,name:(0,L.$rg)(l)},{uri:l.toString()})}e.$$h=s,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,I.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function r(l,a){return L.$mg.isEqualOrParent(l,a.untitledWorkspacesHome)}e.$di=r;function o(l){let a;return R.URI.isUri(l)?a=l:a=l.configuration,a?.scheme===E.Schemas.tmp}e.$ei=o,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$fi}e.$gi=t;function n(l,a){return!r(l,a)&&!o(l)}e.$hi=n;function d(l){return(typeof l=="string"?(0,F.$nc)(l):(0,L.$tg)(l))===e.$ai}e.$ii=d}),define(Se[267],De([1,0,52,4,3,23,2,207,133,31,5,15,44,28,264,8,32,13,17]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var s;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(s||(e.ProfileResourceType=s={}));function r(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&R.URI.isUri(a.location)&&R.URI.isUri(a.globalStorageHome)&&R.URI.isUri(a.settingsResource)&&R.URI.isUri(a.keybindingsResource)&&R.URI.isUri(a.tasksResource)&&R.URI.isUri(a.snippetsHome)&&R.URI.isUri(a.extensionsResource))}e.$Jk=r,e.$Kk=(0,A.$Ph)("IUserDataProfilesService");function o(l,a){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:R.URI.revive(l.location).with({scheme:a}),globalStorageHome:R.URI.revive(l.globalStorageHome).with({scheme:a}),settingsResource:R.URI.revive(l.settingsResource).with({scheme:a}),keybindingsResource:R.URI.revive(l.keybindingsResource).with({scheme:a}),tasksResource:R.URI.revive(l.tasksResource).with({scheme:a}),snippetsHome:R.URI.revive(l.snippetsHome).with({scheme:a}),extensionsResource:R.URI.revive(l.extensionsResource).with({scheme:a}),cacheHome:R.URI.revive(l.cacheHome).with({scheme:a}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}e.$Lk=o;function t(l,a,h,S,k,$){return{id:l,name:a,location:h,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:$&&k?.useDefaultFlags?.globalState?$.globalStorageHome:(0,L.$vg)(h,"globalStorage"),settingsResource:$&&k?.useDefaultFlags?.settings?$.settingsResource:(0,L.$vg)(h,"settings.json"),keybindingsResource:$&&k?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,L.$vg)(h,"keybindings.json"),tasksResource:$&&k?.useDefaultFlags?.tasks?$.tasksResource:(0,L.$vg)(h,"tasks.json"),snippetsHome:$&&k?.useDefaultFlags?.snippets?$.snippetsHome:(0,L.$vg)(h,"snippets"),extensionsResource:$&&k?.useDefaultFlags?.extensions?$.extensionsResource:(0,L.$vg)(h,"extensions.json"),cacheHome:(0,L.$vg)(S,l),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Mk=t;let n=class extends f.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,h,S,k){super(),this.t=a,this.u=h,this.w=S,this.y=k,this.f=!0,this.h=this.B(new F.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),h=[a];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,i.$yf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}h.push(t((0,L.$sg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},a))}}catch($){this.y.error($)}const S=new y.$zc,k=new Map;if(h.length)try{const $=this.Q();if($.workspaces)for(const[b,v]of Object.entries($.workspaces)){const C=R.URI.parse(b),N=h.find(T=>T.id===v);N&&S.set(C,N)}if($.emptyWindows)for(const[b,v]of Object.entries($.emptyWindows)){const C=h.find(N=>N.id===v);C&&k.set(b,C)}}catch($){this.y.error($)}this.z={profiles:h,workspaces:S,emptyWindows:k}}return this.z}D(){const a=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const h="Temp",S=new RegExp(`${(0,c.$Fe)(h)}\\s(\\d+)`);let k=0;for(const b of this.profiles){const v=S.exec(b.name),C=v?parseInt(v[1]):0;k=C>k?C:k}const $=`${h} ${k+1}`;return this.createProfile((0,I.$Di)((0,u.$eg)()).toString(16),$,{transient:!0},a)}async createNamedProfile(a,h,S){return this.createProfile((0,I.$Di)((0,u.$eg)()).toString(16),a,h,S)}async createProfile(a,h,S,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(a,h,S);return k&&await this.setProfileForWorkspace(k,$),$}async F(a,h,S){if(!(0,i.$yf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(h);return k||(k=(async()=>{try{const $=this.profiles.find(C=>C.name===h||C.id===a);if($)return $;const b=t(a,h,(0,L.$vg)(this.profilesHome,a),this.g,S,this.defaultProfile);await this.u.createFolder(b.location);const v=[];return this.j.fire({profile:b,join(C){v.push(C)}}),await w.Promises.settled(v),this.I([b],[],[]),b}finally{this.r.delete(h)}})(),this.r.set(h,k)),k}async updateProfile(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(k=>k.id===a.id);if(!S)throw new Error(`Profile '${a.name}' does not exist`);return S=t(S.id,h.name??S.name,S.location,this.g,{shortName:h.shortName??S.shortName,icon:h.icon===null?void 0:h.icon??S.icon,transient:h.transient??S.isTransient,useDefaultFlags:h.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(k=>k.id===a.id);if(!h)throw new Error(`Profile '${a.name}' does not exist`);const S=[];this.m.fire({profile:h,join(k){S.push(k)}});try{await Promise.allSettled(S)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(k){(0,m.$pk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(k=>k.id===h.id);if(!S)throw new Error(`Profile '${h.name}' does not exist`);this.L(a,S)}unsetWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(h=>h.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(a.map(h=>this.removeProfile(h)))}getProfileForWorkspace(a){const h=this.G(a);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(a){return(0,g.$Zh)(a)?a.uri:(0,g.$5h)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location)))}I(a,h,S){const k=[...this.profiles,...a],$=[];this.s.profiles=[];for(let b of k)b.isDefault||h.some(v=>b.id===v.id)||(b=S.find(v=>b.id===v.id)??b,b.isTransient?this.s.profiles.push(b):$.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P($),this.z=void 0,this.J(a,h,S)}J(a,h,S){this.h.fire({added:a,removed:h,updated:S,all:this.profiles})}L(a,h,S){S=h?.isTransient?!0:S,S||this.L(a,void 0,!0);const k=this.G(a),$=S?this.s:this.C;R.URI.isUri(k)?($.workspaces.delete(k),h&&$.workspaces.set(k,h)):($.emptyWindows.delete(k),h&&$.emptyWindows.set(k,h)),S||this.M()}M(){const a={};for(const[S,k]of this.C.workspaces.entries())a[S.toString()]=k.id;const h={};for(const[S,k]of this.C.emptyWindows.entries())h[S.toString()]=k.id;this.R({workspaces:a,emptyWindows:h}),this.z=void 0}N(a){const h={},S=this.D();if(a.workspaces)for(const[$,b]of Object.entries(a.workspaces)){const v=R.URI.parse(b);h[$]=this.w.extUri.isEqual(v,S.location)?S.id:this.w.extUri.basename(v)}const k={};if(a.emptyWindows)for(const[$,b]of Object.entries(a.emptyWindows)){const v=R.URI.parse(b);k[$]=this.w.extUri.isEqual(v,S.location)?S.id:this.w.extUri.basename(v)}return{workspaces:h,emptyWindows:k}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Nk=n,e.$Nk=n=He([Be(0,E.$Wh),Be(1,m.$$j),Be(2,D.$Ik),Be(3,P.$0i)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Ok=d}),define(Se[268],De([1,0,8,4,3,56,17,187,5,267]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9o=e.$8o=e.$7o=void 0,e.$7o="__$__isNewStorageMarker",e.$8o="__$__targetStorageMarker",e.$9o=(0,E.$Ph)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var g;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function y(i){const s=i.get(e.$8o);if(s)try{return JSON.parse(s)}catch{}return Object.create(null)}e.$0o=y;class D extends f.$Rc{static{this.a=60*1e3}constructor(s={flushInterval:D.a}){super(),this.m=s,this.b=this.B(new F.$Qd),this.c=this.B(new F.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new I.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(s,r,o){return F.Event.filter(this.b.event,t=>t.scope===s&&(r===void 0||t.key===r),o)}n(){this.j.value=(0,I.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(s,r){const{key:o,external:t}=r;if(o===e.$8o){switch(s){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:s})}else this.b.fire({scope:s,key:o,target:this.J(s)[o],external:t})}w(s){this.f.fire({reason:s})}get(s,r,o){return this.P(r)?.get(s,o)}getBoolean(s,r,o){return this.P(r)?.getBoolean(s,o)}getNumber(s,r,o){return this.P(r)?.getNumber(s,o)}getObject(s,r,o){return this.P(r)?.getObject(s,o)}storeAll(s,r){this.y(()=>{for(const o of s)this.store(o.key,o.value,o.scope,o.target,r)})}store(s,r,o,t,n=!1){if((0,R.$Hf)(r)){this.remove(s,o,n);return}this.y(()=>{this.z(s,o,t),this.P(o)?.set(s,r,n)})}remove(s,r,o=!1){this.y(()=>{this.z(s,r,void 0),this.P(r)?.delete(s,o)})}y(s){this.b.pause(),this.c.pause();try{s()}finally{this.b.resume(),this.c.resume()}}keys(s,r){const o=[],t=this.J(s);for(const n of Object.keys(t))t[n]===r&&o.push(n);return o}z(s,r,o,t=!1){const n=this.J(r);typeof o=="number"?n[s]!==o&&(n[s]=o,this.P(r)?.set(e.$8o,JSON.stringify(n),t)):typeof n[s]=="number"&&(delete n[s],this.P(r)?.set(e.$8o,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(s){switch(s){case-1:return this.I;case 0:return this.G;default:return this.D}}L(s){const r=this.P(s);return r?y(r):Object.create(null)}isNew(s){return this.getBoolean(e.$7o,s)===!0}async flush(s=A.NONE){this.f.fire({reason:s});const r=this.P(-1),o=this.P(0),t=this.P(1);switch(s){case A.NONE:await I.Promises.settled([r?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await I.Promises.settled([r?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const s=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return c(s,r,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(s){return await this.flush(),this.P(s)?.optimize()}async switch(s,r){return this.w(A.NONE),(0,m.$Jk)(s)?this.R(s,r):this.S(s,r)}M(s,r){return!(s.id===r.id||w(r)&&w(s))}N(s,r,o){this.y(()=>{const t=new Set;for(const[n,d]of s)t.add(n),r.get(n)!==d&&this.u(o,{key:n,external:!0});for(const[n]of r.items)t.has(n)||this.u(o,{key:n,external:!0})})}}e.$$o=D;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$_o=w;class u extends D{constructor(){super(),this.U=this.B(new p.$5o(new p.$6o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$5o(new p.$6o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$5o(new p.$6o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(s=>this.u(1,s))),this.B(this.W.onDidChangeStorage(s=>this.u(0,s))),this.B(this.U.onDidChangeStorage(s=>this.u(-1,s)))}P(s){switch(s){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(s){switch(s){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(s){return!1}}e.$ap=u;async function c(i,s,r,o,t,n){const d=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,a=new Map;i.forEach((C,N)=>{l.set(N,C),a.set(N,d(C))});const h=new Map,S=new Map;s.forEach((C,N)=>{h.set(N,C),S.set(N,d(C))});const k=new Map,$=new Map;r.forEach((C,N)=>{k.set(N,C),$.set(N,d(C))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const b=[];if(l.forEach((C,N)=>{b.push({key:N,value:C})}),console.table(b),console.groupEnd(),console.log(a),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((N,T)=>{C.push({key:T,value:N})}),console.table(C),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const v=[];k.forEach((C,N)=>{v.push({key:N,value:C})}),console.table(v),console.groupEnd(),console.log($)}e.$bp=c}),define(Se[109],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class I{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const L=this.c++;return this.b.set(L,f),this.e(),L}get(f,L){return this.b.has(f)?this.b.get(f)[L]:void 0}delete(f){this.b.delete(f),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Hcc=I}),define(Se[57],De([1,0,18,23,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;class L{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$kg(p=>{const E=this.b.get(p.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(p,E){E===null?this.b.delete(p.scheme):this.b.set(p.scheme,E)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Jcc=L,e.$Kcc=(0,f.$Ph)("IExtHostFileSystemInfo")}),define(Se[27],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=void 0,e.$KM=(0,I.$Ph)("IExtHostInitDataService")}),define(Se[269],De([1,0,214,15,249,27]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;let R=class extends f.$RN{constructor(E,m,A){const P=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",g=A.remote.isRemote?(0,I.localize)(0,null):E?(0,I.localize)(1,null):(0,I.localize)(2,null);super(m.createLogger(P,{name:g}))}};e.$Sec=R,e.$Sec=R=He([Be(1,F.$$i),Be(2,L.$KM)],R)}),define(Se[270],De([1,0,8]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0;class F{constructor(R,p,E){this.h=new Map,this.a=R,this.b=p,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new I.$6g(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of m.values())A.complete()}catch(A){for(const P of m.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let E=this.f[R];return typeof E>"u"&&(E=p),E}update(R,p){this.f[R]=p;const E=this.h.get(R);if(E!==void 0)return E.p;const m=new I.$ch;return this.h.set(R,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.$adc=F;class f extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$bdc=f}),define(Se[271],De([1,0,4,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class f{constructor(R){this.c=R,this.a=new I.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,E,m){const P=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(p.value,E,m);this.b.fire(P)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$zec=f}),define(Se[20],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0,e.$uM=(0,I.$Ph)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$vM=F}),define(Se[272],De([1,0,25,4]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class f{#e;constructor(R,p){this.b=new F.$Nd,this.onDidChange=this.b.event,this.a=I.$6l.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$mdc=f}),define(Se[67],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,I.$Ph)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Vcc=F}),define(Se[273],De([1,0,22]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=e.$Rcb=void 0;class F{constructor(){this.buffers=[]}add(E){let m=this.buffers.indexOf(E);return m<0&&(m=this.buffers.length,this.buffers.push(E)),m}}function f(p,E){if(E.serializeBuffersForPostMessage){const m=new F,P=JSON.stringify(p,(y,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(D)};if(ArrayBuffer.isView(D)){const w=L(D);if(w)return{$$vscode_array_buffer_reference$$:!0,index:m.add(D.buffer),view:{type:w,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),g=m.buffers.map(y=>{const D=new Uint8Array(y);return I.$be.wrap(D)});return{message:P,buffers:g}}else return{message:JSON.stringify(p),buffers:[]}}e.$Rcb=f;function L(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,E){const m=E.map(g=>{const y=new ArrayBuffer(g.byteLength);return new Uint8Array(y).set(g.buffer),y}),A=E.length?(g,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const D=y,{index:w}=D,u=m[w];if(D.view)switch(D.view.type){case 1:return new Int8Array(u,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return y}:void 0;return{message:JSON.parse(p,A),arrayBuffers:m}}e.$Scb=R}),define(Se[274],De([1,0,275,386,387,62,2,15,388]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;const m=!1;function A(s,r,o,t,n,d){const l=d.environment.useHostProxy,a=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:$=>s.resolveProxy($),lookupProxyAuthorization:u.bind(void 0,t,n,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>g(r),getSystemCertificatesV2:()=>y(r),log:($,b,...v)=>{switch($){case E.LogLevel.Trace:t.trace(b,...v);break;case E.LogLevel.Debug:t.debug(b,...v);break;case E.LogLevel.Info:t.info(b,...v);break;case E.LogLevel.Warning:t.warn(b,...v);break;case E.LogLevel.Error:t.error(b,...v);break;case E.LogLevel.Critical:t.error(b,...v);break;case E.LogLevel.Off:break;default:C($,b,v);break}function C(N,T,...M){t.error("Unknown log level",N),t.error(T,...M)}},getLogLevel:()=>{const $=t.getLevel();switch($){case p.LogLevel.Trace:return E.LogLevel.Trace;case p.LogLevel.Debug:return E.LogLevel.Debug;case p.LogLevel.Info:return E.LogLevel.Info;case p.LogLevel.Warning:return E.LogLevel.Warning;case p.LogLevel.Error:return E.LogLevel.Error;case p.LogLevel.Off:return E.LogLevel.Off;default:return b($)}function b(v){return t.error("Unknown log level",v),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,addCertificates:[],env:process.env},S=(0,E.createProxyResolver)(h),k=P(h,S);return w(o,k)}e.$ofc=A;function P(s,r){return{http:Object.assign(I,(0,E.createHttpPatch)(s,I,r)),https:Object.assign(F,(0,E.createHttpPatch)(s,F,r)),net:Object.assign(L,(0,E.createNetPatch)(s,L)),tls:Object.assign(f,(0,E.createTlsPatch)(s,f))}}function g(s){const r=s.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",m)&&!!r.get("systemCertificates")}function y(s){const r=s.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",m)&&!!r.get("systemCertificates")}const D=new Map;function w(s,r){return s.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(l,a,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const S=o.findSubstr(R.URI.file(a.filename));let k=D.get(S);if(k||D.set(S,k={}),!k[l]){const $=r[l];k[l]={...$}}return k[l]}})}async function u(s,r,o,t,n,d,l,a){const h=t[d];l&&(t[d]=l),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const S=l||h,k=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(i(r,k,n),k.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const $=await new Promise((T,M)=>{$e(["kerberos"],T,M)}),b=new URL(d),v=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${v}`),"Negotiate "+await(await $.initializeClient(v)).step("")}catch($){s.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let c=!1;function i(s,r,o){c||!r.length||(c=!0,s.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(Se[276],De([1,0,130]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;function F(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function f(L){return new I.$Lm(F(L))}e.$Dr=f}),define(Se[141],De([1,0,224,17,2,3,5,43,31,18,41,179,38]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lE=e.$kE=e.$jE=e.EditorsOrder=e.$iE=e.CloseDirection=e.$hE=e.$gE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.EditorInputCapabilities=e.$0D=e.SaveReason=e.Verbosity=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=void 0,e.$XD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$YD={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$ZD="workbench.editor.sidebysideEditor",e.$1D="workbench.editors.textDiffEditor",e.$2D="workbench.editors.binaryResourceDiffEditor";var y;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var D;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function w(ae){const ye=ae;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$3D=w;function u(ae,ye,H){for(const z of H.visibleEditorPanes)if(z.group.id===ye&&ae.matches(z.input))return z.getViewState()}e.$4D=u;function c(ae){if(h(ae))return!1;const ye=ae;return f.URI.isUri(ye?.resource)}e.$5D=c;function i(ae){if(h(ae))return!1;const ye=ae;return ye?.original!==void 0&&ye.modified!==void 0}e.$6D=i;function s(ae){if(h(ae)||i(ae))return!1;const ye=ae;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$7D=s;function r(ae){if(h(ae))return!1;const ye=ae;return ye?ye.resource===void 0||ye.resource.scheme===m.Schemas.untitled||ye.forceUntitled===!0:!1}e.$8D=r;function o(ae){if(h(ae))return!1;const ye=ae;return f.URI.isUri(ye?.base?.resource)&&f.URI.isUri(ye?.input1?.resource)&&f.URI.isUri(ye?.input2?.resource)&&f.URI.isUri(ye?.result?.resource)}e.$9D=o;var t;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class d{constructor(){this.a=new Map}registerSource(ye,H){let z=this.a.get(ye);return z||(z={source:ye,label:H},this.a.set(ye,z)),z.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$0D=new d;var l;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad",ae[ae.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class a extends L.$Rc{}e.$$D=a;function h(ae){return ae instanceof a}e.$_D=h;function S(ae){const ye=ae;return f.URI.isUri(ye?.preferredResource)}function k(ae){const ye=ae;return h(ye?.primary)&&h(ye?.secondary)}e.$aE=k;function $(ae){const ye=ae;return h(ye?.modified)&&h(ye?.original)}e.$bE=$;function b(ae,ye,H,z,X){return ie(z,[(0,P.$zi)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const re={...H,limits:{size:Number.MAX_VALUE}};ae.openEditor(ye,re)}}),(0,P.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>X.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:g.default.Warning})}e.$cE=b;function v(ae){return h(ae?.editor)}e.$dE=v;function C(ae){const ye=ae;return v(ae)&&ye?.group!==void 0}e.$eE=C;function N(ae){const ye=ae;return typeof ye?.groupId=="number"&&h(ye.editor)}e.$fE=N;var T;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var M;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LABEL=2]="GROUP_LABEL",ae[ae.GROUP_LOCKED=3]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=4]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=5]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=6]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=8]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=10]="EDITOR_PIN",ae[ae.EDITOR_STICKY=11]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=12]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var U;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class j{getOriginalUri(ye,H){if(!ye)return;if(o(ye))return e.$hE.getOriginalUri(ye.result,H);if(H?.supportSideBySide){const{primary:X,secondary:re}=this.a(ye);if(X&&re){if(H?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getOriginalUri(X,{filterByScheme:H.filterByScheme})??this.getOriginalUri(re,{filterByScheme:H.filterByScheme});ye=H.supportSideBySide===U.PRIMARY?X:re}}if(i(ye)||s(ye)||o(ye))return;const z=S(ye)?ye.preferredResource:ye.resource;return!z||!H||!H.filterByScheme?z:this.b(z,H.filterByScheme)}a(ye){return k(ye)||s(ye)?{primary:ye.primary,secondary:ye.secondary}:$(ye)||i(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,H){if(!ye)return;if(o(ye))return e.$hE.getCanonicalUri(ye.result,H);if(H?.supportSideBySide){const{primary:X,secondary:re}=this.a(ye);if(X&&re){if(H?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getCanonicalUri(X,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:H.filterByScheme});ye=H.supportSideBySide===U.PRIMARY?X:re}}if(i(ye)||s(ye)||o(ye))return;const z=ye.resource;return!z||!H||!H.filterByScheme?z:this.b(z,H.filterByScheme)}b(ye,H){if(Array.isArray(H)){if(H.some(z=>ye.scheme===z))return ye}else if(H===ye.scheme)return ye}}var O;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function V(ae,ye,H,z){if(!ae.isSticky(ye))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return H===O.MOUSE||H===O.KEYBOARD;case"mouse":return H===O.MOUSE;case"keyboard":return H===O.KEYBOARD}return!1}e.$gE=V,e.$hE=new j;var q;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class de{constructor(){this.c=new Map,this.d=new Map}start(ye){const H=this.a=ye.get(R.$Oh);for(const[z,X]of this.c)this.e(z,X,H);this.c.clear()}e(ye,H,z){const X=z.createInstance(H);this.d.set(ye,X)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,F.$Jf)(this.b)}registerEditorSerializer(ye,H){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,H,this.a):this.c.set(ye,H),(0,L.$Pc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}p.$jn.add(e.$XD.EditorFactory,new de);async function x(ae,ye,H){return!ae||!ae.length?[]:await Promise.all(ae.map(async z=>{const X=f.URI.revive(z.fileUri);if(!X){H.info("Cannot resolve the path because it is not valid.",z);return}if(!await ye.canHandleResource(X)){H.info("Cannot resolve the path because it cannot be handled",z);return}let Z=z.exists,ee=z.type;if(typeof Z!="boolean"||typeof ee!="number")try{ee=(await ye.stat(X)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Z=!0}catch(we){H.error(we),Z=!1}if(!Z&&z.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",z);return}if(ee===E.FileType.Directory){H.info("Cannot resolve the path because it is a directory",z);return}const _={...z.options,pinned:!0};return Z?{resource:X,options:_}:{resource:X,options:_,forceUntitled:!0}}))}e.$iE=x;var Q;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function G(ae){const ye=ae;if(!ye)return!1;const H=ye;if(H.modified)return G(H.modified);const z=ye;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$jE=G;function ce(ae){return(0,A.$Bi)(ae)}e.$kE=ce;function ie(ae,ye,H){const z=(0,A.$Ci)(ae,ye);return z.forceMessage=H?.forceMessage,z.forceSeverity=H?.forceSeverity,z.allowDialog=H?.allowDialog,z}e.$lE=ie}),define(Se[277],De([1,0,4,225,5,3,28,43,19,24,79,263]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wE=e.$vE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$uE=e.$tE=e.ViewContentGroups=e.$sE=e.$rE=e.ViewContainerLocation=e.Extensions=e.$qE=e.$pE=e.$oE=void 0,e.$oE="views",e.$pE=(0,F.localize)(0,null),e.$qE=(0,P.$9v)("default-view-icon",A.$Uj.window,(0,F.localize)(1,null));var g;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(g||(e.Extensions=g={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$rE=[0,1,2];function D(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$sE=D;class w extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new I.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(d,l,a){const h=this.get(d.id);if(h)return h;const S=d;return S.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$wc)(this.g,l,[]).push(S),a?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:l}),S}deregisterViewContainer(d){for(const l of this.g.keys()){const a=this.g.get(l),h=a?.indexOf(d);if(h!==-1){a?.splice(h,1),a.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(a=>a?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}p.$jn.add(g.ViewContainersRegistry,new w);var u;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(u||(e.ViewContentGroups=u={}));function c(n,d){const l=n.group??u.More,a=d.group??u.More;return l!==a?l.localeCompare(a):(n.order??5)-(d.order??5)}class i extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:a})=>this.r(l,a)),this.c.fire(d)}deregisterViews(d,l){const a=this.s(d,l);a.length&&this.f.fire({views:a,viewContainer:l})}moveViews(d,l){for(const a of this.m.keys())if(a!==l){const h=this.s(d,a);h.length&&(this.r(h,l),this.g.fire({views:h,from:a,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const a=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(a)return a}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,L.$Pc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const a=new Map;for(const[h,S]of l)this.n.add(d,S),a.set(h,(0,L.$Pc)(()=>{this.n.delete(d,S),this.h.fire(d)}));return this.h.fire(d),a}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,a=>l.push(a)),l.sort(c)}r(d,l){let a=this.m.get(l);a||(a=[],this.m.set(l,a),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,F.localize)(2,null,h.id));a.push(h)}}s(d,l){const a=this.m.get(l);if(!a)return[];const h=[],S=[];for(const k of a)d.includes(k)?h.push(k):S.push(k);return h.length&&(S.length?this.m.set(l,S):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}p.$jn.add(g.ViewsRegistry,new i),e.$tE=(0,f.$Ph)("viewsService"),e.$uE=(0,f.$Ph)("viewDescriptorService");var s;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(s||(e.ViewVisibilityState=s={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class o{constructor(d,l){this.c=!1,this.d=!1,(0,m.$0m)(this,d),this.d=!!l,this.resolve=async a=>{if(l&&!this.c){const h=await l(a);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$vE=o;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$wE=t}),define(Se[278],De([1,0,2,29,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XE=e.$WE=void 0;function L(m){return!!m&&typeof m=="object"&&"uri"in m&&m.uri instanceof I.URI&&"version"in m&&typeof m.version=="number"&&"ranges"in m&&Array.isArray(m.ranges)&&m.ranges.every(F.$ws.isIRange)}e.$WE=L;function R(m){return!!m&&typeof m=="object"&&"documents"in m&&Array.isArray(m.documents)&&m.documents.every(L)}e.$XE=R;var p;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var E;(function(m){m[m.Action=1]="Action",m[m.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$YE=(0,f.$Ph)("IChatService")}),define(Se[142],De([1,0,4,8,226]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new I.$Nd,this.n=new I.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(p){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=p}onEvent(p){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=p}onRequest(p){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.s("response",p)}sendRequest(p,E,m,A){const P={command:p};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.s("request",P),typeof A=="number"){const g=setTimeout(()=>{clearTimeout(g);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const D={type:"response",seq:0,request_seq:P.seq,success:!1,command:p,message:(0,f.localize)(0,null,A,p)};y(D)}},A)}return m&&this.f.set(P.seq,m),P.seq}acceptMessage(p){this.j?this.j(p):(this.k.push(p),this.k.length===1&&this.q())}o(p,E){return p.type!=="event"||E.type!=="event"}async q(){let p;for(;this.k.length;){if((!p||this.o(this.k[0],p))&&await(0,F.$Ug)(0),p=this.k.shift(),!p)return;switch(p.type){case"event":this.i?.(p);break;case"request":this.g?.(p);break;case"response":{const E=p,m=this.f.get(E.request_seq);m&&(this.f.delete(E.request_seq),m(E));break}}}}s(p,E){E.type=p,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((E,m)=>p.set(m,E)),await(0,F.$Ug)(500),p.forEach((E,m)=>{E({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ldb=L}),define(Se[279],De([1,0,227,42,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$_G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$$G=e.MemoryRangeType=e.$0G=e.State=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=void 0,e.$7F="workbench.view.debug",e.$8F="workbench.debug.variablesView",e.$9F="workbench.debug.watchExpressionsView",e.$0F="workbench.debug.callStackView",e.$$F="workbench.debug.loadedScriptsView",e.$_F="workbench.debug.breakPointsView",e.$aG="workbench.debug.disassemblyView",e.$bG="workbench.panel.repl",e.$cG="workbench.panel.repl.view",e.$dG=new F.$7i("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.$eG=new F.$7i("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.$fG=new F.$7i("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.$gG="debugUx",e.$hG=new F.$7i(e.$gG,"default",{type:"string",description:I.localize(3,null)}),e.$iG=new F.$7i("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.$jG=new F.$7i("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.$kG=new F.$7i("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.$lG=new F.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.$mG=new F.$7i("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.$nG=new F.$7i("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.$oG=new F.$7i("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.$pG=new F.$7i("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.$qG=new F.$7i("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.$rG=new F.$7i("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.$sG=new F.$7i("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.$tG=new F.$7i("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.$uG=new F.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.$vG=new F.$7i("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.$wG=new F.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.$xG=new F.$7i("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.$yG=new F.$7i("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.$zG=new F.$7i("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.$AG=new F.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.$BG=new F.$7i("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.$CG=new F.$7i("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.$DG=new F.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.$EG=new F.$7i("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(26,null)}),e.$FG=new F.$7i("stepBackSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.$GG=new F.$7i("restartFrameSupported",!1,{type:"boolean",description:I.localize(28,null)}),e.$HG=new F.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(29,null)}),e.$IG=new F.$7i("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.$JG=new F.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(31,null)}),e.$KG=new F.$7i("breakpointsExist",!1,{type:"boolean",description:I.localize(32,null)}),e.$LG=new F.$7i("debuggersAvailable",!1,{type:"boolean",description:I.localize(33,null)}),e.$MG=new F.$7i("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(34,null)}),e.$NG=new F.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(35,null)}),e.$OG=new F.$7i("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.$PG=new F.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.$QG=new F.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.$RG=new F.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.$SG=new F.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.$TG=new F.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.$UG=new F.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(42,null)}),e.$VG=new F.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(43,null)}),e.$WG=new F.$7i("variableIsReadonly",!1,{type:"boolean",description:I.localize(44,null)}),e.$XG=new F.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(45,null)}),e.$YG=new F.$7i("multiSessionRepl",!1,{type:"boolean",description:I.localize(46,null)}),e.$ZG=new F.$7i("multiSessionDebug",!1,{type:"boolean",description:I.localize(47,null)}),e.$1G=new F.$7i("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(48,null)}),e.$2G=new F.$7i("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(49,null)}),e.$3G=new F.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(50,null)}),e.$4G=new F.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(51,null)});const L=g=>I.localize(52,null,g);e.$5G=L,e.$6G="editor.contrib.debug",e.$7G="editor.contrib.breakpoint",e.$8G="debug",e.$9G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(53,null)};var R;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(R||(e.State=R={}));function p(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$0G=p;var E;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$$G="vscode-debug-memory";var m;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var A;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$_G=(0,f.$Ph)("debugService");var P;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(Se[280],De([1,0,13,2,16,24,18,29,21,19]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=void 0;const A=/{([^}]+)}/g;function P(k,$,b){return k.replace(A,function(v,C){return $&&C.length>0&&C[0]!=="_"?v:b&&b.hasOwnProperty(C)?b[C]:v})}e.$vF=P;function g(k){const $={};for(const b of Object.keys(k))b.startsWith("!")||($[b]=k[b]);return $}e.$wF=g;function y(k){return k.configuration.request==="attach"&&!D(k)&&(!k.parentSession||y(k.parentSession))}e.$xF=y;function D(k){let $=k.configuration.type;if($)return $==="vslsShare"&&($=k.configuration.adapterProxy.configuration.type),(0,I.$2e)($,"extensionhost")||(0,I.$2e)($,"pwa-extensionhost")?k:k.parentSession?D(k.parentSession):void 0}e.$yF=D;function w(k){return k.type&&(k.label||k.program||k.runtime)}e.$zF=w;function u(k,$,b){let v,C=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=N.exec(k);){const M=T.index+1,U=M+T[0].length;if(M<=$&&U>=b){v=T[0],C=M;break}}if(v){const M=/\w+/g;let U=null;for(;(U=M.exec(v))&&!(U.index+1+C+U[0].length>=b););U&&(v=v.substring(0,M.lastIndex))}return v?{start:C,end:C+v.length-1}:{start:0,end:0}}e.$AF=u;async function c(k,$,b,v){if(k.evaluatableExpressionProvider.has($)){const C=k.evaluatableExpressionProvider.ordered($),N=(0,m.$Gb)(await Promise.all(C.map(async T=>{try{return await T.provideEvaluatableExpression($,b,v??E.CancellationToken.None)}catch{return}})));if(N.length>0){let T=N[0].expression;const M=N[0].range;return T||(T=$.getLineContent(b.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:T}}}else{const C=$.getLineContent(b.lineNumber),{start:N,end:T}=u(C,b.column,b.column),M=C.substring(N-1,T);return{matchingExpression:M,range:new p.$ws(b.lineNumber,N,b.lineNumber,N+M.length)}}return null}e.$BF=c;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(k){return!!(k&&k.match(i))}e.$CF=s;function r(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(s(k.path))return F.URI.parse(k.path);if((0,f.$hc)(k.path))return F.URI.file(k.path)}return k.path}function o(k){if(typeof k.path=="object"){const $=F.URI.revive(k.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return k.path}function t(k,$){const b=$?r:o,v=(0,L.$7m)(k);return d(v,(C,N)=>{C&&N&&(N.path=b(N))}),v}e.$DF=t;function n(k,$){const b=$?r:o,v=(0,L.$7m)(k);return d(v,(C,N)=>{!C&&N&&(N.path=b(N))}),v}e.$EF=n;function d(k,$){switch(k.type){case"event":{const b=k;switch(b.event){case"output":$(!1,b.body.source);break;case"loadedSource":$(!1,b.body.source);break;case"breakpoint":$(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=k;switch(b.command){case"setBreakpoints":$(!0,b.arguments.source);break;case"breakpointLocations":$(!0,b.arguments.source);break;case"source":$(!0,b.arguments.source);break;case"gotoTargets":$(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(v=>$(!1,v));break;default:break}break}case"response":{const b=k;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(v=>$(!1,v.source));break;case"loadedSources":b.body.sources.forEach(v=>$(!1,v));break;case"scopes":b.body.scopes.forEach(v=>$(!1,v.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"setBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"disassemble":b.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function l(k){return k.filter($=>!$.presentation?.hidden).sort(($,b)=>$.presentation?b.presentation?$.presentation.group?b.presentation.group?$.presentation.group!==b.presentation.group?$.presentation.group.localeCompare(b.presentation.group):a($.presentation.order,b.presentation.order):-1:b.presentation.group?1:a($.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$FF=l;function a(k,$){return typeof k!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:k-$}async function h(k,$){const b=k.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(b!=="none"&&(await $.saveAll(),b==="allEditorsInActiveGroup")){const v=$.activeEditorPane;v&&v.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:v.input,groupId:v.group.id})}await k.reloadConfiguration()}e.$GF=h;const S=(k,$)=>!k||!$?k===$:k.name===$.name&&k.path===$.path&&k.sourceReference===$.sourceReference;e.$HF=S}),define(Se[281],De([1,0,49,62,24,16,12,13,30,228,142]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=e.$1ec=e.$Zec=e.$Yec=void 0;class P extends A.$ldb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(c,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,c.on("data",s=>this.w(s))}sendMessage(c){if(this.p){const i=JSON.stringify(c);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}w(c){for(this.r=Buffer.concat([this.r,c]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(s){this.m.fire(new Error((s.message||s)+`
`+i))}continue}}else{const i=this.r.indexOf(P.a);if(i!==-1){const r=this.r.toString("utf8",0,i).split(P.b);for(const o of r){const t=o.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+P.a.length);continue}}break}}}e.$Yec=P;class g extends P{startSession(){return new Promise((c,i)=>{let s=!1;this.x=this.y(()=>{this.v(this.x,this.x),c(),s=!0}),this.x.on("close",()=>{s?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{s?this.m.fire(r):i(r)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Zec=g;class y extends g{constructor(c){super(),this.z=c}y(c){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$1ec=y;class D extends g{constructor(c){super(),this.z=c}y(c){return F.createConnection(this.z.path,c)}}e.$2ec=D;class w extends P{constructor(c,i){super(),this.y=c,this.z=i}async startSession(){const c=this.y.command,i=this.y.args,s=this.y.options||{};try{if(c)if(L.$hc(c)){if(!await E.Promises.exists(c))throw new Error(m.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(m.localize(1,null,this.z));let r=process.env;if(s.env&&Object.keys(s.env).length>0&&(r=f.$0m(f.$7m(process.env),s.env)),c==="node")if(Array.isArray(i)&&i.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(t.cwd=s.cwd);const n=I.fork(i[0],i.slice(1),t);if(!n.pid)throw new Error(m.localize(2,null,i[0]));this.x=n}else throw new Error(m.localize(3,null));else{const o={env:r};s.cwd&&(o.cwd=s.cwd),this.x=I.spawn(c,i,o)}this.x.on("error",o=>{this.m.fire(o)}),this.x.on("exit",(o,t)=>{this.n.fire(o)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.m.fire(o)}),this.x.stdin.on("error",o=>{this.m.fire(o)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(r){this.m.fire(r)}}async stopSession(){return this.x?(await this.u(),R.$j?new Promise((c,i)=>{const s=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,o,t){if(r)return i(r)});s.on("exit",c),s.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,i){if(!c)return;const s=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?s.runtime=L.$ic(i,c.runtime):s.runtime=c.runtime),c.runtimeArgs&&(s.runtimeArgs=c.runtimeArgs),c.program&&(L.$hc(c.program)?s.program=c.program:s.program=L.$ic(i,c.program)),c.args&&(s.args=c.args);const r=c;return r.win&&(s.win=w.A(r.win,i)),r.winx86&&(s.winx86=w.A(r.winx86,i)),r.windows&&(s.windows=w.A(r.windows,i)),r.osx&&(s.osx=w.A(r.osx,i)),r.linux&&(s.linux=w.A(r.linux,i)),s}static platformAdapterExecutable(c,i){let s=Object.create(null);i=i.toLowerCase();for(const l of c)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(h=>typeof h.type=="string"&&p.$2e(h.type,i)).forEach(h=>{const S=w.A(h,l.extensionLocation.fsPath);s=f.$0m(s,S,l.isBuiltin)})}let r;R.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=s.winx86||s.win||s.windows:R.$j?r=s.win||s.windows:R.$k?r=s.osx:R.$l&&(r=s.linux),r=r||s;const o=r.program||s.program,t=r.args||s.args,n=r.runtime||s.runtime,d=r.runtimeArgs||s.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$3ec=w}),define(Se[282],De([1,0,49,33,12]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=void 0;function L(m,A){return new Promise((P,g)=>{let y="";const D=I.spawn(m,A);D.pid&&D.stdout.on("data",w=>{y+=w.toString()}),D.on("error",w=>{g(w)}),D.on("close",w=>{P(y)})})}async function R(m){if(m)if(f.$j){const A=await new Promise((P,g)=>{$e(["@vscode/windows-process-tree"],P,g)});return new Promise(P=>{A.getProcessTree(m,g=>{P(!!g&&g.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(m)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$4ec=R;var p;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(p||(p={}));function E(m,A,P,g,y){m=m.trim().toLowerCase();let D;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?D=1:m.indexOf("cmd.exe")>=0?D=0:m.indexOf("bash")>=0?D=2:f.$j?D=0:D=2;let w,u=" ";switch(D){case 1:if(w=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),g){const c=(0,F.$3f)(g);c&&(u+=`${c}:; `),u+=`cd ${w(g)}; `}if(y)for(const c in y){const i=y[c];i===null?u+=`Remove-Item env:${c}; `:u+=`\${env:${c}}='${i}'; `}if(A.length>0){const c=A.shift(),i=P?c:w(c);u+=i[0]==="'"?`& ${i} `:`${i} `;for(const s of A)u+=s==="<"||s===">"||P?s:w(s),u+=" "}break;case 0:if(w=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>c.includes(i))||c.length===0?`"${c}"`:c),g){const c=(0,F.$3f)(g);c&&(u+=`${c}: && `),u+=`cd ${w(g)} && `}if(y){u+='cmd /C "';for(const c in y){let i=y[c];i===null?u+=`set "${c}=" && `:(i=i.replace(/[&^|<>]/g,s=>`^${s}`),u+=`set "${c}=${i}" && `)}}for(const c of A)u+=c==="<"||c===">"||P?c:w(c),u+=" ";y&&(u+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const c=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(g&&(u+=`cd ${w(g)} ; `),y){u+="/usr/bin/env";for(const i in y){const s=y[i];s===null?u+=` -u ${c(i)}`:u+=` ${c(`${i}=${s}`)}`}u+=" "}for(const i of A)u+=i==="<"||i===">"||P?i:w(i),u+=" ";break}}return u}e.$5ec=E}),define(Se[110],De([1,0,22,37,51,99,18,16,12,42]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",L.$Sr.latex,L.$Sr.markdown,"image/png","image/jpeg",L.$Sr.text],e.$oI=[L.$Sr.latex,L.$Sr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Sr.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var P;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var g;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var D;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var w;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var u;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var c;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${V.join("")}]+`),de=7;function x(ye,H){const z=H.toString(de),re=`${z.length<V.length?V[z.length-1]:"z"}${z}s${(0,I.$ve)(I.$be.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:O.scheme,fragment:re})}O.generate=x;function Q(ye){if(ye.scheme!==O.scheme)return;const H=ye.fragment.indexOf("s");if(H<0)return;const z=parseInt(ye.fragment.substring(0,H).replace(q,""),de),X=(0,I.$ue)(ye.fragment.substring(H+1)).toString();if(!isNaN(z))return{handle:z,notebook:ye.with({scheme:X,fragment:null})}}O.parse=Q;function G(ye,H){return ye.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${ye.scheme!==R.Schemas.file?ye.scheme:""}`})}O.generateCellOutputUri=G;function ce(ye){if(ye.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!H)return;const z=H[1]&&H[1]!==""?H[1]:void 0,X=H[2];return{outputId:z,notebook:ye.with({scheme:X||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=ce;function ie(ye,H,z){return O.generate(ye,H).with({scheme:z})}O.generateCellPropertyUri=ie;function ae(ye,H){if(ye.scheme===H)return O.parse(ye.with({scheme:O.scheme}))}O.parseCellPropertyUri=ae})(s||(e.CellUri=s={}));const r=O=>E.$j?O.replace(/\//g,"\\"):O;class o{constructor(V=[],q=e.$nI){this.e=q,this.d=[...new Set(V)].map(de=>({pattern:de,matches:F.$wj(r(de))}))}sort(V){const q=new Map(f.Iterable.map(V,x=>[x,r(x)]));let de=[];for(const{matches:x}of this.d)for(const[Q,G]of q)if(x(G)){de.push(Q),q.delete(Q);break}return q.size&&(de=de.concat([...q.keys()].sort((x,Q)=>this.e.indexOf(x)-this.e.indexOf(Q)))),de}prioritize(V,q){const de=this.f(V);if(de===-1){this.d.unshift({pattern:V,matches:F.$wj(r(V))});return}const x=new Set(q.map(G=>this.f(G,de)));x.delete(-1);const Q=Array.from(x).sort();this.d.splice(de+1,0,...Q.map(G=>this.d[G]));for(let G=Q.length-1;G>=0;G--)this.d.splice(Q[G],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,q=this.d.length){const de=r(V);for(let x=0;x<q;x++)if(this.d[x].matches(de))return x;return-1}}e.$rI=o;function t(O,V,q,de=(x,Q)=>x===Q){const x=[];function Q(ie,ae,ye){if(ae===0&&ye.length===0)return;const H=x[x.length-1];H&&H.start+H.deleteCount===ie?(H.deleteCount+=ae,H.toInsert.push(...ye)):x.push({start:ie,deleteCount:ae,toInsert:ye})}let G=0,ce=0;for(;;){if(G===O.length){Q(G,0,V.slice(ce));break}if(ce===V.length){Q(G,O.length-G,[]);break}const ie=O[G],ae=V[ce];if(de(ie,ae)){G+=1,ce+=1;continue}q(ae)?(Q(G,1,[]),G+=1):(Q(G,0,[ae]),ce+=1)}return x}e.$sI=t,e.$tI=new m.$7i("notebookEditorCursorAtBoundary","none"),e.$uI=new m.$7i("notebookEditorCursorAtLineBoundary","none");var n;(function(O){O.default="default",O.option="option"})(n||(e.NotebookEditorPriority=n={}));function d(O){const V=O;return!!((typeof V.include=="string"||F.$xj(V.include))&&(typeof V.exclude=="string"||F.$xj(V.exclude)))}e.$vI=d;function l(O,V,q){if(Array.isArray(O.viewType)&&O.viewType.indexOf(V)>=0||O.viewType===V)return!0;if(O.filenamePattern){const de=d(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,x=d(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(F.$vj(de,(0,p.$mc)(q.fsPath).toLowerCase()))return!(x&&F.$vj(x,(0,p.$mc)(q.fsPath).toLowerCase()))}return!1}e.$wI=l,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var a;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class h{static{this.d="notebook/"}static create(V){return`${h.d}${V}`}static parse(V){if(V.startsWith(h.d))return V.substring(h.d.length)}}e.$yI=h;function S(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$zI=S;const k=new TextDecoder;function $(O){const V=[];let q=!1;for(const G of O)(V.length===0||q)&&(V.push(G),q=!0);let de=C(V);const x=I.$be.concat(V.map(G=>I.$be.wrap(G))),Q=j(x);return de=de||Q.byteLength!==x.byteLength,{data:Q,didCompression:de}}e.$AI=$,e.$BI=`${String.fromCharCode(27)}[A`;const b=e.$BI.split("").map(O=>O.charCodeAt(0)),v=10;function C(O){let V=!1;return O.forEach((q,de)=>{if(de===0||q.length<e.$BI.length)return;const x=O[de-1],Q=q.subarray(0,e.$BI.length);if(Q[0]===b[0]&&Q[1]===b[1]&&Q[2]===b[2]){const G=x.lastIndexOf(v);if(G===-1)return;V=!0,O[de-1]=x.subarray(0,G),O[de]=q.subarray(e.$BI.length)}}),V}function N(O){let V=O;do O=V,V=O.replace(/[^\n]\x08/gm,"");while(V.length<O.length);return O}function T(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const V=O.match(/^(.*)\r+/m)[1];let q=O.match(/\r+(.*)$/m)[1];q=q+V.slice(q.length,V.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return O}const M="\b".charCodeAt(0),U="\r".charCodeAt(0);function j(O){return!O.buffer.includes(M)&&!O.buffer.includes(U)?O:I.$be.fromString(T(N(k.decode(O.buffer))))}}),define(Se[7],De([1,0,19,9,81,28,99,13,17,2,32,25,31,65,110]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D){"use strict";var w,u,c,i,s,r,o,t,n,d,l,a,h,S,k,$,b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$jM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.TestRunProfileKind=e.TestResultState=e.$3L=e.$2L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$1L=e.$ZL=e.$YL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$XL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.ColorThemeKind=e.$RL=e.$QL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$PL=e.DebugConsoleMode=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$JL=e.$IL=e.FileChangeType=e.$HL=e.$GL=e.$FL=e.$EL=e.InlineCompletionTriggerKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.ConfigurationTarget=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hL=e.ViewBadge=e.ProgressLocation=e.$gL=e.$fL=e.TaskScope=e.ShellQuoting=e.$eL=e.$dL=e.$cL=e.TaskPanelKind=e.TaskRevealKind=e.$bL=e.TerminalLocation=e.$aL=e.$_K=e.$$K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0K=e.$9K=e.$8K=e.$7K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$6K=e.StatusBarAlignment=e.ViewColumn=e.$5K=e.$4K=e.$3K=e.$2K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1K=e.$ZK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.LanguageStatusSeverity=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.CodeActionTriggerKind=e.$NK=e.$MK=e.SymbolTag=e.SymbolKind=e.$LK=e.DocumentHighlightKind=e.$KK=e.$JK=e.$IK=e.$HK=e.DiagnosticSeverity=e.DiagnosticTag=e.$GK=e.$FK=e.FileEditType=e.$EK=e.$DK=e.$CK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(K){return Object.assign(K,{apply:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const Le=ve.length===1?[]:ve[1];return Reflect.construct(K,Le,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const[Le,...Qe]=ve;return Reflect.construct(K,Qe,Le.constructor)}}})}var N;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var T;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let M=w=class{static from(...W){let ve=W;return new w(function(){if(ve){for(const Le of ve)Le&&typeof Le.dispose=="function"&&Le.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$vK=M,e.$vK=M=w=He([C],M);let U=u=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isBefore(ve)&&(ve=Qe)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isAfter(ve)&&(ve=Qe)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof u)return!0;const{line:ve,character:Le}=W;return typeof ve=="number"&&typeof Le=="number"}static of(W){if(W instanceof u)return W;if(this.isPosition(W))return new u(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,F.$6)("line must be non-negative");if(ve<0)throw(0,F.$6)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,F.$6)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ve===0?this:new u(this.line+Le,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,F.$6)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Le===this.line&&ve===this.character?this:new u(Le,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$wK=U,e.$wK=U=u=He([C],U);let j=c=class{static isRange(W){return W instanceof c?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof c)return W;if(this.isRange(W))return new c(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Le,Qe){let et,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Qe=="number"?(et=new U(W,ve),ot=new U(Le,Qe)):U.isPosition(W)&&U.isPosition(ve)&&(et=U.of(W),ot=U.of(ve)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this.c=et,this.e=ot):(this.c=ot,this.e=et)}contains(W){return c.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=U.Max(W.start,this.c),Le=U.Min(W.end,this.e);if(!ve.isAfter(Le))return new c(ve,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=U.Min(W.start,this.c),Le=U.Max(W.end,this.end);return new c(ve,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,F.$6)();let Le;return W?U.isPosition(W)?Le=W:(Le=W.start||this.start,ve=W.end||this.end):Le=this.start,Le.isEqual(this.c)&&ve.isEqual(this.end)?this:new c(Le,ve)}toJSON(){return[this.start,this.end]}};e.$xK=j,e.$xK=j=c=He([C],j);let O=i=class extends j{static isSelection(W){return W instanceof i?!0:W?j.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Le,Qe){let et,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Qe=="number"?(et=new U(W,ve),ot=new U(Le,Qe)):U.isPosition(W)&&U.isPosition(ve)&&(et=U.of(W),ot=U.of(ve)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this.f=et,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$yK=O,e.$yK=O=i=He([C],O);const V=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,F.$6)("connectionToken")};class q{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Le){if(typeof W!="string"||W.length===0)throw(0,F.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,F.$6)("port");typeof Le<"u"&&V(Le),this.host=W,this.port=Math.round(ve),this.connectionToken=Le}}e.$zK=q;class de{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&V(ve)}}e.$AK=de;class x extends Error{static NotAvailable(W,ve){return new x(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new x(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=y.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=ve,this._detail=Le,Object.setPrototypeOf(this,x.prototype)}}e.$BK=x;var Q;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var G;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let ce=s=class{static isTextEdit(W){return W instanceof s?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new s(W,ve)}static insert(W,ve){return s.replace(new j(W,W),ve)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const ve=new s(new j(new U(0,0),new U(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,F.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$6)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$CK=ce,e.$CK=ce=s=He([C],ce);let ie=r=class{static isNotebookCellEdit(W){return W instanceof r?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new r(W,ve)}static insertCells(W,ve){return new r(new xt(W,W),ve)}static deleteCells(W){return new r(W,[])}static updateCellMetadata(W,ve){const Le=new r(new xt(W,W),[]);return Le.newCellMetadata=ve,Le}static updateNotebookMetadata(W){const ve=new r(new xt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$DK=ie,e.$DK=ie=r=He([C],ie);class ae{static isSnippetTextEdit(W){return W instanceof ae?!0:W?j.isRange(W.range)&&z.isSnippetString(W.snippet):!1}static replace(W,ve){return new ae(W,ve)}static insert(W,ve){return ae.replace(new j(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$EK=ae;var ye;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ye||(e.FileEditType=ye={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Le,Qe){this.c.push({_type:1,from:W,to:ve,options:Le,metadata:Qe})}createFile(W,ve,Le){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Le})}deleteFile(W,ve,Le){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Le})}e(W,ve,Le){this.c.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Le,Qe){const et=ve.start,ot=ve.end;(et!==ot||Le.length>0)&&this.c.push({_type:5,uri:W,index:et,count:ot-et,cells:Le,metadata:Qe})}g(W,ve,Le,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ve,metadata:Le}})}replace(W,ve,Le,Qe){this.c.push({_type:2,uri:W,edit:new ce(ve,Le),metadata:Qe})}insert(W,ve,Le,Qe){this.replace(W,new j(ve,ve),Le,Qe)}delete(W,ve,Le){this.replace(W,ve,"",Le)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Le of ve){if(!Le)continue;let Qe,et;Array.isArray(Le)?(Qe=Le[0],et=Le[1]):Qe=Le,ie.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,et):this.f(W,Qe.range,Qe.newCells,et):ae.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:2,uri:W,edit:Qe,metadata:et})}else{for(let Le=0;Le<this.c.length;Le++){const Qe=this.c[Le];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Le]=void 0);break}}(0,I.$Hb)(this.c)}}get(W){const ve=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===W.toString()&&ve.push(Le.edit);return ve}entries(){const W=new L.$zc;for(const ve of this.c)if(ve._type===2){let Le=W.get(ve.uri);Le||(Le=[ve.uri,[]],W.set(ve.uri,Le)),Le[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$FK=H,e.$FK=H=He([C],H);let z=o=class{static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=o.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Le=new o;Le.e=this.e,W(Le),this.e=Le.e,W=Le.value}else W=o.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Le=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Le=new o;Le.e=this.e,ve(Le),this.e=Le.e,ve=Le.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$GK=z,e.$GK=z=o=He([C],z);var X;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var re;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Z=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&m.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(j.isRange(ve))this.range=j.of(ve);else if(U.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$HK=Z,e.$HK=Z=t=He([C],Z);let ee=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&m.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$IK=ee,e.$IK=ee=He([C],ee);let _=class{constructor(W,ve,Le=re.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Le}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,I.$tb)(W.tags,ve.tags)&&(0,I.$tb)(W.relatedInformation,ve.relatedInformation,ee.isEqual)}};e.$JK=_,e.$JK=_=He([C],_);let we=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$KK=we,e.$KK=we=He([C],we);var ue;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ue||(e.DocumentHighlightKind=ue={}));let ge=class{constructor(W,ve=ue.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:ue[this.kind]}}};e.$LK=ge,e.$LK=ge=He([C],ge);var te;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var fe;(function(K){K[K.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Le,Qe,et){this.name=W,this.kind=ve,this.containerName=et,typeof Le=="string"&&(this.containerName=Le),Qe instanceof Z?this.location=Qe:Le instanceof j&&(this.location=new Z(Qe,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$MK=be,e.$MK=be=n=He([C],be);let Pe=d=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(d.validate)}constructor(W,ve,Le,Qe,et){this.name=W,this.detail=ve,this.kind=Le,this.range=Qe,this.selectionRange=et,this.children=[],d.validate(this)}};e.$NK=Pe,e.$NK=Pe=d=He([C],Pe);var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let J=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$OK=J,e.$OK=J=He([C],J);let se=class{static{l=this}static{this.c="."}constructor(W){this.value=W}append(W){return new l(this.value?this.value+l.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+l.c)}};e.$PK=se,e.$PK=se=l=He([C],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QK=oe,e.$QK=oe=He([C],oe);class Y{constructor(W,ve,Le,Qe,et,ot){this.kind=W,this.name=ve,this.detail=Le,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$RK=Y;class me{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$SK=me;class Ee{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$TK=Ee;var je;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$UK=We,e.$UK=We=He([C],We);let _e=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new f.$3j(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$VK=_e,e.$VK=_e=a=He([C],_e);let Xe=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$WK=Xe,e.$WK=Xe=He([C],Xe);let it=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$XK=it,e.$XK=it=He([C],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YK=tt,e.$YK=tt=He([C],tt);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let qe=class{constructor(W){this.value=W}};e.$ZK=qe,e.$ZK=qe=He([C],qe);let Re=class{constructor(W,ve,Le){this.position=W,this.label=ve,this.kind=Le}};e.$1K=Re,e.$1K=Re=He([C],Re);var Ze;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze||(e.CompletionTriggerKind=Ze={}));var he;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var le;(function(K){K[K.Deprecated=1]="Deprecated"})(le||(e.CompletionItemTag=le={}));let Ie=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2K=Ie,e.$2K=Ie=He([C],Ie);let Ke=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$3K=Ke,e.$3K=Ke=He([C],Ke);let ze=class{constructor(W,ve,Le){this.insertText=W,this.range=ve,this.command=Le}};e.$4K=ze,e.$4K=ze=He([C],ze);let Ye=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$5K=Ye,e.$5K=Ye=He([C],Ye);var nt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function bt(K,W){return`${P.$6l.toKey(K)}.${W}`}e.$6K=bt;var Et;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Kt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var wt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var jt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(K){function W(ve){switch(ve){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=W}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Gt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(K){function W(ve){switch(ve){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=W}(Gt||(e.SyntaxTokenType=Gt={}));let zt=class{constructor(W,ve){if(ve&&!m.URI.isUri(ve))throw(0,F.$6)("target");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.target=ve}};e.$7K=zt,e.$7K=zt=He([C],zt);let Dt=class{constructor(W,ve,Le,Qe){this.red=W,this.green=ve,this.blue=Le,this.alpha=Qe}};e.$8K=Dt,e.$8K=Dt=He([C],Dt);let Ft=class{constructor(W,ve){if(ve&&!(ve instanceof Dt))throw(0,F.$6)("color");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.color=ve}};e.$9K=Ft,e.$9K=Ft=He([C],Ft);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$6)("label");this.label=W}};e.$0K=Bt,e.$0K=Bt=He([C],Bt);var Jt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class Ot{constructor(W,ve,Le){if(this.startIndex=W,this.length=ve,this.tooltip=Le,typeof W!="number"||W<0)throw(0,F.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,F.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,F.$6)("tooltip")}}e.$$K=Ot;class ut{constructor(W){this.uri=W}}e.$_K=ut;class ft{constructor(W){this.terminalCommand=W}}e.$aL=ft;var At;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Vt{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$6)("options")}}e.$bL=Vt;var Lt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Lt||(e.TaskRevealKind=Lt={}));var at;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,F.$6)("name");this.c=W}get id(){return this.c}};e.$cL=vt,e.$cL=vt=h=He([C],vt);function Tt(K){let W="";for(let ve=0;ve<K.length;ve++)W+=K[ve].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,ve,Le){if(typeof W!="string")throw(0,F.$6)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Le):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Tt(W)}};e.$dL=Pt,e.$dL=Pt=He([C],Pt);let Ge=class{constructor(W,ve,Le){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,F.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W,this.f=ve,this.g=Le}else{if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Tt(W)}};e.$eL=Ge,e.$eL=Ge=He([C],Ge);var Qt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Me;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Te{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$eg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$fL=Te;let Ce=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Le,Qe,et,ot){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Le,this.execution=Qe,ht=et,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Le,this.t=this.source=Qe,this.execution=et,ht=ot):(this.target=ve,this.m=this.name=Le,this.t=this.source=Qe,this.execution=et,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof Te?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,A.$eg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ve=this.k.type;(S.g===ve||S.e===ve||S.f===ve||S.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$gL=Ce,e.$gL=Ce=S=He([C],Ce);var ne;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(ne||(e.ProgressLocation=ne={}));var Fe;(function(K){function W(ve){const Le=ve;return(0,E.$Cf)(Le.value)?Le.tooltip&&!(0,E.$yf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=W})(Fe||(e.ViewBadge=Fe={}));let Ve=k=class{static isTreeItem(W,ve){const Le=W;if(Le.checkboxState!==void 0){const Qe=(0,E.$Cf)(Le.checkboxState)?Le.checkboxState:(0,E.$Af)(Le.checkboxState)&&(0,E.$Cf)(Le.checkboxState.state)?Le.checkboxState.state:void 0,et=!(0,E.$Cf)(Le.checkboxState)&&(0,E.$Af)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Je.Checked&&Qe!==Je.Unchecked||et!==void 0&&!(0,E.$yf)(et))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof k)return!0;if(Le.label!==void 0&&!(0,E.$yf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,E.$yf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,E.$yf)(Le.iconPath)&&!m.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,E.$yf)(Le.iconPath.id))){const Qe=Le.iconPath;if(!Qe||!(0,E.$yf)(Qe.light)&&!m.URI.isUri(Qe.light)&&!(0,E.$yf)(Qe.dark)&&!m.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,E.$yf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!m.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,E.$yf)(Le.tooltip)&&!(Le.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<xe.None&&Le.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,E.$yf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,ve=xe.None){this.collapsibleState=ve,m.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$hL=Ve,e.$hL=Ve=k=He([C],Ve);var xe;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Je;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Je||(e.TreeItemCheckboxState=Je={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$iL=rt,e.$iL=rt=He([C],rt);class kt extends rt{}e.$jL=kt;class St extends kt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$kL=St;class mt{constructor(W,ve,Le,Qe){this.name=W,this.uri=ve,this._itemId=Le,this.c=Qe}data(){return this.c()}}e.$lL=mt;let dt=class{#e=new Map;constructor(W){for(const[ve,Le]of W??[]){const Qe=this.#e.get(this.#t(ve));Qe?Qe.push(Le):this.#e.set(this.#t(ve),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Le,Qe]of this.#e)for(const et of Qe)W.call(ve,et,Le,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Le of ve)yield[W,Le]}#t(W){return W.toLowerCase()}};e.$mL=dt,e.$mL=dt=He([C],dt);let gt=class{constructor(W){this.insertText=W}};e.$nL=gt,e.$nL=gt=He([C],gt);let ui=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$oL=ui,e.$oL=ui=He([C],ui);let Ct=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$pL=Ct,e.$pL=Ct=He([C],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$qL=Di,e.$qL=Di=He([C],Di);var li;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=m.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!m.URI.isUri(W)&&!m.URI.isUri(W.uri)))throw(0,F.$6)("base");if(typeof ve!="string")throw(0,F.$6)("pattern");typeof W=="string"?this.baseUri=m.URI.file(W):m.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$rL=$i,e.$rL=$i=He([C],$i);const It=new WeakMap;function gn(K,W){It.set(K,W)}e.$sL=gn;let ri=class{constructor(W,ve,Le,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Le=="string"&&(this.hitCondition=Le),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,A.$eg)()),this.c}};e.$tL=ri,e.$tL=ri=He([C],ri);let yt=class extends ri{constructor(W,ve,Le,Qe,et){if(super(ve,Le,Qe,et),W===null)throw(0,F.$6)("location");this.location=W}};e.$uL=yt,e.$uL=yt=He([C],yt);let bi=class extends ri{constructor(W,ve,Le,Qe,et){super(ve,Le,Qe,et),this.functionName=W}};e.$vL=bi,e.$vL=bi=He([C],bi);let pi=class extends ri{constructor(W,ve,Le,Qe,et,ot,ht){if(super(Qe,et,ot,ht),!ve)throw(0,F.$6)("dataId");this.label=W,this.dataId=ve,this.canPersist=Le}};e.$wL=pi,e.$wL=pi=He([C],pi);let si=class{constructor(W,ve,Le){this.command=W,this.args=ve||[],this.options=Le}};e.$xL=si,e.$xL=si=He([C],si);let Ci=class{constructor(W,ve){this.port=W,this.host=ve}};e.$yL=Ci,e.$yL=Ci=He([C],Ci);let Ii=class{constructor(W){this.path=W}};e.$zL=Ii,e.$zL=Ii=He([C],Ii);let Rt=class{constructor(W){this.implementation=W}};e.$AL=Rt,e.$AL=Rt=He([C],Rt);let wi=class{constructor(W,ve,Le){this.session=W,this.threadId=ve,this.frameId=Le}};e.$BL=wi,e.$BL=wi=He([C],wi);let Pi=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$CL=Pi,e.$CL=Pi=He([C],Pi);let oi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$DL=oi,e.$DL=oi=He([C],oi);var hi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let lt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$EL=lt,e.$EL=lt=He([C],lt);let Ai=class{constructor(W,ve,Le=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Le}};e.$FL=Ai,e.$FL=Ai=He([C],Ai);let Yt=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$GL=Yt,e.$GL=Yt=He([C],Yt);let ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$HL=ii,e.$HL=ii=He([C],ii);var Li;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Ri=$=class extends Error{static FileExists(W){return new $(W,g.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,g.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,g.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,g.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,g.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,g.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,ve=g.FileSystemProviderErrorCode.Unknown,Le){super(m.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,g.$nk)(this,ve),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$IL=Ri,e.$IL=Ri=$=He([C],Ri);let Mi=class{constructor(W,ve,Le){this.start=W,this.end=ve,this.kind=Le}};e.$JL=Mi,e.$JL=Mi=He([C],Mi);var Xi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Zi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Ti;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$KL=mn;function Ni(K){return typeof K>"u"||(0,E.$zf)(K)}class di{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Le=W.tokenTypes.length;ve<Le;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Le=W.tokenModifiers.length;ve<Le;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Le,Qe,et){if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.n(W,ve,Le,Qe,et);if(j.isRange(W)&&typeof ve=="string"&&Ni(Le))return this.m(W,ve,Le);throw(0,F.$6)()}m(W,ve,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,et=W.start.character,ot=W.end.character-W.start.character,ht=this.j.get(ve);let Ut=0;if(Le)for(const Zt of Le){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);Ut|=1<<ei>>>0}this.n(Qe,et,ot,ht,Ut)}n(W,ve,Le,Qe,et){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Zt,Ji+=ei):ni+=Zt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Zt=ni,ei=Ji}}let ot=W,ht=ve;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Le,this.g[this.h++]=Qe,this.g[this.h++]=et,this.c=W,this.e=ve}static o(W){const ve=[],Le=W.length/5|0;for(let ht=0;ht<Le;ht++)ve[ht]=ht;ve.sort((ht,Ut)=>{const Zt=W[5*ht],ei=W[5*Ut];if(Zt===ei){const ti=W[5*ht+1],ni=W[5*Ut+1];return ti-ni}return Zt-ei});const Qe=new Uint32Array(W.length);let et=0,ot=0;for(let ht=0;ht<Le;ht++){const Ut=5*ve[ht],Zt=W[Ut+0],ei=W[Ut+1],ti=W[Ut+2],ni=W[Ut+3],Ji=W[Ut+4],In=Zt-et,Fn=In===0?ei-ot:ei,Qi=5*ht;Qe[Qi+0]=In,Qe[Qi+1]=Fn,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,et=Zt,ot=ei}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(di.o(this.g),W)}}e.$LL=di;class Oi{constructor(W,ve){this.resultId=ve,this.data=W}}e.$ML=Oi;class $n{constructor(W,ve,Le){this.start=W,this.deleteCount=ve,this.data=Le}}e.$NL=$n;class fi{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$OL=fi;var Yi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let Ui=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$PL=Ui,e.$PL=Ui=He([C],Ui);var xi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class bn{static validate(W){if(typeof W.badge=="string"){let ve=(0,p.$_e)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,p.$_e)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Le){this.badge=W,this.tooltip=ve,this.color=Le}}e.$QL=bn;let ji=class{constructor(W){this.kind=W}};e.$RL=ji,e.$RL=ji=He([C],ji);var mi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,F.$6)("start must be positive");if(ve<0)throw(0,F.$6)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Le=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Le=W.end),ve===this.c&&Le===this.e?this:new xt(ve,Le)}}e.$SL=xt;class vi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>vi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Le,Qe,et,ot,ht){this.kind=W,this.value=ve,this.languageId=Le,this.mime=Qe,this.outputs=et??[],this.metadata=ot,this.executionSummary=ht,vi.validate(this)}}e.$TL=vi;class en{constructor(W){this.cells=W}}e.$UL=en;class Xt{static isNotebookCellOutputItem(W){return W instanceof Xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Xt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Xt(W,ve)}static#e=new TextEncoder;static text(W,ve=R.$Sr.text){const Le=Xt.#e.encode(String(W));return new Xt(Le,ve)}static json(W,ve="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Xt.text(Le,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Le=(0,R.$Wr)(ve,!0);if(!Le)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$VL=Xt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Le=new Set,Qe=new Set;for(let et=0;et<W.length;et++){const ot=W[et],ht=(0,R.$Wr)(ot.mime);if(!Le.has(ht)||(0,D.$zI)(ht)){Le.add(ht);continue}Qe.add(et),ve&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Qe.size===0?W:W.filter((et,ot)=>!Qe.has(ot))}constructor(W,ve,Le){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Le):(this.id=(0,A.$eg)(),this.metadata=ve??Le)}}e.$WL=yi;var tn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(W,ve){this.text=W,this.alignment=ve}}e.$XL=sn;var Ue;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Ue||(e.NotebookControllerAffinity=Ue={}));var _t;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(W,ve=[]){this.uri=W,this.provides=(0,I.$2b)(ve)}}e.$YL=on;class $t{constructor(W){this.label=W}}e.$ZL=$t;let zi=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$1L=zi,e.$1L=zi=He([C],zi);var an;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class ki{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$2L=ki;class pn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$3L=pn;var un;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Si=class{constructor(W=void 0,ve=void 0,Le=void 0,Qe=!1){this.include=W,this.exclude=ve,this.profile=Le,this.continuous=Qe}};e.$4L=Si,e.$4L=Si=He([C],Si);let Wi=b=class{static diff(W,ve,Le){const Qe=new b(W);return Qe.expectedOutput=ve,Qe.actualOutput=Le,Qe}constructor(W){this.message=W}};e.$5L=Wi,e.$5L=Wi=b=He([C],Wi);let qi=class{constructor(W){this.id=W}};e.$6L=qi,e.$6L=qi=He([C],qi);let ci=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$7L=ci,e.$7L=ci=He([C],ci);let Vi=v=class{static fromDetails(W,ve){const Le=new ci(0,0),Qe=new ci(0,0),et=new ci(0,0);for(const ht of ve)if("branches"in ht){Le.total+=1,Le.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Qe.total+=1,Qe.covered+=Ut.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ot=new v(W,Le,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return ot.detailedCoverage=ve,ot}constructor(W,ve,Le,Qe){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Le,this.functionCoverage=Qe}};e.$8L=Vi,e.$8L=Vi=v=He([C],Vi);let Ki=class{constructor(W,ve,Le=[]){this.executionCount=W,this.location=ve,this.branches=Le}};e.$9L=Ki,e.$9L=Ki=He([C],Ki);let Hi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$0L=Hi,e.$0L=Hi=He([C],Hi);let Gi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$$L=Gi,e.$$L=Gi=He([C],Gi);var hn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class pe{constructor(W,ve,Le,Qe,et,ot){this.kind=W,this.name=ve,this.detail=Le,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$_L=pe;class ke{constructor(W){this.uri=W}}e.$aM=ke;class Oe{constructor(W,ve){this.original=W,this.modified=ve}}e.$bM=Oe;class st{constructor(W,ve,Le,Qe){this.base=W,this.input1=ve,this.input2=Le,this.result=Qe}}e.$cM=st;class pt{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$dM=pt;class Mt{constructor(W){this.viewType=W}}e.$eM=Mt;class Pn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$fM=Pn;class An{constructor(W,ve,Le){this.original=W,this.modified=ve,this.notebookType=Le}}e.$gM=An;class Ln{constructor(){}}e.$hM=Ln;class Rn{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$iM=Rn;var wn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var vn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var yn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Mn{constructor(W,ve){this.role=W,this.content=ve}}e.$jM=Mn;var Sn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(Se[143],De([1,0,60,18,13,175,126,7,19]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0;const m=new Map;function A(D,w){w?m.set(D,w):m.delete(D)}e.$wM=A;function P(D){return m.get(D)}class g extends L.$Yu{constructor(w,u,c,i,s,r,o,t){super(u,c,i,s),this.c=w,this.m=r,this.q=o,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,E.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===F.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(u){return u?w.s(u):w.getText()},get eol(){return w.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(u){return w.t(u)},offsetAt(u){return w.u(u)},positionAt(u){return w.v(u)},validateRange(u){return w.w(u)},validatePosition(u){return w.x(u)},getWordRangeAtPosition(u,c){return w.y(u,c)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,I.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,I.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const u=this.w(w);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const c=this.g,i=u.start.line,s=u.end.line,r=[];r.push(this.f[i].substring(u.start.character));for(let o=i+1;o<s;o++)r.push(this.f[o]);return r.push(this.f[s].substring(0,u.end.character)),r.join(c)}t(w){let u;if(w instanceof p.$wK?u=w.line:typeof w=="number"&&(u=w),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new y(u,this.f[u],u===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const u=this.j.getIndexOf(w),c=this.f[u.index].length;return new p.$wK(u.index,Math.min(u.remainder,c))}w(w){if(!(w instanceof p.$xK))throw new Error("Invalid argument");const u=this.x(w.start),c=this.x(w.end);return u===w.start&&c===w.end?w:new p.$xK(u.line,u.character,c.line,c.character)}x(w){if(!(w instanceof p.$wK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:u,character:c}=w,i=!1;if(u<0)u=0,c=0,i=!0;else if(u>=this.f.length)u=this.f.length-1,c=this.f[u].length,i=!0;else{const s=this.f[u].length;c<0?(c=0,i=!0):c>s&&(c=s,i=!0)}return i?new p.$wK(u,c):w}y(w,u){const c=this.x(w);if(!u)u=P(this.m);else if((0,f.$Oe)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const i=(0,R.$$r)(c.character+1,(0,R.$9r)(u),this.f[c.line],0);if(i)return new p.$xK(c.line,i.startColumn-1,c.line,i.endColumn-1)}}e.$xM=g;class y{constructor(w,u,c){this.a=w,this.b=u,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$xK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$xK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$yM=y}),define(Se[283],De([1,0,7,20,4]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let L=class{constructor(p){this.a=new I.$RL(I.ColorThemeKind.Dark),this.b=new f.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(p){let E;switch(p){case"light":E=I.ColorThemeKind.Light;break;case"hcDark":E=I.ColorThemeKind.HighContrast;break;case"hcLight":E=I.ColorThemeKind.HighContrastLight;break;default:E=I.ColorThemeKind.Dark}this.a=new I.$RL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iec=L,e.$iec=L=He([Be(0,F.$uM)],L)}),define(Se[284],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$DI=(0,I.$Ph)("INotebookExecutionService")}),define(Se[285],De([1,0,3,29,192,98]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jOb=void 0;class R extends I.$Rc{constructor(E,m,A){super(),this._source=E,this.b=m,this.c=A,this.a=void 0}f(E){const m=E.getLineCount();return new F.$ws(1,1,m,this.g(E,m))}g(E,m){if(m<1||m>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(m)+1}get inputTextBuffer(){if(!this.b){const E=new f.$JB;E.acceptChunk(this._source);const m=E.finish(!0),{textBuffer:A,disposable:P}=m.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const m=new f.$JB;m.acceptChunk(E);const A=m.finish(!0),{textBuffer:P,disposable:g}=A.create(1);return this.B(g),P})),this.a}findInInputs(E){const A=new L.$xB(E,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(E){const A=new L.$xB(E,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const g=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(g.length!==0)return{textBuffer:P,matches:g}}).filter(P=>!!P):[]}}e.$jOb=R}),define(Se[68],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(L){L.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(R,p,E=R.parent){if(R._isRoot)return new f([p]);const m=[R.id];for(let A=E;A&&A.id!==p;A=A.parent)m.push(A.id);return m.push(p),new f(m.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new f(R.split("\0"))}static join(R,p){return new f([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:f.isChild(R,p)?2:f.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new f(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new f(this.path,R)}compare(R){if(typeof R=="string")return f.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$jJ=f}),define(Se[88],De([1,0,2,29,68]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oJ=e.$nJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lJ=e.$kJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var p;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$kJ=[2,4,8,16,32,64];const E=k=>"runId"in k;e.$lJ=E;var m;(function(k){k.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),k.deserialize=$=>({range:F.$ws.lift($.range),uri:I.URI.revive($.uri)})})(m||(e.IRichLocation=m={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var P;(function(k){k.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&m.serialize($.location)}),k.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&m.deserialize($.location)})})(P||(e.ITestErrorMessage=P={}));const g=(k,$)=>`${$?"s":"e"}${k}`;e.$mJ=g;var y;(function(k){k.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&m.serialize($.location)}),k.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&m.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var D;(function(k){k.serialize=$=>$.type===0?P.serialize($):y.serialize($),k.deserialize=$=>$.type===0?P.deserialize($):y.deserialize($)})(D||(e.ITestMessage=D={}));var w;(function(k){k.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),k.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(D.serialize)}),k.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(D.deserialize)})})(w||(e.ITestTaskState=w={}));const u="\0",c=(k,$)=>k+u+$;e.$nJ=c;const i=k=>{const $=k.indexOf(u);return{ctrlId:k.slice(0,$),tagId:k.slice($+1)}};e.$oJ=i;var s;(function(k){k.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),k.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?I.URI.revive($.uri):void 0,range:$.range?F.$ws.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(s||(e.ITestItem=s={}));var r;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var o;(function(k){k.serialize=$=>({expand:$.expand,item:s.serialize($.item)}),k.deserialize=$=>({controllerId:f.$jJ.root($.item.extId),expand:$.expand,item:s.deserialize($.item)})})(o||(e.InternalTestItem=o={}));var t;(function(k){k.serialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.uri!==void 0&&(b.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(b.range=$.item.range?.toJSON()),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}},k.deserialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.range!==void 0&&(b.range=$.item.range?F.$ws.lift($.item.range):null),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}}})(t||(e.ITestItemUpdate=t={}));const n=(k,$)=>{$.expand!==void 0&&(k.expand=$.expand),$.item!==void 0&&(k.item=k.item?Object.assign(k.item,$.item):$.item)};e.$pJ=n;var d;(function(k){k.serializeWithoutMessages=$=>({...o.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.serializeWithoutMessages)}),k.serialize=$=>({...o.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.serialize)}),k.deserialize=$=>({...o.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var l;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(l||(e.DetailType=l={}));var a;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var h;(function(k){k.deserialize=$=>$.op===0?{op:$.op,item:o.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:I.URI.revive($.uri),docv:$.docv}:$,k.serialize=$=>$.op===0?{op:$.op,item:o.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(h||(e.TestsDiffOp=h={}));class S{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply($){const b=this.o();for(const v of $)switch(v.op){case 0:this.j(o.deserialize(v.item),b);break;case 1:this.k(t.deserialize(v.item),b);break;case 3:this.l(v.itemId,b);break;case 5:this.m(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.c.set(v.tag.id,v.tag);break;case 7:this.c.delete(v.id);break}b.complete?.()}j($,b){const v=f.$jJ.parentId($.item.extId)?.toString();let C;if(!v)C=this.p($),this.f.add(C),this.d.set($.item.extId,C);else if(this.d.has(v)){const N=this.d.get(v);N.children.add($.item.extId),C=this.p($,N),this.d.set($.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return b.add?.(C),$.expand===2&&this.g++,C}k($,b){const v=this.d.get($.extId);if(v)return $.expand!==void 0&&(v.expand===2&&this.g--,$.expand===2&&this.g++),(0,e.$pJ)(v,$),b.update?.(v),v}l($,b){const v=this.d.get($);if(!v)return;const C=f.$jJ.parentId(v.item.extId)?.toString();C?this.d.get(C).children.delete(v.item.extId):this.f.delete(v);const N=[[$]];for(;N.length;)for(const T of N.pop()){const M=this.d.get(T);M&&(N.push(M.children),this.d.delete(T),b.remove?.(M,M!==v),M.expand===2&&this.g--)}}m($){}updatePendingRoots($){this.h+=$}o(){return{}}}e.$qJ=S}),define(Se[111],De([1,0,8,4,3,60,88,68]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.TestItemEventOp=void 0;var E;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const m=(i,s)=>i===s,P=Object.entries({range:(i,s)=>i===s?!0:!i||!s?!1:i.equalsRange(s),busy:m,label:m,description:m,error:m,sortText:m,tags:(i,s)=>!(i.length!==s.length||i.some(r=>!s.includes(r)))}),g=(i,s)=>{let r;for(const[o,t]of P)t(i[o],s[o])||(r?r[o]=s[o]:r={[o]:s[o]});return r};class y extends f.$Rc{get root(){return this.s.root}constructor(s){super(),this.s=s,this.f=this.B(new I.$6g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(s){this.h=s;for(const r of this.tree.values())this.I(r)}get resolveHandler(){return this.h}collectDiff(){const s=this.m;return this.m=[],s}pushDiff(s){switch(s.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===s.uri){r.docv=s.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===s.item.extId){(0,R.$pJ)(r.item,s.item);return}if(r.op===0&&r.item.item.extId===s.item.extId){(0,R.$pJ)(r.item,s.item);return}}break}}this.m.push(s),this.f.isScheduled()||this.f.schedule()}expand(s,r){const o=this.tree.get(s);if(o){if((o.expandLevels===void 0||r>o.expandLevels)&&(o.expandLevels=r),o.expand===1){const t=this.L(o);return t.isOpen()?this.J(o,r-1):t.wait().then(()=>this.J(o,r-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.J(o,r-1)):this.J(o,r-1)}}dispose(){for(const s of this.tree.values())this.s.getApiFor(s.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(s,r){switch(r.op){case 3:this.N(p.$jJ.joinToString(s.fullId,r.id));break;case 0:this.y(r.item,s);break;case 5:for(const o of r.ops)this.u(s,o);break;case 1:this.z(r.new,r.old,s.fullId.toString());break;case 2:this.I(s);break;case 4:this.pushDiff({op:1,item:{extId:s.fullId.toString(),item:r.update}});break;case 6:this.w(s.actual.uri);break;default:(0,L.$3c)(r)}}w(s){s&&this.pushDiff({op:2,uri:s,docv:this.s.getDocumentVersion(s)})}y(s,r){const o=p.$jJ.fromExtHostTestItem(s,this.root.id,r?.actual),t=this.s.getApiFor(s);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(s.id);let n=this.tree.get(o.toString());if(!n){n={fullId:o,actual:s,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},s.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(s,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(s)}}),this.H(s,n,r);return}if(n.actual===s){this.G(s,n,r);return}if(n.actual.uri?.toString()!==s.uri?.toString())return this.N(o.toString()),this.y(s,r);const d=this.s.getChildren(n.actual),l=n.actual,a=g(this.s.toITestItem(l),this.s.toITestItem(s));this.s.getApiFor(l).listener=void 0,n.actual=s,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.z(s.tags,l.tags,o.toString()),delete a.tags),this.u(n,{op:4,update:a})),this.H(s,n,r);for(const[h,S]of d)this.s.getChildren(s).get(S.id)||this.N(p.$jJ.joinToString(o,S.id));this.w(n.actual.uri)}z(s,r,o){const t=new Set(r.map(n=>n.id));for(const n of s)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:o,item:{tags:s.map(n=>(0,R.$nJ)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(s){const r=this.j.get(s.id);r?r.refCount++:(this.j.set(s.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$nJ)(this.s.controllerId,s.id)}}))}D(s){const r=this.j.get(s);r&&!--r.refCount&&(this.j.delete(s),this.pushDiff({op:7,id:(0,R.$nJ)(this.s.controllerId,s)}))}F(s,r){this.s.getApiFor(s).parent=r&&r.actual!==this.root?r.actual:void 0}G(s,r,o){this.F(s,o);const t=this.s.getApiFor(s);t.parent=o?.actual,t.listener=n=>this.u(r,n),this.I(r)}H(s,r,o){this.G(s,r,o);for(const[t,n]of this.s.getChildren(s))this.y(n,r)}I(s){let r;this.h?s.resolveBarrier?r=s.resolveBarrier.isOpen()?3:2:r=s.actual.canResolveChildren?1:0:r=0,r!==s.expand&&(s.expand=r,this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:r}}),r===1&&s.expandLevels!==void 0&&this.L(s))}J(s,r){if(r<0)return;const o=[];for(const[t,n]of this.s.getChildren(s.actual)){const d=this.expand(p.$jJ.joinToString(s.fullId,n.id),r);(0,I.$Gg)(d)&&o.push(d)}if(o.length)return Promise.all(o).then(()=>{})}L(s){if(s.resolveBarrier)return s.resolveBarrier;if(!this.h){const n=new I.$Sg;return n.open(),n}s.expand=2,this.M(s);const r=s.resolveBarrier=new I.$Sg,o=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(s.actual===this.root?void 0:s.actual)}catch(n){o(n)}return(0,I.$Gg)(t)?t.catch(o).then(()=>{r.open(),this.I(s)}):(r.open(),this.I(s)),s.resolveBarrier}M(s){this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:s.expand}})}N(s){const r=this.tree.get(s);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:s});const o=[r];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,d]of this.s.getChildren(t.actual))o.push(this.tree.get(p.$jJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const s=this.collectDiff();s.length&&this.g.fire(s)}}e.$kM=y;class D extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.$lM=D;class w extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$mM=w;class u extends Error{constructor(s,r,o){super(`TestItem with ID "${s}" is from controller "${r}" and cannot be added as a child of an item from controller "${o}".`)}}e.$nM=u;const c=(i,s,r)=>{let o=new Map;return{get size(){return o.size},forEach(t,n){for(const d of o.values())t.call(n,d,this)},[Symbol.iterator](){return o.entries()},replace(t){const n=new Map,d=new Set(o.keys()),l={op:5,ops:[]};for(const a of t){if(!(a instanceof r))throw new w(a.id);const h=s(a).controllerId;if(h!==i.controllerId)throw new u(a.id,h,i.controllerId);if(n.has(a.id))throw new D(a.id);n.set(a.id,a),d.delete(a.id),l.ops.push({op:0,item:a})}for(const a of d.keys())l.ops.push({op:3,id:a});i.listener?.(l),o=n},add(t){if(!(t instanceof r))throw new w(t.id);o.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){o.delete(t)&&i.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$oM=c}),define(Se[144],De([1,0,111]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=void 0;const F=new WeakMap,f=(R,p)=>{const E={controllerId:p};return F.set(R,E),E};e.$pM=f;const L=R=>{const p=F.get(R);if(!p)throw new I.$mM(R?.id||"<unknown>");return p};e.$qM=L}),define(Se[112],De([1,0,18,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpb=e.$upb=e.$tpb=e.$spb=e.$rpb=void 0,e.$rpb="vscode-cdn.net",e.$spb=`vscode-resource.${e.$rpb}`,e.$tpb=`'self' https://*.${e.$rpb}`;function f(p,E){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(E&&E.authority&&E.isRemote&&p.scheme===I.Schemas.file&&(p=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:E.authority,path:p.path})),F.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${L(p.authority)}.${e.$spb}`,path:p.path,fragment:p.fragment,query:p.query}))}e.$upb=f;function L(p){return p.replace(/./g,E=>{const m=E.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?E:"-"+m.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(E,m)=>String.fromCharCode(parseInt(m,16)))}e.$vpb=R}),define(Se[286],De([1,0,4,3,112]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class L{constructor(p,E,m){this.d=p,this.e=E,this.f=m,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,E,m,A,P){let g;for(const s of this.e.getVisibleTextEditors(!0))if(s.value===p){g=s;break}if(!g)throw new Error("not a visible editor");const y=this,D=this.a++,w=new I.$Nd,u=new I.$Nd,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(s){return(0,f.$upb)(s,y.f)}get cspSource(){return f.$tpb}set options(s){this.b=s,y.d.$setOptions(D,s)}get options(){return this.b}set html(s){this.a=s,y.d.$setHtml(D,s)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(s){return y.d.$postMessage(D,s)}},i=new class{constructor(){this.editor=p,this.line=E,this.height=m,this.webview=c,this.onDidDispose=u.event}dispose(){y.c.has(D)&&(y.c.delete(D),y.d.$disposeEditorInset(D),u.fire(),u.dispose(),w.dispose())}};return this.d.$createEditorInset(D,g.id,g.value.document.uri,E+1,m,A||{},P.identifier,P.extensionLocation),this.c.set(D,{editor:p,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(p){const E=this.c.get(p);E&&E.inset.dispose()}$onDidReceiveMessage(p,E){this.c.get(p)?.onDidReceiveMessage.fire(E)}}e.$Sdc=L}),define(Se[287],De([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.VariableKind=e.$gN=void 0,e.$gN=(0,I.$Ph)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(R,p){super(p),this.variable=R}}e.$hN=f}),define(Se[288],De([1,0,16,48,17,24,12,101,231,287,13]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,D,w,u){this.h=new Map,this.a=y,this.b=D,this.g=w,u&&(this.c=u.then(c=>this.i(c)))}i(y){if(R.$j){const D=Object.create(null);return Object.keys(y).forEach(w=>{D[w.toLowerCase()]=y[w]}),D}return y}resolveWithEnvironment(y,D,w){return this.l({env:this.i(y),userHome:void 0},D?D.uri:void 0,w)}async resolveAsync(y,D){const w={env:await this.c,userHome:await this.g};return this.l(w,y?y.uri:void 0,D)}async j(y,D,w,u){const c=L.$7m(D);R.$j&&c.windows?Object.keys(c.windows).forEach(s=>c[s]=c.windows[s]):R.$k&&c.osx?Object.keys(c.osx).forEach(s=>c[s]=c.osx[s]):R.$l&&c.linux&&Object.keys(c.linux).forEach(s=>c[s]=c.linux[s]),delete c.windows,delete c.osx,delete c.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,y?y.uri:void 0,c,w,u)}async resolveAnyAsync(y,D,w){return this.j(y,D,w)}async resolveAnyMap(y,D,w){const u=new Map;return{newConfig:await this.j(y,D,w,u),resolvedVariables:u}}resolveWithInteractionReplace(y,D,w,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,D,w,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,D){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,D)}async l(y,D,w,u,c){if(f.$yf(w))return this.m(y,D,w,u,c);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(y,D,i,u,c)));if(f.$Af(w)){const i=Object.create(null),s=await Promise.all(Object.keys(w).map(async r=>[await this.m(y,D,r,u,c),await this.l(y,D,w[r],u,c)]));for(const[r,o]of s)i[r]=o;return i}return w}m(y,D,w,u,c){return(0,A.$Te)(w,P.VARIABLE_REGEXP,async(i,s)=>{if(s.includes(P.VARIABLE_LHS))return i;let r=await this.o(y,i,s,D,u);return c?.set(s,r),r!==i&&f.$yf(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(y,D,r,u,c)),r})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,D,w,u,c){let i;const s=w.split(":");s.length>1&&(w=s[0],i=s[1]);const r=n=>{const d=this.a.getFilePath();if(d)return(0,p.$vv)(d);throw new m.$hN(n,(0,E.localize)(0,null,D))},o=n=>{const d=r(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,p.$vv)(l)}throw new m.$hN(n,(0,E.localize)(1,null,D,I.$mc(d)))},t=n=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new m.$hN(n,(0,E.localize)(2,null,D,i))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new m.$hN(n,(0,E.localize)(3,null,D)):new m.$hN(n,(0,E.localize)(4,null,D))};switch(w){case"env":if(i){if(y.env){const n=y.env[R.$j?i.toLowerCase():i];if(f.$yf(n))return n}return""}throw new m.$hN(m.VariableKind.Env,(0,E.localize)(5,null,D));case"config":if(i){const n=this.a.getConfigurationValue(u,i);if(f.$Hf(n))throw new m.$hN(m.VariableKind.Config,(0,E.localize)(6,null,D,i));if(f.$Af(n))throw new m.$hN(m.VariableKind.Config,(0,E.localize)(7,null,D,i));return n}throw new m.$hN(m.VariableKind.Config,(0,E.localize)(8,null,D));case"command":return this.p(m.VariableKind.Command,D,i,c,"command");case"input":return this.p(m.VariableKind.Input,D,i,c,"input");case"extensionInstallFolder":if(i){const n=await this.a.getExtension(i);if(!n)throw new m.$hN(m.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,D,i));return this.n(n.extensionLocation)}throw new m.$hN(m.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,D));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,p.$vv)(this.n(t(m.VariableKind.WorkspaceFolder)));case"cwd":return u||i?(0,p.$vv)(this.n(t(m.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$vv)(I.$mc(this.n(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new m.$hN(m.VariableKind.UserHome,(0,E.localize)(11,null,D))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new m.$hN(m.VariableKind.LineNumber,(0,E.localize)(12,null,D))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new m.$hN(m.VariableKind.SelectedText,(0,E.localize)(13,null,D))}case"file":return r(m.VariableKind.File);case"fileWorkspaceFolder":return o(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||i?I.$kc(this.n(t(m.VariableKind.RelativeFile)),r(m.VariableKind.RelativeFile)):r(m.VariableKind.RelativeFile);case"relativeFileDirname":{const n=I.$lc(r(m.VariableKind.RelativeFileDirname));if(u||i){const d=I.$kc(this.n(t(m.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return I.$lc(r(m.VariableKind.FileDirname));case"fileExtname":return I.$nc(r(m.VariableKind.FileExtname));case"fileBasename":return I.$mc(r(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=I.$mc(r(m.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-I.$nc(n).length)}case"fileDirnameBasename":return I.$mc(I.$lc(r(m.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||D}case"execInstallFolder":{const n=this.a.getAppRoot();return n||D}case"pathSeparator":return I.sep;default:try{const n=i?`${w}:${i}`:w;return this.p(m.VariableKind.Unknown,D,n,c,void 0)}catch{return D}}}}p(y,D,w,u,c){if(w&&u){const i=c===void 0?u[w]:u[c+":"+w];if(typeof i=="string")return i;throw new m.$hN(y,(0,E.localize)(14,null,D))}return D}}e.$vN=P}),define(Se[145],De([1,0,5,141]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.OpenEditorContext=e.GroupsOrder=e.$sC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rC=void 0,e.$rC=(0,I.$Ph)("editorGroupsService");var f;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var L;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EXPAND=1]="EXPAND",D[D.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var E;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function m(D){const w=D;return(0,F.$_D)(w?.editor)&&(0,F.$_D)(w?.replacement)}e.$sC=m;var A;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function g(D){const w=D;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$tC=g;function y(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$uC=y}),define(Se[289],De([1,0,5,145]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=void 0,e.$vC=(0,I.$Ph)("editorService"),e.$wC=-1,e.$xC=-2;function f(L){const R=L;return typeof L=="number"||(0,F.$tC)(R)}e.$yC=f}),define(Se[146],De([1,0,5,133]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=void 0,e.$NJ=(0,I.$Qh)(F.$Wh)}),define(Se[147],De([1,0,25,4,16,3]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=e.$34b=e.$24b=e.$14b=e.$Z4b=e.$Y4b=void 0;class R{constructor(c,i){this.versionId=c,this.removedDueToLooping=i}}e.$Y4b=R;class p{static isHostExtension(c,i,s){if(i.getExtensionDescription(c))return!1;const r=s.getExtensionDescription(c);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(c,i){this.j=c,this.c=new F.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(D),this.f=new I.$8l,this.g=[],this.h=new Map;for(const c of this.e){if(this.f.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this.f.set(c.identifier,c),this.g.push(c);const i=this.j.readActivationEvents(c);if(Array.isArray(i))for(let s of i)s==="onUri"&&(s=`onUri:${I.$6l.toKey(c.identifier)}`),this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(c)}}set(c){return this.e=c,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(c,i){this.e=w(this.e,i),this.e=this.e.concat(c);const s=p.l(this.e);return this.e=w(this.e,s.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,s)}static l(c){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,d){this.addNode(n),this.addNode(d),this.c.has(n)?this.c.get(n).push(d):this.c.set(n,[d])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,d){const l=i.getArcs(n);for(let a=0;a<l.length;a++)if(!d.has(l[a]))return!1;return!0}getNodes(){return this.e}},s=new I.$8l;for(const n of c)if(s.set(n.identifier,n),n.extensionDependencies)for(const d of n.extensionDependencies)i.addArc(I.$6l.toKey(n.identifier),I.$6l.toKey(d));const r=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>r.add(n));const o=i.getNodes().filter(n=>!r.has(n));let t;do{t=!1;for(let n=0;n<o.length;n++){const d=o[n];i.hasOnlyGoodArcs(d,r)&&(o.splice(n,1),n--,r.add(d),t=!0)}}while(t);return o.map(n=>s.get(n))}containsActivationEvent(c){return this.h.has(c)}containsExtension(c){return this.f.has(c)}getExtensionDescriptionsForActivationEvent(c){const i=this.h.get(c);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(c){const i=this.f.get(c);return i||void 0}getExtensionDescriptionByUUID(c){for(const i of this.g)if(i.uuid===c)return i}getExtensionDescriptionByIdOrUUID(c,i){return this.getExtensionDescription(c)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Z4b=p;class E{constructor(c,i){this.versionId=c,this.extensions=i}}e.$14b=E,e.$24b={readActivationEvents:u=>u.activationEvents};class m{constructor(c){this.d=new g,this.c=new p(c,[])}async acquireLock(c){const i=await this.d.acquire(c);return new A(this,i)}deltaExtensions(c,i,s){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(c){return this.c.containsActivationEvent(c)}containsExtension(c){return this.c.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this.c.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(c){return this.c.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this.c.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,i){return this.c.getExtensionDescriptionByIdOrUUID(c,i)}}e.$34b=m;class A extends L.$Rc{constructor(c,i){super(),this.f=c,this.c=!1,this.B(i)}isAcquiredFor(c){return!this.c&&this.f===c}}e.$44b=A;class P{constructor(c){this.name=c,this.promise=new Promise((i,s)=>{this.c=i})}resolve(c){this.c(c)}}class g{constructor(){this.c=[],this.d=!1}async acquire(c){const i=new P(c);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const c=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};c.resolve((0,L.$Pc)(r))}}var y;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(y||(y={}));function D(u,c){const i=u.isBuiltin?0:u.isUnderDevelopment?2:1,s=c.isBuiltin?0:c.isUnderDevelopment?2:1;if(i!==s)return i-s;const r=f.$fc.basename(u.extensionLocation.path),o=f.$fc.basename(c.extensionLocation.path);return r<o?-1:r>o?1:0}function w(u,c){const i=new I.$7l(c);return u.filter(s=>!i.has(s.identifier))}}),define(Se[290],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ExtHostConnectionType=void 0;var I;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[F.ENV_KEY]=this.pipeName}}e.$xm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[f.ENV_KEY]="1"}}e.$ym=f;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[L.ENV_KEY]="1"}}e.$zm=L;function R(A){delete A[F.ENV_KEY],delete A[f.ENV_KEY],delete A[L.ENV_KEY]}function p(A,P){R(P),A.serialize(P)}e.$Am=p;function E(A){if(A[F.ENV_KEY])return m(A,new F(A[F.ENV_KEY]));if(A[f.ENV_KEY])return m(A,new f);if(A[L.ENV_KEY])return m(A,new L);throw new Error("No connection information defined in environment!")}e.$Bm=E;function m(A,P){return R(A),P}}),define(Se[113],De([1,0,22]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var L;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(m){const A=I.$be.alloc(1);switch(m){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$bm=R;function p(m,A){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$cm=p;var E;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Se[89],De([1,0,5,4,15,27,113,66,86,24,2,3,218]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=void 0;let y=class extends P.$Rc{constructor(c,i){super(),this.s=c,this.t=i,this.a=this.B(new F.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:E.$ro,name:(0,g.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(s=>{(0,f.$_i)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,i,s){const r=this.getTelemetryDetails(),o=new D(i,s,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(c,i,s){this.f=c,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const i=Object.create(null);switch(i["common.extname"]=`${c.publisher}.${c.name}`,i["common.extversion"]=c.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$Vk)((0,E.$yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const i=this.getTelemetryDetails();this.r.forEach((s,r)=>{const o=s.filter(t=>!t.isDisposed);o.length===0?this.r.delete(r):this.r.set(r,o)}),this.r.forEach(s=>{for(const r of s)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,i){const r=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(c.value),!1;let o=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),o=!0);return o}};e.$LM=y,e.$LM=y=He([Be(0,L.$KM),Be(1,f.$$i)],y);class D{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,i,s,r,o,t,n){this.g=s,this.h=r,this.i=o,this.j=t,this.a=new F.$Nd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(c,i){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let i="properties"in c?c.properties??{}:c;return i=(0,E.$Bo)(i,[]),this.c&&(i=(0,m.$0m)(i,this.c)),this.b||(i=(0,m.$0m)(i,this.j)),"properties"in c?c.properties=i:c=i,c}k(c,i){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(c,i),this.h.trace(c,i))}logUsage(c,i){this.d.isUsageEnabled&&this.k(c,i)}logError(c,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,i);else{const s={name:c.name,message:c.message,stack:c.stack,cause:c.cause},r=(0,E.$Bo)(s,[]),o=new Error(r.message,{cause:r.cause});o.stack=r.stack,o.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const c=this,i={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$MM=D;function w(u){const c=Date.now()-new Date(u).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$NM=w,e.$OM=(0,I.$Ph)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,260,139,25,5]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new R.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,p.$Ph)("extensionService");class E{constructor(o){this.dependency=o}}e.$iF=E;var m;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,n){this.c=o,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$3E.createActivationEventsMap(this.d)}}set(o,t,n){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const d=[],l=[],a=[],h=[],S=P(this.d),k=P(t),$=(T,M)=>T.extensionLocation.toString()===M.extensionLocation.toString()||T.isBuiltin===M.isBuiltin||T.isUserBuiltin===M.isUserBuiltin||T.isUnderDevelopment===M.isUnderDevelopment;for(const T of this.d){const M=k.get(T.identifier);if(!M){d.push(T.identifier),S.delete(T.identifier);continue}if(!$(T,M)){d.push(T.identifier),S.delete(T.identifier);continue}}for(const T of t){const M=S.get(T.identifier);if(!M){l.push(T);continue}if(!$(M,T)){d.push(M.identifier),S.delete(M.identifier);continue}}const b=new R.$7l(this.e),v=new R.$7l(n);for(const T of this.e)v.has(T)||a.push(T);for(const T of n)b.has(T)||h.push(T);const C=L.$3E.createActivationEventsMap(l),N={versionId:o,toRemove:d,toAdd:l,addActivationEvents:C,myToRemove:a,myToAdd:h};return this.delta(N),N}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:d,myToAdd:l}=o,a=new R.$7l(t),h=new R.$7l(d);for(let S=0;S<this.d.length;S++)a.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)h.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of n)this.d.push(S);for(const S of l)this.e.push(S);return o}containsExtension(o){for(const t of this.e)if(R.$6l.equals(t,o))return!0;return!1}}e.$jF=A;function P(r){const o=new R.$8l;for(const t of r)o.set(t.identifier,t);return o}function g(r,o){return r.enabledApiProposals?r.enabledApiProposals.includes(o):!1}e.$kF=g;function y(r,o){if(!g(r,o))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$lF=y;class D{constructor(o,t,n,d){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=d}}e.$mF=D;class w{constructor(o,t){this.description=o,this.value=t}}e.$nF=w;var u;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function c(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,f.$Ho)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$oF=c;function i(r,o){return{identifier:new R.$6l((0,f.$Fo)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!o,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$pF=i;class s{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=s}),define(Se[291],De([1,0,9,147,25,26,15,8]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(c,i,s,r){this.startup=c,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=r}}e.$5cc=E;class m{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,i){return c===-1||i===-1?-1:i-c}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6cc=m;class A{constructor(c,i,s,r,o,t){this.activationFailed=c,this.activationFailedError=i,this.activationTimes=s,this.module=r,this.exports=o,this.subscriptions=t}}e.$7cc=A;class P extends A{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8cc=P;class g extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9cc=g;class y extends A{constructor(c){super(!0,c,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(c,i,s,r){this.g=r,this.a=c,this.b=i,this.c=s,this.d=new f.$8l,this.f=Object.create(null)}dispose(){for(const[c,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const c=[];for(const[i,s]of this.d)c.push(s.wait());await Promise.all(c)}isActivated(c){const i=this.d.get(c);return!!(i&&i.value)}getActivatedExtension(c){const i=this.d.get(c);if(!i||!i.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return i.value}async activateByEvent(c,i){if(this.f[c])return;const s=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(s.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,i){const s=this.a.getExtensionDescription(c);if(!s)throw new Error(`Extension '${c}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(c){const i=c.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const i=this.a.getExtensionDescription(c.id);if(!i){const o=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new y(o));return this.c.onExtensionActivationError(c.id,o,new L.$iF(c.id.value)),t}const s=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of r){if(this.m(o))continue;const t=this.d.get(o);if(t){s.push(t);continue}if(this.l(o)){s.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:c.reason}));continue}const n=this.a.getExtensionDescription(o);if(n){if(!n.main&&!n.browser)continue;s.push(this.j({id:n.identifier,reason:c.reason}));continue}const d=i.displayName||i.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${o}'`),a=this.k(c,i.displayName,[],new y(l));return this.c.onExtensionActivationError(i.identifier,l,new L.$iF(o)),a}return this.k(c,i.displayName,s,null)}k(c,i,s,r){const o=new w(c.id,i,c.reason,s,r,this.c,this.g);return this.d.set(c.id,o),o}l(c){return F.$Z4b.isHostExtension(c,this.a,this.b)}m(c){const i=this.b.getExtensionDescription(c);return i?!i.main&&!i.browser:!1}};e.$0cc=D,e.$0cc=D=He([Be(3,R.$0i)],D);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,i,s,r,o,t,n){this.c=c,this.d=i,this.f=s,this.g=r,this.h=o,this.j=t,this.k=n,this.a=new p.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const i=this.g[c];if(i.value&&!i.value.activationFailed){this.g.splice(c,1),c--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new y(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const i=new Error;if(c&&c.name&&(i.name=c.name),c&&c.message?i.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(i.stack=c.stack),this.h=new y(i),this.b&&I.$3(c))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};w=He([Be(6,R.$0i)],w)}),define(Se[14],De([1,0,19,22,164,75,81,28,160,54,99,24,17,2,29,84,135,144,141,110,68,88,289,7,26]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$tM=e.$sM=e.MarkdownString=e.$rM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Me){function Te(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Je}=ne,rt=new n.$wK(Fe-1,Ve-1),kt=new n.$wK(xe-1,Je-1);return new n.$yK(rt,kt)}Me.to=Te;function Ce(ne){const{anchor:Fe,active:Ve}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Ce})(l||(e.Selection=l={}));var a;(function(Me){function Te(ne){if(!ne)return;const{start:Fe,end:Ve}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Te;function Ce(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:xe,endColumn:Je}=ne;return new n.$xK(Fe-1,Ve-1,xe-1,Je-1)}Me.to=Ce})(a||(e.Range=a={}));var h;(function(Me){function Te(Ce){switch(Ce){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(h||(e.TokenType=h={}));var S;(function(Me){function Te(ne){return new n.$wK(ne.lineNumber-1,ne.column-1)}Me.to=Te;function Ce(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Ce})(S||(e.Position=S={}));var k;(function(Me){function Te(Fe,Ve,xe){return(0,I.$Gb)((0,I.$2b)(Fe).map(Je=>Ce(Je,Ve,xe)))}Me.from=Te;function Ce(Fe,Ve,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ve),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ne(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(k||(e.DocumentSelector=k={}));var $;(function(Me){function Te(ne){switch(ne){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Ce(ne){switch(ne){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})($||(e.DiagnosticTag=$={}));var b;(function(Me){function Te(ne){let Fe;return ne.code&&((0,g.$yf)(ne.code)||(0,g.$Cf)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...a.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:C.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(v.from),tags:Array.isArray(ne.tags)?(0,I.$Gb)(ne.tags.map($.from)):void 0}}Me.from=Te;function Ce(ne){const Fe=new n.$JK(a.to(ne),ne.message,C.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,g.$yf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(v.to),Fe.tags=ne.tags&&(0,I.$Gb)(ne.tags.map($.to)),Fe}Me.to=Ce})(b||(e.Diagnostic=b={}));var v;(function(Me){function Te(ne){return{...a.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Te;function Ce(ne){return new n.$IK(new n.$HK(ne.resource,a.to(ne)),ne.message)}Me.to=Ce})(v||(e.DiagnosticRelatedInformation=v={}));var C;(function(Me){function Te(ne){switch(ne){case n.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Te;function Ce(ne){switch(ne){case u.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Ce})(C||(e.DiagnosticSeverity=C={}));var N;(function(Me){function Te(ne){return typeof ne=="number"&&ne>=n.ViewColumn.One?ne-1:ne===n.ViewColumn.Beside?t.$xC:t.$wC}Me.from=Te;function Ce(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(N||(e.ViewColumn=N={}));function T(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!T(Me[0])}e.$rM=M;var U;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Ce(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let rt;if(Ce(Je)){const{language:dt,value:gt}=Je;rt={value:"```"+dt+`
`+gt+"\n```\n"}}else n.$VK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const kt=Object.create(null);rt.uris=kt;const St=dt=>{try{let gt=y.URI.parse(dt,!0);gt=gt.with({query:Fe(gt.query,kt)}),kt[dt]=gt}catch{}return""},mt=new E.marked.Renderer;return mt.link=St,mt.image=dt=>typeof dt=="string"?St(R.$0j(dt).href):"",(0,E.marked)(rt.value,{renderer:mt}),rt}Me.from=ne;function Fe(Je,rt){if(!Je)return Je;let kt;try{kt=(0,m.$lh)(Je)}catch{}if(!kt)return Je;let St=!1;return kt=(0,P.$9m)(kt,mt=>{if(y.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=mt,St=!0,dt}else return}),St?JSON.stringify(kt):Je}function Ve(Je){const rt=new n.$VK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,rt}Me.to=Ve;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(U||(e.MarkdownString=U={}));function j(Me){return M(Me)?Me.map(Te=>({range:a.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?U.fromMany(Te.hoverMessage):Te.hoverMessage?U.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:a.from(Te)}))}e.$sM=j;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$tM=O;var V;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?O(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Te})(V||(e.ThemableDecorationAttachmentRenderOptions=V={}));var q;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?V.from(Ce.before):void 0,after:Ce.after?V.from(Ce.after):void 0}}Me.from=Te})(q||(e.ThemableDecorationRenderOptions=q={}));var de;(function(Me){function Te(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(de||(e.DecorationRangeBehavior=de={}));var x;(function(Me){function Te(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?de.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?q.from(Ce.light):void 0,dark:Ce.dark?q.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?V.from(Ce.before):void 0,after:Ce.after?V.from(Ce.after):void 0}}Me.from=Te})(x||(e.DecorationRenderOptions=x={}));var Q;(function(Me){function Te(ne){return{text:ne.newText,eol:ne.newEol&&Ae.from(ne.newEol),range:a.from(ne.range)}}Me.from=Te;function Ce(ne){const Fe=new n.$CK(a.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:Ae.to(ne.eol),Fe}Me.to=Ce})(Q||(e.TextEdit=Q={}));var G;(function(Me){function Te(ne,Fe){const Ve={edits:[]};if(ne instanceof n.$FK){const xe=new p.$Ac;for(const Je of ne._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,F.$ve)(F.$be.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ve.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?Ve.edits.push({resource:Je.uri,textEdit:Q.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ve.edits.push({resource:Je.uri,textEdit:{range:a.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ve.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ve.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(bt.from)}})}return Ve}Me.from=Te;function Ce(ne){const Fe=new n.$FK,Ve=new p.$zc;for(const xe of ne.edits)if(xe.textEdit){const Je=xe,rt=y.URI.revive(Je.resource),kt=a.to(Je.textEdit.range),St=Je.textEdit.text,mt=Je.textEdit.insertAsSnippet;let dt;mt?dt=n.$EK.replace(kt,new n.$GK(St)):dt=n.$CK.replace(kt,St);const gt=Ve.get(rt);gt?gt.push(dt):Ve.set(rt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Ve)Fe.set(xe,Je);return Fe}Me.to=Ce})(G||(e.WorkspaceEdit=G={}));var ce;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Ce(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Ce;function ne(Fe){for(const Ve in Te)if(Te[Ve]===Fe)return Number(Ve);return n.SymbolKind.Property}Me.to=ne})(ce||(e.SymbolKind=ce={}));var ie;(function(Me){function Te(ne){switch(ne){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Ce(ne){switch(ne){case 1:return n.SymbolTag.Deprecated}}Me.to=Ce})(ie||(e.SymbolTag=ie={}));var ae;(function(Me){function Te(ne){return{name:ne.name,kind:ce.from(ne.kind),tags:ne.tags&&ne.tags.map(ie.from),containerName:ne.containerName,location:re.from(ne.location)}}Me.from=Te;function Ce(ne){const Fe=new n.$MK(ne.name,ce.to(ne.kind),ne.containerName,re.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(ie.to),Fe}Me.to=Ce})(ae||(e.WorkspaceSymbol=ae={}));var ye;(function(Me){function Te(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:a.from(ne.range),selectionRange:a.from(ne.selectionRange),kind:ce.from(ne.kind),tags:ne.tags?.map(ie.from)??[]};return ne.children&&(Fe.children=ne.children.map(Te)),Fe}Me.from=Te;function Ce(ne){const Fe=new n.$NK(ne.name,ne.detail,ce.to(ne.kind),a.to(ne.range),a.to(ne.selectionRange));return(0,I.$Kb)(ne.tags)&&(Fe.tags=ne.tags.map(ie.to)),ne.children&&(Fe.children=ne.children.map(Ce)),Fe}Me.to=Ce})(ye||(e.DocumentSymbol=ye={}));var H;(function(Me){function Te(ne){const Fe=new n.$RK(ce.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),a.to(ne.range),a.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Ce(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ne.name,detail:ne.detail,kind:ce.from(ne.kind),uri:ne.uri,range:a.from(ne.range),selectionRange:a.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Me.from=Ce})(H||(e.CallHierarchyItem=H={}));var z;(function(Me){function Te(Ce){return new n.$SK(H.to(Ce.from),Ce.fromRanges.map(ne=>a.to(ne)))}Me.to=Te})(z||(e.CallHierarchyIncomingCall=z={}));var X;(function(Me){function Te(Ce){return new n.$TK(H.to(Ce.to),Ce.fromRanges.map(ne=>a.to(ne)))}Me.to=Te})(X||(e.CallHierarchyOutgoingCall=X={}));var re;(function(Me){function Te(ne){return{range:ne.range&&a.from(ne.range),uri:ne.uri}}Me.from=Te;function Ce(ne){return new n.$HK(y.URI.revive(ne.uri),a.to(ne.range))}Me.to=Ce})(re||(e.location=re={}));var Z;(function(Me){function Te(ne){const Fe=ne,Ve=ne;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:a.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Ce(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:a.to(ne.range),targetSelectionRange:ne.targetSelectionRange?a.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?a.to(ne.originSelectionRange):void 0}}Me.to=Ce})(Z||(e.DefinitionLink=Z={}));var ee;(function(Me){function Te(ne){return{range:a.from(ne.range),contents:U.fromMany(ne.contents)}}Me.from=Te;function Ce(ne){return new n.$KK(ne.contents.map(U.to),a.to(ne.range))}Me.to=Ce})(ee||(e.Hover=ee={}));var _;(function(Me){function Te(ne){return{range:a.from(ne.range),expression:ne.expression}}Me.from=Te;function Ce(ne){return new n.$DL(a.to(ne.range),ne.expression)}Me.to=Ce})(_||(e.EvaluatableExpression=_={}));var we;(function(Me){function Te(ne){if(ne instanceof n.$EL)return{type:"text",range:a.from(ne.range),text:ne.text};if(ne instanceof n.$FL)return{type:"variable",range:a.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof n.$GL)return{type:"expression",range:a.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Ce(ne){switch(ne.type){case"text":return{range:a.to(ne.range),text:ne.text};case"variable":return{range:a.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:a.to(ne.range),expression:ne.expression}}}Me.to=Ce})(we||(e.InlineValue=we={}));var ue;(function(Me){function Te(ne){return{frameId:ne.frameId,stoppedLocation:a.from(ne.stoppedLocation)}}Me.from=Te;function Ce(ne){return new n.$HL(ne.frameId,a.to(ne.stoppedLocation))}Me.to=Ce})(ue||(e.InlineValueContext=ue={}));var ge;(function(Me){function Te(ne){return{range:a.from(ne.range),kind:ne.kind}}Me.from=Te;function Ce(ne){return new n.$LK(a.to(ne.range),ne.kind)}Me.to=Ce})(ge||(e.DocumentHighlight=ge={}));var te;(function(Me){function Te(Ce){switch(Ce){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(te||(e.CompletionTriggerKind=te={}));var fe;(function(Me){function Te(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Te})(fe||(e.CompletionContext=fe={}));var be;(function(Me){function Te(ne){switch(ne){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Ce(ne){switch(ne){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Ce})(be||(e.CompletionItemTag=be={}));var Pe;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Ce(Ve){return Te.get(Ve)??9}Me.from=Ce;const ne=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Fe(Ve){return ne.get(Ve)??n.CompletionItemKind.Property}Me.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Te(Ce,ne){const Fe=new n.$2K(Ce.label);return Fe.insertText=Ce.insertText,Fe.kind=Pe.to(Ce.kind),Fe.tags=Ce.tags?.map(be.to),Fe.detail=Ce.detail,Fe.documentation=R.$5j(Ce.documentation)?U.to(Ce.documentation):Ce.documentation,Fe.sortText=Ce.sortText,Fe.filterText=Ce.filterText,Fe.preselect=Ce.preselect,Fe.commitCharacters=Ce.commitCharacters,D.$ws.isIRange(Ce.range)?Fe.range=a.to(Ce.range):typeof Ce.range=="object"&&(Fe.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Fe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Fe.insertText=new n.$GK(Ce.insertText):(Fe.insertText=Ce.insertText,Fe.textEdit=Fe.range instanceof n.$xK?new n.$CK(Fe.range,Fe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>Q.to(Ve))),Fe.command=ne&&Ce.command?ne.fromInternal(Ce.command):void 0,Fe}Me.to=Te})(B||(e.CompletionItem=B={}));var J;(function(Me){function Te(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:U.fromStrict(ne.documentation)}}Me.from=Te;function Ce(ne){return{label:ne.label,documentation:R.$5j(ne.documentation)?U.to(ne.documentation):ne.documentation}}Me.to=Ce})(J||(e.ParameterInformation=J={}));var se;(function(Me){function Te(ne){return{label:ne.label,documentation:U.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.from):[],activeParameter:ne.activeParameter}}Me.from=Te;function Ce(ne){return{label:ne.label,documentation:R.$5j(ne.documentation)?U.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.to):[],activeParameter:ne.activeParameter}}Me.to=Ce})(se||(e.SignatureInformation=se={}));var oe;(function(Me){function Te(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.from):[]}}Me.from=Te;function Ce(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.to):[]}}Me.to=Ce})(oe||(e.SignatureHelp=oe={}));var Y;(function(Me){function Te(Ce,ne){const Fe=new n.$1K(S.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(me.to.bind(void 0,Ce)),ne.kind&&Ee.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(Q.to),Fe.tooltip=R.$5j(ne.tooltip)?U.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Me.to=Te})(Y||(e.InlayHint=Y={}));var me;(function(Me){function Te(Ce,ne){const Fe=new n.$ZK(ne.label);return Fe.tooltip=R.$5j(ne.tooltip)?U.to(ne.tooltip):ne.tooltip,w.Command.is(ne.command)&&(Fe.command=Ce.fromInternal(ne.command)),ne.location&&(Fe.location=re.to(ne.location)),Fe}Me.to=Te})(me||(e.InlayHintLabelPart=me={}));var Ee;(function(Me){function Te(ne){return ne}Me.from=Te;function Ce(ne){return ne}Me.to=Ce})(Ee||(e.InlayHintKind=Ee={}));var je;(function(Me){function Te(ne){return{range:a.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Te;function Ce(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new n.$7K(a.to(ne.range),Fe)}Me.to=Ce})(je||(e.DocumentLink=je={}));var We;(function(Me){function Te(ne){const Fe=new n.$0K(ne.label);return ne.textEdit&&(Fe.textEdit=Q.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ve=>Q.to(Ve))),Fe}Me.to=Te;function Ce(ne){return{label:ne.label,textEdit:ne.textEdit?Q.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>Q.from(Fe)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var _e;(function(Me){function Te(ne){return new n.$8K(ne[0],ne[1],ne[2],ne[3])}Me.to=Te;function Ce(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Ce})(_e||(e.Color=_e={}));var Xe;(function(Me){function Te(ne){return{range:a.from(ne.range)}}Me.from=Te;function Ce(ne){return new n.$QK(a.to(ne.range))}Me.to=Ce})(Xe||(e.SelectionRange=Xe={}));var it;(function(Me){function Te(Ce){switch(Ce){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Me){function Te(ne){switch(ne){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Ce(ne){switch(ne){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Ce})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ae;(function(Me){function Te(ne){if(ne===n.EndOfLine.CRLF)return 1;if(ne===n.EndOfLine.LF)return 0}Me.from=Te;function Ce(ne){if(ne===1)return n.EndOfLine.CRLF;if(ne===0)return n.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Ne;(function(Me){function Te(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ne||(e.ProgressLocation=Ne={}));var qe;(function(Me){function Te(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=Re.from(ne.kind)),Fe}Me.from=Te;function Ce(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=Re.to(ne.kind)),Fe}Me.to=Ce})(qe||(e.FoldingRange=qe={}));var Re;(function(Me){function Te(ne){if(ne)switch(ne){case n.FoldingRangeKind.Comment:return w.$lt.Comment;case n.FoldingRangeKind.Imports:return w.$lt.Imports;case n.FoldingRangeKind.Region:return w.$lt.Region}}Me.from=Te;function Ce(ne){if(ne)switch(ne.value){case w.$lt.Comment.value:return n.FoldingRangeKind.Comment;case w.$lt.Imports.value:return n.FoldingRangeKind.Imports;case w.$lt.Region.value:return n.FoldingRangeKind.Region}}Me.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var Ze;(function(Me){function Te(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$YD.id:void 0}}Me.from=Te})(Ze||(e.TextEditorOpenOptions=Ze={}));var he;(function(Me){function Te(Ve){return Ve instanceof n.$rL?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||ne(Ve)?new n.$rL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Te;function Ce(Ve){const xe=Ve;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new n.$rL(y.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Fe})(he||(e.GlobPattern=he={}));var le;(function(Me){function Te(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Te);if(typeof Ce=="string")return Ce;{const ne=Ce;return{language:ne.language,scheme:ne.scheme,pattern:he.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Te})(le||(e.LanguageSelector=le={}));var Ie;(function(Me){function Te(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof n.$xK)))}Me.is=Te;function Ce(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>a.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Te(ne){return{start:ne.start,end:ne.end}}Me.from=Te;function Ce(ne){return new n.$SL(ne.start,ne.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var ze;(function(Me){function Te(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Te;function Ce(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Ce})(ze||(e.NotebookCellExecutionSummary=ze={}));var Ye;(function(Me){function Te(Ce){if(Ce===s.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Ce===s.NotebookCellExecutionState.Pending)return;if(Ce===s.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Te})(Ye||(e.NotebookCellExecutionState=Ye={}));var nt;(function(Me){function Te(ne){switch(ne){case n.NotebookCellKind.Markup:return s.CellKind.Markup;case n.NotebookCellKind.Code:default:return s.CellKind.Code}}Me.from=Te;function Ce(ne){switch(ne){case s.CellKind.Markup:return n.NotebookCellKind.Markup;case s.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Ce})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Me){function Te(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)n.$TL.validate(Ve),Fe.cells.push(bt.from(Ve));return Fe}Me.from=Te;function Ce(ne){const Fe=new n.$UL(ne.cells.map(bt.to));return(0,g.$Lf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Me.to=Ce})(ct||(e.NotebookData=ct={}));var bt;(function(Me){function Te(ne){return{cellKind:nt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:ze.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Kt.from):[]}}Me.from=Te;function Ce(ne){return new n.$TL(nt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Kt.to):void 0,ne.metadata,ne.internalMetadata?ze.to(ne.internalMetadata):void 0)}Me.to=Ce})(bt||(e.NotebookCellData=bt={}));var Et;(function(Me){function Te(ne){return{mime:ne.mime,valueBytes:F.$be.wrap(ne.data)}}Me.from=Te;function Ce(ne){return new n.$VL(ne.valueBytes.buffer,ne.mime)}Me.to=Ce})(Et||(e.NotebookCellOutputItem=Et={}));var Kt;(function(Me){function Te(ne){return{outputId:ne.id,items:ne.items.map(Et.from),metadata:ne.metadata}}Me.from=Te;function Ce(ne){const Fe=ne.items.map(Et.to);return new n.$WL(Fe,ne.outputId,ne.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Te(Fe){return ne(Fe)?{include:he.from(Fe.include)??void 0,exclude:he.from(Fe.exclude)??void 0}:he.from(Fe)??void 0}Me.from=Te;function Ce(Fe){return ne(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Me.to=Ce;function ne(Fe){const Ve=Fe;return Ve?!(0,g.$Hf)(Ve.include)&&!(0,g.$Hf)(Ve.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var wt;(function(Me){function Te(Ce,ne,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Fe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Te})(wt||(e.NotebookStatusBarItem=wt={}));var jt;(function(Me){function Te(Ce,ne,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ne.toInternal(Ve,Fe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(jt||(e.NotebookKernelSourceAction=jt={}));var Nt;(function(Me){function Te(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Te})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Me){function Te(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Te;function Ce(ne){return new n.$YL(y.URI.revive(ne.uri),ne.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var zt;(function(Me){function Te(ne){return{message:U.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:a.from(ne.location.range),uri:ne.location.uri}}}Me.from=Te;function Ce(ne){const Fe=new n.$5L(typeof ne.message=="string"?ne.message:U.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?re.to(ne.location):void 0,Fe}Me.to=Ce})(zt||(e.TestMessage=zt={}));var Dt;(function(Me){Me.namespace=o.$nJ,Me.denamespace=o.$oJ})(Dt||(e.TestTag=Dt={}));var Ft;(function(Me){function Te(ne){const Fe=(0,c.$qM)(ne).controllerId;return{extId:r.$jJ.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>Dt.namespace(Fe,Ve.id)),range:D.$ws.lift(a.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&U.fromStrict(ne.error)||null}}Me.from=Te;function Ce(ne){return{parent:void 0,error:void 0,id:r.$jJ.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ve}=Dt.denamespace(Fe);return new n.$6L(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Ce})(Ft||(e.TestItem=Ft={})),function(Me){function Te(ne){return{id:ne.id}}Me.from=Te;function Ce(ne){return new n.$6L(ne.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Bt;(function(Me){const Te=(ne,Fe)=>{const Ve=[];for(const[Je,rt]of Fe)r.$jJ.compare(rt.item.extId,Je)===2&&(Fe.delete(Je),Ve.push(rt));const xe={...Ft.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(zt.to)})),children:Ve.map(Je=>Te(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Ce(ne){const Fe=[],Ve=new Map;for(const xe of ne.items){Ve.set(xe.item.extId,xe);const Je=r.$jJ.root(xe.item.extId);ne.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ne.completedAt,results:Fe.map(xe=>Te(xe,Ve))}}Me.to=Ce})(Bt||(e.TestResults=Bt={}));var Jt;(function(Me){function Te(Ve){return{covered:Ve.covered,total:Ve.covered}}function Ce(Ve){return"line"in Ve?S.from(Ve):a.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:Ve.executionCount,location:Ce(Ve.location)}}Me.fromDetailed=ne;function Fe(Ve){return{uri:Ve.uri,statement:Te(Ve.statementCoverage),branch:Ve.branchCoverage&&Te(Ve.branchCoverage),function:Ve.functionCoverage&&Te(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ne)}}Me.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Me){function Te(Ce){switch(Ce){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Me){function Te(ne){const Fe=new n.$_L(ce.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),a.to(ne.range),a.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Ce(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:ce.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:a.from(ne.range),selectionRange:a.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var Ot;(function(Me){function Te(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Te})(Ot||(e.ViewBadge=Ot={}));var ut;(function(Me){function Te(Ve,xe,Je){const rt=xe.fileData;return rt?new n.$kL(new n.$lL(rt.name,y.URI.revive(rt.uri),rt.id,(0,L.$cb)(()=>Je(rt.id)))):Ve===A.$Sr.uriList&&xe.uriListData?new n.$jL(Fe(xe.uriListData)):new n.$jL(xe.asString)}Me.to=Te;async function Ce(Ve,xe){const Je=await xe.asString();if(Ve===A.$Sr.uriList)return{asString:Je,fileData:void 0,uriListData:ne(Je)};const rt=xe.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Ce;function ne(Ve){return f.$6s.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(Ve){return f.$6s.create(Ve.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Te(ne,Fe){const Ve=ne.items.map(([xe,Je])=>[xe,ut.to(xe,Je,Fe)]);return new n.$mL(Ve)}Me.toDataTransfer=Te;async function Ce(ne){const Fe={items:[]},Ve=[];for(const[xe,Je]of ne)Ve.push((async()=>{Fe.items.push([xe,await ut.from(xe,Je)])})());return await Promise.all(Ve),Fe}Me.from=Ce})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Te(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.to=Te;function Ce(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.from=Ce})(At||(e.ChatReplyFollowup=At={}));var Vt;(function(Me){function Te(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:At.from(Ce)}Me.from=Te})(Vt||(e.ChatFollowup=Vt={}));var Lt;(function(Me){function Te(ne){const Fe=new n.$jM(at.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Me.to=Te;function Ce(ne){return{role:at.from(ne.role),content:ne.content,name:ne.name}}Me.from=Ce})(Lt||(e.ChatMessage=Lt={}));var at;(function(Me){function Te(ne){switch(ne){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Ce(ne){switch(ne){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Ce})(at||(e.ChatMessageRole=at={}));var vt;(function(Me){function Te(Fe){const Ve={};for(const xe of Object.keys(Fe))Ve[xe]=Fe[xe].map(Me.to);return Ve}Me.objectTo=Te;function Ce(Fe){return{level:Tt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Ce;function ne(Fe){return{level:Tt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ne})(vt||(e.ChatVariable=vt={}));var Tt;(function(Me){function Te(ne){switch(ne){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Ce(ne){switch(ne){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(Tt||(e.ChatVariableLevel=Tt={}));var Pt;(function(Me){function Te(Ce){switch(Ce){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var Ge;(function(Me){function Te(Ce,ne){return"placeholder"in ne&&"resolvedContent"in ne?{placeholder:ne.placeholder}:"responseId"in ne?{requestId:ne.responseId}:"markdownContent"in ne?((0,d.$lF)(Ce,"chatAgents2Additions"),{content:U.from(ne.markdownContent)}):"content"in ne?typeof ne.content=="string"?ne:((0,d.$lF)(Ce,"chatAgents2Additions"),{content:U.from(ne.content)}):"documents"in ne?{documents:ne.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>a.from(Ve))}))}:"reference"in ne?{reference:"uri"in ne.reference?{uri:ne.reference.uri,range:a.from(ne.reference.range)}:ne.reference}:"inlineReference"in ne?{inlineReference:"uri"in ne.inlineReference?{uri:ne.inlineReference.uri,range:a.from(ne.inlineReference.range)}:ne.inlineReference,title:ne.title}:("agentName"in ne&&(0,d.$lF)(Ce,"chatAgents2Additions"),ne)}Me.from=Te})(Ge||(e.ChatResponseProgress=Ge={}));var Qt;(function(Me){function Te(Ce,ne,Fe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ne.toInternal(Ce,Fe)}Me.from=Te})(Qt||(e.TerminalQuickFix=Qt={}))}),define(Se[292],De([1,0,2,9,7,14,76]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class p{constructor(m,A,P,g={timeout:1500,errors:3}){this.c=m,this.d=A,this.f=P,this.g=g,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(A,P,g)=>{const D={dispose:this.a.push([A,P,m])};return Array.isArray(g)&&g.push(D),D}}async $participateInSave(m,A){const P=I.URI.revive(m);let g=!1;const y=setTimeout(()=>g=!0,this.g.timeout),D=[];try{for(const w of[...this.a]){if(g)break;const u=this.d.getDocument(P),c=await this.h(w,{document:u,reason:L.TextDocumentSaveReason.to(A)});D.push(c)}}finally{clearTimeout(y)}return D}h([m,A,P],g){const y=this.b.get(m);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,m,A,g).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const w=this.b.get(m);this.b.set(m,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,A,P,g){const y=[],D=Date.now(),{document:w,reason:u}=g,{version:c}=w,i=Object.freeze({document:w,reason:u,waitUntil(s){if(Object.isFrozen(y))throw(0,F.$7)("waitUntil can not be called async");y.push(Promise.resolve(s))}});try{A.apply(P,[i])}catch(s){return Promise.reject(s)}return Object.freeze(y),new Promise((s,r)=>{const o=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(o),s(t)}).catch(t=>{clearTimeout(o),r(t)})}).then(s=>{const r={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(t=>t instanceof f.$CK))for(const{newText:t,newEol:n,range:d}of o)r.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&L.Range.from(d),text:t,eol:n&&L.EndOfLine.from(n)}});if(r.edits.length!==0)return c===w.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$4cc=p}),define(Se[293],De([1,0,18,2,14,7,110]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=void 0;class p{constructor(P,g,y,D){this.start=P,this.deletedCount=g,this.deletedItems=y,this.items=D}asApiEvent(){return{range:new L.$SL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(P,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,g,y){this.notebook=P,this.h=g,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(f.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,g=this.h.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:g.document,get mime(){return P.g},set mime(D){P.g=D},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(f.NotebookCellOutput.to)}setOutputItems(P,g,y){const D=y.map(f.NotebookCellOutputItem.to),w=this.a.find(u=>u.id===P);if(w&&(g||(w.items.length=0),w.items.push(...D),w.items.length>1&&w.items.every(u=>R.$zI(u.mime)))){const u=new Map,c=[];w.items.forEach(i=>{let s;u.has(i.mime)?s=u.get(i.mime):(s=[],u.set(i.mime,s),c.push(i.mime)),s.push(i.data)}),w.items.length=0,c.forEach(i=>{const s=R.$AI(u.get(i));w.items.push({mime:i,data:s.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$eec=E;class m{static{this.a=0}constructor(P,g,y,D,w){this.k=P,this.l=g,this.m=y,this.uri=D,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,g={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===I.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(w=>w.apiCell)},save(){return P.q()}};this.e=Object.freeze(g)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,g,y){this.g=P.versionId,this.h=g,this.acceptDocumentPropertiesChanged({metadata:y});const D={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},w=[];for(const c of P.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,D.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,D.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),w.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),w.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),w.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),w.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),w.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const u=new Map;for(let c=0;c<w.length;c++){const i=w[c],s=u.get(i.cell);if(s===void 0){const r=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});u.set(i.cell,r-1)}else D.cellChanges[s]={...D.cellChanges[s],...i}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let g=P.start|0,y=P.end|0;return g<0&&(g=0),y>this.b.length&&(y=this.b.length),P.with({start:g,end:y})}p(P){P=this.o(P);const g=[];for(let y=P.start;y<P.end;y++)g.push(this.b[y]);return g}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,g,y){if(this.j)return;const D=[],w=[],u=[];if(P.reverse().forEach(c=>{const s=c[2].map(t=>{const n=new E(this,this.l,t);return g||w.push(E.asModelAddData(this.apiNotebook,t)),n}),r=new p(c[0],c[1],[],s),o=this.b.splice(c[0],c[1],...s);for(const t of o)u.push(t.uri),r.deletedItems.push(t.apiCell);D.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:u}),y)for(const c of D)y.push(c.asApiEvent())}s(P,g,y,D){const w=this.b.splice(P,g);this.b.splice(y,0,...w);const u=[new p(P,g,w.map(c=>c.apiCell),[]),new p(y,0,[],w)];for(const c of u)D.push(c.asApiEvent())}t(P,g){this.b[P].setOutputs(g)}u(P,g,y,D){this.b[P].setOutputItems(g,y,D)}v(P,g){const y=this.b[P];y.apiCell.document.languageId!==g&&this.m.$acceptModelLanguageChanged(y.uri,g)}w(P,g){const y=this.b[P];y.apiCell.mime=g}x(P,g){this.b[P].setMetadata(g)}y(P,g){this.b[P].setInternalMetadata(g)}getCellFromApiCell(P){return this.b.find(g=>g.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(g=>g.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$fec=m}),define(Se[294],De([1,0,4,2,14,7]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class R{constructor(E,m,A,P={timeout:1500,errors:3}){this.b=E,this.c=m,this.d=A,this.f=P,this.a=new I.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(m,A,P)=>{const g=function(D){m.call(A,D)};return g.extension=E,this.a.event(g,void 0,P)}}async $participateInSave(E,m,A){const P=F.URI.revive(E),g=this.c.getNotebookDocument(P);if(!g)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:g.apiNotebook,reason:f.TextDocumentSaveReason.to(m)},A,async(w,u)=>{const c=Date.now(),i=await await Promise.resolve(w);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof L.$FK?y.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const D={edits:[]};for(const w of y){const{edits:u}=f.WorkspaceEdit.from(w);D.edits=D.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Fec=R}),define(Se[148],De([1,0,9,14,7]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,E,m,A,P,g){this.id=p,this.f=E,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=g}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(E){this.selections=[E]},get selections(){return p.a},set selections(E){if(!Array.isArray(E)||!E.every(f.$SL.isNotebookRange))throw(0,I.$6)("selections");p.a=E,p.g(E)},get visibleRanges(){return p.b},revealRange(E,m){p.f.$tryRevealRange(p.id,F.NotebookRange.from(E),m??f.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(F.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$gec=L}),define(Se[295],De([1,0,9,4,15,14]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let R=class{constructor(E,m){this.c=E,this.d=m,this.a=new F.$Nd({onListenerError:I.$1}),this.b=new F.$Nd({onListenerError:I.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,m);const A=this.d.getEditorById(E);m.visibleRanges&&A._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&A._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const m in E)this.d.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(E[m]))}};e.$yec=R,e.$yec=R=He([Be(0,f.$0i)],R)}),define(Se[296],De([1,0,14,64,216,21,59,9]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class E{constructor(g){this.b=0,this.c=new Map,this.a=g}async withProgress(g,y,D){const w=this.b++,{title:u,location:c,cancellable:i}=y,s={label:(0,f.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this.a.$startProgress(w,{location:I.ProgressLocation.from(c),title:u,source:s,cancellable:i},g.isUnderDevelopment?void 0:g.identifier.value).catch(p.$1),this.d(w,D,!!i)}d(g,y,D){let w;D&&(w=new L.$Xd,this.c.set(g,w));const u=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let c;try{c=y(new A(this.a,g),D&&w?w.token:L.CancellationToken.None)}catch(i){throw u(g),i}return c.then(i=>u(g),i=>u(g)),c}$acceptProgressCanceled(g){const y=this.c.get(g);y&&(y.cancel(),this.c.delete(g))}}e.$Cdc=E;function m(P,g){return P.message=g.message,typeof g.increment=="number"&&(typeof P.increment=="number"?P.increment+=g.increment:P.increment=g.increment),P}class A extends F.$8u{constructor(g,y){super(D=>this.throttledReport(D)),this.c=g,this.d=y}throttledReport(g){this.c.$progressReport(this.d,g)}}He([(0,R.$jh)(100,(P,g)=>m(P,g),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Se[149],De([1,0,29,144,68,111,88,14,2]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=e.$GM=void 0;const m=(s,r,o,t)=>{let n=r;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!o(n,d)){const l=n;n=d,s.listener?.(t(d,l))}}}},A=(s,r)=>s===r,P={range:(s,r)=>s===r?!0:!s||!r?!1:s.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(s,r)=>!(s.length!==r.length||s.some(o=>!r.find(t=>o.id===t.id)))},g=s=>r=>({op:4,update:s(r)}),y=(s,r)=>({range:(()=>{let o;const t=g(n=>({range:I.$ws.lift(p.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return o},set(n){s.listener?.({op:6}),P.range(o,n)||(o=n,s.listener?.(t(n)))}}})(),label:m(s,r,P.label,g(o=>({label:o}))),description:m(s,void 0,P.description,g(o=>({description:o}))),sortText:m(s,void 0,P.sortText,g(o=>({sortText:o}))),canResolveChildren:m(s,!1,P.canResolveChildren,o=>({op:2,state:o})),busy:m(s,!1,P.busy,g(o=>({busy:o}))),error:m(s,void 0,P.error,g(o=>({error:p.MarkdownString.fromStrict(o)||null}))),tags:m(s,[],P.tags,(o,t)=>({op:1,new:o.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),D=s=>{const r=f.$jJ.fromString(s.extId),o=new u(r.controllerId,r.localId,s.label,E.URI.revive(s.uri)||void 0);return o.range=p.Range.to(s.range||void 0),o.description=s.description||void 0,o.sortText=s.sortText||void 0,o.tags=s.tags.map(t=>p.TestTag.to({id:(0,R.$oJ)(t).tagId})),o},w=s=>{let r;for(const o of s.tests){const t=D(o.item);(0,F.$qM)(t).parent=r,r=t}return r};e.$GM=w;class u{constructor(r,o,t,n){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const d=(0,F.$pM)(this,r);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof c?void 0:d.parent}},children:{value:(0,L.$oM)(d,F.$qM,u),enumerable:!0,writable:!1},...y(d,t)})}}e.$HM=u;class c extends u{constructor(r,o){super(r,r,o,void 0),this._isRoot=!0}}e.$IM=c;class i extends L.$kM{constructor(r,o,t){super({controllerId:r,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:F.$qM,getChildren:n=>n.children,root:new c(r,o),toITestItem:p.TestItem.from})}}e.$JM=i}),define(Se[150],De([1,0,60,9,121,14,7]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=void 0;class p{static{this.c=new f.$zM("TextEditorDecorationType")}constructor(g,y,D){const w=p.c.nextId();g.$registerTextEditorDecorationType(y.identifier,w,L.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:w,dispose(){g.$removeTextEditorDecorationType(w)}})}}e.$BM=p;class E{constructor(g,y){this.g=[],this.h=void 0,this.j=!1,this.c=g,this.d=g.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(g,y){this.k();let D=null;if(g instanceof R.$wK)D=new R.$xK(g,g);else if(g instanceof R.$xK)D=g;else throw new Error("Unrecognized location");this.l(D,y,!1)}insert(g,y){this.k(),this.l(new R.$xK(g,g),y,!0)}delete(g){this.k();let y=null;if(g instanceof R.$xK)y=g;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(g,y,D){const w=this.c.validateRange(g);this.g.push({range:w,text:y,forceMoveMarkers:D})}setEndOfLine(g){if(this.k(),g!==R.EndOfLine.LF&&g!==R.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=g}}class m{constructor(g,y,D,w){this.c=g,this.d=y,this._accept(D),this.e=w;const u=this;this.value={get tabSize(){return u.f},set tabSize(c){u.m(c)},get indentSize(){return u.g},set indentSize(c){u.o(c)},get insertSpaces(){return u.h},set insertSpaces(c){u.q(c)},get cursorStyle(){return u.j},set cursorStyle(c){u.s(c)},get lineNumbers(){return u.k},set lineNumbers(c){u.t(c)}}}_accept(g){this.f=g.tabSize,this.g=g.indentSize,this.h=g.insertSpaces,this.j=g.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(g.lineNumbers)}l(g){if(g==="auto")return"auto";if(typeof g=="number"){const y=Math.floor(g);return y>0?y:null}if(typeof g=="string"){const y=parseInt(g,10);return isNaN(y)?null:y>0?y:null}return null}m(g){const y=this.l(g);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const y=Math.floor(g);return y>0?y:null}if(typeof g=="string"){const y=parseInt(g,10);return isNaN(y)?null:y>0?y:null}return null}o(g){const y=this.n(g);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(g){return g==="auto"?"auto":g==="false"?!1:!!g}q(g){const y=this.p(g);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(g){this.j!==g&&(this.j=g,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:g})))}t(g){this.k!==g&&(this.k=g,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(g)})))}assign(g){const y={};let D=!1;if(typeof g.tabSize<"u"){const w=this.l(g.tabSize);w==="auto"?(D=!0,y.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,D=!0,y.tabSize=w)}if(typeof g.indentSize<"u"){const w=this.n(g.indentSize);w==="tabSize"?(D=!0,y.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,D=!0,y.indentSize=w)}if(typeof g.insertSpaces<"u"){const w=this.p(g.insertSpaces);w==="auto"?(D=!0,y.insertSpaces=w):this.h!==w&&(this.h=w,D=!0,y.insertSpaces=w)}typeof g.cursorStyle<"u"&&this.j!==g.cursorStyle&&(this.j=g.cursorStyle,D=!0,y.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this.k!==g.lineNumbers&&(this.k=g.lineNumbers,D=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from(g.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(g,y){y.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this.e.warn(D)})}}e.$CM=m;class A{constructor(g,y,D,w,u,c,i,s){this.id=g,this.j=y,this.k=D,this.g=!1,this.h=new Set,this.c=u,this.d=new m(this.j,this.id,c,D),this.e=i,this.f=s;const r=this;this.value=Object.freeze({get document(){return w.value},set document(o){throw new F.$8("document")},get selection(){return r.c&&r.c[0]},set selection(o){if(!(o instanceof R.$yK))throw(0,F.$6)("selection");r.c=[o],r.l()},get selections(){return r.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof R.$yK)))throw(0,F.$6)("selections");r.c=o,r.l()},get visibleRanges(){return r.e},set visibleRanges(o){throw new F.$8("visibleRanges")},get options(){return r.d.value},set options(o){r.g||r.d.assign(o)},get viewColumn(){return r.f},set viewColumn(o){throw new F.$8("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(w.value,t);return o(n),r.m(n)},insertSnippet(o,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>L.Range.from(l));else if(t instanceof R.$wK){const{lineNumber:l,column:a}=L.Position.from(t);d=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(t instanceof R.$xK)d=[L.Range.from(t)];else{d=[];for(const l of t)if(l instanceof R.$xK)d.push(L.Range.from(l));else{const{lineNumber:a,column:h}=L.Position.from(l);d.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return y.$tryInsertSnippet(g,w.value.version,o.value,d,n)},setDecorations(o,t){const n=t.length===0;n&&!r.h.has(o.key)||(n?r.h.delete(o.key):r.h.add(o.key),r.n(()=>{if(L.$rM(t))return y.$trySetDecorations(g,o.key,L.$sM(t));{const d=new Array(4*t.length);for(let l=0,a=t.length;l<a;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return y.$trySetDecorationsFast(g,o.key,d)}}))},revealRange(o,t){r.n(()=>y.$tryRevealRange(g,L.Range.from(o),t||R.TextEditorRevealType.Default))},show(o){y.$tryShowEditor(g,L.ViewColumn.from(o))},hide(){y.$tryHideEditor(g)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(g){(0,I.ok)(!this.g),this.d._accept(g)}_acceptVisibleRanges(g){(0,I.ok)(!this.g),this.e=g}_acceptViewColumn(g){(0,I.ok)(!this.g),this.f=g}_acceptSelections(g){(0,I.ok)(!this.g),this.c=g}async l(){const g=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,g)),this.value}m(g){const y=g.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const D=y.edits.map(u=>u.range);D.sort((u,c)=>u.end.line===c.end.line?u.end.character===c.end.character?u.start.line===c.start.line?u.start.character-c.start.character:u.start.line-c.start.line:u.end.character-c.end.character:u.end.line-c.end.line);for(let u=0,c=D.length-1;u<c;u++){const i=D[u].end;if(D[u+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=y.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,w,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(g){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$DM=A}),define(Se[297],De([1,0,220,23,2,4,3,277,8,7,17,19,14,81,21,176,26]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;function c(r,o){if((0,A.$yf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends R.$Rc{constructor(o,t,n){super(),this.f=o,this.g=t,this.h=n,this.a=new Map,this.b=new w.$57;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(a=>d(a)?this.r(a):a):l})}registerTreeDataProvider(o,t,n){const d=this.createTreeView(o,{treeDataProvider:t},n);return{dispose:()=>d.dispose()}}createTreeView(o,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,S=this.m(o,t,n),k={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:a,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(o,k),b={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,u.$lF)(n,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,u.$lF)(n,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(v){(0,y.$5j)(v)&&(0,u.$lF)(n,"treeViewMarkdownMessage"),S.message=v},get title(){return S.title},set title(v){S.title=v},get description(){return S.description},set description(v){S.description=v},get badge(){return S.badge},set badge(v){v!==void 0&&m.ViewBadge.isViewBadge(v)?S.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(S.badge=void 0)},reveal:(v,C)=>S.reveal(v,C),dispose:async()=>{await $,this.a.delete(o),S.dispose()}};return this.B(b),b}$getChildren(o,t){const n=this.a.get(o);return n?n.getChildren(t):Promise.reject(new p.$wE(o))}async $handleDrop(o,t,n,d,l,a,h,S){const k=this.a.get(o);if(!k)return Promise.reject(new p.$wE(o));const $=g.DataTransfer.toDataTransfer(n,async b=>(await this.f.$resolveDropFileData(o,t,b)).buffer);return h===o&&S&&await this.j($,k,S,l,a),k.onDrop($,d,l)}async j(o,t,n,d,l){const a=this.b.removeDragOperationTransfer(l);if(a)(await a)?.forEach((h,S)=>{h&&o.set(S,h)});else if(l&&t.handleDrag){const h=t.handleDrag(n,o,d);this.b.addDragOperationTransfer(l,h),await h}return o}async $handleDrag(o,t,n,d){const l=this.a.get(o);if(!l)return Promise.reject(new p.$wE(o));const a=await this.j(new m.$mL,l,t,d,n);if(!(!a||d.isCancellationRequested))return g.DataTransfer.from(a)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new p.$wE(o);return t.hasResolve}$resolve(o,t,n){const d=this.a.get(o);if(!d)throw new p.$wE(o);return d.resolveTreeItem(t,n)}$setExpanded(o,t,n){const d=this.a.get(o);if(!d)throw new p.$wE(o);d.setExpanded(t,n)}$setSelectionAndFocus(o,t,n){const d=this.a.get(o);if(!d)throw new p.$wE(o);d.setSelectionAndFocus(t,n)}$setVisible(o,t){const n=this.a.get(o);if(!n){if(!t)return;throw new p.$wE(o)}n.setVisible(t)}$changeCheckboxState(o,t){const n=this.a.get(o);if(!n)throw new p.$wE(o);n.setCheckboxState(t)}m(o,t,n){const d=this.B(new s(o,t,this.f,this.g.converter,this.h,n));return this.a.set(o,d),d}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$Jdc=i;class s extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,A.$Hf)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,n,d,l,a){if(super(),this.I=o,this.J=n,this.L=d,this.M=l,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$Xd,a.contributes&&a.contributes.views)for(const $ in a.contributes.views)for(const b of a.contributes.views[$])b.id===o&&(this.P=b.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let h,S;const k=L.Event.debounce(this.F.event,($,b)=>($||($={message:!1,elements:[]}),b.element!==!1&&(h||(h=new Promise(v=>S=v),this.G=this.G.then(()=>h)),Array.isArray(b.element)?$.elements.push(...b.element):$.elements.push(b.element)),b.message&&($.message=!0),$),200,!0);this.B(k(({message:$,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const v=S;return h=null,this.$(b).then(()=>v())})),$&&this.J.$setMessage(this.I,g.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let n=this.X(o);return n||(n=await this.Y(t)),n?n.map(d=>d.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const n=(0,A.$Hf)(t.select)?!0:t.select,d=(0,A.$Hf)(t.focus)?!1:t.focus,l=(0,A.$Hf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(a=>this.W(o,a[a.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:a.map(S=>S.item)},{select:n,focus:d,expand:l})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=g.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const n=this.getExtensionElement(o);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(o,t){const n=!(0,P.$tb)(this.s,o);this.s=o;const d=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(o,t,n){const d=[];for(const l of o){const a=this.getExtensionElement(l);a&&d.push(a)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,n){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,E.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(d,o,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(o);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Mg)(()=>this.f.getParent(o))}W(o,t){const n=this.m.get(o);return n?Promise.resolve(n):(0,E.$Mg)(()=>this.f.getTreeItem(o)).then(d=>this.kb(o,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const a=this.m.get(l);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const n=this.getExtensionElement(o);t=n?this.m.get(n):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new D.$Xd(this.Z.token);try{const n=o?this.m.get(o):void 0,d=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,P.$Gb)(d||[]).map(async a=>{const h=await this.f.getTreeItem(a);return h&&!t.token.isCancellationRequested?this.db(a,h,n):null}));return t.token.isCancellationRequested?void 0:(0,P.$Gb)(l)}finally{t.dispose()}}$(o){if(o.some(n=>!n))return this.Z.dispose(!0),this.Z=new D.$Xd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(o);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(o){const t=new Set,n=o.map(l=>this.m.get(l));for(const l of n)if(l&&!t.has(l.item.handle)){let a=l;for(;a&&a.parent&&n.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.j.get(a.parent.item.handle);a=h?this.m.get(h):void 0}a&&!a.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const a=this.j.get(l);if(a){const h=this.m.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(o){const t={};return Promise.all(o.map(n=>this.cb(n).then(d=>{d&&(t[n]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Mg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,n.parent);return this.pb(t,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(o,t,n){const d=this.ib(o,t,n);if(t.id&&this.j.has(d.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(o,d),this.qb(d,n),d}eb(o){return m.$VK.isMarkdownString(o)?g.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,n,d;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,n=o.checkboxState.tooltip,d=o.checkboxState.accessibilityInformation),{isChecked:t===m.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(o){if(!m.$hL.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,n){this.hb(t);const d=this.B(new R.$Qc),l=this.kb(o,t,n),a=this.lb(t);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,A.$Hf)(t.collapsibleState)?m.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(o){return o.iconPath instanceof m.$pL?o.iconPath:void 0}kb(o,{id:t,label:n,resourceUri:d},l,a){if(t)return`${s.b}/${t}`;const h=c(n,this.N),S=l?l.item.handle:s.a;let k=h?h.label:d?(0,F.$sg)(d):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const $=this.m.has(o)?this.m.get(o).item.handle:void 0,b=this.X(l)||[];let v,C=0;do{if(v=`${S}/${C}:${k}`,a||!this.j.has(v)||$===v)break;C++}while(C<=b.length);return v}lb(o){if(o.iconPath&&!(o.iconPath instanceof m.$pL))return typeof o.iconPath=="string"||f.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof m.$pL)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return f.URI.isUri(o)?o:f.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,n,d){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(o,t);const l=this.X(d)||[],a=l.filter(h=>h.item.handle===n.item.handle)[0];a&&l.splice(l.indexOf(a),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const n of t.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const n of t.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[298],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[299],De([1,0,232,9,38,134,107,43,25,298,137,139]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=void 0;const g=p.$jn.as(R.$kn.JSONContribution);class y{constructor(o,t,n){this.a=o,this.b=t,this.c=n}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(f.default.Error,o)}warn(o){this.d(f.default.Warning,o)}info(o){this.d(f.default.Info,o)}}e.$_E=y;class D{static a(o){const t=new E.$7l;for(let n=0,d=o.length;n<d;n++)t.add(o[n].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new D(t,[]);if(!t||!t.length)return new D([],o);const n=this.a(o),d=this.a(t),l=t.filter(h=>!n.has(h.description.identifier)),a=o.filter(h=>!d.has(h.description.identifier));return new D(l,a)}constructor(o,t){this.added=o,this.removed=t}}e.$aF=D;class w{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=D.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,F.$Z)(o)}}}e.$bF=w;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$cF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$5l},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"*",description:I.localize(42,null),body:"*"}]}},badges:{type:"array",description:I.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(44,null)},href:{type:"string",description:I.localize(45,null)},description:{type:"string",description:I.localize(46,null)}}}},markdown:{type:"string",description:I.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$1n}},extensionPack:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$1n}},extensionKind:{description:I.localize(51,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(52,null)},{body:["workspace"],description:I.localize(53,null)},{body:["ui","workspace"],description:I.localize(54,null)},{body:["workspace","ui"],description:I.localize(55,null)},{body:[],description:I.localize(56,null)}]},capabilities:{description:I.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(60,null),I.localize(61,null),I.localize(62,null)]},description:{type:"string",markdownDescription:I.localize(63,null)}}},untrustedWorkspaces:{description:I.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(66,null),I.localize(67,null),I.localize(68,null)]},restrictedConfigurations:{description:I.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(70,null)}}}}},sponsor:{description:I.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(73,null),type:"string"},"vscode:uninstall":{description:I.localize(74,null),type:"string"}}},icon:{type:"string",description:I.localize(75,null)},l10n:{type:"string",description:I.localize(76,null)},pricing:{type:"string",markdownDescription:I.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new w(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&P.$3E.register(o.extensionPoint,o.activationEventsGenerator),e.$cF.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,g.registerSchema(c,e.$cF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$dF=i;const s={ExtensionsRegistry:"ExtensionsRegistry"};p.$jn.add(s.ExtensionsRegistry,new i),e.$eF=p.$jn.as(s.ExtensionsRegistry),g.registerSchema(c,e.$cF),g.registerSchema(A.$qj,{properties:{extensionEnabledApiProposals:{description:I.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Se[300],De([1,0,229,17,24,299,42,4]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var m;(function(g){function y(D,w,u){if(!D)return;const c=F.$yf(D.type)?D.type:void 0;if(!c||c.length===0){u.error(I.localize(3,null));return}const i=[];if(Array.isArray(D.required))for(const s of D.required)F.$yf(s)&&i.push(s);return{extensionId:w.value,taskType:c,required:i,properties:D.properties?f.$7m(D.properties):{},when:D.when?R.$Ni.deserialize(D.when):void 0}}g.from=y})(m||(m={}));const A=L.$eF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(g,y)=>{for(const D of g)D.type&&y.push(`onTaskType:${D.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:E}});class P{constructor(){this.d=new p.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,D)=>{A.setHandler((w,u)=>{this.c=void 0;try{for(const c of u.removed){const i=c.value;for(const s of i)this.a&&s.type&&this.a[s.type]&&delete this.a[s.type]}for(const c of u.added){const i=c.value;for(const s of i){const r=m.from(s,c.description.identifier,c.collector);r&&(this.a[r.taskType]=r)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const D of this.all()){const w={type:"object",additionalProperties:!1};D.required.length>0&&(w.required=D.required.slice(0)),D.properties!==void 0?w.properties=f.$7m(D.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[D.taskType]},y.push(w)}this.c={oneOf:y}}return this.c}}e.$VF=new P}),define(Se[301],De([1,0,230,17,23,24,42,300]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$6F=e.JsonSchemaVersion=e.ExecutionEngine=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$ZF=e.ShellQuoting=e.$YF=e.$XF=e.$WF=void 0,e.$WF="settings",e.$XF=new R.$7i("taskRunning",!1,I.localize(0,null)),e.$YF={value:I.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$ZF="$customized",function(j){function O(V){if(!V)return j.Strong;switch(V.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=O}(E||(e.ShellQuoting=E={}));var m;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var A;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(A||(e.RevealKind=A={})),function(j){function O(V){switch(V.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=O}(A||(e.RevealKind=A={}));var P;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(j){function O(V){switch(V.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=O}(P||(e.RevealProblemKind=P={}));var g;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(g||(e.PanelKind=g={})),function(j){function O(V){switch(V.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=O}(g||(e.PanelKind=g={}));var y;(function(j){j.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var D;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(j){function O(q){switch(q.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=O;function V(q){switch(q){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=V}(D||(e.RuntimeType=D={}));var w;(function(j){function O(V){return F.$yf(V)?V:V.value}j.value=O})(w||(e.CommandString=w={}));var u;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function O(q){return q===j.Clean._id||q===j.Build._id||q===j.Rebuild._id||q===j.Test._id}j.is=O;function V(q){if(q!==void 0)return F.$yf(q)?O(q)?{_id:q,isDefault:!1}:void 0:q}j.from=V})(u||(e.TaskGroup=u={}));var c;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function O(V){switch(V){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var s;(function(j){j.parallel="parallel",j.sequence="sequence"})(s||(e.DependsOrder=s={}));var r;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(O,V,q,de,x,Q){this._label="",this._id=O,V&&(this._label=V),q&&(this.type=q),this.runOptions=de,this.configurationProperties=x,this._source=Q}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,V=!1){if(O===void 0)return!1;if(F.$yf(O))return O===this._label||O===this.configurationProperties.identifier||V&&O===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$1F=t;class n extends t{constructor(O,V,q,de,x,Q,G,ce){super(O,q,void 0,G,ce,V),this.command={},this._source=V,this.hasDefinedMatchers=Q,x&&(this.command=x)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case D.Shell:V="shell";break;case D.Process:V="process";break;case D.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(O){return O instanceof n}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$WF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const q={type:e.$ZF,folder:O,id:V};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new n(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$2F=n;class d extends t{constructor(O,V,q,de,x,Q,G){super(O,q,de,Q,G,V),this._source=V,this.configures=x}static is(O){return O instanceof d}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$WF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const q={type:e.$ZF,folder:O,id:V};return JSON.stringify(q)}}e.$3F=d;class l extends t{constructor(O,V,q,de,x,Q,G,ce,ie){super(O,q,de,ce,ie,V),this.defines=x,this.hasDefinedMatchers=G,this.command=Q,this.icon=ie.icon,this.hide=ie.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof l}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new l(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$4F=l;class a extends t{constructor(O,V,q,de,x,Q){super(O,q,de,x,Q,V),this._source=V}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new a(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$5F=a;var h;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(j){j._default=j.Terminal}(h||(e.ExecutionEngine=h={}));var S;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class k{constructor(O){this.c=new Map;for(let V=0;V<O.length;V++)this.c.set(O[V].uri.toString(),V)}compare(O,V){const q=O.getWorkspaceFolder(),de=V.getWorkspaceFolder();if(q&&de){let x=this.c.get(q.uri.toString());x=x===void 0?0:x+1;let Q=this.c.get(de.uri.toString());return Q=Q===void 0?0:Q+1,x===Q?O._label.localeCompare(V._label):x-Q}else return!q&&de?-1:q&&!de?1:0}}e.$6F=k;var $;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})($||(e.TaskEventKind=$={}));var b;(function(j){j.SingleRun="singleRun",j.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var C;(function(j){function O(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function V(ce,ie,ae){return{...O(ce),kind:"start",terminalId:ie,resolvedVariables:ae}}j.start=V;function q(ce,ie,ae){return{...O(ce),kind:"processStarted",terminalId:ie,processId:ae}}j.processStarted=q;function de(ce,ie,ae){return{...O(ce),kind:"processEnded",terminalId:ie,exitCode:ae}}j.processEnded=de;function x(ce,ie,ae){return{...O(ce),kind:"terminated",exitReason:ae,terminalId:ie}}j.terminated=x;function Q(ce,ie,ae){return{...O(ie),kind:ce,terminalId:ae}}j.general=Q;function G(){return{kind:"changed"}}j.changed=G})(C||(e.TaskEvent=C={}));var N;(function(j){function O(q){const de=Object.keys(q).sort();let x="";for(const Q of de){let G=q[Q];G instanceof Object?G=O(G):typeof G=="string"&&(G=G.replace(/,/g,",,")),x+=Q+","+G+","}return x}function V(q){const x={_key:O(q),type:q.taskType};return Object.assign(x,q),x}j.create=V})(N||(e.KeyedTaskIdentifier=N={}));var T;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection"})(T||(e.TaskSettingId=T={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var U;(function(j){function O(V,q){const de=p.$VF.get(V.type);if(de===void 0){const ce=L.$7m(V);return delete ce._key,N.create(ce)}const x=Object.create(null);x.type=de.taskType;const Q=new Set;de.required.forEach(ce=>Q.add(ce));const G=de.properties;for(const ce of Object.keys(G)){const ie=V[ce];if(ie!=null)x[ce]=ie;else if(Q.has(ce)){const ae=G[ce];if(ae.default!==void 0)x[ce]=L.$7m(ae.default);else switch(ae.type){case"boolean":x[ce]=!1;break;case"number":case"integer":x[ce]=0;break;case"string":x[ce]="";break;default:q.error(I.localize(2,null,JSON.stringify(V,void 0,0),ce));return}}}return N.create(x)}j.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Se[302],De([1,0,9]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=e.$54b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$Z)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$54b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new I.$4}}e.$64b=f}),define(Se[69],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=void 0;class I{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++I.count}}e.$qv=I;const F=[];function f(p){const E=new I(p);return F[E.nid]=E,E}e.$rv=f;function L(p){return F[p].sid}e.$sv=L;class R{constructor(E){this.value=E}}e.$tv=R}),define(Se[6],De([1,0,69]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$tK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$sK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var L;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var E;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var m;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(u){return u._id=P.a++,u}}e.$sK=P;var g;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(g||(e.ISuggestDataDtoField=g={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var D;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$tK={MainThreadAuthentication:(0,I.$rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$rv)("MainThreadChatProvider"),MainThreadChatAgents:(0,I.$rv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,I.$rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$rv)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$rv)("MainThreadClipboard"),MainThreadCommands:(0,I.$rv)("MainThreadCommands"),MainThreadComments:(0,I.$rv)("MainThreadComments"),MainThreadConfiguration:(0,I.$rv)("MainThreadConfiguration"),MainThreadConsole:(0,I.$rv)("MainThreadConsole"),MainThreadDebugService:(0,I.$rv)("MainThreadDebugService"),MainThreadDecorations:(0,I.$rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$rv)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$rv)("MainThreadErrors"),MainThreadTreeViews:(0,I.$rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$rv)("MainThreadLanguages"),MainThreadLogger:(0,I.$rv)("MainThreadLogger"),MainThreadMessageService:(0,I.$rv)("MainThreadMessageService"),MainThreadOutputService:(0,I.$rv)("MainThreadOutputService"),MainThreadProgress:(0,I.$rv)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$rv)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$rv)("MainThreadSecretState"),MainThreadStorage:(0,I.$rv)("MainThreadStorage"),MainThreadSpeech:(0,I.$rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$rv)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$rv)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$rv)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$rv)("MainThreadExtensionService"),MainThreadSCM:(0,I.$rv)("MainThreadSCM"),MainThreadSearch:(0,I.$rv)("MainThreadSearch"),MainThreadShare:(0,I.$rv)("MainThreadShare"),MainThreadTask:(0,I.$rv)("MainThreadTask"),MainThreadWindow:(0,I.$rv)("MainThreadWindow"),MainThreadLabelService:(0,I.$rv)("MainThreadLabelService"),MainThreadNotebook:(0,I.$rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$rv)("MainThreadInteractive"),MainThreadChat:(0,I.$rv)("MainThreadChat"),MainThreadInlineChat:(0,I.$rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$rv)("MainThreadTheming"),MainThreadTunnelService:(0,I.$rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$rv)("MainThreadTimeline"),MainThreadTesting:(0,I.$rv)("MainThreadTesting"),MainThreadLocalization:(0,I.$rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$rv)("MainThreadIssueReporter")},e.$uK={ExtHostCommands:(0,I.$rv)("ExtHostCommands"),ExtHostConfiguration:(0,I.$rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$rv)("ExtHostDebugService"),ExtHostDecorations:(0,I.$rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$rv)("ExtHostEditors"),ExtHostTreeViews:(0,I.$rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$rv)("ExtHostStatusBar"),ExtHostShare:(0,I.$rv)("ExtHostShare"),ExtHostExtensionService:(0,I.$rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$rv)("ExtHostTerminalService"),ExtHostSCM:(0,I.$rv)("ExtHostSCM"),ExtHostSearch:(0,I.$rv)("ExtHostSearch"),ExtHostTask:(0,I.$rv)("ExtHostTask"),ExtHostWorkspace:(0,I.$rv)("ExtHostWorkspace"),ExtHostWindow:(0,I.$rv)("ExtHostWindow"),ExtHostWebviews:(0,I.$rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$rv)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$rv)("ExtHostProgress"),ExtHostComments:(0,I.$rv)("ExtHostComments"),ExtHostSecretState:(0,I.$rv)("ExtHostSecretState"),ExtHostStorage:(0,I.$rv)("ExtHostStorage"),ExtHostUrls:(0,I.$rv)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$rv)("ExtHostOutputService"),ExtHosLabelService:(0,I.$rv)("ExtHostLabelService"),ExtHostNotebook:(0,I.$rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$rv)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$rv)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$rv)("ExtHostChat"),ExtHostChatAgents:(0,I.$rv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,I.$rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$rv)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$rv)("ExtHostTheming"),ExtHostTunnelService:(0,I.$rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$rv)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$rv)("ExtHostTimeline"),ExtHostTesting:(0,I.$rv)("ExtHostTesting"),ExtHostTelemetry:(0,I.$rv)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$rv)("ExtHostIssueReporter")}}),define(Se[303],De([1,0,6,7]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$tK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,E){if(this.a.size===0)throw new Error("No related information providers registered");const m=this.a.get(R);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(p,E)??[]}getRelatedInformation(R,p,E){return this.c.$getAiRelatedInformation(p,E)}registerRelatedInformationProvider(R,p,E){const m=this.b;return this.b++,this.a.set(m,E),this.c.$registerAiRelatedInformationProvider(m,p),new F.$vK(()=>{this.c.$unregisterAiRelatedInformationProvider(m),this.a.delete(m)})}}e.$Lec=f}),define(Se[90],De([1,0,5,15,6,20]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=e.$Ncc=void 0,e.$Ncc=(0,I.$Ph)("IExtHostApiDeprecationService");let R=class{constructor(E,m){this.c=m,this.a=new Set,this.b=E.getProxy(f.$tK.MainThreadTelemetry)}report(E,m,A){const P=this.d(E,m);this.a.has(P)||(this.a.add(P),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:E}))}d(E,m){return`${E}-${m.identifier.value}`}};e.$Occ=R,e.$Occ=R=He([Be(0,L.$uM),Be(1,F.$0i)],R),e.$Pcc=Object.freeze(new class{report(p,E,m){}})}),define(Se[304],De([1,0,4,6,7,25]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class R{constructor(m){this.b=new Map,this.c=[],this.d=new I.$Nd,this.onDidChangeSessions=this.d.event,this.f=new p,this.g=new p,this.a=m.getProxy(F.$tK.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,A,P,g={}){const y=L.$6l.toKey(m.identifier),D=[...P].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${D}`,async()=>{await this.a.$ensureProvider(A);const w=m.displayName||m.name;return this.a.$getSession(A,P,y,w,g)})}async getSessions(m,A,P){const g=L.$6l.toKey(m.identifier),y=[...P].sort().join(" ");return await this.g.getOrCreate(`${g} ${y}`,async()=>{await this.a.$ensureProvider(A);const D=m.displayName||m.name;return this.a.$getSessions(A,P,g,D)})}async removeSession(m,A){const P=this.b.get(m);return P?P.provider.removeSession(A):this.a.$removeSession(m,A)}registerAuthenticationProvider(m,A,P,g){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:A,provider:P,options:g??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===m)||this.c.push({id:m,label:A});const y=P.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(m,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(m,A,g?.supportsMultipleAccounts??!1),new f.$vK(()=>{y.dispose(),this.b.delete(m);const D=this.c.findIndex(w=>w.id===m);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,A,P){const g=this.b.get(m);if(g)return Promise.resolve(g.provider.createSession(A,P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,A){const P=this.b.get(m);if(P)return Promise.resolve(P.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,A){const P=this.b.get(m);if(P)return Promise.resolve(P.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,A){return this.d.fire({provider:{id:m,label:A}}),Promise.resolve()}}e.$jec=R;class p{constructor(){this.a=new Map}getOrCreate(m,A){const P=this.a.get(m);if(P)return P;const g=A().finally(()=>this.a.delete(m));return this.a.set(m,g),g}}}),define(Se[305],De([1,0,6,20,14]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;let L=class{constructor(p,E){this.a=p.getProxy(I.$tK.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>E.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,E,m){const A=f.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,m?.isRefactoring??!1)}};e.$pec=L,e.$pec=L=He([Be(0,F.$uM)],L)}),define(Se[306],De([1,0,8,4,51,3,36,209,6,14]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class A{static{this.a=0}constructor(y,D){this.extension=y,this.provider=D,this.handle=A.a++}}class P{static{this.a=0}constructor(y,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new F.$Nd,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$tK.MainThreadChat)}registerChatProvider(y,D,w){const u=new A(y,w);return this.b.set(u.handle,u),this.g.$registerChatProvider(u.handle,D),(0,L.$Pc)(()=>{this.g.$unregisterChatProvider(u.handle),this.b.delete(u.handle)})}transferChatSession(y,D){const w=f.Iterable.find(this.d.keys(),u=>this.d.get(u)===y)??0;typeof w=="number"&&this.g.$transferChatSession(w,D)}sendInteractiveRequestToProvider(y,D){this.g.$sendRequestToProvider(y,D)}async $prepareChat(y,D,w){const u=this.b.get(y);if(!u)return;const c=await u.provider.prepareSession(D,w);if(!c)return;const i=P.a++;return this.d.set(i,c),{id:i,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $provideWelcomeMessage(y,D){const w=this.b.get(y);if(!w||!w.provider.provideWelcomeMessage)return;const u=await w.provider.provideWelcomeMessage(D);if(u)return u.map(c=>typeof c=="string"?c:Array.isArray(c)?c.map(i=>m.ChatReplyFollowup.from(i)):m.MarkdownString.from(c))}async $provideFollowups(y,D,w){const u=this.b.get(y);if(!u)return;const c=this.d.get(D);return!c||!u.provider.provideFollowups?void 0:(await u.provider.provideFollowups(c,w))?.map(s=>m.ChatFollowup.from(s))}async $provideSampleQuestions(y,D){const w=this.b.get(y);if(!w||!w.provider.provideSampleQuestions)return;const u=await w.provider.provideSampleQuestions(D);if(u)return u?.map(c=>m.ChatReplyFollowup.from(c))}$removeRequest(y,D,w){const u=this.b.get(y);if(!u)return;const c=this.d.get(D);c&&u.provider.removeRequest&&u.provider.removeRequest(c,w)}async $provideReply(y,D,w,u){const c=this.b.get(y);if(!c)return;const i=this.d.get(D);if(!i)return;const s={session:i,message:w.message,variables:{}};if(w.variables)for(const l of Object.keys(w.variables))s.variables[l]=w.variables[l].map(m.ChatVariable.to);const r=R.$Jd.create(!1);let o;const t={report:l=>{if(u.isCancellationRequested)return;typeof o>"u"&&(o=r.elapsed());const a=m.ChatResponseProgress.from(c.extension,l);if("placeholder"in l&&"resolvedContent"in l){const h=Promise.all([this.g.$acceptResponseProgress(y,D,a),l.resolvedContent]);(0,I.$Ig)(h,u).then(S=>{if(!S)return;const[k,$]=S;this.g.$acceptResponseProgress(y,D,$,k??void 0)})}else this.g.$acceptResponseProgress(y,D,a)}};let n;try{n=await c.provider.provideResponseWithProgress(s,t,u),n||(n={errorDetails:{message:(0,p.localize)(0,null)}})}catch(l){n={errorDetails:{message:(0,p.localize)(1,null,l.message),responseIsIncomplete:!0}},this.h.error(l)}try{if(i.saveState&&this.d.has(D)){const l=i.saveState();this.g.$acceptChatState(D,l)}}catch(l){this.h.warn(l)}const d={firstProgress:o??0,totalElapsed:r.elapsed()};return{errorDetails:n.errorDetails,timings:d}}async $provideSlashCommands(y,D,w){const u=this.b.get(y);if(!u)return;const c=this.d.get(D);return!c||!u.provider.provideSlashCommands?void 0:(await u.provider.provideSlashCommands(c,w))?.map(s=>({...s,kind:m.CompletionItemKind.from(s.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$Dec=P}),define(Se[307],De([1,0,8,3,64,6,14,7]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class E{static{this.a=0}constructor(P,g,y){this.d=g,this.e=y,this.b=new Map,this.c=P.getProxy(L.$tK.MainThreadChatAgents)}registerAgent(P,g,y,D){const w=E.a++;return this.b.set(w,{extension:P,agent:y}),this.c.$registerAgent(w,g,D),(0,F.$Pc)(()=>{this.c.$unregisterAgent(w),this.b.delete(w)})}async $invokeAgent(P,g,y,D,w){const u=this.b.get(P);if(!u){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let c=!1;function i(){if(c)throw new Error("Only valid while executing the command")}const s=new I.$ch;w.onCancellationRequested(()=>s.complete()),setTimeout(()=>s.complete(),10*1e3),this.d.allowListExtensionWhile(u.extension,s.p);const r=u.agent({role:p.ChatMessageRole.User,content:y},{history:D.history.map(R.ChatMessage.to)},new f.$8u(o=>{i(),this.c.$handleProgressChunk(g,{content:m(o.message)?o.message:o.message.value})}),w);try{return await(0,I.$Ig)(Promise.resolve(r).then(o=>{if(o&&"followUp"in o)return{followUp:o?.followUp?.map(n=>R.ChatFollowup.from(n))}}),w)}finally{c=!0,s.complete()}}}e.$Nec=E;function m(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Se[308],De([1,0,8,21,41,4,36,17,2,210,64,6,14,7,278,26]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class u{static{this.a=0}constructor(s,r,o){this.i=r,this.j=o,this.b=new Map,this.g=new Map,this.h=new Map,this.d=s.getProxy(P.$tK.MainThreadChatAgents2)}createChatAgent(s,r,o){const t=u.a++,n=new c(s,r,this.d,t,o);return this.b.set(t,n),this.d.$registerAgent(t,r,{}),n.apiAgent}async $invokeAgent(s,r,o,t,n,d){this.g.delete(r);const l=this.b.get(s);if(!l)throw new Error(`[CHAT](${s}) CANNOT invoke agent because the agent is not registered`);let a=!1;function h(){if(a)throw new Error("Only valid while executing the command")}const S=new I.$ch;d.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(l.extension.identifier,S.p);const k=t.command?await l.validateSlashCommand(t.command):void 0,$=R.$Jd.create(!1);let b;try{const v=l.invoke({prompt:t.message,variables:g.ChatVariable.objectTo(t.variables),slashCommand:k},{history:n.history.map(g.ChatMessage.to)},new A.$8u(C=>{h(),typeof b>"u"&&"content"in C&&(b=$.elapsed());const N=g.ChatResponseProgress.from(l.extension,C);if("placeholder"in C&&"resolvedContent"in C){const T=Promise.all([this.d.$handleProgressChunk(o,N),C.resolvedContent]);(0,I.$Ig)(T,d).then(M=>{if(!M)return;const[U,j]=M;this.d.$handleProgressChunk(o,j,U??void 0)})}else this.d.$handleProgressChunk(o,N)}),d);return await(0,I.$Ig)(Promise.resolve(v).then(C=>{if(C){this.g.set(r,C);let N=this.h.get(r);N||(N=new Map,this.h.set(r,N)),N.set(o,C);const T={firstProgress:b,totalElapsed:$.elapsed()};return{errorDetails:C.errorDetails,timings:T}}else this.g.delete(r)}),d)}catch(v){return this.j.error(v,l.extension),{errorDetails:{message:(0,m.localize)(0,null,(0,f.$Ai)(v)),responseIsIncomplete:!0}}}finally{a=!0,S.complete()}}$releaseSession(s){this.g.delete(s),this.h.delete(s)}async $provideSlashCommands(s,r){const o=this.b.get(s);return o?o.provideSlashCommand(r):[]}$provideFollowups(s,r,o){const t=this.b.get(s);if(!t)return Promise.resolve([]);const n=this.g.get(r);return n?t.provideFollowups(n,o):Promise.resolve([])}$acceptFeedback(s,r,o,t){const n=this.b.get(s);if(!n)return;const d=this.h.get(r)?.get(o);if(!d)return;let l;switch(t){case D.InteractiveSessionVoteDirection.Down:l=y.ChatAgentResultFeedbackKind.Unhelpful;break;case D.InteractiveSessionVoteDirection.Up:l=y.ChatAgentResultFeedbackKind.Helpful;break}n.acceptFeedback(Object.freeze({result:d,kind:l}))}$acceptAction(s,r,o,t){const n=this.b.get(s);if(!n)return;const d=this.h.get(r)?.get(o);d&&t.action.kind!=="vote"&&n.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$Oec=u;class c{constructor(s,r,o,t,n){this.extension=s,this.n=r,this.o=o,this.q=t,this.r=n,this.l=new L.$Nd,this.m=new L.$Nd}acceptFeedback(s){this.l.fire(s)}acceptAction(s){this.m.fire(s)}async validateSlashCommand(s){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,p.$If)(this.b));const r=this.b.find(o=>o.name===s);if(!r)throw new Error(`Unknown slashCommand: ${s}`);return r}async provideSlashCommand(s){if(!this.a)return[];const r=await this.a.provideSlashCommands(s);return r?(this.b=r,r.map(o=>({name:o.name,description:o.description,followupPlaceholder:o.followupPlaceholder,shouldRepopulate:o.shouldRepopulate}))):[]}async provideFollowups(s,r){if(!this.d)return[];const o=await this.d.provideFollowups(s,r);return o?o.map(t=>g.ChatFollowup.from(t)):[]}get apiAgent(){let s=!1,r=!1;const o=()=>{s||r||(r=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$pL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),r=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(n){t.g=n,o()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(n){t.h=n,o()},get iconPath(){return t.i},set iconPath(n){t.i=n,o()},get slashCommandProvider(){return t.a},set slashCommandProvider(n){t.a=n,o()},get followupProvider(){return t.d},set followupProvider(n){t.d=n,o()},get isDefault(){return(0,w.$lF)(t.extension,"defaultChatAgent"),t.j},set isDefault(n){(0,w.$lF)(t.extension,"defaultChatAgent"),t.j=n,o()},get isSecondary(){return(0,w.$lF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(n){(0,w.$lF)(t.extension,"defaultChatAgent"),t.k=n,o()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,w.$kF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){s=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(s,r,o,t){return this.r(s,r,o,t)}}}),define(Se[309],De([1,0,21,3,6,14,64,25,8,4]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class A{constructor(D,w){this.stream=new E.$gh,this.stream=w??new E.$gh;const u=this;this.apiObj={option:D,response:u.stream.asyncIterable}}}class P{constructor(D,w){this.a=new m.$Nd,this.b=new Map,this.c=new E.$gh,this.d=!1;const u=this;this.apiObject={result:D,response:u.c.asyncIterable,onDidStartResponseStream:u.a.event,cancel(){w.cancel()}},D.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,c]of this.b)c.stream.resolve();else this.c.resolve()})}handleFragment(D){if(this.d)return;let w=this.b.get(D.index);w||(this.b.size===0?w=new A(D.index,this.c):w=new A(D.index),this.b.set(D.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(D.part)}}class g{static{this.a=1}constructor(D,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new p.$8l,this.b=D.getProxy(f.$tK.MainThreadChatProvider)}registerProvider(D,w,u,c){const i=g.a++;return this.c.set(i,{extension:D,provider:u}),this.b.$registerProvider(i,w,{extension:D,displayName:c.name??D.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(D,w,u,c,i){const s=this.c.get(D);if(!s)return;const r=new R.$8u(async o=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${s.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:o.index,part:o.part})});return s.provider.provideChatResponse(u.map(L.ChatMessage.to),c,r,i)}allowListExtensionWhile(D,w){this.f.set(D,w),w.finally(()=>this.f.delete(D))}async requestChatResponseProvider(D,w){if(!this.f.has(D))throw new Error("Extension is NOT allowed to make chat requests");const u=this;return{get isRevoked(){return!u.f.has(D)},makeRequest(c,i,s){if(!u.f.has(D))throw new Error("Access to chat has been revoked");const r=new I.$Xd(s),o=Math.random()*1e6|0,t=u.b.$fetchResponse(D,w,o,c.map(L.ChatMessage.from),i??{},r.token),n=new P(t,r);return u.e.set(o,{res:n}),t.finally(()=>{u.e.delete(o)}),n.apiObject}}}async $handleResponseFragment(D,w){const u=this.e.get(D);u&&u.res.handleFragment(w)}}e.$Iec=g}),define(Se[310],De([1,0,3,6,9,14]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$tK.MainThreadChatVariables)}async $resolveVariable(E,m,A){const P=this.b.get(E);if(P)try{const g=await P.resolver.resolve(P.data.name,{message:m},A);if(g)return g.map(L.ChatVariable.from)}catch(g){(0,f.$1)(g)}}registerVariableResolver(E,m,A,P){const g=R.a++;return this.b.set(g,{extension:E.identifier,data:{name:m,description:A},resolver:P}),this.c.$registerVariable(g,{name:m,description:A}),(0,I.$Pc)(()=>{this.b.delete(g),this.c.$unregisterVariable(g)})}}e.$Kec=R}),define(Se[311],De([1,0,6]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class F{constructor(L){const R=L.getProxy(I.$tK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$Scc=F}),define(Se[34],De([1,0,17,7,14,24,6,19,15,54,29,53,2,3,5,20,149,22,69,41,36,86,89]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=void 0;let n=class{#e;#t;#i;constructor(k,$,b){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$tK.MainThreadCommands),this.d=$,this.#i=b,this.#t=k.getProxy(R.$tK.MainThreadTelemetry),this.converter=new d(this,v=>{const C=this.c.get(v);return C?.result===a.Void?C:void 0},$),this.f=[{processArgument(v){return(0,m.$mh)(v)}},{processArgument(v){return(0,L.$9m)(v,function(C){if(A.$ws.isIRange(C))return f.Range.to(C);if(P.$vs.isIPosition(C))return f.Position.to(C);if(A.$ws.isIRange(C.range)&&g.URI.isUri(C.uri))return f.location.to(C);if(C instanceof c.$be)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const $=this.registerCommand(!1,k.id,async(...b)=>{const v=k.args.map((N,T)=>{if(!N.validate(b[T]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof b[T]=="object"?JSON.stringify(b[T],null,"	"):b[T]} `);return N.convert(b[T])}),C=await this.executeCommand(k.internalId,...v);return k.result.convert(C,b,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new F.$vK(()=>{$.dispose(),this.c.delete(k.id)})}registerCommand(k,$,b,v,C,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:b,thisArg:v,metadata:C,extension:N}),k&&this.#e.$registerCommand($),new F.$vK(()=>{this.b.delete($)&&k&&this.#e.$unregisterCommand($)})}executeCommand(k,...$){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,$,!0)}async g(k,$,b){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,$,!1);{let v=!1;const C=(0,L.$9m)($,function(N){if(N instanceof F.$wK)return f.Position.from(N);if(N instanceof F.$xK)return f.Range.from(N);if(N instanceof F.$HK)return f.location.from(N);if(F.$SL.isNotebookRange(N))return f.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,c.$be.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,c.$be.wrap(N);if(N instanceof c.$be)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,v?new i.$tv(C):C,b);return(0,m.$mh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,$,!1);throw N}}}async h(k,$,b){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:C,thisArg:N,metadata:T}=v;if(T?.args)for(let U=0;U<T.args.length;U++)try{(0,I.$Pf)($[U],T.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${T.args[U].name}' - ${T.args[U].description}`)}const M=r.$Jd.create();try{return await C.apply(N,$)}catch(U){if(k===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...$);j&&(k=j.command)}if(this.d.error(U,k,v.extension?.identifier),!b)throw U;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,U);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,s.$Ai)(U)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,M.elapsed())}}j(k,$,b){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new o.$mo($),duration:b})}$executeContributedCommand(k,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const b=this.b.get(k);return b?($=$.map(v=>this.f.reduce((C,N)=>N.processArgument(C,b.extension?.identifier),v)),this.h(k,$,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then($=>(k&&($=$.filter(b=>b[0]!=="_")),$))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[$,b]of this.b){const{metadata:v}=b;v&&(k[$]=v)}return Promise.resolve(k)}};e.$PM=n,e.$PM=n=He([Be(0,w.$uM),Be(1,E.$0i),Be(2,t.$OM)],n),e.$QM=(0,D.$Ph)("IExtHostCommands");class d{constructor(k,$,b){this.d=k,this.f=$,this.g=b,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,$){if(!k)return;const b={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return b;const v=this.f(k.command);if(v)b.id=v.internalId,b.arguments=v.args.map((C,N)=>C.convert(k.arguments&&k.arguments[N]));else if((0,p.$Kb)(k.arguments)){const C=`${k.command} /${++this.c}`;this.b.set(C,k),$.add((0,y.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),b.$ident=C,b.id=this.delegatingCommandId,b.arguments=[C],this.g.trace("CommandsConverter#CREATE",k.command,C)}return b}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const $=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$RM=d;class l{static{this.Uri=new l("uri","Uri of a text document",k=>g.URI.isUri(k),k=>k)}static{this.Position=new l("position","A position in a text document",k=>F.$wK.isPosition(k),f.Position.from)}static{this.Range=new l("range","A range in a text document",k=>F.$xK.isRange(k),f.Range.from)}static{this.Selection=new l("selection","A selection in a text document",k=>F.$yK.isSelection(k),f.Selection.from)}static{this.Number=new l("number","",k=>typeof k=="number",k=>k)}static{this.String=new l("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=l.Arr(l.String)}static Arr(k){return new l(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,$=>Array.isArray($)&&$.every(b=>k.validate(b)),$=>$.map(b=>k.convert(b)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",k=>k instanceof F.$RK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",k=>k instanceof F.$_L,f.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",k=>k instanceof u.$HM,f.TestItem.from)}constructor(k,$,b,v){this.name=k,this.description=$,this.validate=b,this.convert=v}optional(){return new l(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,$){return new l(k??this.name,$??this.description,this.validate,this.convert)}}e.$SM=l;class a{static{this.Void=new a("no result",k=>k)}constructor(k,$){this.description=k,this.convert=$}}e.$TM=a;class h{constructor(k,$,b,v,C){this.id=k,this.internalId=$,this.description=b,this.args=v,this.result=C}}e.$UM=h}),define(Se[312],De([1,0,19,18,2,84,131,42,136,34,14,7]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;const g=[new m.$UM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of DocumentHighlight-instances.",D(A.DocumentHighlight.to))),new m.$UM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$SM.Uri],new m.$TM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,c)=>{if((0,I.$Jb)(u))return;class i extends P.$MK{static to(r){const o=new i(r.name,A.SymbolKind.to(r.kind),r.containerName||"",new P.$HK(c[0],A.Range.to(r.range)));return o.detail=r.detail,o.range=o.location.range,o.selectionRange=A.Range.to(r.selectionRange),o.children=r.children?r.children.map(i.to):[],o}}return u.map(i.to)})),new m.$UM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$SM.Uri,new m.$SM("options","Formatting options",u=>!0,u=>u)],new m.$TM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new m.$UM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$SM.Uri,m.$SM.Range,new m.$SM("options","Formatting options",u=>!0,u=>u)],new m.$TM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new m.$UM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$SM.Uri,m.$SM.Position,new m.$SM("ch","Trigger character",u=>typeof u=="string",u=>u),new m.$SM("options","Formatting options",u=>!0,u=>u)],new m.$TM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new m.$UM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$UM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$UM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$UM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$UM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of Location-instances.",D(A.location.to))),new m.$UM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of Hover-instances.",D(A.Hover.to))),new m.$UM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$SM.Uri,new m.$SM("position","A position in a text document",u=>Array.isArray(u)&&u.every(c=>P.$wK.isPosition(c)),u=>u.map(A.Position.from))],new m.$TM("A promise that resolves to an array of ranges.",u=>u.map(c=>{let i;for(const s of c.reverse())i=new P.$QK(A.Range.to(s),i);return i}))),new m.$UM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$SM.String.with("query","Search string")],new m.$TM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(A.WorkspaceSymbol.to))),new m.$UM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(A.CallHierarchyItem.to))),new m.$UM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$SM.CallHierarchyItem],new m.$TM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(A.CallHierarchyIncomingCall.to))),new m.$UM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$SM.CallHierarchyItem],new m.$TM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(A.CallHierarchyOutgoingCall.to))),new m.$UM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:A.Range.to(u.range),placeholder:u.text}})),new m.$UM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$SM.Uri,m.$SM.Position,m.$SM.String.with("newName","The new symbol name")],new m.$TM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return A.WorkspaceEdit.to(u)}})),new m.$UM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$SM.Uri,m.$SM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$TM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(A.DocumentLink.to))),new m.$UM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$SM.Uri],new m.$TM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new P.$KL(u.tokenTypes,u.tokenModifiers)})),new m.$UM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$SM.Uri],new m.$TM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const c=(0,R.$c$)(u);if(c.type==="full")return new P.$ML(c.data,void 0)})),new m.$UM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$SM.Uri,m.$SM.Range.optional()],new m.$TM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new P.$KL(u.tokenTypes,u.tokenModifiers)})),new m.$UM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$SM.Uri,m.$SM.Range],new m.$TM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const c=(0,R.$c$)(u);if(c.type==="full")return new P.$ML(c.data,void 0)})),new m.$UM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$SM.Uri,m.$SM.Position,m.$SM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$SM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$TM("A promise that resolves to a CompletionList-instance.",(u,c,i)=>{if(!u)return new P.$3K([]);const s=u.suggestions.map(r=>A.CompletionItem.to(r,i));return new P.$3K(s,u.incomplete)})),new m.$UM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$SM.Uri,m.$SM.Position,m.$SM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$TM("A promise that resolves to SignatureHelp.",u=>{if(u)return A.SignatureHelp.to(u)})),new m.$UM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$SM.Uri,m.$SM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$TM("A promise that resolves to an array of CodeLens-instances.",(u,c,i)=>D(s=>new P.$UK(A.Range.to(s.range),s.command&&i.fromInternal(s.command)))(u))),new m.$UM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$SM.Uri,new m.$SM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>P.$xK.isRange(u),u=>P.$yK.isSelection(u)?A.Selection.from(u):A.Range.from(u)),m.$SM.String.with("kind","Code action kind to return code actions for").optional(),m.$SM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$TM("A promise that resolves to an array of Command-instances.",(u,c,i)=>D(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(s.command)}else{const r=new P.$OK(s.title,s.kind?new P.$PK(s.kind):void 0);return s.edit&&(r.edit=A.WorkspaceEdit.to(s.edit)),s.command&&(r.command=i.fromInternal(s.command)),r.isPreferred=s.isPreferred,r}})(u))),new m.$UM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$SM.Uri],new m.$TM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(c=>new P.$9K(A.Range.to(c.range),A.Color.to(c.color))):[])),new m.$UM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$SM("color","The color to show and insert",u=>u instanceof P.$8K,A.Color.from),new m.$SM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:A.Range.from(u.range)}))],new m.$TM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(A.ColorPresentation.to):[])),new m.$UM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$SM.Uri,m.$SM.Range],new m.$TM("A promise that resolves to an array of Inlay objects",(u,c,i)=>u.map(A.InlayHint.to.bind(void 0,i)))),new m.$UM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$SM.Uri],new m.$TM("A promise that resolves to an array of FoldingRange objects",(u,c)=>{if(u)return u.map(A.FoldingRange.to)})),new m.$UM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$TM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(c=>A.NotebookExclusiveDocumentPattern.to(c))})))),new m.$UM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$SM.Uri,m.$SM.Range,new m.$SM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof P.$xK,u=>A.InlineValueContext.from(u))],new m.$TM("A promise that resolves to an array of InlineValue objects",u=>u.map(A.InlineValue.to))),new m.$UM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$SM("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,E.$xU)(u,F.Schemas.http,F.Schemas.https),u=>u),new m.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional(),m.$SM.String.with("label","").optional()],m.$TM.Void),new m.$UM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$SM.Uri.with("resource","Resource to open"),m.$SM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional()],m.$TM.Void),new m.$UM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$SM.Uri.with("left","Left-hand side resource of the diff editor"),m.$SM.Uri.with("right","Right-hand side resource of the diff editor"),m.$SM.String.with("title","Human readable title for the diff editor").optional(),new m.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)]).optional()],m.$TM.Void),new m.$UM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$SM.Uri,m.$SM.Position],new m.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new m.$UM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$SM.TypeHierarchyItem],new m.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new m.$UM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$SM.TypeHierarchyItem],new m.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new m.$UM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$SM.TestItem],m.$TM.Void),new m.$UM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$SM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$TM.Void),new m.$UM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$SM.String.with("name","The context key name"),new m.$SM("value","The context key value",()=>!0,u=>u)],m.$TM.Void),new m.$UM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$SM.Uri,m.$SM.StringArray,new m.$SM("MappedEditsContext","Mapped Edits Context",u=>A.MappedEditsContext.is(u),u=>A.MappedEditsContext.from(u))],new m.$TM("A promise that resolves to a workspace edit or null",u=>u?A.WorkspaceEdit.to(u):null))];class y{static register(c){g.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",p.$Oi)}}e.$Rcc=y;function D(u){return c=>{if(Array.isArray(c))return c.map(u)}}function w(u){if(!Array.isArray(u))return;const c=[];for(const i of u)L.$ht(i)?c.push(A.DefinitionLink.to(i)):c.push(A.location.to(i));return c}}),define(Se[313],De([1,0,8,59,4,3,2,84,25,14,7,6,26]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;function y(D,w,u){const c=D.getProxy(P.$tK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$8l,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const S=this.b.get(h.handle);return S?S.value:h}else if(h&&h.$mid===7){const S=this.b.get(h.commentControlHandle);if(!S)return h;const k=S.getCommentThread(h.commentThreadHandle);return k?k.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const k=S.getCommentThread(h.thread.commentThreadHandle);return k?h.$mid===8?k.value:{thread:k.value,text:h.text}:h}else if(h&&h.$mid===10){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const k=S.getCommentThread(h.thread.commentThreadHandle);if(!k)return h;const $=h.commentUniqueId,b=k.getCommentByUniqueId($);return b||h}else if(h&&h.$mid===11){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const k=S.getCommentThread(h.thread.commentThreadHandle);if(!k)return h;const $=h.text,b=h.commentUniqueId,v=k.getCommentByUniqueId(b);return v?(typeof v.body=="string"?v.body=$:v.body=new A.$VK($),v):h}return h}})}createCommentController(h,S,k){const $=i.a++,b=new r(h,$,S,k);this.b.set(b.handle,b);const v=this.c.get(h.identifier)||[];return v.push(b),this.c.set(h.identifier,v),b.value}async $createCommentThreadTemplate(h,S,k){const $=this.b.get(h);$&&$.$createCommentThreadTemplate(S,k)}async $updateCommentThreadTemplate(h,S,k){const $=this.b.get(h);$&&$.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(h,S){this.b.get(h)?.$deleteCommentThread(S)}$provideCommentingRanges(h,S,k){const $=this.b.get(h);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const b=u.getDocument(R.URI.revive(S));return(0,I.$Mg)(async()=>{const v=await $.commentingRangeProvider.provideCommentingRanges(b,k);let C;return Array.isArray(v)?C={ranges:v,fileComments:!1}:v?C={ranges:v.ranges||[],fileComments:v.fileComments||!1}:C=v??void 0,C}).then(v=>{let C;return v&&(C={ranges:v.ranges.map(N=>m.Range.from(N)),fileComments:v.fileComments}),C})}$toggleReaction(h,S,k,$,b){const v=this.b.get(h);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,I.$Mg)(()=>{const C=v.getCommentThread(S);if(C){const N=C.getCommentByUniqueId($.uniqueIdInThread);if(v!==void 0&&N&&v.reactionHandler)return v.reactionHandler(N,n(b))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,S,k,$,b,v,C,N){this.m=S,this.n=k,this.o=$,this.p=b,this.q=v,this.extensionDescription=C,this.r=N,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),c.$createCommentThread(S,this.handle,this.n,this.o,m.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{c.$deleteCommentThread(S,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(M){T.range=M},get comments(){return T.comments},set comments(M){T.comments=M},get collapsibleState(){return T.collapsibleState},set collapsibleState(M){T.collapsibleState=M},get canReply(){return T.canReply},set canReply(M){T.canReply=M},get contextValue(){return T.contextValue},set contextValue(M){T.contextValue=M},get label(){return T.label},set label(M){T.label=M},get state(){return T.state},set state(M){T.state=M},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const h=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};h("range")&&(S.range=m.Range.from(this.p)),h("label")&&(S.label=this.label),h("contextValue")&&(S.contextValue=this.contextValue??null),h("comments")&&(S.comments=this.q.map(k=>o(this,k,this.k,this.extensionDescription))),h("collapsibleState")&&(S.collapseState=d(this.g)),h("canReply")&&(S.canReply=this.canReply),h("state")&&(S.state=l(this.h)),h("isTemplate")&&(S.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(h){for(const S of this.k){const k=S[0],$=S[1];if(h===$)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,F.$ih)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,S,k,$){this.f=h,this.g=S,this.h=k,this.i=$,this.a=new Map,c.$registerCommentController(this.handle,k,$,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(v){b.options=v},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(v){b.commentingRangeProvider=v},get reactionHandler(){return b.reactionHandler},set reactionHandler(v){b.reactionHandler=v},createCommentThread(v,C,N){return b.createCommentThread(v,C,N).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(h,S,k){S===void 0&&(0,g.$lF)(this.f,"fileComments");const $=new s(this.id,this.handle,void 0,h,S,k,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(h,S){const k=new s(this.id,this.handle,void 0,R.URI.revive(h),m.Range.to(S),[],this.f,!0);return k.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(h,S){const k=this.a.get(h);k&&(k.range=m.Range.to(S))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function o(a,h,S,k){let $=S.get(h);return $||($=++a.commentHandle,S.set(h,$)),h.state!==void 0&&(0,g.$lF)(k,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:$,body:typeof h.body=="string"?h.body:m.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(b=>t(b)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?m.$tM(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?R.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function d(a){if(a!==void 0)switch(a){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new i}e.$Tcc=y}),define(Se[314],De([1,0,24,6,27,20]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;let R=class{constructor(A,P){this.a=A.getProxy(F.$tK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,P){const g=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){g.e(A,P,y,arguments)}})}e(A,P,g,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:E(y,this.b)}),this.c&&this.f(A,g,y)}};e.$Rec=R,e.$Rec=R=He([Be(0,L.$uM),Be(1,f.$KM)],R);const p=1e5;function E(m,A){const P=[];if(m.length)for(let g=0;g<m.length;g++){let y=m[g];if(typeof y>"u")y="undefined";else if(y instanceof Error){const D=y;D.stack?y=D.stack:y=D.toString()}P.push(y)}if(A){const g=new Error().stack;g&&P.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,I.$_m)(P);return g.length>p?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Se[151],De([1,0,2,6,7,5,20,15,19,13,16,26]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;let y=class{static{g=this}static{this.c=0}static{this.d=250}constructor(w,u){this.h=u,this.f=new Map,this.g=w.getProxy(F.$tK.MainThreadDecorations)}registerFileDecorationProvider(w,u){const c=g.c++;this.f.set(c,{provider:w,extensionDescription:u}),this.g.$registerDecorationProvider(c,u.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(s=>{if(!s){this.g.$onDidChange(c,null);return}const r=(0,E.$2b)(s);if(r.length<=g.d){this.g.$onDidChange(c,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,r.length);const o=r.map(d=>({uri:d,rank:(0,m.$Ge)(d.path,"/")})),t=(0,E.$yb)(o,(d,l)=>d.rank-l.rank||(0,m.$Ue)(d.uri.path,l.uri.path)),n=[];e:for(const d of t){let l;for(const a of d){const h=(0,A.$lc)(a.uri.path);if(l!==h&&(l=h,n.push(a.uri)>=g.d))break e}}this.g.$onDidChange(c,n)});return new f.$vK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(w,u,c){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:s,extensionDescription:r}=this.f.get(w);return await Promise.all(u.map(async o=>{try{const{uri:t,id:n}=o,d=await Promise.resolve(s.provideFileDecoration(I.URI.revive(t),c));if(!d)return;try{f.$QL.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$lF)(r,"codiconDecoration"),i[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),i}};e.$Udc=y,e.$Udc=y=g=He([Be(0,R.$uM),Be(1,p.$0i)],y),e.$Vdc=(0,L.$Ph)("IExtHostDecorations")}),define(Se[315],De([1,0,211,135,2,6,7,14,4,15,28,57]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;class y{#e;#t;#i;constructor(u,c,i,s,r,o,t,n){this.d=u,this.e=c,this.f=i,this.g=s,this.h=r,this.c=!1,this.f=Math.max(s,i),this.#i=new A.$zc(d=>o.getComparisonKey(d)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,c){if(!u){this.clear();return}this.j();let i=[];if(f.URI.isUri(u)){if(!c){this.delete(u);return}this.#i.set(u,c.slice()),i=[u]}else if(Array.isArray(u)){i=[];let o;u=[...u].sort(y.k);for(const t of u){const[n,d]=t;if((!o||n.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=n,i.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(i),!this.#e)return;const s=[];let r=0;for(const o of i){let t=[];const n=this.#i.get(o);if(n)if(n.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const a of n)if(a.severity===d[l]&&t.push({...p.Diagnostic.from(a),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(d=>({...p.Diagnostic.from(d),modelVersionId:this.h(o)}));if(s.push([o,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,s)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,c){this.j();for(const[i,s]of this)u.call(c,i,s,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const c=this.#i.get(u);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,c){return u[0].toString()<c[0].toString()?-1:u[0].toString()>c[0].toString()?1:0}}e.$Lcc=y;let D=class{static{g=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*g.d}static _mapper(u){const c=new A.$zc;for(const i of u)c.set(i,i);return{uris:Object.freeze(Array.from(c.values()))}}constructor(u,c,i,s){this.j=c,this.k=i,this.l=s,this.g=new Map,this.h=new E.$Rd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,g._mapper),this.f=u.getProxy(L.$tK.MainThreadDiagnostics)}createDiagnosticCollection(u,c){const{g:i,f:s,h:r,j:o,k:t,l:n}=this,d=new class{$changeMany(h,S){s.$changeMany(h,S),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,h,S.length===0?"CLEARING":S)}$clear(h){s.$clear(h),o.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,h)}dispose(){s.dispose()}};let l;if(!c)c="_generated_diagnostic_collection_name_#"+g.c++,l=c;else if(!i.has(c))l=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do l=c+g.c++;while(i.has(l))}return new class extends y{constructor(){super(c,l,g.e,g.d,h=>n.getDocument(h)?.version,t.extUri,d,r),i.set(l,this)}dispose(){super.dispose(),i.delete(l)}}}getDiagnostics(u){if(u)return this.m(u);{const c=new Map,i=[];for(const s of this.g.values())s.forEach((r,o)=>{let t=c.get(r.toString());typeof t>"u"&&(t=i.length,c.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...o)});return i}}m(u){let c=[];for(const i of this.g.values())i.has(u)&&(c=c.concat(i.get(u)));return c}$acceptMarkersChange(u){if(!this.n){const c="_generated_mirror",i=new y(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,s=>{},this.k.extUri,void 0,this.h);this.g.set(c,i),this.n=i}for(const[c,i]of u)this.n.set(f.URI.revive(c),i.map(p.Diagnostic.to))}};e.$Mcc=D,e.$Mcc=D=g=He([Be(1,m.$0i),Be(2,P.$Kcc)],D)}),define(Se[316],De([1,0,2,6,26]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class L{constructor(p){this.a=p.getProxy(F.$tK.MainThreadDialogs)}showOpenDialog(p,E){return E?.allowUIResources&&(0,f.$lF)(p,"showLocal"),this.a.$showOpenDialog(E).then(m=>m?m.map(A=>I.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(E=>E?I.URI.revive(E):void 0)}}e.$2cc=L}),define(Se[317],De([1,0,9,2,7,6,18,21,13]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class m{static{this.a=0}constructor(P,g,y){this.d=g,this.e=y,this.b=new Map,this.c=P.getProxy(L.$tK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,g){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=m.a++;this.b.set(y,g),this.c.$registerTextContentProvider(y,P);let D;return typeof g.onDidChange=="function"&&(D=g.onDidChange(w=>{if(w.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(y,w).then(u=>{if(!u&&typeof u!="string")return;const c=this.d.getDocument(w);if(!c)return;const i=(0,E.$Pe)(u);if(!c.equalLines(i))return this.c.$onVirtualDocumentChange(w,u)},I.$Z)})),new f.$vK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(P,g){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(g),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.$3cc=m}),define(Se[318],De([1,0,4,3,2,6,143,14,17,24,7,9]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class g{constructor(D,w){this.a=new I.$Nd({onListenerError:P.$1}),this.b=new I.$Nd({onListenerError:P.$1}),this.c=new I.$Nd({onListenerError:P.$1}),this.d=new I.$Nd({onListenerError:P.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=D.getProxy(L.$tK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(u=>{for(const c of u)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const c of u)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const w=this.g.getDocument(D);if(w)return w}getDocument(D){const w=this.getDocumentData(D);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return w.document}ensureDocumentData(D){const w=this.g.getDocument(D);if(w)return Promise.resolve(w);let u=this.h.get(D.toString());return u||(u=this.f.$tryOpenDocument(D).then(c=>{this.h.delete(D.toString());const i=f.URI.revive(c);return(0,E.$Jf)(this.g.getDocument(i))},c=>(this.h.delete(D.toString()),Promise.reject(c))),this.h.set(D.toString(),u)),u}createDocumentData(D){return this.f.$tryCreateDocument(D).then(w=>f.URI.revive(w))}$acceptModelLanguageChanged(D,w){const u=f.URI.revive(D),c=this.g.getDocument(u);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(w),this.a.fire(c.document)}$acceptModelSaved(D){const w=f.URI.revive(D),u=this.g.getDocument(w);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(D,w){const u=f.URI.revive(D),c=this.g.getDocument(u);if(!c)throw new Error("unknown document");c._acceptIsDirty(w),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,w,u){const c=f.URI.revive(D),i=this.g.getDocument(c);if(!i)throw new Error("unknown document");i._acceptIsDirty(u),i.onEvents(w);let s;w.isUndoing?s=A.TextDocumentChangeReason.Undo:w.isRedoing&&(s=A.TextDocumentChangeReason.Redo),this.c.fire((0,m.$8m)({document:i.document,contentChanges:w.changes.map(r=>({range:p.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:s}))}setWordDefinitionFor(D,w){(0,R.$wM)(D,w)}}e.$Icc=g}),define(Se[70],De([1,0,60,4,3,2,5,6,143,20,150,14,15,28,18,51,47]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class c{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,o){this.h=r,this.i=o,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new F.$Nd,this.e=new F.$Nd,this.f=new F.$Nd,this.g=new F.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const o=[],t=[],n=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=L.URI.revive(d),a=this.c.get(l);a?.unref()&&(this.c.delete(l),o.push(a.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=L.URI.revive(d.uri);let a=this.c.get(l);if(a&&l.scheme!==D.Schemas.vscodeNotebookCell&&l.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new c(new E.$xM(this.h.getProxy(p.$tK.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(l,a),t.push(a.value)),a.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=L.URI.revive(d.documentUri);I.ok(this.c.has(l),`document '${l}' does not exist`),I.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const a=this.c.get(l).value,h=new A.$DM(d.id,this.h.getProxy(p.$tK.MainThreadTextEditors),this.i,new u.$U(()=>a.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(S=>P.Range.to(S)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(I.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,f.$Mc)(o),(0,f.$Mc)(n),r.removedDocuments&&this.e.fire(o),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return w.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const o=this.b.get(this.a);return r?o:o?.value}allEditors(){return[...this.b.values()]}};e.$EM=i,e.$EM=i=He([Be(0,m.$uM),Be(1,g.$0i)],i),e.$FM=(0,R.$Ph)("IExtHostDocumentsAndEditors")}),define(Se[71],De([1,0,14,6,2,4,5,7,20,17,74]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0,e.$Zdc=(0,R.$Ph)("IExtHostEditorTabs");class P{constructor(u,c,i){this.e=i,this.d=c,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,c={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new p.$aM(f.URI.revive(this.b.input.uri));case 2:return new p.$bM(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified));case 3:return new p.$cM(f.URI.revive(this.b.input.base),f.URI.revive(this.b.input.input1),f.URI.revive(this.b.input.input2),f.URI.revive(this.b.input.result));case 6:return new p.$dM(f.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new p.$eM(this.b.input.viewType);case 4:return new p.$fM(f.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new p.$gM(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new p.$hM;case 9:return new p.$iM(f.URI.revive(this.b.input.uri),f.URI.revive(this.b.input.inputBoxUri));default:return}}}class g{constructor(u,c){this.c=[],this.d="",this.b=u,this.e=c;for(const i of u.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,c={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return I.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(i=>i.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(i=>i.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const i=new P(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,i),u.tabDto.isActive&&(this.d=i.tabId),i}else if(u.kind===1){const i=this.c.splice(u.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(u.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,i),i}const c=this.c.find(i=>i.tabId===u.tabDto.id);if(!c)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(u.tabDto),c}activeTabId(){return this.d}}let y=class{constructor(u){this.b=new L.$Nd,this.c=new L.$Nd,this.e=[],this.a=u.getProxy(F.$tK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,c={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(i=>i.apiObject))},get activeTabGroup(){const i=u.d;return(0,m.$Jf)(u.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,s)=>{const r=Array.isArray(i)?i:[i];return r.length?D(r[0])?this.j(r,s):this.i(r,s):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(u){const c=new Set(this.e.map(d=>d.groupId)),i=new Set(u.map(d=>d.groupId)),s=(0,A.$K)(c,i),r=this.e.filter(d=>s.removed.includes(d.groupId)).map(d=>d.apiObject),o=[],t=[];this.e=u.map(d=>{const l=new g(d,()=>this.d);return s.added.includes(l.groupId)?o.push(l.apiObject):t.push(l.apiObject),l});const n=(0,m.$Jf)(u.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:o,closed:r,changed:t}))}$acceptTabGroupUpdate(u){const c=this.e.find(i=>i.groupId===u.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const c=this.e.find(s=>s.groupId===u.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const i=c.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(u){for(const c of this.e)for(const i of c.tabs)if(i.apiObject===u)return i}h(u){return this.e.find(c=>c.apiObject===u)}async i(u,c){const i=[];for(const s of u){const r=this.g(s);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,c)}async j(u,c){const i=[];for(const s of u){const r=this.h(s);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,c)}};e.$1dc=y,e.$1dc=y=He([Be(0,E.$uM)],y);function D(w){return w.tabs!==void 0}}),define(Se[319],De([1,0,6,7]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$tK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const m=this.a.get(R);if(!m)throw new Error("Embedding vector provider not found");const A=await m.provideEmbeddingVector(p,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,p,E){const m=this.b;return this.b++,this.a.set(m,E),this.c.$registerAiEmbeddingVectorProvider(p,m),new F.$vK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(m),this.a.delete(m)})}}e.$Mec=f}),define(Se[320],De([1,0,2,6,3,7,14,172,13,22,26,81]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class g{constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const u=this.a.indexOf(w);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),u=[];let c,i,s=14,r=14;for(const o of w){let t=c?(0,E.$4e)(c,o):0;for(t===0?i=1:i=r;t<o.length;t++)t+1===o.length?(s=r,r=9):r+=1,u.push([i,o.toUpperCase().charCodeAt(t),r]),u.push([i,o.toLowerCase().charCodeAt(t),r]),i=r;c=o,r=s}u.push([9,58,10]),u.push([10,47,12]),this.b=new p.$fZ(u)}}provideDocumentLinks(w){this.c();const u=[],c=p.$gZ.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of c){const s=R.DocumentLink.to(i);s.target&&u.push(s)}return u}}class y{constructor(w,u){this.i=u,this.b=new g,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(F.$tK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,u,c,i={}){if(y.j(c),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const s=this.h++;this.b.add(u),this.d.add(u),this.c.set(s,c);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof c.copy=="function"&&(r+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,A.$lF)(w,"fsChunks"),r+=4);let o;i.isReadonly&&(0,P.$5j)(i.isReadonly)&&((0,A.$lF)(w,"readonlyMessage"),o={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(s,u,r,o).catch(n=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${u}`),console.error(n)});const t=c.onDidChangeFile(n=>{const d=[];for(const l of n){const{uri:a,type:h}=l;if(a.scheme!==u)continue;let S;switch(h){case L.FileChangeType.Changed:S=0;break;case L.FileChangeType.Created:S=1;break;case L.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:a,type:S})}this.a.$onFileSystemChange(s,d)});return(0,f.$Pc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(s),this.a.$unregisterProvider(s)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:u,ctime:c,mtime:i,size:s,permissions:r}=w;return{type:u,ctime:c,mtime:i,size:s,permissions:r}}$stat(w,u){return Promise.resolve(this.l(w).stat(I.URI.revive(u))).then(c=>y.k(c))}$readdir(w,u){return Promise.resolve(this.l(w).readDirectory(I.URI.revive(u)))}$readFile(w,u){return Promise.resolve(this.l(w).readFile(I.URI.revive(u))).then(c=>m.$be.wrap(c))}$writeFile(w,u,c,i){return Promise.resolve(this.l(w).writeFile(I.URI.revive(u),c.buffer,i))}$delete(w,u,c){return Promise.resolve(this.l(w).delete(I.URI.revive(u),c))}$rename(w,u,c,i){return Promise.resolve(this.l(w).rename(I.URI.revive(u),I.URI.revive(c),i))}$copy(w,u,c,i){const s=this.l(w);if(!s.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(s.copy(I.URI.revive(u),I.URI.revive(c),i))}$mkdir(w,u){return Promise.resolve(this.l(w).createDirectory(I.URI.revive(u)))}$watch(w,u,c,i){const s=this.l(w).watch(I.URI.revive(c),i);this.f.set(u,s)}$unwatch(w,u){const c=this.f.get(u);c&&(c.dispose(),this.f.delete(u))}$open(w,u,c){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(u),c))}$close(w,u){const c=this.l(w);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(u))}$read(w,u,c,i){const s=this.l(w);if(!s.read)throw new Error('FileSystemProvider does not implement "read"');const r=m.$be.alloc(i);return Promise.resolve(s.read(u,c,r.buffer,0,i)).then(o=>r.slice(0,o))}$write(w,u,c,i){const s=this.l(w);if(!s.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(s.write(u,c,i.buffer,0,i.byteLength))}l(w){const u=this.c.get(w);if(!u){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return u}}e.$wdc=y}),define(Se[72],De([1,0,6,31,7,22,5,20,57,3,8,23,18]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;let D=y=class{constructor(u,c){this.b=new Map,this.c=new A.$3g,this.a=u.getProxy(I.$tK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(s){try{let r;const o=i.b.get(s.scheme);return o?(await i.a.$ensureActivation(s.scheme),r=await o.impl.stat(s)):r=await i.a.$stat(s),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===F.FilePermission.Readonly?1:void 0}}catch(r){y.e(r)}},async readDirectory(s){try{const r=i.b.get(s.scheme);return r?(await i.a.$ensureActivation(s.scheme),(await r.impl.readDirectory(s)).slice()):await i.a.$readdir(s)}catch(r){return y.e(r)}},async createDirectory(s){try{const r=i.b.get(s.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(s.scheme),await i.d(r.impl,r.extUri,s)):await i.a.$mkdir(s)}catch(r){return y.e(r)}},async readFile(s){try{const r=i.b.get(s.scheme);return r?(await i.a.$ensureActivation(s.scheme),(await r.impl.readFile(s)).slice()):(await i.a.$readFile(s)).buffer}catch(r){return y.e(r)}},async writeFile(s,r){try{const o=i.b.get(s.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(s.scheme),await i.d(o.impl,o.extUri,o.extUri.dirname(s)),await i.c.queueFor(s).queue(()=>Promise.resolve(o.impl.writeFile(s,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(s,L.$be.wrap(r))}catch(o){return y.e(o)}},async delete(s,r){try{const o=i.b.get(s.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(s.scheme),await o.impl.delete(s,{recursive:!1,...r})):await i.a.$delete(s,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(o){return y.e(o)}},async rename(s,r,o){try{return await i.a.$rename(s,r,{overwrite:!1,...o})}catch(t){return y.e(t)}},async copy(s,r,o){try{return await i.a.$copy(s,r,{overwrite:!1,...o})}catch(t){return y.e(t)}},isWritableFileSystem(s){const r=c.getCapabilities(s);if(typeof r=="number")return!(r&2048)}})}async d(u,c,i){const s=[];for(;!c.isEqual(i,c.dirname(i));)try{if(!((await u.stat(i)).type&F.FileType.Directory))throw f.$IL.FileExists(`Unable to create folder '${i.scheme===g.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(F.$ok(r)!==F.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(c.basename(i)),i=c.dirname(i)}for(let r=s.length-1;r>=0;r--){i=c.joinPath(i,s[r]);try{await u.createDirectory(i)}catch(o){if(F.$ok(o)!==F.FileSystemProviderErrorCode.FileExists)throw o}}}static e(u){if(u instanceof f.$IL)throw u;if(u instanceof F.$kk)switch(u.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$IL.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$IL.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$IL.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$IL.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$IL.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$IL.Unavailable(u.message);default:throw new f.$IL(u.message,u.name)}if(!(u instanceof Error))throw new f.$IL(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw f.$IL.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$IL.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$IL.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$IL.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$IL.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$IL.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$IL.Unavailable(u.message);default:throw new f.$IL(u.message,u.name)}}addFileSystemProvider(u,c,i){return this.b.set(u,{impl:c,extUri:i?.isCaseSensitive?P.$lg:P.$ng,isReadonly:!!i?.isReadonly}),(0,m.$Pc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??P.$lg}};e.$cdc=D,e.$cdc=D=y=He([Be(0,p.$uM),Be(1,E.$Kcc)],D),e.$ddc=(0,R.$Ph)("IExtHostConsumerFileSystem")}),define(Se[321],De([1,0,4,37,2,6,14,7,47]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class m{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,D,w,u,c,i){this.a=Math.random(),this.b=new I.$Nd,this.c=new I.$Nd,this.d=new I.$Nd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,F.$wj)(c),r=typeof c=="string",o=i?.correlate,t=u(n=>{if(!(typeof n.session=="number"&&n.session!==this.a)&&!(o&&typeof n.session>"u")){if(!i?.ignoreCreateEvents)for(const d of n.created){const l=f.URI.revive(d);s(l.fsPath)&&(!r||D.getWorkspaceFolder(l))&&this.b.fire(l)}if(!i?.ignoreChangeEvents)for(const d of n.changed){const l=f.URI.revive(d);s(l.fsPath)&&(!r||D.getWorkspaceFolder(l))&&this.c.fire(l)}if(!i?.ignoreDeleteEvents)for(const d of n.deleted){const l=f.URI.revive(d);s(l.fsPath)&&(!r||D.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=p.$vK.from(this.i(y,w,c,i,i?.correlate),this.b,this.c,this.d,t)}i(y,D,w,u,c){const i=p.$vK.from();if(typeof w=="string")return i;const s=y.getProxy(L.$tK.MainThreadFileSystemEventService);let r=!1;return(w.pattern.includes(F.$sj)||w.pattern.includes(F.$tj))&&(r=!0),s.$watch(D.identifier.value,this.a,w.baseUri,{recursive:r,excludes:u?.excludes??[]},!!c),p.$vK.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(f.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(f.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,D,w){this.j=y,this.k=D,this.l=w,this.a=new I.$Nd,this.b=new I.$Nd,this.c=new I.$Nd,this.d=new I.$Nd,this.g=new I.$Pd,this.h=new I.$Pd,this.i=new I.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,D,w,u){return new m(this.j,y,D,this.a.event,R.GlobPattern.from(w),u)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,D){switch(y){case 2:this.b.fire(Object.freeze({files:D.map(w=>({oldUri:f.URI.revive(w.source),newUri:f.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(w=>f.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(w=>f.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,D){return(w,u,c)=>{const i=function(r){w.call(u,r)};return i.extension=y,D.event(i,void 0,c)}}async $onWillRunFileOperation(y,D,w,u){switch(y){case 2:return await this.n(this.g,{files:D.map(c=>({oldUri:f.URI.revive(c.source),newUri:f.URI.revive(c.target)}))},w,u);case 1:return await this.n(this.i,{files:D.map(c=>f.URI.revive(c.target))},w,u);case 0:case 3:return await this.n(this.h,{files:D.map(c=>f.URI.revive(c.target))},w,u)}}async n(y,D,w,u){const c=new Set,i=[];if(await y.fireAsync(D,u,async(r,o)=>{const t=Date.now(),n=await Promise.resolve(r);n instanceof p.$FK&&(i.push([o.extension,n]),c.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",o.extension.identifier)}),u.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,r]of i){const{edits:o}=R.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(c)}}}e.$xdc=P}),define(Se[322],De([1,0,3,2,6,14,7,34,8]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class m{static{this.a=0}constructor(y,D){this.extension=y,this.provider=D,this.handle=m.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,D,w,u){this.f=w,this.g=u,this.b=new Map,this.d=new Map,this.e=y.getProxy(f.$tK.MainThreadInlineChat),D.registerApiCommand(new p.$UM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$SM("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?L.Range.from(c.initialRange):void 0,initialSelection:c.initialSelection?L.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?L.Position.from(c.position):void 0}})],p.$TM.Void))}registerProvider(y,D,w){const u=new m(y,D);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,w.label,y.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,I.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(y,D,w,u){const c=this.b.get(y);if(!c){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(D)),s=L.Selection.to(w),r=await c.provider.prepareInteractiveEditorSession({document:i,selection:s},u);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=P.a++;return this.d.set(o,new A(r)),{id:o,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(r.wholeRange),message:r.message}}async $provideResponse(y,D,w,u){const c=this.b.get(y);if(!c)return;const i=this.d.get(D.id);if(!i)return;const s={prompt:w.prompt,selection:L.Selection.to(w.selection),wholeRange:L.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let r=!1;const o={report:async h=>{if(!w.live&&h.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||u.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:h.message,edits:h.edits?.map(L.TextEdit.from),editsShouldBeInstant:h.editsShouldBeInstant,slashCommand:h.slashCommand?.command,markdownFragment:R.$VK.isMarkdownString(h.content)?h.content.value:h.content})}},t=Promise.resolve(c.provider.provideInteractiveEditorResponse(i.session,s,o,u));let n;try{n=await(0,E.$Ig)(t,u)}finally{r=!0}if(!n)return;const d=i.responses.push(n)-1,l={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(P.h(n))return{...l,id:d,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:a}=n;return a instanceof R.$FK?{...l,id:d,type:"bulkEdit",edits:L.WorkspaceEdit.from(a)}:{...l,id:d,type:"editorEdit",edits:a.map(L.TextEdit.from)}}$handleFeedback(y,D,w,u){const c=this.b.get(y),i=this.d.get(D),s=i?.responses[w];if(c&&s){const r=L.InteractiveEditorResponseFeedbackKind.to(u);c.provider.handleInteractiveEditorResponseFeedback?.(i.session,s,r)}}$releaseSession(y,D){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$Eec=P}),define(Se[323],De([1,0,2,34]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class f{constructor(R,p,E,m,A){this.a=p,this.b=E,this.c=m;const P=new F.$UM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$SM("showOptions","Show Options",g=>!0,g=>g),new F.$SM("resource","Interactive resource Uri",g=>!0,g=>g),new F.$SM("controllerId","Notebook controller Id",g=>!0,g=>g),new F.$SM("title","Interactive editor title",g=>!0,g=>g)],new F.$TM("Notebook and input URI",g=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const y=this.a.getEditorById(g.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:I.URI.revive(g.notebookUri),inputUri:I.URI.revive(g.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:I.URI.revive(g.notebookUri),inputUri:I.URI.revive(g.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(R,p,E,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Aec=f}),define(Se[324],De([1,0,6,7]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;class f{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(I.$tK.MainThreadIssueReporter)}async $getIssueReporterUri(R,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const m=await E.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}async $getIssueReporterData(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const m=await E.provideIssueData(p);if(!m)throw new Error("Issue data provider returned no result");return m}async $getIssueReporterTemplate(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const m=await E.provideIssueTemplate(p);if(!m)throw new Error("Issue template provider returned no result");return m}registerIssueUriRequestHandler(R,p){const E=R.identifier.value;return this.a.set(E,p),this.c.$registerIssueUriRequestHandler(E),new F.$vK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(R,p){const E=R.identifier.value;return this.b.set(E,p),this.c.$registerIssueDataProvider(E),new F.$vK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$Gec=f}),define(Se[325],De([1,0,3,6]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class f{constructor(R){this.b=0,this.a=R.getProxy(F.$tK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,I.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Tdc=f}),define(Se[326],De([1,0,2,24,14,7,84,6,13,29,19,17,168,21,25,3,131,121,109,36,9,8,26,213]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;class d{constructor(B,J){this.d=B,this.e=J}async provideDocumentSymbols(B,J){const se=this.d.getDocument(B),oe=await this.e.provideDocumentSymbols(se,J);if(!(0,A.$Jb)(oe))return oe[0]instanceof L.$NK?oe.map(f.DocumentSymbol.from):d.f(oe)}static f(B){B=B.slice(0).sort((oe,Y)=>{let me=oe.location.range.start.compareTo(Y.location.range.start);return me===0&&(me=Y.location.range.end.compareTo(oe.location.range.end)),me});const J=[],se=[];for(const oe of B){const Y={name:oe.name||"!!MISSING: name!!",kind:f.SymbolKind.from(oe.kind),tags:oe.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:f.Range.from(oe.location.range),selectionRange:f.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(Y),J.push(Y);break}const me=se[se.length-1];if(m.$ws.containsRange(me.range,Y.range)&&!m.$ws.equalsRange(me.range,Y.range)){me.children?.push(Y),se.push(Y);break}se.pop()}}return J}}class l{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,J,se){this.g=B,this.h=J,this.j=se,this.e=new i.$Hcc("CodeLens"),this.f=new Map}async provideCodeLenses(B,J){const se=this.g.getDocument(B),oe=await this.j.provideCodeLenses(se,J);if(!oe||J.isCancellationRequested)return;const Y=this.e.add(oe),me=new w.$Qc;this.f.set(Y,me);const Ee={cacheId:Y,lenses:[]};for(let je=0;je<oe.length;je++)Ee.lenses.push({cacheId:[Y,je],range:f.Range.from(oe[je].range),command:this.h.toInternal(oe[je].command,me)});return Ee}async resolveCodeLens(B,J){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,J),oe||(oe=se),J.isCancellationRequested)return;const Y=B.cacheId&&this.f.get(B.cacheId[0]);if(Y)return B.command=this.h.toInternal(oe.command??l.d,Y),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function a(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class h{constructor(B,J){this.d=B,this.e=J}async provideDefinition(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideDefinition(oe,Y,se);return a(me)}}class S{constructor(B,J){this.d=B,this.e=J}async provideDeclaration(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideDeclaration(oe,Y,se);return a(me)}}class k{constructor(B,J){this.d=B,this.e=J}async provideImplementation(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideImplementation(oe,Y,se);return a(me)}}class ${constructor(B,J){this.d=B,this.e=J}async provideTypeDefinition(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideTypeDefinition(oe,Y,se);return a(me)}}class b{constructor(B,J){this.d=B,this.e=J}async provideHover(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideHover(oe,Y,se);if(!(!me||(0,A.$Jb)(me.contents)))return me.range||(me.range=oe.getWordRangeAtPosition(Y)),me.range||(me.range=new L.$xK(Y,Y)),f.Hover.from(me)}}class v{constructor(B,J){this.d=B,this.e=J}async provideEvaluatableExpression(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideEvaluatableExpression(oe,Y,se);if(me)return f.EvaluatableExpression.from(me)}}class C{constructor(B,J){this.d=B,this.e=J}async provideInlineValues(B,J,se,oe){const Y=this.d.getDocument(B),me=await this.e.provideInlineValues(Y,f.Range.to(J),f.InlineValueContext.to(se),oe);if(Array.isArray(me))return me.map(Ee=>f.InlineValue.from(Ee))}}class N{constructor(B,J){this.d=B,this.e=J}async provideDocumentHighlights(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideDocumentHighlights(oe,Y,se);if(Array.isArray(me))return me.map(f.DocumentHighlight.from)}}class T{constructor(B,J){this.d=B,this.e=J}async provideLinkedEditingRanges(B,J,se){const oe=this.d.getDocument(B),Y=f.Position.to(J),me=await this.e.provideLinkedEditingRanges(oe,Y,se);if(me&&Array.isArray(me.ranges))return{ranges:(0,A.$Gb)(me.ranges.map(f.Range.from)),wordPattern:me.wordPattern}}}class M{constructor(B,J){this.d=B,this.e=J}async provideReferences(B,J,se,oe){const Y=this.d.getDocument(B),me=f.Position.to(J),Ee=await this.e.provideReferences(Y,me,se,oe);if(Array.isArray(Ee))return Ee.map(f.location.from)}}class U{static{this.d=1e3}constructor(B,J,se,oe,Y,me,Ee){this.g=B,this.h=J,this.j=se,this.k=oe,this.l=Y,this.m=me,this.n=Ee,this.e=new i.$Hcc("CodeAction"),this.f=new Map}async provideCodeActions(B,J,se,oe){const Y=this.g.getDocument(B),me=g.$ys.isISelection(J)?f.Selection.to(J):f.Range.to(J),Ee=[];for(const tt of this.j.getDiagnostics(B))if(me.intersection(tt.range)&&Ee.push(tt)>U.d)break;const je={diagnostics:Ee,only:se.only?new L.$PK(se.only):void 0,triggerKind:f.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(Y,me,je,oe);if(!(0,A.$Kb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Xe=new w.$Qc;this.f.set(_e,Xe);const it=[];for(let tt=0;tt<We.length;tt++){const Ae=We[tt];Ae&&(U.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Xe)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,tt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Xe),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$kF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,J){const[se,oe]=B,Y=this.e.get(se,oe);if(!Y||U.o(Y))return{};if(!this.k.resolveCodeAction)return{};const me=await this.k.resolveCodeAction(Y,J)??Y;let Ee;me.edit&&(Ee=f.WorkspaceEdit.from(me.edit,void 0));let je;if(me.command){const We=this.f.get(se);We&&(je=this.h.toInternal(me.command,We))}return{edit:Ee,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,se,oe,Y){this.d=B,this.e=J,this.f=se,this.g=oe,this.h=Y}async prepareDocumentPaste(B,J,se,oe){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(B),me=J.map(We=>f.Range.to(We)),Ee=f.DataTransfer.toDataTransfer(se,()=>{throw new r.$0});if(await this.f.prepareDocumentPaste(Y,me,Ee,oe),oe.isCancellationRequested)return;const je=Array.from(Ee).filter(([,We])=>!(We instanceof L.$jL));return f.DataTransfer.from(je)}async providePasteEdits(B,J,se,oe,Y){if(!this.f.provideDocumentPasteEdits)return;const me=this.e.getDocument(J),Ee=se.map(_e=>f.Range.to(_e)),je=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(me,Ee,je,Y);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:j.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,J){this.d=B,this.e=J}async provideDocumentFormattingEdits(B,J,se){const oe=this.d.getDocument(B),Y=await this.e.provideDocumentFormattingEdits(oe,J,se);if(Array.isArray(Y))return Y.map(f.TextEdit.from)}}class V{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeFormattingEdits(B,J,se,oe){const Y=this.d.getDocument(B),me=f.Range.to(J),Ee=await this.e.provideDocumentRangeFormattingEdits(Y,me,se,oe);if(Array.isArray(Ee))return Ee.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,J,se,oe){(0,P.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(B),me=J.map(f.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Y,me,se,oe);if(Array.isArray(Ee))return Ee.map(f.TextEdit.from)}}class q{constructor(B,J){this.d=B,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,J,se,oe,Y){const me=this.d.getDocument(B),Ee=f.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(me,Ee,se,oe,Y);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class de{constructor(B,J){this.e=B,this.f=J,this.d=new i.$Hcc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,J){const se=await this.e.provideWorkspaceSymbols(B,J);if(!(0,A.$Kb)(se))return{symbols:[]};const oe=this.d.add(se),Y={cacheId:oe,symbols:[]};for(let me=0;me<se.length;me++){const Ee=se[me];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Y.symbols.push({...f.WorkspaceSymbol.from(Ee),cacheId:[oe,me]})}return Y}async resolveWorkspaceSymbol(B,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,J);return oe&&(0,F.$0m)(B,f.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class x{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,J,se){this.d=B,this.e=J,this.f=se}async provideRenameEdits(B,J,se,oe){const Y=this.d.getDocument(B),me=f.Position.to(J);try{const Ee=await this.e.provideRenameEdits(Y,me,se,oe);return Ee?f.WorkspaceEdit.from(Ee):void 0}catch(Ee){const je=x.g(Ee);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(B,J,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(B),Y=f.Position.to(J);try{const me=await this.e.prepareRename(oe,Y,se);let Ee,je;if(L.$xK.isRange(me)?(Ee=me,je=oe.getText(me)):(0,P.$Af)(me)&&(Ee=me.range,je=me.placeholder),!Ee||!je)return;if(Ee.start.line>Y.line||Ee.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Ee),text:je}}catch(me){const Ee=x.g(me);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(me)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,J){this.resultId=B,this.tokens=J}}class G{constructor(B,J){this.f=B,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,J,se){const oe=this.f.getDocument(B),Y=J!==0?this.d.get(J):null;let me=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Y.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return Y&&this.d.delete(J),me?(me=G.h(me),this.o(G.n(Y,me),me)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return G.j(B)?G.k(B)?B:new L.$ML(new Uint32Array(B.data),B.resultId):G.l(B)?G.m(B)?B:new L.$OL(B.edits.map(J=>new L.$NL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const J of B.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(B,J){if(!G.j(J)||!B||!B.tokens)return J;const se=B.tokens,oe=se.length,Y=J.data,me=Y.length;let Ee=0;const je=Math.min(oe,me);for(;Ee<je&&se[Ee]===Y[Ee];)Ee++;if(Ee===oe&&Ee===me)return new L.$OL([],J.resultId);let We=0;const _e=je-Ee;for(;We<_e&&se[oe-We-1]===Y[me-We-1];)We++;return new L.$OL([{start:Ee,deleteCount:oe-Ee-We,data:Y.subarray(Ee,me-We)}],J.resultId)}o(B,J){if(G.j(B)){const se=this.e++;return this.d.set(se,new Q(B.resultId,B.data)),(0,u.$b$)({id:se,type:"full",data:B.data})}if(G.l(B)){const se=this.e++;return G.j(J)?this.d.set(se,new Q(J.resultId,J.data)):this.d.set(se,new Q(B.resultId)),(0,u.$b$)({id:se,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ce{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeSemanticTokens(B,J,se){const oe=this.d.getDocument(B),Y=await this.e.provideDocumentRangeSemanticTokens(oe,f.Range.to(J),se);return Y?this.f(Y):null}f(B){return(0,u.$b$)({id:0,type:"full",data:B.data})}}class ie{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,J,se,oe,Y){this.f=B,this.g=J,this.h=se,this.j=oe,this.k=Y,this.d=new i.$Hcc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,J,se,oe){const Y=this.f.getDocument(B),me=f.Position.to(J),Ee=Y.getWordRangeAtPosition(me)||new L.$xK(me,me),je=Ee.with({end:me}),We=new s.$Jd,_e=await this.h.provideCompletionItems(Y,me,oe,f.CompletionContext.to(se));if(!_e||oe.isCancellationRequested)return;const Xe=Array.isArray(_e)?new L.$3K(_e):_e,it=ie.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),tt=new w.$Qc;this.e.set(it,tt);const Ae=[],Ne={x:it,b:Ae,a:{replace:f.Range.from(Ee),insert:f.Range.from(je)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Xe.items.length;qe++){const Re=Xe.items[qe],Ze=this.l(Re,[it,qe],je,Ee);Ae.push(Ze)}return Ne}async resolveCompletionItem(B,J){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const oe=this.l(se,B),Y=await this.h.resolveCompletionItem(se,J);if(!Y)return;const me=this.l(Y,B);return(oe.h!==me.h||oe.i!==me.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==me.n||oe.o!==me.o||!(0,F.$$m)(oe.p,me.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:me.d,c:me.c,l:me.l,h:me.h,i:me.i,n:me.n,o:me.o,p:me.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J,se,oe){const Y=this.e.get(J[0]);if(!Y)throw Error("DisposableStore is missing...");const me=this.g.toInternal(B.command,Y),Ee={x:J,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:me?.$ident,o:me?.id,p:me?.$ident?void 0:me?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=B.textEdit.newText):typeof B.insertText=="string"?Ee.h=B.insertText:B.insertText instanceof L.$GK&&(Ee.h=B.insertText.value,Ee.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$xK.isRange(je)?Ee.j=f.Range.from(je):je&&(!se?.isEqual(je.inserting)||!oe?.isEqual(je.replacing))&&(Ee.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),Ee}}class ae{async provideInlineCompletions(B,J,se,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,J,se){}handlePartialAccept(B,J,se){}}class ye extends ae{constructor(B,J,se,oe){super(),this.f=B,this.g=J,this.h=se,this.j=oe,this.d=new H,this.e=(0,t.$kF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$kF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,J,se,oe){const Y=this.g.getDocument(B),me=f.Position.to(J),Ee=await this.h.provideInlineCompletionItems(Y,me,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:f.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!Ee||oe.isCancellationRequested)return;const je=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:je}),items:je.map((tt,Ae)=>{let Ne;tt.command&&(Xe||(Xe=new w.$Qc),Ne=this.j.toInternal(tt.command,Xe));const qe=tt.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:tt.filterText,range:tt.range?f.Range.from(tt.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Xe||(Xe=new w.$Qc),this.j.toInternal(tt,Xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,J,se){const oe=this.d.get(B)?.items[J];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(B,J,se){const oe=this.d.get(B)?.items[J];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const J=this.e++;return this.d.set(J,B),J}disposeReferenceId(B){const J=this.d.get(B);return this.d.delete(B),J}get(B){return this.d.get(B)}}class z{constructor(B,J){this.e=B,this.f=J,this.d=new i.$Hcc("SignatureHelp")}async provideSignatureHelp(B,J,se,oe){const Y=this.e.getDocument(B),me=f.Position.to(J),Ee=this.g(se),je=await this.f.provideSignatureHelp(Y,me,oe,Ee);if(je){const We=this.d.add([je]);return{...f.SignatureHelp.from(je),id:We}}}g(B){let J;if(B.activeSignatureHelp){const se=f.SignatureHelp.to(B.activeSignatureHelp),oe=this.d.get(B.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=se.activeSignature,J.activeParameter=se.activeParameter):J=se}return{...B,activeSignatureHelp:J}}releaseSignatureHelp(B){this.d.delete(B)}}class X{constructor(B,J,se,oe,Y){this.f=B,this.g=J,this.h=se,this.j=oe,this.k=Y,this.d=new i.$Hcc("InlayHints"),this.e=new Map}async provideInlayHints(B,J,se){const oe=this.f.getDocument(B),Y=f.Range.to(J),me=await this.h.provideInlayHints(oe,Y,se);if(!Array.isArray(me)||me.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(se.isCancellationRequested)return;const Ee=this.d.add(me);this.e.set(Ee,new w.$Qc);const je={hints:[],cacheId:Ee};for(let We=0;We<me.length;We++)this.l(me[We],Y)&&je.hints.push(this.m(me[We],[Ee,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),je}async resolveInlayHint(B,J){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.h.resolveInlayHint(se,J);if(oe&&this.l(oe))return this.m(oe,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(J&&!J.contains(B.position))}m(B,J){const se=this.e.get(J[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:J,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(Y=>{const me={label:Y.value};return me.tooltip=f.MarkdownString.fromStrict(Y.tooltip),L.$HK.isLocation(Y.location)&&(me.location=f.location.from(Y.location)),Y.command&&(me.command=this.g.toInternal(Y.command,se)),me}),oe}}class re{constructor(B,J){this.e=B,this.f=J,this.d=new i.$Hcc("DocumentLink")}async provideLinks(B,J){const se=this.e.getDocument(B),oe=await this.f.provideDocumentLinks(se,J);if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(re.g).map(f.DocumentLink.from)};{const Y=this.d.add(oe),me={links:[],cacheId:Y};for(let Ee=0;Ee<oe.length;Ee++){if(!re.g(oe[Ee]))continue;const je=f.DocumentLink.from(oe[Ee]);je.cacheId=[Y,Ee],me.links.push(je)}return me}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,J){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.f.resolveDocumentLink(se,J);if(!(!oe||!re.g(oe)))return f.DocumentLink.from(oe)}releaseLinks(B){this.d.delete(B)}}class Z{constructor(B,J){this.d=B,this.e=J}async provideColors(B,J){const se=this.d.getDocument(B),oe=await this.e.provideDocumentColors(se,J);return Array.isArray(oe)?oe.map(me=>({color:f.Color.from(me.color),range:f.Range.from(me.range)})):[]}async provideColorPresentations(B,J,se){const oe=this.d.getDocument(B),Y=f.Range.to(J.range),me=f.Color.to(J.color),Ee=await this.e.provideColorPresentations(me,{document:oe,range:Y},se);if(Array.isArray(Ee))return Ee.map(f.ColorPresentation.from)}}class ee{constructor(B,J){this.d=B,this.e=J}async provideFoldingRanges(B,J,se){const oe=this.d.getDocument(B),Y=await this.e.provideFoldingRanges(oe,J,se);if(Array.isArray(Y))return Y.map(f.FoldingRange.from)}}class _{constructor(B,J,se){this.d=B,this.e=J,this.f=se}async provideSelectionRanges(B,J,se){const oe=this.d.getDocument(B),Y=J.map(f.Position.to),me=await this.e.provideSelectionRanges(oe,Y,se);if(!(0,A.$Kb)(me))return[];if(me.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let je=0;je<Y.length;je++){const We=[];Ee.push(We);let _e=Y[je],Xe=me[je];for(;;){if(!Xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Xe)),!Xe.parent)break;_e=Xe.range,Xe=Xe.parent}}return Ee}}class we{constructor(B,J){this.f=B,this.g=J,this.d=new c.$zM(""),this.e=new Map}async prepareSession(B,J,se){const oe=this.f.getDocument(B),Y=f.Position.to(J),me=await this.g.prepareCallHierarchy(oe,Y,se);if(!me)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(me)?me.map(je=>this.h(Ee,je)):[this.h(Ee,me)]}async provideCallsTo(B,J,se){const oe=this.j(B,J);if(!oe)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(Y)return Y.map(me=>({from:this.h(B,me.from),fromRanges:me.fromRanges.map(Ee=>f.Range.from(Ee))}))}async provideCallsFrom(B,J,se){const oe=this.j(B,J);if(!oe)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(Y)return Y.map(me=>({to:this.h(B,me.to),fromRanges:me.fromRanges.map(Ee=>f.Range.from(Ee))}))}releaseSession(B){this.e.delete(B)}h(B,J){const se=this.e.get(B),oe=f.CallHierarchyItem.from(J,B,se.size.toString(36));return se.set(oe._itemId,J),oe}j(B,J){return this.e.get(B)?.get(J)}}class ue{constructor(B,J){this.f=B,this.g=J,this.d=new c.$zM(""),this.e=new Map}async prepareSession(B,J,se){const oe=this.f.getDocument(B),Y=f.Position.to(J),me=await this.g.prepareTypeHierarchy(oe,Y,se);if(!me)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(me)?me.map(je=>this.h(Ee,je)):[this.h(Ee,me)]}async provideSupertypes(B,J,se){const oe=this.j(B,J);if(!oe)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(oe,se);if(Y)return Y.map(me=>this.h(B,me))}async provideSubtypes(B,J,se){const oe=this.j(B,J);if(!oe)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(oe,se);if(Y)return Y.map(me=>this.h(B,me))}releaseSession(B){this.e.delete(B)}h(B,J){const se=this.e.get(B),oe=f.TypeHierarchyItem.from(J,B,se.size.toString(36));return se.set(oe._itemId,J),oe}j(B,J){return this.e.get(B)?.get(J)}}class ge{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,se,oe,Y){this.d=B,this.e=J,this.f=se,this.g=oe,this.h=Y}async provideDocumentOnDropEdits(B,J,se,oe,Y){const me=this.e.getDocument(J),Ee=f.Position.to(se),je=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(me,Ee,je,Y);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:ge.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,J){this.d=B,this.e=J}async provideMappedEdits(B,J,se,oe){const Y=I.URI.revive(B),me=this.d.getDocument(Y),Ee=se.documents.map(_e=>_e.map(Xe=>({uri:I.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(it=>f.Range.to(it))}))),je={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(me,J,je,oe);return We?f.WorkspaceEdit.from(We):null}}class fe{constructor(B,J){this.adapter=B,this.extension=J}}class be{static{this.d=0}constructor(B,J,se,oe,Y,me,Ee,je){this.g=J,this.h=se,this.j=oe,this.k=Y,this.l=me,this.m=Ee,this.n=je,this.f=new Map,this.e=B.getProxy(p.$tK.MainThreadLanguageFeatures)}o(B,J){return f.DocumentSelector.from(B,this.g,J)}p(B){return new L.$vK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async s(B,J,se,oe,Y,me=!1){const Ee=this.f.get(B);if(!Ee||!(Ee.adapter instanceof J))return oe;const je=Date.now();me||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(_e=>{(0,r.$3)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{me||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(Y)?(0,o.$Jg)(We,Y):We}t(B,J){const se=this.q();return this.f.set(se,new fe(B,J)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,J,se,oe){const Y=this.t(new d(this.h,se),B),me=oe&&oe.label||be.u(B);return this.e.$registerDocumentSymbolProvider(Y,this.o(J,B),me),this.p(Y)}$provideDocumentSymbols(B,J,se){return this.s(B,d,oe=>oe.provideDocumentSymbols(I.URI.revive(J),se),void 0,se)}registerCodeLensProvider(B,J,se){const oe=this.q(),Y=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new fe(new l(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(oe,this.o(J,B),Y);let me=this.p(oe);if(Y!==void 0){const Ee=se.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Y));me=L.$vK.from(me,Ee)}return me}$provideCodeLenses(B,J,se){return this.s(B,l,oe=>oe.provideCodeLenses(I.URI.revive(J),se),void 0,se)}$resolveCodeLens(B,J,se){return this.s(B,l,oe=>oe.resolveCodeLens(J,se),void 0,void 0)}$releaseCodeLenses(B,J){this.s(B,l,se=>Promise.resolve(se.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(B,J,se){const oe=this.t(new h(this.h,se),B);return this.e.$registerDefinitionSupport(oe,this.o(J,B)),this.p(oe)}$provideDefinition(B,J,se,oe){return this.s(B,h,Y=>Y.provideDefinition(I.URI.revive(J),se,oe),[],oe)}registerDeclarationProvider(B,J,se){const oe=this.t(new S(this.h,se),B);return this.e.$registerDeclarationSupport(oe,this.o(J,B)),this.p(oe)}$provideDeclaration(B,J,se,oe){return this.s(B,S,Y=>Y.provideDeclaration(I.URI.revive(J),se,oe),[],oe)}registerImplementationProvider(B,J,se){const oe=this.t(new k(this.h,se),B);return this.e.$registerImplementationSupport(oe,this.o(J,B)),this.p(oe)}$provideImplementation(B,J,se,oe){return this.s(B,k,Y=>Y.provideImplementation(I.URI.revive(J),se,oe),[],oe)}registerTypeDefinitionProvider(B,J,se){const oe=this.t(new $(this.h,se),B);return this.e.$registerTypeDefinitionSupport(oe,this.o(J,B)),this.p(oe)}$provideTypeDefinition(B,J,se,oe){return this.s(B,$,Y=>Y.provideTypeDefinition(I.URI.revive(J),se,oe),[],oe)}registerHoverProvider(B,J,se,oe){const Y=this.t(new b(this.h,se),B);return this.e.$registerHoverProvider(Y,this.o(J,B)),this.p(Y)}$provideHover(B,J,se,oe){return this.s(B,b,Y=>Y.provideHover(I.URI.revive(J),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,J,se,oe){const Y=this.t(new v(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(J,B)),this.p(Y)}$provideEvaluatableExpression(B,J,se,oe){return this.s(B,v,Y=>Y.provideEvaluatableExpression(I.URI.revive(J),se,oe),void 0,oe)}registerInlineValuesProvider(B,J,se,oe){const Y=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,me=this.t(new C(this.h,se),B);this.e.$registerInlineValuesProvider(me,this.o(J,B),Y);let Ee=this.p(me);if(Y!==void 0){const je=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Y));Ee=L.$vK.from(Ee,je)}return Ee}$provideInlineValues(B,J,se,oe,Y){return this.s(B,C,me=>me.provideInlineValues(I.URI.revive(J),se,oe,Y),void 0,Y)}registerDocumentHighlightProvider(B,J,se){const oe=this.t(new N(this.h,se),B);return this.e.$registerDocumentHighlightProvider(oe,this.o(J,B)),this.p(oe)}$provideDocumentHighlights(B,J,se,oe){return this.s(B,N,Y=>Y.provideDocumentHighlights(I.URI.revive(J),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,J,se){const oe=this.t(new T(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(J,B)),this.p(oe)}$provideLinkedEditingRanges(B,J,se,oe){return this.s(B,T,async Y=>{const me=await Y.provideLinkedEditingRanges(I.URI.revive(J),se,oe);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?be.w(me.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,J,se){const oe=this.t(new M(this.h,se),B);return this.e.$registerReferenceSupport(oe,this.o(J,B)),this.p(oe)}$provideReferences(B,J,se,oe,Y){return this.s(B,M,me=>me.provideReferences(I.URI.revive(J),se,oe,Y),void 0,Y)}registerCodeActionProvider(B,J,se,oe){const Y=new w.$Qc,me=this.t(new U(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(me,this.o(J,B),{providedKinds:oe?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:oe?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Y)}))},be.u(B),!!se.resolveCodeAction),Y.add(this.p(me)),Y}$provideCodeActions(B,J,se,oe,Y){return this.s(B,U,me=>me.provideCodeActions(I.URI.revive(J),se,oe,Y),void 0,Y)}$resolveCodeAction(B,J,se){return this.s(B,U,oe=>oe.resolveCodeAction(J,se),{},void 0)}$releaseCodeActions(B,J){this.s(B,U,se=>Promise.resolve(se.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(B,J,se){const oe=this.t(new O(this.h,se),B);return this.e.$registerDocumentFormattingSupport(oe,this.o(J,B),B.identifier,B.displayName||B.name),this.p(oe)}$provideDocumentFormattingEdits(B,J,se,oe){return this.s(B,O,Y=>Y.provideDocumentFormattingEdits(I.URI.revive(J),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,J,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",Y=this.t(new V(this.h,se),B);return this.e.$registerRangeFormattingSupport(Y,this.o(J,B),B.identifier,B.displayName||B.name,oe),this.p(Y)}$provideDocumentRangeFormattingEdits(B,J,se,oe,Y){return this.s(B,V,me=>me.provideDocumentRangeFormattingEdits(I.URI.revive(J),se,oe,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,J,se,oe,Y){return this.s(B,V,me=>me.provideDocumentRangesFormattingEdits(I.URI.revive(J),se,oe,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,J,se,oe){const Y=this.t(new q(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(Y,this.o(J,B),oe,B.identifier),this.p(Y)}$provideOnTypeFormattingEdits(B,J,se,oe,Y,me){return this.s(B,q,Ee=>Ee.provideOnTypeFormattingEdits(I.URI.revive(J),se,oe,Y,me),void 0,me)}registerWorkspaceSymbolProvider(B,J){const se=this.t(new de(J,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof J.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,J,se){return this.s(B,de,oe=>oe.provideWorkspaceSymbols(J,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,J,se){return this.s(B,de,oe=>oe.resolveWorkspaceSymbol(J,se),void 0,void 0)}$releaseWorkspaceSymbols(B,J){this.s(B,de,se=>se.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(B,J,se){const oe=this.t(new x(this.h,se,this.l),B);return this.e.$registerRenameSupport(oe,this.o(J,B),x.supportsResolving(se)),this.p(oe)}$provideRenameEdits(B,J,se,oe,Y){return this.s(B,x,me=>me.provideRenameEdits(I.URI.revive(J),se,oe,Y),void 0,Y)}$resolveRenameLocation(B,J,se,oe){return this.s(B,x,Y=>Y.resolveRenameLocation(I.URI.revive(J),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,J,se,oe){const Y=this.t(new G(this.h,se),B),me=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(J,B),oe,me);let Ee=this.p(Y);if(me){const je=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(me));Ee=L.$vK.from(Ee,je)}return Ee}$provideDocumentSemanticTokens(B,J,se,oe){return this.s(B,G,Y=>Y.provideDocumentSemanticTokens(I.URI.revive(J),se,oe),null,oe)}$releaseDocumentSemanticTokens(B,J){this.s(B,G,se=>se.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,J,se,oe){const Y=this.t(new ce(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(J,B),oe),this.p(Y)}$provideDocumentRangeSemanticTokens(B,J,se,oe){return this.s(B,ce,Y=>Y.provideDocumentRangeSemanticTokens(I.URI.revive(J),se,oe),null,oe)}registerCompletionItemProvider(B,J,se,oe){const Y=this.t(new ie(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(Y,this.o(J,B),oe,ie.supportsResolving(se),B.identifier),this.p(Y)}$provideCompletionItems(B,J,se,oe,Y){return this.s(B,ie,me=>me.provideCompletionItems(I.URI.revive(J),se,oe,Y),void 0,Y)}$resolveCompletionItem(B,J,se){return this.s(B,ie,oe=>oe.resolveCompletionItem(J,se),void 0,se)}$releaseCompletionItems(B,J){this.s(B,ie,se=>se.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(B,J,se,oe){const Y=new ye(B,this.h,se,this.j.converter),me=this.t(Y,B);return this.e.$registerInlineCompletionsSupport(me,this.o(J,B),Y.supportsHandleEvents,D.$6l.toKey(B.identifier.value),oe?.yieldTo?.map(Ee=>D.$6l.toKey(Ee))||[]),this.p(me)}$provideInlineCompletions(B,J,se,oe,Y){return this.s(B,ae,me=>me.provideInlineCompletions(I.URI.revive(J),se,oe,Y),void 0,Y)}$handleInlineCompletionDidShow(B,J,se,oe){this.s(B,ae,async Y=>{Y.handleDidShowCompletionItem(J,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,J,se,oe){this.s(B,ae,async Y=>{Y.handlePartialAccept(J,se,oe)},void 0,void 0)}$freeInlineCompletionsList(B,J){this.s(B,ae,async se=>{se.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(B,J,se,oe){const Y=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,me=this.t(new z(this.h,se),B);return this.e.$registerSignatureHelpProvider(me,this.o(J,B),Y),this.p(me)}$provideSignatureHelp(B,J,se,oe,Y){return this.s(B,z,me=>me.provideSignatureHelp(I.URI.revive(J),se,oe,Y),void 0,Y)}$releaseSignatureHelp(B,J){this.s(B,z,se=>se.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(B,J,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.t(new X(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(Y,this.o(J,B),typeof se.resolveInlayHint=="function",oe,be.u(B));let me=this.p(Y);if(oe!==void 0){const Ee=se.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(oe));me=L.$vK.from(me,Ee)}return me}$provideInlayHints(B,J,se,oe){return this.s(B,X,Y=>Y.provideInlayHints(I.URI.revive(J),se,oe),void 0,oe)}$resolveInlayHint(B,J,se){return this.s(B,X,oe=>oe.resolveInlayHint(J,se),void 0,se)}$releaseInlayHints(B,J){this.s(B,X,se=>se.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(B,J,se){const oe=this.t(new re(this.h,se),B);return this.e.$registerDocumentLinkProvider(oe,this.o(J,B),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(B,J,se){return this.s(B,re,oe=>oe.provideLinks(I.URI.revive(J),se),void 0,se,J.scheme==="output")}$resolveDocumentLink(B,J,se){return this.s(B,re,oe=>oe.resolveLink(J,se),void 0,void 0,!0)}$releaseDocumentLinks(B,J){this.s(B,re,se=>se.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(B,J,se){const oe=this.t(new Z(this.h,se),B);return this.e.$registerDocumentColorProvider(oe,this.o(J,B)),this.p(oe)}$provideDocumentColors(B,J,se){return this.s(B,Z,oe=>oe.provideColors(I.URI.revive(J),se),[],se)}$provideColorPresentations(B,J,se,oe){return this.s(B,Z,Y=>Y.provideColorPresentations(I.URI.revive(J),se,oe),void 0,oe)}registerFoldingRangeProvider(B,J,se){const oe=this.q(),Y=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new fe(new ee(this.h,se),B)),this.e.$registerFoldingRangeProvider(oe,this.o(J,B),B.identifier,Y);let me=this.p(oe);if(Y!==void 0){const Ee=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));me=L.$vK.from(me,Ee)}return me}$provideFoldingRanges(B,J,se,oe){return this.s(B,ee,Y=>Y.provideFoldingRanges(I.URI.revive(J),se,oe),void 0,oe)}registerSelectionRangeProvider(B,J,se){const oe=this.t(new _(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(oe,this.o(J,B)),this.p(oe)}$provideSelectionRanges(B,J,se,oe){return this.s(B,_,Y=>Y.provideSelectionRanges(I.URI.revive(J),se,oe),[],oe)}registerCallHierarchyProvider(B,J,se){const oe=this.t(new we(this.h,se),B);return this.e.$registerCallHierarchyProvider(oe,this.o(J,B)),this.p(oe)}$prepareCallHierarchy(B,J,se,oe){return this.s(B,we,Y=>Promise.resolve(Y.prepareSession(I.URI.revive(J),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,J,se,oe){return this.s(B,we,Y=>Y.provideCallsTo(J,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,J,se,oe){return this.s(B,we,Y=>Y.provideCallsFrom(J,se,oe),void 0,oe)}$releaseCallHierarchy(B,J){this.s(B,we,se=>Promise.resolve(se.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(B,J,se){const oe=this.t(new ue(this.h,se),B);return this.e.$registerTypeHierarchyProvider(oe,this.o(J,B)),this.p(oe)}$prepareTypeHierarchy(B,J,se,oe){return this.s(B,ue,Y=>Promise.resolve(Y.prepareSession(I.URI.revive(J),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,J,se,oe){return this.s(B,ue,Y=>Y.provideSupertypes(J,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,J,se,oe){return this.s(B,ue,Y=>Y.provideSubtypes(J,se,oe),void 0,oe)}$releaseTypeHierarchy(B,J){this.s(B,ue,se=>Promise.resolve(se.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(B,J,se,oe){const Y=this.q();this.f.set(Y,new fe(new ge(this.e,this.h,se,Y,B),B));const me=(0,t.$kF)(B,"dropMetadata")&&oe?ge.toInternalProviderId(B.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(J,B),me,(0,t.$kF)(B,"dropMetadata")?oe:void 0),this.p(Y)}$provideDocumentOnDropEdits(B,J,se,oe,Y,me){return this.s(B,ge,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(J,I.URI.revive(se),oe,Y,me)),void 0,void 0)}registerMappedEditsProvider(B,J,se){const oe=this.t(new te(this.h,se),B);return this.e.$registerMappedEditsProvider(oe,this.o(J,B)),this.p(oe)}$provideMappedEdits(B,J,se,oe,Y){return this.s(B,te,me=>Promise.resolve(me.provideMappedEdits(J,se,oe,Y)),null,Y)}registerDocumentPasteEditProvider(B,J,se,oe){const Y=this.q();this.f.set(Y,new fe(new j(this.e,this.h,se,Y,B),B));const me=j.toInternalProviderId(B.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Y,this.o(J,B),me,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(B,J,se,oe,Y){return this.s(B,j,me=>me.prepareDocumentPaste(I.URI.revive(J),se,oe,Y),void 0,Y)}$providePasteEdits(B,J,se,oe,Y,me){return this.s(B,j,Ee=>Ee.providePasteEdits(J,I.URI.revive(se),oe,Y,me),void 0,me)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:be.w(B.decreaseIndentPattern),increaseIndentPattern:be.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:be.w(B.beforeText),afterText:B.afterText?be.w(B.afterText):void 0,previousLineText:B.previousLineText?be.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(be.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(J=>L.SyntaxTokenType.toString(J)):void 0}}static D(B){return B.map(be.C)}setLanguageConfiguration(B,J,se){const{wordPattern:oe}=se;if(oe&&(0,E.$Oe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(J,oe):this.h.setWordDefinitionFor(J,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Y=this.q(),me={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?be.w(se.wordPattern):void 0,indentationRules:se.indentationRules?be.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?be.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?be.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Y,J,me),this.p(Y)}$setWordDefinitions(B){for(const J of B)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$Qcc=be}),define(Se[327],De([1,0,6,14,7,38,8,3,26]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class m{constructor(P,g,y,D){this.c=g,this.d=y,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(I.$tK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,g){await this.a.$changeLanguage(P,g);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,g){const y=P.version,D=F.Position.from(g),w=await this.a.$tokensAtPosition(P.uri,D),u={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition(g)??new f.$xK(g.line,g.character,g.line,g.character)};if(!w)return u;const c={range:F.Range.to(w.range),type:F.TokenType.to(w.type)};return!c.range.contains(g)||y!==P.version?u:c}createLanguageStatusItem(P,g,y){const D=this.f++,w=this.a,u=this.g,c=`${P.identifier.value}/${g}`;if(u.has(c))throw new Error(`LanguageStatusItem with id '${g}' ALREADY exists`);u.add(c);const i={selector:y,id:g,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const r=new p.$Qc,o=()=>{if(s?.dispose(),!u.has(c)){console.warn(`LanguageStatusItem (${g}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,R.$Vg)(()=>{r.clear(),this.a.$setLanguageStatus(D,{id:c,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?L.default.Error:i.severity===f.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),s?.dispose(),w.$removeLanguageStatus(D),u.delete(c)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,o()},get selector(){return i.selector},set selector(n){i.selector=n,o()},get text(){return i.text},set text(n){i.text=n,o()},set text2(n){(0,E.$lF)(P,"languageStatusText"),i.text=n,o()},get text2(){return(0,E.$lF)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(n){i.detail=n,o()},get severity(){return i.severity},set severity(n){i.severity=n,o()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,o()},get command(){return i.command},set command(n){i.command=n,o()},get busy(){return i.busy},set busy(n){i.busy=n,o()}};return o(),t}}e.$ydc=m}),define(Se[114],De([1,0,12,13,2,5,15,6,27,20]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=e.$ndc=void 0;let A=class{constructor(g,y,D){this.f=D,this.d=new Map,this.a=y.getProxy(p.$tK.MainThreadLocalization),this.b=g.environment.appLanguage,this.c=this.b===I.$g}getMessage(g,y){const{message:D,args:w,comment:u}=y;if(this.c)return(0,F.$De)(D,w??{});let c=D;u&&u.length>0&&(c+=`/${Array.isArray(u)?u.join(""):u}`);const i=this.d.get(g)?.contents[c];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,F.$De)(i??D,w??{})}getBundle(g){return this.d.get(g)?.contents}getBundleUri(g){return this.d.get(g)?.uri}async initializeLocalizedMessages(g){if(this.c||!g.l10n&&!g.isBuiltin||this.d.has(g.identifier.value))return;let y;const D=await this.g(g);if(!D){this.f.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(D),u=JSON.parse(w);y=g.isBuiltin?u.contents?.bundle:u}catch(w){this.f.error(`Failed to load translations for ${g.identifier.value} from ${D}: ${w.message}`);return}y&&this.d.set(g.identifier.value,{contents:y,uri:D})}async g(g){if(g.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(g.identifier.value,this.b);return f.URI.revive(y)}return g.l10n?f.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ndc=A,e.$ndc=A=He([Be(0,E.$KM),Be(1,m.$uM),Be(2,R.$0i)],A),e.$odc=(0,L.$Ph)("IExtHostLocalizationService")}),define(Se[152],De([1,0,15,6,27,20,2,54]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;let E=class extends I.$ij{constructor(P,g){super(g.logLevel,g.logsLocation,g.loggers.map(y=>(0,p.$mh)(y))),this.r=P.getProxy(F.$tK.MainThreadLogger)}$setLogLevel(P,g){g?this.setLogLevel(R.URI.revive(g),P):this.setLogLevel(P)}setVisibility(P,g){super.setVisibility(P,g),this.r.$setVisibility(P,g)}s(P,g,y){return new m(this.r,P,g,y)}};e.$Qec=E,e.$Qec=E=He([Be(0,L.$uM),Be(1,f.$KM)],E);class m extends I.$dj{constructor(P,g,y,D){super(D?.logLevel==="always"),this.r=P,this.s=g,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(g,D).then(()=>{this.u(this.n),this.m=!0})}g(P,g){const y=[[P,g]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(Se[115],De([1,0,6,5,3,20,22]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=void 0,e.$pdc=(0,F.$Ph)("IExtHostManagedSockets");let p=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(I.$tK.MainThreadManagedSockets)}setFactory(P,g){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(P,g),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const g=++this.b,y=await this.c.makeConnection(),D=new f.$Qc;return this.d.set(g,new m(g,y,D)),D.add((0,f.$Pc)(()=>this.d.delete(g))),D.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(g),D.dispose()})),D.add(y.onDidClose(w=>{this.a.$onDidManagedSocketClose(g,w?.stack??w?.message),D.dispose()})),D.add(y.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData(g,R.$be.wrap(w)))),g}$remoteSocketWrite(P,g){this.d.get(P)?.actual.send(g.buffer)}$remoteSocketEnd(P){const g=this.d.get(P);g&&(g.actual.end(),g.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$qdc=p,e.$qdc=p=He([Be(0,L.$uM)],p);class E{constructor(P,g){this.socketFactoryId=P,this.makeConnection=g}}class m extends f.$Rc{constructor(P,g,y){super(),this.socketId=P,this.actual=g,this.B(y)}}}),define(Se[328],De([1,0,6,15,26]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;function L(p){return p&&p.title}let R=class{constructor(E,m){this.b=m,this.a=E.getProxy(I.$tK.MainThreadMessageService)}showMessage(E,m,A,P,g){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let D;typeof P=="string"||L(P)?D=[P,...g]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,D=g),y.useCustom&&(0,f.$lF)(E,"resolvers");const w=[];for(let u=0;u<D.length;u++){const c=D[u];if(typeof c=="string")w.push({title:c,handle:u,isCloseAffordance:!1});else if(typeof c=="object"){const{title:i,isCloseAffordance:s}=c;w.push({title:i,isCloseAffordance:!!s,handle:u})}else this.b.warn("Invalid message item:",c)}return this.a.$showMessage(m,A,y,w).then(u=>{if(typeof u=="number")return D[u]})}};e.$zdc=R,e.$zdc=R=He([Be(1,F.$0i)],R)}),define(Se[329],De([1,0,19,8,21,4,3,28,2,25,15,6,34,14,7,112,284,26,69]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;let s=class{constructor(h,S,k,$,b){this.l=S,this.m=k,this.n=$,this.o=b,this.b=new p.$zc,this.c=new p.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(P.$tK.MainThreadNotebookKernels);const v=new g.$UM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.$SM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const N=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:N}}else if(C&&"notebookEditor"in C){const N=this.m.getIdByEditor(C.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return C})],g.$TM.Void);this.n.registerApiCommand(v)}createNotebookController(h,S,k,$,b,v){for(const ce of this.i.values())if(ce.controller.id===S&&m.$6l.equals(h.identifier,ce.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const C=this.j++,N=this;this.o.trace(`NotebookController[${C}], CREATED by ${h.identifier.value}, ${S}`);const T=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${h.identifier}'`);let M=!1;const U=new L.$Nd,j=new L.$Nd,O={id:l(h.identifier,S),notebookType:k,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:$||h.identifier.value,preloads:v?v.map(y.NotebookRendererScript.from):[]};let V=b??T,q;this.a.$addKernel(C,O).catch(ce=>{console.log(ce),M=!0});let de=0;const x=()=>{if(M)return;const ce=++de;Promise.resolve().then(()=>{ce===de&&this.a.$updateKernel(C,O)})},Q=new p.$zc,G={get id(){return S},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return O.label},set label(ce){O.label=ce??h.displayName??h.name,x()},get detail(){return O.detail??""},set detail(ce){O.detail=ce,x()},get description(){return O.description??""},set description(ce){O.description=ce,x()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ce){O.supportedLanguages=ce,x()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){O.supportsExecutionOrder=ce,x()},get rendererScripts(){return O.preloads?O.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(ce){V=ce??T},get interruptHandler(){return q},set interruptHandler(ce){q=ce,O.supportsInterrupt=!!ce,x()},createNotebookCellExecution(ce){if(M)throw new Error("notebook controller is DISPOSED");if(!Q.has(ce.notebook.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return N._createNotebookCellExecution(ce,l(h.identifier,this.id))},createNotebookExecution(ce){if((0,c.$lF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Q.has(ce.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.uri.toString()}`);return N._createNotebookExecution(ce,l(h.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${C}], DISPOSED`),M=!0,this.i.delete(C),U.dispose(),j.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ce,ie){ie===D.NotebookControllerAffinity2.Hidden&&(0,c.$lF)(h,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(C,ce.uri,ie)},onDidReceiveMessage:j.event,postMessage(ce,ie){return(0,c.$lF)(h,"notebookMessaging"),N.a.$postMessage(C,ie&&N.m.getIdByEditor(ie),ce)},asWebviewUri(ce){return(0,c.$lF)(h,"notebookMessaging"),(0,w.$upb)(ce,N.l.remote)}};return this.i.set(C,{extensionId:h.identifier,controller:G,onDidReceiveMessage:j,onDidChangeSelection:U,associatedNotebooks:Q}),G}getIdByController(h){for(const[S,k]of this.i)if(k.controller===h)return l(k.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,S){const k=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(k,S);const b={dispose:()=>{this.e.delete(k),$.a.$removeKernelDetectionTask(k)}};return this.e.set(k,b),b}registerKernelSourceActionProvider(h,S,k){const $=this.h++,b=typeof k.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,v=this;this.g.set($,k),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,S);let C;return b!==void 0&&(C=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete($),v.a.$removeKernelSourceActionProvider($,$),C?.dispose()}}}async $provideKernelSourceActions(h,S){const k=this.g.get(h);if(k){const $=new R.$Qc;return(await k.provideNotebookKernelSourceActions(S)??[]).map(v=>y.NotebookKernelSourceAction.from(v,this.n.converter,$))}return[]}$acceptNotebookAssociation(h,S,k){const $=this.i.get(h);if($){const b=this.m.getNotebookDocument(E.URI.revive(S));k?$.associatedNotebooks.set(b.uri,!0):$.associatedNotebooks.delete(b.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,b.uri.toString(),k),$.onDidChangeSelection.fire({selected:k,notebook:b.apiNotebook})}}async $executeCells(h,S,k){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(S)),v=[];for(const C of k){const N=b.getCell(C);N&&v.push(N.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,b.uri.toString(),v.length),await $.controller.executeHandler.call($.controller,v,b.apiNotebook,$.controller)}catch(C){this.o.error(`NotebookController[${h}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(h,S,k){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(S));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,b.apiNotebook);else for(const v of k){const C=b.getCell(v);C&&this.b.get(C.uri)?.cancel()}if($.controller.interruptHandler){const v=this.c.get(b.uri);k.length&&Array.isArray(v)&&v.length&&v.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(h,S,k){const $=this.i.get(h);if(!$)return;const b=this.m.getEditorById(S);$.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:k}))}$cellExecutionChanged(h,S,k){const b=this.m.getNotebookDocument(E.URI.revive(h)).getCell(S);if(b){const v=k?y.NotebookCellExecutionState.to(k):D.NotebookCellExecutionState.Idle;v!==void 0&&this.k.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(h,S){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const b=new o(S,$,this.a);this.b.set($.uri,b);const v=b.onDidChangeState(()=>{b.state===r.Resolved&&(b.dispose(),v.dispose(),this.b.delete($.uri))});return b.asApiObject()}_createNotebookExecution(h,S){const k=this.m.getNotebookDocument(h.uri),$=h.getCells().find(C=>{const N=k.getCellFromApiCell(C);return N&&this.b.has(N.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const b=new n(S,k,this.a),v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[b,v]),b.asApiObject()}};e.$vec=s,e.$vec=s=He([Be(4,A.$0i)],s);var r;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(r||(r={}));class o extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,S,k){super(),this.m=S,this.n=k,this.b=o.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new f.$Xd),this.h=new d(10,$=>this.s($)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const S=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$tv(S))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let S=this.m;if(h&&(S=this.m.notebook.getCellFromApiCell(h)),!S)throw new Error("INVALID cell");return S.handle}y(h){return h.map(S=>{const k=D.$WL.ensureUniqueMimeTypes(S.items,!0);return k===S.items?y.NotebookCellOutput.from(S):y.NotebookCellOutput.from({items:k,id:S.id,metadata:S.metadata})})}async z(h,S,k){const $=this.w(S),b=this.y((0,I.$2b)(h));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:$,append:k,outputs:b})}async C(h,S,k){return h=D.$WL.ensureUniqueMimeTypes((0,I.$2b)(h),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:h.map(y.NotebookCellOutputItem.from),outputId:S.id,append:k})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(k){h.j=k,h.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(k){if(h.f===r.Resolved||h.f===r.Started)throw new Error("Cannot call start again");h.f=r.Started,h.c.fire(),h.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,$){if(h.f===r.Resolved)throw new Error("Cannot call resolve twice");h.f=r.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$tv({runEndTime:$,lastRunSuccess:k}))},clearOutput(k){return h.t(),h.z([],k,!1)},appendOutput(k,$){return h.t(),h.z(k,$,!0)},replaceOutput(k,$){return h.t(),h.z(k,$,!1)},appendOutputItems(k,$){return h.t(),h.C(k,$,!0)},replaceOutputItems(k,$){return h.t(),h.C(k,$,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,S,k){super(),this.h=S,this.j=k,this.b=n.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$Xd),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,S){this.e=h,this.f=S,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new F.$ch,this.b=Date.now(),(0,F.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>h.complete())}}function l(a,h){return`${a.value}/${h}`}e.$wec=l}),define(Se[330],De([1,0,4,6,148]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class L{constructor(p,E){this.c=E,this.a=new Map,this.b=p.getProxy(F.$tK.MainThreadNotebookRenderers)}$postRendererMessage(p,E,m){const A=this.c.getEditorById(p);this.a.get(E)?.fire({editor:A.apiEditor,message:m})}createRendererMessaging(p,E){if(!p.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,P,g)=>this.d(E).event(A,P,g),postMessage:(A,P)=>{f.$gec.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const g=P&&f.$gec.apiEditorsToExtHost.get(P);return this.b.$postMessage(g?.id,E,A)}}}d(p){let E=this.a.get(p);return E||(E=new I.$Nd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(p)}}),this.a.set(p,E),E)}}e.$xec=L}),define(Se[331],De([1,0,3,17,2,26,6]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class p{constructor(m){this.b=new Map,this.a=m.getProxy(R.$tK.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,A,P){if((0,L.$lF)(m,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,m.identifier.value),(0,I.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(m,A,P,g){const y=this.b.get(m);if(!y)throw new Error(`Unknown handler with id: ${m}`);return y.saveProfile(A,P,g)}async $readProfile(m,A,P){const g=this.b.get(m);if(!g)throw new Error(`Unknown handler with id: ${m}`);return g.readProfile((0,F.$yf)(A)?A:f.URI.revive(A),P)}}e.$Bec=p}),define(Se[332],De([1,0,2,6,8,14]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class R{static{this.a=0}constructor(E,m){this.d=m,this.c=new Map,this.b=E.getProxy(F.$tK.MainThreadQuickDiff)}$provideOriginalResource(E,m,A){const P=I.URI.revive(m),g=this.c.get(E);return g?(0,f.$Mg)(()=>g.provideOriginalResource(P,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,m,A,P){const g=R.a++;return this.c.set(g,m),this.b.$registerQuickDiffProvider(g,L.DocumentSelector.from(E,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(g),this.c.delete(g)}}}}e.$Cec=R}),define(Se[333],De([1,0,21,4,3,6,2,7,9,19,38,61,26,14]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;function D(w,u,c){const i=w.getProxy(L.$tK.MainThreadQuickOpen);class s{constructor(S,k){this.e=new Map,this.f=0,this.a=S,this.b=k}showQuickPick(S,k,$,b=I.CancellationToken.None){this.c=void 0;const v=Promise.resolve(k),C=++this.f,N=i.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},b),T={},M=N.then(()=>T);return Promise.race([M,v]).then(U=>{if(U===T)return;const j=(0,g.$kF)(S,"quickPickItemTooltip");return v.then(O=>{const V=[];for(let q=0;q<O.length;q++){const de=O[q];if(typeof de=="string")V.push({label:de,handle:q});else if(de.kind===p.QuickPickItemKind.Separator)V.push({type:"separator",label:de.label});else{de.tooltip&&!j&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const x=de.iconPath?d(de.iconPath):void 0;V.push({label:de.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(de.tooltip):void 0,handle:q})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=q=>{$.onDidSelectItem(O[q])}),i.$setItems(C,V),N.then(q=>{if(typeof q=="number")return O[q];if(Array.isArray(q))return q.map(de=>O[de])})})}).then(void 0,U=>{if(!(0,E.$3)(U))return i.$setError(C,U),Promise.reject(U)})}$onItemSelected(S){this.c?.(S)}showInput(S,k=I.CancellationToken.None){return this.d=S?.validateInput,i.$input(S,typeof this.d=="function",k).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(S){if(!this.d)return;const k=await this.d(S);if(!k||typeof k=="string")return k;let $;switch(k.severity){case p.InputBoxValidationSeverity.Info:$=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:$}}async showWorkspaceFolderPick(S,k=I.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!$)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(v=>v.uri.toString()===$.uri.toString())}createQuickPick(S){const k=new l(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(S){const k=new a(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(S,k){this.e.get(S)?._fireDidChangeValue(k)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,k){const $=this.e.get(S);$ instanceof l&&$._fireDidChangeActive(k)}$onDidChangeSelection(S,k){const $=this.e.get(S);$ instanceof l&&$._fireDidChangeSelection(k)}$onDidTriggerButton(S,k){this.e.get(S)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(S,k,$){const b=this.e.get(S);b instanceof l&&b._fireDidTriggerItemButton(k,$)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class r{static{this.a=1}constructor(S,k){this.x=S,this.y=k,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Nd,this.q=new F.$Nd,this.r=new F.$Nd,this.s=new F.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((k,$)=>{const b=k===p.$PL.Back?-1:$;this.o.set(b,k)}),this.z({buttons:S.map((k,$)=>({...d(k.iconPath),tooltip:k.tooltip,handle:k===p.$PL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const k=this.o.get(S);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(S){if(!this.v){for(const k of Object.keys(S)){const $=S[k];this.u[k]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function o(h){if(h instanceof p.$pL)return{id:h.id};const S=n(h),k=t(h);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof k=="string"?R.URI.file(k):k}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function n(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const S=o(h);let k,$;return"id"in S?$=P.ThemeIcon.asClassName(S):k=S,{iconPath:k,iconClass:$}}class l extends r{constructor(S,k){super(S.identifier,k),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Nd,this.L=[],this.M=new F.$Nd,this.N=new F.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((b,v)=>{this.C.set(v,b),this.D.set(b,v)});const k=(0,g.$kF)(this.O,"quickPickItemTooltip"),$=[];for(let b=0;b<S.length;b++){const v=S[b];if(v.kind===p.QuickPickItemKind.Separator)$.push({type:"separator",label:v.label});else{v.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=v.iconPath?d(v.iconPath):void 0;$.push({handle:b,label:v.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:k?y.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((N,T)=>({...d(N.iconPath),tooltip:N.tooltip,handle:T}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(S){const k=(0,m.$Gb)(S.map($=>this.C.get($)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(S){const k=(0,m.$Gb)(S.map($=>this.C.get($)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(S,k){const $=this.C.get(S);if(!$||!$.buttons||!$.buttons.length)return;const b=$.buttons[k];b&&this.N.fire({button:b,item:$})}}class a extends r{constructor(S,k){super(S.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new s(u,c)}e.$Ddc=D}),define(Se[334],De([1,0,2,4,59,3,8,6,19,128,15,25,61,14,26,18]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=void 0;function c(v){if(v)return typeof v.iconPath=="string"?I.URI.file(v.iconPath):I.URI.isUri(v.iconPath)||g.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function i(v){if(v?.icon){if(I.URI.isUri(v.icon))return v.icon;if(g.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function s(v){if(v.icon){if(I.URI.isUri(v.icon))return v.icon;if(g.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function r(v,C){if(!v.iconPath&&!C.iconPath)return 0;if(v.iconPath){if(!C.iconPath)return 1}else return-1;const N=typeof v.iconPath=="string"?v.iconPath:I.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,T=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,m.$uq)(N,T)}function o(v,C){let N=0;if(v.strikeThrough!==C.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==C.faded)return v.faded?1:-1;if(v.tooltip!==C.tooltip)return(v.tooltip||"").localeCompare(C.tooltip||"");if(N=r(v,C),N!==0)return N;if(v.light&&C.light)N=r(v.light,C.light);else{if(v.light)return 1;if(C.light)return-1}if(N!==0)return N;if(v.dark&&C.dark)N=r(v.dark,C.dark);else{if(v.dark)return 1;if(C.dark)return-1}return N}function t(v,C){if(v.command!==C.command)return v.command<C.command?-1:1;if(v.title!==C.title)return v.title<C.title?-1:1;if(v.tooltip!==C.tooltip){if(v.tooltip!==void 0&&C.tooltip!==void 0)return v.tooltip<C.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(v.arguments===C.arguments)return 0;if(v.arguments)if(C.arguments){if(v.arguments.length!==C.arguments.length)return v.arguments.length-C.arguments.length}else return 1;else return-1;for(let N=0;N<v.arguments.length;N++){const T=v.arguments[N],M=C.arguments[N];if(T!==M)return T<M?-1:1}return 0}function n(v,C){let N=(0,m.$uq)(v.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(N!==0)return N;if(v.command&&C.command)N=t(v.command,C.command);else{if(v.command)return 1;if(C.command)return-1}if(N!==0)return N;if(v.decorations&&C.decorations)N=o(v.decorations,C.decorations);else{if(v.decorations)return 1;if(C.decorations)return-1}return N}function d(v,C){for(let N=0;N<v.length;N++)if(v[N]!==C[N])return!1;return!0}function l(v,C){return v.command===C.command&&v.title===C.title&&v.tooltip===C.tooltip&&(v.arguments&&C.arguments?d(v.arguments,C.arguments):v.arguments===C.arguments)}function a(v,C){return(0,E.$tb)(v,C,l)}function h(v,C){return v===C?!0:!v||!C?!1:v.id===C.id&&v.label===C.label&&v.upstream?.id===C.upstream?.id&&v.upstream?.label===C.upstream?.label}class S{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,D.$lF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,D.$lF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,D.$lF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,D.$lF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Qc,this.k=C;const N=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:i(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,D.$lF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,N,T,M,U,j){this.m=C,this.n=N,this.o=U,this.p=j,this.d="",this.e=new F.$Nd,this.f="",this.h=!0,this.j=!0,this.l=new L.$Sc,this.#t=T,this.#e=M}showValidationMessage(C,N){(0,D.$lF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,N)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$Edc=S;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,N,T,M,U){this.q=C,this.s=N,this.t=T,this.u=M,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,N){const T=this.h.get(C);return T?(0,R.$Mg)(()=>this.s.executeCommand(T.command,...T.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(n),T=(0,E.$Cb)(this.o,C,n).map(j=>{const O=j.toInsert.map(V=>{const q=this.e++;this.g.set(q,V);const de=V.resourceUri;let x;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const re=new L.$Qc;x=this.s.converter.toInternal(V.command,re),this.j.set(q,re)}else this.h.set(q,V.command);const Q=c(V.decorations),G=V.decorations&&c(V.decorations.light)||Q,ce=V.decorations&&c(V.decorations.dark)||Q,ie=[G,ce],ae=V.decorations&&V.decorations.tooltip||"",ye=V.decorations&&!!V.decorations.strikeThrough,H=V.decorations&&!!V.decorations.faded,z=V.contextValue||"";return{rawResource:[q,de,ie,ae,ye,H,z,x],handle:q}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),M=T.map(({start:j,deleteCount:O,toInsert:V})=>[j,O,V.map(q=>q.rawResource)]),U=T.reverse();for(const{start:j,deleteCount:O,toInsert:V}of U){const q=V.map(x=>x.handle),de=this.n.splice(j,O,...q);for(const x of de)this.g.delete(x),this.h.delete(x),this.j.get(x)?.dispose(),this.j.delete(x)}return this.o=C,M}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let N;(0,D.$kF)(this.y,"quickDiffProvider")&&(N=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:N})}get historyProvider(){return(0,D.$lF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,D.$lF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,D.$lF)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const N=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new L.$Qc,this.p=C;const N=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,D.$lF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,D.$lF)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=C;const N=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(T=>T.map(M=>this.z.converter.toInternal(M,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&a(this.u,C))return;this.t.value=new L.$Qc,this.u=C;const N=(C||[]).map(T=>this.z.converter.toInternal(T,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(C,N,T,M,U,j,O){this.y=C,this.z=M,this.A=U,this.B=j,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Nd,this.onDidChangeSelection=this.w.event,this.x=$.d++,this.D=new Map,this.E=new Set,this.#e=T;const V=I.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new S(C,M,N,this.#e,this.x,V),this.#e.$registerSourceControl(this.x,U,j,O,V)}createResourceGroup(C,N){const T=new k(this.#e,this.z,this.x,C,N),M=F.Event.once(T.onDidDispose)(()=>this.D.delete(T));return this.D.set(T,M),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const C=[],N=[];for(const[T,M]of this.D){M.dispose();const U=T.onDidUpdateResourceStates(()=>{this.E.add(T),this.eventuallyUpdateResourceStates()});F.Event.once(T.onDidDispose)(()=>{this.E.delete(T),U.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.x,T.handle)}),C.push([T.handle,T.id,T.label,T.features]);const j=T._takeResourceStateSnapshot();j.length>0&&N.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.x,C,N),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(N=>{const T=N._takeResourceStateSnapshot();T.length!==0&&C.push([N.handle,T])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$ih)(100)],$.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$ih)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,N,T,M){this.l=N,this.m=T,this.n=M,this.g=new Map,this.h=new P.$8l,this.j=new F.$Nd,this.e=C.getProxy(p.$tK.MainThreadSCM),this.f=C.getProxy(p.$tK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const j=this.g.get(U.sourceControlHandle);if(!j)return U;const O=j.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const j=this.g.get(U.sourceControlHandle);return j?j.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const j=this.g.get(U.handle);return j||U}return U}})}createSourceControl(C,N,T,M){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,N,T,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const U=u.d++,j=new $(C,this.m,this.e,this.l,N,T,M);this.g.set(U,j);const O=this.h.get(C.identifier)||[];return O.push(j),this.h.set(C.identifier,O),j}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const N=this.h.get(C.identifier),T=N&&N[N.length-1];return T&&T.inputBox}$provideOriginalResource(C,N,T){const M=I.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",C,M.toString());const U=this.g.get(C);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Mg)(()=>U.quickDiffProvider.provideOriginalResource(M,T)).then(j=>j||null)}$onInputBoxValueChange(C,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const T=this.g.get(C);return T&&T.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(C,N,T,M){this.n.trace("ExtHostSCM#$executeResourceCommand",C,N,T);const U=this.g.get(C);if(!U)return Promise.resolve(void 0);const j=U.getResourceGroup(N);return j?j.$executeResourceCommand(T,M):Promise.resolve(void 0)}$validateInput(C,N,T){this.n.trace("ExtHostSCM#$validateInput",C);const M=this.g.get(C);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Mg)(()=>M.inputBox.validateInput(N,T)).then(U=>{if(!U)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(U.message);return j?Promise.resolve([j,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,N,T){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(N,T)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,N,T,M){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,T,M)??void 0}async $provideHistoryItems(C,N,T,M){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(N,T,M))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:s(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(C,N,T){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(N,T)??void 0}};e.$Fdc=b,e.$Fdc=b=u=He([Be(3,A.$0i)],b)}),define(Se[116],De([1,0,6,4,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0;class L{constructor(p){this.b=new F.$Nd,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$tK.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,E){return this.a.$getPassword(p,E)}store(p,E,m){return this.a.$setPassword(p,E,m)}delete(p,E){return this.a.$deletePassword(p,E)}}e.$kdc=L,e.$ldc=(0,f.$Ph)("IExtHostSecretState")}),define(Se[335],De([1,0,6,14,2]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class L{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(I.$tK.MainThreadShare)}async $provideShare(p,E,m){return await this.c.get(p)?.provideShare({selection:F.Range.to(E.selection),resourceUri:f.URI.revive(E.resourceUri)},m)??void 0}registerShareProvider(p,E){const m=L.a++;return this.c.set(m,E),this.b.$registerShareProvider(m,F.DocumentSelector.from(p,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(m),this.c.delete(m)}}}}e.$Hec=L}),define(Se[336],De([1,0,21,3,6]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class L{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(f.$tK.MainThreadSpeech)}async $createSpeechToTextSession(p,E){const m=this.c.get(p);if(!m)return;const A=new F.$Qc,P=new I.$Xd;this.d.set(E,P);const g=A.add(m.provideSpeechToTextSession(P.token));A.add(g.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,E,m){const A=L.a++;return this.c.set(A,m),this.b.$registerProvider(A,E,{extension:p,displayName:p.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Jec=L}),define(Se[337],De([1,0,7,6,217,3,14,17]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$qL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$qL("statusBarItem.warningForeground")]])}#e;#t;constructor(g,y,D,w,u,c=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=g,this.#t=y,u&&w){this.c=(0,I.$6K)(w.identifier,u);const s=D.get(this.c);s&&(c=s.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=s.priority,this.j=!0,this.name=s.name,this.text=s.text,this.tooltip=s.tooltip,this.command=s.command,this.accessibilityInformation=s.accessibilityInformation)}else this.c=String(E.a++);this.e=w,this.f=u,this.g=c,this.h=this.u(i)}u(g){if((0,p.$Cf)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!E.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof g=="string"?this.r={fromApi:g,internal:this.#t.toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:this.#t.toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let y;this.m?y=this.m:y=(0,f.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=E.b.get(this.o.id));const w=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,g,this.e?.identifier.value,y,this.k,w,this.r?.internal,D,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Gdc=E;class m{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const y={message:g};return this.b.unshift(y),this.c(),new I.$vK(()=>{const D=this.b.indexOf(y);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(g,y){this.e=new Map,this.a=g.getProxy(F.$tK.MainThreadStatusBar),this.b=y,this.c=new m(this)}$acceptStaticEntries(g){for(const y of g)this.e.set(y.entryId,y)}createStatusBarEntry(g,y,D,w){return new E(this.a,this.b,this.e,g,y,D,w)}setStatusBarMessage(g,y){const D=this.c.setMessage(g);let w;return typeof y=="number"?w=setTimeout(()=>D.dispose(),y):typeof y<"u"&&y.then(()=>D.dispose(),()=>D.dispose()),new I.$vK(()=>{D.dispose(),clearTimeout(w)})}}e.$Hdc=A}),define(Se[117],De([1,0,6,4,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0;class L{constructor(p,E){this.c=E,this.b=new F.$Nd,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$tK.MainThreadStorage)}registerExtensionStorageKeysToSync(p,E){this.a.$registerExtensionStorageKeysToSync(p,E)}async initializeExtensionStorage(p,E,m){const A=await this.a.$initializeExtensionStorage(p,E);let P;return A&&(P=this.d(p,E,A)),P||m}setValue(p,E,m){return this.a.$setValue(p,E,m)}$acceptValue(p,E,m){const A=this.d(p,E,m);A&&this.b.fire({shared:p,key:E,value:A})}d(p,E,m){try{return JSON.parse(m)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${p}): ${A}`)}}}e.$$cc=L,e.$_cc=(0,f.$Ph)("IExtHostStorage")}),define(Se[91],De([1,0,5,27,15,72,2]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,I.$Ph)("IExtensionStoragePaths");let p=class{constructor(m,A,P){this.d=A,this.f=P,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(g=>this.c=g)}async g(m){return R.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,A=await this.g(m);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(m){if(this.c)return R.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return R.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fdc=p,e.$fdc=p=He([Be(0,F.$KM),Be(1,f.$0i),Be(2,L.$ddc)],p)}),define(Se[45],De([1,0,4,6,5,2,20,3,7,219,9,261,21,32,262,61,8,14,34]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=e.$hdc=e.$gdc=void 0,e.$gdc=(0,f.$Ph)("IExtHostTerminalService");class s{constructor($,b,v,C){this.l=$,this._id=b,this.m=v,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(T=>this.f=T);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(T,M=!0){N.q(),N.l.$sendText(N._id,T,M)},show(T){N.q(),N.l.$show(N._id,T)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??void 0,env:$.env??void 0,icon:a($.iconPath)??void 0,color:w.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o($.location,b?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,b,v,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:v,color:w.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o($,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,b){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in $?{viewColumn:c.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,b){this.h=Object.freeze({code:$,reason:b})}setDimensions($,b){return $===this.d&&b===this.g||$===0||b===0?!1:(this.d=$,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(b=>{b!==$&&(this.b=Promise.resolve($))})}}e.$hdc=s;class r{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new I.$Nd,this.onProcessData=this.a.event,this.b=new I.$Nd,this.d=new I.$Nd,this.onDidChangeProperty=this.d.event,this.f=new I.$Nd,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,b){this.g.setDimensions?.({columns:$,rows:b})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends p.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,b,v){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new I.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new I.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new I.$Nd,this.onDidChangeShell=this.N.event,this.O=new I.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$tK.MainThreadTerminalService),this.y=new D.$elb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const N=T=>{const M=T;return this.W(M.instanceId)?.value};switch(C?.$mid){case 15:return N(C);default:{if(Array.isArray(C))for(let T=0;T<C.length&&C[T].$mid===15;T++)C[T]=N(C[T]);return C}}}}),this.B({dispose:()=>{for(const[C,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,b){const v=new s(this.a,(0,y.$eg)(),$,$.name),C=new r($.pty);return v.createExtensionTerminal($.location,this.R($,b).resolvedExtHostIdentifier,a($.iconPath),h($.color)).then(N=>{const T=this.S(N,C);this.h[N]=T}),this.f.push(v),v.value}R($,b){if(b=b||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const v=$.location.parentTerminal;if(v){const C=this.f.find(N=>N.value===v);C&&(b.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?b.location=$.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal($,b){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new r(b),N=this.S($,C);this.h[$]=N}async $acceptActiveTerminalChanged($){const b=this.b;if($===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const v=this.W($);v&&(this.b=v,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,b){const v=this.W($);v&&this.O.fire({terminal:v.value,data:b})}async $acceptTerminalDimensions($,b,v){const C=this.W($);C&&C.setDimensions(b,v)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,b){const v=this.W($);v&&this.P.fire({terminal:v.value,...b})}async $acceptTerminalMaximumDimensions($,b,v){this.g.get($)?.resize(b,v)}async $acceptTerminalTitleChange($,b){const v=this.W($);v&&(v.name=b)}async $acceptTerminalClosed($,b,v){const C=this.Y(this.f,$);if(C!==null){const N=this.f.splice(C,1)[0];N.setExitStatus(b,v),this.H.fire(N.value)}}$acceptTerminalOpened($,b,v,C){if(b){const M=this.Y(this.f,b);if(M!==null){this.f[M]._id=$,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:L.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},T=new s(this.a,$,N,v);this.f.push(T),this.I.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId($,b){this.W($)?._setProcessId(b)}async $startExtensionTerminal($,b){const v=this.W($);if(!v)return{message:(0,m.localize)(0,null,$)};v.isOpen||await new Promise(N=>{const T=this.onDidOpenTerminal(async M=>{M===v.value&&(T.dispose(),N())})});const C=this.g.get($);C?C.startSendingEvents(b):this.j[$]={initialDimensions:b}}S($,b){const v=new p.$Qc;v.add(b.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),v.add(b.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,b.onProcessData),v.add(b.onProcessExit(N=>this.U($,N))),this.g.set($,b);const C=this.j[$];return C&&b instanceof r&&(b.startSendingEvents(C.initialDimensions),delete this.j[$]),v}$acceptProcessAckDataEvent($,b){this.g.get($)?.acknowledgeDataEvent(b)}$acceptProcessInput($,b){this.g.get($)?.input(b)}$acceptTerminalInteraction($){const b=this.W($);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection($,b){this.W($)?.setSelection(b)}$acceptProcessResize($,b,v){try{this.g.get($)?.resize(b,v)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,b){this.g.get($)?.shutdown(b)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(b=>this.a.$sendProcessProperty($,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(b=>this.a.$sendProcessProperty($,{type:"cwd",value:b}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$vK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,b,v){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,v),this.a.$registerProfileProvider(b,$.identifier.value),new E.$vK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider($,b,v){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,v),this.a.$registerQuickFixProvider($,b),new E.$vK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,b){const v=new g.$Xd().token;if(v.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const N=await C.provideTerminalQuickFixes(b,v);if(N===null||Array.isArray(N)&&N.length===0)return;const T=new p.$Qc;if(this.w.value=T,!Array.isArray(N))return N?c.TerminalQuickFix.from(N,this.Q.converter,T):void 0;const M=[];for(const U of N){const j=c.TerminalQuickFix.from(U,this.Q.converter,T);j&&M.push(j)}return M}async $createContributedProfileTerminal($,b){const v=new g.$Xd().token;let C=await this.C.get($)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,b);return}this.createTerminalFromOptions(C.options,b)}}async $provideLinks($,b){const v=this.W($);if(!v)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new g.$Xd;this.G.set($,N);const T=[],M={terminal:v.value,line:b},U=[];for(const V of this.z)U.push(u.Promises.withAsyncBody(async q=>{N.token.onCancellationRequested(()=>q({provider:V,links:[]}));const de=await V.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||q({provider:V,links:de})}));const j=await Promise.all(U);if(N.token.isCancellationRequested)return[];const O=new Map;for(const V of j)V&&V.links.length>0&&T.push(...V.links.map(q=>{const de={id:o++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return O.set(de.id,{provider:V.provider,link:q}),de}));return this.F.set($,O),T}$activateLink($,b){const v=this.F.get($)?.get(b);v&&v.provider.handleTerminalLink(v.link)}U($,b){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const v=this.h[$];v&&(v.dispose(),delete this.h[$]),this.a.$sendProcessExit($,b)}W($){return this.X(this.f,$)}X($,b){const v=this.Y($,b);return v!==null?$[v]:null}Y($,b){const v=$.findIndex(C=>C._id===b);return v===-1?null:v}getEnvironmentVariableCollection($){let b=this.n.get($.identifier.value);return b||(b=new n,this.$($.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z($,b){const v=(0,P.$nr)(b.map),C=(0,P.$or)(b.descriptionMap);this.a.$setEnvironmentVariableCollection($,b.persistent,v.length===0?void 0:v,C)}$initEnvironmentVariableCollections($){$.forEach(b=>{const v=b[0],C=new n(b[1]);this.$(v,C)})}$acceptDefaultProfile($,b){const v=this.s;this.s=$,this.u=b,v?.path!==$.path&&this.N.fire($.path)}$($,b){this.n.set($,b),b.onDidChangeCollection(()=>{this.Z($,b)})}};e.$idc=t,e.$idc=t=He([Be(1,i.$QM),Be(2,R.$uM)],t);class n{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$Nd,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const b=this.h($);let v=this.a.get(b);return v||(v=new d(this,$),this.a.set(b,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:C})}append($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:C})}prepend($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:C})}f($,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g($,b.scope),C=this.map.get(v),N=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==b.value||C.type!==b.type||C.options?.applyAtProcessCreation!==N.applyAtProcessCreation||C.options?.applyAtShellIntegration!==N.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const T=this.g($,b.scope),M={variable:$,...b,options:N};this.map.set(T,M),this.d.fire()}}get($,b){const v=this.g($,b),C=this.map.get(v);return C?S(C):void 0}g($,b){const v=this.h(b);return v.length?`${$}:::${v}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const b=new Map;for(const[v,C]of this.map)this.h(C.scope)===this.h($)&&b.set(C.variable,S(C));return b}delete($,b){const v=this.g($,b);this.map.delete(v),this.d.fire()}clear($){if($?.workspaceFolder){for(const[b,v]of this.map)v.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(b);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,b){const v=this.h(b),C=this.descriptionMap.get(v);if(!C||C.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const T={description:N,scope:b};this.descriptionMap.set(v,T),this.d.fire()}}getDescription($){const b=this.h($);return this.descriptionMap.get(b)?.description}k($){const b=this.h($);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,b){this.b=$,this.d=b,this.a=new I.$Nd}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,b,v){this.b.replace($,b,v,this.d)}append($,b,v){this.b.append($,b,v,this.d)}prepend($,b,v){this.b.prepend($,b,v,this.d)}get($){return this.b.get($,this.d)}forEach($,b){this.b.getVariableMap(this.d).forEach((v,C)=>$.call(b,C,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor($,b){super(!1,$,b)}createTerminal($,b,v){throw new A.$$}createTerminalFromOptions($,b){throw new A.$$}};e.$jdc=l,e.$jdc=l=He([Be(0,i.$QM),Be(1,R.$uM)],l);function a(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function h(k){return w.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const $={...k};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Se[338],De([1,0,120,8,22,21,4,75,52,3,24,17,32,6,20,149,14,7,68,111,88]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=e.$rec=e.$qec=void 0;let o=class{constructor(T,M,U){this.j=U,this.c=new R.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(y.$tK.MainThreadTesting),this.h=new b(this.f),this.g=new l(this.f),M.registerArgumentProcessor({processArgument:j=>{switch(j?.$mid){case 16:{const O=j,V=O.tests[O.tests.length-1].item.extId;return this.d.get(i.$jJ.root(V))?.collection.tree.get(V)?.actual??(0,w.$GM)(j)}case 18:{const{extId:O,message:V}=j;return{test:this.d.get(i.$jJ.root(O))?.collection.tree.get(O)?.actual,message:u.TestMessage.to(V)}}default:return j}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await M.executeCommand("_testing.getExplorerSelection"),O=V=>{const q=this.d.get(i.$jJ.root(V));if(q)return i.$jJ.isRoot(V)?q.controller:q.collection.tree.get(V)?.actual};return{include:j?.include.map(O).filter(P.$Gf)||[],exclude:j?.exclude.map(O).filter(P.$Gf)||[]}})}createTestController(T,M,U,j){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const O=new m.$Qc,V=O.add(new w.$JM(M,U,this.j));V.root.label=U;const q=new Map,de=this.f,x={items:V.root.children,get label(){return U},set label(G){U=G,V.root.label=G,de.$updateController(M,{label:U})},get refreshHandler(){return j},set refreshHandler(G){j=G,de.$updateController(M,{canRefresh:!!G})},get id(){return M},createRunProfile:(G,ce,ie,ae,ye,H)=>{let z=(0,E.$Di)(G);for(;q.has(z);)z++;return new v(this.f,q,M,z,G,ce,ie,ae,ye,H)},createTestItem(G,ce,ie){return new w.$HM(M,G,ce,ie)},createTestRun:(G,ce,ie=!0)=>this.g.createTestRun(T,M,V,G,ce,ie),invalidateTestResults:G=>{if(G===void 0)this.f.$markTestRetired(void 0);else{const ce=G instanceof Array?G:[G];this.f.$markTestRetired(ce.map(ie=>i.$jJ.fromExtHostTestItem(ie,M).toString()))}},set resolveHandler(G){V.resolveHandler=G},get resolveHandler(){return V.resolveHandler},dispose:()=>{O.dispose()}};de.$registerTestController(M,U,!!j),O.add((0,m.$Pc)(()=>de.$unregisterTestController(M)));const Q={controller:x,collection:V,profiles:q,extension:T};return this.d.set(M,Q),O.add((0,m.$Pc)(()=>this.d.delete(M))),O.add(V.onDidGenerateDiff(G=>de.$publishDiff(M,G.map(r.TestsDiffOp.serialize)))),x}createTestObserver(){return this.h.checkout()}async runTests(T,M=L.CancellationToken.None){const U=a(T);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(U.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(O=>i.$jJ.fromExtHostTestItem(O,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:C[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:T.exclude?.map(O=>O.id)},M)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,M,U){return(0,I.$qb)(this.g.trackers,O=>O.id===T?O.getCoverage(M):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(T,M,U,j){return(0,I.$qb)(this.g.trackers,V=>V.id===T?V.getCoverage(M):void 0)?.resolveFileCoverage(U,j)??Promise.resolve([])}$configureRunProfile(T,M){this.d.get(T)?.profiles.get(M)?.configureHandler?.()}async $refreshTests(T,M){await this.d.get(T)?.controller.refreshHandler?.(M)}$publishTestResults(T){this.results=Object.freeze(T.map(M=>(0,A.$8m)(u.TestResults.to(M))).concat(this.results).sort((M,U)=>U.completedAt-M.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,M){const U=this.d.get(i.$jJ.fromString(T).controllerId)?.collection;U&&(await U.expand(T,M<0?1/0:M),U.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(r.TestsDiffOp.deserialize))}async $runControllerTests(T,M){return Promise.all(T.map(U=>this.k(U,!1,M)))}async $startContinuousRun(T,M){const U=new L.$Xd(M),j=await Promise.all(T.map(O=>this.k(O,!0,U.token)));return!M.isCancellationRequested&&!j.some(O=>O.error)&&await new Promise(O=>M.onCancellationRequested(O)),U.dispose(!0),j}async k(T,M,U){const j=this.d.get(T.controllerId);if(!j)return{};const{collection:O,profiles:V,extension:q}=j,de=V.get(T.profileId);if(!de)return{};const x=T.testIds.map(ie=>O.tree.get(ie)).filter(P.$Gf),Q=T.excludeExtIds.map(ie=>j.collection.tree.get(ie)).filter(P.$Gf).filter(ie=>x.some(ae=>ae.fullId.compare(ie.fullId)===2));if(!x.length)return{};const G=new c.$4L(x.some(ie=>ie.actual instanceof w.$IM)?void 0:x.map(ie=>ie.actual),Q.map(ie=>ie.actual),de,M),ce=(0,r.$lJ)(T)&&this.g.prepareForMainThreadTestRun(G,h.fromInternal(T,j.collection),q,U);try{return await de.runHandler(G,U),{}}catch(ie){return{error:String(ie)}}finally{ce&&(ce.hasRunningTasks&&!U.isCancellationRequested&&await R.Event.toPromise(ce.onEnd),ce.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};e.$qec=o,e.$qec=o=He([Be(0,D.$uM)],o);const t=1e4;var n;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(n||(n={}));class d extends m.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(T,M,U){super(),this.m=T,this.s=M,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Nd),this.onEnd=this.j.event,this.h=this.B(new L.$Xd(U));const j=this.B(new F.$6g(()=>this.u(),t));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const M=this.m.id,U=this.m.controllerId,j=(0,g.$eg)(),O=new S(this.s,M,j),V=Q=>(G,...ce)=>{if(de){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}this.m.isIncluded(G)&&(this.y(G),Q(G,...ce))},q=(Q,G)=>{const ce=G instanceof Array?G.map(u.TestMessage.from):[u.TestMessage.from(G)];if(Q.uri&&Q.range){const ie={range:u.Range.from(Q.range),uri:Q.uri};for(const ae of ce)ae.location=ae.location||ie}this.s.$appendTestMessagesInRun(M,j,i.$jJ.fromExtHostTestItem(Q,U).toString(),ce)};let de=!1;const x={isPersisted:this.m.isPersisted,token:this.h.token,name:T,get coverageProvider(){return O.coverageProvider},set coverageProvider(Q){O.coverageProvider=Q},enqueued:V(Q=>{this.s.$updateTestStateInRun(M,j,i.$jJ.fromExtHostTestItem(Q,U).toString(),1)}),skipped:V(Q=>{this.s.$updateTestStateInRun(M,j,i.$jJ.fromExtHostTestItem(Q,U).toString(),5)}),started:V(Q=>{this.s.$updateTestStateInRun(M,j,i.$jJ.fromExtHostTestItem(Q,U).toString(),2)}),errored:V((Q,G,ce)=>{q(Q,G),this.s.$updateTestStateInRun(M,j,i.$jJ.fromExtHostTestItem(Q,U).toString(),6,ce)}),failed:V((Q,G,ce)=>{q(Q,G),this.s.$updateTestStateInRun(M,j,i.$jJ.fromExtHostTestItem(Q,U).toString(),4,ce)}),passed:V((Q,G)=>{this.s.$updateTestStateInRun(M,j,i.$jJ.fromExtHostTestItem(Q,this.m.controllerId).toString(),3,G)}),appendOutput:(Q,G,ce)=>{de||(ce&&(this.m.isIncluded(ce)?this.y(ce):ce=void 0),this.s.$appendOutputToRun(M,j,f.$be.fromString(Q),G&&u.location.from(G),ce&&i.$jJ.fromExtHostTestItem(ce,U).toString()))},end:()=>{de||(de=!0,this.s.$finishedTestRunTask(M,j),this.f.delete(j),this.f.size||this.w())}};return this.f.set(j,{run:x,coverage:O}),this.s.$startedTestRunTask(M,{id:j,name:T,running:!0}),x}u(){for(const{run:T}of this.f.values())T.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(T){if(!(T instanceof w.$HM))throw new s.$mM(T.id);if(this.g.has(i.$jJ.fromExtHostTestItem(T,this.m.controllerId).toString()))return;const M=[],U=this.m.colllection.root;for(;;){const j=u.TestItem.from(T);if(M.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),T===U))break;T=T.parent||U}this.s.$addTestsToRun(this.m.controllerId,this.m.id,M)}dispose(){this.w(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,M,U,j){return this.f(T,M,U,j)}cancelRunById(T){for(const M of this.c.values())if(M.id===T){M.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,M,U,j,O,V){const q=this.c.get(j);if(q)return q.createRun(O);const de=h.fromPublic(M,U,j,V),x=a(j);this.d.$startedExtensionTestRun({controllerId:M,continuous:!!j.continuous,profile:x&&{group:C[x.kind],id:x.profileId},exclude:j.exclude?.map(G=>i.$jJ.fromExtHostTestItem(G,U.root.id).toString())??[],id:de.id,include:j.include?.map(G=>i.$jJ.fromExtHostTestItem(G,U.root.id).toString())??[U.root.id],persist:V});const Q=this.f(j,de,T);return R.Event.once(Q.onEnd)(()=>{this.d.$finishedExtensionTestRun(de.id),Q.dispose()}),Q.createRun(O)}f(T,M,U,j){const O=new d(M,this.d,j);return this.c.set(T,O),R.Event.once(O.onEnd)(()=>this.c.delete(T)),O}}e.$rec=l;const a=N=>{if(N.profile){if(!(N.profile instanceof v))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class h{static fromPublic(T,M,U,j){return new h(T,(0,g.$eg)(),U.include?.map(O=>i.$jJ.fromExtHostTestItem(O,T).toString())??[T],U.exclude?.map(O=>i.$jJ.fromExtHostTestItem(O,T).toString())??[],j,M)}static fromInternal(T,M){return new h(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,M)}constructor(T,M,U,j,O,V){this.controllerId=T,this.id=M,this.isPersisted=O,this.colllection=V,this.c=U.map(q=>q+"\0"),this.d=j.map(q=>q+"\0")}isIncluded(T){const M=i.$jJ.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const U of this.d)if(M===U||M.startsWith(U))return!1;for(const U of this.c)if(M===U||M.startsWith(U))return!0;return!1}}e.$sec=h;class S{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");T&&(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,M,U){this.f=T,this.g=M,this.h=U}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(u.TestCoverage.fromFile)??[]}catch(M){throw this.d=void 0,M}}async resolveFileCoverage(T,M){const U=await this.d;let j=U?.[T];return!this.c||!U||!j?[]:(j.detailedCoverage||(j=U[T]=await this.c.resolveFileCoverage?.(j,M)??j),j.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class k{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,u.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const M=i.$jJ.parentId(T.item.extId);if(M&&this.g.has(M.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:M,f:U}=this;return{get added(){return[...T].map(j=>j.revived)},get updated(){return[...M].map(j=>j.revived)},get removed(){return[...U].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class $ extends r.$qJ{constructor(){super(...arguments),this.q=new R.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,M){return{...T,revived:u.TestItem.toPlain(T.item),depth:M?M.depth+1:0,children:new Set}}o(){return new k(this.q)}}class b{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(M=>M.revived)},dispose:(0,p.$cb)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new $;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class v{#e;#t;get label(){return this.d}set label(T){T!==this.d&&(this.d=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?u.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,M,U,j,O,V,q,de=!1,x=void 0,Q=!1){this.controllerId=U,this.profileId=j,this.d=O,this.kind=V,this.runHandler=q,this.f=de,this._tag=x,this.g=Q,this.#e=T,this.#t=M,M.set(j,this);const G=C[V];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);this.#e.$publishTestRunProfile({profileId:j,controllerId:U,tag:x?u.TestTag.namespace(this.controllerId,x.id):null,label:O,group:G,isDefault:de,hasConfigurationHandler:!1,supportsContinuousRun:Q})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$tec=v;const C={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(Se[339],De([1,0,19,9,4,6,150,14,7]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class m{constructor(P,g){this.i=g,this.a=new f.$Nd({onListenerError:F.$1}),this.b=new f.$Nd({onListenerError:F.$1}),this.c=new f.$Nd({onListenerError:F.$1}),this.d=new f.$Nd({onListenerError:F.$1}),this.f=new f.$Nd({onListenerError:F.$1}),this.g=new f.$Nd({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(L.$tK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const g=this.i.allEditors();return P?g:g.map(y=>y.value)}async showTextDocument(P,g,y){let D;typeof g=="number"?D={position:p.ViewColumn.from(g),preserveFocus:y}:typeof g=="object"?D={position:p.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?p.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:D={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(P.uri,D),u=w&&this.i.getEditor(w);if(u)return u.value;throw w?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,g){return new R.$BM(this.h,P,g).value}$acceptEditorPropertiesChanged(P,g){const y=this.i.getEditor(P);if(!y)throw new Error("unknown text editor");if(g.options&&y._acceptOptions(g.options),g.selections){const D=g.selections.selections.map(p.Selection.to);y._acceptSelections(D)}if(g.visibleRanges){const D=I.$Gb(g.visibleRanges.map(p.Range.to));y._acceptVisibleRanges(D)}if(g.options&&this.b.fire({textEditor:y.value,options:{...g.options,lineNumbers:p.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const D=E.TextEditorSelectionChangeKind.fromValue(g.selections.source),w=g.selections.selections.map(p.Selection.to);this.a.fire({textEditor:y.value,selections:w,kind:D})}if(g.visibleRanges){const D=I.$Gb(g.visibleRanges.map(p.Range.to));this.c.fire({textEditor:y.value,visibleRanges:D})}}$acceptEditorPositionData(P){for(const g in P){const y=this.i.getEditor(g);if(!y)throw new Error("Unknown text editor");const D=p.ViewColumn.to(P[g]);y.value.viewColumn!==D&&(y._acceptViewColumn(D),this.d.fire({textEditor:y.value,viewColumn:D}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$Idc=m}),define(Se[340],De([1,0,2,5,6,3,7,14,25,17]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0,e.$kec=(0,F.$Ph)("IExtHostTimeline");class A{constructor(y,D){this.b=new Map,this.c=new Map,this.a=y.getProxy(f.$tK.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(w,u)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&E.$6l.equals(u,this.b.get(w.source)?.extension)){const c=w.uri===void 0?void 0:I.URI.revive(w.uri);return this.c.get(w.source)?.get(P(c))?.get(w.handle)}else return;return w}})}async $getTimeline(y,D,w,u){return this.b.get(y)?.provider.provideTimeline(I.URI.revive(D),w,u)}registerTimelineProvider(y,D,w,u){const c=new L.$Qc,i=this.d(D.id,u,c).bind(this);let s;D.onDidChange&&(s=D.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:D.id}),this));const r=this.c;return this.f({...D,scheme:y,onDidChange:void 0,async provideTimeline(o,t,n){t?.resetCache&&(c.clear(),r.get(D.id)?.clear());const d=await D.provideTimeline(o,t,n);if(d==null)return;const l=i(o,t);return{...d,source:D.id,items:d.items.map(l)}},dispose(){for(const o of r.values())o.get(D.id)?.clear();s?.dispose(),c.dispose()}},w)}d(y,D,w){return(u,c)=>{let i;if(c?.cacheResults){let s=this.c.get(y);s===void 0&&(s=new Map,this.c.set(y,s));const r=P(u);i=s.get(r),i===void 0&&(i=new Map,s.set(r,i))}return s=>{const{iconPath:r,...o}=s,t=`${y}|${s.id??s.timestamp}`;i?.set(t,s);let n,d,l;s.iconPath&&(r instanceof R.$pL?l={id:r.id,color:r.color}:I.URI.isUri(r)?(n=r,d=r):{light:n,dark:d}=r);let a;return R.$VK.isMarkdownString(o.tooltip)?a=p.MarkdownString.from(o.tooltip):(0,m.$yf)(o.tooltip)?a=o.tooltip:R.$VK.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=p.MarkdownString.from(o.detail)):(0,m.$yf)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=o.detail),{...o,id:o.id??void 0,handle:t,source:y,command:s.command?D.toInternal(s.command,w):void 0,icon:n,iconDark:d,themeIcon:l,tooltip:a,accessibilityInformation:s.accessibilityInformation}}}}f(y,D){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:D}),(0,L.$Pc)(()=>{for(const u of this.c.values())u.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$lec=A;function P(g){return g?.toString()}}),define(Se[73],De([1,0,21,4,3,221,5,15,87,6,27,20,7]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wwb=e.$vwb=e.TunnelDtoConverter=void 0;class y extends E.$jv{}var D;(function(u){function c(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public,privacy:s.privacy??(s.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:s.protocol}}u.fromApiTunnel=c;function i(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.privacy!==E.TunnelPrivacyId.ConstantPrivate&&s.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:s.privacy,protocol:s.protocol}}u.fromServiceTunnel=i})(D||(e.TunnelDtoConverter=D={})),e.$vwb=(0,R.$Ph)("IExtHostTunnelService");let w=class extends f.$Rc{constructor(c,i,s){super(),this.s=s,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(m.$tK.MainThreadTunnelService)}async openTunnel(c,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const s=await this.a.$openTunnel(i,c.displayName);if(s){const r=new y(s.remoteAddress,s.localAddress,()=>this.a.$closeTunnel(s.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,i){const s=this.u();return this.r.set(s,{selector:c,provider:i}),this.a.$registerPortsAttributesProvider(c,s),new g.$vK(()=>{this.r.delete(s),this.a.$unregisterPortsAttributesProvider(s)})}async $providePortAttributes(c,i,s,r,o){const t=[];for(const d of c){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(i.map(async a=>{let h;try{h=await l.provider.providePortAttributes({port:a,pid:s,commandLine:r},o)}catch{h=await l.provider.providePortAttributes(a,s,r,o)}return{providedAttributes:h,port:a}})))}const n=t.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,o)=>await c.provideTunnel(r,o,new I.$Xd().token)??void 0;const s=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(s),Promise.resolve((0,f.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,i){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const s=c.tunnelFactory??(i?this.w(i):void 0);if(s){this.b=s;let r=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const o=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:r}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,f.$Pc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,i){if(this.g.has(c.host)){const s=this.g.get(c.host);s.has(c.port)&&(i&&s.get(c.port).disposeListener.dispose(),await s.get(c.port).tunnel.dispose(),s.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const s=this.b(c,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),s!==void 0){const r=await s;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const o=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:r,disposeListener:o}),D.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(s){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),s instanceof Error)return s.message}}async $applyCandidateFilter(c){const i=await Promise.all(c.map(r=>this.f(r.host,r.port,r.detail??""))),s=c.filter((r,o)=>i[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(r=>r.port).join(", ")} to ${s.map(r=>r.port).join(", ")}`),s}};e.$wwb=w,e.$wwb=w=He([Be(0,P.$uM),Be(1,A.$KM),Be(2,p.$0i)],w)}),define(Se[341],De([1,0,3,18,2,6]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$tK.MainThreadUriOpeners)}registerExternalUriOpener(E,m,A,P){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const g=P.schemes.find(y=>!R.a.has(y));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this.c.set(m,A),this.b.$registerUriOpener(m,P.schemes,E,P.label),(0,I.$Pc)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(E,m,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const g=f.URI.revive(m);return P.canOpenExternalUri(g,A)}async $openUri(E,m,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(f.URI.revive(m.resolvedUri),{sourceUri:f.URI.revive(m.sourceUri)},A)}}e.$uec=R}),define(Se[342],De([1,0,6,2,3,9,25]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class p{static{this.a=0}constructor(m){this.c=new R.$7l,this.d=new Map,this.b=m.getProxy(I.$tK.MainThreadUrls)}registerUriHandler(m,A){const P=m.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const g=p.a++;return this.c.add(P),this.d.set(g,A),this.b.$registerUriHandler(g,P,m.displayName||m.name),(0,f.$Pc)(()=>{this.c.delete(P),this.d.delete(g),this.b.$unregisterUriHandler(g)})}$handleExternalUri(m,A){const P=this.d.get(m);if(!P)return Promise.resolve(void 0);try{P.handleUri(F.URI.revive(A))}catch(g){(0,L.$Z)(g)}return Promise.resolve(void 0)}async createAppUri(m){return F.URI.revive(await this.b.$createAppUri(m))}}e.$Kdc=p}),define(Se[92],De([1,0,4,3,18,24,2,236,273,112,6]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0;class P{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(r,o,t,n,d,l,a){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new I.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$Nd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=o,this.#r=t,this.#l=n,this.#u=d,this.#n=l,this.#c=g(l),this.#d=y(l),this.#i=a}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#a=!0,(0,m.$upb)(r,this.#l)}get cspSource(){const r=this.#n.extensionLocation;if(r.scheme===f.Schemas.https||r.scheme===f.Schemas.http){let o=r.toString();return o.endsWith("/")||(o+="/"),o+" "+m.$tpb}return m.$tpb}get html(){return this.a(),this.#s}set html(r){this.a(),this.#s!==r&&(this.#s=r,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#r}set options(r){this.a(),L.$$m(this.#r,r)||this.#t.$setOptions(this.#e,u(this.#n,this.#u,r)),this.#r=r}async postMessage(r){if(this.#o)return!1;const o=(0,E.$Rcb)(r,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const o=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,a,h,S)=>{const k=R.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),$=(0,m.$upb)(k,{isRemote:o,authority:t}).toString();return`${d}${$}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,a,h,S)=>{const k=R.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),$=(0,m.$upb)(k,{isRemote:o,authority:t}).toString();return`${d}${$}${S}`})}}e.$Ldc=P;function g(s){try{const r=(0,p.$Qo)((0,p.$Po)(s.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$Mdc=g;function y(s){try{const r=(0,p.$Qo)((0,p.$Po)(s.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class D extends F.$Rc{constructor(r,o,t,n,d){super(),this.c=o,this.f=t,this.g=n,this.h=d,this.b=new Map,this.a=r.getProxy(A.$tK.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,o,t){const n=this.j(r);if(n){const{message:d}=(0,E.$Scb)(o,t.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(r,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,o,t){const n=new P(r,this.a,c(o),this.c,this.f,t,this.h);this.b.set(r,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return n}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Ndc=D;function w(s){return{id:s.identifier,location:s.extensionLocation}}e.$Odc=w;function u(s,r,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||i(s,r)}}e.$Pdc=u;function c(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(r=>R.URI.from(r))}}function i(s,r){return[...(r?.getWorkspaceFolders()||[]).map(o=>o.uri),s.extensionLocation]}}),define(Se[343],De([1,0,21,52,3,18,23,2,14,92,109,6,7]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class y{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new A.$Hcc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=o(this.document.uri)+this.a++;return(0,R.$vg)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class D{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const a=this.b(n,d.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const h=new y(d,l);return this.a.set(a,h),h}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class u{constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(0,n,d,l)}addCustomProvider(n,d,l){return this.b(1,n,d,l)}get(n){return this.a.get(n)}b(n,d,l,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:n,extension:l,provider:a}),new g.$vK(()=>this.a.delete(d))}}class c{constructor(n,d,l,a,h){this.d=d,this.f=l,this.g=a,this.h=h,this.b=new u,this.c=new D,this.a=n.getProxy(P.$tK.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,a){const h=new f.$Qc;return s(l)?(h.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,m.$Odc)(n),d,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,m.$Mdc)(n))):(h.add(this.b.addCustomProvider(d,n,l)),i(l)&&h.add(l.onDidChangeCustomDocument(S=>{const k=this.i(d,S.document.uri);if(r(S)){const $=k.addEdit(S);this.a.$onDidEdit(S.document.uri,d,$,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,m.$Odc)(n),d,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,m.$Mdc)(n))),g.$vK.from(h,new g.$vK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,a,h){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${d}'`);const k=p.URI.revive(n),$=await S.provider.openCustomDocument(k,{backupId:l,untitledDocumentData:a?.buffer},h);let b;return i(S.provider)&&this.f&&(b=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,$,b),{editable:i(S.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const a=p.URI.revive(n),{document:h}=this.i(d,a);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(n,d,l,a,h,S){const k=this.b.get(l);if(!k)throw new Error(`No provider found for '${l}'`);const $=E.ViewColumn.to(h),b=this.g.createNewWebview(d,a.contentOptions,k.extension),v=this.h.createNewWebviewPanel(d,l,a.title,$,a.options,b,a.active),C=p.URI.revive(n);switch(k.type){case 1:{const{document:N}=this.i(l,C);return k.provider.resolveCustomEditor(N,v,S)}case 0:{const N=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(N,v,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const a=this.b.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(n);if(!h)throw new Error("No webview found");const S=p.URI.revive(d),k=this.d.getDocument(S);await a.provider.moveCustomTextEditor(k,h,I.CancellationToken.None)}async $undo(n,d,l,a){return this.i(d,n).undo(l,a)}async $redo(n,d,l,a){return this.i(d,n).redo(l,a)}async $revert(n,d,l){const a=this.i(d,n);await this.j(d).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(n,d,l){const a=this.i(d,n);await this.j(d).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(n,d,l,a){const h=this.i(d,n);return this.j(d).saveCustomDocumentAs(h.document,p.URI.revive(l),a)}async $backup(n,d,l){const a=this.i(d,n),S=await this.j(d).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(S),S.id}i(n,d){const l=this.c.get(n,p.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!i(l))throw new Error("Custom document is not editable");return l}}e.$oec=c;function i(t){return!!t.onDidChangeCustomDocument}function s(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const n=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Di)(n)+""}}),define(Se[344],De([1,0,4,3,2,32,14,92,6,7]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class A extends F.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,w,u,c){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new I.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=w,this.#l=u,this.#i=c.viewType,this.#u=c.panelOptions,this.#r=c.viewColumn,this.#n=c.title,this.#a=c.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,f.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:R.ViewColumn.from(D),preserveFocus:!!w})}c(){if(this.#c)throw new Error("Webview is disposed")}}class P extends F.$Rc{static c(){return(0,L.$eg)()}constructor(D,w,u){super(),this.j=w,this.m=u,this.g=new Map,this.h=new Map,this.f=D.getProxy(E.$tK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,w,u,c,i={}){const s=typeof c=="object"?c.viewColumn:c,r={viewColumn:R.ViewColumn.from(s),preserveFocus:typeof c=="object"&&!!c.preserveFocus},o=(0,p.$Mdc)(D),t=P.c();this.f.$createWebviewPanel((0,p.$Odc)(D),t,w,{title:u,panelOptions:g(i),webviewOptions:(0,p.$Pdc)(D,this.m,i),serializeBuffersForPostMessage:o},r);const n=this.j.createNewWebview(t,i,D);return this.createNewWebviewPanel(t,w,u,s,i,n,!0)}$onDidChangeWebviewPanelViewStates(D){const w=Object.keys(D);w.sort((u,c)=>{const i=D[u],s=D[c];return i.active?1:s.active?-1:+i.visible-+s.visible});for(const u of w){const c=this.getWebviewPanel(u);if(!c)continue;const i=D[u];c._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,w,u){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:u,extension:D}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,p.$Mdc)(D)}),new m.$vK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(D,w,u,c){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:s,extension:r}=i,o=this.j.createNewWebview(D,u.webviewOptions,r),t=this.createNewWebviewPanel(D,w,u.title,c,u.panelOptions,o,u.active);await s.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(D,w,u,c,i,s,r){const o=new A(D,this.f,s,{viewType:w,title:u,viewColumn:c,panelOptions:i,active:r});return this.g.set(D,o),o}getWebviewPanel(D){return this.g.get(D)}}e.$nec=P;function g(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Se[345],De([1,0,4,3,92,14,6,7]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class E extends F.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(P,g,y,D,w,u){super(),this.#u=!1,this.#a=this.B(new I.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new I.$Nd),this.onDidDispose=this.#c.event,this.#i=y,this.#s=D,this.#e=P,this.#t=g,this.#l=w,this.#n=u}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#r}set description(P){this.a(),this.#r!==P&&(this.#r=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#u||(this.#n=P,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(P){this.a(),!(P?.value===this.#o?.value&&P?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#u)throw new Error("Webview is disposed")}}class m{constructor(P,g){this.d=g,this.b=new Map,this.c=new Map,this.a=P.getProxy(R.$tK.MainThreadWebviewViews)}registerWebviewViewProvider(P,g,y,D){if(this.b.has(g))throw new Error(`View provider for '${g}' already registered`);return this.b.set(g,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,f.$Odc)(P),g,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$Mdc)(P)}),new p.$vK(()=>{this.b.delete(g),this.a.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(P,g,y,D,w){const u=this.b.get(g);if(!u)throw new Error(`No view provider found for '${g}'`);const{provider:c,extension:i}=u,s=this.d.createNewWebview(P,{},i),r=new E(P,this.a,g,y,s,!0);this.c.set(P,r),await c.resolveWebviewView(r,{state:D},w)}async $onDidChangeWebviewViewVisibility(P,g){this.e(P)._setVisible(g)}async $disposeWebviewView(P){const g=this.e(P);this.c.delete(P),g.dispose(),this.d.deleteWebview(P)}e(P){const g=this.c.get(P);if(!g)throw new Error("No webview found");return g}}e.$mec=m}),define(Se[153],De([1,0,4,6,2,18,13,5,20,26]),function($e,e,I,F,f,L,R,p,E,m){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(y){const D=this.d;return{get focused(){return D.focused},get active(){return(0,m.$lF)(y,"windowActivity"),D.active}}}constructor(y){this.c=new I.$Nd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(F.$tK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:w})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,D){D!==this.d[y]&&(this.d={...this.d,[y]:D},this.c.fire(this.d))}openUri(y,D){let w;if(typeof y=="string"){w=y;try{y=f.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.$Be)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,w,D)}async asExternalUri(y,D){if((0,R.$Be)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(y,D);return f.URI.from(w)}};e.$Qdc=P,e.$Qdc=P=A=He([Be(0,E.$uM)],P),e.$Rdc=(0,p.$Ph)("IExtHostWindow")}),define(Se[346],De([1,0,314,27,20]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;const L=1024*1024;let R=class extends I.$Rec{constructor(E,m){super(E,m),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,m,A){const P=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),m.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,m){const A=process[E],P=A.write;let g="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,D,w)=>{if(!this.g){g+=y.toString(D);const u=g.length>L?g.length:g.lastIndexOf(`
`);u!==-1&&(console[m](g.slice(0,u)),g=g.slice(u+1))}P.call(A,y,D,w)}})}};e.$qfc=R,e.$qfc=R=He([Be(0,f.$uM),Be(1,F.$KM)],R)}),define(Se[347],De([1,0,72,18,15,248,31,12]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;let E=class{constructor(P,g){P.addFileSystemProvider(F.Schemas.file,new m(g),{isCaseSensitive:p.$l})}};e.$rfc=E,e.$rfc=E=He([Be(0,I.$ddc),Be(1,f.$0i)],E);class m{constructor(P){this.b=P,this.a=new L.$dq(this.b)}async stat(P){const g=await this.a.stat(P);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,g,y){return this.a.writeFile(P,g,{...y,unlock:!1,atomic:!1})}delete(P,g){return this.a.delete(P,{...g,useTrash:!1,atomic:!1})}rename(P,g,y){return this.a.rename(P,g,y)}copy(P,g,y){return this.a.copy(P,g,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,g){throw new Error("Method not implemented.")}}}),define(Se[348],De([1,0,16,63,32,34,3,6,2,20]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;let A=class extends R.$Rc{constructor(g,y){super();const D=g.getProxy(p.$tK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async w=>{const u=E.URI.file((0,I.$ic)((0,F.tmpdir)(),(0,f.$eg)()));return await D.$download(w,u),u})}};e.$pfc=A,e.$pfc=A=He([Be(0,m.$uM),Be(1,L.$QM)],A)}),define(Se[349],De([1,0,152,18,250,32]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class R extends I.$Qec{s(E,m,A){return E.scheme===F.Schemas.file?new f.$GN(A?.name||(0,L.$eg)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,m):super.s(E,m,A)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$Cfc=R}),define(Se[350],De([1,0,55,16,2,91,3,18,8,30]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class A extends L.$fdc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==p.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let a;l===0?a=d:a=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await P(a);const h=F.$ic(a,"vscode.lock"),S=await w(this.d,h,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),f.URI.file(a);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Bfc=A;async function P(o){try{await m.Promises.stat(o);return}catch{}try{await m.Promises.mkdir(o,{recursive:!0})}catch{}}const g=1e3,y=10*60*1e3;class D extends R.$Rc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$5g),this.a.cancelAndSet(async()=>{const d=await u(t,n);(!d||d.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await m.Promises.utimes(n,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${n}': Could not update mtime.`)}},g)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await m.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function w(o,t,n){try{const l={pid:process.pid,willReleaseAt:0};await m.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){o.error(l)}const d=await u(o,t);return!d||d.pid!==process.pid?n?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),s(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new D(o,t))}async function u(o,t){let n;try{n=await m.Promises.readFile(t)}catch(d){return o.error(d),null}try{return JSON.parse(String(n))}catch(d){return o.error(d),null}}async function c(o,t){let n;try{n=await m.Promises.stat(t)}catch(d){return o.error(d),0}return n.mtime.getTime()}function i(o){try{return process.kill(o,0),!0}catch{return!1}}async function s(o,t){const n=await u(o,t);if(!n)return o.info(`Lock '${t}': Could not read pid of lock holder.`),r(o,t);if(n.willReleaseAt){let S=n.willReleaseAt-Date.now();if(S<5e3){for(S>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,E.$Ug)(Math.min(100,S)),await c(o,t)===0)return r(o,t);S=n.willReleaseAt-Date.now()}return r(o,t)}}if(!i(n.pid))return o.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),r(o,t);const d=await c(o,t),l=Date.now()-d;if(l<=y)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Ug)(2e3);const a=await c(o,t),h=Date.now()-a;return h<=y?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(o,t))}async function r(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await m.Promises.unlink(t)}catch{}return w(o,t,!0)}}),define(Se[351],De([1,0,32,20,45,34]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;let R=class extends f.$idc{constructor(E,m){super(!0,E,m)}createTerminal(E,m,A){return this.createTerminalFromOptions({name:E,shellPath:m,shellArgs:A})}createTerminalFromOptions(E,m){const A=new f.$hdc(this.a,(0,I.$eg)(),E,E.name);return this.f.push(A),A.create(E,this.R(E,m)),A.value}};e.$Wec=R,e.$Wec=R=He([Be(0,L.$QM),Be(1,F.$uM)],R)}),define(Se[352],De([1,0,8,22,21,9,4,3,130,302,69]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=e.ResponsiveState=e.RequestInitiator=e.$84b=e.$74b=void 0;function g(v,C){try{return JSON.stringify(v,C)}catch{return"null"}}const y="$$ref$$",D={[y]:-1};class w{constructor(C,N){this.jsonString=C,this.referencedBuffers=N}}function u(v,C=null,N=!1){const T=[];return{jsonString:(N?g:JSON.stringify)(v,(U,j)=>{if(typeof j>"u")return D;if(typeof j=="object"){if(j instanceof F.$be){const O=T.push(j)-1;return{[y]:O}}if(C)return C(U,j)}return j}),referencedBuffers:T}}e.$74b=u;function c(v,C,N){return JSON.parse(v,(T,M)=>{if(M){const U=M[y];if(typeof U=="number")return C[U];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$84b=c;function i(v,C){return JSON.stringify(v,C)}function s(v){return v?(C,N)=>N&&N.$mid===1?v.transformOutgoing(N):N:null}var r;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var o;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},n=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends p.$Rc{static{P=n}static{this.a=3*1e3}constructor(C,N=null,T=null){super(),this[P]=!0,this.b=this.B(new R.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=N,this.g=T,this.h=s(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,U=A.$qv.count;M<U;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$6g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const N=this.w[C];delete this.w[C],N.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,E.$Om)(C,this.g):C}getProxy(C){const{nid:N,sid:T}=C;return this.s[N]||(this.s[N]=this.J(N,T)),this.s[N]}J(C,N){const T={get:(M,U)=>(typeof U=="string"&&!M[U]&&U.charCodeAt(0)===36&&(M[U]=(...j)=>this.U(C,U,j)),U===d?N:M[U])};return new Proxy(Object.create(null),T)}set(C,N){return this.m[C.nid]=N,N}assertRegistered(C){for(let N=0,T=C.length;N<T;N++){const M=C[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(C){if(this.j)return;const N=C.byteLength,T=h.read(C,0),M=T.readUInt8(),U=T.readUInt32();switch(M){case 1:case 2:{let{rpcId:j,method:O,args:V}=k.deserializeRequestJSONArgs(T);this.g&&(V=(0,E.$Om)(V,this.g)),this.M(N,U,j,O,V,M===2);break}case 3:case 4:{let{rpcId:j,method:O,args:V}=k.deserializeRequestMixedArgs(T);this.g&&(V=(0,E.$Om)(V,this.g)),this.M(N,U,j,O,V,M===4);break}case 5:{this.f?.logIncoming(N,U,0,"ack"),this.G(U);break}case 6:{this.N(N,U);break}case 7:{this.O(N,U,void 0);break}case 9:{let j=k.deserializeReplyOKJSON(T);this.g&&(j=(0,E.$Om)(j,this.g)),this.O(N,U,j);break}case 10:{const j=k.deserializeReplyOKJSONWithBuffers(T,this.g);this.O(N,U,j);break}case 8:{const j=k.deserializeReplyOKVSBuffer(T);this.O(N,U,j);break}case 11:{let j=k.deserializeReplyErrError(T);this.g&&(j=(0,E.$Om)(j,this.g)),this.P(N,U,j);break}case 12:{this.P(N,U,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,N,T,M,U,j){this.f?.logIncoming(C,N,1,`receiveRequest ${(0,A.$sv)(T)}.${M}(`,U);const O=String(N);let V,q;if(j){const x=new f.$Xd;U.push(x.token),V=this.Q(T,M,U),q=()=>x.cancel()}else V=this.Q(T,M,U),q=t;this.u[O]=q;const de=k.serializeAcknowledged(N);this.f?.logOutgoing(de.byteLength,N,1,"ack"),this.c.send(de),V.then(x=>{delete this.u[O];const Q=k.serializeReplyOK(N,x,this.h);this.f?.logOutgoing(Q.byteLength,N,1,"reply:",x),this.c.send(Q)},x=>{delete this.u[O];const Q=k.serializeReplyErr(N,x);this.f?.logOutgoing(Q.byteLength,N,1,"replyErr:",x),this.c.send(Q)})}N(C,N){this.f?.logIncoming(C,N,1,"receiveCancel");const T=String(N);this.u[T]?.()}O(C,N,T){this.f?.logIncoming(C,N,0,"receiveReply:",T);const M=String(N);if(!this.w.hasOwnProperty(M))return;const U=this.w[M];delete this.w[M],U.resolveOk(T)}P(C,N,T){this.f?.logIncoming(C,N,0,"receiveReplyErr:",T);const M=String(N);if(!this.w.hasOwnProperty(M))return;const U=this.w[M];delete this.w[M];let j;T&&(T.$isError?(j=new Error,j.name=T.name,j.message=T.message,j.stack=T.stack):j=T),U.resolveErr(j)}Q(C,N,T){try{return Promise.resolve(this.S(C,N,T))}catch(M){return Promise.reject(M)}}S(C,N,T){const M=this.m[C];if(!M)throw new Error("Unknown actor "+(0,A.$sv)(C));const U=M[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$sv)(C));return U.apply(M,T)}U(C,N,T){if(this.j)return new m.$64b;let M=null;if(T.length>0&&f.CancellationToken.isCancellationToken(T[T.length-1])&&(M=T.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$5());const U=k.serializeRequestArguments(T,this.h),j=++this.t,O=String(j),V=new m.$54b,q=new p.$Qc;M&&q.add(M.onCancellationRequested(()=>{const x=k.serializeCancel(j);this.f?.logOutgoing(x.byteLength,j,0,"cancel"),this.c.send(k.serializeCancel(j))})),this.w[O]=new a(V,q),this.F(j);const de=k.serializeRequest(j,C,N,U,!!M);return this.f?.logOutgoing(de.byteLength,j,0,`request: ${(0,A.$sv)(C)}.${N}(`,T),this.c.send(de),V}}e.$94b=l;class a{constructor(C,N){this.a=C,this.b=N}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,N,T){const M=new h(F.$be.alloc(T+1+4),0);return M.writeUInt8(C),M.writeUInt32(N),M}static read(C,N){return new h(C,N)}get buffer(){return this.a}constructor(C,N){this.a=C,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const T=this.a.slice(this.b,this.b+C).toString();return this.b+=C,T}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+C).toString();return this.b+=C,T}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+C);return this.b+=C,N}static sizeMixedArray(C){let N=0;N+=1;for(let T=0,M=C.length;T<M;T++){const U=C[T];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let j=0;j<U.buffers.length;++j)N+=this.sizeVSBuffer(U.buffers[j]);break;case 4:break}}return N}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let N=0,T=C.length;N<T;N++){const M=C[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let U=0;U<M.buffers.length;++U)this.writeBuffer(M.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const N=new Array(C);for(let T=0;T<C;T++)switch(this.readUInt8()){case 1:N[T]=this.readLongString();break;case 2:N[T]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),j=this.readLongString(),O=[];for(let V=0;V<U;++V)O.push(this.readVSBuffer());N[T]=new A.$tv(c(j,O,null));break}case 4:N[T]=void 0;break}return N}}var S;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(S||(S={}));class k{static a(C){for(let N=0,T=C.length;N<T;N++)if(C[N]instanceof F.$be||C[N]instanceof A.$tv||typeof C[N]>"u")return!0;return!1}static serializeRequestArguments(C,N){if(this.a(C)){const T=[];for(let M=0,U=C.length;M<U;M++){const j=C[M];if(j instanceof F.$be)T[M]={type:2,value:j};else if(typeof j>"u")T[M]={type:4};else if(j instanceof A.$tv){const{jsonString:O,referencedBuffers:V}=u(j.value,N);T[M]={type:3,value:F.$be.fromString(O),buffers:V}}else T[M]={type:1,value:F.$be.fromString(i(j,N))}}return{type:1,args:T}}return{type:0,args:i(C,N)}}static serializeRequest(C,N,T,M,U){switch(M.type){case 0:return this.b(C,N,T,M.args,U);case 1:return this.c(C,N,T,M.args,U)}}static b(C,N,T,M,U){const j=F.$be.fromString(T),O=F.$be.fromString(M);let V=0;V+=h.sizeUInt8(),V+=h.sizeShortString(j),V+=h.sizeLongString(O);const q=h.alloc(U?2:1,C,V);return q.writeUInt8(N),q.writeShortString(j),q.writeLongString(O),q.buffer}static deserializeRequestJSONArgs(C){const N=C.readUInt8(),T=C.readShortString(),M=C.readLongString();return{rpcId:N,method:T,args:JSON.parse(M)}}static c(C,N,T,M,U){const j=F.$be.fromString(T);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(j),O+=h.sizeMixedArray(M);const V=h.alloc(U?4:3,C,O);return V.writeUInt8(N),V.writeShortString(j),V.writeMixedArray(M),V.buffer}static deserializeRequestMixedArgs(C){const N=C.readUInt8(),T=C.readShortString(),M=C.readMixedArray(),U=new Array(M.length);for(let j=0,O=M.length;j<O;j++){const V=M[j];typeof V=="string"?U[j]=JSON.parse(V):U[j]=V}return{rpcId:N,method:T,args:U}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,N,T){if(typeof N>"u")return this.d(C);if(N instanceof F.$be)return this.e(C,N);if(N instanceof A.$tv){const{jsonString:M,referencedBuffers:U}=u(N.value,T,!0);return this.g(C,M,U)}else return this.f(C,g(N,T))}static d(C){return h.alloc(7,C,0).buffer}static e(C,N){let T=0;T+=h.sizeVSBuffer(N);const M=h.alloc(8,C,T);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,N){const T=F.$be.fromString(N);let M=0;M+=h.sizeLongString(T);const U=h.alloc(9,C,M);return U.writeLongString(T),U.buffer}static g(C,N,T){const M=F.$be.fromString(N);let U=0;U+=h.sizeUInt32,U+=h.sizeLongString(M);for(const O of T)U+=h.sizeVSBuffer(O);const j=h.alloc(10,C,U);j.writeUInt32(T.length),j.writeLongString(M);for(const O of T)j.writeBuffer(O);return j.buffer}static deserializeReplyOKJSON(C){const N=C.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(C,N){const T=C.readUInt32(),M=C.readLongString(),U=[];for(let j=0;j<T;++j)U.push(C.readVSBuffer());return new A.$tv(c(M,U,N))}static serializeReplyErr(C,N){const T=N?g(L.$2(N),null):void 0;if(typeof T!="string")return this.h(C);const M=F.$be.fromString(T);let U=0;U+=h.sizeLongString(M);const j=h.alloc(11,C,U);return j.writeLongString(M),j.buffer}static deserializeReplyErrError(C){const N=C.readLongString();return JSON.parse(N)}static h(C){return h.alloc(12,C,0).buffer}}var $;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var b;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(b||(b={}))}),define(Se[353],De([1,0,4,43,42,5]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.OutputChannelUpdateMode=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=void 0,e.$BJ="text/x-code-output",e.$CJ="output",e.$DJ="Log",e.$EJ="text/x-code-log-output",e.$FJ="log",e.$GJ="workbench.panel.output",e.$HJ=new f.$7i("inOutput",!1),e.$IJ=new f.$7i("activeLogOutput",!1),e.$JJ=new f.$7i("outputView.scrollLock",!1),e.$KJ=(0,L.$Ph)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$LJ={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new I.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(A=>m.push(A)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}F.$jn.add(e.$LJ.OutputChannels,new p),e.$MJ=new f.$7i("activeOutputChannel","")}),define(Se[154],De([1,0,6,5,20,25,15,353,72,27,57,181,22,17,31,4,3]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class c extends R.$dj{get disposed(){return this.n}constructor(o,t,n,d,l){super(),this.id=o,this.name=t,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=g.$be.fromString(t).byteLength,(0,R.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends c{appendLine(o){this.append(o)}}let s=class{constructor(o,t,n,d,l,a){this.i=t,this.j=n,this.k=d,this.l=l,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(I.$tK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(o,t,n){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,y.$yf)(t)?t:void 0;if((0,y.$yf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([k])=>L.$6l.equals(n.identifier,k))?.[1];h&&(a=(0,R.$nj)(h));const S=d?this.o(o,a,n):this.n(o,l,n);return S.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),d?this.r(o,a??this.m.getLevel(),S):this.q(o,S)}async n(o,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(o,l,t,n.identifier.value);return new c(h,o,a,this.a,n)}async o(o,t,n){const d=await this.p(n),l=o.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(d,`${l}.log`),h=`${n.identifier.value}.${l}`,S=this.l.createLogger(a,{id:h,name:o,logLevel:t,extensionId:n.identifier.value});return new i(h,o,S,this.a,n)}p(o){let t=this.d.get(o.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,D.$ok)(d)!==D.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return t}q(o,t){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return o},append(l){d(),t.then(a=>a.append(l))},appendLine(l){d(),t.then(a=>a.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(a=>a.replace(l))},show(l,a){d(),t.then(h=>h.show(l,a))},hide(){d(),t.then(l=>l.hide())},dispose(){n=!0,t.then(l=>l.dispose())}}}r(o,t,n){const d=new u.$Qc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},a=d.add(new w.$Nd);function h(S){t=S,a.fire(S)}return n.then(S=>{d.add(S),S.logLevel!==t&&h(S.logLevel),d.add(S.onDidChangeLogLevel(k=>h(k)))}),{...this.q(o,n),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(S,...k){l(),n.then($=>$.trace(S,...k))},debug(S,...k){l(),n.then($=>$.debug(S,...k))},info(S,...k){l(),n.then($=>$.info(S,...k))},warn(S,...k){l(),n.then($=>$.warn(S,...k))},error(S,...k){l(),n.then($=>$.error(S,...k))},dispose(){d.dispose()}}}};e.$Adc=s,e.$Adc=s=He([Be(0,f.$uM),Be(1,m.$KM),Be(2,E.$ddc),Be(3,A.$Kcc),Be(4,R.$$i),Be(5,R.$0i)],s),e.$Bdc=(0,F.$Ph)("IExtHostOutputService")}),define(Se[354],De([1,0,5,8]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,I.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let L=1/0;for(let p=0;p<this.maxSampleCount;p++){const E=await f.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$Ug)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((p,E)=>p+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((p,E)=>p+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[355],De([1,0,33,18,16,12,23,2,5,266,44,146,354]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=void 0,e.$5J=(0,E.$Ph)("pathService");let D=y=class{constructor(u,c,i,s){this.d=u,this.e=c,this.f=i,this.g=s,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??u})()}hasValidBasename(u,c,i){return typeof c=="string"||typeof c>"u"?this.a.then(s=>this.h(u,s,c)):this.h(u,c,i)}h(u,c,i){return u.scheme===F.Schemas.file||u.scheme===F.Schemas.vscodeRemote?(0,I.$Vf)(i??(0,R.$sg)(u),c===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,c){if(u.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,m.$2J)(c.getWorkspace());if(i)return i;const s=c.getWorkspace().folders[0];if(s)return s.uri.scheme;const r=c.getWorkspace().configuration;return r?r.scheme:F.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?f.$ec:f.$fc)}async fileURI(u){let c="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const s=u.indexOf("/",2);s===-1?(c=u.substring(2),u="/"):(c=u.substring(2,s),u=u.substring(s)||"/")}return p.URI.from({scheme:F.Schemas.file,authority:c,path:u,query:"",fragment:""})}};e.$6J=D,e.$6J=D=y=He([Be(1,g.$tm),Be(2,P.$NJ),Be(3,A.$Yh)],D)}),define(Se[356],De([1,0,233,19,59,4,52,3,2,50,238,15,65,268,87,44,146,26,21,17,24,42]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$XJ=e.$WJ=e.OnPortForward=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.TunnelSource=e.TunnelCloseReason=e.$QJ=e.$PJ=e.$OJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$OJ="onTunnel",e.$PJ=new o.$7i("forwardedPortsViewEnabled",!1,I.localize(0,null));function d(N){const T=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}e.$QJ=d;var l;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var a;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$RJ={source:a.User,description:I.localize(1,null)},e.$SJ={source:a.Auto,description:I.localize(2,null)};function h(N,T,M){const U=N.get(k(T,M));if(U)return U;if((0,D.$fv)(T))for(const j of D.$ev){const O=k(j,M);if(N.has(O))return N.get(O)}else if((0,D.$hv)(T))for(const j of D.$gv){const O=k(j,M);if(N.has(O))return N.get(O)}}e.$TJ=h;function S(N,T,M){const U=h(N,T,M);if(U)return U;const j=(0,D.$hv)(T)?"localhost":(0,D.$fv)(T)?"0.0.0.0":void 0;if(j)return h(N,j,M)}e.$UJ=S;function k(N,T){return N+":"+T}e.$VJ=k;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function b(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$WJ=b;class v extends p.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new L.$Nd,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,M,U){let j=this.w(T,M,U,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const V=this.j[j];V.key===T?(O.onAutoForward=V.onAutoForward??O.onAutoForward,O.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:O.elevateIfNeeded,O.label=V.label??O.label,O.requireLocalPort=V.requireLocalPort,O.protocol=V.protocol):(O.onAutoForward=O.onAutoForward??V.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:V.elevateIfNeeded,O.label=O.label??V.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??V.protocol),j=this.w(T,M,U,this.j,j+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,s.$yf)(T.host)&&(0,s.$Cf)(T.port)}w(T,M,U,j,O){if(O>=j.length)return-1;const V=!(0,D.$fv)(M)&&!(0,D.$hv)(M),de=j.slice(O).findIndex(x=>(0,s.$Cf)(x.key)?V?!1:x.key===T:this.t(x.key)?V?!1:T>=x.key.start&&T<=x.key.end:this.u(x.key)?T===x.key.port&&M===x.key.host:U?x.key.test(U):!1);return de>=0?de+O:-1}y(){const T=this.r.getValue(v.c);if(!T||!(0,s.$Af)(T))return[];const M=[];for(const j in T){if(j===void 0)continue;const O=T[j];let V;if(Number(j))V=Number(j);else if((0,s.$yf)(j))if(v.g.test(j)){const q=j.match(v.g);V={start:Number(q[1]),end:Number(q[2])}}else if(v.h.test(j)){const q=j.match(v.h);V={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(j)}catch{}q&&(V=q)}V&&M.push({key:V,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const U=this.r.getValue(v.f);return U&&(this.m={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.z(M)}z(T){function M(U,j){return(0,s.$Cf)(U.key)?U.key:j.t(U.key)?U.key.start:j.u(U.key)?U.key.port:Number.MAX_VALUE}return T.sort((U,j)=>M(U,this)-M(j,this))}C(){return this.m}static providedActionToAction(T){switch(T){case D.ProvidedOnAutoForward.Notify:return $.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case D.ProvidedOnAutoForward.Silent:return $.Silent;case D.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(T,M,U){const O=this.r.inspect(v.c).userRemoteValue;let V;!O||!(0,s.$Af)(O)?V={}:V=(0,r.$7m)(O),V[`${T}`]||(V[`${T}`]={});for(const q in M)V[`${T}`][q]=M[q];return this.r.updateValue(v.c,V,U)}}e.$XJ=v;let C=class extends p.$Rc{constructor(T,M,U,j,O,V,q,de,x,Q){super(),this.H=T,this.I=M,this.J=U,this.L=j,this.M=O,this.N=V,this.O=q,this.P=de,this.Q=x,this.R=Q,this.c=new Map,this.g=new L.$Nd,this.onForwardPort=this.g.event,this.h=new L.$Nd,this.onClosePort=this.h.event,this.j=new L.$Nd,this.onPortName=this.j.event,this.n=new L.$Nd,this.onCandidatesChanged=this.n.event,this.t=new L.$Nd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Nd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new v(U),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async G=>{const ce=await this.getAttributes(G.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of G)if(ie.localAddress){const ae=k(ie.tunnelRemoteHost,ie.tunnelRemotePort),ye=S(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(ae,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:ce?.get(ie.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,ce?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:ie.privacy,source:e.$RJ}),this.f.set(ae,ie)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async G=>{const ce=k(G.tunnelRemoteHost,G.tunnelRemotePort);if(!S(this.forwarded,G.tunnelRemoteHost,G.tunnelRemotePort)&&!S(this.detected,G.tunnelRemoteHost,G.tunnelRemotePort)&&!S(this.c,G.tunnelRemoteHost,G.tunnelRemotePort)&&G.localAddress){const ie=S(this.m??new Map,G.tunnelRemoteHost,G.tunnelRemotePort),ae=(await this.getAttributes([{port:G.tunnelRemotePort,host:G.tunnelRemoteHost}]))?.get(G.tunnelRemotePort);this.forwarded.set(ce,{remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localAddress:G.localAddress,protocol:ae?.protocol??D.TunnelProtocol.Http,localUri:await this.X(G.localAddress,ae),localPort:G.tunnelLocalPort,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:G.privacy,source:e.$RJ})}await this.$(),this.f.set(ce,G),this.g.fire(this.forwarded.get(ce))})),this.B(this.H.onTunnelClosed(G=>this.W(G,l.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$OJ))?(this.R.createKey(e.$PJ.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,M){const U=k(T.host,T.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.$(),this.h.fire(T))}X(T,M){if(T.startsWith("http"))return E.URI.parse(T);const U=M?.protocol??"http";return E.URI.parse(`${U}://${T}`)}async Y(){const T=this.N.getWorkspace(),M=T.configuration?(0,R.$Di)(T.configuration.path):T.folders.length>0?(0,R.$Di)(T.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${M}`}async Z(){const T=this.I.get(n,1);if(T)return this.I.remove(n,1),await this.$(),T;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const M=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(U=>U.remotePort).join(", ")}`);for(const U of M){const j=S(this.detected,U.remoteHost,U.remotePort);U.source.source!==a.Extension&&!j||U.source.source===a.Extension&&j?await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===a.Extension&&!j&&this.D.set(k(U.remoteHost,U.remotePort),U)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Y();this.w=this.B(new p.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=JSON.stringify(Array.from(this.forwarded.values()));if(T!==this.y){this.y=T;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(T,M,U){if(!T.tunnelLocalPort||!U?.requireLocalPort||T.tunnelLocalPort===M)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const O=I.localize(3,null,M,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(O)}async forward(T,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(T,M)}async cb(T,M){await this.Q.activateByEvent(e.$OJ);const U=S(this.forwarded,T.remote.host,T.remote.port);M=M??(M!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const j=T.local!==void 0?T.local:T.remote.port;let O;if(U)return this.eb(U,T,M);{const V=this.L.remoteAuthority,q=V?{getAddress:async()=>(await this.M.resolveAuthority(V)).authority}:void 0,de=k(T.remote.host,T.remote.port);this.c.set(de,!0),T=this.db(de,T);const x=await this.H.openTunnel(q,T.remote.host,T.remote.port,void 0,j,T.elevateIfNeeded?T.elevateIfNeeded:M?.elevateIfNeeded,T.privacy,M?.protocol);if(typeof x=="string")O=x;else if(x&&x.localAddress){const Q=S(this.m??new Map,T.remote.host,T.remote.port),G=x.protocol?x.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:M?.protocol??D.TunnelProtocol.Http,ce={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:M?.label??T.name,closeable:!0,localAddress:x.localAddress,protocol:G,localUri:await this.X(x.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:T.source??e.$RJ,privacy:x.privacy};return this.forwarded.set(de,ce),this.f.set(de,x),this.c.delete(de),await this.$(),await this.bb(x,j,M),this.g.fire(ce),x}this.c.delete(de)}return O}db(T,M){const U=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(U){const j=U.get(T);U.delete(T),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=j.privacy??M.privacy)}return M}async eb(T,M,U){const j=U?.label??M.name;let O;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(O||(O={}));let V=O.None;switch(j!==T.name&&(T.name=j,V=O.Fire),(U?.protocol||T.protocol!==D.TunnelProtocol.Http)&&U?.protocol!==T.protocol&&(M.source=T.source,V=O.Reopen),M.privacy&&T.privacy!==M.privacy&&(V=O.Reopen),V){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(T.remoteHost,T.remotePort,l.User),await this.cb(M,U)}return S(this.f,M.remote.host,M.remote.port)}async name(T,M,U){const j=S(this.forwarded,T,M),O=k(T,M);if(j){j.name=U,await this.$(),this.j.fire({host:T,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=U,this.j.fire({host:T,port:M}))}async close(T,M,U){const j=k(T,M),O=this.forwarded.get(j);return U===l.AutoForwardEnd&&O&&O.source.source===a.Auto&&this.F.set(j,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(T,M),this.W({host:T,port:M},U)}address(T,M){const U=k(T,M);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const M of T){const U=S(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:k(M.localAddress.host,M.localAddress.port);this.detected.set(k(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:D.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let M=T;this.r&&(M=await this.r(T));const U=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(j=>j.port).join(", ")}`),this.n.fire(U)}fb(T){const M=this.m??new Map,U=new Map;return this.m=U,T.forEach(j=>{const O=k(j.host,j.port);U.set(O,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(O)&&M.delete(O);const V=S(this.forwarded,j.host,j.port);V&&(V.runningProcess=j.detail,V.hasRunningProcess=!0,V.pid=j.pid)}),M.forEach((j,O)=>{const V=d(O);if(!V)return;const q=S(this.forwarded,V.host,V.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const de=S(this.detected,V.host,V.port);de&&(de.runningProcess=void 0,de.hasRunningProcess=!1,de.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const T=Array.from(this.forwarded.values()),M=await this.getAttributes(T.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(M)for(const U of T){const j=M.get(U.remotePort);(j?.protocol||U.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==U.protocol&&await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},j),j&&j.label&&j.label!==U.name&&await this.name(U.remoteHost,U.remotePort,j.label)}}async getAttributes(T,M=!0){const U=new Map,j=new Map;T.forEach(x=>{const Q=S(this.m??new Map,D.$ev[0],x.port)??x;if(Q){U.set(x.port,Q);const G=b(Q)?Q.pid:void 0;j.has(G)||j.set(G,[]),j.get(G)?.push(x.port)}});const O=new Map;if(T.forEach(x=>{const Q=this.configPortsAttributes.getAttributes(x.port,x.host,U.get(x.port)?.detail);Q&&O.set(x.port,Q)}),this.G.length===0||!M)return O.size>0?O:void 0;const V=await Promise.all((0,F.$Qb)(this.G.map(x=>Array.from(j.entries()).map(Q=>{const G=Q[1],ce=U.get(G[0]);return x.providePortAttributes(G,ce?.pid,ce?.detail,new i.$Xd().token)})))),q=new Map;if(V.forEach(x=>x.forEach(Q=>{Q&&q.set(Q.port,Q)})),!O&&!q)return;const de=new Map;return T.forEach(x=>{const Q=O.get(x.port),G=q.get(x.port);de.set(x.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??v.providedActionToAction(G?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),de}addAttributesProvider(T){this.G.push(T)}};e.$YJ=C,He([(0,f.$ih)(1e3)],C.prototype,"$",null),e.$YJ=C=He([Be(0,D.$av),Be(1,y.$9o),Be(2,m.$ji),Be(3,u.$NJ),Be(4,g.$Pk),Be(5,w.$Yh),Be(6,P.$0i),Be(7,A.$Ev),Be(8,c.$hF),Be(9,o.$8i)],C)}),define(Se[93],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LI=e.$KI=void 0;class I{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new I(0,0)}with(R){return new I(0,0)}}e.$KI=I;class F{constructor(R,p,E,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,p),this.end=new I(E,m)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$LI=F;var f;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(Se[35],De([1,0,19,37,24,33,13,5,16,9,93,8]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchErrorCode=e.$1I=e.$ZI=e.SearchSortOrder=e.ViewMode=e.$YI=e.$XI=e.$WI=e.$VI=e.SearchCompletionExitCode=e.$UI=e.$TI=e.$SI=e.QueryType=e.SearchProviderType=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$MI="workbench.view.search",e.$NI="workbench.panel.search",e.$OI="workbench.view.search",e.$PI="search-result",e.$QI="search.exclude";const g="\u27EA ",y=" characters skipped \u27EB",D=(g.length+y.length+5)*2;e.$RI=(0,p.$Ph)("searchService");var w;(function(G){G[G.file=0]="file",G[G.text=1]="text"})(w||(e.SearchProviderType=w={}));var u;(function(G){G[G.File=1]="File",G[G.Text=2]="Text"})(u||(e.QueryType=u={}));function c(G){return!!G.preview}e.$SI=c;function i(G){return!!G.resource}e.$TI=i;function s(G){return!!G.message}e.$UI=s;var r;(function(G){G[G.Normal=0]="Normal",G[G.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class o{constructor(ce){this.resource=ce,this.results=[]}}e.$VI=o;class t{constructor(ce,ie,ae,ye){this.ranges=ie,this.webviewIndex=ye;const H=Array.isArray(ie)?ie:[ie];if(ae&&ae.matchLines===1&&n(H)){ce=(0,R.$rf)(ce,ae.matchLines);let z="",X=0,re=0;const Z=Math.floor(ae.charsPerLine/5),ee=[];for(const _ of H){const we=Math.max(_.startColumn-Z,0),ue=_.startColumn+ae.charsPerLine;if(we>re+Z+D){const ge=g+(we-re)+y;z+=ge+ce.slice(we,ue),X+=we-(re+ge.length)}else z+=ce.slice(re,ue);ee.push(new l(0,_.startColumn-X,_.endColumn-X)),re=ue}this.preview={text:z,matches:Array.isArray(this.ranges)?ee:ee[0]}}else{const z=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ce,matches:(0,I.$1b)(ie,X=>new d(X.startLineNumber-z,X.startColumn,X.endLineNumber-z,X.endColumn))}}}}e.$WI=t;function n(G){const ce=G[0].startLineNumber;for(const ie of G)if(ie.startLineNumber!==ce||ie.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,ie,ae,ye){this.startLineNumber=ce,this.startColumn=ie,this.endLineNumber=ae,this.endColumn=ye}}e.$XI=d;class l extends d{constructor(ce,ie,ae){super(ce,ie,ce,ae)}}e.$YI=l;var a;(function(G){G.List="list",G.Tree="tree"})(a||(e.ViewMode=a={}));var h;(function(G){G.Default="default",G.FileNames="fileNames",G.Type="type",G.Modified="modified",G.CountDescending="countDescending",G.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function S(G,ce=!0){const ie=G&&G.files&&G.files.exclude,ae=ce&&G&&G.search&&G.search.exclude;if(!ie&&!ae)return;if(!ie||!ae)return ie||ae;let ye=Object.create(null);return ye=f.$0m(ye,f.$7m(ie)),ye=f.$0m(ye,f.$7m(ae),!0),ye}e.$ZI=S;function k(G,ce){return G.excludePattern&&F.$vj(G.excludePattern,ce)?!1:G.includePattern||G.usingSearchPaths?G.includePattern&&F.$vj(G.includePattern,ce)?!0:G.usingSearchPaths?!!G.folderQueries&&G.folderQueries.some(ie=>{const ae=ie.folder.fsPath;if(L.$Xf(ce,ae)){const ye=E.$kc(ae,ce);return!ie.includePattern||!!F.$vj(ie.includePattern,ye)}else return!1}):!1:!0}e.$1I=k;var $;(function(G){G[G.unknownEncoding=1]="unknownEncoding",G[G.regexParseError=2]="regexParseError",G[G.globParseError=3]="globParseError",G[G.invalidLiteral=4]="invalidLiteral",G[G.rgProcessError=5]="rgProcessError",G[G.other=6]="other",G[G.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class b extends Error{constructor(ce,ie){super(ce),this.code=ie}}e.$2I=b;function v(G){const ce=G.message;if((0,m.$3)(G))return new b(ce,$.canceled);try{const ie=JSON.parse(ce);return new b(ie.message,ie.code)}catch{return new b(ce,$.other)}}e.$3I=v;function C(G){const ce={message:G.message,code:G.code};return new Error(JSON.stringify(ce))}e.$4I=C;function N(G){return G.type==="error"?!0:G.type==="success"}e.$5I=N;function T(G){return G.type==="success"}e.$6I=T;function M(G){return!!G.path}e.$7I=M;function U(G,ce){const ie=G.searchPath?G.searchPath:G.relativePath;return(0,R.$of)(ie,ce)}e.$8I=U;class j{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9I=j;function O(G,ce){const ie={...G||{},...ce||{}};return Object.keys(ie).filter(ae=>{const ye=ie[ae];return typeof ye=="boolean"&&ye})}e.$0I=O;class V{constructor(ce,ie){this.c=null,this.a={...ce.excludePattern||{},...ie.excludePattern||{}},this.b=F.$wj(this.a);let ae=ce.includePattern;ie.includePattern&&(ae?ae={...ae,...ie.includePattern}:ae=ie.includePattern),ae&&(this.c=F.$wj(ae))}matchesExcludesSync(ce,ie,ae){return!!(this.b&&this.b(ce,ie,ae))}includedInQuerySync(ce,ie,ae){return!(this.b&&this.b(ce,ie,ae)||this.c&&!this.c(ce,ie,ae))}includedInQuery(ce,ie,ae){const ye=this.b(ce,ie,ae),H=()=>this.c?!!this.c(ce,ie,ae):!0;return(0,P.$Gg)(ye)?ye.then(z=>z?!1:H()):H()}hasSiblingExcludeClauses(){return q(this.a)}}e.$$I=V;function q(G){for(const ce in G)if(typeof G[ce]!="boolean")return!0;return!1}function de(G){if(!G)return;let ce;return ie=>(ce||(ce=(G()||Promise.resolve([])).then(ae=>ae?Q(ae):{})),ce.then(ae=>!!ae[ie]))}e.$_I=de;function x(G){if(!G)return;let ce;return ie=>{if(!ce){const ae=G();ce=ae?Q(ae):{}}return!!ce[ie]}}e.$aJ=x;function Q(G){const ce={};for(const ie of G)ce[ie]=!0;return ce}}),define(Se[39],De([1,0,19,8,21,4,3,78,18,122,23,13,2,222,5,15,251,44,57,27,20,14,7,67,35,6,54]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n,d,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;function h(T,M,U){return new A.$kg(j=>b(j,U)).isEqual(T,M)}function S(T,M,U){return h(T.uri,M.uri,U)?0:(0,P.$Ue)(T.uri.toString(),M.uri.toString())}function k(T,M,U){return T.index!==M.index?T.index<M.index?-1:1:h(T.uri,M.uri,U)?(0,P.$Ue)(T.name,M.name):(0,P.$Ue)(T.uri.toString(),M.uri.toString())}function $(T,M,U,j){const O=T.slice(0).sort((q,de)=>U(q,de,j)),V=M.slice(0).sort((q,de)=>U(q,de,j));return(0,I.$Db)(O,V,(q,de)=>U(q,de,j))}function b(T,M){const U=M.getCapabilities(T.scheme);return!(U&&U&1024)}class v extends c.$9h{static toExtHostWorkspace(M,U,j,O){if(!M)return{workspace:null,added:[],removed:[]};const{id:V,name:q,folders:de,configuration:x,transient:Q,isUntitled:G}=M,ce=[],ie=U;U?de.forEach((z,X)=>{const re=g.URI.revive(z.uri),Z=v.o(j||U,re,O);Z?(Z.name=z.name,Z.index=z.index,ce.push(Z)):ce.push({uri:re,name:z.name,index:X})}):ce.push(...de.map(({uri:z,name:X,index:re})=>({uri:g.URI.revive(z),name:X,index:re}))),ce.sort((z,X)=>z.index<X.index?-1:1);const ae=new v(V,q,ce,!!Q,x?g.URI.revive(x):null,!!G,z=>b(z,O)),{added:ye,removed:H}=$(ie?ie.workspaceFolders:[],ae.workspaceFolders,S,O);return{workspace:ae,added:ye,removed:H}}static o(M,U,j){for(let O=0;O<M.folders.length;O++){const V=M.workspaceFolders[O];if(h(V.uri,U,j))return V}}constructor(M,U,j,O,V,q,de){super(M,j.map(x=>new c.$0h(x)),O,V,de),this.t=U,this.u=q,this.q=[],this.s=p.$Vh.forUris(de),j.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,U){return U&&this.s.get(M)&&(M=(0,A.$ug)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let C=class{constructor(M,U,j,O,V){this.c=new L.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Pd,this.B=new Map,this.h=O,this.s=j,this.t=V,this.j=new m.$Ql,this.k=new F.$Sg,this.o=M.getProxy(l.$tK.MainThreadWorkspace),this.q=M.getProxy(l.$tK.MainThreadMessageService);const q=U.workspace;this.l=q?new v(q.id,q.name,[],!!q.transient,q.configuration?g.URI.revive(q.configuration):null,!!q.isUntitled,de=>b(de,j)):void 0}$initializeWorkspace(M,U){this.v=U,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?g.URI.from({scheme:E.Schemas.untitled,path:(0,A.$sg)((0,A.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,U,j,...O){const V=[];if(Array.isArray(O)&&O.forEach(G=>{g.URI.isUri(G.uri)&&!V.some(ce=>h(ce.uri,G.uri,this.s))&&V.push({uri:G.uri,name:G.name||(0,A.$rg)(G.uri)})}),this.n||[U,j].some(G=>typeof G!="number"||G<0)||j===0&&V.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(U+j>q.length)return!1;const de=q.slice(0);de.splice(U,j,...V.map(G=>({uri:G.uri,name:G.name||(0,A.$rg)(G.uri),index:void 0})));for(let G=0;G<de.length;G++){const ce=de[G];if(de.some((ie,ae)=>ae!==G&&h(ce.uri,ie.uri,this.s)))return!1}de.forEach((G,ce)=>G.index=ce);const{added:x,removed:Q}=$(q,de,k,this.s);if(x.length===0&&Q.length===0)return!1;if(this.o){const G=M.displayName||M.name;this.o.$updateWorkspaceFolders(G,U,j,V).then(void 0,ce=>{this.n=void 0;const ie={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(u.Severity.Error,(0,y.localize)(0,null,G,ce.toString()),ie,[])})}return this.y(de),!0}getWorkspaceFolder(M,U){if(this.x)return this.x.getWorkspaceFolder(M,U)}async getWorkspaceFolder2(M,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,U)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,U){let j,O="";if(typeof M=="string"?(j=g.URI.file(M),O=M):typeof M<"u"&&(j=M,O=M.fsPath),!j)return O;const V=this.getWorkspaceFolder(j,!0);if(!V)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let q=(0,A.$xg)(V.uri,j);return U&&V.name&&(q=`${V.name}/${q}`),q}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:U,added:j,removed:O}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:O}))}findFiles(M,U,j,O,V=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let q;if(U===null?q=!1:U&&(typeof U=="string"?q=U:q=U.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:x}=N(o.GlobPattern.from(M));return this.o.$startFileSearch(de??null,x??null,q??null,j??null,V).then(Q=>Array.isArray(Q)?Q.map(G=>g.URI.revive(G)):[])}async findTextInFiles(M,U,j,O,V=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),de=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:x,folder:Q}=N(o.GlobPattern.from(U.include)),G=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ce={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:de,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:x,excludePattern:G},ie=!1;if(this.u[q]=ae=>{if(ie)return;const ye=g.URI.revive(ae.resource);ae.results.forEach(H=>{const z=(0,a.$mh)(H);(0,d.$SI)(z)?j({uri:ye,preview:{text:z.preview.text,matches:(0,I.$1b)(z.preview.matches,X=>new t.$xK(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))},ranges:(0,I.$1b)(z.ranges,X=>new t.$xK(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))}):j({uri:ye,text:z.text,lineNumber:z.lineNumber})})},V.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(M,Q??null,ce,q,V);return delete this.u[q],ae||{}}catch(ae){throw delete this.u[q],ae}}$handleTextSearchResult(M,U){this.u[U]?.(M)}async save(M){const U=await this.o.$save(M,{saveAs:!1});return g.URI.revive(U)}async saveAs(M){const U=await this.o.$save(M,{saveAs:!0});return g.URI.revive(U)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,U){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,U);const j=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,j),(0,R.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(M,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const j=await this.resolveWorkspaceFolder(g.URI.revive(M));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const O=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!O),!O)return;const V=await O.provideEditSessionIdentity(j,U);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(M,U,j,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const V=await this.resolveWorkspaceFolder(g.URI.revive(M));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const q=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!q),!q)return;const de=await q.provideEditSessionIdentityMatch?.(U,j,O);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(M){return(U,j,O)=>{const V=function(de){U.call(j,de)};return V.extension=M,this.A.event(V,void 0,O)}}async $onWillCreateEditSessionIdentity(M,U,j){const O=await this.resolveWorkspaceFolder(g.URI.revive(M));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(V,q)=>{const de=Date.now();await Promise.resolve(V),Date.now()-de>j&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(M,U){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,U);const j=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerCanonicalUriProvider(O,j),(0,R.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(M,U,j){const O=this.B.get(M.scheme);if(!O)return;const V=await O.provideCanonicalUri?.(g.URI.revive(M),U,j);if(V)return V}async $provideCanonicalUri(M,U,j){return this.provideCanonicalUri(g.URI.revive(M),{targetScheme:U},j)}};e.$Wcc=C,e.$Wcc=C=He([Be(0,r.$uM),Be(1,s.$KM),Be(2,i.$Kcc),Be(3,w.$0i),Be(4,n.$Ucc)],C),e.$Xcc=(0,D.$Ph)("IExtHostWorkspace");function N(T){let M,U;return T&&(typeof T=="string"?M=T:(M=T.pattern,U=g.URI.revive(T.baseUri))),{includePattern:M,folder:U}}}),define(Se[40],De([1,0,24,4,39,6,7,253,138,17,8,5,20,15,2]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=void 0;function w(n,d){if(d){const l=d.split(".");let a=n;for(let h=0;a&&h<l.length;h++)a=a[l[h]];return a}}function u(n){return n instanceof D.URI}function c(n){return n&&n.uri instanceof D.URI&&n.languageId&&typeof n.languageId=="string"}function i(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function s(n){return n&&n.uri instanceof D.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function r(n){if(u(n))return{resource:n};if(c(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(i(n))return{overrideIdentifier:n.languageId};if(s(n))return{resource:n.uri};if(n===null)return{resource:null}}let o=class{constructor(d,l,a){this.a=d.getProxy(L.$tK.MainThreadConfiguration),this.c=l,this.b=a,this.d=new A.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(d,l))}};e.$Ycc=o,e.$Ycc=o=He([Be(0,g.$uM),Be(1,f.$Xcc),Be(2,y.$0i)],o);class t{constructor(d,l,a,h){this.a=new F.$Nd,this.b=d,this.f=h,this.c=l,this.e=p.$Hn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Hn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,a))}getConfiguration(d,l,a){const h=r(l)||{},S=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,a?.identifier);function k(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(b){return typeof w(S,b)<"u"},get:(b,v)=>{this.h(d?`${d}.${b}`:b,h,a?.identifier);let C=w(S,b);if(typeof C>"u")C=v;else{let N;const T=(M,U)=>{if((0,m.$Af)(M)){let j;const O=()=>{N=N||(0,I.$7m)(S),j=j||w(N,U)};return new Proxy(M,{get:(V,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return O(),()=>j;if(N)return j=j||w(N,U),j[q];const de=V[q];return typeof q=="string"?T(de,`${U}.${q}`):de},set:(V,q,de)=>(O(),j&&(j[q]=de),!0),deleteProperty:(V,q)=>(O(),j&&delete j[q],!0),defineProperty:(V,q,de)=>(O(),j&&Object.defineProperty(j,q,de),!0)})}return Array.isArray(M)?(0,I.$7m)(M):M};C=T(C,b)}return C},update:(b,v,C,N)=>{b=d?`${d}.${b}`:b;const T=k(C);return v!==void 0?this.b.$updateConfigurationOption(T,b,v,h,N):this.b.$removeConfigurationOption(T,b,h,N)},inspect:b=>{b=d?`${d}.${b}`:b;const v=this.e.inspect(b,h,this.c.workspace);if(v)return{key:b,defaultValue:(0,I.$7m)(v.policy?.value??v.default?.value),globalValue:(0,I.$7m)(v.user?.value??v.application?.value),workspaceValue:(0,I.$7m)(v.workspace?.value),workspaceFolderValue:(0,I.$7m)(v.workspaceFolder?.value),defaultLanguageValue:(0,I.$7m)(v.default?.override),globalLanguageValue:(0,I.$7m)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,I.$7m)(v.workspace?.override),workspaceFolderLanguageValue:(0,I.$7m)(v.workspaceFolder?.override),languageIds:(0,I.$7m)(v.overrideIdentifiers)}}};return typeof S=="object"&&(0,I.$0m)($,S,!1),Object.freeze($)}g(d){const l=a=>(0,m.$Af)(a)?new Proxy(a,{get:(h,S)=>l(h[S]),set:(h,S,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(h,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(h,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(d)}h(d,l,a){const h=E.$yn.test(d)?4:this.d.get(d),S=a?`[${a.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const a=new p.$Jn(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,S)=>a.affectsConfiguration(h,r(S))})}k(d){return d.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.$Zcc=t,e.$1cc=(0,P.$Ph)("IExtHostConfiguration")}),define(Se[94],De([1,0,2,8,4,6,7,39,70,40,21,45,20,27,5,18,12,15,90,301,9]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=e.$Wdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(T){function M(j){if(j!=null)return j}T.from=M;function U(j){if(j!=null)return j}T.to=U})(o||(o={}));var t;(function(T){function M(j){if(j!=null)return j}T.from=M;function U(j){if(j!=null)return j}T.to=U})(t||(t={}));var n;(function(T){function M(j){if(j!=null)return j}T.from=M;function U(j){if(j!=null)return j}T.to=U})(n||(n={}));var d;(function(T){function M(O){if(O){const V=O;return V&&!!V.process}else return!1}T.is=M;function U(O){if(O==null)return;const V={process:O.process,args:O.args};return O.options&&(V.options=n.from(O.options)),V}T.from=U;function j(O){if(O!=null)return new R.$dL(O.process,O.args,O.options)}T.to=j})(d||(d={}));var l;(function(T){function M(j){if(j!=null)return j}T.from=M;function U(j){if(j!=null)return j}T.to=U})(l||(l={}));var a;(function(T){function M(O){if(O){const V=O;return V&&(!!V.commandLine||!!V.command)}else return!1}T.is=M;function U(O){if(O==null)return;const V={};return O.commandLine!==void 0?V.commandLine=O.commandLine:(V.command=O.command,V.args=O.args),O.options&&(V.options=l.from(O.options)),V}T.from=U;function j(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$eL(O.commandLine,O.options):new R.$eL(O.command,O.args?O.args:[],O.options)}T.to=j})(a||(a={}));var h;(function(T){function M(O){if(O){const V=O;return V&&V.customExecution==="customExecution"}else return!1}T.is=M;function U(O){return{customExecution:"customExecution"}}T.from=U;function j(O,V){return V.get(O)}T.to=j})(h||(e.CustomExecutionDTO=h={}));var S;(function(T){function M(U,j){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?O=j.workspaceFile:O=s.$WF),{id:U._id,workspaceFolder:O}}T.from=M})(S||(e.TaskHandleDTO=S={}));var k;(function(T){function M(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}T.from=M})(k||(k={}));var $;(function(T){function M(O,V){if(O==null)return[];const q=[];for(const de of O){const x=U(de,V);x&&q.push(x)}return q}T.fromMany=M;function U(O,V){if(O==null)return;let q;O.execution instanceof R.$dL?q=d.from(O.execution):O.execution instanceof R.$eL?q=a.from(O.execution):O.execution&&O.execution instanceof R.$fL&&(q=h.from(O.execution));const de=o.from(O.definition);let x;return O.scope?typeof O.scope=="number"?x=O.scope:x=O.scope.uri:x=R.TaskScope.Workspace,!de||!x?void 0:{_id:O._id,definition:de,name:O.name,source:{extensionId:V.identifier.value,label:O.source,scope:x},execution:q,isBackground:O.isBackground,group:k.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}T.from=U;async function j(O,V,q){if(O==null)return;let de;d.is(O.execution)?de=d.to(O.execution):a.is(O.execution)?de=a.to(O.execution):h.is(O.execution)&&(de=h.to(O._id,q));const x=o.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await V.resolveWorkspaceFolder(I.URI.revive(O.source.scope)):Q=R.TaskScope.Workspace),!x||!Q)return;const G=new R.$gL(x,Q,O.name,O.source.label,de,O.problemMatchers);return O.isBackground!==void 0&&(G.isBackground=O.isBackground),O.group!==void 0&&(G.group=R.$cL.from(O.group._id),G.group&&O.group.isDefault&&(G.group=new R.$cL(G.group.id,G.group.label),O.group.isDefault===!0&&(G.group.isDefault=O.group.isDefault))),O.presentationOptions&&(G.presentationOptions=t.to(O.presentationOptions)),O._id&&(G._id=O._id),O.detail&&(G.detail=O.detail),G}T.to=j})($||(e.TaskDTO=$={}));var b;(function(T){function M(j){return j}T.from=M;function U(j){if(j)return Object.assign(Object.create(null),j)}T.to=U})(b||(b={}));class v{#e;constructor(M,U,j){this._id=U,this.a=j,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let C=class{constructor(M,U,j,O,V,q,de,x){this.q=new f.$Nd,this.r=new f.$Nd,this.s=new f.$Nd,this.t=new f.$Nd,this.a=M.getProxy(L.$tK.MainThreadTask),this.b=j,this.c=O,this.d=V,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,U,j){if(!j)return new R.$vK(()=>{});const O=this.w();return this.j.set(O,{type:U,provider:j,extension:M}),this.a.$registerTaskProvider(O,U),new R.$vK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,U){this.a.$registerTaskSystem(M,U)}fetchTasks(M){return this.a.$fetchTasks(b.from(M)).then(async U=>{const j=[];for(const O of U){const V=await $.to(O,this.b,this.m);V&&j.push(V)}return j})}get taskExecutions(){const M=[];return this.k.forEach(U=>M.push(U)),M}terminateTask(M){if(!(M instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,U,j){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(U,await O.callback(j))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const U=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const U=await this.y(M.id);this.s.fire({execution:U,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const U=await this.y(M.id);this.t.fire({execution:U,exitCode:M.exitCode})}$provideTasks(M,U){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));const O=[],V=(0,F.$Mg)(()=>j.provider.provideTasks(A.CancellationToken.None)).then(q=>this.u(U,O,j,q));return new Promise(q=>{V.then(de=>{Promise.all(O).then(()=>{q(de)})})})}async $resolveTask(M,U){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));if(U.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${j.type}].`);const O=await $.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const V=await j.provider.resolveTask(O,A.CancellationToken.None);if(!V)return;this.z(V,j);const q=$.from(V,j.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(q.execution)&&await this.x(q,V,!0),await this.v(q)}w(){return this.h++}async x(M,U,j){const O=await this.a.$createTaskId(M);!j&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async y(M,U){if(typeof M=="string"){const V=this.l.get(M);if(!V)throw new r.$ab("Unexpected: The specified task is missing an execution");return V}const j=this.l.get(M.id);if(j)return j;const O=new Promise((V,q)=>{function de(x,Q,G){G?V(new v(x,Q.id,G)):q("Unexpected: Task does not exist.")}U?de(this,M,U):$.to(M.task,this.b,this.m).then(x=>de(this,M,x))});return this.l.set(M.id,O),O.then(V=>(this.k.set(M.id,V),V),V=>Promise.reject(V))}z(M,U){M._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const j=this.n.values();let O=j.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=j.next()}};e.$Wdc=C,e.$Wdc=C=He([Be(0,g.$uM),Be(1,y.$KM),Be(2,p.$Xcc),Be(3,E.$FM),Be(4,m.$1cc),Be(5,P.$gdc),Be(6,c.$0i),Be(7,i.$Ncc)],C);let N=class extends C{constructor(M,U,j,O,V,q,de,x){super(M,U,j,O,V,q,de,x),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:u.$i(0)})}async executeTask(M,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const j=$.from(U,M);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.x(j,U,!1);else throw new r.$$;const O=await this.y(await this.a.$getTaskExecution(j),U);return this.a.$executeTask(j).catch(V=>{throw new Error(V)}),O}u(M,U,j,O){const V=[];if(O)for(const q of O){this.z(q,j),(!q.definition||!M[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const de=$.from(q,j.extension);de&&h.is(de.execution)?(V.push(de),U.push(this.x(de,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:j.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,U,j){}};e.$Xdc=N,e.$Xdc=N=He([Be(0,g.$uM),Be(1,y.$KM),Be(2,p.$Xcc),Be(3,E.$FM),Be(4,m.$1cc),Be(5,P.$gdc),Be(6,c.$0i),Be(7,i.$Ncc)],N),e.$Ydc=(0,D.$Ph)("IExtHostTask")}),define(Se[357],De([1,0,35,29]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.$pK=void 0;function f(R){return"cellResults"in R}e.$pK=f,e.$qK="rawCell#";function L(R,p){let E=-1;const m=[];let A=[];return R.forEach(g=>{g.range.startLineNumber!==E&&A.length>0&&(m.push([...A]),A=[]),A.push(g),E=g.range.endLineNumber}),A.length>0&&m.push([...A]),m.map(g=>{const y=[],D=g[0].range.startLineNumber,w=g[g.length-1].range.endLineNumber;for(let u=D;u<=w;u++)y.push(p.getLineContent(u));return new I.$WI(y.join(`
`)+`
`,g.map(u=>new F.$ws(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}e.$rK=L}),define(Se[358],De([1,0,215,22,4,3,28,13,17,2,31,109,6,34,14,7,69,293,148,9,24,18,357,285]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,h,S,k,$,b){this.q=S,this.r=k,this.s=$,this.t=b,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new f.$Nd({onListenerError:s.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Nd({onListenerError:s.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Nd({onListenerError:s.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Nd({onListenerError:s.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Hcc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(g.$tK.MainThreadNotebook),this.c=a.getProxy(g.$tK.MainThreadNotebookDocuments),this.d=a.getProxy(g.$tK.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===13){const C=v.notebookEditor?.notebookUri,N=v.cell.handle,M=this.g.get(C)?.getCell(N);if(M)return M.apiCell}if(v&&v.$mid===14){const C=v.uri,N=this.g.get(C);if(N)return N.apiNotebook}return v}}),d.B(h)}getEditorById(a){const h=this.h.get(a);if(!h)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(a){for(const[h,S]of this.h)if(S.apiEditor===a)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,h){const S=this.g.get(a);if(!S&&!h)throw new Error(`NO notebook document for '${a}'`);return S}static u(a,h){if(!h)return;const S=h.filenamePattern.map(k=>D.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(h.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:h.displayName,filenamePattern:S,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,h,S){const k=d.a++,$=typeof S.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(k,S),this.b.$registerNotebookCellStatusBarItemProvider(k,$,h);let b;return $!==void 0&&(b=S.onDidChangeCellStatusBarItems(v=>this.b.$emitCellStatusBarEvent($))),new w.$vK(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,$),b?.dispose()})}async createNotebookDocument(a){const h=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&D.NotebookData.from(a.content)});return m.URI.revive(h)}async openNotebookDocument(a){const h=this.g.get(a);if(h)return h.apiNotebook;const S=await this.c.$tryOpenNotebook(a),k=this.g.get(m.URI.revive(S));return(0,E.$Jf)(k?.apiNotebook)}async showNotebookDocument(a,h){m.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let S;typeof h=="object"?S={position:D.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(D.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:S={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,S),$=k&&this.h.get(k)?.apiEditor;if($)return $;throw k?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,h,S,k){const $=this.f.get(a),b=m.URI.revive(h),v=this.g.get(b);if(!v||!$)return;const C=v.getCellFromIndex(S);if(!C)return;const N=await $.provideCellStatusBarItems(C.apiCell,k);if(!N)return;const T=new L.$Qc,M=this.p.add([T]),j=(Array.isArray(N)?N:[N]).map(O=>D.NotebookStatusBarItem.from(O,this.i,T));return{cacheId:M,items:j}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,h,S,k,$){if((0,p.$Be)(h))throw new Error("viewType cannot be empty or just whitespace");const b=this.w++;return this.x.set(b,{viewType:h,serializer:S,options:k}),this.b.$registerNotebookSerializer(b,{id:a.identifier,location:a.extensionLocation},h,D.NotebookDocumentContentOptions.from(k),d.u(a,$)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(a,h,S){const k=this.x.get(a);if(!k)throw new Error("NO serializer found");const $=await k.serializer.deserializeNotebook(h.buffer,S);return new u.$tv(D.NotebookData.from($))}async $notebookToData(a,h,S){const k=this.x.get(a);if(!k)throw new Error("NO serializer found");const $=await k.serializer.serializeNotebook(D.NotebookData.to(h.value),S);return F.$be.wrap($)}async $saveNotebook(a,h,S,k,$){const b=m.URI.revive(h),v=this.x.get(a);if(!v)throw new Error("NO serializer found");const C=this.g.get(b);if(!C)throw new Error("Document NOT found");if(C.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new A.$tk((0,I.localize)(0,null,this.z(b)),6);await this.y(b,k);const N={metadata:(0,r.$cn)(C.apiNotebook.metadata,O=>!(v.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of C.apiNotebook.getCells()){const V=new w.$TL(O.kind,O.document.getText(),O.document.languageId,O.mime,v.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);V.metadata=(0,r.$cn)(O.metadata,q=>!(v.options?.transientCellMetadata??{})[q]),N.cells.push(V)}const T=await v.serializer.serializeNotebook(N,$);await this.s.value.writeFile(b,T);const M=this.s.getFileSystemProviderExtUri(b.scheme),U=await this.s.value.stat(b);return{name:M.basename(b),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$Ek({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(a,h,S,k){const $=this.x.get(a)?.serializer;if(!$)return{limitHit:!1,results:[]};const v=await(async(M,U,j)=>{const O=new R.$Ac;return await Promise.all(M.map(V=>{const q={type:1,filePattern:V,folderQueries:j.folderQueries,maxResults:j.maxResults};return this.t.doInternalFileSearchWithCustomCallback(q,U,de=>{de.forEach(x=>O.add(x))})})),Array.from(O.keys())})(h,k,S),C=new R.$zc;let N=!1;const T=v.map(async M=>{const U=[];try{if(k.isCancellationRequested)return;if(S.maxResults&&[...C.values()].reduce((q,de)=>q+de.cellResults.length,0)>S.maxResults){N=!0;return}const j=[],O=this.g.get(M);if(O)O.apiNotebook.getCells().forEach(de=>j.push({input:de.document.getText(),outputs:de.outputs.flatMap(x=>x.items.map(Q=>Q.data.toString()))}));else{const q=await this.s.value.readFile(M),de=F.$be.fromString(q.toString()),x=await $.deserializeNotebook(de.buffer,k);if(k.isCancellationRequested)return;D.NotebookData.from(x).cells.forEach(G=>j.push({input:G.source,outputs:G.outputs.flatMap(ce=>ce.items.map(ie=>ie.valueBytes.toString()))}))}if(k.isCancellationRequested)return;j.forEach((q,de)=>{const x=S.contentPattern.pattern,Q=new n.$jOb(q.input,void 0,q.outputs),G=Q.findInInputs(x),ce=Q.findInOutputs(x),ie=ce.flatMap(ae=>(0,t.$rK)(ae.matches,ae.textBuffer)).map((ae,ye)=>(ae.webviewIndex=ye,ae));if(G.length>0||ce.length>0){const ae={index:de,contentResults:(0,t.$rK)(G,Q.inputTextBuffer),webviewResults:ie};U.push(ae)}});const V={resource:M,cellResults:U};C.set(M,V);return}catch{return}});return await Promise.all(T),{limitHit:N,results:[...C.values()]}}async y(a,h){const S=await this.s.value.stat(a);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$Dk&&typeof S.mtime=="number"&&typeof S.size=="number"&&h.mtime<S.mtime&&h.etag!==A.$Ek({mtime:h.mtime,size:S.size}))throw new A.$tk((0,I.localize)(1,null),3,h)}z(a){return a.scheme===o.Schemas.file?a.fsPath:a.toString()}A(a,h,S){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const k=new i.$gec(h,this.d,a,S.visibleRanges.map(D.NotebookRange.to),S.selections.map(D.NotebookRange.to),typeof S.viewColumn=="number"?D.ViewColumn.to(S.viewColumn):void 0);this.h.set(h,k)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const S of a.value.removedDocuments){const k=m.URI.revive(S),$=this.g.get(k);$&&($.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire($.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===k.toString()&&this.h.delete(b.id)}if(a.value.addedDocuments){const S=[];for(const k of a.value.addedDocuments){const $=m.URI.revive(k.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const b=new c.$fec(this.c,this.q,this.r,$,k);S.push(...k.cells.map(v=>c.$eec.asModelAddData(b.apiNotebook,v))),this.g.get($)?.dispose(),this.g.set($,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(b.apiNotebook)}}if(a.value.addedEditors)for(const S of a.value.addedEditors){if(this.h.has(S.id))return;const k=m.URI.revive(S.documentUri),$=this.g.get(k);$&&this.A($,S.id,S)}const h=[];if(a.value.removedEditors)for(const S of a.value.removedEditors){const k=this.h.get(S);k&&(this.h.delete(S),this.k?.id===k.id&&(this.k=void 0),h.push(k))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const S=new Set;this.l.forEach(k=>S.add(k.id));for(const k of this.h.values()){const $=S.has(k.id);k._acceptVisibility($)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const h=y.$SM.String.with("notebookType","A notebook type"),S=new y.$UM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new y.$SM("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>F.$be.wrap($))],new y.$TM("Notebook Data",$=>D.NotebookData.to($.value))),k=new y.$UM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new y.$SM("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new u.$tv(D.NotebookData.from($)))],new y.$TM("Bytes",$=>$.buffer));a.registerApiCommand(S),a.registerApiCommand(k)}}e.$hec=d}),define(Se[359],De([1,0,16,21,41,37,23,36,35]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class m{constructor(g,y,D){this.k=g,this.l=y,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=g.filePattern,this.b=g.includePattern&&L.$wj(g.includePattern),this.c=g.maxResults||void 0,this.d=g.exists,this.h=new Set,this.j=g.excludePattern&&L.$wj(g.excludePattern)}cancel(){this.g=!0,this.h.forEach(g=>g.cancel()),this.h=new Set}search(g){const y=this.k.folderQueries||[];return new Promise((D,w)=>{const u=c=>{this.f++,g(c)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const i=c.toString(),s=I.$mc(i);this.j&&this.j(i,s)||this.v(u,{base:c,basename:s})}),Promise.all(y.map(c=>this.p(c,u))).then(c=>{D({limitHit:this.e,stats:c[0]||void 0})},c=>{w(new Error((0,f.$Ai)(c)))})})}async p(g,y){const D=new F.$Xd,w=this.q(g),u=this.r(),c=new E.$$I(this.k,g),i=!c.hasSiblingExcludeClauses();let s;try{this.h.add(D),s=p.$Jd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,D.token),o=s.elapsed(),t=p.$Jd.create();return this.g&&!this.e||(r&&r.forEach(n=>{const d=I.$fc.relative(g.folder.path,n.path);if(i){const l=I.$mc(n.path);this.v(y,{base:g.folder,relativePath:d,basename:l});return}this.s(u,g.folder,d,y)}),this.g&&!this.e)?null:(this.u(u,c,y),{providerTime:o,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(g){const y=(0,E.$0I)(this.k.includePattern,g.includePattern),D=(0,E.$0I)(this.k.excludePattern,g.excludePattern);return{folder:g.folder,excludes:D,includes:y,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}s({pathToEntries:g},y,D,w){if(D===this.a){const c=I.$mc(this.a);this.v(w,{base:y,relativePath:this.a,basename:c})}function u(c){const i=I.$mc(c),s=I.$lc(c);let r=g[s];r||(r=g[s]=[],u(s)),r.push({base:y,relativePath:c,basename:i})}u(D)}u({rootEntries:g,pathToEntries:y},D,w){const u=this,c=this.a;function i(s){const r=(0,E.$aJ)(()=>s.map(o=>o.basename));for(let o=0,t=s.length;o<t;o++){const n=s[o],{relativePath:d,basename:l}=n;if(D.matchesExcludesSync(d,l,c!==l?r:void 0))continue;const a=y[d];if(a)i(a);else{if(d===c)continue;u.v(w,n)}if(u.e)break}}i(g)}v(g,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||g(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(g,y,D,w){const u=this.c(g.cacheKey),c=new m(g,y,u&&u.token);let i=0;const s=r=>{i+=r.length,D(r.map(o=>this.d(o)))};return this.e(c,A.a,s,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(g){this.c(g)?.cancel()}c(g){if(g)return this.b.has(g)||this.b.set(g,new F.$Xd),this.b.get(g)}d(g){return g.relativePath?{resource:R.$vg(g.base,g.relativePath)}:{resource:g.base}}e(g,y,D,w){const u=w.onCancellationRequested(()=>{g.cancel()}),c=s=>{s&&(i.push(s),y>0&&i.length>=y&&(D(i),i=[]))};let i=[];return g.search(c).then(s=>(i.length&&D(i),u.dispose(),s),s=>(i.length&&D(i),u.dispose(),Promise.reject(s)))}}e.$9dc=A}),define(Se[360],De([1,0,19,74,37,101,28,18,16,23,13,17,2,98,234,50,15,44,145,355,35]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=void 0;let o=class{constructor(b,v,C,N,T){this.a=b,this.b=v,this.c=C,this.d=N,this.e=T}text(b,v,C={}){b=this.f(b,C);const N=this.a.getValue(),T=v&&v.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(v?.map(c.$$h),C),type:2,contentPattern:b,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:N.search.usePCRE2||T||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(b,v){const C=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const N={...b,wordSeparators:C.editor.wordSeparators};return this.j(b,v)&&(N.isCaseSensitive=!0),this.k(b)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file(b,v={}){return{...this.h(b,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(b,v){return b?(b=Array.isArray(b)?b.map(a):a(b),v?this.parseSearchPaths(b):{pattern:n(...Array.isArray(b)?b:[b])}):{}}h(b=[],v={}){const C=this.g(v.includePattern,v.expandPatterns),N=this.g(v.excludePattern,v.expandPatterns),T=b.length>1,M=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(O=>this.q(O,v,N)):b.map(O=>this.r(O,v,N,T))).filter(O=>!!O),U={_reason:v._reason,folderQueries:M,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:C.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const O=I.$Gb(I.$Qb(this.c.groups.map(de=>de.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const V=O.filter(de=>(0,r.$1I)(U,de.fsPath)),q=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...U,...q}}const j=v.extraFileResources&&v.extraFileResources.filter(O=>(0,r.$1I)(U,O.fsPath));return U.extraFileResources=j&&j.length?j:void 0,U}i(b){const v=[],C=new R.$zc,N={};let T=!1;return b.forEach(M=>{if(M.scheme===p.Schemas.walkThrough)return;if((0,m.$zg)(M)){const j=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$lc(M.fsPath)});let O=C.get(j);O||(T=!0,O={folder:j,includePattern:{}},v.push(O),C.set(j,O));const V=E.$kc(j.fsPath,M.fsPath);(0,P.$Jf)(O.includePattern)[V.replace(/\\/g,"/")]=!0}else M.fsPath&&(T=!0,N[M.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(b,v){if(v.isSmartCase){if(b.isRegExp){if(A.$pf(b.pattern,!0))return!0}else if(A.$pf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,y.$yB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const v=q=>E.$hc(q)||/^\.\.?([\/\\]|$)/.test(q),N=(Array.isArray(b)?b:d(b)).map(q=>{const de=this.e.resolvedUserHome;return de?(0,L.$xv)(q,de.scheme===p.Schemas.file?de.fsPath:de.path):q}),T=F.$J(N,q=>v(q)?"searchPaths":"exprSegments"),M=(T.exprSegments||[]).map(q=>A.$Ke(q,"/")).map(q=>A.$Ke(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),l(q))),U={},j=this.m(T.searchPaths||[]);j&&j.length&&(U.searchPaths=j);const O=I.$Qb(M),V=n(...O);return V&&(U.pattern=V),U}l(b,v){return v.disregardExcludeSettings?void 0:(0,r.$ZI)(b,!v.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const v=b.flatMap(N=>{let{pathPortion:T,globPortion:M}=t(N);return M&&(M=h(M)),this.n(T).flatMap(j=>this.o(j,M))}),C=new Map;return v.forEach(N=>{const T=N.searchPath.toString(),M=C.get(T);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):C.set(T,{searchPath:N.searchPath,pattern:N.pattern?n(N.pattern):void 0})}),Array.from(C.values())}n(b){if(E.$hc(b)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==p.Schemas.file?[{searchPath:v[0].uri.with({path:b})}]:[{searchPath:g.URI.file(E.$gc(b))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(b=a(b),b.startsWith("../")||b===".."){const N=E.$fc.resolve(v.path,b);return[{searchPath:v.with({path:N})}]}const C=h(b);return[{searchPath:v,pattern:C}]}else{if(b==="./"||b===".\\")return[];{const v=b.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(T=>{const M=v.match(new RegExp(`^${A.$Fe(T.name)}(?:/(.*)|$)`));return M?{match:M,folder:T}:null}).filter(P.$Gf);if(N.length)return N.map(T=>{const M=T.match[1];return{searchPath:T.folder.uri,pattern:M&&h(M)}});{const T=b.match(/\.[\/\\](.+)[\/\\]?/),M=T?T[1]:b,U=D.localize(0,null,M);throw new Error(U)}}}}o(b,v){const C=b.pattern&&v?`${b.pattern}/${v}`:b.pattern||v,N=[{searchPath:b.searchPath,pattern:C}];return C&&!C.endsWith("**")&&N.push({searchPath:b.searchPath,pattern:C+"/**"}),N}q(b,v,C){const N=this.r((0,c.$$h)(b.searchPath),v,C,!1);return N?{...N,includePattern:b.pattern}:null}r(b,v,C,N){let T;const M=g.URI.isUri(b)?b:b.uri;if(C.searchPaths){const q=C.searchPaths.filter(de=>(0,m.$og)(de.searchPath,M))[0];if(q&&!q.pattern)return null;q&&(T=q.pattern)}const U=this.a.getValue({resource:M}),O={...this.l(U,v)||{},...T||{}},V=g.URI.isUri(b)?(0,m.$sg)(b):b.name;return{folder:M,folderName:N?V:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!U.search.followSymlinks}}};e.$7J=o,e.$7J=o=He([Be(0,w.$ji),Be(1,c.$Yh),Be(2,i.$rC),Be(3,u.$0i),Be(4,s.$5J)],o);function t($){const b=$.match(/[\*\{\}\(\)\[\]\?]/);if(b){const v=b.index,C=$.substr(0,v).match(/[/|\\][^/\\]*$/);if(C){let N=$.substr(0,C.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function n(...$){return $.length?$.reduce((b,v)=>(b[v]=!0,b),Object.create(null)):void 0}function d($){return f.$uj($,",").map(b=>b.trim()).filter(b=>!!b.length)}function l($){return[`**/${$}/**`,`**/${$}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function a($){return $.replace(/\\/g,"/")}function h($){return a($).replace(/^\.\//,"").replace(/\/+$/g,"")}function S($){return $.replace(/([?*[\]])/g,"[$1]")}function k($,b){$=I.$Lb($,N=>N.toString());const v=[],C=b.getWorkspace();return $&&$.forEach(N=>{let T;if(b.getWorkbenchState()===2)T=(0,m.$xg)(C.folders[0].uri,N),T&&T!=="."&&(T="./"+T);else{const M=b.getWorkspaceFolder(N);if(M){const U=M.name;if(C.folders.filter(O=>O.name===U).length===1){const O=(0,m.$xg)(M.uri,N);O===""?T=`./${M.name}`:T=`./${M.name}/${O}`}else T=N.fsPath}}T&&v.push(S(T))}),v}e.$8J=k}),define(Se[361],De([1,0,23,2,21,9,5,360,35,44]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlb=e.$Wlb=void 0;const A=7e3;function P(w,u){const c=u.activationEvents;if(!c)return Promise.resolve(void 0);const i=[],s=[];for(const l of c)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||w.forceUsingSearch?s.push(a):i.push(a)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);let r;const o=new Promise((l,a)=>{r=l}),t=l=>r({activationEvent:l}),n=Promise.all(i.map(l=>g(w,l,t))).then(()=>{}),d=y(w,u.identifier,s,t);return Promise.all([n,d]).then(()=>{r(void 0)}),o}e.$Wlb=P;async function g(w,u,c){for(const i of w.folders)if(await w.exists(I.$vg(F.URI.revive(i),u))){c(`workspaceContains:${u}`);return}}async function y(w,u,c,i){if(c.length===0)return Promise.resolve(void 0);const s=new f.$Xd,r=w.checkExists(w.folders,c,s.token),o=setTimeout(async()=>{s.cancel(),w.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},A);let t=!1;try{t=await r}catch(n){L.$3(n)||L.$Z(n)}s.dispose(),clearTimeout(o),t&&i(`workspaceContains:${c.join(",")}`)}function D(w,u,c,i){const s=w.get(R.$Oh),r=w.get(E.$RI),t=s.createInstance(p.$7J).file(u.map(n=>(0,m.$$h)(F.URI.revive(n))),{_reason:"checkExists",includePattern:c,exists:!0});return r.fileSearch(t,i).then(n=>!!n.limitHit,n=>L.$3(n)?!1:Promise.reject(n))}e.$Xlb=D}),define(Se[46],De([1,0,212,16,56,23,8,3,78,2,15,6,40,291,117,39,26,147,9,25,22,270,7,65,5,27,91,20,106,73,45,4,361,116,272,18,114,36,12,115]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n,d,l,a,h,S,k,$,b,v,C,N,T,M,U,j,O){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=e.$sdc=e.$rdc=void 0,e.$rdc=(0,d.$Ph)("IHostUtils");let q=V=class extends p.$Rc{constructor(H,z,X,re,Z,ee,_,we,ue,ge,te,fe){super(),this.X=fe,this.a=this.B(new b.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=X,this.f=_,this.j=re,this.m=Z,this.s=ee,this.t=ue,this.u=ge,this.w=te,this.y=this.g.getProxy(P.$tK.MainThreadWorkspace),this.z=this.g.getProxy(P.$tK.MainThreadTelemetry),this.C=this.g.getProxy(P.$tK.MainThreadExtensionService),this.D=new R.$Sg,this.F=new R.$Sg,this.G=new R.$Sg,this.H=new R.$Sg,this.I=new ae(this.f.extensions.activationEvents),this.L=new c.$Z4b(this.I,this.f.extensions.allExtensions);const be=new s.$7l(this.f.extensions.myExtensions);this.J=new c.$Z4b(this.I,ce(this.L,be)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new D.$$cc(this.g,this.s),this.N=new C.$kdc(this.g),this.O=we,this.h=H.createChild(new S.$Nh([D.$_cc,this.M],[C.$ldc,this.N])),this.P=this.B(new y.$0cc(this.J,this.L,{onExtensionActivationError:(Pe,B,J)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),J)},actualActivateExtension:async(Pe,B)=>{if(c.$Z4b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$9cc;const J=this.J.getExtensionDescription(Pe);return this.db(J,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){i.$Z(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this.cb(Z))}catch{}await Promise.all(H)}terminate(H,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(re=>{this.s.error(re)}),this.g.dispose();const X=this.Y();Promise.race([(0,R.$Ug)(5e3),X]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const z=await this.C.$getExtension(H);return z&&{...z,identifier:new s.$6l(z.identifier.value),extensionLocation:m.URI.revive(z.extensionLocation)}}Z(H,z){return this.P.activateByEvent(H,z)}$(H,z){return this.P.activateById(H,z)}activateByIdWithErrors(H,z){return this.$(H,z).then(()=>{const X=this.P.getActivatedExtension(H);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===T.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(H.fsPath);return m.URI.file(z)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new ie(H))),this.Q}async bb(H){const z=E.$Vh.forUris(X=>L.$mg.ignorePathCasing(X));return await Promise.all(H.map(async X=>{if(this.ub(X)){const re=await this.ab(X.extensionLocation);z.set(re,X)}})),z}cb(H){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return z;const X=this.P.getActivatedExtension(H);if(!X)return z;try{typeof X.module.deactivate=="function"&&(z=Promise.resolve(X.module.deactivate()).then(void 0,re=>(this.s.error(re),Promise.resolve(void 0))))}catch(re){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(re)}try{(0,p.$Mc)(X.subscriptions)}catch(re){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(re)}return z}async db(H,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,z).then(X=>{const re=X.activationTimes;return this.C.$onDidActivateExtension(H.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,z),this.eb(H,z,"success",re),X},X=>{throw this.eb(H,z,"failure"),X})}eb(H,z,X,re){const Z=x(H,z);this.z.$publicLog2("extensionActivationTimes",{...Z,...re||{},outcome:X})}fb(H,z){const X=x(H,z);this.z.$publicLog2("activatePlugin",X);const re=this.ub(H);if(!re)return Promise.resolve(new y.$8cc(y.$5cc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${H.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const Z=new y.$6cc(z.startup);return Promise.all([this.vb(H,(0,L.$vg)(H.extensionLocation,re),Z),this.gb(H)]).then(ee=>(f.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),V.hb(this.s,H.identifier,ee[0],ee[1],Z))).then(ee=>(f.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),ee))}gb(H){const z=new o.$bdc(H,this.M),X=new o.$adc(H.identifier.value,!1,this.M),re=new N.$mdc(H,this.N),Z=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ee=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([z.whenReady,X.whenReady,this.O.whenReady]).then(()=>{const _=this;let we,ue;const ge=(0,u.$kF)(H,"ipc")?this.f.messagePorts?.get(s.$6l.toKey(H.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:X,secrets:re,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(H.extensionLocation.fsPath,te)},get storagePath(){return _.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return _.O.globalValue(H).fsPath},get logPath(){return F.$ic(_.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return m.URI.joinPath(_.f.logsLocation,H.identifier.value)},get storageUri(){return _.O.workspaceValue(H)},get globalStorageUri(){return _.O.globalValue(H)},get extensionMode(){return Z},get extension(){return we===void 0&&(we=new G(_,H.identifier,H,ee,!1)),we},get extensionRuntime(){return(0,u.$lF)(H,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!ue){if(!ge)return;const te=b.Event.buffer(b.Event.fromDOMEventEmitter(ge,"message",fe=>fe.data));ge.start(),ue={onDidReceiveMessage:te,postMessage:ge.postMessage.bind(ge)}}return ue}})})}static hb(H,z,X,re,Z){return X=X||{activate:void 0,deactivate:void 0},this.ib(H,z,X,re,Z).then(ee=>new y.$7cc(!1,null,Z.build(),X,ee,re.subscriptions))}static ib(H,z,X,re,Z){if(typeof X.activate=="function")try{Z.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ee=typeof global=="object"?global:self,_=X.activate.apply(ee,[re]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(_).then(we=>(Z.activateResolveStop(),we))}catch(ee){return Promise.reject(ee)}else return Promise.resolve(X)}jb(H,z){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:z}).then(void 0,X=>{this.s.error(X)})}kb(H,z=0){const re=Date.now();(0,j.$B)(()=>{for(let Z=z;Z<H.length;Z+=1){const ee=H[Z];for(const _ of ee.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-re>50){this.kb(H,Z);break}else this.jb(ee,_)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(H=>{const z=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this.J.getAllExtensionDescriptions();if(z)this.kb(X);else for(const re of X)if(re.activationEvents)for(const Z of re.activationEvents)Z==="onStartupFinished"&&this.jb(re,Z)})}mb(){const H=this.Z("*",!0).then(void 0,ee=>{this.s.error(ee)});this.B(this.j.onDidChangeWorkspace(ee=>this.nb(ee.added)));const z=this.j.workspace?this.j.workspace.folders:[],X=this.nb(z),re=this.pb(),Z=Promise.all([re,H,X]).then(()=>{});return Promise.race([Z,(0,R.$Ug)(1e4)]).then(()=>{this.lb()}),Z}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(H,z))).then(()=>{})}async ob(H,z){if(this.isActivated(z.identifier))return;const X=!this.f.remote.isRemote&&!!this.f.remote.authority,re={logService:this.s,folders:H.map(ee=>ee.uri),forceUsingSearch:X||!this.c.fsExists,exists:ee=>this.c.fsExists(ee.fsPath),checkExists:(ee,_,we)=>this.y.$checkExists(ee,_,we)},Z=await(0,v.$Wlb)(re,z);if(Z)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:Z.activationEvent}).then(void 0,ee=>this.s.error(ee))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:z}=this.f.environment;if(!H||!z)throw new Error(I.localize(0,null));const X=await this.vb(null,z,new y.$6cc(!1));if(!X||typeof X.run!="function")throw new Error(I.localize(1,null,z.toString()));return new Promise((re,Z)=>{const ee=(ue,ge)=>{ue?(j.$t&&this.s.error("Test runner called back with error",ue),Z(ue)):(j.$t&&(ge?this.s.info(`Test runner called back with ${ge} failures.`):this.s.info("Test runner called back with successful outcome.")),re(typeof ge=="number"&&ge>0?1:0))},_=(0,L.$jg)(z),we=X.run(_,ee);we&&we.then&&we.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),re(0)}).catch(ue=>{j.$t&&this.s.error("Test runner finished with error",ue),Z(ue instanceof Error&&ue.stack?ue.stack:String(ue))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,z){return this.R[H]=z,(0,p.$Pc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:z}=await this.sb(H);return z?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const z=H.indexOf("+");if(z===-1)throw new t.$BK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const X=H.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this.R[X]}}async $resolveAuthority(H,z){const X=U.$Jd.create(!1),re=()=>`[resolveAuthority(${(0,n.$Tk)(H)},${z})][${X.elapsed()}ms] `,Z=oe=>this.s.info(`${re()}${oe}`),ee=oe=>this.s.warn(`${re()}${oe}`),_=(oe,Y=void 0)=>this.s.error(`${re()}${oe}`,Y),we=oe=>{if(oe instanceof t.$BK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ue=async oe=>{Z(`activating resolver for ${oe}...`);const{resolver:Y,authorityPrefix:me}=await this.sb(oe);if(!Y)throw _(`no resolver for ${me}`),new t.$BK(`No remote extension installed to resolve ${me}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:me,remoteAuthority:oe}},ge=H.split(/@|%40/g).reverse();Z(`activating remote resolvers ${ge.join(" -> ")}`);let te;try{te=await Promise.all(ge.map(ue)).catch(async oe=>{if(!(oe instanceof t.$BK)||oe._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return ee(`resolving nested authorities failed: ${oe.message}`),[await ue(H)]})}catch(oe){return we(oe)}const fe=new R.$5g;fe.cancelAndSet(()=>Z("waiting..."),1e3);let be,Pe;for(const[oe,{authorityPrefix:Y,resolver:me,remoteAuthority:Ee}]of te.entries())try{if(oe===te.length-1)Z("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Y}`),be=await me.resolve(Ee,{resolveAttempt:z,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${Y}`),Z("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(me,t.$AK.isManagedResolvedAuthority(be)?be:void 0));else{if(Z(`invoking resolveExecServer() for ${Ee}`),f.mark(`code/extHost/willResolveExecServer/${Y}`),Pe=await me.resolveExecServer?.(Ee,{resolveAttempt:z,execServer:Pe}),!Pe)throw new t.$BK(`Exec server was not available for ${Ee}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(je){return f.mark(`code/extHost/didResolveAuthorityError/${Y}`),_("returned an error",je),fe.dispose(),we(je)}fe.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},J={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};Z(`returned ${t.$AK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let se;if(t.$AK.isManagedResolvedAuthority(be)){const oe=z;this.X.setFactory(oe,be.makeConnection),se={authority:H,connectTo:new n.$Qk(oe),connectionToken:be.connectionToken}}else se={authority:H,connectTo:new n.$Rk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:se,options:J,tunnelInformation:B}}}async $getCanonicalURI(H,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Tk)(H)})`);const{resolver:X}=await this.sb(H);if(!X)return null;const re=m.URI.revive(z);if(typeof X.getCanonicalURI>"u")return re;const Z=await(0,R.$Mg)(()=>X.getCanonicalURI(re));return Z||re}$startExtensionHost(H){H.toAdd.forEach(re=>re.extensionLocation=m.URI.revive(re.extensionLocation));const{globalRegistry:z,myExtensions:X}=de(this.I,this.L,this.J,H);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(X),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(H,z){return z===1?this.D.wait().then(X=>this.Z(H,!1)):this.G.wait().then(X=>this.Z(H,!1))}async $activate(H,z){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,z),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(ee=>ee.extensionLocation=m.URI.revive(ee.extensionLocation));const{globalRegistry:z,myExtensions:X}=de(this.I,this.L,this.J,H),re=await this.bb(X);return(await this.getExtensionPathIndex()).setSearchTree(re),this.L.set(z.getAllExtensionDescriptions()),this.J.set(X),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const z=r.$be.alloc(H),X=Math.random()%256;for(let re=0;re<H;re++)z.writeUInt8(X,re);return z}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$sdc=q,e.$sdc=q=V=He([Be(0,d.$Oh),Be(1,e.$rdc),Be(2,h.$uM),Be(3,w.$Xcc),Be(4,g.$1cc),Be(5,A.$0i),Be(6,l.$KM),Be(7,a.$edc),Be(8,k.$vwb),Be(9,$.$gdc),Be(10,M.$odc),Be(11,O.$pdc)],q);function de(ye,H,z,X){ye.addActivationEvents(X.addActivationEvents);const re=new c.$Z4b(ye,H.getAllExtensionDescriptions());re.deltaExtensions(X.toAdd,X.toRemove);const Z=new s.$7l(z.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of X.myToRemove)Z.delete(_);for(const _ of X.myToAdd)Z.add(_);const ee=ce(re,Z);return{globalRegistry:re,myExtensions:ee}}function x(ye,H){return{id:ye.identifier.value,name:ye.name,extensionVersion:ye.version,publisherDisplayName:ye.publisher,activationEvents:ye.activationEvents?ye.activationEvents.join(","):null,isBuiltin:ye.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function Q(ye){return ye.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$tdc=(0,d.$Ph)("IExtHostExtensionService");class G{#e;#t;#i;constructor(H,z,X,re,Z){this.#e=H,this.#t=z,this.#i=X.identifier,this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=F.$gc((0,L.$jg)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=re,this.isFromDifferentExtensionHost=Z}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$udc=G;function ce(ye,H){return ye.getAllExtensionDescriptions().filter(z=>H.has(z.identifier))}class ie{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$vdc=ie;class ae{constructor(H){this.a=new s.$8l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const z of Object.keys(H))this.a.set(z,H[z])}}}),define(Se[362],De([1,0,56,2,6,40,26,25,20,27,5,46,15,13]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;let w=class{constructor(r,o,t,n,d,l,a){this.c=r,this.d=o,this.e=t,this.f=n,this.g=d,this.h=l,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new c(this.c,o,this.d,r,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,o,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const o of r.nodeModuleName)this.a.set(o,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(o=>r.alternativeModuleName(o))}};e.$Tec=w,e.$Tec=w=He([Be(2,A.$Oh),Be(3,L.$1cc),Be(4,P.$tdc),Be(5,m.$KM),Be(6,g.$0i)],w);let u=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&D.a.size){const o=(0,y.$Fe)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const o=this.b.exec(this.c(r));if(!o)return;const[,t,n,d]=o,l=D.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};u=D=He([Be(0,m.$KM)],u);class c{constructor(r,o,t,n,d){this.c=r,this.d=o,this.e=t,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new p.$8l}load(r,o){const t=this.d.findSubstr(o);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${n}`),this.b=this.c(R.$fF,this.e,this.f)}return this.b}}let i=class{constructor(r,o,t){this.e=r,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$tK.MainThreadTelemetry);const n=t.getProxy(f.$tK.MainThreadWindow);this.c=(d,l)=>{const a=F.URI.parse(d);return l?this.g(d,l):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,d,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?n.$openUri(a,d,{}):this.g(d,l)}}load(r,o,t){const n=this.e.findSubstr(o);return n&&(this.a=n.identifier.value,this.h()),this.b=t(r),this.c}g(r,o){return this.i(),this.b(r,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,E.$uM)],i)}),define(Se[58],De([1,0,47,3,16,48,5,70,71,46,7,39,288,40]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0,e.$2dc=(0,R.$Ph)("IExtHostVariableResolverProvider");class D extends g.$vN{constructor(c,i,s,r,o,t,n){function d(){if(s){const l=s.activeEditor();if(l)return l.document.uri;const a=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.$bM||a.input instanceof A.$gM)return a.input.modified;if(a.input instanceof A.$aM||a.input instanceof A.$fM||a.input instanceof A.$dM)return a.input.uri}}}super({getFolderUri:l=>{const a=t.folders.filter(h=>h.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,a)=>o.getConfiguration(void 0,l).get(a),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return f.$gc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const l=d();if(l){const a=i.getWorkspaceFolder(l);if(a)return f.$gc(a.uri.fsPath)}}},getSelectedText:()=>{if(s){const l=s.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(s){const l=s.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>c.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(L.env))}}let w=class extends F.$Rc{constructor(c,i,s,r,o){super(),this.b=c,this.c=i,this.g=s,this.h=r,this.j=o,this.a=new I.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$3dc=w,e.$3dc=w=He([Be(0,m.$tdc),Be(1,P.$Xcc),Be(2,p.$FM),Be(3,y.$1cc),Be(4,E.$Zdc)],w)}),define(Se[95],De([1,0,8,4,2,5,6,71,46,20,7,39,142,280,40,58]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=e.$6dc=e.$5dc=e.$4dc=void 0,e.$4dc=(0,L.$Ph)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,d,l,a,h,S){this.E=d,this.F=l,this.G=a,this.H=h,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Nd,this.n=new F.$Nd,this.o=new F.$Nd,this.u=new F.$Nd,this.k=n.getProxy(R.$tK.MainThreadDebugService),this.y=new F.$Nd,this.A=new F.$Nd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange($=>{this.J(k)}),this.J(k)})}asDebugSourceUri(n,d){const l=n;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let a=`debug:${encodeURIComponent(l.path||"")}`,h="?";return d&&(a+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),a+=`${h}ref=${l.sourceReference}`,f.URI.parse(a)}else{if(l.path)return f.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const d=[];for(const l of n.getAllExtensionDescriptions())if(l.contributes){const a=l.contributes.debuggers;if(a&&a.length>0)for(const h of a)(0,y.$zF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(d=>n.push(d)),n}addBreakpoints(n){const d=n.filter(h=>{const S=h.id;return this.w.has(S)?!1:(this.w.set(S,h),!0)});this.U(d,[],[]);const l=[],a=new Map;for(const h of d)if(h instanceof A.$uL){let S=a.get(h.location.uri.toString());S||(S={type:"sourceMulti",uri:h.location.uri,lines:[]},a.set(h.location.uri.toString(),S),l.push(S)),S.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$vL&&l.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(n){const d=n.filter(S=>this.w.delete(S.id));this.U([],d,[]);const l=d.filter(S=>S instanceof A.$uL).map(S=>S.id),a=d.filter(S=>S instanceof A.$vL).map(S=>S.id),h=d.filter(S=>S instanceof A.$wL).map(S=>S.id);return this.k.$unregisterBreakpoints(l,a,h)}startDebugging(n,d,l){return this.k.$startDebugging(n?n.uri:void 0,d,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,d,l){if(!d)return new A.$vK(()=>{});const a=this.d++;return this.f.push({type:n,handle:a,provider:d}),this.k.$registerDebugConfigurationProvider(n,l,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,a),new A.$vK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,d,l){if(!l)return new A.$vK(()=>{});if(!this.Q(n,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:d,handle:a,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(d,a),new A.$vK(()=>{this.h=this.h.filter(h=>h.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,d){if(!d)return new A.$vK(()=>{});const l=this.i++;return this.j.push({type:n,handle:l,factory:d}),new A.$vK(()=>{this.j=this.j.filter(a=>a.factory!==d)})}async $runInTerminal(n,d){return Promise.resolve(void 0)}async $substituteVariables(n,d){let l;const a=await this.W(n);return a&&(l={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(l,d)}K(n,d){if(n.type==="implementation")return new r(n.implementation)}L(){}async $startDASession(n,d){const l=this,a=await this.V(d);return this.S(this.N(a.type),a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const S=this.M(h),k=this.K(S,a);if(!k)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const $=k;return this.B.set(n,$),this.R(a).then(b=>(b&&this.C.set(n,b),$.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const C=v,N={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const T=await this.D.sign(C.arguments.value);N.body={signature:T},$.sendResponse(N)}else throw new Error("no signer")}catch(T){N.success=!1,N.message=T.message,$.sendResponse(N)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(v),v=(0,y.$EF)(v,!0),l.k.$acceptDAMessage(n,v)}),$.onError(v=>{b&&b.onError&&b.onError(v),this.k.$acceptDAError(n,v.name,v.message,v.stack)}),$.onExit(v=>{b&&b.onExit&&b.onExit(v??void 0,void 0),this.k.$acceptDAExit(n,v??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),$.startSession()))})}$sendDAMessage(n,d){d=(0,y.$DF)(d,!1);const l=this.C.get(n);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(d),this.B.get(n)?.sendMessage(d)}$stopDASession(n){const d=this.C.get(n);this.C.delete(n),d&&d.onWillStopSession&&d.onWillStopSession();const l=this.B.get(n);return this.B.delete(n),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const d=[],l=[],a=[];if(n.added)for(const h of n.added){const S=h.id;if(S&&!this.w.has(S)){let k;if(h.type==="function")k=new A.$vL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")k=new A.$wL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const $=f.URI.revive(h.uri);k=new A.$uL(new A.$HK($,new A.$wK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$sL)(k,S),this.w.set(S,k),d.push(k)}}if(n.removed)for(const h of n.removed){const S=this.w.get(h);S&&(this.w.delete(h),l.push(S))}if(n.changed){for(const h of n.changed)if(h.id){const S=this.w.get(h.id);if(S){if(S instanceof A.$vL&&h.type==="function"){const k=S;k.enabled=h.enabled,k.condition=h.condition,k.hitCondition=h.hitCondition,k.logMessage=h.logMessage,k.functionName=h.functionName}else if(S instanceof A.$uL&&h.type==="source"){const k=S;k.enabled=h.enabled,k.condition=h.condition,k.hitCondition=h.hitCondition,k.logMessage=h.logMessage,k.location=new A.$HK(f.URI.revive(h.uri),new A.$wK(h.line,h.character))}a.push(S)}}}this.U(d,l,a)}async $acceptStackFrameFocus(n){let d;const l=n.sessionId?await this.V(n.sessionId):void 0;if(!l)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?d=new A.$CL(l,n.threadId):d=new A.$BL(l,n.threadId,n.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(n,d,l){return(0,I.$Mg)(async()=>{const a=this.P(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return a.provideDebugConfigurations(h,l)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,d,l,a){return(0,I.$Mg)(async()=>{const h=this.P(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(d);return h.resolveDebugConfiguration(S,l,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,d,l,a){return(0,I.$Mg)(async()=>{const h=this.P(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(S,l,a)})}async $provideDebugAdapter(n,d){const l=this.O(n);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(d);return this.S(l,a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(n){const d=await this.V(n);this.m.fire(d)}async $acceptDebugSessionTerminated(n){const d=await this.V(n);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,d){(await this.V(n))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(n,d){const a={session:await this.V(n),event:d.event,body:d.body};this.u.fire(a)}M(n){if(n instanceof A.$xL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof A.$yL)return{type:"server",port:n.port,host:n.host};if(n instanceof A.$zL)return{type:"pipeServer",path:n.path};if(n instanceof A.$AL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const d=this.h.filter(l=>l.type===n);if(d.length>0)return d[0].factory}O(n){const d=this.h.filter(l=>l.handle===n);if(d.length>0)return d[0].factory}P(n){const d=this.f.filter(l=>l.handle===n);if(d.length>0)return d[0].provider}Q(n,d){if(n.contributes){const l=n.contributes.debuggers;if(l&&l.length>0){for(const a of l)if(a.label&&a.type&&a.type===d)return!0}}return!1}R(n){const l=n.configuration.type,a=this.j.filter(h=>h.type===l||h.type==="*").map(h=>(0,I.$Mg)(()=>h.factory.createDebugAdapterTracker(n)).then(S=>S,S=>null));return Promise.race([Promise.all(a).then(h=>{const S=h.filter(k=>!!k);if(S.length>0)return new s(S)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(n,d){const l=d.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new A.$yL(l));if(n){const h=await this.F.getExtensionRegistry();return(0,I.$Mg)(()=>n.createDebugAdapterDescriptor(d,this.T(d,h))).then(S=>{if(S)return S})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,a))}T(n,d){}U(n,d,l){(n.length>0||d.length>0||l.length>0)&&this.y.fire(Object.freeze({added:n,removed:d,changed:l}))}async V(n){if(n)if(typeof n=="string"){const d=this.l.get(n);if(d)return d}else{let d=this.l.get(n.id);if(!d){const l=await this.W(n.folderUri),a=n.parent?this.l.get(n.parent):void 0;d=new c(this.k,n.id,n.type,n.name,l,n.configuration,a),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(n){if(n){const d=f.URI.revive(n);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$5dc=u,e.$5dc=u=He([Be(0,m.$uM),Be(1,P.$Xcc),Be(2,E.$tdc),Be(3,D.$1cc),Be(4,p.$Zdc),Be(5,w.$2dc)],u);class c{constructor(n,d,l,a,h,S,k){this.d=n,this.f=d,this.g=l,this.h=a,this.i=h,this.j=S,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,d){return this.d.$customDebugAdapterRequest(this.f,n,d)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$6dc=c;class i{constructor(n){this.value=Object.freeze({append(d){n.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$7dc=i;class s{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(d=>d.onError?d.onError(n):void 0)}onExit(n,d){this.d.forEach(l=>l.onExit?l.onExit(n,d):void 0)}}class r extends g.$ldb{constructor(n){super(),this.h=n,n.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let o=class extends u{constructor(n,d,l,a,h,S){super(n,d,l,a,h,S)}};e.$8dc=o,e.$8dc=o=He([Be(0,m.$uM),Be(1,P.$Xcc),Be(2,E.$tdc),Be(3,D.$1cc),Be(4,p.$Zdc),Be(5,w.$2dc)],o)}),define(Se[363],De([1,0,9,56,2,6,352,15,105,106,27,246,20,67,46,89]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=void 0;class u{static async installEarlyHandler(s){Error.stackTraceLimit=100;const r=s.get(p.$0i),t=s.get(g.$uM).getProxy(L.$tK.MainThreadErrors);I.setUnexpectedErrorHandler(n=>{r.error(n);const d=I.$2(n);t.$onUnexpectedError(d)})}static async installFullHandler(s){const r=s.get(p.$0i),o=s.get(g.$uM),t=s.get(D.$tdc),n=s.get(w.$OM),d=o.getProxy(L.$tK.MainThreadExtensionService),l=o.getProxy(L.$tK.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;function S(b,v){if(h.has(b))return h.get(b).stack;let C="",N,T;for(const U of v)C+=`
	at ${U.toString()}`,T=U.getFileName(),!N&&T&&(N=a.findSubstr(f.URI.file(T)));const M=`${b.name||"Error"}: ${b.message||""}${C}`;return h.set(b,{extensionIdentifier:N?.identifier,stack:M}),M}const k=Symbol("prepareStackTrace wrapped");let $=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(b){if(b===S||!b||b[k]){$=b||S;return}$=function(v,C){return S(v,C),b.call(Error,v,C)},Object.assign($,{[k]:!0})}}),I.setUnexpectedErrorHandler(b=>{r.error(b);const v=I.$2(b),C=h.get(b);if(!C?.extensionIdentifier){l.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(C.extensionIdentifier,v);const N=n.onExtensionError(C.extensionIdentifier,b);r.trace("forwarded error to extension?",N,C)})}}e.$Uec=u;class c{constructor(s,r,o,t,n){this.a=o,this.b=new R.$94b(s,null,t),r=c.e(r,this.b);const d=new m.$Nh(...(0,E.$Ar)());d.set(A.$KM,{_serviceBrand:void 0,...r,messagePorts:n}),d.set(g.$uM,new g.$vM(this.b)),d.set(y.$Ucc,new y.$Vcc(t)),d.set(D.$rdc,o);const l=new P.$gq(d,!0);l.invokeFunction(u.installEarlyHandler),this.d=l.invokeFunction(a=>a.get(p.$0i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(a=>a.get(D.$tdc)),this.c.initialize(),l.invokeFunction(u.installFullHandler)}async asBrowserUri(s){const r=this.b.getProxy(L.$tK.MainThreadExtensionService);return f.URI.revive(await r.$asBrowserUri(s))}terminate(s){this.c.terminate(s)}static e(s,r){s.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),s.environment.appRoot=f.URI.revive(r.transformIncomingURIs(s.environment.appRoot));const o=s.environment.extensionDevelopmentLocationURI;return o&&(s.environment.extensionDevelopmentLocationURI=o.map(t=>f.URI.revive(r.transformIncomingURIs(t)))),s.environment.extensionTestsLocationURI=f.URI.revive(r.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=f.URI.revive(r.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=f.URI.revive(r.transformIncomingURIs(s.environment.workspaceStorageHome)),s.environment.extensionTelemetryLogResource=f.URI.revive(r.transformIncomingURIs(s.environment.extensionTelemetryLogResource)),s.nlsBaseUrl=f.URI.revive(r.transformIncomingURIs(s.nlsBaseUrl)),s.logsLocation=f.URI.revive(r.transformIncomingURIs(s.logsLocation)),s.workspace=r.transformIncomingURIs(s.workspace),s}}e.$Vec=c}),define(Se[364],De([1,0,8,12,223,240,140,95,71,46,20,45,7,58,39,281,282,40]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;let i=class extends p.$5dc{constructor(n,d,l,a,h,S,k){super(n,d,l,a,S,k),this.Z=h,this.X=new o}K(n,d){switch(n.type){case"server":return new w.$1ec(n);case"pipeServer":return new w.$2ec(n);case"executable":return new w.$3ec(n,d.type)}return super.K(n,d)}T(n,d){const l=w.$3ec.platformAdapterExecutable(d.getAllExtensionDescriptions(),n.type);if(l)return new g.$xL(l.command,l.args,l.options)}L(){return new R.$S8b}async $runInTerminal(n,d){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const l=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),S=n.title||f.localize(0,null),k=JSON.stringify({shell:a,shellArgs:h});let $=await this.X.checkout(k,S),b,v=!1;if($)b=n.cwd;else{const M={shellPath:a,shellArgs:h,cwd:n.cwd,name:S,iconPath:new g.$pL("debug")};v=!0,$=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,k)}$.show(!0);const C=await $.processId;v?await new Promise(M=>setTimeout(M,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?$.sendText("cls"):a.indexOf("bash")>=0?$.sendText("clear"):F.$j?$.sendText("cls"):$.sendText("clear"));const N=(0,u.$5ec)(a,n.args,!!n.argsCanBeInterpretedByShell,b,n.env);$.sendText(N);const T=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free($),T.dispose())});return C}else if(n.kind==="external")return r(n,await this.G.getConfigProvider());return super.$runInTerminal(n,d)}};e.$6ec=i,e.$6ec=i=He([Be(0,A.$uM),Be(1,D.$Xcc),Be(2,m.$tdc),Be(3,c.$1cc),Be(4,P.$gdc),Be(5,E.$Zdc),Be(6,y.$2dc)],i);let s;function r(t,n){if(!s)if(F.$j)s=new L.$E7b;else if(F.$k)s=new L.$F7b;else if(F.$l)s=new L.$G7b;else throw new Error("external terminals not supported on this platform");const d=n.getConfiguration("terminal");return s.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class o{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,d){const a=[...this.b.entries()].map(([h,S])=>(0,I.$Hg)(async k=>{if(h.name!==d||S.lastUsedAt!==-1&&await(0,u.$4ec)(await h.processId))return null;const $=Date.now();return S.lastUsedAt+o.a>$||k.isCancellationRequested||S.config!==n?null:(S.lastUsedAt=$,h)}));return await(0,I.$Yg)(a,h=>!!h)}insert(n,d){this.b.set(n,{lastUsedAt:Date.now(),config:d})}free(n){const d=this.b.get(n);d&&(d.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(Se[365],De([1,0,16,2,103,39,70,40,44,45,20,27,94,18,15,90,23,63,58]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;let s=class extends g.$Wdc{constructor(o,t,n,d,l,a,h,S,k){super(o,t,n,d,l,a,h,S),this.B=n,this.C=k,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=g.TaskHandleDTO.from(n,this.B),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(l,t);return this.a.$executeTask(d).catch(()=>{}),a}else{const d=g.TaskDTO.from(t,o);if(d===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const l=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}u(o,t,n,d){const l=[];if(d)for(const a of d){this.z(a,n),(!a.definition||!o[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const h=g.TaskDTO.from(a,n.extension);h&&(l.push(h),g.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,a,!0)))}return{tasks:l,extension:n.extension}}async v(o){return o}async F(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const n=F.URI.file((0,c.homedir)());t=new E.$0h({uri:n,name:u.$sg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const n=F.URI.revive(o),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),a=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),S=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const k of t.variables)d.variables[k]=await h.resolveAsync(S,k);if(t.process!==void 0){let k;if(t.process.path!==void 0){k=t.process.path.split(I.$sc);for(let $=0;$<k.length;$++)k[$]=await h.resolveAsync(S,k[$])}d.process=await f.win32.findExecutable(await h.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(S,t.process.cwd):void 0,k)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,n){return f.win32.findExecutable(o,t,n)}};e.$Xec=s,e.$Xec=s=He([Be(0,A.$uM),Be(1,P.$KM),Be(2,L.$Xcc),Be(3,R.$FM),Be(4,p.$1cc),Be(5,m.$gdc),Be(6,D.$0i),Be(7,w.$Ncc),Be(8,i.$2dc)],s)}),define(Se[366],De([1,0,63,58]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class f extends F.$3dc{m(){return(0,I.homedir)()}}e.$Dfc=f}),define(Se[155],De([1,0,19,8,21,41,18,16,23,2,35]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=e.$0dc=void 0;class P{constructor(i,s,r,o){this.d=i,this.e=s,this.f=r,this.g=o,this.a=null,this.b=!1,this.c=0}search(i,s){const r=this.d.folderQueries||[],o=new f.$Xd(s);return new Promise((t,n)=>{this.a=new y(i);let d=!1;const l=(a,h)=>{if(!d&&!this.b){const S=this.h(a);w(a)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,d=!0,o.cancel(),a=this.j(a,this.d.maxResults-this.c));const k=this.h(a);this.c+=k,(k>0||!w(a))&&this.a.add(a,h)}};Promise.all(r.map((a,h)=>this.k(a,S=>l(S,h),o.token))).then(a=>{o.dispose(),this.a.flush();const h=a.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||h,messages:(0,I.$Qb)(a.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},a=>{o.dispose();const h=(0,L.$Ai)(a);n(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,s){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],o=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,s),preview:{matches:o.slice(0,s),text:i.preview.text},uri:i.uri}}async k(i,s,r){const o=new A.$$I(this.d,i),t=[],n={report:a=>{if(!this.l(a))return;const h=i.folder.scheme===R.Schemas.file?(0,A.$_I)(()=>this.f.readdir(E.$ug(a.uri))):void 0,S=E.$xg(i.folder,a.uri);if(S){const k=o.includedInQuery(S,p.$mc(S),h);(0,F.$Gg)(k)?t.push(k.then($=>{$&&s(a)})):k&&s(a)}}},d=this.n(i),l=await this.e.provideTextSearchResults(g(this.d.contentPattern),d,n,r);return t.length&&await Promise.all(t),l}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const s=(0,A.$0I)(this.d.includePattern,i.includePattern),r=(0,A.$0I)(this.d.excludePattern,i.excludePattern),o={folder:m.URI.from(i.folder),excludes:r,includes:s,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return o.usePCRE2=this.d.usePCRE2,o}}e.$0dc=P;function g(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class y{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new u(512,s=>this.g(s))}add(i,s){this.d&&(this.b!==s||!E.$og(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=s,this.d={resource:i.uri,results:[]}),this.d.results.push(D(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$$dc=y;function D(c){return w(c)?{preview:{matches:(0,I.$1b)(c.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:c.preview.text},ranges:(0,I.$1b)(c.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function w(c){return!!c.preview}e.$_dc=w;class u{static{this.a=4e3}static{this.b=50}constructor(i,s){this.g=i,this.h=s,this.c=0,this.d=[],this.e=0}addItem(i,s){i&&this.j(i,s)}addItems(i,s){i&&this.k(i,s)}j(i,s){this.d.push(i),this.e+=s,this.l()}k(i,s){this.d=this.d.concat(i),this.e+=s,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$aec=u}),define(Se[96],De([1,0,3,6,5,359,20,67,15,2,155]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=e.$bec=void 0,e.$bec=(0,f.$Ph)("IExtHostSearch");let P=class{constructor(w,u,c){this.k=w,this.l=u,this.n=c,this.c=this.k.getProxy(F.$tK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$9dc}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,u){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const c=this.d++;return this.e.set(c,u),this.c.$registerTextSearchProvider(c,this.o(w)),(0,I.$Pc)(()=>{this.g.delete(w),this.e.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(w,u){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const c=this.d++;return this.h.set(c,u),this.c.$registerFileSearchProvider(c,this.o(w)),(0,I.$Pc)(()=>{this.i.delete(w),this.h.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(w,u,c,i){const s=g(c),r=this.h.get(w);if(r)return this.j.fileSearch(s,r,o=>{this.c.$handleFileMatch(w,u,o.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,u,c){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,u,c,i){const s=this.e.get(w);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=g(c);return this.q(r,s).search(t=>this.c.$handleTextMatch(w,u,t),i)}$enableExtensionHostSearch(){}q(w,u){return new A.$0dc(w,u,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};e.$cec=P,e.$cec=P=He([Be(0,R.$uM),Be(1,p.$Ucc),Be(2,E.$0i)],P);function g(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(y),extraFileResources:D.extraFileResources&&D.extraFileResources.map(w=>m.URI.revive(w))}}e.$dec=g;function y(D){return{...D,folder:m.URI.revive(D.folder)}}}),define(Se[367],De([1,0,21,9,4,38,2,132,80,171,190,31,6,113,312,311,34,313,40,315,316,317,292,318,70,46,320,321,326,327,328,154,296,333,334,337,117,45,339,297,14,7,86,342,92,153,39,25,286,325,66,151,94,95,96,15,67,20,27,358,283,73,90,304,340,91,72,345,343,344,305,57,338,341,116,71,89,329,93,330,18,136,295,271,323,3,26,279,114,265,331,332,306,322,294,324,115,335,309,336,310,303,319,307,308]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n,d,l,a,h,S,k,$,b,v,C,N,T,M,U,j,O,V,q,de,x,Q,G,ce,ie,ae,ye,H,z,X,re,Z,ee,_,we,ue,ge,te,fe,be,Pe,B,J,se,oe,Y,me,Ee,je,We,_e,Xe,it,tt,Ae,Ne,qe,Re,Ze,he,le,Ie,Ke,ze,Ye,nt,ct,bt,Et,Kt,Ht,wt,jt,Nt,Gt,zt,Dt,Ft,Bt,Jt,Wt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;function Ot(ut){const ft=ut.get(ue.$KM),At=ut.get(je.$Kcc),Vt=ut.get(se.$ddc),Lt=ut.get(l.$tdc),at=ut.get(ce.$Xcc),vt=ut.get(tt.$OM),Tt=ut.get(i.$1cc),Pt=ut.get(_.$Ucc),Ge=ut.get(we.$uM),Qt=ut.get(M.$_cc),Me=ut.get(J.$edc),Te=ut.get(ee.$$i),Ce=ut.get(ee.$0i),ne=ut.get(fe.$vwb),Fe=ut.get(be.$Ncc),Ve=ut.get(G.$Rdc),xe=ut.get(Xe.$ldc),Je=ut.get(it.$Zdc),rt=ut.get(Nt.$pdc);Ge.set(g.$uK.ExtHostFileSystemInfo,At),Ge.set(g.$uK.ExtHostLogLevelServiceShape,Te),Ge.set(g.$uK.ExtHostWorkspace,at),Ge.set(g.$uK.ExtHostConfiguration,Tt),Ge.set(g.$uK.ExtHostExtensionService,Lt),Ge.set(g.$uK.ExtHostStorage,Qt),Ge.set(g.$uK.ExtHostTunnelService,ne),Ge.set(g.$uK.ExtHostWindow,Ve),Ge.set(g.$uK.ExtHostSecretState,xe),Ge.set(g.$uK.ExtHostTelemetry,vt),Ge.set(g.$uK.ExtHostEditorTabs,Je),Ge.set(g.$uK.ExtHostManagedSockets,rt);const kt=Ge.set(g.$uK.ExtHostDecorations,ut.get(z.$Vdc)),St=Ge.set(g.$uK.ExtHostDocumentsAndEditors,ut.get(d.$FM)),mt=Ge.set(g.$uK.ExtHostCommands,ut.get(u.$QM)),dt=Ge.set(g.$uK.ExtHostTerminalService,ut.get(U.$gdc)),gt=Ge.set(g.$uK.ExtHostDebugService,ut.get(re.$4dc)),ui=Ge.set(g.$uK.ExtHostSearch,ut.get(Z.$bec)),Ct=Ge.set(g.$uK.ExtHostTask,ut.get(X.$Ydc)),Di=Ge.set(g.$uK.ExtHostOutputService,ut.get(b.$Bdc)),li=Ge.set(g.$uK.ExtHostLocalization,ut.get(nt.$odc)),$i=Ge.set(g.$uK.ExtHostUrls,new x.$Kdc(Ge)),It=Ge.set(g.$uK.ExtHostDocuments,new n.$Icc(Ge,St)),gn=Ge.set(g.$uK.ExtHostDocumentContentProviders,new o.$3cc(Ge,St,Ce)),ri=Ge.set(g.$uK.ExtHostDocumentSaveParticipant,new t.$4cc(Ce,It,Ge.getProxy(g.$tK.MainThreadBulkEdits))),yt=Ge.set(g.$uK.ExtHostNotebook,new ge.$hec(Ge,mt,St,It,Vt,ui)),bi=Ge.set(g.$uK.ExtHostNotebookDocuments,new le.$zec(yt)),pi=Ge.set(g.$uK.ExtHostNotebookEditors,new he.$yec(Ce,yt)),si=Ge.set(g.$uK.ExtHostNotebookKernels,new Ae.$vec(Ge,ft,yt,mt,Ce)),Ci=Ge.set(g.$uK.ExtHostNotebookRenderers,new qe.$xec(Ge,yt)),Ii=Ge.set(g.$uK.ExtHostNotebookDocumentSaveParticipant,new wt.$Fec(Ce,yt,Ge.getProxy(g.$tK.MainThreadBulkEdits))),Rt=Ge.set(g.$uK.ExtHostEditors,new j.$Idc(Ge,St)),wi=Ge.set(g.$uK.ExtHostTreeViews,new O.$Jdc(Ge.getProxy(g.$tK.MainThreadTreeViews),mt,Ce)),Pi=Ge.set(g.$uK.ExtHostEditorInsets,new ae.$Sdc(Ge.getProxy(g.$tK.MainThreadEditorInsets),Rt,ft.remote)),oi=Ge.set(g.$uK.ExtHostDiagnostics,new s.$Mcc(Ge,Ce,At,St)),hi=Ge.set(g.$uK.ExtHostLanguages,new k.$ydc(Ge,It,mt.converter,Pt)),lt=Ge.set(g.$uK.ExtHostLanguageFeatures,new S.$Qcc(Ge,Pt,It,mt,oi,Ce,Fe,vt)),Ai=Ge.set(g.$uK.ExtHostFileSystem,new a.$wdc(Ge,lt)),Yt=Ge.set(g.$uK.ExtHostFileSystemEventService,new h.$xdc(Ge,Ce,St)),ii=Ge.set(g.$uK.ExtHostQuickOpen,(0,C.$Ddc)(Ge,at,mt)),Li=Ge.set(g.$uK.ExtHostSCM,new N.$Fdc(Ge,mt,It,Ce)),Ri=Ge.set(g.$uK.ExtHostQuickDiff,new Et.$Cec(Ge,Pt)),Mi=Ge.set(g.$uK.ExtHostShare,new Gt.$Hec(Ge,Pt)),Xi=Ge.set(g.$uK.ExtHostComments,(0,c.$Tcc)(Ge,mt,It)),Fi=Ge.set(g.$uK.ExtHostProgress,new v.$Cdc(Ge.getProxy(g.$tK.MainThreadProgress))),Zi=Ge.set(g.$uK.ExtHosLabelService,new ye.$Tdc(Ge)),Ti=Ge.set(g.$uK.ExtHostTheming,new te.$iec(Ge)),ai=Ge.set(g.$uK.ExtHostAuthentication,new Pe.$jec(Ge)),mn=Ge.set(g.$uK.ExtHostTimeline,new B.$lec(Ge,mt)),Ni=Ge.set(g.$uK.ExtHostWebviews,new Q.$Ndc(Ge,ft.remote,at,Ce,Fe)),di=Ge.set(g.$uK.ExtHostWebviewPanels,new me.$nec(Ge,Ni,at)),Oi=Ge.set(g.$uK.ExtHostCustomEditors,new Y.$oec(Ge,It,Me,Ni,di)),$n=Ge.set(g.$uK.ExtHostWebviewViews,new oe.$mec(Ge,Ni)),fi=Ge.set(g.$uK.ExtHostTesting,new We.$qec(Ge,mt,St)),Yi=Ge.set(g.$uK.ExtHostUriOpeners,new _e.$uec(Ge)),Ui=Ge.set(g.$uK.ExtHostProfileContentHandlers,new bt.$Bec(Ge));Ge.set(g.$uK.ExtHostInteractive,new Ie.$Aec(Ge,yt,St,mt,Ce));const xi=Ge.set(g.$uK.ExtHostInlineChat,new Ht.$Eec(Ge,mt,It,Ce)),gi=Ge.set(g.$uK.ExtHostChatProvider,new zt.$Iec(Ge,Ce)),_i=Ge.set(g.$uK.ExtHostChatAgents,new Wt.$Nec(Ge,gi,Ce)),bn=Ge.set(g.$uK.ExtHostChatAgents2,new qt.$Oec(Ge,gi,Ce)),ji=Ge.set(g.$uK.ExtHostChatVariables,new Ft.$Kec(Ge)),mi=Ge.set(g.$uK.ExtHostChat,new Kt.$Dec(Ge,Ce)),xt=Ge.set(g.$uK.ExtHostAiRelatedInformation,new Bt.$Lec(Ge)),vi=Ge.set(g.$uK.ExtHostAiEmbeddingVector,new Jt.$Mec(Ge)),en=Ge.set(g.$uK.ExtHostIssueReporter,new jt.$Gec(Ge)),Xt=Ge.set(g.$uK.ExtHostStatusBar,new T.$Hdc(Ge,mt.converter)),yi=Ge.set(g.$uK.ExtHostSpeech,new Dt.$Jec(Ge)),tn=Object.values(g.$uK);Ge.assertRegistered(tn);const nn=new Ee.$pec(Ge,St),rn=new w.$Scc(Ge),Ei=new $.$zdc(Ge,Ce),sn=new r.$2cc(Ge);return D.$Rcc.register(mt),function(Ue,_t,on){const $t=function(){let pe=!Ue.isUnderDevelopment;function ke(){pe||(Ce.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const pt=st;typeof pt.scheme>"u"&&ke(),typeof pt.exclusive=="boolean"&&(0,ze.$lF)(Ue,"documentFiltersExclusive")}return st}}(),zi={getSession(pe,ke,Oe){return ai.getSession(Ue,pe,ke,Oe)},getSessions(pe,ke){return(0,ze.$lF)(Ue,"authGetSessions"),ai.getSessions(Ue,pe,ke)},async hasSession(pe,ke){return(0,ze.$lF)(Ue,"authSession"),!!await ai.getSession(Ue,pe,ke,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(pe,ke,Oe,st){return ai.registerAuthenticationProvider(pe,ke,Oe,st)}},an={registerCommand(pe,ke,Oe){return mt.registerCommand(!0,pe,ke,Oe,void 0,Ue)},registerTextEditorCommand(pe,ke,Oe){return mt.registerCommand(!0,pe,(...st)=>{const pt=Rt.getActiveTextEditor();if(!pt){Ce.warn("Cannot execute "+pe+" because there is no active text editor.");return}return pt.edit(Mt=>{ke.apply(Oe,[pt,Mt,...st])}).then(Mt=>{Mt||Ce.warn("Edits from command "+pe+" were not applied.")},Mt=>{Ce.warn("An error occurred while running command "+pe,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(pe,ke,Oe)=>((0,ze.$lF)(Ue,"diffCommand"),mt.registerCommand(!0,pe,async(...st)=>{const pt=St.activeEditor(!0);if(!pt){Ce.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Mt=await Rt.getDiffInformation(pt.id);ke.apply(Oe,[Mt,...st])},void 0,void 0,Ue)),executeCommand(pe,...ke){return mt.executeCommand(pe,...ke)},getCommands(pe=!1){return mt.getCommands(pe)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$lF)(Ue,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$lF)(Ue,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.$NM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return tt.$MM.validateSender(pe),vt.instantiateLogger(Ue,pe,ke)},openExternal(pe,ke){return Ve.openUri(pe,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===ft.environment.appUriScheme)return $i.createAppUri(pe);try{return await Ve.asExternalUri(pe,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Ze.$wU)(pe,Re.Schemas.http)||(0,Ze.$wU)(pe,Re.Schemas.https))return pe;throw ke}},get remoteName(){return(0,H.$Vk)(ft.remote.authority)},get remoteAuthority(){return(0,ze.$lF)(Ue,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ce.getLevel()},get onDidChangeLogLevel(){return Ce.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,ze.$lF)(Ue,"handleIssueUri"),en.registerIssueUriRequestHandler(Ue,pe)},registerIssueDataProvider(pe){return(0,ze.$lF)(Ue,"handleIssueUri"),en.registerIssueDataProvider(Ue,pe)},get appQuality(){return(0,ze.$lF)(Ue,"resolvers"),ft.quality},get appCommit(){return(0,ze.$lF)(Ue,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(pe,ke,Oe){return fi.createTestController(Ue,pe,ke,Oe)},createTestObserver(){return(0,ze.$lF)(Ue,"testObserver"),fi.createTestObserver()},runTests(pe){return(0,ze.$lF)(Ue,"testObserver"),fi.runTests(pe)},get onDidChangeTestResults(){return(0,ze.$lF)(Ue,"testObserver"),fi.onResultsChanged},get testResults(){return(0,ze.$lF)(Ue,"testObserver"),fi.results}},ki=ft.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,pn={getExtension(pe,ke){(0,ze.$kF)(Ue,"extensionsAny")||(ke=!1);const Oe=_t.mine.getExtensionDescription(pe);if(Oe)return new l.$udc(Lt,Ue.identifier,Oe,ki,!1);if(ke){const st=_t.all.getExtensionDescription(pe);if(st)return new l.$udc(Lt,Ue.identifier,st,ki,!0)}},get all(){const pe=[];for(const ke of _t.mine.getAllExtensionDescriptions())pe.push(new l.$udc(Lt,Ue.identifier,ke,ki,!1));return pe},get allAcrossExtensionHosts(){(0,ze.$lF)(Ue,"extensionsAny");const pe=new ie.$7l(_t.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of _t.all.getAllExtensionDescriptions()){const st=!pe.has(Oe.identifier);ke.push(new l.$udc(Lt,Ue.identifier,Oe,ki,st))}return ke},get onDidChange(){return(0,ze.$kF)(Ue,"extensionsAny")?f.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(pe){return oi.createDiagnosticCollection(Ue.identifier,pe)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:pe=>oi.getDiagnostics(pe),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(pe,ke){return hi.changeLanguage(pe.uri,ke)},match(pe,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,A.$xE)(V.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(pe,ke,Oe){return lt.registerCodeActionProvider(Ue,$t(pe),ke,Oe)},registerDocumentPasteEditProvider(pe,ke,Oe){return(0,ze.$lF)(Ue,"documentPaste"),lt.registerDocumentPasteEditProvider(Ue,$t(pe),ke,Oe)},registerCodeLensProvider(pe,ke){return lt.registerCodeLensProvider(Ue,$t(pe),ke)},registerDefinitionProvider(pe,ke){return lt.registerDefinitionProvider(Ue,$t(pe),ke)},registerDeclarationProvider(pe,ke){return lt.registerDeclarationProvider(Ue,$t(pe),ke)},registerImplementationProvider(pe,ke){return lt.registerImplementationProvider(Ue,$t(pe),ke)},registerTypeDefinitionProvider(pe,ke){return lt.registerTypeDefinitionProvider(Ue,$t(pe),ke)},registerHoverProvider(pe,ke){return lt.registerHoverProvider(Ue,$t(pe),ke,Ue.identifier)},registerEvaluatableExpressionProvider(pe,ke){return lt.registerEvaluatableExpressionProvider(Ue,$t(pe),ke,Ue.identifier)},registerInlineValuesProvider(pe,ke){return lt.registerInlineValuesProvider(Ue,$t(pe),ke,Ue.identifier)},registerDocumentHighlightProvider(pe,ke){return lt.registerDocumentHighlightProvider(Ue,$t(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return lt.registerLinkedEditingRangeProvider(Ue,$t(pe),ke)},registerReferenceProvider(pe,ke){return lt.registerReferenceProvider(Ue,$t(pe),ke)},registerRenameProvider(pe,ke){return lt.registerRenameProvider(Ue,$t(pe),ke)},registerDocumentSymbolProvider(pe,ke,Oe){return lt.registerDocumentSymbolProvider(Ue,$t(pe),ke,Oe)},registerWorkspaceSymbolProvider(pe){return lt.registerWorkspaceSymbolProvider(Ue,pe)},registerDocumentFormattingEditProvider(pe,ke){return lt.registerDocumentFormattingEditProvider(Ue,$t(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return lt.registerDocumentRangeFormattingEditProvider(Ue,$t(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,Oe,...st){return lt.registerOnTypeFormattingEditProvider(Ue,$t(pe),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(pe,ke,Oe){return lt.registerDocumentSemanticTokensProvider(Ue,$t(pe),ke,Oe)},registerDocumentRangeSemanticTokensProvider(pe,ke,Oe){return lt.registerDocumentRangeSemanticTokensProvider(Ue,$t(pe),ke,Oe)},registerSignatureHelpProvider(pe,ke,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(Ue,$t(pe),ke,Oe):lt.registerSignatureHelpProvider(Ue,$t(pe),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(pe,ke,...Oe){return lt.registerCompletionItemProvider(Ue,$t(pe),ke,Oe)},registerInlineCompletionItemProvider(pe,ke,Oe){return ke.handleDidShowCompletionItem&&(0,ze.$lF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$lF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,ze.$lF)(Ue,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ue,$t(pe),ke,Oe)},registerDocumentLinkProvider(pe,ke){return lt.registerDocumentLinkProvider(Ue,$t(pe),ke)},registerColorProvider(pe,ke){return lt.registerColorProvider(Ue,$t(pe),ke)},registerFoldingRangeProvider(pe,ke){return lt.registerFoldingRangeProvider(Ue,$t(pe),ke)},registerSelectionRangeProvider(pe,ke){return lt.registerSelectionRangeProvider(Ue,pe,ke)},registerCallHierarchyProvider(pe,ke){return lt.registerCallHierarchyProvider(Ue,pe,ke)},registerTypeHierarchyProvider(pe,ke){return lt.registerTypeHierarchyProvider(Ue,pe,ke)},setLanguageConfiguration:(pe,ke)=>lt.setLanguageConfiguration(Ue,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,ze.$lF)(Ue,"tokenInformation"),hi.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return lt.registerInlayHintsProvider(Ue,pe,ke)},createLanguageStatusItem(pe,ke){return hi.createLanguageStatusItem(Ue,pe,ke)},registerDocumentDropEditProvider(pe,ke,Oe){return lt.registerDocumentOnDropEditProvider(Ue,pe,ke,(0,ze.$kF)(Ue,"dropMetadata")?Oe:void 0)}},ln={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(pe,ke,Oe){const st=await(R.URI.isUri(pe)?Promise.resolve(Si.openTextDocument(pe)):Promise.resolve(pe));return Rt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(pe){return Rt.createTextEditorDecorationType(Ue,pe)},onDidChangeActiveTextEditor(pe,ke,Oe){return Rt.onDidChangeActiveTextEditor(pe,ke,Oe)},onDidChangeVisibleTextEditors(pe,ke,Oe){return Rt.onDidChangeVisibleTextEditors(pe,ke,Oe)},onDidChangeTextEditorSelection(pe,ke,Oe){return Rt.onDidChangeTextEditorSelection(pe,ke,Oe)},onDidChangeTextEditorOptions(pe,ke,Oe){return Rt.onDidChangeTextEditorOptions(pe,ke,Oe)},onDidChangeTextEditorVisibleRanges(pe,ke,Oe){return Rt.onDidChangeTextEditorVisibleRanges(pe,ke,Oe)},onDidChangeTextEditorViewColumn(pe,ke,Oe){return Rt.onDidChangeTextEditorViewColumn(pe,ke,Oe)},onDidCloseTerminal(pe,ke,Oe){return dt.onDidCloseTerminal(pe,ke,Oe)},onDidOpenTerminal(pe,ke,Oe){return dt.onDidOpenTerminal(pe,ke,Oe)},onDidChangeActiveTerminal(pe,ke,Oe){return dt.onDidChangeActiveTerminal(pe,ke,Oe)},onDidChangeTerminalDimensions(pe,ke,Oe){return(0,ze.$lF)(Ue,"terminalDimensions"),dt.onDidChangeTerminalDimensions(pe,ke,Oe)},onDidChangeTerminalState(pe,ke,Oe){return dt.onDidChangeTerminalState(pe,ke,Oe)},onDidWriteTerminalData(pe,ke,Oe){return(0,ze.$lF)(Ue,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(pe,ke,Oe)},onDidExecuteTerminalCommand(pe,ke,Oe){return(0,ze.$lF)(Ue,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(pe,ke,Oe)},get state(){return Ve.getState(Ue)},onDidChangeWindowState(pe,ke,Oe){return Ve.onDidChangeWindowState(pe,ke,Oe)},showInformationMessage(pe,...ke){return Ei.showMessage(Ue,L.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return Ei.showMessage(Ue,L.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return Ei.showMessage(Ue,L.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,Oe){return ii.showQuickPick(Ue,pe,ke,Oe)},showWorkspaceFolderPick(pe){return ii.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return ii.showInput(pe,ke)},showOpenDialog(pe){return sn.showOpenDialog(Ue,pe)},showSaveDialog(pe){return sn.showSaveDialog(pe)},createStatusBarItem(pe,ke,Oe){let st,pt,Mt;return typeof pe=="string"?(st=pe,pt=ke,Mt=Oe):(pt=pe,Mt=ke),Xt.createStatusBarEntry(Ue,st,pt,Mt)},setStatusBarMessage(pe,ke){return Xt.setStatusBarMessage(pe,ke)},withScmProgress(pe){return Fe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Fi.withProgress(Ue,{location:q.ProgressLocation.SourceControl},(ke,Oe)=>pe({report(st){}}))},withProgress(pe,ke){return Fi.withProgress(Ue,pe,ke)},createOutputChannel(pe,ke){return Di.createOutputChannel(pe,ke,Ue)},createWebviewPanel(pe,ke,Oe,st){return di.createWebviewPanel(Ue,pe,ke,Oe,st)},createWebviewTextEditorInset(pe,ke,Oe,st){return(0,ze.$lF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(pe,ke,Oe,st,Ue)},createTerminal(pe,ke,Oe){return typeof pe=="object"?"pty"in pe?dt.createExtensionTerminal(pe):dt.createTerminalFromOptions(pe):dt.createTerminal(pe,ke,Oe)},registerTerminalLinkProvider(pe){return dt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return dt.registerProfileProvider(Ue,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,ze.$lF)(Ue,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(pe,Ue.identifier.value,ke)},registerTreeDataProvider(pe,ke){return wi.registerTreeDataProvider(pe,ke,Ue)},createTreeView(pe,ke){return wi.createTreeView(pe,ke,Ue)},registerWebviewPanelSerializer:(pe,ke)=>di.registerWebviewPanelSerializer(Ue,pe,ke),registerCustomEditorProvider:(pe,ke,Oe={})=>Oi.registerCustomEditorProvider(Ue,pe,ke,Oe),registerFileDecorationProvider(pe){return kt.registerFileDecorationProvider(pe,Ue)},registerUriHandler(pe){return $i.registerUriHandler(Ue,pe)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,Oe){return Ti.onDidChangeActiveColorTheme(pe,ke,Oe)},registerWebviewViewProvider(pe,ke,Oe){return $n.registerWebviewViewProvider(Ue,pe,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,Oe){return yt.onDidChangeActiveNotebookEditor(pe,ke,Oe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,Oe){return pi.onDidChangeNotebookEditorSelection(pe,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(pe,ke,Oe){return pi.onDidChangeNotebookEditorVisibleRanges(pe,ke,Oe)},showNotebookDocument(pe,ke){return yt.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,Oe){return(0,ze.$lF)(Ue,"externalUriOpener"),Yi.registerExternalUriOpener(Ue.identifier,pe,ke,Oe)},registerProfileContentHandler(pe,ke){return(0,ze.$lF)(Ue,"profileContentHandlers"),Ui.registrProfileContentHandler(Ue,pe,ke)},registerQuickDiffProvider(pe,ke,Oe,st){return(0,ze.$lF)(Ue,"quickDiffProvider"),Ri.registerQuickDiffProvider($t(pe),ke,Oe,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(pe,ke){return(0,ze.$lF)(Ue,"shareProvider"),Mi.registerShareProvider($t(pe),ke)}},Si={get rootPath(){return Fe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(pe){throw new F.$8("rootPath")},getWorkspaceFolder(pe){return at.getWorkspaceFolder(pe)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(pe){throw new F.$8("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(pe){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(pe,ke,...Oe)=>at.updateWorkspaceFolders(Ue,pe,ke||0,...Oe),onDidChangeWorkspaceFolders:function(pe,ke,Oe){return at.onDidChangeWorkspace(pe,ke,Oe)},asRelativePath:(pe,ke)=>at.getRelativePath(pe,ke),findFiles:(pe,ke,Oe,st)=>at.findFiles(pe,ke,Oe,Ue.identifier,st),findTextInFiles:(pe,ke,Oe,st)=>{(0,ze.$lF)(Ue,"findTextInFiles");let pt,Mt;return typeof ke=="object"?(pt=ke,Mt=Oe):(pt={},Mt=ke,st=Oe),at.findTextInFiles(pe,pt||{},Mt,Ue.identifier,st)},save:pe=>((0,ze.$lF)(Ue,"saveEditor"),at.save(pe)),saveAs:pe=>((0,ze.$lF)(Ue,"saveEditor"),at.saveAs(pe)),saveAll:pe=>at.saveAll(pe),applyEdit(pe,ke){return nn.applyWorkspaceEdit(pe,Ue,ke)},createFileSystemWatcher:(pe,ke,Oe,st)=>{let pt;return typeof ke=="boolean"?pt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st,correlate:!1}:ke&&((0,ze.$lF)(Ue,"createFileSystemWatcher"),pt={...ke,correlate:!0}),Yt.createFileSystemWatcher(at,Ue,pe,pt)},get textDocuments(){return It.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new F.$8("textDocuments")},openTextDocument(pe){let ke;const Oe=pe;if(typeof pe=="string")ke=Promise.resolve(R.URI.file(pe));else if(R.URI.isUri(pe))ke=Promise.resolve(pe);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(pt=>pt.document))},onDidOpenTextDocument:(pe,ke,Oe)=>It.onDidAddDocument(pe,ke,Oe),onDidCloseTextDocument:(pe,ke,Oe)=>It.onDidRemoveDocument(pe,ke,Oe),onDidChangeTextDocument:(pe,ke,Oe)=>It.onDidChangeDocument(pe,ke,Oe),onDidSaveTextDocument:(pe,ke,Oe)=>It.onDidSaveDocument(pe,ke,Oe),onWillSaveTextDocument:(pe,ke,Oe)=>ri.getOnWillSaveTextDocumentEvent(Ue)(pe,ke,Oe),get notebookDocuments(){return yt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let Oe;if(R.URI.isUri(pe))Oe=pe,await yt.openNotebookDocument(pe);else if(typeof pe=="string")Oe=R.URI.revive(await yt.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(pe,ke,Oe){return bi.onDidSaveNotebookDocument(pe,ke,Oe)},onDidChangeNotebookDocument(pe,ke,Oe){return bi.onDidChangeNotebookDocument(pe,ke,Oe)},onWillSaveNotebookDocument(pe,ke,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(Ue)(pe,ke,Oe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,Oe,st){return yt.registerNotebookSerializer(Ue,pe,ke,Oe,(0,ze.$kF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(pe,ke,Oe)=>on.onDidChangeConfiguration(pe,ke,Oe),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,on.getConfiguration(pe,ke,Ue)},registerTextDocumentContentProvider(pe,ke){return gn.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(Fe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Ue,pe,ke)),registerFileSystemProvider(pe,ke,Oe){return(0,Ke.$Oc)(Ai.registerFileSystemProvider(Ue,pe,ke,Oe),Vt.addFileSystemProvider(pe,ke,Oe))},get fs(){return Vt.value},registerFileSearchProvider:(pe,ke)=>((0,ze.$lF)(Ue,"fileSearchProvider"),ui.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,ze.$lF)(Ue,"textSearchProvider"),ui.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,ze.$lF)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,ze.$lF)(Ue,"resolvers"),Zi.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,ze.$lF)(Ue,"resolvers"),Lt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,Oe)=>Yt.onDidCreateFile(pe,ke,Oe),onDidDeleteFiles:(pe,ke,Oe)=>Yt.onDidDeleteFile(pe,ke,Oe),onDidRenameFiles:(pe,ke,Oe)=>Yt.onDidRenameFile(pe,ke,Oe),onWillCreateFiles:(pe,ke,Oe)=>Yt.getOnWillCreateFileEvent(Ue)(pe,ke,Oe),onWillDeleteFiles:(pe,ke,Oe)=>Yt.getOnWillDeleteFileEvent(Ue)(pe,ke,Oe),onWillRenameFiles:(pe,ke,Oe)=>Yt.getOnWillRenameFileEvent(Ue)(pe,ke,Oe),openTunnel:pe=>((0,ze.$lF)(Ue,"tunnels"),ne.openTunnel(Ue,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$lF)(Ue,"tunnels"),ne.getTunnels()},onDidChangeTunnels:(pe,ke,Oe)=>((0,ze.$lF)(Ue,"tunnels"),ne.onDidChangeTunnels(pe,ke,Oe)),registerPortAttributesProvider:(pe,ke)=>((0,ze.$lF)(Ue,"portsAttributes"),ne.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,ze.$lF)(Ue,"tunnelFactory"),ne.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,ze.$lF)(Ue,"timeline"),mn.registerTimelineProvider(pe,ke,Ue.identifier,mt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:pe=>((0,ze.$lF)(Ue,"workspaceTrust"),at.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,Oe)=>at.onDidGrantWorkspaceTrust(pe,ke,Oe),registerEditSessionIdentityProvider:(pe,ke)=>((0,ze.$lF)(Ue,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,Oe)=>((0,ze.$lF)(Ue,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(Ue)(pe,ke,Oe)),registerCanonicalUriProvider:(pe,ke)=>((0,ze.$lF)(Ue,"canonicalUriProvider"),at.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,Oe)=>((0,ze.$lF)(Ue,"canonicalUriProvider"),at.provideCanonicalUri(pe,ke,Oe))},Wi={get inputBox(){return Fe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Li.getLastInputBox(Ue)},createSourceControl(pe,ke,Oe){return Li.createSourceControl(Ue,pe,ke,Oe)}},qi={createCommentController(pe,ke){return Xi.createCommentController(Ue,pe,ke)}},ci={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(pe,ke,Oe){return gt.onDidStartDebugSession(pe,ke,Oe)},onDidTerminateDebugSession(pe,ke,Oe){return gt.onDidTerminateDebugSession(pe,ke,Oe)},onDidChangeActiveDebugSession(pe,ke,Oe){return gt.onDidChangeActiveDebugSession(pe,ke,Oe)},onDidReceiveDebugSessionCustomEvent(pe,ke,Oe){return gt.onDidReceiveDebugSessionCustomEvent(pe,ke,Oe)},onDidChangeBreakpoints(pe,ke,Oe){return gt.onDidChangeBreakpoints(pe,ke,Oe)},onDidChangeStackFrameFocus(pe,ke,Oe){return(0,ze.$lF)(Ue,"debugFocus"),gt.onDidChangeStackFrameFocus(pe,ke,Oe)},registerDebugConfigurationProvider(pe,ke,Oe){return gt.registerDebugConfigurationProvider(pe,ke,Oe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return gt.registerDebugAdapterDescriptorFactory(Ue,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return gt.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?gt.startDebugging(pe,ke,{parentSession:Oe}):gt.startDebugging(pe,ke,Oe||{})},stopDebugging(pe){return gt.stopDebugging(pe)},addBreakpoints(pe){return gt.addBreakpoints(pe)},removeBreakpoints(pe){return gt.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return gt.asDebugSourceUri(pe,ke)}},Vi={registerTaskProvider:(pe,ke)=>Ct.registerTaskProvider(Ue,pe,ke),fetchTasks:pe=>Ct.fetchTasks(pe),executeTask:pe=>Ct.executeTask(Ue,pe),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(pe,ke,Oe)=>Ct.onDidStartTask(pe,ke,Oe),onDidEndTask:(pe,ke,Oe)=>Ct.onDidEndTask(pe,ke,Oe),onDidStartTaskProcess:(pe,ke,Oe)=>Ct.onDidStartTaskProcess(pe,ke,Oe),onDidEndTaskProcess:(pe,ke,Oe)=>Ct.onDidEndTaskProcess(pe,ke,Oe)},Ki={createNotebookController(pe,ke,Oe,st,pt){return si.createNotebookController(Ue,pe,ke,Oe,st,(0,ze.$kF)(Ue,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>yt.registerNotebookCellStatusBarItemProvider(Ue,pe,ke),createRendererMessaging(pe){return Ci.createRendererMessaging(Ue,pe)},createNotebookControllerDetectionTask(pe){return(0,ze.$lF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,pe)},registerKernelSourceActionProvider(pe,ke){return(0,ze.$lF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,Oe){return(0,ze.$lF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(pe,ke,Oe)}},Hi={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),Oe=!pe||typeof pe[0]!="object"?pe:pe[0];return li.getMessage(Ue.identifier.value,{message:ke,args:Oe})}return li.getMessage(Ue.identifier.value,pe[0])},get bundle(){return li.getBundle(Ue.identifier.value)},get uri(){return li.getBundleUri(Ue.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,ze.$lF)(Ue,"interactive"),xi.registerProvider(Ue,pe,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(pe,ke){return(0,ze.$lF)(Ue,"interactive"),mi.registerChatProvider(Ue,pe,ke)},sendInteractiveRequestToProvider(pe,ke){return(0,ze.$lF)(Ue,"interactive"),mi.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,ze.$lF)(Ue,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(pe,ke){return(0,ze.$lF)(Ue,"interactive"),mi.transferChatSession(pe,ke)}},hn={getRelatedInformation(pe,ke){return(0,ze.$lF)(Ue,"aiRelatedInformation"),xt.getRelatedInformation(Ue,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,ze.$lF)(Ue,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Ue,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,ze.$lF)(Ue,"aiRelatedInformation"),vi.registerEmbeddingVectorProvider(Ue,pe,ke)}},dn={registerChatResponseProvider(pe,ke,Oe){return(0,ze.$lF)(Ue,"chatProvider"),gi.registerProvider(Ue.identifier,pe,ke,Oe)},requestChatAccess(pe){return(0,ze.$lF)(Ue,"chatRequestAccess"),gi.requestChatResponseProvider(Ue.identifier,pe)},registerVariable(pe,ke,Oe){return(0,ze.$lF)(Ue,"chatVariables"),ji.registerVariableResolver(Ue,pe,ke,Oe)},registerMappedEditsProvider(pe,ke){return(0,ze.$lF)(Ue,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ue,pe,ke)},createChatAgent(pe,ke){return(0,ze.$lF)(Ue,"chatAgents2"),bn.createChatAgent(Ue,pe,ke)},registerAgent(pe,ke,Oe){return(0,ze.$lF)(Ue,"chatAgents"),_i.registerAgent(Ue.identifier,pe,ke,Oe)}},fn={registerSpeechProvider(pe,ke){return(0,ze.$lF)(Ue,"speech"),yi.registerProvider(Ue.identifier,pe,ke)}};return{version:ft.version,ai:hn,authentication:zi,commands:an,comments:qi,chat:dn,debug:ci,env:Bi,extensions:pn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:Vi,tests:cn,window:ln,workspace:Si,Breakpoint:q.$tL,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatAgentResultFeedbackKind:q.ChatAgentResultFeedbackKind,ChatMessage:q.$jM,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.$SK,CallHierarchyItem:q.$RK,CallHierarchyOutgoingCall:q.$TK,CancellationError:F.$4,CancellationTokenSource:I.$Xd,CandidatePortSource:g.CandidatePortSource,CodeAction:q.$OK,CodeActionKind:q.$PK,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$UK,Color:q.$8K,ColorInformation:q.$9K,ColorPresentation:q.$0K,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.$2K,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$3K,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$fL,DebugAdapterExecutable:q.$xL,DebugAdapterInlineImplementation:q.$AL,DebugAdapterNamedPipeServer:q.$zL,DebugAdapterServer:q.$yL,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$JK,DiagnosticRelatedInformation:q.$IK,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$vK,DocumentHighlight:q.$LK,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.$7K,DocumentSymbol:q.$NK,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$DL,InlineValueText:q.$EL,InlineValueVariableLookup:q.$FL,InlineValueEvaluatableExpression:q.$GL,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:f.$Nd,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$QL,FileDecoration2:q.$QL,FileSystemError:q.$IL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:q.$JL,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$vL,InlineCompletionItem:q.$4K,InlineCompletionList:q.$5K,Hover:q.$KK,IndentAction:m.IndentAction,Location:q.$HK,MarkdownString:q.$VK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:q.$WK,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$wK,ProcessExecution:q.$dL,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$PL,Range:q.$xK,RelativePattern:q.$rL,Selection:q.$yK,SelectionRange:q.$QK,SemanticTokens:q.$ML,SemanticTokensBuilder:q.$LL,SemanticTokensEdit:q.$NL,SemanticTokensEdits:q.$OL,SemanticTokensLegend:q.$KL,ShellExecution:q.$eL,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$YK,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$XK,SnippetString:q.$GK,SourceBreakpoint:q.$uL,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$MK,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$gL,TaskGroup:q.$cL,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$$K,TerminalQuickFixExecuteTerminalCommand:q.$aL,TerminalQuickFixOpener:q.$_K,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$bL,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$CK,SnippetTextEdit:q.$EK,TextEditorCursorStyle:p.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$qL,ThemeIcon:q.$pL,TreeItem:q.$hL,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$_L,UIKind:y.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$FK,DocumentDropEdit:q.$nL,DocumentPasteEdit:q.$oL,InlayHint:q.$1K,InlayHintLabelPart:q.$ZK,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$BK,ResolvedAuthority:q.$zK,ManagedResolvedAuthority:q.$AK,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$1L,NotebookRange:q.$SL,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$TL,NotebookData:q.$UL,NotebookRendererScript:q.$YL,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$WL,NotebookCellOutputItem:q.$VL,NotebookCellStatusBarItem:q.$XL,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$DK,NotebookKernelSourceAction:q.$ZL,PortAttributes:q.$3L,LinkedEditingRanges:q.$2L,TestResultState:q.TestResultState,TestRunRequest:q.$4L,TestMessage:q.$5L,TestMessage2:q.$5L,TestTag:q.$6L,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:q.$mL,DataTransferItem:q.$iL,CoveredCount:q.$7L,FileCoverage:q.$8L,StatementCoverage:q.$9L,BranchCoverage:q.$0L,FunctionCoverage:q.$$L,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$aM,TabInputTextDiff:q.$bM,TabInputTextMerge:q.$cM,TabInputCustom:q.$dM,TabInputNotebook:q.$fM,TabInputNotebookDiff:q.$gM,TabInputWebview:q.$eM,TabInputTerminal:q.$hM,TabInputInteractiveWindow:q.$iM,TelemetryTrustedValue:de.$mo,LogLevel:ee.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.$BL,ThreadFocus:q.$CL,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus}}}e.$Pec=Ot}),define(Se[368],De([1,0,105,154,39,151,40,34,70,45,94,95,96,117,73,90,153,72,57,116,89,71,152,15,58,114,115]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n,d,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$zr)(l.$odc,l.$ndc,1),(0,I.$zr)(n.$$i,t.$Qec,1),(0,I.$zr)(w.$Ncc,w.$Occ,1),(0,I.$zr)(p.$QM,p.$PM,0),(0,I.$zr)(R.$1cc,R.$Ycc,0),(0,I.$zr)(c.$ddc,c.$cdc,0),(0,I.$zr)(P.$4dc,P.$8dc,0),(0,I.$zr)(L.$Vdc,L.$Udc,0),(0,I.$zr)(E.$FM,E.$EM,0),(0,I.$zr)(a.$pdc,a.$qdc,0),(0,I.$zr)(i.$Kcc,i.$Jcc,0),(0,I.$zr)(F.$Bdc,F.$Adc,1),(0,I.$zr)(g.$bec,g.$cec,0),(0,I.$zr)(y.$_cc,y.$$cc,0),(0,I.$zr)(A.$Ydc,A.$Xdc,0),(0,I.$zr)(m.$gdc,m.$jdc,0),(0,I.$zr)(D.$vwb,D.$wwb,0),(0,I.$zr)(u.$Rdc,u.$Qdc,0),(0,I.$zr)(f.$Xcc,f.$Wcc,0),(0,I.$zr)(s.$ldc,s.$kdc,0),(0,I.$zr)(r.$OM,r.$LM,0),(0,I.$zr)(o.$Zdc,o.$1dc,0),(0,I.$zr)(d.$2dc,d.$3dc,0)}),define(Se[118],De([1,0,19,15,35,93]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=e.$7ec=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$7ec=R;function p(P,g,y,D){const w=(0,I.$1b)(y,E),u=new f.$WI(g,w,D),c=u.preview.matches;return{ranges:(0,I.$1b)(w,m),uri:P,preview:{text:u.preview.text,matches:(0,I.$1b)(c,m)}}}e.$8ec=p;function E(P){return new f.$XI(P.start.line,P.start.character,P.end.line,P.end.character)}function m(P){return new L.$LI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(g,y){this.a=g,this.b=y}appendLine(g){this.b.debug(`${this.a}#search`,g)}};e.$9ec=A,e.$9ec=A=He([Be(1,F.$0i)],A)}),define(Se[369],De([1,0,49,16,77,33,12,13,118,370]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=e.$0ec=void 0;const A=m.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(s,r,o,t){const n=g(s,r,o,t),d=r.folder.fsPath;return{cmd:I.spawn(A,n.args,{cwd:d}),rgDiskPath:A,siblingClauses:n.siblingClauses,rgArgs:n,cwd:d}}e.$0ec=P;function g(s,r,o,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];D([r],o,!1).forEach(l=>{const a=(0,E.$7ec)(l);if(n.push("-g",a),R.$k){const h=(0,f.$pl)(a);h!==a&&n.push("-g",h)}});const d=y([r],t,void 0,!1);return d.globArgs.forEach(l=>{const a=`!${(0,E.$7ec)(l)}`;if(n.push("-g",a),R.$k){const h=(0,f.$pl)(a);h!==a&&n.push("-g",h)}}),r.disregardIgnoreFiles!==!1?n.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),r.ignoreSymlinks||n.push("--follow"),s.exists&&n.push("--quiet"),n.push("--no-config"),r.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:d.siblingClauses}}function y(s,r,o,t=!0){const n=[];let d={};return s.forEach(l=>{const a=Object.assign({},l.excludePattern||{},r||{}),h=w(a,t?l.folder.fsPath:void 0,o);n.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:n,siblingClauses:d}}function D(s,r,o=!0){const t=[];return s.forEach(n=>{const d=Object.assign({},r||{},n.includePattern||{}),l=w(d,o?n.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function w(s,r,o){const t=[],n={};return Object.keys(s).forEach(d=>{if(o&&o.has(d)||!d)return;const l=s[d];d=c(r?u(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):l&&l.when&&(n[d]=l)}),{globArgs:t,siblingClauses:n}}function u(s,r){return F.$hc(r)?r:F.$ic(s,r)}e.$$ec=u;function c(s){return s=p.$Ke(s,"\\"),p.$Ke(s,"/")}function i(s){return L.$Tf(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.$_ec=i}),define(Se[371],De([1,0,49,55,16,372,19,41,37,77,33,12,36,13,17,30,35,369,129]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0;const s=new Set;process.on("exit",()=>{s.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&E.$wj(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Bq)(this.b).normalizedLowercase),this.u=l.excludePattern&&E.$wj(l.excludePattern),this.t=new Map,l.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),S=a.folder.fsPath;l.folderQueries.map(k=>k.folder.fsPath).filter(k=>k!==S).forEach(k=>{(0,A.$Xf)(k,S)&&(h[f.$kc(S,k)]=!0)}),this.t.set(S,new t(h,S))})}cancel(){this.l=!0,s.forEach(l=>l())}walk(l,a,h,S,k){if(this.m=g.$Jd.create(!1),this.l)return k(null,this.j);a.forEach($=>{const b=f.$mc($.fsPath);this.u&&this.u($.fsPath,b)||this.J(h,{relativePath:$.fsPath,searchPath:void 0})}),this.r=g.$Jd.create(!1),this.w(l,($,b)=>{this.x(this.y,this,$,h,S,v=>{if(v){const C=(0,p.$Ai)(v);console.error(C),this.q.push(C),b(v,void 0)}else b(null,void 0)})},($,b)=>{this.m.stop();const v=$?R.$Gb($)[0]:null;k(v,this.j)})}w(l,a,h){const S=new Array(l.length),k=new Array(l.length);let $=!1,b=0;if(l.length===0)return h(null,[]);l.forEach((v,C)=>{a(v,(N,T)=>{if(N?($=!0,S[C]=null,k[C]=N):(S[C]=T,k[C]=null),++b===l.length)return h($?k:null,S)})})}x(l,a,...h){try{l.apply(a,h)}catch(S){h[h.length-1](S)}}y(l,a,h,S){const k=l.folder.fsPath,$=P.$k,b=()=>M&&M.kill();s.add(b);let v=V=>{s.delete(b),v=()=>{},S(V)},C="";const N=this.D(),T=(0,c.$0ec)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),M=T.cmd,U=!Object.keys(T.siblingClauses).length,j=T.rgArgs.args.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");let O=`${T.rgDiskPath} ${j}
 - cwd: ${T.cwd}`;T.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(T.rgArgs.siblingClauses)}`),h({message:O}),this.s=0,this.z(M,"utf8",h,(V,q,de)=>{if(V){v(V);return}if(this.j){v();return}const Q=(C+($?m.$ol(q||""):q)).split(`
`);if(de){const G=Q.length;Q[G-1]=Q[G-1].trim(),Q[G-1]||Q.pop()}else C=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Q.length,U){for(const G of Q)if(this.J(a,{base:k,relativePath:G,searchPath:this.N(l,G)}),this.j){b();break}(de||this.j)&&v();return}this.G(l,N,k,Q,a),de&&(this.H(N,k,a),v())})}spawnFindCmd(l){const a=this.t.get(l.folder.fsPath),h=a.getBasenameTerms(),S=a.getPathTerms(),k=["-L","."];if(h.length||S.length){k.push("-not","(","(");for(const $ of h)k.push("-name",$),k.push("-o");for(const $ of S)k.push("-path",$),k.push("-o");k.pop(),k.push(")","-prune",")")}return k.push("-type","f"),I.spawn("find",k,{cwd:l.folder.fsPath})}readStdout(l,a,h){let S="";this.z(l,a,()=>{},(k,$,b)=>{if(k){h(k);return}S+=$,b&&h(null,S)})}z(l,a,h,S){let k=(v,C,N)=>{(v||N)&&(k=()=>{},this.r?.stop()),S(v,C,N)},$=!1;l.stdout?(this.A(l.stdout,a,k),l.stdout.once("data",()=>$=!0)):h({message:"stdout is null"});let b;l.stderr?b=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",v=>{k(v)}),l.on("close",v=>{let C;!$&&(C=this.C(b,a))&&n(C)?k(new Error(`command failed with error code ${v}: ${this.C(b,a)}`)):(this.g&&v===0&&(this.j=!0),k(null,"",!0))})}A(l,a,h){const S=new L.StringDecoder(a);return l.on("data",k=>{h(null,S.write(k))}),S}B(l){const a=[];return l.on("data",h=>{a.push(h)}),a}C(l,a){const h=new L.StringDecoder(a);return l.map(S=>h.write(S)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:a},h,S,k){S.indexOf(this.b)!==-1&&this.J(k,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const $=b=>{const v=f.$mc(b),C=f.$lc(b);let N=a[C];N||(N=a[C]=[],$(C)),N.push({base:h,relativePath:b,basename:v,searchPath:this.N(l,b)})};S.forEach($)}H({rootEntries:l,pathToEntries:a},h,S){const k=this,$=this.t.get(h),b=this.b;function v(C){k.o++;const N=(0,u.$aJ)(()=>C.map(T=>T.basename));for(let T=0,M=C.length;T<M;T++){const U=C[T],{relativePath:j,basename:O}=U;if($.test(j,O,b!==O?N:void 0))continue;const V=a[j];if(V)v(V);else{if(k.p++,j===b)continue;k.J(S,U)}if(k.j)break}}v(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,a,h,S,k){const $=l.folder,b=(0,u.$aJ)(()=>h);this.w(h,(v,C)=>{if(this.l||this.j)return C(null);const N=a?[a,v].join(f.sep):v;if(this.t.get(l.folder.fsPath).test(N,v,this.a.filePattern!==v?b:void 0))return C(null);const T=[$.fsPath,N].join(f.sep);F.lstat(T,(M,U)=>{if(M||this.l||this.j)return C(null);this.L(T,U,(j,O)=>j||this.l||this.j?C(null):O.isDirectory()?(this.o++,this.M(T,U,(V,q)=>V||this.l||this.j||(q=q||"",this.v[q])?C(null):(this.v[q]=!0,w.Promises.readdir(T).then(de=>{if(this.l||this.j)return C(null);this.I(l,N,de,S,x=>C(x||null))},de=>{C(null)})))):(this.p++,N===this.b||this.h&&D.$Cf(O.size)&&O.size>this.h||this.J(S,{base:$.fsPath,relativePath:N,searchPath:this.N(l,N)}),C(null,void 0)))})},v=>{const C=v&&R.$Gb(v);return k(C&&C.length>0?C[0]:void 0)})}J(l,a){this.K(a)&&(!this.d||this.d(a.relativePath,f.$mc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(a))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$8I)(l,this.c)}return!0}L(l,a,h){return a.isSymbolicLink()?F.stat(l,h):h(null,a)}M(l,a,h){return a.isSymbolicLink()?F.realpath(l,(S,k)=>S?h(S):h(null,k)):h(null,l)}N(l,a){return l.folderName?f.$ic(l.folderName,a):a}}e.$afc=r;class o{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,a,h){this.c.walk(this.a,this.b,l,a,(S,k)=>{h(S,{limitHit:k,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$bfc=o;class t{constructor(l,a){this.expression=l,this.c=a,this.d(l)}d(l){let a,h;Object.keys(l).filter(S=>l[S]).forEach(S=>{f.$hc(S)?(a=a||E.$rj(),a[S]=l[S]):(h=h||E.$rj(),h[S]=l[S])}),this.a=a&&E.$wj(a,{trimForExclusions:!0}),this.b=h&&E.$wj(h,{trimForExclusions:!0})}test(l,a,h){return this.b&&this.b(l,a,h)||this.a&&this.a(f.$ic(this.c,l),a,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...E.$yj(this.a)),this.b&&l.push(...E.$yj(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...E.$zj(this.a)),this.b&&l.push(...E.$zj(this.b)),l}}function n(d){const l=d.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return y.$qf(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[373],De([1,0,97,22,185,21]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=e.$PC=e.$OC=e.$NC=e.$MC=e.$LC=e.$KC=e.$JC=e.$IC=e.DecodeStreamErrorKind=e.$HC=e.$GC=e.$FC=e.$EC=e.$DC=e.$CC=e.$BC=e.$AC=void 0,e.$AC="utf8",e.$BC="utf8bom",e.$CC="utf16be",e.$DC="utf16le";function R(a){return[e.$AC,e.$BC,e.$CC,e.$DC].some(h=>h===a)}e.$EC=R,e.$FC=[254,255],e.$GC=[255,254],e.$HC=[239,187,191];const p=512,E=512,m=512*8,A=512*128;var P;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class g extends Error{constructor(h,S){super(h),this.decodeStreamErrorKind=S}}e.$IC=g;class y{static async create(h){let S;if(h!==e.$AC)S=(await(0,f.$zC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(h));else{const k=new TextDecoder;S={write($){return k.decode($,{stream:!0})},end(){return k.decode()}}}return new y(S)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function D(a,h){const S=h.minBytesRequiredForDetection??h.guessEncoding?m:E;return new Promise((k,$)=>{const b=(0,I.$2d)(U=>U.join("")),v=[];let C=0,N;const T=new L.$Xd,M=async()=>{try{const U=await l({buffer:F.$be.concat(v),bytesRead:C},h.guessEncoding);if(U.seemsBinary&&h.acceptTextOnly)throw new g("Stream is binary but only text is accepted for decoding",1);U.encoding=await h.overwriteEncoding(U.encoding),N=await y.create(U.encoding);const j=N.write(F.$be.concat(v).buffer);b.write(j),v.length=0,C=0,k({stream:b,detected:U})}catch(U){T.cancel(),b.destroy(),$(U)}};(0,I.$6d)(a,{onData:async U=>{N?b.write(N.write(U.buffer)):(v.push(U),C+=U.byteLength,C>=S&&(a.pause(),await M(),setTimeout(()=>a.resume())))},onError:U=>b.error(U),onEnd:async()=>{N||await M(),b.end(N?.end())}},T.token)})}e.$JC=D;async function w(a,h,S){const $=(await(0,f.$zC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(h),S);let b=!1,v=!1;return{read(){if(v)return null;const C=a.read();if(typeof C!="string"){if(v=!0,!b&&S?.addBOM)switch(h){case e.$AC:case e.$BC:return F.$be.wrap(Uint8Array.from(e.$HC));case e.$CC:return F.$be.wrap(Uint8Array.from(e.$FC));case e.$DC:return F.$be.wrap(Uint8Array.from(e.$GC))}const N=$.end();return N&&N.length>0?(b=!0,F.$be.wrap(N)):null}return b=!0,F.$be.wrap($.write(C))}}}e.$KC=w;async function u(a){return(await(0,f.$zC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(a))}e.$LC=u;function c(a){return a===e.$BC||a===null?e.$AC:a}e.$MC=c;function i(a,h){if(!a||h<e.$FC.length)return null;const S=a.readUInt8(0),k=a.readUInt8(1);if(S===e.$FC[0]&&k===e.$FC[1])return e.$CC;if(S===e.$GC[0]&&k===e.$GC[1])return e.$DC;if(h<e.$HC.length)return null;const $=a.readUInt8(2);return S===e.$HC[0]&&k===e.$HC[1]&&$===e.$HC[2]?e.$BC:null}e.$NC=i;const s=["ascii","utf-16","utf-32"];async function r(a){const h=await(0,f.$zC)("jschardet","dist/jschardet.min.js"),S=a.slice(0,A),k=n(S.buffer),$=h.detect(k);if(!$||!$.encoding)return null;const b=$.encoding.toLowerCase();return 0<=s.indexOf(b)?null:t($.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(a){const h=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[h]||h}function n(a){let h="";for(let S=0;S<a.length;S++)h+=String.fromCharCode(a[S]);return h}function d(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=a.match(/windows(\d+)/);return h?"windows-"+h[1]:a}}}e.$OC=d;function l({buffer:a,bytesRead:h},S){let k=i(a,h),$=!1;if(k!==e.$CC&&k!==e.$DC&&a){let b=!0,v=!0,C=!1;for(let N=0;N<h&&N<p;N++){const T=N%2===1,M=a.readUInt8(N)===0;if(M&&(C=!0),b&&(T&&!M||!T&&M)&&(b=!1),v&&(T&&M||!T&&!M)&&(v=!1),M&&!b&&!v)break}C&&(b?k=e.$DC:v?k=e.$CC:$=!0)}return S&&!$&&!k&&a?r(a.slice(0,h)).then(b=>({seemsBinary:!1,encoding:b})):{seemsBinary:$,encoding:k}}e.$PC=l,e.$QC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[156],De([1,0,373,30,155]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class L extends f.$0dc{constructor(p,E,m=F,A="searchProcess"){super(p,E,{readdir:P=>m.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,I.$OC)(P)},A)}}e.$jfc=L}),define(Se[157],De([1,0,49,389,372,19,74,37,16,13,2,35,93,390,370,118]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=e.$gfc=e.$ffc=e.$efc=e.$dfc=e.$cfc=void 0;const u=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class c{constructor(v){this.a=v}provideTextSearchResults(v,C,N,T){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((M,U)=>{T.onCancellationRequested(()=>G());const j=n(v,C),O=C.folder.fsPath,V=j.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${u} ${V}
 - cwd: ${O}`);let q=I.spawn(u,j,{cwd:O});q.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),U((0,P.$4I)(new P.$2I(H&&H.message,P.SearchErrorCode.rgProcessError)))});let de=!1;const x=new r(C.maxResults,O,C.previewOptions);x.on("result",H=>{de=!0,ie="",N.report(H)});let Q=!1;const G=()=>{Q=!0,q?.kill(),x?.cancel()};let ce=!1;x.on("hitLimit",()=>{ce=!0,G()});let ie="";q.stdout.on("data",H=>{x.handleData(H),de||(ie+=H)});let ae=!1;q.stdout.once("data",()=>ae=!0);let ye="";q.stderr.on("data",H=>{const z=H.toString();this.a.appendLine(z),ye.length+z.length<1e6&&(ye+=z)}),q.on("close",()=>{if(this.a.appendLine(ae?"Got data from stdout":"No data from stdout"),this.a.appendLine(de?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),Q)M({limitHit:ce});else{x.flush(),q=null;let H;ye&&!ae&&(H=i(ye))?U((0,P.$4I)(new P.$2I(H.message,H.code))):M({limitHit:ce})}})})}}e.$cfc=c;function i(b){const v=b.split(`
`),C=v[0].trim();if(v.some(T=>T.startsWith("regex parse error")))return new P.$2I(s(v),P.SearchErrorCode.regexParseError);const N=C.match(/grep config error: unknown encoding: (.*)/);if(N)return new P.$2I(`Unknown encoding: ${N[1]}`,P.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new P.$2I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new P.$2I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new P.$2I(C,P.SearchErrorCode.regexParseError)}function s(b){const v=["Regex parse error"],C=b.filter(N=>N.startsWith("PCRE2:"));if(C.length>=1){const N=C[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const T=N.split(":")[1];v.push(":"+T)}}return v.join("")}class r extends F.EventEmitter{constructor(v,C,N){super(),this.g=v,this.h=C,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,C){return super.on(v,C),this}handleData(v){if(this.b)return;const C=typeof v=="string"?v:this.d.write(v);this.k(C)}k(v){let C=v.indexOf(`
`);const N=this.a+v;if(C>=0)C+=this.a.length;else{this.a=N;return}let T=0;for(;C>=0;)this.m(N.substring(T,C).trim()),T=C+1,C=N.indexOf(`
`,T);this.a=N.substring(T)}m(v){if(this.b||!v)return;let C;try{C=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(C.type==="match"){const N=o(C.data.path),T=A.URI.file(E.$ic(this.h,N)),M=this.n(C.data,T);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const N=o(C.data.path),T=A.URI.file(E.$ic(this.h,N));this.o(C.data,T).forEach(U=>this.p(U))}}n(v,C){const N=v.line_number-1,T=o(v.lines),M=Buffer.from(T);let U=0,j=0,O=N;v.submatches.length===0&&v.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const V=(0,L.$Gb)(v.submatches.map((q,de)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const x=o(q.match),Q=M.slice(U,q.start).toString(),G=t(Q),ce=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ie=t(x),ae=G.numLines+O,ye=ie.numLines+ae,H=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+ce;return U=q.end,j=H,O=ye,new g.$LI(ae,ce,ye,H)}));return(0,w.$8ec)(C,T,V,this.j)}o(v,C){const N=o(v.lines),T=v.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,U)=>({text:M,uri:C,lineNumber:T+U}))}p(v){this.emit("result",v)}}e.$dfc=r;function o(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const v=/\n/g;let C=0,N=-1,T;for(;T=v.exec(b);)C++,N=T.index;const M=N>=0?b.length-N-1:b.length;return{numLines:C,lastLineLength:M}}function n(b,v){const C=["--hidden","--no-require-git"];C.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:T}=(0,R.$J)(v.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const U=new Set;T.forEach(j=>{U.add(j)}),C.push("-g","!*"),U.forEach(j=>{d(j).map(w.$7ec).forEach(O=>{C.push("-g",O)})})}N&&N.length&&N.forEach(U=>{C.push("-g",U)}),v.excludes.map(w.$7ec).forEach(U=>C.push("-g",`!${U}`)),v.maxFileSize&&C.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),v.followSymlinks&&C.push("--follow"),v.encoding&&v.encoding!=="utf8"&&C.push("--encoding",v.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,m.$Fe)(b.pattern),b.isRegExp=!0),v.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),b.isRegExp&&(b.pattern=l(b.pattern),C.push("--engine","auto"));let M;if(b.isWordMatch){const j=(0,m.$Ne)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",j)}else if(b.isRegExp){let U=h(b.pattern);U=S(U),C.push("--regexp",U)}else M=b.pattern,C.push("--fixed-strings");return C.push("--no-config"),v.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),b.isMultiline&&C.push("--multiline"),v.beforeContext&&C.push("--before-context",v.beforeContext+""),v.afterContext&&C.push("--after-context",v.afterContext+""),C.push("--"),M&&C.push(M),C.push("."),C}e.$efc=n;function d(b){return $(b).flatMap(C=>{const N=(0,p.$uj)(C,"/");return N.map((T,M)=>N.slice(0,M+1).join("/"))})}function l(b){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(v);)b=b.replace(v,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(C);)b=b.replace(C,"$1\\x{$2}");return b}e.$ffc=l;const a=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let v;try{v=new y.RegExpParser().parsePattern(b)}catch{return b}let C="",N=0;const T=(j,O,V)=>{C+=b.slice(N,j)+V,N=O},M=[];return new y.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const O=M[0];if(!O)T(j.start,j.end,"\\r?\\n");else if(!M.some(a))if(O.type==="CharacterClass")if(O.negate){const V=b.slice(O.start+2,j.start)+b.slice(j.end,O.end-1);O.parent?.type==="Quantifier"?T(O.start,O.end,V?`[^${V}]`:"."):T(O.start,O.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=b.slice(O.start+1,j.start)+b.slice(j.end,O.end-1);T(O.start,O.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else O.type==="Quantifier"&&T(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){M.unshift(j)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(j){M.unshift(j)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(j){M.unshift(j)},onCharacterClassLeave(){M.shift()},onAssertionEnter(j){a(j)&&M.push(j)},onAssertionLeave(j){M[0]===j&&M.shift()}}).visit(v),C+=b.slice(N),C}e.$gfc=h;function S(b){return b.replace(/\n/g,"\\r?\\n")}e.$hfc=S;function k(b){let v=!1,C=!1,N="",T="";for(let M=0;M<b.length;M++){const U=b[M];switch(U){case"\\":C?(v?T+="\\"+U:N+="\\"+U,C=!1):C=!0;break;case"{":if(C)v?T+=U:N+=U,C=!1;else{if(v)return{strInBraces:N+"{"+T+"{"+b.substring(M+1)};v=!0}break;case"}":if(C)v?T+=U:N+=U,C=!1;else{if(v)return{fixedStart:N,strInBraces:T,fixedEnd:b.substring(M+1)};N+=U}break;default:v?T+=(C?"\\":"")+U:N+=(C?"\\":"")+U,C=!1;break}}return{strInBraces:N+(v?"{"+T:"")}}function $(b){const{fixedStart:v,strInBraces:C,fixedEnd:N}=k(b);if(v===void 0||N===void 0)return[C];let T=(0,p.$uj)(C,",");T.length||(T=[""]);const M=$(N);return T.flatMap(U=>{const j=v+U;return M.map(O=>j+O)})}e.$ifc=$}),define(Se[374],De([1,0,21,157,64,18]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class R{constructor(m){this.b=m,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(m,A,P,g){const y=new F.$cfc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const D={...A,folder:A.folder.with({scheme:L.Schemas.file})},w=new f.$8u(u=>P.report({...u,uri:u.uri.with({scheme:A.folder.scheme})}));return this.c(g,u=>y.provideTextSearchResults(m,D,w,u))}else return this.c(g,D=>y.provideTextSearchResults(m,A,P,D))}async c(m,A){const P=p(m);this.a.add(P);const g=await A(P.token);return this.a.delete(P),g}d(){this.a.forEach(m=>m.cancel())}}e.$mfc=R;function p(E){const m=new I.$Xd;return E.onCancellationRequested(()=>m.cancel()),m}}),define(Se[375],De([1,0,30,157,156]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class L{constructor(E){this.a=E}search(E,m,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){A({message:y})}},g=new f.$jfc(this.a,new F.$cfc(P),I);return new Promise((y,D)=>g.search(w=>{m(w.map(R))},E).then(w=>y({limitHit:w.limitHit,type:"success",stats:w.stats}),D))}}e.$kfc=L;function R(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((E,m)=>{if(m.ranges){const A=m;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(Se[376],De([1,0,19,8,9,4,129,16,36,2,31,35,371,375]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class D{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let o;const t=c(r),n=new L.$Nd({onDidAddFirstListener:()=>{o=(0,F.$Hg)(d=>this.doFileSearchWithEngine(g.$bfc,t,l=>n.fire(l),d)),o.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return n.event}textSearch(r){let o;const t=c(r),n=new L.$Nd({onDidAddFirstListener:()=>{o=(0,F.$Hg)(d=>this.f(t,l=>n.fire(l),d)),o.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return n.event}f(r,o,t){return r.maxFileSize=this.g().maxFileSize,new y.$kfc(r).search(t,o,o)}g(){return{maxFileSize:16*A.$Gk.GB}}doFileSearch(r,o,t){return this.doFileSearchWithEngine(g.$bfc,r,o,t)}doFileSearchWithEngine(r,o,t,n,d=D.a){let l=0;const a=S=>{Array.isArray(S)?(l+=S.length,t(S.map(k=>this.h(k)))):S.relativePath?(l++,t(this.h(S))):t(S)};if(o.sortByScore){let S=this.l(o,a,n);if(!S){const k=o.maxResults?Object.assign({},o,{maxResults:null}):o,$=new r(k);S=this.j($,o,t,a,n)}return new Promise((k,$)=>{S.then(([b,v])=>{const C=v.map(N=>this.h(N));this.o(C,t,d),k(b)},$)})}const h=new r(o);return this.r(h,a,d,n).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$ic)(r.base,r.relativePath):r.relativePath}}j(r,o,t,n,d){const l=new L.$Nd;let a=(0,F.$Hg)(S=>{let k=[];const $=b=>{Array.isArray(b)?k=b:(n(b),l.fire(b))};return this.r(r,$,-1,S).then(b=>[b,k])}),h;if(o.cacheKey){h=this.k(o.cacheKey);const S={promise:a,event:l.event,resolved:!1};h.resultsToSearchCache[o.filePattern||""]=S,a.then(()=>{S.resolved=!0},k=>{delete h.resultsToSearchCache[o.filePattern||""]}),a=this.s(a)}return a.then(([S,k])=>{const $=h?h.scorerCache:Object.create(null),b=(typeof o.maxResults!="number"||o.maxResults>0)&&E.$Jd.create(!1);return this.n(o,k,$,d).then(v=>{const C=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:v.length},messages:S.messages,limitHit:S.limitHit||typeof o.maxResults=="number"&&k.length>o.maxResults},v]})})}k(r){const o=this.b[r];return o||(this.b[r]=new w)}l(r,o,t){const n=r.cacheKey&&this.b[r.cacheKey];if(!n)return;const d=this.q(n,r.filePattern||"",o,t);if(d)return d.then(([l,a,h])=>{const S=E.$Jd.create(!1);return this.n(r,a,n.scorerCache,t).then(k=>{const $=S.elapsed(),b={fromCache:!0,detailStats:h,type:this.d,resultCount:a.length,sortingTime:$};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:b},k]})})}n(r,o,t,n){const d=(0,R.$Bq)(r.filePattern||""),l=(h,S)=>(0,R.$Aq)(h,S,d,!0,u,t),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return I.$Fb(o,l,a,1e4,n)}o(r,o,t){if(t&&t>0)for(let n=0;n<r.length;n+=t)o(r.slice(n,n+t));else o(r)}q(r,o,t,n){const d=E.$Jd.create(!1),l=o.indexOf(p.sep)>=0;let a;for(const $ in r.resultsToSearchCache)if(o.startsWith($)){if(l&&$.indexOf(p.sep)<0&&$!=="")continue;const b=r.resultsToSearchCache[$];a={promise:this.s(b.promise),event:b.event,resolved:b.resolved};break}if(!a)return null;const h=d.elapsed(),S=E.$Jd.create(!1),k=a.event(t);return n&&n.onCancellationRequested(()=>{k.dispose()}),a.promise.then(([$,b])=>{if(n&&n.isCancellationRequested)throw(0,f.$5)();const v=[],C=(0,R.$Bq)(o).normalizedLowercase;for(const N of b)(0,P.$8I)(N,C)&&v.push(N);return[$,v,{cacheWasResolved:a.resolved,cacheLookupTime:h,cacheFilterTime:S.elapsed(),cacheEntryCount:b.length}]})}r(r,o,t,n){return new Promise((d,l)=>{let a=[];n?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(a.push(h),t>0&&a.length>=t&&(o(a),a=[])):o(h))},h=>{o(h)},(h,S)=>{a.length&&o(a),h?l(h):d(S)})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return r.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return r.finally(o)}}}}e.$lfc=D;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(s){return(0,p.$mc)(s.relativePath)}getItemDescription(s){return(0,p.$lc)(s.relativePath)}getItemPath(s){return s.relativePath}};function c(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(i),extraFileResources:s.extraFileResources&&s.extraFileResources.map(r=>m.URI.revive(r))}}function i(s){return{...s,folder:m.URI.revive(s.folder)}}}),define(Se[377],De([1,0,3,18,2,30,15,27,20,96,67,35,376,374,118,156]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let u=class extends m.$cec{constructor(i,s,r,o){super(i,r,o),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Qc;const t=new D.$9ec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$mfc(t))),s.remote.isRemote&&s.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new D.$9ec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$mfc(i))),this.x.add(this.z(F.Schemas.file,new g.$lfc("fileSearchProvider")))}z(i,s){const r=this.d++;return this.v=s,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,I.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,s,r,o){const t=(0,m.$dec)(r);return i===this.t?this.A(i,s,t,o):super.$provideFileSearchResults(i,s,r,o)}doInternalFileSearchWithCustomCallback(i,s,r){const o=t=>{if((0,P.$7I)(t)&&(t=[t]),Array.isArray(t)){r(t.map(n=>f.URI.file(n.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,o,s)}async A(i,s,r,o){return this.doInternalFileSearchWithCustomCallback(r,o,t=>{this.c.$handleFileMatch(i,s,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,s){return new w.$jfc(i,s,void 0,"textSearchProvider")}};e.$nfc=u,e.$nfc=u=He([Be(0,E.$uM),Be(1,p.$KM),Be(2,A.$Ucc),Be(3,R.$0i)],u)}),define(Se[119],De([1,0,391,62,63,392,22,9,4,3,16,12,32,82,83]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class w{traceSocketEvent(b,v){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,p.$Z)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=C=>{this.traceSocketEvent("read",C),b(R.$be.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=C=>{b({type:0,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,p.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,p.$Z)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$Eh=w;var u;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var c;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(c||(c={}));class i extends m.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,C,N){super(),this.f=this.B(new E.$Nd),this.g=this.B(new E.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,v,C,N,this.f,(T,M)=>this.m(T,M))),this.B(this.a.onError(T=>{console.error(T),(0,p.$Z)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new D.$zh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+262144,b.byteLength)),{compressed:!0,opcode:2}),v+=262144}m(b,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let N=2;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const T=R.$be.alloc(N),M=v?64:0,U=C&15;if(T.writeUInt8(128|M|U,0),b.byteLength<126)T.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){T.writeUInt8(126,1);let j=1;T.writeUInt8(b.byteLength>>>8&255,++j),T.writeUInt8(b.byteLength>>>0&255,++j)}else{T.writeUInt8(127,1);let j=1;T.writeUInt8(0,++j),T.writeUInt8(0,++j),T.writeUInt8(0,++j),T.writeUInt8(0,++j),T.writeUInt8(b.byteLength>>>24&255,++j),T.writeUInt8(b.byteLength>>>16&255,++j),T.writeUInt8(b.byteLength>>>8&255,++j),T.writeUInt8(b.byteLength>>>0&255,++j)}this.socket.write(R.$be.concat([T,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),N=(C&128)>>>7,T=(C&64)>>>6,M=C&15,U=v.readUInt8(1),j=(U&128)>>>7,O=U&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),N=(C&128)>>>7;let T=C&127,M=1;T===126?T=v.readUInt8(++M)*2**8+v.readUInt8(++M):T===127&&(T=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let U=0;N&&(U=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=i;class s extends m.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$be.alloc(0)}constructor(b,v,C,N,T,M){super(),this.n=b,this.r=T,this.s=M,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new r(this.n,N,C,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,b);this.s(C,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((C,N)=>{b.write(v),b.flush(T=>C(T))})}acceptFrame(b,v,C){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,C){return new Promise((N,T)=>{b.write(v),C&&b.write(R.$be.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class r extends m.$Rc{get recordedInflateBytes(){return this.j?R.$be.concat(this.f):R.$be.alloc(0)}constructor(b,v,C,N){super(),this.h=b,this.j=v,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(R.$be.wrap(T))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent("zlibInflateWrite",b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=R.$be.concat(this.g);this.g.length=0,b(v)})}}class o extends m.$Rc{constructor(b,v){super(),this.g=b,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.$be.wrap(C))})}write(b){this.g.traceSocketEvent("zlibDeflateWrite",b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=R.$be.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function t($,b){if(b===0)return;const v=$.byteLength>>>2;for(let j=0;j<v;j++){const O=$.readUInt32BE(j*4);$.writeUInt32BE(O^b,j*4)}const C=v*4,N=$.byteLength-C,T=b>>>24&255,M=b>>>16&255,U=b>>>8&255;N>=1&&$.writeUInt8($.readUInt8(C)^T,C),N>=2&&$.writeUInt8($.readUInt8(C+1)^M,C+1),N>=3&&$.writeUInt8($.readUInt8(C+2)^U,C+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function d(){const $=(0,g.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const b=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,f.tmpdir)(),v=(0,A.$ic)(b,`vscode-ipc-${$}.sock`);return a(v),v}e.$Hh=d;function l($,b,v){const C=(0,I.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${v}-${b}-sock`;const N=v.substr(0,4),T=b.substr(0,6),M=C.substr(0,8);let U;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?U=(0,A.$ic)(e.$Gh,`vscode-${M}-${N}-${T}.sock`):U=(0,A.$ic)($,`${N}-${T}.sock`),a(U),U}e.$Ih=l;function a($){const b=n[P.$u];typeof b=="number"&&$.length>=b&&console.warn(`WARNING: IPC handle "${$}" is longer than ${b} chars, try a shorter --user-data-dir`)}class h extends y.$th{static b(b){const v=E.Event.fromNodeEventEmitter(b,"connection");return E.Event.map(v,C=>({protocol:new D.$Ah(new w(C,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(C,"close"))}))}constructor(b){super(h.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=h;function S($){return new Promise((b,v)=>{const C=(0,F.createServer)();C.on("error",v),C.listen($,()=>{C.removeListener("error",v),b(new h(C))})})}e.$Kh=S;function k($,b){return new Promise((v,C)=>{const N=(0,F.createConnection)($,()=>{N.removeListener("error",C),v(D.$Bh.fromSocket(new w(N,`ipc-client${b}`),b))});N.once("error",C)})}e.$Lh=k}),define(Se[378],De([1,0,62,63,165,119,8,3,12,50,15,137,255,256,108,87,22]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=e.$P8b=e.$O8b=e.$N8b=void 0;async function c(t,n,d,l,a){let h;for(let S=3;S&&(h?.dispose(),h=await new i(t,n,d,l,a).waitForReady(),!(a&&f.$hg[a]||!f.$hg[h.tunnelLocalPort]));S--);return h}class i extends p.$Rc{constructor(n,d,l,a,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=I.createServer(),this.c=new R.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,w.$hv)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,f.$ig)(n,2,1e3,d),a=null;return this.b.listen(l,this.m),await this.c.wait(),a=this.b.address(),a||(l=0,this.b.listen(l,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(n){n.pause();const d=(0,w.$fv)(this.tunnelRemoteHost)||(0,w.$hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,g.$6k)(this.a,d,this.tunnelRemotePort),a=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&n.write(h.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),a.end()}),n.on("close",()=>a.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),a instanceof L.$Eh?a.socket.destroy():a.end()}),a instanceof L.$Eh?this.t(n,a):this.s(n,a),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),a.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write(u.$be.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$N8b=i;let s=class extends w.$kv{constructor(n,d,l,a,h){super(d,h),this.u=n,this.v=l,this.w=a}isPortPrivileged(n){return(0,w.$iv)(n,this.l,E.OS,F.release())}s(n,d,l,a,h,S,k,$){const b=this.r(d,l);if(b)return++b.refcount,b.value;if((0,w.$cv)(n))return this.t(n,d,l,h,S,k,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},C=c(v,a,d,l,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,l,C),C}}};e.$O8b=s,e.$O8b=s=He([Be(0,y.$Zk),Be(1,A.$0i),Be(2,D.$3k),Be(3,P.$pj),Be(4,m.$ji)],s);let r=class extends s{constructor(n,d,l,a,h){super(n,d,l,a,h)}};e.$P8b=r,e.$P8b=r=He([Be(0,y.$Zk),Be(1,A.$0i),Be(2,D.$3k),Be(3,P.$pj),Be(4,m.$ji)],r);let o=class extends p.$Rc{constructor(n,d,l,a,h){super(),this.b=n,this.c=d,this.f=l,this.g=a,this.h=h,this.a=new Map}async openTunnel(n,d,l,a,h,S,k,$,b){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${a} on local port ${S}.`),!this.a.has(n)){const v=new r(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(n,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,a,h,S,k,$,b)}};e.$Q8b=o,e.$Q8b=o=He([Be(0,y.$Zk),Be(1,A.$0i),Be(2,P.$pj),Be(3,D.$3k),Be(4,m.$ji)],o)}),define(Se[379],De([1,0,119,275,55,34,2,15,44]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=void 0;class m{constructor(g,y,D){this.b=g,this.c=y,this.f=D,this.a=F.createServer((w,u)=>this.h(w,u)),this.g().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",g=>this.c.error(g))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(g,y){const D=(u,c)=>{y.writeHead(u,{"content-type":"application/json"}),y.end(JSON.stringify(c||null),i=>i&&this.c.error(i))},w=[];g.setEncoding("utf8"),g.on("data",u=>w.push(u)),g.on("end",async()=>{try{const u=JSON.parse(w.join(""));let c;switch(u.type){case"open":c=await this.i(u);break;case"openExternal":c=await this.j(u);break;case"status":c=await this.l(u);break;case"extensionManagement":c=await this.k(u);break;default:D(404,`Unknown message type: ${u.type}`);break}D(200,c)}catch(u){const c=u instanceof Error?u.message:JSON.stringify(u);D(500,c),this.c.error("Error while processing pipe request",u)}})}async i(g){const{fileURIs:y,folderURIs:D,forceNewWindow:w,diffMode:u,mergeMode:c,addMode:i,forceReuseWindow:s,gotoLineMode:r,waitMarkerFilePath:o,remoteAuthority:t}=g,n=[];if(Array.isArray(D))for(const h of D)try{n.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(y))for(const h of y)try{(0,E.$ii)(h)?n.push({workspaceUri:R.URI.parse(h)}):n.push({fileUri:R.URI.parse(h)})}catch{}const d=o?R.URI.file(o):void 0,a={forceNewWindow:w,diffMode:u,mergeMode:c,addMode:i,gotoLineMode:r,forceReuseWindow:s,preferNewWindow:!s&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,a)}async j(g){for(const y of g.uris){const D=R.URI.parse(y),w=D.scheme==="file"?D:y;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k(g){const y=w=>w?.map(u=>/\.vsix$/i.test(u)?R.URI.parse(u):u),D={list:g.list,install:y(g.install),uninstall:y(g.uninstall),force:g.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(g){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$VM=m;let A=class extends m{constructor(g,y){super(g,y,(0,I.$Hh)())}};e.$WM=A,e.$WM=A=He([Be(0,L.$QM),Be(1,p.$0i)],A)}),define(Se[380],De([1,0,56,367,362,274,46,348,2,18,7,379,102,346,347]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class w extends f.$Tec{j(){const i=this,s=globalThis._VSCODE_NODE_MODULES.module,r=s._load;s._load=function(d,l,a){return d=t(d),i.a.has(d)?i.a.get(d).load(d,E.URI.file((0,g.$$p)(l.filename)),h=>r.apply(this,[h,l,a])):r.apply(this,arguments)};const o=s._resolveLookupPaths;s._resolveLookupPaths=(n,d)=>o.call(this,t(n),d);const t=n=>{for(const d of i.b){const l=d(n);if(l){n=l;break}}return n}}}class u extends R.$sdc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$qfc);const i=this.h.invokeFunction(F.$Pec);if(this.h.createInstance(p.$pfc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(P.$WM);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(D.$rfc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,L.$ofc)(this.j,r,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,s,r){if(s.scheme!==m.Schemas.file)throw new Error(`Cannot load URI: '${s}', must be of file-scheme`);let o=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${s.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),o=$e.__$__nodeRequire(s.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return o}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const s in i){const r=i[s];r===null?delete process.env[s]:process.env[s]=r}}}e.$sfc=u}),define(Se[381],De([1,0,49,22,4,3,122,12,23,2,30,15,254,65,108,87,378,27,20,73,356]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.$xfc=e.$wfc=e.$vfc=e.$ufc=e.$tfc=void 0;function o(b){const v=b.trim().split(`
`),C=[];return v.forEach(T=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);M&&M.length>=3&&C.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),C.reduce((T,M)=>(T[M.socket]=M,T),{})}e.$tfc=o;function t(...b){const v=[].concat(...b.map(d));return[...new Map(v.filter(C=>C.st==="0A").map(C=>{const N=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:n(N[0]),port:parseInt(N[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}e.$ufc=t;function n(b){let v="";if(b.length===8)for(let C=b.length-2;C>=0;C-=2)v+=parseInt(b.substr(C,2),16),C!==0&&(v+=".");else for(let C=0;C<b.length;C+=8){const N=b.substring(C,C+8);let T="";for(let M=8;M>=2;M-=2)T+=N.substring(M-2,M),(M===6||M===2)&&(T=parseInt(T,16).toString(16),v+=`${T}`,T="",C+M!==b.length-6&&(v+=":"))}return v}e.$vfc=n;function d(b){const v=b.trim().split(`
`),C=v.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return v.map(T=>T.trim().split(/\s+/).reduce((M,U,j)=>(M[C[j]||j]=U,M),{}))}e.$wfc=d;function l(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function a(b){const v=b.trim().split(`
`),C=[];return v.forEach(N=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);T&&T.length>=4&&C.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),C}e.$xfc=a;async function h(b,v,C){const N=C.reduce((M,U)=>(M[U.pid]=U,M),{}),T=[];return b.forEach(({socket:M,ip:U,port:j})=>{const O=v[M]?v[M].pid:void 0,V=O?N[O]?.cmd:void 0;O&&V&&!l(V)&&T.push({host:U,port:j,detail:V,pid:O})}),T}e.$yfc=h;function S(b,v,C){const N=new Map,T=a(v);for(const M of b){const U=C.get(M.port);if(U){N.set(M.port,U);continue}const j=T.find(O=>O.cmd.includes(`${M.port}`));if(j){let O=j,V;do V=T.find(q=>q.ppid===O.pid),V&&(O=V);while(V);N.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$zfc=S;let k=class extends s.$wwb{constructor(v,C,N,T){super(v,C,N),this.D=C,this.F=T,this.y=void 0,this.z=new Map,this.C=!1,p.$l&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$Rl;let T=0;for(;this.C;){const M=new Date().getTime(),U=(await this.I()).filter(V=>(0,w.$fv)(V.host)||(0,w.$hv)(V.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(V=>V.port).join(", ")}`);const j=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),T++>3&&N.update(j),(!C||JSON.stringify(C)!==JSON.stringify(U))&&(C=U,await this.a.$onFoundNewCandidates(C));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(V=>setTimeout(()=>V(),O))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",C="";try{v=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(v,C),T=await new Promise(x=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,G,ce)=>{x(G)})}),M=o(T),U=await A.Promises.readdir("/proc"),j=[];for(const x of U)try{const Q=Number(x),G=E.$vg(m.URI.file("/proc"),x);if((await A.Promises.stat(G.fsPath)).isDirectory()&&!isNaN(Q)){const ie=await A.Promises.readlink(E.$vg(G,"cwd").fsPath),ae=await A.Promises.readFile(E.$vg(G,"cmdline").fsPath,"utf8");j.push({pid:Q,cwd:ie,cmd:ae})}}catch{}const O=[],V=N.filter(x=>{const Q=M[x.socket];return Q||O.push(x),Q}),q=h(V,M,j);let de;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const x=await new Promise(Q=>{(0,I.exec)("ps -F -A -l | grep root",(G,ce,ie)=>{Q(ce)})});this.z=S(O,x,this.z),de=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${de.map(Q=>Q.port).join(", ")}`)}return q.then(x=>de?x.concat(de):x)}w(v){return async C=>{const N=new u.$N8b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,U,j,O){const V=await v.makeConnection();return $.connect(V,U,j,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Qk(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await N.waitForReady();const T=new f.$Nd;return{localAddress:(0,r.$QJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:T.event,dispose:()=>{N.dispose(),T.fire(),T.dispose()}}}}};e.$Afc=k,e.$Afc=k=He([Be(0,i.$uM),Be(1,c.$KM),Be(2,P.$0i),Be(3,D.$3k)],k);class $ extends g.$Zkb{static connect(v,C,N,T){const M=new L.$Qc,U={onClose:M.add(new f.$Nd),onData:M.add(new f.$Nd),onEnd:M.add(new f.$Nd)};M.add(v.onDidReceiveMessage(O=>U.onData.fire(F.$be.wrap(O)))),M.add(v.onDidEnd(()=>U.onEnd.fire())),M.add(v.onDidClose(O=>U.onClose.fire({type:0,error:O,hadError:!!O})));const j=new $(v,T,U);return j.B(M),(0,g.$Ykb)(j,C,N,T,U)}constructor(v,C,N){super(C,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[382],De([1,0,105,351,365,364,377,380,381,95,46,96,94,45,73,91,350,349,15,366,58,269,104,108,140]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c,i,s,r,o,t,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$zr)(A.$tdc,p.$sfc,0),(0,I.$zr)(i.$$i,c.$Cfc,1),(0,I.$zr)(i.$0i,new t.$Mh(o.$Sec,[!1],!0)),(0,I.$zr)(n.$3k,d.$S8b,1),(0,I.$zr)(w.$edc,u.$Bfc,0),(0,I.$zr)(m.$4dc,L.$6ec,0),(0,I.$zr)(P.$bec,R.$nfc,0),(0,I.$zr)(g.$Ydc,f.$Xec,0),(0,I.$zr)(y.$gdc,F.$Wec,0),(0,I.$zr)(D.$vwb,E.$Afc,0),(0,I.$zr)(r.$2dc,s.$Dfc,0)}),define(Se[393],De([1,0,62,394,56,9,83,119,252,113,363,22,30,102,8,132,276,290,368,382]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,D,w,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=globalThis._VSCODE_NODE_MODULES.module,h=a._load;a._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const s=process.exit.bind(process);function r(a){process.exit=function(h){if(a)s(h);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let o=function(a){s()};function t(){const a=(0,c.$Bm)(process.env);if(a.type===3)return new Promise((h,S)=>{const k=$=>{const b=$[0],v=new R.$Ch;b.on("message",C=>v.fire(P.$be.wrap(C.data))),b.on("close",()=>{o("renderer closed the MessagePort")}),b.start(),h({onMessage:v.event,send:C=>b.postMessage(C.buffer)})};process.parentPort.on("message",$=>k($.ports))});if(a.type===2)return new Promise((h,S)=>{let k=null;const $=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,v=3e5,C=new D.$7g(()=>o("renderer disconnected for too long (1)"),b),N=new D.$7g(()=>o("renderer disconnected for too long (2)"),v);process.on("message",(M,U)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const j=P.$be.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new p.$Eh(U,"extHost-socket");else{const V=P.$be.wrap(Buffer.from(M.inflateBytes,"base64"));O=new p.$Fh(new p.$Eh(U,"extHost-socket"),M.permessageDeflate,V,!1)}k?(C.cancel(),N.cancel(),k.beginAcceptReconnection(O,j),k.endAcceptReconnection(),k.sendResume()):(clearTimeout($),k=new R.$Dh({socket:O,initialChunk:j}),k.sendResume(),k.onDidDispose(()=>o("renderer disconnected")),h(k),k.onSocketClose(()=>{C.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;C.isScheduled()&&N.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const h=a.pipeName;return new Promise((S,k)=>{const $=I.createConnection(h,()=>{$.removeListener("error",k);const b=new R.$Dh({socket:new p.$Eh($,"extHost-renderer")});b.sendResume(),S(b)});$.once("error",k),$.on("close",()=>{o("renderer closed the socket")})})}}async function n(){const a=await t();return new class{constructor(){this.a=new R.$Ch,this.onMessage=this.a.event,this.b=!1,a.onMessage(h=>{(0,m.$cm)(h,2)?(this.b=!0,o("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||a.send(h)}async drain(){if(a.drain)return a.drain()}}}function d(a){return new Promise(h=>{const S=a.onMessage(k=>{S.dispose();const $=JSON.parse(k.toString()),b=$.commit,v=E.default.commit;if(b&&v&&b!==v&&s(55),$.parentPid){let C=0;setInterval(function(){try{process.kill($.parentPid,0),C=0}catch(T){T&&T.code==="EPERM"?(C++,C>=3&&o(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):o(`parent process ${$.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(T){(0,L.$Z)(T)}}a.send((0,m.$bm)(0)),h({protocol:a,initData:$})});a.send((0,m.$bm)(1))})}async function l(){const a=[];process.on("unhandledRejection",(C,N)=>{a.push(N),setTimeout(()=>{const T=a.indexOf(N);T>=0&&N.catch(M=>{a.splice(T,1),(0,L.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),C&&(0,L.$Z)(C))})},1e3)}),process.on("rejectionHandled",C=>{const N=a.indexOf(C);N>=0&&a.splice(N,1)}),process.on("uncaughtException",function(C){(0,L.$Y)(C)||(0,L.$Z)(C)}),f.mark("code/extHost/willConnectToRenderer");const h=await n();f.mark("code/extHost/didConnectToRenderer");const S=await d(h);f.mark("code/extHost/didWaitForInitData");const{initData:k}=S;r(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){s(N)}fsExists(N){return g.Promises.exists(N)}fsRealpath(N){return(0,y.$0p)(N)}};let b=null;k.remote.authority&&i.transformURIs&&(b=(0,u.$Dr)(k.remote.authority));const v=new A.$Vec(S.protocol,k,$,b);o=C=>v.terminate(C)}l().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a9d8fbca9ec9a7914f2077a83ca66a08c7e10f83/core/vs/workbench/api/node/extensionHostProcess.js.map
