/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(ve){for(var e=[],E=0,L=ve.length;E<L;E++)e[E]=Ae[ve[E]];return e};define(Ae[66],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function E(R){return($,D,g)=>{let A=null,S=null;if(typeof g.value=="function"?(A="value",S=g.value):typeof g.get=="function"&&(A="get",S=g.get),!S)throw new Error("not supported");g[A]=R(S,D)}}function L(R,$,D){let g=null,A=null;if(typeof D.value=="function"?(g="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",A=D.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;D[g]=function(...o){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,o)}),this[S]}}e.$hh=L;function P(R,$,D){return E((g,A)=>{const S=`$debounce$${A}`,o=`$debounce$result$${A}`;return function(...b){this[o]||(this[o]=D?D():void 0),clearTimeout(this[S]),$&&(this[o]=$(this[o],...b),b=[this[o]]),this[S]=setTimeout(()=>{g.apply(this,b),this[o]=D?D():void 0},R)}})}e.$ih=P;function M(R,$,D){return E((g,A)=>{const S=`$throttle$timer$${A}`,o=`$throttle$result$${A}`,b=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...f){if(this[o]||(this[o]=D?D():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[o]=$(this[o],...f)),this[v])return;const t=this[b]+R;t<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0):(this[v]=!0,this[S]=setTimeout(()=>{this[v]=!1,this[b]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0},t-Date.now()))}})}e.$jh=M}),define(Ae[88],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$zM=E,e.$AM=new E("id#")}),define(Ae[118],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(n,s=!1){let c=0;const h=n.length;let p="",m=0,I=16,k=0;function d(U){let F=0,O=0;for(;F<U;){const ee=n.charCodeAt(c);if(ee>=48&&ee<=57)O=O*16+ee-48;else if(ee>=65&&ee<=70)O=O*16+ee-65+10;else if(ee>=97&&ee<=102)O=O*16+ee-97+10;else break;c++,F++}return F<U&&(O=-1),O}function y(U){c=U,p="",m=0,I=16,k=0}function w(){const U=c;if(n.charCodeAt(c)===48)c++;else for(c++;c<n.length&&g(n.charCodeAt(c));)c++;if(c<n.length&&n.charCodeAt(c)===46)if(c++,c<n.length&&g(n.charCodeAt(c)))for(c++;c<n.length&&g(n.charCodeAt(c));)c++;else return k=3,n.substring(U,c);let F=c;if(c<n.length&&(n.charCodeAt(c)===69||n.charCodeAt(c)===101))if(c++,(c<n.length&&n.charCodeAt(c)===43||n.charCodeAt(c)===45)&&c++,c<n.length&&g(n.charCodeAt(c))){for(c++;c<n.length&&g(n.charCodeAt(c));)c++;F=c}else k=3;return n.substring(U,F)}function C(){let U="",F=c;for(;;){if(c>=h){U+=n.substring(F,c),k=2;break}const O=n.charCodeAt(c);if(O===34){U+=n.substring(F,c),c++;break}if(O===92){if(U+=n.substring(F,c),c++,c>=h){k=2;break}switch(n.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const X=d(4);X>=0?U+=String.fromCharCode(X):k=4;break}default:k=5}F=c;continue}if(O>=0&&O<=31)if(D(O)){U+=n.substring(F,c),k=2;break}else k=6;c++}return U}function j(){if(p="",k=0,m=c,c>=h)return m=h,I=17;let U=n.charCodeAt(c);if($(U)){do c++,p+=String.fromCharCode(U),U=n.charCodeAt(c);while($(U));return I=15}if(D(U))return c++,p+=String.fromCharCode(U),U===13&&n.charCodeAt(c)===10&&(c++,p+=`
`),I=14;switch(U){case 123:return c++,I=1;case 125:return c++,I=2;case 91:return c++,I=3;case 93:return c++,I=4;case 58:return c++,I=6;case 44:return c++,I=5;case 34:return c++,p=C(),I=10;case 47:{const F=c-1;if(n.charCodeAt(c+1)===47){for(c+=2;c<h&&!D(n.charCodeAt(c));)c++;return p=n.substring(F,c),I=12}if(n.charCodeAt(c+1)===42){c+=2;const O=h-1;let ee=!1;for(;c<O;){if(n.charCodeAt(c)===42&&n.charCodeAt(c+1)===47){c+=2,ee=!0;break}c++}return ee||(c++,k=1),p=n.substring(F,c),I=13}return p+=String.fromCharCode(U),c++,I=16}case 45:if(p+=String.fromCharCode(U),c++,c===h||!g(n.charCodeAt(c)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=w(),I=11;default:for(;c<h&&B(U);)c++,U=n.charCodeAt(c);if(m!==c){switch(p=n.substring(m,c),p){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return p+=String.fromCharCode(U),c++,I=16}}function B(U){if($(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=j();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>c,scan:s?W:j,getToken:()=>I,getTokenValue:()=>p,getTokenOffset:()=>m,getTokenLength:()=>c-m,getTokenError:()=>k}}e.$Um=R;function $(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function S(n,s){const c=[],h=new Object;let p;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(d,y,w,C){m.value=d,m.offset=y,m.length=w,m.type=C,m.colonOffset=void 0,p=m}try{u(n,{onObjectBegin:(d,y)=>{if(s<=d)throw h;p=void 0,I=s>d,c.push("")},onObjectProperty:(d,y,w)=>{if(s<y||(k(d,y,w,"property"),c[c.length-1]=d,s<=y+w))throw h},onObjectEnd:(d,y)=>{if(s<=d)throw h;p=void 0,c.pop()},onArrayBegin:(d,y)=>{if(s<=d)throw h;p=void 0,c.push(0)},onArrayEnd:(d,y)=>{if(s<=d)throw h;p=void 0,c.pop()},onLiteralValue:(d,y,w)=>{if(s<y||(k(d,y,w,l(d)),s<=y+w))throw h},onSeparator:(d,y,w)=>{if(s<=y)throw h;if(d===":"&&p&&p.type==="property")p.colonOffset=y,I=!1,p=void 0;else if(d===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(I=!0,c[c.length-1]=""),p=void 0}}})}catch(d){if(d!==h)throw d}return{path:c,previousNode:p,isAtPropertyKey:I,matches:d=>{let y=0;for(let w=0;y<d.length&&w<c.length;w++)if(d[y]===c[w]||d[y]==="*")y++;else if(d[y]!=="**")return!1;return y===d.length}}}e.$Vm=S;function o(n,s=[],c=M.DEFAULT){let h=null,p=[];const m=[];function I(d){Array.isArray(p)?p.push(d):h!==null&&(p[h]=d)}return u(n,{onObjectBegin:()=>{const d={};I(d),m.push(p),p=d,h=null},onObjectProperty:d=>{h=d},onObjectEnd:()=>{p=m.pop()},onArrayBegin:()=>{const d=[];I(d),m.push(p),p=d,h=null},onArrayEnd:()=>{p=m.pop()},onLiteralValue:I,onError:(d,y,w)=>{s.push({error:d,offset:y,length:w})}},c),p[0]}e.$Wm=o;function b(n,s=[],c=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(d){h.type==="property"&&(h.length=d-h.offset,h=h.parent)}function m(d){return h.children.push(d),d}u(n,{onObjectBegin:d=>{h=m({type:"object",offset:d,length:-1,parent:h,children:[]})},onObjectProperty:(d,y,w)=>{h=m({type:"property",offset:y,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:d,offset:y,length:w,parent:h})},onObjectEnd:(d,y)=>{h.length=d+y-h.offset,h=h.parent,p(d+y)},onArrayBegin:(d,y)=>{h=m({type:"array",offset:d,length:-1,parent:h,children:[]})},onArrayEnd:(d,y)=>{h.length=d+y-h.offset,h=h.parent,p(d+y)},onLiteralValue:(d,y,w)=>{m({type:l(d),offset:y,length:w,parent:h,value:d}),p(y+w)},onSeparator:(d,y,w)=>{h.type==="property"&&(d===":"?h.colonOffset=y:d===","&&p(y))},onError:(d,y,w)=>{s.push({error:d,offset:y,length:w})}},c);const k=h.children[0];return k&&delete k.parent,k}e.$Xm=b;function v(n,s){if(!n)return;let c=n;for(const h of s)if(typeof h=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let p=!1;for(const m of c.children)if(Array.isArray(m.children)&&m.children[0].value===h){c=m.children[1],p=!0;break}if(!p)return}else{const p=h;if(c.type!=="array"||p<0||!Array.isArray(c.children)||p>=c.children.length)return;c=c.children[p]}return c}e.$Ym=v;function f(n){if(!n.parent||!n.parent.children)return[];const s=f(n.parent);if(n.parent.type==="property"){const c=n.parent.children[0].value;s.push(c)}else if(n.parent.type==="array"){const c=n.parent.children.indexOf(n);c!==-1&&s.push(c)}return s}e.$Zm=f;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const s=Object.create(null);for(const c of n.children){const h=c.children[1];h&&(s[c.children[0].value]=t(h))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$1m=t;function i(n,s,c=!1){return s>=n.offset&&s<n.offset+n.length||c&&s===n.offset+n.length}e.$2m=i;function r(n,s,c=!1){if(i(n,s,c)){const h=n.children;if(Array.isArray(h))for(let p=0;p<h.length&&h[p].offset<=s;p++){const m=r(h[p],s,c);if(m)return m}return n}}e.$3m=r;function u(n,s,c=M.DEFAULT){const h=R(n,!1);function p(ue){return ue?()=>ue(h.getTokenOffset(),h.getTokenLength()):()=>!0}function m(ue){return ue?oe=>ue(oe,h.getTokenOffset(),h.getTokenLength()):()=>!0}const I=p(s.onObjectBegin),k=m(s.onObjectProperty),d=p(s.onObjectEnd),y=p(s.onArrayBegin),w=p(s.onArrayEnd),C=m(s.onLiteralValue),j=m(s.onSeparator),B=p(s.onComment),W=m(s.onError),U=c&&c.disallowComments,F=c&&c.allowTrailingComma;function O(){for(;;){const ue=h.scan();switch(h.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:U||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(ue){case 12:case 13:U?ee(10):B();break;case 16:ee(1);break;case 15:case 14:break;default:return ue}}}function ee(ue,oe=[],ye=[]){if(W(ue),oe.length+ye.length>0){let te=h.getToken();for(;te!==17;){if(oe.indexOf(te)!==-1){O();break}else if(ye.indexOf(te)!==-1)break;te=O()}}}function X(ue){const oe=h.getTokenValue();return ue?C(oe):k(oe),O(),!0}function Ee(){switch(h.getToken()){case 11:{let ue=0;try{ue=JSON.parse(h.getTokenValue()),typeof ue!="number"&&(ee(2),ue=0)}catch{ee(2)}C(ue);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return O(),!0}function ke(){return h.getToken()!==10?(ee(3,[],[2,5]),!1):(X(!1),h.getToken()===6?(j(":"),O(),be()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){I(),O();let ue=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(ue||ee(4,[],[]),j(","),O(),h.getToken()===2&&F)break}else ue&&ee(6,[],[]);ke()||ee(4,[],[2,5]),ue=!0}return d(),h.getToken()!==2?ee(7,[2],[]):O(),!0}function le(){y(),O();let ue=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(ue||ee(4,[],[]),j(","),O(),h.getToken()===4&&F)break}else ue&&ee(6,[],[]);be()||ee(4,[],[4,5]),ue=!0}return w(),h.getToken()!==4?ee(8,[4],[]):O(),!0}function be(){switch(h.getToken()){case 3:return le();case 1:return Pe();case 10:return X(!0);default:return Ee()}}return O(),h.getToken()===17?c.allowEmptyContent?!0:(ee(4,[],[]),!1):be()?(h.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$4m=u;function a(n,s){const c=R(n),h=[];let p,m=0,I;do switch(I=c.getPosition(),p=c.scan(),p){case 12:case 13:case 17:m!==I&&h.push(n.substring(m,I)),s!==void 0&&h.push(c.getTokenValue().replace(/[^\r\n]/g,s)),m=c.getPosition();break}while(p!==17);return h.join("")}e.$5m=a;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=l}),function(ve,e){typeof define=="function"&&define.amd?define(Ae[119],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e($e,de){for(var De=0;De<de.length;De++){var re=de[De];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty($e,re.key,re)}}function E($e,de,De){return de&&e($e.prototype,de),De&&e($e,De),Object.defineProperty($e,"prototype",{writable:!1}),$e}function L($e,de){if($e){if(typeof $e=="string")return P($e,de);var De=Object.prototype.toString.call($e).slice(8,-1);if(De==="Object"&&$e.constructor&&(De=$e.constructor.name),De==="Map"||De==="Set")return Array.from($e);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return P($e,de)}}function P($e,de){(de==null||de>$e.length)&&(de=$e.length);for(var De=0,re=new Array(de);De<de;De++)re[De]=$e[De];return re}function M($e,de){var De=typeof Symbol<"u"&&$e[Symbol.iterator]||$e["@@iterator"];if(De)return(De=De.call($e)).next.bind(De);if(Array.isArray($e)||(De=L($e))||de&&$e&&typeof $e.length=="number"){De&&($e=De);var re=0;return function(){return re>=$e.length?{done:!0}:{done:!1,value:$e[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=R();function $($e){ve.defaults=$e}var D=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(de){return o[de]};function v($e,de){if(de){if(D.test($e))return $e.replace(g,b)}else if(A.test($e))return $e.replace(S,b);return $e}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t($e){return $e.replace(f,function(de,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function r($e,de){$e=typeof $e=="string"?$e:$e.source,de=de||"";var De={replace:function(he,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),$e=$e.replace(he,ne),De},getRegex:function(){return new RegExp($e,de)}};return De}var u=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l($e,de,De){if($e){var re;try{re=decodeURIComponent(t(De)).replace(u,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}de&&!a.test(De)&&(De=p(de,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},s=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p($e,de){n[" "+$e]||(s.test($e)?n[" "+$e]=$e+"/":n[" "+$e]=d($e,"/",!0)),$e=n[" "+$e];var De=$e.indexOf(":")===-1;return de.substring(0,2)==="//"?De?de:$e.replace(c,"$1")+de:de.charAt(0)==="/"?De?de:$e.replace(h,"$1")+de:$e+de}var m={exec:function(){}};function I($e){for(var de=1,De,re;de<arguments.length;de++){De=arguments[de];for(re in De)Object.prototype.hasOwnProperty.call(De,re)&&($e[re]=De[re])}return $e}function k($e,de){var De=$e.replace(/\|/g,function(ne,ae,ge){for(var Ce=!1,T=ae;--T>=0&&ge[T]==="\\";)Ce=!Ce;return Ce?"|":" |"}),re=De.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>de)re.splice(de);else for(;re.length<de;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function d($e,de,De){var re=$e.length;if(re===0)return"";for(var he=0;he<re;){var ne=$e.charAt(re-he-1);if(ne===de&&!De)he++;else if(ne!==de&&De)he++;else break}return $e.slice(0,re-he)}function y($e,de){if($e.indexOf(de[1])===-1)return-1;for(var De=$e.length,re=0,he=0;he<De;he++)if($e[he]==="\\")he++;else if($e[he]===de[0])re++;else if($e[he]===de[1]&&(re--,re<0))return he;return-1}function w($e){$e&&$e.sanitize&&!$e.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C($e,de){if(de<1)return"";for(var De="";de>1;)de&1&&(De+=$e),de>>=1,$e+=$e;return De+$e}function j($e,de,De,re){var he=de.href,ne=de.title?v(de.title):null,ae=$e[1].replace(/\\([\[\]])/g,"$1");if($e[0].charAt(0)!=="!"){re.state.inLink=!0;var ge={type:"link",raw:De,href:he,title:ne,text:ae,tokens:re.inlineTokens(ae)};return re.state.inLink=!1,ge}return{type:"image",raw:De,href:he,title:ne,text:v(ae)}}function B($e,de){var De=$e.match(/^(\s+)(?:```)/);if(De===null)return de;var re=De[1];return de.split(`
`).map(function(he){var ne=he.match(/^\s+/);if(ne===null)return he;var ae=ne[0];return ae.length>=re.length?he.slice(re.length):he}).join(`
`)}var W=function(){function $e(De){this.options=De||ve.defaults}var de=$e.prototype;return de.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},de.code=function(re){var he=this.rules.block.code.exec(re);if(he){var ne=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:d(ne,`
`)}}},de.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var ne=he[0],ae=B(ne,he[3]||"");return{type:"code",raw:ne,lang:he[2]?he[2].trim():he[2],text:ae}}},de.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var ne=he[2].trim();if(/#$/.test(ne)){var ae=d(ne,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ne=ae.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:ne,tokens:this.lexer.inline(ne)}}},de.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},de.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var ne=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},de.list=function(re){var he=this.rules.block.list.exec(re);if(he){var ne,ae,ge,Ce,T,q,G,J,K,x,ce,Ne,je=he[1].trim(),Qe=je.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Ne=!1,!(!(he=_e.exec(re))||this.rules.block.hr.test(re)));){if(ne=he[0],re=re.substring(ne.length),J=he[2].split(`
`,1)[0],K=re.split(`
`,1)[0],this.options.pedantic?(Ce=2,ce=J.trimLeft()):(Ce=he[2].search(/[^ ]/),Ce=Ce>4?1:Ce,ce=J.slice(Ce),Ce+=he[1].length),q=!1,!J&&/^ *$/.test(K)&&(ne+=K+`
`,re=re.substring(K.length+1),Ne=!0),!Ne)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");re&&(x=re.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(J)||tt.test(J)||Ye.test(J)||xe.test(re)));){if(J.search(/[^ ]/)>=Ce||!J.trim())ce+=`
`+J.slice(Ce);else if(!q)ce+=`
`+J;else break;!q&&!J.trim()&&(q=!0),ne+=x+`
`,re=re.substring(x.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ne)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ce),ae&&(ge=ae[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ne,task:!!ae,checked:ge,loose:!1,text:ce}),Ge.raw+=ne}Ge.items[Ge.items.length-1].raw=ne.trimRight(),Ge.items[Ge.items.length-1].text=ce.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Ge.items[T].tokens=this.lexer.blockTokens(Ge.items[T].text,[]);var ut=Ge.items[T].tokens.filter(function(Q){return Q.type==="space"}),Z=ut.every(function(Q){for(var we=Q.raw.split(""),Be=0,Oe=M(we),Xe;!(Xe=Oe()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&ut.length&&Z&&(Ge.loose=!0,Ge.items[T].loose=!0)}return Ge}},de.html=function(re){var he=this.rules.block.html.exec(re);if(he){var ne={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(he[0]):v(he[0]);ne.type="paragraph",ne.text=ae,ne.tokens=this.lexer.inline(ae)}return ne}},de.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ne=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:he[0],href:he[2],title:he[3]}}},de.table=function(re){var he=this.rules.block.table.exec(re);if(he){var ne={type:"table",header:k(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=he[0];var ae=ne.align.length,ge,Ce,T,q;for(ge=0;ge<ae;ge++)/^ *-+: *$/.test(ne.align[ge])?ne.align[ge]="right":/^ *:-+: *$/.test(ne.align[ge])?ne.align[ge]="center":/^ *:-+ *$/.test(ne.align[ge])?ne.align[ge]="left":ne.align[ge]=null;for(ae=ne.rows.length,ge=0;ge<ae;ge++)ne.rows[ge]=k(ne.rows[ge],ne.header.length).map(function(G){return{text:G}});for(ae=ne.header.length,Ce=0;Ce<ae;Ce++)ne.header[Ce].tokens=this.lexer.inline(ne.header[Ce].text);for(ae=ne.rows.length,Ce=0;Ce<ae;Ce++)for(q=ne.rows[Ce],T=0;T<q.length;T++)q[T].tokens=this.lexer.inline(q[T].text);return ne}}},de.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},de.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var ne=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:ne,tokens:this.lexer.inline(ne)}}},de.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},de.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:v(he[1])}},de.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):v(he[0]):he[0]}},de.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var ne=he[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ae=d(ne.slice(0,-1),"\\");if((ne.length-ae.length)%2===0)return}else{var ge=y(he[2],"()");if(ge>-1){var Ce=he[0].indexOf("!")===0?5:4,T=Ce+he[1].length+ge;he[2]=he[2].substring(0,ge),he[0]=he[0].substring(0,T).trim(),he[3]=""}}var q=he[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);J&&(q=J[1],G=J[3])}else G=he[3]?he[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ne)?q=q.slice(1):q=q.slice(1,-1)),j(he,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},de.reflink=function(re,he){var ne;if((ne=this.rules.inline.reflink.exec(re))||(ne=this.rules.inline.nolink.exec(re))){var ae=(ne[2]||ne[1]).replace(/\s+/g," ");if(ae=he[ae.toLowerCase()],!ae||!ae.href){var ge=ne[0].charAt(0);return{type:"text",raw:ge,text:ge}}return j(ne,ae,ne[0],this.lexer)}},de.emStrong=function(re,he,ne){ne===void 0&&(ne="");var ae=this.rules.inline.emStrong.lDelim.exec(re);if(ae&&!(ae[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=ae[1]||ae[2]||"";if(!ge||ge&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Ce=ae[0].length-1,T,q,G=Ce,J=0,K=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,he=he.slice(-1*re.length+Ce);(ae=K.exec(he))!=null;)if(T=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!T){if(q=T.length,ae[3]||ae[4]){G+=q;continue}else if((ae[5]||ae[6])&&Ce%3&&!((Ce+q)%3)){J+=q;continue}if(G-=q,!(G>0)){if(q=Math.min(q,q+G+J),Math.min(Ce,q)%2){var x=re.slice(1,Ce+ae.index+q);return{type:"em",raw:re.slice(0,Ce+ae.index+q+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ce=re.slice(2,Ce+ae.index+q-1);return{type:"strong",raw:re.slice(0,Ce+ae.index+q+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},de.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var ne=he[2].replace(/\n/g," "),ae=/[^ ]/.test(ne),ge=/^ /.test(ne)&&/ $/.test(ne);return ae&&ge&&(ne=ne.substring(1,ne.length-1)),ne=v(ne,!0),{type:"codespan",raw:he[0],text:ne}}},de.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},de.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},de.autolink=function(re,he){var ne=this.rules.inline.autolink.exec(re);if(ne){var ae,ge;return ne[2]==="@"?(ae=v(this.options.mangle?he(ne[1]):ne[1]),ge="mailto:"+ae):(ae=v(ne[1]),ge=ae),{type:"link",raw:ne[0],text:ae,href:ge,tokens:[{type:"text",raw:ae,text:ae}]}}},de.url=function(re,he){var ne;if(ne=this.rules.inline.url.exec(re)){var ae,ge;if(ne[2]==="@")ae=v(this.options.mangle?he(ne[0]):ne[0]),ge="mailto:"+ae;else{var Ce;do Ce=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Ce!==ne[0]);ae=v(ne[0]),ne[1]==="www."?ge="http://"+ae:ge=ae}return{type:"link",raw:ne[0],text:ae,href:ge,tokens:[{type:"text",raw:ae,text:ae}]}}},de.inlineText=function(re,he){var ne=this.rules.inline.text.exec(re);if(ne){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):v(ne[0]):ne[0]:ae=v(this.options.smartypants?he(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ae}}},$e}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=r(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=r(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=r(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=r(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=r(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=r(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=I({},U),U.gfm=I({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=r(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=r(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=I({},U.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:r(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=r(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=r(U._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=r(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=r(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=r(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=r(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=r(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=r(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=r(F.reflink).replace("label",F._label).replace("ref",U._label).getRegex(),F.nolink=r(F.nolink).replace("ref",U._label).getRegex(),F.reflinkSearch=r(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=I({},F),F.pedantic=I({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=I({},F.normal,{escape:r(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=r(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=I({},F.gfm,{br:r(F.br).replace("{2,}","*").getRegex(),text:r(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O($e){return $e.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee($e){var de="",De,re,he=$e.length;for(De=0;De<he;De++)re=$e.charCodeAt(De),Math.random()>.5&&(re="x"+re.toString(16)),de+="&#"+re+";";return de}var X=function(){function $e(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ve.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:U.normal,inline:F.normal};this.options.pedantic?(re.block=U.pedantic,re.inline=F.pedantic):this.options.gfm&&(re.block=U.gfm,this.options.breaks?re.inline=F.breaks:re.inline=F.gfm),this.tokenizer.rules=re}$e.lex=function(re,he){var ne=new $e(he);return ne.lex(re)},$e.lexInline=function(re,he){var ne=new $e(he);return ne.inlineTokens(re)};var de=$e.prototype;return de.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},de.blockTokens=function(re,he){var ne=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,J,K){return J+"    ".repeat(K.length)});for(var ae,ge,Ce,T;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:ne},re,he))?(re=re.substring(ae.raw.length),he.push(ae),!0):!1}))){if(ae=this.tokenizer.space(re)){re=re.substring(ae.raw.length),ae.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(ae);continue}if(ae=this.tokenizer.code(re)){re=re.substring(ae.raw.length),ge=he[he.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ae);continue}if(ae=this.tokenizer.fences(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.heading(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.hr(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.blockquote(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.list(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.html(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.def(re)){re=re.substring(ae.raw.length),ge=he[he.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.lheading(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(Ce=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=re.slice(1),K=void 0;ne.options.extensions.startBlock.forEach(function(x){K=x.call({lexer:this},J),typeof K=="number"&&K>=0&&(G=Math.min(G,K))}),G<1/0&&G>=0&&(Ce=re.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ce))){ge=he[he.length-1],T&&ge.type==="paragraph"?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ae),T=Ce.length!==re.length,re=re.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(re)){re=re.substring(ae.raw.length),ge=he[he.length-1],ge&&ge.type==="text"?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ae);continue}if(re){var q="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,he},de.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},de.inlineTokens=function(re,he){var ne=this;he===void 0&&(he=[]);var ae,ge,Ce,T=re,q,G,J;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)K.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,q.index)+"["+C("a",q[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,q.index)+"["+C("a",q[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,q.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ae=ce.call({lexer:ne},re,he))?(re=re.substring(ae.raw.length),he.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.tag(re)){re=re.substring(ae.raw.length),ge=he[he.length-1],ge&&ae.type==="text"&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):he.push(ae);continue}if(ae=this.tokenizer.link(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ae.raw.length),ge=he[he.length-1],ge&&ae.type==="text"&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):he.push(ae);continue}if(ae=this.tokenizer.emStrong(re,T,J)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.codespan(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.br(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.del(re)){re=re.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.autolink(re,ee)){re=re.substring(ae.raw.length),he.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(re,ee))){re=re.substring(ae.raw.length),he.push(ae);continue}if(Ce=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ne=re.slice(1),je=void 0;ne.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Ne),typeof je=="number"&&je>=0&&(ce=Math.min(ce,je))}),ce<1/0&&ce>=0&&(Ce=re.substring(0,ce+1))}(),ae=this.tokenizer.inlineText(Ce,O)){re=re.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),G=!0,ge=he[he.length-1],ge&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):he.push(ae);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},E($e,null,[{key:"rules",get:function(){return{block:U,inline:F}}}]),$e}(),Ee=function(){function $e(De){this.options=De||ve.defaults}var de=$e.prototype;return de.code=function(re,he,ne){var ae=(he||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(re,ae);ge!=null&&ge!==re&&(ne=!0,re=ge)}return re=re.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+v(ae,!0)+'">'+(ne?re:v(re,!0))+`</code></pre>
`:"<pre><code>"+(ne?re:v(re,!0))+`</code></pre>
`},de.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},de.html=function(re){return re},de.heading=function(re,he,ne,ae){if(this.options.headerIds){var ge=this.options.headerPrefix+ae.slug(ne);return"<h"+he+' id="'+ge+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(re,he,ne){var ae=he?"ol":"ul",ge=he&&ne!==1?' start="'+ne+'"':"";return"<"+ae+ge+`>
`+re+"</"+ae+`>
`},de.listitem=function(re){return"<li>"+re+`</li>
`},de.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(re){return"<p>"+re+`</p>
`},de.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},de.tablerow=function(re){return`<tr>
`+re+`</tr>
`},de.tablecell=function(re,he){var ne=he.header?"th":"td",ae=he.align?"<"+ne+' align="'+he.align+'">':"<"+ne+">";return ae+re+("</"+ne+`>
`)},de.strong=function(re){return"<strong>"+re+"</strong>"},de.em=function(re){return"<em>"+re+"</em>"},de.codespan=function(re){return"<code>"+re+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(re){return"<del>"+re+"</del>"},de.link=function(re,he,ne){if(re=l(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var ae='<a href="'+v(re)+'"';return he&&(ae+=' title="'+he+'"'),ae+=">"+ne+"</a>",ae},de.image=function(re,he,ne){if(re=l(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var ae='<img src="'+re+'" alt="'+ne+'"';return he&&(ae+=' title="'+he+'"'),ae+=this.options.xhtml?"/>":">",ae},de.text=function(re){return re},$e}(),ke=function(){function $e(){}var de=$e.prototype;return de.strong=function(re){return re},de.em=function(re){return re},de.codespan=function(re){return re},de.del=function(re){return re},de.html=function(re){return re},de.text=function(re){return re},de.link=function(re,he,ne){return""+ne},de.image=function(re,he,ne){return""+ne},de.br=function(){return""},$e}(),Pe=function(){function $e(){this.seen={}}var de=$e.prototype;return de.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(re,he){var ne=re,ae=0;if(this.seen.hasOwnProperty(ne)){ae=this.seen[re];do ae++,ne=re+"-"+ae;while(this.seen.hasOwnProperty(ne))}return he||(this.seen[re]=ae,this.seen[ne]=0),ne},de.slug=function(re,he){he===void 0&&(he={});var ne=this.serialize(re);return this.getNextSafeSlug(ne,he.dryrun)},$e}(),le=function(){function $e(De){this.options=De||ve.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Pe}$e.parse=function(re,he){var ne=new $e(he);return ne.parse(re)},$e.parseInline=function(re,he){var ne=new $e(he);return ne.parseInline(re)};var de=$e.prototype;return de.parse=function(re,he){he===void 0&&(he=!0);var ne="",ae,ge,Ce,T,q,G,J,K,x,ce,Ne,je,Qe,Ge,_e,Ye,xe,it,tt,ze=re.length;for(ae=0;ae<ze;ae++){if(ce=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ne+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(K="",J="",T=ce.header.length,ge=0;ge<T;ge++)J+=this.renderer.tablecell(this.parseInline(ce.header[ge].tokens),{header:!0,align:ce.align[ge]});for(K+=this.renderer.tablerow(J),x="",T=ce.rows.length,ge=0;ge<T;ge++){for(G=ce.rows[ge],J="",q=G.length,Ce=0;Ce<q;Ce++)J+=this.renderer.tablecell(this.parseInline(G[Ce].tokens),{header:!1,align:ce.align[Ce]});x+=this.renderer.tablerow(J)}ne+=this.renderer.table(K,x);continue}case"blockquote":{x=this.parse(ce.tokens),ne+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ce.ordered,je=ce.start,Qe=ce.loose,T=ce.items.length,x="",ge=0;ge<T;ge++)_e=ce.items[ge],Ye=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Ye),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Qe),x+=this.renderer.listitem(Ge,xe,Ye);ne+=this.renderer.list(x,Ne,je);continue}case"html":{ne+=this.renderer.html(ce.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(x=ce.tokens?this.parseInline(ce.tokens):ce.text;ae+1<ze&&re[ae+1].type==="text";)ce=re[++ae],x+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ne+=he?this.renderer.paragraph(x):x;continue}default:{var ut='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return ne},de.parseInline=function(re,he){he=he||this.renderer;var ne="",ae,ge,Ce,T=re.length;for(ae=0;ae<T;ae++){if(ge=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(Ce=this.options.extensions.renderers[ge.type].call({parser:this},ge),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ge.type))){ne+=Ce||"";continue}switch(ge.type){case"escape":{ne+=he.text(ge.text);break}case"html":{ne+=he.html(ge.text);break}case"link":{ne+=he.link(ge.href,ge.title,this.parseInline(ge.tokens,he));break}case"image":{ne+=he.image(ge.href,ge.title,ge.text);break}case"strong":{ne+=he.strong(this.parseInline(ge.tokens,he));break}case"em":{ne+=he.em(this.parseInline(ge.tokens,he));break}case"codespan":{ne+=he.codespan(ge.text);break}case"br":{ne+=he.br();break}case"del":{ne+=he.del(this.parseInline(ge.tokens,he));break}case"text":{ne+=he.text(ge.text);break}default:{var q='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ne},$e}();function be($e,de,De){if(typeof $e>"u"||$e===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $e!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($e)+", string expected");if(typeof de=="function"&&(De=de,de=null),de=I({},be.defaults,de||{}),w(de),De){var re=de.highlight,he;try{he=X.lex($e,de)}catch(T){return De(T)}var ne=function(q){var G;if(!q)try{de.walkTokens&&be.walkTokens(he,de.walkTokens),G=le.parse(he,de)}catch(J){q=J}return de.highlight=re,q?De(q):De(null,G)};if(!re||re.length<3||(delete de.highlight,!he.length))return ne();var ae=0;be.walkTokens(he,function(T){T.type==="code"&&(ae++,setTimeout(function(){re(T.text,T.lang,function(q,G){if(q)return ne(q);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),ae--,ae===0&&ne()})},0))}),ae===0&&ne();return}function ge(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+v(T.message+"",!0)+"</pre>";throw T}try{var Ce=X.lex($e,de);if(de.walkTokens){if(de.async)return Promise.all(be.walkTokens(Ce,de.walkTokens)).then(function(){return le.parse(Ce,de)}).catch(ge);be.walkTokens(Ce,de.walkTokens)}return le.parse(Ce,de)}catch(T){ge(T)}}be.options=be.setOptions=function($e){return I(be.defaults,$e),$(be.defaults),be},be.getDefaults=R,be.defaults=ve.defaults,be.use=function(){for(var $e=arguments.length,de=new Array($e),De=0;De<$e;De++)de[De]=arguments[De];var re=I.apply(void 0,[{}].concat(de)),he=be.defaults.extensions||{renderers:{},childTokens:{}},ne;de.forEach(function(ae){if(ae.extensions&&(ne=!0,ae.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var T=he.renderers?he.renderers[Ce.name]:null;T?he.renderers[Ce.name]=function(){for(var q=arguments.length,G=new Array(q),J=0;J<q;J++)G[J]=arguments[J];var K=Ce.renderer.apply(this,G);return K===!1&&(K=T.apply(this,G)),K}:he.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ce.level]?he[Ce.level].unshift(Ce.tokenizer):he[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?he.startBlock?he.startBlock.push(Ce.start):he.startBlock=[Ce.start]:Ce.level==="inline"&&(he.startInline?he.startInline.push(Ce.start):he.startInline=[Ce.start]))}Ce.childTokens&&(he.childTokens[Ce.name]=Ce.childTokens)})),ae.renderer&&function(){var Ce=be.defaults.renderer||new Ee,T=function(J){var K=Ce[J];Ce[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var je=ae.renderer[J].apply(Ce,ce);return je===!1&&(je=K.apply(Ce,ce)),je}};for(var q in ae.renderer)T(q);re.renderer=Ce}(),ae.tokenizer&&function(){var Ce=be.defaults.tokenizer||new W,T=function(J){var K=Ce[J];Ce[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var je=ae.tokenizer[J].apply(Ce,ce);return je===!1&&(je=K.apply(Ce,ce)),je}};for(var q in ae.tokenizer)T(q);re.tokenizer=Ce}(),ae.walkTokens){var ge=be.defaults.walkTokens;re.walkTokens=function(Ce){var T=[];return T.push(ae.walkTokens.call(this,Ce)),ge&&(T=T.concat(ge.call(this,Ce))),T}}ne&&(re.extensions=he),be.setOptions(re)})},be.walkTokens=function($e,de){for(var De=[],re=function(){var ge=ne.value;switch(De=De.concat(de.call(be,ge)),ge.type){case"table":{for(var Ce=M(ge.header),T;!(T=Ce()).done;){var q=T.value;De=De.concat(be.walkTokens(q.tokens,de))}for(var G=M(ge.rows),J;!(J=G()).done;)for(var K=J.value,x=M(K),ce;!(ce=x()).done;){var Ne=ce.value;De=De.concat(be.walkTokens(Ne.tokens,de))}break}case"list":{De=De.concat(be.walkTokens(ge.items,de));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[ge.type]?be.defaults.extensions.childTokens[ge.type].forEach(function(je){De=De.concat(be.walkTokens(ge[je],de))}):ge.tokens&&(De=De.concat(be.walkTokens(ge.tokens,de)))}},he=M($e),ne;!(ne=he()).done;)re();return De},be.parseInline=function($e,de){if(typeof $e>"u"||$e===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $e!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($e)+", string expected");de=I({},be.defaults,de||{}),w(de);try{var De=X.lexInline($e,de);return de.walkTokens&&be.walkTokens(De,de.walkTokens),le.parseInline(De,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+v(re.message+"",!0)+"</pre>";throw re}},be.Parser=le,be.parser=le.parse,be.Renderer=Ee,be.TextRenderer=ke,be.Lexer=X,be.lexer=X.lex,be.Tokenizer=W,be.Slugger=Pe,be.parse=be;var ue=be.options,oe=be.setOptions,ye=be.use,te=be.walkTokens,V=be.parseInline,Y=be,_=le.parse,pe=X.lex;ve.Lexer=X,ve.Parser=le,ve.Renderer=Ee,ve.Slugger=Pe,ve.TextRenderer=ke,ve.Tokenizer=W,ve.getDefaults=R,ve.lexer=pe,ve.marked=be,ve.options=ue,ve.parse=Y,ve.parseInline=V,ve.parser=_,ve.setOptions=oe,ve.use=ye,ve.walkTokens=te,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Ae[120],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function E($,D,g){return Math.min(Math.max($,D),g)}e.$Ol=E;function L($,D){return(D+$%D)%D}e.rot=L;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=P;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=M;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=R}),function(){function ve(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function R(D){M.push(D,Date.now())}function $(){const D=[];for(let g=0;g<M.length;g+=2)D.push({name:M[g],startTime:M[g+1]});return D}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(P+R.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:ve)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function E(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return ve[L].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=ve,E.c=e,E.d=function(L,P,M){E.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:M})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,P){if(1&P&&(L=E(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var R in L)E.d(M,R,function($){return L[$]}.bind(null,R));return M},E.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(P,"a",P),P},E.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},E.p="",E(E.s=0)}([function(ve,e,E){(function(L){var P;e=ve.exports=ye,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],D=e.src=[],g=0,A=g++;D[A]="0|[1-9]\\d*";var S=g++;D[S]="[0-9]+";var o=g++;D[o]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;D[b]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var v=g++;D[v]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var f=g++;D[f]="(?:"+D[A]+"|"+D[o]+")";var t=g++;D[t]="(?:"+D[S]+"|"+D[o]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var r=g++;D[r]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var u=g++;D[u]="[0-9A-Za-z-]+";var a=g++;D[a]="(?:\\+("+D[u]+"(?:\\."+D[u]+")*))";var l=g++,n="v?"+D[b]+D[i]+"?"+D[a]+"?";D[l]="^"+n+"$";var s="[v=\\s]*"+D[v]+D[r]+"?"+D[a]+"?",c=g++;D[c]="^"+s+"$";var h=g++;D[h]="((?:<|>)?=?)";var p=g++;D[p]=D[S]+"|x|X|\\*";var m=g++;D[m]=D[A]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[i]+")?"+D[a]+"?)?)?";var k=g++;D[k]="[v=\\s]*("+D[p]+")(?:\\.("+D[p]+")(?:\\.("+D[p]+")(?:"+D[r]+")?"+D[a]+"?)?)?";var d=g++;D[d]="^"+D[h]+"\\s*"+D[I]+"$";var y=g++;D[y]="^"+D[h]+"\\s*"+D[k]+"$";var w=g++;D[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;D[C]="(?:~>?)";var j=g++;D[j]="(\\s*)"+D[C]+"\\s+",$[j]=new RegExp(D[j],"g");var B=g++;D[B]="^"+D[C]+D[I]+"$";var W=g++;D[W]="^"+D[C]+D[k]+"$";var U=g++;D[U]="(?:\\^)";var F=g++;D[F]="(\\s*)"+D[U]+"\\s+",$[F]=new RegExp(D[F],"g");var O=g++;D[O]="^"+D[U]+D[I]+"$";var ee=g++;D[ee]="^"+D[U]+D[k]+"$";var X=g++;D[X]="^"+D[h]+"\\s*("+s+")$|^$";var Ee=g++;D[Ee]="^"+D[h]+"\\s*("+n+")$|^$";var ke=g++;D[ke]="(\\s*)"+D[h]+"\\s*("+s+"|"+D[I]+")",$[ke]=new RegExp(D[ke],"g");var Pe=g++;D[Pe]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var le=g++;D[le]="^\\s*("+D[k]+")\\s+-\\s+("+D[k]+")\\s*$";var be=g++;D[be]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)P(ue,D[ue]),$[ue]||($[ue]=new RegExp(D[ue]));function oe(K,x){if(K instanceof ye)return K;if(typeof K!="string"||K.length>M||!(x?$[c]:$[l]).test(K))return null;try{return new ye(K,x)}catch{return null}}function ye(K,x){if(K instanceof ye){if(K.loose===x)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ye))return new ye(K,x);P("SemVer",K,x),this.loose=x;var ce=K.trim().match(x?$[c]:$[l]);if(!ce)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var je=+Ne;if(je>=0&&je<R)return je}return Ne}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=oe,e.valid=function(K,x){var ce=oe(K,x);return ce?ce.version:null},e.clean=function(K,x){var ce=oe(K.trim().replace(/^[=v]+/,""),x);return ce?ce.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(K){return P("SemVer.compare",this.version,this.loose,K),K instanceof ye||(K=new ye(K,this.loose)),this.compareMain(K)||this.comparePre(K)},ye.prototype.compareMain=function(K){return K instanceof ye||(K=new ye(K,this.loose)),V(this.major,K.major)||V(this.minor,K.minor)||V(this.patch,K.patch)},ye.prototype.comparePre=function(K){if(K instanceof ye||(K=new ye(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var x=0;do{var ce=this.prerelease[x],Ne=K.prerelease[x];if(P("prerelease compare",x,ce,Ne),ce===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ce===void 0)return-1;if(ce!==Ne)return V(ce,Ne)}while(++x)},ye.prototype.inc=function(K,x){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,x,ce,Ne){typeof ce=="string"&&(Ne=ce,ce=void 0);try{return new ye(K,ce).inc(x,Ne).version}catch{return null}},e.diff=function(K,x){if($e(K,x))return null;var ce=oe(K),Ne=oe(x);if(ce.prerelease.length||Ne.prerelease.length){for(var je in ce)if((je==="major"||je==="minor"||je==="patch")&&ce[je]!==Ne[je])return"pre"+je;return"prerelease"}for(var je in ce)if((je==="major"||je==="minor"||je==="patch")&&ce[je]!==Ne[je])return je},e.compareIdentifiers=V;var te=/^[0-9]+$/;function V(K,x){var ce=te.test(K),Ne=te.test(x);return ce&&Ne&&(K=+K,x=+x),ce&&!Ne?-1:Ne&&!ce?1:K<x?-1:K>x?1:0}function Y(K,x,ce){return new ye(K,ce).compare(new ye(x,ce))}function _(K,x,ce){return Y(K,x,ce)>0}function pe(K,x,ce){return Y(K,x,ce)<0}function $e(K,x,ce){return Y(K,x,ce)===0}function de(K,x,ce){return Y(K,x,ce)!==0}function De(K,x,ce){return Y(K,x,ce)>=0}function re(K,x,ce){return Y(K,x,ce)<=0}function he(K,x,ce,Ne){var je;switch(x){case"===":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),je=K===ce;break;case"!==":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),je=K!==ce;break;case"":case"=":case"==":je=$e(K,ce,Ne);break;case"!=":je=de(K,ce,Ne);break;case">":je=_(K,ce,Ne);break;case">=":je=De(K,ce,Ne);break;case"<":je=pe(K,ce,Ne);break;case"<=":je=re(K,ce,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return je}function ne(K,x){if(K instanceof ne){if(K.loose===x)return K;K=K.value}if(!(this instanceof ne))return new ne(K,x);P("comparator",K,x),this.loose=x,this.parse(K),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(K,x){return V(x,K)},e.major=function(K,x){return new ye(K,x).major},e.minor=function(K,x){return new ye(K,x).minor},e.patch=function(K,x){return new ye(K,x).patch},e.compare=Y,e.compareLoose=function(K,x){return Y(K,x,!0)},e.rcompare=function(K,x,ce){return Y(x,K,ce)},e.sort=function(K,x){return K.sort(function(ce,Ne){return e.compare(ce,Ne,x)})},e.rsort=function(K,x){return K.sort(function(ce,Ne){return e.rcompare(ce,Ne,x)})},e.gt=_,e.lt=pe,e.eq=$e,e.neq=de,e.gte=De,e.lte=re,e.cmp=he,e.Comparator=ne;var ae={};function ge(K,x){if(K instanceof ge)return K.loose===x?K:new ge(K.raw,x);if(K instanceof ne)return new ge(K.value,x);if(!(this instanceof ge))return new ge(K,x);if(this.loose=x,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Ce(K){return!K||K.toLowerCase()==="x"||K==="*"}function T(K,x,ce,Ne,je,Qe,Ge,_e,Ye,xe,it,tt,ze){return((x=Ce(ce)?"":Ce(Ne)?">="+ce+".0.0":Ce(je)?">="+ce+"."+Ne+".0":">="+x)+" "+(_e=Ce(Ye)?"":Ce(xe)?"<"+(+Ye+1)+".0.0":Ce(it)?"<"+Ye+"."+(+xe+1)+".0":tt?"<="+Ye+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function q(K,x){for(var ce=0;ce<K.length;ce++)if(!K[ce].test(x))return!1;if(x.prerelease.length){for(ce=0;ce<K.length;ce++)if(P(K[ce].semver),K[ce].semver!==ae&&K[ce].semver.prerelease.length>0){var Ne=K[ce].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function G(K,x,ce){try{x=new ge(x,ce)}catch{return!1}return x.test(K)}function J(K,x,ce,Ne){var je,Qe,Ge,_e,Ye;switch(K=new ye(K,Ne),x=new ge(x,Ne),ce){case">":je=_,Qe=re,Ge=pe,_e=">",Ye=">=";break;case"<":je=pe,Qe=De,Ge=_,_e="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(K,x,Ne))return!1;for(var xe=0;xe<x.set.length;++xe){var it=x.set[xe],tt=null,ze=null;if(it.forEach(function(ut){ut.semver===ae&&(ut=new ne(">=0.0.0")),tt=tt||ut,ze=ze||ut,je(ut.semver,tt.semver,Ne)?tt=ut:Ge(ut.semver,ze.semver,Ne)&&(ze=ut)}),tt.operator===_e||tt.operator===Ye||(!ze.operator||ze.operator===_e)&&Qe(K,ze.semver)||ze.operator===Ye&&Ge(K,ze.semver))return!1}return!0}ne.prototype.parse=function(K){var x=this.loose?$[X]:$[Ee],ce=K.match(x);if(!ce)throw new TypeError("Invalid comparator: "+K);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new ye(ce[2],this.loose):this.semver=ae},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(K){return P("Comparator.test",K,this.loose),this.semver===ae||(typeof K=="string"&&(K=new ye(K,this.loose)),he(K,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(K,x){if(!(K instanceof ne))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new ge(K.value,x),G(this.value,ce,x);if(K.operator==="")return ce=new ge(this.value,x),G(K.semver,ce,x);var Ne=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Qe=this.semver.version===K.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),_e=he(this.semver,"<",K.semver,x)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),Ye=he(this.semver,">",K.semver,x)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return Ne||je||Qe&&Ge||_e||Ye},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(K){var x=this.loose;K=K.trim(),P("range",K,x);var ce=x?$[le]:$[Pe];K=K.replace(ce,T),P("hyphen replace",K),K=K.replace($[ke],"$1$2$3"),P("comparator trim",K,$[ke]),K=(K=(K=K.replace($[j],"$1~")).replace($[F],"$1^")).split(/\s+/).join(" ");var Ne=x?$[X]:$[Ee],je=K.split(" ").map(function(Qe){return function(Ge,_e){return P("comp",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){P("caret",tt,ze);var ut=ze?$[ee]:$[O];return tt.replace(ut,function(Z,Q,we,Be,Oe){var Xe;return P("caret",tt,Z,Q,we,Be,Oe),Ce(Q)?Xe="":Ce(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ce(Be)?Xe=Q==="0"?">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+".0 <"+(+Q+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+we+"."+(+Be+1):">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+Be+Oe+" <"+(+Q+1)+".0.0"):(P("no pr"),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+Be+" <"+Q+"."+we+"."+(+Be+1):">="+Q+"."+we+"."+Be+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+Be+" <"+(+Q+1)+".0.0"),P("caret return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),P("caret",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var ut=ze?$[W]:$[B];return tt.replace(ut,function(Z,Q,we,Be,Oe){var Xe;return P("tilde",tt,Z,Q,we,Be,Oe),Ce(Q)?Xe="":Ce(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ce(Be)?Xe=">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+(+we+1)+".0"):Xe=">="+Q+"."+we+"."+Be+" <"+Q+"."+(+we+1)+".0",P("tilde return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),P("tildes",Ge),Ge=function(Ye,xe){return P("replaceXRanges",Ye,xe),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var ut=ze?$[y]:$[d];return tt.replace(ut,function(Z,Q,we,Be,Oe,Xe){P("xRange",tt,Z,Q,we,Be,Oe,Xe);var nt=Ce(we),$t=nt||Ce(Be),bt=$t||Ce(Oe);return Q==="="&&bt&&(Q=""),nt?Z=Q===">"||Q==="<"?"<0.0.0":"*":Q&&bt?($t&&(Be=0),bt&&(Oe=0),Q===">"?(Q=">=",$t?(we=+we+1,Be=0,Oe=0):bt&&(Be=+Be+1,Oe=0)):Q==="<="&&(Q="<",$t?we=+we+1:Be=+Be+1),Z=Q+we+"."+Be+"."+Oe):$t?Z=">="+we+".0.0 <"+(+we+1)+".0.0":bt&&(Z=">="+we+"."+Be+".0 <"+we+"."+(+Be+1)+".0"),P("xRange return",Z),Z})}(it,xe)}).join(" ")}(Ge,_e),P("xrange",Ge),Ge=function(Ye,xe){return P("replaceStars",Ye,xe),Ye.trim().replace($[be],"")}(Ge,_e),P("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Ne)})),je=je.map(function(Qe){return new ne(Qe,x)})},ge.prototype.intersects=function(K,x){if(!(K instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Ne){return K.set.some(function(je){return je.every(function(Qe){return Ne.intersects(Qe,x)})})})})},e.toComparators=function(K,x){return new ge(K,x).set.map(function(ce){return ce.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new ye(K,this.loose));for(var x=0;x<this.set.length;x++)if(q(this.set[x],K))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(K,x,ce){var Ne=null,je=null;try{var Qe=new ge(x,ce)}catch{return null}return K.forEach(function(Ge){Qe.test(Ge)&&(Ne&&je.compare(Ge)!==-1||(je=new ye(Ne=Ge,ce)))}),Ne},e.minSatisfying=function(K,x,ce){var Ne=null,je=null;try{var Qe=new ge(x,ce)}catch{return null}return K.forEach(function(Ge){Qe.test(Ge)&&(Ne&&je.compare(Ge)!==1||(je=new ye(Ne=Ge,ce)))}),Ne},e.validRange=function(K,x){try{return new ge(K,x).range||"*"}catch{return null}},e.ltr=function(K,x,ce){return J(K,x,"<",ce)},e.gtr=function(K,x,ce){return J(K,x,">",ce)},e.outside=J,e.prerelease=function(K,x){var ce=oe(K,x);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(K,x,ce){return K=new ge(K,ce),x=new ge(x,ce),K.intersects(x)},e.coerce=function(K){if(K instanceof ye)return K;if(typeof K!="string")return null;var x=K.match($[w]);return x==null?null:oe((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,E(1))},function(ve,e){var E,L,P=ve.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(E===setTimeout)return setTimeout(t,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(t,0);try{return E(t,0)}catch{try{return E.call(null,t,0)}catch{return E.call(this,t,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var D,g=[],A=!1,S=-1;function o(){A&&D&&(A=!1,D.length?g=D.concat(g):S=-1,g.length&&b())}function b(){if(!A){var t=$(o);A=!0;for(var i=g.length;i;){for(D=g,g=[];++S<i;)D&&D[S].run();S=-1,i=g.length}D=null,A=!1,function(r){if(L===clearTimeout)return clearTimeout(r);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(r);try{L(r)}catch{try{return L.call(null,r)}catch{return L.call(this,r)}}}(t)}}function v(t,i){this.fun=t,this.array=i}function f(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];g.push(new v(t,i)),g.length!==1||A||$(b)},v.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ae[121],Re([1,0,11,6]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function P(a){const l=a;return l?typeof l.read=="function":!1}e.$Yd=P;function M(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.$Zd=M;function R(a){const l=a;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$1d=R;function $(a,l){return new D(a,l)}e.$2d=$;class D{constructor(l,n){this.e=l,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(n=>n(l))}h(l){this.c.error.length===0?(0,E.$Z)(l):this.c.error.slice(0).forEach(n=>n(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,n){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(l,n){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const c=s.indexOf(n);c>=0&&s.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(a,l){const n=[];let s;for(;(s=a.read())!==null;)n.push(s);return l(n)}e.$3d=g;function A(a,l,n){const s=[];let c;for(;(c=a.read())!==null&&s.length<n;)s.push(c);return c===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c<"u"){const h=c;return c=void 0,h}return a.read()}}}e.$4d=A;function S(a,l){return new Promise((n,s)=>{const c=[];o(a,{onData:h=>{l&&c.push(h)},onError:h=>{l?s(h):n(void 0)},onEnd:()=>{n(l?l(c):void 0)}})})}e.$5d=S;function o(a,l,n){a.on("error",s=>{n?.isCancellationRequested||l.onError(s)}),a.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),a.on("data",s=>{n?.isCancellationRequested||l.onData(s)})}e.$6d=o;function b(a,l){return new Promise((n,s)=>{const c=new L.$Qc,h=[],p=k=>{if(h.push(k),h.length>l)return c.dispose(),a.pause(),n({stream:a,buffer:h,ended:!1})},m=k=>(c.dispose(),s(k)),I=()=>(c.dispose(),n({stream:a,buffer:h,ended:!0}));c.add((0,L.$Pc)(()=>a.removeListener("error",m))),a.on("error",m),c.add((0,L.$Pc)(()=>a.removeListener("end",I))),a.on("end",I),c.add((0,L.$Pc)(()=>a.removeListener("data",p))),a.on("data",p)})}e.$7d=b;function v(a,l){const n=$(l);return n.end(a),n}e.$8d=v;function f(){const a=$(()=>{throw new Error("not supported")});return a.end(),a}e.$9d=f;function t(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.$0d=t;function i(a,l,n){const s=$(n);return o(a,{onData:c=>s.write(l.data(c)),onError:c=>s.error(l.error?l.error(c):c),onEnd:()=>s.end()}),s}e.$$d=i;function r(a,l,n){let s=!1;return{read:()=>{const c=l.read();return s?c:(s=!0,c!==null?n([a,c]):a)}}}e.$_d=r;function u(a,l,n){let s=!1;const c=$(n);return o(l,{onData:h=>s?c.write(h):(s=!0,c.write(n([a,h]))),onError:h=>c.error(h),onEnd:()=>{s||(s=!0,c.write(a)),c.end()}}),c}e.$ae=u}),define(Ae[22],Re([1,0,43,121]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const P=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let R,$;class D{static alloc(w){return P?new D(Buffer.allocUnsafe(w)):new D(new Uint8Array(w))}static wrap(w){return P&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new D(w)}static fromString(w,C){return!(C?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(w)):(R||(R=new TextEncoder),new D(R.encode(w)))}static fromByteArray(w){const C=D.alloc(w.length);for(let j=0,B=w.length;j<B;j++)C.buffer[j]=w[j];return C}static concat(w,C){if(typeof C>"u"){C=0;for(let W=0,U=w.length;W<U;W++)C+=w[W].byteLength}const j=D.alloc(C);let B=0;for(let W=0,U=w.length;W<U;W++){const F=w[W];j.set(F,B),B+=F.byteLength}return j}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=D.alloc(this.byteLength);return w.set(this),w}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(w,C){return new D(this.buffer.subarray(w,C))}set(w,C){if(w instanceof D)this.buffer.set(w.buffer,C);else if(w instanceof Uint8Array)this.buffer.set(w,C);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),C);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return o(this.buffer,w)}writeUInt32BE(w,C){b(this.buffer,w,C)}readUInt32LE(w){return v(this.buffer,w)}writeUInt32LE(w,C){f(this.buffer,w,C)}readUInt8(w){return t(this.buffer,w)}writeUInt8(w,C){i(this.buffer,w,C)}indexOf(w,C=0){return g(this.buffer,w instanceof D?w.buffer:w,C)}}e.$be=D;function g(y,w,C=0){const j=w.byteLength,B=y.byteLength;if(j===0)return 0;if(j===1)return y.indexOf(w[0]);if(j>B-C)return-1;const W=M.value;W.fill(w.length);for(let ee=0;ee<w.length;ee++)W[w[ee]]=w.length-ee-1;let U=C+w.length-1,F=U,O=-1;for(;U<B;)if(y[U]===w[F]){if(F===0){O=U;break}U--,F--}else U+=Math.max(w.length-F,W[y[U]]),F=w.length-1;return O}e.$ce=g;function A(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0}e.$de=A;function S(y,w,C){y[C+0]=w&255,w=w>>>8,y[C+1]=w&255}e.$ee=S;function o(y,w){return y[w]*2**24+y[w+1]*2**16+y[w+2]*2**8+y[w+3]}e.$fe=o;function b(y,w,C){y[C+3]=w,w=w>>>8,y[C+2]=w,w=w>>>8,y[C+1]=w,w=w>>>8,y[C]=w}e.$ge=b;function v(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0|y[w+2]<<16>>>0|y[w+3]<<24>>>0}e.$he=v;function f(y,w,C){y[C+0]=w&255,w=w>>>8,y[C+1]=w&255,w=w>>>8,y[C+2]=w&255,w=w>>>8,y[C+3]=w&255}e.$ie=f;function t(y,w){return y[w]}e.$je=t;function i(y,w,C){y[C]=w}e.$ke=i;function r(y){return L.$3d(y,w=>D.concat(w))}e.$le=r;function u(y){return L.$0d(y)}e.$me=u;function a(y){return L.$5d(y,w=>D.concat(w))}e.$ne=a;async function l(y){return y.ended?D.concat(y.buffer):D.concat([...y.buffer,await a(y.stream)])}e.$oe=l;function n(y){return L.$8d(y,w=>D.concat(w))}e.$pe=n;function s(y){return L.$$d(y,{data:w=>typeof w=="string"?D.fromString(w):D.wrap(w)},w=>D.concat(w))}e.$qe=s;function c(y){return L.$2d(w=>D.concat(w),y)}e.$re=c;function h(y,w){return L.$_d(y,w,C=>D.concat(C))}e.$se=h;function p(y,w){return L.$ae(y,w,C=>D.concat(C))}e.$te=p;function m(y){let w=0,C=0,j=0;const B=new Uint8Array(Math.floor(y.length/4*3)),W=F=>{switch(C){case 3:B[j++]=w|F,C=0;break;case 2:B[j++]=w|F>>>2,w=F<<6,C=3;break;case 1:B[j++]=w|F>>>4,w=F<<4,C=2;break;default:w=F<<2,C=1}};for(let F=0;F<y.length;F++){const O=y.charCodeAt(F);if(O>=65&&O<=90)W(O-65);else if(O>=97&&O<=122)W(O-97+26);else if(O>=48&&O<=57)W(O-48+52);else if(O===43||O===45)W(62);else if(O===47||O===95)W(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${y[F]}`)}}const U=j;for(;C>0;)W(0);return D.wrap(B).slice(0,U)}e.$ue=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:y},w=!0,C=!1){const j=C?k:I;let B="";const W=y.byteLength%3;let U=0;for(;U<y.byteLength-W;U+=3){const F=y[U+0],O=y[U+1],ee=y[U+2];B+=j[F>>>2],B+=j[(F<<4|O>>>4)&63],B+=j[(O<<2|ee>>>6)&63],B+=j[ee&63]}if(W===1){const F=y[U+0];B+=j[F>>>2],B+=j[F<<4&63],w&&(B+="==")}else if(W===2){const F=y[U+0],O=y[U+1];B+=j[F>>>2],B+=j[(F<<4|O>>>4)&63],B+=j[O<<2&63],w&&(B+="=")}return B}e.$ve=d}),define(Ae[122],Re([1,0,28,13]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function P(...ne){return function(ae,ge){for(let Ce=0,T=ne.length;Ce<T;Ce++){const q=ne[Ce](ae,ge);if(q)return q}return null}}e.or=P,e.$Cj=M.bind(void 0,!1),e.$Dj=M.bind(void 0,!0);function M(ne,ae,ge){if(!ge||ge.length<ae.length)return null;let Ce;return ne?Ce=L.$3e(ge,ae):Ce=ge.indexOf(ae)===0,Ce?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(ne,ae){const ge=ae.toLowerCase().indexOf(ne.toLowerCase());return ge===-1?null:[{start:ge,end:ge+ne.length}]}e.$Ej=R;function $(ne,ae){return D(ne.toLowerCase(),ae.toLowerCase(),0,0)}e.$Fj=$;function D(ne,ae,ge,Ce){if(ge===ne.length)return[];if(Ce===ae.length)return null;if(ne[ge]===ae[Ce]){let T=null;return(T=D(ne,ae,ge+1,Ce+1))?i({start:Ce,end:Ce+1},T):null}return D(ne,ae,ge,Ce+1)}function g(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.$Gj=A;function S(ne){return 48<=ne&&ne<=57}function o(ne){return ne===32||ne===9||ne===10||ne===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>b.add(ne.charCodeAt(0)));function v(ne){return o(ne)||b.has(ne)}function f(ne,ae){return ne===ae||v(ne)&&v(ae)}function t(ne){return g(ne)||A(ne)||S(ne)}function i(ne,ae){return ae.length===0?ae=[ne]:ne.end===ae[0].start?ae[0].start=ne.start:ae.unshift(ne),ae}function r(ne,ae){for(let ge=ae;ge<ne.length;ge++){const Ce=ne.charCodeAt(ge);if(A(Ce)||S(Ce)||ge>0&&!t(ne.charCodeAt(ge-1)))return ge}return ne.length}function u(ne,ae,ge,Ce){if(ge===ne.length)return[];if(Ce===ae.length)return null;if(ne[ge]!==ae[Ce].toLowerCase())return null;{let T=null,q=Ce+1;for(T=u(ne,ae,ge+1,Ce+1);!T&&(q=r(ae,q))<ae.length;)T=u(ne,ae,ge+1,q),q++;return T===null?null:i({start:Ce,end:Ce+1},T)}}function a(ne){let ae=0,ge=0,Ce=0,T=0,q=0;for(let ce=0;ce<ne.length;ce++)q=ne.charCodeAt(ce),A(q)&&ae++,g(q)&&ge++,t(q)&&Ce++,S(q)&&T++;const G=ae/ne.length,J=ge/ne.length,K=Ce/ne.length,x=T/ne.length;return{upperPercent:G,lowerPercent:J,alphaPercent:K,numericPercent:x}}function l(ne){const{upperPercent:ae,lowerPercent:ge}=ne;return ge===0&&ae>.6}function n(ne){const{upperPercent:ae,lowerPercent:ge,alphaPercent:Ce,numericPercent:T}=ne;return ge>.2&&ae<.8&&Ce>.6&&T<.2}function s(ne){let ae=0,ge=0,Ce=0,T=0;for(let q=0;q<ne.length;q++)Ce=ne.charCodeAt(q),A(Ce)&&ae++,g(Ce)&&ge++,o(Ce)&&T++;return(ae===0||ge===0)&&T===0?ne.length<=30:ae<=5}function c(ne,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(ne)||ae.length>60)return null;const ge=a(ae);if(!n(ge)){if(!l(ge))return null;ae=ae.toLowerCase()}let Ce=null,T=0;for(ne=ne.toLowerCase();T<ae.length&&(Ce=u(ne,ae,0,T))===null;)T=r(ae,T+1);return Ce}e.$Hj=c;function h(ne,ae,ge=!1){if(!ae||ae.length===0)return null;let Ce=null,T=0;for(ne=ne.toLowerCase(),ae=ae.toLowerCase();T<ae.length&&(Ce=p(ne,ae,0,T,ge))===null;)T=m(ae,T+1);return Ce}e.$Ij=h;function p(ne,ae,ge,Ce,T){if(ge===ne.length)return[];if(Ce===ae.length)return null;if(f(ne.charCodeAt(ge),ae.charCodeAt(Ce))){let q=null,G=Ce+1;if(q=p(ne,ae,ge+1,Ce+1,T),!T)for(;!q&&(G=m(ae,G))<ae.length;)q=p(ne,ae,ge+1,G,T),G++;return q?ne.charCodeAt(ge)!==ae.charCodeAt(Ce)?q:i({start:Ce,end:Ce+1},q):null}else return null}function m(ne,ae){for(let ge=ae;ge<ne.length;ge++)if(v(ne.charCodeAt(ge))||ge>0&&v(ne.charCodeAt(ge-1)))return ge;return ne.length}const I=P(e.$Dj,c,R),k=P(e.$Dj,c,$),d=new E.$Cc(1e4);function y(ne,ae,ge=!1){if(typeof ne!="string"||typeof ae!="string")return null;let Ce=d.get(ne);Ce||(Ce=new RegExp(L.$Le(ne),"i"),d.set(ne,Ce));const T=Ce.exec(ae);return T?[{start:T.index,end:T.index+T[0].length}]:ge?k(ne,ae):I(ne,ae)}e.$Jj=y;function w(ne,ae){const ge=_(ne,ne.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ge?j(ge):null}e.$Kj=w;function C(ne,ae,ge,Ce,T,q){const G=Math.min(13,ne.length);for(;ge<G;ge++){const J=_(ne,ae,ge,Ce,T,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,q]}e.$Lj=C;function j(ne){if(typeof ne>"u")return[];const ae=[],ge=ne[1];for(let Ce=ne.length-1;Ce>1;Ce--){const T=ne[Ce]+ge,q=ae[ae.length-1];q&&q.end===T?q.end=T+1:ae.push({start:T,end:T+1})}return ae}e.$Mj=j;const B=128;function W(){const ne=[],ae=[];for(let ge=0;ge<=B;ge++)ae[ge]=0;for(let ge=0;ge<=B;ge++)ne.push(ae.slice(0));return ne}function U(ne){const ae=[];for(let ge=0;ge<=ne;ge++)ae[ge]=0;return ae}const F=U(2*B),O=U(2*B),ee=W(),X=W(),Ee=W(),ke=!1;function Pe(ne,ae,ge,Ce,T){function q(J,K,x=" "){for(;J.length<K;)J=x+J;return J}let G=` |   |${Ce.split("").map(J=>q(J,3)).join("|")}
`;for(let J=0;J<=ge;J++)J===0?G+=" |":G+=`${ae[J-1]}|`,G+=ne[J].slice(0,T+1).map(K=>q(K.toString(),3)).join("|")+`
`;return G}function le(ne,ae,ge,Ce){ne=ne.substr(ae),ge=ge.substr(Ce),console.log(Pe(X,ne,ne.length,ge,ge.length)),console.log(Pe(Ee,ne,ne.length,ge,ge.length)),console.log(Pe(ee,ne,ne.length,ge,ge.length))}function be(ne,ae){if(ae<0||ae>=ne.length)return!1;const ge=ne.codePointAt(ae);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$if(ge)}}function ue(ne,ae){if(ae<0||ae>=ne.length)return!1;switch(ne.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function oe(ne,ae,ge){return ae[ne]!==ge[ne]}function ye(ne,ae,ge,Ce,T,q,G=!1){for(;ae<ge&&T<q;)ne[ae]===Ce[T]&&(G&&(F[ae]=T),ae+=1),T+=1;return ae===ge}e.$Nj=ye;var te;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(te||(te={}));var V;(function(ne){ne.Default=[-100,0];function ae(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}ne.isDefault=ae})(V||(e.FuzzyScore=V={}));class Y{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,ge){this.firstMatchCanBeWeak=ae,this.boostFullMatch=ge}}e.$Oj=Y;function _(ne,ae,ge,Ce,T,q,G=Y.default){const J=ne.length>B?B:ne.length,K=Ce.length>B?B:Ce.length;if(ge>=J||q>=K||J-ge>K-q||!ye(ae,ge,J,T,q,K,!0))return;pe(J,K,ge,q,ae,T);let x=1,ce=1,Ne=ge,je=q;const Qe=[!1];for(x=1,Ne=ge;Ne<J;x++,Ne++){const it=F[Ne],tt=O[Ne],ze=Ne+1<J?O[Ne+1]:K;for(ce=it-q+1,je=it;je<ze;ce++,je++){let ut=Number.MIN_SAFE_INTEGER,Z=!1;je<=tt&&(ut=$e(ne,ae,Ne,ge,Ce,T,je,K,q,ee[x-1][ce-1]===0,Qe));let Q=0;ut!==Number.MAX_SAFE_INTEGER&&(Z=!0,Q=ut+X[x-1][ce-1]);const we=je>it,Be=we?X[x][ce-1]+(ee[x][ce-1]>0?-5:0):0,Oe=je>it+1&&ee[x][ce-1]>0,Xe=Oe?X[x][ce-2]+(ee[x][ce-2]>0?-5:0):0;if(Oe&&(!we||Xe>=Be)&&(!Z||Xe>=Q))X[x][ce]=Xe,Ee[x][ce]=3,ee[x][ce]=0;else if(we&&(!Z||Be>=Q))X[x][ce]=Be,Ee[x][ce]=2,ee[x][ce]=0;else if(Z)X[x][ce]=Q,Ee[x][ce]=1,ee[x][ce]=ee[x-1][ce-1]+1;else throw new Error("not possible")}}if(ke&&le(ne,ge,Ce,q),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ce--;const Ge=[X[x][ce],q];let _e=0,Ye=0;for(;x>=1;){let it=ce;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&ae[ge+x-1]===T[q+ce-1]&&!oe(it+q-1,Ce,T)&&_e+1>ee[x][it]&&(it=ce),it===ce?_e++:_e=1,Ye||(Ye=it),x--,ce=it-1,Ge.push(ce)}K===J&&G.boostFullMatch&&(Ge[0]+=2);const xe=Ye-J;return Ge[0]-=xe,Ge}e.$Pj=_;function pe(ne,ae,ge,Ce,T,q){let G=ne-1,J=ae-1;for(;G>=ge&&J>=Ce;)T[G]===q[J]&&(O[G]=J,G--),J--}function $e(ne,ae,ge,Ce,T,q,G,J,K,x,ce){if(ae[ge]!==q[G])return Number.MIN_SAFE_INTEGER;let Ne=1,je=!1;return G===ge-Ce?Ne=ne[ge]===T[G]?7:5:oe(G,T,q)&&(G===0||!oe(G-1,T,q))?(Ne=ne[ge]===T[G]?7:5,je=!0):be(q,G)&&(G===0||!be(q,G-1))?Ne=5:(be(q,G-1)||ue(q,G-1))&&(Ne=5,je=!0),Ne>1&&ge===Ce&&(ce[0]=!0),je||(je=oe(G,T,q)||be(q,G-1)||ue(q,G-1)),ge===Ce?G>K&&(Ne-=je?3:5):x?Ne+=je?2:0:Ne+=je?0:1,G+1===J&&(Ne-=je?3:5),Ne}function de(ne,ae,ge,Ce,T,q,G){return re(ne,ae,ge,Ce,T,q,!0,G)}e.$Qj=de;function De(ne,ae,ge,Ce,T,q,G){return re(ne,ae,ge,Ce,T,q,!1,G)}e.$Rj=De;function re(ne,ae,ge,Ce,T,q,G,J){let K=_(ne,ae,ge,Ce,T,q,J);if(K&&!G)return K;if(ne.length>=3){const x=Math.min(7,ne.length-1);for(let ce=ge+1;ce<x;ce++){const Ne=he(ne,ce);if(Ne){const je=_(Ne,Ne.toLowerCase(),ge,Ce,T,q,J);je&&(je[0]-=3,(!K||je[0]>K[0])&&(K=je))}}}return K}function he(ne,ae){if(ae+1>=ne.length)return;const ge=ne[ae],Ce=ne[ae+1];if(ge!==Ce)return ne.slice(0,ae)+Ce+ge+ne.slice(ae+2)}}),define(Ae[30],Re([1,0,13]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const M="error",R="warning",$="warn",D="info",g="ignore";function A(o){return o?E.$2e(M,o)?P.Error:E.$2e(R,o)||E.$2e($,o)?P.Warning:E.$2e(D,o)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function S(o){switch(o){case P.Error:return M;case P.Warning:return R;case P.Info:return D;default:return g}}P.toString=S}(L||(L={})),e.default=L}),define(Ae[123],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[50],Re([1,0,18,13]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class P{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const v=b.charCodeAt(0),f=this.b.charCodeAt(this.c);return v-f}value(){return this.b[this.c]}}e.$Rh=P;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,L.$Ve)(b,this.b,0,b.length,this.c,this.d):(0,L.$Xe)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=M;class R{constructor(b=!0,v=!0){this.f=b,this.g=v}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let v=b.length-1;v>=0;v--,this.c--){const f=this.b.charCodeAt(v);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,L.$Ve)(b,this.b,0,b.length,this.d,this.e):(0,L.$Xe)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=R;var $;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})($||($={}));class D{constructor(b,v){this.f=b,this.g=v,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,L.$We)(b,this.c.scheme);if(this.d[this.e]===2)return(0,L.$We)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,L.$Ue)(b,this.c.query);if(this.d[this.e]===5)return(0,L.$Ue)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(A||(A={}));class S{static forUris(b=()=>!1,v=()=>!1){return new S(new D(b,v))}static forPaths(b=!1){return new S(new R(void 0,!b))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,v){if(v){const f=v.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t,b)}else{const f=b.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(b,v){const f=this.b.reset(b);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const u=f.cmp(t.segment);if(u>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(u<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const r=t.value;t.value=v,t.key=b;for(let u=i.length-1;u>=0;u--){const a=i[u][1];a.updateHeight();const l=a.balanceFactor();if(l<-1||l>1){const n=i[u][0],s=i[u+1][0];if(n===1&&s===1)i[u][1]=a.rotateLeft();else if(n===-1&&s===-1)i[u][1]=a.rotateRight();else if(n===1&&s===-1)a.right=i[u+1][1]=i[u+1][1].rotateRight(),i[u][1]=a.rotateLeft();else if(n===-1&&s===1)a.left=i[u+1][1]=i[u+1][1].rotateLeft(),i[u][1]=a.rotateRight();else throw new Error;if(u>0)switch(i[u-1][0]){case-1:i[u-1][1].left=i[u][1];break;case 1:i[u-1][1].right=i[u][1];break;case 0:i[u-1][1].mid=i[u][1];break}else this.c=i[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const v=this.b.reset(b);let f=this.c;for(;f;){const t=v.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(v.hasNext())v.next(),f=f.mid;else break}return f}has(b){const v=this.d(b);return!(v?.value===void 0&&v?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,v){const f=this.b.reset(b),t=[];let i=this.c;for(;i;){const r=f.cmp(i.segment);if(r>0)t.push([-1,i]),i=i.left;else if(r<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(v?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:u,value:a,segment:l}=r;this.e(r.key,!1),i.key=u,i.value=a,i.segment=l}}else{const r=i.left??i.right;if(t.length>0){const[u,a]=t[t.length-1];switch(u){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=t.length-1;r>=0;r--){const u=t[r][1];u.updateHeight();const a=u.balanceFactor();if(a>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),t[r][1]=u.rotateLeft()):a<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),t[r][1]=u.rotateRight()),r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const v=this.b.reset(b);let f=this.c,t;for(;f;){const i=v.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(v.hasNext())v.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(b){return this.g(b,!1)}g(b,v){const f=this.b.reset(b);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):v?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[v,f]of this)b(f,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const v=[];return this.j(b,v),v[Symbol.iterator]()}j(b,v){b&&(b.left&&this.j(b.left,v),b.value&&v.push([b.key,b.value]),b.mid&&this.j(b.mid,v),b.right&&this.j(b.right,v))}_isBalanced(){const b=v=>{if(!v)return!0;const f=v.balanceFactor();return f<-1||f>1?!1:b(v.left)&&b(v.right)};return b(this.c)}}e.$Vh=S}),define(Ae[44],Re([1,0,89]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var L;(function(R){function $(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=$})(L||(e.ThemeColor=L={}));function P(R){return{id:R}}e.$Vj=P;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(r){const u=$.exec(r.id);if(!u)return D(E.$Uj.error);const[,a,l]=u,n=["codicon","codicon-"+a];return l&&n.push("codicon-modifier-"+l.substring(1)),n}R.asClassNameArray=D;function g(r){return D(r).join(" ")}R.asClassName=g;function A(r){return"."+D(r).join(".")}R.asCSSSelector=A;function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||L.isThemeColor(r.color))}R.isThemeIcon=S;const o=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(r){const u=o.exec(r);if(!u)return;const[,a]=u;return{id:a}}R.fromString=b;function v(r){return{id:r}}R.fromId=v;function f(r,u){let a=r.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),u&&(a=`${a}~${u}`),{id:a}}R.modify=f;function t(r){const u=r.id.lastIndexOf("~");if(u!==-1)return r.id.substring(u+1)}R.getModifier=t;function i(r,u){return r.id===u.id&&r.color?.id===u.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Ae[124],Re([1,0,122,13,44]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const M="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace($,(r,u)=>u?r:`\\${r}`)}e.$Wj=D;const g=new RegExp(`\\\\${R.source}`,"g");function A(i){return i.replace(g,r=>`\\${r}`)}e.$Xj=A;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function o(i){return i.indexOf(M)===-1?i:i.replace(S,(r,u,a,l)=>a?r:u||l||"")}e.$Yj=o;function b(i){return i?i.replace(/\$\((.*?)\)/g,(r,u)=>` ${u} `).trim():""}e.$Zj=b;const v=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){v.lastIndex=0;let r="";const u=[];let a=0;for(;;){const l=v.lastIndex,n=v.exec(i),s=i.substring(l,n?.index);if(s.length>0){r+=s;for(let c=0;c<s.length;c++)u.push(a)}if(!n)break;a+=n[0].length}return{text:r,iconOffsets:u}}e.$1j=f;function t(i,r,u=!1){const{text:a,iconOffsets:l}=r;if(!l||l.length===0)return(0,E.$Jj)(i,a,u);const n=(0,L.$Je)(a," "),s=a.length-n.length,c=(0,E.$Jj)(i,n,u);if(c)for(const h of c){const p=l[h.start+s]+s;h.start+=p,h.end+=p}return c}e.$2j=t}),define(Ae[37],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return E.test(P)}e.$dg=L,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let D=0;D<$.length;D++)$[D]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,g="";return g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g}}()}),define(Ae[125],Re([1,0,18,67,37]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=e.$4s=e.$3s=e.$2s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$2s=M;function R(S,o,b){const v={id:(0,P.$eg)(),name:S,uri:o,data:b};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$3s=R;class ${constructor(){this.a=new Map}get size(){let o=0;for(const b of this.a)o++;return o}has(o){return this.a.has(this.b(o))}matches(o){const b=[...this.a.keys()];return L.Iterable.some(this,([v,f])=>f.asFile())&&b.push("files"),A(D(o),b)}get(o){return this.a.get(this.b(o))?.[0]}append(o,b){const v=this.a.get(o);v?v.push(b):this.a.set(this.b(o),[b])}replace(o,b){this.a.set(this.b(o),[b])}delete(o){this.a.delete(this.b(o))}*[Symbol.iterator](){for(const[o,b]of this.a)for(const v of b)yield[o,v]}b(o){return D(o)}}e.$4s=$;function D(S){return S.toLowerCase()}function g(S,o){return A(D(S),o.map(D))}e.$5s=g;function A(S,o){if(S==="*/*")return o.length>0;if(o.includes(S))return!0;const b=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[v,f,t]=b;return t==="*"?o.some(i=>i.startsWith(f+"/")):!1}e.$6s=Object.freeze({create:S=>(0,E.$Lb)(S.map(o=>o.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$6s.split(S).filter(o=>!o.startsWith("#"))})}),define(Ae[126],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.StringEOL=void 0;var E;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function L(P){let M=0,R=0,$=0,D=0;for(let g=0,A=P.length;g<A;g++){const S=P.charCodeAt(g);S===13?(M===0&&(R=g),M++,g+1<A&&P.charCodeAt(g+1)===10?(D|=2,g++):D|=3,$=g+1):S===10&&(D|=1,M===0&&(R=g),M++,$=g+1)}return M===0&&(R=P.length),[M,R,P.length-$,D]}e.$9s=L}),define(Ae[127],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0,e.$6r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[128],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class L{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let D=0,g=$.notIn.length;D<g;D++)switch($.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,D){if($.getTokenCount()===0)return!0;const g=$.findTokenIndexAtOffset(D-2),A=$.getStandardTokenType(g);return this.isOK(A)}g($,D){for(let g=$;g<=D;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$st=L;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of $)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$tt=P;function M(R,$,D){R.has($)?R.get($).push(D):R.set($,[D])}}),define(Ae[129],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=e.NodeColor=e.$nB=void 0;class E{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oB)return P(this.right);let t=this;for(;t.parent!==e.$oB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$oB?e.$oB:t.parent}prev(){if(this.left!==e.$oB)return M(this.left);let t=this;for(;t.parent!==e.$oB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$oB?e.$oB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nB=E;var L;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$oB=new E(null,0),e.$oB.parent=e.$oB,e.$oB.left=e.$oB,e.$oB.right=e.$oB,e.$oB.color=0;function P(f){for(;f.left!==e.$oB;)f=f.left;return f}e.$pB=P;function M(f){for(;f.right!==e.$oB;)f=f.right;return f}e.$qB=M;function R(f){return f===e.$oB?0:f.size_left+f.piece.length+R(f.right)}function $(f){return f===e.$oB?0:f.lf_left+f.piece.lineFeedCnt+$(f.right)}function D(){e.$oB.parent=e.$oB}function g(f,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$oB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$oB?f.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$rB=g;function A(f,t){const i=t.left;t.left=i.right,i.right!==e.$oB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$oB?f.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$sB=A;function S(f,t){let i,r;if(t.left===e.$oB?(r=t,i=r.right):t.right===e.$oB?(r=t,i=r.left):(r=P(t.right),i=r.right),r===f.root){f.root=i,i.color=0,t.detach(),D(),f.root.parent=e.$oB;return}const u=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===t?(i.parent=r.parent,v(f,i)):(r.parent===t?i.parent=r:i.parent=r.parent,v(f,i),r.left=t.left,r.right=t.right,r.parent=t.parent,r.color=t.color,t===f.root?f.root=r:t===t.parent.left?t.parent.left=r:t.parent.right=r,r.left!==e.$oB&&(r.left.parent=r),r.right!==e.$oB&&(r.right.parent=r),r.size_left=t.size_left,r.lf_left=t.lf_left,v(f,r)),t.detach(),i.parent.left===i){const l=R(i),n=$(i);if(l!==i.parent.size_left||n!==i.parent.lf_left){const s=l-i.parent.size_left,c=n-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=n,b(f,i.parent,s,c)}}if(v(f,i.parent),u){D();return}let a;for(;i!==f.root&&i.color===0;)i===i.parent.left?(a=i.parent.right,a.color===1&&(a.color=0,i.parent.color=1,g(f,i.parent),a=i.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(f,a),a=i.parent.right),a.color=i.parent.color,i.parent.color=0,a.right.color=0,g(f,i.parent),i=f.root)):(a=i.parent.left,a.color===1&&(a.color=0,i.parent.color=1,A(f,i.parent),a=i.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.left.color===0&&(a.right.color=0,a.color=1,g(f,a),a=i.parent.left),a.color=i.parent.color,i.parent.color=0,a.left.color=0,A(f,i.parent),i=f.root));i.color=0,D()}e.$tB=S;function o(f,t){for(v(f,t);t!==f.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,g(f,t)),t.parent.color=0,t.parent.parent.color=1,A(f,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,A(f,t)),t.parent.color=0,t.parent.parent.color=1,g(f,t.parent.parent))}f.root.color=0}e.$uB=o;function b(f,t,i,r){for(;t!==f.root&&t!==e.$oB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}e.$vB=b;function v(f,t){let i=0,r=0;if(t!==f.root){for(;t!==f.root&&t===t.parent.right;)t=t.parent;if(t!==f.root)for(t=t.parent,i=R(t.left)-t.size_left,r=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=r;t!==f.root&&(i!==0||r!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}}e.$wB=v}),define(Ae[90],Re([1,0,130,29,91,129,92]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=void 0;const $=65535;function D(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class g{constructor(r,u,a,l,n){this.lineStarts=r,this.cr=u,this.lf=a,this.crlf=l,this.isBasicASCII=n}}function A(i,r=!0){const u=[0];let a=1;for(let l=0,n=i.length;l<n;l++){const s=i.charCodeAt(l);s===13?l+1<n&&i.charCodeAt(l+1)===10?(u[a++]=l+2,l++):u[a++]=l+1:s===10&&(u[a++]=l+1)}return r?D(u):u}e.$DB=A;function S(i,r){i.length=0,i[0]=0;let u=1,a=0,l=0,n=0,s=!0;for(let h=0,p=r.length;h<p;h++){const m=r.charCodeAt(h);m===13?h+1<p&&r.charCodeAt(h+1)===10?(n++,i[u++]=h+2,h++):(a++,i[u++]=h+1):m===10?(l++,i[u++]=h+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const c=new g(D(i),a,l,n,s);return i.length=0,c}e.$EB=S;class o{constructor(r,u,a,l,n){this.bufferIndex=r,this.start=u,this.end=a,this.lineFeedCnt=l,this.length=n}}e.$FB=o;class b{constructor(r,u){this.buffer=r,this.lineStarts=u}}e.$GB=b;class v{constructor(r,u){this.a=[],this.c=r,this.d=u,this.b=0,r.root!==M.$oB&&r.iterate(r.root,a=>(a!==M.$oB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(r){this.a=r,this.b=[]}get(r){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let u=!1;const a=this.b;for(let l=0;l<a.length;l++){const n=a[l];if(n.node.parent===null||n.nodeStartOffset>=r){a[l]=null,u=!0;continue}}if(u){const l=[];for(const n of a)n!==null&&l.push(n);this.b=l}}}class t{constructor(r,u,a){this.create(r,u,a)}create(r,u,a){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=M.$oB,this.b=1,this.c=0,this.d=u,this.e=u.length,this.f=a;let l=null;for(let n=0,s=r.length;n<s;n++)if(r[n].buffer.length>0){r[n].lineStarts||(r[n].lineStarts=A(r[n].buffer));const c=new o(n+1,{line:0,column:0},{line:r[n].lineStarts.length-1,column:r[n].buffer.length-r[n].lineStarts[r[n].lineStarts.length-1]},r[n].lineStarts.length-1,r[n].buffer.length);this.a.push(r[n]),l=this.S(l,c)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const u=$,a=u-Math.floor(u/3),l=a*2;let n="",s=0;const c=[];if(this.iterate(this.root,h=>{const p=this.R(h),m=p.length;if(s<=a||s+m<l)return n+=p,s+=m,!0;const I=n.replace(/\r\n|\r|\n/g,r);return c.push(new b(I,A(I))),n=p,s=m,!0}),s>0){const h=n.replace(/\r\n|\r|\n/g,r);c.push(new b(h,A(h)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new v(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let u=0;return this.iterate(this.root,l=>{if(l===M.$oB)return!0;const n=this.R(l),s=n.length,c=r.G(u),h=r.G(u+s),p=r.getValueInRange2(c,h);return u+=s,n===p})}getOffsetAt(r,u){let a=0,l=this.root;for(;l!==M.$oB;)if(l.left!==M.$oB&&l.lf_left+1>=r)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=r){a+=l.size_left;const n=this.B(l,r-l.lf_left-2);return a+=n+u-1}else r-=l.lf_left+l.piece.lineFeedCnt,a+=l.size_left+l.piece.length,l=l.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let u=this.root,a=0;const l=r;for(;u!==M.$oB;)if(u.size_left!==0&&u.size_left>=r)u=u.left;else if(u.size_left+u.piece.length>=r){const n=this.A(u,r-u.size_left);if(a+=u.lf_left+n.index,n.index===0){const s=this.getOffsetAt(a+1,1),c=l-s;return new E.$vs(a+1,c+1)}return new E.$vs(a+1,n.remainder+1)}else if(r-=u.size_left+u.piece.length,a+=u.lf_left+u.piece.lineFeedCnt,u.right===M.$oB){const n=this.getOffsetAt(a+1,1),s=l-r-n;return new E.$vs(a+1,s+1)}else u=u.right;return new E.$vs(1,1)}getValueInRange(r,u){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),l=this.H(r.endLineNumber,r.endColumn),n=this.getValueInRange2(a,l);return u?u!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,u):u===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,u):n}getValueInRange2(r,u){if(r.node===u.node){const c=r.node,h=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);return h.substring(p+r.remainder,p+u.remainder)}let a=r.node;const l=this.a[a.piece.bufferIndex].buffer,n=this.u(a.piece.bufferIndex,a.piece.start);let s=l.substring(n+r.remainder,n+a.piece.length);for(a=a.next();a!==M.$oB;){const c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(a===u.node){s+=c.substring(h,h+u.remainder);break}else s+=c.substr(h,a.piece.length);a=a.next()}return s}getLinesContent(){const r=[];let u=0,a="",l=!1;return this.iterate(this.root,n=>{if(n===M.$oB)return!0;const s=n.piece;let c=s.length;if(c===0)return!0;const h=this.a[s.bufferIndex].buffer,p=this.a[s.bufferIndex].lineStarts,m=s.start.line,I=s.end.line;let k=p[m]+s.start.column;if(l&&(h.charCodeAt(k)===10&&(k++,c--),r[u++]=a,a="",l=!1,c===0))return!0;if(m===I)return!this.f&&h.charCodeAt(k+c-1)===13?(l=!0,a+=h.substr(k,c-1)):a+=h.substr(k,c),!0;a+=this.f?h.substring(k,Math.max(k,p[m+1]-this.e)):h.substring(k,p[m+1]).replace(/(\r\n|\r|\n)$/,""),r[u++]=a;for(let d=m+1;d<I;d++)a=this.f?h.substring(p[d],p[d+1]-this.e):h.substring(p[d],p[d+1]).replace(/(\r\n|\r|\n)$/,""),r[u++]=a;return!this.f&&h.charCodeAt(p[I]+s.end.column-1)===13?(l=!0,s.end.column===0?u--:a=h.substr(p[I],s.end.column-1)):a=h.substr(p[I],s.end.column),!0}),l&&(r[u++]=a,a=""),r[u++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const u=r.node.next();if(!u)return 0;const a=this.a[u.piece.bufferIndex],l=this.u(u.piece.bufferIndex,u.piece.start);return a.buffer.charCodeAt(l)}else{const u=this.a[r.node.piece.bufferIndex],l=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return u.buffer.charCodeAt(l)}}getLineCharCode(r,u){const a=this.H(r,u+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const u=this.getOffsetAt(r,1);return this.getLength()-u}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const u=this.G(r);return this.l(u)}findMatchesInNode(r,u,a,l,n,s,c,h,p,m,I){const k=this.a[r.piece.bufferIndex],d=this.u(r.piece.bufferIndex,r.piece.start),y=this.u(r.piece.bufferIndex,n),w=this.u(r.piece.bufferIndex,s);let C;const j={line:0,column:0};let B,W;u._wordSeparators?(B=k.buffer.substring(y,w),W=U=>U+y,u.reset(0)):(B=k.buffer,W=U=>U,u.reset(y));do if(C=u.next(B),C){if(W(C.index)>=w)return m;this.s(r,W(C.index)-d,j);const U=this.t(r.piece.bufferIndex,n,j),F=j.line===n.line?j.column-n.column+l:j.column+1,O=F+C[0].length;if(I[m++]=(0,R.$zB)(new L.$ws(a+U,F,a+U,O),C,h),W(C.index)+C[0].length>=w||m>=p)return m}while(C);return m}findMatchesLineByLine(r,u,a,l){const n=[];let s=0;const c=new R.$CB(u.wordSeparators,u.regex);let h=this.H(r.startLineNumber,r.startColumn);if(h===null)return[];const p=this.H(r.endLineNumber,r.endColumn);if(p===null)return[];let m=this.s(h.node,h.remainder);const I=this.s(p.node,p.remainder);if(h.node===p.node)return this.findMatchesInNode(h.node,c,r.startLineNumber,r.startColumn,m,I,u,a,l,s,n),n;let k=r.startLineNumber,d=h.node;for(;d!==p.node;){const w=this.t(d.piece.bufferIndex,m,d.piece.end);if(w>=1){const j=this.a[d.piece.bufferIndex].lineStarts,B=this.u(d.piece.bufferIndex,d.piece.start),W=j[m.line+w],U=k===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(d,c,k,U,m,this.s(d,W-B),u,a,l,s,n),s>=l)return n;k+=w}const C=k===r.startLineNumber?r.startColumn-1:0;if(k===r.endLineNumber){const j=this.getLineContent(k).substring(C,r.endColumn-1);return s=this.n(u,c,j,r.endLineNumber,C,s,n,a,l),n}if(s=this.n(u,c,this.getLineContent(k).substr(C),k,C,s,n,a,l),s>=l)return n;k++,h=this.H(k,1),d=h.node,m=this.s(h.node,h.remainder)}if(k===r.endLineNumber){const w=k===r.startLineNumber?r.startColumn-1:0,C=this.getLineContent(k).substring(w,r.endColumn-1);return s=this.n(u,c,C,r.endLineNumber,w,s,n,a,l),n}const y=k===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(p.node,c,k,y,m,I,u,a,l,s,n),n}n(r,u,a,l,n,s,c,h,p){const m=r.wordSeparators;if(!h&&r.simpleSearch){const k=r.simpleSearch,d=k.length,y=a.length;let w=-d;for(;(w=a.indexOf(k,w+d))!==-1;)if((!m||(0,R.$BB)(m,a,y,w,d))&&(c[s++]=new P.$Nu(new L.$ws(l,w+1+n,l,w+1+d+n),null),s>=p))return s;return s}let I;u.reset(0);do if(I=u.next(a),I&&(c[s++]=(0,R.$zB)(new L.$ws(l,I.index+1+n,l,I.index+1+I[0].length+n),I,h),s>=p))return s;while(I);return s}insert(r,u,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==M.$oB){const{node:l,remainder:n,nodeStartOffset:s}=this.G(r),c=l.piece,h=c.bufferIndex,p=this.s(l,n);if(l.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&s+c.length===r&&u.length<$){this.F(l,u),this.y();return}if(s===r)this.o(u,l),this.h.validate(r);else if(s+l.piece.length>r){const m=[];let I=new o(c.bufferIndex,p,c.end,this.t(c.bufferIndex,p,c.end),this.u(h,c.end)-this.u(h,p));if(this.K()&&this.M(u)&&this.I(l,n)===10){const w={line:I.start.line+1,column:0};I=new o(I.bufferIndex,w,I.end,this.t(I.bufferIndex,w,I.end),I.length-1),u+=`
`}if(this.K()&&this.L(u))if(this.I(l,n-1)===13){const w=this.s(l,n-1);this.C(l,w),u="\r"+u,l.piece.length===0&&m.push(l)}else this.C(l,p);else this.C(l,p);const k=this.w(u);I.length>0&&this.S(l,I);let d=l;for(let y=0;y<k.length;y++)d=this.S(d,k[y]);this.v(m)}else this.q(u,l)}else{const l=this.w(u);let n=this.T(null,l[0]);for(let s=1;s<l.length;s++)n=this.S(n,l[s])}this.y()}delete(r,u){if(this.j.lineNumber=0,this.j.value="",u<=0||this.root===M.$oB)return;const a=this.G(r),l=this.G(r+u),n=a.node,s=l.node;if(n===s){const k=this.s(n,a.remainder),d=this.s(n,l.remainder);if(a.nodeStartOffset===r){if(u===n.piece.length){const y=n.next();(0,M.$tB)(this,n),this.N(y),this.y();return}this.D(n,d),this.h.validate(r),this.N(n),this.y();return}if(a.nodeStartOffset+n.piece.length===r+u){this.C(n,k),this.O(n),this.y();return}this.E(n,k,d),this.y();return}const c=[],h=this.s(n,a.remainder);this.C(n,h),this.h.validate(r),n.piece.length===0&&c.push(n);const p=this.s(s,l.remainder);this.D(s,p),s.piece.length===0&&c.push(s);const m=n.next();for(let k=m;k!==M.$oB&&k!==s;k=k.next())c.push(k);const I=n.piece.length===0?n.prev():n;this.v(c),this.O(I),this.y()}o(r,u){const a=[];if(this.K()&&this.M(r)&&this.L(u)){const s=u.piece,c={line:s.start.line+1,column:0},h=new o(s.bufferIndex,c,s.end,this.t(s.bufferIndex,c,s.end),s.length-1);u.piece=h,r+=`
`,(0,M.$vB)(this,u,-1,-1),u.piece.length===0&&a.push(u)}const l=this.w(r);let n=this.T(u,l[l.length-1]);for(let s=l.length-2;s>=0;s--)n=this.T(n,l[s]);this.N(n),this.v(a)}q(r,u){this.Q(r,u)&&(r+=`
`);const a=this.w(r),l=this.S(u,a[0]);let n=l;for(let s=1;s<a.length;s++)n=this.S(n,a[s]);this.N(l)}s(r,u,a){const l=r.piece,n=r.piece.bufferIndex,s=this.a[n].lineStarts,h=s[l.start.line]+l.start.column+u;let p=l.start.line,m=l.end.line,I=0,k=0,d=0;for(;p<=m&&(I=p+(m-p)/2|0,d=s[I],I!==m);)if(k=s[I+1],h<d)m=I-1;else if(h>=k)p=I+1;else break;return a?(a.line=I,a.column=h-d,null):{line:I,column:h-d}}t(r,u,a){if(a.column===0)return a.line-u.line;const l=this.a[r].lineStarts;if(a.line===l.length-1)return a.line-u.line;const n=l[a.line+1],s=l[a.line]+a.column;if(n>s+1)return a.line-u.line;const c=s-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-u.line+1:a.line-u.line}u(r,u){return this.a[r].lineStarts[u.line]+u.column}v(r){for(let u=0;u<r.length;u++)(0,M.$tB)(this,r[u])}w(r){if(r.length>$){const m=[];for(;r.length>$;){const k=r.charCodeAt($-1);let d;k===13||k>=55296&&k<=56319?(d=r.substring(0,$-1),r=r.substring($-1)):(d=r.substring(0,$),r=r.substring($));const y=A(d);m.push(new o(this.a.length,{line:0,column:0},{line:y.length-1,column:d.length-y[y.length-1]},y.length-1,d.length)),this.a.push(new b(d,y))}const I=A(r);return m.push(new o(this.a.length,{line:0,column:0},{line:I.length-1,column:r.length-I[I.length-1]},I.length-1,r.length)),this.a.push(new b(r,I)),m}let u=this.a[0].buffer.length;const a=A(r,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===u&&u!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<a.length;m++)a[m]+=u+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,u+=1}else{if(u!==0)for(let m=0;m<a.length;m++)a[m]+=u;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const n=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,c=n-this.a[0].lineStarts[s],h={line:s,column:c},p=new o(0,l,h,this.t(0,l,h),n-u);return this.g=h,[p]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,u=0){let a=this.root,l="";const n=this.h.get2(r);if(n){a=n.node;const s=this.B(a,r-n.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(n.nodeStartLineNumber+a.piece.lineFeedCnt===r)l=c.substring(h+s,h+a.piece.length);else{const p=this.B(a,r-n.nodeStartLineNumber);return c.substring(h+s,h+p-u)}}else{let s=0;const c=r;for(;a!==M.$oB;)if(a.left!==M.$oB&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const h=this.B(a,r-a.lf_left-2),p=this.B(a,r-a.lf_left-1),m=this.a[a.piece.bufferIndex].buffer,I=this.u(a.piece.bufferIndex,a.piece.start);return s+=a.size_left,this.h.set({node:a,nodeStartOffset:s,nodeStartLineNumber:c-(r-1-a.lf_left)}),m.substring(I+h,I+p-u)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const h=this.B(a,r-a.lf_left-2),p=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);l=p.substring(m+h,m+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==M.$oB;){const s=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),h=this.u(a.piece.bufferIndex,a.piece.start);return l+=s.substring(h,h+c-u),l}else{const c=this.u(a.piece.bufferIndex,a.piece.start);l+=s.substr(c,a.piece.length)}a=a.next()}return l}y(){let r=this.root,u=1,a=0;for(;r!==M.$oB;)u+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=u,this.c=a,this.h.validate(this.c)}A(r,u){const a=r.piece,l=this.s(r,u),n=l.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===u){const s=this.t(r.piece.bufferIndex,a.start,l);if(s!==n)return{index:s,remainder:0}}return{index:n,remainder:l.column}}B(r,u){if(u<0)return 0;const a=r.piece,l=this.a[a.bufferIndex].lineStarts,n=a.start.line+u+1;return n>a.end.line?l[a.end.line]+a.end.column-l[a.start.line]-a.start.column:l[n]-l[a.start.line]-a.start.column}C(r,u){const a=r.piece,l=a.lineFeedCnt,n=this.u(a.bufferIndex,a.end),s=u,c=this.u(a.bufferIndex,s),h=this.t(a.bufferIndex,a.start,s),p=h-l,m=c-n,I=a.length+m;r.piece=new o(a.bufferIndex,a.start,s,h,I),(0,M.$vB)(this,r,m,p)}D(r,u){const a=r.piece,l=a.lineFeedCnt,n=this.u(a.bufferIndex,a.start),s=u,c=this.t(a.bufferIndex,s,a.end),h=this.u(a.bufferIndex,s),p=c-l,m=n-h,I=a.length+m;r.piece=new o(a.bufferIndex,s,a.end,c,I),(0,M.$vB)(this,r,m,p)}E(r,u,a){const l=r.piece,n=l.start,s=l.end,c=l.length,h=l.lineFeedCnt,p=u,m=this.t(l.bufferIndex,l.start,p),I=this.u(l.bufferIndex,u)-this.u(l.bufferIndex,n);r.piece=new o(l.bufferIndex,l.start,p,m,I),(0,M.$vB)(this,r,I-c,m-h);const k=new o(l.bufferIndex,a,s,this.t(l.bufferIndex,a,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,a)),d=this.S(r,k);this.N(d)}F(r,u){this.Q(u,r)&&(u+=`
`);const a=this.K()&&this.L(u)&&this.M(r),l=this.a[0].buffer.length;this.a[0].buffer+=u;const n=A(u,!1);for(let d=0;d<n.length;d++)n[d]+=l;if(a){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const s=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[s],h={line:s,column:c},p=r.piece.length+u.length,m=r.piece.lineFeedCnt,I=this.t(0,r.piece.start,h),k=I-m;r.piece=new o(r.piece.bufferIndex,r.piece.start,h,I,p),this.g=h,(0,M.$vB)(this,r,u.length,k)}G(r){let u=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let l=0;for(;u!==M.$oB;)if(u.size_left>r)u=u.left;else if(u.size_left+u.piece.length>=r){l+=u.size_left;const n={node:u,remainder:r-u.size_left,nodeStartOffset:l};return this.h.set(n),n}else r-=u.size_left+u.piece.length,l+=u.size_left+u.piece.length,u=u.right;return null}H(r,u){let a=this.root,l=0;for(;a!==M.$oB;)if(a.left!==M.$oB&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const n=this.B(a,r-a.lf_left-2),s=this.B(a,r-a.lf_left-1);return l+=a.size_left,{node:a,remainder:Math.min(n+u-1,s),nodeStartOffset:l}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const n=this.B(a,r-a.lf_left-2);if(n+u-1<=a.piece.length)return{node:a,remainder:n+u-1,nodeStartOffset:l};u-=a.piece.length-n;break}else r-=a.lf_left+a.piece.lineFeedCnt,l+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==M.$oB;){if(a.piece.lineFeedCnt>0){const n=this.B(a,0),s=this.J(a);return{node:a,remainder:Math.min(u-1,n),nodeStartOffset:s}}else if(a.piece.length>=u-1){const n=this.J(a);return{node:a,remainder:u-1,nodeStartOffset:n}}else u-=a.piece.length;a=a.next()}return null}I(r,u){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start)+u;return a.buffer.charCodeAt(l)}J(r){if(!r)return 0;let u=r.size_left;for(;r!==this.root;)r.parent.right===r&&(u+=r.parent.size_left+r.parent.piece.length),r=r.parent;return u}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$oB||r.piece.lineFeedCnt===0)return!1;const u=r.piece,a=this.a[u.bufferIndex].lineStarts,l=u.start.line,n=a[l]+u.start.column;return l===a.length-1||a[l+1]>n+1?!1:this.a[u.bufferIndex].buffer.charCodeAt(n)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$oB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const u=r.prev();this.M(u)&&this.P(u,r)}}O(r){if(this.K()&&this.M(r)){const u=r.next();this.L(u)&&this.P(r,u)}}P(r,u){const a=[],l=this.a[r.piece.bufferIndex].lineStarts;let n;r.piece.end.column===0?n={line:r.piece.end.line-1,column:l[r.piece.end.line]-l[r.piece.end.line-1]-1}:n={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new o(r.piece.bufferIndex,r.piece.start,n,c,s),(0,M.$vB)(this,r,-1,-1),r.piece.length===0&&a.push(r);const h={line:u.piece.start.line+1,column:0},p=u.piece.length-1,m=this.t(u.piece.bufferIndex,h,u.piece.end);u.piece=new o(u.piece.bufferIndex,h,u.piece.end,m,p),(0,M.$vB)(this,u,-1,-1),u.piece.length===0&&a.push(u);const I=this.w(`\r
`);this.S(r,I[0]);for(let k=0;k<a.length;k++)(0,M.$tB)(this,a[k])}Q(r,u){if(this.K()&&this.M(r)){const a=u.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,M.$tB)(this,a);else{const l=a.piece,n={line:l.start.line+1,column:0},s=l.length-1,c=this.t(l.bufferIndex,n,l.end);a.piece=new o(l.bufferIndex,n,l.end,c,s),(0,M.$vB)(this,a,-1,-1)}return!0}}return!1}iterate(r,u){if(r===M.$oB)return u(M.$oB);const a=this.iterate(r.left,u);return a&&u(r)&&this.iterate(r.right,u)}R(r){if(r===M.$oB)return"";const u=this.a[r.piece.bufferIndex],a=r.piece,l=this.u(a.bufferIndex,a.start),n=this.u(a.bufferIndex,a.end);return u.buffer.substring(l,n)}getPieceContent(r){const u=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),l=this.u(r.bufferIndex,r.end);return u.buffer.substring(a,l)}S(r,u){const a=new M.$nB(u,1);if(a.left=M.$oB,a.right=M.$oB,a.parent=M.$oB,a.size_left=0,a.lf_left=0,this.root===M.$oB)this.root=a,a.color=0;else if(r.right===M.$oB)r.right=a,a.parent=r;else{const n=(0,M.$pB)(r.right);n.left=a,a.parent=n}return(0,M.$uB)(this,a),a}T(r,u){const a=new M.$nB(u,1);if(a.left=M.$oB,a.right=M.$oB,a.parent=M.$oB,a.size_left=0,a.lf_left=0,this.root===M.$oB)this.root=a,a.color=0;else if(r.left===M.$oB)r.left=a,a.parent=r;else{const l=(0,M.$qB)(r.left);l.right=a,a.parent=l}return(0,M.$uB)(this,a),a}U(r){let u="";return this.iterate(r,a=>(u+=this.R(a),!0)),u}}e.$HB=t}),define(Ae[131],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67=e.$57=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$57=E;class L{constructor(M){this.identifier=M}}e.$67=L}),define(Ae[132],Re([9,10]),function(ve,e){return ve.create("vs/base/common/actions",e)}),define(Ae[133],Re([1,0,5,6,132]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class M extends L.$Rc{constructor(o,b="",v="",f=!0,t){super(),this.h=this.B(new E.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=b,this.u=v,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,b){this.C&&await this.C(o)}}e.$ui=M;class R extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Nd),this.onWillRun=this.f.event,this.m=this.B(new E.$Nd),this.onDidRun=this.m.event}async run(o,b){if(!o.enabled)return;this.f.fire({action:o});let v;try{await this.u(o,b)}catch(f){v=f}this.m.fire({action:o,error:v})}async u(o,b){await o.run(b)}}e.$vi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let b=[];for(const v of o)v.length&&(b.length?b=[...b,new $,...v]:b=v);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=$;class D{get actions(){return this.a}constructor(o,b,v,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=b,this.class=f,this.a=v}async run(){}}e.$xi=D;class g extends M{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,P.localize(0,null),void 0,!1)}}e.$yi=g;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...o)=>S.run(...o),tooltip:S.label}}e.$zi=A}),define(Ae[134],Re([9,10]),function(ve,e){return ve.create("vs/base/common/date",e)}),define(Ae[135],Re([1,0,134]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const L=60,P=L*60,M=P*24,R=M*7,$=M*30,D=M*365;function g(S,o,b,v){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,E.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!v&&f<30)return(0,E.localize)(1,null);let t;return f<L?(t=f,o?t===1?b?(0,E.localize)(2,null,t):(0,E.localize)(3,null,t):b?(0,E.localize)(4,null,t):(0,E.localize)(5,null,t):t===1?b?(0,E.localize)(6,null,t):(0,E.localize)(7,null,t):b?(0,E.localize)(8,null,t):(0,E.localize)(9,null,t)):f<P?(t=Math.floor(f/L),o?t===1?b?(0,E.localize)(10,null,t):(0,E.localize)(11,null,t):b?(0,E.localize)(12,null,t):(0,E.localize)(13,null,t):t===1?b?(0,E.localize)(14,null,t):(0,E.localize)(15,null,t):b?(0,E.localize)(16,null,t):(0,E.localize)(17,null,t)):f<M?(t=Math.floor(f/P),o?t===1?b?(0,E.localize)(18,null,t):(0,E.localize)(19,null,t):b?(0,E.localize)(20,null,t):(0,E.localize)(21,null,t):t===1?b?(0,E.localize)(22,null,t):(0,E.localize)(23,null,t):b?(0,E.localize)(24,null,t):(0,E.localize)(25,null,t)):f<R?(t=Math.floor(f/M),o?t===1?(0,E.localize)(26,null,t):(0,E.localize)(27,null,t):t===1?(0,E.localize)(28,null,t):(0,E.localize)(29,null,t)):f<$?(t=Math.floor(f/R),o?t===1?b?(0,E.localize)(30,null,t):(0,E.localize)(31,null,t):b?(0,E.localize)(32,null,t):(0,E.localize)(33,null,t):t===1?b?(0,E.localize)(34,null,t):(0,E.localize)(35,null,t):b?(0,E.localize)(36,null,t):(0,E.localize)(37,null,t)):f<D?(t=Math.floor(f/$),o?t===1?b?(0,E.localize)(38,null,t):(0,E.localize)(39,null,t):b?(0,E.localize)(40,null,t):(0,E.localize)(41,null,t):t===1?b?(0,E.localize)(42,null,t):(0,E.localize)(43,null,t):b?(0,E.localize)(44,null,t):(0,E.localize)(45,null,t)):(t=Math.floor(f/D),o?t===1?b?(0,E.localize)(46,null,t):(0,E.localize)(47,null,t):b?(0,E.localize)(48,null,t):(0,E.localize)(49,null,t):t===1?b?(0,E.localize)(50,null,t):(0,E.localize)(51,null,t):b?(0,E.localize)(52,null,t):(0,E.localize)(53,null,t))}e.$dm=g;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=A}),define(Ae[136],Re([9,10]),function(ve,e){return ve.create("vs/base/common/errorMessage",e)}),define(Ae[38],Re([1,0,18,16,136]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function M(S,o){return o&&(S.stack||S.stacktrace)?P.localize(0,null,$(S),R(S.stack)||R(S.stacktrace)):$(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?P.localize(1,null,S.message):S.message||P.localize(2,null)}function D(S=null,o=!1){if(!S)return P.localize(3,null);if(Array.isArray(S)){const b=E.$Gb(S),v=D(b[0],o);return b.length>1?P.localize(4,null,v,b.length):v}if(L.$yf(S))return S;if(S.detail){const b=S.detail;if(b.error)return M(b.error,o);if(b.exception)return M(b.exception,o)}return S.stack?M(S,o):S.message?S.message:P.localize(5,null)}e.$Ai=D;function g(S){const o=S;return o instanceof Error&&Array.isArray(o.actions)}e.$Bi=g;function A(S,o){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=o,b}e.$Ci=A}),define(Ae[137],Re([1,0,43,20]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=void 0;const P=new E.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,d,y=!1){const w=k||"",C=d||"",j=P.value.collator.compare(w,C);return P.value.collatorIsNumeric&&j===0&&w!==C?w<C?-1:1:j}e.$kq=$;function D(k,d){const y=M.value.collator;return k=k||"",d=d||"",a(y,k,d)}e.$lq=D;function g(k,d){const y=M.value.collator;return k=k||"",d=d||"",c(k,d)||a(y,k,d)}e.$mq=g;function A(k,d){const y=M.value.collator;return k=k||"",d=d||"",s(k,d)||a(y,k,d)}e.$nq=A;function S(k,d){return k=k||"",d=d||"",k===d?0:k<d?-1:1}e.$oq=S;function o(k,d){const[y,w]=r(k),[C,j]=r(d);let B=P.value.collator.compare(w,j);if(B===0){if(P.value.collatorIsNumeric&&w!==j)return w<j?-1:1;if(B=P.value.collator.compare(y,C),P.value.collatorIsNumeric&&B===0&&y!==C)return y<C?-1:1}return B}e.$pq=o;function b(k,d){k=k||"",d=d||"";const y=u(k),w=u(d),C=M.value.collator,j=R.value.collator;return a(j,y,w)||a(C,k,d)}e.$qq=b;function v(k,d){k=k||"",d=d||"";const y=u(k),w=u(d),C=M.value.collator,j=R.value.collator;return a(j,y,w)||c(k,d)||a(C,k,d)}e.$rq=v;function f(k,d){k=k||"",d=d||"";const y=u(k),w=u(d),C=M.value.collator,j=R.value.collator;return a(j,y,w)||s(k,d)||a(C,k,d)}e.$sq=f;function t(k,d){k=k||"",d=d||"";const y=u(k).toLowerCase(),w=u(d).toLowerCase();return y!==w?y<w?-1:1:k!==d?k<d?-1:1:0}e.$tq=t;const i=/^(.*?)(\.([^.]*))?$/;function r(k,d=!1){const y=k?i.exec(k):[];let w=[y&&y[1]||"",y&&y[3]||""];return d&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function u(k){const d=k?i.exec(k):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function a(k,d,y){const w=k.compare(d,y);return w!==0?w:d.length!==y.length?d.length<y.length?-1:1:0}function l(k){const d=k.charAt(0);return d.toLocaleUpperCase()!==d}function n(k){const d=k.charAt(0);return d.toLocaleLowerCase()!==d}function s(k,d){return l(k)&&n(d)?-1:n(k)&&l(d)?1:0}function c(k,d){return n(k)&&l(d)?-1:l(k)&&n(d)?1:0}function h(k,d,y=!1){return y||(k=k&&k.toLowerCase(),d=d&&d.toLowerCase()),k===d?0:k<d?-1:1}function p(k,d,y=!1){const w=k.split(L.sep),C=d.split(L.sep),j=w.length-1,B=C.length-1;let W,U;for(let F=0;;F++){if(W=j===F,U=B===F,W&&U)return $(w[F],C[F],y);if(W)return-1;if(U)return 1;const O=h(w[F],C[F],y);if(O!==0)return O}}e.$uq=p;function m(k,d,y){const w=k.toLowerCase(),C=d.toLowerCase(),j=I(k,d,y);if(j)return j;const B=w.endsWith(y),W=C.endsWith(y);if(B!==W)return B?-1:1;const U=$(w,C);return U!==0?U:w.localeCompare(C)}e.$vq=m;function I(k,d,y){const w=k.toLowerCase(),C=d.toLowerCase(),j=w.startsWith(y),B=C.startsWith(y);if(j!==B)return j?-1:1;if(j&&B){if(w.length<C.length)return-1;if(w.length>C.length)return 1}return 0}e.$wq=I}),define(Ae[45],Re([1,0,20,23,13,16]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function R(m){return m===47||m===92}e.$Qf=R;function $(m){return m.replace(/[\\/]/g,E.$fc.sep)}e.$Rf=$;function D(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Sf=D;function g(m,I=E.$fc.sep){if(!m)return"";const k=m.length,d=m.charCodeAt(0);if(R(d)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let w=3;const C=w;for(;w<k&&!R(m.charCodeAt(w));w++);if(C!==w&&!R(m.charCodeAt(w+1))){for(w+=1;w<k;w++)if(R(m.charCodeAt(w)))return m.slice(0,w+1).replace(/[\\/]/g,I)}}return I}else if(i(d)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let y=m.indexOf("://");if(y!==-1){for(y+=3;y<k;y++)if(R(m.charCodeAt(y)))return m.slice(0,y+1)}return""}e.$Tf=g;function A(m){if(!L.$j||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let k=2;const d=k;for(;k<m.length&&(I=m.charCodeAt(k),I!==92);k++);return!(d===k||(I=m.charCodeAt(k+1),isNaN(I)||I===92))}e.$Uf=A;const S=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(m,I=L.$j){const k=I?S:o;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||I&&b.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Vf=v;function f(m,I,k){const d=m===I;return!k||d?d:!m||!I?!1:(0,P.$2e)(m,I)}e.$Wf=f;function t(m,I,k,d=E.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(k){if(!(0,P.$3e)(m,I))return!1;if(I.length===m.length)return!0;let w=I.length;return I.charAt(I.length-1)===d&&w--,m.charAt(w)===d}return I.charAt(I.length-1)!==d&&(I+=d),m.indexOf(I)===0}e.$Xf=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$Yf=i;function r(m,I){return L.$j&&m.endsWith(":")&&(m+=E.sep),(0,E.$hc)(m)||(m=(0,E.$ic)(I,m)),m=(0,E.$gc)(m),L.$j?(m=(0,P.$Ke)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,P.$Ke)(m,E.sep),m||(m=E.sep)),m}e.$Zf=r;function u(m){const I=(0,E.$gc)(m);return L.$j?m.length>3?!1:a(I)&&(m.length===2||I.charCodeAt(2)===92):I===E.$fc.sep}e.$1f=u;function a(m,I=L.$j){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$2f=a;function l(m,I=L.$j){return a(m,I)?m[0]:void 0}e.$3f=l;function n(m,I,k){return I.length>m.length?-1:m===I?0:(k&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$4f=n;function s(m){const I=m.split(":");let k,d,y;for(const w of I){const C=Number(w);(0,M.$Cf)(C)?d===void 0?d=C:y===void 0&&(y=C):k=k?[k,w].join(":"):w}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:d!==void 0?d:void 0,column:y!==void 0?y:d!==void 0?1:void 0}}e.$5f=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(m,I,k=8){let d="";for(let w=0;w<k;w++){let C;w===0&&L.$j&&!I&&(k===3||k===4)?C=h:C=c,d+=C.charAt(Math.floor(Math.random()*C.length))}let y;return I?y=`${I}-${d}`:y=d,m?(0,E.$ic)(m,y):y}e.$6f=p}),define(Ae[68],Re([1,0,20]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const S=(0,E.$nc)(A),o=L[S.toLowerCase()];return o!==void 0?o:R(A)}e.$Tr=M;function R(A){const S=(0,E.$nc)(A);return P[S.toLowerCase()]}e.$Ur=R;function $(A){for(const S in P)if(P[S]===A)return S}e.$Vr=$;const D=/^(.+)\/(.+?)(;.+)?$/;function g(A,S){const o=D.exec(A);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:S?void 0:A}e.$Wr=g}),define(Ae[51],Re([1,0,22,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function P(D){return JSON.stringify(D,R)}e.$kh=P;function M(D){let g=JSON.parse(D);return g=$(g),g}e.$lh=M;function R(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function $(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof E.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let A=0;A<D.length;++A)D[A]=$(D[A],g+1);else for(const A in D)Object.hasOwnProperty.call(D,A)&&(D[A]=$(D[A],g+1))}return D}e.$mh=$}),define(Ae[14],Re([1,0,11,23,2]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$7f="vscode-tkn",e.$8f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${M.vscodeRemoteResource}`}set(A,S,o){this.a[A]=S,this.b[A]=o}setConnectionToken(A,S){this.c[A]=S}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return E.$Z(t),A}const S=A.authority;let o=this.a[S];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const b=this.b[S],v=this.c[S];let f=`path=${encodeURIComponent(A.path)}`;return typeof v=="string"&&(f+=`&${e.$8f}=${encodeURIComponent(v)}`),P.URI.from({scheme:L.$p?this.d:M.vscodeRemoteResource,authority:`${o}:${b}`,path:this.f,query:f})}}e.$9f=new R,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class ${static{this.a=e.$bg}asBrowserUri(A){const S=this.b(A,ve);return this.uriToBrowserUri(S)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.$9f.rewrite(A):A.scheme===M.file&&(L.$n||L.$q&&L.$h.origin===`${M.vscodeFileResource}://${$.a}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const S=this.b(A,ve);return this.uriToFileUri(S)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,S){return P.URI.isUri(A)?A:P.URI.parse(S.toUrl(A))}}e.$cg=new $;var D;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const S="vscode-coi";function o(v){let f;typeof v=="string"?f=new URL(v).searchParams:v instanceof URL?f=v.searchParams:P.URI.isUri(v)&&(f=new URL(v.toString(!0)).searchParams);const t=f?.get(S);if(t)return A.get(t)}g.getHeadersFromQuery=o;function b(v,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(S,i):v[S]=i}g.addSearchParam=b})(D||(e.COI=D={}))}),define(Ae[25],Re([1,0,45,14,20,23,13,2]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(b){return(0,$.$vc)(b,!0)}e.$jg=D;class g{constructor(v){this.a=v}compare(v,f,t=!1){return v===f?0:(0,R.$Ue)(this.getComparisonKey(v,t),this.getComparisonKey(f,t))}isEqual(v,f,t=!1){return v===f?!0:!v||!f?!1:this.getComparisonKey(v,t)===this.getComparisonKey(f,t)}getComparisonKey(v,f=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,f,t=!1){if(v.scheme===f.scheme){if(v.scheme===L.Schemas.file)return E.$Xf(D(v),D(f),this.a(v))&&v.query===f.query&&(t||v.fragment===f.fragment);if((0,e.$Ag)(v.authority,f.authority))return E.$Xf(v.path,f.path,this.a(v),"/")&&v.query===f.query&&(t||v.fragment===f.fragment)}return!1}joinPath(v,...f){return $.URI.joinPath(v,...f)}basenameOrAuthority(v){return(0,e.$sg)(v)||v.authority}basename(v){return P.$fc.basename(v.path)}extname(v){return P.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let f;return v.scheme===L.Schemas.file?f=$.URI.file(P.$lc(D(v))).path:(f=P.$fc.dirname(v.path),v.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),f="/")),v.with({path:f})}normalizePath(v){if(!v.path.length)return v;let f;return v.scheme===L.Schemas.file?f=$.URI.file(P.$gc(D(v))).path:f=P.$fc.normalize(v.path),v.with({path:f})}relativePath(v,f){if(v.scheme!==f.scheme||!(0,e.$Ag)(v.authority,f.authority))return;if(v.scheme===L.Schemas.file){const r=P.$kc(D(v),D(f));return M.$j?E.$Rf(r):r}let t=v.path||"/";const i=f.path||"/";if(this.a(v)){let r=0;for(const u=Math.min(t.length,i.length);r<u&&!(t.charCodeAt(r)!==i.charCodeAt(r)&&t.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);t=i.substr(0,r)+t.substr(r)}return P.$fc.relative(t,i)}resolvePath(v,f){if(v.scheme===L.Schemas.file){const t=$.URI.file(P.$jc(D(v),f));return v.with({authority:t.authority,path:t.path})}return f=E.$Sf(f),v.with({path:P.$fc.resolve(v.path,f)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,f){return v===f||v!==void 0&&f!==void 0&&(0,R.$2e)(v,f)}hasTrailingPathSeparator(v,f=P.sep){if(v.scheme===L.Schemas.file){const t=D(v);return t.length>E.$Tf(t).length&&t[t.length-1]===f}else{const t=v.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,f=P.sep){return(0,e.$Bg)(v,f)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,f=P.sep){let t=!1;if(v.scheme===L.Schemas.file){const i=D(v);t=i!==void 0&&i.length===E.$Tf(i).length&&i[i.length-1]===f}else{f="/";const i=v.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)(v,f)?v.with({path:v.path+"/"}):v}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(b=>b.scheme===L.Schemas.file?!M.$l:!0),e.$ng=new g(b=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function A(b,v){const f=[];for(let t=0;t<b.length;t++){const i=v(b[t]);b.some((r,u)=>u===t?!1:(0,e.$pg)(i,v(r)))||f.push(b[t])}return f}e.$Eg=A;var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function v(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,l]=u.split(":");a&&l&&t.set(a,l)});const r=f.path.substring(0,f.path.indexOf(";"));return r&&t.set(b.META_DATA_MIME,r),t}b.parseMetaData=v})(S||(e.DataUri=S={}));function o(b,v,f){if(v){let t=b.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),b.with({scheme:f,authority:v,path:t})}return b.with({scheme:f})}e.$Fg=o}),define(Ae[12],Re([1,0,19,11,5,6,25,23,123]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(Y){return!!Y&&typeof Y.then=="function"}e.$Gg=g;function A(Y){const _=new E.$Xd,pe=Y(_.token),$e=new Promise((de,De)=>{const re=_.token.onCancellationRequested(()=>{re.dispose(),_.dispose(),De(new L.$4)});Promise.resolve(pe).then(he=>{re.dispose(),_.dispose(),de(he)},he=>{re.dispose(),_.dispose(),De(he)})});return new class{cancel(){_.cancel()}then(de,De){return $e.then(de,De)}catch(de){return this.then(void 0,de)}finally(de){return $e.finally(de)}}}e.$Hg=A;function S(Y,_,pe){return new Promise(($e,de)=>{const De=_.onCancellationRequested(()=>{De.dispose(),$e(pe)});Y.then($e,de).finally(()=>De.dispose())})}e.$Ig=S;function o(Y,_){return new Promise((pe,$e)=>{const de=_.onCancellationRequested(()=>{de.dispose(),$e(new L.$4)});Y.then(pe,$e).finally(()=>de.dispose())})}e.$Jg=o;async function b(Y){let _=-1;const pe=Y.map(($e,de)=>$e.then(De=>(_=de,De)));try{return await Promise.race(pe)}finally{Y.forEach(($e,de)=>{de!==_&&$e.cancel()})}}e.$Kg=b;function v(Y,_,pe){let $e;const de=setTimeout(()=>{$e?.(void 0),pe?.()},_);return Promise.race([Y.finally(()=>clearTimeout(de)),new Promise(De=>$e=De)])}e.$Lg=v;function f(Y){return new Promise((_,pe)=>{const $e=Y();g($e)?$e.then(_,pe):_($e)})}e.$Mg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(_){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=_,!this.b){const pe=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(pe,pe).then($e)})}return new Promise((pe,$e)=>{this.b.then(pe,$e)})}return this.a=_(),new Promise((pe,$e)=>{this.a.then(de=>{this.a=null,pe(de)},de=>{this.a=null,$e(de)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.$Og=i;class r{constructor(){this.a=new Map}queue(_,pe){const de=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(_)===de&&this.a.delete(_)});return this.a.set(_,de),de}}e.$Pg=r;const u=(Y,_)=>{let pe=!0;const $e=setTimeout(()=>{pe=!1,_()},Y);return{isTriggered:()=>pe,dispose:()=>{clearTimeout($e),pe=!1}}},a=Y=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,Y())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};class l{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,pe=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise((de,De)=>{this.d=de,this.f=De}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=pe===D.$Kd?a($e):u(pe,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=l;class n{constructor(_){this.a=new l(_),this.b=new t}trigger(_,pe){return this.a.trigger(()=>this.b.queue(_),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=n;class s{constructor(){this.a=!1,this.b=new Promise((_,pe)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=s;class c extends s{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.$Tg=c;function h(Y,_){return _?new Promise((pe,$e)=>{const de=setTimeout(()=>{De.dispose(),pe()},Y),De=_.onCancellationRequested(()=>{clearTimeout(de),De.dispose(),$e(new L.$4)})}):A(pe=>h(Y,pe))}e.$Ug=h;function p(Y,_=0,pe){const $e=setTimeout(()=>{Y(),pe&&de.dispose()},_),de=(0,M.$Pc)(()=>{clearTimeout($e),pe?.deleteAndLeak(de)});return pe?.add(de),de}e.$Vg=p;function m(Y){const _=[];let pe=0;const $e=Y.length;function de(){return pe<$e?Y[pe++]():null}function De(re){re!=null&&_.push(re);const he=de();return he?he.then(De):Promise.resolve(_)}return Promise.resolve(null).then(De)}e.$Wg=m;function I(Y,_=$e=>!!$e,pe=null){let $e=0;const de=Y.length,De=()=>{if($e>=de)return Promise.resolve(pe);const re=Y[$e++];return Promise.resolve(re()).then(ne=>_(ne)?Promise.resolve(ne):De())};return De()}e.$Xg=I;function k(Y,_=$e=>!!$e,pe=null){if(Y.length===0)return Promise.resolve(pe);let $e=Y.length;const de=()=>{$e=-1;for(const De of Y)De.cancel?.()};return new Promise((De,re)=>{for(const he of Y)he.then(ne=>{--$e>=0&&_(ne)?(de(),De(ne)):$e===0&&De(pe)}).catch(ne=>{--$e>=0&&(de(),re(ne))})})}e.$Yg=k;class d{constructor(_){this.a=0,this.d=_,this.f=[],this.b=0,this.g=new P.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(_){return this.a++,new Promise((pe,$e)=>{this.f.push({factory:_,c:pe,e:$e}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const _=this.f.shift();this.b++;const pe=_.factory();pe.then(_.c,_.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=d;class y extends d{constructor(){super(1)}}e.$1g=y;class w{constructor(){this.a=new Ee,this.b=0}queue(_){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,_())):this.a.run(this.b++,_())}}e.$2g=w;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const _=new le;return this.b.add(_),_.p}g(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueFor(_,pe=R.$lg){const $e=pe.getComparisonKey(_);let de=this.a.get($e);if(!de){de=new y;const De=this.f++,re=P.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(De,re),this.a.set($e,de)}return de}h(){this.g()&&this.j()}j(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=C;class j{constructor(_,pe){this.a=-1,typeof _=="function"&&typeof pe=="number"&&this.setIfNotSet(_,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},pe)}setIfNotSet(_,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},pe))}}e.$4g=j;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(_,pe){this.cancel(),this.a=setInterval(()=>{_()},pe)}}e.$5g=B;class W{constructor(_,pe){this.b=-1,this.a=_,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=W;class U{constructor(_,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=_,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=U;class F extends W{constructor(_,pe){super(_,pe),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.$8g=F;class O extends M.$Rc{constructor(_,pe){super(),this.g=_,this.h=pe,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const pe of _)this.a.push(pe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=Y=>{(0,$.$B)(()=>{if(_)return;const pe=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$0g=(Y,_)=>{const pe=requestIdleCallback(Y,typeof _=="number"?{timeout:_}:void 0);let $e=!1;return{dispose(){$e||($e=!0,cancelIdleCallback(pe))}}}}();class ee{constructor(_){this.d=!1,this.a=()=>{try{this.f=_()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ee;async function X(Y,_,pe){let $e;for(let de=0;de<pe;de++)try{return await Y()}catch(De){$e=De,await h(_)}throw $e}e.$_g=X;class Ee{isRunning(_){return typeof _=="number"?this.a?.taskId===_:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(_,pe,$e){return this.a={taskId:_,cancel:()=>$e?.(),promise:pe},pe.then(()=>this.d(_),()=>this.d(_)),pe}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}queue(_){if(this.b)this.b.run=_;else{let pe,$e;const de=new Promise((De,re)=>{pe=De,$e=re});this.b={run:_,promise:de,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Ee;class ke{constructor(_,pe=()=>Date.now()){this.d=_,this.f=pe,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.$bh=ke;var Pe;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(Pe||(Pe={}));class le{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((_,pe)=>{this.a=_,this.b=pe})}complete(_){return new Promise(pe=>{this.a(_),this.d={outcome:0,value:_},pe()})}error(_){return new Promise(pe=>{this.b(_),this.d={outcome:1,value:_},pe()})}cancel(){return this.error(new L.$4)}}e.$ch=le;var be;(function(Y){async function _($e){let de;const De=await Promise.all($e.map(re=>re.then(he=>he,he=>{de||(de=he)})));if(typeof de<"u")throw de;return De}Y.settled=_;function pe($e){return new Promise(async(de,De)=>{try{await $e(de,De)}catch(re){De(re)}})}Y.withAsyncBody=pe})(be||(e.Promises=be={}));var ue;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(ue||(ue={}));class oe{static fromArray(_){return new oe(pe=>{pe.emitMany(_)})}static fromPromise(_){return new oe(async pe=>{pe.emitMany(await _)})}static fromPromises(_){return new oe(async pe=>{await Promise.all(_.map(async $e=>pe.emitOne(await $e)))})}static merge(_){return new oe(async pe=>{await Promise.all(_.map(async $e=>{for await(const de of $e)pe.emitOne(de)}))})}static{this.EMPTY=oe.fromArray([])}constructor(_){this.a=0,this.b=[],this.d=null,this.f=new P.$Nd,queueMicrotask(async()=>{const pe={emitOne:$e=>this.g($e),emitMany:$e=>this.h($e),reject:$e=>this.k($e)};try{await Promise.resolve(_(pe)),this.j()}catch($e){this.k($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(_,pe){return new oe(async $e=>{for await(const de of _)$e.emitOne(pe(de))})}map(_){return oe.map(this,_)}static filter(_,pe){return new oe(async $e=>{for await(const de of _)pe(de)&&$e.emitOne(de)})}filter(_){return oe.filter(this,_)}static coalesce(_){return oe.filter(_,pe=>!!pe)}coalesce(){return oe.coalesce(this)}static async toPromise(_){const pe=[];for await(const $e of _)pe.push($e);return pe}toPromise(){return oe.toPromise(this)}g(_){this.a===0&&(this.b.push(_),this.f.fire())}h(_){this.a===0&&(this.b=this.b.concat(_),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(_){this.a===0&&(this.a=2,this.d=_,this.f.fire())}}e.$dh=oe;class ye extends oe{constructor(_,pe){super(pe),this.l=_}cancel(){this.l.cancel()}}e.$eh=ye;function te(Y){const _=new E.$Xd,pe=Y(_.token);return new ye(_,async $e=>{const de=_.token.onCancellationRequested(()=>{de.dispose(),_.dispose(),$e.reject(new L.$4)});try{for await(const De of pe){if(_.token.isCancellationRequested)return;$e.emitOne(De)}de.dispose(),_.dispose()}catch(De){de.dispose(),_.dispose(),$e.reject(De)}})}e.$fh=te;class V{constructor(){this.a=new le,this.b=new oe($e=>{if(_){$e.reject(_);return}return pe&&$e.emitMany(pe),this.d=de=>$e.reject(de),this.f=de=>$e.emitOne(de),this.a.p});let _,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{_||(_=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(_){this.d(_),this.a.complete()}emitOne(_){this.f(_)}}e.$gh=V}),define(Ae[39],Re([1,0,18,12,45,28,20,23,13]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function g(){return Object.create(null)}e.$rj=g,e.$sj="**",e.$tj="/";const A="[/\\\\]",S="[^/\\\\]",o=/\//g;function b(Ee,ke){switch(Ee){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${ke?`|${A}${S}+`:""})*?`}}function v(Ee,ke){if(!Ee)return[];const Pe=[];let le=!1,be=!1,ue="";for(const oe of Ee){switch(oe){case ke:if(!le&&!be){Pe.push(ue),ue="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":be=!0;break;case"]":be=!1;break}ue+=oe}return ue&&Pe.push(ue),Pe}e.$uj=v;function f(Ee){if(!Ee)return"";let ke="";const Pe=v(Ee,e.$tj);if(Pe.every(le=>le===e.$sj))ke=".*";else{let le=!1;Pe.forEach((be,ue)=>{if(be===e.$sj){if(le)return;ke+=b(2,ue===Pe.length-1)}else{let oe=!1,ye="",te=!1,V="";for(const Y of be){if(Y!=="}"&&oe){ye+=Y;continue}if(te&&(Y!=="]"||!V)){let _;Y==="-"?_=Y:(Y==="^"||Y==="!")&&!V?_="^":Y===e.$tj?_="":_=(0,D.$Fe)(Y),V+=_;continue}switch(Y){case"{":oe=!0;continue;case"[":te=!0;continue;case"}":{const pe=`(?:${v(ye,",").map($e=>f($e)).join("|")})`;ke+=pe,oe=!1,ye="";break}case"]":{ke+="["+V+"]",te=!1,V="";break}case"?":ke+=S;continue;case"*":ke+=b(1);continue;default:ke+=(0,D.$Fe)(Y)}}ue<Pe.length-1&&(Pe[ue+1]!==e.$sj||ue+2<Pe.length)&&(ke+=A)}le=be===e.$sj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$Cc(1e4),s=function(){return!1},c=function(){return null};function h(Ee,ke){if(!Ee)return c;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const le=`${Pe}_${!!ke.trimForExclusions}`;let be=n.get(le);if(be)return p(be,Ee);let ue;return t.test(Pe)?be=I(Pe.substr(4),Pe):(ue=i.exec(m(Pe,ke)))?be=k(ue[1],Pe):(ke.trimForExclusions?u:r).test(Pe)?be=d(Pe,ke):(ue=a.exec(m(Pe,ke)))?be=y(ue[1].substr(1),Pe,!0):(ue=l.exec(m(Pe,ke)))?be=y(ue[1],Pe,!1):be=w(Pe),n.set(le,be),p(be,Ee)}function p(Ee,ke){if(typeof ke=="string")return Ee;const Pe=function(le,be){return(0,P.$Xf)(le,ke.base,!$.$l)?Ee((0,D.$Je)(le.substr(ke.base.length),R.sep),be):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function m(Ee,ke){return ke.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,ke){return function(Pe,le){return typeof Pe=="string"&&Pe.endsWith(Ee)?ke:null}}function k(Ee,ke){const Pe=`/${Ee}`,le=`\\${Ee}`,be=function(oe,ye){return typeof oe!="string"?null:ye?ye===Ee?ke:null:oe===Ee||oe.endsWith(Pe)||oe.endsWith(le)?ke:null},ue=[Ee];return be.basenames=ue,be.patterns=[ke],be.allBasenames=ue,be}function d(Ee,ke){const Pe=ee(Ee.slice(1,-1).split(",").map(ye=>h(ye,ke)).filter(ye=>ye!==c),Ee),le=Pe.length;if(!le)return c;if(le===1)return Pe[0];const be=function(ye,te){for(let V=0,Y=Pe.length;V<Y;V++)if(Pe[V](ye,te))return Ee;return null},ue=Pe.find(ye=>!!ye.allBasenames);ue&&(be.allBasenames=ue.allBasenames);const oe=Pe.reduce((ye,te)=>te.allPaths?ye.concat(te.allPaths):ye,[]);return oe.length&&(be.allPaths=oe),be}function y(Ee,ke,Pe){const le=R.sep===R.$fc.sep,be=le?Ee:Ee.replace(o,R.sep),ue=R.sep+be,oe=R.$fc.sep+Ee;let ye;return Pe?ye=function(te,V){return typeof te=="string"&&(te===be||te.endsWith(ue)||!le&&(te===Ee||te.endsWith(oe)))?ke:null}:ye=function(te,V){return typeof te=="string"&&(te===be||!le&&te===Ee)?ke:null},ye.allPaths=[(Pe?"*/":"./")+Ee],ye}function w(Ee){try{const ke=new RegExp(`^${f(Ee)}$`);return function(Pe){return ke.lastIndex=0,typeof Pe=="string"&&ke.test(Pe)?Ee:null}}catch{return c}}function C(Ee,ke,Pe){return!Ee||typeof ke!="string"?!1:j(Ee)(ke,void 0,Pe)}e.$vj=C;function j(Ee,ke={}){if(!Ee)return s;if(typeof Ee=="string"||B(Ee)){const Pe=h(Ee,ke);if(Pe===c)return s;const le=function(be,ue){return!!Pe(be,ue)};return Pe.allBasenames&&(le.allBasenames=Pe.allBasenames),Pe.allPaths&&(le.allPaths=Pe.allPaths),le}return F(Ee,ke)}e.$wj=j;function B(Ee){const ke=Ee;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$xj=B;function W(Ee){return Ee.allBasenames||[]}e.$yj=W;function U(Ee){return Ee.allPaths||[]}e.$zj=U;function F(Ee,ke){const Pe=ee(Object.getOwnPropertyNames(Ee).map(ye=>O(ye,Ee[ye],ke)).filter(ye=>ye!==c)),le=Pe.length;if(!le)return c;if(!Pe.some(ye=>!!ye.requiresSiblings)){if(le===1)return Pe[0];const ye=function(Y,_){let pe;for(let $e=0,de=Pe.length;$e<de;$e++){const De=Pe[$e](Y,_);if(typeof De=="string")return De;(0,L.$Gg)(De)&&(pe||(pe=[]),pe.push(De))}return pe?(async()=>{for(const $e of pe){const de=await $e;if(typeof de=="string")return de}return null})():null},te=Pe.find(Y=>!!Y.allBasenames);te&&(ye.allBasenames=te.allBasenames);const V=Pe.reduce((Y,_)=>_.allPaths?Y.concat(_.allPaths):Y,[]);return V.length&&(ye.allPaths=V),ye}const be=function(ye,te,V){let Y,_;for(let pe=0,$e=Pe.length;pe<$e;pe++){const de=Pe[pe];de.requiresSiblings&&V&&(te||(te=(0,R.$mc)(ye)),Y||(Y=te.substr(0,te.length-(0,R.$nc)(ye).length)));const De=de(ye,te,Y,V);if(typeof De=="string")return De;(0,L.$Gg)(De)&&(_||(_=[]),_.push(De))}return _?(async()=>{for(const pe of _){const $e=await pe;if(typeof $e=="string")return $e}return null})():null},ue=Pe.find(ye=>!!ye.allBasenames);ue&&(be.allBasenames=ue.allBasenames);const oe=Pe.reduce((ye,te)=>te.allPaths?ye.concat(te.allPaths):ye,[]);return oe.length&&(be.allPaths=oe),be}function O(Ee,ke,Pe){if(ke===!1)return c;const le=h(Ee,Pe);if(le===c)return c;if(typeof ke=="boolean")return le;if(ke){const be=ke.when;if(typeof be=="string"){const ue=(oe,ye,te,V)=>{if(!V||!le(oe,ye))return null;const Y=be.replace("$(basename)",()=>te),_=V(Y);return(0,L.$Gg)(_)?_.then(pe=>pe?Ee:null):_?Ee:null};return ue.requiresSiblings=!0,ue}}return le}function ee(Ee,ke){const Pe=Ee.filter(ye=>!!ye.basenames);if(Pe.length<2)return Ee;const le=Pe.reduce((ye,te)=>{const V=te.basenames;return V?ye.concat(V):ye},[]);let be;if(ke){be=[];for(let ye=0,te=le.length;ye<te;ye++)be.push(ke)}else be=Pe.reduce((ye,te)=>{const V=te.patterns;return V?ye.concat(V):ye},[]);const ue=function(ye,te){if(typeof ye!="string")return null;if(!te){let Y;for(Y=ye.length;Y>0;Y--){const _=ye.charCodeAt(Y-1);if(_===47||_===92)break}te=ye.substr(Y)}const V=le.indexOf(te);return V!==-1?be[V]:null};ue.basenames=le,ue.patterns=be,ue.allBasenames=le;const oe=Ee.filter(ye=>!ye.basenames);return oe.push(ue),oe}function X(Ee,ke){return(0,E.$tb)(Ee,ke,(Pe,le)=>typeof Pe=="string"&&typeof le=="string"?Pe===le:typeof Pe!="string"&&typeof le!="string"?Pe.base===le.base&&Pe.pattern===le.pattern:!1)}e.$Aj=X}),define(Ae[52],Re([1,0,11,124,25,13,2]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class D{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,E.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=o(this.supportThemeIcons?(0,L.$Wj)(i):i).replace(/([ \t]+)/g,(u,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(i,r,u){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(i,r){const u=new RegExp((0,M.$Fe)(r),"g");return i.replace(u,(a,l)=>i.charAt(l-1)!=="\\"?`\\${a}`:a)}}e.$3j=D;function g(t){return A(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$4j=g;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$5j=A;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$og)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$6j=S;function o(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=o;function b(t){return t.replace(/"/g,"&quot;")}e.$8j=b;function v(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=v;function f(t){const i=[],r=t.split("|").map(a=>a.trim());t=r[0];const u=r[1];if(u){const a=/height=(\d+)/.exec(u),l=/width=(\d+)/.exec(u),n=a?a[1]:"",s=l?l[1]:"",c=isFinite(parseInt(s)),h=isFinite(parseInt(n));c&&i.push(`width="${s}"`),h&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$0j=f}),define(Ae[93],Re([1,0,18,45,20,23,25,13]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=void 0;function D(h,p){const{os:m,tildify:I,relative:k}=p;if(k){const w=g(h,k,m);if(typeof w=="string")return w}let d=h.fsPath;if(m===1&&!M.$j?d=d.replace(/\//g,"\\"):m!==1&&M.$j&&(d=d.replace(/\\/g,"/")),m!==1&&I?.userHome){const w=I.userHome.fsPath;let C;h.scheme!==I.userHome.scheme&&h.path.startsWith(P.$fc.sep)?C=I.userHome.with({path:h.path}).fsPath:C=h.fsPath,d=o(C,w,m)}return(m===1?P.$ec:P.$fc).normalize(A(d,m===1))}e.$uv=D;function g(h,p,m){const I=m===1?P.$ec:P.$fc,k=m===3?R.$lg:R.$ng,d=p.getWorkspace(),y=(0,E.$Nb)(d.folders);if(!y)return;h.scheme!==y.uri.scheme&&h.path.startsWith(P.$fc.sep)&&(h=y.uri.with({path:h.path}));const w=p.getWorkspaceFolder(h);if(!w)return;let C;if(k.isEqual(w.uri,h)?C="":C=k.relativePath(w.uri,h)??"",C&&(C=I.normalize(C)),d.folders.length>1&&!p.noPrefix){const j=w.name?w.name:k.basenameOrAuthority(w.uri);C=C?`${j} \u2022 ${C}`:j}return C}function A(h,p=M.$j){return(0,L.$2f)(h,p)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$vv=A;let S=Object.create(null);function o(h,p,m=M.OS){if(m===1||!h||!p)return h;let I=S.original===p?S.normalized:void 0;I||(I=p,M.$j&&(I=(0,L.$Rf)(I)),I=`${(0,$.$Ke)(I,P.$fc.sep)}${P.$fc.sep}`,S={original:p,normalized:I});let k=h;return M.$j&&(k=(0,L.$Rf)(k)),(m===3?k.startsWith(I):(0,$.$3e)(k,I))?`~/${k.substr(I.length)}`:h}e.$wv=o;function b(h,p){return h.replace(/^~($|\/|\\)/,`${p}$1`)}e.$xv=b;const v="\u2026",f="\\\\",t="~";function i(h,p=P.sep){const m=new Array(h.length);let I=!1;for(let k=0;k<h.length;k++){const d=h[k];if(d===""){m[k]=`.${p}`;continue}if(!d){m[k]=d;continue}I=!0;let y="",w=d;w.indexOf(f)===0?(y=w.substr(0,w.indexOf(f)+f.length),w=w.substr(w.indexOf(f)+f.length)):w.indexOf(p)===0?(y=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(t)===0&&(y=w.substr(0,w.indexOf(t)+t.length),w=w.substr(w.indexOf(t)+t.length));const C=w.split(p);for(let j=1;I&&j<=C.length;j++)for(let B=C.length-j;I&&B>=0;B--){I=!1;let W=C.slice(B,B+j).join(p);for(let U=0;!I&&U<h.length;U++)if(U!==k&&h[U]&&h[U].indexOf(W)>-1){const F=B+j===C.length,O=B>0&&h[U].indexOf(p)>-1?p+W:W,ee=h[U].endsWith(O);I=!F||ee}if(!I){let U="";(C[0].endsWith(":")||y!=="")&&(B===1&&(B=0,j++,W=C[0]+p+W),B>0&&(U=C[0]+p),U=y+U),B>0&&(U=U+v+p),U=U+W,B+j<C.length&&(U=U+p+v),m[k]=U}}I&&(m[k]=d)}return m}e.$yv=i;var r;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function u(h,p=Object.create(null)){const m=[];let I=!1,k="";for(const d of h)if(d==="$"||I&&d==="{")k&&m.push({value:k,type:r.TEXT}),k="",I=!0;else if(d==="}"&&I){const y=p[k];if(typeof y=="string")y.length&&m.push({value:y,type:r.VARIABLE});else if(y){const w=m[m.length-1];(!w||w.type!==r.SEPARATOR)&&m.push({value:y.label,type:r.SEPARATOR})}k="",I=!1}else k+=d;return k&&!I&&m.push({value:k,type:r.TEXT}),m.filter((d,y)=>{if(d.type===r.SEPARATOR){const w=m[y-1],C=m[y+1];return[w,C].every(j=>j&&(j.type===r.VARIABLE||j.type===r.TEXT)&&j.value.length>0)}return!0}).map(d=>d.value).join("")}e.$zv=u;function a(h,p){return M.$k||p?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):h.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Av=a;function l(h,p){return M.$k||p?h.replace(/\(&&\w\)|&&/g,""):M.$j?h.replace(/&&|&/g,m=>m==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$Bv=l;function n(h){return h.replace(/&/g,"&&")}e.$Cv=n;function s(h){if(h.endsWith("]")){const p=h.lastIndexOf(" [",h.length-2);if(p!==-1){const m=c(h.substring(0,p));return{name:m.name,parentPath:m.parentPath+h.substring(p)}}}return c(h)}e.$Dv=s;function c(h){const p=h.indexOf("/")!==-1?P.$fc:P.$ec,m=p.basename(h),I=p.dirname(h);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[138],Re([1,0,22,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function P(S){return S.toJSON()}class M{constructor(o){this.a=o}transformIncoming(o){const b=this.a.transformIncoming(o);return b===o?o:P(L.URI.from(b))}transformOutgoing(o){const b=this.a.transformOutgoing(o);return b===o?o:P(L.URI.from(b))}transformOutgoingURI(o){const b=this.a.transformOutgoing(o);return b===o?o:L.URI.from(b)}transformOutgoingScheme(o){return this.a.transformOutgoingScheme(o)}}e.$Lm=M,e.$Mm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,o,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return o.transformOutgoing(S);for(const v in S)if(Object.hasOwnProperty.call(S,v)){const f=R(S[v],o,b+1);f!==null&&(S[v]=f)}}return null}function $(S,o){const b=R(S,o,0);return b===null?S:b}e.$Nm=$;function D(S,o,b,v){if(!S||v>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?L.URI.revive(o.transformIncoming(S)):o.transformIncoming(S);if(S instanceof E.$be)return null;for(const f in S)if(Object.hasOwnProperty.call(S,f)){const t=D(S[f],o,b,v+1);t!==null&&(S[f]=t)}}return null}function g(S,o){const b=D(S,o,!1,0);return b===null?S:b}e.$Om=g;function A(S,o){const b=D(S,o,!0,0);return b===null?S:b}e.$Pm=A}),define(Ae[139],Re([1,0,13,23,22]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function D(){return $||($=new TextDecoder("UTF-16BE")),$}let g;function A(){return g||(g=L.$D()?R():D()),g}e.$Os=A;function S(v,f,t){const i=new Uint16Array(v.buffer,f,t);return t>0&&(i[0]===65279||i[0]===65534)?o(v,f,t):R().decode(i)}e.$Ps=S;function o(v,f,t){const i=[];let r=0;for(let u=0;u<t;u++){const a=P.$de(v,f);f+=2,i[r++]=String.fromCharCode(a)}return i.join("")}class b{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return A().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const t=this.a-this.d;t<=1&&(t===0||E.$6e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const t=f.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=f;return}for(let i=0;i<t;i++)this.b[this.d++]=f.charCodeAt(i)}}e.$Qs=b}),define(Ae[140],Re([1,0,22,139]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;function P(D){return D.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,S,o){this.oldPosition=g,this.oldText=A,this.newPosition=S,this.newText=o}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,S){const o=A.length;E.$ge(g,o,S),S+=4;for(let b=0;b<o;b++)E.$ee(g,A.charCodeAt(b),S),S+=2;return S}static d(g,A){const S=E.$fe(g,A);return A+=4,(0,L.$Ps)(g,A,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(g,A){return E.$ge(g,this.oldPosition,A),A+=4,E.$ge(g,this.newPosition,A),A+=4,A=M.c(g,this.oldText,A),A=M.c(g,this.newText,A),A}static read(g,A,S){const o=E.$fe(g,A);A+=4;const b=E.$fe(g,A);A+=4;const v=M.d(g,A);A+=M.a(v);const f=M.d(g,A);return A+=M.a(f),S.push(new M(o,v,b,f)),A}}e.$Rs=M;function R(D,g){return D===null||D.length===0?g:new $(D,g).compress()}e.$Ss=R;class ${constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,S=this.n(g),o=this.l(A);for(;g<this.f||A<this.h;){if(S===null){this.k(o),o=this.l(++A);continue}if(o===null){this.m(S),S=this.n(++g);continue}if(o.oldEnd<=S.newPosition){this.k(o),o=this.l(++A);continue}if(S.newEnd<=o.oldPosition){this.m(S),S=this.n(++g);continue}if(o.oldPosition<S.newPosition){const[i,r]=$.r(o,S.newPosition-o.oldPosition);this.k(i),o=r;continue}if(S.newPosition<o.oldPosition){const[i,r]=$.q(S,o.oldPosition-S.newPosition);this.m(i),S=r;continue}let f,t;if(o.oldEnd===S.newEnd)f=S,t=o,S=this.n(++g),o=this.l(++A);else if(o.oldEnd<S.newEnd){const[i,r]=$.q(S,o.oldLength);f=i,t=o,S=r,o=this.l(++A)}else{const[i,r]=$.r(o,S.newLength);f=S,t=i,S=this.n(++g),o=r}this.d[this.e++]=new M(f.oldPosition,f.oldText,t.newPosition,t.newText),this.g+=f.newLength-f.oldLength,this.j+=t.newLength-t.oldLength}const b=$.s(this.d);return $.t(b)}k(g){this.d[this.e++]=$.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=$.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new M(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new M(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const S=g.newText.substr(0,A),o=g.newText.substr(A);return[new M(g.oldPosition,g.oldText,g.newPosition,S),new M(g.oldEnd,"",g.newPosition+A,o)]}static r(g,A){const S=g.oldText.substr(0,A),o=g.oldText.substr(A);return[new M(g.oldPosition,S,g.newPosition,g.newText),new M(g.oldPosition+A,o,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let S=0,o=g[0];for(let b=1;b<g.length;b++){const v=g[b];o.oldEnd===v.oldPosition?o=new M(o.oldPosition,o.oldText+v.oldText,o.newPosition,o.newText+v.newText):(A[S++]=o,o=v)}return A[S++]=o,A}static t(g){if(g.length===0)return g;const A=[];let S=0;for(let o=0;o<g.length;o++){const b=g[o];b.oldText!==b.newText&&(A[S++]=b)}return A}}}),define(Ae[141],Re([1,0,39,20]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=void 0;function P(M,R,$,D,g,A){if(Array.isArray(M)){let S=0;for(const o of M){const b=P(o,R,$,D,g,A);if(b===10)return b;b>S&&(S=b)}return S}else{if(typeof M=="string")return D?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:o,scheme:b,hasAccessToAllModels:v,notebookType:f}=M;if(!D&&!v)return 0;f&&g&&(R=g);let t=0;if(b)if(b===R.scheme)t=10;else if(b==="*")t=5;else return 0;if(S)if(S===$)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(f)if(f===A)t=10;else if(f==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(o){let i;if(typeof o=="string"?i=o:i={...o,base:(0,L.$gc)(o.base)},i===R.fsPath||(0,E.$vj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$xE=P}),define(Ae[142],Re([1,0,5,13,29,91,90,126,140,6]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IB=void 0;class A extends g.$Rc{constructor(o,b,v,f,t,i,r){super(),this.m=this.B(new E.$Nd),this.onDidChangeContent=this.m.event,this.f=b,this.j=!i,this.g=f,this.h=t,this.c=new R.$HB(o,v,r)}equals(o){return!(o instanceof A)||this.f!==o.f||this.getEOL()!==o.getEOL()?!1:this.c.equal(o.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(o){return this.c.createSnapshot(o?this.f:"")}getOffsetAt(o,b){return this.c.getOffsetAt(o,b)}getPositionAt(o){return this.c.getPositionAt(o)}getRangeAt(o,b){const v=o+b,f=this.getPositionAt(o),t=this.getPositionAt(v);return new P.$ws(f.lineNumber,f.column,t.lineNumber,t.column)}getValueInRange(o,b=0){if(o.isEmpty())return"";const v=this.n(b);return this.c.getValueInRange(o,v)}getValueLengthInRange(o,b=0){if(o.isEmpty())return 0;if(o.startLineNumber===o.endLineNumber)return o.endColumn-o.startColumn;const v=this.getOffsetAt(o.startLineNumber,o.startColumn),f=this.getOffsetAt(o.endLineNumber,o.endColumn);let t=0;const i=this.n(b),r=this.getEOL();if(i.length!==r.length){const u=i.length-r.length,a=o.endLineNumber-o.startLineNumber;t=u*a}return f-v+t}getCharacterCountInRange(o,b=0){if(this.j){let v=0;const f=o.startLineNumber,t=o.endLineNumber;for(let i=f;i<=t;i++){const r=this.getLineContent(i),u=i===f?o.startColumn-1:0,a=i===t?o.endColumn-1:r.length;for(let l=u;l<a;l++)L.$6e(r.charCodeAt(l))?(v=v+1,l=l+1):v=v+1}return v+=this.n(b).length*(t-f),v}return this.getValueLengthInRange(o,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(o){return this.c.getLineContent(o)}getLineCharCode(o,b){return this.c.getLineCharCode(o,b)}getCharCode(o){return this.c.getCharCode(o)}getLineLength(o){return this.c.getLineLength(o)}getLineMinColumn(o){return 1}getLineMaxColumn(o){return this.getLineLength(o)+1}getLineFirstNonWhitespaceColumn(o){const b=L.$Qe(this.getLineContent(o));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(o){const b=L.$Se(this.getLineContent(o));return b===-1?0:b+2}n(o){switch(o){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(o){this.c.setEOL(o)}applyEdits(o,b,v){let f=this.g,t=this.h,i=this.j,r=!0,u=[];for(let p=0;p<o.length;p++){const m=o[p];r&&m._isTracked&&(r=!1);const I=m.range;if(m.text){let C=!0;i||(C=!L.$ef(m.text),i=C),!f&&C&&(f=L.$df(m.text)),!t&&C&&(t=L.$gf(m.text))}let k="",d=0,y=0,w=0;if(m.text){let C;[d,y,w,C]=(0,$.$9s)(m.text);const j=this.getEOL();C===0||C===(j===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,j)}u[p]={sortIndex:p,identifier:m.identifier||null,range:I,rangeOffset:this.getOffsetAt(I.startLineNumber,I.startColumn),rangeLength:this.getValueLengthInRange(I),text:k,eolCount:d,firstLineLength:y,lastLineLength:w,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}u.sort(A.u);let a=!1;for(let p=0,m=u.length-1;p<m;p++){const I=u[p].range.getEndPosition(),k=u[p+1].range.getStartPosition();if(k.isBeforeOrEqual(I)){if(k.isBefore(I))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(u=this.s(u));const l=v||b?A._getInverseEditRanges(u):[],n=[];if(b)for(let p=0;p<u.length;p++){const m=u[p],I=l[p];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=I.startLineNumber;k<=I.endLineNumber;k++){let d="";k===I.startLineNumber&&(d=this.getLineContent(m.range.startLineNumber),L.$Qe(d)!==-1)||n.push({lineNumber:k,oldContent:d})}}let s=null;if(v){let p=0;s=[];for(let m=0;m<u.length;m++){const I=u[m],k=l[m],d=this.getValueInRange(I.range),y=I.rangeOffset+p;p+=I.text.length-d.length,s[m]={sortIndex:I.sortIndex,identifier:I.identifier,range:k,text:d,textChange:new D.$Rs(I.rangeOffset,d,y,I.text)}}a||s.sort((m,I)=>m.sortIndex-I.sortIndex)}this.g=f,this.h=t,this.j=i;const c=this.t(u);let h=null;if(b&&n.length>0){n.sort((p,m)=>m.lineNumber-p.lineNumber),h=[];for(let p=0,m=n.length;p<m;p++){const I=n[p].lineNumber;if(p>0&&n[p-1].lineNumber===I)continue;const k=n[p].oldContent,d=this.getLineContent(I);d.length===0||d===k||L.$Qe(d)!==-1||h.push(I)}}return this.m.fire(),new M.$Ru(s,c,h)}s(o){return o.length<1e3?o:[this._toSingleEditOperation(o)]}_toSingleEditOperation(o){let b=!1;const v=o[0].range,f=o[o.length-1].range,t=new P.$ws(v.startLineNumber,v.startColumn,f.endLineNumber,f.endColumn);let i=v.startLineNumber,r=v.startColumn;const u=[];for(let c=0,h=o.length;c<h;c++){const p=o[c],m=p.range;b=b||p.forceMoveMarkers,u.push(this.getValueInRange(new P.$ws(i,r,m.startLineNumber,m.startColumn))),p.text.length>0&&u.push(p.text),i=m.endLineNumber,r=m.endColumn}const a=u.join(""),[l,n,s]=(0,$.$9s)(a);return{sortIndex:0,identifier:o[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:a,eolCount:l,firstLineLength:n,lastLineLength:s,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(o){o.sort(A.w);const b=[];for(let v=0;v<o.length;v++){const f=o[v],t=f.range.startLineNumber,i=f.range.startColumn,r=f.range.endLineNumber,u=f.range.endColumn;if(t===r&&i===u&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const a=new P.$ws(t,i,r,u);b.push({range:a,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return b}findMatchesLineByLine(o,b,v,f){return this.c.findMatchesLineByLine(o,b,v,f)}getPieceTree(){return this.c}static _getInverseEditRange(o,b){const v=o.startLineNumber,f=o.startColumn,[t,i,r]=(0,$.$9s)(b);let u;if(b.length>0){const a=t+1;a===1?u=new P.$ws(v,f,v,f+i):u=new P.$ws(v,f,v+a-1,r+1)}else u=new P.$ws(v,f,v,f);return u}static _getInverseEditRanges(o){const b=[];let v=0,f=0,t=null;for(let i=0,r=o.length;i<r;i++){const u=o[i];let a,l;t?t.range.endLineNumber===u.range.startLineNumber?(a=v,l=f+(u.range.startColumn-t.range.endColumn)):(a=v+(u.range.startLineNumber-t.range.endLineNumber),l=u.range.startColumn):(a=u.range.startLineNumber,l=u.range.startColumn);let n;if(u.text.length>0){const s=u.eolCount+1;s===1?n=new P.$ws(a,l,a,l+u.firstLineLength):n=new P.$ws(a,l,a+s-1,u.lastLineLength+1)}else n=new P.$ws(a,l,a,l);v=n.endLineNumber,f=n.endColumn,b.push(n),t=u}return b}static u(o,b){const v=P.$ws.compareRangesUsingEnds(o.range,b.range);return v===0?o.sortIndex-b.sortIndex:v}static w(o,b){const v=P.$ws.compareRangesUsingEnds(o.range,b.range);return v===0?b.sortIndex-o.sortIndex:-v}}e.$IB=A}),define(Ae[143],Re([1,0,13,90,142]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=void 0;class M{constructor(D,g,A,S,o,b,v,f,t){this.a=D,this.b=g,this.c=A,this.d=S,this.e=o,this.f=b,this.g=v,this.h=f,this.j=t}k(D){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?D===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(D){const g=this.k(D),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let o=0,b=A.length;o<b;o++){const v=A[o].buffer.replace(/\r\n|\r|\n/g,g),f=(0,L.$DB)(v);A[o]=new L.$GB(v,f)}const S=new P.$IB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(D){return this.a[0].buffer.substr(0,D).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(D){if(D.length===0)return;this.a.length===0&&E.$mf(D)&&(this.b=E.$lf,D=D.substr(1));const g=D.charCodeAt(D.length-1);g===13||g>=55296&&g<=56319?(this.m(D.substr(0,D.length-1),!1),this.c=!0,this.d=g):(this.m(D,!1),this.c=!1,this.d=g)}m(D,g){!g&&D.length===0||(this.c?this.n(String.fromCharCode(this.d)+D):this.n(D))}n(D){const g=(0,L.$EB)(this.e,D);this.a.push(new L.$GB(D,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=E.$df(D)),this.k||(this.k=E.$gf(D)))}finish(D=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,D)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const D=this.a[this.a.length-1];D.buffer+=String.fromCharCode(this.d);const g=(0,L.$DB)(D.buffer);D.lineStarts=g,this.d===13&&this.f++}}}e.$JB=R}),define(Ae[94],Re([1,0,22,23]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$=e.$b$=void 0;var P;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(P||(P={}));function M(S){for(let o=0,b=S.length;o<b;o+=4){const v=S[o+0],f=S[o+1],t=S[o+2],i=S[o+3];S[o+0]=i,S[o+1]=t,S[o+2]=f,S[o+3]=v}}function R(S){const o=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return L.$D()||M(o),E.$be.wrap(o)}function $(S){const o=S.buffer;if(L.$D()||M(o),o.byteOffset%4===0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const b=new Uint8Array(o.byteLength);return b.set(o),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function D(S){const o=new Uint32Array(g(S));let b=0;if(o[b++]=S.id,S.type==="full")o[b++]=1,o[b++]=S.data.length,o.set(S.data,b),b+=S.data.length;else{o[b++]=2,o[b++]=S.deltas.length;for(const v of S.deltas)o[b++]=v.start,o[b++]=v.deleteCount,v.data?(o[b++]=v.data.length,o.set(v.data,b),b+=v.data.length):o[b++]=0}return R(o)}e.$b$=D;function g(S){let o=0;if(o+=1+1,S.type==="full")o+=1+S.data.length;else{o+=1,o+=(1+1+1)*S.deltas.length;for(const b of S.deltas)b.data&&(o+=b.data.length)}return o}function A(S){const o=$(S);let b=0;const v=o[b++];if(o[b++]===1){const r=o[b++],u=o.subarray(b,b+r);return b+=r,{id:v,type:"full",data:u}}const t=o[b++],i=[];for(let r=0;r<t;r++){const u=o[b++],a=o[b++],l=o[b++];let n;l>0&&(n=o.subarray(b,b+l),b+=l),i[r]={start:u,deleteCount:a,data:n}}return{id:v,type:"delta",deltas:i}}e.$c$=A}),define(Ae[144],Re([9,10]),function(ve,e){return ve.create("vs/editor/common/config/editorOptions",e)}),define(Ae[145],Re([1,0,18,26,23,127,146,144]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(Q,we,Be,Oe){this.id=Q,this.name=we,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,we){return b(Q,we)}compute(Q,we,Be){return Be}}class o{constructor(Q,we){this.newValue=Q,this.didChange=we}}e.ApplyUpdateResult=o;function b(Z,Q){if(typeof Z!="object"||typeof Q!="object"||!Z||!Q)return new o(Q,Z!==Q);if(Array.isArray(Z)||Array.isArray(Q)){const Be=Array.isArray(Z)&&Array.isArray(Q)&&E.$tb(Z,Q);return new o(Q,!Be)}let we=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const Oe=b(Z[Be],Q[Be]);Oe.didChange&&(Z[Be]=Oe.newValue,we=!0)}return new o(Z,we)}class v{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,we){return b(Q,we)}validate(Q){return this.defaultValue}}class f{constructor(Q,we,Be,Oe){this.id=Q,this.name=we,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,we){return b(Q,we)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,we,Be){return Be}}function t(Z,Q){return typeof Z>"u"?Q:Z==="false"?!1:!!Z}e.boolean=t;class i extends f{constructor(Q,we,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(Q,we,Be,Oe)}validate(Q){return t(Q,this.defaultValue)}}function r(Z,Q,we,Be){if(typeof Z>"u")return Q;let Oe=parseInt(Z,10);return isNaN(Oe)?Q:(Oe=Math.max(we,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=r;class u extends f{static clampedInt(Q,we,Be,Oe){return r(Q,we,Be,Oe)}constructor(Q,we,Be,Oe,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Oe,nt.maximum=Xe),super(Q,we,Be,nt),this.minimum=Oe,this.maximum=Xe}validate(Q){return u.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function a(Z,Q,we,Be){if(typeof Z>"u")return Q;const Oe=l.float(Z,Q);return l.clamp(Oe,we,Be)}e.clampedFloat=a;class l extends f{static clamp(Q,we,Be){return Q<we?we:Q>Be?Be:Q}static float(Q,we){if(typeof Q=="number")return Q;if(typeof Q>"u")return we;const Be=parseFloat(Q);return isNaN(Be)?we:Be}constructor(Q,we,Be,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,we,Be,Xe),this.validationFn=Oe}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class n extends f{static string(Q,we){return typeof Q!="string"?we:Q}constructor(Q,we,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(Q,we,Be,Oe)}validate(Q){return n.string(Q,this.defaultValue)}}function s(Z,Q,we,Be){return typeof Z!="string"?Q:Be&&Z in Be?Be[Z]:we.indexOf(Z)===-1?Q:Z}e.stringSet=s;class c extends f{constructor(Q,we,Be,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Be),super(Q,we,Be,Xe),this.c=Oe}validate(Q){return s(Q,this.defaultValue,this.c)}}class h extends S{constructor(Q,we,Be,Oe,Xe,nt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Xe,$t.default=Oe),super(Q,we,Be,$t),this.c=Xe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function p(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,we,Be){return Be===0?Q.accessibilitySupport:Be}}class I extends S{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertSpace:t(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function d(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function w(Z){switch(Z){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function C(Z){switch(Z){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class j extends v{constructor(){super(141)}compute(Q,we,Be){const Oe=["monaco-editor"];return we.get(39)&&Oe.push(we.get(39)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),we.get(73)==="default"?Oe.push("mouse-default"):we.get(73)==="copy"&&Oe.push("mouse-copy"),we.get(111)&&Oe.push("showUnused"),we.get(139)&&Oe.push("showDeprecated"),Oe.join(" ")}}class B extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Q,we,Be){return Be&&Q.emptySelectionClipboard}}class W extends S{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:$.localize(16,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:$.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{cursorMoveOnType:t(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(we.loop,this.defaultValue.loop)}}}class U extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?U.OFF:Q==="true"?U.ON:Q:Q?U.ON:U.OFF}}e.EditorFontLigatures=U;class F extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.TRANSLATE:Q:Q?F.TRANSLATE:F.OFF}compute(Q,we,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class O extends v{constructor(){super(50)}compute(Q,we,Be){return Q.fontInfo}}class ee extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Q){const we=l.float(Q,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(we,6,100)}compute(Q,we,Be){return Q.fontInfo.fontSize}}class X extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(u.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class Ee extends S{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{multiple:s(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??s(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??s(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??s(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??s(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??s(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends S{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:$.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),delay:u.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:t(we.sticky,this.defaultValue.sticky),hidingDelay:u.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(we.above,this.defaultValue.above)}}}var Pe;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class le extends v{constructor(){super(144)}compute(Q,we,Be){return le.computeLayout(we,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const we=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,we-1));const Xe=(Be+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:nt}}static c(Q,we){const Be=Q.outerWidth,Oe=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=we.stableMinimapLayoutInput,$t=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,bt=Q.lineHeight,Pt=Q.typicalHalfwidthCharacterWidth,Kt=Q.scrollBeyondLastLine,Ht=Q.minimap.renderCharacters;let vt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ut=Q.minimap.maxColumn,Nt=Q.minimap.size,Gt=Q.minimap.side,jt=Q.verticalScrollbarWidth,kt=Q.viewLineCount,Ft=Q.remainingWidth,Bt=Q.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Xe*Oe);const Vt=Wt/Xe;let Ot=!1,at=!1,dt=Jt*vt,At=vt/Xe,qt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:me,minimapLineCount:H}=le.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:bt,pixelRatio:Xe});if(kt/H>1)Ot=!0,at=!0,vt=1,dt=1,At=vt/Xe;else{let Ue=!1,Je=vt+1;if(Nt==="fit"){const qe=Math.ceil((Ie+kt+Le)*dt);Bt&&$t&&Ft<=we.stableFitRemainingWidth?(Ue=!0,Je=we.stableFitMaxMinimapScale):Ue=qe>Wt}if(Nt==="fill"||Ue){Ot=!0;const qe=vt;dt=Math.min(bt*Xe,Math.max(1,Math.floor(1/me))),Bt&&$t&&Ft<=we.stableFitRemainingWidth&&(Je=we.stableFitMaxMinimapScale),vt=Math.min(Je,Math.max(1,Math.floor(dt/Jt))),vt>qe&&(qt=Math.min(2,vt/qe)),At=vt/Xe/qt,Wt=Math.ceil(Math.max(Qt,Ie+kt+Le)*dt),Bt?(we.stableMinimapLayoutInput=Q,we.stableFitRemainingWidth=Ft,we.stableFitMaxMinimapScale=vt):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*At),ot=Math.min(Rt,Math.max(0,Math.floor((Ft-jt-2)*At/(Pt+At)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Xe*ot);const Tt=wt/Xe;wt=Math.floor(wt*qt);const Ct=Ht?1:2,We=Gt==="left"?0:Be-ot-jt;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:ot,minimapHeightIsEditorHeight:Ot,minimapIsSampling:at,minimapScale:vt,minimapLineHeight:dt,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Vt}}static computeLayout(Q,we){const Be=we.outerWidth|0,Oe=we.outerHeight|0,Xe=we.lineHeight|0,nt=we.lineNumbersDigitCount|0,$t=we.typicalHalfwidthCharacterWidth,bt=we.maxDigitWidth,Pt=we.pixelRatio,Kt=we.viewLineCount,Ht=Q.get(136),vt=Ht==="inherit"?Q.get(135):Ht,Ut=vt==="inherit"?Q.get(131):vt,Nt=Q.get(134),Gt=we.isDominatedByLongLines,jt=Q.get(57),kt=Q.get(67).renderType!==0,Ft=Q.get(68),Bt=Q.get(105),Jt=Q.get(84),Wt=Q.get(72),Vt=Q.get(103),Ot=Vt.verticalScrollbarSize,at=Vt.verticalHasArrows,dt=Vt.arrowSize,At=Vt.horizontalScrollbarSize,qt=Q.get(43),Rt=Q.get(110)!=="never";let ot=Q.get(65);qt&&Rt&&(ot+=16);let wt=0;if(kt){const Et=Math.max(nt,Ft);wt=Math.round(Et*bt)}let Tt=0;jt&&(Tt=Xe*we.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Tt,Qt=We+wt,Ie=Qt+ot;const Le=Be-Tt-wt-ot;let me=!1,H=!1,Me=-1;vt==="inherit"&&Gt?(me=!0,H=!0):Ut==="on"||Ut==="bounded"?H=!0:Ut==="wordWrapColumn"&&(Me=Nt);const Ue=le.c({outerWidth:Be,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Ot,viewLineCount:Kt,remainingWidth:Le,isViewportWrapping:H},we.memory||new A);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(Ct+=Ue.minimapWidth,We+=Ue.minimapWidth,Qt+=Ue.minimapWidth,Ie+=Ue.minimapWidth);const Je=Le-Ue.minimapWidth,qe=Math.max(1,Math.floor((Je-Ot-2)/$t)),et=at?dt:0;return H&&(Me=Math.max(1,qe),Ut==="bounded"&&(Me=Math.min(Me,Nt))),{width:Be,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:wt,decorationsLeft:Qt,decorationsWidth:ot,contentLeft:Ie,contentWidth:Je,minimap:Ue,viewportColumn:qe,isWordWrapMinified:me,isViewportWrapping:H,wrappingColumn:Me,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:At,overviewRuler:{top:et,width:Ot,height:Oe-2*et,right:0}}}}e.EditorLayoutInfoComputer=le;class be extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,we,Be){return we.get(2)===2?"advanced":Be}}class ue extends S{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:$.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class oe extends S{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:$.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),maxLineCount:u.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends S{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:$.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:s(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:u.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(we.fontFamily,this.defaultValue.fontFamily),padding:t(we.padding,this.defaultValue.padding)}}}class te extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):u.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,we,Be){return Be<0?u.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class V extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:$.localize(63,null)})}compute(Q,we,Be){return Q.fontInfo.lineHeight}}class Y extends S{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Q.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:$.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),autohide:t(we.autohide,this.defaultValue.autohide),size:s(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(we.side,this.defaultValue.side,["right","left"]),showSlider:s(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(we.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(we.scale,1,1,3),maxColumn:u.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function _(Z){return Z==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class pe extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{top:u.clampedInt(we.top,0,0,1e3),bottom:u.clampedInt(we.bottom,0,0,1e3)}}}class $e extends S{constructor(){const Q={enabled:!0,cycle:!0};super(86,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:$.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),cycle:t(we.cycle,this.defaultValue.cycle)}}}class de extends v{constructor(){super(142)}compute(Q,we,Be){return Q.pixelRatio}}class De extends S{constructor(){const Q={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(89,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:Q.strings,description:$.localize(82,null)},comments:{anyOf:we,default:Q.comments,description:$.localize(83,null)},other:{anyOf:we,default:Q.other,description:$.localize(84,null)}},default:Q,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Pt=Q?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:we,comments:Be,strings:Oe}=Q,Xe=["on","inline","off"];let nt,$t,bt;return typeof we=="boolean"?nt=we?"on":"off":nt=s(we,this.defaultValue.other,Xe),typeof Be=="boolean"?$t=Be?"on":"off":$t=s(Be,this.defaultValue.comments,Xe),typeof Oe=="boolean"?bt=Oe?"on":"off":bt=s(Oe,this.defaultValue.strings,Xe),{other:nt,comments:$t,strings:bt}}}var re;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Q){let we=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(we=4,Be=Q):Q==="interval"?we=3:Q==="relative"?we=2:Q==="on"?we=1:we=0),{renderType:we,renderFn:Be}}}function ne(Z){const Q=Z.get(98);return Q==="editable"?Z.get(91):Q!=="on"}e.filterValidationDecorations=ne;class ae extends S{constructor(){const Q=[],we={type:"number",description:$.localize(91,null)};super(102,"rulers",Q,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Q,description:$.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const we=[];for(const Be of Q)if(typeof Be=="number")we.push({column:u.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;we.push({column:u.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return we.sort((Be,Oe)=>Be.column-Oe.column),we}return this.defaultValue}}class ge extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ce(Z,Q){if(typeof Z!="string")return Q;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends S{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q,Be=u.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=u.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(we.vertical,this.defaultValue.vertical),horizontal:Ce(we.horizontal,this.defaultValue.horizontal),useShadows:t(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:u.clampedInt(we.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:u.clampedInt(we.verticalSliderSize,Oe,0,1e3),scrollByPage:t(we.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(we.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends S{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Q,we){let Be=!1;we.allowedCharacters&&Q&&(L.$$m(Q.allowedCharacters,we.allowedCharacters)||(Q={...Q,allowedCharacters:we.allowedCharacters},Be=!0)),we.allowedLocales&&Q&&(L.$$m(Q.allowedLocales,we.allowedLocales)||(Q={...Q,allowedLocales:we.allowedLocales},Be=!0));const Oe=super.applyUpdate(Q,we);return Be?new o(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{nonBasicASCII:x(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,we){if(typeof Q!="object"||!Q)return we;const Be={};for(const[Oe,Xe]of Object.entries(Q))Xe===!0&&(Be[Oe]=!0);return Be}}class G extends S{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:$.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),mode:s(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(we.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends S{constructor(){const Q={enabled:M.$6r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$6r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends S{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:Q.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:Q.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:Q.highlightActiveIndentation,description:$.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{bracketPairs:x(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Z,Q,we){const Be=we.indexOf(Z);return Be===-1?Q:we[Be]}class ce extends S{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:Q.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:Q.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertMode:s(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(we.showIcons,this.defaultValue.showIcons),showStatusBar:t(we.showStatusBar,this.defaultValue.showStatusBar),preview:t(we.preview,this.defaultValue.preview),previewMode:s(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(we.showMethods,this.defaultValue.showMethods),showFunctions:t(we.showFunctions,this.defaultValue.showFunctions),showConstructors:t(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(we.showFields,this.defaultValue.showFields),showVariables:t(we.showVariables,this.defaultValue.showVariables),showClasses:t(we.showClasses,this.defaultValue.showClasses),showStructs:t(we.showStructs,this.defaultValue.showStructs),showInterfaces:t(we.showInterfaces,this.defaultValue.showInterfaces),showModules:t(we.showModules,this.defaultValue.showModules),showProperties:t(we.showProperties,this.defaultValue.showProperties),showEvents:t(we.showEvents,this.defaultValue.showEvents),showOperators:t(we.showOperators,this.defaultValue.showOperators),showUnits:t(we.showUnits,this.defaultValue.showUnits),showValues:t(we.showValues,this.defaultValue.showValues),showConstants:t(we.showConstants,this.defaultValue.showConstants),showEnums:t(we.showEnums,this.defaultValue.showEnums),showEnumMembers:t(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(we.showKeywords,this.defaultValue.showKeywords),showWords:t(we.showWords,this.defaultValue.showWords),showColors:t(we.showColors,this.defaultValue.showColors),showFiles:t(we.showFiles,this.defaultValue.showFiles),showReferences:t(we.showReferences,this.defaultValue.showReferences),showFolders:t(we.showFolders,this.defaultValue.showFolders),showTypeParameters:t(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(we.showSnippets,this.defaultValue.showSnippets),showUsers:t(we.showUsers,this.defaultValue.showUsers),showIssues:t(we.showIssues,this.defaultValue.showIssues)}}}class Ne extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,we,Be){return we.get(2)===2?0:Be}}class Ge extends v{constructor(){super(145)}compute(Q,we,Be){const Oe=we.get(144);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class _e extends S{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),showDropSelector:s(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends S{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),showPasteSelector:s(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?it:P.$l?tt:xe,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var ut;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSeparators=130]="wordSeparators",Z[Z.wordWrap=131]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=134]="wordWrapColumn",Z[Z.wordWrapOverride1=135]="wordWrapOverride1",Z[Z.wordWrapOverride2=136]="wordWrapOverride2",Z[Z.wrappingIndent=137]="wrappingIndent",Z[Z.wrappingStrategy=138]="wrappingStrategy",Z[Z.showDeprecated=139]="showDeprecated",Z[Z.inlayHints=140]="inlayHints",Z[Z.editorClassName=141]="editorClassName",Z[Z.pixelRatio=142]="pixelRatio",Z[Z.tabFocusMode=143]="tabFocusMode",Z[Z.layoutInfo=144]="layoutInfo",Z[Z.wrappingInfo=145]="wrappingInfo",Z[Z.defaultColorDecorators=146]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(ut||(e.EditorOption=ut={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:ze(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new u(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",$.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:ze(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:ze(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:ze(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:ze(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:ze(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new K),stickyTabStops:ze(new i(116,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:ze(new u(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:ze(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:ze(new u(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:ze(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:ze(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:ze(new h(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(243,null)})),cursorSurroundingLines:ze(new u(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:ze(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:ze(new u(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:ze(new B),dropIntoEditor:ze(new _e),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:$.localize(254,null)})),find:ze(new W),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:ze(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:ze(new u(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:ze(new O),fontLigatures2:ze(new U),fontSize:ze(new ee),fontWeight:ze(new X),fontVariations:ze(new F),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:ze(new ke),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>l.clamp(Z,-5,20),{description:$.localize(268,null)})),lightbulb:ze(new ue),lineDecorationsWidth:ze(new te),lineHeight:ze(new V),lineNumbers:ze(new he),lineNumbersMinChars:ze(new u(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:ze(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:ze(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:ze(new Y),mouseStyle:ze(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:ze(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],_,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:ze(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:ze(new u(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:ze(new i(81,"occurrencesHighlight",!0,{description:$.localize(282,null)})),multiDocumentOccurrencesHighlight:ze(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:$.localize(283,null)})),overviewRulerBorder:ze(new i(82,"overviewRulerBorder",!0,{description:$.localize(284,null)})),overviewRulerLanes:ze(new u(83,"overviewRulerLanes",3,0,3)),padding:ze(new pe),pasteAs:ze(new Ye),parameterHints:ze(new $e),peekWidgetDefaultFocus:ze(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(285,null),$.localize(286,null)],description:$.localize(287,null)})),definitionLinkOpensInPeek:ze(new i(88,"definitionLinkOpensInPeek",!1,{description:$.localize(288,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new u(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(289,null)})),readOnly:ze(new i(91,"readOnly",!1)),readOnlyMessage:ze(new ge),renameOnType:ze(new i(93,"renameOnType",!1,{description:$.localize(290,null),markdownDeprecationMessage:$.localize(291,null)})),renderControlCharacters:ze(new i(94,"renderControlCharacters",!0,{description:$.localize(292,null),restricted:!0})),renderFinalNewline:ze(new c(95,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:$.localize(293,null)})),renderLineHighlight:ze(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(294,null)],description:$.localize(295,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(296,null)})),renderValidationDecorations:ze(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(297,null),$.localize(298,null),$.localize(299,null),""],description:$.localize(300,null)})),revealHorizontalRightPadding:ze(new u(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(101,"roundedSelection",!0,{description:$.localize(301,null)})),rulers:ze(new ae),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new u(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(302,null)})),scrollBeyondLastLine:ze(new i(105,"scrollBeyondLastLine",!0,{description:$.localize(303,null)})),scrollPredominantAxis:ze(new i(106,"scrollPredominantAxis",!0,{description:$.localize(304,null)})),selectionClipboard:ze(new i(107,"selectionClipboard",!0,{description:$.localize(305,null),included:P.$l})),selectionHighlight:ze(new i(108,"selectionHighlight",!0,{description:$.localize(306,null)})),selectOnLineNumbers:ze(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:ze(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(307,null),$.localize(308,null),$.localize(309,null)],description:$.localize(310,null)})),showUnused:ze(new i(111,"showUnused",!0,{description:$.localize(311,null)})),showDeprecated:ze(new i(139,"showDeprecated",!0,{description:$.localize(312,null)})),inlayHints:ze(new ye),snippetSuggestions:ze(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(313,null),$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(114,"smoothScrolling",!1,{description:$.localize(318,null)})),stopRenderingLineAfter:ze(new u(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(319,null)})),suggestFontSize:ze(new u(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new u(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(121,"suggestOnTriggerCharacters",!0,{description:$.localize(322,null)})),suggestSelection:ze(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(323,null),$.localize(324,null),$.localize(325,null)],description:$.localize(326,null)})),tabCompletion:ze(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),tabIndex:ze(new u(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new q),unusualLineTerminators:ze(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(331,null),$.localize(332,null),$.localize(333,null)],description:$.localize(334,null)})),useShadowDOM:ze(new i(127,"useShadowDOM",!0)),useTabStops:ze(new i(128,"useTabStops",!0,{description:$.localize(335,null)})),wordBreak:ze(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(336,null),$.localize(337,null)],description:$.localize(338,null)})),wordSeparators:ze(new n(130,"wordSeparators",R.$7r,{description:$.localize(339,null)})),wordWrap:ze(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(340,null),$.localize(341,null),$.localize(342,null),$.localize(343,null)],description:$.localize(344,null)})),wordWrapBreakAfterCharacters:ze(new n(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new u(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(345,null)})),wordWrapOverride1:ze(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new j),defaultColorDecorators:ze(new i(146,"defaultColorDecorators",!1,{markdownDescription:$.localize(346,null)})),pixelRatio:ze(new de),tabFocusMode:ze(new i(143,"tabFocusMode",!1,{markdownDescription:$.localize(347,null)})),layoutInfo:ze(new le),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new be)}}),define(Ae[147],Re([9,10]),function(ve,e){return ve.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[148],Re([9,10]),function(ve,e){return ve.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[149],Re([9,10]),function(ve,e){return ve.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[150],Re([9,10]),function(ve,e){return ve.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[151],Re([9,10]),function(ve,e){return ve.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[152],Re([9,10]),function(ve,e){return ve.create("vs/platform/files/common/files",e)}),define(Ae[153],Re([9,10]),function(ve,e){return ve.create("vs/platform/markers/common/markers",e)}),define(Ae[154],Re([9,10]),function(ve,e){return ve.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[155],Re([9,10]),function(ve,e){return ve.create("vs/platform/workspace/common/workspace",e)}),define(Ae[156],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[157],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[158],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[159],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[160],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[161],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[162],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[163],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[164],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[165],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[166],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[167],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[168],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[169],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[170],Re([9,10]),function(ve,e){return ve.create("vs/workbench/common/editor",e)}),define(Ae[171],Re([9,10]),function(ve,e){return ve.create("vs/workbench/common/views",e)}),define(Ae[172],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[173],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[174],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[175],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[176],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[177],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[178],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[179],Re([1,0,11,149]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var P;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,L.localize)(3,null),$=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,o=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:o};this.g.push({offset:S,lexeme:o,additionalInfo:A}),this.f.push(b)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),o=D.b.get(S);o?this.k(o):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,o=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const v=this.c.charCodeAt(A);if(S)S=!1;else if(v===47&&!o){A++;break}else v===91?o=!0:v===92?S=!0:v===93&&(o=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=D}),define(Ae[180],Re([1,0,25,30,151,292]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Oo=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(R);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Po=g;function A(i){if(!i)return null;const r=i.majorBase,u=i.majorMustEqual,a=i.minorBase;let l=i.minorMustEqual;const n=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(r===0||(l=!1),s=!1);let c=0;if(i.preRelease){const h=$.exec(i.preRelease);if(h){const[,p,m,I]=h;c=Date.UTC(Number(p),Number(m)-1,Number(I))}}return{majorBase:r,majorMustEqual:u,minorBase:a,minorMustEqual:l,patchBase:n,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$Qo=A;function S(i,r,u){let a;typeof i=="string"?a=A(g(i)):a=i;let l;r instanceof Date?l=r.getTime():typeof r=="string"&&(l=new Date(r).getTime());let n;if(typeof u=="string"?n=A(g(u)):n=u,!a||!n)return!1;const s=a.majorBase,c=a.minorBase,h=a.patchBase;let p=n.majorBase,m=n.minorBase,I=n.patchBase;const k=n.notBefore;let d=n.majorMustEqual,y=n.minorMustEqual,w=n.patchMustEqual;return n.isMinimum?s>p?!0:s<p?!1:c>m?!0:c<m||l&&l<k?!1:h>=I:(s===1&&p===0&&(!d||!y||!w)&&(p=1,m=0,I=0,d=!0,y=!1,w=!1),s<p?!1:s>p?!d:c<m?!1:c>m?!y:h<I?!1:h>I?!w:!(l&&l<k))}e.$Ro=S;function o(i,r,u,a,l){const n=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return n.push([L.default.Error,P.localize(0,null)]),n;if(typeof a.name!="string")return n.push([L.default.Error,P.localize(1,null,"name")]),n;if(typeof a.version!="string")return n.push([L.default.Error,P.localize(2,null,"version")]),n;if(!a.engines)return n.push([L.default.Error,P.localize(3,null,"engines")]),n;if(typeof a.engines.vscode!="string")return n.push([L.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof a.extensionDependencies<"u"&&!t(a.extensionDependencies))return n.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof a.activationEvents<"u"){if(!t(a.activationEvents))return n.push([L.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof a.main>"u"&&typeof a.browser>"u")return n.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&n.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return n.push([L.default.Error,P.localize(9,null,"main")]),n;{const h=(0,E.$vg)(u,a.main);(0,E.$pg)(h,u)||n.push([L.default.Warning,P.localize(10,null,h.path,u.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return n.push([L.default.Error,P.localize(11,null,"browser")]),n;{const h=(0,E.$vg)(u,a.browser);(0,E.$pg)(h,u)||n.push([L.default.Warning,P.localize(12,null,h.path,u.path)])}}if(!M.valid(a.version))return n.push([L.default.Error,P.localize(13,null)]),n;const s=[];if(!b(i,r,a,l,s))for(const h of s)n.push([L.default.Error,h]);return n}e.$So=o;function b(i,r,u,a,l){return a||typeof u.main>"u"&&typeof u.browser>"u"?!0:f(i,r,u.engines.vscode,l)}e.$To=b;function v(i,r,u){return i==="*"||f(r,u,i)}e.$Uo=v;function f(i,r,u,a=[]){const l=A(g(u));if(!l)return a.push(P.localize(14,null,u)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(P.localize(15,null,u)),!1}else if(!l.majorMustEqual)return a.push(P.localize(16,null,u)),!1;return S(i,r,l)?!0:(a.push(P.localize(17,null,i,u)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let r=0,u=i.length;r<u;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class E{constructor(P,M=[],R=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Mh=E}),define(Ae[70],Re([1,0,69]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const L=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,D,g){D instanceof E.$Mh||(D=new E.$Mh(D,[],!!g)),L.push([$,D])}e.$zr=M;function R(){return L}e.$Ar=R}),define(Ae[181],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$eq=E;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(R);$.outgoing.set(D.key,D),D.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),D=this.c(R,$);if(D)return D}}c(M,R){for(const[$,D]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const g=this.c(D,R);if(g)return g;R.delete($)}}}e.$fq=L}),define(Ae[4],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$Oh=P("instantiationService");function L(R,$,D){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:D}):($[E.DI_DEPENDENCIES]=[{id:R,index:D}],$[E.DI_TARGET]=$)}function P(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(D,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L($,D,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$Ph=P;function M(R){return R}e.$Qh=M}),define(Ae[46],Re([1,0,16,2,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,P.$Ph)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$ki=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$li=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ni=g;function A(i,r){const u=Object.create(null);for(const a in i)S(u,a,i[a],r);return u}e.$oi=A;function S(i,r,u,a){const l=r.split("."),n=l.pop();let s=i;for(let c=0;c<l.length;c++){const h=l[c];let p=s[h];switch(typeof p){case"undefined":p=s[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(p)}`);return}s=p}if(typeof s=="object"&&s!==null)try{s[n]=u}catch{a(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}else a(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$pi=S;function o(i,r){const u=r.split(".");b(i,u)}e.$qi=o;function b(i,r){const u=r.shift();if(r.length===0){delete i[u];return}if(Object.keys(i).indexOf(u)!==-1){const a=i[u];typeof a=="object"&&!Array.isArray(a)&&(b(a,r),Object.keys(a).length===0&&delete i[u])}}function v(i,r,u){function a(s,c){let h=s;for(const p of c){if(typeof h!="object"||h===null)return;h=h[p]}return h}const l=r.split("."),n=a(i,l);return typeof n>"u"?u:n}e.$ri=v;function f(i,r,u){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in i?E.$Af(i[a])&&E.$Af(r[a])?f(i[a],r[a],u):u&&(i[a]=r[a]):i[a]=r[a])})}e.$si=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$ti=t}),define(Ae[33],Re([1,0,23,13,179,4,148,11]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",E.$k),D.set("isLinux",E.$l),D.set("isWindows",E.$j),D.set("isWeb",E.$p),D.set("isMacNative",E.$k&&!E.$p),D.set("isEdge",E.$H),D.set("isFirefox",E.$F),D.set("isChrome",E.$E),D.set("isSafari",E.$G);function g(te,V){if(D.get(te)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(te,V)}e.$Li=g;const A=Object.prototype.hasOwnProperty;var S;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const o={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),v=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),r=(0,R.localize)(5,null),u=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=o){this.k=V,this.d=new P.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const _=this.D(),pe=_.type===17?r:void 0;throw this.h.push({message:i,offset:_.offset,lexeme:P.$Ki.getLexeme(_),additionalInfo:pe}),l.c}return Y}catch(Y){if(Y!==l.c)throw Y;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const Y=this.o();V.push(Y)}return V.length===1?V[0]:n.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const Y=this.s();V.push(Y)}return V.length===1?V[0]:n.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const Y=this.l();return this.A(1,t),Y?.negate()}case 17:return this.z(),C.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const Y=this.l();return this.A(1,t),Y}case 17:{const Y=V.lexeme;if(this.z(),this.y(9)){const pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),pe.type!==10)throw this.B("REGEX",pe);const $e=pe.lexeme,de=$e.lastIndexOf("/"),De=de===$e.length-1?void 0:this.w($e.substring(de+1));let re;try{re=new RegExp($e.substring(1,de),De)}catch{throw this.B("REGEX",pe)}return O.create(Y,re)}switch(pe.type){case 10:case 19:{const $e=[pe.lexeme];this.z();let de=this.D(),De=0;for(let ge=0;ge<pe.lexeme.length;ge++)pe.lexeme.charCodeAt(ge)===40?De++:pe.lexeme.charCodeAt(ge)===41&&De--;for(;!this.E()&&de.type!==15&&de.type!==16;){switch(de.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let ge=0;ge<de.lexeme.length;ge++)de.lexeme.charCodeAt(ge)===40?De++:pe.lexeme.charCodeAt(ge)===41&&De--}if(De<0)break;$e.push(P.$Ki.getLexeme(de)),this.z(),de=this.D()}const re=$e.join(""),he=re.lastIndexOf("/"),ne=he===re.length-1?void 0:this.w(re.substring(he+1));let ae;try{ae=new RegExp(re.substring(1,he),ne)}catch{throw this.B("REGEX",pe)}return n.regex(Y,ae)}case 18:{const $e=pe.lexeme;this.z();let de=null;if(!(0,L.$Be)($e)){const De=$e.indexOf("/"),re=$e.lastIndexOf("/");if(De!==re&&De>=0){const he=$e.slice(De+1,re),ne=$e[re+1]==="i"?"i":"";try{de=new RegExp(he,ne)}catch{throw this.B("REGEX",pe)}}}if(de===null)throw this.B("REGEX",pe);return O.create(Y,de)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const pe=this.u();return n.notIn(Y,pe)}switch(this.D().type){case 3:{this.z();const pe=this.u();if(this.x().type===18)return n.equals(Y,pe);switch(pe){case"true":return n.has(Y);case"false":return n.not(Y);default:return n.equals(Y,pe)}}case 4:{this.z();const pe=this.u();if(this.x().type===18)return n.notEquals(Y,pe);switch(pe){case"true":return n.not(Y);case"false":return n.has(Y);default:return n.notEquals(Y,pe)}}case 5:return this.z(),U.create(Y,this.u());case 6:return this.z(),F.create(Y,this.u());case 7:return this.z(),B.create(Y,this.u());case 8:return this.z(),W.create(Y,this.u());case 13:return this.z(),n.in(Y,this.u());default:return n.has(Y)}}case 20:throw this.h.push({message:u,offset:V.offset,lexeme:"",additionalInfo:a}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,Y){if(this.C(V))return this.z();throw this.B(Y,this.D())}B(V,Y,_){const pe=(0,R.localize)(8,null,V,P.$Ki.getLexeme(Y)),$e=Y.offset,de=P.$Ki.getLexeme(Y);return this.h.push({message:pe,offset:$e,lexeme:de,additionalInfo:_}),l.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=l;class n{static false(){return p.INSTANCE}static true(){return m.INSTANCE}static has(V){return I.create(V)}static equals(V,Y){return k.create(V,Y)}static notEquals(V,Y){return w.create(V,Y)}static regex(V,Y){return O.create(V,Y)}static in(V,Y){return d.create(V,Y)}static notIn(V,Y){return y.create(V,Y)}static not(V){return C.create(V)}static and(...V){return Ee.create(V,null,!0)}static or(...V){return ke.create(V,null,!0)}static greater(V,Y){return B.create(V,Y)}static greaterEquals(V,Y){return W.create(V,Y)}static smaller(V,Y){return U.create(V,Y)}static smallerEquals(V,Y){return F.create(V,Y)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ni=n;function s(te){const V=new l({regexParsingWithErrorRecovery:!1});return te.map(Y=>(V.parse(Y),V.lexingErrors.length>0?V.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,R.localize)(9,null,_.additionalInfo):(0,R.localize)(10,null),offset:_.offset,length:_.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}e.$Oi=s;function c(te,V){const Y=te?te.substituteConstants():void 0,_=V?V.substituteConstants():void 0;return!Y&&!_?!0:!Y||!_?!1:Y.equals(_)}e.$Pi=c;function h(te,V){return te.cmp(V)}class p{static{this.INSTANCE=new p}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return m.INSTANCE}}e.$Qi=p;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return p.INSTANCE}}e.$Ri=m;class I{static create(V,Y=null){const _=D.get(V);return typeof _=="boolean"?_?m.INSTANCE:p.INSTANCE:new I(V,Y)}constructor(V,Y){this.key=V,this.c=Y,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:le(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=D.get(this.key);return typeof V=="boolean"?V?m.INSTANCE:p.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Si=I;class k{static create(V,Y,_=null){if(typeof Y=="boolean")return Y?I.create(V,_):C.create(V,_);const pe=D.get(V);return typeof pe=="boolean"?Y===(pe?"true":"false")?m.INSTANCE:p.INSTANCE:new k(V,Y,_)}constructor(V,Y,_){this.c=V,this.d=Y,this.f=_,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=D.get(this.c);if(typeof V=="boolean"){const Y=V?"true":"false";return this.d===Y?m.INSTANCE:p.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ti=k;class d{static create(V,Y){return new d(V,Y)}constructor(V,Y){this.d=V,this.f=Y,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:be(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const Y=V.getValue(this.f),_=V.getValue(this.d);return Array.isArray(Y)?Y.includes(_):typeof _=="string"&&typeof Y=="object"&&Y!==null?A.call(Y,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$Ui=d;class y{static create(V,Y){return new y(V,Y)}constructor(V,Y){this.d=V,this.f=Y,this.type=11,this.c=d.create(V,Y)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=y;class w{static create(V,Y,_=null){if(typeof Y=="boolean")return Y?C.create(V,_):I.create(V,_);const pe=D.get(V);return typeof pe=="boolean"?Y===(pe?"true":"false")?p.INSTANCE:m.INSTANCE:new w(V,Y,_)}constructor(V,Y,_){this.c=V,this.d=Y,this.f=_,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=D.get(this.c);if(typeof V=="boolean"){const Y=V?"true":"false";return this.d===Y?p.INSTANCE:m.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Wi=w;class C{static create(V,Y=null){const _=D.get(V);return typeof _=="boolean"?_?p.INSTANCE:m.INSTANCE:new C(V,Y)}constructor(V,Y){this.c=V,this.d=Y,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=D.get(this.c);return typeof V=="boolean"?V?p.INSTANCE:m.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Xi=C;function j(te,V){if(typeof te=="string"){const Y=parseFloat(te);isNaN(Y)||(te=Y)}return typeof te=="string"||typeof te=="number"?V(te):p.INSTANCE}class B{static create(V,Y,_=null){return j(Y,pe=>new B(V,pe,_))}constructor(V,Y,_){this.c=V,this.d=Y,this.f=_,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Yi=B;class W{static create(V,Y,_=null){return j(Y,pe=>new W(V,pe,_))}constructor(V,Y,_){this.c=V,this.d=Y,this.f=_,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Zi=W;class U{static create(V,Y,_=null){return j(Y,pe=>new U(V,pe,_))}constructor(V,Y,_){this.c=V,this.d=Y,this.f=_,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$1i=U;class F{static create(V,Y,_=null){return j(Y,pe=>new F(V,pe,_))}constructor(V,Y,_){this.c=V,this.d=Y,this.f=_,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:be(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$2i=F;class O{static create(V,Y){return new O(V,Y)}constructor(V,Y){this.d=V,this.f=Y,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const Y=this.f?this.f.source:"",_=V.f?V.f.source:"";return Y<_?-1:Y>_?1:0}equals(V){if(V.type===this.type){const Y=this.f?this.f.source:"",_=V.f?V.f.source:"";return this.d===V.d&&Y===_}return!1}substituteConstants(){return this}evaluate(V){const Y=V.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$3i=O;class ee{static create(V){return new ee(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new ee(this.c.map(V))}negate(){return this.c}}e.$4i=ee;function X(te){let V=null;for(let Y=0,_=te.length;Y<_;Y++){const pe=te[Y].substituteConstants();if(te[Y]!==pe&&V===null){V=[];for(let $e=0;$e<Y;$e++)V[$e]=te[$e]}V!==null&&(V[Y]=pe)}return V===null?te:V}class Ee{static create(V,Y,_){return Ee.d(V,Y,_)}constructor(V,Y){this.expr=V,this.c=Y,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let Y=0,_=this.expr.length;Y<_;Y++){const pe=h(this.expr[Y],V.expr[Y]);if(pe!==0)return pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let Y=0,_=this.expr.length;Y<_;Y++)if(!this.expr[Y].equals(V.expr[Y]))return!1;return!0}return!1}substituteConstants(){const V=X(this.expr);return V===this.expr?this:Ee.create(V,this.c,!1)}evaluate(V){for(let Y=0,_=this.expr.length;Y<_;Y++)if(!this.expr[Y].evaluate(V))return!1;return!0}static d(V,Y,_){const pe=[];let $e=!1;for(const de of V)if(de){if(de.type===1){$e=!0;continue}if(de.type===0)return p.INSTANCE;if(de.type===6){pe.push(...de.expr);continue}pe.push(de)}if(pe.length===0&&$e)return m.INSTANCE;if(pe.length!==0){if(pe.length===1)return pe[0];pe.sort(h);for(let de=1;de<pe.length;de++)pe[de-1].equals(pe[de])&&(pe.splice(de,1),de--);if(pe.length===1)return pe[0];for(;pe.length>1;){const de=pe[pe.length-1];if(de.type!==9)break;pe.pop();const De=pe.pop(),re=pe.length===0,he=ke.create(de.expr.map(ne=>Ee.create([ne,De],null,_)),null,re);he&&(pe.push(he),pe.sort(h))}if(pe.length===1)return pe[0];if(_){for(let de=0;de<pe.length;de++)for(let De=de+1;De<pe.length;De++)if(pe[de].negate().equals(pe[De]))return p.INSTANCE;if(pe.length===1)return pe[0]}return new Ee(pe,Y)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const Y of this.expr)V.push(...Y.keys());return V}map(V){return new Ee(this.expr.map(Y=>Y.map(V)),null)}negate(){if(!this.c){const V=[];for(const Y of this.expr)V.push(Y.negate());this.c=ke.create(V,this,!0)}return this.c}}e.$5i=Ee;class ke{static create(V,Y,_){return ke.d(V,Y,_)}constructor(V,Y){this.expr=V,this.c=Y,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let Y=0,_=this.expr.length;Y<_;Y++){const pe=h(this.expr[Y],V.expr[Y]);if(pe!==0)return pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let Y=0,_=this.expr.length;Y<_;Y++)if(!this.expr[Y].equals(V.expr[Y]))return!1;return!0}return!1}substituteConstants(){const V=X(this.expr);return V===this.expr?this:ke.create(V,this.c,!1)}evaluate(V){for(let Y=0,_=this.expr.length;Y<_;Y++)if(this.expr[Y].evaluate(V))return!0;return!1}static d(V,Y,_){let pe=[],$e=!1;if(V){for(let de=0,De=V.length;de<De;de++){const re=V[de];if(re){if(re.type===0){$e=!0;continue}if(re.type===1)return m.INSTANCE;if(re.type===9){pe=pe.concat(re.expr);continue}pe.push(re)}}if(pe.length===0&&$e)return p.INSTANCE;pe.sort(h)}if(pe.length!==0){if(pe.length===1)return pe[0];for(let de=1;de<pe.length;de++)pe[de-1].equals(pe[de])&&(pe.splice(de,1),de--);if(pe.length===1)return pe[0];if(_){for(let de=0;de<pe.length;de++)for(let De=de+1;De<pe.length;De++)if(pe[de].negate().equals(pe[De]))return m.INSTANCE;if(pe.length===1)return pe[0]}return new ke(pe,Y)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const Y of this.expr)V.push(...Y.keys());return V}map(V){return new ke(this.expr.map(Y=>Y.map(V)),null)}negate(){if(!this.c){const V=[];for(const Y of this.expr)V.push(Y.negate());for(;V.length>1;){const Y=V.shift(),_=V.shift(),pe=[];for(const $e of ye(Y))for(const de of ye(_))pe.push(Ee.create([$e,de],null,!1));V.unshift(ke.create(pe,null,!1))}this.c=ke.create(V,this,!0)}return this.c}}e.$6i=ke;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(V,Y,_){super(V,null),this.f=Y,typeof _=="object"?Pe.d.push({..._,key:V}):_!==!0&&Pe.d.push({key:V,description:_,type:Y!=null?typeof Y:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return k.create(this.key,V)}notEqualsTo(V){return w.create(this.key,V)}}e.$7i=Pe,e.$8i=(0,M.$Ph)("contextKeyService");function le(te,V){return te<V?-1:te>V?1:0}function be(te,V,Y,_){return te<Y?-1:te>Y?1:V<_?-1:V>_?1:0}function ue(te,V){if(te.type===0||V.type===1)return!0;if(te.type===9)return V.type===9?oe(te.expr,V.expr):!1;if(V.type===9){for(const Y of V.expr)if(ue(te,Y))return!0;return!1}if(te.type===6){if(V.type===6)return oe(V.expr,te.expr);for(const Y of te.expr)if(ue(Y,V))return!0;return!1}return te.equals(V)}e.$9i=ue;function oe(te,V){let Y=0,_=0;for(;Y<te.length&&_<V.length;){const pe=te[Y].cmp(V[_]);if(pe<0)return!1;pe===0&&Y++,_++}return Y===te.length}function ye(te){return te.type===9?te.expr:[te]}}),define(Ae[182],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,E.$Ph)("environmentService"),e.$Xh=(0,E.$Qh)(e.$Wh)}),define(Ae[95],Re([1,0,150,4]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=M;function R(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=R;function $(i,r){return r==="web"&&!i.includes("web")}e.$0n=$;function D(i,r,u){return $(r,u)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===u}e.$$n=D;function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$_n=g;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var o;(function(i){i.Install="install",i.Uninstall="uninstall"})(o||(e.StatisticType=o={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$ao=(0,L.$Ph)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var f;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class t extends Error{constructor(r,u){super(r),this.code=u,this.name=u}}e.$bo=t,e.$co=(0,L.$Ph)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,L.$Ph)("IGlobalExtensionEnablementService"),e.$go=(0,L.$Ph)("IExtensionTipsService"),e.$ho=(0,E.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ae[40],Re([1,0,50,20,13,16,2,152,4,23,14,43]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,D.$Ph)("fileService");function o(ue){return ue.create===!0}e.$_j=o;var b;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var v;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function f(ue){const oe=ue;return!!oe&&typeof oe.onDidChange=="function"}e.$ak=f;var t;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ue){return!!(ue.capabilities&2)}e.$bk=i;function r(ue){return!!(ue.capabilities&8)}e.$ck=r;function u(ue){return!!(ue.capabilities&131072)}e.$dk=u;function a(ue){return!!(ue.capabilities&4)}e.$ek=a;function l(ue){return!!(ue.capabilities&16)}e.$fk=l;function n(ue){return i(ue)?!!(ue.capabilities&16384):!1}e.$gk=n;function s(ue){return i(ue)?!!(ue.capabilities&32768):!1}e.$hk=s;function c(ue){return!!(ue.capabilities&65536)}e.$ik=c;function h(ue){return!!(ue.capabilities&2048)}e.$jk=h;var p;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class m extends Error{static create(oe,ye){const te=new m(oe.toString(),ye);return d(te,ye),te}constructor(oe,ye){super(oe),this.code=ye}}e.$kk=m;function I(ue,oe){return m.create(ue,oe)}e.$lk=I;function k(ue){return ue||I((0,$.localize)(0,null),p.Unknown)}e.$mk=k;function d(ue,oe){return ue.name=oe?`${oe} (FileSystemError)`:"FileSystemError",ue}e.$nk=d;function y(ue){if(!ue)return p.Unknown;if(ue instanceof m)return ue.code;const oe=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!oe)return p.Unknown;switch(oe[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.$ok=y;function w(ue){if(ue instanceof F)return ue.fileOperationResult;switch(y(ue)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}e.$pk=w;var C;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class j{constructor(oe,ye,te){this.resource=oe,this.operation=ye,this.target=te}isOperation(oe){return this.operation===oe}}e.$qk=j;var B;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(B||(e.FileChangeType=B={}));class W{static{this.a=null}constructor(oe,ye){this.c=ye,this.b=void 0,this.d=new S.$U(()=>{const te=E.$Vh.forUris(()=>this.c);return te.fill(this.rawAdded.map(V=>[V,!0])),te}),this.f=new S.$U(()=>{const te=E.$Vh.forUris(()=>this.c);return te.fill(this.rawUpdated.map(V=>[V,!0])),te}),this.g=new S.$U(()=>{const te=E.$Vh.forUris(()=>this.c);return te.fill(this.rawDeleted.map(V=>[V,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of oe){switch(te.type){case 1:this.rawAdded.push(te.resource);break;case 0:this.rawUpdated.push(te.resource);break;case 2:this.rawDeleted.push(te.resource);break}this.b!==W.a&&(typeof te.cId=="number"?this.b===void 0?this.b=te.cId:this.b!==te.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(oe,...ye){return this.h(oe,{includeChildren:!1},...ye)}affects(oe,...ye){return this.h(oe,{includeChildren:!0},...ye)}h(oe,ye,...te){if(!oe)return!1;const V=te.length>0;return!!((!V||te.includes(1))&&(this.d.value.get(oe)||ye.includeChildren&&this.d.value.findSuperstr(oe))||(!V||te.includes(0))&&(this.f.value.get(oe)||ye.includeChildren&&this.f.value.findSuperstr(oe))||(!V||te.includes(2))&&(this.g.value.findSubstr(oe)||ye.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$rk=W;function U(ue,oe,ye){return!ue||!oe||ue===oe||oe.length>ue.length?!1:(oe.charAt(oe.length-1)!==L.sep&&(oe+=L.sep),ye?(0,P.$3e)(ue,oe):ue.indexOf(oe)===0)}e.$sk=U;class F extends Error{constructor(oe,ye,te){super(oe),this.fileOperationResult=ye,this.options=te}}e.$tk=F;class O extends F{constructor(oe,ye,te,V){super(oe,ye,V),this.fileOperationResult=ye,this.size=te}}e.$uk=O;class ee extends F{constructor(oe,ye,te){super(oe,2,te),this.stat=ye}}e.$vk=ee;var X;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Ee;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Dk="";function ke(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}e.$Ek=ke;async function Pe(ue,oe){if(!oe.hasProvider(R.URI.from({scheme:ue.scheme})))return new Promise(ye=>{const te=oe.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ue.scheme&&V.added&&(te.dispose(),ye())})})}e.$Fk=Pe;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(oe){return(0,M.$Cf)(oe)||(oe=0),oe<le.KB?(0,$.localize)(1,null,oe.toFixed(0)):oe<le.MB?(0,$.localize)(2,null,(oe/le.KB).toFixed(2)):oe<le.GB?(0,$.localize)(3,null,(oe/le.MB).toFixed(2)):oe<le.TB?(0,$.localize)(4,null,(oe/le.GB).toFixed(2)):(0,$.localize)(5,null,(oe/le.TB).toFixed(2))}}e.$Gk=le;function be(ue){const oe=typeof ue=="string"||ue?.scheme===A.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===A.Schemas.file?1024*le.MB:oe?10*le.MB:g.$p?50*le.MB:1024*le.MB}e.$Hk=be}),define(Ae[71],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class E{constructor(...P){this.a=new Map;for(const[M,R]of P)this.set(M,R)}set(P,M){const R=this.a.get(P);return this.a.set(P,M),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Nh=E}),define(Ae[183],Re([1,0,12,11,6,69,181,4,71,184]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const A=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class o{constructor(t=new D.$Nh,i=!1,r,u=A){this.f=t,this.g=i,this.h=r,this.i=u,this.o=new Set,this.f.set($.$Oh,this),this._globalGraph=u?r?._globalGraph??new R.$fq(a=>a):void 0}createChild(t){return new o(t,this.g,this,this.i)}invokeFunction(t,...i){const r=v.traceInvocation(this.i,t);let u=!1;try{return t({get:l=>{if(u)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const n=this.m(l,r);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...i)}finally{u=!0,r.stop()}}createInstance(t,...i){let r,u;return t instanceof M.$Mh?(r=v.traceCreation(this.i,t.ctor),u=this.j(t.ctor,t.staticArguments.concat(i),r)):(r=v.traceCreation(this.i,t),u=this.j(t,i,r)),r.stop(),u}j(t,i=[],r){const u=$._util.getServiceDependencies(t).sort((n,s)=>n.index-s.index),a=[];for(const n of u){const s=this.m(n.id,r);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),a.push(s)}const l=u.length>0?u[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const n=l-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(a))}k(t,i){if(this.f.get(t)instanceof M.$Mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const r=this.l(t);return r instanceof M.$Mh?this.q(t,r,i.branch(t,!0)):(i.branch(t,!1),r)}q(t,i,r){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,r)}finally{this.o.delete(t)}}r(t,i,r){const u=new R.$fq(n=>n.id.toString());let a=0;const l=[{id:t,desc:i,_trace:r}];for(;l.length;){const n=l.pop();if(u.lookupOrInsertNode(n),a++>1e3)throw new S(u);for(const s of $._util.getServiceDependencies(n.desc.ctor)){const c=this.l(s.id);if(c||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),c instanceof M.$Mh){const h={id:s.id,desc:c,_trace:n._trace.branch(s.id,!0)};u.insertEdge(n,h),l.push(h)}}}for(;;){const n=u.roots();if(n.length===0){if(!u.isEmpty())throw new S(u);break}for(const{data:s}of n){if(this.l(s.id)instanceof M.$Mh){const h=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,h)}u.removeNode(s)}}return this.l(t)}s(t,i,r=[],u,a){if(this.f.get(t)instanceof M.$Mh)return this.t(t,i,r,u,a);if(this.h)return this.h.s(t,i,r,u,a);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,r=[],u,a){if(u){const l=new o(void 0,this.g,this,this.i);l.c=String(t);const n=new Map,s=new E.$$g(()=>{const c=l.j(i,r,a);for(const[h,p]of n){const m=c[h];if(typeof m=="function")for(const I of p)m.apply(c,I)}return n.clear(),c});return new Proxy(Object.create(null),{get(c,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=n.get(h);return I||(I=new g.$1c,n.set(h,I)),(d,y,w)=>{const C=I.push([d,y,w]);return(0,P.$Pc)(C)}}if(h in c)return c[h];const p=s.value;let m=p[h];return typeof m!="function"||(m=m.bind(p),c[h]=m),m},set(c,h,p){return s.value[h]=p,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,r,a)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$gq=o;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new v(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(t,i){return t?new v(1,i.name):v.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const r=new v(3,t.toString());return this.h.push([t,i,r]),r}stop(){const t=Date.now()-this.g;v.f+=t;let i=!1;function r(a,l){const n=[],s=new Array(a+1).join("	");for(const[c,h,p]of l.h)if(h&&p){i=!0,n.push(`${s}CREATES -> ${c}`);const m=r(a+1,p);m&&n.push(m)}else n.push(`${s}uses -> ${c}`);return n.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(t>2||i)&&v.all.add(u.join(`
`))}}e.$hq=v}),define(Ae[15],Re([1,0,38,5,96,6,28,23,25,16,2,33,4]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,o.$Ph)("logService"),e.$$i=(0,o.$Ph)("loggerService");function b(){return new Date().toISOString()}function v(d){return(0,g.$Cf)(d)}e.$_i=v;var f;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$aj=f.Info;function t(d,y,w){switch(y){case f.Trace:d.trace(w);break;case f.Debug:d.debug(w);break;case f.Info:d.info(w);break;case f.Warning:d.warn(w);break;case f.Error:d.error(w);break;case f.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=t;function i(d,y=!1){let w="";for(let C=0;C<d.length;C++){let j=d[C];if(j instanceof Error&&(j=(0,E.$Ai)(j,y)),typeof j=="object")try{j=JSON.stringify(j)}catch{}w+=(C>0?" ":"")+j}return w}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new L.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==f.Off&&this.b<=y}}e.$cj=r;class u extends r{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...w){this.f(f.Trace)&&this.g(f.Trace,i([y,...w],!0))}debug(y,...w){this.f(f.Debug)&&this.g(f.Debug,i([y,...w]))}info(y,...w){this.f(f.Info)&&this.g(f.Info,i([y,...w]))}warn(y,...w){this.f(f.Warning)&&this.g(f.Warning,i([y,...w]))}error(y,...w){if(this.f(f.Error))if(y instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=y.stack,this.g(f.Error,i(C))}else this.g(f.Error,i([y,...w]))}flush(){}}e.$dj=u;class a extends r{constructor(y=e.$aj){super(),this.setLevel(y),this.g=!$.$j}trace(y,...w){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,y,...w):console.log(`[main ${b()}]`,y,...w))}debug(y,...w){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,y,...w):console.log(`[main ${b()}]`,y,...w))}info(y,...w){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,y,...w):console.log(`[main ${b()}]`,y,...w))}warn(y,...w){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,y,...w):console.warn(`[main ${b()}]`,y,...w))}error(y,...w){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,y,...w):console.error(`[main ${b()}]`,y,...w))}dispose(){}flush(){}}e.$ej=a;class l extends r{constructor(y=e.$aj,w=!0){super(),this.g=w,this.setLevel(y)}trace(y,...w){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...w):console.log(y,...w))}debug(y,...w){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...w):console.log(y,...w))}info(y,...w){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...w):console.log(y,...w))}warn(y,...w){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...w):console.log(y,...w))}error(y,...w){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...w):console.error(y,...w))}dispose(){}flush(){}}e.$fj=l;class n extends r{constructor(y,w=e.$aj){super(),this.g=y,this.setLevel(w)}trace(y,...w){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(y),...w])}debug(y,...w){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(y),...w])}info(y,...w){this.f(f.Info)&&this.g.log(f.Info,[this.h(y),...w])}warn(y,...w){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(y),...w])}error(y,...w){this.f(f.Error)&&this.g.log(f.Error,[this.h(y),...w])}h(y){return typeof y=="string"?y:(0,E.$Ai)(y,this.f(f.Trace))}dispose(){}flush(){}}e.$gj=n;class s extends r{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const w of this.g)w.setLevel(y);super.setLevel(y)}trace(y,...w){for(const C of this.g)C.trace(y,...w)}debug(y,...w){for(const C of this.g)C.debug(y,...w)}info(y,...w){for(const C of this.g)C.info(y,...w)}warn(y,...w){for(const C of this.g)C.warn(y,...w)}error(y,...w){for(const C of this.g)C.error(y,...w)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$hj=s;class c extends M.$Rc{constructor(y,w,C){if(super(),this.h=y,this.j=w,this.b=new R.$zc,this.c=this.B(new L.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Nd),this.onDidChangeVisibility=this.g.event,C)for(const j of C)this.b.set(j.resource,{logger:void 0,info:j})}m(y){return(0,g.$yf)(y)?[...this.b.values()].find(w=>w.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,w){const C=this.n(y),j=(0,g.$yf)(y)?y:w?.id??(0,P.$Di)(C.toString()).toString(16);let B=this.b.get(C)?.logger;const W=w?.logLevel==="always"?f.Trace:w?.logLevel;B||(B=this.s(C,W??this.getLogLevel(C)??this.h,{...w,id:j}));const U={logger:B,info:{resource:C,id:j,logLevel:W,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(U.info),this.b.set(C,U),B}n(y){return(0,g.$yf)(y)?(0,D.$vg)(this.j,`${y}.log`):y}setLogLevel(y,w){if(A.URI.isUri(y)){const C=y,j=w,B=this.b.get(C);B&&j!==B.info.logLevel&&(B.info.logLevel=j===this.h?void 0:j,B.logger?.setLevel(j),this.b.set(B.info.resource,B),this.f.fire([C,j]))}else{this.h=y;for(const[C,j]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,w){const C=this.m(y);C&&w!==!C.info.hidden&&(C.info.hidden=!w,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,w]))}getLogLevel(y){let w;return y&&(w=this.b.get(y)?.info.logLevel),w??this.h}registerLogger(y){const w=this.b.get(y.resource);w?w.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const w=this.b.get(y);w&&(w.logger&&w.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=c;class h{constructor(){this.onDidChangeLogLevel=new L.$Nd().event}setLevel(y){}getLevel(){return f.Info}trace(y,...w){}debug(y,...w){}info(y,...w){}warn(y,...w){}error(y,...w){}critical(y,...w){}dispose(){}flush(){}}e.$jj=h;class p extends h{}e.$kj=p;function m(d){if(d.verbose)return f.Trace;if(typeof d.logLevel=="string"){const y=k(d.logLevel.toLowerCase());if(y!==void 0)return y}return e.$aj}e.$lj=m;function I(d){switch(d){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$mj=I;function k(d){switch(d){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$nj=k,e.$oj=new S.$7i("logLevel",I(f.Info))}),define(Ae[185],Re([1,0,6,15]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class P extends E.$Rc{constructor(R,$=[]){super(),this.a=new L.$hj([R,...$]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$RN=P}),define(Ae[97],Re([1,0,30,153,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function g(v,f){return f-v}D.compare=g;const A=Object.create(null);A[D.Error]=(0,L.localize)(0,null),A[D.Warning]=(0,L.localize)(1,null),A[D.Info]=(0,L.localize)(2,null);function S(v){return A[v]||""}D.toString=S;function o(v){switch(v){case E.default.Error:return D.Error;case E.default.Warning:return D.Warning;case E.default.Info:return D.Info;case E.default.Ignore:return D.Hint}}D.fromSeverity=o;function b(v){switch(v){case D.Error:return E.default.Error;case D.Warning:return E.default.Warning;case D.Info:return E.default.Info;case D.Hint:return E.default.Ignore}}D.toSeverity=b}(R||(e.MarkerSeverity=R={}));var $;(function(D){const g="";function A(o){return S(o,!0)}D.makeKey=A;function S(o,b){const v=[g];return o.source?v.push(o.source.replace("\xA6","\\\xA6")):v.push(g),o.code?typeof o.code=="string"?v.push(o.code.replace("\xA6","\\\xA6")):v.push(o.code.value.replace("\xA6","\\\xA6")):v.push(g),o.severity!==void 0&&o.severity!==null?v.push(R.toString(o.severity)):v.push(g),o.message&&b?v.push(o.message.replace("\xA6","\\\xA6")):v.push(g),o.startLineNumber!==void 0&&o.startLineNumber!==null?v.push(o.startLineNumber.toString()):v.push(g),o.startColumn!==void 0&&o.startColumn!==null?v.push(o.startColumn.toString()):v.push(g),o.endLineNumber!==void 0&&o.endLineNumber!==null?v.push(o.endLineNumber.toString()):v.push(g),o.endColumn!==void 0&&o.endColumn!==null?v.push(o.endColumn.toString()):v.push(g),v.push(g),v.join("\xA6")}D.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$ct=(0,P.$Ph)("markerService")}),define(Ae[186],Re([1,0,5,30,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3u=e.Severity=void 0,e.Severity=L.default,e.$3u=(0,P.$Ph)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class D{constructor(){this.progress=new g,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$4u=D;class g{infinite(){}done(){}total(S){}worked(S){}}e.$5u=g}),define(Ae[98],Re([1,0,13,2,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=e.$xU=e.$wU=e.$vU=void 0,e.$vU=(0,P.$Ph)("openerService");function M(g,A){return L.URI.isUri(g)?(0,E.$2e)(g.scheme,A):(0,E.$3e)(g,A+":")}e.$wU=M;function R(g,...A){return A.some(S=>M(g,S))}e.$xU=R;function $(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$yU=$;function D(g){let A;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return S&&(A={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$zU=D}),define(Ae[187],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,E.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(ve,e,E,L){var P=arguments.length,M=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ve,e,E,L);else for(var $=ve.length-1;$>=0;$--)(R=ve[$])&&(M=(P<3?R(M):P>3?R(e,E,M):R(e,E))||M);return P>3&&M&&Object.defineProperty(e,E,M),M},Ve=this&&this.__param||function(ve,e){return function(E,L){e(E,L,ve)}};define(Ae[53],Re([1,0,12,19,6,4]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProgressLocation=e.$6u=void 0,e.$6u=(0,M.$Ph)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$7u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(o){this.b=o}report(o){this.a=o,this.b(this.a)}}e.$8u=$;class D{get value(){return this.a}constructor(o){this.e=o}report(o){this.b?this.b.push(o):this.b=[o],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const o=this.b.shift();this.a=o,await this.e(this.a)}}finally{this.c=!1;const o=this.d;this.d=void 0,o?.()}}drain(){return this.c?new Promise(o=>{const b=this.d;this.d=()=>{b?.(),o()}}):Promise.resolve()}}e.$9u=D;let g=class extends P.$Rc{constructor(o,b){super(),this.a=new E.$ch,b.withProgress(o,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(o){this.b?this.b.report(o):this.c=o}};e.$0u=g,e.$0u=g=Ke([Ve(1,e.$6u)],g);class A extends P.$Rc{constructor(o){super(),this.g=o,this.a=0,this.b=this.B(new P.$Qc)}start(o){this.stop();const b=++this.a,v=new L.$Xd;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},o),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>v.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:b,token:v.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(o){this.a===o&&this.b.clear()}}e.$$u=A,e.$_u=(0,M.$Ph)("editorProgressService")}),define(Ae[31],Re([1,0,54,16]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class P{constructor(){this.a=new Map}add(R,$){E.ok(L.$yf(R)),E.ok(L.$Af($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$jn=new P}),define(Ae[72],Re([1,0,5,31]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[P(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$jn.add(e.$kn.JSONContribution,R)}),define(Ae[99],Re([1,0,18,5,16,147,46,72,31]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$on={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const S=D.$jn.as($.$kn.JSONContribution);class o{constructor(){this.h=new Set,this.i=new L.$Nd,this.onDidSchemaChange=this.i.event,this.j=new L.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const c=new Set;this.n(n,s,c),S.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(n){const s=new Set;this.o(n,s),S.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const c=new Set;this.o(s,c),this.n(n,!1,c),S.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const c=[];for(const{overrides:h,source:p}of n)for(const m in h)if(s.add(m),e.$yn.test(m)){const I=this.a.get(m),k=I?.valuesSources??new Map;if(p)for(const C of Object.keys(h[m]))k.set(C,p);const d={...I?.value||{},...h[m]};this.a.set(m,{source:p,value:d,valuesSources:k});const y=(0,R.$ti)(m),w={type:"object",default:d,description:M.localize(1,null,y),$ref:e.$vn,defaultDefaultValue:d,source:P.$yf(p)?void 0:p,defaultValueSource:p};c.push(...f(m)),this.d[m]=w,this.b.properties[m]=w}else{this.a.set(m,{value:h[m],source:p});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(c)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:c,source:h}of n)for(const p in c){const m=this.a.get(p),I=P.$yf(h)?h:h?.id,k=P.$yf(m?.source)?m?.source:m?.source?.id;if(I===k)if(s.add(p),this.a.delete(p),e.$yn.test(p))delete this.d[p],delete this.b.properties[p];else{const d=this.d[p];d&&(this.w(p,d),this.r(p,d))}}this.u()}deltaConfiguration(n){let s=!1;const c=new Set;n.removedDefaults&&(this.l(n.removedDefaults,c),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,c),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,c),n.addedConfigurations&&this.n(n.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,c){n.forEach(h=>{this.p(h,s,h.extensionInfo,h.restrictedProperties,void 0,c),this.c.push(h),this.q(h)})}o(n,s){const c=h=>{if(h.properties)for(const p in h.properties){s.add(p);const m=this.d[p];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[p],this.s(p,h.properties[p])}h.allOf?.forEach(p=>c(p))};for(const h of n){c(h);const p=this.c.indexOf(h);p!==-1&&this.c.splice(p,1)}}p(n,s=!0,c,h,p=3,m){p=P.$Hf(n.scope)?p:n.scope;const I=n.properties;if(I)for(const d in I){const y=I[d];if(s&&u(d,y)){delete I[d];continue}if(y.source=c,y.defaultDefaultValue=I[d].default,this.w(d,y),e.$yn.test(d)?y.scope=void 0:(y.scope=P.$Hf(y.scope)?p:y.scope,y.restricted=P.$Hf(y.restricted)?!!h?.includes(d):y.restricted),I[d].hasOwnProperty("included")&&!I[d].included){this.f[d]=I[d],delete I[d];continue}else this.d[d]=I[d],I[d].policy?.name&&this.e.set(I[d].policy.name,d);!I[d].deprecationMessage&&I[d].markdownDeprecationMessage&&(I[d].deprecationMessage=I[d].markdownDeprecationMessage),m.add(d)}const k=n.allOf;if(k)for(const d of k)this.p(d,s,c,h,p,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=c=>{const h=c.properties;if(h)for(const m in h)this.r(m,h[m]);c.allOf?.forEach(s)};s(n)}r(n,s){switch(e.$pn.properties[n]=s,s.scope){case 1:e.$qn.properties[n]=s;break;case 2:e.$rn.properties[n]=s;break;case 6:e.$sn.properties[n]=s;break;case 3:e.$tn.properties[n]=s;break;case 4:e.$un.properties[n]=s;break;case 5:e.$un.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.$pn.properties[n],s.scope){case 1:delete e.$qn.properties[n];break;case 2:delete e.$rn.properties[n];break;case 6:delete e.$sn.properties[n];break;case 3:delete e.$tn.properties[n];break;case 4:case 5:delete e.$un.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$vn};this.w(s,c),e.$pn.properties[s]=c,e.$qn.properties[s]=c,e.$rn.properties[s]=c,e.$sn.properties[s]=c,e.$tn.properties[s]=c,e.$un.properties[s]=c}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=n,e.$qn.patternProperties[e.$xn]=n,e.$rn.patternProperties[e.$xn]=n,e.$sn.patternProperties[e.$xn]=n,e.$tn.patternProperties[e.$xn]=n,e.$un.patternProperties[e.$xn]=n,this.i.fire()}w(n,s){const c=this.a.get(n);let h=c?.value,p=c?.source;P.$Ff(h)&&(h=s.defaultDefaultValue,p=void 0),P.$Ff(h)&&(h=i(s.type)),s.default=h,s.defaultValueSource=p}}const b="\\[([^\\]]+)\\]",v=new RegExp(b,"g");e.$xn=`^(${b})+$`,e.$yn=new RegExp(e.$xn);function f(l){const n=[];if(e.$yn.test(l)){let s=v.exec(l);for(;s?.length;){const c=s[1].trim();c&&n.push(c),s=v.exec(l)}}return(0,E.$Lb)(n)}e.$zn=f;function t(l){return l.reduce((n,s)=>`${n}[${s}]`,"")}e.$An=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=i;const r=new o;D.$jn.add(e.$on.Configuration,r);function u(l,n){return l.trim()?e.$yn.test(l)?M.localize(7,null,l):r.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):n.policy?.name&&r.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,l,n.policy?.name,r.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$Cn=u;function a(){const l=[],n=r.getConfigurationProperties();for(const s of Object.keys(n))l.push([s,n[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Dn=a}),define(Ae[188],Re([1,0,18,5,118,6,28,26,16,2,46,99,31]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function b(s){return Object.isFrozen(s)?s:$.$8m(s)}class v{constructor(c={},h=[],p=[],m){this.b=c,this.c=h,this.d=p,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(h=>{if(h instanceof v)return h;const p=new f("");return p.parseRaw(h),p.configurationModel});this.f=c.reduce((h,p)=>p===h?p:h.merge(p),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$ri)(this.contents,c):this.contents}inspect(c,h){const p=this.rawConfiguration.getValue(c),m=h?this.rawConfiguration.getOverrideValue(c,h):void 0,I=h?this.rawConfiguration.override(h).getValue(c):p;return{value:p,override:m,merged:I}}getOverrideValue(c,h){const p=this.i(h);return p?c?(0,A.$ri)(p,c):p:void 0}getKeysForOverrideIdentifier(c){const h=[];for(const p of this.overrides)p.identifiers.includes(c)&&h.push(...p.keys);return E.$Lb(h)}getAllOverrideIdentifiers(){const c=[];for(const h of this.overrides)c.push(...h.identifiers);return E.$Lb(c)}override(c){let h=this.a.get(c);return h||(h=this.g(c),this.a.set(c,h)),h}merge(...c){const h=$.$7m(this.contents),p=$.$7m(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of c)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(h,k.contents);for(const d of k.overrides){const[y]=p.filter(w=>E.$tb(w.identifiers,d.identifiers));y?(this.h(y.contents,d.contents),y.keys.push(...d.keys),y.keys=E.$Lb(y.keys)):p.push($.$7m(d))}for(const d of k.keys)m.indexOf(d)===-1&&m.push(d)}return new v(h,m,p,I.every(k=>k instanceof v)?void 0:I)}g(c){const h=this.i(c);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const p={};for(const m of E.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[m];const k=h[m];k&&(typeof I=="object"&&typeof k=="object"?(I=$.$7m(I),this.h(I,k)):I=k),p[m]=I}return new v(p,this.keys,this.overrides)}h(c,h){for(const p of Object.keys(h)){if(p in c&&D.$Af(c[p])&&D.$Af(h[p])){this.h(c[p],h[p]);continue}c[p]=$.$7m(h[p])}}i(c){let h=null,p=null;const m=I=>{I&&(p?this.h(p,I):p=$.$7m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?h=I.contents:I.identifiers.includes(c)&&m(I.contents);return m(h),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,h){this.j(c,h,!0)}setValue(c,h){this.j(c,h,!1)}removeValue(c){const h=this.keys.indexOf(c);h!==-1&&(this.keys.splice(h,1),(0,A.$qi)(this.contents,c),S.$yn.test(c)&&this.overrides.splice(this.overrides.findIndex(p=>E.$tb(p.identifiers,(0,S.$zn)(c))),1))}j(c,h,p){(0,A.$pi)(this.contents,c,h,m=>console.error(m)),p=p||this.keys.indexOf(c)===-1,p&&this.keys.push(c),S.$yn.test(c)&&this.overrides.push({identifiers:(0,S.$zn)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$oi)(this.contents[c],m=>console.error(m))})}}e.$En=v;class f{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,h){if(!D.$Hf(c)){const p=this.g(c);this.parseRaw(p,h)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,h){this.a=c;const{contents:p,keys:m,overrides:I,restricted:k,hasExcludedProperties:d}=this.h(c,h);this.b=new v(p,m,I,d?[c]:void 0),this.c=k||[]}g(c){let h={},p=null,m=[];const I=[],k=[];function d(w){Array.isArray(m)?m.push(w):p!==null&&(m[p]=w)}const y={onObjectBegin:()=>{const w={};d(w),I.push(m),m=w,p=null},onObjectProperty:w=>{p=w},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const w=[];d(w),I.push(m),m=w,p=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:d,onError:(w,C,j)=>{k.push({error:w,offset:C,length:j})}};if(c)try{P.$4m(c,y),h=m[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return h}h(c,h){const p=o.$jn.as(S.$on.Configuration).getConfigurationProperties(),m=this.i(c,p,!0,h);c=m.raw;const I=(0,A.$oi)(c,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),k=Object.keys(c),d=this.j(c,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:I,keys:k,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(c,h,p,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const k={},d=[];for(const y in c)if(S.$yn.test(y)&&p){const w=this.i(c[y],h,!1,m);k[y]=w.raw,I=I||w.hasExcludedProperties,d.push(...w.restricted)}else{const w=h[y],C=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&d.push(y),!m.exclude?.includes(y)&&(m.include?.includes(y)||(C===void 0||m.scopes===void 0||m.scopes.includes(C))&&!(m.skipRestricted&&w?.restricted))?k[y]=c[y]:I=!0}return{raw:k,restricted:d,hasExcludedProperties:I}}j(c,h){const p=[];for(const m of Object.keys(c))if(S.$yn.test(m)){const I={};for(const k in c[m])I[k]=c[m][k];p.push({identifiers:(0,S.$zn)(m),keys:Object.keys(I),contents:(0,A.$oi)(I,h)})}return p}}e.$Fn=f;class t extends M.$Rc{constructor(c,h,p,m){super(),this.c=c,this.f=h,this.g=m,this.b=this.B(new L.$Nd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(p.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&p.isEqual(I.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=t;class i{constructor(c,h,p,m,I,k,d,y,w,C,j,B,W){this.a=c,this.b=h,this.c=p,this.overrideIdentifiers=m,this.d=I,this.f=k,this.g=d,this.h=y,this.i=w,this.j=C,this.k=j,this.l=B,this.m=W}get value(){return b(this.c)}n(c,h,p){const m=c.inspect(h,p);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(c,h,p,m,I=new v,k=new v,d=new R.$zc,y=new v,w=new R.$zc){this.c=c,this.d=h,this.f=p,this.g=m,this.h=I,this.i=k,this.j=d,this.l=y,this.m=w,this.a=null,this.b=new R.$zc,this.n=null}getValue(c,h,p){return this.q(c,h,p).getValue(c)}updateValue(c,h,p={}){let m;p.resource?(m=this.m.get(p.resource),m||(m=new v,this.m.set(p.resource,m))):m=this.l,h===void 0?m.removeValue(c):m.setValue(c,h),p.resource||(this.a=null)}inspect(c,h,p){const m=this.q(c,h,p),I=this.u(h.resource,p),k=h.resource?this.m.get(h.resource)||this.l:this.l,d=new Set;for(const y of m.overrides)for(const w of y.identifiers)m.getOverrideValue(c,w)!==void 0&&d.add(w);return new i(c,h,m.getValue(c),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,I||void 0,k)}keys(c){const h=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,h){this.j.set(c,h),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,h){const p=[];if(!h){const{added:m,updated:I,removed:k}=l(this.c,c);h=[...m,...I,...k]}for(const m of h)for(const I of(0,S.$zn)(m)){const k=this.c.getKeysForOverrideIdentifier(I),d=c.getKeysForOverrideIdentifier(I),y=[...d.filter(w=>k.indexOf(w)===-1),...k.filter(w=>d.indexOf(w)===-1),...k.filter(w=>!$.$$m(this.c.override(I).getValue(w),c.override(I).getValue(w)))];p.push([I,y])}return this.updateDefaultConfiguration(c),{keys:h,overrides:p}}compareAndUpdatePolicyConfiguration(c){const{added:h,updated:p,removed:m}=l(this.d,c),I=[...h,...p,...m];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:h,updated:p,removed:m,overrides:I}=l(this.applicationConfiguration,c),k=[...h,...p,...m];return k.length&&this.updateApplicationConfiguration(c),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:h,updated:p,removed:m,overrides:I}=l(this.localUserConfiguration,c),k=[...h,...p,...m];return k.length&&this.updateLocalUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:h,updated:p,removed:m,overrides:I}=l(this.remoteUserConfiguration,c),k=[...h,...p,...m];return k.length&&this.updateRemoteUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:h,updated:p,removed:m,overrides:I}=l(this.workspaceConfiguration,c),k=[...h,...p,...m];return k.length&&this.updateWorkspaceConfiguration(c),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(c,h){const p=this.p.get(c),{added:m,updated:I,removed:k,overrides:d}=l(p,h),y=[...m,...I,...k];return(y.length||!p)&&this.updateFolderConfiguration(c,h),{keys:y,overrides:d}}compareAndDeleteFolderConfiguration(c){const h=this.p.get(c);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:p,updated:m,removed:I,overrides:k}=l(h,void 0);return{keys:[...p,...m,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,h,p){let m=this.r(h,p);return h.overrideIdentifier&&(m=m.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(m=m.merge(this.d)),m}r({resource:c},h){let p=this.s();if(h&&c){const m=h.getFolder(c);m&&(p=this.t(m.uri)||p);const I=this.m.get(c);I&&(p=p.merge(I))}return p}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let h=this.b.get(c);if(!h){const p=this.s(),m=this.j.get(c);m?(h=p.merge(m),this.b.set(c,h)):h=p}return h}u(c,h){if(h&&c){const p=h.getFolder(c);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,h)=>{const{contents:p,overrides:m,keys:I}=this.j.get(h);return c.push([h,{contents:p,overrides:m,keys:I}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(h=>c.add(h)),this.userConfiguration.keys.forEach(h=>c.add(h)),this.i.keys.forEach(h=>c.add(h)),this.j.forEach(h=>h.keys.forEach(p=>c.add(p))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(p=>c.add(p))),[...c.values()]}w(c){const h=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(p=>h.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(p=>h.add(p)),this.i.getKeysForOverrideIdentifier(c).forEach(p=>h.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(c).forEach(m=>h.add(m))),[...h.values()]}static parse(c){const h=this.x(c.defaults),p=this.x(c.policy),m=this.x(c.application),I=this.x(c.user),k=this.x(c.workspace),d=c.folders.reduce((y,w)=>(y.set(g.URI.revive(w[0]),this.x(w[1])),y),new R.$zc);return new r(h,p,m,I,new v,k,d,new v,new R.$zc)}static x(c){return new v(c.contents,c.keys,c.overrides)}}e.$Hn=r;function u(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const c=new Set,h=new Map;for(const m of s)m.keys.forEach(I=>c.add(I)),m.overrides.forEach(([I,k])=>{const d=(0,R.$wc)(h,I,new Set);k.forEach(y=>d.add(y))});const p=[];return h.forEach((m,I)=>p.push([I,[...m.values()]])),{keys:[...c.values()],overrides:p}}e.$In=u;class a{constructor(c,h,p,m){this.change=c,this.f=h,this.g=p,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of c.keys)this.affectedKeys.add(I);for(const[,I]of c.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(c,h){const p=this.a+c,m=this.d.indexOf(p);if(m<0)return!1;const I=m+p.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(h){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,h,this.f?.workspace):void 0,y=this.g.getValue(c,h,this.h);return!$.$$m(d,y)}return!0}}e.$Jn=a;function l(s,c){const{added:h,removed:p,updated:m}=n(c?.rawConfiguration,s?.rawConfiguration),I=[],k=s?.getAllOverrideIdentifiers()||[],d=c?.getAllOverrideIdentifiers()||[];if(c){const y=d.filter(w=>!k.includes(w));for(const w of y)I.push([w,c.getKeysForOverrideIdentifier(w)])}if(s){const y=k.filter(w=>!d.includes(w));for(const w of y)I.push([w,s.getKeysForOverrideIdentifier(w)])}if(c&&s){for(const y of k)if(d.includes(y)){const w=n({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:c.getOverrideValue(void 0,y)||{},keys:c.getKeysForOverrideIdentifier(y)});I.push([y,[...w.added,...w.removed,...w.updated]])}}return{added:h,removed:p,updated:m,overrides:I}}function n(s,c){const h=s?c?s.keys.filter(I=>c.keys.indexOf(I)===-1):[...s.keys]:[],p=c?s?c.keys.filter(I=>s.keys.indexOf(I)===-1):[...c.keys]:[],m=[];if(s&&c){for(const I of c.keys)if(s.keys.indexOf(I)!==-1){const k=(0,A.$ri)(c.contents,I),d=(0,A.$ri)(s.contents,I);$.$$m(k,d)||m.push(I)}}return{added:h,removed:p,updated:m}}}),define(Ae[100],Re([1,0,11,4]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,L.$Ph)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=M;class R{constructor(S,o){this.host=S,this.port=o,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class D extends E.$ab{static isNotAvailable(S){return S instanceof D&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof D&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof D&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof D&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof D&&S.isHandled}constructor(S,o=$.Unknown,b){super(S),this._message=S,this._code=o,this._detail=b,this.isHandled=o===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Sk=D;function g(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$Tk=g}),define(Ae[55],Re([1,0,14]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function L(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}e.$Uk=L;function P(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$Vk=P;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Wk=M;function R(g){const{host:A,port:S}=D(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$Xk=R;function $(g,A){let{host:S,port:o}=D(g);return typeof o>"u"&&(o=A),{host:S,port:o}}e.$Yk=$;function D(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const o=g.match(/(.*):(\d+)$/);return o?{host:o[1],port:parseInt(o[2],10)}:{host:g,port:void 0}}}),define(Ae[21],Re([1,0,13,4,55]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$4l=M,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const r=typeof t=="string"?t:t.value,u=typeof i=="string"?i:i.value;return E.$2e(r,u)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$6l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$7l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=A;function S(f){return o(f)}e.$9l=S;function o(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$0l=o;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$$l=b;function v(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$Vk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$_l=v,e.$am=(0,L.$Ph)("IBuiltinExtensionsScannerService")}),define(Ae[101],Re([1,0,11,21]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const D of R){const g=this.readActivationEvents(D);g.length>0&&($[L.$6l.toKey(D.identifier)]=g)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return $;for(const D in R.contributes){const g=this.a.get(D);if(!g)continue;const A=R.contributes[D],S=Array.isArray(A)?A:[A];try{g(S,$)}catch(o){(0,E.$Z)(o)}}return $}}e.$2E=P,e.$3E=new P}),define(Ae[189],Re([1,0,23,73,37]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function M(D){if(E.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,g,A,S,o,b,v,f,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=v,i.sessionID=(0,P.$eg)()+Date.now(),i.commitHash=S,i.version=o,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,E.$i)(E.$u),i["common.nodePlatform"]=L.$cc,i["common.nodeArch"]=A,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let r=0;const u=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),E.$m&&(i["common.snap"]="true");const a=M(g);return a&&(i["common.platformDetail"]=a),i}e.$ko=R;function $(D){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return D.some(S=>A===S)}e.$lo=$}),define(Ae[190],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,E.$Ph)("telemetryService"),e.$dl=(0,E.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ae[56],Re([1,0,26,16,5,46,55,189,190]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class g{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$mo=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=A,e.$oo=new A;class S{async publicLog(p,m,I){}async publicLogError(p,m,I){}}e.$po=S,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function o(h,p){return P.Event.debounce(p.onDidChangeConfiguration,(I,k)=>{const d=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:d}},1e3,!0)(I=>{I.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.$mi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$to=o;function b(h,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!h.enableTelemetry)}e.$uo=b;function v(h,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.$vo=v;function f(h){const p=h.getValue(D.$kl),m=h.getValue(D.$ll);if(h.getValue(D.$ml)===!1||m===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=f;function t(h){const p={},m={},I={};u(h,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const d=I[k];typeof d=="number"?m[k]=d:typeof d=="boolean"?m[k]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${d.length}`),p[k]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(p[k]=d)}return{properties:p,measurements:m}}e.$xo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(h){if(!h)return"none";const p=(0,R.$Vk)(h);return i.has(p)?p:"other"}e.$yo=r;function u(h,p,m=0,I){if(h)for(const k of Object.getOwnPropertyNames(h)){const d=h[k],y=I?I+k:k;Array.isArray(d)?p[y]=(0,E.$_m)(d):d instanceof Date?p[y]=d.toISOString():(0,L.$Af)(d)?m<2?u(d,p,m+1,y+"."):p[y]=(0,E.$_m)(d):p[y]=d}}function a(h,p){const m=h.msftInternalDomains||[],I=p.getValue("telemetry.internalTesting");return(0,$.$lo)(m)||I}e.$zo=a;function l(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.$Ao=l;function n(h,p){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let m=h;const I=[];for(const w of p)for(;;){const C=w.exec(h);if(!C)break;I.push([C.index,w.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(m="";;){const w=d.exec(h);if(!w)break;const C=I.some(([j,B])=>w.index<B&&j<d.lastIndex);!k.test(w[0])&&!C&&(m+=h.substring(y,w.index)+"<REDACTED: user-file-path>",y=d.lastIndex)}return y<h.length&&(m+=h.substr(y)),m}function s(h){if(!h)return h;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of p)if(m.regex.test(h))return`<REDACTED: ${m.label}>`;return h}function c(h,p){return(0,E.$9m)(h,m=>{if(m instanceof g||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=n(I,p);for(const k of p)I=I.replace(k,"");return I=s(I),I}})}e.$Bo=c}),define(Ae[191],Re([1,0,13,95,21,23,2,11,73,56]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function A(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,E.$We)(c.id,h.id)===0}e.$Co=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class o{static create(h){const p=h.manifest?h.manifest.version:h.version,m=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new o(h.identifier,p,m)}static parse(h){const p=S.exec(h);return p&&p[1]&&p[2]?new o({id:p[1]},p[2],p[4]||void 0):null}constructor(h,p,m="undefined"){this.version=p,this.targetPlatform=m,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof o?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$Do=o;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(c){const h=b.exec(c);return h&&h[1]?[t(h[1]),h[2]]:[t(c),void 0]}e.$Eo=v;function f(c,h){return`${c}.${h}`}e.$Fo=f;function t(c){return c.toLowerCase()}e.$Go=t;function i(c,h){return t(f(c??P.$2l,h))}e.$Ho=i;function r(c,h){const p=[],m=I=>{for(const k of p)if(k.some(d=>A(h(d),h(I))))return k;return null};for(const I of c){const k=m(I);k?k.push(I):p.push([I])}return p}e.$Io=r;function u(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Jo=u;function a(c){return{id:new g.$mo(c.identifier.id),name:new g.$mo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Ko=a,e.$Lo=new P.$6l("pprice.better-merge");function l(c,h){const p=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&p.every(k=>!A(k.identifier,{id:I}))){const k=c.filter(d=>A(d.identifier,{id:I}));k.length===1&&(p.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$Mo=l;async function n(c,h){if(!M.$l)return!1;let p;try{p=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){h.debug("Error while getting the os-release file.",(0,$.$9)(I))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(c,h){const p=await n(c,h),m=(0,L.$9n)(p?"alpine":M.$u,D.$dc);return h.debug("ComputeTargetPlatform:",m),m}e.$No=s}),define(Ae[192],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=e.$qr=e.$pr=e.$or=e.$nr=void 0;function E(D){return[...D.entries()]}e.$nr=E;function L(D){return D?[...D.entries()]:[]}e.$or=L;function P(D){return new Map(D)}e.$pr=P;function M(D){return new Map(D??[])}e.$qr=M;function R(D){return Array.from(D.entries()).map(g=>[g[0],E(g[1].map),L(g[1].descriptionMap)])}e.$rr=R;function $(D){return new Map(D.map(g=>[g[0],{map:P(g[1]),descriptionMap:M(g[2])}]))}e.$sr=$}),define(Ae[193],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,R=5){const $=M(D=>{const g=typeof D=="string"?D:D.data;let A=this.a.get(P);if(A){A.data.push(g);return}const S=setTimeout(()=>this.flushBuffer(P),R);A={data:[g],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(P),$.dispose()}},this.a.set(P,A)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$elb=E}),define(Ae[194],Re([1,0,12,89,44,5,16,2,154,72,31]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.IconFontDefinition=e.IconContribution=e.$8v=void 0,e.$8v={IconContribution:"base.contributions.icons"};var S;(function(a){function l(n,s){let c=n.defaults;for(;P.ThemeIcon.isThemeIcon(c);){const h=v.getIcon(c.id);if(!h)return;c=h.defaults}return c}a.getDefinition=l})(S||(e.IconContribution=S={}));var o;(function(a){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(c=>({format:c.format,location:c.location.toString()}))}}a.toJSONObject=l;function n(s){const c=h=>(0,R.$yf)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,R.$yf)(h.format)&&(0,R.$yf)(h.location)))return{weight:c(s.weight),style:c(s.style),src:s.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}a.fromJSONObject=n})(o||(e.IconFontDefinition=o={}));class b{constructor(){this.a=new M.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,n,s,c){const h=this.b[l];if(h){if(s&&!h.description){h.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return h}const p={id:l,description:s,defaults:n,deprecationMessage:c};this.b[l]=p;const m={$ref:"#/definitions/icons"};return c&&(m.deprecationMessage=c),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const n=this.e.enum.indexOf(l);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,n){const s=this.f[l];return s||(this.f[l]=n,this.a.fire(),n)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(h,p)=>h.id.localeCompare(p.id),n=h=>{for(;P.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(h=>this.b[h]);for(const h of c.filter(p=>!!p.description).sort(l))s.push(`|<i class="${n(h)}"></i>|${h.id}|${P.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of c.filter(p=>!P.ThemeIcon.isThemeIcon(p.defaults)).sort(l))s.push(`|<i class="${n(h)}"></i>|${h.id}|`);return s.join(`
`)}}const v=new b;A.$jn.add(e.$8v.IconContribution,v);function f(a,l,n,s){return v.registerIcon(a,l,n,s)}e.$9v=f;function t(){return v}e.$0v=t;function i(){const a=(0,L.$Sj)();for(const l in a){const n="\\"+a[l].toString(16);v.registerIcon(l,{fontCharacter:n})}}i(),e.$$v="vscode://schemas/icons";const r=A.$jn.as(g.$kn.JSONContribution);r.registerSchema(e.$$v,v.getIconSchema());const u=new E.$6g(()=>r.notifySchemaChanged(e.$$v),200);v.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$_v=f("widget-close",L.$Uj.close,(0,D.localize)(2,null)),e.$aw=f("goto-previous-location",L.$Uj.arrowUp,(0,D.localize)(3,null)),e.$bw=f("goto-next-location",L.$Uj.arrowDown,(0,D.localize)(4,null)),e.$cw=P.ThemeIcon.modify(L.$Uj.sync,"spin"),e.$dw=P.ThemeIcon.modify(L.$Uj.loading,"spin")}),define(Ae[195],Re([1,0,5,46,4,15]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,P.$Ph)("tunnelService"),e.$bv=(0,P.$Ph)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function D(t){return!!t.forwardPort}e.$cv=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$dv=A,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$ev.indexOf(t)>=0}e.$fv=S,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(t){return e.$gv.indexOf(t)>=0}e.$hv=o;function b(t,i,r,u){if(r===1)return!1;if(r===2&&o(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(a?.length===4&&parseInt(a[1])>=18)return!1}return t<1024}e.$iv=b;class v{constructor(i,r,u){this.remoteAddress=i,this.localAddress=r,this.b=u,this.a=new E.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=v;let f=class{constructor(i,r){this.j=i,this.k=r,this.a=new E.$Nd,this.onTunnelOpened=this.a.event,this.b=new E.$Nd,this.onTunnelClosed=this.b.event,this.c=new E.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],r=Array.from(this.e.values());for(const u of r){const a=Array.from(u.values());for(const l of a){const n=await l.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,u,a,l){this.p(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:u,privacy:a,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(o(i)||S(i))&&(i=e.$ev[0]);const u=this.r(i,r);if(u)return++u.refcount,u.value}openTunnel(i,r,u,a,l,n=!1,s,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${u} on local port ${l}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),a||(a=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.s(h,r,u,a,l,n,s,c);return p?p.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,u),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==r||m.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const u=r.get(i.tunnelRemotePort);u&&(u.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async o(i,r,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const a=u.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),a}}async closeTunnel(i,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const u=this.e.get(i);if(u&&u.has(r)){const a=u.get(r);a.refcount=0,await this.o(i,r,a)}}p(i,r,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:u})}async q(i,r){const u=this.e.get(i);if(u){const a=u.get(r),l=a?await a.value:void 0;(!l||typeof l=="string")&&u.delete(r),u.size===0&&this.e.delete(i)}}r(i,r){const u=[i];S(i)?(u.push(...e.$ev),u.push(...e.$gv)):o(i)&&u.push(...e.$gv);const a=u.map(l=>this.e.get(l));for(const l of a){const n=l?.get(r);if(n)return n}}canTunnel(i){return!!A(i)}t(i,r,u,a,l,n,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${u} on local port ${a}.`);const c=u;this.i.add(c);const h=a===void 0?u:a,p={elevationRequired:l?this.isPortPrivileged(h):!1},m={remoteAddress:{host:r,port:u},localAddressPort:a,privacy:n,public:n?n!==$.Private:void 0,protocol:s},I=i.forwardPort(m,p);return I?(this.p(r,u,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),I}};e.$kv=f,e.$kv=f=Ke([Ve(0,M.$0i),Ve(1,L.$ji)],f)}),define(Ae[196],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$lv=void 0,e.$lv=(0,E.$Ph)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[197],Re([1,0,14]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0;function L(D){return D.scheme!==E.Schemas.file&&D.scheme!==E.Schemas.vscodeRemote}e.$ZJ=L;function P(D){if(D.folders.length)return D.folders.every(g=>L(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$1J=P;function M(D){return P(D)?.scheme}e.$2J=M;function R(D){return P(D)?.authority}e.$3J=R;function $(D){return P(D)!==void 0}e.$4J=$}),define(Ae[57],Re([1,0,155,20,50,25,2,4,14]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,$.$Ph)("contextService");function g(h){const p=h;return typeof p?.id=="string"&&R.URI.isUri(p.uri)}e.$Zh=g;function A(h){return typeof h?.id=="string"&&!g(h)&&!o(h)}e.$1h=A,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function S(h,p){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,L.$mc)(h)}:p?e.$2h:e.$3h;const m=h;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$4h=S;function o(h){const p=h;return typeof p?.id=="string"&&R.URI.isUri(p.configPath)}e.$5h=o;function b(h){const p=h;if(p?.uri)return{id:p.id,uri:R.URI.revive(p.uri)};const m=h;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(h?.id)return{id:h.id}}e.$6h=b;var v;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function f(h){const p=h;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$7h=f;function t(h){const p=h;return!!(p&&typeof p=="object"&&R.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$8h=t;class i{constructor(p,m,I,k,d){this.h=p,this.j=I,this.k=k,this.l=d,this.c=P.$Vh.forUris(this.l,()=>!0),this.folders=m}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=P.$Vh.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=i;class r{constructor(p,m){this.raw=m,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,M.$vg)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=r;function u(h){return new r({uri:h,index:0,name:(0,M.$rg)(h)},{uri:h.toString()})}e.$$h=u,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,E.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function a(h,p){return M.$mg.isEqualOrParent(h,p.untitledWorkspacesHome)}e.$di=a;function l(h){let p;return R.URI.isUri(h)?p=h:p=h.configuration,p?.scheme===D.Schemas.tmp}e.$ei=l,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(h){return h.id===e.$fi}e.$gi=n;function s(h,p){return!a(h,p)&&!l(h)}e.$hi=s;function c(h){return(typeof h=="string"?(0,L.$nc)(h):(0,M.$tg)(h))===e.$ai}e.$ii=c}),define(Ae[74],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Hcc=E}),define(Ae[41],Re([1,0,14,25,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new L.$kg($=>{const D=this.b.get($.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos($,D){D===null?this.b.delete($.scheme):this.b.set($.scheme,D)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Jcc=M,e.$Kcc=(0,P.$Ph)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=void 0,e.$KM=(0,E.$Ph)("IExtHostInitDataService")}),define(Ae[198],Re([1,0,161,15,185,27]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;let R=class extends P.$RN{constructor(D,g,A){const S=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",o=A.remote.isRemote?(0,E.localize)(0,null):D?(0,E.localize)(1,null):(0,E.localize)(2,null);super(g.createLogger(S,{name:o}))}};e.$Sec=R,e.$Sec=R=Ke([Ve(1,L.$$i),Ve(2,M.$KM)],R)}),define(Ae[199],Re([1,0,12]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0;class L{constructor(R,$,D){this.h=new Map,this.a=R,this.b=$,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new E.$6g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const S of g.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let D=this.f[R];return typeof D>"u"&&(D=$),D}update(R,$){this.f[R]=$;const D=this.h.get(R);if(D!==void 0)return D.p;const g=new E.$ch;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$adc=L;class P extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$bdc=P}),define(Ae[200],Re([1,0,5,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class P{constructor(R){this.c=R,this.a=new E.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,D,g){const S=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged($.value,D,g);this.b.fire(S)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire($.apiNotebook)}}e.$zec=P}),define(Ae[17],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0,e.$uM=(0,E.$Ph)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$vM=L}),define(Ae[201],Re([1,0,21,5]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class P{#e;constructor(R,$){this.b=new L.$Nd,this.onDidChange=this.b.event,this.a=E.$6l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$mdc=P}),define(Ae[58],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,E.$Ph)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Vcc=L}),define(Ae[202],Re([1,0,22]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=e.$Rcb=void 0;class L{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function P($,D){if(D.serializeBuffersForPostMessage){const g=new L,S=JSON.stringify($,(b,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(v)};if(ArrayBuffer.isView(v)){const f=M(v);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(v.buffer),view:{type:f,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),o=g.buffers.map(b=>{const v=new Uint8Array(b);return E.$be.wrap(v)});return{message:S,buffers:o}}else return{message:JSON.stringify($),buffers:[]}}e.$Rcb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,D){const g=D.map(o=>{const b=new ArrayBuffer(o.byteLength);return new Uint8Array(b).set(o.buffer),b}),A=D.length?(o,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const v=b,{index:f}=v,t=g[f];if(v.view)switch(v.view.type){case 1:return new Int8Array(t,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse($,A),arrayBuffers:g}}e.$Scb=R}),define(Ae[102],Re([1,0,170,16,2,6,4,31,40,14,38,133,30]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lE=e.$kE=e.$jE=e.EditorsOrder=e.$iE=e.CloseDirection=e.$hE=e.$gE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.EditorInputCapabilities=e.$0D=e.SaveReason=e.Verbosity=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=void 0,e.$XD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$YD={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$ZD="workbench.editor.sidebysideEditor",e.$1D="workbench.editors.textDiffEditor",e.$2D="workbench.editors.binaryResourceDiffEditor";var b;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var v;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function f(oe){const ye=oe;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$3D=f;function t(oe,ye,te){for(const V of te.visibleEditorPanes)if(V.group.id===ye&&oe.matches(V.input))return V.getViewState()}e.$4D=t;function i(oe){if(m(oe))return!1;const ye=oe;return P.URI.isUri(ye?.resource)}e.$5D=i;function r(oe){if(m(oe))return!1;const ye=oe;return ye?.original!==void 0&&ye.modified!==void 0}e.$6D=r;function u(oe){if(m(oe)||r(oe))return!1;const ye=oe;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$7D=u;function a(oe){if(m(oe))return!1;const ye=oe;return ye?ye.resource===void 0||ye.resource.scheme===g.Schemas.untitled||ye.forceUntitled===!0:!1}e.$8D=a;function l(oe){if(m(oe))return!1;const ye=oe;return P.URI.isUri(ye?.base?.resource)&&P.URI.isUri(ye?.input1?.resource)&&P.URI.isUri(ye?.input2?.resource)&&P.URI.isUri(ye?.result?.resource)}e.$9D=l;var n;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.a=new Map}registerSource(ye,te){let V=this.a.get(ye);return V||(V={source:ye,label:te},this.a.set(ye,V)),V.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$0D=new c;var h;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(h||(e.EditorInputCapabilities=h={}));class p extends M.$Rc{}e.$$D=p;function m(oe){return oe instanceof p}e.$_D=m;function I(oe){const ye=oe;return P.URI.isUri(ye?.preferredResource)}function k(oe){const ye=oe;return m(ye?.primary)&&m(ye?.secondary)}e.$aE=k;function d(oe){const ye=oe;return m(ye?.modified)&&m(ye?.original)}e.$bE=d;function y(oe,ye,te,V,Y){return ue(V,[(0,S.$zi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const _={...te,limits:{size:Number.MAX_VALUE}};oe.openEditor(ye,_)}}),(0,S.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Y.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:o.default.Warning})}e.$cE=y;function w(oe){return m(oe?.editor)}e.$dE=w;function C(oe){const ye=oe;return w(oe)&&ye?.group!==void 0}e.$eE=C;function j(oe){const ye=oe;return typeof ye?.groupId=="number"&&m(ye.editor)}e.$fE=j;var B;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var W;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(W||(e.GroupModelChangeKind=W={}));var U;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class F{getOriginalUri(ye,te){if(!ye)return;if(l(ye))return e.$hE.getOriginalUri(ye.result,te);if(te?.supportSideBySide){const{primary:Y,secondary:_}=this.a(ye);if(Y&&_){if(te?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(_,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===U.ANY)return this.getOriginalUri(Y,{filterByScheme:te.filterByScheme})??this.getOriginalUri(_,{filterByScheme:te.filterByScheme});ye=te.supportSideBySide===U.PRIMARY?Y:_}}if(r(ye)||u(ye)||l(ye))return;const V=I(ye)?ye.preferredResource:ye.resource;return!V||!te||!te.filterByScheme?V:this.b(V,te.filterByScheme)}a(ye){return k(ye)||u(ye)?{primary:ye.primary,secondary:ye.secondary}:d(ye)||r(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,te){if(!ye)return;if(l(ye))return e.$hE.getCanonicalUri(ye.result,te);if(te?.supportSideBySide){const{primary:Y,secondary:_}=this.a(ye);if(Y&&_){if(te?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(_,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===U.ANY)return this.getCanonicalUri(Y,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(_,{filterByScheme:te.filterByScheme});ye=te.supportSideBySide===U.PRIMARY?Y:_}}if(r(ye)||u(ye)||l(ye))return;const V=ye.resource;return!V||!te||!te.filterByScheme?V:this.b(V,te.filterByScheme)}b(ye,te){if(Array.isArray(te)){if(te.some(V=>ye.scheme===V))return ye}else if(te===ye.scheme)return ye}}var O;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function ee(oe,ye,te,V){if(!oe.isSticky(ye))return!1;switch(V.preventPinnedEditorClose){case"keyboardAndMouse":return te===O.MOUSE||te===O.KEYBOARD;case"mouse":return te===O.MOUSE;case"keyboard":return te===O.KEYBOARD}return!1}e.$gE=ee,e.$hE=new F;var X;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(ye){const te=this.a=ye.get(R.$Oh);for(const[V,Y]of this.c)this.e(V,Y,te);this.c.clear()}e(ye,te,V){const Y=V.createInstance(te);this.d.set(ye,Y)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,L.$Jf)(this.b)}registerEditorSerializer(ye,te){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,te,this.a):this.c.set(ye,te),(0,M.$Pc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}$.$jn.add(e.$XD.EditorFactory,new Ee);async function ke(oe,ye,te){return!oe||!oe.length?[]:await Promise.all(oe.map(async V=>{const Y=P.URI.revive(V.fileUri);if(!Y){te.info("Cannot resolve the path because it is not valid.",V);return}if(!await ye.canHandleResource(Y)){te.info("Cannot resolve the path because it cannot be handled",V);return}let pe=V.exists,$e=V.type;if(typeof pe!="boolean"||typeof $e!="number")try{$e=(await ye.stat(Y)).isDirectory?D.FileType.Directory:D.FileType.Unknown,pe=!0}catch(De){te.error(De),pe=!1}if(!pe&&V.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",V);return}if($e===D.FileType.Directory){te.info("Cannot resolve the path because it is a directory",V);return}const de={...V.options,pinned:!0};return pe?{resource:Y,options:de}:{resource:Y,options:de,forceUntitled:!0}}))}e.$iE=ke;var Pe;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function le(oe){const ye=oe;if(!ye)return!1;const te=ye;if(te.modified)return le(te.modified);const V=ye;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.$jE=le;function be(oe){return(0,A.$Bi)(oe)}e.$kE=be;function ue(oe,ye,te){const V=(0,A.$Ci)(oe,ye);return V.forceMessage=te?.forceMessage,V.forceSeverity=te?.forceSeverity,V.allowDialog=te?.allowDialog,V}e.$lE=ue}),define(Ae[203],Re([1,0,5,171,4,6,28,31,18,26,89,194]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wE=e.$vE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$uE=e.$tE=e.ViewContentGroups=e.$sE=e.$rE=e.ViewContainerLocation=e.Extensions=e.$qE=e.$pE=e.$oE=void 0,e.$oE="views",e.$pE=(0,L.localize)(0,null),e.$qE=(0,S.$9v)("default-view-icon",A.$Uj.window,(0,L.localize)(1,null));var o;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(o||(e.Extensions=o={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$rE=[0,1,2];function v(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$sE=v;class f extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(c,h,p){const m=this.get(c.id);if(m)return m;const I=c;return I.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,h,[]).push(I),p?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:h}),I}deregisterViewContainer(c){for(const h of this.g.keys()){const p=this.g.get(h),m=p?.indexOf(c);if(m!==-1){p?.splice(m,1),p.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(p=>p?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}$.$jn.add(o.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,c){const h=s.group??t.More,p=c.group??t.More;return h!==p?h.localeCompare(p):(s.order??5)-(c.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:p})=>this.r(h,p)),this.c.fire(c)}deregisterViews(c,h){const p=this.s(c,h);p.length&&this.f.fire({views:p,viewContainer:h})}moveViews(c,h){for(const p of this.m.keys())if(p!==h){const m=this.s(c,p);m.length&&(this.r(m,h),this.g.fire({views:m,from:p,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const p=(this.m.get(h)||[]).filter(m=>m.id===c)[0];if(p)return p}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(m=>m.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,M.$Pc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const p=new Map;for(const[m,I]of h)this.n.add(c,I),p.set(m,(0,M.$Pc)(()=>{this.n.delete(c,I),this.h.fire(c)}));return this.h.fire(c),p}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,p=>h.push(p)),h.sort(i)}r(c,h){let p=this.m.get(h);p||(p=[],this.m.set(h,p),this.j.push(h));for(const m of c){if(this.getView(m.id)!==null)throw new Error((0,L.localize)(2,null,m.id));p.push(m)}}s(c,h){const p=this.m.get(h);if(!p)return[];const m=[],I=[];for(const k of p)c.includes(k)?m.push(k):I.push(k);return m.length&&(I.length?this.m.set(h,I):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),m}}$.$jn.add(o.ViewsRegistry,new r),e.$tE=(0,P.$Ph)("viewsService"),e.$uE=(0,P.$Ph)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var a;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class l{constructor(c,h){this.c=!1,this.d=!1,(0,g.$0m)(this,c),this.d=!!h,this.resolve=async p=>{if(h&&!this.c){const m=await h(p);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$vE=l;class n extends Error{constructor(c){super((0,L.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$wE=n}),define(Ae[204],Re([1,0,2,29,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XE=e.$WE=void 0;function M(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof E.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(L.$ws.isIRange)}e.$WE=M;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(M)}e.$XE=R;var $;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var D;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$YE=(0,P.$Ph)("IChatService")}),define(Ae[205],Re([1,0,5,12,172]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Nd,this.n=new E.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,D,g,A){const S={command:$};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.s("request",S),typeof A=="number"){const o=setTimeout(()=>{clearTimeout(o);const b=this.f.get(S.seq);if(b){this.f.delete(S.seq);const v={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,P.localize)(0,null,A,$)};b(v)}},A)}return g&&this.f.set(S.seq,g),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,D){return $.type!=="event"||D.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,L.$Ug)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const D=$,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s($,D){D.type=$,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((D,g)=>$.set(g,D)),await(0,L.$Ug)(500),$.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ldb=M}),define(Ae[206],Re([1,0,173,33,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$_G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$$G=e.MemoryRangeType=e.$0G=e.State=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=void 0,e.$7F="workbench.view.debug",e.$8F="workbench.debug.variablesView",e.$9F="workbench.debug.watchExpressionsView",e.$0F="workbench.debug.callStackView",e.$$F="workbench.debug.loadedScriptsView",e.$_F="workbench.debug.breakPointsView",e.$aG="workbench.debug.disassemblyView",e.$bG="workbench.panel.repl",e.$cG="workbench.panel.repl.view",e.$dG=new L.$7i("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$eG=new L.$7i("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$fG=new L.$7i("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$gG="debugUx",e.$hG=new L.$7i(e.$gG,"default",{type:"string",description:E.localize(3,null)}),e.$iG=new L.$7i("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$jG=new L.$7i("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$kG=new L.$7i("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$lG=new L.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$mG=new L.$7i("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$nG=new L.$7i("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$oG=new L.$7i("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$pG=new L.$7i("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$qG=new L.$7i("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$rG=new L.$7i("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$sG=new L.$7i("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$tG=new L.$7i("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$uG=new L.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$vG=new L.$7i("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$wG=new L.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$xG=new L.$7i("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$yG=new L.$7i("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$zG=new L.$7i("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$AG=new L.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$BG=new L.$7i("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$CG=new L.$7i("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$DG=new L.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$EG=new L.$7i("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$FG=new L.$7i("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$GG=new L.$7i("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$HG=new L.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$IG=new L.$7i("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$JG=new L.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$KG=new L.$7i("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$LG=new L.$7i("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$MG=new L.$7i("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$NG=new L.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$OG=new L.$7i("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$PG=new L.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$QG=new L.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$RG=new L.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$SG=new L.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$TG=new L.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$UG=new L.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$VG=new L.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$WG=new L.$7i("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$XG=new L.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$YG=new L.$7i("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$ZG=new L.$7i("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$1G=new L.$7i("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$2G=new L.$7i("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$3G=new L.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$4G=new L.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=o=>E.localize(52,null,o);e.$5G=M,e.$6G="editor.contrib.debug",e.$7G="editor.contrib.breakpoint",e.$8G="debug",e.$9G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(R||(e.State=R={}));function $(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$0G=$;var D;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$$G="vscode-debug-memory";var g;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$_G=(0,P.$Ph)("debugService");var S;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ae[207],Re([1,0,13,2,20,26,14,29,19,18]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=void 0;const A=/{([^}]+)}/g;function S(k,d,y){return k.replace(A,function(w,C){return d&&C.length>0&&C[0]!=="_"?w:y&&y.hasOwnProperty(C)?y[C]:w})}e.$vF=S;function o(k){const d={};for(const y of Object.keys(k))y.startsWith("!")||(d[y]=k[y]);return d}e.$wF=o;function b(k){return k.configuration.request==="attach"&&!v(k)&&(!k.parentSession||b(k.parentSession))}e.$xF=b;function v(k){let d=k.configuration.type;if(d)return d==="vslsShare"&&(d=k.configuration.adapterProxy.configuration.type),(0,E.$2e)(d,"extensionhost")||(0,E.$2e)(d,"pwa-extensionhost")?k:k.parentSession?v(k.parentSession):void 0}e.$yF=v;function f(k){return k.type&&(k.label||k.program||k.runtime)}e.$zF=f;function t(k,d,y){let w,C=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=j.exec(k);){const W=B.index+1,U=W+B[0].length;if(W<=d&&U>=y){w=B[0],C=W;break}}if(w){const W=/\w+/g;let U=null;for(;(U=W.exec(w))&&!(U.index+1+C+U[0].length>=y););U&&(w=w.substring(0,W.lastIndex))}return w?{start:C,end:C+w.length-1}:{start:0,end:0}}e.$AF=t;async function i(k,d,y,w){if(k.evaluatableExpressionProvider.has(d)){const C=k.evaluatableExpressionProvider.ordered(d),j=(0,g.$Gb)(await Promise.all(C.map(async B=>{try{return await B.provideEvaluatableExpression(d,y,w??D.CancellationToken.None)}catch{return}})));if(j.length>0){let B=j[0].expression;const W=j[0].range;return B||(B=d.getLineContent(y.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:B}}}else{const C=d.getLineContent(y.lineNumber),{start:j,end:B}=t(C,y.column,y.column),W=C.substring(j-1,B);return{matchingExpression:W,range:new $.$ws(y.lineNumber,j,y.lineNumber,j+W.length)}}return null}e.$BF=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(k){return!!(k&&k.match(r))}e.$CF=u;function a(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(u(k.path))return L.URI.parse(k.path);if((0,P.$hc)(k.path))return L.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const d=L.URI.revive(k.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return k.path}function n(k,d){const y=d?a:l,w=(0,M.$7m)(k);return c(w,(C,j)=>{C&&j&&(j.path=y(j))}),w}e.$DF=n;function s(k,d){const y=d?a:l,w=(0,M.$7m)(k);return c(w,(C,j)=>{!C&&j&&(j.path=y(j))}),w}e.$EF=s;function c(k,d){switch(k.type){case"event":{const y=k;switch(y.event){case"output":d(!1,y.body.source);break;case"loadedSource":d(!1,y.body.source);break;case"breakpoint":d(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=k;switch(y.command){case"setBreakpoints":d(!0,y.arguments.source);break;case"breakpointLocations":d(!0,y.arguments.source);break;case"source":d(!0,y.arguments.source);break;case"gotoTargets":d(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(w=>d(!1,w));break;default:break}break}case"response":{const y=k;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(w=>d(!1,w.source));break;case"loadedSources":y.body.sources.forEach(w=>d(!1,w));break;case"scopes":y.body.scopes.forEach(w=>d(!1,w.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(w=>d(!1,w.source));break;case"setBreakpoints":y.body.breakpoints.forEach(w=>d(!1,w.source));break;case"disassemble":y.body?.instructions.forEach(C=>d(!1,C.location));break;default:break}break}}}function h(k){return k.filter(d=>!d.presentation?.hidden).sort((d,y)=>d.presentation?y.presentation?d.presentation.group?y.presentation.group?d.presentation.group!==y.presentation.group?d.presentation.group.localeCompare(y.presentation.group):p(d.presentation.order,y.presentation.order):-1:y.presentation.group?1:p(d.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$FF=h;function p(k,d){return typeof k!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:k-d}async function m(k,d){const y=k.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(y!=="none"&&(await d.saveAll(),y==="allEditorsInActiveGroup")){const w=d.activeEditorPane;w&&w.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:w.input,groupId:w.group.id})}await k.reloadConfiguration()}e.$GF=m;const I=(k,d)=>!k||!d?k===d:k.name===d.name&&k.path===d.path&&k.sourceReference===d.sourceReference;e.$HF=I}),define(Ae[75],Re([1,0,22,39,67,68,14,20,23,33]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",M.$Sr.latex,M.$Sr.markdown,"image/png","image/jpeg",M.$Sr.text],e.$oI=[M.$Sr.latex,M.$Sr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Sr.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var S;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var o;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(o||(e.NotebookCellExecutionState=o={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var v;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var f;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var u;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ee.join("")}]+`),Ee=7;function ke(ye,te){const V=te.toString(Ee),_=`${V.length<ee.length?ee[V.length-1]:"z"}${V}s${(0,E.$ve)(E.$be.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:O.scheme,fragment:_})}O.generate=ke;function Pe(ye){if(ye.scheme!==O.scheme)return;const te=ye.fragment.indexOf("s");if(te<0)return;const V=parseInt(ye.fragment.substring(0,te).replace(X,""),Ee),Y=(0,E.$ue)(ye.fragment.substring(te+1)).toString();if(!isNaN(V))return{handle:V,notebook:ye.with({scheme:Y,fragment:null})}}O.parse=Pe;function le(ye,te){return ye.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${te??""},${ye.scheme!==R.Schemas.file?ye.scheme:""}`})}O.generateCellOutputUri=le;function be(ye){if(ye.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const te=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!te)return;const V=te[1]&&te[1]!==""?te[1]:void 0,Y=te[2];return{outputId:V,notebook:ye.with({scheme:Y||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=be;function ue(ye,te,V){return O.generate(ye,te).with({scheme:V})}O.generateCellPropertyUri=ue;function oe(ye,te){if(ye.scheme===te)return O.parse(ye.with({scheme:O.scheme}))}O.parseCellPropertyUri=oe})(u||(e.CellUri=u={}));const a=O=>D.$j?O.replace(/\//g,"\\"):O;class l{constructor(ee=[],X=e.$nI){this.e=X,this.d=[...new Set(ee)].map(Ee=>({pattern:Ee,matches:L.$wj(a(Ee))}))}sort(ee){const X=new Map(P.Iterable.map(ee,ke=>[ke,a(ke)]));let Ee=[];for(const{matches:ke}of this.d)for(const[Pe,le]of X)if(ke(le)){Ee.push(Pe),X.delete(Pe);break}return X.size&&(Ee=Ee.concat([...X.keys()].sort((ke,Pe)=>this.e.indexOf(ke)-this.e.indexOf(Pe)))),Ee}prioritize(ee,X){const Ee=this.f(ee);if(Ee===-1){this.d.unshift({pattern:ee,matches:L.$wj(a(ee))});return}const ke=new Set(X.map(le=>this.f(le,Ee)));ke.delete(-1);const Pe=Array.from(ke).sort();this.d.splice(Ee+1,0,...Pe.map(le=>this.d[le]));for(let le=Pe.length-1;le>=0;le--)this.d.splice(Pe[le],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,X=this.d.length){const Ee=a(ee);for(let ke=0;ke<X;ke++)if(this.d[ke].matches(Ee))return ke;return-1}}e.$rI=l;function n(O,ee,X,Ee=(ke,Pe)=>ke===Pe){const ke=[];function Pe(ue,oe,ye){if(oe===0&&ye.length===0)return;const te=ke[ke.length-1];te&&te.start+te.deleteCount===ue?(te.deleteCount+=oe,te.toInsert.push(...ye)):ke.push({start:ue,deleteCount:oe,toInsert:ye})}let le=0,be=0;for(;;){if(le===O.length){Pe(le,0,ee.slice(be));break}if(be===ee.length){Pe(le,O.length-le,[]);break}const ue=O[le],oe=ee[be];if(Ee(ue,oe)){le+=1,be+=1;continue}X(oe)?(Pe(le,1,[]),le+=1):(Pe(le,0,[oe]),be+=1)}return ke}e.$sI=n,e.$tI=new g.$7i("notebookEditorCursorAtBoundary","none"),e.$uI=new g.$7i("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function c(O){const ee=O;return!!((typeof ee.include=="string"||L.$xj(ee.include))&&(typeof ee.exclude=="string"||L.$xj(ee.exclude)))}e.$vI=c;function h(O,ee,X){if(Array.isArray(O.viewType)&&O.viewType.indexOf(ee)>=0||O.viewType===ee)return!0;if(O.filenamePattern){const Ee=c(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,ke=c(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(L.$vj(Ee,(0,$.$mc)(X.fsPath).toLowerCase()))return!(ke&&L.$vj(ke,(0,$.$mc)(X.fsPath).toLowerCase()))}return!1}e.$wI=h,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var p;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class m{static{this.d="notebook/"}static create(ee){return`${m.d}${ee}`}static parse(ee){if(ee.startsWith(m.d))return ee.substring(m.d.length)}}e.$yI=m;function I(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$zI=I;const k=new TextDecoder;function d(O){const ee=[];let X=!1;for(const le of O)(ee.length===0||X)&&(ee.push(le),X=!0);let Ee=C(ee);const ke=E.$be.concat(ee.map(le=>E.$be.wrap(le))),Pe=F(ke);return Ee=Ee||Pe.byteLength!==ke.byteLength,{data:Pe,didCompression:Ee}}e.$AI=d,e.$BI=`${String.fromCharCode(27)}[A`;const y=e.$BI.split("").map(O=>O.charCodeAt(0)),w=10;function C(O){let ee=!1;return O.forEach((X,Ee)=>{if(Ee===0||X.length<e.$BI.length)return;const ke=O[Ee-1],Pe=X.subarray(0,e.$BI.length);if(Pe[0]===y[0]&&Pe[1]===y[1]&&Pe[2]===y[2]){const le=ke.lastIndexOf(w);if(le===-1)return;ee=!0,O[Ee-1]=ke.subarray(0,le),O[Ee]=X.subarray(e.$BI.length)}}),ee}function j(O){let ee=O;do O=ee,ee=O.replace(/[^\n]\x08/gm,"");while(ee.length<O.length);return O}function B(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const ee=O.match(/^(.*)\r+/m)[1];let X=O.match(/\r+(.*)$/m)[1];X=X+ee.slice(X.length,ee.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return O}const W="\b".charCodeAt(0),U="\r".charCodeAt(0);function F(O){return!O.buffer.includes(W)&&!O.buffer.includes(U)?O:E.$be.fromString(B(j(k.decode(O.buffer))))}}),define(Ae[7],Re([1,0,18,11,52,28,68,13,16,2,37,21,40,100,75]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v){"use strict";var f,t,i,r,u,a,l,n,s,c,h,p,m,I,k,d,y,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$jM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.TestRunProfileKind=e.TestResultState=e.$3L=e.$2L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$1L=e.$ZL=e.$YL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$XL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.ColorThemeKind=e.$RL=e.$QL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$PL=e.DebugConsoleMode=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$JL=e.$IL=e.FileChangeType=e.$HL=e.$GL=e.$FL=e.$EL=e.InlineCompletionTriggerKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.ConfigurationTarget=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$hL=e.ViewBadge=e.ProgressLocation=e.$gL=e.$fL=e.TaskScope=e.ShellQuoting=e.$eL=e.$dL=e.$cL=e.TaskPanelKind=e.TaskRevealKind=e.$bL=e.TerminalLocation=e.$aL=e.$_K=e.$$K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$0K=e.$9K=e.$8K=e.$7K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$6K=e.StatusBarAlignment=e.ViewColumn=e.$5K=e.$4K=e.$3K=e.$2K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$1K=e.$ZK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.LanguageStatusSeverity=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.CodeActionTriggerKind=e.$NK=e.$MK=e.SymbolTag=e.SymbolKind=e.$LK=e.DocumentHighlightKind=e.$KK=e.$JK=e.$IK=e.$HK=e.DiagnosticSeverity=e.DiagnosticTag=e.$GK=e.$FK=e.FileEditType=e.$EK=e.$DK=e.$CK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(z){return Object.assign(z,{apply:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const Se=se.length===1?[]:se[1];return Reflect.construct(z,Se,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const[Se,...He]=se;return Reflect.construct(z,He,Se.constructor)}}})}var j;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(j||(e.TerminalOutputAnchor=j={}));var B;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(B||(e.TerminalQuickFixType=B={}));let W=f=class{static from(...N){let se=N;return new f(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$vK=W,e.$vK=W=f=Ke([C],W);let U=t=class{static Min(...N){if(N.length===0)throw new TypeError;let se=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isBefore(se)&&(se=He)}return se}static Max(...N){if(N.length===0)throw new TypeError;let se=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isAfter(se)&&(se=He)}return se}static isPosition(N){if(!N)return!1;if(N instanceof t)return!0;const{line:se,character:Se}=N;return typeof se=="number"&&typeof Se=="number"}static of(N){if(N instanceof t)return N;if(this.isPosition(N))return new t(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,se){if(N<0)throw(0,L.$6)("line must be non-negative");if(se<0)throw(0,L.$6)("character must be non-negative");this.c=N,this.e=se}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,se=0){if(N===null||se===null)throw(0,L.$6)();let Se;return typeof N>"u"?Se=0:typeof N=="number"?Se=N:(Se=typeof N.lineDelta=="number"?N.lineDelta:0,se=typeof N.characterDelta=="number"?N.characterDelta:0),Se===0&&se===0?this:new t(this.line+Se,this.character+se)}with(N,se=this.character){if(N===null||se===null)throw(0,L.$6)();let Se;return typeof N>"u"?Se=this.line:typeof N=="number"?Se=N:(Se=typeof N.line=="number"?N.line:this.line,se=typeof N.character=="number"?N.character:this.character),Se===this.line&&se===this.character?this:new t(Se,se)}toJSON(){return{line:this.line,character:this.character}}};e.$wK=U,e.$wK=U=t=Ke([C],U);let F=i=class{static isRange(N){return N instanceof i?!0:N?U.isPosition(N.start)&&U.isPosition(N.end):!1}static of(N){if(N instanceof i)return N;if(this.isRange(N))return new i(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,se,Se,He){let Ze,st;if(typeof N=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"?(Ze=new U(N,se),st=new U(Se,He)):U.isPosition(N)&&U.isPosition(se)&&(Ze=U.of(N),st=U.of(se)),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this.c=Ze,this.e=st):(this.c=st,this.e=Ze)}contains(N){return i.isRange(N)?this.contains(N.start)&&this.contains(N.end):U.isPosition(N)?!(U.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const se=U.Max(N.start,this.c),Se=U.Min(N.end,this.e);if(!se.isAfter(Se))return new i(se,Se)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const se=U.Min(N.start,this.c),Se=U.Max(N.end,this.end);return new i(se,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,se=this.end){if(N===null||se===null)throw(0,L.$6)();let Se;return N?U.isPosition(N)?Se=N:(Se=N.start||this.start,se=N.end||this.end):Se=this.start,Se.isEqual(this.c)&&se.isEqual(this.end)?this:new i(Se,se)}toJSON(){return[this.start,this.end]}};e.$xK=F,e.$xK=F=i=Ke([C],F);let O=r=class extends F{static isSelection(N){return N instanceof r?!0:N?F.isRange(N)&&U.isPosition(N.anchor)&&U.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,se,Se,He){let Ze,st;if(typeof N=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"?(Ze=new U(N,se),st=new U(Se,He)):U.isPosition(N)&&U.isPosition(se)&&(Ze=U.of(N),st=U.of(se)),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st),this.f=Ze,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$yK=O,e.$yK=O=r=Ke([C],O);const ee=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,L.$6)("connectionToken")};class X{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,se,Se){if(typeof N!="string"||N.length===0)throw(0,L.$6)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.$6)("port");typeof Se<"u"&&ee(Se),this.host=N,this.port=Math.round(se),this.connectionToken=Se}}e.$zK=X;class Ee{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,se){this.makeConnection=N,this.connectionToken=se,typeof se<"u"&&ee(se)}}e.$AK=Ee;class ke extends Error{static NotAvailable(N,se){return new ke(N,b.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(N){return new ke(N,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,se=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(N),this._message=N,this._code=se,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$BK=ke;var Pe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var le;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(le||(e.EnvironmentVariableMutatorType=le={}));let be=u=class{static isTextEdit(N){return N instanceof u?!0:N?F.isRange(N)&&typeof N.newText=="string":!1}static replace(N,se){return new u(N,se)}static insert(N,se){return u.replace(new F(N,N),se)}static delete(N){return u.replace(N,"")}static setEndOfLine(N){const se=new u(new F(new U(0,0),new U(0,0)),"");return se.newEol=N,se}get range(){return this.c}set range(N){if(N&&!F.isRange(N))throw(0,L.$6)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,L.$6)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,L.$6)("newEol");this.f=N}constructor(N,se){this.c=N,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$CK=be,e.$CK=be=u=Ke([C],be);let ue=a=class{static isNotebookCellEdit(N){return N instanceof a?!0:N?xt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,se){return new a(N,se)}static insertCells(N,se){return new a(new xt(N,N),se)}static deleteCells(N){return new a(N,[])}static updateCellMetadata(N,se){const Se=new a(new xt(N,N),[]);return Se.newCellMetadata=se,Se}static updateNotebookMetadata(N){const se=new a(new xt(0,0),[]);return se.newNotebookMetadata=N,se}constructor(N,se){this.range=N,this.newCells=se}};e.$DK=ue,e.$DK=ue=a=Ke([C],ue);class oe{static isSnippetTextEdit(N){return N instanceof oe?!0:N?F.isRange(N.range)&&V.isSnippetString(N.snippet):!1}static replace(N,se){return new oe(N,se)}static insert(N,se){return oe.replace(new F(N,N),se)}constructor(N,se){this.range=N,this.snippet=se}}e.$EK=oe;var ye;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(ye||(e.FileEditType=ye={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,se,Se,He){this.c.push({_type:1,from:N,to:se,options:Se,metadata:He})}createFile(N,se,Se){this.c.push({_type:1,from:void 0,to:N,options:se,metadata:Se})}deleteFile(N,se,Se){this.c.push({_type:1,from:N,to:void 0,options:se,metadata:Se})}e(N,se,Se){this.c.push({_type:3,metadata:Se,uri:N,edit:{editType:5,metadata:se},notebookMetadata:se})}f(N,se,Se,He){const Ze=se.start,st=se.end;(Ze!==st||Se.length>0)&&this.c.push({_type:5,uri:N,index:Ze,count:st-Ze,cells:Se,metadata:He})}g(N,se,Se,He){this.c.push({_type:3,metadata:He,uri:N,edit:{editType:3,index:se,metadata:Se}})}replace(N,se,Se,He){this.c.push({_type:2,uri:N,edit:new be(se,Se),metadata:He})}insert(N,se,Se,He){this.replace(N,new F(se,se),Se,He)}delete(N,se,Se){this.replace(N,se,"",Se)}has(N){return this.c.some(se=>se._type===2&&se.uri.toString()===N.toString())}set(N,se){if(se)for(const Se of se){if(!Se)continue;let He,Ze;Array.isArray(Se)?(He=Se[0],Ze=Se[1]):He=Se,ue.isNotebookCellEdit(He)?He.newCellMetadata?this.g(N,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(N,He.newNotebookMetadata,Ze):this.f(N,He.range,He.newCells,Ze):oe.isSnippetTextEdit(He)?this.c.push({_type:6,uri:N,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:N,edit:He,metadata:Ze})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===N.toString()&&(this.c[Se]=void 0);break}}(0,E.$Hb)(this.c)}}get(N){const se=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===N.toString()&&se.push(Se.edit);return se}entries(){const N=new M.$zc;for(const se of this.c)if(se._type===2){let Se=N.get(se.uri);Se||(Se=[se.uri,[]],N.set(se.uri,Se)),Se[1].push(se.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$FK=te,e.$FK=te=Ke([C],te);let V=l=class{static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=l.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,se=this.e++){if(typeof N=="function"){const Se=new l;Se.e=this.e,N(Se),this.e=Se.e,N=Se.value}else N=l.c(N);return this.value+="${",this.value+=se,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,se=this.e++){const Se=N.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(N,se){if(typeof se=="function"){const Se=new l;Se.e=this.e,se(Se),this.e=Se.e,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$GK=V,e.$GK=V=l=Ke([C],V);var Y;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var _;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let pe=n=class{static isLocation(N){return N instanceof n?!0:N?F.isRange(N.range)&&g.URI.isUri(N.uri):!1}constructor(N,se){if(this.uri=N,se)if(F.isRange(se))this.range=F.of(se);else if(U.isPosition(se))this.range=new F(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$HK=pe,e.$HK=pe=n=Ke([C],pe);let $e=class{static is(N){return N?typeof N.message=="string"&&N.location&&F.isRange(N.location.range)&&g.URI.isUri(N.location.uri):!1}constructor(N,se){this.location=N,this.message=se}static isEqual(N,se){return N===se?!0:!N||!se?!1:N.message===se.message&&N.location.range.isEqual(se.location.range)&&N.location.uri.toString()===se.location.uri.toString()}};e.$IK=$e,e.$IK=$e=Ke([C],$e);let de=class{constructor(N,se,Se=_.Error){if(!F.isRange(N))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=N,this.message=se,this.severity=Se}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,se){return N===se?!0:!N||!se?!1:N.message===se.message&&N.severity===se.severity&&N.code===se.code&&N.severity===se.severity&&N.source===se.source&&N.range.isEqual(se.range)&&(0,E.$tb)(N.tags,se.tags)&&(0,E.$tb)(N.relatedInformation,se.relatedInformation,$e.isEqual)}};e.$JK=de,e.$JK=de=Ke([C],de);let De=class{constructor(N,se){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=se}};e.$KK=De,e.$KK=De=Ke([C],De);var re;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(N,se=re.Text){this.range=N,this.kind=se}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$LK=he,e.$LK=he=Ke([C],he);var ne;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var ae;(function(z){z[z.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let ge=s=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,se,Se,He,Ze){this.name=N,this.kind=se,this.containerName=Ze,typeof Se=="string"&&(this.containerName=Se),He instanceof pe?this.location=He:Se instanceof F&&(this.location=new pe(He,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.$MK=ge,e.$MK=ge=s=Ke([C],ge);let Ce=c=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(c.validate)}constructor(N,se,Se,He,Ze){this.name=N,this.detail=se,this.kind=Se,this.range=He,this.selectionRange=Ze,this.children=[],c.validate(this)}};e.$NK=Ce,e.$NK=Ce=c=Ke([C],Ce);var T;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let q=class{constructor(N,se){this.title=N,this.kind=se}};e.$OK=q,e.$OK=q=Ke([C],q);let G=class{static{h=this}static{this.c="."}constructor(N){this.value=N}append(N){return new h(this.value?this.value+h.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+h.c)}};e.$PK=G,e.$PK=G=h=Ke([C],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(N,se){if(this.range=N,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$QK=J,e.$QK=J=Ke([C],J);class K{constructor(N,se,Se,He,Ze,st){this.kind=N,this.name=se,this.detail=Se,this.uri=He,this.range=Ze,this.selectionRange=st}}e.$RK=K;class x{constructor(N,se){this.fromRanges=se,this.from=N}}e.$SK=x;class ce{constructor(N,se){this.fromRanges=se,this.to=N}}e.$TK=ce;var Ne;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let je=class{constructor(N,se){this.range=N,this.command=se}get isResolved(){return!!this.command}};e.$UK=je,e.$UK=je=Ke([C],je);let Qe=p=class{#e;static isMarkdownString(N){return N instanceof p?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,se=!1){this.#e=new P.$3j(N,{supportThemeIcons:se})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,se){return this.#e.appendCodeblock(se??"",N),this}};e.$VK=Qe,e.$VK=Qe=p=Ke([C],Qe);let Ge=class{constructor(N,se){this.label=N,this.documentation=se}};e.$WK=Ge,e.$WK=Ge=Ke([C],Ge);let _e=class{constructor(N,se){this.label=N,this.documentation=se,this.parameters=[]}};e.$XK=_e,e.$XK=_e=Ke([C],_e);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$YK=Ye,e.$YK=Ye=Ke([C],Ye);var xe;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(N){this.value=N}};e.$ZK=tt,e.$ZK=tt=Ke([C],tt);let ze=class{constructor(N,se,Se){this.position=N,this.label=se,this.kind=Se}};e.$1K=ze,e.$1K=ze=Ke([C],ze);var ut;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var Z;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var Q;(function(z){z[z.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let we=class{constructor(N,se){this.label=N,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$2K=we,e.$2K=we=Ke([C],we);let Be=class{constructor(N=[],se=!1){this.items=N,this.isIncomplete=se}};e.$3K=Be,e.$3K=Be=Ke([C],Be);let Oe=class{constructor(N,se,Se){this.insertText=N,this.range=se,this.command=Se}};e.$4K=Oe,e.$4K=Oe=Ke([C],Oe);let Xe=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$5K=Xe,e.$5K=Xe=Ke([C],Xe);var nt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var $t;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function bt(z,N){return`${S.$6l.toKey(z)}.${N}`}e.$6K=bt;var Pt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Kt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(z){function N(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=N}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(z){function N(se){switch(se){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=N}(Gt||(e.SyntaxTokenType=Gt={}));let jt=class{constructor(N,se){if(se&&!g.URI.isUri(se))throw(0,L.$6)("target");if(!F.isRange(N)||N.isEmpty)throw(0,L.$6)("range");this.range=N,this.target=se}};e.$7K=jt,e.$7K=jt=Ke([C],jt);let kt=class{constructor(N,se,Se,He){this.red=N,this.green=se,this.blue=Se,this.alpha=He}};e.$8K=kt,e.$8K=kt=Ke([C],kt);let Ft=class{constructor(N,se){if(se&&!(se instanceof kt))throw(0,L.$6)("color");if(!F.isRange(N)||N.isEmpty)throw(0,L.$6)("range");this.range=N,this.color=se}};e.$9K=Ft,e.$9K=Ft=Ke([C],Ft);let Bt=class{constructor(N){if(!N||typeof N!="string")throw(0,L.$6)("label");this.label=N}};e.$0K=Bt,e.$0K=Bt=Ke([C],Bt);var Jt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Ot{constructor(N,se,Se){if(this.startIndex=N,this.length=se,this.tooltip=Se,typeof N!="number"||N<0)throw(0,L.$6)("startIndex");if(typeof se!="number"||se<1)throw(0,L.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,L.$6)("tooltip")}}e.$$K=Ot;class at{constructor(N){this.uri=N}}e.$_K=at;class dt{constructor(N){this.terminalCommand=N}}e.$aL=dt;var At;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(N){if(this.options=N,typeof N!="object")throw(0,L.$6)("options")}}e.$bL=qt;var Rt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ot;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let wt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(N){switch(N){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(N,se){if(this.label=se,typeof N!="string"||typeof se!="string")throw(0,L.$6)("name");this.c=N}get id(){return this.c}};e.$cL=wt,e.$cL=wt=m=Ke([C],wt);function Tt(z){let N="";for(let se=0;se<z.length;se++)N+=z[se].replace(/,/g,",,")+",";return N}let Ct=class{constructor(N,se,Se){if(typeof N!="string")throw(0,L.$6)("process");this.e=[],this.c=N,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Se):this.f=se)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,L.$6)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const se of this.e)N.push(se);return Tt(N)}};e.$dL=Ct,e.$dL=Ct=Ke([C],Ct);let We=class{constructor(N,se,Se){if(this.f=[],Array.isArray(se)){if(!N)throw(0,L.$6)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,L.$6)("command");this.e=N,this.f=se,this.g=Se}else{if(typeof N!="string")throw(0,L.$6)("commandLine");this.c=N,this.g=se}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,L.$6)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,L.$6)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)N.push(typeof se=="string"?se:se.value);return Tt(N)}};e.$eL=We,e.$eL=We=Ke([C],We);var Qt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Ie;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Ie||(e.TaskScope=Ie={}));class Le{constructor(N){this.c=N}computeId(){return"customExecution"+(0,A.$eg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$fL=Le;let me=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,se,Se,He,Ze,st){this.j=!1,this.k=this.definition=N;let lt;typeof se=="string"?(this.m=this.name=se,this.t=this.source=Se,this.execution=He,lt=Ze,this.j=!0):se===Ie.Global||se===Ie.Workspace?(this.target=se,this.m=this.name=Se,this.t=this.source=He,this.execution=Ze,lt=st):(this.target=se,this.m=this.name=Se,this.t=this.source=He,this.execution=Ze,lt=st),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Le?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,A.$eg)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,L.$6)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,L.$6)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const se=this.k.type;(I.g===se||I.e===se||I.f===se||I.c===se)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,L.$6)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$gL=me,e.$gL=me=I=Ke([C],me);var H;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(H||(e.ProgressLocation=H={}));var Me;(function(z){function N(se){const Se=se;return(0,D.$Cf)(Se.value)?Se.tooltip&&!(0,D.$yf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=N})(Me||(e.ViewBadge=Me={}));let Ue=k=class{static isTreeItem(N,se){const Se=N;if(Se.checkboxState!==void 0){const He=(0,D.$Cf)(Se.checkboxState)?Se.checkboxState:(0,D.$Af)(Se.checkboxState)&&(0,D.$Cf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ze=!(0,D.$Cf)(Se.checkboxState)&&(0,D.$Af)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==qe.Checked&&He!==qe.Unchecked||Ze!==void 0&&!(0,D.$yf)(Ze))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(N instanceof k)return!0;if(Se.label!==void 0&&!(0,D.$yf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.$yf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.$yf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.$yf)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,D.$yf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.$yf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.$yf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Je.None&&Se.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.$yf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(N,se=Je.None){this.collapsibleState=se,g.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$hL=Ue,e.$hL=Ue=k=Ke([C],Ue);var Je;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var qe;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$iL=et,e.$iL=et=Ke([C],et);class Et extends et{}e.$jL=Et;class Dt extends Et{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$kL=Dt;class gt{constructor(N,se,Se,He){this.name=N,this.uri=se,this._itemId=Se,this.c=He}data(){return this.c()}}e.$lL=gt;let ht=class{#e=new Map;constructor(N){for(const[se,Se]of N??[]){const He=this.#e.get(this.#t(se));He?He.push(Se):this.#e.set(this.#t(se),[Se])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,se){this.#e.set(this.#t(N),[se])}forEach(N,se){for(const[Se,He]of this.#e)for(const Ze of He)N.call(se,Ze,Se,this)}*[Symbol.iterator](){for(const[N,se]of this.#e)for(const Se of se)yield[N,Se]}#t(N){return N.toLowerCase()}};e.$mL=ht,e.$mL=ht=Ke([C],ht);let ft=class{constructor(N){this.insertText=N}};e.$nL=ft,e.$nL=ft=Ke([C],ft);let ui=class{constructor(N,se){this.label=se,this.insertText=N}};e.$oL=ui,e.$oL=ui=Ke([C],ui);let St=class{constructor(N,se){this.id=N,this.color=se}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$pL=St,e.$pL=St=Ke([C],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(N){this.id=N}};e.$qL=Si,e.$qL=Si=Ke([C],Si);var li;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(N){this.c=N,this.e=g.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,se){if(typeof N!="string"&&(!N||!g.URI.isUri(N)&&!g.URI.isUri(N.uri)))throw(0,L.$6)("base");if(typeof se!="string")throw(0,L.$6)("pattern");typeof N=="string"?this.baseUri=g.URI.file(N):g.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$rL=$i,e.$rL=$i=Ke([C],$i);const It=new WeakMap;function gn(z,N){It.set(z,N)}e.$sL=gn;let ri=class{constructor(N,se,Se,He){this.enabled=typeof N=="boolean"?N:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,A.$eg)()),this.c}};e.$tL=ri,e.$tL=ri=Ke([C],ri);let yt=class extends ri{constructor(N,se,Se,He,Ze){if(super(se,Se,He,Ze),N===null)throw(0,L.$6)("location");this.location=N}};e.$uL=yt,e.$uL=yt=Ke([C],yt);let pi=class extends ri{constructor(N,se,Se,He,Ze){super(se,Se,He,Ze),this.functionName=N}};e.$vL=pi,e.$vL=pi=Ke([C],pi);let vi=class extends ri{constructor(N,se,Se,He,Ze,st,lt){if(super(He,Ze,st,lt),!se)throw(0,L.$6)("dataId");this.label=N,this.dataId=se,this.canPersist=Se}};e.$wL=vi,e.$wL=vi=Ke([C],vi);let si=class{constructor(N,se,Se){this.command=N,this.args=se||[],this.options=Se}};e.$xL=si,e.$xL=si=Ke([C],si);let Ii=class{constructor(N,se){this.port=N,this.host=se}};e.$yL=Ii,e.$yL=Ii=Ke([C],Ii);let Ci=class{constructor(N){this.path=N}};e.$zL=Ci,e.$zL=Ci=Ke([C],Ci);let Mt=class{constructor(N){this.implementation=N}};e.$AL=Mt,e.$AL=Mt=Ke([C],Mt);let bi=class{constructor(N,se,Se){this.session=N,this.threadId=se,this.frameId=Se}};e.$BL=bi,e.$BL=bi=Ke([C],bi);let Pi=class{constructor(N,se){this.session=N,this.threadId=se}};e.$CL=Pi,e.$CL=Pi=Ke([C],Pi);let oi=class{constructor(N,se){this.range=N,this.expression=se}};e.$DL=oi,e.$DL=oi=Ke([C],oi);var hi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let ct=class{constructor(N,se){this.range=N,this.text=se}};e.$EL=ct,e.$EL=ct=Ke([C],ct);let Ai=class{constructor(N,se,Se=!0){this.range=N,this.variableName=se,this.caseSensitiveLookup=Se}};e.$FL=Ai,e.$FL=Ai=Ke([C],Ai);let Yt=class{constructor(N,se){this.range=N,this.expression=se}};e.$GL=Yt,e.$GL=Yt=Ke([C],Yt);let ii=class{constructor(N,se){this.frameId=N,this.stoppedLocation=se}};e.$HL=ii,e.$HL=ii=Ke([C],ii);var Ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=d=class extends Error{static FileExists(N){return new d(N,o.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(N){return new d(N,o.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(N){return new d(N,o.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(N){return new d(N,o.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(N){return new d(N,o.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(N){return new d(N,o.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(N,se=o.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(N)?N.toString(!0):N),this.code=Se?.name??"Unknown",(0,o.$nk)(this,se),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$IL=Mi,e.$IL=Mi=d=Ke([C],Mi);let Li=class{constructor(N,se,Se){this.start=N,this.end=se,this.kind=Se}};e.$JL=Li,e.$JL=Li=Ke([C],Li);var Xi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Zi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Ti;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(N,se=[]){this.tokenTypes=N,this.tokenModifiers=se}}e.$KL=mn;function Ni(z){return typeof z>"u"||(0,D.$zf)(z)}class di{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let se=0,Se=N.tokenTypes.length;se<Se;se++)this.j.set(N.tokenTypes[se],se);for(let se=0,Se=N.tokenModifiers.length;se<Se;se++)this.k.set(N.tokenModifiers[se],se)}}push(N,se,Se,He,Ze){if(typeof N=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(N,se,Se,He,Ze);if(F.isRange(N)&&typeof se=="string"&&Ni(Se))return this.m(N,se,Se);throw(0,L.$6)()}m(N,se,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,Ze=N.start.character,st=N.end.character-N.start.character,lt=this.j.get(se);let zt=0;if(Se)for(const Zt of Se){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(He,Ze,st,lt,zt)}n(N,se,Se,He,Ze){if(this.f&&(N<this.c||N===this.c&&se<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Zt,Ji+=ei):ni+=Zt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Zt=ni,ei=Ji}}let st=N,lt=se;this.f&&this.h>0&&(st-=this.c,st===0&&(lt-=this.e)),this.g[this.h++]=st,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=N,this.e=se}static o(N){const se=[],Se=N.length/5|0;for(let lt=0;lt<Se;lt++)se[lt]=lt;se.sort((lt,zt)=>{const Zt=N[5*lt],ei=N[5*zt];if(Zt===ei){const ti=N[5*lt+1],ni=N[5*zt+1];return ti-ni}return Zt-ei});const He=new Uint32Array(N.length);let Ze=0,st=0;for(let lt=0;lt<Se;lt++){const zt=5*se[lt],Zt=N[zt+0],ei=N[zt+1],ti=N[zt+2],ni=N[zt+3],Ji=N[zt+4],Cn=Zt-Ze,Fn=Cn===0?ei-st:ei,Qi=5*lt;He[Qi+0]=Cn,He[Qi+1]=Fn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ze=Zt,st=ei}return He}build(N){return this.f?new Oi(new Uint32Array(this.g),N):new Oi(di.o(this.g),N)}}e.$LL=di;class Oi{constructor(N,se){this.resultId=se,this.data=N}}e.$ML=Oi;class $n{constructor(N,se,Se){this.start=N,this.deleteCount=se,this.data=Se}}e.$NL=$n;class fi{constructor(N,se){this.resultId=se,this.edits=N}}e.$OL=fi;var Yi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$PL=zi,e.$PL=zi=Ke([C],zi);var xi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class pn{static validate(N){if(typeof N.badge=="string"){let se=(0,$.$_e)(N.badge,0);if(se<N.badge.length&&(se+=(0,$.$_e)(N.badge,se)),N.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!St.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,se,Se){this.badge=N,this.tooltip=se,this.color=Se}}e.$QL=pn;let Ui=class{constructor(N){this.kind=N}};e.$RL=Ui,e.$RL=Ui=Ke([C],Ui);var mi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(N){return N instanceof xt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,se){if(N<0)throw(0,L.$6)("start must be positive");if(se<0)throw(0,L.$6)("end must be positive");N<=se?(this.c=N,this.e=se):(this.c=se,this.e=N)}with(N){let se=this.c,Se=this.e;return N.start!==void 0&&(se=N.start),N.end!==void 0&&(Se=N.end),se===this.c&&Se===this.e?this:new xt(se,Se)}}e.$SL=xt;class wi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(N){return!0}constructor(N,se,Se,He,Ze,st,lt){this.kind=N,this.value=se,this.languageId=Se,this.mime=He,this.outputs=Ze??[],this.metadata=st,this.executionSummary=lt,wi.validate(this)}}e.$TL=wi;class en{constructor(N){this.cells=N}}e.$UL=en;class Xt{static isNotebookCellOutputItem(N){return N instanceof Xt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const se={name:N.name,message:N.message,stack:N.stack};return Xt.json(se,"application/vnd.code.notebook.error")}static stdout(N){return Xt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Xt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,se="application/octet-stream"){return new Xt(N,se)}static#e=new TextEncoder;static text(N,se=R.$Sr.text){const Se=Xt.#e.encode(String(N));return new Xt(Se,se)}static json(N,se="text/x-json"){const Se=JSON.stringify(N,void 0,"	");return Xt.text(Se,se)}constructor(N,se){this.data=N,this.mime=se;const Se=(0,R.$Wr)(se,!0);if(!Se)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$VL=Xt;class yi{static isNotebookCellOutput(N){return N instanceof yi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,se=!1){const Se=new Set,He=new Set;for(let Ze=0;Ze<N.length;Ze++){const st=N[Ze],lt=(0,R.$Wr)(st.mime);if(!Se.has(lt)||(0,v.$zI)(lt)){Se.add(lt);continue}He.add(Ze),se&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?N:N.filter((Ze,st)=>!He.has(st))}constructor(N,se,Se){this.items=yi.ensureUniqueMimeTypes(N,!0),typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,A.$eg)(),this.metadata=se??Se)}}e.$WL=yi;var tn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(N,se){this.text=N,this.alignment=se}}e.$XL=sn;var Te;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Te||(e.NotebookControllerAffinity=Te={}));var _t;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(N,se=[]){this.uri=N,this.provides=(0,E.$2b)(se)}}e.$YL=on;class mt{constructor(N){this.label=N}}e.$ZL=mt;let ji=class{constructor(N,se){this.label=N,this.timestamp=se}};e.$1L=ji,e.$1L=ji=Ke([C],ji);var an;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class Di{constructor(N,se){this.ranges=N,this.wordPattern=se}}e.$2L=Di;class vn{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$3L=vn;var un;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let ki=class{constructor(N=void 0,se=void 0,Se=void 0,He=!1){this.include=N,this.exclude=se,this.profile=Se,this.continuous=He}};e.$4L=ki,e.$4L=ki=Ke([C],ki);let Wi=y=class{static diff(N,se,Se){const He=new y(N);return He.expectedOutput=se,He.actualOutput=Se,He}constructor(N){this.message=N}};e.$5L=Wi,e.$5L=Wi=y=Ke([C],Wi);let Vi=class{constructor(N){this.id=N}};e.$6L=Vi,e.$6L=Vi=Ke([C],Vi);let ci=class{constructor(N,se){this.covered=N,this.total=se}};e.$7L=ci,e.$7L=ci=Ke([C],ci);let qi=w=class{static fromDetails(N,se){const Se=new ci(0,0),He=new ci(0,0),Ze=new ci(0,0);for(const lt of se)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)He.total+=1,He.covered+=zt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=lt.executionCount>0?1:0;const st=new w(N,Se,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=se,st}constructor(N,se,Se,He){this.uri=N,this.statementCoverage=se,this.branchCoverage=Se,this.functionCoverage=He}};e.$8L=qi,e.$8L=qi=w=Ke([C],qi);let Ki=class{constructor(N,se,Se=[]){this.executionCount=N,this.location=se,this.branches=Se}};e.$9L=Ki,e.$9L=Ki=Ke([C],Ki);let Hi=class{constructor(N,se){this.executionCount=N,this.location=se}};e.$0L=Hi,e.$0L=Hi=Ke([C],Hi);let Gi=class{constructor(N,se){this.executionCount=N,this.location=se}};e.$$L=Gi,e.$$L=Gi=Ke([C],Gi);var hn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class ie{constructor(N,se,Se,He,Ze,st){this.kind=N,this.name=se,this.detail=Se,this.uri=He,this.range=Ze,this.selectionRange=st}}e.$_L=ie;class fe{constructor(N){this.uri=N}}e.$aM=fe;class Fe{constructor(N,se){this.original=N,this.modified=se}}e.$bM=Fe;class rt{constructor(N,se,Se,He){this.base=N,this.input1=se,this.input2=Se,this.result=He}}e.$cM=rt;class pt{constructor(N,se){this.uri=N,this.viewType=se}}e.$dM=pt;class Lt{constructor(N){this.viewType=N}}e.$eM=Lt;class Pn{constructor(N,se){this.uri=N,this.notebookType=se}}e.$fM=Pn;class An{constructor(N,se,Se){this.original=N,this.modified=se,this.notebookType=Se}}e.$gM=An;class Rn{constructor(){}}e.$hM=Rn;class Mn{constructor(N,se){this.uri=N,this.inputBoxUri=se}}e.$iM=Mn;var bn;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Ln{constructor(N,se){this.role=N,this.content=se}}e.$jM=Ln;var kn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[103],Re([1,0,54,14,13,293,146,7,18]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0;const g=new Map;function A(v,f){f?g.set(v,f):g.delete(v)}e.$wM=A;function S(v){return g.get(v)}class o extends M.$Yu{constructor(f,t,i,r,u,a,l,n){super(t,i,r,u),this.c=f,this.m=a,this.q=l,this.notebook=n,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===L.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,E.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,E.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,r=t.start.line,u=t.end.line,a=[];a.push(this.f[r].substring(t.start.character));for(let l=r+1;l<u;l++)a.push(this.f[l]);return a.push(this.f[u].substring(0,t.end.character)),a.join(i)}t(f){let t;if(f instanceof $.$wK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new $.$wK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof $.$xK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new $.$xK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof $.$wK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,r=!1;if(t<0)t=0,i=0,r=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,r=!0;else{const u=this.f[t].length;i<0?(i=0,r=!0):i>u&&(i=u,r=!0)}return r?new $.$wK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=S(this.m);else if((0,P.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const r=(0,R.$$r)(i.character+1,(0,R.$9r)(t),this.f[i.line],0);if(r)return new $.$xK(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$xM=o;class b{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$xK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$xK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$yM=b}),define(Ae[208],Re([1,0,7,17,5]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let M=class{constructor($){this.a=new E.$RL(E.ColorThemeKind.Dark),this.b=new P.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange($){let D;switch($){case"light":D=E.ColorThemeKind.Light;break;case"hcDark":D=E.ColorThemeKind.HighContrast;break;case"hcLight":D=E.ColorThemeKind.HighContrastLight;break;default:D=E.ColorThemeKind.Dark}this.a=new E.$RL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iec=M,e.$iec=M=Ke([Ve(0,L.$uM)],M)}),define(Ae[209],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$DI=(0,E.$Ph)("INotebookExecutionService")}),define(Ae[210],Re([1,0,6,29,143,92]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jOb=void 0;class R extends E.$Rc{constructor(D,g,A){super(),this._source=D,this.b=g,this.c=A,this.a=void 0}f(D){const g=D.getLineCount();return new L.$ws(1,1,g,this.g(D,g))}g(D,g){if(g<1||g>D.getLineCount())throw new Error("Illegal value for lineNumber");return D.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const D=new P.$JB;D.acceptChunk(this._source);const g=D.finish(!0),{textBuffer:A,disposable:S}=g.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(D=>{const g=new P.$JB;g.acceptChunk(D);const A=g.finish(!0),{textBuffer:S,disposable:o}=A.create(1);return this.B(o),S})),this.a}findInInputs(D){const A=new M.$xB(D,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(D){const A=new M.$xB(D,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const o=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(o.length!==0)return{textBuffer:S,matches:o}}).filter(S=>!!S):[]}}e.$jOb=R}),define(Ae[47],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(R,$,D=R.parent){if(R._isRoot)return new P([$]);const g=[R.id];for(let A=D;A&&A.id!==$;A=A.parent)g.push(A.id);return g.push($),new P(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new P(R.split("\0"))}static join(R,$){return new P([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:P.isChild(R,$)?2:P.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$jJ=P}),define(Ae[59],Re([1,0,2,29,47]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oJ=e.$nJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lJ=e.$kJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$kJ=[2,4,8,16,32,64];const D=k=>"runId"in k;e.$lJ=D;var g;(function(k){k.serialize=d=>({range:d.range.toJSON(),uri:d.uri.toJSON()}),k.deserialize=d=>({range:L.$ws.lift(d.range),uri:E.URI.revive(d.uri)})})(g||(e.IRichLocation=g={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(k){k.serialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.deserialize(d.location)})})(S||(e.ITestErrorMessage=S={}));const o=(k,d)=>`${d?"s":"e"}${k}`;e.$mJ=o;var b;(function(k){k.serialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.deserialize(d.location)})})(b||(e.ITestOutputMessage=b={}));var v;(function(k){k.serialize=d=>d.type===0?S.serialize(d):b.serialize(d),k.deserialize=d=>d.type===0?S.deserialize(d):b.deserialize(d)})(v||(e.ITestMessage=v={}));var f;(function(k){k.serializeWithoutMessages=d=>({state:d.state,duration:d.duration,messages:[]}),k.serialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(v.serialize)}),k.deserialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(v.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(k,d)=>k+t+d;e.$nJ=i;const r=k=>{const d=k.indexOf(t);return{ctrlId:k.slice(0,d),tagId:k.slice(d+1)}};e.$oJ=r;var u;(function(k){k.serialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?.toJSON(),range:d.range?.toJSON()||null,description:d.description,error:d.error,sortText:d.sortText}),k.deserialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?E.URI.revive(d.uri):void 0,range:d.range?L.$ws.lift(d.range):null,description:d.description,error:d.error,sortText:d.sortText})})(u||(e.ITestItem=u={}));var a;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var l;(function(k){k.serialize=d=>({expand:d.expand,item:u.serialize(d.item)}),k.deserialize=d=>({controllerId:P.$jJ.root(d.item.extId),expand:d.expand,item:u.deserialize(d.item)})})(l||(e.InternalTestItem=l={}));var n;(function(k){k.serialize=d=>{let y;return d.item&&(y={},d.item.label!==void 0&&(y.label=d.item.label),d.item.tags!==void 0&&(y.tags=d.item.tags),d.item.busy!==void 0&&(y.busy=d.item.busy),d.item.uri!==void 0&&(y.uri=d.item.uri?.toJSON()),d.item.range!==void 0&&(y.range=d.item.range?.toJSON()),d.item.description!==void 0&&(y.description=d.item.description),d.item.error!==void 0&&(y.error=d.item.error),d.item.sortText!==void 0&&(y.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:y}},k.deserialize=d=>{let y;return d.item&&(y={},d.item.label!==void 0&&(y.label=d.item.label),d.item.tags!==void 0&&(y.tags=d.item.tags),d.item.busy!==void 0&&(y.busy=d.item.busy),d.item.range!==void 0&&(y.range=d.item.range?L.$ws.lift(d.item.range):null),d.item.description!==void 0&&(y.description=d.item.description),d.item.error!==void 0&&(y.error=d.item.error),d.item.sortText!==void 0&&(y.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:y}}})(n||(e.ITestItemUpdate=n={}));const s=(k,d)=>{d.expand!==void 0&&(k.expand=d.expand),d.item!==void 0&&(k.item=k.item?Object.assign(k.item,d.item):d.item)};e.$pJ=s;var c;(function(k){k.serializeWithoutMessages=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serializeWithoutMessages)}),k.serialize=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serialize)}),k.deserialize=d=>({...l.deserialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var h;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(h||(e.DetailType=h={}));var p;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(p||(e.TestDiffOpType=p={}));var m;(function(k){k.deserialize=d=>d.op===0?{op:d.op,item:l.deserialize(d.item)}:d.op===1?{op:d.op,item:n.deserialize(d.item)}:d.op===2?{op:d.op,uri:E.URI.revive(d.uri),docv:d.docv}:d,k.serialize=d=>d.op===0?{op:d.op,item:l.serialize(d.item)}:d.op===1?{op:d.op,item:n.serialize(d.item)}:d})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(d){const y=this.o();for(const w of d)switch(w.op){case 0:this.j(l.deserialize(w.item),y);break;case 1:this.k(n.deserialize(w.item),y);break;case 3:this.l(w.itemId,y);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}y.complete?.()}j(d,y){const w=P.$jJ.parentId(d.item.extId)?.toString();let C;if(!w)C=this.p(d),this.f.add(C),this.d.set(d.item.extId,C);else if(this.d.has(w)){const j=this.d.get(w);j.children.add(d.item.extId),C=this.p(d,j),this.d.set(d.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(d)}`);return}return y.add?.(C),d.expand===2&&this.g++,C}k(d,y){const w=this.d.get(d.extId);if(w)return d.expand!==void 0&&(w.expand===2&&this.g--,d.expand===2&&this.g++),(0,e.$pJ)(w,d),y.update?.(w),w}l(d,y){const w=this.d.get(d);if(!w)return;const C=P.$jJ.parentId(w.item.extId)?.toString();C?this.d.get(C).children.delete(w.item.extId):this.f.delete(w);const j=[[d]];for(;j.length;)for(const B of j.pop()){const W=this.d.get(B);W&&(j.push(W.children),this.d.delete(B),y.remove?.(W,W!==w),W.expand===2&&this.g--)}}m(d){}updatePendingRoots(d){this.h+=d}o(){return{}}}e.$qJ=I}),define(Ae[76],Re([1,0,12,5,6,54,59,47]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.TestItemEventOp=void 0;var D;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(r,u)=>r===u,S=Object.entries({range:(r,u)=>r===u?!0:!r||!u?!1:r.equalsRange(u),busy:g,label:g,description:g,error:g,sortText:g,tags:(r,u)=>!(r.length!==u.length||r.some(a=>!u.includes(a)))}),o=(r,u)=>{let a;for(const[l,n]of S)n(r[l],u[l])||(a?a[l]=u[l]:a={[l]:u[l]});return a};class b extends P.$Rc{get root(){return this.s.root}constructor(u){super(),this.s=u,this.f=this.B(new E.$6g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(u){this.h=u;for(const a of this.tree.values())this.I(a)}get resolveHandler(){return this.h}collectDiff(){const u=this.m;return this.m=[],u}pushDiff(u){switch(u.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===u.uri){a.docv=u.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===u.item.extId){(0,R.$pJ)(a.item,u.item);return}if(a.op===0&&a.item.item.extId===u.item.extId){(0,R.$pJ)(a.item,u.item);return}}break}}this.m.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,a){const l=this.tree.get(u);if(l){if((l.expandLevels===void 0||a>l.expandLevels)&&(l.expandLevels=a),l.expand===1){const n=this.L(l);return n.isOpen()?this.J(l,a-1):n.wait().then(()=>this.J(l,a-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,a-1)):this.J(l,a-1)}}dispose(){for(const u of this.tree.values())this.s.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(u,a){switch(a.op){case 3:this.N($.$jJ.joinToString(u.fullId,a.id));break;case 0:this.y(a.item,u);break;case 5:for(const l of a.ops)this.u(u,l);break;case 1:this.z(a.new,a.old,u.fullId.toString());break;case 2:this.I(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:a.update}});break;case 6:this.w(u.actual.uri);break;default:(0,M.$3c)(a)}}w(u){u&&this.pushDiff({op:2,uri:u,docv:this.s.getDocumentVersion(u)})}y(u,a){const l=$.$jJ.fromExtHostTestItem(u,this.root.id,a?.actual),n=this.s.getApiFor(u);n.parent&&n.parent!==a?.actual&&this.s.getChildren(n.parent).delete(u.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:u,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},u.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(u,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(u)}}),this.H(u,s,a);return}if(s.actual===u){this.G(u,s,a);return}if(s.actual.uri?.toString()!==u.uri?.toString())return this.N(l.toString()),this.y(u,a);const c=this.s.getChildren(s.actual),h=s.actual,p=o(this.s.toITestItem(h),this.s.toITestItem(u));this.s.getApiFor(h).listener=void 0,s.actual=u,s.expand=0,p&&(p.hasOwnProperty("tags")&&(this.z(u.tags,h.tags,l.toString()),delete p.tags),this.u(s,{op:4,update:p})),this.H(u,s,a);for(const[m,I]of c)this.s.getChildren(u).get(I.id)||this.N($.$jJ.joinToString(l,I.id));this.w(s.actual.uri)}z(u,a,l){const n=new Set(a.map(s=>s.id));for(const s of u)n.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:u.map(s=>(0,R.$nJ)(this.s.controllerId,s.id))}}}),n.forEach(this.D,this)}C(u){const a=this.j.get(u.id);a?a.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$nJ)(this.s.controllerId,u.id)}}))}D(u){const a=this.j.get(u);a&&!--a.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,R.$nJ)(this.s.controllerId,u)}))}F(u,a){this.s.getApiFor(u).parent=a&&a.actual!==this.root?a.actual:void 0}G(u,a,l){this.F(u,l);const n=this.s.getApiFor(u);n.parent=l?.actual,n.listener=s=>this.u(a,s),this.I(a)}H(u,a,l){this.G(u,a,l);for(const[n,s]of this.s.getChildren(u))this.y(s,a)}I(u){let a;this.h?u.resolveBarrier?a=u.resolveBarrier.isOpen()?3:2:a=u.actual.canResolveChildren?1:0:a=0,a!==u.expand&&(u.expand=a,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:a}}),a===1&&u.expandLevels!==void 0&&this.L(u))}J(u,a){if(a<0)return;const l=[];for(const[n,s]of this.s.getChildren(u.actual)){const c=this.expand($.$jJ.joinToString(u.fullId,s.id),a);(0,E.$Gg)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}L(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const s=new E.$Sg;return s.open(),s}u.expand=2,this.M(u);const a=u.resolveBarrier=new E.$Sg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let n;try{n=this.h(u.actual===this.root?void 0:u.actual)}catch(s){l(s)}return(0,E.$Gg)(n)?n.catch(l).then(()=>{a.open(),this.I(u)}):(a.open(),this.I(u)),u.resolveBarrier}M(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}N(u){const a=this.tree.get(u);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const l=[a];for(;l.length;){const n=l.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.D(s.id);this.tree.delete(n.fullId.toString());for(const[s,c]of this.s.getChildren(n.actual))l.push(this.tree.get($.$jJ.joinToString(n.fullId,c.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.$kM=b;class v extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.$lM=v;class f extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$mM=f;class t extends Error{constructor(u,a,l){super(`TestItem with ID "${u}" is from controller "${a}" and cannot be added as a child of an item from controller "${l}".`)}}e.$nM=t;const i=(r,u,a)=>{let l=new Map;return{get size(){return l.size},forEach(n,s){for(const c of l.values())n.call(s,c,this)},[Symbol.iterator](){return l.entries()},replace(n){const s=new Map,c=new Set(l.keys()),h={op:5,ops:[]};for(const p of n){if(!(p instanceof a))throw new f(p.id);const m=u(p).controllerId;if(m!==r.controllerId)throw new t(p.id,m,r.controllerId);if(s.has(p.id))throw new v(p.id);s.set(p.id,p),c.delete(p.id),h.ops.push({op:0,item:p})}for(const p of c.keys())h.ops.push({op:3,id:p});r.listener?.(h),l=s},add(n){if(!(n instanceof a))throw new f(n.id);l.set(n.id,n),r.listener?.({op:0,item:n})},delete(n){l.delete(n)&&r.listener?.({op:3,id:n})},get(n){return l.get(n)},toJSON(){return Array.from(l.values())}}};e.$oM=i}),define(Ae[104],Re([1,0,76]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=void 0;const L=new WeakMap,P=(R,$)=>{const D={controllerId:$};return L.set(R,D),D};e.$pM=P;const M=R=>{const $=L.get(R);if(!$)throw new E.$mM(R?.id||"<unknown>");return $};e.$qM=M}),define(Ae[77],Re([1,0,14,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpb=e.$upb=e.$tpb=e.$spb=e.$rpb=void 0,e.$rpb="vscode-cdn.net",e.$spb=`vscode-resource.${e.$rpb}`,e.$tpb=`'self' https://*.${e.$rpb}`;function P($,D){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(D&&D.authority&&D.isRemote&&$.scheme===E.Schemas.file&&($=L.URI.from({scheme:E.Schemas.vscodeRemote,authority:D.authority,path:$.path})),L.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$spb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$upb=P;function M($){return $.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$vpb=R}),define(Ae[211],Re([1,0,5,6,77]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class M{constructor($,D,g){this.d=$,this.e=D,this.f=g,this.a=0,this.b=new L.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,D,g,A,S){let o;for(const u of this.e.getVisibleTextEditors(!0))if(u.value===$){o=u;break}if(!o)throw new Error("not a visible editor");const b=this,v=this.a++,f=new E.$Nd,t=new E.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(u){return(0,P.$upb)(u,b.f)}get cspSource(){return P.$tpb}set options(u){this.b=u,b.d.$setOptions(v,u)}get options(){return this.b}set html(u){this.a=u,b.d.$setHtml(v,u)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(u){return b.d.$postMessage(v,u)}},r=new class{constructor(){this.editor=$,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(v)&&(b.c.delete(v),b.d.$disposeEditorInset(v),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(v,o.id,o.value.document.uri,D+1,g,A||{},S.identifier,S.extensionLocation),this.c.set(v,{editor:$,inset:r,onDidReceiveMessage:f}),r}$onDidDispose($){const D=this.c.get($);D&&D.inset.dispose()}$onDidReceiveMessage($,D){this.c.get($)?.onDidReceiveMessage.fire(D)}}e.$Sdc=M}),define(Ae[212],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.VariableKind=e.$gN=void 0,e.$gN=(0,E.$Ph)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class P extends Error{constructor(R,$){super($),this.variable=R}}e.$hN=P}),define(Ae[213],Re([1,0,20,73,16,26,23,93,176,212,13]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,v,f,t){this.h=new Map,this.a=b,this.b=v,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(R.$j){const v=Object.create(null);return Object.keys(b).forEach(f=>{v[f.toLowerCase()]=b[f]}),v}return b}resolveWithEnvironment(b,v,f){return this.l({env:this.i(b),userHome:void 0},v?v.uri:void 0,f)}async resolveAsync(b,v){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,v)}async j(b,v,f,t){const i=M.$7m(v);R.$j&&i.windows?Object.keys(i.windows).forEach(u=>i[u]=i.windows[u]):R.$k&&i.osx?Object.keys(i.osx).forEach(u=>i[u]=i.osx[u]):R.$l&&i.linux&&Object.keys(i.linux).forEach(u=>i[u]=i.linux[u]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,i,f,t)}async resolveAnyAsync(b,v,f){return this.j(b,v,f)}async resolveAnyMap(b,v,f){const t=new Map;return{newConfig:await this.j(b,v,f,t),resolvedVariables:t}}resolveWithInteractionReplace(b,v,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,v,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,v){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,v)}async l(b,v,f,t,i){if(P.$yf(f))return this.m(b,v,f,t,i);if(Array.isArray(f))return Promise.all(f.map(r=>this.l(b,v,r,t,i)));if(P.$Af(f)){const r=Object.create(null),u=await Promise.all(Object.keys(f).map(async a=>[await this.m(b,v,a,t,i),await this.l(b,v,f[a],t,i)]));for(const[a,l]of u)r[a]=l;return r}return f}m(b,v,f,t,i){return(0,A.$Te)(f,S.VARIABLE_REGEXP,async(r,u)=>{if(u.includes(S.VARIABLE_LHS))return r;let a=await this.o(b,r,u,v,t);return i?.set(u,a),a!==r&&P.$yf(a)&&a.match(S.VARIABLE_REGEXP)&&(a=await this.m(b,v,a,t,i)),a})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,v,f,t,i){let r;const u=f.split(":");u.length>1&&(f=u[0],r=u[1]);const a=s=>{const c=this.a.getFilePath();if(c)return(0,$.$vv)(c);throw new g.$hN(s,(0,D.localize)(0,null,v))},l=s=>{const c=a(s);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,$.$vv)(h)}throw new g.$hN(s,(0,D.localize)(1,null,v,E.$mc(c)))},n=s=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new g.$hN(s,(0,D.localize)(2,null,v,r))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$hN(s,(0,D.localize)(3,null,v)):new g.$hN(s,(0,D.localize)(4,null,v))};switch(f){case"env":if(r){if(b.env){const s=b.env[R.$j?r.toLowerCase():r];if(P.$yf(s))return s}return""}throw new g.$hN(g.VariableKind.Env,(0,D.localize)(5,null,v));case"config":if(r){const s=this.a.getConfigurationValue(t,r);if(P.$Hf(s))throw new g.$hN(g.VariableKind.Config,(0,D.localize)(6,null,v,r));if(P.$Af(s))throw new g.$hN(g.VariableKind.Config,(0,D.localize)(7,null,v,r));return s}throw new g.$hN(g.VariableKind.Config,(0,D.localize)(8,null,v));case"command":return this.p(g.VariableKind.Command,v,r,i,"command");case"input":return this.p(g.VariableKind.Input,v,r,i,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new g.$hN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,v,r));return this.n(s.extensionLocation)}throw new g.$hN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,v));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,$.$vv)(this.n(n(g.VariableKind.WorkspaceFolder)));case"cwd":return t||r?(0,$.$vv)(this.n(n(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$vv)(E.$mc(this.n(n(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new g.$hN(g.VariableKind.UserHome,(0,D.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$hN(g.VariableKind.LineNumber,(0,D.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$hN(g.VariableKind.SelectedText,(0,D.localize)(13,null,v))}case"file":return a(g.VariableKind.File);case"fileWorkspaceFolder":return l(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||r?E.$kc(this.n(n(g.VariableKind.RelativeFile)),a(g.VariableKind.RelativeFile)):a(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$lc(a(g.VariableKind.RelativeFileDirname));if(t||r){const c=E.$kc(this.n(n(g.VariableKind.RelativeFileDirname)),s);return c.length===0?".":c}return s}case"fileDirname":return E.$lc(a(g.VariableKind.FileDirname));case"fileExtname":return E.$nc(a(g.VariableKind.FileExtname));case"fileBasename":return E.$mc(a(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$mc(a(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$nc(s).length)}case"fileDirnameBasename":return E.$mc(E.$lc(a(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return E.sep;default:try{const s=r?`${f}:${r}`:f;return this.p(g.VariableKind.Unknown,v,s,i,void 0)}catch{return v}}}}p(b,v,f,t,i){if(f&&t){const r=i===void 0?t[f]:t[i+":"+f];if(typeof r=="string")return r;throw new g.$hN(b,(0,D.localize)(14,null,v))}return v}}e.$vN=S}),define(Ae[105],Re([1,0,4,102]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.OpenEditorContext=e.GroupsOrder=e.$sC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rC=void 0,e.$rC=(0,E.$Ph)("editorGroupsService");var P;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var D;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(v){const f=v;return(0,L.$_D)(f?.editor)&&(0,L.$_D)(f?.replacement)}e.$sC=g;var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function o(v){const f=v;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$tC=o;function b(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$uC=b}),define(Ae[214],Re([1,0,4,105]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=void 0,e.$vC=(0,E.$Ph)("editorService"),e.$wC=-1,e.$xC=-2;function P(M){const R=M;return typeof M=="number"||(0,L.$tC)(R)}e.$yC=P}),define(Ae[215],Re([1,0,4,182]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=void 0,e.$NJ=(0,E.$Qh)(L.$Wh)}),define(Ae[106],Re([1,0,21,5,20,6]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=e.$34b=e.$24b=e.$14b=e.$Z4b=e.$Y4b=void 0;class R{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$Y4b=R;class ${static isHostExtension(i,r,u){if(r.getExtensionDescription(i))return!1;const a=u.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,r){this.j=i,this.c=new L.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(v),this.f=new E.$8l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);if(Array.isArray(r))for(let u of r)u==="onUri"&&(u=`onUri:${E.$6l.toKey(i.identifier)}`),this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=f(this.e,r),this.e=this.e.concat(i);const u=$.l(this.e);return this.e=f(this.e,u.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,u)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,c){this.addNode(s),this.addNode(c),this.c.has(s)?this.c.get(s).push(c):this.c.set(s,[c])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,c){const h=r.getArcs(s);for(let p=0;p<h.length;p++)if(!c.has(h[p]))return!1;return!0}getNodes(){return this.e}},u=new E.$8l;for(const s of i)if(u.set(s.identifier,s),s.extensionDependencies)for(const c of s.extensionDependencies)r.addArc(E.$6l.toKey(s.identifier),E.$6l.toKey(c));const a=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>a.add(s));const l=r.getNodes().filter(s=>!a.has(s));let n;do{n=!1;for(let s=0;s<l.length;s++){const c=l[s];r.hasOnlyGoodArcs(c,a)&&(l.splice(s,1),s--,a.add(c),n=!0)}}while(n);return l.map(s=>u.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$Z4b=$;class D{constructor(i,r){this.versionId=i,this.extensions=r}}e.$14b=D,e.$24b={readActivationEvents:t=>t.activationEvents};class g{constructor(i){this.d=new o,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new A(this,r)}deltaExtensions(i,r,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$34b=g;class A extends M.$Rc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$44b=A;class S{constructor(i){this.name=i,this.promise=new Promise((r,u)=>{this.c=r})}resolve(i){this.c(i)}}class o{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new S(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const u=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{r&&(clearTimeout(u),r=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(a))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function v(t,i){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==u)return r-u;const a=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return a<l?-1:a>l?1:0}function f(t,i){const r=new E.$7l(i);return t.filter(u=>!r.has(u.identifier))}}),define(Ae[78],Re([1,0,22]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(g){const A=E.$be.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$bm=R;function $(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$cm=$;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[60],Re([1,0,4,5,15,27,78,55,56,26,2,6,165]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=void 0;let b=class extends S.$Rc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new L.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:D.$ro,name:(0,o.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(u=>{(0,P.$_i)(u)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,u){const a=this.getTelemetryDetails(),l=new v(r,u,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,r,u){this.f=i,this.g=r,this.c=u??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:r["common.uikind"]="web";break;case R.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$Vk)((0,D.$yo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((u,a)=>{const l=u.filter(n=>!n.isDisposed);l.length===0?this.r.delete(a):this.r.set(a,l)}),this.r.forEach(u=>{for(const a of u)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const a=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!a)return this.r.delete(i.value),!1;let l=!1;for(const n of a)n.ignoreUnhandledExtHostErrors||(n.logError(r),l=!0);return l}};e.$LM=b,e.$LM=b=Ke([Ve(0,M.$KM),Ve(1,P.$$i)],b);class v{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,u,a,l,n,s){this.g=u,this.h=a,this.i=l,this.j=n,this.a=new L.$Nd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,D.$Bo)(r,[]),this.c&&(r=(0,g.$0m)(r,this.c)),this.b||(r=(0,g.$0m)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const u={name:i.name,message:i.message,stack:i.stack,cause:i.cause},a=(0,D.$Bo)(u,[]),l=new Error(a.message,{cause:a.cause});l.stack=a.stack,l.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(l,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$MM=v;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$NM=f,e.$OM=(0,E.$Ph)("IExtHostTelemetry")}),define(Ae[24],Re([1,0,5,2,191,101,21,4]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new R.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,$.$Ph)("extensionService");class D{constructor(l){this.dependency=l}}e.$iF=D;var g;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,n,s){this.c=l,this.d=n.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$3E.createActivationEventsMap(this.d)}}set(l,n,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],h=[],p=[],m=[],I=S(this.d),k=S(n),d=(B,W)=>B.extensionLocation.toString()===W.extensionLocation.toString()||B.isBuiltin===W.isBuiltin||B.isUserBuiltin===W.isUserBuiltin||B.isUnderDevelopment===W.isUnderDevelopment;for(const B of this.d){const W=k.get(B.identifier);if(!W){c.push(B.identifier),I.delete(B.identifier);continue}if(!d(B,W)){c.push(B.identifier),I.delete(B.identifier);continue}}for(const B of n){const W=I.get(B.identifier);if(!W){h.push(B);continue}if(!d(W,B)){c.push(W.identifier),I.delete(W.identifier);continue}}const y=new R.$7l(this.e),w=new R.$7l(s);for(const B of this.e)w.has(B)||p.push(B);for(const B of s)y.has(B)||m.push(B);const C=M.$3E.createActivationEventsMap(h),j={versionId:l,toRemove:c,toAdd:h,addActivationEvents:C,myToRemove:p,myToAdd:m};return this.delta(j),j}delta(l){if(this.c>=l.versionId)return null;const{toRemove:n,toAdd:s,myToRemove:c,myToAdd:h}=l,p=new R.$7l(n),m=new R.$7l(c);for(let I=0;I<this.d.length;I++)p.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of h)this.e.push(I);return l}containsExtension(l){for(const n of this.e)if(R.$6l.equals(n,l))return!0;return!1}}e.$jF=A;function S(a){const l=new R.$8l;for(const n of a)l.set(n.identifier,n);return l}function o(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}e.$kF=o;function b(a,l){if(!o(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$lF=b;class v{constructor(l,n,s,c){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=c}}e.$mF=v;class f{constructor(l,n){this.description=l,this.value=n}}e.$nF=f;var t;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.$Ho)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$oF=i;function r(a,l){return{identifier:new R.$6l((0,P.$Fo)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$pF=r;class u{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=u}),define(Ae[216],Re([1,0,11,106,21,24,15,12]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,r,u,a){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=u,this.activateResolvedTime=a}}e.$5cc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6cc=g;class A{constructor(i,r,u,a,l,n){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=u,this.module=a,this.exports=l,this.subscriptions=n}}e.$7cc=A;class S extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8cc=S;class o extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9cc=o;class b extends A{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(i,r,u,a){this.g=a,this.a=i,this.b=r,this.c=u,this.d=new P.$8l,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,u]of this.d)i.push(u.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const u=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(u.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const u=this.a.getExtensionDescription(i);if(!u)throw new Error(`Extension '${i}' is not known`);return this.h([{id:u.identifier,reason:r}])}async h(i){const r=i.filter(u=>!this.isActivated(u.id)).map(u=>this.j(u));await Promise.all(r.map(u=>u.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(l));return this.c.onExtensionActivationError(i.id,l,new M.$iF(i.id.value)),n}const u=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const l of a){if(this.m(l))continue;const n=this.d.get(l);if(n){u.push(n);continue}if(this.l(l)){u.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;u.push(this.j({id:s.identifier,reason:i.reason}));continue}const c=r.displayName||r.identifier.value,h=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),p=this.k(i,r.displayName,[],new b(h));return this.c.onExtensionActivationError(r.identifier,h,new M.$iF(l)),p}return this.k(i,r.displayName,u,null)}k(i,r,u,a){const l=new f(i.id,r,i.reason,u,a,this.c,this.g);return this.d.set(i.id,l),l}l(i){return L.$Z4b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$0cc=v,e.$0cc=v=Ke([Ve(3,R.$0i)],v);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,u,a,l,n,s){this.c=i,this.d=r,this.f=u,this.g=a,this.h=l,this.j=n,this.k=s,this.a=new $.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const u=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);u.detail=r.value.activationFailedError,this.h=new b(u),this.j.onExtensionActivationError(this.c,u,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new b(r),this.b&&E.$3(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([Ve(6,R.$0i)],f)}),define(Ae[8],Re([1,0,18,22,125,217,52,28,119,51,68,26,16,2,29,79,97,104,102,75,47,59,214,7,24]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$tM=e.$sM=e.MarkdownString=e.$rM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Ie){function Le(H){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Je,positionColumn:qe}=H,et=new s.$wK(Me-1,Ue-1),Et=new s.$wK(Je-1,qe-1);return new s.$yK(et,Et)}Ie.to=Le;function me(H){const{anchor:Me,active:Ue}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ie.from=me})(h||(e.Selection=h={}));var p;(function(Ie){function Le(H){if(!H)return;const{start:Me,end:Ue}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ie.from=Le;function me(H){if(!H)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Je,endColumn:qe}=H;return new s.$xK(Me-1,Ue-1,Je-1,qe-1)}Ie.to=me})(p||(e.Range=p={}));var m;(function(Ie){function Le(me){switch(me){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ie.to=Le})(m||(e.TokenType=m={}));var I;(function(Ie){function Le(H){return new s.$wK(H.lineNumber-1,H.column-1)}Ie.to=Le;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ie.from=me})(I||(e.Position=I={}));var k;(function(Ie){function Le(Me,Ue,Je){return(0,E.$Gb)((0,E.$2b)(Me).map(qe=>me(qe,Ue,Je)))}Ie.from=Le;function me(Me,Ue,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,Ue),pattern:Z.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function H(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(k||(e.DocumentSelector=k={}));var d;(function(Ie){function Le(H){switch(H){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ie.from=Le;function me(H){switch(H){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ie.to=me})(d||(e.DiagnosticTag=d={}));var y;(function(Ie){function Le(H){let Me;return H.code&&((0,o.$yf)(H.code)||(0,o.$Cf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...p.from(H.range),message:H.message,source:H.source,code:Me,severity:C.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(w.from),tags:Array.isArray(H.tags)?(0,E.$Gb)(H.tags.map(d.from)):void 0}}Ie.from=Le;function me(H){const Me=new s.$JK(p.to(H),H.message,C.to(H.severity));return Me.source=H.source,Me.code=(0,o.$yf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(w.to),Me.tags=H.tags&&(0,E.$Gb)(H.tags.map(d.to)),Me}Ie.to=me})(y||(e.Diagnostic=y={}));var w;(function(Ie){function Le(H){return{...p.from(H.location.range),message:H.message,resource:H.location.uri}}Ie.from=Le;function me(H){return new s.$IK(new s.$HK(H.resource,p.to(H)),H.message)}Ie.to=me})(w||(e.DiagnosticRelatedInformation=w={}));var C;(function(Ie){function Le(H){switch(H){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Le;function me(H){switch(H){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ie.to=me})(C||(e.DiagnosticSeverity=C={}));var j;(function(Ie){function Le(H){return typeof H=="number"&&H>=s.ViewColumn.One?H-1:H===s.ViewColumn.Beside?n.$xC:n.$wC}Ie.from=Le;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=me})(j||(e.ViewColumn=j={}));function B(Ie){return typeof Ie.range<"u"}function W(Ie){return Ie.length===0?!0:!!B(Ie[0])}e.$rM=W;var U;(function(Ie){function Le(qe){return qe.map(Ie.from)}Ie.fromMany=Le;function me(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function H(qe){let et;if(me(qe)){const{language:ht,value:ft}=qe;et={value:"```"+ht+`
`+ft+"\n```\n"}}else s.$VK.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const Et=Object.create(null);et.uris=Et;const Dt=ht=>{try{let ft=b.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,Et)}),Et[ht]=ft}catch{}return""},gt=new D.marked.Renderer;return gt.link=Dt,gt.image=ht=>typeof ht=="string"?Dt(R.$0j(ht).href):"",(0,D.marked)(et.value,{renderer:gt}),et}Ie.from=H;function Me(qe,et){if(!qe)return qe;let Et;try{Et=(0,g.$lh)(qe)}catch{}if(!Et)return qe;let Dt=!1;return Et=(0,S.$9m)(Et,gt=>{if(b.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=gt,Dt=!0,ht}else return}),Dt?JSON.stringify(Et):qe}function Ue(qe){const et=new s.$VK(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,et}Ie.to=Ue;function Je(qe){if(qe)return typeof qe=="string"?qe:Ie.from(qe)}Ie.fromStrict=Je})(U||(e.MarkdownString=U={}));function F(Ie){return W(Ie)?Ie.map(Le=>({range:p.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?U.fromMany(Le.hoverMessage):Le.hoverMessage?U.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Ie.map(Le=>({range:p.from(Le)}))}e.$sM=F;function O(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?b.URI.file(Ie):Ie}e.$tM=O;var ee;(function(Ie){function Le(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ie.from=Le})(ee||(e.ThemableDecorationAttachmentRenderOptions=ee={}));var X;(function(Ie){function Le(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?ee.from(me.before):void 0,after:me.after?ee.from(me.after):void 0}}Ie.from=Le})(X||(e.ThemableDecorationRenderOptions=X={}));var Ee;(function(Ie){function Le(me){if(typeof me>"u")return me;switch(me){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Le})(Ee||(e.DecorationRangeBehavior=Ee={}));var ke;(function(Ie){function Le(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Ee.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?X.from(me.light):void 0,dark:me.dark?X.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?ee.from(me.before):void 0,after:me.after?ee.from(me.after):void 0}}Ie.from=Le})(ke||(e.DecorationRenderOptions=ke={}));var Pe;(function(Ie){function Le(H){return{text:H.newText,eol:H.newEol&&xe.from(H.newEol),range:p.from(H.range)}}Ie.from=Le;function me(H){const Me=new s.$CK(p.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:xe.to(H.eol),Me}Ie.to=me})(Pe||(e.TextEdit=Pe={}));var le;(function(Ie){function Le(H,Me){const Ue={edits:[]};if(H instanceof s.$FK){const Je=new $.$Ac;for(const qe of H._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of H._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,L.$ve)(L.$be.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:Pe.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:p.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(bt.from)}})}return Ue}Ie.from=Le;function me(H){const Me=new s.$FK,Ue=new $.$zc;for(const Je of H.edits)if(Je.textEdit){const qe=Je,et=b.URI.revive(qe.resource),Et=p.to(qe.textEdit.range),Dt=qe.textEdit.text,gt=qe.textEdit.insertAsSnippet;let ht;gt?ht=s.$EK.replace(Et,new s.$GK(Dt)):ht=s.$CK.replace(Et,Dt);const ft=Ue.get(et);ft?ft.push(ht):Ue.set(et,[ht])}else Me.renameFile(b.URI.revive(Je.oldResource),b.URI.revive(Je.newResource),Je.options);for(const[Je,qe]of Ue)Me.set(Je,qe);return Me}Ie.to=me})(le||(e.WorkspaceEdit=le={}));var be;(function(Ie){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function me(Me){return typeof Le[Me]=="number"?Le[Me]:6}Ie.from=me;function H(Me){for(const Ue in Le)if(Le[Ue]===Me)return Number(Ue);return s.SymbolKind.Property}Ie.to=H})(be||(e.SymbolKind=be={}));var ue;(function(Ie){function Le(H){switch(H){case s.SymbolTag.Deprecated:return 1}}Ie.from=Le;function me(H){switch(H){case 1:return s.SymbolTag.Deprecated}}Ie.to=me})(ue||(e.SymbolTag=ue={}));var oe;(function(Ie){function Le(H){return{name:H.name,kind:be.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:_.from(H.location)}}Ie.from=Le;function me(H){const Me=new s.$MK(H.name,be.to(H.kind),H.containerName,_.to(H.location));return Me.tags=H.tags&&H.tags.map(ue.to),Me}Ie.to=me})(oe||(e.WorkspaceSymbol=oe={}));var ye;(function(Ie){function Le(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:p.from(H.range),selectionRange:p.from(H.selectionRange),kind:be.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Me.children=H.children.map(Le)),Me}Ie.from=Le;function me(H){const Me=new s.$NK(H.name,H.detail,be.to(H.kind),p.to(H.range),p.to(H.selectionRange));return(0,E.$Kb)(H.tags)&&(Me.tags=H.tags.map(ue.to)),H.children&&(Me.children=H.children.map(me)),Me}Ie.to=me})(ye||(e.DocumentSymbol=ye={}));var te;(function(Ie){function Le(H){const Me=new s.$RK(be.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),p.to(H.range),p.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ie.to=Le;function me(H,Me,Ue){if(Me=Me??H._sessionId,Ue=Ue??H._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:H.name,detail:H.detail,kind:be.from(H.kind),uri:H.uri,range:p.from(H.range),selectionRange:p.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ie.from=me})(te||(e.CallHierarchyItem=te={}));var V;(function(Ie){function Le(me){return new s.$SK(te.to(me.from),me.fromRanges.map(H=>p.to(H)))}Ie.to=Le})(V||(e.CallHierarchyIncomingCall=V={}));var Y;(function(Ie){function Le(me){return new s.$TK(te.to(me.to),me.fromRanges.map(H=>p.to(H)))}Ie.to=Le})(Y||(e.CallHierarchyOutgoingCall=Y={}));var _;(function(Ie){function Le(H){return{range:H.range&&p.from(H.range),uri:H.uri}}Ie.from=Le;function me(H){return new s.$HK(b.URI.revive(H.uri),p.to(H.range))}Ie.to=me})(_||(e.location=_={}));var pe;(function(Ie){function Le(H){const Me=H,Ue=H;return{originSelectionRange:Me.originSelectionRange?p.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:p.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?p.from(Me.targetSelectionRange):void 0}}Ie.from=Le;function me(H){return{targetUri:b.URI.revive(H.uri),targetRange:p.to(H.range),targetSelectionRange:H.targetSelectionRange?p.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?p.to(H.originSelectionRange):void 0}}Ie.to=me})(pe||(e.DefinitionLink=pe={}));var $e;(function(Ie){function Le(H){return{range:p.from(H.range),contents:U.fromMany(H.contents)}}Ie.from=Le;function me(H){return new s.$KK(H.contents.map(U.to),p.to(H.range))}Ie.to=me})($e||(e.Hover=$e={}));var de;(function(Ie){function Le(H){return{range:p.from(H.range),expression:H.expression}}Ie.from=Le;function me(H){return new s.$DL(p.to(H.range),H.expression)}Ie.to=me})(de||(e.EvaluatableExpression=de={}));var De;(function(Ie){function Le(H){if(H instanceof s.$EL)return{type:"text",range:p.from(H.range),text:H.text};if(H instanceof s.$FL)return{type:"variable",range:p.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof s.$GL)return{type:"expression",range:p.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Le;function me(H){switch(H.type){case"text":return{range:p.to(H.range),text:H.text};case"variable":return{range:p.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:p.to(H.range),expression:H.expression}}}Ie.to=me})(De||(e.InlineValue=De={}));var re;(function(Ie){function Le(H){return{frameId:H.frameId,stoppedLocation:p.from(H.stoppedLocation)}}Ie.from=Le;function me(H){return new s.$HL(H.frameId,p.to(H.stoppedLocation))}Ie.to=me})(re||(e.InlineValueContext=re={}));var he;(function(Ie){function Le(H){return{range:p.from(H.range),kind:H.kind}}Ie.from=Le;function me(H){return new s.$LK(p.to(H.range),H.kind)}Ie.to=me})(he||(e.DocumentHighlight=he={}));var ne;(function(Ie){function Le(me){switch(me){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ie.to=Le})(ne||(e.CompletionTriggerKind=ne={}));var ae;(function(Ie){function Le(me){return{triggerKind:ne.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ie.to=Le})(ae||(e.CompletionContext=ae={}));var ge;(function(Ie){function Le(H){switch(H){case s.CompletionItemTag.Deprecated:return 1}}Ie.from=Le;function me(H){switch(H){case 1:return s.CompletionItemTag.Deprecated}}Ie.to=me})(ge||(e.CompletionItemTag=ge={}));var Ce;(function(Ie){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function me(Ue){return Le.get(Ue)??9}Ie.from=me;const H=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(Ue){return H.get(Ue)??s.CompletionItemKind.Property}Ie.to=Me})(Ce||(e.CompletionItemKind=Ce={}));var T;(function(Ie){function Le(me,H){const Me=new s.$2K(me.label);return Me.insertText=me.insertText,Me.kind=Ce.to(me.kind),Me.tags=me.tags?.map(ge.to),Me.detail=me.detail,Me.documentation=R.$5j(me.documentation)?U.to(me.documentation):me.documentation,Me.sortText=me.sortText,Me.filterText=me.filterText,Me.preselect=me.preselect,Me.commitCharacters=me.commitCharacters,v.$ws.isIRange(me.range)?Me.range=p.to(me.range):typeof me.range=="object"&&(Me.range={inserting:p.to(me.range.insert),replacing:p.to(me.range.replace)}),Me.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Me.insertText=new s.$GK(me.insertText):(Me.insertText=me.insertText,Me.textEdit=Me.range instanceof s.$xK?new s.$CK(Me.range,Me.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Me.additionalTextEdits=me.additionalTextEdits.map(Ue=>Pe.to(Ue))),Me.command=H&&me.command?H.fromInternal(me.command):void 0,Me}Ie.to=Le})(T||(e.CompletionItem=T={}));var q;(function(Ie){function Le(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:U.fromStrict(H.documentation)}}Ie.from=Le;function me(H){return{label:H.label,documentation:R.$5j(H.documentation)?U.to(H.documentation):H.documentation}}Ie.to=me})(q||(e.ParameterInformation=q={}));var G;(function(Ie){function Le(H){return{label:H.label,documentation:U.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(q.from):[],activeParameter:H.activeParameter}}Ie.from=Le;function me(H){return{label:H.label,documentation:R.$5j(H.documentation)?U.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(q.to):[],activeParameter:H.activeParameter}}Ie.to=me})(G||(e.SignatureInformation=G={}));var J;(function(Ie){function Le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.from):[]}}Ie.from=Le;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.to):[]}}Ie.to=me})(J||(e.SignatureHelp=J={}));var K;(function(Ie){function Le(me,H){const Me=new s.$1K(I.to(H.position),typeof H.label=="string"?H.label:H.label.map(x.to.bind(void 0,me)),H.kind&&ce.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(Pe.to),Me.tooltip=R.$5j(H.tooltip)?U.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ie.to=Le})(K||(e.InlayHint=K={}));var x;(function(Ie){function Le(me,H){const Me=new s.$ZK(H.label);return Me.tooltip=R.$5j(H.tooltip)?U.to(H.tooltip):H.tooltip,f.Command.is(H.command)&&(Me.command=me.fromInternal(H.command)),H.location&&(Me.location=_.to(H.location)),Me}Ie.to=Le})(x||(e.InlayHintLabelPart=x={}));var ce;(function(Ie){function Le(H){return H}Ie.from=Le;function me(H){return H}Ie.to=me})(ce||(e.InlayHintKind=ce={}));var Ne;(function(Ie){function Le(H){return{range:p.from(H.range),url:H.target,tooltip:H.tooltip}}Ie.from=Le;function me(H){let Me;if(H.url)try{Me=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new s.$7K(p.to(H.range),Me)}Ie.to=me})(Ne||(e.DocumentLink=Ne={}));var je;(function(Ie){function Le(H){const Me=new s.$0K(H.label);return H.textEdit&&(Me.textEdit=Pe.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(Ue=>Pe.to(Ue))),Me}Ie.to=Le;function me(H){return{label:H.label,textEdit:H.textEdit?Pe.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>Pe.from(Me)):void 0}}Ie.from=me})(je||(e.ColorPresentation=je={}));var Qe;(function(Ie){function Le(H){return new s.$8K(H[0],H[1],H[2],H[3])}Ie.to=Le;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ie.from=me})(Qe||(e.Color=Qe={}));var Ge;(function(Ie){function Le(H){return{range:p.from(H.range)}}Ie.from=Le;function me(H){return new s.$QK(p.to(H.range))}Ie.to=me})(Ge||(e.SelectionRange=Ge={}));var _e;(function(Ie){function Le(me){switch(me){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ie.to=Le})(_e||(e.TextDocumentSaveReason=_e={}));var Ye;(function(Ie){function Le(H){switch(H){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Le;function me(H){switch(H){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ie.to=me})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var xe;(function(Ie){function Le(H){if(H===s.EndOfLine.CRLF)return 1;if(H===s.EndOfLine.LF)return 0}Ie.from=Le;function me(H){if(H===1)return s.EndOfLine.CRLF;if(H===0)return s.EndOfLine.LF}Ie.to=me})(xe||(e.EndOfLine=xe={}));var it;(function(Ie){function Le(me){if(typeof me=="object")return me.viewId;switch(me){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Le})(it||(e.ProgressLocation=it={}));var tt;(function(Ie){function Le(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=ze.from(H.kind)),Me}Ie.from=Le;function me(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=ze.to(H.kind)),Me}Ie.to=me})(tt||(e.FoldingRange=tt={}));var ze;(function(Ie){function Le(H){if(H)switch(H){case s.FoldingRangeKind.Comment:return f.$lt.Comment;case s.FoldingRangeKind.Imports:return f.$lt.Imports;case s.FoldingRangeKind.Region:return f.$lt.Region}}Ie.from=Le;function me(H){if(H)switch(H.value){case f.$lt.Comment.value:return s.FoldingRangeKind.Comment;case f.$lt.Imports.value:return s.FoldingRangeKind.Imports;case f.$lt.Region.value:return s.FoldingRangeKind.Region}}Ie.to=me})(ze||(e.FoldingRangeKind=ze={}));var ut;(function(Ie){function Le(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?p.from(me.selection):void 0,override:typeof me.override=="boolean"?r.$YD.id:void 0}}Ie.from=Le})(ut||(e.TextEditorOpenOptions=ut={}));var Z;(function(Ie){function Le(Ue){return Ue instanceof s.$rL?Ue.toJSON():typeof Ue=="string"?Ue:me(Ue)||H(Ue)?new s.$rL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ie.from=Le;function me(Ue){const Je=Ue;return Je?b.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function H(Ue){const Je=Ue;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new s.$rL(b.URI.revive(Ue.baseUri),Ue.pattern)}Ie.to=Me})(Z||(e.GlobPattern=Z={}));var Q;(function(Ie){function Le(me){if(me){if(Array.isArray(me))return me.map(Le);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:Z.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ie.from=Le})(Q||(e.LanguageSelector=Q={}));var we;(function(Ie){function Le(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&b.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Je=>Je instanceof s.$xK)))}Ie.is=Le;function me(H){return{documents:H.documents.map(Me=>Me.map(Ue=>({uri:b.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Je=>p.from(Je))})))}}Ie.from=me})(we||(e.MappedEditsContext=we={}));var Be;(function(Ie){function Le(H){return{start:H.start,end:H.end}}Ie.from=Le;function me(H){return new s.$SL(H.start,H.end)}Ie.to=me})(Be||(e.NotebookRange=Be={}));var Oe;(function(Ie){function Le(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ie.to=Le;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ie.from=me})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var Xe;(function(Ie){function Le(me){if(me===u.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(me===u.NotebookCellExecutionState.Pending)return;if(me===u.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ie.to=Le})(Xe||(e.NotebookCellExecutionState=Xe={}));var nt;(function(Ie){function Le(H){switch(H){case s.NotebookCellKind.Markup:return u.CellKind.Markup;case s.NotebookCellKind.Code:default:return u.CellKind.Code}}Ie.from=Le;function me(H){switch(H){case u.CellKind.Markup:return s.NotebookCellKind.Markup;case u.CellKind.Code:default:return s.NotebookCellKind.Code}}Ie.to=me})(nt||(e.NotebookCellKind=nt={}));var $t;(function(Ie){function Le(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const Ue of H.cells)s.$TL.validate(Ue),Me.cells.push(bt.from(Ue));return Me}Ie.from=Le;function me(H){const Me=new s.$UL(H.cells.map(bt.to));return(0,o.$Lf)(H.metadata)||(Me.metadata=H.metadata),Me}Ie.to=me})($t||(e.NotebookData=$t={}));var bt;(function(Ie){function Le(H){return{cellKind:nt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Oe.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Kt.from):[]}}Ie.from=Le;function me(H){return new s.$TL(nt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Kt.to):void 0,H.metadata,H.internalMetadata?Oe.to(H.internalMetadata):void 0)}Ie.to=me})(bt||(e.NotebookCellData=bt={}));var Pt;(function(Ie){function Le(H){return{mime:H.mime,valueBytes:L.$be.wrap(H.data)}}Ie.from=Le;function me(H){return new s.$VL(H.valueBytes.buffer,H.mime)}Ie.to=me})(Pt||(e.NotebookCellOutputItem=Pt={}));var Kt;(function(Ie){function Le(H){return{outputId:H.id,items:H.items.map(Pt.from),metadata:H.metadata}}Ie.from=Le;function me(H){const Me=H.items.map(Pt.to);return new s.$WL(Me,H.outputId,H.metadata)}Ie.to=me})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ie){function Le(Me){return H(Me)?{include:Z.from(Me.include)??void 0,exclude:Z.from(Me.exclude)??void 0}:Z.from(Me)??void 0}Ie.from=Le;function me(Me){return H(Me)?{include:Z.to(Me.include),exclude:Z.to(Me.exclude)}:Z.to(Me)}Ie.to=me;function H(Me){const Ue=Me;return Ue?!(0,o.$Hf)(Ue.include)&&!(0,o.$Hf)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Ie){function Le(me,H,Me){const Ue=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ue,Me),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ie.from=Le})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Ie){function Le(me,H,Me){const Ue=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(Ue,Me),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ie.from=Le})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Nt;(function(Ie){function Le(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ie.from=Le})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Ie){function Le(H){return{uri:H.uri,provides:H.provides}}Ie.from=Le;function me(H){return new s.$YL(b.URI.revive(H.uri),H.provides)}Ie.to=me})(Gt||(e.NotebookRendererScript=Gt={}));var jt;(function(Ie){function Le(H){return{message:U.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:p.from(H.location.range),uri:H.location.uri}}}Ie.from=Le;function me(H){const Me=new s.$5L(typeof H.message=="string"?H.message:U.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?_.to(H.location):void 0,Me}Ie.to=me})(jt||(e.TestMessage=jt={}));var kt;(function(Ie){Ie.namespace=l.$nJ,Ie.denamespace=l.$oJ})(kt||(e.TestTag=kt={}));var Ft;(function(Ie){function Le(H){const Me=(0,i.$qM)(H).controllerId;return{extId:a.$jJ.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Ue=>kt.namespace(Me,Ue.id)),range:v.$ws.lift(p.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&U.fromStrict(H.error)||null}}Ie.from=Le;function me(H){return{parent:void 0,error:void 0,id:a.$jJ.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:Ue}=kt.denamespace(Me);return new s.$6L(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:p.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ie.toPlain=me})(Ft||(e.TestItem=Ft={})),function(Ie){function Le(H){return{id:H.id}}Ie.from=Le;function me(H){return new s.$6L(H.id)}Ie.to=me}(kt||(e.TestTag=kt={}));var Bt;(function(Ie){const Le=(H,Me)=>{const Ue=[];for(const[qe,et]of Me)a.$jJ.compare(et.item.extId,qe)===2&&(Me.delete(qe),Ue.push(et));const Je={...Ft.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(jt.to)})),children:Ue.map(qe=>Le(qe,Me))};for(const qe of Je.children)qe.parent=Je;return Je};function me(H){const Me=[],Ue=new Map;for(const Je of H.items){Ue.set(Je.item.extId,Je);const qe=a.$jJ.root(Je.item.extId);H.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:H.completedAt,results:Me.map(Je=>Le(Je,Ue))}}Ie.to=me})(Bt||(e.TestResults=Bt={}));var Jt;(function(Ie){function Le(Ue){return{covered:Ue.covered,total:Ue.covered}}function me(Ue){return"line"in Ue?I.from(Ue):p.from(Ue)}function H(Ue){return"branches"in Ue?{count:Ue.executionCount,location:me(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Je=>({count:Je.executionCount,location:Je.location&&me(Je.location)})):void 0}:{type:0,count:Ue.executionCount,location:me(Ue.location)}}Ie.fromDetailed=H;function Me(Ue){return{uri:Ue.uri,statement:Le(Ue.statementCoverage),branch:Ue.branchCoverage&&Le(Ue.branchCoverage),function:Ue.functionCoverage&&Le(Ue.functionCoverage),details:Ue.detailedCoverage?.map(H)}}Ie.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Ie){function Le(me){switch(me){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ie.to=Le})(Wt||(e.CodeActionTriggerKind=Wt={}));var Vt;(function(Ie){function Le(H){const Me=new s.$_L(be.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),p.to(H.range),p.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ie.to=Le;function me(H,Me,Ue){if(Me=Me??H._sessionId,Ue=Ue??H._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:be.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:p.from(H.range),selectionRange:p.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ie.from=me})(Vt||(e.TypeHierarchyItem=Vt={}));var Ot;(function(Ie){function Le(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ie.from=Le})(Ot||(e.ViewBadge=Ot={}));var at;(function(Ie){function Le(Ue,Je,qe){const et=Je.fileData;return et?new s.$kL(new s.$lL(et.name,b.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):Ue===A.$Sr.uriList&&Je.uriListData?new s.$jL(Me(Je.uriListData)):new s.$jL(Je.asString)}Ie.to=Le;async function me(Ue,Je){const qe=await Je.asString();if(Ue===A.$Sr.uriList)return{asString:qe,fileData:void 0,uriListData:H(qe)};const et=Je.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ie.from=me;function H(Ue){return P.$6s.split(Ue).map(Je=>{if(Je.startsWith("#"))return Je;try{return b.URI.parse(Je)}catch{}return Je})}function Me(Ue){return P.$6s.create(Ue.map(Je=>typeof Je=="string"?Je:b.URI.revive(Je)))}})(at||(e.DataTransferItem=at={}));var dt;(function(Ie){function Le(H,Me){const Ue=H.items.map(([Je,qe])=>[Je,at.to(Je,qe,Me)]);return new s.$mL(Ue)}Ie.toDataTransfer=Le;async function me(H){const Me={items:[]},Ue=[];for(const[Je,qe]of H)Ue.push((async()=>{Me.items.push([Je,await at.from(Je,qe)])})());return await Promise.all(Ue),Me}Ie.from=me})(dt||(e.DataTransfer=dt={}));var At;(function(Ie){function Le(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ie.to=Le;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ie.from=me})(At||(e.ChatReplyFollowup=At={}));var qt;(function(Ie){function Le(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:At.from(me)}Ie.from=Le})(qt||(e.ChatFollowup=qt={}));var Rt;(function(Ie){function Le(H){const Me=new s.$jM(ot.to(H.role),H.content);return Me.name=H.name,Me}Ie.to=Le;function me(H){return{role:ot.from(H.role),content:H.content,name:H.name}}Ie.from=me})(Rt||(e.ChatMessage=Rt={}));var ot;(function(Ie){function Le(H){switch(H){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ie.to=Le;function me(H){switch(H){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ie.from=me})(ot||(e.ChatMessageRole=ot={}));var wt;(function(Ie){function Le(Me){const Ue={};for(const Je of Object.keys(Me))Ue[Je]=Me[Je].map(Ie.to);return Ue}Ie.objectTo=Le;function me(Me){return{level:Tt.to(Me.level),value:Me.value,description:Me.description}}Ie.to=me;function H(Me){return{level:Tt.from(Me.level),value:Me.value,description:Me.description}}Ie.from=H})(wt||(e.ChatVariable=wt={}));var Tt;(function(Ie){function Le(H){switch(H){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ie.to=Le;function me(H){switch(H){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ie.from=me})(Tt||(e.ChatVariableLevel=Tt={}));var Ct;(function(Ie){function Le(me){switch(me){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Le})(Ct||(e.InteractiveEditorResponseFeedbackKind=Ct={}));var We;(function(Ie){function Le(me,H){return"placeholder"in H&&"resolvedContent"in H?{placeholder:H.placeholder}:"responseId"in H?{requestId:H.responseId}:"markdownContent"in H?((0,c.$lF)(me,"chatAgents2Additions"),{content:U.from(H.markdownContent)}):"content"in H?typeof H.content=="string"?H:((0,c.$lF)(me,"chatAgents2Additions"),{content:U.from(H.content)}):"documents"in H?{documents:H.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>p.from(Ue))}))}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:p.from(H.reference.range)}:H.reference}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:p.from(H.inlineReference.range)}:H.inlineReference,title:H.title}:("agentName"in H&&(0,c.$lF)(me,"chatAgents2Additions"),H)}Ie.from=Le})(We||(e.ChatResponseProgress=We={}));var Qt;(function(Ie){function Le(me,H,Me){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Me)}Ie.from=Le})(Qt||(e.TerminalQuickFix=Qt={}))}),define(Ae[218],Re([1,0,2,11,7,8,184]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class ${constructor(g,A,S,o={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=S,this.g=o,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,S,o)=>{const v={dispose:this.a.push([A,S,g])};return Array.isArray(o)&&o.push(v),v}}async $participateInSave(g,A){const S=E.URI.revive(g);let o=!1;const b=setTimeout(()=>o=!0,this.g.timeout),v=[];try{for(const f of[...this.a]){if(o)break;const t=this.d.getDocument(S),i=await this.h(f,{document:t,reason:M.TextDocumentSaveReason.to(A)});v.push(i)}}finally{clearTimeout(b)}return v}h([g,A,S],o){const b=this.b.get(g);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(S,g,A,o).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,S,o){const b=[],v=Date.now(),{document:f,reason:t}=o,{version:i}=f,r=Object.freeze({document:f,reason:t,waitUntil(u){if(Object.isFrozen(b))throw(0,L.$7)("waitUntil can not be called async");b.push(Promise.resolve(u))}});try{A.apply(S,[r])}catch(u){return Promise.reject(u)}return Object.freeze(b),new Promise((u,a)=>{const l=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(l),u(n)}).catch(n=>{clearTimeout(l),a(n)})}).then(u=>{const a={edits:[]};for(const l of u)if(Array.isArray(l)&&l.every(n=>n instanceof P.$CK))for(const{newText:n,newEol:s,range:c}of l)a.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&M.Range.from(c),text:n,eol:s&&M.EndOfLine.from(s)}});if(a.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$4cc=$}),define(Ae[219],Re([1,0,14,2,8,7,75]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=void 0;class ${constructor(S,o,b,v){this.start=S,this.deletedCount=o,this.deletedItems=b,this.items=v}asApiEvent(){return{range:new M.$SL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,o){return{EOL:o.eol,lines:o.source,languageId:o.language,uri:o.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,o,b){this.notebook=S,this.h=o,this.j=b,this.handle=b.handle,this.uri=L.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(P.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,o=this.h.getDocument(this.uri);if(!o)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:o.document,get mime(){return S.g},set mime(v){S.g=v},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(b)}return this.f}setOutputs(S){this.a=S.map(P.NotebookCellOutput.to)}setOutputItems(S,o,b){const v=b.map(P.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===S);if(f&&(o||(f.items.length=0),f.items.push(...v),f.items.length>1&&f.items.every(t=>R.$zI(t.mime)))){const t=new Map,i=[];f.items.forEach(r=>{let u;t.has(r.mime)?u=t.get(r.mime):(u=[],t.set(r.mime,u),i.push(r.mime)),u.push(r.data)}),f.items.length=0,i.forEach(r=>{const u=R.$AI(t.get(r));f.items.push({mime:r,data:u.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$eec=D;class g{static{this.a=0}constructor(S,o,b,v,f){this.k=S,this.l=o,this.m=b,this.uri=v,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,o={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(b){return b=S.n(b),S.b[b].apiCell},getCells(b){return(b?S.p(b):S.b).map(f=>f.apiCell)},save(){return S.q()}};this.e=Object.freeze(o)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,o,b){this.g=S.versionId,this.h=o,this.acceptDocumentPropertiesChanged({metadata:b});const v={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},f=[];for(const i of S.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,v.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,v.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const r=f[i],u=t.get(r.cell);if(u===void 0){const a=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});t.set(r.cell,a-1)}else v.cellChanges[u]={...v.cellChanges[u],...r}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let o=S.start|0,b=S.end|0;return o<0&&(o=0),b>this.b.length&&(b=this.b.length),S.with({start:o,end:b})}p(S){S=this.o(S);const o=[];for(let b=S.start;b<S.end;b++)o.push(this.b[b]);return o}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,o,b){if(this.j)return;const v=[],f=[],t=[];if(S.reverse().forEach(i=>{const u=i[2].map(n=>{const s=new D(this,this.l,n);return o||f.push(D.asModelAddData(this.apiNotebook,n)),s}),a=new $(i[0],i[1],[],u),l=this.b.splice(i[0],i[1],...u);for(const n of l)t.push(n.uri),a.deletedItems.push(n.apiCell);v.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),b)for(const i of v)b.push(i.asApiEvent())}s(S,o,b,v){const f=this.b.splice(S,o);this.b.splice(b,0,...f);const t=[new $(S,o,f.map(i=>i.apiCell),[]),new $(b,0,[],f)];for(const i of t)v.push(i.asApiEvent())}t(S,o){this.b[S].setOutputs(o)}u(S,o,b,v){this.b[S].setOutputItems(o,b,v)}v(S,o){const b=this.b[S];b.apiCell.document.languageId!==o&&this.m.$acceptModelLanguageChanged(b.uri,o)}w(S,o){const b=this.b[S];b.apiCell.mime=o}x(S,o){this.b[S].setMetadata(o)}y(S,o){this.b[S].setInternalMetadata(o)}getCellFromApiCell(S){return this.b.find(o=>o.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(o=>o.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$fec=g}),define(Ae[220],Re([1,0,5,2,8,7]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class R{constructor(D,g,A,S={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=A,this.f=S,this.a=new E.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,A,S)=>{const o=function(v){g.call(A,v)};return o.extension=D,this.a.event(o,void 0,S)}}async $participateInSave(D,g,A){const S=L.URI.revive(D),o=this.c.getNotebookDocument(S);if(!o)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:o.apiNotebook,reason:P.TextDocumentSaveReason.to(g)},A,async(f,t)=>{const i=Date.now(),r=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&r&&(r instanceof M.$FK?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(b.length===0)return!0;const v={edits:[]};for(const f of b){const{edits:t}=P.WorkspaceEdit.from(f);v.edits=v.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$Fec=R}),define(Ae[107],Re([1,0,11,8,7]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,D,g,A,S,o){this.id=$,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=o}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(D){this.selections=[D]},get selections(){return $.a},set selections(D){if(!Array.isArray(D)||!D.every(P.$SL.isNotebookRange))throw(0,E.$6)("selections");$.a=D,$.g(D)},get visibleRanges(){return $.b},revealRange(D,g){$.f.$tryRevealRange($.id,L.NotebookRange.from(D),g??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(L.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$gec=M}),define(Ae[221],Re([1,0,11,5,15,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let R=class{constructor(D,g){this.c=D,this.d=g,this.a=new L.$Nd({onListenerError:E.$1}),this.b=new L.$Nd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const A=this.d.getEditorById(D);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(M.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(M.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(M.ViewColumn.to(D[g]))}};e.$yec=R,e.$yec=R=Ke([Ve(0,P.$0i)],R)}),define(Ae[222],Re([1,0,8,53,163,19,66,11]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class D{constructor(o){this.b=0,this.c=new Map,this.a=o}async withProgress(o,b,v){const f=this.b++,{title:t,location:i,cancellable:r}=b,u={label:(0,P.localize)(0,null,o.displayName||o.name),id:o.identifier.value};return this.a.$startProgress(f,{location:E.ProgressLocation.from(i),title:t,source:u,cancellable:r},o.isUnderDevelopment?void 0:o.identifier.value).catch($.$1),this.d(f,v,!!r)}d(o,b,v){let f;v&&(f=new M.$Xd,this.c.set(o,f));const t=r=>{this.a.$progressEnd(r),this.c.delete(r),f?.dispose()};let i;try{i=b(new A(this.a,o),v&&f?f.token:M.CancellationToken.None)}catch(r){throw t(o),r}return i.then(r=>t(o),r=>t(o)),i}$acceptProgressCanceled(o){const b=this.c.get(o);b&&(b.cancel(),this.c.delete(o))}}e.$Cdc=D;function g(S,o){return S.message=o.message,typeof o.increment=="number"&&(typeof S.increment=="number"?S.increment+=o.increment:S.increment=o.increment),S}class A extends L.$8u{constructor(o,b){super(v=>this.throttledReport(v)),this.c=o,this.d=b}throttledReport(o){this.c.$progressReport(this.d,o)}}Ke([(0,R.$jh)(100,(S,o)=>g(S,o),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[108],Re([1,0,29,104,47,76,59,8,2]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=e.$GM=void 0;const g=(u,a,l,n)=>{let s=a;return{enumerable:!0,configurable:!1,get(){return s},set(c){if(!l(s,c)){const h=s;s=c,u.listener?.(n(c,h))}}}},A=(u,a)=>u===a,S={range:(u,a)=>u===a?!0:!u||!a?!1:u.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(u,a)=>!(u.length!==a.length||u.some(l=>!a.find(n=>l.id===n.id)))},o=u=>a=>({op:4,update:u(a)}),b=(u,a)=>({range:(()=>{let l;const n=o(s=>({range:E.$ws.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){u.listener?.({op:6}),S.range(l,s)||(l=s,u.listener?.(n(s)))}}})(),label:g(u,a,S.label,o(l=>({label:l}))),description:g(u,void 0,S.description,o(l=>({description:l}))),sortText:g(u,void 0,S.sortText,o(l=>({sortText:l}))),canResolveChildren:g(u,!1,S.canResolveChildren,l=>({op:2,state:l})),busy:g(u,!1,S.busy,o(l=>({busy:l}))),error:g(u,void 0,S.error,o(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:g(u,[],S.tags,(l,n)=>({op:1,new:l.map($.TestTag.from),old:n.map($.TestTag.from)}))}),v=u=>{const a=P.$jJ.fromString(u.extId),l=new t(a.controllerId,a.localId,u.label,D.URI.revive(u.uri)||void 0);return l.range=$.Range.to(u.range||void 0),l.description=u.description||void 0,l.sortText=u.sortText||void 0,l.tags=u.tags.map(n=>$.TestTag.to({id:(0,R.$oJ)(n).tagId})),l},f=u=>{let a;for(const l of u.tests){const n=v(l.item);(0,L.$qM)(n).parent=a,a=n}return a};e.$GM=f;class t{constructor(a,l,n,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,L.$pM)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,M.$oM)(c,L.$qM,t),enumerable:!0,writable:!1},...b(c,n)})}}e.$HM=t;class i extends t{constructor(a,l){super(a,a,l,void 0),this._isRoot=!0}}e.$IM=i;class r extends M.$kM{constructor(a,l,n){super({controllerId:a,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:L.$qM,getChildren:s=>s.children,root:new i(a,l),toITestItem:$.TestItem.from})}}e.$JM=r}),define(Ae[109],Re([1,0,54,11,88,8,7]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=void 0;class ${static{this.c=new P.$zM("TextEditorDecorationType")}constructor(o,b,v){const f=$.c.nextId();o.$registerTextEditorDecorationType(b.identifier,f,M.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:f,dispose(){o.$removeTextEditorDecorationType(f)}})}}e.$BM=$;class D{constructor(o,b){this.g=[],this.h=void 0,this.j=!1,this.c=o,this.d=o.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(o,b){this.k();let v=null;if(o instanceof R.$wK)v=new R.$xK(o,o);else if(o instanceof R.$xK)v=o;else throw new Error("Unrecognized location");this.l(v,b,!1)}insert(o,b){this.k(),this.l(new R.$xK(o,o),b,!0)}delete(o){this.k();let b=null;if(o instanceof R.$xK)b=o;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(o,b,v){const f=this.c.validateRange(o);this.g.push({range:f,text:b,forceMoveMarkers:v})}setEndOfLine(o){if(this.k(),o!==R.EndOfLine.LF&&o!==R.EndOfLine.CRLF)throw(0,L.$6)("endOfLine");this.h=o}}class g{constructor(o,b,v,f){this.c=o,this.d=b,this._accept(v),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(o){this.f=o.tabSize,this.g=o.indentSize,this.h=o.insertSpaces,this.j=o.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(o.lineNumbers)}l(o){if(o==="auto")return"auto";if(typeof o=="number"){const b=Math.floor(o);return b>0?b:null}if(typeof o=="string"){const b=parseInt(o,10);return isNaN(b)?null:b>0?b:null}return null}m(o){const b=this.l(o);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(o){if(o==="tabSize")return"tabSize";if(typeof o=="number"){const b=Math.floor(o);return b>0?b:null}if(typeof o=="string"){const b=parseInt(o,10);return isNaN(b)?null:b>0?b:null}return null}o(o){const b=this.n(o);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(o){return o==="auto"?"auto":o==="false"?!1:!!o}q(o){const b=this.p(o);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(o){this.j!==o&&(this.j=o,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:o})))}t(o){this.k!==o&&(this.k=o,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(o)})))}assign(o){const b={};let v=!1;if(typeof o.tabSize<"u"){const f=this.l(o.tabSize);f==="auto"?(v=!0,b.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,v=!0,b.tabSize=f)}if(typeof o.indentSize<"u"){const f=this.n(o.indentSize);f==="tabSize"?(v=!0,b.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,v=!0,b.indentSize=f)}if(typeof o.insertSpaces<"u"){const f=this.p(o.insertSpaces);f==="auto"?(v=!0,b.insertSpaces=f):this.h!==f&&(this.h=f,v=!0,b.insertSpaces=f)}typeof o.cursorStyle<"u"&&this.j!==o.cursorStyle&&(this.j=o.cursorStyle,v=!0,b.cursorStyle=o.cursorStyle),typeof o.lineNumbers<"u"&&this.k!==o.lineNumbers&&(this.k=o.lineNumbers,v=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(o.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(o,b){b.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${o}' failed:'`),this.e.warn(v)})}}e.$CM=g;class A{constructor(o,b,v,f,t,i,r,u){this.id=o,this.j=b,this.k=v,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,v),this.e=r,this.f=u;const a=this;this.value=Object.freeze({get document(){return f.value},set document(l){throw new L.$8("document")},get selection(){return a.c&&a.c[0]},set selection(l){if(!(l instanceof R.$yK))throw(0,L.$6)("selection");a.c=[l],a.l()},get selections(){return a.c},set selections(l){if(!Array.isArray(l)||l.some(n=>!(n instanceof R.$yK)))throw(0,L.$6)("selections");a.c=l,a.l()},get visibleRanges(){return a.e},set visibleRanges(l){throw new L.$8("visibleRanges")},get options(){return a.d.value},set options(l){a.g||a.d.assign(l)},get viewColumn(){return a.f},set viewColumn(l){throw new L.$8("viewColumn")},edit(l,n={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,n);return l(s),a.m(s)},insertSnippet(l,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!n||Array.isArray(n)&&n.length===0)c=a.c.map(h=>M.Range.from(h));else if(n instanceof R.$wK){const{lineNumber:h,column:p}=M.Position.from(n);c=[{startLineNumber:h,startColumn:p,endLineNumber:h,endColumn:p}]}else if(n instanceof R.$xK)c=[M.Range.from(n)];else{c=[];for(const h of n)if(h instanceof R.$xK)c.push(M.Range.from(h));else{const{lineNumber:p,column:m}=M.Position.from(h);c.push({startLineNumber:p,startColumn:m,endLineNumber:p,endColumn:m})}}return b.$tryInsertSnippet(o,f.value.version,l.value,c,s)},setDecorations(l,n){const s=n.length===0;s&&!a.h.has(l.key)||(s?a.h.delete(l.key):a.h.add(l.key),a.n(()=>{if(M.$rM(n))return b.$trySetDecorations(o,l.key,M.$sM(n));{const c=new Array(4*n.length);for(let h=0,p=n.length;h<p;h++){const m=n[h];c[4*h]=m.start.line+1,c[4*h+1]=m.start.character+1,c[4*h+2]=m.end.line+1,c[4*h+3]=m.end.character+1}return b.$trySetDecorationsFast(o,l.key,c)}}))},revealRange(l,n){a.n(()=>b.$tryRevealRange(o,M.Range.from(l),n||R.TextEditorRevealType.Default))},show(l){b.$tryShowEditor(o,M.ViewColumn.from(l))},hide(){b.$tryHideEditor(o)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(o){(0,E.ok)(!this.g),this.d._accept(o)}_acceptVisibleRanges(o){(0,E.ok)(!this.g),this.e=o}_acceptViewColumn(o){(0,E.ok)(!this.g),this.f=o}_acceptSelections(o){(0,E.ok)(!this.g),this.c=o}async l(){const o=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,o)),this.value}m(o){const b=o.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const v=b.edits.map(t=>t.range);v.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=v.length-1;t<i;t++){const r=v[t].end;if(v[t+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,f,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(o){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$DM=A}),define(Ae[223],Re([1,0,167,25,2,5,6,203,12,7,16,18,8,52,19,131,24]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;function i(a,l){if((0,A.$yf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let n;return Array.isArray(a.highlights)&&(n=a.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:a.label,highlights:n}}}class r extends R.$Rc{constructor(l,n,s){super(),this.f=l,this.g=n,this.h=s,this.a=new Map,this.b=new f.$57;function c(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:h=>c(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(p=>c(p)?this.r(p):p):h})}registerTreeDataProvider(l,n,s){const c=this.createTreeView(l,{treeDataProvider:n},s);return{dispose:()=>c.dispose()}}createTreeView(l,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=n.dragAndDropController?.dropMimeTypes??[],h=n.dragAndDropController?.dragMimeTypes??[],p=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,I=this.m(l,n,s),k={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:c,dragMimeTypes:h,hasHandleDrag:p,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,k),y={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$lF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$lF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(w){(0,b.$5j)(w)&&(0,t.$lF)(s,"treeViewMarkdownMessage"),I.message=w},get title(){return I.title},set title(w){I.title=w},get description(){return I.description},set description(w){I.description=w},get badge(){return I.badge},set badge(w){w!==void 0&&g.ViewBadge.isViewBadge(w)?I.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(I.badge=void 0)},reveal:(w,C)=>I.reveal(w,C),dispose:async()=>{await d,this.a.delete(l),I.dispose()}};return this.B(y),y}$getChildren(l,n){const s=this.a.get(l);return s?s.getChildren(n):Promise.reject(new $.$wE(l))}async $handleDrop(l,n,s,c,h,p,m,I){const k=this.a.get(l);if(!k)return Promise.reject(new $.$wE(l));const d=o.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(l,n,y)).buffer);return m===l&&I&&await this.j(d,k,I,h,p),k.onDrop(d,c,h)}async j(l,n,s,c,h){const p=this.b.removeDragOperationTransfer(h);if(p)(await p)?.forEach((m,I)=>{m&&l.set(I,m)});else if(h&&n.handleDrag){const m=n.handleDrag(s,l,c);this.b.addDragOperationTransfer(h,m),await m}return l}async $handleDrag(l,n,s,c){const h=this.a.get(l);if(!h)return Promise.reject(new $.$wE(l));const p=await this.j(new g.$mL,h,n,c,s);if(!(!p||c.isCancellationRequested))return o.DataTransfer.from(p)}async $hasResolve(l){const n=this.a.get(l);if(!n)throw new $.$wE(l);return n.hasResolve}$resolve(l,n,s){const c=this.a.get(l);if(!c)throw new $.$wE(l);return c.resolveTreeItem(n,s)}$setExpanded(l,n,s){const c=this.a.get(l);if(!c)throw new $.$wE(l);c.setExpanded(n,s)}$setSelectionAndFocus(l,n,s){const c=this.a.get(l);if(!c)throw new $.$wE(l);c.setSelectionAndFocus(n,s)}$setVisible(l,n){const s=this.a.get(l);if(!s){if(!n)return;throw new $.$wE(l)}s.setVisible(n)}$changeCheckboxState(l,n){const s=this.a.get(l);if(!s)throw new $.$wE(l);s.setCheckboxState(n)}m(l,n,s){const c=this.B(new u(l,n,this.f,this.g.converter,this.h,s));return this.a.set(l,c),c}r(l){const n=this.a.get(l.$treeViewId);return n&&"$treeItemHandle"in l?n.getExtensionElement(l.$treeItemHandle):n&&"$focusedTreeItem"in l&&l.$focusedTreeItem?n.focusedElement:null}}e.$Jdc=r;class u extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$Hf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,n,s,c,h,p){if(super(),this.I=l,this.J=s,this.L=c,this.M=h,this.N=p,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$Xd,p.contributes&&p.contributes.views)for(const d in p.contributes.views)for(const y of p.contributes.views[d])y.id===l&&(this.P=y.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let m,I;const k=M.Event.debounce(this.F.event,(d,y)=>(d||(d={message:!1,elements:[]}),y.element!==!1&&(m||(m=new Promise(w=>I=w),this.G=this.G.then(()=>m)),Array.isArray(y.element)?d.elements.push(...y.element):d.elements.push(y.element)),y.message&&(d.message=!0),d),200,!0);this.B(k(({message:d,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const w=I;return m=null,this.$(y).then(()=>w())})),d&&this.J.$setMessage(this.I,o.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const n=l?this.getExtensionElement(l):void 0;if(l&&!n)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(n)),s?s.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,n){n=n||{select:!0,focus:!1};const s=(0,A.$Hf)(n.select)?!0:n.select,c=(0,A.$Hf)(n.focus)?!1:n.focus,h=(0,A.$Hf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(p=>this.W(l,p[p.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:p.map(I=>I.item)},{select:s,focus:c,expand:h})),p=>this.M.error(p)):this.J.$reveal(this.I,void 0,{select:s,focus:c,expand:h})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=o.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,n){const s=this.getExtensionElement(l);s&&(n?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,n){const s=!(0,S.$tb)(this.s,l);this.s=l;const c=this.t!==n;this.t=n,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const n=(await Promise.all(l.map(async s=>{const c=this.getExtensionElement(s.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,n,s){const c=[];for(const h of l){const p=this.getExtensionElement(h);p&&c.push(p)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,n,s){const c=n?this.getExtensionElement(n):void 0;if(!(!c&&n||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,n){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const c=this.m.get(s);if(c){const h=await this.f.resolveTreeItem(c.extensionItem,s,n)??c.extensionItem;return this.hb(h),c.item.tooltip=this.eb(h.tooltip),c.item.command=this.fb(c.disposableStore,h.command),c.item}}}S(l){return this.U(l).then(n=>n?this.S(n).then(s=>this.W(n,s[s.length-1]).then(c=>(s.push(c),s))):Promise.resolve([]))}U(l){const n=this.m.get(l);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(l))}W(l,n){const s=this.m.get(l);return s?Promise.resolve(s):(0,D.$Mg)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,n,!0)).then(c=>this.getChildren(n?n.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const p=this.m.get(h);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let n;if(typeof l=="string"){const s=this.getExtensionElement(l);n=s?this.m.get(s):void 0}else n=l;return n&&n.children||void 0}return this.h}async Y(l){this.rb(l);const n=new v.$Xd(this.Z.token);try{const s=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(n.token.isCancellationRequested)return;const h=await Promise.all((0,S.$Gb)(c||[]).map(async p=>{const m=await this.f.getTreeItem(p);return m&&!n.token.isCancellationRequested?this.db(p,m,s):null}));return n.token.isCancellationRequested?void 0:(0,S.$Gb)(h)}finally{n.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new v.$Xd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const n=new Set,s=l.map(h=>this.m.get(h));for(const h of s)if(h&&!n.has(h.item.handle)){let p=h;for(;p&&p.parent&&s.findIndex(m=>p&&p.parent&&m&&m.item.handle===p.parent.item.handle)===-1;){const m=this.j.get(p.parent.item.handle);p=m?this.m.get(m):void 0}p&&!p.parent&&n.add(h.item.handle)}const c=[];return n.forEach(h=>{const p=this.j.get(h);if(p){const m=this.m.get(p);m&&(!m.parent||!n.has(m.parent.item.handle))&&c.push(h)}}),c}bb(l){const n={};return Promise.all(l.map(s=>this.cb(s).then(c=>{c&&(n[s]=c.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(l){const n=this.getExtensionElement(l);if(n){const s=this.m.get(n);if(s)return this.rb(n),(0,D.$Mg)(()=>this.f.getTreeItem(n)).then(c=>{if(c){const h=this.ib(n,c,s.parent);return this.pb(n,h,s,s.parent),s.dispose(),h}return null})}return Promise.resolve(null)}db(l,n,s){const c=this.ib(l,n,s);if(n.id&&this.j.has(c.item.handle))throw new Error((0,E.localize)(0,null,n.id));return this.ob(l,c),this.qb(c,s),c}eb(l){return g.$VK.isMarkdownString(l)?o.MarkdownString.from(l):l}fb(l,n){return n?{...this.L.toInternal(n,l),originalId:n.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let n,s,c;return typeof l.checkboxState=="number"?n=l.checkboxState:(n=l.checkboxState.state,s=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:n===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:c}}hb(l){if(!g.$hL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,n,s){this.hb(n);const c=this.B(new R.$Qc),h=this.kb(l,n,s),p=this.lb(n);return{item:{handle:h,parentHandle:s?s.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(c,n.command),contextValue:n.contextValue,icon:p,iconDark:this.mb(n)||p,themeIcon:this.jb(n),collapsibleState:(0,A.$Hf)(n.collapsibleState)?g.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof g.$pL?l.iconPath:void 0}kb(l,{id:n,label:s,resourceUri:c},h,p){if(n)return`${u.b}/${n}`;const m=i(s,this.N),I=h?h.item.handle:u.a;let k=m?m.label:c?(0,L.$sg)(c):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,y=this.X(h)||[];let w,C=0;do{if(w=`${I}/${C}:${k}`,p||!this.j.has(w)||d===w)break;C++}while(C<=y.length);return w}lb(l){if(l.iconPath&&!(l.iconPath instanceof g.$pL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof g.$pL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,n){this.j.set(n.item.handle,l),this.m.set(l,n)}pb(l,n,s,c){this.j.delete(n.item.handle),this.m.delete(l),n.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,n);const h=this.X(c)||[],p=h.filter(m=>m.item.handle===s.item.handle)[0];p&&h.splice(h.indexOf(p),1,n)}qb(l,n){n?(n.children||(n.children=[]),n.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}n.children=void 0}}else this.tb()}sb(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[224],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[225],Re([1,0,177,11,30,95,72,31,21,224,187,101]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=void 0;const o=$.$jn.as(R.$kn.JSONContribution);class b{constructor(l,n,s){this.a=l,this.b=n,this.c=s}d(l,n){this.a({type:l,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$_E=b;class v{static a(l){const n=new D.$7l;for(let s=0,c=l.length;s<c;s++)n.add(l[s].description.identifier);return n}static compute(l,n){if(!l||!l.length)return new v(n,[]);if(!n||!n.length)return new v([],l);const s=this.a(l),c=this.a(n),h=n.filter(m=>!s.has(m.description.identifier)),p=l.filter(m=>!c.has(m.description.identifier));return new v(h,p)}constructor(l,n){this.added=l,this.removed=n}}e.$aF=v;class f{constructor(l,n){this.name=l,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=v.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$Z)(l)}}}e.$bF=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$cF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$5l},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"*",description:E.localize(42,null),body:"*"}]}},badges:{type:"array",description:E.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(44,null)},href:{type:"string",description:E.localize(45,null)},description:{type:"string",description:E.localize(46,null)}}}},markdown:{type:"string",description:E.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$1n}},extensionPack:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$1n}},extensionKind:{description:E.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(52,null)},{body:["workspace"],description:E.localize(53,null)},{body:["ui","workspace"],description:E.localize(54,null)},{body:["workspace","ui"],description:E.localize(55,null)},{body:[],description:E.localize(56,null)}]},capabilities:{description:E.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(60,null),E.localize(61,null),E.localize(62,null)]},description:{type:"string",markdownDescription:E.localize(63,null)}}},untrustedWorkspaces:{description:E.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(66,null),E.localize(67,null),E.localize(68,null)]},restrictedConfigurations:{description:E.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(70,null)}}}}},sponsor:{description:E.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(73,null),type:"string"},"vscode:uninstall":{description:E.localize(74,null),type:"string"}}},icon:{type:"string",description:E.localize(75,null)},l10n:{type:"string",description:E.localize(76,null)},pricing:{type:"string",markdownDescription:E.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const n=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,n),l.activationEventsGenerator&&S.$3E.register(l.extensionPoint,l.activationEventsGenerator),e.$cF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,o.registerSchema(i,e.$cF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$dF=r;const u={ExtensionsRegistry:"ExtensionsRegistry"};$.$jn.add(u.ExtensionsRegistry,new r),e.$eF=$.$jn.as(u.ExtensionsRegistry),o.registerSchema(i,e.$cF),o.registerSchema(A.$qj,{properties:{extensionEnabledApiProposals:{description:E.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[226],Re([1,0,174,16,26,225,33,5]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var g;(function(o){function b(v,f,t){if(!v)return;const i=L.$yf(v.type)?v.type:void 0;if(!i||i.length===0){t.error(E.localize(3,null));return}const r=[];if(Array.isArray(v.required))for(const u of v.required)L.$yf(u)&&r.push(u);return{extensionId:f.value,taskType:i,required:r,properties:v.properties?P.$7m(v.properties):{},when:v.when?R.$Ni.deserialize(v.when):void 0}}o.from=b})(g||(g={}));const A=M.$eF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(o,b)=>{for(const v of o)v.type&&b.push(`onTaskType:${v.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:D}});class S{constructor(){this.d=new $.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,v)=>{A.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const r=i.value;for(const u of r)this.a&&u.type&&this.a[u.type]&&delete this.a[u.type]}for(const i of t.added){const r=i.value;for(const u of r){const a=g.from(u,i.description.identifier,i.collector);a&&(this.a[a.taskType]=a)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const v of this.all()){const f={type:"object",additionalProperties:!1};v.required.length>0&&(f.required=v.required.slice(0)),v.properties!==void 0?f.properties=P.$7m(v.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[v.taskType]},b.push(f)}this.c={oneOf:b}}return this.c}}e.$VF=new S}),define(Ae[227],Re([1,0,175,16,25,26,33,226]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$6F=e.JsonSchemaVersion=e.ExecutionEngine=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$ZF=e.ShellQuoting=e.$YF=e.$XF=e.$WF=void 0,e.$WF="settings",e.$XF=new R.$7i("taskRunning",!1,E.localize(0,null)),e.$YF={value:E.localize(1,null),original:"Tasks"};var D;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$ZF="$customized",function(F){function O(ee){if(!ee)return F.Strong;switch(ee.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=O}(D||(e.ShellQuoting=D={}));var g;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A||(e.RevealKind=A={})),function(F){function O(ee){switch(ee.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=O}(A||(e.RevealKind=A={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function O(ee){switch(ee.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=O}(S||(e.RevealProblemKind=S={}));var o;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(o||(e.PanelKind=o={})),function(F){function O(ee){switch(ee.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=O}(o||(e.PanelKind=o={}));var b;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:o.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(F){function O(X){switch(X.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=O;function ee(X){switch(X){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ee}(v||(e.RuntimeType=v={}));var f;(function(F){function O(ee){return L.$yf(ee)?ee:ee.value}F.value=O})(f||(e.CommandString=f={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function O(X){return X===F.Clean._id||X===F.Build._id||X===F.Rebuild._id||X===F.Test._id}F.is=O;function ee(X){if(X!==void 0)return L.$yf(X)?O(X)?{_id:X,isDefault:!1}:void 0:X}F.from=ee})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function O(ee){switch(ee){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=O})(r||(e.TaskSourceKind=r={}));var u;(function(F){F.parallel="parallel",F.sequence="sequence"})(u||(e.DependsOrder=u={}));var a;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var l;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class n{constructor(O,ee,X,Ee,ke,Pe){this._label="",this._id=O,ee&&(this._label=ee),X&&(this.type=X),this.runOptions=Ee,this.configurationProperties=ke,this._source=Pe}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,ee=!1){if(O===void 0)return!1;if(L.$yf(O))return O===this._label||O===this.configurationProperties.identifier||ee&&O===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$1F=n;class s extends n{constructor(O,ee,X,Ee,ke,Pe,le,be){super(O,X,void 0,le,be,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,ke&&(this.command=ke)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case v.Shell:ee="shell";break;case v.Process:ee="process";break;case v.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$WF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let ee=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(ee+=this._source.kind);const X={type:e.$ZF,folder:O,id:ee};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$2F=s;class c extends n{constructor(O,ee,X,Ee,ke,Pe,le){super(O,X,Ee,Pe,le,ee),this._source=ee,this.configures=ke}static is(O){return O instanceof c}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$WF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let ee=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(ee+=this._source.kind);const X={type:e.$ZF,folder:O,id:ee};return JSON.stringify(X)}}e.$3F=c;class h extends n{constructor(O,ee,X,Ee,ke,Pe,le,be,ue){super(O,X,Ee,be,ue,ee),this.defines=ke,this.hasDefinedMatchers=le,this.command=Pe,this.icon=ue.icon,this.hide=ue.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof h}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new h(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$4F=h;class p extends n{constructor(O,ee,X,Ee,ke,Pe){super(O,X,Ee,ke,Pe,ee),this._source=ee}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new p(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$5F=p;var m;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(F){F._default=F.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(O){this.c=new Map;for(let ee=0;ee<O.length;ee++)this.c.set(O[ee].uri.toString(),ee)}compare(O,ee){const X=O.getWorkspaceFolder(),Ee=ee.getWorkspaceFolder();if(X&&Ee){let ke=this.c.get(X.uri.toString());ke=ke===void 0?0:ke+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,ke===Pe?O._label.localeCompare(ee._label):ke-Pe}else return!X&&Ee?-1:X&&!Ee?1:0}}e.$6F=k;var d;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(d||(e.TaskEventKind=d={}));var y;(function(F){F.SingleRun="singleRun",F.Background="background"})(y||(e.TaskRunType=y={}));var w;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var C;(function(F){function O(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function ee(be,ue,oe){return{...O(be),kind:"start",terminalId:ue,resolvedVariables:oe}}F.start=ee;function X(be,ue,oe){return{...O(be),kind:"processStarted",terminalId:ue,processId:oe}}F.processStarted=X;function Ee(be,ue,oe){return{...O(be),kind:"processEnded",terminalId:ue,exitCode:oe}}F.processEnded=Ee;function ke(be,ue,oe){return{...O(be),kind:"terminated",exitReason:oe,terminalId:ue}}F.terminated=ke;function Pe(be,ue,oe){return{...O(ue),kind:be,terminalId:oe}}F.general=Pe;function le(){return{kind:"changed"}}F.changed=le})(C||(e.TaskEvent=C={}));var j;(function(F){function O(X){const Ee=Object.keys(X).sort();let ke="";for(const Pe of Ee){let le=X[Pe];le instanceof Object?le=O(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),ke+=Pe+","+le+","}return ke}function ee(X){const ke={_key:O(X),type:X.taskType};return Object.assign(ke,X),ke}F.create=ee})(j||(e.KeyedTaskIdentifier=j={}));var B;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(B||(e.TaskSettingId=B={}));var W;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(F){function O(ee,X){const Ee=$.$VF.get(ee.type);if(Ee===void 0){const be=M.$7m(ee);return delete be._key,j.create(be)}const ke=Object.create(null);ke.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(be=>Pe.add(be));const le=Ee.properties;for(const be of Object.keys(le)){const ue=ee[be];if(ue!=null)ke[be]=ue;else if(Pe.has(be)){const oe=le[be];if(oe.default!==void 0)ke[be]=M.$7m(oe.default);else switch(oe.type){case"boolean":ke[be]=!1;break;case"number":case"integer":ke[be]=0;break;case"string":ke[be]="";break;default:X.error(E.localize(2,null,JSON.stringify(ee,void 0,0),be));return}}}return j.create(ke)}F.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Ae[228],Re([1,0,11]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=e.$54b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$54b=L;class P extends L{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$64b=P}),define(Ae[48],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=void 0;class E{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++E.count}}e.$qv=E;const L=[];function P($){const D=new E($);return L[D.nid]=D,D}e.$rv=P;function M($){return L[$].sid}e.$sv=M;class R{constructor(D){this.value=D}}e.$tv=R}),define(Ae[3],Re([1,0,48]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$tK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$sK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(t){return t._id=S.a++,t}}e.$sK=S;var o;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(o||(e.ISuggestDataDtoField=o={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var v;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$tK={MainThreadAuthentication:(0,E.$rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$rv)("MainThreadChatProvider"),MainThreadChatAgents:(0,E.$rv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,E.$rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$rv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$rv)("MainThreadClipboard"),MainThreadCommands:(0,E.$rv)("MainThreadCommands"),MainThreadComments:(0,E.$rv)("MainThreadComments"),MainThreadConfiguration:(0,E.$rv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$rv)("MainThreadConsole"),MainThreadDebugService:(0,E.$rv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$rv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$rv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$rv)("MainThreadLanguages"),MainThreadLogger:(0,E.$rv)("MainThreadLogger"),MainThreadMessageService:(0,E.$rv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$rv)("MainThreadOutputService"),MainThreadProgress:(0,E.$rv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$rv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$rv)("MainThreadSecretState"),MainThreadStorage:(0,E.$rv)("MainThreadStorage"),MainThreadSpeech:(0,E.$rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$rv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$rv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$rv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$rv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$rv)("MainThreadSCM"),MainThreadSearch:(0,E.$rv)("MainThreadSearch"),MainThreadShare:(0,E.$rv)("MainThreadShare"),MainThreadTask:(0,E.$rv)("MainThreadTask"),MainThreadWindow:(0,E.$rv)("MainThreadWindow"),MainThreadLabelService:(0,E.$rv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$rv)("MainThreadInteractive"),MainThreadChat:(0,E.$rv)("MainThreadChat"),MainThreadInlineChat:(0,E.$rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$rv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$rv)("MainThreadTimeline"),MainThreadTesting:(0,E.$rv)("MainThreadTesting"),MainThreadLocalization:(0,E.$rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$rv)("MainThreadIssueReporter")},e.$uK={ExtHostCommands:(0,E.$rv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$rv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$rv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$rv)("ExtHostStatusBar"),ExtHostShare:(0,E.$rv)("ExtHostShare"),ExtHostExtensionService:(0,E.$rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$rv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$rv)("ExtHostSCM"),ExtHostSearch:(0,E.$rv)("ExtHostSearch"),ExtHostTask:(0,E.$rv)("ExtHostTask"),ExtHostWorkspace:(0,E.$rv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$rv)("ExtHostWindow"),ExtHostWebviews:(0,E.$rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$rv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$rv)("ExtHostProgress"),ExtHostComments:(0,E.$rv)("ExtHostComments"),ExtHostSecretState:(0,E.$rv)("ExtHostSecretState"),ExtHostStorage:(0,E.$rv)("ExtHostStorage"),ExtHostUrls:(0,E.$rv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$rv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$rv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$rv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$rv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$rv)("ExtHostChat"),ExtHostChatAgents:(0,E.$rv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,E.$rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$rv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$rv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$rv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$rv)("ExtHostTimeline"),ExtHostTesting:(0,E.$rv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$rv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$rv)("ExtHostIssueReporter")}}),define(Ae[229],Re([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$tK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation($,D)??[]}getRelatedInformation(R,$,D){return this.c.$getAiRelatedInformation($,D)}registerRelatedInformationProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,$),new L.$vK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Lec=P}),define(Ae[80],Re([1,0,4,15,3,17]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=e.$Ncc=void 0,e.$Ncc=(0,E.$Ph)("IExtHostApiDeprecationService");let R=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(P.$tK.MainThreadTelemetry)}report(D,g,A){const S=this.d(D,g);this.a.has(S)||(this.a.add(S),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$Occ=R,e.$Occ=R=Ke([Ve(0,M.$uM),Ve(1,L.$0i)],R),e.$Pcc=Object.freeze(new class{report($,D,g){}})}),define(Ae[230],Re([1,0,5,3,7,21]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new E.$Nd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=g.getProxy(L.$tK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,S,o={}){const b=M.$6l.toKey(g.identifier),v=[...S].sort().join(" ");return await this.f.getOrCreate(`${b} ${A} ${v}`,async()=>{await this.a.$ensureProvider(A);const f=g.displayName||g.name;return this.a.$getSession(A,S,b,f,o)})}async getSessions(g,A,S){const o=M.$6l.toKey(g.identifier),b=[...S].sort().join(" ");return await this.g.getOrCreate(`${o} ${b}`,async()=>{await this.a.$ensureProvider(A);const v=g.displayName||g.name;return this.a.$getSessions(A,S,o,v)})}async removeSession(g,A){const S=this.b.get(g);return S?S.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,S,o){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:S,options:o??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===g)||this.c.push({id:g,label:A});const b=S.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(g,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,o?.supportsMultipleAccounts??!1),new P.$vK(()=>{b.dispose(),this.b.delete(g);const v=this.c.findIndex(f=>f.id===g);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,S){const o=this.b.get(g);if(o)return Promise.resolve(o.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$jec=R;class ${constructor(){this.a=new Map}getOrCreate(g,A){const S=this.a.get(g);if(S)return S;const o=A().finally(()=>this.a.delete(g));return this.a.set(g,o),o}}}),define(Ae[231],Re([1,0,3,17,8]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;let M=class{constructor($,D){this.a=$.getProxy(E.$tK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,D,g){const A=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$pec=M,e.$pec=M=Ke([Ve(0,L.$uM)],M)}),define(Ae[232],Re([1,0,12,5,67,6,49,156,3,8]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class A{static{this.a=0}constructor(b,v){this.extension=b,this.provider=v,this.handle=A.a++}}class S{static{this.a=0}constructor(b,v){this.h=v,this.b=new Map,this.d=new Map,this.e=new L.$Nd,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(D.$tK.MainThreadChat)}registerChatProvider(b,v,f){const t=new A(b,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,v),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,v){const f=P.Iterable.find(this.d.keys(),t=>this.d.get(t)===b)??0;typeof f=="number"&&this.g.$transferChatSession(f,v)}sendInteractiveRequestToProvider(b,v){this.g.$sendRequestToProvider(b,v)}async $prepareChat(b,v,f){const t=this.b.get(b);if(!t)return;const i=await t.provider.prepareSession(v,f);if(!i)return;const r=S.a++;return this.d.set(r,i),{id:r,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(b,v){const f=this.b.get(b);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(v);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(r=>g.ChatReplyFollowup.from(r)):g.MarkdownString.from(i))}async $provideFollowups(b,v,f){const t=this.b.get(b);if(!t)return;const i=this.d.get(v);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(u=>g.ChatFollowup.from(u))}async $provideSampleQuestions(b,v){const f=this.b.get(b);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions(v);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(b,v,f){const t=this.b.get(b);if(!t)return;const i=this.d.get(v);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(b,v,f,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(v);if(!r)return;const u={session:r,message:f.message,variables:{}};if(f.variables)for(const h of Object.keys(f.variables))u.variables[h]=f.variables[h].map(g.ChatVariable.to);const a=R.$Jd.create(!1);let l;const n={report:h=>{if(t.isCancellationRequested)return;typeof l>"u"&&(l=a.elapsed());const p=g.ChatResponseProgress.from(i.extension,h);if("placeholder"in h&&"resolvedContent"in h){const m=Promise.all([this.g.$acceptResponseProgress(b,v,p),h.resolvedContent]);(0,E.$Ig)(m,t).then(I=>{if(!I)return;const[k,d]=I;this.g.$acceptResponseProgress(b,v,d,k??void 0)})}else this.g.$acceptResponseProgress(b,v,p)}};let s;try{s=await i.provider.provideResponseWithProgress(u,n,t),s||(s={errorDetails:{message:(0,$.localize)(0,null)}})}catch(h){s={errorDetails:{message:(0,$.localize)(1,null,h.message),responseIsIncomplete:!0}},this.h.error(h)}try{if(r.saveState&&this.d.has(v)){const h=r.saveState();this.g.$acceptChatState(v,h)}}catch(h){this.h.warn(h)}const c={firstProgress:l??0,totalElapsed:a.elapsed()};return{errorDetails:s.errorDetails,timings:c}}async $provideSlashCommands(b,v,f){const t=this.b.get(b);if(!t)return;const i=this.d.get(v);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(u=>({...u,kind:g.CompletionItemKind.from(u.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$Dec=S}),define(Ae[233],Re([1,0,12,6,53,3,8,7]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class D{static{this.a=0}constructor(S,o,b){this.d=o,this.e=b,this.b=new Map,this.c=S.getProxy(M.$tK.MainThreadChatAgents)}registerAgent(S,o,b,v){const f=D.a++;return this.b.set(f,{extension:S,agent:b}),this.c.$registerAgent(f,o,v),(0,L.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(S,o,b,v,f){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function r(){if(i)throw new Error("Only valid while executing the command")}const u=new E.$ch;f.onCancellationRequested(()=>u.complete()),setTimeout(()=>u.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,u.p);const a=t.agent({role:$.ChatMessageRole.User,content:b},{history:v.history.map(R.ChatMessage.to)},new P.$8u(l=>{r(),this.c.$handleProgressChunk(o,{content:g(l.message)?l.message:l.message.value})}),f);try{return await(0,E.$Ig)(Promise.resolve(a).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(s=>R.ChatFollowup.from(s))}}),f)}finally{i=!0,u.complete()}}}e.$Nec=D;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Ae[234],Re([1,0,12,19,38,5,49,16,2,157,53,3,8,7,204,24]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class t{static{this.a=0}constructor(u,a,l){this.i=a,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=u.getProxy(S.$tK.MainThreadChatAgents2)}createChatAgent(u,a,l){const n=t.a++,s=new i(u,a,this.d,n,l);return this.b.set(n,s),this.d.$registerAgent(n,a,{}),s.apiAgent}async $invokeAgent(u,a,l,n,s,c){this.g.delete(a);const h=this.b.get(u);if(!h)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let p=!1;function m(){if(p)throw new Error("Only valid while executing the command")}const I=new E.$ch;c.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(h.extension.identifier,I.p);const k=n.command?await h.validateSlashCommand(n.command):void 0,d=R.$Jd.create(!1);let y;try{const w=h.invoke({prompt:n.message,variables:o.ChatVariable.objectTo(n.variables),slashCommand:k},{history:s.history.map(o.ChatMessage.to)},new A.$8u(C=>{m(),typeof y>"u"&&"content"in C&&(y=d.elapsed());const j=o.ChatResponseProgress.from(h.extension,C);if("placeholder"in C&&"resolvedContent"in C){const B=Promise.all([this.d.$handleProgressChunk(l,j),C.resolvedContent]);(0,E.$Ig)(B,c).then(W=>{if(!W)return;const[U,F]=W;this.d.$handleProgressChunk(l,F,U??void 0)})}else this.d.$handleProgressChunk(l,j)}),c);return await(0,E.$Ig)(Promise.resolve(w).then(C=>{if(C){this.g.set(a,C);let j=this.h.get(a);j||(j=new Map,this.h.set(a,j)),j.set(l,C);const B={firstProgress:y,totalElapsed:d.elapsed()};return{errorDetails:C.errorDetails,timings:B}}else this.g.delete(a)}),c)}catch(w){return this.j.error(w,h.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,P.$Ai)(w)),responseIsIncomplete:!0}}}finally{p=!0,I.complete()}}$releaseSession(u){this.g.delete(u),this.h.delete(u)}async $provideSlashCommands(u,a){const l=this.b.get(u);return l?l.provideSlashCommand(a):[]}$provideFollowups(u,a,l){const n=this.b.get(u);if(!n)return Promise.resolve([]);const s=this.g.get(a);return s?n.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(u,a,l,n){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);if(!c)return;let h;switch(n){case v.InteractiveSessionVoteDirection.Down:h=b.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:h=b.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:c,kind:h}))}$acceptAction(u,a,l,n){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);c&&n.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:n.action,result:c}))}}e.$Oec=t;class i{constructor(u,a,l,n,s){this.extension=u,this.n=a,this.o=l,this.q=n,this.r=s,this.l=new M.$Nd,this.m=new M.$Nd}acceptFeedback(u){this.l.fire(u)}acceptAction(u){this.m.fire(u)}async validateSlashCommand(u){this.b||(await this.provideSlashCommand(L.CancellationToken.None),(0,$.$If)(this.b));const a=this.b.find(l=>l.name===u);if(!a)throw new Error(`Unknown slashCommand: ${u}`);return a}async provideSlashCommand(u){if(!this.a)return[];const a=await this.a.provideSlashCommands(u);return a?(this.b=a,a.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate}))):[]}async provideFollowups(u,a){if(!this.d)return[];const l=await this.d.provideFollowups(u,a);return l?l.map(n=>o.ChatFollowup.from(n)):[]}get apiAgent(){let u=!1,a=!1;const l=()=>{u||a||(a=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$pL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),a=!1}))},n=this;return{get name(){return n.n},get description(){return n.g??""},set description(s){n.g=s,l()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(s){n.h=s,l()},get iconPath(){return n.i},set iconPath(s){n.i=s,l()},get slashCommandProvider(){return n.a},set slashCommandProvider(s){n.a=s,l()},get followupProvider(){return n.d},set followupProvider(s){n.d=s,l()},get isDefault(){return(0,f.$lF)(n.extension,"defaultChatAgent"),n.j},set isDefault(s){(0,f.$lF)(n.extension,"defaultChatAgent"),n.j=s,l()},get isSecondary(){return(0,f.$lF)(n.extension,"defaultChatAgent"),n.k},set isSecondary(s){(0,f.$lF)(n.extension,"defaultChatAgent"),n.k=s,l()},get onDidReceiveFeedback(){return n.l.event},onDidPerformAction:(0,f.$kF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){u=!0,n.a=void 0,n.d=void 0,n.l.dispose(),n.o.$unregisterAgent(n.q)}}}invoke(u,a,l,n){return this.r(u,a,l,n)}}}),define(Ae[235],Re([1,0,19,6,3,8,53,21,12,5]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class A{constructor(v,f){this.stream=new D.$gh,this.stream=f??new D.$gh;const t=this;this.apiObj={option:v,response:t.stream.asyncIterable}}}class S{constructor(v,f){this.a=new g.$Nd,this.b=new Map,this.c=new D.$gh,this.d=!1;const t=this;this.apiObject={result:v,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let f=this.b.get(v.index);f||(this.b.size===0?f=new A(v.index,this.c):f=new A(v.index),this.b.set(v.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(v.part)}}class o{static{this.a=1}constructor(v,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new $.$8l,this.b=v.getProxy(P.$tK.MainThreadChatProvider)}registerProvider(v,f,t,i){const r=o.a++;return this.c.set(r,{extension:v,provider:t}),this.b.$registerProvider(r,f,{extension:v,displayName:i.name??v.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(v,f,t,i,r){const u=this.c.get(v);if(!u)return;const a=new R.$8u(async l=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:l.index,part:l.part})});return u.provider.provideChatResponse(t.map(M.ChatMessage.to),i,a,r)}allowListExtensionWhile(v,f){this.f.set(v,f),f.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,f){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(v)},makeRequest(i,r,u){if(!t.f.has(v))throw new Error("Access to chat has been revoked");const a=new E.$Xd(u),l=Math.random()*1e6|0,n=t.b.$fetchResponse(v,f,l,i.map(M.ChatMessage.from),r??{},a.token),s=new S(n,a);return t.e.set(l,{res:s}),n.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(v,f){const t=this.e.get(v);t&&t.res.handleFragment(f)}}e.$Iec=o}),define(Ae[236],Re([1,0,6,3,11,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$tK.MainThreadChatVariables)}async $resolveVariable(D,g,A){const S=this.b.get(D);if(S)try{const o=await S.resolver.resolve(S.data.name,{message:g},A);if(o)return o.map(M.ChatVariable.from)}catch(o){(0,P.$1)(o)}}registerVariableResolver(D,g,A,S){const o=R.a++;return this.b.set(o,{extension:D.identifier,data:{name:g,description:A},resolver:S}),this.c.$registerVariable(o,{name:g,description:A}),(0,E.$Pc)(()=>{this.b.delete(o),this.c.$unregisterVariable(o)})}}e.$Kec=R}),define(Ae[237],Re([1,0,3]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class L{constructor(M){const R=M.getProxy(E.$tK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$Scc=L}),define(Ae[32],Re([1,0,16,7,8,26,3,18,15,51,29,130,2,6,4,17,108,22,48,38,49,56,60]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=void 0;let s=class{#e;#t;#i;constructor(k,d,y){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$tK.MainThreadCommands),this.d=d,this.#i=y,this.#t=k.getProxy(R.$tK.MainThreadTelemetry),this.converter=new c(this,w=>{const C=this.c.get(w);return C?.result===p.Void?C:void 0},d),this.f=[{processArgument(w){return(0,g.$mh)(w)}},{processArgument(w){return(0,M.$9m)(w,function(C){if(A.$ws.isIRange(C))return P.Range.to(C);if(S.$vs.isIPosition(C))return P.Position.to(C);if(A.$ws.isIRange(C.range)&&o.URI.isUri(C.uri))return P.location.to(C);if(C instanceof i.$be)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const d=this.registerCommand(!1,k.id,async(...y)=>{const w=k.args.map((j,B)=>{if(!j.validate(y[B]))throw new Error(`Invalid argument '${j.name}' when running '${k.id}', received: ${typeof y[B]=="object"?JSON.stringify(y[B],null,"	"):y[B]} `);return j.convert(y[B])}),C=await this.executeCommand(k.internalId,...w);return k.result.convert(C,y,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new L.$vK(()=>{d.dispose(),this.c.delete(k.id)})}registerCommand(k,d,y,w,C,j){if(this.d.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this.b.has(d))throw new Error(`command '${d}' already exists`);return this.b.set(d,{callback:y,thisArg:w,metadata:C,extension:j}),k&&this.#e.$registerCommand(d),new L.$vK(()=>{this.b.delete(d)&&k&&this.#e.$unregisterCommand(d)})}executeCommand(k,...d){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,d,!0)}async g(k,d,y){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,d,!1);{let w=!1;const C=(0,M.$9m)(d,function(j){if(j instanceof L.$wK)return P.Position.from(j);if(j instanceof L.$xK)return P.Range.from(j);if(j instanceof L.$HK)return P.location.from(j);if(L.$SL.isNotebookRange(j))return P.NotebookRange.from(j);if(j instanceof ArrayBuffer)return w=!0,i.$be.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return w=!0,i.$be.wrap(j);if(j instanceof i.$be)return w=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(k,w?new r.$tv(C):C,y);return(0,g.$mh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(k,d,!1);throw j}}}async h(k,d,y){const w=this.b.get(k);if(!w)throw new Error("Unknown command");const{callback:C,thisArg:j,metadata:B}=w;if(B?.args)for(let U=0;U<B.args.length;U++)try{(0,E.$Pf)(d[U],B.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${B.args[U].name}' - ${B.args[U].description}`)}const W=a.$Jd.create();try{return await C.apply(j,d)}catch(U){if(k===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...d);F&&(k=F.command)}if(this.d.error(U,k,w.extension?.identifier),!y)throw U;if(w.extension?.identifier){const F=this.#i.onExtensionError(w.extension.identifier,U);this.d.trace("forwarded error to extension?",F,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.$Ai)(U)),this.id=k,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,k,W.elapsed())}}j(k,d,y){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$mo(d),duration:y})}$executeContributedCommand(k,...d){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const y=this.b.get(k);return y?(d=d.map(w=>this.f.reduce((C,j)=>j.processArgument(C,y.extension?.identifier),w)),this.h(k,d,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(d=>(k&&(d=d.filter(y=>y[0]!=="_")),d))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[d,y]of this.b){const{metadata:w}=y;w&&(k[d]=w)}return Promise.resolve(k)}};e.$PM=s,e.$PM=s=Ke([Ve(0,f.$uM),Ve(1,D.$0i),Ve(2,n.$OM)],s),e.$QM=(0,v.$Ph)("IExtHostCommands");class c{constructor(k,d,y){this.d=k,this.f=d,this.g=y,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,d){if(!k)return;const y={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return y;const w=this.f(k.command);if(w)y.id=w.internalId,y.arguments=w.args.map((C,j)=>C.convert(k.arguments&&k.arguments[j]));else if((0,$.$Kb)(k.arguments)){const C=`${k.command} /${++this.c}`;this.b.set(C,k),d.add((0,b.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),y.$ident=C,y.id=this.delegatingCommandId,y.arguments=[C],this.g.trace("CommandsConverter#CREATE",k.command,C)}return y}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const d=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],d?d.command:"MISSING"),d?this.d.executeCommand(d.command,...d.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$RM=c;class h{static{this.Uri=new h("uri","Uri of a text document",k=>o.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>L.$wK.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>L.$xK.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>L.$yK.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,d=>Array.isArray(d)&&d.every(y=>k.validate(y)),d=>d.map(y=>k.convert(y)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof L.$RK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof L.$_L,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof t.$HM,P.TestItem.from)}constructor(k,d,y,w){this.name=k,this.description=d,this.validate=y,this.convert=w}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,d){return new h(k??this.name,d??this.description,this.validate,this.convert)}}e.$SM=h;class p{static{this.Void=new p("no result",k=>k)}constructor(k,d){this.description=k,this.convert=d}}e.$TM=p;class m{constructor(k,d,y,w,C){this.id=k,this.internalId=d,this.description=y,this.args=w,this.result=C}}e.$UM=m}),define(Ae[238],Re([1,0,18,14,2,79,94,33,98,32,8,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;const o=[new g.$UM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of DocumentHighlight-instances.",v(A.DocumentHighlight.to))),new g.$UM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$SM.Uri],new g.$TM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,E.$Jb)(t))return;class r extends S.$MK{static to(a){const l=new r(a.name,A.SymbolKind.to(a.kind),a.containerName||"",new S.$HK(i[0],A.Range.to(a.range)));return l.detail=a.detail,l.range=l.location.range,l.selectionRange=A.Range.to(a.selectionRange),l.children=a.children?a.children.map(r.to):[],l}}return t.map(r.to)})),new g.$UM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$SM.Uri,new g.$SM("options","Formatting options",t=>!0,t=>t)],new g.$TM("A promise that resolves to an array of TextEdits.",v(A.TextEdit.to))),new g.$UM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$SM.Uri,g.$SM.Range,new g.$SM("options","Formatting options",t=>!0,t=>t)],new g.$TM("A promise that resolves to an array of TextEdits.",v(A.TextEdit.to))),new g.$UM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$SM.Uri,g.$SM.Position,new g.$SM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$SM("options","Formatting options",t=>!0,t=>t)],new g.$TM("A promise that resolves to an array of TextEdits.",v(A.TextEdit.to))),new g.$UM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location-instances.",v(A.location.to))),new g.$UM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Hover-instances.",v(A.Hover.to))),new g.$UM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$SM.Uri,new g.$SM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$wK.isPosition(i)),t=>t.map(A.Position.from))],new g.$TM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let r;for(const u of i.reverse())r=new S.$QK(A.Range.to(u),r);return r}))),new g.$UM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$SM.String.with("query","Search string")],new g.$TM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new g.$UM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new g.$UM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$SM.CallHierarchyItem],new g.$TM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new g.$UM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$SM.CallHierarchyItem],new g.$TM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new g.$UM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new g.$UM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$SM.Uri,g.$SM.Position,g.$SM.String.with("newName","The new symbol name")],new g.$TM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new g.$UM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$SM.Uri,g.$SM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$TM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new g.$UM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$SM.Uri],new g.$TM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$KL(t.tokenTypes,t.tokenModifiers)})),new g.$UM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$SM.Uri],new g.$TM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$c$)(t);if(i.type==="full")return new S.$ML(i.data,void 0)})),new g.$UM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$SM.Uri,g.$SM.Range.optional()],new g.$TM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$KL(t.tokenTypes,t.tokenModifiers)})),new g.$UM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$SM.Uri,g.$SM.Range],new g.$TM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$c$)(t);if(i.type==="full")return new S.$ML(i.data,void 0)})),new g.$UM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$SM.Uri,g.$SM.Position,g.$SM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$SM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$TM("A promise that resolves to a CompletionList-instance.",(t,i,r)=>{if(!t)return new S.$3K([]);const u=t.suggestions.map(a=>A.CompletionItem.to(a,r));return new S.$3K(u,t.incomplete)})),new g.$UM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$SM.Uri,g.$SM.Position,g.$SM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$TM("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new g.$UM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$SM.Uri,g.$SM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$TM("A promise that resolves to an array of CodeLens-instances.",(t,i,r)=>v(u=>new S.$UK(A.Range.to(u.range),u.command&&r.fromInternal(u.command)))(t))),new g.$UM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$SM.Uri,new g.$SM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$xK.isRange(t),t=>S.$yK.isSelection(t)?A.Selection.from(t):A.Range.from(t)),g.$SM.String.with("kind","Code action kind to return code actions for").optional(),g.$SM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$TM("A promise that resolves to an array of Command-instances.",(t,i,r)=>v(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(u.command)}else{const a=new S.$OK(u.title,u.kind?new S.$PK(u.kind):void 0);return u.edit&&(a.edit=A.WorkspaceEdit.to(u.edit)),u.command&&(a.command=r.fromInternal(u.command)),a.isPreferred=u.isPreferred,a}})(t))),new g.$UM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$SM.Uri],new g.$TM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$9K(A.Range.to(i.range),A.Color.to(i.color))):[])),new g.$UM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$SM("color","The color to show and insert",t=>t instanceof S.$8K,A.Color.from),new g.$SM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new g.$TM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new g.$UM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$SM.Uri,g.$SM.Range],new g.$TM("A promise that resolves to an array of Inlay objects",(t,i,r)=>t.map(A.InlayHint.to.bind(void 0,r)))),new g.$UM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$SM.Uri],new g.$TM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new g.$UM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$TM("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new g.$UM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$SM.Uri,g.$SM.Range,new g.$SM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof S.$xK,t=>A.InlineValueContext.from(t))],new g.$TM("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new g.$UM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$SM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,D.$xU)(t,L.Schemas.http,L.Schemas.https),t=>t),new g.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),g.$SM.String.with("label","").optional()],g.$TM.Void),new g.$UM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$SM.Uri.with("resource","Resource to open"),g.$SM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],g.$TM.Void),new g.$UM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$SM.Uri.with("left","Left-hand side resource of the diff editor"),g.$SM.Uri.with("right","Right-hand side resource of the diff editor"),g.$SM.String.with("title","Human readable title for the diff editor").optional(),new g.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],g.$TM.Void),new g.$UM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$UM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$SM.TypeHierarchyItem],new g.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$UM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$SM.TypeHierarchyItem],new g.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$UM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$SM.TestItem],g.$TM.Void),new g.$UM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$SM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$TM.Void),new g.$UM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$SM.String.with("name","The context key name"),new g.$SM("value","The context key value",()=>!0,t=>t)],g.$TM.Void),new g.$UM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$SM.Uri,g.$SM.StringArray,new g.$SM("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new g.$TM("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class b{static register(i){o.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Oi)}}e.$Rcc=b;function v(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const r of t)M.$ht(r)?i.push(A.DefinitionLink.to(r)):i.push(A.location.to(r));return i}}),define(Ae[239],Re([1,0,12,66,5,6,2,79,21,8,7,3,24]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;function b(v,f,t){const i=v.getProxy(S.$tK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$8l,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.commentUniqueId,y=k.getCommentByUniqueId(d);return y||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.text,y=m.commentUniqueId,w=k.getCommentByUniqueId(y);return w?(typeof w.body=="string"?w.body=d:w.body=new A.$VK(d),w):m}return m}})}createCommentController(m,I,k){const d=r.a++,y=new a(m,d,I,k);this.b.set(y.handle,y);const w=this.c.get(m.identifier)||[];return w.push(y),this.c.set(m.identifier,w),y.value}async $createCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,k){const d=this.b.get(m);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const y=t.getDocument(R.URI.revive(I));return(0,E.$Mg)(async()=>{const w=await d.commentingRangeProvider.provideCommentingRanges(y,k);let C;return Array.isArray(w)?C={ranges:w,fileComments:!1}:w?C={ranges:w.ranges||[],fileComments:w.fileComments||!1}:C=w??void 0,C}).then(w=>{let C;return w&&(C={ranges:w.ranges.map(j=>g.Range.from(j)),fileComments:w.fileComments}),C})}$toggleReaction(m,I,k,d,y){const w=this.b.get(m);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,E.$Mg)(()=>{const C=w.getCommentThread(I);if(C){const j=C.getCommentByUniqueId(d.uniqueIdInThread);if(w!==void 0&&j&&w.reactionHandler)return w.reactionHandler(j,s(y))}return Promise.resolve(void 0)})}}class u{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,k,d,y,w,C,j){this.m=I,this.n=k,this.o=d,this.p=y,this.q=w,this.extensionDescription=C,this.r=j,this.handle=u.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(W){B.range=W},get comments(){return B.comments},set comments(W){B.comments=W},get collapsibleState(){return B.collapsibleState},set collapsibleState(W){B.collapsibleState=W},get canReply(){return B.canReply},set canReply(W){B.canReply=W},get contextValue(){return B.contextValue},set contextValue(W){B.contextValue=W},get label(){return B.label},set label(W){B.label=W},get state(){return B.state},set state(W){B.state=W},dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};m("range")&&(I.range=g.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=c(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=h(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const k=I[0],d=I[1];if(m===d)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,L.$ih)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,k,d){this.f=m,this.g=I,this.h=k,this.i=d,this.a=new Map,i.$registerCommentController(this.handle,k,d,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(w){y.options=w},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(w){y.commentingRangeProvider=w},get reactionHandler(){return y.reactionHandler},set reactionHandler(w){y.reactionHandler=w},createCommentThread(w,C,j){return y.createCommentThread(w,C,j).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,k){I===void 0&&(0,o.$lF)(this.f,"fileComments");const d=new u(this.id,this.handle,void 0,m,I,k,this.f,!1);return this.a.set(d.handle,d),d}$createCommentThreadTemplate(m,I){const k=new u(this.id,this.handle,void 0,R.URI.revive(m),g.Range.to(I),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,I){const k=this.a.get(m);k&&(k.range=g.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(p,m,I,k){let d=I.get(m);return d||(d=++p.commentHandle,I.set(m,d)),m.state!==void 0&&(0,o.$lF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:d,body:typeof m.body=="string"?m.body:g.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(y=>n(y)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(p){return{label:p.label,iconPath:p.iconPath?g.$tM(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function s(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?R.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function c(p){if(p!==void 0)switch(p){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(p){if(p!==void 0)switch(p){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$Tcc=b}),define(Ae[240],Re([1,0,26,3,27,17]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;let R=class{constructor(A,S){this.a=A.getProxy(L.$tK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,S){const o=this,b=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){o.e(A,S,b,arguments)}})}e(A,S,o,b){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(b,this.b)}),this.c&&this.f(A,o,b)}};e.$Rec=R,e.$Rec=R=Ke([Ve(0,M.$uM),Ve(1,P.$KM)],R);const $=1e5;function D(g,A){const S=[];if(g.length)for(let o=0;o<g.length;o++){let b=g[o];if(typeof b>"u")b="undefined";else if(b instanceof Error){const v=b;v.stack?b=v.stack:b=v.toString()}S.push(b)}if(A){const o=new Error().stack;o&&S.push({__$stack:o.split(`
`).slice(3).join(`
`)})}try{const o=(0,E.$_m)(S);return o.length>$?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}),define(Ae[110],Re([1,0,2,3,7,4,17,15,18,13,20,24]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;let b=class{static{o=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(L.$tK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=o.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const r=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(u=>{if(!u){this.g.$onDidChange(i,null);return}const a=(0,D.$2b)(u);if(a.length<=o.d){this.g.$onDidChange(i,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,a.length);const l=a.map(c=>({uri:c,rank:(0,g.$Ge)(c.path,"/")})),n=(0,D.$yb)(l,(c,h)=>c.rank-h.rank||(0,g.$Ue)(c.uri.path,h.uri.path)),s=[];e:for(const c of n){let h;for(const p of c){const m=(0,A.$lc)(p.uri.path);if(h!==m&&(h=m,s.push(p.uri)>=o.d))break e}}this.g.$onDidChange(i,s)});return new P.$vK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const r=Object.create(null),{provider:u,extensionDescription:a}=this.f.get(f);return await Promise.all(t.map(async l=>{try{const{uri:n,id:s}=l,c=await Promise.resolve(u.provideFileDecoration(E.URI.revive(n),i));if(!c)return;try{P.$QL.validate(c),c.badge&&typeof c.badge!="string"&&(0,S.$lF)(a,"codiconDecoration"),r[s]=[c.propagate,c.tooltip,c.badge,c.color]}catch(h){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${h}`)}}catch(n){this.h.error(n)}})),r}};e.$Udc=b,e.$Udc=b=o=Ke([Ve(0,R.$uM),Ve(1,$.$0i)],b),e.$Vdc=(0,M.$Ph)("IExtHostDecorations")}),define(Ae[241],Re([1,0,158,97,2,3,7,8,5,15,28,41]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;class b{#e;#t;#i;constructor(t,i,r,u,a,l,n,s){this.d=t,this.e=i,this.f=r,this.g=u,this.h=a,this.c=!1,this.f=Math.max(u,r),this.#i=new A.$zc(c=>l.getComparisonKey(c)),this.#e=n,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let r=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),r=[t]}else if(Array.isArray(t)){r=[];let l;t=[...t].sort(b.k);for(const n of t){const[s,c]=n;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,r.push(s),this.#i.set(s,[])),c)this.#i.get(s)?.push(...c);else{const h=this.#i.get(s);h&&(h.length=0)}}}if(this.#t.fire(r),!this.#e)return;const u=[];let a=0;for(const l of r){let n=[];const s=this.#i.get(l);if(s)if(s.length>this.g){n=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const p of s)if(p.severity===c[h]&&n.push({...$.Diagnostic.from(p),modelVersionId:this.h(l)})===this.g)break e;n.push({severity:L.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=s.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(l)}));if(u.push([l,n]),a+=n.length,a>this.f)break}this.#e.$changeMany(this.e,u)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[r,u]of this)t.call(i,r,u,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Lcc=b;let v=class{static{o=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*o.d}static _mapper(t){const i=new A.$zc;for(const r of t)i.set(r,r);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,r,u){this.j=i,this.k=r,this.l=u,this.g=new Map,this.h=new D.$Rd({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,o._mapper),this.f=t.getProxy(M.$tK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:r,f:u,h:a,j:l,k:n,l:s}=this,c=new class{$changeMany(m,I){u.$changeMany(m,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){u.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){u.dispose()}};let h;if(!i)i="_generated_diagnostic_collection_name_#"+o.c++,h=i;else if(!r.has(i))h=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do h=i+o.c++;while(r.has(h))}return new class extends b{constructor(){super(i,h,o.e,o.d,m=>s.getDocument(m)?.version,n.extUri,c,a),r.set(h,this)}dispose(){super.dispose(),r.delete(h)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,r=[];for(const u of this.g.values())u.forEach((a,l)=>{let n=i.get(a.toString());typeof n>"u"&&(n=r.length,i.set(a.toString(),n),r.push([a,[]])),r[n][1]=r[n][1].concat(...l)});return r}}m(t){let i=[];for(const r of this.g.values())r.has(t)&&(i=i.concat(r.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",r=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,u=>{},this.k.extUri,void 0,this.h);this.g.set(i,r),this.n=r}for(const[i,r]of t)this.n.set(P.URI.revive(i),r.map($.Diagnostic.to))}};e.$Mcc=v,e.$Mcc=v=o=Ke([Ve(1,g.$0i),Ve(2,S.$Kcc)],v)}),define(Ae[242],Re([1,0,2,3,24]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class M{constructor($){this.a=$.getProxy(L.$tK.MainThreadDialogs)}showOpenDialog($,D){return D?.allowUIResources&&(0,P.$lF)($,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(D=>D?E.URI.revive(D):void 0)}}e.$2cc=M}),define(Ae[243],Re([1,0,11,2,7,3,14,19,13]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class g{static{this.a=0}constructor(S,o,b){this.d=o,this.e=b,this.b=new Map,this.c=S.getProxy(M.$tK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,o){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const b=g.a++;this.b.set(b,o),this.c.$registerTextContentProvider(b,S);let v;return typeof o.onDidChange=="function"&&(v=o.onDidChange(f=>{if(f.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(b,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const r=(0,D.$Pe)(t);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(f,t)},E.$Z)})),new P.$vK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(S,o){const b=this.b.get(S);return b?Promise.resolve(b.provideTextDocumentContent(L.URI.revive(o),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.$3cc=g}),define(Ae[244],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class o{constructor(v,f){this.a=new E.$Nd({onListenerError:S.$1}),this.b=new E.$Nd({onListenerError:S.$1}),this.c=new E.$Nd({onListenerError:S.$1}),this.d=new E.$Nd({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Qc,this.h=new Map,this.f=v.getProxy(M.$tK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const f=this.g.getDocument(v);if(f)return f}getDocument(v){const f=this.getDocumentData(v);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return f.document}ensureDocumentData(v){const f=this.g.getDocument(v);if(f)return Promise.resolve(f);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(i=>{this.h.delete(v.toString());const r=P.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(r))},i=>(this.h.delete(v.toString()),Promise.reject(i))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(v,f){const t=P.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(v){const f=P.URI.revive(v),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,f){const t=P.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,f,t){const i=P.URI.revive(v),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(t),r.onEvents(f);let u;f.isUndoing?u=A.TextDocumentChangeReason.Undo:f.isRedoing&&(u=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$8m)({document:r.document,contentChanges:f.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:u}))}setWordDefinitionFor(v,f){(0,R.$wM)(v,f)}}e.$Icc=o}),define(Ae[61],Re([1,0,54,5,6,2,4,3,103,17,109,8,15,28,14,67,43]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class i{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,l){this.h=a,this.i=l,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new L.$Nd,this.e=new L.$Nd,this.f=new L.$Nd,this.g=new L.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const l=[],n=[],s=[];if(a.removedDocuments)for(const c of a.removedDocuments){const h=M.URI.revive(c),p=this.c.get(h);p?.unref()&&(this.c.delete(h),l.push(p.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const h=M.URI.revive(c.uri);let p=this.c.get(h);if(p&&h.scheme!==v.Schemas.vscodeNotebookCell&&h.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);p||(p=new i(new D.$xM(this.h.getProxy($.$tK.MainThreadDocuments),h,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(h,p),n.push(p.value)),p.ref()}if(a.removedEditors)for(const c of a.removedEditors){const h=this.b.get(c);this.b.delete(c),h&&s.push(h)}if(a.addedEditors)for(const c of a.addedEditors){const h=M.URI.revive(c.documentUri);E.ok(this.c.has(h),`document '${h}' does not exist`),E.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const p=this.c.get(h).value,m=new A.$DM(c.id,this.h.getProxy($.$tK.MainThreadTextEditors),this.i,new t.$U(()=>p.document),c.selections.map(S.Selection.to),c.options,c.visibleRanges.map(I=>S.Range.to(I)),typeof c.editorPosition=="number"?S.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,m)}a.newActiveEditor!==void 0&&(E.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),a.removedDocuments&&this.e.fire(l),a.addedDocuments&&this.d.fire(n),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return f.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const l=this.b.get(this.a);return a?l:l?.value}allEditors(){return[...this.b.values()]}};e.$EM=r,e.$EM=r=Ke([Ve(0,g.$uM),Ve(1,o.$0i)],r),e.$FM=(0,R.$Ph)("IExtHostDocumentsAndEditors")}),define(Ae[62],Re([1,0,8,3,2,5,4,7,17,16,245]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0,e.$Zdc=(0,R.$Ph)("IExtHostEditorTabs");class S{constructor(t,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new $.$aM(P.URI.revive(this.b.input.uri));case 2:return new $.$bM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new $.$cM(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new $.$dM(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new $.$eM(this.b.input.viewType);case 4:return new $.$fM(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new $.$gM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new $.$hM;case 9:return new $.$iM(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));default:return}}}class o{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const r of t.tabs)r.isActive&&(this.d=r.id),this.c.push(new S(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return E.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(r=>r.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const r=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,r),t.tabDto.isActive&&(this.d=r.tabId),r}else if(t.kind===1){const r=this.c.splice(t.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(t.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,r),r}const i=this.c.find(r=>r.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new M.$Nd,this.c=new M.$Nd,this.e=[],this.a=t.getProxy(L.$tK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(r=>r.apiObject))},get activeTabGroup(){const r=t.d;return(0,g.$Jf)(t.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,u)=>{const a=Array.isArray(r)?r:[r];return a.length?v(a[0])?this.j(a,u):this.i(a,u):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(c=>c.groupId)),r=new Set(t.map(c=>c.groupId)),u=(0,A.$K)(i,r),a=this.e.filter(c=>u.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],n=[];this.e=t.map(c=>{const h=new o(c,()=>this.d);return u.added.includes(h.groupId)?l.push(h.apiObject):n.push(h.apiObject),h});const s=(0,g.$Jf)(t.find(c=>c.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:a,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(r=>r.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(u=>u.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(t){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===t)return r}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const r=[];for(const u of t){const a=this.g(u);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,i)}async j(t,i){const r=[];for(const u of t){const a=this.h(u);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,i)}};e.$1dc=b,e.$1dc=b=Ke([Ve(0,D.$uM)],b);function v(f){return f.tabs!==void 0}}),define(Ae[246],Re([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$tK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector($,D);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider($,g),new L.$vK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Mec=P}),define(Ae[247],Re([1,0,2,3,6,7,8,294,13,22,24,52]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class o{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,r,u=14,a=14;for(const l of f){let n=i?(0,D.$4e)(i,l):0;for(n===0?r=1:r=a;n<l.length;n++)n+1===l.length?(u=a,a=9):a+=1,t.push([r,l.toUpperCase().charCodeAt(n),a]),t.push([r,l.toLowerCase().charCodeAt(n),a]),r=a;i=l,a=u}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$fZ(t)}}provideDocumentLinks(f){this.c();const t=[],i=$.$gZ.computeLinks({getLineContent(r){return f.lineAt(r-1).text},getLineCount(){return f.lineCount}},this.b);for(const r of i){const u=R.DocumentLink.to(r);u.target&&t.push(u)}return t}}class b{constructor(f,t){this.i=t,this.b=new o,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(L.$tK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,r={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const u=this.h++;this.b.add(t),this.d.add(t),this.c.set(u,i);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof i.copy=="function"&&(a+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$lF)(f,"fsChunks"),a+=4);let l;r.isReadonly&&(0,S.$5j)(r.isReadonly)&&((0,A.$lF)(f,"readonlyMessage"),l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(u,t,a,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const n=i.onDidChangeFile(s=>{const c=[];for(const h of s){const{uri:p,type:m}=h;if(p.scheme!==t)continue;let I;switch(m){case M.FileChangeType.Changed:I=0;break;case M.FileChangeType.Created:I=1;break;case M.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:p,type:I})}this.a.$onFileSystemChange(u,c)});return(0,P.$Pc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(u),this.a.$unregisterProvider(u)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:r,size:u,permissions:a}=f;return{type:t,ctime:i,mtime:r,size:u,permissions:a}}$stat(f,t){return Promise.resolve(this.l(f).stat(E.URI.revive(t))).then(i=>b.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(E.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(E.URI.revive(t))).then(i=>g.$be.wrap(i))}$writeFile(f,t,i,r){return Promise.resolve(this.l(f).writeFile(E.URI.revive(t),i.buffer,r))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(E.URI.revive(t),i))}$rename(f,t,i,r){return Promise.resolve(this.l(f).rename(E.URI.revive(t),E.URI.revive(i),r))}$copy(f,t,i,r){const u=this.l(f);if(!u.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(u.copy(E.URI.revive(t),E.URI.revive(i),r))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(E.URI.revive(t)))}$watch(f,t,i,r){const u=this.l(f).watch(E.URI.revive(i),r);this.f.set(t,u)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const r=this.l(f);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(E.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,r){const u=this.l(f);if(!u.read)throw new Error('FileSystemProvider does not implement "read"');const a=g.$be.alloc(r);return Promise.resolve(u.read(t,i,a.buffer,0,r)).then(l=>a.slice(0,l))}$write(f,t,i,r){const u=this.l(f);if(!u.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(u.write(t,i,r.buffer,0,r.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$wdc=b}),define(Ae[63],Re([1,0,3,40,7,22,4,17,41,6,12,25,14]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;let v=b=class{constructor(t,i){this.b=new Map,this.c=new A.$3g,this.a=t.getProxy(E.$tK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(u){try{let a;const l=r.b.get(u.scheme);return l?(await r.a.$ensureActivation(u.scheme),a=await l.impl.stat(u)):a=await r.a.$stat(u),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){b.e(a)}},async readDirectory(u){try{const a=r.b.get(u.scheme);return a?(await r.a.$ensureActivation(u.scheme),(await a.impl.readDirectory(u)).slice()):await r.a.$readdir(u)}catch(a){return b.e(a)}},async createDirectory(u){try{const a=r.b.get(u.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(u.scheme),await r.d(a.impl,a.extUri,u)):await r.a.$mkdir(u)}catch(a){return b.e(a)}},async readFile(u){try{const a=r.b.get(u.scheme);return a?(await r.a.$ensureActivation(u.scheme),(await a.impl.readFile(u)).slice()):(await r.a.$readFile(u)).buffer}catch(a){return b.e(a)}},async writeFile(u,a){try{const l=r.b.get(u.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(u.scheme),await r.d(l.impl,l.extUri,l.extUri.dirname(u)),await r.c.queueFor(u).queue(()=>Promise.resolve(l.impl.writeFile(u,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(u,M.$be.wrap(a))}catch(l){return b.e(l)}},async delete(u,a){try{const l=r.b.get(u.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(u.scheme),await l.impl.delete(u,{recursive:!1,...a})):await r.a.$delete(u,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(l){return b.e(l)}},async rename(u,a,l){try{return await r.a.$rename(u,a,{overwrite:!1,...l})}catch(n){return b.e(n)}},async copy(u,a,l){try{return await r.a.$copy(u,a,{overwrite:!1,...l})}catch(n){return b.e(n)}},isWritableFileSystem(u){const a=i.getCapabilities(u);if(typeof a=="number")return!(a&2048)}})}async d(t,i,r){const u=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await t.stat(r)).type&L.FileType.Directory))throw P.$IL.FileExists(`Unable to create folder '${r.scheme===o.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.$ok(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;u.push(i.basename(r)),r=i.dirname(r)}for(let a=u.length-1;a>=0;a--){r=i.joinPath(r,u[a]);try{await t.createDirectory(r)}catch(l){if(L.$ok(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$IL)throw t;if(t instanceof L.$kk)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw P.$IL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$IL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$IL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$IL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$IL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$IL.Unavailable(t.message);default:throw new P.$IL(t.message,t.name)}if(!(t instanceof Error))throw new P.$IL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$IL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw P.$IL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$IL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$IL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$IL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$IL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$IL.Unavailable(t.message);default:throw new P.$IL(t.message,t.name)}}addFileSystemProvider(t,i,r){return this.b.set(t,{impl:i,extUri:r?.isCaseSensitive?S.$lg:S.$ng,isReadonly:!!r?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$lg}};e.$cdc=v,e.$cdc=v=b=Ke([Ve(0,$.$uM),Ve(1,D.$Kcc)],v),e.$ddc=(0,R.$Ph)("IExtHostConsumerFileSystem")}),define(Ae[248],Re([1,0,5,39,2,3,8,7,43]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,v,f,t,i,r){this.a=Math.random(),this.b=new E.$Nd,this.c=new E.$Nd,this.d=new E.$Nd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const u=(0,L.$wj)(i),a=typeof i=="string",l=r?.correlate,n=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const c of s.created){const h=P.URI.revive(c);u(h.fsPath)&&(!a||v.getWorkspaceFolder(h))&&this.b.fire(h)}if(!r?.ignoreChangeEvents)for(const c of s.changed){const h=P.URI.revive(c);u(h.fsPath)&&(!a||v.getWorkspaceFolder(h))&&this.c.fire(h)}if(!r?.ignoreDeleteEvents)for(const c of s.deleted){const h=P.URI.revive(c);u(h.fsPath)&&(!a||v.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=$.$vK.from(this.i(b,f,i,r,r?.correlate),this.b,this.c,this.d,n)}i(b,v,f,t,i){const r=$.$vK.from();if(typeof f=="string")return r;const u=b.getProxy(M.$tK.MainThreadFileSystemEventService);let a=!1;return(f.pattern.includes(L.$sj)||f.pattern.includes(L.$tj))&&(a=!0),u.$watch(v.identifier.value,this.a,f.baseUri,{recursive:a,excludes:t?.excludes??[]},!!i),$.$vK.from({dispose:()=>u.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(b){this.a=b,this.session=this.a.session,this.b=new D.$U(()=>this.a.created.map(P.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(b,v,f){this.j=b,this.k=v,this.l=f,this.a=new E.$Nd,this.b=new E.$Nd,this.c=new E.$Nd,this.d=new E.$Nd,this.g=new E.$Pd,this.h=new E.$Pd,this.i=new E.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,v,f,t){return new g(this.j,b,v,this.a.event,R.GlobPattern.from(f),t)}$onFileEvent(b){this.a.fire(new A(b))}$onDidRunFileOperation(b,v){switch(b){case 2:this.b.fire(Object.freeze({files:v.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(f=>P.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,v){return(f,t,i)=>{const r=function(a){f.call(t,a)};return r.extension=b,v.event(r,void 0,i)}}async $onWillRunFileOperation(b,v,f,t){switch(b){case 2:return await this.n(this.g,{files:v.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:v.map(i=>P.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:v.map(i=>P.URI.revive(i.target))},f,t)}}async n(b,v,f,t){const i=new Set,r=[];if(await b.fireAsync(v,t,async(a,l)=>{const n=Date.now(),s=await Promise.resolve(a);s instanceof $.$FK&&(r.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-n>f&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||r.length===0)return;const u={edits:[]};for(const[,a]of r){const{edits:l}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(l)}return{edit:u,extensionNames:Array.from(i)}}}e.$xdc=S}),define(Ae[249],Re([1,0,6,2,3,8,7,32,12]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class g{static{this.a=0}constructor(b,v){this.extension=b,this.provider=v,this.handle=g.a++}}class A{constructor(b){this.session=b,this.responses=[]}}class S{static{this.a=0}constructor(b,v,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(P.$tK.MainThreadInlineChat),v.registerApiCommand(new $.$UM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$SM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$TM.Void))}registerProvider(b,v,f){const t=new g(b,v);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,b.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function"),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,v,f,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(L.URI.revive(v)),u=M.Selection.to(f),a=await i.provider.prepareInteractiveEditorSession({document:r,selection:u},t);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=S.a++;return this.d.set(l,new A(a)),{id:l,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:M.Range.from(a.wholeRange),message:a.message}}async $provideResponse(b,v,f,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(v.id);if(!r)return;const u={prompt:f.prompt,selection:M.Selection.to(f.selection),wholeRange:M.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let a=!1;const l={report:async m=>{if(!f.live&&m.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:m.message,edits:m.edits?.map(M.TextEdit.from),editsShouldBeInstant:m.editsShouldBeInstant,slashCommand:m.slashCommand?.command,markdownFragment:R.$VK.isMarkdownString(m.content)?m.content.value:m.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,u,l,t));let s;try{s=await(0,D.$Ig)(n,t)}finally{a=!0}if(!s)return;const c=r.responses.push(s)-1,h={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s))return{...h,id:c,type:"message",message:M.MarkdownString.from(s.contents)};const{edits:p}=s;return p instanceof R.$FK?{...h,id:c,type:"bulkEdit",edits:M.WorkspaceEdit.from(p)}:{...h,id:c,type:"editorEdit",edits:p.map(M.TextEdit.from)}}$handleFeedback(b,v,f,t){const i=this.b.get(b),r=this.d.get(v),u=r?.responses[f];if(i&&u){const a=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,u,a)}}$releaseSession(b,v){}static h(b){return typeof b=="object"&&typeof b.contents=="object"}}e.$Eec=S}),define(Ae[250],Re([1,0,2,32]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class P{constructor(R,$,D,g,A){this.a=$,this.b=D,this.c=g;const S=new L.$UM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$SM("showOptions","Show Options",o=>!0,o=>o),new L.$SM("resource","Interactive resource Uri",o=>!0,o=>o),new L.$SM("controllerId","Notebook controller Id",o=>!0,o=>o),new L.$SM("title","Interactive editor title",o=>!0,o=>o)],new L.$TM("Notebook and input URI",o=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",o.notebookEditorId),o.notebookEditorId!==void 0){const b=this.a.getEditorById(o.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri),notebookEditor:b.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",o.notebookUri,o.inputUri),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,$,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Aec=P}),define(Ae[251],Re([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$tK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueData($);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueTemplate($);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,$){const D=R.identifier.value;return this.a.set(D,$),this.c.$registerIssueUriRequestHandler(D),new L.$vK(()=>{this.c.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}registerIssueDataProvider(R,$){const D=R.identifier.value;return this.b.set(D,$),this.c.$registerIssueDataProvider(D),new L.$vK(()=>{this.c.$unregisterIssueDataProvider(D),this.b.delete(D)})}}e.$Gec=P}),define(Ae[252],Re([1,0,6,3]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(L.$tK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Tdc=P}),define(Ae[253],Re([1,0,2,26,8,7,79,3,13,29,18,16,295,19,21,6,94,88,74,49,11,12,24,160]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;class c{constructor(T,q){this.d=T,this.e=q}async provideDocumentSymbols(T,q){const G=this.d.getDocument(T),J=await this.e.provideDocumentSymbols(G,q);if(!(0,A.$Jb)(J))return J[0]instanceof M.$NK?J.map(P.DocumentSymbol.from):c.f(J)}static f(T){T=T.slice(0).sort((J,K)=>{let x=J.location.range.start.compareTo(K.location.range.start);return x===0&&(x=K.location.range.end.compareTo(J.location.range.end)),x});const q=[],G=[];for(const J of T){const K={name:J.name||"!!MISSING: name!!",kind:P.SymbolKind.from(J.kind),tags:J.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:P.Range.from(J.location.range),selectionRange:P.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(K),q.push(K);break}const x=G[G.length-1];if(g.$ws.containsRange(x.range,K.range)&&!g.$ws.equalsRange(x.range,K.range)){x.children?.push(K),G.push(K);break}G.pop()}}return q}}class h{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,q,G){this.g=T,this.h=q,this.j=G,this.e=new r.$Hcc("CodeLens"),this.f=new Map}async provideCodeLenses(T,q){const G=this.g.getDocument(T),J=await this.j.provideCodeLenses(G,q);if(!J||q.isCancellationRequested)return;const K=this.e.add(J),x=new f.$Qc;this.f.set(K,x);const ce={cacheId:K,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ce.lenses.push({cacheId:[K,Ne],range:P.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ce}async resolveCodeLens(T,q){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,q),J||(J=G),q.isCancellationRequested)return;const K=T.cacheId&&this.f.get(T.cacheId[0]);if(K)return T.command=this.h.toInternal(J.command??h.d,K),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function p(Ce){return Array.isArray(Ce)?Ce.map(P.DefinitionLink.from):Ce?[P.DefinitionLink.from(Ce)]:[]}class m{constructor(T,q){this.d=T,this.e=q}async provideDefinition(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideDefinition(J,K,G);return p(x)}}class I{constructor(T,q){this.d=T,this.e=q}async provideDeclaration(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideDeclaration(J,K,G);return p(x)}}class k{constructor(T,q){this.d=T,this.e=q}async provideImplementation(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideImplementation(J,K,G);return p(x)}}class d{constructor(T,q){this.d=T,this.e=q}async provideTypeDefinition(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideTypeDefinition(J,K,G);return p(x)}}class y{constructor(T,q){this.d=T,this.e=q}async provideHover(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideHover(J,K,G);if(!(!x||(0,A.$Jb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(K)),x.range||(x.range=new M.$xK(K,K)),P.Hover.from(x)}}class w{constructor(T,q){this.d=T,this.e=q}async provideEvaluatableExpression(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideEvaluatableExpression(J,K,G);if(x)return P.EvaluatableExpression.from(x)}}class C{constructor(T,q){this.d=T,this.e=q}async provideInlineValues(T,q,G,J){const K=this.d.getDocument(T),x=await this.e.provideInlineValues(K,P.Range.to(q),P.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ce=>P.InlineValue.from(ce))}}class j{constructor(T,q){this.d=T,this.e=q}async provideDocumentHighlights(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideDocumentHighlights(J,K,G);if(Array.isArray(x))return x.map(P.DocumentHighlight.from)}}class B{constructor(T,q){this.d=T,this.e=q}async provideLinkedEditingRanges(T,q,G){const J=this.d.getDocument(T),K=P.Position.to(q),x=await this.e.provideLinkedEditingRanges(J,K,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Gb)(x.ranges.map(P.Range.from)),wordPattern:x.wordPattern}}}class W{constructor(T,q){this.d=T,this.e=q}async provideReferences(T,q,G,J){const K=this.d.getDocument(T),x=P.Position.to(q),ce=await this.e.provideReferences(K,x,G,J);if(Array.isArray(ce))return ce.map(P.location.from)}}class U{static{this.d=1e3}constructor(T,q,G,J,K,x,ce){this.g=T,this.h=q,this.j=G,this.k=J,this.l=K,this.m=x,this.n=ce,this.e=new r.$Hcc("CodeAction"),this.f=new Map}async provideCodeActions(T,q,G,J){const K=this.g.getDocument(T),x=o.$ys.isISelection(q)?P.Selection.to(q):P.Range.to(q),ce=[];for(const Ye of this.j.getDiagnostics(T))if(x.intersection(Ye.range)&&ce.push(Ye)>U.d)break;const Ne={diagnostics:ce,only:G.only?new M.$PK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},je=await this.k.provideCodeActions(K,x,Ne,J);if(!(0,A.$Kb)(je)||J.isCancellationRequested)return;const Qe=this.e.add(je),Ge=new f.$Qc;this.f.set(Qe,Ge);const _e=[];for(let Ye=0;Ye<je.length;Ye++){const xe=je[Ye];xe&&(U.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Ne.only&&(xe.kind?Ne.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Ye],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(P.Diagnostic.from),edit:xe.edit&&P.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,n.$kF)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(T,q){const[G,J]=T,K=this.e.get(G,J);if(!K||U.o(K))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(K,q)??K;let ce;x.edit&&(ce=P.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const je=this.f.get(G);je&&(Ne=this.h.toInternal(x.command,je))}return{edit:ce,command:Ne}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class F{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,G,J,K){this.d=T,this.e=q,this.f=G,this.g=J,this.h=K}async prepareDocumentPaste(T,q,G,J){if(!this.f.prepareDocumentPaste)return;const K=this.e.getDocument(T),x=q.map(je=>P.Range.to(je)),ce=P.DataTransfer.toDataTransfer(G,()=>{throw new a.$0});if(await this.f.prepareDocumentPaste(K,x,ce,J),J.isCancellationRequested)return;const Ne=Array.from(ce).filter(([,je])=>!(je instanceof M.$jL));return P.DataTransfer.from(Ne)}async providePasteEdits(T,q,G,J,K){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),ce=G.map(Qe=>P.Range.to(Qe)),Ne=P.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolvePasteFileData(this.g,T,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ce,Ne,K);if(je)return{label:je.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:F.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class O{constructor(T,q){this.d=T,this.e=q}async provideDocumentFormattingEdits(T,q,G){const J=this.d.getDocument(T),K=await this.e.provideDocumentFormattingEdits(J,q,G);if(Array.isArray(K))return K.map(P.TextEdit.from)}}class ee{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeFormattingEdits(T,q,G,J){const K=this.d.getDocument(T),x=P.Range.to(q),ce=await this.e.provideDocumentRangeFormattingEdits(K,x,G,J);if(Array.isArray(ce))return ce.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,q,G,J){(0,S.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const K=this.d.getDocument(T),x=q.map(P.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(K,x,G,J);if(Array.isArray(ce))return ce.map(P.TextEdit.from)}}class X{constructor(T,q){this.d=T,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,q,G,J,K){const x=this.d.getDocument(T),ce=P.Position.to(q),Ne=await this.e.provideOnTypeFormattingEdits(x,ce,G,J,K);if(Array.isArray(Ne))return Ne.map(P.TextEdit.from)}}class Ee{constructor(T,q){this.e=T,this.f=q,this.d=new r.$Hcc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,q){const G=await this.e.provideWorkspaceSymbols(T,q);if(!(0,A.$Kb)(G))return{symbols:[]};const J=this.d.add(G),K={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ce=G[x];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}K.symbols.push({...P.WorkspaceSymbol.from(ce),cacheId:[J,x]})}return K}async resolveWorkspaceSymbol(T,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,q);return J&&(0,L.$0m)(T,P.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class ke{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,q,G){this.d=T,this.e=q,this.f=G}async provideRenameEdits(T,q,G,J){const K=this.d.getDocument(T),x=P.Position.to(q);try{const ce=await this.e.provideRenameEdits(K,x,G,J);return ce?P.WorkspaceEdit.from(ce):void 0}catch(ce){const Ne=ke.g(ce);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(T,q,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(T),K=P.Position.to(q);try{const x=await this.e.prepareRename(J,K,G);let ce,Ne;if(M.$xK.isRange(x)?(ce=x,Ne=J.getText(x)):(0,S.$Af)(x)&&(ce=x.range,Ne=x.placeholder),!ce||!Ne)return;if(ce.start.line>K.line||ce.end.line<K.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ce),text:Ne}}catch(x){const ce=ke.g(x);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(x)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Pe{constructor(T,q){this.resultId=T,this.tokens=q}}class le{constructor(T,q){this.f=T,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,q,G){const J=this.f.getDocument(T),K=q!==0?this.d.get(q):null;let x=typeof K?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,K.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return K&&this.d.delete(q),x?(x=le.h(x),this.o(le.n(K,x),x)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return le.j(T)?le.k(T)?T:new M.$ML(new Uint32Array(T.data),T.resultId):le.l(T)?le.m(T)?T:new M.$OL(T.edits.map(q=>new M.$NL(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const q of T.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(T,q){if(!le.j(q)||!T||!T.tokens)return q;const G=T.tokens,J=G.length,K=q.data,x=K.length;let ce=0;const Ne=Math.min(J,x);for(;ce<Ne&&G[ce]===K[ce];)ce++;if(ce===J&&ce===x)return new M.$OL([],q.resultId);let je=0;const Qe=Ne-ce;for(;je<Qe&&G[J-je-1]===K[x-je-1];)je++;return new M.$OL([{start:ce,deleteCount:J-ce-je,data:K.subarray(ce,x-je)}],q.resultId)}o(T,q){if(le.j(T)){const G=this.e++;return this.d.set(G,new Pe(T.resultId,T.data)),(0,t.$b$)({id:G,type:"full",data:T.data})}if(le.l(T)){const G=this.e++;return le.j(q)?this.d.set(G,new Pe(q.resultId,q.data)):this.d.set(G,new Pe(T.resultId)),(0,t.$b$)({id:G,type:"delta",deltas:(T.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class be{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeSemanticTokens(T,q,G){const J=this.d.getDocument(T),K=await this.e.provideDocumentRangeSemanticTokens(J,P.Range.to(q),G);return K?this.f(K):null}f(T){return(0,t.$b$)({id:0,type:"full",data:T.data})}}class ue{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,q,G,J,K){this.f=T,this.g=q,this.h=G,this.j=J,this.k=K,this.d=new r.$Hcc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,q,G,J){const K=this.f.getDocument(T),x=P.Position.to(q),ce=K.getWordRangeAtPosition(x)||new M.$xK(x,x),Ne=ce.with({end:x}),je=new u.$Jd,Qe=await this.h.provideCompletionItems(K,x,J,P.CompletionContext.to(G));if(!Qe||J.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new M.$3K(Qe):Qe,_e=ue.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new f.$Qc;this.e.set(_e,Ye);const xe=[],it={x:_e,b:xe,a:{replace:P.Range.from(ce),insert:P.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],ut=this.l(ze,[_e,tt],Ne,ce);xe.push(ut)}return it}async resolveCompletionItem(T,q){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const J=this.l(G,T),K=await this.h.resolveCompletionItem(G,q);if(!K)return;const x=this.l(K,T);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,L.$$m)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q,G,J){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const x=this.g.toInternal(T.command,K),ce={x:q,a:T.label,b:T.kind!==void 0?P.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(P.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:P.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(P.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=T.textEdit.newText):typeof T.insertText=="string"?ce.h=T.insertText:T.insertText instanceof M.$GK&&(ce.h=T.insertText.value,ce.i|=4);let Ne;return T.textEdit?Ne=T.textEdit.range:T.range&&(Ne=T.range),M.$xK.isRange(Ne)?ce.j=P.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ce.j={insert:P.Range.from(Ne.inserting),replace:P.Range.from(Ne.replacing)}),ce}}class oe{async provideInlineCompletions(T,q,G,J){}disposeCompletions(T){}handleDidShowCompletionItem(T,q,G){}handlePartialAccept(T,q,G){}}class ye extends oe{constructor(T,q,G,J){super(),this.f=T,this.g=q,this.h=G,this.j=J,this.d=new te,this.e=(0,n.$kF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$kF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,q,G,J){const K=this.g.getDocument(T),x=P.Position.to(q),ce=await this.h.provideInlineCompletionItems(K,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ce||J.isCancellationRequested)return;const Ne=Array.isArray(ce)?ce:ce.items,je=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ye,xe)=>{let it;Ye.command&&(Ge||(Ge=new f.$Qc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?P.Range.from(Ye.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:je.map(Ye=>(Ge||(Ge=new f.$Qc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,q,G){const J=this.d.get(T)?.items[q];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(T,q,G){const J=this.d.get(T)?.items[q];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const q=this.e++;return this.d.set(q,T),q}disposeReferenceId(T){const q=this.d.get(T);return this.d.delete(T),q}get(T){return this.d.get(T)}}class V{constructor(T,q){this.e=T,this.f=q,this.d=new r.$Hcc("SignatureHelp")}async provideSignatureHelp(T,q,G,J){const K=this.e.getDocument(T),x=P.Position.to(q),ce=this.g(G),Ne=await this.f.provideSignatureHelp(K,x,J,ce);if(Ne){const je=this.d.add([Ne]);return{...P.SignatureHelp.from(Ne),id:je}}}g(T){let q;if(T.activeSignatureHelp){const G=P.SignatureHelp.to(T.activeSignatureHelp),J=this.d.get(T.activeSignatureHelp.id,0);J?(q=J,q.activeSignature=G.activeSignature,q.activeParameter=G.activeParameter):q=G}return{...T,activeSignatureHelp:q}}releaseSignatureHelp(T){this.d.delete(T)}}class Y{constructor(T,q,G,J,K){this.f=T,this.g=q,this.h=G,this.j=J,this.k=K,this.d=new r.$Hcc("InlayHints"),this.e=new Map}async provideInlayHints(T,q,G){const J=this.f.getDocument(T),K=P.Range.to(q),x=await this.h.provideInlayHints(J,K,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(x);this.e.set(ce,new f.$Qc);const Ne={hints:[],cacheId:ce};for(let je=0;je<x.length;je++)this.l(x[je],K)&&Ne.hints.push(this.m(x[je],[ce,je]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Ne}async resolveInlayHint(T,q){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const J=await this.h.resolveInlayHint(G,q);if(J&&this.l(J))return this.m(J,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(q&&!q.contains(T.position))}m(T,q){const G=this.e.get(q[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:q,tooltip:P.MarkdownString.fromStrict(T.tooltip),position:P.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(P.TextEdit.from),kind:T.kind&&P.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?J.label=T.label:J.label=T.label.map(K=>{const x={label:K.value};return x.tooltip=P.MarkdownString.fromStrict(K.tooltip),M.$HK.isLocation(K.location)&&(x.location=P.location.from(K.location)),K.command&&(x.command=this.g.toInternal(K.command,G)),x}),J}}class _{constructor(T,q){this.e=T,this.f=q,this.d=new r.$Hcc("DocumentLink")}async provideLinks(T,q){const G=this.e.getDocument(T),J=await this.f.provideDocumentLinks(G,q);if(!(!Array.isArray(J)||J.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(_.g).map(P.DocumentLink.from)};{const K=this.d.add(J),x={links:[],cacheId:K};for(let ce=0;ce<J.length;ce++){if(!_.g(J[ce]))continue;const Ne=P.DocumentLink.from(J[ce]);Ne.cacheId=[K,ce],x.links.push(Ne)}return x}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,q){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const J=await this.f.resolveDocumentLink(G,q);if(!(!J||!_.g(J)))return P.DocumentLink.from(J)}releaseLinks(T){this.d.delete(T)}}class pe{constructor(T,q){this.d=T,this.e=q}async provideColors(T,q){const G=this.d.getDocument(T),J=await this.e.provideDocumentColors(G,q);return Array.isArray(J)?J.map(x=>({color:P.Color.from(x.color),range:P.Range.from(x.range)})):[]}async provideColorPresentations(T,q,G){const J=this.d.getDocument(T),K=P.Range.to(q.range),x=P.Color.to(q.color),ce=await this.e.provideColorPresentations(x,{document:J,range:K},G);if(Array.isArray(ce))return ce.map(P.ColorPresentation.from)}}class $e{constructor(T,q){this.d=T,this.e=q}async provideFoldingRanges(T,q,G){const J=this.d.getDocument(T),K=await this.e.provideFoldingRanges(J,q,G);if(Array.isArray(K))return K.map(P.FoldingRange.from)}}class de{constructor(T,q,G){this.d=T,this.e=q,this.f=G}async provideSelectionRanges(T,q,G){const J=this.d.getDocument(T),K=q.map(P.Position.to),x=await this.e.provideSelectionRanges(J,K,G);if(!(0,A.$Kb)(x))return[];if(x.length!==K.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ne=0;Ne<K.length;Ne++){const je=[];ce.push(je);let Qe=K[Ne],Ge=x[Ne];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(P.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ce}}class De{constructor(T,q){this.f=T,this.g=q,this.d=new i.$zM(""),this.e=new Map}async prepareSession(T,q,G){const J=this.f.getDocument(T),K=P.Position.to(q),x=await this.g.prepareCallHierarchy(J,K,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideCallsTo(T,q,G){const J=this.j(T,q);if(!J)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyIncomingCalls(J,G);if(K)return K.map(x=>({from:this.h(T,x.from),fromRanges:x.fromRanges.map(ce=>P.Range.from(ce))}))}async provideCallsFrom(T,q,G){const J=this.j(T,q);if(!J)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(K)return K.map(x=>({to:this.h(T,x.to),fromRanges:x.fromRanges.map(ce=>P.Range.from(ce))}))}releaseSession(T){this.e.delete(T)}h(T,q){const G=this.e.get(T),J=P.CallHierarchyItem.from(q,T,G.size.toString(36));return G.set(J._itemId,q),J}j(T,q){return this.e.get(T)?.get(q)}}class re{constructor(T,q){this.f=T,this.g=q,this.d=new i.$zM(""),this.e=new Map}async prepareSession(T,q,G){const J=this.f.getDocument(T),K=P.Position.to(q),x=await this.g.prepareTypeHierarchy(J,K,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideSupertypes(T,q,G){const J=this.j(T,q);if(!J)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySupertypes(J,G);if(K)return K.map(x=>this.h(T,x))}async provideSubtypes(T,q,G){const J=this.j(T,q);if(!J)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySubtypes(J,G);if(K)return K.map(x=>this.h(T,x))}releaseSession(T){this.e.delete(T)}h(T,q){const G=this.e.get(T),J=P.TypeHierarchyItem.from(q,T,G.size.toString(36));return G.set(J._itemId,q),J}j(T,q){return this.e.get(T)?.get(q)}}class he{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,G,J,K){this.d=T,this.e=q,this.f=G,this.g=J,this.h=K}async provideDocumentOnDropEdits(T,q,G,J,K){const x=this.e.getDocument(q),ce=P.Position.to(G),Ne=P.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,ce,Ne,K);if(je)return{label:je.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class ne{constructor(T,q){this.d=T,this.e=q}async provideMappedEdits(T,q,G,J){const K=E.URI.revive(T),x=this.d.getDocument(K),ce=G.documents.map(Qe=>Qe.map(Ge=>({uri:E.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>P.Range.to(_e))}))),Ne={documents:ce,selections:ce[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(x,q,Ne,J);return je?P.WorkspaceEdit.from(je):null}}class ae{constructor(T,q){this.adapter=T,this.extension=q}}class ge{static{this.d=0}constructor(T,q,G,J,K,x,ce,Ne){this.g=q,this.h=G,this.j=J,this.k=K,this.l=x,this.m=ce,this.n=Ne,this.f=new Map,this.e=T.getProxy($.$tK.MainThreadLanguageFeatures)}o(T,q){return P.DocumentSelector.from(T,this.g,q)}p(T){return new M.$vK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return ge.d++}async s(T,q,G,J,K,x=!1){const ce=this.f.get(T);if(!ce||!(ce.adapter instanceof q))return J;const Ne=Date.now();x||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(ce.adapter,ce.extension);return Promise.resolve(je).catch(Qe=>{(0,a.$3)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),b.CancellationToken.isCancellationToken(K)?(0,l.$Jg)(je,K):je}t(T,q){const G=this.q();return this.f.set(G,new ae(T,q)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,q,G,J){const K=this.t(new c(this.h,G),T),x=J&&J.label||ge.u(T);return this.e.$registerDocumentSymbolProvider(K,this.o(q,T),x),this.p(K)}$provideDocumentSymbols(T,q,G){return this.s(T,c,J=>J.provideDocumentSymbols(E.URI.revive(q),G),void 0,G)}registerCodeLensProvider(T,q,G){const J=this.q(),K=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new h(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(J,this.o(q,T),K);let x=this.p(J);if(K!==void 0){const ce=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(K));x=M.$vK.from(x,ce)}return x}$provideCodeLenses(T,q,G){return this.s(T,h,J=>J.provideCodeLenses(E.URI.revive(q),G),void 0,G)}$resolveCodeLens(T,q,G){return this.s(T,h,J=>J.resolveCodeLens(q,G),void 0,void 0)}$releaseCodeLenses(T,q){this.s(T,h,G=>Promise.resolve(G.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(T,q,G){const J=this.t(new m(this.h,G),T);return this.e.$registerDefinitionSupport(J,this.o(q,T)),this.p(J)}$provideDefinition(T,q,G,J){return this.s(T,m,K=>K.provideDefinition(E.URI.revive(q),G,J),[],J)}registerDeclarationProvider(T,q,G){const J=this.t(new I(this.h,G),T);return this.e.$registerDeclarationSupport(J,this.o(q,T)),this.p(J)}$provideDeclaration(T,q,G,J){return this.s(T,I,K=>K.provideDeclaration(E.URI.revive(q),G,J),[],J)}registerImplementationProvider(T,q,G){const J=this.t(new k(this.h,G),T);return this.e.$registerImplementationSupport(J,this.o(q,T)),this.p(J)}$provideImplementation(T,q,G,J){return this.s(T,k,K=>K.provideImplementation(E.URI.revive(q),G,J),[],J)}registerTypeDefinitionProvider(T,q,G){const J=this.t(new d(this.h,G),T);return this.e.$registerTypeDefinitionSupport(J,this.o(q,T)),this.p(J)}$provideTypeDefinition(T,q,G,J){return this.s(T,d,K=>K.provideTypeDefinition(E.URI.revive(q),G,J),[],J)}registerHoverProvider(T,q,G,J){const K=this.t(new y(this.h,G),T);return this.e.$registerHoverProvider(K,this.o(q,T)),this.p(K)}$provideHover(T,q,G,J){return this.s(T,y,K=>K.provideHover(E.URI.revive(q),G,J),void 0,J)}registerEvaluatableExpressionProvider(T,q,G,J){const K=this.t(new w(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(K,this.o(q,T)),this.p(K)}$provideEvaluatableExpression(T,q,G,J){return this.s(T,w,K=>K.provideEvaluatableExpression(E.URI.revive(q),G,J),void 0,J)}registerInlineValuesProvider(T,q,G,J){const K=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new C(this.h,G),T);this.e.$registerInlineValuesProvider(x,this.o(q,T),K);let ce=this.p(x);if(K!==void 0){const Ne=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(K));ce=M.$vK.from(ce,Ne)}return ce}$provideInlineValues(T,q,G,J,K){return this.s(T,C,x=>x.provideInlineValues(E.URI.revive(q),G,J,K),void 0,K)}registerDocumentHighlightProvider(T,q,G){const J=this.t(new j(this.h,G),T);return this.e.$registerDocumentHighlightProvider(J,this.o(q,T)),this.p(J)}$provideDocumentHighlights(T,q,G,J){return this.s(T,j,K=>K.provideDocumentHighlights(E.URI.revive(q),G,J),void 0,J)}registerLinkedEditingRangeProvider(T,q,G){const J=this.t(new B(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(J,this.o(q,T)),this.p(J)}$provideLinkedEditingRanges(T,q,G,J){return this.s(T,B,async K=>{const x=await K.provideLinkedEditingRanges(E.URI.revive(q),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?ge.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(T,q,G){const J=this.t(new W(this.h,G),T);return this.e.$registerReferenceSupport(J,this.o(q,T)),this.p(J)}$provideReferences(T,q,G,J,K){return this.s(T,W,x=>x.provideReferences(E.URI.revive(q),G,J,K),void 0,K)}registerCodeActionProvider(T,q,G,J){const K=new f.$Qc,x=this.t(new U(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(x,this.o(q,T),{providedKinds:J?.providedCodeActionKinds?.map(ce=>ce.value),documentation:J?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,K)}))},ge.u(T),!!G.resolveCodeAction),K.add(this.p(x)),K}$provideCodeActions(T,q,G,J,K){return this.s(T,U,x=>x.provideCodeActions(E.URI.revive(q),G,J,K),void 0,K)}$resolveCodeAction(T,q,G){return this.s(T,U,J=>J.resolveCodeAction(q,G),{},void 0)}$releaseCodeActions(T,q){this.s(T,U,G=>Promise.resolve(G.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(T,q,G){const J=this.t(new O(this.h,G),T);return this.e.$registerDocumentFormattingSupport(J,this.o(q,T),T.identifier,T.displayName||T.name),this.p(J)}$provideDocumentFormattingEdits(T,q,G,J){return this.s(T,O,K=>K.provideDocumentFormattingEdits(E.URI.revive(q),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(T,q,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",K=this.t(new ee(this.h,G),T);return this.e.$registerRangeFormattingSupport(K,this.o(q,T),T.identifier,T.displayName||T.name,J),this.p(K)}$provideDocumentRangeFormattingEdits(T,q,G,J,K){return this.s(T,ee,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(q),G,J,K),void 0,K)}$provideDocumentRangesFormattingEdits(T,q,G,J,K){return this.s(T,ee,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(q),G,J,K),void 0,K)}registerOnTypeFormattingEditProvider(T,q,G,J){const K=this.t(new X(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(K,this.o(q,T),J,T.identifier),this.p(K)}$provideOnTypeFormattingEdits(T,q,G,J,K,x){return this.s(T,X,ce=>ce.provideOnTypeFormattingEdits(E.URI.revive(q),G,J,K,x),void 0,x)}registerWorkspaceSymbolProvider(T,q){const G=this.t(new Ee(q,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof q.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,q,G){return this.s(T,Ee,J=>J.provideWorkspaceSymbols(q,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,q,G){return this.s(T,Ee,J=>J.resolveWorkspaceSymbol(q,G),void 0,void 0)}$releaseWorkspaceSymbols(T,q){this.s(T,Ee,G=>G.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(T,q,G){const J=this.t(new ke(this.h,G,this.l),T);return this.e.$registerRenameSupport(J,this.o(q,T),ke.supportsResolving(G)),this.p(J)}$provideRenameEdits(T,q,G,J,K){return this.s(T,ke,x=>x.provideRenameEdits(E.URI.revive(q),G,J,K),void 0,K)}$resolveRenameLocation(T,q,G,J){return this.s(T,ke,K=>K.resolveRenameLocation(E.URI.revive(q),G,J),void 0,J)}registerDocumentSemanticTokensProvider(T,q,G,J){const K=this.t(new le(this.h,G),T),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(K,this.o(q,T),J,x);let ce=this.p(K);if(x){const Ne=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ce=M.$vK.from(ce,Ne)}return ce}$provideDocumentSemanticTokens(T,q,G,J){return this.s(T,le,K=>K.provideDocumentSemanticTokens(E.URI.revive(q),G,J),null,J)}$releaseDocumentSemanticTokens(T,q){this.s(T,le,G=>G.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,q,G,J){const K=this.t(new be(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(K,this.o(q,T),J),this.p(K)}$provideDocumentRangeSemanticTokens(T,q,G,J){return this.s(T,be,K=>K.provideDocumentRangeSemanticTokens(E.URI.revive(q),G,J),null,J)}registerCompletionItemProvider(T,q,G,J){const K=this.t(new ue(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(K,this.o(q,T),J,ue.supportsResolving(G),T.identifier),this.p(K)}$provideCompletionItems(T,q,G,J,K){return this.s(T,ue,x=>x.provideCompletionItems(E.URI.revive(q),G,J,K),void 0,K)}$resolveCompletionItem(T,q,G){return this.s(T,ue,J=>J.resolveCompletionItem(q,G),void 0,G)}$releaseCompletionItems(T,q){this.s(T,ue,G=>G.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(T,q,G,J){const K=new ye(T,this.h,G,this.j.converter),x=this.t(K,T);return this.e.$registerInlineCompletionsSupport(x,this.o(q,T),K.supportsHandleEvents,v.$6l.toKey(T.identifier.value),J?.yieldTo?.map(ce=>v.$6l.toKey(ce))||[]),this.p(x)}$provideInlineCompletions(T,q,G,J,K){return this.s(T,oe,x=>x.provideInlineCompletions(E.URI.revive(q),G,J,K),void 0,K)}$handleInlineCompletionDidShow(T,q,G,J){this.s(T,oe,async K=>{K.handleDidShowCompletionItem(q,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,q,G,J){this.s(T,oe,async K=>{K.handlePartialAccept(q,G,J)},void 0,void 0)}$freeInlineCompletionsList(T,q){this.s(T,oe,async G=>{G.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(T,q,G,J){const K=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new V(this.h,G),T);return this.e.$registerSignatureHelpProvider(x,this.o(q,T),K),this.p(x)}$provideSignatureHelp(T,q,G,J,K){return this.s(T,V,x=>x.provideSignatureHelp(E.URI.revive(q),G,J,K),void 0,K)}$releaseSignatureHelp(T,q){this.s(T,V,G=>G.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(T,q,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,K=this.t(new Y(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(K,this.o(q,T),typeof G.resolveInlayHint=="function",J,ge.u(T));let x=this.p(K);if(J!==void 0){const ce=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=M.$vK.from(x,ce)}return x}$provideInlayHints(T,q,G,J){return this.s(T,Y,K=>K.provideInlayHints(E.URI.revive(q),G,J),void 0,J)}$resolveInlayHint(T,q,G){return this.s(T,Y,J=>J.resolveInlayHint(q,G),void 0,G)}$releaseInlayHints(T,q){this.s(T,Y,G=>G.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(T,q,G){const J=this.t(new _(this.h,G),T);return this.e.$registerDocumentLinkProvider(J,this.o(q,T),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(T,q,G){return this.s(T,_,J=>J.provideLinks(E.URI.revive(q),G),void 0,G,q.scheme==="output")}$resolveDocumentLink(T,q,G){return this.s(T,_,J=>J.resolveLink(q,G),void 0,void 0,!0)}$releaseDocumentLinks(T,q){this.s(T,_,G=>G.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(T,q,G){const J=this.t(new pe(this.h,G),T);return this.e.$registerDocumentColorProvider(J,this.o(q,T)),this.p(J)}$provideDocumentColors(T,q,G){return this.s(T,pe,J=>J.provideColors(E.URI.revive(q),G),[],G)}$provideColorPresentations(T,q,G,J){return this.s(T,pe,K=>K.provideColorPresentations(E.URI.revive(q),G,J),void 0,J)}registerFoldingRangeProvider(T,q,G){const J=this.q(),K=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new $e(this.h,G),T)),this.e.$registerFoldingRangeProvider(J,this.o(q,T),T.identifier,K);let x=this.p(J);if(K!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(K));x=M.$vK.from(x,ce)}return x}$provideFoldingRanges(T,q,G,J){return this.s(T,$e,K=>K.provideFoldingRanges(E.URI.revive(q),G,J),void 0,J)}registerSelectionRangeProvider(T,q,G){const J=this.t(new de(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(J,this.o(q,T)),this.p(J)}$provideSelectionRanges(T,q,G,J){return this.s(T,de,K=>K.provideSelectionRanges(E.URI.revive(q),G,J),[],J)}registerCallHierarchyProvider(T,q,G){const J=this.t(new De(this.h,G),T);return this.e.$registerCallHierarchyProvider(J,this.o(q,T)),this.p(J)}$prepareCallHierarchy(T,q,G,J){return this.s(T,De,K=>Promise.resolve(K.prepareSession(E.URI.revive(q),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(T,q,G,J){return this.s(T,De,K=>K.provideCallsTo(q,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(T,q,G,J){return this.s(T,De,K=>K.provideCallsFrom(q,G,J),void 0,J)}$releaseCallHierarchy(T,q){this.s(T,De,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(T,q,G){const J=this.t(new re(this.h,G),T);return this.e.$registerTypeHierarchyProvider(J,this.o(q,T)),this.p(J)}$prepareTypeHierarchy(T,q,G,J){return this.s(T,re,K=>Promise.resolve(K.prepareSession(E.URI.revive(q),G,J)),void 0,J)}$provideTypeHierarchySupertypes(T,q,G,J){return this.s(T,re,K=>K.provideSupertypes(q,G,J),void 0,J)}$provideTypeHierarchySubtypes(T,q,G,J){return this.s(T,re,K=>K.provideSubtypes(q,G,J),void 0,J)}$releaseTypeHierarchy(T,q){this.s(T,re,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(T,q,G,J){const K=this.q();this.f.set(K,new ae(new he(this.e,this.h,G,K,T),T));const x=(0,n.$kF)(T,"dropMetadata")&&J?he.toInternalProviderId(T.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(K,this.o(q,T),x,(0,n.$kF)(T,"dropMetadata")?J:void 0),this.p(K)}$provideDocumentOnDropEdits(T,q,G,J,K,x){return this.s(T,he,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(q,E.URI.revive(G),J,K,x)),void 0,void 0)}registerMappedEditsProvider(T,q,G){const J=this.t(new ne(this.h,G),T);return this.e.$registerMappedEditsProvider(J,this.o(q,T)),this.p(J)}$provideMappedEdits(T,q,G,J,K){return this.s(T,ne,x=>Promise.resolve(x.provideMappedEdits(q,G,J,K)),null,K)}registerDocumentPasteEditProvider(T,q,G,J){const K=this.q();this.f.set(K,new ae(new F(this.e,this.h,G,K,T),T));const x=F.toInternalProviderId(T.identifier.value,J.id);return this.e.$registerPasteEditProvider(K,this.o(q,T),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(K)}$prepareDocumentPaste(T,q,G,J,K){return this.s(T,F,x=>x.prepareDocumentPaste(E.URI.revive(q),G,J,K),void 0,K)}$providePasteEdits(T,q,G,J,K,x){return this.s(T,F,ce=>ce.providePasteEdits(q,E.URI.revive(G),J,K,x),void 0,x)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:ge.w(T.decreaseIndentPattern),increaseIndentPattern:ge.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?ge.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?ge.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:ge.w(T.beforeText),afterText:T.afterText?ge.w(T.afterText):void 0,previousLineText:T.previousLineText?ge.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(ge.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(q=>M.SyntaxTokenType.toString(q)):void 0}}static D(T){return T.map(ge.C)}setLanguageConfiguration(T,q,G){const{wordPattern:J}=G;if(J&&(0,D.$Oe)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(q,J):this.h.setWordDefinitionFor(q,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const K=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ge.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ge.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ge.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?ge.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(K,q,x),this.p(K)}$setWordDefinitions(T){for(const q of T)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Qcc=ge}),define(Ae[254],Re([1,0,3,8,7,30,12,6,24]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class g{constructor(S,o,b,v){this.c=o,this.d=b,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$tK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,o){await this.a.$changeLanguage(S,o);const b=this.c.getDocumentData(S);if(!b)throw new Error(`document '${S.toString()}' NOT found`);return b.document}async tokenAtPosition(S,o){const b=S.version,v=L.Position.from(o),f=await this.a.$tokensAtPosition(S.uri,v),t={type:P.StandardTokenType.Other,range:S.getWordRangeAtPosition(o)??new P.$xK(o.line,o.character,o.line,o.character)};if(!f)return t;const i={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!i.range.contains(o)||b!==S.version?t:i}createLanguageStatusItem(S,o,b){const v=this.f++,f=this.a,t=this.g,i=`${S.identifier.value}/${o}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${o}' ALREADY exists`);t.add(i);const r={selector:b,id:o,name:S.displayName??S.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const a=new $.$Qc,l=()=>{if(u?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${o}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,R.$Vg)(()=>{a.clear(),this.a.$setLanguageStatus(v,{id:i,name:r.name??S.displayName??S.name,source:S.displayName??S.name,selector:L.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===P.LanguageStatusSeverity.Error?M.default.Error:r.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},n={dispose(){a.dispose(),u?.dispose(),f.$removeLanguageStatus(v),t.delete(i)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,l()},get selector(){return r.selector},set selector(s){r.selector=s,l()},get text(){return r.text},set text(s){r.text=s,l()},set text2(s){(0,D.$lF)(S,"languageStatusText"),r.text=s,l()},get text2(){return(0,D.$lF)(S,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,l()},get severity(){return r.severity},set severity(s){r.severity=s,l()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,l()},get command(){return r.command},set command(s){r.command=s,l()},get busy(){return r.busy},set busy(s){r.busy=s,l()}};return l(),n}}e.$ydc=g}),define(Ae[81],Re([1,0,23,13,2,4,15,3,27,17]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=e.$ndc=void 0;let A=class{constructor(o,b,v){this.f=v,this.d=new Map,this.a=b.getProxy($.$tK.MainThreadLocalization),this.b=o.environment.appLanguage,this.c=this.b===E.$g}getMessage(o,b){const{message:v,args:f,comment:t}=b;if(this.c)return(0,L.$De)(v,f??{});let i=v;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const r=this.d.get(o)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$De)(r??v,f??{})}getBundle(o){return this.d.get(o)?.contents}getBundleUri(o){return this.d.get(o)?.uri}async initializeLocalizedMessages(o){if(this.c||!o.l10n&&!o.isBuiltin||this.d.has(o.identifier.value))return;let b;const v=await this.g(o);if(!v){this.f.error(`No bundle location found for extension ${o.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(v),t=JSON.parse(f);b=o.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${o.identifier.value} from ${v}: ${f.message}`);return}b&&this.d.set(o.identifier.value,{contents:b,uri:v})}async g(o){if(o.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(o.identifier.value,this.b);return P.URI.revive(b)}return o.l10n?P.URI.joinPath(o.extensionLocation,o.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ndc=A,e.$ndc=A=Ke([Ve(0,D.$KM),Ve(1,g.$uM),Ve(2,R.$0i)],A),e.$odc=(0,M.$Ph)("IExtHostLocalizationService")}),define(Ae[255],Re([1,0,15,3,27,17,2,51]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;let D=class extends E.$ij{constructor(S,o){super(o.logLevel,o.logsLocation,o.loggers.map(b=>(0,$.$mh)(b))),this.r=S.getProxy(L.$tK.MainThreadLogger)}$setLogLevel(S,o){o?this.setLogLevel(R.URI.revive(o),S):this.setLogLevel(S)}setVisibility(S,o){super.setVisibility(S,o),this.r.$setVisibility(S,o)}s(S,o,b){return new g(this.r,S,o,b)}};e.$Qec=D,e.$Qec=D=Ke([Ve(0,M.$uM),Ve(1,P.$KM)],D);class g extends E.$dj{constructor(S,o,b,v){super(v?.logLevel==="always"),this.r=S,this.s=o,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(o,v).then(()=>{this.u(this.n),this.m=!0})}g(S,o){const b=[[S,o]];this.m?this.u(b):this.n.push(...b)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,22]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=void 0,e.$pdc=(0,L.$Ph)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$tK.MainThreadManagedSockets)}setFactory(S,o){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(S,o),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const o=++this.b,b=await this.c.makeConnection(),v=new P.$Qc;return this.d.set(o,new g(o,b,v)),v.add((0,P.$Pc)(()=>this.d.delete(o))),v.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(o),v.dispose()})),v.add(b.onDidClose(f=>{this.a.$onDidManagedSocketClose(o,f?.stack??f?.message),v.dispose()})),v.add(b.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(o,R.$be.wrap(f)))),o}$remoteSocketWrite(S,o){this.d.get(S)?.actual.send(o.buffer)}$remoteSocketEnd(S){const o=this.d.get(S);o&&(o.actual.end(),o.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$qdc=$,e.$qdc=$=Ke([Ve(0,M.$uM)],$);class D{constructor(S,o){this.socketFactoryId=S,this.makeConnection=o}}class g extends P.$Rc{constructor(S,o,b){super(),this.socketId=S,this.actual=o,this.B(b)}}}),define(Ae[256],Re([1,0,3,15,24]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;function M($){return $&&$.title}let R=class{constructor(D,g){this.b=g,this.a=D.getProxy(E.$tK.MainThreadMessageService)}showMessage(D,g,A,S,o){const b={source:{identifier:D.identifier,label:D.displayName||D.name}};let v;typeof S=="string"||M(S)?v=[S,...o]:(b.modal=S?.modal,b.useCustom=S?.useCustom,b.detail=S?.detail,v=o),b.useCustom&&(0,P.$lF)(D,"resolvers");const f=[];for(let t=0;t<v.length;t++){const i=v[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:u}=i;f.push({title:r,isCloseAffordance:!!u,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,A,b,f).then(t=>{if(typeof t=="number")return v[t]})}};e.$zdc=R,e.$zdc=R=Ke([Ve(1,L.$0i)],R)}),define(Ae[257],Re([1,0,18,12,19,5,6,28,2,21,15,3,32,8,7,77,209,24,48]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;let u=class{constructor(m,I,k,d,y){this.l=I,this.m=k,this.n=d,this.o=y,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(S.$tK.MainThreadNotebookKernels);const w=new o.$UM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new o.$SM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const j=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:j}}else if(C&&"notebookEditor"in C){const j=this.m.getIdByEditor(C.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return C})],o.$TM.Void);this.n.registerApiCommand(w)}createNotebookController(m,I,k,d,y,w){for(const be of this.i.values())if(be.controller.id===I&&g.$6l.equals(m.identifier,be.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.j++,j=this;this.o.trace(`NotebookController[${C}], CREATED by ${m.identifier.value}, ${I}`);const B=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${m.identifier}'`);let W=!1;const U=new M.$Nd,F=new M.$Nd,O={id:h(m.identifier,I),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:d||m.identifier.value,preloads:w?w.map(b.NotebookRendererScript.from):[]};let ee=y??B,X;this.a.$addKernel(C,O).catch(be=>{console.log(be),W=!0});let Ee=0;const ke=()=>{if(W)return;const be=++Ee;Promise.resolve().then(()=>{be===Ee&&this.a.$updateKernel(C,O)})},Pe=new $.$zc,le={get id(){return I},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return O.label},set label(be){O.label=be??m.displayName??m.name,ke()},get detail(){return O.detail??""},set detail(be){O.detail=be,ke()},get description(){return O.description??""},set description(be){O.description=be,ke()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(be){O.supportedLanguages=be,ke()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(be){O.supportsExecutionOrder=be,ke()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(be){ee=be??B},get interruptHandler(){return X},set interruptHandler(be){X=be,O.supportsInterrupt=!!be,ke()},createNotebookCellExecution(be){if(W)throw new Error("notebook controller is DISPOSED");if(!Pe.has(be.notebook.uri))throw j.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.notebook.uri.toString()}`);return j._createNotebookCellExecution(be,h(m.identifier,this.id))},createNotebookExecution(be){if((0,i.$lF)(m,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Pe.has(be.uri))throw j.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.uri.toString()}`);return j._createNotebookExecution(be,h(m.identifier,this.id))},dispose:()=>{W||(this.o.trace(`NotebookController[${C}], DISPOSED`),W=!0,this.i.delete(C),U.dispose(),F.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(be,ue){ue===v.NotebookControllerAffinity2.Hidden&&(0,i.$lF)(m,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(C,be.uri,ue)},onDidReceiveMessage:F.event,postMessage(be,ue){return(0,i.$lF)(m,"notebookMessaging"),j.a.$postMessage(C,ue&&j.m.getIdByEditor(ue),be)},asWebviewUri(be){return(0,i.$lF)(m,"notebookMessaging"),(0,f.$upb)(be,j.l.remote)}};return this.i.set(C,{extensionId:m.identifier,controller:le,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:Pe}),le}getIdByController(m){for(const[I,k]of this.i)if(k.controller===m)return h(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const k=this.f++,d=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,I);const y={dispose:()=>{this.e.delete(k),d.a.$removeKernelDetectionTask(k)}};return this.e.set(k,y),y}registerKernelSourceActionProvider(m,I,k){const d=this.h++,y=typeof k.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,w=this;this.g.set(d,k),this.o.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let C;return y!==void 0&&(C=k.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.g.delete(d),w.a.$removeKernelSourceActionProvider(d,d),C?.dispose()}}}async $provideKernelSourceActions(m,I){const k=this.g.get(m);if(k){const d=new R.$Qc;return(await k.provideNotebookKernelSourceActions(I)??[]).map(w=>b.NotebookKernelSourceAction.from(w,this.n.converter,d))}return[]}$acceptNotebookAssociation(m,I,k){const d=this.i.get(m);if(d){const y=this.m.getNotebookDocument(D.URI.revive(I));k?d.associatedNotebooks.set(y.uri,!0):d.associatedNotebooks.delete(y.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,y.uri.toString(),k),d.onDidChangeSelection.fire({selected:k,notebook:y.apiNotebook})}}async $executeCells(m,I,k){const d=this.i.get(m);if(!d)return;const y=this.m.getNotebookDocument(D.URI.revive(I)),w=[];for(const C of k){const j=y.getCell(C);j&&w.push(j.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,y.uri.toString(),w.length),await d.controller.executeHandler.call(d.controller,w,y.apiNotebook,d.controller)}catch(C){this.o.error(`NotebookController[${m}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(m,I,k){const d=this.i.get(m);if(!d)return;const y=this.m.getNotebookDocument(D.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,y.apiNotebook);else for(const w of k){const C=y.getCell(w);C&&this.b.get(C.uri)?.cancel()}if(d.controller.interruptHandler){const w=this.c.get(y.uri);k.length&&Array.isArray(w)&&w.length&&w.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(m,I,k){const d=this.i.get(m);if(!d)return;const y=this.m.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:k}))}$cellExecutionChanged(m,I,k){const y=this.m.getNotebookDocument(D.URI.revive(m)).getCell(I);if(y){const w=k?b.NotebookCellExecutionState.to(k):v.NotebookCellExecutionState.Idle;w!==void 0&&this.k.fire({cell:y.apiCell,state:w})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const y=new l(I,d,this.a);this.b.set(d.uri,y);const w=y.onDidChangeState(()=>{y.state===a.Resolved&&(y.dispose(),w.dispose(),this.b.delete(d.uri))});return y.asApiObject()}_createNotebookExecution(m,I){const k=this.m.getNotebookDocument(m.uri),d=m.getCells().find(C=>{const j=k.getCellFromApiCell(C);return j&&this.b.has(j.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const y=new s(I,k,this.a),w=y.onDidChangeState(()=>{y.state===n.Resolved&&(y.dispose(),w.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[y,w]),y.asApiObject()}};e.$vec=u,e.$vec=u=Ke([Ve(4,A.$0i)],u);var a;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(a||(a={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.m=I,this.n=k,this.b=l.a++,this.c=new M.$Nd,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new P.$Xd),this.h=new c(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new r.$tv(I))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const k=v.$WL.ensureUniqueMimeTypes(I.items,!0);return k===I.items?b.NotebookCellOutput.from(I):b.NotebookCellOutput.from({items:k,id:I.id,metadata:I.metadata})})}async z(m,I,k){const d=this.w(I),y=this.y((0,E.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:d,append:k,outputs:y})}async C(m,I,k){return m=v.$WL.ensureUniqueMimeTypes((0,E.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(b.NotebookCellOutputItem.from),outputId:I.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===a.Resolved||m.f===a.Started)throw new Error("Cannot call start again");m.f=a.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,d){if(m.f===a.Resolved)throw new Error("Cannot call resolve twice");m.f=a.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new r.$tv({runEndTime:d,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,d){return m.t(),m.z(k,d,!0)},replaceOutput(k,d){return m.t(),m.z(k,d,!1)},appendOutputItems(k,d){return m.t(),m.C(k,d,!0)},replaceOutputItems(k,d){return m.t(),m.C(k,d,!1)}})}}var n;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(n||(n={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.h=I,this.j=k,this.b=s.a++,this.c=new M.$Nd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$Xd),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(m,I){this.e=m,this.f=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$ch,this.b=Date.now(),(0,L.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>m.complete())}}function h(p,m){return`${p.value}/${m}`}e.$wec=h}),define(Ae[258],Re([1,0,5,3,107]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class M{constructor($,D){this.c=D,this.a=new Map,this.b=$.getProxy(L.$tK.MainThreadNotebookRenderers)}$postRendererMessage($,D,g){const A=this.c.getEditorById($);this.a.get(D)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging($,D){if(!$.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,S,o)=>this.d(D).event(A,S,o),postMessage:(A,S)=>{P.$gec.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const o=S&&P.$gec.apiEditorsToExtHost.get(S);return this.b.$postMessage(o?.id,D,A)}}}d($){let D=this.a.get($);return D||(D=new E.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete($)}}),this.a.set($,D),D)}}e.$xec=M}),define(Ae[259],Re([1,0,6,16,2,24,3]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class ${constructor(g){this.b=new Map,this.a=g.getProxy(R.$tK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,S){if((0,M.$lF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,g.identifier.value),(0,E.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,S,o){const b=this.b.get(g);if(!b)throw new Error(`Unknown handler with id: ${g}`);return b.saveProfile(A,S,o)}async $readProfile(g,A,S){const o=this.b.get(g);if(!o)throw new Error(`Unknown handler with id: ${g}`);return o.readProfile((0,L.$yf)(A)?A:P.URI.revive(A),S)}}e.$Bec=$}),define(Ae[260],Re([1,0,2,3,12,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class R{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(L.$tK.MainThreadQuickDiff)}$provideOriginalResource(D,g,A){const S=E.URI.revive(g),o=this.c.get(D);return o?(0,P.$Mg)(()=>o.provideOriginalResource(S,A)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,A,S){const o=R.a++;return this.c.set(o,g),this.b.$registerQuickDiffProvider(o,M.DocumentSelector.from(D,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(o),this.c.delete(o)}}}}e.$Cec=R}),define(Ae[261],Re([1,0,19,5,6,3,2,7,11,18,30,44,24,8]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;function v(f,t,i){const r=f.getProxy(M.$tK.MainThreadQuickOpen);class u{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,d,y=E.CancellationToken.None){this.c=void 0;const w=Promise.resolve(k),C=++this.f,j=r.$show(C,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},y),B={},W=j.then(()=>B);return Promise.race([W,w]).then(U=>{if(U===B)return;const F=(0,o.$kF)(I,"quickPickItemTooltip");return w.then(O=>{const ee=[];for(let X=0;X<O.length;X++){const Ee=O[X];if(typeof Ee=="string")ee.push({label:Ee,handle:X});else if(Ee.kind===$.QuickPickItemKind.Separator)ee.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!F&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=Ee.iconPath?c(Ee.iconPath):void 0;ee.push({label:Ee.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:F?b.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:X})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=X=>{d.onDidSelectItem(O[X])}),r.$setItems(C,ee),j.then(X=>{if(typeof X=="number")return O[X];if(Array.isArray(X))return X.map(Ee=>O[Ee])})})}).then(void 0,U=>{if(!(0,D.$3)(U))return r.$setError(C,U),Promise.reject(U)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=E.CancellationToken.None){return this.d=I?.validateInput,r.$input(I,typeof this.d=="function",k).then(void 0,d=>{if(!(0,D.$3)(d))return Promise.reject(d)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let d;switch(k.severity){case $.InputBoxValidationSeverity.Info:d=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:d}}async showWorkspaceFolderPick(I,k=E.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!d)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(w=>w.uri.toString()===d.uri.toString())}createQuickPick(I){const k=new h(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new p(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,d){const y=this.e.get(I);y instanceof h&&y._fireDidTriggerItemButton(k,d)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class a{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Nd,this.q=new L.$Nd,this.r=new L.$Nd,this.s=new L.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,d)=>{const y=k===$.$PL.Back?-1:d;this.o.set(y,k)}),this.z({buttons:I.map((k,d)=>({...c(k.iconPath),tooltip:k.tooltip,handle:k===$.$PL.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const d=I[k];this.u[k]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$pL)return{id:m.id};const I=s(m),k=n(m);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof k=="string"?R.URI.file(k):k}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function c(m){const I=l(m);let k,d;return"id"in I?d=S.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:d}}class h extends a{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Nd,this.L=[],this.M=new L.$Nd,this.N=new L.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((y,w)=>{this.C.set(w,y),this.D.set(y,w)});const k=(0,o.$kF)(this.O,"quickPickItemTooltip"),d=[];for(let y=0;y<I.length;y++){const w=I[y];if(w.kind===$.QuickPickItemKind.Separator)d.push({type:"separator",label:w.label});else{w.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=w.iconPath?c(w.iconPath):void 0;d.push({handle:y,label:w.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:k?b.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((j,B)=>({...c(j.iconPath),tooltip:j.tooltip,handle:B}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const d=this.C.get(I);if(!d||!d.buttons||!d.buttons.length)return;const y=d.buttons[k];y&&this.N.fire({button:y,item:d})}}class p extends a{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:A.default.Error}):this.z({validationMessage:I.message,severity:I.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new u(t,i)}e.$Ddc=v}),define(Ae[262],Re([1,0,2,5,66,6,12,3,18,137,15,21,44,8,24,14]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=void 0;function i(w){if(w)return typeof w.iconPath=="string"?E.URI.file(w.iconPath):E.URI.isUri(w.iconPath)||o.ThemeIcon.isThemeIcon(w.iconPath)?w.iconPath:void 0}function r(w){if(w?.icon){if(E.URI.isUri(w.icon))return w.icon;if(o.ThemeIcon.isThemeIcon(w.icon))return w.icon;{const C=w.icon;return{light:C.light,dark:C.dark}}}else return}function u(w){if(w.icon){if(E.URI.isUri(w.icon))return w.icon;if(o.ThemeIcon.isThemeIcon(w.icon))return w.icon;{const C=w.icon;return{light:C.light,dark:C.dark}}}else return}function a(w,C){if(!w.iconPath&&!C.iconPath)return 0;if(w.iconPath){if(!C.iconPath)return 1}else return-1;const j=typeof w.iconPath=="string"?w.iconPath:E.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id,B=typeof C.iconPath=="string"?C.iconPath:E.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$uq)(j,B)}function l(w,C){let j=0;if(w.strikeThrough!==C.strikeThrough)return w.strikeThrough?1:-1;if(w.faded!==C.faded)return w.faded?1:-1;if(w.tooltip!==C.tooltip)return(w.tooltip||"").localeCompare(C.tooltip||"");if(j=a(w,C),j!==0)return j;if(w.light&&C.light)j=a(w.light,C.light);else{if(w.light)return 1;if(C.light)return-1}if(j!==0)return j;if(w.dark&&C.dark)j=a(w.dark,C.dark);else{if(w.dark)return 1;if(C.dark)return-1}return j}function n(w,C){if(w.command!==C.command)return w.command<C.command?-1:1;if(w.title!==C.title)return w.title<C.title?-1:1;if(w.tooltip!==C.tooltip){if(w.tooltip!==void 0&&C.tooltip!==void 0)return w.tooltip<C.tooltip?-1:1;if(w.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(w.arguments===C.arguments)return 0;if(w.arguments)if(C.arguments){if(w.arguments.length!==C.arguments.length)return w.arguments.length-C.arguments.length}else return 1;else return-1;for(let j=0;j<w.arguments.length;j++){const B=w.arguments[j],W=C.arguments[j];if(B!==W)return B<W?-1:1}return 0}function s(w,C){let j=(0,g.$uq)(w.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(j!==0)return j;if(w.command&&C.command)j=n(w.command,C.command);else{if(w.command)return 1;if(C.command)return-1}if(j!==0)return j;if(w.decorations&&C.decorations)j=l(w.decorations,C.decorations);else{if(w.decorations)return 1;if(C.decorations)return-1}return j}function c(w,C){for(let j=0;j<w.length;j++)if(w[j]!==C[j])return!1;return!0}function h(w,C){return w.command===C.command&&w.title===C.title&&w.tooltip===C.tooltip&&(w.arguments&&C.arguments?c(w.arguments,C.arguments):w.arguments===C.arguments)}function p(w,C){return(0,D.$tb)(w,C,h)}function m(w,C){return w===C?!0:!w||!C?!1:w.id===C.id&&w.label===C.label&&w.upstream?.id===C.upstream?.id&&w.upstream?.label===C.upstream?.label}class I{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,v.$lF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,v.$lF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,v.$lF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,v.$lF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const j=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:r(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,j??null)}get document(){return(0,v.$lF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,j,B,W,U,F){this.m=C,this.n=j,this.o=U,this.p=F,this.d="",this.e=new L.$Nd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=B,this.#e=W}showValidationMessage(C,j){(0,v.$lF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,j)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$Edc=I;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,j,B,W,U){this.q=C,this.s=j,this.t=B,this.u=W,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,j){const B=this.h.get(C);return B?(0,R.$Mg)(()=>this.s.executeCommand(B.command,...B.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(s),B=(0,D.$Cb)(this.o,C,s).map(F=>{const O=F.toInsert.map(ee=>{const X=this.e++;this.g.set(X,ee);const Ee=ee.resourceUri;let ke;if(ee.command)if(ee.command.command==="vscode.open"||ee.command.command==="vscode.diff"){const _=new M.$Qc;ke=this.s.converter.toInternal(ee.command,_),this.j.set(X,_)}else this.h.set(X,ee.command);const Pe=i(ee.decorations),le=ee.decorations&&i(ee.decorations.light)||Pe,be=ee.decorations&&i(ee.decorations.dark)||Pe,ue=[le,be],oe=ee.decorations&&ee.decorations.tooltip||"",ye=ee.decorations&&!!ee.decorations.strikeThrough,te=ee.decorations&&!!ee.decorations.faded,V=ee.contextValue||"";return{rawResource:[X,Ee,ue,oe,ye,te,V,ke],handle:X}});return{start:F.start,deleteCount:F.deleteCount,toInsert:O}}),W=B.map(({start:F,deleteCount:O,toInsert:ee})=>[F,O,ee.map(X=>X.rawResource)]),U=B.reverse();for(const{start:F,deleteCount:O,toInsert:ee}of U){const X=ee.map(ke=>ke.handle),Ee=this.n.splice(F,O,...X);for(const ke of Ee)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=C,W}dispose(){this.l=!0,this.m.fire()}}class d{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let j;(0,v.$kF)(this.y,"quickDiffProvider")&&(j=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:j})}get historyProvider(){return(0,v.$lF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,v.$lF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,v.$lF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const j=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,j??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const j=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,v.$lF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,v.$lF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const j=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(B=>B.map(W=>this.z.converter.toInternal(W,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&p(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const j=(C||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(C,j,B,W,U,F,O){this.y=C,this.z=W,this.A=U,this.B=F,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new L.$Nd,this.onDidChangeSelection=this.w.event,this.x=d.d++,this.D=new Map,this.E=new Set,this.#e=B;const ee=E.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new I(C,W,j,this.#e,this.x,ee),this.#e.$registerSourceControl(this.x,U,F,O,ee)}createResourceGroup(C,j){const B=new k(this.#e,this.z,this.x,C,j),W=L.Event.once(B.onDidDispose)(()=>this.D.delete(B));return this.D.set(B,W),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const C=[],j=[];for(const[B,W]of this.D){W.dispose();const U=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});L.Event.once(B.onDidDispose)(()=>{this.E.delete(B),U.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),C.push([B.handle,B.id,B.label,B.features]);const F=B._takeResourceStateSnapshot();F.length>0&&j.push([B.handle,F]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,C,j),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(j=>{const B=j._takeResourceStateSnapshot();B.length!==0&&C.push([j.handle,B])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$ih)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$ih)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,j,B,W){this.l=j,this.m=B,this.n=W,this.g=new Map,this.h=new S.$8l,this.j=new L.$Nd,this.e=C.getProxy($.$tK.MainThreadSCM),this.f=C.getProxy($.$tK.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const F=this.g.get(U.sourceControlHandle);if(!F)return U;const O=F.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const F=this.g.get(U.sourceControlHandle);return F?F.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const F=this.g.get(U.handle);return F||U}return U}})}createSourceControl(C,j,B,W){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,j,B,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const U=t.d++,F=new d(C,this.m,this.e,this.l,j,B,W);this.g.set(U,F);const O=this.h.get(C.identifier)||[];return O.push(F),this.h.set(C.identifier,O),F}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const j=this.h.get(C.identifier),B=j&&j[j.length-1];return B&&B.inputBox}$provideOriginalResource(C,j,B){const W=E.URI.revive(j);this.n.trace("ExtHostSCM#$provideOriginalResource",C,W.toString());const U=this.g.get(C);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Mg)(()=>U.quickDiffProvider.provideOriginalResource(W,B)).then(F=>F||null)}$onInputBoxValueChange(C,j){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const B=this.g.get(C);return B&&B.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(C,j,B,W){this.n.trace("ExtHostSCM#$executeResourceCommand",C,j,B);const U=this.g.get(C);if(!U)return Promise.resolve(void 0);const F=U.getResourceGroup(j);return F?F.$executeResourceCommand(B,W):Promise.resolve(void 0)}$validateInput(C,j,B){this.n.trace("ExtHostSCM#$validateInput",C);const W=this.g.get(C);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Mg)(()=>W.inputBox.validateInput(j,B)).then(U=>{if(!U)return Promise.resolve(void 0);const F=b.MarkdownString.fromStrict(U.message);return F?Promise.resolve([F,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,j,B){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(j,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,j,B,W){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,B,W)??void 0}async $provideHistoryItems(C,j,B,W){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(j,B,W))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:u(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(C,j,B){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(j,B)??void 0}};e.$Fdc=y,e.$Fdc=y=t=Ke([Ve(3,A.$0i)],y)}),define(Ae[83],Re([1,0,3,5,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0;class M{constructor($){this.b=new L.$Nd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$tK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,D){return this.a.$getPassword($,D)}store($,D,g){return this.a.$setPassword($,D,g)}delete($,D){return this.a.$deletePassword($,D)}}e.$kdc=M,e.$ldc=(0,P.$Ph)("IExtHostSecretState")}),define(Ae[263],Re([1,0,3,8,2]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class M{static{this.a=0}constructor($,D){this.d=D,this.c=new Map,this.b=$.getProxy(E.$tK.MainThreadShare)}async $provideShare($,D,g){return await this.c.get($)?.provideShare({selection:L.Range.to(D.selection),resourceUri:P.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider($,D){const g=M.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,L.DocumentSelector.from($,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Hec=M}),define(Ae[264],Re([1,0,19,6,3]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$tK.MainThreadSpeech)}async $createSpeechToTextSession($,D){const g=this.c.get($);if(!g)return;const A=new L.$Qc,S=new E.$Xd;this.d.set(D,S);const o=A.add(g.provideSpeechToTextSession(S.token));A.add(o.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,b)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,D,g){const A=M.a++;return this.c.set(A,g),this.b.$registerProvider(A,D,{extension:$,displayName:$.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Jec=M}),define(Ae[265],Re([1,0,7,3,164,6,8,16]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$qL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$qL("statusBarItem.warningForeground")]])}#e;#t;constructor(o,b,v,f,t,i=E.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=o,this.#t=b,t&&f){this.c=(0,E.$6K)(f.identifier,t);const u=v.get(this.c);u&&(i=u.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,r=u.priority,this.j=!0,this.name=u.name,this.text=u.text,this.tooltip=u.tooltip,this.command=u.command,this.accessibilityInformation=u.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(r)}u(o){if((0,$.$Cf)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(o){this.k=o,this.v()}set name(o){this.m=o,this.v()}set tooltip(o){this.l=o,this.v()}set color(o){this.n=o,this.v()}set backgroundColor(o){o&&!D.b.has(o.id)&&(o=void 0),this.o=o,this.v()}set command(o){this.r?.fromApi!==o&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof o=="string"?this.r={fromApi:o,internal:this.#t.toInternal({title:"",command:o},this.p)}:o?this.r={fromApi:o,internal:this.#t.toInternal(o,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(o){this.t=o,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let o;this.e?this.f?o=`${this.e.identifier.value}.${this.f}`:o=this.e.identifier.value:o=this.f;let b;this.m?b=this.m:b=(0,P.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=D.b.get(this.o.id));const f=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,o,this.e?.identifier.value,b,this.k,f,this.r?.internal,v,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Gdc=D;class g{constructor(o){this.b=[],this.a=o.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(o){const b={message:o};return this.b.unshift(b),this.c(),new E.$vK(()=>{const v=this.b.indexOf(b);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(o,b){this.e=new Map,this.a=o.getProxy(L.$tK.MainThreadStatusBar),this.b=b,this.c=new g(this)}$acceptStaticEntries(o){for(const b of o)this.e.set(b.entryId,b)}createStatusBarEntry(o,b,v,f){return new D(this.a,this.b,this.e,o,b,v,f)}setStatusBarMessage(o,b){const v=this.c.setMessage(o);let f;return typeof b=="number"?f=setTimeout(()=>v.dispose(),b):typeof b<"u"&&b.then(()=>v.dispose(),()=>v.dispose()),new E.$vK(()=>{v.dispose(),clearTimeout(f)})}}e.$Hdc=A}),define(Ae[84],Re([1,0,3,5,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0;class M{constructor($,D){this.c=D,this.b=new L.$Nd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$tK.MainThreadStorage)}registerExtensionStorageKeysToSync($,D){this.a.$registerExtensionStorageKeysToSync($,D)}async initializeExtensionStorage($,D,g){const A=await this.a.$initializeExtensionStorage($,D);let S;return A&&(S=this.d($,D,A)),S||g}setValue($,D,g){return this.a.$setValue($,D,g)}$acceptValue($,D,g){const A=this.d($,D,g);A&&this.b.fire({shared:$,key:D,value:A})}d($,D,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${$}): ${A}`)}}}e.$$cc=M,e.$_cc=(0,P.$Ph)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,15,63,2]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,E.$Ph)("IExtensionStoragePaths");let $=class{constructor(g,A,S){this.d=A,this.f=S,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(o=>this.c=o)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$fdc=$,e.$fdc=$=Ke([Ve(0,L.$KM),Ve(1,P.$0i),Ve(2,M.$ddc)],$)}),define(Ae[64],Re([1,0,5,3,4,2,17,6,7,166,11,192,19,37,193,44,12,8,32]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=e.$hdc=e.$gdc=void 0,e.$gdc=(0,P.$Ph)("IExtHostTerminalService");class u{constructor(d,y,w,C){this.l=d,this._id=y,this.m=w,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(B=>this.f=B);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(B,W=!0){j.q(),j.l.$sendText(j._id,B,W)},show(B){j.q(),j.l.$show(j._id,B)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(d,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??void 0,env:d.env??void 0,icon:p(d.iconPath)??void 0,color:f.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(d.location,y?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,y,w,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:w,color:f.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(d,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,y){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in d?{viewColumn:i.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,y){this.h=Object.freeze({code:d,reason:y})}setDimensions(d,y){return d===this.d&&y===this.g||d===0||y===0?!1:(this.d=d,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(y=>{y!==d&&(this.b=Promise.resolve(d))})}}e.$hdc=u;class a{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new E.$Nd,this.onProcessData=this.a.event,this.b=new E.$Nd,this.d=new E.$Nd,this.onDidChangeProperty=this.d.event,this.f=new E.$Nd,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,y){this.g.setDimensions?.({columns:d,rows:y})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,n=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,y,w){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Nd,this.onDidChangeShell=this.N.event,this.O=new E.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(L.$tK.MainThreadTerminalService),this.y=new v.$elb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:C=>{const j=B=>{const W=B;return this.W(W.instanceId)?.value};switch(C?.$mid){case 15:return j(C);default:{if(Array.isArray(C))for(let B=0;B<C.length&&C[B].$mid===15;B++)C[B]=j(C[B]);return C}}}}),this.B({dispose:()=>{for(const[C,j]of this.g)j.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,y){const w=new u(this.a,(0,b.$eg)(),d,d.name),C=new a(d.pty);return w.createExtensionTerminal(d.location,this.R(d,y).resolvedExtHostIdentifier,p(d.iconPath),m(d.color)).then(j=>{const B=this.S(j,C);this.h[j]=B}),this.f.push(w),w.value}R(d,y){if(y=y||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const w=d.location.parentTerminal;if(w){const C=this.f.find(j=>j.value===w);C&&(y.resolvedExtHostIdentifier=C._id)}}else d.location&&typeof d.location!="object"?y.location=d.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(d,y){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const C=new a(y),j=this.S(d,C);this.h[d]=j}async $acceptActiveTerminalChanged(d){const y=this.b;if(d===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const w=this.W(d);w&&(this.b=w,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,y){const w=this.W(d);w&&this.O.fire({terminal:w.value,data:y})}async $acceptTerminalDimensions(d,y,w){const C=this.W(d);C&&C.setDimensions(y,w)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(d,y){const w=this.W(d);w&&this.P.fire({terminal:w.value,...y})}async $acceptTerminalMaximumDimensions(d,y,w){this.g.get(d)?.resize(y,w)}async $acceptTerminalTitleChange(d,y){const w=this.W(d);w&&(w.name=y)}async $acceptTerminalClosed(d,y,w){const C=this.Y(this.f,d);if(C!==null){const j=this.f.splice(C,1)[0];j.setExitStatus(y,w),this.H.fire(j.value)}}$acceptTerminalOpened(d,y,w,C){if(y){const W=this.Y(this.f,y);if(W!==null){this.f[W]._id=d,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const j={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},B=new u(this.a,d,j,w);this.f.push(B),this.I.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(d,y){this.W(d)?._setProcessId(y)}async $startExtensionTerminal(d,y){const w=this.W(d);if(!w)return{message:(0,g.localize)(0,null,d)};w.isOpen||await new Promise(j=>{const B=this.onDidOpenTerminal(async W=>{W===w.value&&(B.dispose(),j())})});const C=this.g.get(d);C?C.startSendingEvents(y):this.j[d]={initialDimensions:y}}S(d,y){const w=new $.$Qc;w.add(y.onProcessReady(j=>this.a.$sendProcessReady(d,j.pid,j.cwd,j.windowsPty))),w.add(y.onDidChangeProperty(j=>this.a.$sendProcessProperty(d,j))),this.y.startBuffering(d,y.onProcessData),w.add(y.onProcessExit(j=>this.U(d,j))),this.g.set(d,y);const C=this.j[d];return C&&y instanceof a&&(y.startSendingEvents(C.initialDimensions),delete this.j[d]),w}$acceptProcessAckDataEvent(d,y){this.g.get(d)?.acknowledgeDataEvent(y)}$acceptProcessInput(d,y){this.g.get(d)?.input(y)}$acceptTerminalInteraction(d){const y=this.W(d);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(d,y){this.W(d)?.setSelection(y)}$acceptProcessResize(d,y,w){try{this.g.get(d)?.resize(y,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(d,y){this.g.get(d)?.shutdown(y)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(y=>this.a.$sendProcessProperty(d,{type:"cwd",value:y}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new D.$vK(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,y,w){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,w),this.a.$registerProfileProvider(y,d.identifier.value),new D.$vK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(d,y,w){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,w),this.a.$registerQuickFixProvider(d,y),new D.$vK(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,y){const w=new o.$Xd().token;if(w.isCancellationRequested)return;const C=this.D.get(d);if(!C)return;const j=await C.provideTerminalQuickFixes(y,w);if(j===null||Array.isArray(j)&&j.length===0)return;const B=new $.$Qc;if(this.w.value=B,!Array.isArray(j))return j?i.TerminalQuickFix.from(j,this.Q.converter,B):void 0;const W=[];for(const U of j){const F=i.TerminalQuickFix.from(U,this.Q.converter,B);F&&W.push(F)}return W}async $createContributedProfileTerminal(d,y){const w=new o.$Xd().token;let C=await this.C.get(d)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,y);return}this.createTerminalFromOptions(C.options,y)}}async $provideLinks(d,y){const w=this.W(d);if(!w)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const j=new o.$Xd;this.G.set(d,j);const B=[],W={terminal:w.value,line:y},U=[];for(const ee of this.z)U.push(t.Promises.withAsyncBody(async X=>{j.token.onCancellationRequested(()=>X({provider:ee,links:[]}));const Ee=await ee.provideTerminalLinks(W,j.token)||[];j.token.isCancellationRequested||X({provider:ee,links:Ee})}));const F=await Promise.all(U);if(j.token.isCancellationRequested)return[];const O=new Map;for(const ee of F)ee&&ee.links.length>0&&B.push(...ee.links.map(X=>{const Ee={id:l++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return O.set(Ee.id,{provider:ee.provider,link:X}),Ee}));return this.F.set(d,O),B}$activateLink(d,y){const w=this.F.get(d)?.get(y);w&&w.provider.handleTerminalLink(w.link)}U(d,y){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const w=this.h[d];w&&(w.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,y)}W(d){return this.X(this.f,d)}X(d,y){const w=this.Y(d,y);return w!==null?d[w]:null}Y(d,y){const w=d.findIndex(C=>C._id===y);return w===-1?null:w}getEnvironmentVariableCollection(d){let y=this.n.get(d.identifier.value);return y||(y=new s,this.$(d.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(d,y){const w=(0,S.$nr)(y.map),C=(0,S.$or)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(d,y.persistent,w.length===0?void 0:w,C)}$initEnvironmentVariableCollections(d){d.forEach(y=>{const w=y[0],C=new s(y[1]);this.$(w,C)})}$acceptDefaultProfile(d,y){const w=this.s;this.s=d,this.u=y,w?.path!==d.path&&this.N.fire(d.path)}$(d,y){this.n.set(d,y),y.onDidChangeCollection(()=>{this.Z(d,y)})}};e.$idc=n,e.$idc=n=Ke([Ve(1,r.$QM),Ve(2,R.$uM)],n);class s{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Nd,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const y=this.h(d);let w=this.a.get(y);return w||(w=new c(this,d),this.a.set(y,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(d,y,w,C){this.f(d,{value:y,type:D.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:C})}append(d,y,w,C){this.f(d,{value:y,type:D.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:C})}prepend(d,y,w,C){this.f(d,{value:y,type:D.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:C})}f(d,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(d,y.scope),C=this.map.get(w),j=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==y.value||C.type!==y.type||C.options?.applyAtProcessCreation!==j.applyAtProcessCreation||C.options?.applyAtShellIntegration!==j.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const B=this.g(d,y.scope),W={variable:d,...y,options:j};this.map.set(B,W),this.d.fire()}}get(d,y){const w=this.g(d,y),C=this.map.get(w);return C?I(C):void 0}g(d,y){const w=this.h(y);return w.length?`${d}:::${w}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const y=new Map;for(const[w,C]of this.map)this.h(C.scope)===this.h(d)&&y.set(C.variable,I(C));return y}delete(d,y){const w=this.g(d,y);this.map.delete(w),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[y,w]of this.map)w.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(y);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,y){const w=this.h(y),C=this.descriptionMap.get(w);if(!C||C.description!==d){let j;typeof d=="string"?j=d:j=d?.value.split(`

`)[0];const B={description:j,scope:y};this.descriptionMap.set(w,B),this.d.fire()}}getDescription(d){const y=this.h(d);return this.descriptionMap.get(y)?.description}k(d){const y=this.h(d);this.descriptionMap.delete(y)}}class c{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,y){this.b=d,this.d=y,this.a=new E.$Nd}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,y,w){this.b.replace(d,y,w,this.d)}append(d,y,w){this.b.append(d,y,w,this.d)}prepend(d,y,w){this.b.prepend(d,y,w,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,y){this.b.getVariableMap(this.d).forEach((w,C)=>d.call(y,C,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends n{constructor(d,y){super(!1,d,y)}createTerminal(d,y,w){throw new A.$$}createTerminalFromOptions(d,y){throw new A.$$}};e.$jdc=h,e.$jdc=h=Ke([Ve(0,r.$QM),Ve(1,R.$uM)],h);function p(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return f.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const d={...k};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Ae[266],Re([1,0,296,12,22,19,5,217,96,6,26,16,37,3,17,108,8,7,47,76,59]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=e.$rec=e.$qec=void 0;let l=class{constructor(B,W,U){this.j=U,this.c=new R.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=B.getProxy(b.$tK.MainThreadTesting),this.h=new y(this.f),this.g=new h(this.f),W.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const O=F,ee=O.tests[O.tests.length-1].item.extId;return this.d.get(r.$jJ.root(ee))?.collection.tree.get(ee)?.actual??(0,f.$GM)(F)}case 18:{const{extId:O,message:ee}=F;return{test:this.d.get(r.$jJ.root(O))?.collection.tree.get(O)?.actual,message:t.TestMessage.to(ee)}}default:return F}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await W.executeCommand("_testing.getExplorerSelection"),O=ee=>{const X=this.d.get(r.$jJ.root(ee));if(X)return r.$jJ.isRoot(ee)?X.controller:X.collection.tree.get(ee)?.actual};return{include:F?.include.map(O).filter(S.$Gf)||[],exclude:F?.exclude.map(O).filter(S.$Gf)||[]}})}createTestController(B,W,U,F){if(this.d.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const O=new g.$Qc,ee=O.add(new f.$JM(W,U,this.j));ee.root.label=U;const X=new Map,Ee=this.f,ke={items:ee.root.children,get label(){return U},set label(le){U=le,ee.root.label=le,Ee.$updateController(W,{label:U})},get refreshHandler(){return F},set refreshHandler(le){F=le,Ee.$updateController(W,{canRefresh:!!le})},get id(){return W},createRunProfile:(le,be,ue,oe,ye,te)=>{let V=(0,D.$Di)(le);for(;X.has(V);)V++;return new w(this.f,X,W,V,le,be,ue,oe,ye,te)},createTestItem(le,be,ue){return new f.$HM(W,le,be,ue)},createTestRun:(le,be,ue=!0)=>this.g.createTestRun(B,W,ee,le,be,ue),invalidateTestResults:le=>{if(le===void 0)this.f.$markTestRetired(void 0);else{const be=le instanceof Array?le:[le];this.f.$markTestRetired(be.map(ue=>r.$jJ.fromExtHostTestItem(ue,W).toString()))}},set resolveHandler(le){ee.resolveHandler=le},get resolveHandler(){return ee.resolveHandler},dispose:()=>{O.dispose()}};Ee.$registerTestController(W,U,!!F),O.add((0,g.$Pc)(()=>Ee.$unregisterTestController(W)));const Pe={controller:ke,collection:ee,profiles:X,extension:B};return this.d.set(W,Pe),O.add((0,g.$Pc)(()=>this.d.delete(W))),O.add(ee.onDidGenerateDiff(le=>Ee.$publishDiff(W,le.map(a.TestsDiffOp.serialize)))),ke}createTestObserver(){return this.h.checkout()}async runTests(B,W=M.CancellationToken.None){const U=p(B);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.d.get(U.controllerId);if(!F)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(O=>r.$jJ.fromExtHostTestItem(O,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:C[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:B.exclude?.map(O=>O.id)},W)}$syncTests(){for(const{collection:B}of this.d.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,W,U){return(0,E.$qb)(this.g.trackers,O=>O.id===B?O.getCoverage(W):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(B,W,U,F){return(0,E.$qb)(this.g.trackers,ee=>ee.id===B?ee.getCoverage(W):void 0)?.resolveFileCoverage(U,F)??Promise.resolve([])}$configureRunProfile(B,W){this.d.get(B)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(B,W){await this.d.get(B)?.controller.refreshHandler?.(W)}$publishTestResults(B){this.results=Object.freeze(B.map(W=>(0,A.$8m)(t.TestResults.to(W))).concat(this.results).sort((W,U)=>U.completedAt-W.completedAt).slice(0,32)),this.c.fire()}async $expandTest(B,W){const U=this.d.get(r.$jJ.fromString(B).controllerId)?.collection;U&&(await U.expand(B,W<0?1/0:W),U.flushDiff())}$acceptDiff(B){this.h.applyDiff(B.map(a.TestsDiffOp.deserialize))}async $runControllerTests(B,W){return Promise.all(B.map(U=>this.k(U,!1,W)))}async $startContinuousRun(B,W){const U=new M.$Xd(W),F=await Promise.all(B.map(O=>this.k(O,!0,U.token)));return!W.isCancellationRequested&&!F.some(O=>O.error)&&await new Promise(O=>W.onCancellationRequested(O)),U.dispose(!0),F}async k(B,W,U){const F=this.d.get(B.controllerId);if(!F)return{};const{collection:O,profiles:ee,extension:X}=F,Ee=ee.get(B.profileId);if(!Ee)return{};const ke=B.testIds.map(ue=>O.tree.get(ue)).filter(S.$Gf),Pe=B.excludeExtIds.map(ue=>F.collection.tree.get(ue)).filter(S.$Gf).filter(ue=>ke.some(oe=>oe.fullId.compare(ue.fullId)===2));if(!ke.length)return{};const le=new i.$4L(ke.some(ue=>ue.actual instanceof f.$IM)?void 0:ke.map(ue=>ue.actual),Pe.map(ue=>ue.actual),Ee,W),be=(0,a.$lJ)(B)&&this.g.prepareForMainThreadTestRun(le,m.fromInternal(B,F.collection),X,U);try{return await Ee.runHandler(le,U),{}}catch(ue){return{error:String(ue)}}finally{be&&(be.hasRunningTasks&&!U.isCancellationRequested&&await R.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.g.cancelAllRuns():this.g.cancelRunById(B)}};e.$qec=l,e.$qec=l=Ke([Ve(0,v.$uM)],l);const n=1e4;var s;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(s||(s={}));class c extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(B,W,U){super(),this.m=B,this.s=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Nd),this.onEnd=this.j.event,this.h=this.B(new M.$Xd(U));const F=this.B(new L.$6g(()=>this.u(),n));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(B){return this.f.get(B)?.coverage}createRun(B){const W=this.m.id,U=this.m.controllerId,F=(0,o.$eg)(),O=new I(this.s,W,F),ee=Pe=>(le,...be)=>{if(Ee){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.m.isIncluded(le)&&(this.y(le),Pe(le,...be))},X=(Pe,le)=>{const be=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Pe.uri&&Pe.range){const ue={range:t.Range.from(Pe.range),uri:Pe.uri};for(const oe of be)oe.location=oe.location||ue}this.s.$appendTestMessagesInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,U).toString(),be)};let Ee=!1;const ke={isPersisted:this.m.isPersisted,token:this.h.token,name:B,get coverageProvider(){return O.coverageProvider},set coverageProvider(Pe){O.coverageProvider=Pe},enqueued:ee(Pe=>{this.s.$updateTestStateInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,U).toString(),1)}),skipped:ee(Pe=>{this.s.$updateTestStateInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,U).toString(),5)}),started:ee(Pe=>{this.s.$updateTestStateInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,U).toString(),2)}),errored:ee((Pe,le,be)=>{X(Pe,le),this.s.$updateTestStateInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,U).toString(),6,be)}),failed:ee((Pe,le,be)=>{X(Pe,le),this.s.$updateTestStateInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,U).toString(),4,be)}),passed:ee((Pe,le)=>{this.s.$updateTestStateInRun(W,F,r.$jJ.fromExtHostTestItem(Pe,this.m.controllerId).toString(),3,le)}),appendOutput:(Pe,le,be)=>{Ee||(be&&(this.m.isIncluded(be)?this.y(be):be=void 0),this.s.$appendOutputToRun(W,F,P.$be.fromString(Pe),le&&t.location.from(le),be&&r.$jJ.fromExtHostTestItem(be,U).toString()))},end:()=>{Ee||(Ee=!0,this.s.$finishedTestRunTask(W,F),this.f.delete(F),this.f.size||this.w())}};return this.f.set(F,{run:ke,coverage:O}),this.s.$startedTestRunTask(W,{id:F,name:B,running:!0}),ke}u(){for(const{run:B}of this.f.values())B.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(B){if(!(B instanceof f.$HM))throw new u.$mM(B.id);if(this.g.has(r.$jJ.fromExtHostTestItem(B,this.m.controllerId).toString()))return;const W=[],U=this.m.colllection.root;for(;;){const F=t.TestItem.from(B);if(W.unshift(F),this.g.has(F.extId)||(this.g.add(F.extId),B===U))break;B=B.parent||U}this.s.$addTestsToRun(this.m.controllerId,this.m.id,W)}dispose(){this.w(),super.dispose()}}class h{get trackers(){return this.c.values()}constructor(B){this.d=B,this.c=new Map}prepareForMainThreadTestRun(B,W,U,F){return this.f(B,W,U,F)}cancelRunById(B){for(const W of this.c.values())if(W.id===B){W.cancel();return}}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,W,U,F,O,ee){const X=this.c.get(F);if(X)return X.createRun(O);const Ee=m.fromPublic(W,U,F,ee),ke=p(F);this.d.$startedExtensionTestRun({controllerId:W,continuous:!!F.continuous,profile:ke&&{group:C[ke.kind],id:ke.profileId},exclude:F.exclude?.map(le=>r.$jJ.fromExtHostTestItem(le,U.root.id).toString())??[],id:Ee.id,include:F.include?.map(le=>r.$jJ.fromExtHostTestItem(le,U.root.id).toString())??[U.root.id],persist:ee});const Pe=this.f(F,Ee,B);return R.Event.once(Pe.onEnd)(()=>{this.d.$finishedExtensionTestRun(Ee.id),Pe.dispose()}),Pe.createRun(O)}f(B,W,U,F){const O=new c(W,this.d,F);return this.c.set(B,O),R.Event.once(O.onEnd)(()=>this.c.delete(B)),O}}e.$rec=h;const p=j=>{if(j.profile){if(!(j.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class m{static fromPublic(B,W,U,F){return new m(B,(0,o.$eg)(),U.include?.map(O=>r.$jJ.fromExtHostTestItem(O,B).toString())??[B],U.exclude?.map(O=>r.$jJ.fromExtHostTestItem(O,B).toString())??[],F,W)}static fromInternal(B,W){return new m(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,W)}constructor(B,W,U,F,O,ee){this.controllerId=B,this.id=W,this.isPersisted=O,this.colllection=ee,this.c=U.map(X=>X+"\0"),this.d=F.map(X=>X+"\0")}isIncluded(B){const W=r.$jJ.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const U of this.d)if(W===U||W.startsWith(U))return!1;for(const U of this.c)if(W===U||W.startsWith(U))return!0;return!1}}e.$sec=m;class I{set coverageProvider(B){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this.c=B,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(B,W,U){this.f=B,this.g=W,this.h=U}async provideFileCoverage(B){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(B))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.d=void 0,W}}async resolveFileCoverage(B,W){const U=await this.d;let F=U?.[B];return!this.c||!U||!F?[]:(F.detailedCoverage||(F=U[B]=await this.c.resolveFileCoverage?.(F,W)??F),F.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class k{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(B){this.h=B,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.c.has(B)||this.d.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.d.delete(B);const W=r.$jJ.parentId(B.item.extId);if(W&&this.g.has(W.toString())){this.g.add(B.item.extId);return}this.f.add(B)}getChangeEvent(){const{c:B,d:W,f:U}=this;return{get added(){return[...B].map(F=>F.revived)},get updated(){return[...W].map(F=>F.revived)},get removed(){return[...U].map(F=>F.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class d extends a.$qJ{constructor(){super(...arguments),this.q=new R.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(B){return this.d.get(B)}getMirroredTestDataByReference(B){return this.d.get(B.id)}p(B,W){return{...B,revived:t.TestItem.toPlain(B.item),depth:W?W.depth+1:0,children:new Set}}o(){return new k(this.q)}}class y{constructor(B){this.d=B}checkout(){this.c||(this.c=this.f());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(W=>W.revived)},dispose:(0,$.$cb)(()=>{--B.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}f(){const B=new d;return this.d.$subscribeToDiffs(),{observers:0,tests:B}}}class w{#e;#t;get label(){return this.d}set label(B){B!==this.d&&(this.d=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.f}set isDefault(B){B!==this.f&&(this.f=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,W,U,F,O,ee,X,Ee=!1,ke=void 0,Pe=!1){this.controllerId=U,this.profileId=F,this.d=O,this.kind=ee,this.runHandler=X,this.f=Ee,this._tag=ke,this.g=Pe,this.#e=B,this.#t=W,W.set(F,this);const le=C[ee];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${ee}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:U,tag:ke?t.TestTag.namespace(this.controllerId,ke.id):null,label:O,group:le,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:Pe})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$tec=w;const C={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[267],Re([1,0,18,11,5,3,109,8,7]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class g{constructor(S,o){this.i=o,this.a=new P.$Nd({onListenerError:L.$1}),this.b=new P.$Nd({onListenerError:L.$1}),this.c=new P.$Nd({onListenerError:L.$1}),this.d=new P.$Nd({onListenerError:L.$1}),this.f=new P.$Nd({onListenerError:L.$1}),this.g=new P.$Nd({onListenerError:L.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$tK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const o=this.i.allEditors();return S?o:o.map(b=>b.value)}async showTextDocument(S,o,b){let v;typeof o=="number"?v={position:$.ViewColumn.from(o),preserveFocus:b}:typeof o=="object"?v={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selection:typeof o.selection=="object"?$.Range.from(o.selection):void 0,pinned:typeof o.preview=="boolean"?!o.preview:void 0}:v={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(S.uri,v),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,o){return new R.$BM(this.h,S,o).value}$acceptEditorPropertiesChanged(S,o){const b=this.i.getEditor(S);if(!b)throw new Error("unknown text editor");if(o.options&&b._acceptOptions(o.options),o.selections){const v=o.selections.selections.map($.Selection.to);b._acceptSelections(v)}if(o.visibleRanges){const v=E.$Gb(o.visibleRanges.map($.Range.to));b._acceptVisibleRanges(v)}if(o.options&&this.b.fire({textEditor:b.value,options:{...o.options,lineNumbers:$.TextEditorLineNumbersStyle.to(o.options.lineNumbers)}}),o.selections){const v=D.TextEditorSelectionChangeKind.fromValue(o.selections.source),f=o.selections.selections.map($.Selection.to);this.a.fire({textEditor:b.value,selections:f,kind:v})}if(o.visibleRanges){const v=E.$Gb(o.visibleRanges.map($.Range.to));this.c.fire({textEditor:b.value,visibleRanges:v})}}$acceptEditorPositionData(S){for(const o in S){const b=this.i.getEditor(o);if(!b)throw new Error("Unknown text editor");const v=$.ViewColumn.to(S[o]);b.value.viewColumn!==v&&(b._acceptViewColumn(v),this.d.fire({textEditor:b.value,viewColumn:v}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$Idc=g}),define(Ae[268],Re([1,0,2,4,3,6,7,8,21,16]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0,e.$kec=(0,L.$Ph)("IExtHostTimeline");class A{constructor(b,v){this.b=new Map,this.c=new Map,this.a=b.getProxy(P.$tK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$6l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:E.URI.revive(f.uri);return this.c.get(f.source)?.get(S(i))?.get(f.handle)}else return;return f}})}async $getTimeline(b,v,f,t){return this.b.get(b)?.provider.provideTimeline(E.URI.revive(v),f,t)}registerTimelineProvider(b,v,f,t){const i=new M.$Qc,r=this.d(v.id,t,i).bind(this);let u;v.onDidChange&&(u=v.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:v.id}),this));const a=this.c;return this.f({...v,scheme:b,onDidChange:void 0,async provideTimeline(l,n,s){n?.resetCache&&(i.clear(),a.get(v.id)?.clear());const c=await v.provideTimeline(l,n,s);if(c==null)return;const h=r(l,n);return{...c,source:v.id,items:c.items.map(h)}},dispose(){for(const l of a.values())l.get(v.id)?.clear();u?.dispose(),i.dispose()}},f)}d(b,v,f){return(t,i)=>{let r;if(i?.cacheResults){let u=this.c.get(b);u===void 0&&(u=new Map,this.c.set(b,u));const a=S(t);r=u.get(a),r===void 0&&(r=new Map,u.set(a,r))}return u=>{const{iconPath:a,...l}=u,n=`${b}|${u.id??u.timestamp}`;r?.set(n,u);let s,c,h;u.iconPath&&(a instanceof R.$pL?h={id:a.id,color:a.color}:E.URI.isUri(a)?(s=a,c=a):{light:s,dark:c}=a);let p;return R.$VK.isMarkdownString(l.tooltip)?p=$.MarkdownString.from(l.tooltip):(0,g.$yf)(l.tooltip)?p=l.tooltip:R.$VK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=$.MarkdownString.from(l.detail)):(0,g.$yf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=l.detail),{...l,id:l.id??void 0,handle:n,source:b,command:u.command?v.toInternal(u.command,f):void 0,icon:s,iconDark:c,themeIcon:h,tooltip:p,accessibilityInformation:u.accessibilityInformation}}}}f(b,v){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:v}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$lec=A;function S(o){return o?.toString()}}),define(Ae[86],Re([1,0,19,5,6,168,4,15,195,3,27,17,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wwb=e.$vwb=e.TunnelDtoConverter=void 0;class b extends D.$jv{}var v;(function(t){function i(u){return{remoteAddress:u.remoteAddress,localAddress:u.localAddress,public:!!u.public,privacy:u.privacy??(u.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:u.protocol}}t.fromApiTunnel=i;function r(u){return{remoteAddress:{host:u.tunnelRemoteHost,port:u.tunnelRemotePort},localAddress:u.localAddress,public:u.privacy!==D.TunnelPrivacyId.ConstantPrivate&&u.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:u.privacy,protocol:u.protocol}}t.fromServiceTunnel=r})(v||(e.TunnelDtoConverter=v={})),e.$vwb=(0,R.$Ph)("IExtHostTunnelService");let f=class extends P.$Rc{constructor(i,r,u){super(),this.s=u,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$tK.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const u=await this.a.$openTunnel(r,i.displayName);if(u){const a=new b(u.remoteAddress,u.localAddress,()=>this.a.$closeTunnel(u.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const u=this.u();return this.r.set(u,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,u),new o.$vK(()=>{this.r.delete(u),this.a.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(i,r,u,a,l){const n=[];for(const c of i){const h=this.r.get(c);if(!h)return[];n.push(...await Promise.all(r.map(async p=>{let m;try{m=await h.provider.providePortAttributes({port:p,pid:u,commandLine:a},l)}catch{m=await h.provider.providePortAttributes(p,u,a,l)}return{providedAttributes:m,port:p}})))}const s=n.filter(c=>!!c.providedAttributes);return s.length>0?s.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,l)=>await i.provideTunnel(a,l,new E.$Xd().token)??void 0;const u=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(u),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const u=i.tunnelFactory??(r?this.w(r):void 0);if(u){this.b=u;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const u=this.g.get(i.host);u.has(i.port)&&(r&&u.get(i.port).disposeListener.dispose(),await u.get(i.port).tunnel.dispose(),u.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const a=await u;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:a,disposeListener:l}),v.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),u instanceof Error)return u.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(a=>this.f(a.host,a.port,a.detail??""))),u=i.filter((a,l)=>r[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(a=>a.port).join(", ")} to ${u.map(a=>a.port).join(", ")}`),u}};e.$wwb=f,e.$wwb=f=Ke([Ve(0,S.$uM),Ve(1,A.$KM),Ve(2,$.$0i)],f)}),define(Ae[269],Re([1,0,6,14,2,3]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$tK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,A,S){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const o=S.schemes.find(b=>!R.a.has(b));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,S.schemes,D,S.label),(0,E.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const o=P.URI.revive(g);return S.canOpenExternalUri(o,A)}async $openUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(P.URI.revive(g.resolvedUri),{sourceUri:P.URI.revive(g.sourceUri)},A)}}e.$uec=R}),define(Ae[270],Re([1,0,3,2,6,11,21]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class ${static{this.a=0}constructor(g){this.c=new R.$7l,this.d=new Map,this.b=g.getProxy(E.$tK.MainThreadUrls)}registerUriHandler(g,A){const S=g.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const o=$.a++;return this.c.add(S),this.d.set(o,A),this.b.$registerUriHandler(o,S,g.displayName||g.name),(0,P.$Pc)(()=>{this.c.delete(S),this.d.delete(o),this.b.$unregisterUriHandler(o)})}$handleExternalUri(g,A){const S=this.d.get(g);if(!S)return Promise.resolve(void 0);try{S.handleUri(L.URI.revive(A))}catch(o){(0,M.$Z)(o)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this.b.$createAppUri(g))}}e.$Kdc=$}),define(Ae[65],Re([1,0,5,6,14,26,2,180,202,77,3]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0;class S{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(a,l,n,s,c,h,p){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new E.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Nd,this._onDidDispose=this.#h.event,this.#e=a,this.#t=l,this.#r=n,this.#l=s,this.#u=c,this.#n=h,this.#c=o(h),this.#d=b(h),this.#i=p}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#a=!0,(0,g.$upb)(a,this.#l)}get cspSource(){const a=this.#n.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let l=a.toString();return l.endsWith("/")||(l+="/"),l+" "+g.$tpb}return g.$tpb}get html(){return this.a(),this.#s}set html(a){this.a(),this.#s!==a&&(this.#s=a,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#r}set options(a){this.a(),M.$$m(this.#r,a)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,a)),this.#r=a}async postMessage(a){if(this.#o)return!1;const l=(0,D.$Rcb)(a,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,p,m,I)=>{const k=R.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),d=(0,g.$upb)(k,{isRemote:l,authority:n}).toString();return`${c}${d}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,p,m,I)=>{const k=R.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),d=(0,g.$upb)(k,{isRemote:l,authority:n}).toString();return`${c}${d}${I}`})}}e.$Ldc=S;function o(u){try{const a=(0,$.$Qo)((0,$.$Po)(u.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$Mdc=o;function b(u){try{const a=(0,$.$Qo)((0,$.$Po)(u.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class v extends L.$Rc{constructor(a,l,n,s,c){super(),this.c=l,this.f=n,this.g=s,this.h=c,this.b=new Map,this.a=a.getProxy(A.$tK.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,l,n){const s=this.j(a);if(s){const{message:c}=(0,D.$Scb)(l,n.value);s._onMessageEmitter.fire(c)}}$onMissingCsp(a,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,l,n){const s=new S(a,this.a,i(l),this.c,this.f,n,this.h);this.b.set(a,s);const c=s._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return s}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Ndc=v;function f(u){return{id:u.identifier,location:u.extensionLocation}}e.$Odc=f;function t(u,a,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||r(u,a)}}e.$Pdc=t;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(a=>R.URI.from(a))}}function r(u,a){return[...(a?.getWorkspaceFolders()||[]).map(l=>l.uri),u.extensionLocation]}}),define(Ae[271],Re([1,0,19,96,6,14,25,2,8,65,74,3,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class b{constructor(s,c){this.document=s,this.b=c,this.a=1,this.c=new A.$Hcc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,c){await this.f(s).undo(),c||this.disposeBackup()}async redo(s,c){await this.f(s).redo(),c||this.disposeBackup()}disposeEdits(s){for(const c of s)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$vg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const c=this.c.get(s,0);if(!c)throw new Error("No edit found");return c}}class v{constructor(){this.a=new Map}get(s,c){return this.a.get(this.b(s,c))}add(s,c,h){const p=this.b(s,c.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${s} resource:${c.uri}`);const m=new b(c,h);return this.a.set(p,m),m}delete(s,c){const h=this.b(s,c.uri);this.a.delete(h)}b(s,c){return`${s}@@@${c}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,c,h){return this.b(0,s,c,h)}addCustomProvider(s,c,h){return this.b(1,s,c,h)}get(s){return this.a.get(s)}b(s,c,h,p){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:s,extension:h,provider:p}),new o.$vK(()=>this.a.delete(c))}}class i{constructor(s,c,h,p,m){this.d=c,this.f=h,this.g=p,this.h=m,this.b=new t,this.c=new v,this.a=s.getProxy(S.$tK.MainThreadCustomEditors)}registerCustomEditorProvider(s,c,h,p){const m=new P.$Qc;return u(h)?(m.add(this.b.addTextProvider(c,s,h)),this.a.$registerTextEditorProvider((0,g.$Odc)(s),c,p.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,g.$Mdc)(s))):(m.add(this.b.addCustomProvider(c,s,h)),r(h)&&m.add(h.onDidChangeCustomDocument(I=>{const k=this.i(c,I.document.uri);if(a(I)){const d=k.addEdit(I);this.a.$onDidEdit(I.document.uri,c,d,I.label)}else this.a.$onContentChange(I.document.uri,c)})),this.a.$registerCustomEditorProvider((0,g.$Odc)(s),c,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,g.$Mdc)(s))),o.$vK.from(m,new o.$vK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(s,c,h,p,m){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${c}'`);const k=$.URI.revive(s),d=await I.provider.openCustomDocument(k,{backupId:h,untitledDocumentData:p?.buffer},m);let y;return r(I.provider)&&this.f&&(y=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(c,d,y),{editable:r(I.provider)}}async $disposeCustomDocument(s,c){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${c}'`);const p=$.URI.revive(s),{document:m}=this.i(c,p);this.c.delete(c,m),m.dispose()}async $resolveCustomEditor(s,c,h,p,m,I){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);const d=D.ViewColumn.to(m),y=this.g.createNewWebview(c,p.contentOptions,k.extension),w=this.h.createNewWebviewPanel(c,h,p.title,d,p.options,y,p.active),C=$.URI.revive(s);switch(k.type){case 1:{const{document:j}=this.i(h,C);return k.provider.resolveCustomEditor(j,w,I)}case 0:{const j=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(j,w,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,c,h){this.i(c,s).disposeEdits(h)}async $onMoveCustomEditor(s,c,h){const p=this.b.get(h);if(!p)throw new Error(`No provider found for '${h}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const I=$.URI.revive(c),k=this.d.getDocument(I);await p.provider.moveCustomTextEditor(k,m,E.CancellationToken.None)}async $undo(s,c,h,p){return this.i(c,s).undo(h,p)}async $redo(s,c,h,p){return this.i(c,s).redo(h,p)}async $revert(s,c,h){const p=this.i(c,s);await this.j(c).revertCustomDocument(p.document,h),p.disposeBackup()}async $onSave(s,c,h){const p=this.i(c,s);await this.j(c).saveCustomDocument(p.document,h),p.disposeBackup()}async $onSaveAs(s,c,h,p){const m=this.i(c,s);return this.j(c).saveCustomDocumentAs(m.document,$.URI.revive(h),p)}async $backup(s,c,h){const p=this.i(c,s),I=await this.j(c).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},h);return p.updateBackup(I),I.id}i(s,c){const h=this.c.get(s,$.URI.revive(c));if(!h)throw new Error("No custom document found");return h}j(s){const h=this.b.get(s)?.provider;if(!h||!r(h))throw new Error("Custom document is not editable");return h}}e.$oec=i;function r(n){return!!n.onDidChangeCustomDocument}function u(n){return typeof n.resolveCustomTextEditor=="function"}function a(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function l(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,L.$Di)(s)+""}}),define(Ae[272],Re([1,0,5,6,2,37,8,65,3,7]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class A extends L.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(v,f,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new E.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=f,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#s}set iconPath(v){this.c(),this.#s!==v&&(this.#s=v,this.#t.$setIconPath(this.#e,P.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(v){this.#c||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#a=v.active,this.#o=v.visible,this.#r=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class S extends L.$Rc{static c(){return(0,M.$eg)()}constructor(v,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=v.getProxy(D.$tK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,f,t,i,r={}){const u=typeof i=="object"?i.viewColumn:i,a={viewColumn:R.ViewColumn.from(u),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$Mdc)(v),n=S.c();this.f.$createWebviewPanel((0,$.$Odc)(v),n,f,{title:t,panelOptions:o(r),webviewOptions:(0,$.$Pdc)(v,this.m,r),serializeBuffersForPostMessage:l},a);const s=this.j.createNewWebview(n,r,v);return this.createNewWebviewPanel(n,f,t,u,r,s,!0)}$onDidChangeWebviewPanelViewStates(v){const f=Object.keys(v);f.sort((t,i)=>{const r=v[t],u=v[i];return r.active?1:u.active?-1:+r.visible-+u.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const r=v[t];i._updateViewState({active:r.active,visible:r.visible,viewColumn:R.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:v}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$Mdc)(v)}),new g.$vK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(v,f,t,i){const r=this.h.get(f);if(!r)throw new Error(`No serializer found for '${f}'`);const{serializer:u,extension:a}=r,l=this.j.createNewWebview(v,t.webviewOptions,a),n=this.createNewWebviewPanel(v,f,t.title,i,t.panelOptions,l,t.active);await u.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(v,f,t,i,r,u,a){const l=new A(v,this.f,u,{viewType:f,title:t,viewColumn:i,panelOptions:r,active:a});return this.g.set(v,l),l}getWebviewPanel(v){return this.g.get(v)}}e.$nec=S;function o(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[273],Re([1,0,5,6,65,8,3,7]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class D extends L.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(S,o,b,v,f,t){super(),this.#u=!1,this.#a=this.B(new E.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new E.$Nd),this.onDidDispose=this.#c.event,this.#i=b,this.#s=v,this.#e=S,this.#t=o,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#r}set description(S){this.a(),this.#r!==S&&(this.#r=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#u||(this.#n=S,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(S){this.a(),!(S?.value===this.#o?.value&&S?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(S,o){this.d=o,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$tK.MainThreadWebviewViews)}registerWebviewViewProvider(S,o,b,v){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:b,extension:S}),this.a.$registerWebviewViewProvider((0,P.$Odc)(S),o,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Mdc)(S)}),new $.$vK(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(S,o,b,v,f){const t=this.b.get(o);if(!t)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:r}=t,u=this.d.createNewWebview(S,{},r),a=new D(S,this.a,o,b,u,!0);this.c.set(S,a),await i.resolveWebviewView(a,{state:v},f)}async $onDidChangeWebviewViewVisibility(S,o){this.e(S)._setVisible(o)}async $disposeWebviewView(S){const o=this.e(S);this.c.delete(S),o.dispose(),this.d.deleteWebview(S)}e(S){const o=this.c.get(S);if(!o)throw new Error("No webview found");return o}}e.$mec=g}),define(Ae[111],Re([1,0,5,3,2,14,13,4,17,24]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(b){const v=this.d;return{get focused(){return v.focused},get active(){return(0,g.$lF)(b,"windowActivity"),v.active}}}constructor(b){this.c=new E.$Nd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=b.getProxy(L.$tK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:f})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,v){v!==this.d[b]&&(this.d={...this.d,[b]:v},this.c.fire(this.d))}openUri(b,v){let f;if(typeof b=="string"){f=b;try{b=P.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,R.$Be)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,f,v)}async asExternalUri(b,v){if((0,R.$Be)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(b,v);return P.URI.from(f)}};e.$Qdc=S,e.$Qdc=S=A=Ke([Ve(0,D.$uM)],S),e.$Rdc=(0,$.$Ph)("IExtHostWindow")}),define(Ae[274],Re([1,0,240,27,17]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;let M=class extends E.$Rec{constructor($,D){super($,D)}f($,D,g){D.apply(console,g)}};e.$Ygc=M,e.$Ygc=M=Ke([Ve(0,P.$uM),Ve(1,L.$KM)],M)}),define(Ae[275],Re([1,0,12,22,19,11,5,6,138,228,48]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=e.ResponsiveState=e.RequestInitiator=e.$84b=e.$74b=void 0;function o(w,C){try{return JSON.stringify(w,C)}catch{return"null"}}const b="$$ref$$",v={[b]:-1};class f{constructor(C,j){this.jsonString=C,this.referencedBuffers=j}}function t(w,C=null,j=!1){const B=[];return{jsonString:(j?o:JSON.stringify)(w,(U,F)=>{if(typeof F>"u")return v;if(typeof F=="object"){if(F instanceof L.$be){const O=B.push(F)-1;return{[b]:O}}if(C)return C(U,F)}return F}),referencedBuffers:B}}e.$74b=t;function i(w,C,j){return JSON.parse(w,(B,W)=>{if(W){const U=W[b];if(typeof U=="number")return C[U];if(j&&W.$mid===1)return j.transformIncoming(W)}return W})}e.$84b=i;function r(w,C){return JSON.stringify(w,C)}function u(w){return w?(C,j)=>j&&j.$mid===1?w.transformOutgoing(j):j:null}var a;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var l;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const n=()=>{},s=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends $.$Rc{static{S=s}static{this.a=3*1e3}constructor(C,j=null,B=null){super(),this[S]=!0,this.b=this.B(new R.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=j,this.g=B,this.h=u(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=A.$qv.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$6g(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const j=this.w[C];delete this.w[C],j.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,D.$Om)(C,this.g):C}getProxy(C){const{nid:j,sid:B}=C;return this.s[j]||(this.s[j]=this.J(j,B)),this.s[j]}J(C,j){const B={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...F)=>this.U(C,U,F)),U===c?j:W[U])};return new Proxy(Object.create(null),B)}set(C,j){return this.m[C.nid]=j,j}assertRegistered(C){for(let j=0,B=C.length;j<B;j++){const W=C[j];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(C){if(this.j)return;const j=C.byteLength,B=m.read(C,0),W=B.readUInt8(),U=B.readUInt32();switch(W){case 1:case 2:{let{rpcId:F,method:O,args:ee}=k.deserializeRequestJSONArgs(B);this.g&&(ee=(0,D.$Om)(ee,this.g)),this.M(j,U,F,O,ee,W===2);break}case 3:case 4:{let{rpcId:F,method:O,args:ee}=k.deserializeRequestMixedArgs(B);this.g&&(ee=(0,D.$Om)(ee,this.g)),this.M(j,U,F,O,ee,W===4);break}case 5:{this.f?.logIncoming(j,U,0,"ack"),this.G(U);break}case 6:{this.N(j,U);break}case 7:{this.O(j,U,void 0);break}case 9:{let F=k.deserializeReplyOKJSON(B);this.g&&(F=(0,D.$Om)(F,this.g)),this.O(j,U,F);break}case 10:{const F=k.deserializeReplyOKJSONWithBuffers(B,this.g);this.O(j,U,F);break}case 8:{const F=k.deserializeReplyOKVSBuffer(B);this.O(j,U,F);break}case 11:{let F=k.deserializeReplyErrError(B);this.g&&(F=(0,D.$Om)(F,this.g)),this.P(j,U,F);break}case 12:{this.P(j,U,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,j,B,W,U,F){this.f?.logIncoming(C,j,1,`receiveRequest ${(0,A.$sv)(B)}.${W}(`,U);const O=String(j);let ee,X;if(F){const ke=new P.$Xd;U.push(ke.token),ee=this.Q(B,W,U),X=()=>ke.cancel()}else ee=this.Q(B,W,U),X=n;this.u[O]=X;const Ee=k.serializeAcknowledged(j);this.f?.logOutgoing(Ee.byteLength,j,1,"ack"),this.c.send(Ee),ee.then(ke=>{delete this.u[O];const Pe=k.serializeReplyOK(j,ke,this.h);this.f?.logOutgoing(Pe.byteLength,j,1,"reply:",ke),this.c.send(Pe)},ke=>{delete this.u[O];const Pe=k.serializeReplyErr(j,ke);this.f?.logOutgoing(Pe.byteLength,j,1,"replyErr:",ke),this.c.send(Pe)})}N(C,j){this.f?.logIncoming(C,j,1,"receiveCancel");const B=String(j);this.u[B]?.()}O(C,j,B){this.f?.logIncoming(C,j,0,"receiveReply:",B);const W=String(j);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(B)}P(C,j,B){this.f?.logIncoming(C,j,0,"receiveReplyErr:",B);const W=String(j);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let F;B&&(B.$isError?(F=new Error,F.name=B.name,F.message=B.message,F.stack=B.stack):F=B),U.resolveErr(F)}Q(C,j,B){try{return Promise.resolve(this.S(C,j,B))}catch(W){return Promise.reject(W)}}S(C,j,B){const W=this.m[C];if(!W)throw new Error("Unknown actor "+(0,A.$sv)(C));const U=W[j];if(typeof U!="function")throw new Error("Unknown method "+j+" on actor "+(0,A.$sv)(C));return U.apply(W,B)}U(C,j,B){if(this.j)return new g.$64b;let W=null;if(B.length>0&&P.CancellationToken.isCancellationToken(B[B.length-1])&&(W=B.pop()),W&&W.isCancellationRequested)return Promise.reject(M.$5());const U=k.serializeRequestArguments(B,this.h),F=++this.t,O=String(F),ee=new g.$54b,X=new $.$Qc;W&&X.add(W.onCancellationRequested(()=>{const ke=k.serializeCancel(F);this.f?.logOutgoing(ke.byteLength,F,0,"cancel"),this.c.send(k.serializeCancel(F))})),this.w[O]=new p(ee,X),this.F(F);const Ee=k.serializeRequest(F,C,j,U,!!W);return this.f?.logOutgoing(Ee.byteLength,F,0,`request: ${(0,A.$sv)(C)}.${j}(`,B),this.c.send(Ee),ee}}e.$94b=h;class p{constructor(C,j){this.a=C,this.b=j}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class m{static alloc(C,j,B){const W=new m(L.$be.alloc(B+1+4),0);return W.writeUInt8(C),W.writeUInt32(j),W}static read(C,j){return new m(C,j)}get buffer(){return this.a}constructor(C,j){this.a=C,this.b=j}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const B=this.a.slice(this.b,this.b+C).toString();return this.b+=C,B}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+C).toString();return this.b+=C,B}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C);return this.b+=C,j}static sizeMixedArray(C){let j=0;j+=1;for(let B=0,W=C.length;B<W;B++){const U=C[B];switch(j+=1,U.type){case 1:j+=this.sizeLongString(U.value);break;case 2:j+=this.sizeVSBuffer(U.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(U.value);for(let F=0;F<U.buffers.length;++F)j+=this.sizeVSBuffer(U.buffers[F]);break;case 4:break}}return j}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let j=0,B=C.length;j<B;j++){const W=C[j];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const j=new Array(C);for(let B=0;B<C;B++)switch(this.readUInt8()){case 1:j[B]=this.readLongString();break;case 2:j[B]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),F=this.readLongString(),O=[];for(let ee=0;ee<U;++ee)O.push(this.readVSBuffer());j[B]=new A.$tv(i(F,O,null));break}case 4:j[B]=void 0;break}return j}}var I;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(I||(I={}));class k{static a(C){for(let j=0,B=C.length;j<B;j++)if(C[j]instanceof L.$be||C[j]instanceof A.$tv||typeof C[j]>"u")return!0;return!1}static serializeRequestArguments(C,j){if(this.a(C)){const B=[];for(let W=0,U=C.length;W<U;W++){const F=C[W];if(F instanceof L.$be)B[W]={type:2,value:F};else if(typeof F>"u")B[W]={type:4};else if(F instanceof A.$tv){const{jsonString:O,referencedBuffers:ee}=t(F.value,j);B[W]={type:3,value:L.$be.fromString(O),buffers:ee}}else B[W]={type:1,value:L.$be.fromString(r(F,j))}}return{type:1,args:B}}return{type:0,args:r(C,j)}}static serializeRequest(C,j,B,W,U){switch(W.type){case 0:return this.b(C,j,B,W.args,U);case 1:return this.c(C,j,B,W.args,U)}}static b(C,j,B,W,U){const F=L.$be.fromString(B),O=L.$be.fromString(W);let ee=0;ee+=m.sizeUInt8(),ee+=m.sizeShortString(F),ee+=m.sizeLongString(O);const X=m.alloc(U?2:1,C,ee);return X.writeUInt8(j),X.writeShortString(F),X.writeLongString(O),X.buffer}static deserializeRequestJSONArgs(C){const j=C.readUInt8(),B=C.readShortString(),W=C.readLongString();return{rpcId:j,method:B,args:JSON.parse(W)}}static c(C,j,B,W,U){const F=L.$be.fromString(B);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(F),O+=m.sizeMixedArray(W);const ee=m.alloc(U?4:3,C,O);return ee.writeUInt8(j),ee.writeShortString(F),ee.writeMixedArray(W),ee.buffer}static deserializeRequestMixedArgs(C){const j=C.readUInt8(),B=C.readShortString(),W=C.readMixedArray(),U=new Array(W.length);for(let F=0,O=W.length;F<O;F++){const ee=W[F];typeof ee=="string"?U[F]=JSON.parse(ee):U[F]=ee}return{rpcId:j,method:B,args:U}}static serializeAcknowledged(C){return m.alloc(5,C,0).buffer}static serializeCancel(C){return m.alloc(6,C,0).buffer}static serializeReplyOK(C,j,B){if(typeof j>"u")return this.d(C);if(j instanceof L.$be)return this.e(C,j);if(j instanceof A.$tv){const{jsonString:W,referencedBuffers:U}=t(j.value,B,!0);return this.g(C,W,U)}else return this.f(C,o(j,B))}static d(C){return m.alloc(7,C,0).buffer}static e(C,j){let B=0;B+=m.sizeVSBuffer(j);const W=m.alloc(8,C,B);return W.writeVSBuffer(j),W.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,j){const B=L.$be.fromString(j);let W=0;W+=m.sizeLongString(B);const U=m.alloc(9,C,W);return U.writeLongString(B),U.buffer}static g(C,j,B){const W=L.$be.fromString(j);let U=0;U+=m.sizeUInt32,U+=m.sizeLongString(W);for(const O of B)U+=m.sizeVSBuffer(O);const F=m.alloc(10,C,U);F.writeUInt32(B.length),F.writeLongString(W);for(const O of B)F.writeBuffer(O);return F.buffer}static deserializeReplyOKJSON(C){const j=C.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(C,j){const B=C.readUInt32(),W=C.readLongString(),U=[];for(let F=0;F<B;++F)U.push(C.readVSBuffer());return new A.$tv(i(W,U,j))}static serializeReplyErr(C,j){const B=j?o(M.$2(j),null):void 0;if(typeof B!="string")return this.h(C);const W=L.$be.fromString(B);let U=0;U+=m.sizeLongString(W);const F=m.alloc(11,C,U);return F.writeLongString(W),F.buffer}static deserializeReplyErrError(C){const j=C.readLongString();return JSON.parse(j)}static h(C){return m.alloc(12,C,0).buffer}}var d;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var y;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(y||(y={}))}),define(Ae[276],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const D=$.data;Object.defineProperties(globalThis,{postMessage:{value(g,A){D.postMessage(g,A)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${E})('${R}'))`,g=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(g),S=new MessageChannel,o=A,b={type:"_newWorker",id:o,port:S.port2,url:A,options:$};M(b,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:o}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(v){S.port1.onmessage=v}},onmessageerror:{get(){return S.port1.onmessageerror},set(v){S.port1.onmessageerror=v}}}),S.port1.addEventListener("messageerror",v=>{const f=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(f)}),S.port1.addEventListener("message",v=>{const f=new MessageEvent("message",{data:v.data});this.dispatchEvent(f)}),S.port1.start()}}e.$1gc=L}),define(Ae[277],Re([1,0,5,31,33,4]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.OutputChannelUpdateMode=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=void 0,e.$BJ="text/x-code-output",e.$CJ="output",e.$DJ="Log",e.$EJ="text/x-code-log-output",e.$FJ="log",e.$GJ="workbench.panel.output",e.$HJ=new P.$7i("inOutput",!1),e.$IJ=new P.$7i("activeLogOutput",!1),e.$JJ=new P.$7i("outputView.scrollLock",!1),e.$KJ=(0,M.$Ph)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$LJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}L.$jn.add(e.$LJ.OutputChannels,new $),e.$MJ=new P.$7i("activeOutputChannel","")}),define(Ae[112],Re([1,0,3,4,17,21,15,277,63,27,41,135,22,16,40,5,6]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class i extends R.$dj{get disposed(){return this.n}constructor(l,n,s,c,h){super(),this.id=l,this.name=n,this.r=s,this.s=c,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const n=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(l,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:n))}hide(){this.s.$close(this.id)}g(l,n){this.m+=o.$be.fromString(n).byteLength,(0,R.log)(this.r,l,n),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(l){this.append(l)}}let u=class{constructor(l,n,s,c,h,p){this.i=n,this.j=s,this.k=c,this.l=h,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(E.$tK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,S.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(l,n,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof n=="object"&&n.log,h=(0,b.$yf)(n)?n:void 0;if((0,b.$yf)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$6l.equals(s.identifier,k))?.[1];m&&(p=(0,R.$nj)(m));const I=c?this.o(l,p,s):this.n(l,h,s);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),c?this.r(l,p??this.m.getLevel(),I):this.q(l,I)}async n(l,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,h=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,h,n,s.identifier.value);return new i(m,l,p,this.a,s)}async o(l,n,s){const c=await this.p(s),h=l.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(c,`${h}.log`),m=`${s.identifier.value}.${h}`,I=this.l.createLogger(p,{id:m,name:l,logLevel:n,extensionId:s.identifier.value});return new r(m,l,I,this.a,s)}p(l){let n=this.d.get(l.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(c){if((0,v.$ok)(c)!==v.FileSystemProviderErrorCode.FileExists)throw c}return s})())}return n}q(l,n){let s=!1;const c=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(h){c(),n.then(p=>p.append(h))},appendLine(h){c(),n.then(p=>p.appendLine(h))},clear(){c(),n.then(h=>h.clear())},replace(h){c(),n.then(p=>p.replace(h))},show(h,p){c(),n.then(m=>m.show(h,p))},hide(){c(),n.then(h=>h.hide())},dispose(){s=!0,n.then(h=>h.dispose())}}}r(l,n,s){const c=new t.$Qc,h=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},p=c.add(new f.$Nd);function m(I){n=I,p.fire(I)}return s.then(I=>{c.add(I),I.logLevel!==n&&m(I.logLevel),c.add(I.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return n},onDidChangeLogLevel:p.event,trace(I,...k){h(),s.then(d=>d.trace(I,...k))},debug(I,...k){h(),s.then(d=>d.debug(I,...k))},info(I,...k){h(),s.then(d=>d.info(I,...k))},warn(I,...k){h(),s.then(d=>d.warn(I,...k))},error(I,...k){h(),s.then(d=>d.error(I,...k))},dispose(){c.dispose()}}}};e.$Adc=u,e.$Adc=u=Ke([Ve(0,P.$uM),Ve(1,g.$KM),Ve(2,D.$ddc),Ve(3,A.$Kcc),Ve(4,R.$$i),Ve(5,R.$0i)],u),e.$Bdc=(0,L.$Ph)("IExtHostOutputService")}),define(Ae[278],Re([1,0,4,12]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,E.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const D=await P.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,L.$Ug)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,D)=>$+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,D)=>$+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[279],Re([1,0,45,14,20,23,25,2,4,197,57,215,278]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=void 0,e.$5J=(0,D.$Ph)("pathService");let v=b=class{constructor(t,i,r,u){this.d=t,this.e=i,this.f=r,this.g=u,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??t})()}hasValidBasename(t,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(u=>this.h(t,u,i)):this.h(t,i,r)}h(t,i,r){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,E.$Vf)(r??(0,R.$sg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const r=(0,g.$2J)(i.getWorkspace());if(r)return r;const u=i.getWorkspace().folders[0];if(u)return u.uri.scheme;const a=i.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const u=t.indexOf("/",2);u===-1?(i=t.substring(2),t="/"):(i=t.substring(2,u),t=t.substring(u)||"/")}return $.URI.from({scheme:L.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$6J=v,e.$6J=v=b=Ke([Ve(1,o.$tm),Ve(2,S.$NJ),Ve(3,A.$Yh)],v)}),define(Ae[113],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LI=e.$KI=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$KI=E;class L{constructor(R,$,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(D,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$LI=L;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ae[42],Re([1,0,18,39,26,45,13,4,20,11,113,12]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchErrorCode=e.$1I=e.$ZI=e.SearchSortOrder=e.ViewMode=e.$YI=e.$XI=e.$WI=e.$VI=e.SearchCompletionExitCode=e.$UI=e.$TI=e.$SI=e.QueryType=e.SearchProviderType=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$MI="workbench.view.search",e.$NI="workbench.panel.search",e.$OI="workbench.view.search",e.$PI="search-result",e.$QI="search.exclude";const o="\u27EA ",b=" characters skipped \u27EB",v=(o.length+b.length+5)*2;e.$RI=(0,$.$Ph)("searchService");var f;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(t||(e.QueryType=t={}));function i(le){return!!le.preview}e.$SI=i;function r(le){return!!le.resource}e.$TI=r;function u(le){return!!le.message}e.$UI=u;var a;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class l{constructor(be){this.resource=be,this.results=[]}}e.$VI=l;class n{constructor(be,ue,oe,ye){this.ranges=ue,this.webviewIndex=ye;const te=Array.isArray(ue)?ue:[ue];if(oe&&oe.matchLines===1&&s(te)){be=(0,R.$rf)(be,oe.matchLines);let V="",Y=0,_=0;const pe=Math.floor(oe.charsPerLine/5),$e=[];for(const de of te){const De=Math.max(de.startColumn-pe,0),re=de.startColumn+oe.charsPerLine;if(De>_+pe+v){const he=o+(De-_)+b;V+=he+be.slice(De,re),Y+=De-(_+he.length)}else V+=be.slice(_,re);$e.push(new h(0,de.startColumn-Y,de.endColumn-Y)),_=re}this.preview={text:V,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const V=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:be,matches:(0,E.$1b)(ue,Y=>new c(Y.startLineNumber-V,Y.startColumn,Y.endLineNumber-V,Y.endColumn))}}}}e.$WI=n;function s(le){const be=le[0].startLineNumber;for(const ue of le)if(ue.startLineNumber!==be||ue.endLineNumber!==be)return!1;return!0}class c{constructor(be,ue,oe,ye){this.startLineNumber=be,this.startColumn=ue,this.endLineNumber=oe,this.endColumn=ye}}e.$XI=c;class h extends c{constructor(be,ue,oe){super(be,ue,be,oe)}}e.$YI=h;var p;(function(le){le.List="list",le.Tree="tree"})(p||(e.ViewMode=p={}));var m;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(le,be=!0){const ue=le&&le.files&&le.files.exclude,oe=be&&le&&le.search&&le.search.exclude;if(!ue&&!oe)return;if(!ue||!oe)return ue||oe;let ye=Object.create(null);return ye=P.$0m(ye,P.$7m(ue)),ye=P.$0m(ye,P.$7m(oe),!0),ye}e.$ZI=I;function k(le,be){return le.excludePattern&&L.$vj(le.excludePattern,be)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&L.$vj(le.includePattern,be)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(ue=>{const oe=ue.folder.fsPath;if(M.$Xf(be,oe)){const ye=D.$kc(oe,be);return!ue.includePattern||!!L.$vj(ue.includePattern,ye)}else return!1}):!1:!0}e.$1I=k;var d;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class y extends Error{constructor(be,ue){super(be),this.code=ue}}e.$2I=y;function w(le){const be=le.message;if((0,g.$3)(le))return new y(be,d.canceled);try{const ue=JSON.parse(be);return new y(ue.message,ue.code)}catch{return new y(be,d.other)}}e.$3I=w;function C(le){const be={message:le.message,code:le.code};return new Error(JSON.stringify(be))}e.$4I=C;function j(le){return le.type==="error"?!0:le.type==="success"}e.$5I=j;function B(le){return le.type==="success"}e.$6I=B;function W(le){return!!le.path}e.$7I=W;function U(le,be){const ue=le.searchPath?le.searchPath:le.relativePath;return(0,R.$of)(ue,be)}e.$8I=U;class F{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9I=F;function O(le,be){const ue={...le||{},...be||{}};return Object.keys(ue).filter(oe=>{const ye=ue[oe];return typeof ye=="boolean"&&ye})}e.$0I=O;class ee{constructor(be,ue){this.c=null,this.a={...be.excludePattern||{},...ue.excludePattern||{}},this.b=L.$wj(this.a);let oe=be.includePattern;ue.includePattern&&(oe?oe={...oe,...ue.includePattern}:oe=ue.includePattern),oe&&(this.c=L.$wj(oe))}matchesExcludesSync(be,ue,oe){return!!(this.b&&this.b(be,ue,oe))}includedInQuerySync(be,ue,oe){return!(this.b&&this.b(be,ue,oe)||this.c&&!this.c(be,ue,oe))}includedInQuery(be,ue,oe){const ye=this.b(be,ue,oe),te=()=>this.c?!!this.c(be,ue,oe):!0;return(0,S.$Gg)(ye)?ye.then(V=>V?!1:te()):te()}hasSiblingExcludeClauses(){return X(this.a)}}e.$$I=ee;function X(le){for(const be in le)if(typeof le[be]!="boolean")return!0;return!1}function Ee(le){if(!le)return;let be;return ue=>(be||(be=(le()||Promise.resolve([])).then(oe=>oe?Pe(oe):{})),be.then(oe=>!!oe[ue]))}e.$_I=Ee;function ke(le){if(!le)return;let be;return ue=>{if(!be){const oe=le();be=oe?Pe(oe):{}}return!!be[ue]}}e.$aJ=ke;function Pe(le){const be={};for(const ue of le)be[ue]=!0;return be}}),define(Ae[34],Re([1,0,18,12,19,5,6,50,14,120,25,13,2,169,4,15,186,57,41,27,17,8,7,58,42,3,51]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;function m(B,W,U){return new A.$kg(F=>y(F,U)).isEqual(B,W)}function I(B,W,U){return m(B.uri,W.uri,U)?0:(0,S.$Ue)(B.uri.toString(),W.uri.toString())}function k(B,W,U){return B.index!==W.index?B.index<W.index?-1:1:m(B.uri,W.uri,U)?(0,S.$Ue)(B.name,W.name):(0,S.$Ue)(B.uri.toString(),W.uri.toString())}function d(B,W,U,F){const O=B.slice(0).sort((X,Ee)=>U(X,Ee,F)),ee=W.slice(0).sort((X,Ee)=>U(X,Ee,F));return(0,E.$Db)(O,ee,(X,Ee)=>U(X,Ee,F))}function y(B,W){const U=W.getCapabilities(B.scheme);return!(U&&U&1024)}class w extends i.$9h{static toExtHostWorkspace(W,U,F,O){if(!W)return{workspace:null,added:[],removed:[]};const{id:ee,name:X,folders:Ee,configuration:ke,transient:Pe,isUntitled:le}=W,be=[],ue=U;U?Ee.forEach((V,Y)=>{const _=o.URI.revive(V.uri),pe=w.o(F||U,_,O);pe?(pe.name=V.name,pe.index=V.index,be.push(pe)):be.push({uri:_,name:V.name,index:Y})}):be.push(...Ee.map(({uri:V,name:Y,index:_})=>({uri:o.URI.revive(V),name:Y,index:_}))),be.sort((V,Y)=>V.index<Y.index?-1:1);const oe=new w(ee,X,be,!!Pe,ke?o.URI.revive(ke):null,!!le,V=>y(V,O)),{added:ye,removed:te}=d(ue?ue.workspaceFolders:[],oe.workspaceFolders,I,O);return{workspace:oe,added:ye,removed:te}}static o(W,U,F){for(let O=0;O<W.folders.length;O++){const ee=W.workspaceFolders[O];if(m(ee.uri,U,F))return ee}}constructor(W,U,F,O,ee,X,Ee){super(W,F.map(ke=>new i.$0h(ke)),O,ee,Ee),this.t=U,this.u=X,this.q=[],this.s=$.$Vh.forUris(Ee),F.forEach(ke=>{this.q.push(ke),this.s.set(ke.uri,ke)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,A.$ug)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let C=class{constructor(W,U,F,O,ee){this.c=new M.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Pd,this.B=new Map,this.h=O,this.s=F,this.t=ee,this.j=new g.$Ql,this.k=new L.$Sg,this.o=W.getProxy(h.$tK.MainThreadWorkspace),this.q=W.getProxy(h.$tK.MainThreadMessageService);const X=U.workspace;this.l=X?new w(X.id,X.name,[],!!X.transient,X.configuration?o.URI.revive(X.configuration):null,!!X.isUntitled,Ee=>y(Ee,F)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:(0,A.$sg)((0,A.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,F,...O){const ee=[];if(Array.isArray(O)&&O.forEach(le=>{o.URI.isUri(le.uri)&&!ee.some(be=>m(be.uri,le.uri,this.s))&&ee.push({uri:le.uri,name:le.name||(0,A.$rg)(le.uri)})}),this.n||[U,F].some(le=>typeof le!="number"||le<0)||F===0&&ee.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(U+F>X.length)return!1;const Ee=X.slice(0);Ee.splice(U,F,...ee.map(le=>({uri:le.uri,name:le.name||(0,A.$rg)(le.uri),index:void 0})));for(let le=0;le<Ee.length;le++){const be=Ee[le];if(Ee.some((ue,oe)=>oe!==le&&m(be.uri,ue.uri,this.s)))return!1}Ee.forEach((le,be)=>le.index=be);const{added:ke,removed:Pe}=d(X,Ee,k,this.s);if(ke.length===0&&Pe.length===0)return!1;if(this.o){const le=W.displayName||W.name;this.o.$updateWorkspaceFolders(le,U,F,ee).then(void 0,be=>{this.n=void 0;const ue={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,le,be.toString()),ue,[])})}return this.y(Ee),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let F,O="";if(typeof W=="string"?(F=o.URI.file(W),O=W):typeof W<"u"&&(F=W,O=W.fsPath),!F)return O;const ee=this.getWorkspaceFolder(F,!0);if(!ee)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let X=(0,A.$xg)(ee.uri,F);return U&&ee.name&&(X=`${ee.name}/${X}`),X}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:F,removed:O}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:O}))}findFiles(W,U,F,O,ee=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let X;if(U===null?X=!1:U&&(typeof U=="string"?X=U:X=U.pattern),ee&&ee.isCancellationRequested)return Promise.resolve([]);const{includePattern:Ee,folder:ke}=j(l.GlobPattern.from(W));return this.o.$startFileSearch(Ee??null,ke??null,X??null,F??null,ee).then(Pe=>Array.isArray(Pe)?Pe.map(le=>o.URI.revive(le)):[])}async findTextInFiles(W,U,F,O,ee=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),Ee=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ke,folder:Pe}=j(l.GlobPattern.from(U.include)),le=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,be={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Ee,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ke,excludePattern:le},ue=!1;if(this.u[X]=oe=>{if(ue)return;const ye=o.URI.revive(oe.resource);oe.results.forEach(te=>{const V=(0,p.$mh)(te);(0,c.$SI)(V)?F({uri:ye,preview:{text:V.preview.text,matches:(0,E.$1b)(V.preview.matches,Y=>new n.$xK(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,E.$1b)(V.ranges,Y=>new n.$xK(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):F({uri:ye,text:V.text,lineNumber:V.lineNumber})})},ee.isCancellationRequested)return{};try{const oe=await this.o.$startTextSearch(W,Pe??null,be,X,ee);return delete this.u[X],oe||{}}catch(oe){throw delete this.u[X],oe}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return o.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return o.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const F=this.t.transformOutgoingScheme(W),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,F),(0,R.$Pc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const F=await this.resolveWorkspaceFolder(o.URI.revive(W));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const O=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!O),!O)return;const ee=await O.provideEditSessionIdentity(F,U);if(this.h.info("Provider returned edit session identifier: ",ee),!!ee)return ee}async $provideEditSessionIdentityMatch(W,U,F,O){this.h.info("Getting edit session identifier for workspaceFolder",W);const ee=await this.resolveWorkspaceFolder(o.URI.revive(W));if(!ee){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ee);const X=this.w.get(ee.uri.scheme);if(this.h.info(`Provider for scheme ${ee.uri.scheme} is defined: `,!!X),!X)return;const Ee=await X.provideEditSessionIdentityMatch?.(U,F,O);if(this.h.info("Provider returned edit session identifier match result: ",Ee),!!Ee)return Ee}getOnWillCreateEditSessionIdentityEvent(W){return(U,F,O)=>{const ee=function(Ee){U.call(F,Ee)};return ee.extension=W,this.A.event(ee,void 0,O)}}async $onWillCreateEditSessionIdentity(W,U,F){const O=await this.resolveWorkspaceFolder(o.URI.revive(W));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(ee,X)=>{const Ee=Date.now();await Promise.resolve(ee),Date.now()-Ee>F&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.B.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.B.set(W,U);const F=this.t.transformOutgoingScheme(W),O=this.z++;return this.o.$registerCanonicalUriProvider(O,F),(0,R.$Pc)(()=>{this.B.delete(W),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(W,U,F){const O=this.B.get(W.scheme);if(!O)return;const ee=await O.provideCanonicalUri?.(o.URI.revive(W),U,F);if(ee)return ee}async $provideCanonicalUri(W,U,F){return this.provideCanonicalUri(o.URI.revive(W),{targetScheme:U},F)}};e.$Wcc=C,e.$Wcc=C=Ke([Ve(0,a.$uM),Ve(1,u.$KM),Ve(2,r.$Kcc),Ve(3,f.$0i),Ve(4,s.$Ucc)],C),e.$Xcc=(0,v.$Ph)("IExtHostWorkspace");function j(B){let W,U;return B&&(typeof B=="string"?W=B:(W=B.pattern,U=o.URI.revive(B.baseUri))),{includePattern:W,folder:U}}}),define(Ae[35],Re([1,0,26,5,34,3,7,188,99,16,12,4,17,15,2]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=void 0;function f(s,c){if(c){const h=c.split(".");let p=s;for(let m=0;p&&m<h.length;m++)p=p[h[m]];return p}}function t(s){return s instanceof v.URI}function i(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function a(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(c,h,p){this.a=c.getProxy(M.$tK.MainThreadConfiguration),this.c=h,this.b=p,this.d=new A.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new n(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,h){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(c,h))}};e.$Ycc=l,e.$Ycc=l=Ke([Ve(0,o.$uM),Ve(1,P.$Xcc),Ve(2,b.$0i)],l);class n{constructor(c,h,p,m){this.a=new L.$Nd,this.b=c,this.f=m,this.c=h,this.e=$.$Hn.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,h){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Hn.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(h,p))}getConfiguration(c,h,p){const m=a(h)||{},I=this.g(c?f(this.e.getValue(void 0,m,this.c.workspace),c):this.e.getValue(void 0,m,this.c.workspace));c&&this.h(c,m,p?.identifier);function k(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(y){return typeof f(I,y)<"u"},get:(y,w)=>{this.h(c?`${c}.${y}`:y,m,p?.identifier);let C=f(I,y);if(typeof C>"u")C=w;else{let j;const B=(W,U)=>{if((0,g.$Af)(W)){let F;const O=()=>{j=j||(0,E.$7m)(I),F=F||f(j,U)};return new Proxy(W,{get:(ee,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return O(),()=>F;if(j)return F=F||f(j,U),F[X];const Ee=ee[X];return typeof X=="string"?B(Ee,`${U}.${X}`):Ee},set:(ee,X,Ee)=>(O(),F&&(F[X]=Ee),!0),deleteProperty:(ee,X)=>(O(),F&&delete F[X],!0),defineProperty:(ee,X,Ee)=>(O(),F&&Object.defineProperty(F,X,Ee),!0)})}return Array.isArray(W)?(0,E.$7m)(W):W};C=B(C,y)}return C},update:(y,w,C,j)=>{y=c?`${c}.${y}`:y;const B=k(C);return w!==void 0?this.b.$updateConfigurationOption(B,y,w,m,j):this.b.$removeConfigurationOption(B,y,m,j)},inspect:y=>{y=c?`${c}.${y}`:y;const w=this.e.inspect(y,m,this.c.workspace);if(w)return{key:y,defaultValue:(0,E.$7m)(w.policy?.value??w.default?.value),globalValue:(0,E.$7m)(w.user?.value??w.application?.value),workspaceValue:(0,E.$7m)(w.workspace?.value),workspaceFolderValue:(0,E.$7m)(w.workspaceFolder?.value),defaultLanguageValue:(0,E.$7m)(w.default?.override),globalLanguageValue:(0,E.$7m)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,E.$7m)(w.workspace?.override),workspaceFolderLanguageValue:(0,E.$7m)(w.workspaceFolder?.override),languageIds:(0,E.$7m)(w.overrideIdentifiers)}}};return typeof I=="object"&&(0,E.$0m)(d,I,!1),Object.freeze(d)}g(c){const h=p=>(0,g.$Af)(p)?new Proxy(p,{get:(m,I)=>h(m[I]),set:(m,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return h(c)}h(c,h,p){const m=D.$yn.test(c)?4:this.d.get(c),I=p?`[${p.value}] `:"";if(m===4){typeof h?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){h?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,h){const p=new $.$Jn(c,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>p.affectsConfiguration(m,a(I))})}k(c){return c.reduce((h,p)=>(h.set(p[0],p[1]),h),new Map)}}e.$Zcc=n,e.$1cc=(0,S.$Ph)("IExtHostConfiguration")}),define(Ae[114],Re([1,0,2,12,5,3,7,34,61,35,19,64,17,27,4,14,23,15,80,227,11]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=e.$Wdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(B){function W(F){if(F!=null)return F}B.from=W;function U(F){if(F!=null)return F}B.to=U})(l||(l={}));var n;(function(B){function W(F){if(F!=null)return F}B.from=W;function U(F){if(F!=null)return F}B.to=U})(n||(n={}));var s;(function(B){function W(F){if(F!=null)return F}B.from=W;function U(F){if(F!=null)return F}B.to=U})(s||(s={}));var c;(function(B){function W(O){if(O){const ee=O;return ee&&!!ee.process}else return!1}B.is=W;function U(O){if(O==null)return;const ee={process:O.process,args:O.args};return O.options&&(ee.options=s.from(O.options)),ee}B.from=U;function F(O){if(O!=null)return new R.$dL(O.process,O.args,O.options)}B.to=F})(c||(c={}));var h;(function(B){function W(F){if(F!=null)return F}B.from=W;function U(F){if(F!=null)return F}B.to=U})(h||(h={}));var p;(function(B){function W(O){if(O){const ee=O;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}B.is=W;function U(O){if(O==null)return;const ee={};return O.commandLine!==void 0?ee.commandLine=O.commandLine:(ee.command=O.command,ee.args=O.args),O.options&&(ee.options=h.from(O.options)),ee}B.from=U;function F(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$eL(O.commandLine,O.options):new R.$eL(O.command,O.args?O.args:[],O.options)}B.to=F})(p||(p={}));var m;(function(B){function W(O){if(O){const ee=O;return ee&&ee.customExecution==="customExecution"}else return!1}B.is=W;function U(O){return{customExecution:"customExecution"}}B.from=U;function F(O,ee){return ee.get(O)}B.to=F})(m||(e.CustomExecutionDTO=m={}));var I;(function(B){function W(U,F){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?O=F.workspaceFile:O=u.$WF),{id:U._id,workspaceFolder:O}}B.from=W})(I||(e.TaskHandleDTO=I={}));var k;(function(B){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}B.from=W})(k||(k={}));var d;(function(B){function W(O,ee){if(O==null)return[];const X=[];for(const Ee of O){const ke=U(Ee,ee);ke&&X.push(ke)}return X}B.fromMany=W;function U(O,ee){if(O==null)return;let X;O.execution instanceof R.$dL?X=c.from(O.execution):O.execution instanceof R.$eL?X=p.from(O.execution):O.execution&&O.execution instanceof R.$fL&&(X=m.from(O.execution));const Ee=l.from(O.definition);let ke;return O.scope?typeof O.scope=="number"?ke=O.scope:ke=O.scope.uri:ke=R.TaskScope.Workspace,!Ee||!ke?void 0:{_id:O._id,definition:Ee,name:O.name,source:{extensionId:ee.identifier.value,label:O.source,scope:ke},execution:X,isBackground:O.isBackground,group:k.from(O.group),presentationOptions:n.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}B.from=U;async function F(O,ee,X){if(O==null)return;let Ee;c.is(O.execution)?Ee=c.to(O.execution):p.is(O.execution)?Ee=p.to(O.execution):m.is(O.execution)&&(Ee=m.to(O._id,X));const ke=l.to(O.definition);let Pe;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Pe=O.source.scope:Pe=await ee.resolveWorkspaceFolder(E.URI.revive(O.source.scope)):Pe=R.TaskScope.Workspace),!ke||!Pe)return;const le=new R.$gL(ke,Pe,O.name,O.source.label,Ee,O.problemMatchers);return O.isBackground!==void 0&&(le.isBackground=O.isBackground),O.group!==void 0&&(le.group=R.$cL.from(O.group._id),le.group&&O.group.isDefault&&(le.group=new R.$cL(le.group.id,le.group.label),O.group.isDefault===!0&&(le.group.isDefault=O.group.isDefault))),O.presentationOptions&&(le.presentationOptions=n.to(O.presentationOptions)),O._id&&(le._id=O._id),O.detail&&(le.detail=O.detail),le}B.to=F})(d||(e.TaskDTO=d={}));var y;(function(B){function W(F){return F}B.from=W;function U(F){if(F)return Object.assign(Object.create(null),F)}B.to=U})(y||(y={}));class w{#e;constructor(W,U,F){this._id=U,this.a=F,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let C=class{constructor(W,U,F,O,ee,X,Ee,ke){this.q=new P.$Nd,this.r=new P.$Nd,this.s=new P.$Nd,this.t=new P.$Nd,this.a=W.getProxy(M.$tK.MainThreadTask),this.b=F,this.c=O,this.d=ee,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,F){if(!F)return new R.$vK(()=>{});const O=this.w();return this.j.set(O,{type:U,provider:F,extension:W}),this.a.$registerTaskProvider(O,U),new R.$vK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(y.from(W)).then(async U=>{const F=[];for(const O of U){const ee=await d.to(O,this.b,this.m);ee&&F.push(ee)}return F})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,F){const O=this.m.get(W.id);O&&(this.o.set(W.id,O),this.e.attachPtyToTerminal(U,await O.callback(F))),this.p=W.id,this.q.fire({execution:await this.y(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){const U=await this.y(W);this.l.delete(W.id),this.k.delete(W.id),this.A(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.y(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(W){const U=await this.y(W.id);this.t.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const F=this.j.get(W);if(!F)return Promise.reject(new Error("no handler found"));const O=[],ee=(0,L.$Mg)(()=>F.provider.provideTasks(A.CancellationToken.None)).then(X=>this.u(U,O,F,X));return new Promise(X=>{ee.then(Ee=>{Promise.all(O).then(()=>{X(Ee)})})})}async $resolveTask(W,U){const F=this.j.get(W);if(!F)return Promise.reject(new Error("no handler found"));if(U.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${F.type}].`);const O=await d.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const ee=await F.provider.resolveTask(O,A.CancellationToken.None);if(!ee)return;this.z(ee,F);const X=d.from(ee,F.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(X.execution)&&await this.x(X,ee,!0),await this.v(X)}w(){return this.h++}async x(W,U,F){const O=await this.a.$createTaskId(W);!F&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async y(W,U){if(typeof W=="string"){const ee=this.l.get(W);if(!ee)throw new a.$ab("Unexpected: The specified task is missing an execution");return ee}const F=this.l.get(W.id);if(F)return F;const O=new Promise((ee,X)=>{function Ee(ke,Pe,le){le?ee(new w(ke,Pe.id,le)):X("Unexpected: Task does not exist.")}U?Ee(this,W,U):d.to(W.task,this.b,this.m).then(ke=>Ee(this,W,ke))});return this.l.set(W.id,O),O.then(ee=>(this.k.set(W.id,ee),ee),ee=>Promise.reject(ee))}z(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const F=this.n.values();let O=F.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=F.next()}};e.$Wdc=C,e.$Wdc=C=Ke([Ve(0,o.$uM),Ve(1,b.$KM),Ve(2,$.$Xcc),Ve(3,D.$FM),Ve(4,g.$1cc),Ve(5,S.$gdc),Ve(6,i.$0i),Ve(7,r.$Ncc)],C);let j=class extends C{constructor(W,U,F,O,ee,X,Ee,ke){super(W,U,F,O,ee,X,Ee,ke),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const F=d.from(U,W);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.x(F,U,!1);else throw new a.$$;const O=await this.y(await this.a.$getTaskExecution(F),U);return this.a.$executeTask(F).catch(ee=>{throw new Error(ee)}),O}u(W,U,F,O){const ee=[];if(O)for(const X of O){this.z(X,F),(!X.definition||!W[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=d.from(X,F.extension);Ee&&m.is(Ee.execution)?(ee.push(Ee),U.push(this.x(Ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:F.extension}}async v(W){if(m.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,F){}};e.$Xdc=j,e.$Xdc=j=Ke([Ve(0,o.$uM),Ve(1,b.$KM),Ve(2,$.$Xcc),Ve(3,D.$FM),Ve(4,g.$1cc),Ve(5,S.$gdc),Ve(6,i.$0i),Ve(7,r.$Ncc)],j),e.$Ydc=(0,v.$Ph)("IExtHostTask")}),define(Ae[280],Re([1,0,42,29]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.$pK=void 0;function P(R){return"cellResults"in R}e.$pK=P,e.$qK="rawCell#";function M(R,$){let D=-1;const g=[];let A=[];return R.forEach(o=>{o.range.startLineNumber!==D&&A.length>0&&(g.push([...A]),A=[]),A.push(o),D=o.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(o=>{const b=[],v=o[0].range.startLineNumber,f=o[o.length-1].range.endLineNumber;for(let t=v;t<=f;t++)b.push($.getLineContent(t));return new E.$WI(b.join(`
`)+`
`,o.map(t=>new L.$ws(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$rK=M}),define(Ae[281],Re([1,0,162,22,5,6,28,13,16,2,40,74,3,32,8,7,48,219,107,11,26,14,280,210]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(p=>p.apiEditor)}constructor(p,m,I,k,d,y){this.q=I,this.r=k,this.s=d,this.t=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new P.$Nd({onListenerError:u.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Nd({onListenerError:u.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Nd({onListenerError:u.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Nd({onListenerError:u.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Hcc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=p.getProxy(o.$tK.MainThreadNotebook),this.c=p.getProxy(o.$tK.MainThreadNotebookDocuments),this.d=p.getProxy(o.$tK.MainThreadNotebookEditors),this.i=m.converter,m.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const C=w.notebookEditor?.notebookUri,j=w.cell.handle,W=this.g.get(C)?.getCell(j);if(W)return W.apiCell}if(w&&w.$mid===14){const C=w.uri,j=this.g.get(C);if(j)return j.apiNotebook}return w}}),c.B(m)}getEditorById(p){const m=this.h.get(p);if(!m)throw new Error(`unknown text editor: ${p}. known editors: ${[...this.h.keys()]} `);return m}getIdByEditor(p){for(const[m,I]of this.h)if(I.apiEditor===p)return m}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(p,m){const I=this.g.get(p);if(!I&&!m)throw new Error(`NO notebook document for '${p}'`);return I}static u(p,m){if(!m)return;const I=m.filenamePattern.map(k=>v.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(m.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:m.displayName,filenamePattern:I,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,m,I){const k=c.a++,d=typeof I.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(k,I),this.b.$registerNotebookCellStatusBarItemProvider(k,d,m);let y;return d!==void 0&&(y=I.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(d))),new f.$vK(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,d),y?.dispose()})}async createNotebookDocument(p){const m=await this.c.$tryCreateNotebook({viewType:p.viewType,content:p.content&&v.NotebookData.from(p.content)});return g.URI.revive(m)}async openNotebookDocument(p){const m=this.g.get(p);if(m)return m.apiNotebook;const I=await this.c.$tryOpenNotebook(p),k=this.g.get(g.URI.revive(I));return(0,D.$Jf)(k?.apiNotebook)}async showNotebookDocument(p,m){g.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let I;typeof m=="object"?I={position:v.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(v.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:I={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(p.uri,p.notebookType,I),d=k&&this.h.get(k)?.apiEditor;if(d)return d;throw k?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,m,I,k){const d=this.f.get(p),y=g.URI.revive(m),w=this.g.get(y);if(!w||!d)return;const C=w.getCellFromIndex(I);if(!C)return;const j=await d.provideCellStatusBarItems(C.apiCell,k);if(!j)return;const B=new M.$Qc,W=this.p.add([B]),F=(Array.isArray(j)?j:[j]).map(O=>v.NotebookStatusBarItem.from(O,this.i,B));return{cacheId:W,items:F}}$releaseNotebookCellStatusBarItems(p){this.p.delete(p)}registerNotebookSerializer(p,m,I,k,d){if((0,$.$Be)(m))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:m,serializer:I,options:k}),this.b.$registerNotebookSerializer(y,{id:p.identifier,location:p.extensionLocation},m,v.NotebookDocumentContentOptions.from(k),c.u(p,d)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(p,m,I){const k=this.x.get(p);if(!k)throw new Error("NO serializer found");const d=await k.serializer.deserializeNotebook(m.buffer,I);return new t.$tv(v.NotebookData.from(d))}async $notebookToData(p,m,I){const k=this.x.get(p);if(!k)throw new Error("NO serializer found");const d=await k.serializer.serializeNotebook(v.NotebookData.to(m.value),I);return L.$be.wrap(d)}async $saveNotebook(p,m,I,k,d){const y=g.URI.revive(m),w=this.x.get(p);if(!w)throw new Error("NO serializer found");const C=this.g.get(y);if(!C)throw new Error("Document NOT found");if(C.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$tk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,k);const j={metadata:(0,a.$cn)(C.apiNotebook.metadata,O=>!(w.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of C.apiNotebook.getCells()){const ee=new f.$TL(O.kind,O.document.getText(),O.document.languageId,O.mime,w.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);ee.metadata=(0,a.$cn)(O.metadata,X=>!(w.options?.transientCellMetadata??{})[X]),j.cells.push(ee)}const B=await w.serializer.serializeNotebook(j,d);await this.s.value.writeFile(y,B);const W=this.s.getFileSystemProviderExtUri(y.scheme),U=await this.s.value.stat(y);return{name:W.basename(y),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$Ek({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(p,m,I,k){const d=this.x.get(p)?.serializer;if(!d)return{limitHit:!1,results:[]};const w=await(async(W,U,F)=>{const O=new R.$Ac;return await Promise.all(W.map(ee=>{const X={type:1,filePattern:ee,folderQueries:F.folderQueries,maxResults:F.maxResults};return this.t.doInternalFileSearchWithCustomCallback(X,U,Ee=>{Ee.forEach(ke=>O.add(ke))})})),Array.from(O.keys())})(m,k,I),C=new R.$zc;let j=!1;const B=w.map(async W=>{const U=[];try{if(k.isCancellationRequested)return;if(I.maxResults&&[...C.values()].reduce((X,Ee)=>X+Ee.cellResults.length,0)>I.maxResults){j=!0;return}const F=[],O=this.g.get(W);if(O)O.apiNotebook.getCells().forEach(Ee=>F.push({input:Ee.document.getText(),outputs:Ee.outputs.flatMap(ke=>ke.items.map(Pe=>Pe.data.toString()))}));else{const X=await this.s.value.readFile(W),Ee=L.$be.fromString(X.toString()),ke=await d.deserializeNotebook(Ee.buffer,k);if(k.isCancellationRequested)return;v.NotebookData.from(ke).cells.forEach(le=>F.push({input:le.source,outputs:le.outputs.flatMap(be=>be.items.map(ue=>ue.valueBytes.toString()))}))}if(k.isCancellationRequested)return;F.forEach((X,Ee)=>{const ke=I.contentPattern.pattern,Pe=new s.$jOb(X.input,void 0,X.outputs),le=Pe.findInInputs(ke),be=Pe.findInOutputs(ke),ue=be.flatMap(oe=>(0,n.$rK)(oe.matches,oe.textBuffer)).map((oe,ye)=>(oe.webviewIndex=ye,oe));if(le.length>0||be.length>0){const oe={index:Ee,contentResults:(0,n.$rK)(le,Pe.inputTextBuffer),webviewResults:ue};U.push(oe)}});const ee={resource:W,cellResults:U};C.set(W,ee);return}catch{return}});return await Promise.all(B),{limitHit:j,results:[...C.values()]}}async y(p,m){const I=await this.s.value.stat(p);if(typeof m?.mtime=="number"&&typeof m.etag=="string"&&m.etag!==A.$Dk&&typeof I.mtime=="number"&&typeof I.size=="number"&&m.mtime<I.mtime&&m.etag!==A.$Ek({mtime:m.mtime,size:I.size}))throw new A.$tk((0,E.localize)(1,null),3,m)}z(p){return p.scheme===l.Schemas.file?p.fsPath:p.toString()}A(p,m,I){if(this.h.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const k=new r.$gec(m,this.d,p,I.visibleRanges.map(v.NotebookRange.to),I.selections.map(v.NotebookRange.to),typeof I.viewColumn=="number"?v.ViewColumn.to(I.viewColumn):void 0);this.h.set(m,k)}$acceptDocumentAndEditorsDelta(p){if(p.value.removedDocuments)for(const I of p.value.removedDocuments){const k=g.URI.revive(I),d=this.g.get(k);d&&(d.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(d.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===k.toString()&&this.h.delete(y.id)}if(p.value.addedDocuments){const I=[];for(const k of p.value.addedDocuments){const d=g.URI.revive(k.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const y=new i.$fec(this.c,this.q,this.r,d,k);I.push(...k.cells.map(w=>i.$eec.asModelAddData(y.apiNotebook,w))),this.g.get(d)?.dispose(),this.g.set(d,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(y.apiNotebook)}}if(p.value.addedEditors)for(const I of p.value.addedEditors){if(this.h.has(I.id))return;const k=g.URI.revive(I.documentUri),d=this.g.get(k);d&&this.A(d,I.id,I)}const m=[];if(p.value.removedEditors)for(const I of p.value.removedEditors){const k=this.h.get(I);k&&(this.h.delete(I),this.k?.id===k.id&&(this.k=void 0),m.push(k))}if(p.value.visibleEditors){this.l=p.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const I=new Set;this.l.forEach(k=>I.add(k.id));for(const k of this.h.values()){const d=I.has(k.id);k._acceptVisibility(d)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}p.value.newActiveEditor===null?this.k=void 0:p.value.newActiveEditor&&(this.h.get(p.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${p.value.newActiveEditor}`),this.k=this.h.get(p.value.newActiveEditor)),p.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(p){const m=b.$SM.String.with("notebookType","A notebook type"),I=new b.$UM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new b.$SM("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>L.$be.wrap(d))],new b.$TM("Notebook Data",d=>v.NotebookData.to(d.value))),k=new b.$UM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new b.$SM("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new t.$tv(v.NotebookData.from(d)))],new b.$TM("Bytes",d=>d.buffer));p.registerApiCommand(I),p.registerApiCommand(k)}}e.$hec=c}),define(Ae[282],Re([1,0,20,19,38,39,25,49,42]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class g{constructor(o,b,v){this.k=o,this.l=b,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=o.filePattern,this.b=o.includePattern&&M.$wj(o.includePattern),this.c=o.maxResults||void 0,this.d=o.exists,this.h=new Set,this.j=o.excludePattern&&M.$wj(o.excludePattern)}cancel(){this.g=!0,this.h.forEach(o=>o.cancel()),this.h=new Set}search(o){const b=this.k.folderQueries||[];return new Promise((v,f)=>{const t=i=>{this.f++,o(i)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),u=E.$mc(r);this.j&&this.j(r,u)||this.v(t,{base:i,basename:u})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{v({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,P.$Ai)(i)))})})}async p(o,b){const v=new L.$Xd,f=this.q(o),t=this.r(),i=new D.$$I(this.k,o),r=!i.hasSiblingExcludeClauses();let u;try{this.h.add(v),u=$.$Jd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,v.token),l=u.elapsed(),n=$.$Jd.create();return this.g&&!this.e||(a&&a.forEach(s=>{const c=E.$fc.relative(o.folder.path,s.path);if(r){const h=E.$mc(s.path);this.v(b,{base:o.folder,relativePath:c,basename:h});return}this.s(t,o.folder,c,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:l,postProcessTime:n.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(o){const b=(0,D.$0I)(this.k.includePattern,o.includePattern),v=(0,D.$0I)(this.k.excludePattern,o.excludePattern);return{folder:o.folder,excludes:v,includes:b,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}s({pathToEntries:o},b,v,f){if(v===this.a){const i=E.$mc(this.a);this.v(f,{base:b,relativePath:this.a,basename:i})}function t(i){const r=E.$mc(i),u=E.$lc(i);let a=o[u];a||(a=o[u]=[],t(u)),a.push({base:b,relativePath:i,basename:r})}t(v)}u({rootEntries:o,pathToEntries:b},v,f){const t=this,i=this.a;function r(u){const a=(0,D.$aJ)(()=>u.map(l=>l.basename));for(let l=0,n=u.length;l<n;l++){const s=u[l],{relativePath:c,basename:h}=s;if(v.matchesExcludesSync(c,h,i!==h?a:void 0))continue;const p=b[c];if(p)r(p);else{if(c===i)continue;t.v(f,s)}if(t.e)break}}r(o)}v(o,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||o(b))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(o,b,v,f){const t=this.c(o.cacheKey),i=new g(o,b,t&&t.token);let r=0;const u=a=>{r+=a.length,v(a.map(l=>this.d(l)))};return this.e(i,A.a,u,f).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(o){this.c(o)?.cancel()}c(o){if(o)return this.b.has(o)||this.b.set(o,new L.$Xd),this.b.get(o)}d(o){return o.relativePath?{resource:R.$vg(o.base,o.relativePath)}:{resource:o.base}}e(o,b,v,f){const t=f.onCancellationRequested(()=>{o.cancel()}),i=u=>{u&&(r.push(u),b>0&&r.length>=b&&(v(r),r=[]))};let r=[];return o.search(i).then(u=>(r.length&&v(r),t.dispose(),u),u=>(r.length&&v(r),t.dispose(),Promise.reject(u)))}}e.$9dc=A}),define(Ae[283],Re([1,0,18,245,39,93,28,14,20,25,13,16,2,92,178,46,15,57,105,279,42]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=void 0;let l=class{constructor(y,w,C,j,B){this.a=y,this.b=w,this.c=C,this.d=j,this.e=B}text(y,w,C={}){y=this.f(y,C);const j=this.a.getValue(),B=w&&w.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(w?.map(i.$$h),C),type:2,contentPattern:y,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:j.search.usePCRE2||B||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(y,w){const C=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const j={...y,wordSeparators:C.editor.wordSeparators};return this.j(y,w)&&(j.isCaseSensitive=!0),this.k(y)&&(j.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),j}file(y,w={}){return{...this.h(y,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(y,w){return y?(y=Array.isArray(y)?y.map(p):p(y),w?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],w={}){const C=this.g(w.includePattern,w.expandPatterns),j=this.g(w.excludePattern,w.expandPatterns),B=y.length>1,W=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(O=>this.q(O,w,j)):y.map(O=>this.r(O,w,j,B))).filter(O=>!!O),U={_reason:w._reason,folderQueries:W,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:j.pattern,includePattern:C.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=E.$Gb(E.$Qb(this.c.groups.map(Ee=>Ee.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const ee=O.filter(Ee=>(0,a.$1I)(U,Ee.fsPath)),X=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...U,...X}}const F=w.extraFileResources&&w.extraFileResources.filter(O=>(0,a.$1I)(U,O.fsPath));return U.extraFileResources=F&&F.length?F:void 0,U}i(y){const w=[],C=new R.$zc,j={};let B=!1;return y.forEach(W=>{if(W.scheme===$.Schemas.walkThrough)return;if((0,g.$zg)(W)){const F=this.b.getWorkspaceFolder(W)?.uri??W.with({path:D.$lc(W.fsPath)});let O=C.get(F);O||(B=!0,O={folder:F,includePattern:{}},w.push(O),C.set(F,O));const ee=D.$kc(F.fsPath,W.fsPath);(0,S.$Jf)(O.includePattern)[ee.replace(/\\/g,"/")]=!0}else W.fsPath&&(B=!0,j[W.fsPath]=!0)}),{folderQueries:w,includePattern:j,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(y,w){if(w.isSmartCase){if(y.isRegExp){if(A.$pf(y.pattern,!0))return!0}else if(A.$pf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,b.$yB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const w=X=>D.$hc(X)||/^\.\.?([\/\\]|$)/.test(X),j=(Array.isArray(y)?y:c(y)).map(X=>{const Ee=this.e.resolvedUserHome;return Ee?(0,M.$xv)(X,Ee.scheme===$.Schemas.file?Ee.fsPath:Ee.path):X}),B=L.$J(j,X=>w(X)?"searchPaths":"exprSegments"),W=(B.exprSegments||[]).map(X=>A.$Ke(X,"/")).map(X=>A.$Ke(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),h(X))),U={},F=this.m(B.searchPaths||[]);F&&F.length&&(U.searchPaths=F);const O=E.$Qb(W),ee=s(...O);return ee&&(U.pattern=ee),U}l(y,w){return w.disregardExcludeSettings?void 0:(0,a.$ZI)(y,!w.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const w=y.flatMap(j=>{let{pathPortion:B,globPortion:W}=n(j);return W&&(W=m(W)),this.n(B).flatMap(F=>this.o(F,W))}),C=new Map;return w.forEach(j=>{const B=j.searchPath.toString(),W=C.get(B);W?j.pattern&&(W.pattern=W.pattern||{},W.pattern[j.pattern]=!0):C.set(B,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(C.values())}n(y){if(D.$hc(y)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==$.Schemas.file?[{searchPath:w[0].uri.with({path:y})}]:[{searchPath:o.URI.file(D.$gc(y))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(y=p(y),y.startsWith("../")||y===".."){const j=D.$fc.resolve(w.path,y);return[{searchPath:w.with({path:j})}]}const C=m(y);return[{searchPath:w,pattern:C}]}else{if(y==="./"||y===".\\")return[];{const w=y.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(B=>{const W=w.match(new RegExp(`^${A.$Fe(B.name)}(?:/(.*)|$)`));return W?{match:W,folder:B}:null}).filter(S.$Gf);if(j.length)return j.map(B=>{const W=B.match[1];return{searchPath:B.folder.uri,pattern:W&&m(W)}});{const B=y.match(/\.[\/\\](.+)[\/\\]?/),W=B?B[1]:y,U=v.localize(0,null,W);throw new Error(U)}}}}o(y,w){const C=y.pattern&&w?`${y.pattern}/${w}`:y.pattern||w,j=[{searchPath:y.searchPath,pattern:C}];return C&&!C.endsWith("**")&&j.push({searchPath:y.searchPath,pattern:C+"/**"}),j}q(y,w,C){const j=this.r((0,i.$$h)(y.searchPath),w,C,!1);return j?{...j,includePattern:y.pattern}:null}r(y,w,C,j){let B;const W=o.URI.isUri(y)?y:y.uri;if(C.searchPaths){const X=C.searchPaths.filter(Ee=>(0,g.$og)(Ee.searchPath,W))[0];if(X&&!X.pattern)return null;X&&(B=X.pattern)}const U=this.a.getValue({resource:W}),O={...this.l(U,w)||{},...B||{}},ee=o.URI.isUri(y)?(0,g.$sg)(y):y.name;return{folder:W,folderName:j?ee:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!U.search.followSymlinks}}};e.$7J=l,e.$7J=l=Ke([Ve(0,f.$ji),Ve(1,i.$Yh),Ve(2,r.$rC),Ve(3,t.$0i),Ve(4,u.$5J)],l);function n(d){const y=d.match(/[\*\{\}\(\)\[\]\?]/);if(y){const w=y.index,C=d.substr(0,w).match(/[/|\\][^/\\]*$/);if(C){let j=d.substr(0,C.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:d.substr((C.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((y,w)=>(y[w]=!0,y),Object.create(null)):void 0}function c(d){return P.$uj(d,",").map(y=>y.trim()).filter(y=>!!y.length)}function h(d){return[`**/${d}/**`,`**/${d}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function p(d){return d.replace(/\\/g,"/")}function m(d){return p(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(d){return d.replace(/([?*[\]])/g,"[$1]")}function k(d,y){d=E.$Lb(d,j=>j.toString());const w=[],C=y.getWorkspace();return d&&d.forEach(j=>{let B;if(y.getWorkbenchState()===2)B=(0,g.$xg)(C.folders[0].uri,j),B&&B!=="."&&(B="./"+B);else{const W=y.getWorkspaceFolder(j);if(W){const U=W.name;if(C.folders.filter(O=>O.name===U).length===1){const O=(0,g.$xg)(W.uri,j);O===""?B=`./${W.name}`:B=`./${W.name}/${O}`}else B=j.fsPath}}B&&w.push(I(B))}),w}e.$8J=k}),define(Ae[284],Re([1,0,25,2,19,11,4,283,42,57]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlb=e.$Wlb=void 0;const A=7e3;function S(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],u=[];for(const h of i)if(/^workspaceContains:/.test(h)){const p=h.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||f.forceUsingSearch?u.push(p):r.push(p)}if(r.length===0&&u.length===0)return Promise.resolve(void 0);let a;const l=new Promise((h,p)=>{a=h}),n=h=>a({activationEvent:h}),s=Promise.all(r.map(h=>o(f,h,n))).then(()=>{}),c=b(f,t.identifier,u,n);return Promise.all([s,c]).then(()=>{a(void 0)}),l}e.$Wlb=S;async function o(f,t,i){for(const r of f.folders)if(await f.exists(E.$vg(L.URI.revive(r),t))){i(`workspaceContains:${t}`);return}}async function b(f,t,i,r){if(i.length===0)return Promise.resolve(void 0);const u=new P.$Xd,a=f.checkExists(f.folders,i,u.token),l=setTimeout(async()=>{u.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let n=!1;try{n=await a}catch(s){M.$3(s)||M.$Z(s)}u.dispose(),clearTimeout(l),n&&r(`workspaceContains:${i.join(",")}`)}function v(f,t,i,r){const u=f.get(R.$Oh),a=f.get(D.$RI),n=u.createInstance($.$7J).file(t.map(s=>(0,g.$$h)(L.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(n,r).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$Xlb=v}),define(Ae[36],Re([1,0,159,20,87,25,12,6,50,2,15,3,35,216,84,34,24,106,11,21,22,199,7,100,4,27,85,17,71,86,64,5,284,83,201,14,81,49,23,82]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s,c,h,p,m,I,k,d,y,w,C,j,B,W,U,F,O){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=e.$sdc=e.$rdc=void 0,e.$rdc=(0,c.$Ph)("IHostUtils");let X=ee=class extends $.$Rc{constructor(te,V,Y,_,pe,$e,de,De,re,he,ne,ae){super(),this.X=ae,this.a=this.B(new y.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=Y,this.f=de,this.j=_,this.m=pe,this.s=$e,this.t=re,this.u=he,this.w=ne,this.y=this.g.getProxy(S.$tK.MainThreadWorkspace),this.z=this.g.getProxy(S.$tK.MainThreadTelemetry),this.C=this.g.getProxy(S.$tK.MainThreadExtensionService),this.D=new R.$Sg,this.F=new R.$Sg,this.G=new R.$Sg,this.H=new R.$Sg,this.I=new oe(this.f.extensions.activationEvents),this.L=new i.$Z4b(this.I,this.f.extensions.allExtensions);const ge=new u.$7l(this.f.extensions.myExtensions);this.J=new i.$Z4b(this.I,be(this.L,ge)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new v.$$cc(this.g,this.s),this.N=new C.$kdc(this.g),this.O=De,this.h=te.createChild(new I.$Nh([v.$_cc,this.M],[C.$ldc,this.N])),this.P=this.B(new b.$0cc(this.J,this.L,{onExtensionActivationError:(Ce,T,q)=>{this.C.$onExtensionActivationError(Ce,r.$2(T),q)},actualActivateExtension:async(Ce,T)=>{if(i.$Z4b.isHostExtension(Ce,this.J,this.L))return await this.C.$activateExtension(Ce,T),new b.$9cc;const q=this.J.getExtensionDescription(Ce);return this.db(q,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(te){r.$Z(te)}}async Y(){this.O.onWillDeactivateAll();let te=[];try{te=this.J.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.cb(pe))}catch{}await Promise.all(te)}terminate(te,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${te}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(_=>{this.s.error(_)}),this.g.dispose();const Y=this.Y();Promise.race([(0,R.$Ug)(5e3),Y]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(te){return this.G.isOpen()?this.P.isActivated(te):!1}async getExtension(te){const V=await this.C.$getExtension(te);return V&&{...V,identifier:new u.$6l(V.identifier.value),extensionLocation:g.URI.revive(V.extensionLocation)}}Z(te,V){return this.P.activateByEvent(te,V)}$(te,V){return this.P.activateById(te,V)}activateByIdWithErrors(te,V){return this.$(te,V).then(()=>{const Y=this.P.getActivatedExtension(te);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(te=>this.J)}getExtensionExports(te){if(this.G.isOpen())return this.P.getActivatedExtension(te).exports;try{return this.P.getActivatedExtension(te).exports}catch{return null}}async ab(te){if(te.scheme===B.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(te.fsPath);return g.URI.file(V)}return te}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(te=>new ue(te))),this.Q}async bb(te){const V=D.$Vh.forUris(Y=>M.$mg.ignorePathCasing(Y));return await Promise.all(te.map(async Y=>{if(this.ub(Y)){const _=await this.ab(Y.extensionLocation);V.set(_,Y)}})),V}cb(te){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(te))return V;const Y=this.P.getActivatedExtension(te);if(!Y)return V;try{typeof Y.module.deactivate=="function"&&(V=Promise.resolve(Y.module.deactivate()).then(void 0,_=>(this.s.error(_),Promise.resolve(void 0))))}catch(_){this.s.error(`An error occurred when deactivating the extension '${te.value}':`),this.s.error(_)}try{(0,$.$Mc)(Y.subscriptions)}catch(_){this.s.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.s.error(_)}return V}async db(te,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(te.identifier):await this.C.$onWillActivateExtension(te.identifier),this.fb(te,V).then(Y=>{const _=Y.activationTimes;return this.C.$onDidActivateExtension(te.identifier,_.codeLoadingTime,_.activateCallTime,_.activateResolvedTime,V),this.eb(te,V,"success",_),Y},Y=>{throw this.eb(te,V,"failure"),Y})}eb(te,V,Y,_){const pe=ke(te,V);this.z.$publicLog2("extensionActivationTimes",{...pe,..._||{},outcome:Y})}fb(te,V){const Y=ke(te,V);this.z.$publicLog2("activatePlugin",Y);const _=this.ub(te);if(!_)return Promise.resolve(new b.$8cc(b.$5cc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${te.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const pe=new b.$6cc(V.startup);return Promise.all([this.vb(te,(0,M.$vg)(te.extensionLocation,_),pe),this.gb(te)]).then($e=>(P.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),ee.hb(this.s,te.identifier,$e[0],$e[1],pe))).then($e=>(P.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),$e))}gb(te){const V=new l.$bdc(te,this.M),Y=new l.$adc(te.identifier.value,!1,this.M),_=new j.$mdc(te,this.N),pe=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,$e=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([V.whenReady,Y.whenReady,this.O.whenReady]).then(()=>{const de=this;let De,re;const he=(0,t.$kF)(te,"ipc")?this.f.messagePorts?.get(u.$6l.toKey(te.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:Y,secrets:_,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(ne){return L.$ic(te.extensionLocation.fsPath,ne)},get storagePath(){return de.O.workspaceValue(te)?.fsPath},get globalStoragePath(){return de.O.globalValue(te).fsPath},get logPath(){return L.$ic(de.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return g.URI.joinPath(de.f.logsLocation,te.identifier.value)},get storageUri(){return de.O.workspaceValue(te)},get globalStorageUri(){return de.O.globalValue(te)},get extensionMode(){return pe},get extension(){return De===void 0&&(De=new le(de,te.identifier,te,$e,!1)),De},get extensionRuntime(){return(0,t.$lF)(te,"extensionRuntime"),de.extensionRuntime},get environmentVariableCollection(){return de.u.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!re){if(!he)return;const ne=y.Event.buffer(y.Event.fromDOMEventEmitter(he,"message",ae=>ae.data));he.start(),re={onDidReceiveMessage:ne,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(te,V,Y,_,pe){return Y=Y||{activate:void 0,deactivate:void 0},this.ib(te,V,Y,_,pe).then($e=>new b.$7cc(!1,null,pe.build(),Y,$e,_.subscriptions))}static ib(te,V,Y,_,pe){if(typeof Y.activate=="function")try{pe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${V.value}`);const $e=typeof global=="object"?global:self,de=Y.activate.apply($e,[_]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(de).then(De=>(pe.activateResolveStop(),De))}catch($e){return Promise.reject($e)}else return Promise.resolve(Y)}jb(te,V){this.$(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:V}).then(void 0,Y=>{this.s.error(Y)})}kb(te,V=0){const _=Date.now();(0,F.$B)(()=>{for(let pe=V;pe<te.length;pe+=1){const $e=te[pe];for(const de of $e.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-_>50){this.kb(te,pe);break}else this.jb($e,de)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(te=>{const V=te.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Y=this.J.getAllExtensionDescriptions();if(V)this.kb(Y);else for(const _ of Y)if(_.activationEvents)for(const pe of _.activationEvents)pe==="onStartupFinished"&&this.jb(_,pe)})}mb(){const te=this.Z("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.nb($e.added)));const V=this.j.workspace?this.j.workspace.folders:[],Y=this.nb(V),_=this.pb(),pe=Promise.all([_,te,Y]).then(()=>{});return Promise.race([pe,(0,R.$Ug)(1e4)]).then(()=>{this.lb()}),pe}nb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(te,V))).then(()=>{})}async ob(te,V){if(this.isActivated(V.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,_={logService:this.s,folders:te.map($e=>$e.uri),forceUsingSearch:Y||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,de,De)=>this.y.$checkExists($e,de,De)},pe=await(0,w.$Wlb)(_,V);if(pe)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:pe.activationEvent}).then(void 0,$e=>this.s.error($e))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(te){throw console.error(te),te}}async qb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:V}=this.f.environment;if(!te||!V)throw new Error(E.localize(0,null));const Y=await this.vb(null,V,new b.$6cc(!1));if(!Y||typeof Y.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((_,pe)=>{const $e=(re,he)=>{re?(F.$t&&this.s.error("Test runner called back with error",re),pe(re)):(F.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),_(typeof he=="number"&&he>0?1:0))},de=(0,M.$jg)(V),De=Y.run(de,$e);De&&De.then&&De.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),_(0)}).catch(re=>{F.$t&&this.s.error("Test runner finished with error",re),pe(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,V){return this.R[te]=V,(0,$.$Pc)(()=>{delete this.R[te]})}async getRemoteExecServer(te){const{resolver:V}=await this.sb(te);return V?.resolveExecServer?.(te,{resolveAttempt:0})}async sb(te){const V=te.indexOf("+");if(V===-1)throw new n.$BK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Y=te.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.R[Y]}}async $resolveAuthority(te,V){const Y=U.$Jd.create(!1),_=()=>`[resolveAuthority(${(0,s.$Tk)(te)},${V})][${Y.elapsed()}ms] `,pe=J=>this.s.info(`${_()}${J}`),$e=J=>this.s.warn(`${_()}${J}`),de=(J,K=void 0)=>this.s.error(`${_()}${J}`,K),De=J=>{if(J instanceof n.$BK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},re=async J=>{pe(`activating resolver for ${J}...`);const{resolver:K,authorityPrefix:x}=await this.sb(J);if(!K)throw de(`no resolver for ${x}`),new n.$BK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:x,remoteAuthority:J}},he=te.split(/@|%40/g).reverse();pe(`activating remote resolvers ${he.join(" -> ")}`);let ne;try{ne=await Promise.all(he.map(re)).catch(async J=>{if(!(J instanceof n.$BK)||J._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return $e(`resolving nested authorities failed: ${J.message}`),[await re(te)]})}catch(J){return De(J)}const ae=new R.$5g;ae.cancelAndSet(()=>pe("waiting..."),1e3);let ge,Ce;for(const[J,{authorityPrefix:K,resolver:x,remoteAuthority:ce}]of ne.entries())try{if(J===ne.length-1)pe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),ge=await x.resolve(ce,{resolveAttempt:V,execServer:Ce}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$AK.isManagedResolvedAuthority(ge)?ge:void 0));else{if(pe(`invoking resolveExecServer() for ${ce}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ce=await x.resolveExecServer?.(ce,{resolveAttempt:V,execServer:Ce}),!Ce)throw new n.$BK(`Exec server was not available for ${ce}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(Ne){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),de("returned an error",Ne),ae.dispose(),De(Ne)}ae.dispose();const T={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures},q={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};pe(`returned ${n.$AK.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let G;if(n.$AK.isManagedResolvedAuthority(ge)){const J=V;this.X.setFactory(J,ge.makeConnection),G={authority:te,connectTo:new s.$Qk(J),connectionToken:ge.connectionToken}}else G={authority:te,connectTo:new s.$Rk(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:G,options:q,tunnelInformation:T}}}async $getCanonicalURI(te,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Tk)(te)})`);const{resolver:Y}=await this.sb(te);if(!Y)return null;const _=g.URI.revive(V);if(typeof Y.getCanonicalURI>"u")return _;const pe=await(0,R.$Mg)(()=>Y.getCanonicalURI(_));return pe||_}$startExtensionHost(te){te.toAdd.forEach(_=>_.extensionLocation=g.URI.revive(_.extensionLocation));const{globalRegistry:V,myExtensions:Y}=Ee(this.I,this.L,this.J,te);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(Y),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(te,V){return V===1?this.D.wait().then(Y=>this.Z(te,!1)):this.G.wait().then(Y=>this.Z(te,!1))}async $activate(te,V){return await this.G.wait(),this.J.getExtensionDescription(te)?(await this.$(te,V),!0):!1}async $deltaExtensions(te){te.toAdd.forEach($e=>$e.extensionLocation=g.URI.revive($e.extensionLocation));const{globalRegistry:V,myExtensions:Y}=Ee(this.I,this.L,this.J,te),_=await this.bb(Y);return(await this.getExtensionPathIndex()).setSearchTree(_),this.L.set(V.getAllExtensionDescriptions()),this.J.set(Y),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const V=a.$be.alloc(te),Y=Math.random()%256;for(let _=0;_<te;_++)V.writeUInt8(Y,_);return V}async $updateRemoteConnectionData(te){this.W=te,this.a.fire()}};e.$sdc=X,e.$sdc=X=ee=Ke([Ve(0,c.$Oh),Ve(1,e.$rdc),Ve(2,m.$uM),Ve(3,f.$Xcc),Ve(4,o.$1cc),Ve(5,A.$0i),Ve(6,h.$KM),Ve(7,p.$edc),Ve(8,k.$vwb),Ve(9,d.$gdc),Ve(10,W.$odc),Ve(11,O.$pdc)],X);function Ee(ye,te,V,Y){ye.addActivationEvents(Y.addActivationEvents);const _=new i.$Z4b(ye,te.getAllExtensionDescriptions());_.deltaExtensions(Y.toAdd,Y.toRemove);const pe=new u.$7l(V.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of Y.myToRemove)pe.delete(de);for(const de of Y.myToAdd)pe.add(de);const $e=be(_,pe);return{globalRegistry:_,myExtensions:$e}}function ke(ye,te){return{id:ye.identifier.value,name:ye.name,extensionVersion:ye.version,publisherDisplayName:ye.publisher,activationEvents:ye.activationEvents?ye.activationEvents.join(","):null,isBuiltin:ye.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}function Pe(ye){return ye.getAllExtensionDescriptions().map(te=>te.identifier.value).join(",")}e.$tdc=(0,c.$Ph)("IExtHostExtensionService");class le{#e;#t;#i;constructor(te,V,Y,_,pe){this.#e=te,this.#t=V,this.#i=Y.identifier,this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=L.$gc((0,M.$jg)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=_,this.isFromDifferentExtensionHost=pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$udc=le;function be(ye,te){return ye.getAllExtensionDescriptions().filter(V=>te.has(V.identifier))}class ue{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.$vdc=ue;class oe{constructor(te){this.a=new u.$8l,this.addActivationEvents(te)}readActivationEvents(te){return this.a.get(te.identifier)}addActivationEvents(te){for(const V of Object.keys(te))this.a.set(V,te[V])}}}),define(Ae[285],Re([1,0,87,2,3,35,24,21,17,27,4,36,15,13]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;let f=class{constructor(a,l,n,s,c,h,p){this.c=a,this.d=l,this.e=n,this.f=s,this.g=c,this.h=h,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,a,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,l,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const l of a.nodeModuleName)this.a.set(l,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(l=>a.alternativeModuleName(l))}};e.$Tec=f,e.$Tec=f=Ke([Ve(2,A.$Oh),Ve(3,M.$1cc),Ve(4,S.$tdc),Ve(5,g.$KM),Ve(6,o.$0i)],f);let t=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&v.a.size){const l=(0,b.$Fe)(this.c(a.environment.appRoot.fsPath)),n="[a-z0-9_.-]",s=`@${n}+\\/${n}+|${n}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const l=this.b.exec(this.c(a));if(!l)return;const[,n,s,c]=l,h=v.a.get(s);if(h!==void 0)return console.warn(`${s} as been renamed to ${h}, please update your imports`),n+h+c}c(a){return a.replace(/\\/g,"/")}};t=v=Ke([Ve(0,g.$KM)],t);class i{constructor(a,l,n,s,c){this.c=a,this.d=l,this.e=n,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new $.$8l}load(a,l){const n=this.d.findSubstr(l);if(n){let s=this.a.get(n.identifier);return s||(s=this.c(n,this.e,this.f),this.a.set(n.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,h)=>s+=`	${h} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$fF,this.e,this.f)}return this.b}}let r=class{constructor(a,l,n){this.e=a,this.f=l,this.nodeModuleName=["open","opn"],this.d=n.getProxy(P.$tK.MainThreadTelemetry);const s=n.getProxy(P.$tK.MainThreadWindow);this.c=(c,h)=>{const p=L.URI.parse(c);return h?this.g(c,h):p.scheme==="http"||p.scheme==="https"?s.$openUri(p,c,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?s.$openUri(p,c,{}):this.g(c,h)}}load(a,l,n){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=n(a),this.c}g(a,l){return this.i(),this.b(a,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ke([Ve(2,D.$uM)],r)}),define(Ae[115],Re([1,0,43,6,20,73,4,61,62,36,7,34,213,35]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0,e.$2dc=(0,R.$Ph)("IExtHostVariableResolverProvider");class v extends o.$vN{constructor(i,r,u,a,l,n,s){function c(){if(u){const h=u.activeEditor();if(h)return h.document.uri;const p=a.tabGroups.all.find(m=>m.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof A.$bM||p.input instanceof A.$gM)return p.input.modified;if(p.input instanceof A.$aM||p.input instanceof A.$fM||p.input instanceof A.$dM)return p.input.uri}}}super({getFolderUri:h=>{const p=n.folders.filter(m=>m.name===h);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(h,p)=>l.getConfiguration(void 0,h).get(p),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=c();if(h)return P.$gc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const h=c();if(h){const p=r.getWorkspaceFolder(h);if(p)return P.$gc(p.uri.fsPath)}}},getSelectedText:()=>{if(u){const h=u.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(u){const h=u.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>i.getExtension(h)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let f=class extends L.$Rc{constructor(i,r,u,a,l){super(),this.b=i,this.c=r,this.g=u,this.h=a,this.j=l,this.a=new E.$U(async()=>{const n=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,n,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$3dc=f,e.$3dc=f=Ke([Ve(0,g.$tdc),Ve(1,S.$Xcc),Ve(2,$.$FM),Ve(3,b.$1cc),Ve(4,D.$Zdc)],f)}),define(Ae[116],Re([1,0,12,5,2,4,3,62,36,17,7,34,205,207,35,115]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=e.$6dc=e.$5dc=e.$4dc=void 0,e.$4dc=(0,M.$Ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,h,p,m,I){this.E=c,this.F=h,this.G=p,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Nd,this.n=new L.$Nd,this.o=new L.$Nd,this.u=new L.$Nd,this.k=s.getProxy(R.$tK.MainThreadDebugService),this.y=new L.$Nd,this.A=new L.$Nd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(d=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,c){const h=s;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let p=`debug:${encodeURIComponent(h.path||"")}`,m="?";return c&&(p+=`${m}session=${encodeURIComponent(c.id)}`,m="&"),p+=`${m}ref=${h.sourceReference}`,P.URI.parse(p)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const c=[];for(const h of s.getAllExtensionDescriptions())if(h.contributes){const p=h.contributes.debuggers;if(p&&p.length>0)for(const m of p)(0,b.$zF)(m)&&c.push(m.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){const c=s.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(c,[],[]);const h=[],p=new Map;for(const m of c)if(m instanceof A.$uL){let I=p.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},p.set(m.location.uri.toString(),I),h.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof A.$vL&&h.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(s){const c=s.filter(I=>this.w.delete(I.id));this.U([],c,[]);const h=c.filter(I=>I instanceof A.$uL).map(I=>I.id),p=c.filter(I=>I instanceof A.$vL).map(I=>I.id),m=c.filter(I=>I instanceof A.$wL).map(I=>I.id);return this.k.$unregisterBreakpoints(h,p,m)}startDebugging(s,c,h){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,h){if(!c)return new A.$vK(()=>{});const p=this.d++;return this.f.push({type:s,handle:p,provider:c}),this.k.$registerDebugConfigurationProvider(s,h,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,p),new A.$vK(()=>{this.f=this.f.filter(m=>m.provider!==c),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(s,c,h){if(!h)return new A.$vK(()=>{});if(!this.Q(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:c,handle:p,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(c,p),new A.$vK(()=>{this.h=this.h.filter(m=>m.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new A.$vK(()=>{});const h=this.i++;return this.j.push({type:s,handle:h,factory:c}),new A.$vK(()=>{this.j=this.j.filter(p=>p.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let h;const p=await this.W(s);return p&&(h={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,c)}K(s,c){if(s.type==="implementation")return new a(s.implementation)}L(){}async $startDASession(s,c){const h=this,p=await this.V(c);return this.S(this.N(p.type),p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const I=this.M(m),k=this.K(I,p);if(!k)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const d=k;return this.B.set(s,d),this.R(p).then(y=>(y&&this.C.set(s,y),d.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const C=w,j={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const B=await this.D.sign(C.arguments.value);j.body={signature:B},d.sendResponse(j)}else throw new Error("no signer")}catch(B){j.success=!1,j.message=B.message,d.sendResponse(j)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(w),w=(0,b.$EF)(w,!0),h.k.$acceptDAMessage(s,w)}),d.onError(w=>{y&&y.onError&&y.onError(w),this.k.$acceptDAError(s,w.name,w.message,w.stack)}),d.onExit(w=>{y&&y.onExit&&y.onExit(w??void 0,void 0),this.k.$acceptDAExit(s,w??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),d.startSession()))})}$sendDAMessage(s,c){c=(0,b.$DF)(c,!1);const h=this.C.get(s);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(c),this.B.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.C.get(s);this.C.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const h=this.B.get(s);return this.B.delete(s),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],h=[],p=[];if(s.added)for(const m of s.added){const I=m.id;if(I&&!this.w.has(I)){let k;if(m.type==="function")k=new A.$vL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new A.$wL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const d=P.URI.revive(m.uri);k=new A.$uL(new A.$HK(d,new A.$wK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,A.$sL)(k,I),this.w.set(I,k),c.push(k)}}if(s.removed)for(const m of s.removed){const I=this.w.get(m);I&&(this.w.delete(m),h.push(I))}if(s.changed){for(const m of s.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof A.$vL&&m.type==="function"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(I instanceof A.$uL&&m.type==="source"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new A.$HK(P.URI.revive(m.uri),new A.$wK(m.line,m.character))}p.push(I)}}}this.U(c,h,p)}async $acceptStackFrameFocus(s){let c;const h=s.sessionId?await this.V(s.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?c=new A.$CL(h,s.threadId):c=new A.$BL(h,s.threadId,s.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(s,c,h){return(0,E.$Mg)(async()=>{const p=this.P(s);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(c);return p.provideDebugConfigurations(m,h)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(s,c,h,p){return(0,E.$Mg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(c);return m.resolveDebugConfiguration(I,h,p)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,h,p){return(0,E.$Mg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(c);return m.resolveDebugConfigurationWithSubstitutedVariables(I,h,p)})}async $provideDebugAdapter(s,c){const h=this.O(s);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(c);return this.S(h,p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const p={session:await this.V(s),event:c.event,body:c.body};this.u.fire(p)}M(s){if(s instanceof A.$xL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$yL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$zL)return{type:"pipeServer",path:s.path};if(s instanceof A.$AL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const c=this.h.filter(h=>h.type===s);if(c.length>0)return c[0].factory}O(s){const c=this.h.filter(h=>h.handle===s);if(c.length>0)return c[0].factory}P(s){const c=this.f.filter(h=>h.handle===s);if(c.length>0)return c[0].provider}Q(s,c){if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0){for(const p of h)if(p.label&&p.type&&p.type===c)return!0}}return!1}R(s){const h=s.configuration.type,p=this.j.filter(m=>m.type===h||m.type==="*").map(m=>(0,E.$Mg)(()=>m.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(p).then(m=>{const I=m.filter(k=>!!k);if(I.length>0)return new u(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,c){const h=c.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.$yL(h));if(s){const m=await this.F.getExtensionRegistry();return(0,E.$Mg)(()=>s.createDebugAdapterDescriptor(c,this.T(c,m))).then(I=>{if(I)return I})}const p=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,p))}T(s,c){}U(s,c,h){(s.length>0||c.length>0||h.length>0)&&this.y.fire(Object.freeze({added:s,removed:c,changed:h}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const h=await this.W(s.folderUri),p=s.parent?this.l.get(s.parent):void 0;c=new i(this.k,s.id,s.type,s.name,h,s.configuration,p),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=P.URI.revive(s);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$5dc=t,e.$5dc=t=Ke([Ve(0,g.$uM),Ve(1,S.$Xcc),Ve(2,D.$tdc),Ve(3,v.$1cc),Ve(4,$.$Zdc),Ve(5,f.$2dc)],t);class i{constructor(s,c,h,p,m,I,k){this.d=s,this.f=c,this.g=h,this.h=p,this.i=m,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$6dc=i;class r{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$7dc=r;class u{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(h=>h.onExit?h.onExit(s,c):void 0)}}class a extends o.$ldb{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,c,h,p,m,I){super(s,c,h,p,m,I)}};e.$8dc=l,e.$8dc=l=Ke([Ve(0,g.$uM),Ve(1,S.$Xcc),Ve(2,D.$tdc),Ve(3,v.$1cc),Ve(4,$.$Zdc),Ve(5,f.$2dc)],l)}),define(Ae[286],Re([1,0,11,87,2,3,275,15,70,71,27,183,17,58,36,60]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=void 0;class t{static async installEarlyHandler(u){Error.stackTraceLimit=100;const a=u.get($.$0i),n=u.get(o.$uM).getProxy(M.$tK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{a.error(s);const c=E.$2(s);n.$onUnexpectedError(c)})}static async installFullHandler(u){const a=u.get($.$0i),l=u.get(o.$uM),n=u.get(v.$tdc),s=u.get(f.$OM),c=l.getProxy(M.$tK.MainThreadExtensionService),h=l.getProxy(M.$tK.MainThreadErrors),p=await n.getExtensionPathIndex(),m=new WeakMap;function I(y,w){if(m.has(y))return m.get(y).stack;let C="",j,B;for(const U of w)C+=`
	at ${U.toString()}`,B=U.getFileName(),!j&&B&&(j=p.findSubstr(P.URI.file(B)));const W=`${y.name||"Error"}: ${y.message||""}${C}`;return m.set(y,{extensionIdentifier:j?.identifier,stack:W}),W}const k=Symbol("prepareStackTrace wrapped");let d=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(y){if(y===I||!y||y[k]){d=y||I;return}d=function(w,C){return I(w,C),y.call(Error,w,C)},Object.assign(d,{[k]:!0})}}),E.setUnexpectedErrorHandler(y=>{a.error(y);const w=E.$2(y),C=m.get(y);if(!C?.extensionIdentifier){h.$onUnexpectedError(w);return}c.$onExtensionRuntimeError(C.extensionIdentifier,w);const j=s.onExtensionError(C.extensionIdentifier,y);a.trace("forwarded error to extension?",j,C)})}}e.$Uec=t;class i{constructor(u,a,l,n,s){this.a=l,this.b=new R.$94b(u,null,n),a=i.e(a,this.b);const c=new g.$Nh(...(0,D.$Ar)());c.set(A.$KM,{_serviceBrand:void 0,...a,messagePorts:s}),c.set(o.$uM,new o.$vM(this.b)),c.set(b.$Ucc,new b.$Vcc(n)),c.set(v.$rdc,l);const h=new S.$gq(c,!0);h.invokeFunction(t.installEarlyHandler),this.d=h.invokeFunction(p=>p.get($.$0i)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=h.invokeFunction(p=>p.get(v.$tdc)),this.c.initialize(),h.invokeFunction(t.installFullHandler)}async asBrowserUri(u){const a=this.b.getProxy(M.$tK.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(u))}terminate(u){this.c.terminate(u)}static e(u,a){u.extensions.allExtensions.forEach(n=>{n.extensionLocation=P.URI.revive(a.transformIncomingURIs(n.extensionLocation))}),u.environment.appRoot=P.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const l=u.environment.extensionDevelopmentLocationURI;return l&&(u.environment.extensionDevelopmentLocationURI=l.map(n=>P.URI.revive(a.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTelemetryLogResource)),u.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(u.nlsBaseUrl)),u.logsLocation=P.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.$Vec=i}),define(Ae[287],Re([1,0,18,12,19,38,14,20,25,2,42]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=e.$0dc=void 0;class S{constructor(r,u,a,l){this.d=r,this.e=u,this.f=a,this.g=l,this.a=null,this.b=!1,this.c=0}search(r,u){const a=this.d.folderQueries||[],l=new P.$Xd(u);return new Promise((n,s)=>{this.a=new b(r);let c=!1;const h=(p,m)=>{if(!c&&!this.b){const I=this.h(p);f(p)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,c=!0,l.cancel(),p=this.j(p,this.d.maxResults-this.c));const k=this.h(p);this.c+=k,(k>0||!f(p))&&this.a.add(p,m)}};Promise.all(a.map((p,m)=>this.k(p,I=>h(I,m),l.token))).then(p=>{l.dispose(),this.a.flush();const m=p.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||m,messages:(0,E.$Qb)(p.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},p=>{l.dispose();const m=(0,M.$Ai)(p);s(new Error(m))})})}h(r){return f(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,u){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],l=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,u),preview:{matches:l.slice(0,u),text:r.preview.text},uri:r.uri}}async k(r,u,a){const l=new A.$$I(this.d,r),n=[],s={report:p=>{if(!this.l(p))return;const m=r.folder.scheme===R.Schemas.file?(0,A.$_I)(()=>this.f.readdir(D.$ug(p.uri))):void 0,I=D.$xg(r.folder,p.uri);if(I){const k=l.includedInQuery(I,$.$mc(I),m);(0,L.$Gg)(k)?n.push(k.then(d=>{d&&u(p)})):k&&u(p)}}},c=this.n(r),h=await this.e.provideTextSearchResults(o(this.d.contentPattern),c,s,a);return n.length&&await Promise.all(n),h}l(r){if(f(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const u=(0,A.$0I)(this.d.includePattern,r.includePattern),a=(0,A.$0I)(this.d.excludePattern,r.excludePattern),l={folder:g.URI.from(r.folder),excludes:a,includes:u,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$0dc=S;function o(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new t(512,u=>this.g(u))}add(r,u){this.d&&(this.b!==u||!D.$og(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=u,this.d={resource:r.uri,results:[]}),this.d.results.push(v(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$$dc=b;function v(i){return f(i)?{preview:{matches:(0,E.$1b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,E.$1b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$_dc=f;class t{static{this.a=4e3}static{this.b=50}constructor(r,u){this.g=r,this.h=u,this.c=0,this.d=[],this.e=0}addItem(r,u){r&&this.j(r,u)}addItems(r,u){r&&this.k(r,u)}j(r,u){this.d.push(r),this.e+=u,this.l()}k(r,u){this.d=this.d.concat(r),this.e+=u,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$aec=t}),define(Ae[117],Re([1,0,6,3,4,282,17,58,15,2,287]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=e.$bec=void 0,e.$bec=(0,P.$Ph)("IExtHostSearch");let S=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(L.$tK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$9dc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,r){const u=o(i),a=this.h.get(f);if(a)return this.j.fileSearch(u,a,l=>{this.c.$handleFileMatch(f,t,l.map(n=>n.resource))},r);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,t,i){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,r){const u=this.e.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const a=o(i);return this.q(a,u).search(n=>this.c.$handleTextMatch(f,t,n),r)}$enableExtensionHostSearch(){}q(f,t){return new A.$0dc(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$cec=S,e.$cec=S=Ke([Ve(0,R.$uM),Ve(1,$.$Ucc),Ve(2,D.$0i)],S);function o(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(b),extraFileResources:v.extraFileResources&&v.extraFileResources.map(f=>g.URI.revive(f))}}e.$dec=o;function b(v){return{...v,folder:g.URI.revive(v.folder)}}}),define(Ae[288],Re([1,0,19,11,5,30,2,145,91,128,141,40,3,78,238,237,32,239,35,241,242,243,218,244,61,36,247,248,253,254,256,112,222,261,262,265,84,64,267,223,8,7,56,270,65,111,34,21,211,252,55,110,114,116,117,15,58,17,27,281,208,86,80,230,268,85,63,273,271,272,231,41,266,269,83,62,60,257,113,258,14,98,221,200,250,6,24,206,81,196,259,260,232,249,220,251,82,263,235,264,236,229,246,233,234]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s,c,h,p,m,I,k,d,y,w,C,j,B,W,U,F,O,ee,X,Ee,ke,Pe,le,be,ue,oe,ye,te,V,Y,_,pe,$e,de,De,re,he,ne,ae,ge,Ce,T,q,G,J,K,x,ce,Ne,je,Qe,Ge,_e,Ye,xe,it,tt,ze,ut,Z,Q,we,Be,Oe,Xe,nt,$t,bt,Pt,Kt,Ht,vt,Ut,Nt,Gt,jt,kt,Ft,Bt,Jt,Wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;function Ot(at){const dt=at.get(re.$KM),At=at.get(Ne.$Kcc),qt=at.get(G.$ddc),Rt=at.get(h.$tdc),ot=at.get(be.$Xcc),wt=at.get(Ye.$OM),Tt=at.get(r.$1cc),Ct=at.get(de.$Ucc),We=at.get(De.$uM),Qt=at.get(W.$_cc),Ie=at.get(q.$edc),Le=at.get($e.$$i),me=at.get($e.$0i),H=at.get(ae.$vwb),Me=at.get(ge.$Ncc),Ue=at.get(le.$Rdc),Je=at.get(Ge.$ldc),qe=at.get(_e.$Zdc),et=at.get(Nt.$pdc);We.set(o.$uK.ExtHostFileSystemInfo,At),We.set(o.$uK.ExtHostLogLevelServiceShape,Le),We.set(o.$uK.ExtHostWorkspace,ot),We.set(o.$uK.ExtHostConfiguration,Tt),We.set(o.$uK.ExtHostExtensionService,Rt),We.set(o.$uK.ExtHostStorage,Qt),We.set(o.$uK.ExtHostTunnelService,H),We.set(o.$uK.ExtHostWindow,Ue),We.set(o.$uK.ExtHostSecretState,Je),We.set(o.$uK.ExtHostTelemetry,wt),We.set(o.$uK.ExtHostEditorTabs,qe),We.set(o.$uK.ExtHostManagedSockets,et);const Et=We.set(o.$uK.ExtHostDecorations,at.get(V.$Vdc)),Dt=We.set(o.$uK.ExtHostDocumentsAndEditors,at.get(c.$FM)),gt=We.set(o.$uK.ExtHostCommands,at.get(t.$QM)),ht=We.set(o.$uK.ExtHostTerminalService,at.get(U.$gdc)),ft=We.set(o.$uK.ExtHostDebugService,at.get(_.$4dc)),ui=We.set(o.$uK.ExtHostSearch,at.get(pe.$bec)),St=We.set(o.$uK.ExtHostTask,at.get(Y.$Ydc)),Si=We.set(o.$uK.ExtHostOutputService,at.get(y.$Bdc)),li=We.set(o.$uK.ExtHostLocalization,at.get(nt.$odc)),$i=We.set(o.$uK.ExtHostUrls,new ke.$Kdc(We)),It=We.set(o.$uK.ExtHostDocuments,new s.$Icc(We,Dt)),gn=We.set(o.$uK.ExtHostDocumentContentProviders,new l.$3cc(We,Dt,me)),ri=We.set(o.$uK.ExtHostDocumentSaveParticipant,new n.$4cc(me,It,We.getProxy(o.$tK.MainThreadBulkEdits))),yt=We.set(o.$uK.ExtHostNotebook,new he.$hec(We,gt,Dt,It,qt,ui)),pi=We.set(o.$uK.ExtHostNotebookDocuments,new Q.$zec(yt)),vi=We.set(o.$uK.ExtHostNotebookEditors,new Z.$yec(me,yt)),si=We.set(o.$uK.ExtHostNotebookKernels,new xe.$vec(We,dt,yt,gt,me)),Ii=We.set(o.$uK.ExtHostNotebookRenderers,new tt.$xec(We,yt)),Ci=We.set(o.$uK.ExtHostNotebookDocumentSaveParticipant,new vt.$Fec(me,yt,We.getProxy(o.$tK.MainThreadBulkEdits))),Mt=We.set(o.$uK.ExtHostEditors,new F.$Idc(We,Dt)),bi=We.set(o.$uK.ExtHostTreeViews,new O.$Jdc(We.getProxy(o.$tK.MainThreadTreeViews),gt,me)),Pi=We.set(o.$uK.ExtHostEditorInsets,new oe.$Sdc(We.getProxy(o.$tK.MainThreadEditorInsets),Mt,dt.remote)),oi=We.set(o.$uK.ExtHostDiagnostics,new u.$Mcc(We,me,At,Dt)),hi=We.set(o.$uK.ExtHostLanguages,new k.$ydc(We,It,gt.converter,Ct)),ct=We.set(o.$uK.ExtHostLanguageFeatures,new I.$Qcc(We,Ct,It,gt,oi,me,Me,wt)),Ai=We.set(o.$uK.ExtHostFileSystem,new p.$wdc(We,ct)),Yt=We.set(o.$uK.ExtHostFileSystemEventService,new m.$xdc(We,me,Dt)),ii=We.set(o.$uK.ExtHostQuickOpen,(0,C.$Ddc)(We,ot,gt)),Ri=We.set(o.$uK.ExtHostSCM,new j.$Fdc(We,gt,It,me)),Mi=We.set(o.$uK.ExtHostQuickDiff,new Pt.$Cec(We,Ct)),Li=We.set(o.$uK.ExtHostShare,new Gt.$Hec(We,Ct)),Xi=We.set(o.$uK.ExtHostComments,(0,i.$Tcc)(We,gt,It)),Fi=We.set(o.$uK.ExtHostProgress,new w.$Cdc(We.getProxy(o.$tK.MainThreadProgress))),Zi=We.set(o.$uK.ExtHosLabelService,new ye.$Tdc(We)),Ti=We.set(o.$uK.ExtHostTheming,new ne.$iec(We)),ai=We.set(o.$uK.ExtHostAuthentication,new Ce.$jec(We)),mn=We.set(o.$uK.ExtHostTimeline,new T.$lec(We,gt)),Ni=We.set(o.$uK.ExtHostWebviews,new Pe.$Ndc(We,dt.remote,ot,me,Me)),di=We.set(o.$uK.ExtHostWebviewPanels,new x.$nec(We,Ni,ot)),Oi=We.set(o.$uK.ExtHostCustomEditors,new K.$oec(We,It,Ie,Ni,di)),$n=We.set(o.$uK.ExtHostWebviewViews,new J.$mec(We,Ni)),fi=We.set(o.$uK.ExtHostTesting,new je.$qec(We,gt,Dt)),Yi=We.set(o.$uK.ExtHostUriOpeners,new Qe.$uec(We)),zi=We.set(o.$uK.ExtHostProfileContentHandlers,new bt.$Bec(We));We.set(o.$uK.ExtHostInteractive,new we.$Aec(We,yt,Dt,gt,me));const xi=We.set(o.$uK.ExtHostInlineChat,new Ht.$Eec(We,gt,It,me)),gi=We.set(o.$uK.ExtHostChatProvider,new jt.$Iec(We,me)),_i=We.set(o.$uK.ExtHostChatAgents,new Wt.$Nec(We,gi,me)),pn=We.set(o.$uK.ExtHostChatAgents2,new Vt.$Oec(We,gi,me)),Ui=We.set(o.$uK.ExtHostChatVariables,new Ft.$Kec(We)),mi=We.set(o.$uK.ExtHostChat,new Kt.$Dec(We,me)),xt=We.set(o.$uK.ExtHostAiRelatedInformation,new Bt.$Lec(We)),wi=We.set(o.$uK.ExtHostAiEmbeddingVector,new Jt.$Mec(We)),en=We.set(o.$uK.ExtHostIssueReporter,new Ut.$Gec(We)),Xt=We.set(o.$uK.ExtHostStatusBar,new B.$Hdc(We,gt.converter)),yi=We.set(o.$uK.ExtHostSpeech,new kt.$Jec(We)),tn=Object.values(o.$uK);We.assertRegistered(tn);const nn=new ce.$pec(We,Dt),rn=new f.$Scc(We),Ei=new d.$zdc(We,me),sn=new a.$2cc(We);return v.$Rcc.register(gt),function(Te,_t,on){const mt=function(){let ie=!Te.isUnderDevelopment;function fe(){ie||(me.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")fe();else{const pt=rt;typeof pt.scheme>"u"&&fe(),typeof pt.exclusive=="boolean"&&(0,Oe.$lF)(Te,"documentFiltersExclusive")}return rt}}(),ji={getSession(ie,fe,Fe){return ai.getSession(Te,ie,fe,Fe)},getSessions(ie,fe){return(0,Oe.$lF)(Te,"authGetSessions"),ai.getSessions(Te,ie,fe)},async hasSession(ie,fe){return(0,Oe.$lF)(Te,"authSession"),!!await ai.getSession(Te,ie,fe,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Fe,rt){return ai.registerAuthenticationProvider(ie,fe,Fe,rt)}},an={registerCommand(ie,fe,Fe){return gt.registerCommand(!0,ie,fe,Fe,void 0,Te)},registerTextEditorCommand(ie,fe,Fe){return gt.registerCommand(!0,ie,(...rt)=>{const pt=Mt.getActiveTextEditor();if(!pt){me.warn("Cannot execute "+ie+" because there is no active text editor.");return}return pt.edit(Lt=>{fe.apply(Fe,[pt,Lt,...rt])}).then(Lt=>{Lt||me.warn("Edits from command "+ie+" were not applied.")},Lt=>{me.warn("An error occurred while running command "+ie,Lt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ie,fe,Fe)=>((0,Oe.$lF)(Te,"diffCommand"),gt.registerCommand(!0,ie,async(...rt)=>{const pt=Dt.activeEditor(!0);if(!pt){me.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(pt.id);fe.apply(Fe,[Lt,...rt])},void 0,void 0,Te)),executeCommand(ie,...fe){return gt.executeCommand(ie,...fe)},getCommands(ie=!1){return gt.getCommands(ie)}},Bi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$lF)(Te,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$lF)(Te,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$NM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,fe){return Ye.$MM.validateSender(ie),wt.instantiateLogger(Te,ie,fe)},openExternal(ie,fe){return Ue.openUri(ie,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===dt.environment.appUriScheme)return $i.createAppUri(ie);try{return await Ue.asExternalUri(ie,{allowTunneling:!!dt.remote.authority})}catch(fe){if((0,ut.$wU)(ie,ze.Schemas.http)||(0,ut.$wU)(ie,ze.Schemas.https))return ie;throw fe}},get remoteName(){return(0,te.$Vk)(dt.remote.authority)},get remoteAuthority(){return(0,Oe.$lF)(Te,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return me.getLevel()},get onDidChangeLogLevel(){return me.onDidChangeLogLevel},registerIssueUriRequestHandler(ie){return(0,Oe.$lF)(Te,"handleIssueUri"),en.registerIssueUriRequestHandler(Te,ie)},registerIssueDataProvider(ie){return(0,Oe.$lF)(Te,"handleIssueUri"),en.registerIssueDataProvider(Te,ie)},get appQuality(){return(0,Oe.$lF)(Te,"resolvers"),dt.quality},get appCommit(){return(0,Oe.$lF)(Te,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(ie,fe,Fe){return fi.createTestController(Te,ie,fe,Fe)},createTestObserver(){return(0,Oe.$lF)(Te,"testObserver"),fi.createTestObserver()},runTests(ie){return(0,Oe.$lF)(Te,"testObserver"),fi.runTests(ie)},get onDidChangeTestResults(){return(0,Oe.$lF)(Te,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Oe.$lF)(Te,"testObserver"),fi.results}},Di=dt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,vn={getExtension(ie,fe){(0,Oe.$kF)(Te,"extensionsAny")||(fe=!1);const Fe=_t.mine.getExtensionDescription(ie);if(Fe)return new h.$udc(Rt,Te.identifier,Fe,Di,!1);if(fe){const rt=_t.all.getExtensionDescription(ie);if(rt)return new h.$udc(Rt,Te.identifier,rt,Di,!0)}},get all(){const ie=[];for(const fe of _t.mine.getAllExtensionDescriptions())ie.push(new h.$udc(Rt,Te.identifier,fe,Di,!1));return ie},get allAcrossExtensionHosts(){(0,Oe.$lF)(Te,"extensionsAny");const ie=new ue.$7l(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const rt=!ie.has(Fe.identifier);fe.push(new h.$udc(Rt,Te.identifier,Fe,Di,rt))}return fe},get onDidChange(){return(0,Oe.$kF)(Te,"extensionsAny")?P.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(ie){return oi.createDiagnosticCollection(Te.identifier,ie)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ie=>oi.getDiagnostics(ie),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(ie,fe){return hi.changeLanguage(ie.uri,fe)},match(ie,fe){const Fe=It.getDocumentData(fe.uri)?.notebook;return(0,A.$xE)(ee.LanguageSelector.from(ie),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ie,fe,Fe){return ct.registerCodeActionProvider(Te,mt(ie),fe,Fe)},registerDocumentPasteEditProvider(ie,fe,Fe){return(0,Oe.$lF)(Te,"documentPaste"),ct.registerDocumentPasteEditProvider(Te,mt(ie),fe,Fe)},registerCodeLensProvider(ie,fe){return ct.registerCodeLensProvider(Te,mt(ie),fe)},registerDefinitionProvider(ie,fe){return ct.registerDefinitionProvider(Te,mt(ie),fe)},registerDeclarationProvider(ie,fe){return ct.registerDeclarationProvider(Te,mt(ie),fe)},registerImplementationProvider(ie,fe){return ct.registerImplementationProvider(Te,mt(ie),fe)},registerTypeDefinitionProvider(ie,fe){return ct.registerTypeDefinitionProvider(Te,mt(ie),fe)},registerHoverProvider(ie,fe){return ct.registerHoverProvider(Te,mt(ie),fe,Te.identifier)},registerEvaluatableExpressionProvider(ie,fe){return ct.registerEvaluatableExpressionProvider(Te,mt(ie),fe,Te.identifier)},registerInlineValuesProvider(ie,fe){return ct.registerInlineValuesProvider(Te,mt(ie),fe,Te.identifier)},registerDocumentHighlightProvider(ie,fe){return ct.registerDocumentHighlightProvider(Te,mt(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return ct.registerLinkedEditingRangeProvider(Te,mt(ie),fe)},registerReferenceProvider(ie,fe){return ct.registerReferenceProvider(Te,mt(ie),fe)},registerRenameProvider(ie,fe){return ct.registerRenameProvider(Te,mt(ie),fe)},registerDocumentSymbolProvider(ie,fe,Fe){return ct.registerDocumentSymbolProvider(Te,mt(ie),fe,Fe)},registerWorkspaceSymbolProvider(ie){return ct.registerWorkspaceSymbolProvider(Te,ie)},registerDocumentFormattingEditProvider(ie,fe){return ct.registerDocumentFormattingEditProvider(Te,mt(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return ct.registerDocumentRangeFormattingEditProvider(Te,mt(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Te,mt(ie),fe,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(ie,fe,Fe){return ct.registerDocumentSemanticTokensProvider(Te,mt(ie),fe,Fe)},registerDocumentRangeSemanticTokensProvider(ie,fe,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Te,mt(ie),fe,Fe)},registerSignatureHelpProvider(ie,fe,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Te,mt(ie),fe,Fe):ct.registerSignatureHelpProvider(Te,mt(ie),fe,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(ie,fe,...Fe){return ct.registerCompletionItemProvider(Te,mt(ie),fe,Fe)},registerInlineCompletionItemProvider(ie,fe,Fe){return fe.handleDidShowCompletionItem&&(0,Oe.$lF)(Te,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$lF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Oe.$lF)(Te,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Te,mt(ie),fe,Fe)},registerDocumentLinkProvider(ie,fe){return ct.registerDocumentLinkProvider(Te,mt(ie),fe)},registerColorProvider(ie,fe){return ct.registerColorProvider(Te,mt(ie),fe)},registerFoldingRangeProvider(ie,fe){return ct.registerFoldingRangeProvider(Te,mt(ie),fe)},registerSelectionRangeProvider(ie,fe){return ct.registerSelectionRangeProvider(Te,ie,fe)},registerCallHierarchyProvider(ie,fe){return ct.registerCallHierarchyProvider(Te,ie,fe)},registerTypeHierarchyProvider(ie,fe){return ct.registerTypeHierarchyProvider(Te,ie,fe)},setLanguageConfiguration:(ie,fe)=>ct.setLanguageConfiguration(Te,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,Oe.$lF)(Te,"tokenInformation"),hi.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return ct.registerInlayHintsProvider(Te,ie,fe)},createLanguageStatusItem(ie,fe){return hi.createLanguageStatusItem(Te,ie,fe)},registerDocumentDropEditProvider(ie,fe,Fe){return ct.registerDocumentOnDropEditProvider(Te,ie,fe,(0,Oe.$kF)(Te,"dropMetadata")?Fe:void 0)}},ln={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(ie,fe,Fe){const rt=await(R.URI.isUri(ie)?Promise.resolve(ki.openTextDocument(ie)):Promise.resolve(ie));return Mt.showTextDocument(rt,fe,Fe)},createTextEditorDecorationType(ie){return Mt.createTextEditorDecorationType(Te,ie)},onDidChangeActiveTextEditor(ie,fe,Fe){return Mt.onDidChangeActiveTextEditor(ie,fe,Fe)},onDidChangeVisibleTextEditors(ie,fe,Fe){return Mt.onDidChangeVisibleTextEditors(ie,fe,Fe)},onDidChangeTextEditorSelection(ie,fe,Fe){return Mt.onDidChangeTextEditorSelection(ie,fe,Fe)},onDidChangeTextEditorOptions(ie,fe,Fe){return Mt.onDidChangeTextEditorOptions(ie,fe,Fe)},onDidChangeTextEditorVisibleRanges(ie,fe,Fe){return Mt.onDidChangeTextEditorVisibleRanges(ie,fe,Fe)},onDidChangeTextEditorViewColumn(ie,fe,Fe){return Mt.onDidChangeTextEditorViewColumn(ie,fe,Fe)},onDidCloseTerminal(ie,fe,Fe){return ht.onDidCloseTerminal(ie,fe,Fe)},onDidOpenTerminal(ie,fe,Fe){return ht.onDidOpenTerminal(ie,fe,Fe)},onDidChangeActiveTerminal(ie,fe,Fe){return ht.onDidChangeActiveTerminal(ie,fe,Fe)},onDidChangeTerminalDimensions(ie,fe,Fe){return(0,Oe.$lF)(Te,"terminalDimensions"),ht.onDidChangeTerminalDimensions(ie,fe,Fe)},onDidChangeTerminalState(ie,fe,Fe){return ht.onDidChangeTerminalState(ie,fe,Fe)},onDidWriteTerminalData(ie,fe,Fe){return(0,Oe.$lF)(Te,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(ie,fe,Fe)},onDidExecuteTerminalCommand(ie,fe,Fe){return(0,Oe.$lF)(Te,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(ie,fe,Fe)},get state(){return Ue.getState(Te)},onDidChangeWindowState(ie,fe,Fe){return Ue.onDidChangeWindowState(ie,fe,Fe)},showInformationMessage(ie,...fe){return Ei.showMessage(Te,M.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return Ei.showMessage(Te,M.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return Ei.showMessage(Te,M.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Fe){return ii.showQuickPick(Te,ie,fe,Fe)},showWorkspaceFolderPick(ie){return ii.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return ii.showInput(ie,fe)},showOpenDialog(ie){return sn.showOpenDialog(Te,ie)},showSaveDialog(ie){return sn.showSaveDialog(ie)},createStatusBarItem(ie,fe,Fe){let rt,pt,Lt;return typeof ie=="string"?(rt=ie,pt=fe,Lt=Fe):(pt=ie,Lt=fe),Xt.createStatusBarEntry(Te,rt,pt,Lt)},setStatusBarMessage(ie,fe){return Xt.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Fi.withProgress(Te,{location:X.ProgressLocation.SourceControl},(fe,Fe)=>ie({report(rt){}}))},withProgress(ie,fe){return Fi.withProgress(Te,ie,fe)},createOutputChannel(ie,fe){return Si.createOutputChannel(ie,fe,Te)},createWebviewPanel(ie,fe,Fe,rt){return di.createWebviewPanel(Te,ie,fe,Fe,rt)},createWebviewTextEditorInset(ie,fe,Fe,rt){return(0,Oe.$lF)(Te,"editorInsets"),Pi.createWebviewEditorInset(ie,fe,Fe,rt,Te)},createTerminal(ie,fe,Fe){return typeof ie=="object"?"pty"in ie?ht.createExtensionTerminal(ie):ht.createTerminalFromOptions(ie):ht.createTerminal(ie,fe,Fe)},registerTerminalLinkProvider(ie){return ht.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return ht.registerProfileProvider(Te,ie,fe)},registerTerminalQuickFixProvider(ie,fe){return(0,Oe.$lF)(Te,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(ie,Te.identifier.value,fe)},registerTreeDataProvider(ie,fe){return bi.registerTreeDataProvider(ie,fe,Te)},createTreeView(ie,fe){return bi.createTreeView(ie,fe,Te)},registerWebviewPanelSerializer:(ie,fe)=>di.registerWebviewPanelSerializer(Te,ie,fe),registerCustomEditorProvider:(ie,fe,Fe={})=>Oi.registerCustomEditorProvider(Te,ie,fe,Fe),registerFileDecorationProvider(ie){return Et.registerFileDecorationProvider(ie,Te)},registerUriHandler(ie){return $i.registerUriHandler(Te,ie)},createQuickPick(){return ii.createQuickPick(Te)},createInputBox(){return ii.createInputBox(Te)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Fe){return Ti.onDidChangeActiveColorTheme(ie,fe,Fe)},registerWebviewViewProvider(ie,fe,Fe){return $n.registerWebviewViewProvider(Te,ie,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Fe){return yt.onDidChangeActiveNotebookEditor(ie,fe,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Fe){return vi.onDidChangeNotebookEditorSelection(ie,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Fe){return vi.onDidChangeNotebookEditorVisibleRanges(ie,fe,Fe)},showNotebookDocument(ie,fe){return yt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Fe){return(0,Oe.$lF)(Te,"externalUriOpener"),Yi.registerExternalUriOpener(Te.identifier,ie,fe,Fe)},registerProfileContentHandler(ie,fe){return(0,Oe.$lF)(Te,"profileContentHandlers"),zi.registrProfileContentHandler(Te,ie,fe)},registerQuickDiffProvider(ie,fe,Fe,rt){return(0,Oe.$lF)(Te,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(ie),fe,Fe,rt)},get tabGroups(){return qe.tabGroups},registerShareProvider(ie,fe){return(0,Oe.$lF)(Te,"shareProvider"),Li.registerShareProvider(mt(ie),fe)}},ki={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(ie){throw new L.$8("rootPath")},getWorkspaceFolder(ie){return ot.getWorkspaceFolder(ie)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(ie){throw new L.$8("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(ie){throw new L.$8("workspaceFile")},updateWorkspaceFolders:(ie,fe,...Fe)=>ot.updateWorkspaceFolders(Te,ie,fe||0,...Fe),onDidChangeWorkspaceFolders:function(ie,fe,Fe){return ot.onDidChangeWorkspace(ie,fe,Fe)},asRelativePath:(ie,fe)=>ot.getRelativePath(ie,fe),findFiles:(ie,fe,Fe,rt)=>ot.findFiles(ie,fe,Fe,Te.identifier,rt),findTextInFiles:(ie,fe,Fe,rt)=>{(0,Oe.$lF)(Te,"findTextInFiles");let pt,Lt;return typeof fe=="object"?(pt=fe,Lt=Fe):(pt={},Lt=fe,rt=Fe),ot.findTextInFiles(ie,pt||{},Lt,Te.identifier,rt)},save:ie=>((0,Oe.$lF)(Te,"saveEditor"),ot.save(ie)),saveAs:ie=>((0,Oe.$lF)(Te,"saveEditor"),ot.saveAs(ie)),saveAll:ie=>ot.saveAll(ie),applyEdit(ie,fe){return nn.applyWorkspaceEdit(ie,Te,fe)},createFileSystemWatcher:(ie,fe,Fe,rt)=>{let pt;return typeof fe=="boolean"?pt={ignoreCreateEvents:!!fe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:fe&&((0,Oe.$lF)(Te,"createFileSystemWatcher"),pt={...fe,correlate:!0}),Yt.createFileSystemWatcher(ot,Te,ie,pt)},get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new L.$8("textDocuments")},openTextDocument(ie){let fe;const Fe=ie;if(typeof ie=="string")fe=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Fe||typeof Fe=="object")fe=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>It.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(ie,fe,Fe)=>It.onDidAddDocument(ie,fe,Fe),onDidCloseTextDocument:(ie,fe,Fe)=>It.onDidRemoveDocument(ie,fe,Fe),onDidChangeTextDocument:(ie,fe,Fe)=>It.onDidChangeDocument(ie,fe,Fe),onDidSaveTextDocument:(ie,fe,Fe)=>It.onDidSaveDocument(ie,fe,Fe),onWillSaveTextDocument:(ie,fe,Fe)=>ri.getOnWillSaveTextDocumentEvent(Te)(ie,fe,Fe),get notebookDocuments(){return yt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Fe;if(R.URI.isUri(ie))Fe=ie,await yt.openNotebookDocument(ie);else if(typeof ie=="string")Fe=R.URI.revive(await yt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ie,fe,Fe){return pi.onDidSaveNotebookDocument(ie,fe,Fe)},onDidChangeNotebookDocument(ie,fe,Fe){return pi.onDidChangeNotebookDocument(ie,fe,Fe)},onWillSaveNotebookDocument(ie,fe,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Te)(ie,fe,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Fe,rt){return yt.registerNotebookSerializer(Te,ie,fe,Fe,(0,Oe.$kF)(Te,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ie,fe,Fe)=>on.onDidChangeConfiguration(ie,fe,Fe),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,on.getConfiguration(ie,fe,Te)},registerTextDocumentContentProvider(ie,fe){return gn.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Te,ie,fe)),registerFileSystemProvider(ie,fe,Fe){return(0,Be.$Oc)(Ai.registerFileSystemProvider(Te,ie,fe,Fe),qt.addFileSystemProvider(ie,fe,Fe))},get fs(){return qt.value},registerFileSearchProvider:(ie,fe)=>((0,Oe.$lF)(Te,"fileSearchProvider"),ui.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,Oe.$lF)(Te,"textSearchProvider"),ui.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,Oe.$lF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,Oe.$lF)(Te,"resolvers"),Zi.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Oe.$lF)(Te,"resolvers"),Rt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,fe,Fe)=>Yt.onDidCreateFile(ie,fe,Fe),onDidDeleteFiles:(ie,fe,Fe)=>Yt.onDidDeleteFile(ie,fe,Fe),onDidRenameFiles:(ie,fe,Fe)=>Yt.onDidRenameFile(ie,fe,Fe),onWillCreateFiles:(ie,fe,Fe)=>Yt.getOnWillCreateFileEvent(Te)(ie,fe,Fe),onWillDeleteFiles:(ie,fe,Fe)=>Yt.getOnWillDeleteFileEvent(Te)(ie,fe,Fe),onWillRenameFiles:(ie,fe,Fe)=>Yt.getOnWillRenameFileEvent(Te)(ie,fe,Fe),openTunnel:ie=>((0,Oe.$lF)(Te,"tunnels"),H.openTunnel(Te,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$lF)(Te,"tunnels"),H.getTunnels()},onDidChangeTunnels:(ie,fe,Fe)=>((0,Oe.$lF)(Te,"tunnels"),H.onDidChangeTunnels(ie,fe,Fe)),registerPortAttributesProvider:(ie,fe)=>((0,Oe.$lF)(Te,"portsAttributes"),H.registerPortsAttributesProvider(ie,fe)),registerTunnelProvider:(ie,fe)=>((0,Oe.$lF)(Te,"tunnelFactory"),H.registerTunnelProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,Oe.$lF)(Te,"timeline"),mn.registerTimelineProvider(ie,fe,Te.identifier,gt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:ie=>((0,Oe.$lF)(Te,"workspaceTrust"),ot.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Fe)=>ot.onDidGrantWorkspaceTrust(ie,fe,Fe),registerEditSessionIdentityProvider:(ie,fe)=>((0,Oe.$lF)(Te,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(ie,fe)),onWillCreateEditSessionIdentity:(ie,fe,Fe)=>((0,Oe.$lF)(Te,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Te)(ie,fe,Fe)),registerCanonicalUriProvider:(ie,fe)=>((0,Oe.$lF)(Te,"canonicalUriProvider"),ot.registerCanonicalUriProvider(ie,fe)),getCanonicalUri:(ie,fe,Fe)=>((0,Oe.$lF)(Te,"canonicalUriProvider"),ot.provideCanonicalUri(ie,fe,Fe))},Wi={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Te)},createSourceControl(ie,fe,Fe){return Ri.createSourceControl(Te,ie,fe,Fe)}},Vi={createCommentController(ie,fe){return Xi.createCommentController(Te,ie,fe)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(ie,fe,Fe){return ft.onDidStartDebugSession(ie,fe,Fe)},onDidTerminateDebugSession(ie,fe,Fe){return ft.onDidTerminateDebugSession(ie,fe,Fe)},onDidChangeActiveDebugSession(ie,fe,Fe){return ft.onDidChangeActiveDebugSession(ie,fe,Fe)},onDidReceiveDebugSessionCustomEvent(ie,fe,Fe){return ft.onDidReceiveDebugSessionCustomEvent(ie,fe,Fe)},onDidChangeBreakpoints(ie,fe,Fe){return ft.onDidChangeBreakpoints(ie,fe,Fe)},onDidChangeStackFrameFocus(ie,fe,Fe){return(0,Oe.$lF)(Te,"debugFocus"),ft.onDidChangeStackFrameFocus(ie,fe,Fe)},registerDebugConfigurationProvider(ie,fe,Fe){return ft.registerDebugConfigurationProvider(ie,fe,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return ft.registerDebugAdapterDescriptorFactory(Te,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return ft.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(ie,fe,{parentSession:Fe}):ft.startDebugging(ie,fe,Fe||{})},stopDebugging(ie){return ft.stopDebugging(ie)},addBreakpoints(ie){return ft.addBreakpoints(ie)},removeBreakpoints(ie){return ft.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return ft.asDebugSourceUri(ie,fe)}},qi={registerTaskProvider:(ie,fe)=>St.registerTaskProvider(Te,ie,fe),fetchTasks:ie=>St.fetchTasks(ie),executeTask:ie=>St.executeTask(Te,ie),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ie,fe,Fe)=>St.onDidStartTask(ie,fe,Fe),onDidEndTask:(ie,fe,Fe)=>St.onDidEndTask(ie,fe,Fe),onDidStartTaskProcess:(ie,fe,Fe)=>St.onDidStartTaskProcess(ie,fe,Fe),onDidEndTaskProcess:(ie,fe,Fe)=>St.onDidEndTaskProcess(ie,fe,Fe)},Ki={createNotebookController(ie,fe,Fe,rt,pt){return si.createNotebookController(Te,ie,fe,Fe,rt,(0,Oe.$kF)(Te,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>yt.registerNotebookCellStatusBarItemProvider(Te,ie,fe),createRendererMessaging(ie){return Ii.createRendererMessaging(Te,ie)},createNotebookControllerDetectionTask(ie){return(0,Oe.$lF)(Te,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Te,ie)},registerKernelSourceActionProvider(ie,fe){return(0,Oe.$lF)(Te,"notebookKernelSource"),si.registerKernelSourceActionProvider(Te,ie,fe)},onDidChangeNotebookCellExecutionState(ie,fe,Fe){return(0,Oe.$lF)(Te,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ie,fe,Fe)}},Hi={t(...ie){if(typeof ie[0]=="string"){const fe=ie.shift(),Fe=!ie||typeof ie[0]!="object"?ie:ie[0];return li.getMessage(Te.identifier.value,{message:fe,args:Fe})}return li.getMessage(Te.identifier.value,ie[0])},get bundle(){return li.getBundle(Te.identifier.value)},get uri(){return li.getBundleUri(Te.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(ie,fe){return(0,Oe.$lF)(Te,"interactive"),xi.registerProvider(Te,ie,fe={label:fe?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(ie,fe){return(0,Oe.$lF)(Te,"interactive"),mi.registerChatProvider(Te,ie,fe)},sendInteractiveRequestToProvider(ie,fe){return(0,Oe.$lF)(Te,"interactive"),mi.sendInteractiveRequestToProvider(ie,fe)},get onDidPerformUserAction(){return(0,Oe.$lF)(Te,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(ie,fe){return(0,Oe.$lF)(Te,"interactive"),mi.transferChatSession(ie,fe)}},hn={getRelatedInformation(ie,fe){return(0,Oe.$lF)(Te,"aiRelatedInformation"),xt.getRelatedInformation(Te,ie,fe)},registerRelatedInformationProvider(ie,fe){return(0,Oe.$lF)(Te,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Te,ie,fe)},registerEmbeddingVectorProvider(ie,fe){return(0,Oe.$lF)(Te,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Te,ie,fe)}},dn={registerChatResponseProvider(ie,fe,Fe){return(0,Oe.$lF)(Te,"chatProvider"),gi.registerProvider(Te.identifier,ie,fe,Fe)},requestChatAccess(ie){return(0,Oe.$lF)(Te,"chatRequestAccess"),gi.requestChatResponseProvider(Te.identifier,ie)},registerVariable(ie,fe,Fe){return(0,Oe.$lF)(Te,"chatVariables"),Ui.registerVariableResolver(Te,ie,fe,Fe)},registerMappedEditsProvider(ie,fe){return(0,Oe.$lF)(Te,"mappedEditsProvider"),ct.registerMappedEditsProvider(Te,ie,fe)},createChatAgent(ie,fe){return(0,Oe.$lF)(Te,"chatAgents2"),pn.createChatAgent(Te,ie,fe)},registerAgent(ie,fe,Fe){return(0,Oe.$lF)(Te,"chatAgents"),_i.registerAgent(Te.identifier,ie,fe,Fe)}},fn={registerSpeechProvider(ie,fe){return(0,Oe.$lF)(Te,"speech"),yi.registerProvider(Te.identifier,ie,fe)}};return{version:dt.version,ai:hn,authentication:ji,commands:an,comments:Vi,chat:dn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:qi,tests:cn,window:ln,workspace:ki,Breakpoint:X.$tL,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatAgentResultFeedbackKind:X.ChatAgentResultFeedbackKind,ChatMessage:X.$jM,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$SK,CallHierarchyItem:X.$RK,CallHierarchyOutgoingCall:X.$TK,CancellationError:L.$4,CancellationTokenSource:E.$Xd,CandidatePortSource:o.CandidatePortSource,CodeAction:X.$OK,CodeActionKind:X.$PK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$UK,Color:X.$8K,ColorInformation:X.$9K,ColorPresentation:X.$0K,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$2K,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$3K,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$fL,DebugAdapterExecutable:X.$xL,DebugAdapterInlineImplementation:X.$AL,DebugAdapterNamedPipeServer:X.$zL,DebugAdapterServer:X.$yL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$JK,DiagnosticRelatedInformation:X.$IK,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$vK,DocumentHighlight:X.$LK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$7K,DocumentSymbol:X.$NK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$DL,InlineValueText:X.$EL,InlineValueVariableLookup:X.$FL,InlineValueEvaluatableExpression:X.$GL,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:P.$Nd,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$QL,FileDecoration2:X.$QL,FileSystemError:X.$IL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:X.$JL,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$vL,InlineCompletionItem:X.$4K,InlineCompletionList:X.$5K,Hover:X.$KK,IndentAction:g.IndentAction,Location:X.$HK,MarkdownString:X.$VK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:X.$WK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$wK,ProcessExecution:X.$dL,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$PL,Range:X.$xK,RelativePattern:X.$rL,Selection:X.$yK,SelectionRange:X.$QK,SemanticTokens:X.$ML,SemanticTokensBuilder:X.$LL,SemanticTokensEdit:X.$NL,SemanticTokensEdits:X.$OL,SemanticTokensLegend:X.$KL,ShellExecution:X.$eL,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$YK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$XK,SnippetString:X.$GK,SourceBreakpoint:X.$uL,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$MK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$gL,TaskGroup:X.$cL,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$$K,TerminalQuickFixExecuteTerminalCommand:X.$aL,TerminalQuickFixOpener:X.$_K,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$bL,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$CK,SnippetTextEdit:X.$EK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$qL,ThemeIcon:X.$pL,TreeItem:X.$hL,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$_L,UIKind:b.UIKind,Uri:R.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$FK,DocumentDropEdit:X.$nL,DocumentPasteEdit:X.$oL,InlayHint:X.$1K,InlayHintLabelPart:X.$ZK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$BK,ResolvedAuthority:X.$zK,ManagedResolvedAuthority:X.$AK,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$1L,NotebookRange:X.$SL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$TL,NotebookData:X.$UL,NotebookRendererScript:X.$YL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$WL,NotebookCellOutputItem:X.$VL,NotebookCellStatusBarItem:X.$XL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$DK,NotebookKernelSourceAction:X.$ZL,PortAttributes:X.$3L,LinkedEditingRanges:X.$2L,TestResultState:X.TestResultState,TestRunRequest:X.$4L,TestMessage:X.$5L,TestMessage2:X.$5L,TestTag:X.$6L,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$mL,DataTransferItem:X.$iL,CoveredCount:X.$7L,FileCoverage:X.$8L,StatementCoverage:X.$9L,BranchCoverage:X.$0L,FunctionCoverage:X.$$L,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$aM,TabInputTextDiff:X.$bM,TabInputTextMerge:X.$cM,TabInputCustom:X.$dM,TabInputNotebook:X.$fM,TabInputNotebookDiff:X.$gM,TabInputWebview:X.$eM,TabInputTerminal:X.$hM,TabInputInteractiveWindow:X.$iM,TelemetryTrustedValue:Ee.$mo,LogLevel:$e.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$BL,ThreadFocus:X.$CL,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus}}}e.$Pec=Ot}),define(Ae[289],Re([1,0,70,112,34,110,35,32,61,64,114,116,117,84,86,80,111,63,41,83,60,62,255,15,115,81,82]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,b,v,f,t,i,r,u,a,l,n,s,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$zr)(h.$odc,h.$ndc,1),(0,E.$zr)(s.$$i,n.$Qec,1),(0,E.$zr)(f.$Ncc,f.$Occ,1),(0,E.$zr)($.$QM,$.$PM,0),(0,E.$zr)(R.$1cc,R.$Ycc,0),(0,E.$zr)(i.$ddc,i.$cdc,0),(0,E.$zr)(S.$4dc,S.$8dc,0),(0,E.$zr)(M.$Vdc,M.$Udc,0),(0,E.$zr)(D.$FM,D.$EM,0),(0,E.$zr)(p.$pdc,p.$qdc,0),(0,E.$zr)(r.$Kcc,r.$Jcc,0),(0,E.$zr)(L.$Bdc,L.$Adc,1),(0,E.$zr)(o.$bec,o.$cec,0),(0,E.$zr)(b.$_cc,b.$$cc,0),(0,E.$zr)(A.$Ydc,A.$Xdc,0),(0,E.$zr)(g.$gdc,g.$jdc,0),(0,E.$zr)(v.$vwb,v.$wwb,0),(0,E.$zr)(t.$Rdc,t.$Qdc,0),(0,E.$zr)(P.$Xcc,P.$Wcc,0),(0,E.$zr)(u.$ldc,u.$kdc,0),(0,E.$zr)(a.$OM,a.$LM,0),(0,E.$zr)(l.$Zdc,l.$1dc,0),(0,E.$zr)(c.$2dc,c.$3dc,0)}),define(Ae[290],Re([1,0,288,36,2,285,7,12,274]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class g extends M.$Tec{j(){}getModule(b,v){for(const f of this.b){const t=f(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends L.$sdc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$Ygc);const b=this.h.invokeFunction(E.$Pec);this.r=this.h.createInstance(g,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,v,f){v=v.with({path:S(v.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(v)),r=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),r.status!==200)throw new Error(r.statusText);const u=await r.text(),a=`${v.toString(!0)}#vscode-extension`,l=`${u}
//# sourceURL=${a}`;let n;try{n=new Function("module","exports","require",l)}catch(p){throw console.error(t?`Loading code for extension ${t} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${v.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}b&&await this.w.initializeLocalizedMessages(b);const s={},c={exports:s},h=p=>{const m=this.r.getModule(p,v);if(m===void 0)throw new Error(`Cannot load module '${p}'`);return m};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(c,s,h),c.exports!==s?c.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+b;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Ug)(10)}}e.$Zgc=A;function S(o,b){return o.endsWith(b)?o:o+b}}),define(Ae[291],Re([1,0,69,70,15,36,198,85,290]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$zr)(P.$0i,new E.$Mh(R.$Sec,[!0],!0)),(0,L.$zr)(M.$tdc,D.$Zgc,0),(0,L.$zr)($.$edc,$.$fdc,0)}),define(Ae[297],Re([1,0,22,5,78,286,276,20,87,14,2,289,291]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const o=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const v=fetch.bind(self);function f(n){self.fetch=async function(s,c){return s instanceof Request||b(String(s))&&(s=(await n(A.URI.parse(String(s)))).toString(!0)),v(s,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,c,h,p,m){(async()=>(b(c.toString())&&(c=(await n(A.URI.parse(c.toString()))).toString(!0)),super.open(s,c,h??!0,p,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,c){if(/^file:/i.test(s.toString()))s=g.$cg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(d){function y(j){return typeof j=="string"||j instanceof URL?String(j).replace(/^file:\/\//i,"vscode-file://vscode-app"):j}const w=fetch.bind(self);self.fetch=function(j,B){return j instanceof Request?w(j,B):w(y(j),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(j,B,W,U,F){return super.open(j,y(B),W??!0,U,F)}};const C=importScripts.bind(self);self.importScripts=(...j)=>{C(...j.map(y))},C(d)}.toString()}('${s}'))`;c=c||{},c.name=c.name||$.$mc(s.toString());const m=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(m);return new n(I,c)}}else self.Worker=class extends R.$1gc{constructor(n,s){super(o,n,{name:$.$mc(n.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(n){S()}};class i{constructor(){const s=new MessageChannel,c=new L.$Nd;let h=!1;o(s.port2,[s.port2]),s.port1.onmessage=p=>{const{data:m}=p;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=E.$be.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$cm)(I,2)){h=!0,u("received terminate message from renderer");return}c.fire(I)},this.protocol={onMessage:c.event,send:p=>{if(!h){const m=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function r(n){return new Promise(s=>{const c=n.onMessage(h=>{c.dispose();const p=JSON.parse(h.toString());n.send((0,P.$bm)(0)),s({protocol:n,initData:p})});n.send((0,P.$bm)(1))})}let u=n=>S();function a(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function l(){D.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(s){a(s)&&r(n.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const h=new M.$Vec(c.protocol,c.initData,t,null,s.data);f(p=>h.asBrowserUri(p)),u=p=>h.terminate(p)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a9d8fbca9ec9a7914f2077a83ca66a08c7e10f83/core/vs/workbench/api/worker/extensionHostWorker.js.map
